/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/errors","vs/base/common/path","vs/platform/log/common/log","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/network","vs/base/common/resources","vs/base/common/arrays","vs/base/common/types","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/buffer","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/common/objects","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/base/common/uuid","vs/base/common/process","vs/base/parts/ipc/common/ipc","os","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","vs/base/common/map","child_process","vs/platform/product/common/product","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/base/parts/ipc/node/ipc.cp","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/iterator","net","vs/base/common/date","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/base/common/semver/semver","vs/platform/remote/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensionHostStarter","crypto","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/decoder","string_decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensions/node/extensionHostStarter","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","util","minimist","path","assert","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ne=function(J){for(var e=[],D=0,A=J.length;D<A;D++)e[D]=te[J[D]];return e};define(te[97],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function D(A,P){if(!A)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}e.ok=D}),define(te[65],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const D=Object.prototype.hasOwnProperty;function A(n){const I=[];for(let g in n)D.call(n,g)&&I.push(n[g]);return I}e.values=A;function P(n,I){for(let g in n)if(D.call(n,g)&&I({key:g,value:n[g]},function(){delete n[g]})===!1)return}e.forEach=P;function T(n,I){const g=Object.create(null);for(const b of n){const h=I(b);let y=g[h];y||(y=g[h]=[]),y.push(b)}return g}e.groupBy=T;function L(n){const I=Object.create(null);return n&&n.forEach((g,b)=>{I[b]=g}),I}e.fromMap=L;function R(n,I){const g=[],b=[];for(let h of n)I.has(h)||g.push(h);for(let h of I)n.has(h)||b.push(h);return{removed:g,added:b}}e.diffSets=R;function S(n,I){const g=[],b=[];for(let[h,y]of n)I.has(h)||g.push(y);for(let[h,y]of I)n.has(h)||b.push(y);return{removed:g,added:b}}e.diffMaps=S;class E{constructor(){this.map=new Map}add(I,g){let b=this.map.get(I);b||(b=new Set,this.map.set(I,b)),b.add(g)}delete(I,g){const b=this.map.get(I);!b||(b.delete(g),b.size===0&&this.map.delete(I))}forEach(I,g){const b=this.map.get(I);!b||b.forEach(g)}}e.SetMap=E}),define(te[66],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(L){return(R,S,E)=>{let n=null,I=null;if(typeof E.value=="function"?(n="value",I=E.value):typeof E.get=="function"&&(n="get",I=E.get),!I)throw new Error("not supported");E[n]=L(I,S)}}e.createDecorator=D;function A(L,R,S){let E=null,n=null;if(typeof S.value=="function"?(E="value",n=S.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(E="get",n=S.get),!n)throw new Error("not supported");const I=`$memoize$${R}`;S[E]=function(...g){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,g)}),this[I]}}e.memoize=A;function P(L,R,S){return D((E,n)=>{const I=`$debounce$${n}`,g=`$debounce$result$${n}`;return function(...b){this[g]||(this[g]=S?S():void 0),clearTimeout(this[I]),R&&(this[g]=R(this[g],...b),b=[this[g]]),this[I]=setTimeout(()=>{E.apply(this,b),this[g]=S?S():void 0},L)}})}e.debounce=P;function T(L,R,S){return D((E,n)=>{const I=`$throttle$timer$${n}`,g=`$throttle$result$${n}`,b=`$throttle$lastRun$${n}`,h=`$throttle$pending$${n}`;return function(...y){if(this[g]||(this[g]=S?S():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),R&&(this[g]=R(this[g],...y)),this[h])return;const f=this[b]+L;f<=Date.now()?(this[b]=Date.now(),E.apply(this,[this[g]]),this[g]=S?S():void 0):(this[h]=!0,this[I]=setTimeout(()=>{this[h]=!1,this[b]=Date.now(),E.apply(this,[this[g]]),this[g]=S?S():void 0},f-Date.now()))}})}e.throttle=T}),define(te[8],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(s=>{s(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=D,e.errorHandler=new D;function A(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=A;function P(c){S(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=P;function T(c){S(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=T;function L(c){if(c instanceof Error){let{name:t,message:s}=c;const r=c.stacktrace||c.stack;return{$isError:!0,name:t,message:s,stack:r}}return c}e.transformErrorForSerialization=L;const R="Canceled";function S(c){return c instanceof Error&&c.name===R&&c.message===R}e.isPromiseCanceledError=S;class E extends Error{constructor(){super(R);this.name=this.message}}e.CancellationError=E;function n(){const c=new Error(R);return c.name=c.message,c}e.canceled=n;function I(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=I;function g(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=g;function b(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function h(c){const t=new Error(`${c} has been disposed`);return t.name="DISPOSED",t}e.disposed=h;function y(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=y;class f extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=f;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class v extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=v;function p(c){const t=c;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=p;function l(c,t=Object.create(null)){const s=new Error(c);return t.actions&&(s.actions=t.actions),s}e.createErrorWithActions=l}),define(te[17],ne([0,1,8]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function A(M,B=0){return M[M.length-(1+B)]}e.tail=A;function P(M){if(M.length===0)throw new Error("Invalid tail call");return[M.slice(0,M.length-1),M[M.length-1]]}e.tail2=P;function T(M,B,V=(Q,Z)=>Q===Z){if(M===B)return!0;if(!M||!B||M.length!==B.length)return!1;for(let Q=0,Z=M.length;Q<Z;Q++)if(!V(M[Q],B[Q]))return!1;return!0}e.equals=T;function L(M,B,V){let Q=0,Z=M.length-1;for(;Q<=Z;){const K=(Q+Z)/2|0,H=V(M[K],B);if(H<0)Q=K+1;else if(H>0)Z=K-1;else return K}return-(Q+1)}e.binarySearch=L;function R(M,B){let V=0,Q=M.length;if(Q===0)return 0;for(;V<Q;){const Z=Math.floor((V+Q)/2);B(M[Z])?Q=Z:V=Z+1}return V}e.findFirstInSorted=R;function S(M,B,V){if(M=M|0,M>=B.length)throw new TypeError("invalid index");let Q=B[Math.floor(B.length*Math.random())],Z=[],K=[],H=[];for(let re of B){const ie=V(re,Q);ie<0?Z.push(re):ie>0?K.push(re):H.push(re)}return M<Z.length?S(M,Z,V):M<Z.length+H.length?H[0]:S(M-(Z.length+H.length),K,V)}e.quickSelect=S;function E(M,B){const V=[];let Q;for(const Z of M.slice(0).sort(B))!Q||B(Q[0],Z)!==0?(Q=[Z],V.push(Q)):Q.push(Z);return V}e.groupBy=E;function n(M,B,V){const Q=[];function Z(re,ie,ae){if(ie===0&&ae.length===0)return;const ue=Q[Q.length-1];ue&&ue.start+ue.deleteCount===re?(ue.deleteCount+=ie,ue.toInsert.push(...ae)):Q.push({start:re,deleteCount:ie,toInsert:ae})}let K=0,H=0;for(;;){if(K===M.length){Z(K,0,B.slice(H));break}if(H===B.length){Z(K,M.length-K,[]);break}const re=M[K],ie=B[H],ae=V(re,ie);ae===0?(K+=1,H+=1):ae<0?(Z(K,1,[]),K+=1):ae>0&&(Z(K,0,[ie]),H+=1)}return Q}e.sortedDiff=n;function I(M,B,V){const Q=n(M,B,V),Z=[],K=[];for(const H of Q)Z.push(...M.slice(H.start,H.start+H.deleteCount)),K.push(...H.toInsert);return{removed:Z,added:K}}e.delta=I;function g(M,B,V){if(V===0)return[];const Q=M.slice(0,V).sort(B);return h(M,B,Q,V,M.length),Q}e.top=g;function b(M,B,V,Q,Z){return V===0?Promise.resolve([]):new Promise((K,H)=>{(async()=>{const re=M.length,ie=M.slice(0,V).sort(B);for(let ae=V,ue=Math.min(V+Q,re);ae<re;ae=ue,ue=Math.min(ue+Q,re)){if(ae>V&&await new Promise(fe=>setTimeout(fe)),Z&&Z.isCancellationRequested)throw(0,D.canceled)();h(M,B,ie,ae,ue)}return ie})().then(K,H)})}e.topAsync=b;function h(M,B,V,Q,Z){for(const K=V.length;Q<Z;Q++){const H=M[Q];if(B(H,V[K-1])<0){V.pop();const re=R(V,ie=>B(H,ie)<0);V.splice(re,0,H)}}}function y(M){return M.filter(B=>!!B)}e.coalesce=y;function f(M){let B=0;for(let V=0;V<M.length;V++)M[V]&&(M[B]=M[V],B+=1);M.length=B}e.coalesceInPlace=f;function w(M,B,V){M.splice(V,0,M.splice(B,1)[0])}e.move=w;function v(M){return!Array.isArray(M)||M.length===0}e.isFalsyOrEmpty=v;function p(M){return Array.isArray(M)&&M.length>0}e.isNonEmptyArray=p;function l(M,B=V=>V){const V=new Set;return M.filter(Q=>{const Z=B(Q);return V.has(Z)?!1:(V.add(Z),!0)})}e.distinct=l;function c(M){const B=Object.create(null);return V=>{const Q=M(V);return B[Q]?!1:(B[Q]=!0,!0)}}e.uniqueFilter=c;function t(M,B){const V=s(M,B);if(V!==-1)return M[V]}e.findLast=t;function s(M,B){for(let V=M.length-1;V>=0;V--){const Q=M[V];if(B(Q))return V}return-1}e.lastIndex=s;function r(M,B){return M.length>0?M[0]:B}e.firstOrDefault=r;function i(M,B,V=(Q,Z)=>Q===Z){let Q=0;for(let Z=0,K=Math.min(M.length,B.length);Z<K&&V(M[Z],B[Z]);Z++)Q++;return Q}e.commonPrefixLength=i;function a(M){return[].concat(...M)}e.flatten=a;function o(M,B){let V=typeof B=="number"?M:0;typeof B=="number"?V=M:(V=0,B=M);const Q=[];if(V<=B)for(let Z=V;Z<B;Z++)Q.push(Z);else for(let Z=V;Z>B;Z--)Q.push(Z);return Q}e.range=o;function u(M,B,V){return M.reduce((Q,Z)=>(Q[B(Z)]=V?V(Z):Z,Q),Object.create(null))}e.index=u;function d(M,B){return M.push(B),()=>m(M,B)}e.insert=d;function m(M,B){const V=M.indexOf(B);if(V>-1)return M.splice(V,1),B}e.remove=m;function k(M,B,V){const Q=M.slice(0,B),Z=M.slice(B);return Q.concat(V,Z)}e.arrayInsert=k;function _(M,B){let V;if(typeof B=="number"){let Q=B;V=()=>{const Z=Math.sin(Q++)*179426549;return Z-Math.floor(Z)}}else V=Math.random;for(let Q=M.length-1;Q>0;Q-=1){const Z=Math.floor(V()*(Q+1)),K=M[Q];M[Q]=M[Z],M[Z]=K}}e.shuffle=_;function O(M,B){const V=M.indexOf(B);V>-1&&(M.splice(V,1),M.unshift(B))}e.pushToStart=O;function N(M,B){const V=M.indexOf(B);V>-1&&(M.splice(V,1),M.push(B))}e.pushToEnd=N;function C(M,B){return Array.isArray(M)?M.map(B):B(M)}e.mapArrayOrNot=C;function F(M){return Array.isArray(M)?M:[M]}e.asArray=F;function z(M){return M[Math.floor(Math.random()*M.length)]}e.getRandomElement=z;function U(M,B){for(const V of M){const Q=B(V);if(Q!==void 0)return Q}}e.mapFind=U;function j(M,B,V){const Q=x(M,B),Z=M.length,K=V.length;M.length=Z+K;for(let H=Z-1;H>=Q;H--)M[H+K]=M[H];for(let H=0;H<K;H++)M[H+Q]=V[H]}e.insertInto=j;function W(M,B,V,Q){const Z=x(M,B),K=M.splice(Z,V);return j(M,Z,Q),K}e.splice=W;function x(M,B){return B<0?Math.max(B+M.length,0):Math.min(B,M.length)}function q(M,B){let V=Number.MAX_SAFE_INTEGER,Q=0;return M.forEach((Z,K)=>{const H=B(Z);H<V&&(V=H,Q=K)}),Q}e.minIndex=q;function $(M,B){let V=Number.MIN_SAFE_INTEGER,Q=0;return M.forEach((Z,K)=>{const H=B(Z);H>V&&(V=H,Q=K)}),Q}e.maxIndex=$;class G{constructor(B){this.items=B,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(B){let V=this.firstIdx;for(;V<this.items.length&&B(this.items[V]);)V++;const Q=V===this.firstIdx?null:this.items.slice(this.firstIdx,V);return this.firstIdx=V,Q}takeFromEndWhile(B){let V=this.lastIdx;for(;V>=0&&B(this.items[V]);)V--;const Q=V===this.lastIdx?null:this.items.slice(V+1,this.lastIdx+1);return this.lastIdx=V,Q}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=G}),define(te[67],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(A){const P=this;let T=!1,L;return function(){return T||(T=!0,L=A.apply(P,arguments)),L}}e.once=D}),define(te[55],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(A){function P(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}A.is=P;const T=Object.freeze([]);function L(){return T}A.empty=L;function*R(c){yield c}A.single=R;function S(c){return c||T}A.from=S;function E(c){return!c||c[Symbol.iterator]().next().done===!0}A.isEmpty=E;function n(c){return c[Symbol.iterator]().next().value}A.first=n;function I(c,t){for(const s of c)if(t(s))return!0;return!1}A.some=I;function g(c,t){for(const s of c)if(t(s))return s}A.find=g;function*b(c,t){for(const s of c)t(s)&&(yield s)}A.filter=b;function*h(c,t){let s=0;for(const r of c)yield t(r,s++)}A.map=h;function*y(...c){for(const t of c)for(const s of t)yield s}A.concat=y;function*f(c){for(const t of c)for(const s of t)yield s}A.concatNested=f;function w(c,t,s){let r=s;for(const i of c)r=t(r,i);return r}A.reduce=w;function*v(c,t,s=c.length){for(t<0&&(t+=c.length),s<0?s+=c.length:s>c.length&&(s=c.length);t<s;t++)yield c[t]}A.slice=v;function p(c,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,c];const r=c[Symbol.iterator]();for(let i=0;i<t;i++){const a=r.next();if(a.done)return[s,A.empty()];s.push(a.value)}return[s,{[Symbol.iterator](){return r}}]}A.consume=p;function l(c,t,s=(r,i)=>r===i){const r=c[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const a=r.next(),o=i.next();if(a.done!==o.done)return!1;if(a.done)return!0;if(!s(a.value,o.value))return!1}}A.equals=l})(D=e.Iterable||(e.Iterable={}))}),define(te[36],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function L(t,s=!1){let r=0,i=t.length,a="",o=0,u=16,d=0;function m(z){let U=0,j=0;for(;U<z;){const W=t.charCodeAt(r);if(W>=48&&W<=57)j=j*16+W-48;else if(W>=65&&W<=70)j=j*16+W-65+10;else if(W>=97&&W<=102)j=j*16+W-97+10;else break;r++,U++}return U<z&&(j=-1),j}function k(z){r=z,a="",o=0,u=16,d=0}function _(){const z=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&E(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&E(t.charCodeAt(r)))for(r++;r<t.length&&E(t.charCodeAt(r));)r++;else return d=3,t.substring(z,r);let U=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&E(t.charCodeAt(r))){for(r++;r<t.length&&E(t.charCodeAt(r));)r++;U=r}else d=3;return t.substring(z,U)}function O(){let z="",U=r;for(;;){if(r>=i){z+=t.substring(U,r),d=2;break}const j=t.charCodeAt(r);if(j===34){z+=t.substring(U,r),r++;break}if(j===92){if(z+=t.substring(U,r),r++,r>=i){d=2;break}switch(t.charCodeAt(r++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:const x=m(4);x>=0?z+=String.fromCharCode(x):d=4;break;default:d=5}U=r;continue}if(j>=0&&j<=31)if(S(j)){z+=t.substring(U,r),d=2;break}else d=6;r++}return z}function N(){if(a="",d=0,o=r,r>=i)return o=i,u=17;let z=t.charCodeAt(r);if(R(z)){do r++,a+=String.fromCharCode(z),z=t.charCodeAt(r);while(R(z));return u=15}if(S(z))return r++,a+=String.fromCharCode(z),z===13&&t.charCodeAt(r)===10&&(r++,a+=`
`),u=14;switch(z){case 123:return r++,u=1;case 125:return r++,u=2;case 91:return r++,u=3;case 93:return r++,u=4;case 58:return r++,u=6;case 44:return r++,u=5;case 34:return r++,a=O(),u=10;case 47:const U=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!S(t.charCodeAt(r));)r++;return a=t.substring(U,r),u=12}if(t.charCodeAt(r+1)===42){r+=2;const j=i-1;let W=!1;for(;r<j;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,W=!0;break}r++}return W||(r++,d=1),a=t.substring(U,r),u=13}return a+=String.fromCharCode(z),r++,u=16;case 45:if(a+=String.fromCharCode(z),r++,r===i||!E(t.charCodeAt(r)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=_(),u=11;default:for(;r<i&&C(z);)r++,z=t.charCodeAt(r);if(o!==r){switch(a=t.substring(o,r),a){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return a+=String.fromCharCode(z),r++,u=16}}function C(z){if(R(z)||S(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let z;do z=N();while(z>=12&&z<=15);return z}return{setPosition:k,getPosition:()=>r,scan:s?F:N,getToken:()=>u,getTokenValue:()=>a,getTokenOffset:()=>o,getTokenLength:()=>r-o,getTokenError:()=>d}}e.createScanner=L;function R(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function I(t,s){const r=[],i=new Object;let a;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function d(m,k,_,O){o.value=m,o.offset=k,o.length=_,o.type=O,o.colonOffset=void 0,a=o}try{p(t,{onObjectBegin:(m,k)=>{if(s<=m)throw i;a=void 0,u=s>m,r.push("")},onObjectProperty:(m,k,_)=>{if(s<k||(d(m,k,_,"property"),r[r.length-1]=m,s<=k+_))throw i},onObjectEnd:(m,k)=>{if(s<=m)throw i;a=void 0,r.pop()},onArrayBegin:(m,k)=>{if(s<=m)throw i;a=void 0,r.push(0)},onArrayEnd:(m,k)=>{if(s<=m)throw i;a=void 0,r.pop()},onLiteralValue:(m,k,_)=>{if(s<k||(d(m,k,_,c(m)),s<=k+_))throw i},onSeparator:(m,k,_)=>{if(s<=k)throw i;if(m===":"&&a&&a.type==="property")a.colonOffset=k,u=!1,a=void 0;else if(m===","){const O=r[r.length-1];typeof O=="number"?r[r.length-1]=O+1:(u=!0,r[r.length-1]=""),a=void 0}}})}catch(m){if(m!==i)throw m}return{path:r,previousNode:a,isAtPropertyKey:u,matches:m=>{let k=0;for(let _=0;k<m.length&&_<r.length;_++)if(m[k]===r[_]||m[k]==="*")k++;else if(m[k]!=="**")return!1;return k===m.length}}}e.getLocation=I;function g(t,s=[],r=T.DEFAULT){let i=null,a=[];const o=[];function u(m){Array.isArray(a)?a.push(m):i!==null&&(a[i]=m)}return p(t,{onObjectBegin:()=>{const m={};u(m),o.push(a),a=m,i=null},onObjectProperty:m=>{i=m},onObjectEnd:()=>{a=o.pop()},onArrayBegin:()=>{const m=[];u(m),o.push(a),a=m,i=null},onArrayEnd:()=>{a=o.pop()},onLiteralValue:u,onError:(m,k,_)=>{s.push({error:m,offset:k,length:_})}},r),a[0]}e.parse=g;function b(t,s=[],r=T.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(m){i.type==="property"&&(i.length=m-i.offset,i=i.parent)}function o(m){return i.children.push(m),m}p(t,{onObjectBegin:m=>{i=o({type:"object",offset:m,length:-1,parent:i,children:[]})},onObjectProperty:(m,k,_)=>{i=o({type:"property",offset:k,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:m,offset:k,length:_,parent:i})},onObjectEnd:(m,k)=>{i.length=m+k-i.offset,i=i.parent,a(m+k)},onArrayBegin:(m,k)=>{i=o({type:"array",offset:m,length:-1,parent:i,children:[]})},onArrayEnd:(m,k)=>{i.length=m+k-i.offset,i=i.parent,a(m+k)},onLiteralValue:(m,k,_)=>{o({type:c(m),offset:k,length:_,parent:i,value:m}),a(k+_)},onSeparator:(m,k,_)=>{i.type==="property"&&(m===":"?i.colonOffset=k:m===","&&a(k))},onError:(m,k,_)=>{s.push({error:m,offset:k,length:_})}},r);const d=i.children[0];return d&&delete d.parent,d}e.parseTree=b;function h(t,s){if(!t)return;let r=t;for(let i of s)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let a=!1;for(const o of r.children)if(Array.isArray(o.children)&&o.children[0].value===i){r=o.children[1],a=!0;break}if(!a)return}else{const a=i;if(r.type!=="array"||a<0||!Array.isArray(r.children)||a>=r.children.length)return;r=r.children[a]}return r}e.findNodeAtLocation=h;function y(t){if(!t.parent||!t.parent.children)return[];const s=y(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;s.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&s.push(r)}return s}e.getNodePath=y;function f(t){switch(t.type){case"array":return t.children.map(f);case"object":const s=Object.create(null);for(let r of t.children){const i=r.children[1];i&&(s[r.children[0].value]=f(i))}return s;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=f;function w(t,s,r=!1){return s>=t.offset&&s<t.offset+t.length||r&&s===t.offset+t.length}e.contains=w;function v(t,s,r=!1){if(w(t,s,r)){const i=t.children;if(Array.isArray(i))for(let a=0;a<i.length&&i[a].offset<=s;a++){const o=v(i[a],s,r);if(o)return o}return t}}e.findNodeAtOffset=v;function p(t,s,r=T.DEFAULT){const i=L(t,!1);function a(V){return V?()=>V(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(V){return V?Q=>V(Q,i.getTokenOffset(),i.getTokenLength()):()=>!0}const u=a(s.onObjectBegin),d=o(s.onObjectProperty),m=a(s.onObjectEnd),k=a(s.onArrayBegin),_=a(s.onArrayEnd),O=o(s.onLiteralValue),N=o(s.onSeparator),C=a(s.onComment),F=o(s.onError),z=r&&r.disallowComments,U=r&&r.allowTrailingComma;function j(){for(;;){const V=i.scan();switch(i.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:z||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(V){case 12:case 13:z?W(10):C();break;case 16:W(1);break;case 15:case 14:break;default:return V}}}function W(V,Q=[],Z=[]){if(F(V),Q.length+Z.length>0){let K=i.getToken();for(;K!==17;){if(Q.indexOf(K)!==-1){j();break}else if(Z.indexOf(K)!==-1)break;K=j()}}}function x(V){const Q=i.getTokenValue();return V?O(Q):d(Q),j(),!0}function q(){switch(i.getToken()){case 11:let V=0;try{V=JSON.parse(i.getTokenValue()),typeof V!="number"&&(W(2),V=0)}catch(Q){W(2)}O(V);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return j(),!0}function $(){return i.getToken()!==10?(W(3,[],[2,5]),!1):(x(!1),i.getToken()===6?(N(":"),j(),B()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function G(){u(),j();let V=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(V||W(4,[],[]),N(","),j(),i.getToken()===2&&U)break}else V&&W(6,[],[]);$()||W(4,[],[2,5]),V=!0}return m(),i.getToken()!==2?W(7,[2],[]):j(),!0}function M(){k(),j();let V=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(V||W(4,[],[]),N(","),j(),i.getToken()===4&&U)break}else V&&W(6,[],[]);B()||W(4,[],[4,5]),V=!0}return _(),i.getToken()!==4?W(8,[4],[]):j(),!0}function B(){switch(i.getToken()){case 3:return M();case 1:return G();case 10:return x(!0);default:return q()}}return j(),i.getToken()===17?r.allowEmptyContent?!0:(W(4,[],[]),!1):B()?(i.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=p;function l(t,s){let r=L(t),i=[],a,o=0,u;do switch(u=r.getPosition(),a=r.scan(),a){case 12:case 13:case 17:o!==u&&i.push(t.substring(o,u)),s!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,s)),o=r.getPosition();break}while(a!==17);return i.join("")}e.stripComments=l;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(te[49],ne([0,1,36]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function A(S,E,n){let I,g,b,h,y;if(E){for(h=E.offset,y=h+E.length,b=h;b>0&&!R(S,b-1);)b--;let o=y;for(;o<S.length&&!R(S,o);)o++;g=S.substring(b,o),I=T(g,n)}else g=S,I=0,b=0,h=0,y=S.length;const f=L(n,S);let w=!1,v=0,p;n.insertSpaces?p=P(" ",n.tabSize||4):p="	";const l=(0,D.createScanner)(g,!1);let c=!1;function t(){return f+P(p,I+v)}function s(){let o=l.scan();for(w=!1;o===15||o===14;)w=w||o===14,o=l.scan();return c=o===16||l.getTokenError()!==0,o}const r=[];function i(o,u,d){!c&&u<y&&d>h&&S.substring(u,d)!==o&&r.push({offset:u,length:d-u,content:o})}let a=s();if(a!==17){const o=l.getTokenOffset()+b,u=P(p,I);i(u,b,o)}for(;a!==17;){let o=l.getTokenOffset()+l.getTokenLength()+b,u=s(),d="";for(;!w&&(u===12||u===13);){const k=l.getTokenOffset()+b;i(" ",o,k),o=l.getTokenOffset()+l.getTokenLength()+b,d=u===12?t():"",u=s()}if(u===2)a!==1&&(v--,d=t());else if(u===4)a!==3&&(v--,d=t());else{switch(a){case 3:case 1:v++,d=t();break;case 5:case 12:d=t();break;case 13:w?d=t():d=" ";break;case 6:d=" ";break;case 10:if(u===6){d="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?d=" ":u!==5&&u!==17&&(c=!0);break;case 16:c=!0;break}w&&(u===12||u===13)&&(d=t())}const m=l.getTokenOffset()+b;i(d,o,m),a=u}return r}e.format=A;function P(S,E){let n="";for(let I=0;I<E;I++)n+=S;return n}function T(S,E){let n=0,I=0;const g=E.tabSize||4;for(;n<S.length;){const b=S.charAt(n);if(b===" ")I++;else if(b==="	")I+=g;else break;n++}return Math.floor(I/g)}function L(S,E){for(let n=0;n<E.length;n++){const I=E.charAt(n);if(I==="\r")return n+1<E.length&&E.charAt(n+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=L;function R(S,E){return`\r
`.indexOf(S.charAt(E))!==-1}e.isEOL=R}),define(te[44],ne([0,1,36,49]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function P(E,n,I){return T(E,n,void 0,I)}e.removeProperty=P;function T(E,n,I,g,b){const h=n.slice(),y=[],f=(0,D.parseTree)(E,y);let w,v;for(;h.length>0&&(v=h.pop(),w=(0,D.findNodeAtLocation)(f,h),w===void 0&&I!==void 0);)typeof v=="string"?I={[v]:I}:I=[I];if(w)if(w.type==="object"&&typeof v=="string"&&Array.isArray(w.children)){const p=(0,D.findNodeAtLocation)(w,[v]);if(p!==void 0)if(I===void 0){if(!p.parent)throw new Error("Malformed AST");const l=w.children.indexOf(p.parent);let c,t=p.parent.offset+p.parent.length;if(l>0){const s=w.children[l-1];c=s.offset+s.length}else c=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return L(E,{offset:c,length:t-c,content:""},g)}else return L(E,{offset:p.offset,length:p.length,content:JSON.stringify(I)},g);else{if(I===void 0)return[];const l=`${JSON.stringify(v)}: ${JSON.stringify(I)}`,c=b?b(w.children.map(s=>s.children[0].value)):w.children.length;let t;if(c>0){const s=w.children[c-1];t={offset:s.offset+s.length,length:0,content:","+l}}else w.children.length===0?t={offset:w.offset+1,length:0,content:l}:t={offset:w.offset+1,length:0,content:l+","};return L(E,t,g)}}else if(w.type==="array"&&typeof v=="number"&&Array.isArray(w.children))if(I!==void 0){const p=`${JSON.stringify(I)}`;let l;if(w.children.length===0||v===0)l={offset:w.offset+1,length:0,content:w.children.length===0?p:p+","};else{const c=v===-1||v>w.children.length?w.children.length:v,t=w.children[c-1];l={offset:t.offset+t.length,length:0,content:","+p}}return L(E,l,g)}else{const p=v,l=w.children[p];let c;if(w.children.length===1)c={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===p){const t=w.children[p-1],s=t.offset+t.length,r=w.offset+w.length;c={offset:s,length:r-2-s,content:""}}else c={offset:l.offset,length:w.children[p+1].offset-l.offset,content:""};return L(E,c,g)}else throw new Error(`Can not add ${typeof v!="number"?"index":"property"} to parent of type ${w.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return L(E,{offset:f?f.offset:0,length:f?f.length:0,content:JSON.stringify(I)},g)}}e.setProperty=T;function L(E,n,I){let g=R(E,n),b=n.offset,h=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;b>0&&!(0,A.isEOL)(g,b-1);)b--;for(;h<g.length&&!(0,A.isEOL)(g,h);)h++}const y=(0,A.format)(g,{offset:b,length:h-b},I);for(let w=y.length-1;w>=0;w--){const v=y[w];g=R(g,v),b=Math.min(b,v.offset),h=Math.max(h,v.offset+v.length),h+=v.content.length-v.length}const f=E.length-(g.length-h)-b;return[{offset:b,length:f,content:g.substring(b,h)}]}e.withFormatting=L;function R(E,n){return E.substring(0,n.offset)+n.content+E.substring(n.offset+n.length)}e.applyEdit=R;function S(E,n){let I=n.slice(0).sort((b,h)=>{const y=b.offset-h.offset;return y===0?b.length-h.length:y}),g=E.length;for(let b=I.length-1;b>=0;b--){let h=I[b];if(h.offset+h.length<=g)E=R(E,h);else throw new Error("Overlapping edit");g=h.offset}return E}e.applyEdits=S}),define(te[2],ne([0,1,67,55]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const P=!1;let T=null;function L(i){T=i}if(e.setDisposableTracker=L,P){const i="__is_disposable_tracked__";L(new class{trackDisposable(a){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[i]||console.log(o)},3e3)}setParent(a,o){if(a&&a!==v.None)try{a[i]=!0}catch{}}markAsDisposed(a){if(a&&a!==v.None)try{a[i]=!0}catch{}}markAsSingleton(a){}})}function R(i){return T?.trackDisposable(i),i}function S(i){T?.markAsDisposed(i)}function E(i,a){T?.setParent(i,a)}function n(i,a){if(!!T)for(const o of i)T.setParent(o,a)}function I(i){return T?.markAsSingleton(i),i}e.markAsSingleton=I;class g extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=g;function b(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=b;function h(i){if(A.Iterable.is(i)){let a=[];for(const o of i)if(o)try{o.dispose()}catch(u){a.push(u)}if(a.length===1)throw a[0];if(a.length>1)throw new g(a);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=h;function y(...i){const a=f(()=>h(i));return n(i,a),a}e.combinedDisposable=y;function f(i){const a=R({dispose:(0,D.once)(()=>{S(a),i()})});return a}e.toDisposable=f;class w{constructor(){this._toDispose=new Set,this._isDisposed=!1,R(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return E(a,this),this._isDisposed?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=w,w.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new w,R(this),E(this._store,this)}dispose(){S(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class p{constructor(){this._isDisposed=!1,R(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&E(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&E(a,null),a}}e.MutableDisposable=p;class l{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=l;class c{constructor(){this.references=new Map}acquire(a,...o){let u=this.references.get(a);u||(u={counter:0,object:this.createReferencedObject(a,...o)},this.references.set(a,u));const{object:d}=u,m=(0,D.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(a,u.object),this.references.delete(a))});return u.counter++,{object:d,dispose:m}}}e.ReferenceCollection=c;class t{constructor(a){this.referenceCollection=a}async acquire(a,...o){const u=this.referenceCollection.acquire(a,...o);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(d){throw u.dispose(),d}}}e.AsyncReferenceCollection=t;class s{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=s;function r(i){const a=new w;try{i(a)}finally{a.dispose()}}e.disposeOnReturn=r}),define(te[98],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(T){this.element=T,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class A{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let T=this._first;for(;T!==D.Undefined;){const L=T.next;T.prev=D.Undefined,T.next=D.Undefined,T=L}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,L){const R=new D(T);if(this._first===D.Undefined)this._first=R,this._last=R;else if(L){const E=this._last;this._last=R,R.prev=E,E.next=R}else{const E=this._first;this._first=R,R.next=E,E.prev=R}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(R))}}shift(){if(this._first!==D.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==D.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==D.Undefined&&T.next!==D.Undefined){const L=T.prev;L.next=T.next,T.next.prev=L}else T.prev===D.Undefined&&T.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):T.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):T.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==D.Undefined;)yield T.element,T=T.next}}e.LinkedList=A}),function(){function J(P){const T=[];typeof P=="number"&&T.push("code/timeOrigin",P);function L(S){T.push(S,Date.now())}function R(){const S=[];for(let E=0;E<T.length;E+=2)S.push({name:T[E],startTime:T[E+1]});return S}return{mark:L,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const L of performance.getEntriesByType("mark"))T.push({name:L.name,startTime:Math.round(P+L.startTime)});return T}};if(typeof process=="object"){const P=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function D(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=D(A))}(),define(te[4],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const D="en";let A=!1,P=!1,T=!1,L=!1,R=!1,S=!1,E=!1,n,I=D,g,b;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const y=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=y&&h?.sandboxed,typeof navigator=="object"&&!y)b=navigator.userAgent,A=b.indexOf("Windows")>=0,P=b.indexOf("Macintosh")>=0,E=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=b.indexOf("Linux")>=0,S=!0,n=navigator.language,I=n;else if(typeof h=="object"){A=h.platform==="win32",P=h.platform==="darwin",T=h.platform==="linux",L=T&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,n=D,I=D;const r=h.env.VSCODE_NLS_CONFIG;if(r)try{const i=JSON.parse(r),a=i.availableLanguages["*"];n=i.locale,I=a||D,g=i._translationsConfigFile}catch(i){}R=!0}else console.error("Unable to resolve platform.");var f;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function w(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=w;let v=0;P?v=1:A?v=3:T&&(v=2),e.isWindows=A,e.isMacintosh=P,e.isLinux=T,e.isLinuxSnap=L,e.isNative=R,e.isWeb=S,e.isIOS=E,e.platform=v,e.userAgent=b,e.language=I;var p;(function(r){function i(){return e.language}r.value=i;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=a;function o(){return e.language==="en"}r.isDefault=o})(p=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=g,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let a=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeSetImmediateId)for(let d=0,m=a.length;d<m;d++){const k=a[d];if(k.id===u.data.vscodeSetImmediateId){a.splice(d,1),k.callback();return}}});let o=0;return u=>{const d=++o;a.push({id:d,callback:u}),e.globals.postMessage({vscodeSetImmediateId:d},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const i=Promise.resolve();return a=>i.then(a)}();var l;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||E?2:A?1:3;let c=!0,t=!1;function s(){if(!t){t=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,c=new Uint16Array(r.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=s}),define(te[31],ne([0,1,4]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let A;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const P=D.globals.vscode.process;A={get platform(){return P.platform},get arch(){return P.arch},get env(){return P.env},cwd(){return P.cwd()},nextTick(T){return(0,D.setImmediate)(T)}}}else typeof process!="undefined"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(P){return process.nextTick(P)}}:A={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},nextTick(P){return(0,D.setImmediate)(P)},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.nextTick=A.nextTick,e.arch=A.arch}),define(te[9],ne([0,1,31]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,P=97,T=90,L=122,R=46,S=47,E=92,n=58,I=63;class g extends Error{constructor(l,c,t){let s;typeof c=="string"&&c.indexOf("not ")===0?(s="must not be",c=c.replace(/^not /,"")):s="must be";const r=l.indexOf(".")!==-1?"property":"argument";let i=`The "${l}" ${r} ${s} of type ${c}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function b(p,l){if(typeof p!="string")throw new g(l,"string",p)}function h(p){return p===S||p===E}function y(p){return p===S}function f(p){return p>=A&&p<=T||p>=P&&p<=L}function w(p,l,c,t){let s="",r=0,i=-1,a=0,o=0;for(let u=0;u<=p.length;++u){if(u<p.length)o=p.charCodeAt(u);else{if(t(o))break;o=S}if(t(o)){if(!(i===u-1||a===1))if(a===2){if(s.length<2||r!==2||s.charCodeAt(s.length-1)!==R||s.charCodeAt(s.length-2)!==R){if(s.length>2){const d=s.lastIndexOf(c);d===-1?(s="",r=0):(s=s.slice(0,d),r=s.length-1-s.lastIndexOf(c)),i=u,a=0;continue}else if(s.length!==0){s="",r=0,i=u,a=0;continue}}l&&(s+=s.length>0?`${c}..`:"..",r=2)}else s.length>0?s+=`${c}${p.slice(i+1,u)}`:s=p.slice(i+1,u),r=u-i-1;i=u,a=0}else o===R&&a!==-1?++a:a=-1}return s}function v(p,l){if(l===null||typeof l!="object")throw new g("pathObject","Object",l);const c=l.dir||l.root,t=l.base||`${l.name||""}${l.ext||""}`;return c?c===l.root?`${c}${t}`:`${c}${p}${t}`:t}e.win32={resolve(...p){let l="",c="",t=!1;for(let s=p.length-1;s>=-1;s--){let r;if(s>=0){if(r=p[s],b(r,"path"),r.length===0)continue}else l.length===0?r=D.cwd():(r=D.env[`=${l}`]||D.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==l.toLowerCase()&&r.charCodeAt(2)===E)&&(r=`${l}\\`));const i=r.length;let a=0,o="",u=!1;const d=r.charCodeAt(0);if(i===1)h(d)&&(a=1,u=!0);else if(h(d))if(u=!0,h(r.charCodeAt(1))){let m=2,k=m;for(;m<i&&!h(r.charCodeAt(m));)m++;if(m<i&&m!==k){const _=r.slice(k,m);for(k=m;m<i&&h(r.charCodeAt(m));)m++;if(m<i&&m!==k){for(k=m;m<i&&!h(r.charCodeAt(m));)m++;(m===i||m!==k)&&(o=`\\\\${_}\\${r.slice(k,m)}`,a=m)}}}else a=1;else f(d)&&r.charCodeAt(1)===n&&(o=r.slice(0,2),a=2,i>2&&h(r.charCodeAt(2))&&(u=!0,a=3));if(o.length>0)if(l.length>0){if(o.toLowerCase()!==l.toLowerCase())continue}else l=o;if(t){if(l.length>0)break}else if(c=`${r.slice(a)}\\${c}`,t=u,u&&l.length>0)break}return c=w(c,!t,"\\",h),t?`${l}\\${c}`:`${l}${c}`||"."},normalize(p){b(p,"path");const l=p.length;if(l===0)return".";let c=0,t,s=!1;const r=p.charCodeAt(0);if(l===1)return y(r)?"\\":p;if(h(r))if(s=!0,h(p.charCodeAt(1))){let a=2,o=a;for(;a<l&&!h(p.charCodeAt(a));)a++;if(a<l&&a!==o){const u=p.slice(o,a);for(o=a;a<l&&h(p.charCodeAt(a));)a++;if(a<l&&a!==o){for(o=a;a<l&&!h(p.charCodeAt(a));)a++;if(a===l)return`\\\\${u}\\${p.slice(o)}\\`;a!==o&&(t=`\\\\${u}\\${p.slice(o,a)}`,c=a)}}}else c=1;else f(r)&&p.charCodeAt(1)===n&&(t=p.slice(0,2),c=2,l>2&&h(p.charCodeAt(2))&&(s=!0,c=3));let i=c<l?w(p.slice(c),!s,"\\",h):"";return i.length===0&&!s&&(i="."),i.length>0&&h(p.charCodeAt(l-1))&&(i+="\\"),t===void 0?s?`\\${i}`:i:s?`${t}\\${i}`:`${t}${i}`},isAbsolute(p){b(p,"path");const l=p.length;if(l===0)return!1;const c=p.charCodeAt(0);return h(c)||l>2&&f(c)&&p.charCodeAt(1)===n&&h(p.charCodeAt(2))},join(...p){if(p.length===0)return".";let l,c;for(let r=0;r<p.length;++r){const i=p[r];b(i,"path"),i.length>0&&(l===void 0?l=c=i:l+=`\\${i}`)}if(l===void 0)return".";let t=!0,s=0;if(typeof c=="string"&&h(c.charCodeAt(0))){++s;const r=c.length;r>1&&h(c.charCodeAt(1))&&(++s,r>2&&(h(c.charCodeAt(2))?++s:t=!1))}if(t){for(;s<l.length&&h(l.charCodeAt(s));)s++;s>=2&&(l=`\\${l.slice(s)}`)}return e.win32.normalize(l)},relative(p,l){if(b(p,"from"),b(l,"to"),p===l)return"";const c=e.win32.resolve(p),t=e.win32.resolve(l);if(c===t||(p=c.toLowerCase(),l=t.toLowerCase(),p===l))return"";let s=0;for(;s<p.length&&p.charCodeAt(s)===E;)s++;let r=p.length;for(;r-1>s&&p.charCodeAt(r-1)===E;)r--;const i=r-s;let a=0;for(;a<l.length&&l.charCodeAt(a)===E;)a++;let o=l.length;for(;o-1>a&&l.charCodeAt(o-1)===E;)o--;const u=o-a,d=i<u?i:u;let m=-1,k=0;for(;k<d;k++){const O=p.charCodeAt(s+k);if(O!==l.charCodeAt(a+k))break;O===E&&(m=k)}if(k!==d){if(m===-1)return t}else{if(u>d){if(l.charCodeAt(a+k)===E)return t.slice(a+k+1);if(k===2)return t.slice(a+k)}i>d&&(p.charCodeAt(s+k)===E?m=k:k===2&&(m=3)),m===-1&&(m=0)}let _="";for(k=s+m+1;k<=r;++k)(k===r||p.charCodeAt(k)===E)&&(_+=_.length===0?"..":"\\..");return a+=m,_.length>0?`${_}${t.slice(a,o)}`:(t.charCodeAt(a)===E&&++a,t.slice(a,o))},toNamespacedPath(p){if(typeof p!="string")return p;if(p.length===0)return"";const l=e.win32.resolve(p);if(l.length<=2)return p;if(l.charCodeAt(0)===E){if(l.charCodeAt(1)===E){const c=l.charCodeAt(2);if(c!==I&&c!==R)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(f(l.charCodeAt(0))&&l.charCodeAt(1)===n&&l.charCodeAt(2)===E)return`\\\\?\\${l}`;return p},dirname(p){b(p,"path");const l=p.length;if(l===0)return".";let c=-1,t=0;const s=p.charCodeAt(0);if(l===1)return h(s)?p:".";if(h(s)){if(c=t=1,h(p.charCodeAt(1))){let a=2,o=a;for(;a<l&&!h(p.charCodeAt(a));)a++;if(a<l&&a!==o){for(o=a;a<l&&h(p.charCodeAt(a));)a++;if(a<l&&a!==o){for(o=a;a<l&&!h(p.charCodeAt(a));)a++;if(a===l)return p;a!==o&&(c=t=a+1)}}}}else f(s)&&p.charCodeAt(1)===n&&(c=l>2&&h(p.charCodeAt(2))?3:2,t=c);let r=-1,i=!0;for(let a=l-1;a>=t;--a)if(h(p.charCodeAt(a))){if(!i){r=a;break}}else i=!1;if(r===-1){if(c===-1)return".";r=c}return p.slice(0,r)},basename(p,l){l!==void 0&&b(l,"ext"),b(p,"path");let c=0,t=-1,s=!0,r;if(p.length>=2&&f(p.charCodeAt(0))&&p.charCodeAt(1)===n&&(c=2),l!==void 0&&l.length>0&&l.length<=p.length){if(l===p)return"";let i=l.length-1,a=-1;for(r=p.length-1;r>=c;--r){const o=p.charCodeAt(r);if(h(o)){if(!s){c=r+1;break}}else a===-1&&(s=!1,a=r+1),i>=0&&(o===l.charCodeAt(i)?--i==-1&&(t=r):(i=-1,t=a))}return c===t?t=a:t===-1&&(t=p.length),p.slice(c,t)}for(r=p.length-1;r>=c;--r)if(h(p.charCodeAt(r))){if(!s){c=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":p.slice(c,t)},extname(p){b(p,"path");let l=0,c=-1,t=0,s=-1,r=!0,i=0;p.length>=2&&p.charCodeAt(1)===n&&f(p.charCodeAt(0))&&(l=t=2);for(let a=p.length-1;a>=l;--a){const o=p.charCodeAt(a);if(h(o)){if(!r){t=a+1;break}continue}s===-1&&(r=!1,s=a+1),o===R?c===-1?c=a:i!==1&&(i=1):c!==-1&&(i=-1)}return c===-1||s===-1||i===0||i===1&&c===s-1&&c===t+1?"":p.slice(c,s)},format:v.bind(null,"\\"),parse(p){b(p,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(p.length===0)return l;const c=p.length;let t=0,s=p.charCodeAt(0);if(c===1)return h(s)?(l.root=l.dir=p,l):(l.base=l.name=p,l);if(h(s)){if(t=1,h(p.charCodeAt(1))){let m=2,k=m;for(;m<c&&!h(p.charCodeAt(m));)m++;if(m<c&&m!==k){for(k=m;m<c&&h(p.charCodeAt(m));)m++;if(m<c&&m!==k){for(k=m;m<c&&!h(p.charCodeAt(m));)m++;m===c?t=m:m!==k&&(t=m+1)}}}}else if(f(s)&&p.charCodeAt(1)===n){if(c<=2)return l.root=l.dir=p,l;if(t=2,h(p.charCodeAt(2))){if(c===3)return l.root=l.dir=p,l;t=3}}t>0&&(l.root=p.slice(0,t));let r=-1,i=t,a=-1,o=!0,u=p.length-1,d=0;for(;u>=t;--u){if(s=p.charCodeAt(u),h(s)){if(!o){i=u+1;break}continue}a===-1&&(o=!1,a=u+1),s===R?r===-1?r=u:d!==1&&(d=1):r!==-1&&(d=-1)}return a!==-1&&(r===-1||d===0||d===1&&r===a-1&&r===i+1?l.base=l.name=p.slice(i,a):(l.name=p.slice(i,r),l.base=p.slice(i,a),l.ext=p.slice(r,a))),i>0&&i!==t?l.dir=p.slice(0,i-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...p){let l="",c=!1;for(let t=p.length-1;t>=-1&&!c;t--){const s=t>=0?p[t]:D.cwd();b(s,"path"),s.length!==0&&(l=`${s}/${l}`,c=s.charCodeAt(0)===S)}return l=w(l,!c,"/",y),c?`/${l}`:l.length>0?l:"."},normalize(p){if(b(p,"path"),p.length===0)return".";const l=p.charCodeAt(0)===S,c=p.charCodeAt(p.length-1)===S;return p=w(p,!l,"/",y),p.length===0?l?"/":c?"./":".":(c&&(p+="/"),l?`/${p}`:p)},isAbsolute(p){return b(p,"path"),p.length>0&&p.charCodeAt(0)===S},join(...p){if(p.length===0)return".";let l;for(let c=0;c<p.length;++c){const t=p[c];b(t,"path"),t.length>0&&(l===void 0?l=t:l+=`/${t}`)}return l===void 0?".":e.posix.normalize(l)},relative(p,l){if(b(p,"from"),b(l,"to"),p===l||(p=e.posix.resolve(p),l=e.posix.resolve(l),p===l))return"";const c=1,t=p.length,s=t-c,r=1,i=l.length-r,a=s<i?s:i;let o=-1,u=0;for(;u<a;u++){const m=p.charCodeAt(c+u);if(m!==l.charCodeAt(r+u))break;m===S&&(o=u)}if(u===a)if(i>a){if(l.charCodeAt(r+u)===S)return l.slice(r+u+1);if(u===0)return l.slice(r+u)}else s>a&&(p.charCodeAt(c+u)===S?o=u:u===0&&(o=0));let d="";for(u=c+o+1;u<=t;++u)(u===t||p.charCodeAt(u)===S)&&(d+=d.length===0?"..":"/..");return`${d}${l.slice(r+o)}`},toNamespacedPath(p){return p},dirname(p){if(b(p,"path"),p.length===0)return".";const l=p.charCodeAt(0)===S;let c=-1,t=!0;for(let s=p.length-1;s>=1;--s)if(p.charCodeAt(s)===S){if(!t){c=s;break}}else t=!1;return c===-1?l?"/":".":l&&c===1?"//":p.slice(0,c)},basename(p,l){l!==void 0&&b(l,"ext"),b(p,"path");let c=0,t=-1,s=!0,r;if(l!==void 0&&l.length>0&&l.length<=p.length){if(l===p)return"";let i=l.length-1,a=-1;for(r=p.length-1;r>=0;--r){const o=p.charCodeAt(r);if(o===S){if(!s){c=r+1;break}}else a===-1&&(s=!1,a=r+1),i>=0&&(o===l.charCodeAt(i)?--i==-1&&(t=r):(i=-1,t=a))}return c===t?t=a:t===-1&&(t=p.length),p.slice(c,t)}for(r=p.length-1;r>=0;--r)if(p.charCodeAt(r)===S){if(!s){c=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":p.slice(c,t)},extname(p){b(p,"path");let l=-1,c=0,t=-1,s=!0,r=0;for(let i=p.length-1;i>=0;--i){const a=p.charCodeAt(i);if(a===S){if(!s){c=i+1;break}continue}t===-1&&(s=!1,t=i+1),a===R?l===-1?l=i:r!==1&&(r=1):l!==-1&&(r=-1)}return l===-1||t===-1||r===0||r===1&&l===t-1&&l===c+1?"":p.slice(l,t)},format:v.bind(null,"/"),parse(p){b(p,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(p.length===0)return l;const c=p.charCodeAt(0)===S;let t;c?(l.root="/",t=1):t=0;let s=-1,r=0,i=-1,a=!0,o=p.length-1,u=0;for(;o>=t;--o){const d=p.charCodeAt(o);if(d===S){if(!a){r=o+1;break}continue}i===-1&&(a=!1,i=o+1),d===R?s===-1?s=o:u!==1&&(u=1):s!==-1&&(u=-1)}if(i!==-1){const d=r===0&&c?1:r;s===-1||u===0||u===1&&s===i-1&&s===r+1?l.base=l.name=p.slice(d,i):(l.name=p.slice(d,s),l.base=p.slice(d,i),l.ext=p.slice(s,i))}return r>0?l.dir=p.slice(0,r-1):c&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[99],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var D;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(D=e.Source||(e.Source={}));var A;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(A=e.TerminateResponseCode||(e.TerminateResponseCode={}));function P(T,...L){const R=L.reduce((n,I)=>(n[I]=!0,n),{}),S=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(n=>!R[n]).forEach(n=>{for(let I=0;I<S.length;I++)if(n.search(S[I])!==-1){delete T[n];break}})}e.sanitizeProcessEnvironment=P}),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var A in D)(typeof exports=="object"?exports:J)[A]=D[A]}}(typeof self!="undefined"?self:this,function(){return function(J){var e={};function D(A){if(e[A])return e[A].exports;var P=e[A]={i:A,l:!1,exports:{}};return J[A].call(P.exports,P,P.exports,D),P.l=!0,P.exports}return D.m=J,D.c=e,D.d=function(A,P,T){D.o(A,P)||Object.defineProperty(A,P,{enumerable:!0,get:T})},D.r=function(A){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},D.t=function(A,P){if(1&P&&(A=D(A)),8&P||4&P&&typeof A=="object"&&A&&A.__esModule)return A;var T=Object.create(null);if(D.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:A}),2&P&&typeof A!="string")for(var L in A)D.d(T,L,function(R){return A[R]}.bind(null,L));return T},D.n=function(A){var P=A&&A.__esModule?function(){return A.default}:function(){return A};return D.d(P,"a",P),P},D.o=function(A,P){return Object.prototype.hasOwnProperty.call(A,P)},D.p="",D(D.s=0)}([function(J,e,D){(function(A){var P;e=J.exports=Z,P=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],S=e.src=[],E=0,n=E++;S[n]="0|[1-9]\\d*";var I=E++;S[I]="[0-9]+";var g=E++;S[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=E++;S[b]="("+S[n]+")\\.("+S[n]+")\\.("+S[n]+")";var h=E++;S[h]="("+S[I]+")\\.("+S[I]+")\\.("+S[I]+")";var y=E++;S[y]="(?:"+S[n]+"|"+S[g]+")";var f=E++;S[f]="(?:"+S[I]+"|"+S[g]+")";var w=E++;S[w]="(?:-("+S[y]+"(?:\\."+S[y]+")*))";var v=E++;S[v]="(?:-?("+S[f]+"(?:\\."+S[f]+")*))";var p=E++;S[p]="[0-9A-Za-z-]+";var l=E++;S[l]="(?:\\+("+S[p]+"(?:\\."+S[p]+")*))";var c=E++,t="v?"+S[b]+S[w]+"?"+S[l]+"?";S[c]="^"+t+"$";var s="[v=\\s]*"+S[h]+S[v]+"?"+S[l]+"?",r=E++;S[r]="^"+s+"$";var i=E++;S[i]="((?:<|>)?=?)";var a=E++;S[a]=S[I]+"|x|X|\\*";var o=E++;S[o]=S[n]+"|x|X|\\*";var u=E++;S[u]="[v=\\s]*("+S[o]+")(?:\\.("+S[o]+")(?:\\.("+S[o]+")(?:"+S[w]+")?"+S[l]+"?)?)?";var d=E++;S[d]="[v=\\s]*("+S[a]+")(?:\\.("+S[a]+")(?:\\.("+S[a]+")(?:"+S[v]+")?"+S[l]+"?)?)?";var m=E++;S[m]="^"+S[i]+"\\s*"+S[u]+"$";var k=E++;S[k]="^"+S[i]+"\\s*"+S[d]+"$";var _=E++;S[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=E++;S[O]="(?:~>?)";var N=E++;S[N]="(\\s*)"+S[O]+"\\s+",R[N]=new RegExp(S[N],"g");var C=E++;S[C]="^"+S[O]+S[u]+"$";var F=E++;S[F]="^"+S[O]+S[d]+"$";var z=E++;S[z]="(?:\\^)";var U=E++;S[U]="(\\s*)"+S[z]+"\\s+",R[U]=new RegExp(S[U],"g");var j=E++;S[j]="^"+S[z]+S[u]+"$";var W=E++;S[W]="^"+S[z]+S[d]+"$";var x=E++;S[x]="^"+S[i]+"\\s*("+s+")$|^$";var q=E++;S[q]="^"+S[i]+"\\s*("+t+")$|^$";var $=E++;S[$]="(\\s*)"+S[i]+"\\s*("+s+"|"+S[u]+")",R[$]=new RegExp(S[$],"g");var G=E++;S[G]="^\\s*("+S[u]+")\\s+-\\s+("+S[u]+")\\s*$";var M=E++;S[M]="^\\s*("+S[d]+")\\s+-\\s+("+S[d]+")\\s*$";var B=E++;S[B]="(<|>)?=?\\s*\\*";for(var V=0;V<35;V++)P(V,S[V]),R[V]||(R[V]=new RegExp(S[V]));function Q(ee,oe){if(ee instanceof Z)return ee;if(typeof ee!="string"||ee.length>T||!(oe?R[r]:R[c]).test(ee))return null;try{return new Z(ee,oe)}catch(ce){return null}}function Z(ee,oe){if(ee instanceof Z){if(ee.loose===oe)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof Z))return new Z(ee,oe);P("SemVer",ee,oe),this.loose=oe;var ce=ee.trim().match(oe?R[r]:R[c]);if(!ce)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+ce[1],this.minor=+ce[2],this.patch=+ce[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");ce[4]?this.prerelease=ce[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var pe=+ye;if(pe>=0&&pe<L)return pe}return ye}):this.prerelease=[],this.build=ce[5]?ce[5].split("."):[],this.format()}e.parse=Q,e.valid=function(ee,oe){var ce=Q(ee,oe);return ce?ce.version:null},e.clean=function(ee,oe){var ce=Q(ee.trim().replace(/^[=v]+/,""),oe);return ce?ce.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(ee){return P("SemVer.compare",this.version,this.loose,ee),ee instanceof Z||(ee=new Z(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},Z.prototype.compareMain=function(ee){return ee instanceof Z||(ee=new Z(ee,this.loose)),H(this.major,ee.major)||H(this.minor,ee.minor)||H(this.patch,ee.patch)},Z.prototype.comparePre=function(ee){if(ee instanceof Z||(ee=new Z(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var oe=0;do{var ce=this.prerelease[oe],ye=ee.prerelease[oe];if(P("prerelease compare",oe,ce,ye),ce===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(ce===void 0)return-1;if(ce!==ye)return H(ce,ye)}while(++oe)},Z.prototype.inc=function(ee,oe){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",oe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",oe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",oe),this.inc("pre",oe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",oe),this.inc("pre",oe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ce=this.prerelease.length;--ce>=0;)typeof this.prerelease[ce]=="number"&&(this.prerelease[ce]++,ce=-2);ce===-1&&this.prerelease.push(0)}oe&&(this.prerelease[0]===oe?isNaN(this.prerelease[1])&&(this.prerelease=[oe,0]):this.prerelease=[oe,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,oe,ce,ye){typeof ce=="string"&&(ye=ce,ce=void 0);try{return new Z(ee,ce).inc(oe,ye).version}catch(pe){return null}},e.diff=function(ee,oe){if(ue(ee,oe))return null;var ce=Q(ee),ye=Q(oe);if(ce.prerelease.length||ye.prerelease.length){for(var pe in ce)if((pe==="major"||pe==="minor"||pe==="patch")&&ce[pe]!==ye[pe])return"pre"+pe;return"prerelease"}for(var pe in ce)if((pe==="major"||pe==="minor"||pe==="patch")&&ce[pe]!==ye[pe])return pe},e.compareIdentifiers=H;var K=/^[0-9]+$/;function H(ee,oe){var ce=K.test(ee),ye=K.test(oe);return ce&&ye&&(ee=+ee,oe=+oe),ce&&!ye?-1:ye&&!ce?1:ee<oe?-1:ee>oe?1:0}function re(ee,oe,ce){return new Z(ee,ce).compare(new Z(oe,ce))}function ie(ee,oe,ce){return re(ee,oe,ce)>0}function ae(ee,oe,ce){return re(ee,oe,ce)<0}function ue(ee,oe,ce){return re(ee,oe,ce)===0}function fe(ee,oe,ce){return re(ee,oe,ce)!==0}function de(ee,oe,ce){return re(ee,oe,ce)>=0}function Ie(ee,oe,ce){return re(ee,oe,ce)<=0}function Ce(ee,oe,ce,ye){var pe;switch(oe){case"===":typeof ee=="object"&&(ee=ee.version),typeof ce=="object"&&(ce=ce.version),pe=ee===ce;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof ce=="object"&&(ce=ce.version),pe=ee!==ce;break;case"":case"=":case"==":pe=ue(ee,ce,ye);break;case"!=":pe=fe(ee,ce,ye);break;case">":pe=ie(ee,ce,ye);break;case">=":pe=de(ee,ce,ye);break;case"<":pe=ae(ee,ce,ye);break;case"<=":pe=Ie(ee,ce,ye);break;default:throw new TypeError("Invalid operator: "+oe)}return pe}function Ee(ee,oe){if(ee instanceof Ee){if(ee.loose===oe)return ee;ee=ee.value}if(!(this instanceof Ee))return new Ee(ee,oe);P("comparator",ee,oe),this.loose=oe,this.parse(ee),this.semver===_e?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(ee,oe){return H(oe,ee)},e.major=function(ee,oe){return new Z(ee,oe).major},e.minor=function(ee,oe){return new Z(ee,oe).minor},e.patch=function(ee,oe){return new Z(ee,oe).patch},e.compare=re,e.compareLoose=function(ee,oe){return re(ee,oe,!0)},e.rcompare=function(ee,oe,ce){return re(oe,ee,ce)},e.sort=function(ee,oe){return ee.sort(function(ce,ye){return e.compare(ce,ye,oe)})},e.rsort=function(ee,oe){return ee.sort(function(ce,ye){return e.rcompare(ce,ye,oe)})},e.gt=ie,e.lt=ae,e.eq=ue,e.neq=fe,e.gte=de,e.lte=Ie,e.cmp=Ce,e.Comparator=Ee;var _e={};function Re(ee,oe){if(ee instanceof Re)return ee.loose===oe?ee:new Re(ee.raw,oe);if(ee instanceof Ee)return new Re(ee.value,oe);if(!(this instanceof Re))return new Re(ee,oe);if(this.loose=oe,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(ce){return this.parseRange(ce.trim())},this).filter(function(ce){return ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function ke(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Fe(ee,oe,ce,ye,pe,Oe,De,Y,se,le,ge,me,be){return((oe=ke(ce)?"":ke(ye)?">="+ce+".0.0":ke(pe)?">="+ce+"."+ye+".0":">="+oe)+" "+(Y=ke(se)?"":ke(le)?"<"+(+se+1)+".0.0":ke(ge)?"<"+se+"."+(+le+1)+".0":me?"<="+se+"."+le+"."+ge+"-"+me:"<="+Y)).trim()}function $e(ee,oe){for(var ce=0;ce<ee.length;ce++)if(!ee[ce].test(oe))return!1;if(oe.prerelease.length){for(ce=0;ce<ee.length;ce++)if(P(ee[ce].semver),ee[ce].semver!==_e&&ee[ce].semver.prerelease.length>0){var ye=ee[ce].semver;if(ye.major===oe.major&&ye.minor===oe.minor&&ye.patch===oe.patch)return!0}return!1}return!0}function Ne(ee,oe,ce){try{oe=new Re(oe,ce)}catch(ye){return!1}return oe.test(ee)}function qe(ee,oe,ce,ye){var pe,Oe,De,Y,se;switch(ee=new Z(ee,ye),oe=new Re(oe,ye),ce){case">":pe=ie,Oe=Ie,De=ae,Y=">",se=">=";break;case"<":pe=ae,Oe=de,De=ie,Y="<",se="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(ee,oe,ye))return!1;for(var le=0;le<oe.set.length;++le){var ge=oe.set[le],me=null,be=null;if(ge.forEach(function(Te){Te.semver===_e&&(Te=new Ee(">=0.0.0")),me=me||Te,be=be||Te,pe(Te.semver,me.semver,ye)?me=Te:De(Te.semver,be.semver,ye)&&(be=Te)}),me.operator===Y||me.operator===se||(!be.operator||be.operator===Y)&&Oe(ee,be.semver)||be.operator===se&&De(ee,be.semver))return!1}return!0}Ee.prototype.parse=function(ee){var oe=this.loose?R[x]:R[q],ce=ee.match(oe);if(!ce)throw new TypeError("Invalid comparator: "+ee);this.operator=ce[1],this.operator==="="&&(this.operator=""),ce[2]?this.semver=new Z(ce[2],this.loose):this.semver=_e},Ee.prototype.toString=function(){return this.value},Ee.prototype.test=function(ee){return P("Comparator.test",ee,this.loose),this.semver===_e||(typeof ee=="string"&&(ee=new Z(ee,this.loose)),Ce(ee,this.operator,this.semver,this.loose))},Ee.prototype.intersects=function(ee,oe){if(!(ee instanceof Ee))throw new TypeError("a Comparator is required");var ce;if(this.operator==="")return ce=new Re(ee.value,oe),Ne(this.value,ce,oe);if(ee.operator==="")return ce=new Re(this.value,oe),Ne(ee.semver,ce,oe);var ye=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),pe=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),Oe=this.semver.version===ee.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Y=Ce(this.semver,"<",ee.semver,oe)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),se=Ce(this.semver,">",ee.semver,oe)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return ye||pe||Oe&&De||Y||se},e.Range=Re,Re.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},Re.prototype.toString=function(){return this.range},Re.prototype.parseRange=function(ee){var oe=this.loose;ee=ee.trim(),P("range",ee,oe);var ce=oe?R[M]:R[G];ee=ee.replace(ce,Fe),P("hyphen replace",ee),ee=ee.replace(R[$],"$1$2$3"),P("comparator trim",ee,R[$]),ee=(ee=(ee=ee.replace(R[N],"$1~")).replace(R[U],"$1^")).split(/\s+/).join(" ");var ye=oe?R[x]:R[q],pe=ee.split(" ").map(function(Oe){return function(De,Y){return P("comp",De),De=function(se,le){return se.trim().split(/\s+/).map(function(ge){return function(me,be){P("caret",me,be);var Te=be?R[W]:R[j];return me.replace(Te,function(Le,Se,we,Pe,Ae){var Ue;return P("caret",me,Le,Se,we,Pe,Ae),ke(Se)?Ue="":ke(we)?Ue=">="+Se+".0.0 <"+(+Se+1)+".0.0":ke(Pe)?Ue=Se==="0"?">="+Se+"."+we+".0 <"+Se+"."+(+we+1)+".0":">="+Se+"."+we+".0 <"+(+Se+1)+".0.0":Ae?(P("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Ue=Se==="0"?we==="0"?">="+Se+"."+we+"."+Pe+Ae+" <"+Se+"."+we+"."+(+Pe+1):">="+Se+"."+we+"."+Pe+Ae+" <"+Se+"."+(+we+1)+".0":">="+Se+"."+we+"."+Pe+Ae+" <"+(+Se+1)+".0.0"):(P("no pr"),Ue=Se==="0"?we==="0"?">="+Se+"."+we+"."+Pe+" <"+Se+"."+we+"."+(+Pe+1):">="+Se+"."+we+"."+Pe+" <"+Se+"."+(+we+1)+".0":">="+Se+"."+we+"."+Pe+" <"+(+Se+1)+".0.0"),P("caret return",Ue),Ue})}(ge,le)}).join(" ")}(De,Y),P("caret",De),De=function(se,le){return se.trim().split(/\s+/).map(function(ge){return function(me,be){var Te=be?R[F]:R[C];return me.replace(Te,function(Le,Se,we,Pe,Ae){var Ue;return P("tilde",me,Le,Se,we,Pe,Ae),ke(Se)?Ue="":ke(we)?Ue=">="+Se+".0.0 <"+(+Se+1)+".0.0":ke(Pe)?Ue=">="+Se+"."+we+".0 <"+Se+"."+(+we+1)+".0":Ae?(P("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Ue=">="+Se+"."+we+"."+Pe+Ae+" <"+Se+"."+(+we+1)+".0"):Ue=">="+Se+"."+we+"."+Pe+" <"+Se+"."+(+we+1)+".0",P("tilde return",Ue),Ue})}(ge,le)}).join(" ")}(De,Y),P("tildes",De),De=function(se,le){return P("replaceXRanges",se,le),se.split(/\s+/).map(function(ge){return function(me,be){me=me.trim();var Te=be?R[k]:R[m];return me.replace(Te,function(Le,Se,we,Pe,Ae,Ue){P("xRange",me,Le,Se,we,Pe,Ae,Ue);var it=ke(we),Ge=it||ke(Pe),je=Ge||ke(Ae);return Se==="="&&je&&(Se=""),it?Le=Se===">"||Se==="<"?"<0.0.0":"*":Se&&je?(Ge&&(Pe=0),je&&(Ae=0),Se===">"?(Se=">=",Ge?(we=+we+1,Pe=0,Ae=0):je&&(Pe=+Pe+1,Ae=0)):Se==="<="&&(Se="<",Ge?we=+we+1:Pe=+Pe+1),Le=Se+we+"."+Pe+"."+Ae):Ge?Le=">="+we+".0.0 <"+(+we+1)+".0.0":je&&(Le=">="+we+"."+Pe+".0 <"+we+"."+(+Pe+1)+".0"),P("xRange return",Le),Le})}(ge,le)}).join(" ")}(De,Y),P("xrange",De),De=function(se,le){return P("replaceStars",se,le),se.trim().replace(R[B],"")}(De,Y),P("stars",De),De}(Oe,oe)}).join(" ").split(/\s+/);return this.loose&&(pe=pe.filter(function(Oe){return!!Oe.match(ye)})),pe=pe.map(function(Oe){return new Ee(Oe,oe)})},Re.prototype.intersects=function(ee,oe){if(!(ee instanceof Re))throw new TypeError("a Range is required");return this.set.some(function(ce){return ce.every(function(ye){return ee.set.some(function(pe){return pe.every(function(Oe){return ye.intersects(Oe,oe)})})})})},e.toComparators=function(ee,oe){return new Re(ee,oe).set.map(function(ce){return ce.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},Re.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new Z(ee,this.loose));for(var oe=0;oe<this.set.length;oe++)if($e(this.set[oe],ee))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(ee,oe,ce){var ye=null,pe=null;try{var Oe=new Re(oe,ce)}catch(De){return null}return ee.forEach(function(De){Oe.test(De)&&(ye&&pe.compare(De)!==-1||(pe=new Z(ye=De,ce)))}),ye},e.minSatisfying=function(ee,oe,ce){var ye=null,pe=null;try{var Oe=new Re(oe,ce)}catch(De){return null}return ee.forEach(function(De){Oe.test(De)&&(ye&&pe.compare(De)!==1||(pe=new Z(ye=De,ce)))}),ye},e.validRange=function(ee,oe){try{return new Re(ee,oe).range||"*"}catch(ce){return null}},e.ltr=function(ee,oe,ce){return qe(ee,oe,"<",ce)},e.gtr=function(ee,oe,ce){return qe(ee,oe,">",ce)},e.outside=qe,e.prerelease=function(ee,oe){var ce=Q(ee,oe);return ce&&ce.prerelease.length?ce.prerelease:null},e.intersects=function(ee,oe,ce){return ee=new Re(ee,ce),oe=new Re(oe,ce),ee.intersects(oe)},e.coerce=function(ee){if(ee instanceof Z)return ee;if(typeof ee!="string")return null;var oe=ee.match(R[_]);return oe==null?null:Q((oe[1]||"0")+"."+(oe[2]||"0")+"."+(oe[3]||"0"))}}).call(this,D(1))},function(J,e){var D,A,P=J.exports={};function T(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function R(f){if(D===setTimeout)return setTimeout(f,0);if((D===T||!D)&&setTimeout)return D=setTimeout,setTimeout(f,0);try{return D(f,0)}catch(w){try{return D.call(null,f,0)}catch(v){return D.call(this,f,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:T}catch(f){D=T}try{A=typeof clearTimeout=="function"?clearTimeout:L}catch(f){A=L}})();var S,E=[],n=!1,I=-1;function g(){n&&S&&(n=!1,S.length?E=S.concat(E):I=-1,E.length&&b())}function b(){if(!n){var f=R(g);n=!0;for(var w=E.length;w;){for(S=E,E=[];++I<w;)S&&S[I].run();I=-1,w=E.length}S=null,n=!1,function(v){if(A===clearTimeout)return clearTimeout(v);if((A===L||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(v);try{A(v)}catch(p){try{return A.call(null,v)}catch(l){return A.call(this,v)}}}(f)}}function h(f,w){this.fun=f,this.array=w}function y(){}P.nextTick=function(f){var w=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)w[v-1]=arguments[v];E.push(new h(f,w)),E.length!==1||n||R(b)},h.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=y,P.addListener=y,P.once=y,P.off=y,P.removeListener=y,P.removeAllListeners=y,P.emit=y,P.prependListener=y,P.prependOnceListener=y,P.listeners=function(f){return[]},P.binding=function(f){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(f){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(te[100],ne([0,1,4]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=D.globals.performance&&typeof D.globals.performance.now=="function";class P{constructor(L){this._highResolution=A&&L,this._startTime=this._now(),this._stopTime=-1}static create(L=!0){return new P(L)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=P}),define(te[3],ne([0,1,8,67,2,98,100]),function(J,e,D,A,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var R;(function(l){l.None=()=>P.Disposable.None;function c(U){return(j,W=null,x)=>{let q=!1,$;return $=U(G=>{if(!q)return $?$.dispose():q=!0,j.call(W,G)},null,x),q&&$.dispose(),$}}l.once=c;function t(U,j){return u((W,x=null,q)=>U($=>W.call(x,j($)),null,q))}l.map=t;function s(U,j){return u((W,x=null,q)=>U($=>{j($),W.call(x,$)},null,q))}l.forEach=s;function r(U,j){return u((W,x=null,q)=>U($=>j($)&&W.call(x,$),null,q))}l.filter=r;function i(U){return U}l.signal=i;function a(...U){return(j,W=null,x)=>(0,P.combinedDisposable)(...U.map(q=>q($=>j.call(W,$),null,x)))}l.any=a;function o(U,j,W){let x=W;return t(U,q=>(x=j(x,q),x))}l.reduce=o;function u(U){let j;const W=new g({onFirstListenerAdd(){j=U(W.fire,W)},onLastListenerRemove(){j.dispose()}});return W.event}function d(U,j,W=100,x=!1,q){let $,G,M,B=0;const V=new g({leakWarningThreshold:q,onFirstListenerAdd(){$=U(Q=>{B++,G=j(G,Q),x&&!M&&(V.fire(G),G=void 0),clearTimeout(M),M=setTimeout(()=>{const Z=G;G=void 0,M=void 0,(!x||B>1)&&V.fire(Z),B=0},W)})},onLastListenerRemove(){$.dispose()}});return V.event}l.debounce=d;function m(U,j=(W,x)=>W===x){let W=!0,x;return r(U,q=>{const $=W||!j(q,x);return W=!1,x=q,$})}l.latch=m;function k(U,j){return[l.filter(U,j),l.filter(U,W=>!j(W))]}l.split=k;function _(U,j=!1,W=[]){let x=W.slice(),q=U(M=>{x?x.push(M):G.fire(M)});const $=()=>{x&&x.forEach(M=>G.fire(M)),x=null},G=new g({onFirstListenerAdd(){q||(q=U(M=>G.fire(M)))},onFirstListenerDidAdd(){x&&(j?setTimeout($):$())},onLastListenerRemove(){q&&q.dispose(),q=null}});return G.event}l.buffer=_;class O{constructor(j){this.event=j}map(j){return new O(t(this.event,j))}forEach(j){return new O(s(this.event,j))}filter(j){return new O(r(this.event,j))}reduce(j,W){return new O(o(this.event,j,W))}latch(){return new O(m(this.event))}debounce(j,W=100,x=!1,q){return new O(d(this.event,j,W,x,q))}on(j,W,x){return this.event(j,W,x)}once(j,W,x){return c(this.event)(j,W,x)}}function N(U){return new O(U)}l.chain=N;function C(U,j,W=x=>x){const x=(...M)=>G.fire(W(...M)),q=()=>U.on(j,x),$=()=>U.removeListener(j,x),G=new g({onFirstListenerAdd:q,onLastListenerRemove:$});return G.event}l.fromNodeEventEmitter=C;function F(U,j,W=x=>x){const x=(...M)=>G.fire(W(...M)),q=()=>U.addEventListener(j,x),$=()=>U.removeEventListener(j,x),G=new g({onFirstListenerAdd:q,onLastListenerRemove:$});return G.event}l.fromDOMEventEmitter=F;function z(U){return new Promise(j=>c(U)(j))}l.toPromise=z})(R=e.Event||(e.Event={}));class S{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${S._idPool++}`}start(c){this._stopWatch=new L.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let E=-1;function n(l){const c=E;return E=l,{dispose(){E=c}}}e.setGlobalLeakWarningThreshold=n;class I{constructor(c,t=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=t,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c){let t=E;if(typeof this.customThreshold=="number"&&(t=this.customThreshold),t<=0||c<t)return;this._stacks||(this._stacks=new Map);const s=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(s)||0;if(this._stacks.set(s,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=t*.5;let i,a=0;for(const[o,u]of this._stacks)(!i||a<u)&&(i=o,a=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${c} listeners already. MOST frequent listener (${a}):`),console.warn(i)}return()=>{const i=this._stacks.get(s)||0;this._stacks.set(s,i-1)}}}class g{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=E>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(c,t,s)=>{this._listeners||(this._listeners=new T.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(t?[c,t]:c);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,t);const a=this._leakageMon?.check(this._listeners.size),o=(0,P.toDisposable)(()=>{a&&a(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return s instanceof P.DisposableStore?s.add(o):Array.isArray(s)&&s.push(o),o}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,c]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,s]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,s):t[0].call(t[1],s)}catch(r){(0,D.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=g;class b extends g{async fireAsync(c,t,s){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,c]);for(;this._asyncDeliveryQueue.size>0&&!t.isCancellationRequested;){const[r,i]=this._asyncDeliveryQueue.shift(),a=[],o={...i,waitUntil:u=>{if(Object.isFrozen(a))throw new Error("waitUntil can NOT be called asynchronous");s&&(u=s(u,typeof r=="function"?r:r[0])),a.push(u)}};try{typeof r=="function"?r.call(void 0,o):r[0].call(r[1],o)}catch(u){(0,D.onUnexpectedError)(u);continue}Object.freeze(a),await Promise.allSettled(a).then(u=>{for(const d of u)d.status==="rejected"&&(0,D.onUnexpectedError)(d.reason)})}}}}e.AsyncEmitter=b;class h extends g{constructor(c){super(c);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=h;class y extends h{constructor(c){super(c);this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=y;class f extends g{constructor(c){super(c);this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(t=>super.fire(t)),this._queuedEvents=[]})}}e.MicrotaskEmitter=f;class w{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const t={event:c,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);const s=()=>{this.hasListeners&&this.unhook(t);const r=this.events.indexOf(t);this.events.splice(r,1)};return(0,P.toDisposable)((0,A.once)(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(t=>this.emitter.fire(t))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=w;class v{constructor(){this.buffers=[]}wrapEvent(c){return(t,s,r)=>c(i=>{const a=this.buffers[this.buffers.length-1];a?a.push(()=>t.call(s,i)):t.call(s,i)},void 0,r)}bufferEvents(c){const t=[];this.buffers.push(t);const s=c();return this.buffers.pop(),t.forEach(r=>r()),s}}e.EventBufferer=v;class p{constructor(){this.listening=!1,this.inputEvent=R.None,this.inputEventListener=P.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=p}),define(te[27],ne([0,1,3]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(R,S){const E=setTimeout(R.bind(S),0);return{dispose(){clearTimeout(E)}}});var P;(function(R){function S(E){return E===R.None||E===R.Cancelled||E instanceof T?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}R.isCancellationToken=S,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(P=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?A:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class L{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=P.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=P.None}}e.CancellationTokenSource=L}),define(te[50],ne([0,1,3]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class A{constructor(){this._icons=new Map,this._onDidRegister=new D.Emitter}add(I){const g=this._icons.get(I.id);g?I.description?g.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const P=new A;e.iconRegistry=P;function T(n,I){return new R(n,I)}e.registerCodicon=T;function L(n){return n?n.replace(/\$\((.*?)\)/g,(I,g)=>` ${g} `).trim():""}e.getCodiconAriaLabel=L;class R{constructor(I,g,b){this.id=I,this.definition=g,this.description=b,P.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=R;function S(n,I){const g=["codicon","codicon-"+n];return I&&g.push("codicon-modifier-"+I),g}e.getClassNamesArray=S;var E;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function g(y){if(y instanceof R)return["codicon","codicon-"+y.id];const f=I.exec(y.id);if(!f)return g(R.error);let[,w,v]=f;const p=["codicon","codicon-"+w];return v&&p.push("codicon-modifier-"+v.substr(1)),p}n.asClassNameArray=g;function b(y){return g(y).join(" ")}n.asClassName=b;function h(y){return"."+g(y).join(".")}n.asCSSSelector=h})(E=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"})}(R=e.Codicon||(e.Codicon={}))}),define(te[51],ne([0,1,8,2]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function P(p){const l=p;return l?[l.on,l.pause,l.resume,l.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=P;function T(p){const l=p;return l?P(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=T;function L(p,l){return new R(p,l)}e.newWriteableStream=L;class R{constructor(l,c){this.reducer=l,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(c=>c(l))}emitError(l){this.listeners.error.length===0?(0,D.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(c=>c(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,c){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(l,c){if(this.state.destroyed)return;let t;switch(l){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const s=t.indexOf(c);s>=0&&t.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(p,l){const c=[];let t;for(;(t=p.read())!==null;)c.push(t);return l(c)}e.consumeReadable=S;function E(p,l,c){const t=[];let s;for(;(s=p.read())!==null&&t.length<c;)t.push(s);return s===null&&t.length>0?l(t):{read:()=>{if(t.length>0)return t.shift();if(typeof s!="undefined"){const r=s;return s=void 0,r}return p.read()}}}e.peekReadable=E;function n(p,l){return new Promise((c,t)=>{const s=[];I(p,{onData:r=>{l&&s.push(r)},onError:r=>{l?t(r):c(void 0)},onEnd:()=>{c(l?l(s):void 0)}})})}e.consumeStream=n;function I(p,l){p.on("error",c=>l.onError(c)),p.on("end",()=>l.onEnd()),p.on("data",c=>l.onData(c))}e.listenStream=I;function g(p,l){return new Promise((c,t)=>{const s=new A.DisposableStore,r=[],i=u=>{if(r.push(u),r.length>l)return s.dispose(),p.pause(),c({stream:p,buffer:r,ended:!1})},a=u=>t(u),o=()=>c({stream:p,buffer:r,ended:!0});s.add((0,A.toDisposable)(()=>p.removeListener("error",a))),p.on("error",a),s.add((0,A.toDisposable)(()=>p.removeListener("end",o))),p.on("end",o),s.add((0,A.toDisposable)(()=>p.removeListener("data",i))),p.on("data",i)})}e.peekStream=g;function b(p,l){const c=L(l);return c.end(p),c}e.toStream=b;function h(){const p=L(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=h;function y(p){let l=!1;return{read:()=>l?null:(l=!0,p)}}e.toReadable=y;function f(p,l,c){const t=L(c);return I(p,{onData:s=>t.write(l.data(s)),onError:s=>t.error(l.error?l.error(s):s),onEnd:()=>t.end()}),t}e.transform=f;function w(p,l,c){let t=!1;return{read:()=>{const s=l.read();return t?s:(t=!0,s!==null?c([p,s]):p)}}}e.prefixedReadable=w;function v(p,l,c){let t=!1;const s=L(c);return I(l,{onData:r=>t?s.write(r):(t=!0,s.write(c([p,r]))),onError:r=>s.error(r),onEnd:()=>{t||(t=!0,s.write(p)),s.end()}}),s}e.prefixedStream=v}),define(te[22],ne([0,1,51]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined";let P,T;class L{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return A?new L(Buffer.allocUnsafe(i)):new L(new Uint8Array(i))}static wrap(i){return A&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new L(i)}static fromString(i,a){return!(a?.dontUseNodeBuffer||!1)&&A?new L(Buffer.from(i)):(P||(P=new TextEncoder),new L(P.encode(i)))}static concat(i,a){if(typeof a=="undefined"){a=0;for(let d=0,m=i.length;d<m;d++)a+=i[d].byteLength}const o=L.alloc(a);let u=0;for(let d=0,m=i.length;d<m;d++){const k=i[d];o.set(k,u),u+=k.byteLength}return o}toString(){return A?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(i,a){return new L(this.buffer.subarray(i,a))}set(i,a){i instanceof L?this.buffer.set(i.buffer,a):this.buffer.set(i,a)}readUInt32BE(i){return E(this.buffer,i)}writeUInt32BE(i,a){n(this.buffer,i,a)}readUInt32LE(i){return I(this.buffer,i)}writeUInt32LE(i,a){g(this.buffer,i,a)}readUInt8(i){return b(this.buffer,i)}writeUInt8(i,a){h(this.buffer,i,a)}}e.VSBuffer=L;function R(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0}e.readUInt16LE=R;function S(r,i,a){r[a+0]=i&255,i=i>>>8,r[a+1]=i&255}e.writeUInt16LE=S;function E(r,i){return r[i]*2**24+r[i+1]*2**16+r[i+2]*2**8+r[i+3]}e.readUInt32BE=E;function n(r,i,a){r[a+3]=i,i=i>>>8,r[a+2]=i,i=i>>>8,r[a+1]=i,i=i>>>8,r[a]=i}e.writeUInt32BE=n;function I(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0|r[i+2]<<16>>>0|r[i+3]<<24>>>0}e.readUInt32LE=I;function g(r,i,a){r[a+0]=i&255,i=i>>>8,r[a+1]=i&255,i=i>>>8,r[a+2]=i&255,i=i>>>8,r[a+3]=i&255}e.writeUInt32LE=g;function b(r,i){return r[i]}e.readUInt8=b;function h(r,i,a){r[a]=i}e.writeUInt8=h;function y(r){return D.consumeReadable(r,i=>L.concat(i))}e.readableToBuffer=y;function f(r){return D.toReadable(r)}e.bufferToReadable=f;function w(r){return D.consumeStream(r,i=>L.concat(i))}e.streamToBuffer=w;async function v(r){return r.ended?L.concat(r.buffer):L.concat([...r.buffer,await w(r.stream)])}e.bufferedStreamToBuffer=v;function p(r){return D.toStream(r,i=>L.concat(i))}e.bufferToStream=p;function l(r){return D.transform(r,{data:i=>typeof i=="string"?L.fromString(i):L.wrap(i)},i=>L.concat(i))}e.streamToBufferReadableStream=l;function c(r){return D.newWriteableStream(i=>L.concat(i),r)}e.newWriteableBufferStream=c;function t(r,i){return D.prefixedReadable(r,i,a=>L.concat(a))}e.prefixedBufferReadable=t;function s(r,i){return D.prefixedStream(r,i,a=>L.concat(a))}e.prefixedBufferStream=s}),define(te[25],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=D;const A=/{(\d+)}/g;function P(Y,...se){return se.length===0?Y:Y.replace(A,function(le,ge){const me=parseInt(ge,10);return isNaN(me)||me<0||me>=se.length?le:se[me]})}e.format=P;const T=/{([^}]+)}/g;function L(Y,se){return Y.replace(T,(le,ge)=>se[ge]??le)}e.format2=L;function R(Y){return Y.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=R;function S(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function E(Y,se){let le=0;const ge=se.charCodeAt(0);for(let me=Y.length-1;me>=0;me--)Y.charCodeAt(me)===ge&&le++;return le}e.count=E;function n(Y,se,le="\u2026"){return Y.length<=se?Y:`${Y.substr(0,se)}${le}`}e.truncate=n;function I(Y,se=" "){const le=g(Y,se);return b(le,se)}e.trim=I;function g(Y,se){if(!Y||!se)return Y;const le=se.length;if(le===0||Y.length===0)return Y;let ge=0;for(;Y.indexOf(se,ge)===ge;)ge=ge+le;return Y.substring(ge)}e.ltrim=g;function b(Y,se){if(!Y||!se)return Y;const le=se.length,ge=Y.length;if(le===0||ge===0)return Y;let me=ge,be=-1;for(;be=Y.lastIndexOf(se,me-1),!(be===-1||be+le!==me);){if(be===0)return"";me=be}return Y.substring(0,me)}e.rtrim=b;function h(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function y(Y){return Y.replace(/\*/g,"")}e.stripWildcards=y;function f(Y,se,le={}){if(!Y)throw new Error("Cannot create regex from empty string");se||(Y=S(Y)),le.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let ge="";return le.global&&(ge+="g"),le.matchCase||(ge+="i"),le.multiline&&(ge+="m"),le.unicode&&(ge+="u"),new RegExp(Y,ge)}e.createRegExp=f;function w(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function v(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=v;function p(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=p;function l(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=l;function c(Y){for(let se=0,le=Y.length;se<le;se++){const ge=Y.charCodeAt(se);if(ge!==32&&ge!==9)return se}return-1}e.firstNonWhitespaceIndex=c;function t(Y,se=0,le=Y.length){for(let ge=se;ge<le;ge++){const me=Y.charCodeAt(ge);if(me!==32&&me!==9)return Y.substring(se,ge)}return Y.substring(se,le)}e.getLeadingWhitespace=t;function s(Y,se=Y.length-1){for(let le=se;le>=0;le--){const ge=Y.charCodeAt(le);if(ge!==32&&ge!==9)return le}return-1}e.lastNonWhitespaceIndex=s;function r(Y,se){return Y<se?-1:Y>se?1:0}e.compare=r;function i(Y,se,le=0,ge=Y.length,me=0,be=se.length){for(;le<ge&&me<be;le++,me++){let Se=Y.charCodeAt(le),we=se.charCodeAt(me);if(Se<we)return-1;if(Se>we)return 1}const Te=ge-le,Le=be-me;return Te<Le?-1:Te>Le?1:0}e.compareSubstring=i;function a(Y,se){return o(Y,se,0,Y.length,0,se.length)}e.compareIgnoreCase=a;function o(Y,se,le=0,ge=Y.length,me=0,be=se.length){for(;le<ge&&me<be;le++,me++){let Se=Y.charCodeAt(le),we=se.charCodeAt(me);if(Se===we)continue;if(Se>=128||we>=128)return i(Y.toLowerCase(),se.toLowerCase(),le,ge,me,be);u(Se)&&(Se-=32),u(we)&&(we-=32);const Pe=Se-we;if(Pe!==0)return Pe}const Te=ge-le,Le=be-me;return Te<Le?-1:Te>Le?1:0}e.compareSubstringIgnoreCase=o;function u(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=u;function d(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=d;function m(Y,se){return Y.length===se.length&&o(Y,se)===0}e.equalsIgnoreCase=m;function k(Y,se){const le=se.length;return se.length>Y.length?!1:o(Y,se,0,le)===0}e.startsWithIgnoreCase=k;function _(Y,se){let le,ge=Math.min(Y.length,se.length);for(le=0;le<ge;le++)if(Y.charCodeAt(le)!==se.charCodeAt(le))return le;return ge}e.commonPrefixLength=_;function O(Y,se){let le,ge=Math.min(Y.length,se.length);const me=Y.length-1,be=se.length-1;for(le=0;le<ge;le++)if(Y.charCodeAt(me-le)!==se.charCodeAt(be-le))return le;return ge}e.commonSuffixLength=O;function N(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=N;function C(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=C;function F(Y,se){return(Y-55296<<10)+(se-56320)+65536}e.computeCodePoint=F;function z(Y,se,le){const ge=Y.charCodeAt(le);if(N(ge)&&le+1<se){const me=Y.charCodeAt(le+1);if(C(me))return F(ge,me)}return ge}e.getNextCodePoint=z;function U(Y,se){const le=Y.charCodeAt(se-1);if(C(le)&&se>1){const ge=Y.charCodeAt(se-2);if(N(ge))return F(ge,le)}return le}function j(Y,se){const le=ee.getInstance(),ge=se,me=Y.length,be=z(Y,me,se);se+=be>=65536?2:1;let Te=le.getGraphemeBreakType(be);for(;se<me;){const Le=z(Y,me,se),Se=le.getGraphemeBreakType(Le);if(Ne(Te,Se))break;se+=Le>=65536?2:1,Te=Se}return se-ge}e.nextCharLength=j;function W(Y,se){const le=ee.getInstance(),ge=se,me=U(Y,se);se-=me>=65536?2:1;let be=le.getGraphemeBreakType(me);for(;se>0;){const Te=U(Y,se),Le=le.getGraphemeBreakType(Te);if(Ne(Le,be))break;se-=Te>=65536?2:1,be=Le}return ge-se}e.prevCharLength=W;function x(Y,se){const le=ee.getInstance(),ge=Y.length,me=se,be=z(Y,ge,se),Te=le.getGraphemeBreakType(be);se+=be>=65536?2:1;let Le=Te;for(;se<ge;){const we=z(Y,ge,se),Pe=le.getGraphemeBreakType(we);if(Ne(Le,Pe))break;se+=we>=65536?2:1,Le=Pe}const Se=se;for(se=me,Le=Te;se>0;){const we=U(Y,se),Pe=le.getGraphemeBreakType(we);if(Ne(Pe,Le))break;se-=we>=65536?2:1,Le=Pe}return[se,Se]}function q(Y,se){return se>0&&C(Y.charCodeAt(se))?x(Y,se-1):x(Y,se)}e.getCharContainingOffset=q;const $=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function G(Y){return $.test(Y)}e.containsRTL=G;const M=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function B(Y){return M.test(Y)}e.containsEmoji=B;const V=/^[\t\n\r\x20-\x7E]*$/;function Q(Y){return V.test(Y)}e.isBasicASCII=Q,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=Z;function K(Y){for(let se=0,le=Y.length;se<le;se++)if(H(Y.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=K;function H(Y){return Y=+Y,Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=H;function re(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129003||Y>=129280&&Y<=129535||Y>=129648&&Y<=129750}e.isEmojiImprecise=re;function ie(Y,se){if(Y.length<se)return Y;const le=/\b/g;let ge=0;for(;le.test(Y)&&!(Y.length-le.lastIndex<se);)ge=le.lastIndex,le.lastIndex+=1;return Y.substring(ge).replace(/^\s/,"")}e.lcut=ie;const ae=/\x1B\x5B[12]?K/g,ue=/\x1b\[\d+m/g,fe=/\x1b\[0?m/g;function de(Y){return Y&&(Y=Y.replace(ae,""),Y=Y.replace(ue,""),Y=Y.replace(fe,"")),Y}e.removeAnsiEscapeCodes=de,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ie(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ie;function Ce(Y){return Ie(Y)?Y.substr(1):Y}e.stripUTF8BOM=Ce;function Ee(Y,se){if(!Y||!se||Y.length<se.length)return!1;const le=se.length,ge=Y.toLowerCase();let me=0,be=-1;for(;me<le;){const Te=ge.indexOf(se[me],be+1);if(Te<0)return!1;be=Te,me++}return!0}e.fuzzyContains=Ee;function _e(Y,se=!1){return Y?(se&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=_e;function Re(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=Re;function ke(Y,se=1){if(se===0)return"";let le=-1;do le=Y.indexOf(`
`,le+1),se--;while(se>0&&le>=0);return le===-1?Y:(Y[le-1]==="\r"&&le--,Y.substr(0,le))}e.getNLines=ke;function Fe(Y){const se=90-65+1;return Y=Y%(2*se),Y<se?String.fromCharCode(97+Y):String.fromCharCode(65+Y-se)}e.singleLetterHash=Fe;function $e(Y){return ee.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=$e;function Ne(Y,se){return Y===0?se!==5&&se!==7:Y===2&&se===3?!1:Y===4||Y===2||Y===3||se===4||se===2||se===3?!0:!(Y===8&&(se===8||se===9||se===11||se===12)||(Y===11||Y===9)&&(se===9||se===10)||(Y===12||Y===10)&&se===10||se===5||se===13||se===7||Y===1||Y===13&&se===14||Y===6&&se===6)}e.breakBetweenGraphemeBreakType=Ne;var qe;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(qe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ee{constructor(){this._data=oe()}static getInstance(){return ee._INSTANCE||(ee._INSTANCE=new ee),ee._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const le=this._data,ge=le.length/3;let me=1;for(;me<=ge;)if(se<le[3*me])me=2*me;else if(se>le[3*me+1])me=2*me+1;else return le[3*me+2];return 0}}ee._INSTANCE=null;function oe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function ce(Y,se){if(Y===0)return 0;const le=ye(Y,se);if(le!==void 0)return le;const ge=U(se,Y);return Y-=pe(ge),Y}e.getLeftDeleteOffset=ce;function ye(Y,se){let le=U(se,Y);for(Y-=pe(le);Oe(le)||le===65039||le===8419;){if(Y===0)return;le=U(se,Y),Y-=pe(le)}if(!!re(le)){if(Y>=0){const ge=U(se,Y);ge===8205&&(Y-=pe(ge))}return Y}}function pe(Y){return Y>=65536?2:1}function Oe(Y){return 127995<=Y&&Y<=127999}var De;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(De||(De={}))}),define(te[18],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function D(d){return Array.isArray(d)}e.isArray=D;function A(d){return typeof d=="string"}e.isString=A;function P(d){return Array.isArray(d)&&d.every(m=>A(m))}e.isStringArray=P;function T(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=T;function L(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=L;function R(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=R;function S(d){return d===!0||d===!1}e.isBoolean=S;function E(d){return typeof d=="undefined"}e.isUndefined=E;function n(d){return!I(d)}e.isDefined=n;function I(d){return E(d)||d===null}e.isUndefinedOrNull=I;function g(d,m){if(!d)throw new Error(m?`Unexpected type, expected '${m}'`:"Unexpected type")}e.assertType=g;function b(d){if(I(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=b;function h(...d){const m=[];for(let k=0;k<d.length;k++){const _=d[k];if(I(_))throw new Error(`Assertion Failed: argument at index ${k} is undefined or null`);m.push(_)}return m}e.assertAllDefined=h;const y=Object.prototype.hasOwnProperty;function f(d){if(!T(d))return!1;for(let m in d)if(y.call(d,m))return!1;return!0}e.isEmptyObject=f;function w(d){return typeof d=="function"}e.isFunction=w;function v(...d){return d.length>0&&d.every(w)}e.areFunctions=v;function p(d,m){const k=Math.min(d.length,m.length);for(let _=0;_<k;_++)l(d[_],m[_])}e.validateConstraints=p;function l(d,m){if(A(m)){if(typeof d!==m)throw new Error(`argument does not match constraint: typeof ${m}`)}else if(w(m)){try{if(d instanceof m)return}catch{}if(!I(d)&&d.constructor===m||m.length===1&&m.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function c(d){let m=[],k=Object.getPrototypeOf(d);for(;Object.prototype!==k;)m=m.concat(Object.getOwnPropertyNames(k)),k=Object.getPrototypeOf(k);return m}e.getAllPropertyNames=c;function t(d){const m=[];for(const k of c(d))typeof d[k]=="function"&&m.push(k);return m}e.getAllMethodNames=t;function s(d,m){const k=O=>function(){const N=Array.prototype.slice.call(arguments,0);return m(O,N)};let _={};for(const O of d)_[O]=k(O);return _}e.createProxyObject=s;function r(d){return d===null?void 0:d}e.withNullAsUndefined=r;function i(d){return typeof d=="undefined"?null:d}e.withUndefinedAsNull=i;function a(d){return class{constructor(){return new Proxy({},{get(m,k){if(m[k])return m[k];throw new Error(`Not Implemented: ${d}->${String(k)}`)}})}}}e.NotImplementedProxy=a;function o(d,m="Unreachable"){throw new Error(m)}e.assertNever=o;function u(d){return!!d&&typeof d.then=="function"&&typeof d.catch=="function"}e.isPromise=u}),define(te[39],ne([0,1,9,4,25,18]),function(J,e,D,A,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function L(r){return r===47||r===92}e.isPathSeparator=L;function R(r){return r.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=R;function S(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=S;function E(r,i=D.posix.sep){if(!r)return"";const a=r.length,o=r.charCodeAt(0);if(L(o)){if(L(r.charCodeAt(1))&&!L(r.charCodeAt(2))){let d=3;const m=d;for(;d<a&&!L(r.charCodeAt(d));d++);if(m!==d&&!L(r.charCodeAt(d+1))){for(d+=1;d<a;d++)if(L(r.charCodeAt(d)))return r.slice(0,d+1).replace(/[\\/]/g,i)}}return i}else if(w(o)&&r.charCodeAt(1)===58)return L(r.charCodeAt(2))?r.slice(0,2)+i:r.slice(0,2);let u=r.indexOf("://");if(u!==-1){for(u+=3;u<a;u++)if(L(r.charCodeAt(u)))return r.slice(0,u+1)}return""}e.getRoot=E;function n(r){if(!A.isWindows||!r||r.length<5)return!1;let i=r.charCodeAt(0);if(i!==92||(i=r.charCodeAt(1),i!==92))return!1;let a=2;const o=a;for(;a<r.length&&(i=r.charCodeAt(a),i!==92);a++);return!(o===a||(i=r.charCodeAt(a+1),isNaN(i)||i===92))}e.isUNC=n;const I=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(r,i=A.isWindows){const a=i?I:g;return!(!r||r.length===0||/^\s+$/.test(r)||(a.lastIndex=0,a.test(r))||i&&b.test(r)||r==="."||r===".."||i&&r[r.length-1]==="."||i&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=h;function y(r,i,a){const o=r===i;return!a||o?o:!r||!i?!1:(0,P.equalsIgnoreCase)(r,i)}e.isEqual=y;function f(r,i,a,o=D.sep){if(r===i)return!0;if(!r||!i||i.length>r.length)return!1;if(a){if(!(0,P.startsWithIgnoreCase)(r,i))return!1;if(i.length===r.length)return!0;let d=i.length;return i.charAt(i.length-1)===o&&d--,r.charAt(d)===o}return i.charAt(i.length-1)!==o&&(i+=o),r.indexOf(i)===0}e.isEqualOrParent=f;function w(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=w;function v(r,i){return A.isWindows&&r.endsWith(":")&&(r+=D.sep),(0,D.isAbsolute)(r)||(r=(0,D.join)(i,r)),r=(0,D.normalize)(r),A.isWindows?(r=(0,P.rtrim)(r,D.sep),r.endsWith(":")&&(r+=D.sep)):(r=(0,P.rtrim)(r,D.sep),r||(r=D.sep)),r}e.sanitizeFilePath=v;function p(r){const i=(0,D.normalize)(r);return A.isWindows?r.length>3?!1:l(i)&&(r.length===2||i.charCodeAt(2)===92):i===D.posix.sep}e.isRootOrDriveLetter=p;function l(r){return A.isWindows?w(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function c(r){return l(r)?r[0]:void 0}e.getDriveLetter=c;function t(r,i,a){return i.length>r.length?-1:r===i?0:(a&&(r=r.toLowerCase(),i=i.toLowerCase()),r.indexOf(i))}e.indexOfPath=t;function s(r){const i=r.split(":");let a,o,u;if(i.forEach(d=>{const m=Number(d);(0,T.isNumber)(m)?o===void 0?o=m:u===void 0&&(u=m):a=a?[a,d].join(":"):d}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:o!==void 0?o:void 0,column:u!==void 0?u:o!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(te[26],ne([0,1,18]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(y){if(!y||typeof y!="object"||y instanceof RegExp)return y;const f=Array.isArray(y)?[]:{};return Object.keys(y).forEach(w=>{y[w]&&typeof y[w]=="object"?f[w]=A(y[w]):f[w]=y[w]}),f}e.deepClone=A;function P(y){if(!y||typeof y!="object")return y;const f=[y];for(;f.length>0;){const w=f.shift();Object.freeze(w);for(const v in w)if(T.call(w,v)){const p=w[v];typeof p=="object"&&!Object.isFrozen(p)&&f.push(p)}}return y}e.deepFreeze=P;const T=Object.prototype.hasOwnProperty;function L(y,f){return R(y,f,new Set)}e.cloneAndChange=L;function R(y,f,w){if((0,D.isUndefinedOrNull)(y))return y;const v=f(y);if(typeof v!="undefined")return v;if((0,D.isArray)(y)){const p=[];for(const l of y)p.push(R(l,f,w));return p}if((0,D.isObject)(y)){if(w.has(y))throw new Error("Cannot clone recursive data-structure");w.add(y);const p={};for(let l in y)T.call(y,l)&&(p[l]=R(y[l],f,w));return w.delete(y),p}return y}function S(y,f,w=!0){return(0,D.isObject)(y)?((0,D.isObject)(f)&&Object.keys(f).forEach(v=>{v in y?w&&((0,D.isObject)(y[v])&&(0,D.isObject)(f[v])?S(y[v],f[v],w):y[v]=f[v]):y[v]=f[v]}),y):f}e.mixin=S;function E(y,f){if(y===f)return!0;if(y==null||f===null||f===void 0||typeof y!=typeof f||typeof y!="object"||Array.isArray(y)!==Array.isArray(f))return!1;let w,v;if(Array.isArray(y)){if(y.length!==f.length)return!1;for(w=0;w<y.length;w++)if(!E(y[w],f[w]))return!1}else{const p=[];for(v in y)p.push(v);p.sort();const l=[];for(v in f)l.push(v);if(l.sort(),!E(p,l))return!1;for(w=0;w<p.length;w++)if(!E(y[p[w]],f[p[w]]))return!1}return!0}e.equals=E;function n(y){const f=new Set;return JSON.stringify(y,(w,v)=>{if((0,D.isObject)(v)||Array.isArray(v)){if(f.has(v))return"[Circular]";f.add(v)}return v})}e.safeStringify=n;function I(y,f,w){const v=f(y);return typeof v=="undefined"?w:v}e.getOrDefault=I;function g(y,f){const w=Object.create(null);return!y||!f||Object.keys(f).forEach(p=>{const l=y[p],c=f[p];E(l,c)||(w[p]=c)}),w}e.distinct=g;function b(y,f){const w=f.toLowerCase(),v=Object.keys(y).find(p=>p.toLowerCase()===w);return v?y[v]:y[f]}e.getCaseInsensitive=b;function h(y,f){const w=Object.create(null);for(const v of Object.keys(y))f(v,y[v])&&(w[v]=y[v]);return w}e.filter=h}),define(te[7],ne([0,1,9,4]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const P=/^\w[\w\d+.-]*$/,T=/^\//,L=/^\/\//;function R(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!P.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!T.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(r,i){return!r&&!i?"file":r}function E(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==I&&(i=I+i):i=I;break}return i}const n="",I="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(i,a,o,u,d,m=!1){typeof i=="object"?(this.scheme=i.scheme||n,this.authority=i.authority||n,this.path=i.path||n,this.query=i.query||n,this.fragment=i.fragment||n):(this.scheme=S(i,m),this.authority=a||n,this.path=E(this.scheme,o||n),this.query=u||n,this.fragment=d||n,R(this,m))}static isUri(i){return i instanceof b?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return p(this,!1)}with(i){if(!i)return this;let{scheme:a,authority:o,path:u,query:d,fragment:m}=i;return a===void 0?a=this.scheme:a===null&&(a=n),o===void 0?o=this.authority:o===null&&(o=n),u===void 0?u=this.path:u===null&&(u=n),d===void 0?d=this.query:d===null&&(d=n),m===void 0?m=this.fragment:m===null&&(m=n),a===this.scheme&&o===this.authority&&u===this.path&&d===this.query&&m===this.fragment?this:new y(a,o,u,d,m)}static parse(i,a=!1){const o=g.exec(i);return o?new y(o[2]||n,s(o[4]||n),s(o[5]||n),s(o[7]||n),s(o[9]||n),a):new y(n,n,n,n,n)}static file(i){let a=n;if(A.isWindows&&(i=i.replace(/\\/g,I)),i[0]===I&&i[1]===I){const o=i.indexOf(I,2);o===-1?(a=i.substring(2),i=I):(a=i.substring(2,o),i=i.substring(o)||I)}return new y("file",a,i,n,n)}static from(i){const a=new y(i.scheme,i.authority,i.path,i.query,i.fragment);return R(a,!0),a}static joinPath(i,...a){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return A.isWindows&&i.scheme==="file"?o=b.file(D.win32.join(p(i,!0),...a)).path:o=D.posix.join(i.path,...a),i.with({path:o})}toString(i=!1){return l(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof b)return i;{const a=new y(i);return a._formatted=i.external,a._fsPath=i._sep===h?i.fsPath:null,a}}else return i}}e.URI=b;const h=A.isWindows?1:void 0;class y extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(i=!1){return i?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=h),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(r,i){let a,o=-1;for(let u=0;u<r.length;u++){const d=r.charCodeAt(u);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||i&&d===47)o!==-1&&(a+=encodeURIComponent(r.substring(o,u)),o=-1),a!==void 0&&(a+=r.charAt(u));else{a===void 0&&(a=r.substr(0,u));const m=f[d];m!==void 0?(o!==-1&&(a+=encodeURIComponent(r.substring(o,u)),o=-1),a+=m):o===-1&&(o=u)}}return o!==-1&&(a+=encodeURIComponent(r.substring(o))),a!==void 0?a:r}function v(r){let i;for(let a=0;a<r.length;a++){const o=r.charCodeAt(a);o===35||o===63?(i===void 0&&(i=r.substr(0,a)),i+=f[o]):i!==void 0&&(i+=r[a])}return i!==void 0?i:r}function p(r,i){let a;return r.authority&&r.path.length>1&&r.scheme==="file"?a=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?a=r.path.substr(1):a=r.path[1].toLowerCase()+r.path.substr(2):a=r.path,A.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=p;function l(r,i){const a=i?v:w;let o="",{scheme:u,authority:d,path:m,query:k,fragment:_}=r;if(u&&(o+=u,o+=":"),(d||u==="file")&&(o+=I,o+=I),d){let O=d.indexOf("@");if(O!==-1){const N=d.substr(0,O);d=d.substr(O+1),O=N.indexOf(":"),O===-1?o+=a(N,!1):(o+=a(N.substr(0,O),!1),o+=":",o+=a(N.substr(O+1),!1)),o+="@"}d=d.toLowerCase(),O=d.indexOf(":"),O===-1?o+=a(d,!1):(o+=a(d.substr(0,O),!1),o+=d.substr(O))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const O=m.charCodeAt(1);O>=65&&O<=90&&(m=`/${String.fromCharCode(O+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const O=m.charCodeAt(0);O>=65&&O<=90&&(m=`${String.fromCharCode(O+32)}:${m.substr(2)}`)}o+=a(m,!0)}return k&&(o+="?",o+=a(k,!1)),_&&(o+="#",o+=i?_:w(_,!1)),o}function c(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+c(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(t)?r.replace(t,i=>c(i)):r}}),define(te[101],ne([0,1,7]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function A(E){const n=E;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=A;function P(E){const n=[];let I;try{const g=JSON.parse(E.arguments),b=g[g.length-1];b&&b.__$stack&&(g.pop(),I=b.__$stack),n.push(...g)}catch(g){n.push("Unable to log remote console arguments",E.arguments)}return{args:n,stack:I}}e.parse=P;function T(E){if(typeof E!="string")return T(P(E).stack);const n=E;if(n){const I=L(n),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(g&&g.length===4)return{uri:D.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.getFirstFrame=T;function L(E){if(!E)return E;const n=E.indexOf(`
`);return n===-1?E:E.substring(0,n)}function R(E,n){const{args:I,stack:g}=P(E),b=typeof I[0]=="string"&&I.length===1;let h=L(g);h&&(h=`(${h.trim()})`);let y=[];if(typeof I[0]=="string"?h&&b?y=[`%c[${n}] %c${I[0]} %c${h}`,S("blue"),S(""),S("grey")]:y=[`%c[${n}] %c${I[0]}`,S("blue"),S(""),...I.slice(1)]:y=[`%c[${n}]%`,S("blue"),...I],h&&!b&&y.push(h),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,y)}e.log=R;function S(E){return`color: ${E}`}});var yt=this&&this.__classPrivateFieldSet||function(J,e,D,A,P){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!P:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?P.call(J,D):P?P.value=D:e.set(J,D),D},Be=this&&this.__classPrivateFieldGet||function(J,e,D,A){if(D==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!A:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?A:D==="a"?A.call(J):A?A.value:e.get(J)};define(te[40],ne([0,1,17,25,7]),function(J,e,D,A,P){"use strict";var T,L,R;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(r,i,a){let o=r.get(i);return o===void 0&&(o=a,r.set(i,o)),o}e.getOrSet=S;function E(r){const i=[];return r.forEach((a,o)=>{i.push(`${o} => ${a}`)}),`Map(${r.size}) {${i.join(", ")}}`}e.mapToString=E;function n(r){const i=[];return r.forEach(a=>{i.push(a)}),`Set(${r.size}) {${i.join(", ")}}`}e.setToString=n;class I{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const a=i.charCodeAt(0),o=this._value.charCodeAt(this._pos);return a-o}value(){return this._value[this._pos]}}e.StringIterator=I;class g{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,A.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=g;class b{constructor(i=!0,a=!0){this._splitOnBackslash=i,this._caseSensitive=a}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const a=this._value.charCodeAt(this._to);if(a===47||this._splitOnBackslash&&a===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,A.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=b;var h;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(h||(h={}));class y{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new b(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,A.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,A.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,A.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,A.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=y;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(w||(w={}));class v{constructor(i){this._iter=i}static forUris(i=()=>!1){return new v(new y(i))}static forPaths(){return new v(new b)}static forStrings(){return new v(new I)}static forConfigKeys(){return new v(new g)}clear(){this._root=void 0}fill(i,a){if(a){const o=a.slice(0);(0,D.shuffle)(o);for(let u of o)this.set(u,i)}else{const o=i.slice(0);(0,D.shuffle)(o);for(let u of o)this.set(u[0],u[1])}}set(i,a){const o=this._iter.reset(i);let u;this._root||(this._root=new f,this._root.segment=o.value());const d=[];for(u=this._root;;){const k=o.cmp(u.segment);if(k>0)u.left||(u.left=new f,u.left.segment=o.value()),d.push([-1,u]),u=u.left;else if(k<0)u.right||(u.right=new f,u.right.segment=o.value()),d.push([1,u]),u=u.right;else if(o.hasNext())o.next(),u.mid||(u.mid=new f,u.mid.segment=o.value()),d.push([0,u]),u=u.mid;else break}const m=u.value;u.value=a,u.key=i;for(let k=d.length-1;k>=0;k--){const _=d[k][1];_.updateHeight();const O=_.balanceFactor();if(O<-1||O>1){const N=d[k][0],C=d[k+1][0];if(N===1&&C===1)d[k][1]=_.rotateLeft();else if(N===-1&&C===-1)d[k][1]=_.rotateRight();else if(N===1&&C===-1)_.right=d[k+1][1]=d[k+1][1].rotateRight(),d[k][1]=_.rotateLeft();else if(N===-1&&C===1)_.left=d[k+1][1]=d[k+1][1].rotateLeft(),d[k][1]=_.rotateRight();else throw new Error;if(k>0)switch(d[k-1][0]){case-1:d[k-1][1].left=d[k][1];break;case 1:d[k-1][1].right=d[k][1];break;case 0:d[k-1][1].mid=d[k][1];break}else this._root=d[0][1]}}return m}get(i){return this._getNode(i)?.value}_getNode(i){const a=this._iter.reset(i);let o=this._root;for(;o;){const u=a.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(a.hasNext())a.next(),o=o.mid;else break}return o}has(i){const a=this._getNode(i);return!(a?.value===void 0&&a?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,a){const o=this._iter.reset(i),u=[];let d=this._root;for(;d;){const m=o.cmp(d.segment);if(m>0)u.push([-1,d]),d=d.left;else if(m<0)u.push([1,d]),d=d.right;else if(o.hasNext())o.next(),u.push([0,d]),d=d.mid;else break}if(!!d){if(a?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const m=this._min(d.right),{key:k,value:_,segment:O}=m;this._delete(m.key,!1),d.key=k,d.value=_,d.segment=O}else{const m=d.left??d.right;if(u.length>0){const[k,_]=u[u.length-1];switch(k){case-1:_.left=m;break;case 0:_.mid=m;break;case 1:_.right=m;break}}else this._root=m}for(let m=u.length-1;m>=0;m--){const k=u[m][1];k.updateHeight();const _=k.balanceFactor();if(_>1?(k.right.balanceFactor()>=0||(k.right=u[m+1][1]=u[m+1][1].rotateRight()),u[m][1]=k.rotateLeft()):_<-1&&(k.left.balanceFactor()<=0||(k.left=u[m+1][1]=u[m+1][1].rotateLeft()),u[m][1]=k.rotateRight()),m>0)switch(u[m-1][0]){case-1:u[m-1][1].left=u[m][1];break;case 1:u[m-1][1].right=u[m][1];break;case 0:u[m-1][1].mid=u[m][1];break}else this._root=u[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const a=this._iter.reset(i);let o=this._root,u;for(;o;){const d=a.cmp(o.segment);if(d>0)o=o.left;else if(d<0)o=o.right;else if(a.hasNext())a.next(),u=o.value||u,o=o.mid;else break}return o&&o.value||u}findSuperstr(i){const a=this._iter.reset(i);let o=this._root;for(;o;){const u=a.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(a.hasNext())a.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(i){for(const[a,o]of this)i(o,a)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=a=>{if(!a)return!0;const o=a.balanceFactor();return o<-1||o>1?!1:i(a.left)&&i(a.right)};return i(this._root)}}e.TernarySearchTree=v;class p{constructor(i,a){this[T]="ResourceMap",i instanceof p?(this.map=new Map(i.map),this.toKey=a??p.defaultToKey):(this.map=new Map,this.toKey=i??p.defaultToKey)}set(i,a){return this.map.set(this.toKey(i),a),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,a){typeof a!="undefined"&&(i=i.bind(a));for(let[o,u]of this.map)i(u,P.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield P.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[P.URI.parse(i[0]),i[1]]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[P.URI.parse(i[0]),i[1]]}}e.ResourceMap=p,p.defaultToKey=r=>r.toString();var l;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(l=e.Touch||(e.Touch={}));class c{constructor(){this[L]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,a=0){const o=this._map.get(i);if(!!o)return a!==0&&this.touch(o,a),o.value}set(i,a,o=0){let u=this._map.get(i);if(u)u.value=a,o!==0&&this.touch(u,o);else{switch(u={key:i,value:a,next:void 0,previous:void 0},o){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(i,u),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const a=this._map.get(i);if(!!a)return this._map.delete(i),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,a){const o=this._state;let u=this._head;for(;u;){if(a?i.bind(a)(u.value,u.key,this):i(u.value,u.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const i=this,a=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==a)throw new Error("LinkedMap got modified during iteration.");if(o){const d={value:o.key,done:!1};return o=o.next,d}else return{value:void 0,done:!0}}};return u}values(){const i=this,a=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==a)throw new Error("LinkedMap got modified during iteration.");if(o){const d={value:o.value,done:!1};return o=o.next,d}else return{value:void 0,done:!0}}};return u}entries(){const i=this,a=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==a)throw new Error("LinkedMap got modified during iteration.");if(o){const d={value:[o.key,o.value],done:!1};return o=o.next,d}else return{value:void 0,done:!0}}};return u}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let a=this._head,o=this.size;for(;a&&o>i;)this._map.delete(a.key),a=a.next,o--;this._head=a,this._size=o,a&&(a.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const a=i.next,o=i.previous;if(!a||!o)throw new Error("Invalid list");a.previous=o,o.next=a}i.next=void 0,i.previous=void 0,this._state++}touch(i,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(i===this._head)return;const o=i.next,u=i.previous;i===this._tail?(u.next=void 0,this._tail=u):(o.previous=u,u.next=o),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(a===2){if(i===this._tail)return;const o=i.next,u=i.previous;i===this._head?(o.previous=void 0,this._head=o):(o.previous=u,u.next=o),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((a,o)=>{i.push([o,a])}),i}fromJSON(i){this.clear();for(const[a,o]of i)this.set(a,o)}}e.LinkedMap=c;class t extends c{constructor(i,a=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,a=2){return super.get(i,a)}peek(i){return super.get(i,0)}set(i,a){return super.set(i,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=t;class s{constructor(i){R.set(this,void 0),yt(this,R,i,"f")}get size(){return Be(this,R,"f").size}forEach(i,a){Be(this,R,"f").forEach(i,a)}get(i){return Be(this,R,"f").get(i)}has(i){return Be(this,R,"f").has(i)}entries(){return Be(this,R,"f").entries()}keys(){return Be(this,R,"f").keys()}values(){return Be(this,R,"f").values()}[(R=new WeakMap,Symbol.iterator)](){return Be(this,R,"f").entries()}}e.ReadonlyMapView=s}),define(te[102],ne([0,1,22,25,7]),function(J,e,D,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(n){return JSON.stringify(n,S)}e.stringify=T;function L(n){let I=JSON.parse(n);return I=E(I),I}e.parse=L;var R;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(R=e.MarshalledId||(e.MarshalledId={}));function S(n,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,A.regExpFlags)(I)}:I}function E(n,I=0){if(!n||I>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return P.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof D.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let g=0;g<n.length;++g)n[g]=E(n[g],I+1);else for(const g in n)Object.hasOwnProperty.call(n,g)&&(n[g]=E(n[g],I+1))}return n}e.revive=E}),define(te[15],ne([0,1,4,7]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var P;(function(R){R.inMemory="inmemory",R.vscode="vscode",R.internal="private",R.walkThrough="walkThrough",R.walkThroughSnippet="walkThroughSnippet",R.http="http",R.https="https",R.file="file",R.mailto="mailto",R.untitled="untitled",R.data="data",R.command="command",R.vscodeRemote="vscode-remote",R.vscodeRemoteResource="vscode-remote-resource",R.userData="vscode-userdata",R.vscodeCustomEditor="vscode-custom-editor",R.vscodeNotebook="vscode-notebook",R.vscodeNotebookCell="vscode-notebook-cell",R.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",R.vscodeNotebookCellOutput="vscode-notebook-cell-output",R.vscodeInteractive="vscode-interactive",R.vscodeInteractiveInput="vscode-interactive-input",R.vscodeSettings="vscode-settings",R.vscodeWorkspaceTrust="vscode-workspace-trust",R.vscodeTerminal="vscode-terminal",R.webviewPanel="webview-panel",R.vscodeWebview="vscode-webview",R.extension="extension",R.vscodeFileResource="vscode-file",R.tmp="tmp"})(P=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,E,n){this._hosts[S]=E,this._ports[S]=n}setConnectionToken(S,E){this._connectionTokens[S]=E}rewrite(S){if(this._delegate)return this._delegate(S);const E=S.authority;let n=this._hosts[E];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const I=this._ports[E],g=this._connectionTokens[E];let b=`path=${encodeURIComponent(S.path)}`;return typeof g=="string"&&(b+=`&tkn=${encodeURIComponent(g)}`),A.URI.from({scheme:D.isWeb?this._preferredWebSchema:P.vscodeRemoteResource,authority:`${n}:${I}`,path:"/vscode-remote-resource",query:b})}}e.RemoteAuthorities=new T;class L{asBrowserUri(S,E){const n=this.toUri(S,E);return n.scheme===P.vscodeRemote?e.RemoteAuthorities.rewrite(n):n.scheme===P.file&&(D.isNative||typeof D.globals.importScripts=="function"&&D.globals.origin===`${P.vscodeFileResource}://${L.FALLBACK_AUTHORITY}`)?n.with({scheme:P.vscodeFileResource,authority:n.authority||L.FALLBACK_AUTHORITY,query:null,fragment:null}):n}asFileUri(S,E){const n=this.toUri(S,E);return n.scheme===P.vscodeFileResource?n.with({scheme:P.file,authority:n.authority!==L.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(S,E){return A.URI.isUri(S)?S:A.URI.parse(E.toUrl(S))}}L.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new L}),define(te[68],ne([0,1,40]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const A=new D.LRUCache(1e4);function P(E){return S(E,"NFC",A)}e.normalizeNFC=P;const T=new D.LRUCache(1e4);function L(E){return S(E,"NFD",T)}e.normalizeNFD=L;const R=/[^\u0000-\u0080]/;function S(E,n,I){if(!E)return E;const g=I.get(E);if(g)return g;let b;return R.test(E)?b=E.normalize(n):b=E,I.set(E,b),b}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(n){return L(n).replace(E,"")}}()}),define(te[16],ne([0,1,39,15,9,4,25,7]),function(J,e,D,A,P,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(b){return(0,R.uriToFsPath)(b,!0)}e.originalFSPath=S;class E{constructor(h){this._ignorePathCasing=h}compare(h,y,f=!1){return h===y?0:(0,L.compare)(this.getComparisonKey(h,f),this.getComparisonKey(y,f))}isEqual(h,y,f=!1){return h===y?!0:!h||!y?!1:this.getComparisonKey(h,f)===this.getComparisonKey(y,f)}getComparisonKey(h,y=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,y,f=!1){if(h.scheme===y.scheme){if(h.scheme===A.Schemas.file)return D.isEqualOrParent(S(h),S(y),this._ignorePathCasing(h))&&h.query===y.query&&(f||h.fragment===y.fragment);if((0,e.isEqualAuthority)(h.authority,y.authority))return D.isEqualOrParent(h.path,y.path,this._ignorePathCasing(h),"/")&&h.query===y.query&&(f||h.fragment===y.fragment)}return!1}joinPath(h,...y){return R.URI.joinPath(h,...y)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return P.posix.basename(h.path)}extname(h){return P.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let y;return h.scheme===A.Schemas.file?y=R.URI.file(P.dirname(S(h))).path:(y=P.posix.dirname(h.path),h.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),y="/")),h.with({path:y})}normalizePath(h){if(!h.path.length)return h;let y;return h.scheme===A.Schemas.file?y=R.URI.file(P.normalize(S(h))).path:y=P.posix.normalize(h.path),h.with({path:y})}relativePath(h,y){if(h.scheme!==y.scheme||!(0,e.isEqualAuthority)(h.authority,y.authority))return;if(h.scheme===A.Schemas.file){const v=P.relative(S(h),S(y));return T.isWindows?D.toSlashes(v):v}let f=h.path||"/",w=y.path||"/";if(this._ignorePathCasing(h)){let v=0;for(const p=Math.min(f.length,w.length);v<p&&!(f.charCodeAt(v)!==w.charCodeAt(v)&&f.charAt(v).toLowerCase()!==w.charAt(v).toLowerCase());v++);f=w.substr(0,v)+f.substr(v)}return P.posix.relative(f,w)}resolvePath(h,y){if(h.scheme===A.Schemas.file){const f=R.URI.file(P.resolve(S(h),y));return h.with({authority:f.authority,path:f.path})}return y=D.toPosixPath(y),h.with({path:P.posix.resolve(h.path,y)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,y){return h===y||(0,L.equalsIgnoreCase)(h,y)}hasTrailingPathSeparator(h,y=P.sep){if(h.scheme===A.Schemas.file){const f=S(h);return f.length>D.getRoot(f).length&&f[f.length-1]===y}else{const f=h.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,y=P.sep){return(0,e.hasTrailingPathSeparator)(h,y)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,y=P.sep){let f=!1;if(h.scheme===A.Schemas.file){const w=S(h);f=w!==void 0&&w.length===D.getRoot(w).length&&w[w.length-1]===y}else{y="/";const w=h.path;f=w.length===1&&w.charCodeAt(w.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(h,y)?h.with({path:h.path+"/"}):h}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(b=>b.scheme===A.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new E(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(b,h){const y=[];for(let f=0;f<b.length;f++){const w=h(b[f]);b.some((v,p)=>p===f?!1:(0,e.isEqualOrParent)(w,h(v)))||y.push(b[f])}return y}e.distinctParents=n;var I;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function h(y){const f=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(p=>{const[l,c]=p.split(":");l&&c&&f.set(l,c)});const v=y.path.substring(0,y.path.indexOf(";"));return v&&f.set(b.META_DATA_MIME,v),f}b.parseMetaData=h})(I=e.DataUri||(e.DataUri={}));function g(b,h,y){if(h){let f=b.path;return f&&f[0]!==P.posix.sep&&(f=P.posix.sep+f),b.with({scheme:y,authority:h,path:f})}return b.with({scheme:y})}e.toLocalResource=g}),define(te[5],ne([0,1,27,8,3,2,16]),function(J,e,D,A,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function R(W){return!!W&&typeof W.then=="function"}e.isThenable=R;function S(W){const x=new D.CancellationTokenSource,q=W(x.token),$=new Promise((G,M)=>{const B=x.token.onCancellationRequested(()=>{B.dispose(),x.dispose(),M((0,A.canceled)())});Promise.resolve(q).then(V=>{B.dispose(),x.dispose(),G(V)},V=>{B.dispose(),x.dispose(),M(V)})});return new class{cancel(){x.cancel()}then(G,M){return $.then(G,M)}catch(G){return this.then(void 0,G)}finally(G){return $.finally(G)}}}e.createCancelablePromise=S;function E(W,x,q){return Promise.race([W,new Promise($=>x.onCancellationRequested(()=>$(q)))])}e.raceCancellation=E;async function n(W){let x=-1;const q=W.map((G,M)=>G.then(B=>(x=M,B))),$=await Promise.race(q);return W.forEach((G,M)=>{M!==x&&G.cancel()}),$}e.raceCancellablePromises=n;function I(W,x,q){let $;const G=setTimeout(()=>{$?.(void 0),q?.()},x);return Promise.race([W.finally(()=>clearTimeout(G)),new Promise(M=>$=M)])}e.raceTimeout=I;function g(W){return new Promise((x,q)=>{const $=W();R($)?$.then(x,q):x($)})}e.asPromise=g;class b{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(x){if(this.activePromise){if(this.queuedPromiseFactory=x,!this.queuedPromise){const q=()=>{this.queuedPromise=null;const $=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,$};this.queuedPromise=new Promise($=>{this.activePromise.then(q,q).then($)})}return new Promise((q,$)=>{this.queuedPromise.then(q,$)})}return this.activePromise=x(),new Promise((q,$)=>{this.activePromise.then(G=>{this.activePromise=null,q(G)},G=>{this.activePromise=null,$(G)})})}}e.Throttler=b;class h{constructor(){this.current=Promise.resolve(null)}queue(x){return this.current=this.current.then(()=>x(),()=>x())}}e.Sequencer=h;class y{constructor(){this.promiseMap=new Map}queue(x,q){const G=(this.promiseMap.get(x)??Promise.resolve()).catch(()=>{}).then(q).finally(()=>{this.promiseMap.get(x)===G&&this.promiseMap.delete(x)});return this.promiseMap.set(x,G),G}}e.SequencerByKey=y;class f{constructor(x){this.defaultDelay=x,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(x,q=this.defaultDelay){return this.task=x,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise(($,G)=>{this.doResolve=$,this.doReject=G}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const $=this.task;return this.task=null,$()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},q),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,A.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=f;class w{constructor(x){this.delayer=new f(x),this.throttler=new b}trigger(x,q){return this.delayer.trigger(()=>this.throttler.queue(x),q)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class v{constructor(){this._isOpen=!1,this._promise=new Promise((x,q)=>{this._completePromise=x})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=v;class p extends v{constructor(x){super();this._timeout=setTimeout(()=>this.open(),x)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=p;function l(W,x){return x?new Promise((q,$)=>{const G=setTimeout(()=>{M.dispose(),q()},W),M=x.onCancellationRequested(()=>{clearTimeout(G),M.dispose(),$((0,A.canceled)())})}):S(q=>l(W,q))}e.timeout=l;function c(W,x=0){const q=setTimeout(W,x);return(0,T.toDisposable)(()=>clearTimeout(q))}e.disposableTimeout=c;function t(W){const x=[];let q=0;const $=W.length;function G(){return q<$?W[q++]():null}function M(B){B!=null&&x.push(B);const V=G();return V?V.then(M):Promise.resolve(x)}return Promise.resolve(null).then(M)}e.sequence=t;function s(W,x=$=>!!$,q=null){let $=0;const G=W.length,M=()=>{if($>=G)return Promise.resolve(q);const B=W[$++];return Promise.resolve(B()).then(Q=>x(Q)?Promise.resolve(Q):M())};return M()}e.first=s;function r(W,x=$=>!!$,q=null){if(W.length===0)return Promise.resolve(q);let $=W.length;const G=()=>{$=-1;for(const M of W)M.cancel?.()};return new Promise((M,B)=>{for(const V of W)V.then(Q=>{--$>=0&&x(Q)?(G(),M(Q)):$===0&&M(q)}).catch(Q=>{--$>=0&&(G(),B(Q))})})}e.firstParallel=r;class i{constructor(x){this._size=0,this.maxDegreeOfParalellism=x,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new P.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(x){return this._size++,new Promise((q,$)=>{this.outstandingPromises.push({factory:x,c:q,e:$}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const x=this.outstandingPromises.shift();this.runningPromises++;const q=x.factory();q.then(x.c,x.e),q.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class a extends i{constructor(){super(1)}}e.Queue=a;class o{constructor(){this.queues=new Map}queueFor(x,q=L.extUri){const $=q.getComparisonKey(x);let G=this.queues.get($);return G||(G=new a,P.Event.once(G.onFinished)(()=>{G?.dispose(),this.queues.delete($)}),this.queues.set($,G)),G}dispose(){this.queues.forEach(x=>x.dispose()),this.queues.clear()}}e.ResourceQueue=o;class u{constructor(x,q){this._token=-1,typeof x=="function"&&typeof q=="number"&&this.setIfNotSet(x,q)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(x,q){this.cancel(),this._token=setTimeout(()=>{this._token=-1,x()},q)}setIfNotSet(x,q){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,x()},q))}}e.TimeoutTimer=u;class d{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(x,q){this.cancel(),this._token=setInterval(()=>{x()},q)}}e.IntervalTimer=d;class m{constructor(x,q){this.timeoutToken=-1,this.runner=x,this.timeout=q,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(x=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,x)}get delay(){return this.timeout}set delay(x){this.timeout=x}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=m;class k{constructor(x,q){q%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.runner=x,this.timeout=q,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(x=this.timeout){x%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(x/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=k;class _ extends m{constructor(x,q){super(x,q);this.units=[]}work(x){this.units.push(x),this.isScheduled()||this.schedule()}doRun(){const x=this.units;this.units=[],this.runner&&this.runner(x)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=_;class O extends T.Disposable{constructor(x,q,$,G){super();this.maxWorkChunkSize=x,this.maxPendingWork=q,this.throttleDelay=$,this.handler=G,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(x){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+x.length>this.maxPendingWork)return!1}else if(this.pending+x.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...x),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new m(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=O,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=W=>{const x=setTimeout(()=>{const $=Date.now()+15;W(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,$-Date.now())}}))});let q=!1;return{dispose(){q||(q=!0,clearTimeout(x))}}}:e.runWhenIdle=(W,x)=>{const q=requestIdleCallback(W,typeof x=="number"?{timeout:x}:void 0);let $=!1;return{dispose(){$||($=!0,cancelIdleCallback(q))}}}}();class N{constructor(x){this._didRun=!1,this._executor=()=>{try{this._value=x()}catch(q){this._error=q}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=N;async function C(W,x,q){let $;for(let G=0;G<q;G++)try{return await W()}catch(M){$=M,await l(x)}throw $}e.retry=C;class F{hasPending(x){return this._pending?typeof x=="number"?this._pending.taskId===x:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(x,q,$){return this._pending={taskId:x,cancel:()=>$?.(),promise:q},q.then(()=>this.donePending(x),()=>this.donePending(x)),q}donePending(x){this._pending&&x===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const x=this._next;this._next=void 0,x.run().then(x.promiseResolve,x.promiseReject)}}setNext(x){if(this._next)this._next.run=x;else{let q,$;const G=new Promise((M,B)=>{q=M,$=B});this._next={run:x,promise:G,promiseResolve:q,promiseReject:$}}return this._next.promise}}e.TaskSequentializer=F;class z{constructor(x){this.interval=x,this.lastIncrementTime=0,this.value=0}increment(){const x=Date.now();return x-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=x,this.value=0),this.value++,this.value}}e.IntervalCounter=z;class U{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((x,q)=>{this.completeCallback=x,this.errorCallback=q})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(x){return new Promise(q=>{this.completeCallback(x),this.resolved=!0,q()})}error(x){return new Promise(q=>{this.errorCallback(x),this.rejected=!0,q()})}cancel(){new Promise(x=>{this.errorCallback((0,A.canceled)()),this.rejected=!0,x()})}}e.DeferredPromise=U;var j;(function(W){async function x($){let G;const M=await Promise.all($.map(B=>B.then(V=>V,V=>{G||(G=V)})));if(typeof G!="undefined")throw G;return M}W.settled=x;function q($){return new Promise(async(G,M)=>{try{await $(G,M)}catch(B){M(B)}})}W.withAsyncBody=q})(j=e.Promises||(e.Promises={}))}),define(te[103],ne([0,1,5,39,40,9,25]),function(J,e,D,A,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function R(){return Object.create(null)}e.getEmptyExpression=R;const S="**",E="/",n="[/\\\\]",I="[^/\\\\]",g=/\//g;function b($){switch($){case 0:return"";case 1:return`${I}*?`;default:return`(?:${n}|${I}+${n}|${n}${I}+)*?`}}function h($,G){if(!$)return[];const M=[];let B=!1,V=!1,Q="";for(const Z of $){switch(Z){case G:if(!B&&!V){M.push(Q),Q="";continue}break;case"{":B=!0;break;case"}":B=!1;break;case"[":V=!0;break;case"]":V=!1;break}Q+=Z}return Q&&M.push(Q),M}e.splitGlobAware=h;function y($){if(!$)return"";let G="";const M=h($,E);if(M.every(B=>B===S))G=".*";else{let B=!1;M.forEach((V,Q)=>{if(V===S){B||(G+=b(2),B=!0);return}let Z=!1,K="",H=!1,re="";for(const ie of V){if(ie!=="}"&&Z){K+=ie;continue}if(H&&(ie!=="]"||!re)){let ae;ie==="-"?ae=ie:(ie==="^"||ie==="!")&&!re?ae="^":ie===E?ae="":ae=L.escapeRegExpCharacters(ie),re+=ae;continue}switch(ie){case"{":Z=!0;continue;case"[":H=!0;continue;case"}":G+=`(?:${h(K,",").map(fe=>y(fe)).join("|")})`,Z=!1,K="";break;case"]":G+="["+re+"]",H=!1,re="";break;case"?":G+=I;continue;case"*":G+=b(1);continue;default:G+=L.escapeRegExpCharacters(ie)}}Q<M.length-1&&(M[Q+1]!==S||Q+2<M.length)&&(G+=n),B=!1})}return G}const f=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,p=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.LRUCache(1e4),s=function(){return!1},r=function(){return null};function i($,G){if(!$)return r;let M;typeof $!="string"?M=$.pattern:M=$,M=M.trim();const B=`${M}_${!!G.trimForExclusions}`;let V=t.get(B);if(V)return a(V,$);let Q;if(f.test(M)){const Z=M.substr(4);V=function(K,H){return typeof K=="string"&&K.endsWith(Z)?M:null}}else(Q=w.exec(o(M,G)))?V=u(Q[1],M):(G.trimForExclusions?p:v).test(M)?V=d(M,G):(Q=l.exec(o(M,G)))?V=m(Q[1].substr(1),M,!0):(Q=c.exec(o(M,G)))?V=m(Q[1],M,!1):V=k(M);return t.set(B,V),a(V,$)}function a($,G){return typeof G=="string"?$:function(M,B){return A.isEqualOrParent(M,G.base)?$(T.relative(G.base,M),B):null}}function o($,G){return G.trimForExclusions&&$.endsWith("/**")?$.substr(0,$.length-2):$}function u($,G){const M=`/${$}`,B=`\\${$}`,V=function(Z,K){return typeof Z!="string"?null:K?K===$?G:null:Z===$||Z.endsWith(M)||Z.endsWith(B)?G:null},Q=[$];return V.basenames=Q,V.patterns=[G],V.allBasenames=Q,V}function d($,G){const M=q($.slice(1,-1).split(",").map(K=>i(K,G)).filter(K=>K!==r),$),B=M.length;if(!B)return r;if(B===1)return M[0];const V=function(K,H){for(let re=0,ie=M.length;re<ie;re++)if(M[re](K,H))return $;return null},Q=M.find(K=>!!K.allBasenames);Q&&(V.allBasenames=Q.allBasenames);const Z=M.reduce((K,H)=>H.allPaths?K.concat(H.allPaths):K,[]);return Z.length&&(V.allPaths=Z),V}function m($,G,M){const B=T.sep===T.posix.sep,V=B?$:$.replace(g,T.sep),Q=T.sep+V,Z=T.posix.sep+$,K=M?function(H,re){return typeof H=="string"&&(H===V||H.endsWith(Q)||!B&&(H===$||H.endsWith(Z)))?G:null}:function(H,re){return typeof H=="string"&&(H===V||!B&&H===$)?G:null};return K.allPaths=[(M?"*/":"./")+$],K}function k($){try{const G=new RegExp(`^${y($)}$`);return function(M){return G.lastIndex=0,typeof M=="string"&&G.test(M)?$:null}}catch(G){return r}}function _($,G,M){return!$||typeof G!="string"?!1:O($)(G,void 0,M)}e.match=_;function O($,G={}){if(!$)return s;if(typeof $=="string"||z($)){const M=i($,G);if(M===r)return s;const B=function(V,Q){return!!M(V,Q)};return M.allBasenames&&(B.allBasenames=M.allBasenames),M.allPaths&&(B.allPaths=M.allPaths),B}return W($,G)}e.parse=O;function N($){if(!$)return;let G;return M=>(G||(G=($()||Promise.resolve([])).then(B=>B?F(B):{})),G.then(B=>!!B[M]))}e.hasSiblingPromiseFn=N;function C($){if(!$)return;let G;return M=>{if(!G){const B=$();G=B?F(B):{}}return!!G[M]}}e.hasSiblingFn=C;function F($){const G={};for(const M of $)G[M]=!0;return G}function z($){const G=$;return G&&typeof G.base=="string"&&typeof G.pattern=="string"}e.isRelativePattern=z;function U($){return $.allBasenames||[]}e.getBasenameTerms=U;function j($){return $.allPaths||[]}e.getPathTerms=j;function W($,G){const M=q(Object.getOwnPropertyNames($).map(K=>x(K,$[K],G)).filter(K=>K!==r)),B=M.length;if(!B)return r;if(!M.some(K=>!!K.requiresSiblings)){if(B===1)return M[0];const K=function(ie,ae){for(let ue=0,fe=M.length;ue<fe;ue++){const de=M[ue](ie,ae);if(de)return de}return null},H=M.find(ie=>!!ie.allBasenames);H&&(K.allBasenames=H.allBasenames);const re=M.reduce((ie,ae)=>ae.allPaths?ie.concat(ae.allPaths):ie,[]);return re.length&&(K.allPaths=re),K}const V=function(K,H,re){let ie;for(let ae=0,ue=M.length;ae<ue;ae++){const fe=M[ae];fe.requiresSiblings&&re&&(H||(H=T.basename(K)),ie||(ie=H.substr(0,H.length-T.extname(K).length)));const de=fe(K,H,ie,re);if(de)return de}return null},Q=M.find(K=>!!K.allBasenames);Q&&(V.allBasenames=Q.allBasenames);const Z=M.reduce((K,H)=>H.allPaths?K.concat(H.allPaths):K,[]);return Z.length&&(V.allPaths=Z),V}function x($,G,M){if(G===!1)return r;const B=i($,M);if(B===r)return r;if(typeof G=="boolean")return B;if(G){const V=G.when;if(typeof V=="string"){const Q=(Z,K,H,re)=>{if(!re||!B(Z,K))return null;const ie=V.replace("$(basename)",H),ae=re(ie);return(0,D.isThenable)(ae)?ae.then(ue=>ue?$:null):ae?$:null};return Q.requiresSiblings=!0,Q}}return B}function q($,G){const M=$.filter(K=>!!K.basenames);if(M.length<2)return $;const B=M.reduce((K,H)=>{const re=H.basenames;return re?K.concat(re):K},[]);let V;if(G){V=[];for(let K=0,H=B.length;K<H;K++)V.push(G)}else V=M.reduce((K,H)=>{const re=H.patterns;return re?K.concat(re):K},[]);const Q=function(K,H){if(typeof K!="string")return null;if(!H){let ie;for(ie=K.length;ie>0;ie--){const ae=K.charCodeAt(ie-1);if(ae===47||ae===92)break}H=K.substr(ie)}const re=B.indexOf(H);return re!==-1?V[re]:null};Q.basenames=B,Q.patterns=V,Q.allBasenames=B;const Z=$.filter(K=>!K.basenames);return Z.push(Q),Z}}),define(te[104],ne([0,1,103,15,9,16,25]),function(J,e,D,A,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var R;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown",i.latex="text/latex"})(R=e.Mimes||(e.Mimes={}));let S=[],E=[],n=[];function I(i,a=!1){const o=g(i);S.push(o),o.userConfigured?n.push(o):E.push(o),a&&!o.userConfigured&&S.forEach(u=>{u.mime===o.mime||u.userConfigured||(o.extension&&u.extension===o.extension&&console.warn(`Overwriting extension <<${o.extension}>> to now point to mime <<${o.mime}>>`),o.filename&&u.filename===o.filename&&console.warn(`Overwriting filename <<${o.filename}>> to now point to mime <<${o.mime}>>`),o.filepattern&&u.filepattern===o.filepattern&&console.warn(`Overwriting filepattern <<${o.filepattern}>> to now point to mime <<${o.mime}>>`),o.firstline&&u.firstline===o.firstline&&console.warn(`Overwriting firstline <<${o.firstline}>> to now point to mime <<${o.mime}>>`))})}e.registerTextMime=I;function g(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?(0,D.parse)(i.filepattern.toLowerCase()):void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(P.posix.sep)>=0:!1}}function b(i){i?(S=S.filter(a=>!a.userConfigured),n=[]):(S=[],E=[],n=[])}e.clearTextMimes=b;function h(i,a){let o;if(i)switch(i.scheme){case A.Schemas.file:o=i.fsPath;break;case A.Schemas.data:o=T.DataUri.parseMetaData(i).get(T.DataUri.META_DATA_LABEL);break;default:o=i.path}if(!o)return[R.unknown];o=o.toLowerCase();const u=(0,P.basename)(o),d=y(o,u,n);if(d)return[d,R.text];const m=y(o,u,E);if(m)return[m,R.text];if(a){const k=f(a);if(k)return[k,R.text]}return[R.unknown]}e.guessMimeTypes=h;function y(i,a,o){let u=null,d=null,m=null;for(let k=o.length-1;k>=0;k--){const _=o[k];if(a===_.filenameLowercase){u=_;break}if(_.filepattern&&(!d||_.filepattern.length>d.filepattern.length)){const O=_.filepatternOnPath?i:a;_.filepatternLowercase?.(O)&&(d=_)}_.extension&&(!m||_.extension.length>m.extension.length)&&a.endsWith(_.extensionLowercase)&&(m=_)}return u?u.mime:d?d.mime:m?m.mime:null}function f(i){if((0,L.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let a=S.length-1;a>=0;a--){const o=S[a];if(!o.firstline)continue;const u=i.match(o.firstline);if(u&&u.length>0)return o.mime}return null}function w(i){return i?typeof i=="string"?i===R.binary||i===R.text||i===R.unknown:i.length===1&&w(i[0]):!0}e.isUnspecific=w;const v={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},p={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function l(i){const a=(0,P.extname)(i),o=v[a.toLowerCase()];return o!==void 0?o:c(i)}e.getMediaOrTextMime=l;function c(i){const a=(0,P.extname)(i);return p[a.toLowerCase()]}e.getMediaMime=c;function t(i){for(const a in p)if(p[a]===i)return a}e.getExtensionForMimeType=t;const s=/^(.+)\/(.+?)(;.+)?$/;function r(i,a){const o=s.exec(i);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:a?void 0:i}e.normalizeMimeType=r}),define(te[105],ne([0,1,7]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function A(n){return n.toJSON()}class P{constructor(I){this._uriTransformer=I}transformIncoming(I){const g=this._uriTransformer.transformIncoming(I);return g===I?I:A(D.URI.from(g))}transformOutgoing(I){const g=this._uriTransformer.transformOutgoing(I);return g===I?I:A(D.URI.from(g))}transformOutgoingURI(I){const g=this._uriTransformer.transformOutgoing(I);return g===I?I:D.URI.from(g)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=P,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function T(n,I,g){if(!n||g>200)return null;if(typeof n=="object"){if(n instanceof D.URI)return I.transformOutgoing(n);for(let b in n)if(Object.hasOwnProperty.call(n,b)){const h=T(n[b],I,g+1);h!==null&&(n[b]=h)}}return null}function L(n,I){const g=T(n,I,0);return g===null?n:g}e.transformOutgoingURIs=L;function R(n,I,g,b){if(!n||b>200)return null;if(typeof n=="object"){if(n.$mid===1)return g?D.URI.revive(I.transformIncoming(n)):I.transformIncoming(n);for(let h in n)if(Object.hasOwnProperty.call(n,h)){const y=R(n[h],I,g,b+1);y!==null&&(n[h]=y)}}return null}function S(n,I){const g=R(n,I,!1,0);return g===null?n:g}e.transformIncomingURIs=S;function E(n,I){const g=R(n,I,!0,0);return g===null?n:g}e.transformAndReviveIncomingURIs=E}),define(te[30],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(S){return D.test(S)}e.isUUID=A;const P=new Uint8Array(16),T=[];for(let S=0;S<256;S++)T.push(S.toString(16).padStart(2,"0"));let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(S){for(let E=0;E<S.length;E++)S[E]=Math.floor(Math.random()*256);return S};function R(){L(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let S=0,E="";return E+=T[P[S++]],E+=T[P[S++]],E+=T[P[S++]],E+=T[P[S++]],E+="-",E+=T[P[S++]],E+=T[P[S++]],E+="-",E+=T[P[S++]],E+=T[P[S++]],E+="-",E+=T[P[S++]],E+=T[P[S++]],E+="-",E+=T[P[S++]],E+=T[P[S++]],E+=T[P[S++]],E+=T[P[S++]],E+=T[P[S++]],E+=T[P[S++]],E}e.generateUuid=R}),define(te[106],ne([0,1,107]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class A{constructor(T="utf8"){this.stringDecoder=new D.StringDecoder(T),this.remaining=null}write(T){const L=[],R=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(R.length<1)return L;let S=0,E,n=S;for(;n<R.length;)if(E=R.charCodeAt(n),E===13||E===10){if(L.push(R.substring(S,n)),n++,n<R.length){const I=E;E=R.charCodeAt(n),(I===13&&E===10||I===10&&E===13)&&n++}S=n}else n++;return this.remaining=S<R.length?R.substr(S):null,L}end(){return this.remaining}}e.LineDecoder=A}),define(te[108],ne([0,1,33]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function P(R){const S=R.replace(/\-/g,":").toLowerCase();return!A.has(S)}function T(){return new Promise(async(R,S)=>{const E=setTimeout(()=>S("Unable to retrieve mac address (timeout after 10s)"),1e4);try{R(await L())}catch(n){S(n)}finally{clearTimeout(E)}})}e.getMac=T;function L(){return new Promise((R,S)=>{try{const E=(0,D.networkInterfaces)();for(let n in E){const I=E[n];if(I){for(const{mac:g}of I)if(P(g))return R(g)}}S("Unable to retrieve mac address (unexpected format)")}catch(E){S(E)}})}}),define(te[109],ne([0,1,33,8,40,30,108]),function(J,e,D,A,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=P.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,I=0;const g=(0,D.networkInterfaces)();for(let b in g){const h=g[b];if(h)for(const{mac:y,internal:f}of h)f||(I+=1,this._isVirtualMachineMacAddress(y.toUpperCase())&&(n+=1))}this._value=I>0?n/I:0}return this._value}};let R;async function S(){return R||(R=(async()=>await E()||T.generateUuid())()),R}e.getMachineId=S;async function E(){try{const n=await new Promise((g,b)=>{J(["crypto"],g,b)}),I=await(0,L.getMac)();return n.createHash("sha256").update(I,"utf8").digest("hex")}catch(n){A.onUnexpectedError(n);return}}}),define(te[19],ne([0,1,52,33,235,5,39,68,9,4,16,7,30]),function(J,e,D,A,P,T,L,R,S,E,n,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function h(U,j=b.UNLINK){if((0,L.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return j===b.UNLINK?f(U):y(U)}async function y(U){try{const j=(0,S.join)((0,A.tmpdir)(),(0,g.generateUuid)());try{await e.Promises.rename(U,j)}catch(W){return f(U)}f(j).catch(W=>{})}catch(j){if(j.code!=="ENOENT")throw j}}async function f(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function w(U){if((0,L.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");D.rmdirSync(U,{recursive:!0})}e.rimrafSync=w;async function v(U,j){return c(await(j?p(U):(0,P.promisify)(D.readdir)(U)))}async function p(U){try{return await(0,P.promisify)(D.readdir)(U,{withFileTypes:!0})}catch(x){console.warn("[node.js fs] readdir with filetypes failed with error: ",x)}const j=[],W=await v(U);for(const x of W){let q=!1,$=!1,G=!1;try{const M=await e.Promises.lstat((0,S.join)(U,x));q=M.isFile(),$=M.isDirectory(),G=M.isSymbolicLink()}catch(M){console.warn("[node.js fs] unexpected error from lstat after readdir: ",M)}j.push({name:x,isFile:()=>q,isDirectory:()=>$,isSymbolicLink:()=>G})}return j}function l(U){return c(D.readdirSync(U))}e.readdirSync=l;function c(U){return U.map(j=>typeof j=="string"?E.isMacintosh?(0,R.normalizeNFC)(j):j:(j.name=E.isMacintosh?(0,R.normalizeNFC)(j.name):j.name,j))}async function t(U){const j=await v(U),W=[];for(const x of j)await r.existsDirectory((0,S.join)(U,x))&&W.push(x);return W}function s(U,j=1e3){return new Promise(W=>{let x=!1;const q=setInterval(()=>{x||(x=!0,D.access(U,$=>{x=!1,$&&(clearInterval(q),W(void 0))}))},j)})}e.whenDeleted=s;var r;(function(U){async function j(q){let $;try{if($=await e.Promises.lstat(q),!$.isSymbolicLink())return{stat:$}}catch(G){}try{return{stat:await e.Promises.stat(q),symbolicLink:$?.isSymbolicLink()?{dangling:!1}:void 0}}catch(G){if(G.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};if(E.isWindows&&G.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(M){if(M.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};throw M}throw G}}U.stat=j;async function W(q){try{const{stat:$,symbolicLink:G}=await U.stat(q);return $.isFile()&&G?.dangling!==!0}catch($){}return!1}U.existsFile=W;async function x(q){try{const{stat:$,symbolicLink:G}=await U.stat(q);return $.isDirectory()&&G?.dangling!==!0}catch($){}return!1}U.existsDirectory=x})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new T.ResourceQueue;function a(U,j,W){return i.queueFor(I.URI.file(U),n.extUriBiasedIgnorePathCase).queue(()=>{const x=m(W);return new Promise((q,$)=>u(U,j,x,G=>G?$(G):q()))})}let o=!0;function u(U,j,W,x){if(!o)return D.writeFile(U,j,{mode:W.mode,flag:W.flag},x);D.open(U,W.flag,W.mode,(q,$)=>{if(q)return x(q);D.writeFile($,j,G=>{if(G)return D.close($,()=>x(G));D.fdatasync($,M=>(M&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",M),o=!1),D.close($,B=>x(B))))})})}function d(U,j,W){const x=m(W);if(!o)return D.writeFileSync(U,j,{mode:x.mode,flag:x.flag});const q=D.openSync(U,x.flag,x.mode);try{D.writeFileSync(q,j);try{D.fdatasyncSync(q)}catch($){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",$),o=!1}}finally{D.closeSync(q)}}e.writeFileSync=d;function m(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function k(U,j){if(U===j)return;async function W(x){try{const q=await e.Promises.lstat(x);if(q.isDirectory()||q.isSymbolicLink())return;await e.Promises.utimes(x,q.atime,new Date)}catch(q){}}try{await e.Promises.rename(U,j),await W(j)}catch(x){if(U.toLowerCase()!==j.toLowerCase()&&x.code==="EXDEV"||U.endsWith("."))await _(U,j,{preserveSymlinks:!1}),await h(U,b.MOVE),await W(j);else throw x}}async function _(U,j,W){return N(U,j,{root:{source:U,target:j},options:W,handledSourcePaths:new Set})}const O=511;async function N(U,j,W){if(W.handledSourcePaths.has(U))return;W.handledSourcePaths.add(U);const{stat:x,symbolicLink:q}=await r.stat(U);if(q){if(W.options.preserveSymlinks)try{return await z(U,j,W)}catch($){console.warn("[node.js fs] copy of symlink failed: ",$)}if(q.dangling)return}return x.isDirectory()?C(U,j,x.mode&O,W):F(U,j,x.mode&O)}async function C(U,j,W,x){await e.Promises.mkdir(j,{recursive:!0,mode:W});const q=await v(U);for(const $ of q)await N((0,S.join)(U,$),(0,S.join)(j,$),x)}async function F(U,j,W){await e.Promises.copyFile(U,j),await e.Promises.chmod(j,W)}async function z(U,j,W){let x=await e.Promises.readlink(U);(0,L.isEqualOrParent)(x,W.root.source,!E.isLinux)&&(x=(0,S.join)(W.root.target,x.substr(W.root.source.length+1))),await e.Promises.symlink(x,j)}e.Promises=new class{get access(){return(0,P.promisify)(D.access)}get stat(){return(0,P.promisify)(D.stat)}get lstat(){return(0,P.promisify)(D.lstat)}get utimes(){return(0,P.promisify)(D.utimes)}get read(){return(0,P.promisify)(D.read)}get readFile(){return(0,P.promisify)(D.readFile)}get write(){return(0,P.promisify)(D.write)}get appendFile(){return(0,P.promisify)(D.appendFile)}get fdatasync(){return(0,P.promisify)(D.fdatasync)}get truncate(){return(0,P.promisify)(D.truncate)}get rename(){return(0,P.promisify)(D.rename)}get copyFile(){return(0,P.promisify)(D.copyFile)}get open(){return(0,P.promisify)(D.open)}get close(){return(0,P.promisify)(D.close)}get symlink(){return(0,P.promisify)(D.symlink)}get readlink(){return(0,P.promisify)(D.readlink)}get chmod(){return(0,P.promisify)(D.chmod)}get mkdir(){return(0,P.promisify)(D.mkdir)}get unlink(){return(0,P.promisify)(D.unlink)}get rmdir(){return(0,P.promisify)(D.rmdir)}get realpath(){return(0,P.promisify)(D.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return v}get readDirsInDir(){return t}get writeFile(){return a}get rm(){return h}get move(){return k}get copy(){return _}}}),define(te[110],ne([0,1,52,9,25,19]),function(J,e,D,A,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function L(n){const I=(0,A.dirname)(n);if(n===I)return n;const g=((0,A.basename)(n)||n).toLowerCase();try{const h=(0,T.readdirSync)(I).filter(y=>y.toLowerCase()===g);if(h.length===1){const y=L(I);if(y)return(0,A.join)(y,h[0])}else if(h.length>1){const y=h.indexOf(g);if(y>=0){const f=L(I);if(f)return(0,A.join)(f,h[y])}}}catch(b){}return null}e.realcaseSync=L;async function R(n){try{return await T.Promises.realpath(n)}catch(I){const g=E(n);return await T.Promises.access(g,D.constants.R_OK),g}}e.realpath=R;function S(n){try{return D.realpathSync(n)}catch(I){const g=E(n);return D.accessSync(g,D.constants.R_OK),g}}e.realpathSync=S;function E(n){return(0,P.rtrim)((0,A.normalize)(n),A.sep)}}),define(te[111],ne([0,1,56]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function A(R,S,E,n=1){let I=!1;return new Promise(g=>{const b=setTimeout(()=>{if(!I)return I=!0,g(0)},E);P(R,S,n,h=>{if(!I)return I=!0,clearTimeout(b),g(h)})})}e.findFreePort=A;function P(R,S,E,n){if(S===0)return n(0);const I=new D.Socket;I.once("connect",()=>(L(I),P(R+E,S-1,E,n))),I.once("data",()=>{}),I.once("error",g=>(L(I),g.code!=="ECONNREFUSED"?P(R+E,S-1,E,n):n(R))),I.connect(R,"127.0.0.1")}function T(R,S,E){let n=!1,I,g=1;const b=D.createServer({pauseOnConnect:!0});function h(y,f){n||(n=!0,b.removeAllListeners(),b.close(),I&&clearTimeout(I),f(y))}return new Promise(y=>{I=setTimeout(()=>{h(0,y)},E),b.on("listening",()=>{h(R,y)}),b.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&g<S?(R++,g++,b.listen(R,"127.0.0.1")):h(0,y)}),b.on("close",()=>{h(0,y)}),b.listen(R,"127.0.0.1")})}e.findFreePortFaster=T;function L(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(S){console.error(S)}}}),define(te[69],ne([0,1,33,9,19]),function(J,e,D,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,L=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var S;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(S||(S={}));let E;switch(process.arch){case"ia32":case"x32":E=1;break;case"arm":case"arm64":E=2;break;default:E=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class I{constructor(c,t,s){this.exePath=c,this.displayName=t,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await P.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:l=!1}={}){return l?E===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function b({useAlternateBitness:l=!1,findPreview:c=!1}={}){const t=g({useAlternateBitness:l});if(!t)return null;const s=A.join(t,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(s))return null;let r=-1,i=null;for(const u of await P.Promises.readdir(s)){let d=-1;if(c){const k=u.indexOf("-");if(k<0)continue;const _=u.substring(0,k);if(!T.test(_)||u.substring(k+1)!=="preview")continue;d=parseInt(_,10)}else{if(!T.test(u))continue;d=parseInt(u,10)}if(d<=r)continue;const m=A.join(s,u,"pwsh.exe");!await P.SymlinkSupport.existsFile(m)||(i=m,r=d)}if(!i)return null;const a=t.includes("x86")?" (x86)":"",o=c?" Preview":"";return new I(i,`PowerShell${o}${a}`,!0)}async function h({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const c=A.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=l?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const r of await P.Promises.readdir(c))if(t.test(r)){const i=A.join(c,r,"pwsh.exe");return new I(i,s)}return null}function y(){const l=A.join(D.homedir(),".dotnet","tools","pwsh.exe");return new I(l,".NET Core PowerShell Global Tool")}function f(){const l=A.join(process.env.windir,E===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(l,"Windows PowerShell",!0)}async function*w(){let l=await b();l&&(yield l),l=await b({useAlternateBitness:!0}),l&&(yield l),l=await h(),l&&(yield l),l=y(),l&&(yield l),l=await b({findPreview:!0}),l&&(yield l),l=await h({findPreview:!0}),l&&(yield l),l=await b({useAlternateBitness:!0,findPreview:!0}),l&&(yield l),l=f(),l&&(yield l)}async function*v(){for await(const l of w())await l.exists()&&(yield l)}e.enumeratePowerShellInstallations=v;async function p(){for await(const l of v())return l;return null}e.getFirstAvailablePowerShellInstallation=p}),define(te[112],ne([0,1,41,15]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function P(L){return new Promise((R,S)=>{let E;const n=new Map;function I(b,h,y,f,w){const v=n.get(h);if(b===L||v){const p={name:g(y),cmd:y,pid:b,ppid:h,load:f,mem:w};n.set(b,p),b===L&&(E=p),v&&(v.children||(v.children=[]),v.children.push(p),v.children.length>1&&(v.children=v.children.sort((l,c)=>l.pid-c.pid)))}}function g(b){const h=/--disable-blink-features=Auxclick/,y=/\\watcher\\win32\\CodeHelper\.exe/,f=/--crashes-directory/,w=/\\pipe\\winpty-control/,v=/conhost\.exe/,p=/--type=([a-zA-Z-]+)/;if(y.exec(b))return"watcherService ";if(f.exec(b))return"electron-crash-reporter";if(w.exec(b))return"winpty-process";if(v.exec(b))return"console-window-host (Windows internal process)";let l=p.exec(b);if(l&&l.length===2)return l[1]==="renderer"?h.exec(b)?"shared-process":"window":l[1];const c=/[a-zA-Z-]+\.js/g;let t="";do l=c.exec(b),l&&(t+=l+" ");while(l);return t&&b.indexOf("node ")<0&&b.indexOf("node.exe")<0?`electron_node ${t}`:b}if(process.platform==="win32"){const b=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,y)=>{J(["windows-process-tree"],h,y)}).then(h=>{h.getProcessList(L,y=>{h.getProcessCpuUsage(y,f=>{const w=new Map;f.forEach(v=>{const p=b(v.commandLine||"");w.set(v.pid,{name:g(p),cmd:p,pid:v.pid,ppid:v.ppid,load:v.cpu||0,mem:v.memory||0})}),E=w.get(L),E?(w.forEach(v=>{const p=w.get(v.ppid);p&&(p.children||(p.children=[]),p.children.push(v))}),w.forEach(v=>{v.children&&(v.children=v.children.sort((p,l)=>p.pid-l.pid))}),R(E)):S(new Error(`Root process ${L} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let b=function(){let h=[E];const y=[];for(;h.length;){const w=h.shift();w&&(y.push(w.pid),w.children&&(h=h.concat(w.children)))}let f=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",J).fsPath);f+=" "+y.join(" "),(0,D.exec)(f,{},(w,v,p)=>{if(w||p)S(w||new Error(p.toString()));else{const l=v.toString().split(`
`);for(let c=0;c<y.length;c++){const t=n.get(y[c]);t.load=parseFloat(l[c])}if(!E){S(new Error(`Root process ${L} not found`));return}R(E)}})};(0,D.exec)("which ps",{},(h,y,f)=>{if(h||f)if(process.platform!=="linux")S(h||new Error(f.toString()));else{const w=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/ps.sh",J).fsPath);(0,D.exec)(w,{},(v,p,l)=>{v||l?S(v||new Error(l.toString())):(T(p,I),b())})}else{const w=y.toString().trim(),v="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${w} ${v}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(p,l,c)=>{p||c&&!c.includes("screen size is bogus")?S(p||new Error(c.toString())):(T(l,I),process.platform==="linux"?b():E?R(E):S(new Error(`Root process ${L} not found`)))})}})}})}e.listProcesses=P;function T(L,R){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=L.toString().split(`
`);for(const n of E){const I=S.exec(n.trim());I&&I.length===6&&R(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(te[113],ne([0,1,52,27,39,2,68,9,4,19]),function(J,e,D,A,P,T,L,R,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function n(h,y,f){return g({path:h,isDirectory:!1},y,f)}e.watchFile=n;function I(h,y,f){return g({path:h,isDirectory:!0},y,f)}e.watchFolder=I,e.CHANGE_BUFFER_DELAY=100;function g(h,y,f){if(S.isMacintosh&&(0,P.isEqualOrParent)(h.path,"/Volumes/"))return f(`Refusing to watch ${h.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const w=(0,R.basename)(h.path),v=new Map;let p=!1,l=[(0,T.toDisposable)(()=>{v.forEach(c=>(0,T.dispose)(c)),v.clear()})];try{const c=(0,D.watch)(h.path);l.push((0,T.toDisposable)(()=>{c.removeAllListeners(),c.close()}));const t=new Set;h.isDirectory&&E.Promises.readdir(h.path).then(s=>s.forEach(r=>t.add(r))),c.on("error",(s,r)=>{p||f(`Failed to watch ${h.path} for changes using fs.watch() (${s}, ${r})`)}),c.on("change",(s,r)=>{if(p)return;let i="";if(r&&(i=r.toString(),S.isMacintosh&&(i=(0,L.normalizeNFC)(i))),!i||s!=="change"&&s!=="rename")return;const a=h.isDirectory?(0,R.join)(h.path,i):h.path;if(h.isDirectory)if(s==="rename"){const o=v.get(a);o&&(0,T.dispose)(o);const u=setTimeout(async()=>{v.delete(a);const d=await E.Promises.exists(a);if(p)return;let m;d?t.has(i)?m="changed":(m="added",t.add(i)):(t.delete(i),m="deleted"),y(m,a)},e.CHANGE_BUFFER_DELAY);v.set(a,(0,T.toDisposable)(()=>clearTimeout(u)))}else{let o;t.has(i)?o="changed":(o="added",t.add(i)),y(o,a)}else if(s==="rename"||i!==w){const o=setTimeout(async()=>{const u=await E.Promises.exists(a);p||(u?(y("changed",a),l=[g(h,y,f)]):y("deleted",a))},e.CHANGE_BUFFER_DELAY);(0,T.dispose)(l),l=[(0,T.toDisposable)(()=>clearTimeout(o))]}else y("changed",a)})}catch(c){E.Promises.exists(h.path).then(t=>{t&&!p&&f(`Failed to watch ${h.path} for changes using fs.watch() (${c.toString()})`)})}return(0,T.toDisposable)(()=>{p=!0,l=(0,T.dispose)(l)})}async function b(h,y,f,w=512){const v=await E.Promises.open(h,"r"),p=Buffer.allocUnsafe(w),l=new A.CancellationTokenSource(f);let c,t=!1;const s=n(h,async r=>{if(r==="changed"){if(t)return;t=!0;try{for(;!l.token.isCancellationRequested;){const{bytesRead:i}=await E.Promises.read(v,p,0,w,null);if(!i||l.token.isCancellationRequested)break;y(p.slice(0,i))}}catch(i){c=new Error(i),l.dispose(!0)}finally{t=!1}}},r=>{c=new Error(r),l.dispose(!0)});return new Promise((r,i)=>{l.token.onCancellationRequested(async()=>{s.dispose(),await E.Promises.close(v),c?i(c):r()})})}e.watchFileContents=b});var he=this&&this.__decorate||function(J,e,D,A){var P=arguments.length,T=P<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,D):A,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(J,e,D,A);else for(var R=J.length-1;R>=0;R--)(L=J[R])&&(T=(P<3?L(T):P>3?L(e,D,T):L(e,D))||T);return P>3&&T&&Object.defineProperty(e,D,T),T};define(te[32],ne([0,1,17,5,22,27,66,8,3,2,102,25,18]),function(J,e,D,A,P,T,L,R,S,E,n,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function h(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(y=e.ResponseType||(e.ResponseType={}));function f(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(w||(w={}));class v{constructor($){this.buffer=$,this.pos=0}read($){const G=this.buffer.slice(this.pos,this.pos+$);return this.pos+=G.byteLength,G}}class p{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write($){this.buffers.push($)}}var l;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(l||(l={}));function c(q){const $=P.VSBuffer.alloc(4);return $.writeUInt32BE(q,0),$}function t(q){return q.read(4).readUInt32BE(0)}function s(q){const $=P.VSBuffer.alloc(1);return $.writeUInt8(q,0),$}const r={Undefined:s(l.Undefined),String:s(l.String),Buffer:s(l.Buffer),VSBuffer:s(l.VSBuffer),Array:s(l.Array),Object:s(l.Object)},i=typeof Buffer!="undefined";function a(q,$){if(typeof $=="undefined")q.write(r.Undefined);else if(typeof $=="string"){const G=P.VSBuffer.fromString($);q.write(r.String),q.write(c(G.byteLength)),q.write(G)}else if(i&&Buffer.isBuffer($)){const G=P.VSBuffer.wrap($);q.write(r.Buffer),q.write(c(G.byteLength)),q.write(G)}else if($ instanceof P.VSBuffer)q.write(r.VSBuffer),q.write(c($.byteLength)),q.write($);else if(Array.isArray($)){q.write(r.Array),q.write(c($.length));for(const G of $)a(q,G)}else{const G=P.VSBuffer.fromString(JSON.stringify($));q.write(r.Object),q.write(c(G.byteLength)),q.write(G)}}function o(q){switch(q.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return q.read(t(q)).toString();case l.Buffer:return q.read(t(q)).buffer;case l.VSBuffer:return q.read(t(q));case l.Array:{const G=t(q),M=[];for(let B=0;B<G;B++)M.push(o(q));return M}case l.Object:return JSON.parse(q.read(t(q)).toString())}}class u{constructor($,G,M=null,B=1e3){this.protocol=$,this.ctx=G,this.logger=M,this.timeoutDelay=B,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(V=>this.onRawMessage(V)),this.sendResponse({type:200})}registerChannel($,G){this.channels.set($,G),setTimeout(()=>this.flushPendingRequests($),0)}sendResponse($){switch($.type){case 200:{const G=this.send([$.type]);this.logger&&this.logger.logOutgoing(G,0,1,f($.type));return}case 201:case 202:case 204:case 203:{const G=this.send([$.type,$.id],$.data);this.logger&&this.logger.logOutgoing(G,$.id,1,f($.type),$.data);return}}}send($,G=void 0){const M=new p;return a(M,$),a(M,G),this.sendBuffer(M.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch(G){return 0}}onRawMessage($){const G=new v($),M=o(G),B=o(G),V=M[0];switch(V){case 100:return this.logger&&this.logger.logIncoming($.byteLength,M[1],1,`${h(V)}: ${M[2]}.${M[3]}`,B),this.onPromise({type:V,id:M[1],channelName:M[2],name:M[3],arg:B});case 102:return this.logger&&this.logger.logIncoming($.byteLength,M[1],1,`${h(V)}: ${M[2]}.${M[3]}`,B),this.onEventListen({type:V,id:M[1],channelName:M[2],name:M[3],arg:B});case 101:return this.logger&&this.logger.logIncoming($.byteLength,M[1],1,`${h(V)}`),this.disposeActiveRequest({type:V,id:M[1]});case 103:return this.logger&&this.logger.logIncoming($.byteLength,M[1],1,`${h(V)}`),this.disposeActiveRequest({type:V,id:M[1]})}}onPromise($){const G=this.channels.get($.channelName);if(!G){this.collectPendingRequest($);return}const M=new T.CancellationTokenSource;let B;try{B=G.call(this.ctx,$.name,$.arg,M.token)}catch(Z){B=Promise.reject(Z)}const V=$.id;B.then(Z=>{this.sendResponse({id:V,data:Z,type:201}),this.activeRequests.delete($.id)},Z=>{Z instanceof Error?this.sendResponse({id:V,data:{message:Z.message,name:Z.name,stack:Z.stack?Z.stack.split?Z.stack.split(`
`):Z.stack:void 0},type:202}):this.sendResponse({id:V,data:Z,type:203}),this.activeRequests.delete($.id)});const Q=(0,E.toDisposable)(()=>M.cancel());this.activeRequests.set($.id,Q)}onEventListen($){const G=this.channels.get($.channelName);if(!G){this.collectPendingRequest($);return}const M=$.id,V=G.listen(this.ctx,$.name,$.arg)(Q=>this.sendResponse({id:M,data:Q,type:204}));this.activeRequests.set($.id,V)}disposeActiveRequest($){const G=this.activeRequests.get($.id);G&&(G.dispose(),this.activeRequests.delete($.id))}collectPendingRequest($){let G=this.pendingRequests.get($.channelName);G||(G=[],this.pendingRequests.set($.channelName,G));const M=setTimeout(()=>{console.error(`Unknown channel: ${$.channelName}`),$.type===100&&this.sendResponse({id:$.id,data:{name:"Unknown channel",message:`Channel name '${$.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);G.push({request:$,timeoutTimer:M})}flushPendingRequests($){const G=this.pendingRequests.get($);if(G){for(const M of G)switch(clearTimeout(M.timeoutTimer),M.request.type){case 100:this.onPromise(M.request);break;case 102:this.onEventListen(M.request);break}this.pendingRequests.delete($)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach($=>$.dispose()),this.activeRequests.clear()}}e.ChannelServer=u;var d;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class m{constructor($,G=null){this.protocol=$,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(M=>this.onBuffer(M)),this.logger=G}getChannel($){const G=this;return{call(M,B,V){return G.isDisposed?Promise.reject(R.canceled()):G.requestPromise($,M,B,V)},listen(M,B){return G.isDisposed?Promise.reject(R.canceled()):G.requestEvent($,M,B)}}}requestPromise($,G,M,B=T.CancellationToken.None){const V=this.lastRequestId++,Z={id:V,type:100,channelName:$,name:G,arg:M};if(B.isCancellationRequested)return Promise.reject(R.canceled());let K;return new Promise((re,ie)=>{if(B.isCancellationRequested)return ie(R.canceled());const ae=()=>{const Ie=Ce=>{switch(Ce.type){case 201:this.handlers.delete(V),re(Ce.data);break;case 202:this.handlers.delete(V);const Ee=new Error(Ce.data.message);Ee.stack=Ce.data.stack,Ee.name=Ce.data.name,ie(Ee);break;case 203:this.handlers.delete(V),ie(Ce.data);break}};this.handlers.set(V,Ie),this.sendRequest(Z)};let ue=null;this.state===w.Idle?ae():(ue=(0,A.createCancelablePromise)(Ie=>this.whenInitialized()),ue.then(()=>{ue=null,ae()}));const fe=()=>{ue?(ue.cancel(),ue=null):this.sendRequest({id:V,type:101}),ie(R.canceled())},de=B.onCancellationRequested(fe);K=(0,E.combinedDisposable)((0,E.toDisposable)(fe),de),this.activeRequests.add(K)}).finally(()=>{this.activeRequests.delete(K)})}requestEvent($,G,M){const B=this.lastRequestId++,Q={id:B,type:102,channelName:$,name:G,arg:M};let Z=null;const K=new S.Emitter({onFirstListenerAdd:()=>{Z=(0,A.createCancelablePromise)(re=>this.whenInitialized()),Z.then(()=>{Z=null,this.activeRequests.add(K),this.sendRequest(Q)})},onLastListenerRemove:()=>{Z?(Z.cancel(),Z=null):(this.activeRequests.delete(K),this.sendRequest({id:B,type:103}))}}),H=re=>K.fire(re.data);return this.handlers.set(B,H),K.event}sendRequest($){switch($.type){case 100:case 102:{const G=this.send([$.type,$.id,$.channelName,$.name],$.arg);this.logger&&this.logger.logOutgoing(G,$.id,0,`${h($.type)}: ${$.channelName}.${$.name}`,$.arg);return}case 101:case 103:{const G=this.send([$.type,$.id]);this.logger&&this.logger.logOutgoing(G,$.id,0,h($.type));return}}}send($,G=void 0){const M=new p;return a(M,$),a(M,G),this.sendBuffer(M.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch(G){return 0}}onBuffer($){const G=new v($),M=o(G),B=o(G),V=M[0];switch(V){case 200:return this.logger&&this.logger.logIncoming($.byteLength,0,0,f(V)),this.onResponse({type:M[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming($.byteLength,M[1],0,f(V),B),this.onResponse({type:M[0],id:M[1],data:B})}}onResponse($){if($.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}const G=this.handlers.get($.id);G&&G($)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach($=>$.dispose()),this.activeRequests.clear()}}he([L.memoize],m.prototype,"onDidInitializePromise",null),e.ChannelClient=m;class k{constructor($){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,$(({protocol:G,onDidClientDisconnect:M})=>{S.Event.once(G.onMessage)(V=>{const Q=new v(V),Z=o(Q),K=new u(G,Z),H=new m(G);this.channels.forEach((ie,ae)=>K.registerChannel(ae,ie));const re={channelServer:K,channelClient:H,ctx:Z};this._connections.add(re),this._onDidAddConnection.fire(re),M(()=>{K.dispose(),H.dispose(),this._connections.delete(re),this._onDidRemoveConnection.fire(re)})})})}get connections(){const $=[];return this._connections.forEach(G=>$.push(G)),$}getChannel($,G){const M=this;return{call(B,V,Q){let Z;if((0,g.isFunction)(G)){let H=(0,D.getRandomElement)(M.connections.filter(G));Z=H?Promise.resolve(H):S.Event.toPromise(S.Event.filter(M.onDidAddConnection,G))}else Z=G.routeCall(M,B,V);const K=Z.then(H=>H.channelClient.getChannel($));return O(K).call(B,V,Q)},listen(B,V){if((0,g.isFunction)(G))return M.getMulticastEvent($,G,B,V);const Q=G.routeEvent(M,B,V).then(Z=>Z.channelClient.getChannel($));return O(Q).listen(B,V)}}}getMulticastEvent($,G,M,B){const V=this;let Q=new E.DisposableStore;const Z=new S.Emitter({onFirstListenerAdd:()=>{Q=new E.DisposableStore;const K=new S.EventMultiplexer,H=new Map,re=ae=>{const fe=ae.channelClient.getChannel($).listen(M,B),de=K.add(fe);H.set(ae,de)},ie=ae=>{const ue=H.get(ae);!ue||(ue.dispose(),H.delete(ae))};V.connections.filter(G).forEach(re),S.Event.filter(V.onDidAddConnection,G)(re,void 0,Q),V.onDidRemoveConnection(ie,void 0,Q),K.event(Z.fire,Z,Q),Q.add(K)},onLastListenerRemove:()=>{Q.dispose()}});return Z.event}registerChannel($,G){this.channels.set($,G),this._connections.forEach(M=>{M.channelServer.registerChannel($,G)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=k;class _{constructor($,G,M=null){const B=new p;a(B,G),$.send(B.buffer),this.channelClient=new m($,M),this.channelServer=new u($,G,M)}getChannel($){return this.channelClient.getChannel($)}registerChannel($,G){this.channelServer.registerChannel($,G)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function O(q){return{call($,G,M){return q.then(B=>B.call($,G,M))},listen($,G){const M=new S.Relay;return q.then(B=>M.input=B.listen($,G)),M.event}}}e.getDelayedChannel=O;function N(q){let $=!1;return{call(G,M,B){return $?q.call(G,M,B):(0,A.timeout)(0).then(()=>$=!0).then(()=>q.call(G,M,B))},listen(G,M){if($)return q.listen(G,M);const B=new S.Relay;return(0,A.timeout)(0).then(()=>$=!0).then(()=>B.input=q.listen(G,M)),B.event}}}e.getNextTickChannel=N;class C{constructor($){this.fn=$}routeCall($){return this.route($)}routeEvent($){return this.route($)}async route($){for(const G of $.connections)if(await Promise.resolve(this.fn(G.ctx)))return Promise.resolve(G);return await S.Event.toPromise($.onDidAddConnection),await this.route($)}}e.StaticRouter=C;var F;(function(q){function $(V,Q){const Z=V,K=Q&&Q.disableMarshalling,H=new Map;for(const re in Z)M(re)&&H.set(re,S.Event.buffer(Z[re],!0));return new class{listen(re,ie,ae){const ue=H.get(ie);if(ue)return ue;if(B(ie)){const fe=Z[ie];if(typeof fe=="function")return fe.call(Z,ae)}throw new Error(`Event not found: ${ie}`)}call(re,ie,ae){const ue=Z[ie];if(typeof ue=="function"){if(!K&&Array.isArray(ae))for(let fe=0;fe<ae.length;fe++)ae[fe]=(0,n.revive)(ae[fe]);return ue.apply(Z,ae)}throw new Error(`Method not found: ${ie}`)}}}q.fromService=$;function G(V,Q){const Z=Q&&Q.disableMarshalling;return new Proxy({},{get(K,H){if(typeof H=="string")return Q?.properties?.has(H)?Q.properties.get(H):B(H)?function(re){return V.listen(H,re)}:M(H)?V.listen(H):async function(...re){let ie;Q&&!(0,g.isUndefinedOrNull)(Q.context)?ie=[Q.context,...re]:ie=re;const ae=await V.call(H,ie);return Z?ae:(0,n.revive)(ae)};throw new Error(`Property not found: ${String(H)}`)}})}q.toService=G;function M(V){return V[0]==="o"&&V[1]==="n"&&I.isUpperAsciiLetter(V.charCodeAt(2))}function B(V){return/^onDynamic/.test(V)&&I.isUpperAsciiLetter(V.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){let $=q.toString();if($!=="[object Object]")return $}return q}function j(q){return Array.isArray(q)?q.map(U):U(q)}function W(q,$,G,M,B,V,Q){Q=j(Q);const Z=z[B],K=Z[M%Z.length];let H=[`%c[${q}]%c[${String($).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String(M).padStart(5," ")} - ${V}`,"color: darkgreen","color: grey","color: grey",`color: ${K}`];/\($/.test(V)?(H=H.concat(Q),H.push(")")):H.push(Q),console.log.apply(console,H)}e.logWithColors=W;class x{constructor($,G){this._outgoingPrefix=$,this._incomingPrefix=G,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing($,G,M,B,V){this._totalOutgoing+=$,W(this._outgoingPrefix,this._totalOutgoing,$,G,M,B,V)}logIncoming($,G,M,B,V){this._totalIncoming+=$,W(this._incomingPrefix,this._totalIncoming,$,G,M,B,V)}}e.IPCLogger=x}),define(te[114],ne([0,1,22,3,32]),function(J,e,D,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(S){this.port=S,this.onMessage=A.Event.fromDOMEventEmitter(this.port,"message",E=>D.VSBuffer.wrap(E.data)),S.start()}send(S){this.port.postMessage(S.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class L extends P.IPCClient{constructor(S,E){const n=new T(S);super(n,E);this.protocol=n}dispose(){this.protocol.disconnect()}}e.Client=L}),define(te[70],ne([0,1,22,3,2,4,31,32]),function(J,e,D,A,P,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var S;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let E=null;function n(){return E||(E=D.VSBuffer.alloc(0)),E}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,a){if(i===0)return n();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const m=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=i),m}if(this._chunks[0].byteLength>i){const m=this._chunks[0].slice(0,i);return a&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),m}let o=D.VSBuffer.alloc(i),u=0,d=0;for(;i>0;){const m=this._chunks[d];if(m.byteLength>i){const k=m.slice(0,i);o.set(k,u),u+=i,a&&(this._chunks[d]=m.slice(i),this._totalLength-=i),i-=i}else o.set(m,u),u+=m.byteLength,a?(this._chunks.shift(),this._totalLength-=m.byteLength):d++,i-=m.byteLength}return o}}e.ChunkStream=I;var g;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(g||(g={}));var b;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(b=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(i,a,o,u){this.type=i,this.id=a,this.ack=o,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class y extends P.Disposable{constructor(i){super();this._onMessage=this._register(new A.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5);else{const o=this._state.messageType,u=this._state.id,d=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new h(o,u,d,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class f{constructor(i){this._isDisposed=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(i){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=D.VSBuffer.alloc(13);a.writeUInt8(i.type,0),a.writeUInt32BE(i.id,1),a.writeUInt32BE(i.ack,5),a.writeUInt32BE(i.data.byteLength,9),this._writeSoon(a,i.data)}_bufferAdd(i,a){const o=this._totalLength===0;return this._data.push(i,a),this._totalLength+=i.byteLength+a.byteLength,o}_bufferTake(){const i=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,a){this._bufferAdd(i,a)&&T.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class w extends P.Disposable{constructor(i){super();this._onMessage=new A.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new A.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new f(this._socket)),this._socketReader=this._register(new y(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new h(1,0,0,i))}}e.Protocol=w;class v extends R.IPCClient{constructor(i,a,o=null){super(i,a,o);this.protocol=i}static fromSocket(i,a){return new v(new w(i),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=v;class p{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new A.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,L.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=p;class l{constructor(i){this.data=i,this.next=null}}class c{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let i=[],a=0,o=this._first;for(;o;)i[a++]=o.data,o=o.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const a=new l(i);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class t{constructor(){this.lastRuns=[];const i=Date.now();for(let a=0;a<t._HISTORY_LENGTH;a++)this.lastRuns[a]=i-1e3*a;setInterval(()=>{for(let a=t._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const i=Date.now(),a=(1+t._HISTORY_LENGTH)*1e3;let o=0;for(let u=0;u<t._HISTORY_LENGTH;u++)i-this.lastRuns[u]<=a&&o++;return 1-o/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class s{constructor(i,a=null,o=t.getInstance()){this._onControlMessage=new p,this.onControlMessage=this._onControlMessage.event,this._onMessage=new p,this.onMessage=this._onMessage.event,this._onDidDispose=new p,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new p,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new p,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=o,this._isReconnecting=!1,this._outgoingUnackMsg=new c,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=i,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),a&&this._socketReader.acceptChunk(a),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,P.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new h(5,0,0,n());this._socketWriter.write(i),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const i=Date.now()-this._socketWriter.lastWriteTime;if(i>=5e3){const a=new h(4,0,0,n());this._socketWriter.write(a),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-i+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const i=Date.now()-this._socketReader.lastReadTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-i,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,a){this._isReconnecting=!0,this._socketDisposables=(0,P.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=i,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(o=>this._onSocketClose.fire(o))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1;const i=this._outgoingUnackMsg.toArray();for(let a=0,o=i.length;a<o;a++)this._socketWriter.write(i[a]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(i.type===1){if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new h(6,0,0,n())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data)}else if(i.type===2)this._onControlMessage.fire(i.data);else if(i.type===5)this._onDidDispose.fire();else if(i.type===6){const a=this._outgoingUnackMsg.toArray();for(let o=0,u=a.length;o<u;o++)this._socketWriter.write(a[o]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new h(1,a,this._incomingAckId,i);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(i){const a=new h(2,0,0,i);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const i=this._outgoingUnackMsg.peek(),a=Date.now()-i.writtenTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-a,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new h(3,0,this._incomingAckId,n());this._socketWriter.write(i)}}e.PersistentProtocol=s}),define(te[115],ne([0,1,116,3,32,114]),function(J,e,D,A,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class L extends P.IPCServer{static getOnDidClientConnect(){const S=A.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(E,n)=>n);return A.Event.map(S,E=>{const{port1:n,port2:I}=new MessageChannel,b={protocol:new T.Protocol(n),onDidClientDisconnect:A.Event.fromDOMEventEmitter(n,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",E,[I]),b})}constructor(){super(L.getOnDidClientConnect())}}e.Server=L}),define(te[117],ne([0,1,22,8]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function P(R,S){R.proxyAuthorization&&(R.headers={...R.headers||{},"Proxy-Authorization":R.proxyAuthorization});const E=new XMLHttpRequest;return new Promise((n,I)=>{E.open(R.type||"GET",R.url||"",!0,R.user,R.password),T(E,R),E.responseType="arraybuffer",E.onerror=g=>I(new Error(E.statusText&&"XHR failed: "+E.statusText||"XHR failed")),E.onload=g=>{n({res:{statusCode:E.status,headers:L(E)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(E.response)))})},E.ontimeout=g=>I(new Error(`XHR timeout: ${R.timeout}ms`)),R.timeout&&(E.timeout=R.timeout),E.send(R.data),S.onCancellationRequested(()=>{E.abort(),I((0,A.canceled)())})})}e.request=P;function T(R,S){if(S.headers){e:for(let E in S.headers){switch(E){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}R.setRequestHeader(E,S.headers[E])}}}function L(R){const S=Object.create(null);for(const E of R.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(E){const n=E.indexOf(":");S[E.substr(0,n).trim().toLowerCase()]=E.substr(n+1).trim()}return S}}),define(te[71],ne([0,1,5,3,2,18]),function(J,e,D,A,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var L;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(L=e.StorageHint||(e.StorageHint={}));function R(I){const g=I;return g?.changed instanceof Map||g?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var S;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(S||(S={}));class E extends P.Disposable{constructor(g,b=Object.create(null)){super();this.database=g,this.options=b,this._onDidChangeStorage=this._register(new A.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=S.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(E.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){g.changed?.forEach((b,h)=>this.accept(h,b)),g.deleted?.forEach(b=>this.accept(b,void 0))}accept(g,b){if(this.state===S.Closed)return;let h=!1;(0,T.isUndefinedOrNull)(b)?h=this.cache.delete(g):this.cache.get(g)!==b&&(this.cache.set(g,b),h=!0),h&&this._onDidChangeStorage.fire(g)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===S.None&&(this.state=S.Initialized,this.options.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,b){const h=this.cache.get(g);return(0,T.isUndefinedOrNull)(h)?b:h}getBoolean(g,b){const h=this.get(g);return(0,T.isUndefinedOrNull)(h)?b:h==="true"}getNumber(g,b){const h=this.get(g);return(0,T.isUndefinedOrNull)(h)?b:parseInt(h,10)}async set(g,b){if(this.state===S.Closed)return;if((0,T.isUndefinedOrNull)(b))return this.delete(g);const h=String(b);if(this.cache.get(g)!==h)return this.cache.set(g,h),this.pendingInserts.set(g,h),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async delete(g){if(!(this.state===S.Closed||!this.cache.delete(g)))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=S.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(g){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=E,E.DEFAULT_FLUSH_DELAY=100;class n{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((b,h)=>this.items.set(h,b)),g.delete&&g.delete.forEach(b=>this.items.delete(b))}async close(){}}e.InMemoryStorageDatabase=n}),define(te[118],ne([11,12]),function(J,e){return J.create("vs/base/common/date",e)}),define(te[57],ne([0,1,118]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,P=A*60,T=P*24,L=T*7,R=T*30,S=T*365;function E(I,g){typeof I!="number"&&(I=I.getTime());const b=Math.round((new Date().getTime()-I)/1e3);if(b<-30)return(0,D.localize)(0,null,E(new Date().getTime()+b*1e3,!1));if(b<30)return(0,D.localize)(1,null);let h;return b<A?(h=b,g?h===1?(0,D.localize)(2,null,h):(0,D.localize)(3,null,h):h===1?(0,D.localize)(4,null,h):(0,D.localize)(5,null,h)):b<P?(h=Math.floor(b/A),g?h===1?(0,D.localize)(6,null,h):(0,D.localize)(7,null,h):h===1?(0,D.localize)(8,null,h):(0,D.localize)(9,null,h)):b<T?(h=Math.floor(b/P),g?h===1?(0,D.localize)(10,null,h):(0,D.localize)(11,null,h):h===1?(0,D.localize)(12,null,h):(0,D.localize)(13,null,h)):b<L?(h=Math.floor(b/T),g?h===1?(0,D.localize)(14,null,h):(0,D.localize)(15,null,h):h===1?(0,D.localize)(16,null,h):(0,D.localize)(17,null,h)):b<R?(h=Math.floor(b/L),g?h===1?(0,D.localize)(18,null,h):(0,D.localize)(19,null,h):h===1?(0,D.localize)(20,null,h):(0,D.localize)(21,null,h)):b<S?(h=Math.floor(b/R),g?h===1?(0,D.localize)(22,null,h):(0,D.localize)(23,null,h):h===1?(0,D.localize)(24,null,h):(0,D.localize)(25,null,h)):(h=Math.floor(b/S),g?h===1?(0,D.localize)(26,null,h):(0,D.localize)(27,null,h):h===1?(0,D.localize)(28,null,h):(0,D.localize)(29,null,h))}e.fromNow=E;function n(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(te[119],ne([11,12]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(te[37],ne([0,1,17,18,119]),function(J,e,D,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(E,n){return n&&(E.stack||E.stacktrace)?P.localize(0,null,R(E),L(E.stack)||L(E.stacktrace)):R(E)}function L(E){return Array.isArray(E)?E.join(`
`):E}function R(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?P.localize(1,null,E.message):E.message||P.localize(2,null)}function S(E=null,n=!1){if(!E)return P.localize(3,null);if(Array.isArray(E)){const I=D.coalesce(E),g=S(I[0],n);return I.length>1?P.localize(4,null,g,I.length):g}if(A.isString(E))return E;if(E.detail){const I=E.detail;if(I.error)return T(I.error,n);if(I.exception)return T(I.exception,n)}return E.stack?T(E,n):E.message?E.message:P.localize(5,null)}e.toErrorMessage=S}),define(te[120],ne([11,12]),function(J,e){return J.create("vs/base/node/processes",e)}),define(te[72],ne([0,1,41,39,15,26,9,4,31,99,18,106,19,120]),function(J,e,D,A,P,T,L,R,S,E,n,I,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return E.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return E.TerminateResponseCode}});function h(c){switch(c){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function y(c,t){if(R.isWindows)try{const s={stdio:["pipe","pipe","ignore"]};t&&(s.cwd=t);const r=D.execFile("taskkill",["/T","/F","/PID",c.pid.toString()],s);return new Promise(i=>{r.once("error",a=>{i({success:!1,error:a})}),r.once("exit",(a,o)=>{i(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(s){return Promise.resolve({success:!1,error:s,code:s.status?h(s.status):1})}else if(R.isLinux||R.isMacintosh)try{const s=P.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(r=>{D.execFile(s,[c.pid.toString()],{encoding:"utf8",shell:!0},(i,a,o)=>{r(i?{success:!1,error:i}:{success:!0})})})}catch(s){return Promise.resolve({success:!1,error:s})}else c.kill("SIGKILL");return Promise.resolve({success:!0})}function f(c=S.env){return c.comspec||"cmd.exe"}e.getWindowsShell=f;class w{constructor(t,s,r,i){if(s!==void 0&&r!==void 0&&i!==void 0)this.cmd=t,this.args=s,this.shell=r,this.options=i;else{const a=t;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(S.env).forEach(o=>{a[o]=S.env[o]}),Object.keys(this.options.env).forEach(o=>{a[o]=this.options.env[o]}),this.options.env=a}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const s=t.lastIndexOf(L.sep);return s!==-1&&(t=t.substring(s+1)),w.WellKnowCommands[t]?t:"other"}start(t){return R.isWindows&&(this.options&&this.options.cwd&&A.isUNC(this.options.cwd)||!this.options&&A.isUNC(S.cwd()))?Promise.reject(new Error(b.localize(0,null))):this.useExec().then(s=>{let r,i;const a=new Promise((o,u)=>{r=o,i=u});if(s){let o=this.cmd;this.args&&(o=o+" "+this.args.join(" ")),this.childProcess=D.exec(o,this.options,(u,d,m)=>{this.childProcess=null;const k=u;k&&k.killed?i({killed:this.terminateRequested,stdout:d.toString(),stderr:m.toString()}):this.handleExec(r,t,u,d,m)})}else{let o=null;const u=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,r,t,i);const m={terminated:this.terminateRequested};n.isNumber(d)&&(m.cmdCode=d),r(m)};if(this.shell&&R.isWindows){const d=T.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let m=!1,k=!1;const _=[];let O=this.ensureQuotes(this.cmd);_.push(O.value),m=O.quoted,this.args&&this.args.forEach(C=>{O=this.ensureQuotes(C),_.push(O.value),k=k&&O.quoted});const N=["/s","/c"];m?k?N.push('"'+_.join(" ")+'"'):_.length>1?N.push('"'+_[0]+'" '+_.slice(1).join(" ")):N.push('"'+_[0]+'"'):N.push(_.join(" ")),o=D.spawn(f(),N,d)}else this.cmd&&(o=D.spawn(this.cmd,this.args,this.options));o&&(this.childProcess=o,this.childProcessPromise=Promise.resolve(o),this.pidResolve&&(this.pidResolve(n.isNumber(o.pid)?o.pid:-1),this.pidResolve=void 0),o.on("error",d=>{this.childProcess=null,i({terminated:this.terminateRequested,error:d})}),o.pid&&(this.childProcess.on("close",u),this.handleSpawn(o,r,t,i,!0)))}return a})}handleClose(t,s,r,i){}ensureQuotes(t){return w.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,y(t,this.options.cwd).then(s=>(s.success&&(this.childProcess=null),s))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!R.isWindows)return t(!1);const s=D.spawn(f(),["/s","/c"]);s.on("error",r=>t(!0)),s.on("exit",r=>t(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class v extends w{constructor(t,s,r,i){super(t,s,r,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,s,r,i,a){[i,a].forEach((o,u)=>{const d=new I.LineDecoder;d.write(o).forEach(_=>{s({line:_,source:u===0?0:1})});const k=d.end();k&&s({line:k,source:u===0?0:1})}),t({terminated:this.terminateRequested,error:r})}handleSpawn(t,s,r,i,a){const o=new I.LineDecoder,u=new I.LineDecoder;t.stdout.on("data",d=>{o.write(d).forEach(k=>r({line:k,source:0}))}),t.stderr.on("data",d=>{u.write(d).forEach(k=>r({line:k,source:1}))}),this.stdoutLineDecoder=o,this.stderrLineDecoder=u}handleClose(t,s,r,i){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&r({line:a,source:0});const o=this.stderrLineDecoder?this.stderrLineDecoder.end():null;o&&r({line:o,source:1})}}e.LineProcess=v;function p(c){let t=[],s=!1;const r=function(i){if(s){t.push(i);return}(!c.send(i,o=>{if(o&&console.error(o),s=!1,t.length>0){const u=t.slice(0);t=[],u.forEach(d=>r(d))}})||R.isWindows)&&(s=!0)};return{send:r}}e.createQueuedSender=p;var l;(function(c){async function t(s,r,i){if(L.isAbsolute(s))return s;if(r===void 0&&(r=S.cwd()),L.dirname(s)!=="."||(i===void 0&&n.isString(S.env.PATH)&&(i=S.env.PATH.split(L.delimiter)),i===void 0||i.length===0))return L.join(r,s);async function o(u){if(await g.Promises.exists(u)){let d;try{d=await g.Promises.stat(u)}catch(m){m.message.startsWith("EACCES")&&(d=await g.Promises.lstat(u))}return d?!d.isDirectory():!1}return!1}for(let u of i){let d;if(L.isAbsolute(u)?d=L.join(u,s):d=L.join(r,u,s),await o(d))return d;let m=d+".com";if(await o(m)||(m=d+".exe",await o(m)))return m}return L.join(r,s)}c.findExecutable=t})(l=e.win32||(e.win32={}))}),define(te[121],ne([0,1,33,4,69,72]),function(J,e,D,A,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function L(b,h){return b===1?A.isWindows?I():T.getWindowsShell(h):E(b,h)}e.getSystemShell=L;function R(b,h){return b===1?A.isWindows?g(h):T.getWindowsShell(h):E(b,h)}e.getSystemShellSync=R;let S=null;function E(b,h){if(A.isLinux&&b===2||A.isMacintosh&&b===3)return"/bin/bash";if(!S){let y;if(A.isWindows)y="/bin/bash";else{if(y=h.SHELL,!y)try{y=(0,D.userInfo)().shell}catch(f){}y||(y="sh"),y==="/bin/false"&&(y="/bin/bash")}S=y}return S}let n=null;async function I(){return n||(n=(await(0,P.getFirstAvailablePowerShellInstallation)()).exePath),n}function g(b){if(n)return n;const h=A.isWindows&&parseFloat((0,D.release)())>=10,y=b.hasOwnProperty("PROCESSOR_ARCHITEW6432"),f=`${b.windir}\\${y?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?f:T.getWindowsShell(b)}}),define(te[45],ne([0,1,41,5,22,27,101,8,3,2,26,4,72,32]),function(J,e,D,A,P,T,L,R,S,E,n,I,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends b.ChannelServer{constructor(w){super({send:v=>{try{process.send&&process.send(v.buffer.toString("base64"))}catch(p){}},onMessage:S.Event.fromNodeEventEmitter(process,"message",v=>P.VSBuffer.wrap(Buffer.from(v,"base64")))},w);process.once("disconnect",()=>this.dispose())}}e.Server=h;class y{constructor(w,v){this.modulePath=w,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new S.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const p=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new A.Delayer(p),this.child=null,this._client=null}getChannel(w){const v=this;return{call(p,l,c){return v.requestPromise(w,p,l,c)},listen(p,l){return v.requestEvent(w,p,l)}}}requestPromise(w,v,p,l=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(w),t=(0,A.createCancelablePromise)(i=>c.call(v,p,i)),s=l.onCancellationRequested(()=>t.cancel()),r=(0,E.toDisposable)(()=>t.cancel());return this.activeRequests.add(r),t.finally(()=>{s.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(w,v,p){if(!this.disposeDelayer)return S.Event.None;this.disposeDelayer.cancel();let l;const c=new S.Emitter({onFirstListenerAdd:()=>{l=this.getCachedChannel(w).listen(v,p)(c.fire,c),this.activeRequests.add(l)},onLastListenerRemove:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const w=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,n.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),I.isMacintosh&&v.env&&delete v.env.DYLD_LIBRARY_PATH,this.child=(0,D.fork)(this.modulePath,w,v);const p=new S.Emitter;S.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,L.isRemoteConsoleLog)(a)){(0,L.log)(a,`IPC Library: ${this.options.serverName}`);return}p.fire(P.VSBuffer.wrap(Buffer.from(a,"base64")))});const c=this.options.useQueue?(0,g.createQueuedSender)(this.child):this.child,t=a=>this.child&&this.child.connected&&c.send(a.buffer.toString("base64")),s=p.event,r={send:t,onMessage:s};this._client=new b.ChannelClient(r);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,o)=>{process.removeListener("exit",i),this.activeRequests.forEach(u=>(0,E.dispose)(u)),this.activeRequests.clear(),a!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:o})})}return this._client}getCachedChannel(w){let v=this.channels.get(w);return v||(v=this.client.getChannel(w),this.channels.set(w,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=y}),define(te[122],ne([11,12]),function(J,e){return J.create("vs/base/node/zip",e)}),define(te[123],ne([11,12]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[124],ne([11,12]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(te[125],ne([11,12]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(te[126],ne([11,12]),function(J,e){return J.create("vs/platform/environment/node/shellEnv",e)}),define(te[127],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[128],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[129],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[130],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[131],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[132],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[133],ne([11,12]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[134],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(te[135],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(te[136],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(te[137],ne([11,12]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[138],ne([11,12]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(te[139],ne([11,12]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[140],ne([11,12]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[141],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[142],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[143],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[144],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[145],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[146],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[73],ne([0,1,57,66,15,9,31,16,7]),function(J,e,D,A,P,T,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class E{constructor(y,f,w){this._args=y,this.paths=f,this.productService=w}get appRoot(){return(0,T.dirname)(P.FileAccess.asFileUri("",J).fsPath)}get userHome(){return S.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return S.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return S.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const y=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",y)}return this.args.logsPath}get userDataSyncLogResource(){return S.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(S.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return S.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return S.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const y=L.env.VSCODE_PORTABLE;return y?S.URI.file((0,T.join)(y,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return S.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const y=this.args["builtin-extensions-dir"];return y?(0,T.resolve)(y):(0,T.normalize)((0,T.join)(P.FileAccess.asFileUri("",J).fsPath,"..","extensions"))}get extensionsDownloadPath(){const y=this.args["extensions-download-dir"];return y?(0,T.resolve)(y):(0,T.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const y=this.args["extensions-dir"];if(y)return(0,T.resolve)(y);const f=L.env.VSCODE_EXTENSIONS;if(f)return f;const w=L.env.VSCODE_PORTABLE;return w?(0,T.join)(w,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const y=this.args.extensionDevelopmentPath;if(Array.isArray(y))return y.map(f=>/^[^:/?#]+?:\/\//.test(f)?S.URI.parse(f):S.URI.file((0,T.normalize)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(y=>y==="ui"||y==="workspace"||y==="web"?y:"workspace")}get extensionTestsLocationURI(){const y=this.args.extensionTestsPath;if(y)return/^[^:/?#]+?:\/\//.test(y)?S.URI.parse(y):S.URI.file((0,T.normalize)(y))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const y=this.args["disable-extension"];if(y){if(typeof y=="string")return[y];if(Array.isArray(y)&&y.length>0)return y}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(S.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return S.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([A.memoize],E.prototype,"appRoot",null),he([A.memoize],E.prototype,"userHome",null),he([A.memoize],E.prototype,"userDataPath",null),he([A.memoize],E.prototype,"appSettingsHome",null),he([A.memoize],E.prototype,"tmpDir",null),he([A.memoize],E.prototype,"userRoamingDataHome",null),he([A.memoize],E.prototype,"settingsResource",null),he([A.memoize],E.prototype,"userDataSyncHome",null),he([A.memoize],E.prototype,"userDataSyncLogResource",null),he([A.memoize],E.prototype,"sync",null),he([A.memoize],E.prototype,"machineSettingsResource",null),he([A.memoize],E.prototype,"globalStorageHome",null),he([A.memoize],E.prototype,"workspaceStorageHome",null),he([A.memoize],E.prototype,"keybindingsResource",null),he([A.memoize],E.prototype,"keyboardLayoutResource",null),he([A.memoize],E.prototype,"argvResource",null),he([A.memoize],E.prototype,"snippetsHome",null),he([A.memoize],E.prototype,"isExtensionDevelopment",null),he([A.memoize],E.prototype,"untitledWorkspacesHome",null),he([A.memoize],E.prototype,"installSourcePath",null),he([A.memoize],E.prototype,"builtinExtensionsPath",null),he([A.memoize],E.prototype,"extensionsPath",null),he([A.memoize],E.prototype,"extensionDevelopmentLocationURI",null),he([A.memoize],E.prototype,"extensionDevelopmentKind",null),he([A.memoize],E.prototype,"extensionTestsLocationURI",null),he([A.memoize],E.prototype,"debugExtensionHost",null),he([A.memoize],E.prototype,"serviceMachineIdResource",null),he([A.memoize],E.prototype,"telemetryLogResource",null),he([A.memoize],E.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=E;function n(h,y){return b(h["inspect-extensions"],h["inspect-brk-extensions"],5870,y,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=n;function I(h,y){return b(h["inspect-search"],h["inspect-brk-search"],5876,y,h.extensionEnvironment)}e.parseSearchPort=I;function g(h,y){return b(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,y,h.extensionEnvironment)}e.parsePtyHostPort=g;function b(h,y,f,w,v,p){const c=Number(y||h)||(w?null:f),t=c?Boolean(!!y):!1;let s;if(p)try{s=JSON.parse(p)}catch{}return{port:c,break:t,debugId:v,env:s}}}),define(te[147],ne([0,1,236,4,124]),function(J,e,D,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,P.localize)(0,null),e:(0,P.localize)(1,null),t:(0,P.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,P.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,P.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,P.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,P.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,P.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,P.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,P.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,P.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,P.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,P.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,P.localize)(14,null)},category:{type:"string",cat:"e",description:(0,P.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,P.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,P.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,P.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,P.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,P.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,P.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,P.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,P.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,P.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,P.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,P.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,P.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,P.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,P.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,P.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,P.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const L={onUnknownOption:()=>{},onMultipleValues:()=>{}};function R(h,y,f=L){const w={},v=[],p=[];for(let s in y){const r=y[s];r.alias&&(w[s]=r.alias),r.type==="string"||r.type==="string[]"?(v.push(s),r.deprecates&&v.push(r.deprecates)):r.type==="boolean"&&(p.push(s),r.deprecates&&p.push(r.deprecates))}const l=D(h,{string:v,boolean:p,alias:w}),c={},t=l;c._=l._.map(s=>String(s)).filter(s=>s.length>0),delete t._;for(let s in y){const r=y[s];r.alias&&delete t[r.alias];let i=t[s];r.deprecates&&t.hasOwnProperty(r.deprecates)&&(i||(i=t[r.deprecates]),delete t[r.deprecates]),typeof i!="undefined"&&(r.type==="string[]"?i&&!Array.isArray(i)&&(i=[i]):r.type==="string"&&Array.isArray(i)&&(i=i.pop(),f.onMultipleValues(s,i)),c[s]=i),delete t[s]}for(let s in t)f.onUnknownOption(s);return c}e.parseArgs=R;function S(h,y){let f="";return y.args&&(Array.isArray(y.args)?f=` <${y.args.join("> <")}>`:f=` <${y.args}>`),y.alias?`-${y.alias} --${h}${f}`:`--${h}${f}`}function E(h,y){let f=0,w=[];for(const c in h){const t=h[c],s=S(c,t);f=Math.max(f,s.length),w.push([s,t.description])}let v=f+2+1;if(y-v<25)return w.reduce((c,t)=>c.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let p=y-v-1,l=[];for(const c of w){let t=c[0],s=I(c[1],p),r=n(v-t.length-2);l.push("  "+t+r+s[0]);for(let i=1;i<s.length;i++)l.push(n(v)+s[i])}return l}e.formatOptions=E;function n(h){return" ".repeat(h)}function I(h,y){let f=[];for(;h.length;){let w=h.length<y?h.length:h.lastIndexOf(" ",y),v=h.slice(0,w).trim();h=h.slice(w),f.push(v)}return f}function g(h,y,f,w,v=!0){const p=process.stdout.isTTY&&process.stdout.columns||80;let l=[`${h} ${f}`];l.push(""),l.push(`${(0,P.localize)(32,null)}: ${y} [${(0,P.localize)(33,null)}][${(0,P.localize)(34,null)}...]`),l.push(""),v&&(A.isWindows?l.push((0,P.localize)(35,null,y)):l.push((0,P.localize)(36,null,y)),l.push(""));const c={};for(const t in w){const s=w[t];if(s.description&&s.cat){let r=c[s.cat];r||(c[s.cat]=r={}),r[t]=s}}for(let t in c){const s=t;let r=c[s];r&&(l.push(T[s]),l.push(...E(r,p)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=g;function b(h,y){return`${h||(0,P.localize)(37,null)}
${y||(0,P.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=b}),function(){"use strict";function J(e,D,A,P){function T(R){const S=L(R),E=[S];return e.isAbsolute(S)||E.unshift(P),e.resolve(...E)}function L(R){const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,A);const n=R["user-data-dir"];if(n)return n;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(I,"AppData","Roaming")}break;case"darwin":E=e.join(D.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,A)}return{getUserDataPath:T}}if(typeof define=="function")define(te[148],ne([0,237,33,15,16,31]),function(e,D,A,P,T,L){const R=T.dirname(P.FileAccess.asFileUri("",e)),S=e.__$__nodeRequire(T.joinPath(R,"package.json").fsPath);return J(D,A,S.name,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),D=require("path"),A=require("os");module.exports=J(D,A,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[149],ne([0,1,33,73,148]),function(J,e,D,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends A.AbstractNativeEnvironmentService{constructor(R,S){super(R,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,P.getUserDataPath)(R)},S)}}e.NativeEnvironmentService=T}),define(te[150],ne([0,1,7]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const A=/^([^@:]+@)?([^:]+):/,P=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,L=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,S=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function E(f){const w=f.match(L);return w?w[1]:null}function n(f){if(f.indexOf("://")===-1){const w=f.match(A);return w?E(w[2]):null}try{const w=D.URI.parse(f);if(w.authority)return E(w.authority)}catch(w){}return null}function I(f,w){const v=new Set;let p;for(;p=R.exec(f);){const c=n(p[1]);c&&v.add(c)}const l=new Set(w);return Array.from(v).map(c=>l.has(c)?c:c.replace(S,"a"))}e.getDomainsOfRemotes=I;function g(f){const w=f.match(T);return w?w[2]:null}function b(f,w,v){return f&&w?(v&&w.endsWith(".git")&&(w=w.substr(0,w.length-4)),w.indexOf("/")===0?`${f}${w}`:`${f}/${w}`):null}function h(f,w){if(f.indexOf("://")===-1){const v=f.match(P);if(v)return b(v[2],v[3],w)}try{const v=D.URI.parse(f);if(v.authority)return b(g(v.authority),v.path,w)}catch(v){}return null}function y(f,w=!1){const v=[];let p;for(;p=R.exec(f);){const l=h(p[1],w);l&&v.push(l)}return v}e.getRemotes=y}),define(te[151],ne([0,1,26]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const A=/^%([\w\d.-]+)%$/i;function P(T,L){const R=S=>{if(typeof S!="string")return;const E=A.exec(S);if(!E)return;const n=L[E[1]]??S;return typeof n=="string"?n:typeof n.message=="string"?n.message:S};return(0,D.cloneAndChange)(T,R)}e.localizeManifest=P}),define(te[152],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,L,R,S){return this.channel.call("promptImportantExtensionsInstallNotification",[T,L,R,S])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class A{constructor(T){this.service=T}listen(T,L){throw new Error(`Event not found: ${L}`)}call(T,L,R){switch(L){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${L}`)}}e.ExtensionRecommendationNotificationServiceChannel=A}),define(te[74],ne([0,1,133]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function T(g){return g=g.trim(),g==="*"||A.test(g)}e.isValidVersionStr=T;function L(g){if(!T(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=g.match(A);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=L;function R(g){if(!g)return null;let b=g.majorBase,h=g.majorMustEqual,y=g.minorBase,f=g.minorMustEqual,w=g.patchBase,v=g.patchMustEqual;g.hasCaret&&(b===0||(f=!1),v=!1);let p=0;if(g.preRelease){const l=P.exec(g.preRelease);if(l){const[,c,t,s]=l;p=Date.UTC(Number(c),Number(t)-1,Number(s))}}return{majorBase:b,majorMustEqual:h,minorBase:y,minorMustEqual:f,patchBase:w,patchMustEqual:v,isMinimum:g.hasGreaterEquals,notBefore:p}}e.normalizeVersion=R;function S(g,b,h){let y;typeof g=="string"?y=R(L(g)):y=g;let f;b instanceof Date?f=b.getTime():typeof b=="string"&&(f=new Date(b).getTime());let w;if(typeof h=="string"?w=R(L(h)):w=h,!y||!w)return!1;let v=y.majorBase,p=y.minorBase,l=y.patchBase,c=w.majorBase,t=w.minorBase,s=w.patchBase,r=w.notBefore,i=w.majorMustEqual,a=w.minorMustEqual,o=w.patchMustEqual;return w.isMinimum?v>c?!0:v<c?!1:p>t?!0:p<t||f&&f<r?!1:l>=s:(v===1&&c===0&&(!i||!a||!o)&&(c=1,t=0,s=0,i=!0,a=!1,o=!1),v<c?!1:v>c?!i:p<t?!1:p>t?!a:l<s?!1:l>s?!o:!(f&&f<r))}e.isValidVersion=S;function E(g,b,h,y){return h.isBuiltin||typeof h.main=="undefined"?!0:I(g,b,h.engines.vscode,y)}e.isValidExtensionVersion=E;function n(g,b,h){return g==="*"||I(b,h,g)}e.isEngineValid=n;function I(g,b,h,y=[]){let f=R(L(h));if(!f)return y.push(D.localize(0,null,h)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return y.push(D.localize(1,null,h)),!1}else if(!f.majorMustEqual)return y.push(D.localize(2,null,h)),!1;return S(g,b,f)?!0:(y.push(D.localize(3,null,g,h)),!1)}}),define(te[153],ne([0,1,2,15,32,45]),function(J,e,D,A,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class L extends D.Disposable{constructor(S,E,n,I){super();this.requests=S,this.onDidFilesChange=E,this.onLogMessage=n,this.verboseLogging=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const S=this._register(new T.Client(A.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(S.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=L.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=P.ProxyChannel.toService((0,P.getNextTickChannel)(S.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(E=>!this.isDisposed&&this.onDidFilesChange(E))),this._register(this.service.onDidLogMessage(E=>this.onLogMessage(E))),this.watch(this.requests)}setVerboseLogging(S){this.verboseLogging=S,this.isDisposed||this.service?.setVerboseLogging(S)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${S}`})}watch(S){this.requests=S,this.service?.watch(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=L,L.MAX_RESTARTS=5}),define(te[154],ne([0,1,2,15,32,45]),function(J,e,D,A,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class L extends D.Disposable{constructor(S,E,n,I){super();this.requests=S,this.onDidFilesChange=E,this.onLogMessage=n,this.verboseLogging=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const S=this._register(new T.Client(A.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (parcel)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(S.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=L.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=P.ProxyChannel.toService((0,P.getNextTickChannel)(S.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(E=>!this.isDisposed&&this.onDidFilesChange(E))),this._register(this.service.onDidLogMessage(E=>this.onLogMessage(E))),this.watch(this.requests)}setVerboseLogging(S){this.verboseLogging=S,this.isDisposed||this.service?.setVerboseLogging(S)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${S}`})}watch(S){this.requests=S,this.service?.watch(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=L,L.MAX_RESTARTS=5}),define(te[155],ne([0,1,2,15,32,45]),function(J,e,D,A,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class L extends D.Disposable{constructor(S,E,n,I,g={}){super();this.folders=S,this.onDidFilesChange=E,this.onLogMessage=n,this.verboseLogging=I,this.watcherOptions=g,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const S=this._register(new T.Client(A.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(S.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=L.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=P.ProxyChannel.toService((0,P.getNextTickChannel)(S.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(E=>!this.isDisposed&&this.onDidFilesChange(E))),this._register(this.service.onDidLogMessage(E=>this.onLogMessage(E))),this.service.watch(this.folders)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${S}`})}setVerboseLogging(S){this.verboseLogging=S,this.service&&this.service.setVerboseLogging(S)}watch(S){this.folders=S,this.service&&this.service.watch(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=L,L.MAX_RESTARTS=5}),define(te[53],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(P,T=[],L=!1){this.ctor=P,this.staticArguments=T,this.supportsDelayedInstantiation=L}}e.SyncDescriptor=D}),define(te[75],ne([0,1,53]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const A=[];function P(L,R,S){R instanceof D.SyncDescriptor||(R=new D.SyncDescriptor(R,[],S)),A.push([L,R])}e.registerSingleton=P;function T(){return A}e.getSingletonServiceDescriptors=T}),define(te[156],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=D;class A{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let L of this._nodes.values())L.outgoing.size===0&&T.push(L);return T}insertEdge(T,L){const R=this.lookupOrInsertNode(T),S=this.lookupOrInsertNode(L);R.outgoing.set(this._hashFn(L),S),S.incoming.set(this._hashFn(T),R)}removeNode(T){const L=this._hashFn(T);this._nodes.delete(L);for(let R of this._nodes.values())R.outgoing.delete(L),R.incoming.delete(L)}lookupOrInsertNode(T){const L=this._hashFn(T);let R=this._nodes.get(L);return R||(R=new D(T),this._nodes.set(L,R)),R}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[L,R]of this._nodes)T.push(`${L}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,L]of this._nodes){const R=new Set([T]),S=this._findCycle(L,R);if(S)return S}}_findCycle(T,L){for(let[R,S]of T.outgoing){if(L.has(R))return[...L,R].join(" -> ");L.add(R);const E=this._findCycle(S,L);if(E)return E;L.delete(R)}}}e.Graph=A}),define(te[6],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function S(E){return E[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=S})(D=e._util||(e._util={})),e.IInstantiationService=P("instantiationService");function A(R,S,E,n){S[D.DI_TARGET]===S?S[D.DI_DEPENDENCIES].push({id:R,index:E,optional:n}):(S[D.DI_DEPENDENCIES]=[{id:R,index:E,optional:n}],S[D.DI_TARGET]=S)}function P(R){if(D.serviceIds.has(R))return D.serviceIds.get(R);const S=function(E,n,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(S,E,I,!1)};return S.toString=()=>R,D.serviceIds.set(R,S),S}e.createDecorator=P;function T(R){return R}e.refineServiceDecorator=T;function L(R){return function(S,E,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");A(R,S,n,!0)}}e.optional=L}),define(te[157],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(te[158],ne([0,1,4,25,6]),function(J,e,D,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=D.userAgent||"";const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",D.isMacintosh),L.set("isLinux",D.isLinux),L.set("isWindows",D.isWindows),L.set("isWeb",D.isWeb),L.set("isMacNative",D.isMacintosh&&!D.isWeb),L.set("isEdge",T.indexOf("Edg/")>=0),L.set("isFirefox",T.indexOf("Firefox")>=0),L.set("isChrome",T.indexOf("Chrome")>=0),L.set("isSafari",T.indexOf("Safari")>=0);const R=Object.prototype.hasOwnProperty;var S;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return g.INSTANCE}static true(){return b.INSTANCE}static has(C){return h.create(C)}static equals(C,F){return y.create(C,F)}static notEquals(C,F){return v.create(C,F)}static regex(C,F){return r.create(C,F)}static in(C,F){return f.create(C,F)}static not(C){return p.create(C)}static and(...C){return o.create(C,null)}static or(...C){return u.create(C,null,!0)}static greater(C,F){return l.create(C,F)}static less(C,F){return t.create(C,F)}static deserialize(C,F=!1){if(!!C)return this._deserializeOrExpression(C,F)}static _deserializeOrExpression(C,F){let z=C.split("||");return u.create(z.map(U=>this._deserializeAndExpression(U,F)),null,!0)}static _deserializeAndExpression(C,F){let z=C.split("&&");return o.create(z.map(U=>this._deserializeOne(U,F)),null)}static _deserializeOne(C,F){if(C=C.trim(),C.indexOf("!=")>=0){let z=C.split("!=");return v.create(z[0].trim(),this._deserializeValue(z[1],F))}if(C.indexOf("==")>=0){let z=C.split("==");return y.create(z[0].trim(),this._deserializeValue(z[1],F))}if(C.indexOf("=~")>=0){let z=C.split("=~");return r.create(z[0].trim(),this._deserializeRegexValue(z[1],F))}if(C.indexOf(" in ")>=0){let z=C.split(" in ");return f.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(C)){const z=C.split(">=");return c.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(C)){const z=C.split(">");return l.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(C)){const z=C.split("<=");return s.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(C)){const z=C.split("<");return t.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(C)?p.create(C.substr(1).trim()):h.create(C)}static _deserializeValue(C,F){if(C=C.trim(),C==="true")return!0;if(C==="false")return!1;let z=/^'([^']*)'$/.exec(C);return z?z[1].trim():C}static _deserializeRegexValue(C,F){if((0,A.isFalsyOrWhitespace)(C)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let z=C.indexOf("/"),U=C.lastIndexOf("/");if(z===U||z<0){if(F)throw new Error(`bad regexp-value '${C}', missing /-enclosure`);return console.warn(`bad regexp-value '${C}', missing /-enclosure`),null}let j=C.slice(z+1,U),W=C[U+1]==="i"?"i":"";try{return new RegExp(j,W)}catch(x){if(F)throw new Error(`bad regexp-value '${C}', parse error: ${x}`);return console.warn(`bad regexp-value '${C}', parse error: ${x}`),null}}}e.ContextKeyExpr=E;function n(N,C){const F=N?N.substituteConstants():void 0,z=C?C.substituteConstants():void 0;return!F&&!z?!0:!F||!z?!1:F.equals(z)}e.expressionsAreEqualWithConstantSubstitution=n;function I(N,C){return N.cmp(C)}class g{constructor(){this.type=0}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!1}serialize(){return"false"}keys(){return[]}map(C){return this}negate(){return b.INSTANCE}}e.ContextKeyFalseExpr=g,g.INSTANCE=new g;class b{constructor(){this.type=1}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!0}serialize(){return"true"}keys(){return[]}map(C){return this}negate(){return g.INSTANCE}}e.ContextKeyTrueExpr=b,b.INSTANCE=new b;class h{constructor(C,F){this.key=C,this.negated=F,this.type=2}static create(C,F=null){const z=L.get(C);return typeof z=="boolean"?z?b.INSTANCE:g.INSTANCE:new h(C,F)}cmp(C){return C.type!==this.type?this.type-C.type:m(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=L.get(this.key);return typeof C=="boolean"?C?b.INSTANCE:g.INSTANCE:this}evaluate(C){return!!C.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(C){return C.mapDefined(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class y{constructor(C,F,z){this.key=C,this.value=F,this.negated=z,this.type=4}static create(C,F,z=null){if(typeof F=="boolean")return F?h.create(C,z):p.create(C,z);const U=L.get(C);return typeof U=="boolean"?F===(U?"true":"false")?b.INSTANCE:g.INSTANCE:new y(C,F,z)}cmp(C){return C.type!==this.type?this.type-C.type:k(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){const C=L.get(this.key);if(typeof C=="boolean"){const F=C?"true":"false";return this.value===F?b.INSTANCE:g.INSTANCE}return this}evaluate(C){return C.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(C){return C.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=y;class f{constructor(C,F){this.key=C,this.valueKey=F,this.type=10,this.negated=null}static create(C,F){return new f(C,F)}cmp(C){return C.type!==this.type?this.type-C.type:k(this.key,this.valueKey,C.key,C.valueKey)}equals(C){return C.type===this.type?this.key===C.key&&this.valueKey===C.valueKey:!1}substituteConstants(){return this}evaluate(C){const F=C.getValue(this.valueKey),z=C.getValue(this.key);return Array.isArray(F)?F.indexOf(z)>=0:typeof z=="string"&&typeof F=="object"&&F!==null?R.call(F,z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(C){return C.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=w.create(this)),this.negated}}e.ContextKeyInExpr=f;class w{constructor(C){this._actual=C,this.type=11}static create(C){return new w(C)}cmp(C){return C.type!==this.type?this.type-C.type:this._actual.cmp(C._actual)}equals(C){return C.type===this.type?this._actual.equals(C._actual):!1}substituteConstants(){return this}evaluate(C){return!this._actual.evaluate(C)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(C){return new w(this._actual.map(C))}negate(){return this._actual}}e.ContextKeyNotInExpr=w;class v{constructor(C,F,z){this.key=C,this.value=F,this.negated=z,this.type=5}static create(C,F,z=null){if(typeof F=="boolean")return F?p.create(C,z):h.create(C,z);const U=L.get(C);return typeof U=="boolean"?F===(U?"true":"false")?g.INSTANCE:b.INSTANCE:new v(C,F,z)}cmp(C){return C.type!==this.type?this.type-C.type:k(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){const C=L.get(this.key);if(typeof C=="boolean"){const F=C?"true":"false";return this.value===F?g.INSTANCE:b.INSTANCE}return this}evaluate(C){return C.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(C){return C.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=v;class p{constructor(C,F){this.key=C,this.negated=F,this.type=3}static create(C,F=null){const z=L.get(C);return typeof z=="boolean"?z?g.INSTANCE:b.INSTANCE:new p(C,F)}cmp(C){return C.type!==this.type?this.type-C.type:m(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=L.get(this.key);return typeof C=="boolean"?C?g.INSTANCE:b.INSTANCE:this}evaluate(C){return!C.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(C){return C.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=p;class l{constructor(C,F,z){this.key=C,this.value=F,this.negated=z,this.type=12}static create(C,F,z=null){return new l(C,F,z)}cmp(C){return C.type!==this.type?this.type-C.type:k(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return parseFloat(C.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(C){return C.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class c{constructor(C,F,z){this.key=C,this.value=F,this.negated=z,this.type=13}static create(C,F,z=null){return new c(C,F,z)}cmp(C){return C.type!==this.type?this.type-C.type:k(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return parseFloat(C.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(C){return C.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=c;class t{constructor(C,F,z){this.key=C,this.value=F,this.negated=z,this.type=14}static create(C,F,z=null){return new t(C,F,z)}cmp(C){return C.type!==this.type?this.type-C.type:k(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return parseFloat(C.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(C){return C.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=t;class s{constructor(C,F,z){this.key=C,this.value=F,this.negated=z,this.type=15}static create(C,F,z=null){return new s(C,F,z)}cmp(C){return C.type!==this.type?this.type-C.type:k(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return parseFloat(C.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(C){return C.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=s;class r{constructor(C,F){this.key=C,this.regexp=F,this.type=7,this.negated=null}static create(C,F){return new r(C,F)}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.key<C.key)return-1;if(this.key>C.key)return 1;const F=this.regexp?this.regexp.source:"",z=C.regexp?C.regexp.source:"";return F<z?-1:F>z?1:0}equals(C){if(C.type===this.type){const F=this.regexp?this.regexp.source:"",z=C.regexp?C.regexp.source:"";return this.key===C.key&&F===z}return!1}substituteConstants(){return this}evaluate(C){let F=C.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const C=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${C}`}keys(){return[this.key]}map(C){return C.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class i{constructor(C){this._actual=C,this.type=8}static create(C){return new i(C)}cmp(C){return C.type!==this.type?this.type-C.type:this._actual.cmp(C._actual)}equals(C){return C.type===this.type?this._actual.equals(C._actual):!1}substituteConstants(){return this}evaluate(C){return!this._actual.evaluate(C)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(C){return new i(this._actual.map(C))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function a(N){let C=null;for(let F=0,z=N.length;F<z;F++){const U=N[F].substituteConstants();if(N[F]!==U&&C===null){C=[];for(let j=0;j<F;j++)C[j]=N[j]}C!==null&&(C[F]=U)}return C===null?N:C}class o{constructor(C,F){this.expr=C,this.negated=F,this.type=6}static create(C,F){return o._normalizeArr(C,F)}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let F=0,z=this.expr.length;F<z;F++){const U=I(this.expr[F],C.expr[F]);if(U!==0)return U}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let F=0,z=this.expr.length;F<z;F++)if(!this.expr[F].equals(C.expr[F]))return!1;return!0}return!1}substituteConstants(){const C=a(this.expr);return C===this.expr?this:o.create(C,this.negated)}evaluate(C){for(let F=0,z=this.expr.length;F<z;F++)if(!this.expr[F].evaluate(C))return!1;return!0}static _normalizeArr(C,F){const z=[];let U=!1;for(const j of C)if(!!j){if(j.type===1){U=!0;continue}if(j.type===0)return g.INSTANCE;if(j.type===6){z.push(...j.expr);continue}z.push(j)}if(z.length===0&&U)return b.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(I);for(let j=1;j<z.length;j++)z[j-1].equals(z[j])&&(z.splice(j,1),j--);if(z.length===1)return z[0];for(;z.length>1;){const j=z[z.length-1];if(j.type!==9)break;z.pop();const W=z.pop(),x=z.length===0,q=u.create(j.expr.map($=>o.create([$,W],null)),null,x);q&&(z.push(q),z.sort(I))}return z.length===1?z[0]:new o(z,F)}}serialize(){return this.expr.map(C=>C.serialize()).join(" && ")}keys(){const C=[];for(let F of this.expr)C.push(...F.keys());return C}map(C){return new o(this.expr.map(F=>F.map(C)),null)}negate(){if(!this.negated){const C=[];for(let F of this.expr)C.push(F.negate());this.negated=u.create(C,this,!0)}return this.negated}}class u{constructor(C,F){this.expr=C,this.negated=F,this.type=9}static create(C,F,z){return u._normalizeArr(C,F,z)}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let F=0,z=this.expr.length;F<z;F++){const U=I(this.expr[F],C.expr[F]);if(U!==0)return U}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let F=0,z=this.expr.length;F<z;F++)if(!this.expr[F].equals(C.expr[F]))return!1;return!0}return!1}substituteConstants(){const C=a(this.expr);return C===this.expr?this:u.create(C,this.negated,!1)}evaluate(C){for(let F=0,z=this.expr.length;F<z;F++)if(this.expr[F].evaluate(C))return!0;return!1}static _normalizeArr(C,F,z){let U=[],j=!1;if(C){for(let W=0,x=C.length;W<x;W++){const q=C[W];if(!!q){if(q.type===0){j=!0;continue}if(q.type===1)return b.INSTANCE;if(q.type===9){U=U.concat(q.expr);continue}U.push(q)}}if(U.length===0&&j)return g.INSTANCE;U.sort(I)}if(U.length!==0){if(U.length===1)return U[0];for(let W=1;W<U.length;W++)U[W-1].equals(U[W])&&(U.splice(W,1),W--);if(U.length===1)return U[0];if(z){for(let W=0;W<U.length;W++)for(let x=W+1;x<U.length;x++)_(U[W],U[x])&&(U.splice(x,1),x--);if(U.length===1)return U[0]}return new u(U,F)}}serialize(){return this.expr.map(C=>C.serialize()).join(" || ")}keys(){const C=[];for(let F of this.expr)C.push(...F.keys());return C}map(C){return new u(this.expr.map(F=>F.map(C)),null)}negate(){if(!this.negated){let C=[];for(let F of this.expr)C.push(F.negate());for(;C.length>1;){const F=C.shift(),z=C.shift(),U=[];for(const W of O(F))for(const x of O(z))U.push(o.create([W,x],null));const j=C.length===0;C.unshift(u.create(U,null,j))}this.negated=C[0]}return this.negated}}class d extends h{constructor(C,F,z){super(C,null);this._defaultValue=F,typeof z=="object"?d._info.push({...z,key:C}):z!==!0&&d._info.push({key:C,description:z,type:F!=null?typeof F:void 0})}static all(){return d._info.values()}bindTo(C){return C.createKey(this.key,this._defaultValue)}getValue(C){return C.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(C){return y.create(this.key,C)}notEqualsTo(C){return v.create(this.key,C)}}e.RawContextKey=d,d._info=[],e.IContextKeyService=(0,P.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(N,C){return N<C?-1:N>C?1:0}function k(N,C,F,z){return N<F?-1:N>F?1:C<z?-1:C>z?1:0}function _(N,C){if(C.type===6&&N.type!==9&&N.type!==6){for(const U of C.expr)if(N.equals(U))return!0}const F=N.negate(),z=O(F).concat(O(C));z.sort(I);for(let U=0;U<z.length;U++){const W=z[U].negate();for(let x=U+1;x<z.length;x++){const q=z[x];if(W.equals(q))return!0}}return!1}e.implies=_;function O(N){return N.type===9?N.expr:[N]}}),define(te[76],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function A(P){return!!P.hostName&&!!P.errorMessage}e.isRemoteDiagnosticError=A}),define(te[77],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(te[13],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(te[28],ne([0,1,15,128,6]),function(J,e,D,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var T;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(T=e.TargetPlatform||(e.TargetPlatform={}));function L(v){switch(v){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=L;function R(v){switch(v){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function S(v,p){switch(v){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=S;function E(v,p){return p==="web"&&!v.includes("web")}e.isNotWebExtensionInWebTargetPlatform=E;function n(v,p,l){return E(p,l)?!1:v==="undefined"||v==="universal"?!0:v==="unknown"?!1:v===l?!0:I(l).includes(v)}e.isTargetPlatformCompatible=n;function I(v){switch(v){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function g(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=g;var b;(function(v){v[v.NoneOrRelevance=0]="NoneOrRelevance",v[v.LastUpdatedDate=1]="LastUpdatedDate",v[v.Title=2]="Title",v[v.PublisherName=3]="PublisherName",v[v.InstallCount=4]="InstallCount",v[v.PublishedDate=10]="PublishedDate",v[v.AverageRating=6]="AverageRating",v[v.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var h;(function(v){v[v.Default=0]="Default",v[v.Ascending=1]="Ascending",v[v.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var y;(function(v){v.Install="install",v.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var f;(function(v){v[v.None=0]="None",v[v.Install=1]="Install",v[v.Update=2]="Update"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,P.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class w extends Error{constructor(p,l){super(p);this.code=l,this.name=l}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,P.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,P.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,P.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,A.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,A.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,P.createDecorator)("IExtensionManagementCLIService")});var X=this&&this.__param||function(J,e){return function(D,A){e(D,A,J)}};define(te[159],ne([0,1,2,28]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let P=class extends D.Disposable{constructor(L){super();this.extensionManagementService=L,this._register(L),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};P=he([X(0,A.IExtensionManagementService)],P),e.DeprecatedExtensionsCleaner=P}),define(te[160],ne([0,1,3,2,26,7,105,28]),function(J,e,D,A,P,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function S(y,f){return T.URI.revive(f?f.transformIncoming(y):y)}function E(y,f){return f?f.transformOutgoingURI(y):y}function n(y,f){f=f||L.DefaultURITransformer;const w=y.manifest;return{...(0,L.transformAndReviveIncomingURIs)({...y,manifest:void 0},f),manifest:w}}function I(y,f){return f?(0,P.cloneAndChange)(y,w=>w instanceof T.URI?f.transformOutgoingURI(w):void 0):y}class g{constructor(f,w){this.service=f,this.getUriTransformer=w,this.onInstallExtension=D.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(f.onDidUninstallExtension,!0)}listen(f,w){const v=this.getUriTransformer(f);switch(w){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,p=>p.map(l=>({...l,local:l.local?I(l.local,v):l.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(f,w,v){const p=this.getUriTransformer(f);switch(w){case"zip":return this.service.zip(n(v[0],p)).then(l=>E(l,p));case"unzip":return this.service.unzip(S(v[0],p));case"install":return this.service.install(S(v[0],p),v[1]);case"getManifest":return this.service.getManifest(S(v[0],p));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(v[0]);case"installFromGallery":return this.service.installFromGallery(v[0],v[1]);case"uninstall":return this.service.uninstall(n(v[0],p),v[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(n(v[0],p));case"getInstalled":return this.service.getInstalled(v[0]).then(l=>l.map(c=>I(c,p)));case"updateMetadata":return this.service.updateMetadata(n(v[0],p),v[1]).then(l=>I(l,p));case"updateExtensionScope":return this.service.updateExtensionScope(n(v[0],p),v[1]).then(l=>I(l,p));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=g;class b extends A.Disposable{constructor(f){super();this.channel=f,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(w=>this._onInstallExtension.fire({identifier:w.identifier,source:this.isUriComponents(w.source)?T.URI.revive(w.source):w.source}))),this._register(this.channel.listen("onDidInstallExtensions")(w=>this._onDidInstallExtensions.fire(w.map(v=>({...v,local:v.local?n(v.local,null):v.local,source:this.isUriComponents(v.source)?T.URI.revive(v.source):v.source}))))),this._register(this.channel.listen("onUninstallExtension")(w=>this._onUninstallExtension.fire(w))),this._register(this.channel.listen("onDidUninstallExtension")(w=>this._onDidUninstallExtension.fire(w)))}isUriComponents(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(f){const w=await this.getTargetPlatform();return f.allTargetPlatforms.some(v=>(0,R.isTargetPlatformCompatible)(v,f.allTargetPlatforms,w))}zip(f){return Promise.resolve(this.channel.call("zip",[f]).then(w=>T.URI.revive(w)))}unzip(f){return Promise.resolve(this.channel.call("unzip",[f]))}install(f,w){return Promise.resolve(this.channel.call("install",[f,w])).then(v=>n(v,null))}getManifest(f){return Promise.resolve(this.channel.call("getManifest",[f]))}installFromGallery(f,w){return Promise.resolve(this.channel.call("installFromGallery",[f,w])).then(v=>n(v,null))}uninstall(f,w){return Promise.resolve(this.channel.call("uninstall",[f,w]))}reinstallFromGallery(f){return Promise.resolve(this.channel.call("reinstallFromGallery",[f]))}getInstalled(f=null){return Promise.resolve(this.channel.call("getInstalled",[f])).then(w=>w.map(v=>n(v,null)))}updateMetadata(f,w){return Promise.resolve(this.channel.call("updateMetadata",[f,w])).then(v=>n(v,null))}updateExtensionScope(f,w){return Promise.resolve(this.channel.call("updateExtensionScope",[f,w])).then(v=>n(v,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=b;class h{constructor(f){this.service=f}listen(f,w){throw new Error("Invalid listen")}call(f,w,v){switch(w){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(v[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=h}),define(te[78],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var A;(function(L){L[L.FILE=1]="FILE",L[L.WORKSPACE=2]="WORKSPACE",L[L.EXE=3]="EXE"})(A=e.RecommendationSource||(e.RecommendationSource={}));function P(L){switch(L){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=P;var T;(function(L){L.Ignored="ignored",L.Cancelled="cancelled",L.TooMany="toomany",L.IncompatibleWindow="incompatibleWindow",L.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[79],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,D.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(te[14],ne([0,1,40,9,25,18,7,135,6]),function(J,e,D,A,P,T,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function E(U){return U.create===!0}e.isFileOpenForWriteOptions=E;var n;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var I;(function(U){U[U.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var g;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=b;function h(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=h;function y(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=y;function f(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=f;var w;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(j,W){super(j);this.code=W}}e.FileSystemProviderError=v;function p(U,j){const W=new v(U.toString(),j);return c(W,j),W}e.createFileSystemProviderError=p;function l(U){return U||p((0,R.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=l;function c(U,j){return U.name=j?`${j} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=c;function t(U){if(!U)return w.Unknown;if(U instanceof v)return U.code;const j=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!j)return w.Unknown;switch(j[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=t;function s(U){if(U instanceof d)return U.fileOperationResult;switch(t(U)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var r;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class i{constructor(j,W,x){this.resource=j,this.operation=W,this.target=x}isOperation(j){return this.operation===j}}e.FileOperationEvent=i;var a;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class o{constructor(j,W){this.added=void 0,this.updated=void 0,this.deleted=void 0;const x=new Map;for(const q of j){const $=x.get(q.type);$?$.push([q.resource,q]):x.set(q.type,[[q.resource,q]])}for(const[q,$]of x)switch(q){case 1:this.added=D.TernarySearchTree.forUris(()=>W),this.added.fill($);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>W),this.updated.fill($);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>W),this.deleted.fill($);break}}contains(j,...W){return this.doContains(j,{includeChildren:!1},...W)}affects(j,...W){return this.doContains(j,{includeChildren:!0},...W)}doContains(j,W,...x){if(!j)return!1;const q=x.length>0;return!!((!q||x.includes(1))&&(this.added?.get(j)||W.includeChildren&&this.added?.findSuperstr(j))||(!q||x.includes(0))&&(this.updated?.get(j)||W.includeChildren&&this.updated?.findSuperstr(j))||(!q||x.includes(2))&&(this.deleted?.findSubstr(j)||W.includeChildren&&this.deleted?.findSuperstr(j)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=o;function u(U,j,W){return!U||!j||U===j||j.length>U.length?!1:(j.charAt(j.length-1)!==A.sep&&(j+=A.sep),W?(0,P.startsWithIgnoreCase)(U,j):U.indexOf(j)===0)}e.isParent=u;class d extends Error{constructor(j,W,x){super(j);this.fileOperationResult=W,this.options=x}}e.FileOperationError=d;class m extends d{constructor(j,W,x){super(j,2,x);this.stat=W}}e.NotModifiedSinceFileOperationError=m;var k;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(k=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var _;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(_=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=O;async function N(U,j){if(!j.hasProvider(L.URI.from({scheme:U.scheme})))return new Promise(W=>{const x=j.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===U.scheme&&q.added&&(x.dispose(),W())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class C{static formatSize(j){return(0,T.isNumber)(j)||(j=0),j<C.KB?(0,R.localize)(1,null,j.toFixed(0)):j<C.MB?(0,R.localize)(2,null,(j/C.KB).toFixed(2)):j<C.GB?(0,R.localize)(3,null,(j/C.MB).toFixed(2)):j<C.TB?(0,R.localize)(4,null,(j/C.GB).toFixed(2)):(0,R.localize)(5,null,(j/C.TB).toFixed(2))}}e.ByteSize=C,C.KB=1024,C.MB=C.KB*C.KB,C.GB=C.MB*C.KB,C.TB=C.GB*C.KB;var F;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function z(U){return{maxFileSize:U===0?300*C.MB:16*C.GB,maxHeapSize:U===0?700*C.MB:2*700*C.MB}}e.getPlatformLimits=z}),define(te[161],ne([0,1,80,51,14]),function(J,e,D,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(R){this.fileService=R}async checksum(R){const S=(await this.fileService.readFileStream(R)).value;return new Promise((E,n)=>{const I=(0,D.createHash)("md5");(0,A.listenStream)(S,{onData:g=>I.update(g.buffer),onError:g=>n(g),onEnd:()=>E(I.digest("base64").replace(/=+$/,""))})})}};T=he([X(0,P.IFileService)],T),e.ChecksumService=T}),define(te[162],ne([0,1,238,125,147,14]),function(J,e,D,A,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function L(g,b){const h={onUnknownOption:f=>{console.warn((0,A.localize)(0,null,f))},onMultipleValues:(f,w)=>{console.warn((0,A.localize)(1,null,f,w))}},y=(0,P.parseArgs)(g,P.OPTIONS,b?h:void 0);return y.goto&&y._.forEach(f=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(f),(0,A.localize)(2,null))),y["max-memory"]&&D(parseInt(y["max-memory"])>=T.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${T.MIN_MAX_MEMORY_SIZE_MB} MB.`),y}function R(g){const b=g.findIndex(h=>!/^-/.test(h));if(b>-1)return[...g.slice(0,b),...g.slice(b+1)]}function S(g){let[,...b]=g;process.env.VSCODE_DEV&&(b=R(b)||[]);const h=!I(process.env);return L(b,h)}e.parseMainProcessArgv=S;function E(g){const[,,...b]=g;return L(b,!0)}e.parseCLIProcessArgv=E;function n(g,...b){const h=g.indexOf("--");return h===-1?g.push(...b):g.splice(h,0,...b),g}e.addArg=n;function I(g){return g.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),define(te[163],ne([0,1,41,9,126,27,37,8,4,30,121,162,5]),function(J,e,D,A,P,T,L,R,S,E,n,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;const b=1e4;let h;async function y(w,v,p){return v["force-disable-user-env"]?(w.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):S.isWindows?(w.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(p)&&!v["force-user-env"]?(w.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(p)?w.trace("resolveShellEnv(): running (--force-user-env)"):w.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=g.Promises.withAsyncBody(async(l,c)=>{const t=new T.CancellationTokenSource,s=setTimeout(()=>{t.dispose(!0),c(new Error((0,P.localize)(0,null)))},b);try{l(await f(w,t.token))}catch(r){!(0,R.isPromiseCanceledError)(r)&&!t.token.isCancellationRequested?c(new Error((0,P.localize)(1,null,(0,L.toErrorMessage)(r)))):l({})}finally{clearTimeout(s),t.dispose()}})),h)}e.resolveShellEnv=y;async function f(w,v){const p=process.env.ELECTRON_RUN_AS_NODE;w.trace("getUnixShellEnvironment#runAsNode",p);const l=process.env.ELECTRON_NO_ATTACH_CONSOLE;w.trace("getUnixShellEnvironment#noAttach",l);const c=(0,E.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(c+"(.*)"+c),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};w.trace("getUnixShellEnvironment#env",s);const r=await(0,n.getSystemShell)(S.OS,s);return w.trace("getUnixShellEnvironment#shell",r),new Promise((i,a)=>{if(v.isCancellationRequested)return a((0,R.canceled)());const o=(0,A.basename)(r);let u,d;/^pwsh(-preview)?$/.test(o)?(u=`& '${process.execPath}' -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,d=["-Login","-Command"]):(u=`'${process.execPath}' -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,d=["-ilc"]),w.trace("getUnixShellEnvironment#spawn",JSON.stringify(d),u);const m=(0,D.spawn)(r,[...d,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});v.onCancellationRequested(()=>(m.kill(),a((0,R.canceled)()))),m.on("error",O=>{w.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(O)),a(O)});const k=[];m.stdout.on("data",O=>k.push(O));const _=[];m.stderr.on("data",O=>_.push(O)),m.on("close",(O,N)=>{const C=Buffer.concat(k).toString("utf8");w.trace("getUnixShellEnvironment#raw",C);const F=Buffer.concat(_).toString("utf8");if(F.trim()&&w.trace("getUnixShellEnvironment#stderr",F),O||N)return a(new Error((0,P.localize)(2,null,O,N)));const z=t.exec(C),U=z?z[1]:"{}";try{const j=JSON.parse(U);p?j.ELECTRON_RUN_AS_NODE=p:delete j.ELECTRON_RUN_AS_NODE,l?j.ELECTRON_NO_ATTACH_CONSOLE=l:delete j.ELECTRON_NO_ATTACH_CONSOLE,delete j.XDG_RUNTIME_DIR,w.trace("getUnixShellEnvironment#result",j),i(j)}catch(j){w.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(j)),a(j)}})})}}),define(te[81],ne([0,1,4,7,14]),function(J,e,D,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function T(S){return S.map(E=>({type:E.type,resource:A.URI.file(E.path)}))}e.toFileChanges=T;function L(S){const E=new R;for(const n of S)E.processEvent(n);return E.normalize()}e.normalizeFileChanges=L;class R{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(E){return D.isLinux?E.path:E.path.toLowerCase()}processEvent(E){const n=this.mapPathToChange.get(this.toKey(E));let I=!1;if(n){const g=n.type,b=E.type;n.path!==E.path&&E.type===2?I=!0:g===1&&b===2?(this.mapPathToChange.delete(this.toKey(E)),this.normalized.delete(n)):g===2&&b===1?n.type=0:g===1&&b===0||(n.type=b)}else I=!0;I&&(this.normalized.add(E),this.mapPathToChange.set(this.toKey(E),E))}normalize(){const E=[],n=[];return Array.from(this.normalized).filter(I=>I.type!==2?(E.push(I),!1):!0).sort((I,g)=>I.path.length-g.path.length).filter(I=>n.some(g=>(0,P.isParent)(I.path,g,!D.isLinux))?!1:(n.push(I.path),!0)).concat(E)}}}),define(te[164],ne([0,1,5,2,9,110,19,113,81]),function(J,e,D,A,P,T,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends A.Disposable{constructor(I,g,b,h){super();this.path=I,this.onDidFilesChange=g,this.onLogMessage=b,this.verboseLogging=h,this.fileChangesDelayer=this._register(new D.ThrottledDelayer(R.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:g}=await L.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let b=this.path;if(g)try{b=await(0,T.realpath)(b)}catch(h){if(this.onError(h),g.dangling)return}I.isDirectory()?this._register((0,R.watchFolder)(b,(h,y)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,P.join)(this.path,(0,P.basename)(y))})},h=>this.onError(h))):this._register((0,R.watchFile)(b,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const b=(0,S.normalizeFileChanges)(g);if(this.verboseLogging)for(const h of b)this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);b.length>0&&this.onDidFilesChange(b)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E}),define(te[82],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...P){this._entries=new Map;for(let[T,L]of P)this.set(T,L)}set(P,T){const L=this._entries.get(P);return this._entries.set(P,T),L}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}e.ServiceCollection=D}),define(te[165],ne([0,1,5,8,53,156,6,82]),function(J,e,D,A,P,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class E extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class n{constructor(h=new R.ServiceCollection,y=!1,f){this._activeInstantiations=new Set,this._services=h,this._strict=y,this._parent=f,this._services.set(L.IInstantiationService,this)}createChild(h){return new n(h,this._strict,this)}invokeFunction(h,...y){let f=g.traceInvocation(h),w=!1;try{return h({get:(p,l)=>{if(w)throw(0,A.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(p,f);if(!c&&l!==L.optional)throw new Error(`[invokeFunction] unknown service '${p}'`);return c}},...y)}finally{w=!0,f.stop()}}createInstance(h,...y){let f,w;return h instanceof P.SyncDescriptor?(f=g.traceCreation(h.ctor),w=this._createInstance(h.ctor,h.staticArguments.concat(y),f)):(f=g.traceCreation(h),w=this._createInstance(h,y,f)),f.stop(),w}_createInstance(h,y=[],f){let w=L._util.getServiceDependencies(h).sort((l,c)=>l.index-c.index),v=[];for(const l of w){let c=this._getOrCreateServiceInstance(l.id,f);if(!c&&this._strict&&!l.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${l.id}.`);v.push(c)}let p=w.length>0?w[0].index:y.length;if(y.length!==p){console.warn(`[createInstance] First service dependency of ${h.name} at position ${p+1} conflicts with ${y.length} static arguments`);let l=p-y.length;l>0?y=y.concat(new Array(l)):y=y.slice(0,p)}return new h(...[...y,...v])}_setServiceInstance(h,y){if(this._services.get(h)instanceof P.SyncDescriptor)this._services.set(h,y);else if(this._parent)this._parent._setServiceInstance(h,y);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let y=this._services.get(h);return!y&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):y}_getOrCreateServiceInstance(h,y){let f=this._getServiceInstanceOrDescriptor(h);return f instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,f,y.branch(h,!0)):(y.branch(h,!1),f)}_safeCreateAndCacheServiceInstance(h,y,f){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,y,f)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,y,f){const w=new T.Graph(l=>l.id.toString());let v=0;const p=[{id:h,desc:y,_trace:f}];for(;p.length;){const l=p.pop();if(w.lookupOrInsertNode(l),v++>1e3)throw new E(w);for(let c of L._util.getServiceDependencies(l.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(c.id);if(!t&&!c.optional&&console.warn(`[createInstance] ${h} depends on ${c.id} which is NOT registered.`),t instanceof P.SyncDescriptor){const s={id:c.id,desc:t,_trace:l._trace.branch(c.id,!0)};w.insertEdge(l,s),p.push(s)}}}for(;;){const l=w.roots();if(l.length===0){if(!w.isEmpty())throw new E(w);break}for(const{data:c}of l){if(this._getServiceInstanceOrDescriptor(c.id)instanceof P.SyncDescriptor){const s=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,s)}w.removeNode(c)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,y,f=[],w,v){if(this._services.get(h)instanceof P.SyncDescriptor)return this._createServiceInstance(y,f,w,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,y,f,w,v);throw new Error(`illegalState - creating UNKNOWN service instance ${y.name}`)}_createServiceInstance(h,y=[],f,w){if(f){const v=new D.IdleValue(()=>this._createInstance(h,y,w));return new Proxy(Object.create(null),{get(p,l){if(l in p)return p[l];let c=v.value,t=c[l];return typeof t!="function"||(t=t.bind(c),p[l]=t),t},set(p,l,c){return v.value[l]=c,!0}})}else return this._createInstance(h,y,w)}}e.InstantiationService=n;var I;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(I||(I={}));class g{constructor(h,y){this.type=h,this.name=y,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return S?new g(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(h){return S?new g(0,h.name):g._None}branch(h,y){let f=new g(2,h.toString());return this._dep.push([h,y,f]),f}stop(){let h=Date.now()-this._start;g._totals+=h;let y=!1;function f(v,p){let l=[],c=new Array(v+1).join("	");for(const[t,s,r]of p._dep)if(s&&r){y=!0,l.push(`${c}CREATES -> ${t}`);let i=f(v+1,r);i&&l.push(i)}else l.push(`${c}uses -> ${t}`);return l.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(h>2||y)&&console.log(w.join(`
`))}}g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(te[166],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(P,T){this.server=P,this.router=T}getChannel(P){return this.server.getChannel(P,this.router)}registerChannel(P,T){this.server.registerChannel(P,T)}}e.MessagePortMainProcessService=D}),define(te[167],ne([0,1,32,53,75,6]),function(J,e,D,A,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class L{constructor(b,h,y){const f=y.getChannel(b);return R(h)?new h.channelClientCtor(f):D.ProxyChannel.toService(f,h?.proxyOptions)}}function R(g){return!!g?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let S=class extends L{constructor(b,h,y){super(b,h,y)}};S=he([X(2,e.IMainProcessService)],S);function E(g,b,h){(0,P.registerSingleton)(g,new A.SyncDescriptor(S,[b,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=E,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let n=class extends L{constructor(b,h,y){super(b,h,y)}};n=he([X(2,e.ISharedProcessService)],n);function I(g,b,h){(0,P.registerSingleton)(g,new A.SyncDescriptor(n,[b,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=I}),define(te[58],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,D.createDecorator)("localizationsService");function A(P){if(typeof P.languageId!="string"||!Array.isArray(P.translations)||P.translations.length===0)return!1;for(const T of P.translations)if(typeof T.id!="string"||typeof T.path!="string")return!1;return!(P.languageName&&typeof P.languageName!="string"||P.localizedLanguageName&&typeof P.localizedLanguageName!="string")}e.isValidLocalization=A}),define(te[168],ne([0,1,2,58]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let P=class extends D.Disposable{constructor(L){super();this.localizationsService=L,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};P=he([X(0,A.ILocalizationsService)],P),e.LocalizationsUpdater=P}),define(te[10],ne([0,1,37,3,2,4,6]),function(J,e,D,A,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,L.createDecorator)("logService"),e.ILoggerService=(0,L.createDecorator)("loggerService");function R(){return new Date().toISOString()}var S;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class E extends P.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class n extends E{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...s){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([t,...s]))}debug(t,...s){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([t,...s]))}info(t,...s){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([t,...s]))}warn(t,...s){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([t,...s]))}error(t,...s){if(this.checkLogLevel(S.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(S.Error,this.format(r))}else this.log(S.Error,this.format([t,...s]))}critical(t,...s){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([t,...s]))}flush(){}format(t){let s="";for(let r=0;r<t.length;r++){let i=t[r];if(typeof i=="object")try{i=JSON.stringify(i)}catch(a){}s+=(r>0?" ":"")+i}return s}}e.AbstractMessageLogger=n;class I extends E{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!T.isWindows}trace(t,...s){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,t,...s):console.log(`[main ${R()}]`,t,...s))}debug(t,...s){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,t,...s):console.log(`[main ${R()}]`,t,...s))}info(t,...s){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,t,...s):console.log(`[main ${R()}]`,t,...s))}warn(t,...s){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,t,...s):console.warn(`[main ${R()}]`,t,...s))}error(t,...s){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,t,...s):console.error(`[main ${R()}]`,t,...s))}critical(t,...s){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,t,...s):console.error(`[main ${R()}]`,t,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class g extends E{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...s){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",t,...s)}debug(t,...s){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...s)}info(t,...s){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",t,...s)}warn(t,...s){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",t,...s)}error(t,...s){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",t,...s)}critical(t,...s){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...s)}dispose(){}flush(){}}e.ConsoleLogger=g;class b extends E{constructor(t,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(s)}trace(t,...s){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(t),...s])}debug(t,...s){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(t),...s])}info(t,...s){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(t),...s])}warn(t,...s){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(t),...s])}error(t,...s){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(t),...s])}critical(t,...s){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(t),...s])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=b;class h extends E{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const s of this.logServices)s.setLevel(t);super.setLevel(t)}trace(t,...s){for(const r of this.logServices)r.trace(t,...s)}debug(t,...s){for(const r of this.logServices)r.debug(t,...s)}info(t,...s){for(const r of this.logServices)r.info(t,...s)}warn(t,...s){for(const r of this.logServices)r.warn(t,...s)}error(t,...s){for(const r of this.logServices)r.error(t,...s)}critical(t,...s){for(const r of this.logServices)r.critical(t,...s)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=h;class y extends P.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...s){this.logger.trace(t,...s)}debug(t,...s){this.logger.debug(t,...s)}info(t,...s){this.logger.info(t,...s)}warn(t,...s){this.logger.warn(t,...s)}error(t,...s){this.logger.error(t,...s)}critical(t,...s){this.logger.critical(t,...s)}flush(){this.logger.flush()}}e.LogService=y;class f extends P.Disposable{constructor(t,s){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(r))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,s){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,s?.always?S.Trace:this.logLevel,s),this.loggers.set(t.toString(),r),s?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=f;class w{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(t){}getLevel(){return S.Info}trace(t,...s){}debug(t,...s){}info(t,...s){}warn(t,...s){}error(t,...s){}critical(t,...s){}dispose(){}flush(){}}e.NullLogService=w;function v(c){if(c.verbose)return S.Trace;if(typeof c.logLevel=="string"){const t=p(c.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=v;function p(c){switch(c){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=p;function l(c){switch(c){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=l}),define(te[169],ne([0,1,5,8,2,9,19,13,10]),function(J,e,D,A,P,T,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let E=class extends P.Disposable{constructor(I,g){super();this.environmentService=I,this.logService=g,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.info("[logs cleanup]: Starting to clean up old logs.");try{const I=(0,T.basename)(this.environmentService.logsPath),g=(0,T.dirname)(this.environmentService.logsPath),y=(await L.Promises.readdir(g)).filter(w=>/^\d{8}T\d{6}$/.test(w)).sort().filter(w=>w!==I),f=y.slice(0,Math.max(0,y.length-9));f.length>0&&(this.logService.info(`[logs cleanup]: Removing log folders '${f.join(", ")}'`),await Promise.all(f.map(w=>L.Promises.rm((0,T.join)(g,w)))))}catch(I){(0,A.onUnexpectedError)(I)}}};E=he([X(0,R.IEnvironmentService),X(1,S.ILogService)],E),e.LogsDataCleaner=E}),define(te[170],ne([0,1,5,8,2,9,19,13,10]),function(J,e,D,A,P,T,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let E=class mt extends P.Disposable{constructor(I,g,b){super();this.backupWorkspacesPath=I,this.environmentService=g,this.logService=b,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.info("[storage cleanup]: Starting to clean up storage folders.");try{const I=await L.Promises.readFile(this.backupWorkspacesPath,"utf8"),b=JSON.parse(I).emptyWorkspaceInfos.map(y=>y.backupFolder),h=await L.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async y=>{y.length!==mt.NON_EMPTY_WORKSPACE_ID_LENGTH&&b.indexOf(y)===-1&&(this.logService.info(`[storage cleanup]: Deleting storage folder ${y}.`),await L.Promises.rm((0,T.join)(this.environmentService.workspaceStorageHome.fsPath,y)))}))}catch(I){(0,A.onUnexpectedError)(I)}}};E.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,E=he([X(1,R.INativeEnvironmentService),X(2,S.ILogService)],E),e.StorageDataCleaner=E}),define(te[171],ne([0,1,41,5,37,3,2,15,9,19,13,10]),function(J,e,D,A,P,T,L,R,S,E,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let g=class extends L.Disposable{constructor(h,y){super();this.environmentService=h,this.logService=y,this.processesLimiter=new A.Limiter(5)}async postUninstall(h){const y=this.parseScript(h,"uninstall");return y&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(y.script,"uninstall",y.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),f=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${f}`)))),E.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,f=>this.logService.error("Error while removing extension storage path",f))}parseScript(h,y){const f=`vscode:${y}`;if(h.location.scheme===R.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[f]=="string"){const w=h.manifest.scripts[f].split(" ");return w.length<2||w[0]!=="node"||!w[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${f} should be a node script`),null):{script:(0,S.join)(h.location.fsPath,w[1]),args:w.slice(2)||[]}}return null}runLifecycleHook(h,y,f,w,v){return new Promise((p,l)=>{const c=this.start(h,y,f,v);let t;const s=r=>{t&&(clearTimeout(t),t=null),r?l(r):p(void 0)};c.on("error",r=>{s((0,P.toErrorMessage)(r)||"Unknown")}),c.on("exit",(r,i)=>{s(r?`post-${y} process exited with code ${r}`:void 0)}),w&&(t=setTimeout(()=>{t=null,c.kill(),l("timed out")},5e3))})}start(h,y,f,w){const v={silent:!0,execArgv:void 0},p=(0,D.fork)(h,[`--type=extension-post-${y}`,...f],v);p.stdout.setEncoding("utf8"),p.stderr.setEncoding("utf8");const l=T.Event.fromNodeEventEmitter(p.stdout,"data"),c=T.Event.fromNodeEventEmitter(p.stderr,"data");l(r=>this.logService.info(w.identifier.id,w.manifest.version,`post-${y}`,r)),c(r=>this.logService.error(w.identifier.id,w.manifest.version,`post-${y}`,r));const t=T.Event.any(T.Event.map(l,r=>({data:`%c${r}`,format:[""]})),T.Event.map(c,r=>({data:`%c${r}`,format:["color: red"]})));return T.Event.debounce(t,(r,i)=>r?{data:r.data+i.data,format:[...r.format,...i.format]}:{data:i.data,format:i.format},100)(r=>{console.group(w.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),p}getExtensionStoragePath(h){return(0,S.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};g=he([X(0,n.IEnvironmentService),X(1,I.ILogService)],g),e.ExtensionsLifecycle=g}),define(te[172],ne([0,1,8,2,79,3,41,15,107,4,10,75]),function(J,e,D,A,P,T,L,R,S,E,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let g=class extends A.Disposable{constructor(y,f){super();this.id=y,this._logService=f,this._onStdout=this._register(new T.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new T.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new T.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this._onExit=this._register(new T.Emitter),this.onExit=this._onExit.event,this._process=null}register(y){this._register(y)}start(y){this._process=(0,L.fork)(R.FileAccess.asFileUri("bootstrap-fork",J).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],y);const f=this._process.pid;this._logService.info(`Starting extension host with pid ${f}.`);const w=new S.StringDecoder("utf-8");this._process.stdout?.on("data",p=>{const l=typeof p=="string"?p:w.write(p);this._onStdout.fire(l)});const v=new S.StringDecoder("utf-8");return this._process.stderr?.on("data",p=>{const l=typeof p=="string"?p:v.write(p);this._onStderr.fire(l)}),this._process.on("message",p=>{this._onMessage.fire(p)}),this._process.on("error",p=>{this._onError.fire({error:(0,D.transformErrorForSerialization)(p)})}),this._process.on("exit",(p,l)=>{this._onExit.fire({pid:f,code:p,signal:l})}),{pid:f}}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):E.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}};g=he([X(1,n.ILogService)],g);let b=class vt{constructor(y){this._logService=y,this._extHosts=new Map}dispose(){}_getExtHost(y){const f=this._extHosts.get(y);if(!f)throw new Error("Unknown extension host!");return f}onDynamicStdout(y){return this._getExtHost(y).onStdout}onDynamicStderr(y){return this._getExtHost(y).onStderr}onDynamicMessage(y){return this._getExtHost(y).onMessage}onDynamicError(y){return this._getExtHost(y).onError}onDynamicExit(y){return this._getExtHost(y).onExit}async createExtensionHost(){const y=String(++vt._lastId),f=new g(y,this._logService);return this._extHosts.set(y,f),f.onExit(({pid:w,code:v,signal:p})=>{this._logService.info(`Extension host with pid ${w} exited with code: ${v}, signal: ${p}.`),setTimeout(()=>{f.dispose(),this._extHosts.delete(y)})}),{id:y}}async start(y,f){return this._getExtHost(y).start(f)}async enableInspectPort(y){const f=this._extHosts.get(y);return f?f.enableInspectPort():!1}async kill(y){const f=this._extHosts.get(y);!f||f.kill()}};b._lastId=0,b=he([X(0,n.ILogService)],b),e.ExtensionHostStarter=b,(0,I.registerSingleton)(P.IExtensionHostStarter,b,!0)}),define(te[83],ne([0,1,3,7,10]),function(J,e,D,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(g){this.service=g,this.onDidChangeLogLevel=D.Event.buffer(g.onDidChangeLogLevel,!0)}listen(g,b){switch(b){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${b}`)}async call(g,b,h){switch(b){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${b}`)}}e.LogLevelChannel=T;class L{constructor(g){this.channel=g}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(g){L.setLevel(this.channel,g)}static setLevel(g,b){return g.call("setLevel",b)}}e.LogLevelChannelClient=L;class R{constructor(g){this.loggerService=g,this.loggers=new Map}listen(g,b){throw new Error(`Event not found: ${b}`)}async call(g,b,h){switch(b){case"createLogger":this.createLogger(A.URI.revive(h[0]),h[1]);return;case"log":return this.log(A.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${b}`)}createLogger(g,b){this.loggers.set(g.toString(),this.loggerService.createLogger(g,b))}consoleLog(g,b){let h=console.log;switch(g){case P.LogLevel.Error:h=console.error;break;case P.LogLevel.Warning:h=console.warn;break;case P.LogLevel.Info:h=console.info;break}h.call(console,...b)}log(g,b){const h=this.loggers.get(g.toString());if(!h)throw new Error("Create the logger before logging");for(const[y,f]of b)switch(y){case P.LogLevel.Trace:h.trace(f);break;case P.LogLevel.Debug:h.debug(f);break;case P.LogLevel.Info:h.info(f);break;case P.LogLevel.Warning:h.warn(f);break;case P.LogLevel.Error:h.error(f);break;case P.LogLevel.Critical:h.critical(f);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=R;class S extends P.AbstractLoggerService{constructor(g,b,h){super(g,b);this.channel=h}createConsoleMainLogger(){return new P.AdapterLogger({log:(g,b)=>{this.channel.call("consoleLog",[g,b])}})}doCreateLogger(g,b,h){return new E(this.channel,g,b,h)}}e.LoggerChannelClient=S;class E extends P.AbstractMessageLogger{constructor(g,b,h,y){super(y?.always);this.channel=g,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[b,y]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(g,b){const h=[[g,b]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(g){this.channel.call("log",[this.file,g])}}class n extends P.LogService{constructor(g,b){super(b);this.parent=g,this._register(g.onDidChangeLogLevel(h=>b.setLevel(h)))}setLevel(g){super.setLevel(g),this.parent.setLevel(g)}}e.FollowerLogService=n}),define(te[59],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(te[42],ne([0,1,15,4,31,16]),function(J,e,D,A,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;if(typeof A.globals.vscode!="undefined"&&typeof A.globals.vscode.context!="undefined"){const R=A.globals.vscode.context.configuration();if(R)L=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const R=(0,T.dirname)(D.FileAccess.asFileUri("",J));L=J.__$__nodeRequire((0,T.joinPath)(R,"product.json").fsPath);const S=J.__$__nodeRequire((0,T.joinPath)(R,"package.json").fsPath);P.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`}),Object.assign(L,{version:S.version})}else L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=L}),define(te[84],ne([0,1,22,8,136,14,42]),function(J,e,D,A,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function R(I,g,b,h,y,f){let w;try{await S(I,g,b,h,y,f)}catch(v){w=v}finally{w&&y.errorTransformer&&(w=y.errorTransformer(w)),typeof w!="undefined"&&b.error(w),b.end()}}e.readFileIntoStream=R;async function S(I,g,b,h,y,f){E(f);const w=await I.open(g,{create:!1});try{E(f);let v=0,p=0,l=y&&typeof y.length=="number"?y.length:void 0,c=D.VSBuffer.alloc(Math.min(y.bufferSize,typeof l=="number"?l:y.bufferSize)),t=y&&typeof y.position=="number"?y.position:0,s=0;do p=await I.read(w,t,c.buffer,s,c.byteLength-s),t+=p,s+=p,v+=p,typeof l=="number"&&(l-=p),s===c.byteLength&&(await b.write(h(c)),c=D.VSBuffer.alloc(Math.min(y.bufferSize,typeof l=="number"?l:y.bufferSize)),s=0);while(p>0&&(typeof l!="number"||l>0)&&E(f)&&n(v,y));if(s>0){let r=s;typeof l=="number"&&(r=Math.min(s,l)),b.write(h(c.slice(0,r)))}}catch(v){throw(0,T.ensureFileSystemProviderError)(v)}finally{await I.close(w)}}function E(I){if(I.isCancellationRequested)throw(0,A.canceled)();return!0}function n(I,g){if(g?.limits){if(typeof g.limits.memory=="number"&&I>g.limits.memory)throw(0,T.createFileSystemProviderError)((0,P.localize)(0,null,L.default.nameShort),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof g.limits.size=="number"&&I>g.limits.size)throw(0,T.createFileSystemProviderError)((0,P.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[173],ne([0,1,17,5,22,27,3,55,2,40,15,174,16,51,134,14,84,10]),function(J,e,D,A,P,T,L,R,S,E,n,I,g,b,h,y,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let v=class He extends S.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new L.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new L.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new L.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new L.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new L.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new A.ThrottledWorker(He.FILE_EVENTS_THROTTLING.maxChangesChunkSize,He.FILE_EVENTS_THROTTLING.maxChangesBufferSize,He.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new y.FileChangesEvent(c,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new A.ThrottledWorker(He.FILE_EVENTS_THROTTLING.maxChangesChunkSize,He.FILE_EVENTS_THROTTLING.maxChangesBufferSize,He.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new y.FileChangesEvent(c,!0)))),this.watchedResources=E.TernarySearchTree.forUris(c=>{const t=this.getProvider(c.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new A.ResourceQueue)}registerProvider(l,c){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${l}`),this.provider.set(l,c),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:c});const t=new S.DisposableStore;return t.add(c.onDidChangeFile(s=>this.onDidChangeFile(s,this.isPathCaseSensitive(c)))),t.add(c.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:c,scheme:l}))),typeof c.onDidErrorOccur=="function"&&t.add(c.onDidErrorOccur(s=>this._onError.fire(new Error(s)))),(0,S.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:c}),this.provider.delete(l),(0,S.dispose)(t)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const c=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(t){c.push(t)}}),!this.provider.has(l)&&await A.Promises.settled(c)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,c){const t=this.provider.get(l.scheme);return!!(t&&t.capabilities&c)}listCapabilities(){return R.Iterable.map(this.provider,([l,c])=>({scheme:l,capabilities:c.capabilities}))}async withProvider(l){if(!(0,g.isAbsolutePath)(l))throw new y.FileOperationError((0,h.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const c=this.provider.get(l.scheme);if(!c){const t=new Error;throw t.name="ENOPRO",t.message=(0,h.localize)(1,null,l.toString()),t}return c}async withReadProvider(l){const c=await this.withProvider(l);if((0,y.hasOpenReadWriteCloseCapability)(c)||(0,y.hasReadWriteCapability)(c)||(0,y.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const c=await this.withProvider(l);if((0,y.hasOpenReadWriteCloseCapability)(c)||(0,y.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,c){try{return await this.doResolveFile(l,c)}catch(t){throw(0,y.toFileSystemProviderErrorCode)(t)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,h.localize)(2,null,this.resourceForError(l)),1):(0,y.ensureFileSystemProviderError)(t)}}async doResolveFile(l,c){const t=await this.withProvider(l),s=this.isPathCaseSensitive(t),r=c?.resolveTo,i=c?.resolveSingleChildDescendants,a=c?.resolveMetadata,o=await t.stat(l);let u;return this.toFileStat(t,l,o,void 0,!!a,(d,m)=>(u||(u=E.TernarySearchTree.forUris(()=>!s),u.set(l,!0),r&&u.fill(!0,r)),u.get(d.resource)||u.findSuperstr(d.resource.with({query:null,fragment:null}))?!0:d.isDirectory&&i?m===1:!1))}async toFileStat(l,c,t,s,r,i){const{providerExtUri:a}=this.getExtUri(l),o={resource:c,name:a.basename(c),isFile:(t.type&y.FileType.File)!=0,isDirectory:(t.type&y.FileType.Directory)!=0,isSymbolicLink:(t.type&y.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&y.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,y.etag)({mtime:t.mtime,size:t.size})};if(o.isDirectory&&i(o,s)){try{const u=await l.readdir(c),d=await A.Promises.settled(u.map(async([m,k])=>{try{const _=a.joinPath(c,m),O=r?await l.stat(_):{type:k};return await this.toFileStat(l,_,O,u.length,r,i)}catch(_){return this.logService.trace(_),null}}));o.children=(0,D.coalesce)(d)}catch(u){this.logService.trace(u),o.children=[]}return o}return o}async resolveAll(l){return A.Promises.settled(l.map(async c=>{try{return{stat:await this.doResolveFile(c.resource,c.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(l){const c=await this.withProvider(l);try{return!!await c.stat(l)}catch(t){return!1}}async canCreateFile(l,c){try{await this.doValidateCreateFile(l,c)}catch(t){return t}return!0}async doValidateCreateFile(l,c){if(!c?.overwrite&&await this.exists(l))throw new y.FileOperationError((0,h.localize)(3,null,this.resourceForError(l)),3,c)}async createFile(l,c=P.VSBuffer.fromString(""),t){await this.doValidateCreateFile(l,t);const s=await this.writeFile(l,c);return this._onDidRunOperation.fire(new y.FileOperationEvent(l,0,s)),s}async writeFile(l,c,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:r}=this.getExtUri(s);try{await this.validateWriteFile(s,l,t)||await this.mkdirp(s,r.dirname(l));let a;if((0,y.hasReadWriteCapability)(s)&&!(c instanceof P.VSBuffer))if((0,b.isReadableStream)(c)){const o=await(0,b.peekStream)(c,3);o.ended?a=P.VSBuffer.concat(o.buffer):a=o}else a=(0,b.peekReadable)(c,o=>P.VSBuffer.concat(o),3);else a=c;!(0,y.hasOpenReadWriteCloseCapability)(s)||(0,y.hasReadWriteCapability)(s)&&a instanceof P.VSBuffer?await this.doWriteUnbuffered(s,l,t,a):await this.doWriteBuffered(s,l,t,a instanceof P.VSBuffer?(0,P.bufferToReadable)(a):a)}catch(i){throw new y.FileOperationError((0,h.localize)(4,null,this.resourceForError(l),(0,y.ensureFileSystemProviderError)(i).toString()),(0,y.toFileOperationResult)(i),t)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,c,t){if(!!t?.unlock&&!(l.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(c)));let r;try{r=await l.stat(c)}catch(i){return}if((r.type&y.FileType.Directory)!=0)throw new y.FileOperationError((0,h.localize)(6,null,this.resourceForError(c)),0,t);if(this.throwIfFileIsReadonly(c,r),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==y.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&t.mtime<r.mtime&&t.etag!==(0,y.etag)({mtime:t.mtime,size:r.size}))throw new y.FileOperationError((0,h.localize)(7,null),3,t);return r}async readFile(l,c){const t=await this.withReadProvider(l);return c?.atomic?this.doReadFileAtomic(t,l,c):this.doReadFile(t,l,c)}async doReadFileAtomic(l,c,t){return new Promise((s,r)=>{this.writeQueue.queueFor(c,this.getExtUri(l).providerExtUri).queue(async()=>{try{const i=await this.doReadFile(l,c,t);s(i)}catch(i){r(i)}})})}async doReadFile(l,c,t){const s=await this.doReadFileStream(l,c,{...t,preferUnbuffered:!0});return{...s,value:await(0,P.streamToBuffer)(s.value)}}async readFileStream(l,c){const t=await this.withReadProvider(l);return this.doReadFileStream(t,l,c)}async doReadFileStream(l,c,t){const s=new T.CancellationTokenSource,r=this.validateReadFile(c,t).then(a=>a,a=>{throw s.cancel(),a});let i;try{return typeof t?.etag=="string"&&t.etag!==y.ETAG_DISABLED&&await r,!((0,y.hasOpenReadWriteCloseCapability)(l)||(0,y.hasFileReadStreamCapability)(l))||(0,y.hasReadWriteCapability)(l)&&t?.preferUnbuffered?i=this.readFileUnbuffered(l,c,t):(0,y.hasFileReadStreamCapability)(l)?i=this.readFileStreamed(l,c,s.token,t):i=this.readFileBuffered(l,c,s.token,t),{...await r,value:i}}catch(a){i&&await(0,b.consumeStream)(i);const o=(0,h.localize)(8,null,this.resourceForError(c),(0,y.ensureFileSystemProviderError)(a).toString());throw a instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(o,a.stat,t):new y.FileOperationError(o,(0,y.toFileOperationResult)(a),t)}}readFileStreamed(l,c,t,s=Object.create(null)){const r=l.readFileStream(c,s,t);return(0,b.transform)(r,{data:i=>i instanceof P.VSBuffer?i:P.VSBuffer.wrap(i),error:i=>new y.FileOperationError((0,h.localize)(9,null,this.resourceForError(c),(0,y.ensureFileSystemProviderError)(i).toString()),(0,y.toFileOperationResult)(i),s)},i=>P.VSBuffer.concat(i))}readFileBuffered(l,c,t,s=Object.create(null)){const r=(0,P.newWriteableBufferStream)();return(0,f.readFileIntoStream)(l,c,r,i=>i,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:i=>new y.FileOperationError((0,h.localize)(10,null,this.resourceForError(c),(0,y.ensureFileSystemProviderError)(i).toString()),(0,y.toFileOperationResult)(i),s)},t),r}readFileUnbuffered(l,c,t){const s=(0,b.newWriteableStream)(r=>P.VSBuffer.concat(r));return(async()=>{try{let r=await l.readFile(c);typeof t?.position=="number"&&(r=r.slice(t.position)),typeof t?.length=="number"&&(r=r.slice(0,t.length)),this.validateReadFileLimits(c,r.byteLength,t),s.end(P.VSBuffer.wrap(r))}catch(r){s.error(r),s.end()}})(),s}async validateReadFile(l,c){const t=await this.resolve(l,{resolveMetadata:!0});if(t.isDirectory)throw new y.FileOperationError((0,h.localize)(11,null,this.resourceForError(l)),0,c);if(typeof c?.etag=="string"&&c.etag!==y.ETAG_DISABLED&&c.etag===t.etag)throw new y.NotModifiedSinceFileOperationError((0,h.localize)(12,null),t,c);return this.validateReadFileLimits(l,t.size,c),t}validateReadFileLimits(l,c,t){if(t?.limits){let s;if(typeof t.limits.memory=="number"&&c>t.limits.memory&&(s=9),typeof t.limits.size=="number"&&c>t.limits.size&&(s=7),typeof s=="number")throw new y.FileOperationError((0,h.localize)(13,null,this.resourceForError(l)),s)}}async canMove(l,c,t){return this.doCanMoveCopy(l,c,"move",t)}async canCopy(l,c,t){return this.doCanMoveCopy(l,c,"copy",t)}async doCanMoveCopy(l,c,t,s){if(l.toString()!==c.toString())try{const r=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c);await this.doValidateMoveCopy(r,l,i,c,t,s)}catch(r){return r}return!0}async move(l,c,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),i=await this.doMoveCopy(s,l,r,c,"move",!!t),a=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(l,i==="move"?2:3,a)),a}async copy(l,c,t){const s=await this.withReadProvider(l),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),i=await this.doMoveCopy(s,l,r,c,"copy",!!t),a=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(l,i==="copy"?3:2,a)),a}async doMoveCopy(l,c,t,s,r,i){if(c.toString()===s.toString())return r;const{exists:a,isSameResourceWithDifferentPathCase:o}=await this.doValidateMoveCopy(l,c,t,s,r,i);if(a&&!o&&i&&await this.del(s,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(s)),r==="copy"){if(l===t&&(0,y.hasFileFolderCopyCapability)(l))await l.copy(c,s,{overwrite:i});else{const u=await this.resolve(c);u.isDirectory?await this.doCopyFolder(l,u,t,s):await this.doCopyFile(l,c,t,s)}return r}else return l===t?(await l.rename(c,s,{overwrite:i}),r):(await this.doMoveCopy(l,c,t,s,"copy",i),await this.del(c,{recursive:!0}),"copy")}async doCopyFile(l,c,t,s){if((0,y.hasOpenReadWriteCloseCapability)(l)&&(0,y.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(l,c,t,s);if((0,y.hasOpenReadWriteCloseCapability)(l)&&(0,y.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(l,c,t,s);if((0,y.hasReadWriteCapability)(l)&&(0,y.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(l,c,t,s);if((0,y.hasReadWriteCapability)(l)&&(0,y.hasReadWriteCapability)(t))return this.doPipeUnbuffered(l,c,t,s)}async doCopyFolder(l,c,t,s){await t.mkdir(s),Array.isArray(c.children)&&await A.Promises.settled(c.children.map(async r=>{const i=this.getExtUri(t).providerExtUri.joinPath(s,r.name);return r.isDirectory?this.doCopyFolder(l,await this.resolve(r.resource),t,i):this.doCopyFile(l,r.resource,t,i)}))}async doValidateMoveCopy(l,c,t,s,r,i){let a=!1;if(l===t){const{providerExtUri:u,isPathCaseSensitive:d}=this.getExtUri(l);if(d||(a=u.isEqual(c,s)),a&&r==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(c),this.resourceForError(s)));if(!a&&u.isEqualOrParent(s,c))throw new Error((0,h.localize)(15,null,this.resourceForError(c),this.resourceForError(s)))}const o=await this.exists(s);if(o&&!a){if(!i)throw new y.FileOperationError((0,h.localize)(16,null,this.resourceForError(c),this.resourceForError(s)),4);if(l===t){const{providerExtUri:u}=this.getExtUri(l);if(u.isEqualOrParent(c,s))throw new Error((0,h.localize)(17,null,this.resourceForError(c),this.resourceForError(s)))}}return{exists:o,isSameResourceWithDifferentPathCase:a}}getExtUri(l){const c=this.isPathCaseSensitive(l);return{providerExtUri:c?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:c}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(c,l);const t=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(l,0,t)),t}async mkdirp(l,c){const t=[],{providerExtUri:s}=this.getExtUri(l);for(;!s.isEqual(c,s.dirname(c));)try{if(((await l.stat(c)).type&y.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(c)));break}catch(r){if((0,y.toFileSystemProviderErrorCode)(r)!==y.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(s.basename(c)),c=s.dirname(c)}for(let r=t.length-1;r>=0;r--){c=s.joinPath(c,t[r]);try{await l.mkdir(c)}catch(i){if((0,y.toFileSystemProviderErrorCode)(i)!==y.FileSystemProviderErrorCode.FileExists)throw i}}}async canDelete(l,c){try{await this.doValidateDelete(l,c)}catch(t){return t}return!0}async doValidateDelete(l,c){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!c?.useTrash&&!(t.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(l)));let r;try{r=await t.stat(l)}catch(a){}if(r)this.throwIfFileIsReadonly(l,r);else throw new y.FileOperationError((0,h.localize)(20,null,this.resourceForError(l)),1);if(!!!c?.recursive){const a=await this.resolve(l);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(l)))}return t}async del(l,c){const t=await this.doValidateDelete(l,c),s=!!c?.useTrash,r=!!c?.recursive;await t.delete(l,{recursive:r,useTrash:s}),this._onDidRunOperation.fire(new y.FileOperationEvent(l,1))}onDidChangeFile(l,c){this._onDidChangeFilesRaw.fire({changes:l});let t,s;{for(const r of l)this.watchedResources.has(r.resource)?(t||(t=[]),t.push(r)):(s||(s=[]),s.push(r));t&&this._onDidFilesChange.fire(new y.FileChangesEvent(t,!c))}if(s){const r=c?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!r.work(s)&&He.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),r.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${r.pending}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(l,c={recursive:!1,excludes:[]}){const t=new S.DisposableStore;{let s=!1,r=()=>{s=!0};t.add((0,S.toDisposable)(()=>r())),this.doWatch(l,c).then(i=>{s?(0,S.dispose)(i):r=()=>(0,S.dispose)(i)},i=>this.logService.error(i))}return c.recursive||(this.watchedResources.set(l,(this.watchedResources.get(l)??0)+1),t.add((0,S.toDisposable)(()=>{const s=this.watchedResources.get(l);typeof s=="number"&&(s<=1?this.watchedResources.delete(l):this.watchedResources.set(l,s-1))}))),t}async doWatch(l,c){const t=await this.withProvider(l),s=this.toWatchKey(t,l,c),r=this.activeWatchers.get(s)||{count:0,disposable:t.watch(l,c)};return this.activeWatchers.has(s)||this.activeWatchers.set(s,r),r.count+=1,(0,S.toDisposable)(()=>{r.count--,r.count===0&&((0,S.dispose)(r.disposable),this.activeWatchers.delete(s))})}toWatchKey(l,c,t){const{providerExtUri:s}=this.getExtUri(l);return[s.getComparisonKey(c),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,S.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,c,t,s){return this.writeQueue.queueFor(c,this.getExtUri(l).providerExtUri).queue(async()=>{const r=await l.open(c,{create:!0,unlock:t?.unlock??!1});try{(0,b.isReadableStream)(s)||(0,b.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(l,r,s):await this.doWriteReadableBufferedQueued(l,r,s)}catch(i){throw(0,y.ensureFileSystemProviderError)(i)}finally{await l.close(r)}})}async doWriteStreamBufferedQueued(l,c,t){let s=0,r;if((0,b.isReadableBufferedStream)(t)){if(t.buffer.length>0){const i=P.VSBuffer.concat(t.buffer);await this.doWriteBuffer(l,c,i,i.byteLength,s,0),s+=i.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise((i,a)=>{(0,b.listenStream)(r,{onData:async o=>{r.pause();try{await this.doWriteBuffer(l,c,o,o.byteLength,s,0)}catch(u){return a(u)}s+=o.byteLength,setTimeout(()=>r.resume())},onError:o=>a(o),onEnd:()=>i()})})}async doWriteReadableBufferedQueued(l,c,t){let s=0,r;for(;(r=t.read())!==null;)await this.doWriteBuffer(l,c,r,r.byteLength,s,0),s+=r.byteLength}async doWriteBuffer(l,c,t,s,r,i){let a=0;for(;a<s;)a+=await l.write(c,r+a,t.buffer,i+a,s-a)}async doWriteUnbuffered(l,c,t,s){return this.writeQueue.queueFor(c,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,c,t,s))}async doWriteUnbufferedQueued(l,c,t,s){let r;s instanceof P.VSBuffer?r=s:(0,b.isReadableStream)(s)?r=await(0,P.streamToBuffer)(s):(0,b.isReadableBufferedStream)(s)?r=await(0,P.bufferedStreamToBuffer)(s):r=(0,P.readableToBuffer)(s),await l.writeFile(c,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(l,c,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,c,t,s))}async doPipeBufferedQueued(l,c,t,s){let r,i;try{r=await l.open(c,{create:!1}),i=await t.open(s,{create:!0,unlock:!1});const a=P.VSBuffer.alloc(this.BUFFER_SIZE);let o=0,u=0,d=0;do d=await l.read(r,o,a.buffer,u,a.byteLength-u),await this.doWriteBuffer(t,i,a,d,o,u),o+=d,u+=d,u===a.byteLength&&(u=0);while(d>0)}catch(a){throw(0,y.ensureFileSystemProviderError)(a)}finally{await A.Promises.settled([typeof r=="number"?l.close(r):Promise.resolve(),typeof i=="number"?t.close(i):Promise.resolve()])}}async doPipeUnbuffered(l,c,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,c,t,s))}async doPipeUnbufferedQueued(l,c,t,s){return t.writeFile(s,await l.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,c,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,c,t,s))}async doPipeUnbufferedToBufferedQueued(l,c,t,s){const r=await t.open(s,{create:!0,unlock:!1});try{const i=await l.readFile(c);await this.doWriteBuffer(t,r,P.VSBuffer.wrap(i),i.byteLength,0,0)}catch(i){throw(0,y.ensureFileSystemProviderError)(i)}finally{await t.close(r)}}async doPipeBufferedToUnbuffered(l,c,t,s){const r=await(0,P.streamToBuffer)(this.readFileBuffered(l,c,T.CancellationToken.None));await this.doWriteUnbuffered(t,s,void 0,r)}throwIfFileSystemIsReadonly(l,c){if(l.capabilities&2048)throw new y.FileOperationError((0,h.localize)(22,null,this.resourceForError(c)),6);return l}throwIfFileIsReadonly(l,c){if((c.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,h.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===n.Schemas.file?l.fsPath:l.toString(!0)}};v.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},v=he([X(0,w.ILogService)],v),e.FileService=v}),define(te[175],ne([0,1,17,5,22,3,39,2,9,4,16,51,19,137,14,84,164,153,154,155,81,10,42]),function(J,e,D,A,P,T,L,R,S,E,n,I,g,b,h,y,f,w,v,p,l,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class s extends R.Disposable{constructor(i,a){super();this.logService=i,this.options=a,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=T.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new T.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new A.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,E.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:a,symbolicLink:o}=await g.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(a,o),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(i){try{const a=await g.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),o=[];return await Promise.all(a.map(async u=>{try{let d;u.isSymbolicLink()?d=(await this.stat((0,n.joinPath)(i,u.name))).type:d=this.toType(u),o.push([u.name,d])}catch(d){this.logService.trace(d)}})),o}catch(a){throw this.toFileSystemProviderError(a)}}toType(i,a){let o;return a?.dangling?o=h.FileType.Unknown:i.isFile()?o=h.FileType.File:i.isDirectory()?o=h.FileType.Directory:o=h.FileType.Unknown,a&&(o|=h.FileType.SymbolicLink),o}async readFile(i){try{const a=this.toFilePath(i);return await g.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(i,a,o){const u=(0,I.newWriteableStream)(d=>P.VSBuffer.concat(d.map(m=>P.VSBuffer.wrap(m))).buffer);return(0,y.readFileIntoStream)(this,i,u,d=>d.buffer,{...a,bufferSize:this.BUFFER_SIZE},o),u}async writeFile(i,a,o){let u;try{const d=this.toFilePath(i);if(!o.create||!o.overwrite){if(await g.Promises.exists(d)){if(!o.overwrite)throw(0,h.createFileSystemProviderError)((0,b.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,h.createFileSystemProviderError)((0,b.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(u,0,a,0,a.byteLength)}catch(d){throw await this.toFileSystemProviderWriteError(i,d)}finally{typeof u=="number"&&await this.close(u)}}async open(i,a){try{const o=this.toFilePath(i);if((0,h.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:m}=await g.SymlinkSupport.stat(o);m.mode&128||await g.Promises.chmod(o,m.mode|128)}catch(m){this.logService.trace(m)}let u;if((0,h.isFileOpenForWriteOptions)(a)){if(E.isWindows)try{await g.Promises.truncate(o,0),u="r+"}catch(m){m.code!=="ENOENT"&&this.logService.trace(m)}u||(u="w")}else u="r";const d=await g.Promises.open(o,u);return this.mapHandleToPos.set(d,0),(0,h.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(d,i),d}catch(o){throw(0,h.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(i,o):this.toFileSystemProviderError(o)}}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await g.Promises.fdatasync(i)}catch(a){this.canFlush=!1,this.logService.error(a)}return await g.Promises.close(i)}catch(a){throw this.toFileSystemProviderError(a)}}async read(i,a,o,u,d){const m=this.normalizePos(i,a);let k=null;try{const _=await g.Promises.read(i,o,u,d,m);return typeof _=="number"?k=_:k=_.bytesRead,k}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(i,m,k)}}normalizePos(i,a){return a===this.mapHandleToPos.get(i)?null:a}updatePos(i,a,o){const u=this.mapHandleToPos.get(i);typeof u=="number"&&(typeof a=="number"||(typeof o=="number"?this.mapHandleToPos.set(i,u+o):this.mapHandleToPos.delete(i)))}async write(i,a,o,u,d){return(0,A.retry)(()=>this.doWrite(i,a,o,u,d),100,3)}async doWrite(i,a,o,u,d){const m=this.normalizePos(i,a);let k=null;try{const _=await g.Promises.write(i,o,u,d,m);return typeof _=="number"?k=_:k=_.bytesWritten,k}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),_)}finally{this.updatePos(i,m,k)}}async mkdir(i){try{await g.Promises.mkdir(this.toFilePath(i))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(i,a){try{const o=this.toFilePath(i);await this.doDelete(o,a)}catch(o){throw this.toFileSystemProviderError(o)}}async doDelete(i,a){a.recursive?await g.Promises.rm(i,g.RimRafMode.MOVE):await g.Promises.unlink(i)}async rename(i,a,o){const u=this.toFilePath(i),d=this.toFilePath(a);if(u!==d)try{await this.validateTargetDeleted(i,a,"move",o.overwrite),await g.Promises.move(u,d)}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,b.localize)(2,null,(0,S.basename)(u),(0,S.basename)((0,S.dirname)(d)),m.toString()))),this.toFileSystemProviderError(m)}}async copy(i,a,o){const u=this.toFilePath(i),d=this.toFilePath(a);if(u!==d)try{await this.validateTargetDeleted(i,a,"copy",o.overwrite),await g.Promises.copy(u,d,{preserveSymlinks:!0})}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,b.localize)(3,null,(0,S.basename)(u),(0,S.basename)((0,S.dirname)(d)),m.toString()))),this.toFileSystemProviderError(m)}}async validateTargetDeleted(i,a,o,u){const d=this.toFilePath(i),m=this.toFilePath(a);let k=!1;if(!!(this.capabilities&1024)||(k=(0,L.isEqual)(d,m,!0)),k&&o==="copy")throw(0,h.createFileSystemProviderError)((0,b.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!k&&await g.Promises.exists(m)){if(!u)throw(0,h.createFileSystemProviderError)((0,b.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}watch(i,a){return a.recursive?this.watchRecursive(i,a):this.watchNonRecursive(i)}watchRecursive(i,a){const o={path:this.toFilePath(i),excludes:a.excludes},u=(0,D.insert)(this.recursiveFoldersToWatch,o);return this.refreshRecursiveWatchers(),(0,R.toDisposable)(()=>{u(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof w.FileWatcher||this.recursiveWatcher instanceof v.FileWatcher)this.recursiveWatcher.watch(this.recursiveFoldersToWatch);else if((0,R.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let i,a;if(this.options?.watcher?.usePolling)i=p.FileWatcher,a=this.options?.watcher;else{let o=!1;this.options?.legacyWatcher==="on"||this.options?.legacyWatcher==="off"?o=this.options.legacyWatcher==="on":t.default.quality==="stable"&&(o=this.recursiveFoldersToWatch.length===1),o?E.isLinux?i=p.FileWatcher:i=w.FileWatcher:i=v.FileWatcher}this.recursiveWatcher=new i(this.recursiveFoldersToWatch,o=>this._onDidChangeFile.fire((0,l.toFileChanges)(o)),o=>{o.type==="error"&&this._onDidWatchErrorOccur.fire(o.message),this.logService[o.type](o.message)},this.logService.getLevel()===c.LogLevel.Trace,a),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)}))}}watchNonRecursive(i){const a=new f.FileWatcher(this.toFilePath(i),u=>this._onDidChangeFile.fire((0,l.toFileChanges)(u)),u=>{u.type==="error"&&this._onDidWatchErrorOccur.fire(u.message),this.logService[u.type](u.message)},this.logService.getLevel()===c.LogLevel.Trace),o=this.logService.onDidChangeLogLevel(()=>{a.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)});return(0,R.combinedDisposable)(a,o)}toFilePath(i){return(0,S.normalize)(i.fsPath)}toFileSystemProviderError(i){if(i instanceof h.FileSystemProviderError)return i;let a;switch(i.code){case"ENOENT":a=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=h.FileSystemProviderErrorCode.NoPermissions;break;default:a=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(i,a)}async toFileSystemProviderWriteError(i,a){let o=this.toFileSystemProviderError(a);if(i&&o.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await g.SymlinkSupport.stat(this.toFilePath(i));u.mode&128||(o=(0,h.createFileSystemProviderError)(a,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.logService.trace(u)}return o}dispose(){super.dispose(),(0,R.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,R.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=s}),define(te[29],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService")}),define(te[176],ne([0,1,5,8,2,9,19,10,29]),function(J,e,D,A,P,T,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let E=class extends P.Disposable{constructor(I,g,b){super();this.productService=g,this.logService=b,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,I&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(I)},30*1e3)).schedule()}async cleanUpCodeCaches(I){this.logService.info("[code cache cleanup]: Starting to clean up old code cache folders.");try{const g=Date.now(),b=(0,T.dirname)(I),h=(0,T.basename)(I),y=await L.Promises.readdir(b);await Promise.all(y.map(async f=>{if(f===h)return;const w=(0,T.join)(b,f),v=await L.Promises.stat(w);if(v.isDirectory()&&g-v.mtime.getTime()>this._DataMaxAge)return this.logService.info(`[code cache cleanup]: Removing code cache folder ${f}.`),L.Promises.rm(w)}))}catch(g){(0,A.onUnexpectedError)(g)}}};E=he([X(1,S.IProductService),X(2,R.ILogService)],E),e.CodeCacheCleaner=E}),define(te[177],ne([0,1,5,8,2,9,19,13,10,29]),function(J,e,D,A,P,T,L,R,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let n=class extends P.Disposable{constructor(g,b,h){super();this.environmentService=g,this.logService=b,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.info("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const g=Object.create(null),b=JSON.parse(await L.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let v of Object.keys(b)){const p=b[v];g[`${p.hash}.${v}`]=!0}const h=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await L.Promises.exists(h))return;const f=await L.Promises.readdir(h);for(const v of f){if(g[v]){this.logService.info(`[language pack cache cleanup]: Skipping folder ${v}. Language pack still in use.`);continue}this.logService.info(`[language pack cache cleanup]: Removing unused language pack: ${v}`),await L.Promises.rm((0,T.join)(h,v))}const w=Date.now();for(const v of Object.keys(g)){const p=(0,T.join)(h,v),l=await L.Promises.readdir(p);for(const c of l){if(c==="tcf.json")continue;const t=(0,T.join)(p,c),s=await L.Promises.stat(t);s.isDirectory()&&w-s.mtime.getTime()>this._DataMaxAge&&(this.logService.info(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(v,c)}`),await L.Promises.rm(t))}}}catch(g){(0,A.onUnexpectedError)(g)}}};n=he([X(0,R.INativeEnvironmentService),X(1,S.ILogService),X(2,E.IProductService)],n),e.LanguagePackCachedDataCleaner=n}),define(te[34],ne([0,1,97,18]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class P{constructor(){this.data=new Map}add(L,R){D.ok(A.isString(L)),D.ok(A.isObject(R)),D.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,R)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}e.Registry=new P}),define(te[85],ne([0,1,3,34]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function P(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class T{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,E){this.schemasById[P(S)]=E,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const L=new T;A.Registry.add(e.Extensions.JSONContribution,L)}),define(te[38],ne([0,1,17,3,18,123,85,34]),function(J,e,D,A,P,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var E;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const n=R.Registry.as(L.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new A.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new A.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(p,l=!0){this.registerConfigurations([p],l)}registerConfigurations(p,l=!0){const c=this.doRegisterConfigurations(p,l);n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterConfigurations(p){const l=this.doDeregisterConfigurations(p);n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}updateConfigurations({add:p,remove:l}){const c=[];c.push(...this.doDeregisterConfigurations(l)),c.push(...this.doRegisterConfigurations(p,!1)),n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,D.distinct)(c))}registerDefaultConfigurations(p){const l=[],c=[];for(const t of p)for(const s in t)if(l.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]={...this.defaultValues[s]||{},...t[s]};const r={type:"object",default:this.defaultValues[s],description:T.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};c.push(b(s)),this.configurationProperties[s]=r,this.defaultLanguageConfigurationOverridesNode.properties[s]=r}else{this.defaultValues[s]=t[s];const r=this.configurationProperties[s];r&&(this.updatePropertyDefaultValue(s,r),this.updateSchema(s,r))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterDefaultConfigurations(p){const l=[];for(const c of p)for(const t in c)if(l.push(t),delete this.defaultValues[t],e.OVERRIDE_PROPERTY_PATTERN.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}notifyConfigurationSchemaUpdated(...p){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(p){for(const l of p)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(p,l){const c=[];return p.forEach(t=>{c.push(...this.validateAndRegisterProperties(t,l,t.extensionInfo)),this.configurationContributors.push(t),this.registerJSONConfiguration(t)}),c}doDeregisterConfigurations(p){const l=[],c=t=>{if(t.properties)for(const s in t.properties)l.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,t.properties[s]);t.allOf&&t.allOf.forEach(s=>c(s))};for(const t of p){c(t);const s=this.configurationContributors.indexOf(t);s!==-1&&this.configurationContributors.splice(s,1)}return l}validateAndRegisterProperties(p,l=!0,c,t=3){t=P.isUndefinedOrNull(p.scope)?t:p.scope;let s=[],r=p.properties;if(r)for(let a in r){if(l&&f(a)){delete r[a];continue}const o=r[a];if(this.updatePropertyDefaultValue(a,o),e.OVERRIDE_PROPERTY_PATTERN.test(a)?o.scope=void 0:(o.scope=P.isUndefinedOrNull(o.scope)?t:o.scope,o.restricted=P.isUndefinedOrNull(o.restricted)?!!c?.restrictedConfigurations?.includes(a):o.restricted),r[a].hasOwnProperty("included")&&!r[a].included){this.excludedConfigurationProperties[a]=r[a],delete r[a];continue}else this.configurationProperties[a]=r[a];!r[a].deprecationMessage&&r[a].markdownDeprecationMessage&&(r[a].deprecationMessage=r[a].markdownDeprecationMessage),s.push(a)}let i=p.allOf;if(i)for(let a of i)s.push(...this.validateAndRegisterProperties(a,l,c,t));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(p){const l=c=>{let t=c.properties;if(t)for(const r in t)this.updateSchema(r,t[r]);let s=c.allOf;s&&s.forEach(l)};l(p)}updateSchema(p,l){switch(e.allSettings.properties[p]=l,l.scope){case 1:e.applicationSettings.properties[p]=l;break;case 2:e.machineSettings.properties[p]=l;break;case 6:e.machineOverridableSettings.properties[p]=l;break;case 3:e.windowSettings.properties[p]=l;break;case 4:e.resourceSettings.properties[p]=l;break;case 5:e.resourceSettings.properties[p]=l,this.resourceLanguageSettingsSchema.properties[p]=l;break}}removeFromSchema(p,l){switch(delete e.allSettings.properties[p],l.scope){case 1:delete e.applicationSettings.properties[p];break;case 2:delete e.machineSettings.properties[p];break;case 6:delete e.machineOverridableSettings.properties[p];break;case 3:delete e.windowSettings.properties[p];break;case 4:case 5:delete e.resourceSettings.properties[p];break}}updateOverridePropertyPatternKey(){for(const p of this.overrideIdentifiers.values()){const l=`[${p}]`,c={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,c),e.allSettings.properties[l]=c,e.applicationSettings.properties[l]=c,e.machineSettings.properties[l]=c,e.machineOverridableSettings.properties[l]=c,e.windowSettings.properties[l]=c,e.resourceSettings.properties[l]=c}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(p,l){let c=this.defaultValues[p];P.isUndefined(c)&&(c=l.default),P.isUndefined(c)&&(c=h(l.type)),l.default=c}}const g="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(g);function b(v){return v.substring(1,v.length-1)}e.overrideIdentifierFromKey=b;function h(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const y=new I;R.Registry.add(e.Extensions.Configuration,y);function f(v){return v.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(v)?T.localize(5,null,v):y.getConfigurationProperties()[v]!==void 0?T.localize(6,null,v):null:T.localize(4,null)}e.validateProperty=f;function w(){const v=[],p=y.getConfigurationProperties();for(const l of Object.keys(p))v.push([l,p[l].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=w}),define(te[20],ne([0,1,26,18,7,38,6,34]),function(J,e,D,A,P,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,L.createDecorator)("configurationService");function S(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof P.URI)}e.isConfigurationOverrides=S;var E;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(E=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function I(s,r){const i=r?s?r.keys.filter(_=>s.keys.indexOf(_)===-1):[...r.keys]:[],a=s?r?s.keys.filter(_=>r.keys.indexOf(_)===-1):[...s.keys]:[],o=[];if(r&&s){for(const _ of s.keys)if(r.keys.indexOf(_)!==-1){const O=w(s.contents,_),N=w(r.contents,_);D.equals(O,N)||o.push(_)}}const u=[],d=_=>{const O={};for(const N of _)for(const C of N.identifiers)O[c(C)]=N;return O},m=r?d(r.overrides):{},k=s?d(s.overrides):{};if(Object.keys(m).length)for(const _ of i){const O=m[_];O&&u.push([(0,T.overrideIdentifierFromKey)(_),O.keys])}if(Object.keys(k).length)for(const _ of a){const O=k[_];O&&u.push([(0,T.overrideIdentifierFromKey)(_),O.keys])}if(Object.keys(m).length&&Object.keys(k).length)for(const _ of o){const O=k[_],N=m[_];if(O&&N){const C=I({contents:O.contents,keys:O.keys,overrides:[]},{contents:N.contents,keys:N.keys,overrides:[]});u.push([(0,T.overrideIdentifierFromKey)(_),[...C.added,...C.removed,...C.updated]])}}return{added:i,removed:a,updated:o,overrides:u}}e.compare=I;function g(s,r){const i=[];for(const a of Object.keys(s))if(T.OVERRIDE_PROPERTY_PATTERN.test(a)){const o={};for(const u in s[a])o[u]=s[a][u];i.push({identifiers:[(0,T.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(o),contents:b(o,r)})}return i}e.toOverrides=g;function b(s,r){const i=Object.create(null);for(let a in s)h(i,a,s[a],r);return i}e.toValuesTree=b;function h(s,r,i,a){const o=r.split("."),u=o.pop();let d=s;for(let m=0;m<o.length;m++){let k=o[m],_=d[k];switch(typeof _){case"undefined":_=d[k]=Object.create(null);break;case"object":break;default:a(`Ignoring ${r} as ${o.slice(0,m+1).join(".")} is ${JSON.stringify(_)}`);return}d=_}if(typeof d=="object"&&d!==null)try{d[u]=i}catch(m){a(`Ignoring ${r} as ${o.join(".")} is ${JSON.stringify(d)}`)}else a(`Ignoring ${r} as ${o.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=h;function y(s,r){const i=r.split(".");f(s,i)}e.removeFromValueTree=y;function f(s,r){const i=r.shift();if(r.length===0){delete s[i];return}if(Object.keys(s).indexOf(i)!==-1){const a=s[i];typeof a=="object"&&!Array.isArray(a)&&(f(a,r),Object.keys(a).length===0&&delete s[i])}}function w(s,r,i){function a(d,m){let k=d;for(const _ of m){if(typeof k!="object"||k===null)return;k=k[_]}return k}const o=r.split("."),u=a(s,o);return typeof u=="undefined"?i:u}e.getConfigurationValue=w;function v(s,r,i){Object.keys(r).forEach(a=>{a!=="__proto__"&&(a in s?A.isObject(s[a])&&A.isObject(r[a])?v(s[a],r[a],i):i&&(s[a]=r[a]):s[a]=r[a])})}e.merge=v;function p(){const s=R.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=p;function l(){const s=Object.create(null),r=R.Registry.as(T.Extensions.Configuration).getConfigurationProperties();for(let i in r){let a=r[i].default;h(s,i,a,o=>console.error(`Conflict in default settings: ${o}`))}return s}e.getDefaultValues=l;function c(s){return`[${s}]`}e.keyFromOverrideIdentifier=c;function t(s,r,i){const a=s.inspect(r),o=s.inspect(i);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:a.defaultValue}e.getMigratedSettingValue=t}),define(te[86],ne([0,1,17,3,36,2,40,26,18,7,20,38,34]),function(J,e,D,A,P,T,L,R,S,E,n,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class b{constructor(t={},s=[],r=[]){this._contents=t,this._keys=s,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,s){const r=this.getContentsForOverrideIdentifer(s);return r?t?(0,n.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.keys;return[]}override(t){let s=this.overrideConfigurations.get(t);return s||(s=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,s)),s}merge(...t){const s=R.deepClone(this.contents),r=R.deepClone(this.overrides),i=[...this.keys];for(const a of t){this.mergeContents(s,a.contents);for(const o of a.overrides){const[u]=r.filter(d=>D.equals(d.identifiers,o.identifiers));u?this.mergeContents(u.contents,o.contents):r.push(R.deepClone(o))}for(const o of a.keys)i.indexOf(o)===-1&&i.push(o)}return new b(s,i,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let r={};for(const i of D.distinct([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[i],o=s[i];o&&(typeof a=="object"&&typeof o=="object"?(a=R.deepClone(a),this.mergeContents(a,o)):a=o),r[i]=a}return new b(r,this.keys,this.overrides)}mergeContents(t,s){for(const r of Object.keys(s)){if(r in t&&S.isObject(t[r])&&S.isObject(s[r])){this.mergeContents(t[r],s[r]);continue}t[r]=R.deepClone(s[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?R.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,s){this.addKey(t),(0,n.addToValueTree)(this.contents,t,s,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let s=this.keys.length;for(let r=0;r<s;r++)t.indexOf(this.keys[r])===0&&(s=r);this.keys.splice(s,1,t)}removeKey(t){let s=this.keys.indexOf(t);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=b;class h extends b{constructor(){const t=(0,n.getDefaultValues)(),s=(0,n.getConfigurationKeys)(),r=[];for(const i of Object.keys(t))I.OVERRIDE_PROPERTY_PATTERN.test(i)&&r.push({identifiers:[(0,I.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,n.toValuesTree)(t[i],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,s,r)}}e.DefaultConfigurationModel=h;class y{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!S.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:r,keys:i,overrides:a,restricted:o}=this.doParseRaw(t,s);this._configurationModel=new b(r,i,a),this._restrictedConfigurations=o||[]}doParseContent(t){let s={},r=null,i=[],a=[],o=[];function u(m){Array.isArray(i)?i.push(m):r!==null&&(i[r]=m)}let d={onObjectBegin:()=>{let m={};u(m),a.push(i),i=m,r=null},onObjectProperty:m=>{r=m},onObjectEnd:()=>{i=a.pop()},onArrayBegin:()=>{let m=[];u(m),a.push(i),i=m,r=null},onArrayEnd:()=>{i=a.pop()},onLiteralValue:u,onError:(m,k,_)=>{o.push({error:m,offset:k,length:_})}};if(t)try{P.visit(t,d),s=i[0]||{}}catch(m){console.error(`Error while parsing settings file ${this._name}: ${m}`),this._parseErrors=[m]}return s}doParseRaw(t,s){const r=g.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,r,!0,s);t=i.raw;const a=(0,n.toValuesTree)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),o=Object.keys(t),u=(0,n.toOverrides)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:a,keys:o,overrides:u,restricted:i.restricted}}filter(t,s,r,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:t,restricted:[]};const a={},o=[];for(let u in t)if(I.OVERRIDE_PROPERTY_PATTERN.test(u)&&r){const d=this.filter(t[u],s,!1,i);a[u]=d.raw,o.push(...d.restricted)}else{const d=s[u],m=d?typeof d.scope!="undefined"?d.scope:3:void 0;d?.restricted&&o.push(u),(m===void 0||i.scopes===void 0||i.scopes.includes(m))&&(i.skipRestricted&&d?.restricted||(a[u]=t[u]))}return{raw:a,restricted:o}}}e.ConfigurationModelParser=y;class f extends T.Disposable{constructor(t,s,r,i){super();this.userSettingsResource=t,this.scopes=s,this.fileService=i,this._onDidChange=this._register(new A.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new y(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(A.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=f;class w{constructor(t,s,r=new b,i=new b,a=new L.ResourceMap,o=new b,u=new L.ResourceMap,d=!0){this._defaultConfiguration=t,this._localUserConfiguration=s,this._remoteUserConfiguration=r,this._workspaceConfiguration=i,this._folderConfigurations=a,this._memoryConfiguration=o,this._memoryConfigurationByResource=u,this._freeze=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(t,s,r){return this.getConsolidateConfigurationModel(s,r).getValue(t)}updateValue(t,s,r={}){let i;r.resource?(i=this._memoryConfigurationByResource.get(r.resource),i||(i=new b,this._memoryConfigurationByResource.set(r.resource,i))):i=this._memoryConfiguration,s===void 0?i.removeValue(t):i.setValue(t,s),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,r){const i=this.getConsolidateConfigurationModel(s,r),a=this.getFolderConfigurationModelForResource(s.resource,r),o=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,u=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),d=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),m=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),k=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),_=r?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=a?s.overrideIdentifier?a.freeze().override(s.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,N=s.overrideIdentifier?o.override(s.overrideIdentifier).getValue(t):o.getValue(t),C=i.getValue(t),F=D.distinct(D.flatten(i.overrides.map(z=>z.identifiers))).filter(z=>i.getOverrideValue(t,z)!==void 0);return{defaultValue:u,userValue:d,userLocalValue:m,userRemoteValue:k,workspaceValue:_,workspaceFolderValue:O,memoryValue:N,value:C,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,user:d!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userLocal:m!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userRemote:k!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspace:_!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:a?.freeze().getValue(t),override:s.overrideIdentifier?a?.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,memory:N!==void 0?{value:o.getValue(t),override:s.overrideIdentifier?o.getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:F.length?F:void 0}}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const r=s.filter(i=>I.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const a=(0,I.overrideIdentifierFromKey)(i),o=this._defaultConfiguration.getKeysForOverrideIdentifier(a),u=t.getKeysForOverrideIdentifier(a),d=[...u.filter(m=>o.indexOf(m)===-1),...o.filter(m=>u.indexOf(m)===-1),...o.filter(m=>!R.equals(this._defaultConfiguration.override(a).getValue(m),t.override(a).getValue(m)))];return[a,d]});return this.updateDefaultConfiguration(t),{keys:s,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:r,removed:i,overrides:a}=(0,n.compare)(this.localUserConfiguration,t),o=[...s,...r,...i];return o.length&&this.updateLocalUserConfiguration(t),{keys:o,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:r,removed:i,overrides:a}=(0,n.compare)(this.remoteUserConfiguration,t);let o=[...s,...r,...i];return o.length&&this.updateRemoteUserConfiguration(t),{keys:o,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:r,removed:i,overrides:a}=(0,n.compare)(this.workspaceConfiguration,t);let o=[...s,...r,...i];return o.length&&this.updateWorkspaceConfiguration(t),{keys:o,overrides:a}}compareAndUpdateFolderConfiguration(t,s){const r=this.folderConfigurations.get(t),{added:i,updated:a,removed:o,overrides:u}=(0,n.compare)(r,s);let d=[...i,...a,...o];return(d.length||!r)&&this.updateFolderConfiguration(t,s),{keys:d,overrides:u}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:i,removed:a,overrides:o}=(0,n.compare)(s,void 0);return{keys:[...r,...i,...a],overrides:o}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,s){let r=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},s){let r=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const i=s.getFolder(t);i&&(r=this.getFolderConsolidatedConfiguration(i.uri)||r);const a=this._memoryConfigurationByResource.get(t);a&&(r=r.merge(a))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const r=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(s=r.merge(i),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(t,s)):s=r}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const r=s.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:r,overrides:i,keys:a}=this._folderConfigurations.get(s);return t.push([s,{contents:r,overrides:i,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>t.add(s)),this.userConfiguration.freeze().keys.forEach(s=>t.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(i=>s.add(i))),[...s.values()]}static parse(t){const s=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((o,u)=>(o.set(E.URI.revive(u[0]),this.parseConfigurationModel(u[1])),o),new L.ResourceMap);return new w(s,r,new b,i,a,new b,new L.ResourceMap,!1)}static parseConfigurationModel(t){return new b(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function v(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const t=new Set,s=new Map;for(const i of c)i.keys.forEach(a=>t.add(a)),i.overrides.forEach(([a,o])=>{const u=(0,L.getOrSet)(s,a,new Set);o.forEach(d=>u.add(d))});const r=[];return s.forEach((i,a)=>r.push([a,[...i.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=v;class p{constructor(t,s,r,i){this.change=t,this.previous=s,this.currentConfiguraiton=r,this.currentWorkspace=i,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(u=>a.add(u)),t.overrides.forEach(([,u])=>u.forEach(d=>a.add(d))),this.affectedKeys=[...a.values()];const o=new b;this.affectedKeys.forEach(u=>o.setValue(u,{})),this.affectedKeysTree=o.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(s){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!R.equals(r,i)}return!0}return!1}doesAffectedKeysTreeContains(t,s){let r=(0,n.toValuesTree)({[s]:!0},()=>{}),i;for(;typeof r=="object"&&(i=Object.keys(r)[0]);){if(t=t[i],!t)return!1;r=r[i]}return!0}}e.ConfigurationChangeEvent=p;class l extends p{constructor(t,s,r,i){super({keys:t.allKeys(),overrides:[]},void 0,t,s);this.source=r,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=l}),define(te[178],ne([0,1,5,3,2,16,20,86,38,34]),function(J,e,D,A,P,T,L,R,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends P.Disposable{constructor(g,b){super();this.settingsResource=g,this._onDidChangeConfiguration=this._register(new A.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new R.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,b)),this.configuration=new R.Configuration(new R.DefaultConfigurationModel,new R.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(E.Registry.as(S.Extensions.Configuration).onDidUpdateConfiguration(h=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const g=await this.userConfiguration.loadConfiguration();this.configuration=new R.Configuration(new R.DefaultConfigurationModel,g)}getConfigurationData(){return this.configuration.toData()}getValue(g,b){const h=typeof g=="string"?g:void 0,y=(0,L.isConfigurationOverrides)(g)?g:(0,L.isConfigurationOverrides)(b)?b:{};return this.configuration.getValue(h,y,void 0)}updateValue(g,b,h,y){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const b=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(h,b,1)}onDidDefaultConfigurationChange(g){const b=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new R.DefaultConfigurationModel,g);this.trigger(h,b,6)}trigger(g,b,h){const y=new R.ConfigurationChangeEvent(g,{data:b},this.configuration);y.source=h,y.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(y)}getTargetConfiguration(g){switch(g){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(te[179],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,D.createDecorator)("remoteAuthorityResolverService");var A;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(A=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class P extends Error{constructor(L,R=A.Unknown,S){super(L);this._message=L,this._code=R,this._detail=S,this.isHandled=R===A.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype)}static isTemporarilyNotAvailable(L){return L instanceof P&&L._code===A.TemporarilyNotAvailable}static isNoResolverFound(L){return L instanceof P&&L._code===A.NoResolverFound}static isHandled(L){return L instanceof P&&L.isHandled}}e.RemoteAuthorityResolverError=P}),define(te[180],ne([0,1,5,22,27,8,3,2,30,70,179]),function(J,e,D,A,P,T,L,R,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const I=30*1e3;var g;(function(M){M[M.Management=1]="Management",M[M.ExtensionHost=2]="ExtensionHost",M[M.Tunnel=3]="Tunnel"})(g=e.ConnectionType||(e.ConnectionType={}));function b(M){switch(M){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(M){const B=new P.CancellationTokenSource;return setTimeout(()=>B.cancel(),M),B.token}function y(M,B){if(M.isCancellationRequested||B.isCancellationRequested)return P.CancellationToken.Cancelled;const V=new P.CancellationTokenSource;return M.onCancellationRequested(()=>V.cancel()),B.onCancellationRequested(()=>V.cancel()),V.token}class f{constructor(B){this._state="pending",this._disposables=new R.DisposableStore,this.promise=new Promise((V,Q)=>{this._resolvePromise=V,this._rejectPromise=Q}),B.isCancellationRequested?this._timeout():this._disposables.add(B.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(B){this._state==="pending"?this._disposables.add(B):B.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(B))}reject(B){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(B))}}function w(M,B){const V=new f(B);return V.registerDisposable(M.onControlMessage(Q=>{const Z=JSON.parse(Q.toString()),K=W(Z);K?V.reject(K):V.resolve(Z)})),V.promise}function v(M,B,V,Q,Z,K){const H=new f(K);return B.connect(V,Q,Z,(re,ie)=>{H.didTimeout?(re&&M.error(re),ie?.dispose()):re||!ie?H.reject(re):H.resolve(ie)}),H.promise}function p(M,B){const V=new f(B);return M.then(Q=>{V.didTimeout||V.resolve(Q)},Q=>{V.didTimeout||V.reject(Q)}),V.promise}async function l(M,B,V,Q){const Z=$(M,B);M.logService.trace(`${Z} 1/6. invoking socketFactory.connect().`);let K;try{K=await v(M.logService,M.socketFactory,M.host,M.port,`reconnectionToken=${M.reconnectionToken}&reconnection=${M.reconnectionProtocol?"true":"false"}`,Q)}catch(ae){throw M.logService.error(`${Z} socketFactory.connect() failed or timed out. Error:`),M.logService.error(ae),ae}M.logService.trace(`${Z} 2/6. socketFactory.connect() was successful.`);let H,re;M.reconnectionProtocol?(M.reconnectionProtocol.beginAcceptReconnection(K,null),H=M.reconnectionProtocol,re=!1):(H=new E.PersistentProtocol(K,null),re=!0),M.logService.trace(`${Z} 3/6. sending AuthRequest control message.`);const ie={type:"auth",auth:M.connectionToken||"00000000000000000000"};H.sendControl(A.VSBuffer.fromString(JSON.stringify(ie)));try{const ae=await w(H,y(Q,h(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const de=new Error("Unexpected handshake message");throw de.code="VSCODE_CONNECTION_ERROR",de}M.logService.trace(`${Z} 4/6. received SignRequest control message.`);const ue=await p(M.signService.sign(ae.data),Q),fe={type:"connectionType",commit:M.commit,signedData:ue,desiredConnectionType:B};return V&&(fe.args=V),M.logService.trace(`${Z} 5/6. sending ConnectionTypeRequest control message.`),H.sendControl(A.VSBuffer.fromString(JSON.stringify(fe))),{protocol:H,ownsProtocol:re}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(M.logService.error(`${Z} the handshake timed out. Error:`),M.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(M.logService.error(`${Z} received error control message when negotiating connection. Error:`),M.logService.error(ae)),re&&j(H),ae}}async function c(M,B,V,Q){const Z=Date.now(),K=$(M,B),{protocol:H,ownsProtocol:re}=await l(M,B,V,Q),ie=new f(Q);return ie.registerDisposable(H.onControlMessage(ae=>{const ue=JSON.parse(ae.toString()),fe=W(ue);fe?(M.logService.error(`${K} received error control message when negotiating connection. Error:`),M.logService.error(fe),re&&j(H),ie.reject(fe)):(M.reconnectionProtocol&&M.reconnectionProtocol.endAcceptReconnection(),M.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${G(Z)}!`),ie.resolve({protocol:H,firstMessage:ue}))})),ie.promise}async function t(M,B){const{protocol:V}=await c(M,1,void 0,B);return{protocol:V}}async function s(M,B,V){const{protocol:Q,firstMessage:Z}=await c(M,2,B,V),K=Z&&Z.debugPort;return{protocol:Q,debugPort:K}}async function r(M,B,V){const Q=Date.now(),Z=$(M,3),{protocol:K}=await l(M,3,B,V);return M.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${G(Q)}!`),K}async function i(M,B,V){const{host:Q,port:Z,connectionToken:K}=await M.addressProvider.getAddress();return{commit:M.commit,host:Q,port:Z,connectionToken:K,reconnectionToken:B,reconnectionProtocol:V,socketFactory:M.socketFactory,signService:M.signService,logService:M.logService}}async function a(M,B,V){try{const Q=(0,S.generateUuid)(),Z=await i(M,Q,null),{protocol:K}=await t(Z,P.CancellationToken.None);return new z(M,B,V,Q,K)}catch(Q){throw M.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),M.logService.error(Q),F.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(Q)),Q}}e.connectRemoteAgentManagement=a;async function o(M,B){try{const V=(0,S.generateUuid)(),Q=await i(M,V,null),{protocol:Z,debugPort:K}=await s(Q,B,P.CancellationToken.None);return new U(M,B,V,Z,K)}catch(V){throw M.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),M.logService.error(V),F.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(V)),V}}e.connectRemoteAgentExtensionHost=o;async function u(M,B,V){const Q=await i(M,(0,S.generateUuid)(),null);return await r(Q,{host:B,port:V},P.CancellationToken.None)}e.connectRemoteAgentTunnel=u;function d(M){return(0,D.createCancelablePromise)(B=>new Promise((V,Q)=>{const Z=setTimeout(V,M*1e3);B.onCancellationRequested(()=>{clearTimeout(Z),V()})}))}var m;(function(M){M[M.ConnectionLost=0]="ConnectionLost",M[M.ReconnectionWait=1]="ReconnectionWait",M[M.ReconnectionRunning=2]="ReconnectionRunning",M[M.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",M[M.ConnectionGain=4]="ConnectionGain"})(m=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class k{constructor(B,V){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.type=0}}e.ConnectionLostEvent=k;class _{constructor(B,V,Q,Z){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.durationSeconds=Q,this.cancellableTimer=Z,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=_;class O{constructor(B,V,Q){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.attempt=Q,this.type=2}}e.ReconnectionRunningEvent=O;class N{constructor(B,V,Q){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.attempt=Q,this.type=4}}e.ConnectionGainEvent=N;class C{constructor(B,V,Q,Z){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.attempt=Q,this.handled=Z,this.type=3}}e.ReconnectionPermanentFailureEvent=C;class F extends R.Disposable{constructor(B,V,Q,Z){super();this._connectionType=B,this._onDidStateChange=this._register(new L.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=V,this.reconnectionToken=Q,this.protocol=Z,this._isReconnecting=!1,this._onDidStateChange.fire(new N(this.reconnectionToken,0,0)),this._register(Z.onSocketClose(K=>{const H=q(this._connectionType,this.reconnectionToken,!0);K?K.type===0?(this._options.logService.info(`${H} received socket close event (hadError: ${K.hadError}).`),K.error&&this._options.logService.error(K.error)):(this._options.logService.info(`${H} received socket close event (wasClean: ${K.wasClean}, code: ${K.code}, reason: ${K.reason}).`),K.event&&this._options.logService.error(K.event)):this._options.logService.info(`${H} received socket close event.`),this._beginReconnecting()})),this._register(Z.onSocketTimeout(()=>{const K=q(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${K} received socket timeout event.`),this._beginReconnecting()})),F._instances.push(this),F._permanentFailure&&this._gotoPermanentFailure(F._permanentFailureMillisSinceLastIncomingData,F._permanentFailureAttempt,F._permanentFailureHandled)}static triggerPermanentFailure(B,V,Q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=B,this._permanentFailureAttempt=V,this._permanentFailureHandled=Q,this._instances.forEach(Z=>Z._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(F._permanentFailure)return;const B=q(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new k(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const V=[0,5,5,10,10,10,10,10,30];let Q=-1;do{Q++;const Z=Q<V.length?V[Q]:V[V.length-1];try{if(Z>0){const H=d(Z);this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z,H)),this._options.logService.info(`${B} waiting for ${Z} seconds before reconnecting...`);try{await H}catch{}}if(F._permanentFailure){this._options.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1)),this._options.logService.info(`${B} resolving connection...`);const K=await i(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${B} connecting to ${K.host}:${K.port}...`),await this._reconnect(K,h(I)),this._options.logService.info(`${B} reconnected!`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1));break}catch(K){if(K.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(K),F.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(Q>360){this._options.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(K),F.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(n.RemoteAuthorityResolverError.isTemporarilyNotAvailable(K)){this._options.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(K);continue}if((K.code==="ETIMEDOUT"||K.code==="ENETUNREACH"||K.code==="ECONNREFUSED"||K.code==="ECONNRESET")&&K.syscall==="connect"){this._options.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(K);continue}if((0,T.isPromiseCanceledError)(K)){this._options.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(K);continue}if(K instanceof n.RemoteAuthorityResolverError){this._options.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(K),F.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,n.RemoteAuthorityResolverError.isHandled(K));break}this._options.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(K),F.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}}while(!F._permanentFailure)}_gotoPermanentFailure(B,V,Q){this._onDidStateChange.fire(new C(this.reconnectionToken,B,V,Q)),j(this.protocol)}}F._permanentFailure=!1,F._permanentFailureMillisSinceLastIncomingData=0,F._permanentFailureAttempt=0,F._permanentFailureHandled=!1,F._instances=[];class z extends F{constructor(B,V,Q,Z,K){super(1,B,Z,K);this.client=this._register(new E.Client(K,{remoteAuthority:V,clientId:Q},B.ipcLogger))}async _reconnect(B,V){await t(B,V)}}e.ManagementPersistentConnection=z;class U extends F{constructor(B,V,Q,Z,K){super(2,B,Q,Z);this._startArguments=V,this.debugPort=K}async _reconnect(B,V){await s(B,this._startArguments,V)}}e.ExtensionHostPersistentConnection=U;function j(M){try{M.acceptDisconnect();const B=M.getSocket();M.dispose(),B.dispose()}catch(B){(0,T.onUnexpectedError)(B)}}function W(M){if(M&&M.type==="error"){const B=new Error(`Connection error: ${M.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function x(M,B){for(;M.length<B;)M+=" ";return M}function q(M,B,V){return`[remote-connection][${x(b(M),13)}][${B.substr(0,5)}\u2026][${V?"reconnect":"initial"}]`}function $(M,B){return`${q(B,M.reconnectionToken,!!M.reconnectionProtocol)}[${M.host}:${M.port}]`}function G(M){return`${Date.now()-M} ms`}}),define(te[181],ne([0,1,15]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function A(E){return E.scheme===D.Schemas.vscodeRemote?E.authority:void 0}e.getRemoteAuthority=A;function P(E){if(!E)return;const n=E.indexOf("+");return n<0?E:E.substr(0,n)}e.getRemoteName=P;function T(E){return E.scheme!==D.Schemas.file&&E.scheme!==D.Schemas.vscodeRemote}e.isVirtualResource=T;function L(E){if(E.folders.length)return E.folders.every(n=>T(n.uri))?E.folders[0].uri:void 0;if(E.configuration&&T(E.configuration))return E.configuration}e.getVirtualWorkspaceLocation=L;function R(E){return L(E)?.scheme}e.getVirtualWorkspaceScheme=R;function S(E){return L(E)!==void 0}e.isVirtualWorkspace=S}),define(te[87],ne([0,1,25,6,181]),function(J,e,D,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.getWorkspaceSupportTypeMessage=T;function L(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=L,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class S{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,h){if(typeof b=="undefined"||b===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof b=="string"||typeof h=="string"){let y=typeof b=="string"?b:b.value,f=typeof h=="string"?h:h.value;return D.equalsIgnoreCase(y,f)}return b._lower===h._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.ExtensionIdentifier=S;function E(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function n(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=n;function I(g,b){if(b&&g.enableProposedApi){const h=`onResolveRemoteAuthority:${(0,P.getRemoteName)(b)}`;return g.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[35],ne([0,1,25,87]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function P(h,y){return h.uuid&&y.uuid?h.uuid===y.uuid:h.id===y.id?!0:(0,D.compareIgnoreCase)(h.id,y.id)===0}e.areSameExtensions=P;class T{constructor(y,f){this.version=f,this.id=y.id,this.uuid=y.uuid}key(){return`${this.id}-${this.version}`}equals(y){return y instanceof T?P(this,y)&&this.version===y.version:!1}}e.ExtensionIdentifierWithVersion=T;function L(h,y){return`${h}.${y}`}e.getExtensionId=L;function R(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=R;function S(h,y){return R(L(h,y))}e.getGalleryExtensionId=S;function E(h,y){const f=[],w=v=>{for(const p of f)if(p.some(l=>P(y(l),y(v))))return p;return null};for(const v of h){const p=w(v);p?p.push(v):f.push([v])}return f}e.groupByExtension=E;function n(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function I(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new A.ExtensionIdentifier("pprice.better-merge");function g(h){const y=new Set;for(const f of h)f.malicious&&y.add(f.id.id);return y}e.getMaliciousExtensionsSet=g;function b(h,y){const f=[],w=y.manifest.extensionDependencies?.slice(0)??[];for(;w.length;){const v=w.shift();if(v&&f.every(p=>!P(p.identifier,{id:v}))){const p=h.filter(l=>P(l.identifier,{id:v}));p.length===1&&(f.push(p[0]),w.push(...p[0].manifest.extensionDependencies?.slice(0)??[]))}}return f}e.getExtensionDependencies=b}),define(te[182],ne([0,1,5,8,2,4,16,60,7,30,19,13,28,35,14,10]),function(J,e,D,A,P,T,L,R,S,E,n,I,g,b,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const f=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let w=class extends P.Disposable{constructor(p,l,c,t){super();this.fileService=l,this.extensionGalleryService=c,this.logService=t,this.extensionsDownloadDir=S.URI.file(p.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(p,l){await this.cleanUpPromise;const c=this.getName(p),t=(0,L.joinPath)(this.extensionsDownloadDir,c);if(!await this.fileService.exists(t)){const s=(0,L.joinPath)(this.extensionsDownloadDir,`.${(0,E.generateUuid)()}`);await this.fileService.exists(s)||await this.extensionGalleryService.download(p,s,l);try{await this.rename(s,t,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(s)}catch(i){}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",p.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,A.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,s.path),r}}return t}async delete(p){await this.cleanUpPromise,await this.fileService.del(p)}async rename(p,l,c){try{await n.Promises.rename(p.fsPath,l.fsPath)}catch(t){if(T.isWindows&&t&&t.code==="EPERM"&&Date.now()<c)return this.logService.info(`Failed renaming ${p} to ${l} with 'EPERM' error. Trying again...`),this.rename(p,l,c);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const p=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(p.children){const l=[],c=[];for(const r of p.children){const i=this.parse(r.name);i&&c.push([i,r])}const t=(0,b.groupByExtension)(c,([r])=>r),s=[];for(const r of t)r.sort((i,a)=>R.rcompare(i[0].version,a[0].version)),l.push(...r.slice(1).map(i=>i[1].resource)),s.push(r[0][1]);s.sort((r,i)=>r.mtime-i.mtime),l.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(r=>r.resource)),await D.Promises.settled(l.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(p){this.logService.error(p)}}getName(p){return this.cache?`${new b.ExtensionIdentifierWithVersion(p.identifier,p.version).key().toLowerCase()}${p.properties.targetPlatform!=="undefined"?`-${p.properties.targetPlatform}`:""}`:(0,E.generateUuid)()}parse(p){const l=f.exec(p);return l&&l[1]&&l[2]?new b.ExtensionIdentifierWithVersion({id:l[1]},l[2]):null}};w=he([X(0,I.INativeEnvironmentService),X(1,h.IFileService),X(2,g.IExtensionGalleryService),X(3,y.ILogService)],w),e.ExtensionsDownloader=w}),define(te[183],ne([0,1,2,9,19,87]),function(J,e,D,A,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class L extends D.Disposable{constructor(S,E){super();this.environmentService=S,this.extensionsManifestCache=(0,A.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(E.onDidInstallExtensions(n=>this.onDidInstallExtensions(n))),this._register(E.onDidUninstallExtension(n=>this.onDidUnInstallExtension(n)))}onDidInstallExtensions(S){S.some(E=>!!E.local)&&this.invalidate()}onDidUnInstallExtension(S){S.error||this.invalidate()}invalidate(){P.Promises.rm(this.extensionsManifestCache,P.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=L}),define(te[184],ne([0,1,3,2,16,7,13,35,14,10]),function(J,e,D,A,P,T,L,R,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let n=class extends A.Disposable{constructor(g,b,h,y){super();this.extensionsManagementService=g,this.logService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(v=>{this.installedExtensions=v.map(p=>p.identifier),this.startTimestamp=Date.now()}),this._register(g.onInstallExtension(v=>this.onInstallExtension(v))),this._register(g.onDidInstallExtensions(v=>this.onDidInstallExtensions(v))),this._register(g.onDidUninstallExtension(v=>this.onDidUninstallExtension(v)));const f=T.URI.file(h.extensionsPath),w=new P.ExtUri(v=>!b.hasCapability(v,1024));this._register(b.watch(f)),this._register(D.Event.filter(b.onDidChangeFilesRaw,v=>v.changes.some(p=>this.doesChangeAffects(p,f,w)))(()=>this.onDidChange()))}doesChangeAffects(g,b,h){return h.isEqual(h.dirname(g.resource),b)?h.isEqual(g.resource,h.joinPath(b,".obsolete"))?!0:!(g.type!==1&&g.type!==2||h.basename(g.resource).startsWith(".")):!1}onInstallExtension(g){this.addInstallingExtension(g.identifier)}onDidInstallExtensions(g){for(const b of g)this.removeInstallingExtension(b.identifier),b.local&&this.addInstalledExtension(b.identifier)}onDidUninstallExtension(g){g.error||this.removeInstalledExtension(g.identifier)}addInstallingExtension(g){this.removeInstallingExtension(g),this.installingExtensions.push(g)}removeInstallingExtension(g){this.installingExtensions=this.installingExtensions.filter(b=>!(0,R.areSameExtensions)(b,g))}addInstalledExtension(g){this.installedExtensions&&(this.removeInstalledExtension(g),this.installedExtensions.push(g))}removeInstalledExtension(g){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(b=>!(0,R.areSameExtensions)(b,g)))}async onDidChange(){if(this.installedExtensions){const g=await this.extensionsManagementService.getInstalled(1),b=g.filter(y=>[...this.installingExtensions,...this.installedExtensions].some(f=>(0,R.areSameExtensions)(f,y.identifier))?!1:y.installedTimestamp&&y.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",y.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",y.identifier.id),!1)),h=this.installedExtensions.filter(y=>this.installingExtensions.some(f=>(0,R.areSameExtensions)(f,y))?!1:g.every(f=>!(0,R.areSameExtensions)(f.identifier,y))?(this.logService.info("Detected extension removed from another source",y.id),!0):!1);this.installedExtensions=g.map(y=>y.identifier),(b.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:b,removed:h})}}};n=he([X(1,S.IFileService),X(2,L.INativeEnvironmentService),X(3,E.ILogService)],n),e.ExtensionsWatcher=n}),define(te[185],ne([0,1,80,17,5,2,15,9,19,13,28,35,58,10]),function(J,e,D,A,P,T,L,R,S,E,n,I,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let h=class extends T.Disposable{constructor(w,v,p){super();this.extensionManagementService=w,this.logService=p,this.cache=this._register(new y(v,p)),this.extensionManagementService.registerParticipant({postInstall:async l=>this.postInstallExtension(l),postUninstall:async l=>this.postUninstallExtension(l)})}async getLanguageIds(){const w=await this.cache.getLanguagePacks(),v=["en",...Object.keys(w)];return(0,A.distinct)(v)}async postInstallExtension(w){w&&w.manifest&&w.manifest.contributes&&w.manifest.contributes.localizations&&w.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",w.identifier.id),await this.update())}async postUninstallExtension(w){const v=await this.cache.getLanguagePacks();Object.keys(v).some(p=>v[p]&&v[p].extensions.some(l=>(0,I.areSameExtensions)(l.extensionIdentifier,w.identifier)))&&(this.logService.info("Removing language packs from the extension",w.identifier.id),await this.update())}async update(){const[w,v]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),p=await this.cache.update(v);return!(0,A.equals)(Object.keys(w),Object.keys(p))}};h=he([X(0,n.IExtensionManagementService),X(1,E.INativeEnvironmentService),X(2,b.ILogService)],h),e.LocalizationsService=h;let y=class extends T.Disposable{constructor(w,v){super();this.logService=v,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(w.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new P.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(w){return this.withLanguagePacks(v=>{Object.keys(v).forEach(p=>delete v[p]),this.createLanguagePacksFromExtensions(v,...w)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(w,...v){for(const p of v)p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(w,p);Object.keys(w).forEach(p=>this.updateHash(w[p]))}createLanguagePacksFromExtension(w,v){const p=v.identifier,l=v.manifest.contributes&&v.manifest.contributes.localizations?v.manifest.contributes.localizations:[];for(const c of l)if(v.location.scheme===L.Schemas.file&&(0,g.isValidLocalization)(c)){let t=w[c.languageId];t||(t={hash:"",extensions:[],translations:{}},w[c.languageId]=t);let s=t.extensions.filter(r=>(0,I.areSameExtensions)(r.extensionIdentifier,p))[0];s?s.version=v.manifest.version:t.extensions.push({extensionIdentifier:p,version:v.manifest.version});for(const r of c.translations)t.translations[r.id]=(0,R.join)(v.location.fsPath,r.path)}}updateHash(w){if(w){const v=(0,D.createHash)("md5");for(const p of w.extensions)v.update(p.extensionIdentifier.uuid||p.extensionIdentifier.id).update(p.version);w.hash=v.digest("hex")}}withLanguagePacks(w=()=>null){return this.languagePacksFileLimiter.queue(()=>{let v=null;return S.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,p=>p.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(p)).then(p=>{try{return JSON.parse(p)}catch(l){return{}}}).then(p=>(v=w(p),p)).then(p=>{for(const c of Object.keys(p))p[c]||delete p[c];this.languagePacks=p,this.initializedCache=!0;const l=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",l),S.Promises.writeFile(this.languagePacksFilePath,l)}).then(()=>v,p=>this.logService.error(p))})}};y=he([X(0,E.INativeEnvironmentService),X(1,b.ILogService)],y)}),define(te[186],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(te[61],ne([0,1,3,4,6,10]),function(J,e,D,A,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,P.createDecorator)("tunnelService");var L;(function(h){h.Http="http",h.Https="https"})(L=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function E(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const y=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!y)return{address:y[1],port:+y[2]}}e.extractLocalHostUriMetaDataForPortMapping=E,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function n(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=n,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=I;function g(h,y){return y?y!==1&&h<1024:!A.isWindows&&h<1024}e.isPortPrivileged=g;let b=class{constructor(y){this.logService=y,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(y,f){return this._tunnelProvider=y,y?(this._canElevate=f.elevation,this._privacyOptions=f.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const y=[],f=Array.from(this._tunnels.values());for(let w of f){const v=Array.from(w.values());for(let p of v){const l=await p.value;l&&y.push(l)}}return y}async dispose(){for(const y of this._tunnels.values()){for(const{value:f}of y.values())await f.then(w=>w?.dispose());y.clear()}this._tunnels.clear()}openTunnel(y,f,w,v,p=!1,l=R.Private,c){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${w} on local port ${v}.`),!y)return;f||(f="localhost");const t=this.retainOrCreateTunnel(y,f,w,v,p,l,c);return t?t.then(s=>{if(!s){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(f,w);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(s);return(s.tunnelRemoteHost!==f||s.tunnelRemotePort!==w)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}makeTunnel(y){return{tunnelRemotePort:y.tunnelRemotePort,tunnelRemoteHost:y.tunnelRemoteHost,tunnelLocalPort:y.tunnelLocalPort,localAddress:y.localAddress,privacy:y.privacy,protocol:y.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${y.tunnelRemoteHost}:${y.tunnelRemotePort} `);const f=this._tunnels.get(y.tunnelRemoteHost);if(f){const w=f.get(y.tunnelRemotePort);w&&(w.refcount--,await this.tryDisposeTunnel(y.tunnelRemoteHost,y.tunnelRemotePort,w))}}}}async tryDisposeTunnel(y,f,w){if(w.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${y}:${f}.`);const v=w.value.then(async p=>{p&&(await p.dispose(!0),this._onTunnelClosed.fire({host:p.tunnelRemoteHost,port:p.tunnelRemotePort}))});return this._tunnels.has(y)&&this._tunnels.get(y).delete(f),v}}async closeTunnel(y,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${y}:${f} `);const w=this._tunnels.get(y);if(w&&w.has(f)){const v=w.get(f);v.refcount=0,await this.tryDisposeTunnel(y,f,v)}}addTunnelToMap(y,f,w){this._tunnels.has(y)||this._tunnels.set(y,new Map),this._tunnels.get(y).set(f,{refcount:1,value:w})}async removeEmptyTunnelFromMap(y,f){const w=this._tunnels.get(y);w&&(await w.get(f)||w.delete(f),w.size===0&&this._tunnels.delete(y))}getTunnelFromMap(y,f){let w=[y];n(y)?(w.push(...e.LOCALHOST_ADDRESSES),w.push(...e.ALL_INTERFACES_ADDRESSES)):I(y)&&w.push(...e.ALL_INTERFACES_ADDRESSES);const v=w.map(p=>this._tunnels.get(p));for(const p of v){const l=p?.get(f);if(l)return l}}canTunnel(y){return!!E(y)}createWithProvider(y,f,w,v,p,l,c){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${w} on local port ${v}.`);const s={elevationRequired:p?g(v===void 0?w:v):!1},r={remoteAddress:{host:f,port:w},localAddressPort:v,privacy:l,public:l!==R.Private,protocol:c},i=y.forwardPort(r,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(f,w,i),i}};b=he([X(0,T.ILogService)],b),e.AbstractTunnelService=b}),define(te[187],ne([0,1,10,61,2,8,5]),function(J,e,D,A,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends P.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new L.DeferredPromise),this._addressPromise.p)}setAddress(n){this._address=n,this._addressPromise&&(this._addressPromise.complete(n),this._addressPromise=null)}setTunnel(n){this._register(n)}}let S=class pt extends P.Disposable{constructor(n,I){super();this._tunnelService=n,this._logService=I,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(n=>n.dispose())}async createTunnel(){return{id:String(++pt._lastId)}}async startTunnel(n,I,g,b,h){const y=new R,f=await Promise.resolve(this._tunnelService.openTunnel(y,I,g,b,h));if(!f)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${I}:${g} (remote).`),y.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(n))throw this._disposedTunnels.delete(n),y.dispose(),await f.dispose(),(0,T.canceled)();return y.setTunnel(f),this._tunnels.set(n,y),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${n}: ${f.localAddress} (local) to ${I}:${g} (remote).`),{tunnelLocalPort:f.tunnelLocalPort,localAddress:f.localAddress}}async setAddress(n,I){const g=this._tunnels.get(n);!g||g.setAddress(I)}async destroyTunnel(n){const I=this._tunnels.get(n);if(I){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${n}.`),this._tunnels.delete(n),await I.dispose();return}this._disposedTunnels.add(n)}};S._lastId=0,S=he([X(0,A.ITunnelService),X(1,D.ILogService)],S),e.SharedProcessTunnelService=S}),define(te[188],ne([0,1,117,20,10]),function(J,e,D,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(R,S){this.configurationService=R,this.logService=S}request(R,S){return this.logService.trace("RequestService#request",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,D.request)(R,S)}async resolveProxy(R){}};T=he([X(0,A.IConfigurationService),X(1,P.ILogService)],T),e.RequestService=T}),define(te[43],ne([0,1,22,138,38,6,34]),function(J,e,D,A,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function R(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=R;function S(h){return h.res.statusCode===204}async function E(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);return S(h)?null:(await(0,D.streamToBuffer)(h.stream)).toString()}e.asText=E;async function n(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);if(S(h))return null;const f=(await(0,D.streamToBuffer)(h.stream)).toString();try{return JSON.parse(f)}catch(w){throw w.message+=`:
`+f,w}}e.asJson=n;function I(h){b(h)}e.updateProxyConfigurationsScope=I;let g;function b(h){const y=L.Registry.as(P.Extensions.Configuration),f=g;g={id:"http",order:15,title:(0,A.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(4,null),(0,A.localize)(5,null),(0,A.localize)(6,null),(0,A.localize)(7,null)],default:"override",description:(0,A.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(9,null),restricted:!0}}},y.updateConfigurations({add:[g],remove:f?[f]:[]})}b(2)}),define(te[189],ne([0,1,27,15,14,43]),function(J,e,D,A,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let L=class{constructor(S,E){this.requestService=S,this.fileService=E}async download(S,E,n=D.CancellationToken.None){if(S.scheme===A.Schemas.file||S.scheme===A.Schemas.vscodeRemote){await this.fileService.copy(S,E);return}const I={type:"GET",url:S.toString()},g=await this.requestService.request(I,n);if(g.res.statusCode===200)await this.fileService.writeFile(E,g.stream);else{const b=await(0,T.asText)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${b}`)}}};L=he([X(0,T.IRequestService),X(1,P.IFileService)],L),e.DownloadService=L}),define(te[190],ne([0,1,17,27,65,2,16,150,14,10,29,43]),function(J,e,D,A,P,T,L,R,S,E,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let g=class extends T.Disposable{constructor(h,y,f,w){super();this.fileService=h,this.productService=y,this.requestService=f,this.logService=w,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,P.forEach)(this.productService.configBasedExtensionTips,({value:v})=>this.allConfigBasedTips.set(v.configPath,v))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const y=[];for(const[f,w]of this.allConfigBasedTips)if(!(w.configScheme&&w.configScheme!==h.scheme))try{const v=await this.fileService.readFile((0,L.joinPath)(h,f)),p=new Map;(0,P.forEach)(w.recommendations,({key:c,value:t})=>{if((0,D.isNonEmptyArray)(t.remotes))for(const s of t.remotes)p.set(s,{extensionId:c,extensionName:t.name,configName:w.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else y.push({extensionId:c,extensionName:t.name,configName:w.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const l=(0,R.getDomainsOfRemotes)(v.value.toString(),[...p.keys()]);for(const c of l){const t=p.get(c);t&&y.push(t)}}catch(v){}return y}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},A.CancellationToken.None);if(h.res.statusCode!==200)return[];const y=await(0,I.asJson)(h);return y?y.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};g=he([X(0,S.IFileService),X(1,n.IProductService),X(2,I.IRequestService),X(3,E.ILogService)],g),e.ExtensionTipsService=g}),define(te[46],ne([0,1,22,30]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function P(T,L,R){let S=R&&R.get("storage.serviceMachineId",0)||null;if(S)return S;try{const n=(await L.readFile(T.serviceMachineIdResource)).value.toString();S=(0,A.isUUID)(n)?n:null}catch(E){S=null}if(!S){S=(0,A.generateUuid)();try{await L.writeFile(T.serviceMachineIdResource,D.VSBuffer.fromString(S))}catch(E){}}return R&&R.store("storage.serviceMachineId",S,0,1),S}e.getServiceMachineId=P}),define(te[88],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[191],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{vsda(){return new Promise((P,T)=>J(["vsda"],P,T))}async sign(P){try{const T=await this.vsda(),L=new T.signer;if(L)return L.sign(P)}catch(T){}return P}}e.SignService=D}),define(te[23],ne([0,1,5,3,2,18,71,6]),function(J,e,D,A,P,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const S="__$__targetStorageMarker";e.IStorageService=(0,R.createDecorator)("storageService");var E;(function(y){y[y.NONE=0]="NONE",y[y.SHUTDOWN=1]="SHUTDOWN"})(E=e.WillSaveStateReason||(e.WillSaveStateReason={}));var n;(function(y){y[y.GLOBAL=0]="GLOBAL",y[y.WORKSPACE=1]="WORKSPACE"})(n=e.StorageScope||(e.StorageScope={}));var I;(function(y){y[y.USER=0]="USER",y[y.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));class g extends P.Disposable{constructor(f={flushInterval:g.DEFAULT_FLUSH_INTERVAL}){super();this.options=f,this._onDidChangeValue=this._register(new A.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new A.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new A.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new P.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,P.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(f,w){w===S?(f===0?this._globalKeyTargets=void 0:f===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:f})):this._onDidChangeValue.fire({scope:f,key:w,target:this.getKeyTargets(f)[w]})}emitWillSaveState(f){this._onWillSaveState.fire({reason:f})}get(f,w,v){return this.getStorage(w)?.get(f,v)}getBoolean(f,w,v){return this.getStorage(w)?.getBoolean(f,v)}getNumber(f,w,v){return this.getStorage(w)?.getNumber(f,v)}store(f,w,v,p){if((0,T.isUndefinedOrNull)(w)){this.remove(f,v);return}this.withPausedEmitters(()=>{this.updateKeyTarget(f,v,p),this.getStorage(v)?.set(f,w)})}remove(f,w){this.withPausedEmitters(()=>{this.updateKeyTarget(f,w,void 0),this.getStorage(w)?.delete(f)})}withPausedEmitters(f){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{f()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(f,w){const v=[],p=this.getKeyTargets(f);for(const l of Object.keys(p))p[l]===w&&v.push(l);return v}updateKeyTarget(f,w,v){const p=this.getKeyTargets(w);typeof v=="number"?p[f]!==v&&(p[f]=v,this.getStorage(w)?.set(S,JSON.stringify(p))):typeof p[f]=="number"&&(delete p[f],this.getStorage(w)?.set(S,JSON.stringify(p)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(f){return f===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(f){const w=this.get(S,f);if(w)try{return JSON.parse(w)}catch(v){}return Object.create(null)}isNew(f){return this.getBoolean(e.IS_NEW_KEY,f)===!0}async flush(f=E.NONE){this._onWillSaveState.fire({reason:f}),await D.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const f=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return h(f,w,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=g,g.DEFAULT_FLUSH_INTERVAL=60*1e3;class b extends g{constructor(){super();this.globalStorage=this._register(new L.Storage(new L.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new L.Storage(new L.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(f=>this.emitDidChangeValue(1,f))),this._register(this.globalStorage.onDidChangeStorage(f=>this.emitDidChangeValue(0,f)))}getStorage(f){return f===0?this.globalStorage:this.workspaceStorage}getLogDetails(f){return f===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(f){}}e.InMemoryStorageService=b;async function h(y,f,w,v){const p=a=>{try{return JSON.parse(a)}catch(o){return a}},l=new Map,c=new Map;y.forEach((a,o)=>{l.set(o,a),c.set(o,p(a))});const t=new Map,s=new Map;f.forEach((a,o)=>{t.set(o,a),s.set(o,p(a))}),console.group(`Storage: Global (path: ${w})`);let r=[];l.forEach((a,o)=>{r.push({key:o,value:a})}),console.table(r),console.groupEnd(),console.log(c),console.group(`Storage: Workspace (path: ${v})`);let i=[];t.forEach((a,o)=>{i.push({key:o,value:a})}),console.table(i),console.groupEnd(),console.log(s)}e.logStorage=h}),define(te[192],ne([0,1,3,2,18,28,35,23]),function(J,e,D,A,P,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let S=class extends A.Disposable{constructor(I){super();this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new E(I)),this._register(this.storageManger.onDidChange(g=>this._onDidChangeEnablement.fire({extensions:g,source:"storage"})))}async enableExtension(I,g){return this._removeFromDisabledExtensions(I)?(this._onDidChangeEnablement.fire({extensions:[I],source:g}),!0):!1}async disableExtension(I,g){return this._addToDisabledExtensions(I)?(this._onDidChangeEnablement.fire({extensions:[I],source:g}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(I){let g=this.getDisabledExtensions();return g.every(b=>!(0,L.areSameExtensions)(b,I))?(g.push(I),this._setDisabledExtensions(g),!0):!1}_removeFromDisabledExtensions(I){let g=this.getDisabledExtensions();for(let b=0;b<g.length;b++){const h=g[b];if((0,L.areSameExtensions)(h,I))return g.splice(b,1),this._setDisabledExtensions(g),!0}return!1}_setDisabledExtensions(I){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,I)}_getExtensions(I){return this.storageManger.get(I,0)}_setExtensions(I,g){this.storageManger.set(I,g,0)}};S=he([X(0,R.IStorageService)],S),e.GlobalExtensionEnablementService=S;class E extends A.Disposable{constructor(I){super();this.storageService=I,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(I.onDidChangeValue(g=>this.onDidStorageChange(g)))}get(I,g){let b;return g===0?((0,P.isUndefinedOrNull)(this.storage[I])&&(this.storage[I]=this._get(I,g)),b=this.storage[I]):b=this._get(I,g),JSON.parse(b)}set(I,g,b){let h=JSON.stringify(g.map(({id:f,uuid:w})=>({id:f,uuid:w})));this._get(I,b)!==h&&(b===0&&(g.length?this.storage[I]=h:delete this.storage[I]),this._set(I,g.length?h:void 0,b))}onDidStorageChange(I){if(I.scope===0&&!(0,P.isUndefinedOrNull)(this.storage[I.key])&&this._get(I.key,I.scope)!==this.storage[I.key]){const b=this.get(I.key,I.scope);delete this.storage[I.key];const h=this.get(I.key,I.scope),y=b.filter(w=>!h.some(v=>(0,L.areSameExtensions)(w,v))),f=h.filter(w=>!b.some(v=>(0,L.areSameExtensions)(v,w)));(y.length||f.length)&&this._onDidChange.fire([...y,...f])}}_get(I,g){return this.storageService.get(I,g,"[]")}_set(I,g,b){g?this.storageService.store(I,g,b,1):this.storageService.remove(I,b)}}e.StorageManager=E}),define(te[193],ne([0,1,3,2]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class P extends A.Disposable{constructor(E,n){super();this.channel=E,this.workspace=n}async getItems(){const E={workspace:this.workspace},n=await this.channel.call("getItems",E);return new Map(n)}updateItems(E){const n={workspace:this.workspace};return E.insert&&(n.insert=Array.from(E.insert.entries())),E.delete&&(n.delete=Array.from(E.delete.values())),this.channel.call("updateItems",n)}}class T extends P{constructor(E){super(E,void 0);this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(E=>this.onDidChangeGlobalStorage(E)))}onDidChangeGlobalStorage(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this._onDidChangeItemsExternal.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}async close(){this.dispose()}}class L extends P{constructor(E,n){super(E,n);this.onDidChangeItemsExternal=D.Event.None}async close(){const E={workspace:this.workspace};return this.channel.call("close",E)}}class R extends A.Disposable{constructor(E,n){super();this.channel=E,this.workspace=n,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new T(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new L(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=R}),define(te[194],ne([0,1,5,2,174,16,71,23,193]),function(J,e,D,A,P,T,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class E extends R.AbstractStorageService{constructor(I,g,b){super();this.mainProcessService=g,this.environmentService=b,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new A.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(I)}createGlobalStorage(){const I=new S.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),g=new L.Storage(I.globalStorage);return this._register(g.onDidChangeStorage(b=>this.emitDidChangeValue(0,b))),g}createWorkspaceStorage(I){const g=new S.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),I);if(g.workspaceStorage){const b=new L.Storage(g.workspaceStorage);return this.workspaceStorageDisposable.value=b.onDidChangeStorage(h=>this.emitDidChangeValue(1,h)),this.workspaceStorageId=I?.id,b}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){(0,P.mark)("code/willInitStorage");try{await D.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}finally{(0,P.mark)("code/didInitStorage")}}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,T.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(R.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(I){const g=this.workspaceStorage,b=g?.items??new Map;g&&(await g.close(),g.dispose()),this.workspaceStorage=this.createWorkspaceStorage(I),await this.workspaceStorage.init();for(const[h,y]of b)this.workspaceStorage.set(h,y)}}e.NativeStorageService=E}),define(te[195],ne([0,1,4,31,7,30]),function(J,e,D,A,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function L(E){if(D.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}async function R(E,n,I,g,b,h,y,f,w,v){const p=Object.create(null);p["common.machineId"]=y,p.sessionID=(0,T.generateUuid)()+Date.now(),p.commitHash=b,p.version=h,p["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,D.PlatformToString)(D.platform),p["common.nodePlatform"]=A.platform,p["common.nodeArch"]=g,p["common.product"]=v||"desktop";const l=S(f||[]);l&&(p["common.msftInternal"]=l);let c=0;const t=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),D.isLinuxSnap&&(p["common.snap"]="true");const s=L(I);s&&(p["common.platformDetail"]=s);try{const r=await E.readFile(P.URI.file(w));p["common.source"]=r.value.toString().slice(0,30)}catch(r){}return p}e.resolveCommonProperties=R;function S(E){const n=A.env.USERDNSDOMAIN;if(!n)return!1;const I=n.toLowerCase();return E.some(g=>I===g)}e.verifyMicrosoftInternalDomain=S}),define(te[21],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var A;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(A=e.TelemetryLevel||(e.TelemetryLevel={}));var P;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(P=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[196],ne([0,1,33,55,5,36,15,9,4,7,109,19,112,76,14,29,21]),function(J,e,D,A,P,T,L,R,S,E,n,I,g,b,h,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function w(t,s){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],i=new Map,a=new Map,o=2e4;function u(k,_,O,N){const C=_.substring(k.length+1);return P.Promises.withAsyncBody(async F=>{let z;try{z=await I.Promises.readdir(_,{withFileTypes:!0})}catch(W){F();return}if(N.count>=o){N.count+=z.length,N.maxReached=!0,F();return}let U=z.length;if(U===0){F();return}let j=z;N.count+z.length>o&&(N.maxReached=!0,U=o-N.count,j=z.slice(0,U)),N.count+=z.length;for(const W of j)if(W.isDirectory()){if(O.includes(W.name)||await u(k,(0,R.join)(_,W.name),O,N),--U==0){F();return}}else{const x=W.name.lastIndexOf(".");if(x>=0){const q=W.name.substring(x+1);q&&i.set(q,(i.get(q)??0)+1)}for(const q of r)q.relativePathPattern?.test(C)!==!1&&q.filePattern.test(W.name)&&a.set(q.tag,(a.get(q.tag)??0)+1);if(--U==0){F();return}}})}const d={count:0,maxReached:!1};await u(t,t,s,d);const m=await l(t);return{configFiles:v(a),fileTypes:v(i),fileCount:d.count,maxFilesReached:d.maxReached,launchConfigFiles:m}}e.collectWorkspaceStats=w;function v(t){return[...A.Iterable.map(t.entries(),([s,r])=>({name:s,count:r}))].sort((s,r)=>r.count-s.count)}function p(){const t={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(n.virtualMachineHint.value()*100)}%`},s=D.cpus();return s&&s.length>0&&(t.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),t}e.getMachineInfo=p;async function l(t){try{const s=new Map,r=(0,R.join)(t,".vscode","launch.json"),i=await I.Promises.readFile(r),a=[],o=(0,T.parse)(i.toString(),a);if(a.length)return console.log(`Unable to parse ${r}`),[];if((0,T.getNodeType)(o)==="object"&&o.configurations)for(const u of o.configurations){const d=u.type;d&&(s.has(d)?s.set(d,s.get(d)+1):s.set(d,1))}return v(s)}catch(s){return[]}}e.collectLaunchConfigs=l;let c=class{constructor(s,r){this.telemetryService=s,this.productService=r}formatMachineInfo(s){const r=[];return r.push(`OS Version:       ${s.os}`),r.push(`CPUs:             ${s.cpus}`),r.push(`Memory (System):  ${s.memory}`),r.push(`VM:               ${s.vmHint}`),r.join(`
`)}formatEnvironment(s){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const i=D.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(D.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),S.isWindows||r.push(`Load (avg):       ${D.loadavg().map(a=>Math.round(a)).join(", ")}`),r.push(`VM:               ${Math.round(n.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${s.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(s.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(s,r){return Promise.all([(0,g.listProcesses)(s.mainPID),this.formatWorkspaceMetadata(s)]).then(async i=>{let[a,o]=i,u=this.formatProcessList(s,a);return r.forEach(d=>{if((0,b.isRemoteDiagnosticError)(d))u+=`
${d.errorMessage}`,o+=`
${d.errorMessage}`;else if(u+=`

Remote: ${d.hostName}`,d.processes&&(u+=`
${this.formatProcessList(s,d.processes)}`),d.workspaceMetadata){o+=`
|  Remote: ${d.hostName}`;for(const m of Object.keys(d.workspaceMetadata)){const k=d.workspaceMetadata[m];let _=`${k.fileCount} files`;k.maxFilesReached&&(_=`more than ${_}`),o+=`|    Folder (${m}): ${_}`,o+=this.formatWorkspaceStats(k)}}}),{processInfo:u,workspaceInfo:o}})}async getSystemInfo(s,r){const{memory:i,vmHint:a,os:o,cpus:u}=p(),d={os:o,memory:i,cpus:u,vmHint:a,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:r};return S.isWindows||(d.load=`${D.loadavg().map(m=>Math.round(m)).join(", ")}`),S.isLinux&&(d.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(d)}async getDiagnostics(s,r){const i=[];return(0,g.listProcesses)(s.mainPID).then(async a=>(i.push(""),i.push(this.formatEnvironment(s)),i.push(""),i.push(this.formatProcessList(s,a)),s.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(s))),r.forEach(o=>{if((0,b.isRemoteDiagnosticError)(o))i.push(`
${o.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${o.hostName}`),i.push(this.formatMachineInfo(o.machineInfo)),o.processes&&i.push(this.formatProcessList(s,o.processes)),o.workspaceMetadata)for(const u of Object.keys(o.workspaceMetadata)){const d=o.workspaceMetadata[u];let m=`${d.fileCount} files`;d.maxFilesReached&&(m=`more than ${m}`),i.push(`Folder (${u}): ${m}`),i.push(this.formatWorkspaceStats(d))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(s){const r=[],i=60;let a=0;const o=(k,_)=>{const O=` ${k}(${_})`;a+O.length>i?(r.push(u),u="|                 ",a=u.length):a+=O.length,u+=O};let u="|      File types:";const d=10;let m=s.fileTypes.length>d?d:s.fileTypes.length;for(let k=0;k<m;k++){const _=s.fileTypes[k];o(_.name,_.count)}if(r.push(u),s.configFiles.length>=0&&(u="|      Conf files:",a=0,s.configFiles.forEach(k=>{o(k.name,k.count)}),r.push(u)),s.launchConfigFiles.length>0){let k="|      Launch Configs:";s.launchConfigFiles.forEach(_=>{k+=_.count>1?` ${_.name}(${_.count})`:` ${_.name}`}),r.push(k)}return r.join(`
`)}expandGPUFeatures(s){const r=Math.max(...Object.keys(s).map(i=>i.length));return Object.keys(s).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${s[i]}`).join(`
                  `)}formatWorkspaceMetadata(s){const r=[],i=[];return s.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(r.push(`|  Window (${a.title})`),a.folderURIs.forEach(o=>{const u=E.URI.revive(o);if(u.scheme===L.Schemas.file){const d=u.fsPath;i.push(w(d,["node_modules",".git"]).then(m=>{let k=`${m.fileCount} files`;m.maxFilesReached&&(k=`more than ${k}`),r.push(`|    Folder (${(0,R.basename)(d)}): ${k}`),r.push(this.formatWorkspaceStats(m))}).catch(m=>{r.push(`|      Error: Unable to collect workspace stats for folder ${d} (${m.toString()})`)}))}else r.push(`|    Folder (${u.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(a=>r.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(s,r){const i=new Map;s.windows.forEach(o=>i.set(o.pid,o.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(s.mainPID,i,a,r,0),a.join(`
`)}formatProcessItem(s,r,i,a,o){const u=o===0;let d;u?d=a.pid===s?`${this.productService.applicationName} main`:"remote agent":(d=`${"  ".repeat(o)} ${a.name}`,a.name==="window"&&(d=`${d} (${r.get(a.pid)})`));const m=process.platform==="win32"?a.mem:D.totalmem()*(a.mem/100);i.push(`${a.load.toFixed(0).padStart(5," ")}	${(m/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${d}`),Array.isArray(a.children)&&a.children.forEach(k=>this.formatProcessItem(s,r,i,k,o+1))}async reportWorkspaceStats(s){for(const{uri:r}of s.folders){const i=E.URI.revive(r);if(i.scheme!==L.Schemas.file)continue;const a=i.fsPath;try{const o=await w(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),o.fileTypes.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:u.name,count:u.count})}),o.launchConfigFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:u.name,count:u.count})}),o.configFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:u.name,count:u.count})})}catch{}}}};c=he([X(0,f.ITelemetryService),X(1,y.IProductService)],c),e.DiagnosticsService=c}),define(te[197],ne([0,1,17,5,27,8,3,2,4,7,127,28,35,10,42,21]),function(J,e,D,A,P,T,L,R,S,E,n,I,g,b,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.INSTALL_ERROR_LOCAL=e.ERROR_UNKNOWN=e.INSTALL_ERROR_VALIDATING=void 0,e.INSTALL_ERROR_VALIDATING="validating",e.ERROR_UNKNOWN="unknown",e.INSTALL_ERROR_LOCAL="local";let f=class extends R.Disposable{constructor(c,t,s){super();this.galleryService=c,this.telemetryService=t,this.logService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new L.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new L.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new L.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new L.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(r=>r.cancel()),this.uninstallingExtensions.forEach(r=>r.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(c){const t=await this.getTargetPlatform();return c.allTargetPlatforms.some(s=>(0,I.isTargetPlatformCompatible)(s,c.allTargetPlatforms,t))}async installFromGallery(c,t={}){if(!this.galleryService.isEnabled())throw new Error(n.localize(0,null));if(!await this.canInstall(c)){const r=await this.getTargetPlatform(),i=new I.ExtensionManagementError(n.localize(1,null,c.identifier.id,h.default.nameLong,(0,I.TargetPlatformToString)(r)),e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension.",c.identifier.id,i.message),v(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(c),void 0,i),i}try{c=await this.checkAndGetCompatibleVersion(c,!t.installGivenVersion)}catch(r){throw this.logService.error((0,T.getErrorMessage)(r)),v(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(c),void 0,r),r}const s=await this.galleryService.getManifest(c,P.CancellationToken.None);if(s===null){const r=new I.ExtensionManagementError(`Missing manifest for extension ${c.identifier.id}`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",c.identifier.id,r.message),v(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(c),void 0,r),r}if(s.version!==c.version){const r=new I.ExtensionManagementError(`Cannot install '${c.identifier.id}' extension because of version mismatch in Marketplace`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error(r.message),v(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(c),void 0,r),r}return this.installExtension(s,c,t)}async uninstall(c,t={}){return this.logService.trace("ExtensionManagementService#uninstall",c.identifier.id),this.unininstallExtension(c,t)}async reinstallFromGallery(c){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",c.identifier.id),!this.galleryService.isEnabled())throw new Error(n.localize(2,null));const t=await this.findGalleryExtension(c);if(!t)throw new Error(n.localize(3,null));await this.createUninstallExtensionTask(c,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(t)}getExtensionsReport(){const c=new Date().getTime();return(!this.reportedExtensions||c-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=c),this.reportedExtensions}registerParticipant(c){this.participants.push(c)}async installExtension(c,t,s){if(!E.URI.isUri(t)){let u=this.installingExtensions.get(new g.ExtensionIdentifierWithVersion(t.identifier,t.version).key());if(u)return this.logService.info("Extensions is already requested to install",t.identifier.id),u.waitUntilTaskIsFinished();s={...s,installOnlyNewlyAddedFromExtensionPack:!0}}const r=[],i=[],a=this.createInstallExtensionTask(c,t,s);E.URI.isUri(t)||this.installingExtensions.set(new g.ExtensionIdentifierWithVersion(a.identifier,c.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:t}),this.logService.info("Installing extension:",a.identifier.id),r.push({task:a,manifest:c});let o=!1;try{if(s.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const d=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,c,!!s.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:m,manifest:k}of d)if(o=o||!!k.extensionDependencies?.some(_=>(0,g.areSameExtensions)({id:_},a.identifier)),this.installingExtensions.has(new g.ExtensionIdentifierWithVersion(m.identifier,m.version).key()))this.logService.info("Extension is already requested to install",m.identifier.id);else{const _=this.createInstallExtensionTask(k,m,{...s,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new g.ExtensionIdentifierWithVersion(_.identifier,k.version).key(),_),this._onInstallExtension.fire({identifier:_.identifier,source:m}),this.logService.info("Installing extension:",_.identifier.id),r.push({task:_,manifest:k})}}catch(d){if(E.URI.isUri(a.source))(0,D.isNonEmptyArray)(c.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,d.message),(0,D.isNonEmptyArray)(c.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,d.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),this.logService.error(d),d}const u=r.reduce((d,{task:m,manifest:k})=>(d.set(m.identifier.id.toLowerCase(),{task:m,manifest:k}),d),new Map);for(;u.size;){let d;const m=[...u.values()].filter(({manifest:k})=>!k.extensionDependencies?.some(_=>u.has(_.toLowerCase())));m.length?d=u.size===1?m:m.filter(({task:k})=>!(k===a&&!o)):(this.logService.info("Found extensions with circular dependencies",m.map(({task:k})=>k.identifier.id)),d=[...u.values()]),await this.joinAllSettled(d.map(async({task:k})=>{const _=new Date().getTime();try{const O=await k.run();if(await this.joinAllSettled(this.participants.map(N=>N.postInstall(O,k.source,s,P.CancellationToken.None))),!E.URI.isUri(k.source)&&(v(this.telemetryService,k.operation===2?"extensionGallery:update":"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(k.source),new Date().getTime()-_,void 0),S.isWeb&&k.operation===1))try{await this.galleryService.reportStatistic(O.manifest.publisher,O.manifest.name,O.manifest.version,"install")}catch(N){}i.push({local:O,identifier:k.identifier,operation:k.operation,source:k.source})}catch(O){throw E.URI.isUri(k.source)||v(this.telemetryService,k.operation===2?"extensionGallery:update":"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(k.source),new Date().getTime()-_,O),this.logService.error("Error while installing the extension:",k.identifier.id),this.logService.error(O),O}finally{u.delete(k.identifier.id.toLowerCase())}}))}return i.forEach(({identifier:d})=>this.logService.info("Extension installed successfully:",d.id)),this._onDidInstallExtensions.fire(i),i.filter(({identifier:d})=>(0,g.areSameExtensions)(d,a.identifier))[0].local}catch(u){if(r.forEach(({task:d})=>d.cancel()),i.length)try{const d=await Promise.allSettled(i.map(({local:m})=>this.createUninstallExtensionTask(m,{versionOnly:!0}).run()));for(let m=0;m<d.length;m++){const k=d[m],{identifier:_}=i[m];k.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",_.id):this.logService.warn("Rollback: Error while uninstalling extension",_.id,(0,T.getErrorMessage)(k.reason))}}catch(d){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(d),i.map(({identifier:m})=>m.id))}throw this.logService.error("Failed to install extension:",a.identifier.id,(0,T.getErrorMessage)(u)),this._onDidInstallExtensions.fire(r.map(({task:d})=>({identifier:d.identifier,operation:1,source:d.source}))),u instanceof Error&&(u.name=u&&u.code?u.code:e.ERROR_UNKNOWN),u}finally{for(const{task:u,manifest:d}of r)if(!E.URI.isUri(u.source)){const m=new g.ExtensionIdentifierWithVersion(u.identifier,d.version).key();this.installingExtensions.delete(m)||this.logService.warn("Installation task is not found in the cache",m)}}}async joinAllSettled(c){const t=[],s=[],r=await Promise.allSettled(c);for(const i of r)i.status==="fulfilled"?t.push(i.value):s.push(i.reason);if(s.length)throw w(s);return t}async getAllDepsAndPackExtensionsToInstall(c,t,s){if(!this.galleryService.isEnabled())return[];let r=await this.getInstalled();const i=[c,...r.map(u=>u.identifier)],a=[],o=async(u,d)=>{const m=d.extensionDependencies||[],k=[...m];if(d.extensionPack){const _=s?r.find(O=>(0,g.areSameExtensions)(O.identifier,u)):void 0;for(const O of d.extensionPack)_&&_.manifest.extensionPack&&_.manifest.extensionPack.some(N=>(0,g.areSameExtensions)({id:N},{id:O}))||k.every(N=>!(0,g.areSameExtensions)({id:N},{id:O}))&&k.push(O)}if(k.length){const _=[...i,...a.map(N=>N.gallery.identifier)],O=k.filter(N=>_.every(C=>!(0,g.areSameExtensions)(C,{id:N})));if(O.length){const N=await this.galleryService.query({names:O,pageSize:k.length},P.CancellationToken.None);for(const C of N.firstPage){if(_.find(j=>(0,g.areSameExtensions)(j,C.identifier)))continue;if(!m.some(j=>(0,g.areSameExtensions)({id:j},C.identifier))&&!await this.canInstall(C)){this.logService.info("Skipping the packed extension as it cannot be installed",C.identifier.id);continue}const z=await this.checkAndGetCompatibleVersion(C,!0),U=await this.galleryService.getManifest(z,P.CancellationToken.None);if(U===null)throw new I.ExtensionManagementError(`Missing manifest for extension ${z.identifier.id}`,e.INSTALL_ERROR_VALIDATING);a.push({gallery:z,manifest:U}),await o(z.identifier,U)}}}};return await o(c,t),r=await this.getInstalled(),a.filter(u=>!r.some(d=>(0,g.areSameExtensions)(d.identifier,u.gallery.identifier)))}async checkAndGetCompatibleVersion(c,t){if(await this.isMalicious(c))throw new I.ExtensionManagementError(n.localize(4,null,c.identifier.id),I.INSTALL_ERROR_MALICIOUS);const s=await this.getCompatibleVersion(c,t);if(!s)throw new I.ExtensionManagementError(n.localize(5,null,c.identifier.id,h.default.version),I.INSTALL_ERROR_INCOMPATIBLE);return s}async getCompatibleVersion(c,t){const s=await this.getTargetPlatform();let r=null;return await this.galleryService.isExtensionCompatible(c,s)&&(r=c),!r&&t&&(r=await this.galleryService.getCompatibleExtension(c,s)),r}async isMalicious(c){const t=await this.getExtensionsReport();return(0,g.getMaliciousExtensionsSet)(t).has(c.identifier.id)}async unininstallExtension(c,t){const s=this.uninstallingExtensions.get(c.identifier.id.toLowerCase());if(s)return this.logService.info("Extensions is already requested to uninstall",c.identifier.id),s.waitUntilTaskIsFinished();const r=(u,d)=>{const m=this.createUninstallExtensionTask(u,d);return this.uninstallingExtensions.set(m.extension.identifier.id.toLowerCase(),m),this.logService.info("Uninstalling extension:",u.identifier.id),this._onUninstallExtension.fire(u.identifier),m},i=(u,d)=>{d?this.logService.error("Failed to uninstall extension:",u.identifier.id,d.message):this.logService.info("Successfully uninstalled extension:",u.identifier.id),v(this.telemetryService,"extensionGallery:uninstall",(0,g.getLocalExtensionTelemetryData)(u),void 0,d),this._onDidUninstallExtension.fire({identifier:u.identifier,error:d?.code})},a=[],o=[];try{a.push(r(c,{}));const u=await this.getInstalled(1);if(t.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",c.identifier.id);else{const d=this.getAllPackExtensionsToUninstall(c,u);for(const m of d)this.uninstallingExtensions.has(m.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",m.identifier.id):a.push(r(m,{}))}t.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",c.identifier.id):this.checkForDependents(a.map(d=>d.extension),u,c),await this.joinAllSettled(a.map(async d=>{try{if(await d.run(),await this.joinAllSettled(this.participants.map(m=>m.postUninstall(d.extension,t,P.CancellationToken.None))),d.extension.identifier.uuid)try{await this.galleryService.reportStatistic(d.extension.manifest.publisher,d.extension.manifest.name,d.extension.manifest.version,"uninstall")}catch(m){}i(d.extension)}catch(m){const k=m instanceof I.ExtensionManagementError?m:new I.ExtensionManagementError((0,T.getErrorMessage)(m),e.ERROR_UNKNOWN);throw i(d.extension,k),k}finally{o.push(d)}}))}catch(u){const d=u instanceof I.ExtensionManagementError?u:new I.ExtensionManagementError((0,T.getErrorMessage)(u),e.ERROR_UNKNOWN);for(const m of a){try{m.cancel()}catch(k){}o.includes(m)||i(m.extension,d)}throw d}finally{for(const u of a)this.uninstallingExtensions.delete(u.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",u.extension.identifier.id)}}checkForDependents(c,t,s){for(const r of c){const i=this.getDependents(r,t);if(i.length){const a=i.filter(o=>!c.some(u=>(0,g.areSameExtensions)(u.identifier,o.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(r,a,s))}}}getDependentsErrorMessage(c,t,s){return s===c?t.length===1?n.localize(6,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?n.localize(7,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):n.localize(8,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):t.length===1?n.localize(9,null,s.manifest.displayName||s.manifest.name,c.manifest.displayName||c.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?n.localize(10,null,s.manifest.displayName||s.manifest.name,c.manifest.displayName||c.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):n.localize(11,null,s.manifest.displayName||s.manifest.name,c.manifest.displayName||c.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name)}getAllPackExtensionsToUninstall(c,t,s=[]){if(s.indexOf(c)!==-1)return[];s.push(c);const r=c.manifest.extensionPack?c.manifest.extensionPack:[];if(r.length){const i=t.filter(o=>!o.isBuiltin&&r.some(u=>(0,g.areSameExtensions)({id:u},o.identifier))),a=[];for(const o of i)a.push(...this.getAllPackExtensionsToUninstall(o,t,s));return[...i,...a]}return[]}getDependents(c,t){return t.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(r=>(0,g.areSameExtensions)({id:r},c.identifier)))}async findGalleryExtension(c){if(c.identifier.uuid){const t=await this.findGalleryExtensionById(c.identifier.uuid);return t||this.findGalleryExtensionByName(c.identifier.id)}return this.findGalleryExtensionByName(c.identifier.id)}async findGalleryExtensionById(c){return(await this.galleryService.query({ids:[c],pageSize:1},P.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(c){return(await this.galleryService.query({names:[c],pageSize:1},P.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const c=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${c.length} reported extensions from service`),c}catch(c){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};f=he([X(0,I.IExtensionGalleryService),X(1,y.ITelemetryService),X(2,b.ILogService)],f),e.AbstractExtensionManagementService=f;function w(l){const c=Array.isArray(l)?l:[l];return c.length===1?c[0]instanceof Error?c[0]:new Error(c[0]):c.reduce((t,s)=>new Error(`${t.message}${t.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=w;function v(l,c,t,s,r){const i=r?r instanceof I.ExtensionManagementError?r.code:e.ERROR_UNKNOWN:void 0;l.publicLogError(c,{...t,success:!r,duration:s,errorcode:i})}e.reportTelemetry=v;class p{constructor(){this.barrier=new A.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,A.createCancelablePromise)(c=>this.doRun(c))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,A.createCancelablePromise)(c=>new Promise((t,s)=>{const r=c.onCancellationRequested(()=>{r.dispose(),s((0,T.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=p}),define(te[198],ne([0,1,17,5,65,3,9,4,31,7,129,13,28,190,78,14,10,59,29,43,23,21]),function(J,e,D,A,P,T,L,R,S,E,n,I,g,b,h,y,f,w,v,p,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",s="extensionTips/lastPromptedMediumImpExeTime";let r=class extends b.ExtensionTipsService{constructor(a,o,u,d,m,k,_,O,N,C){super(_,O,N,C);this.environmentService=a,this.telemetryService=o,this.extensionManagementService=u,this.storageService=d,this.nativeHostService=m,this.extensionRecommendationNotificationService=k,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&(0,P.forEach)(O.exeBasedExtensionTips,({key:F,value:z})=>{const U=[],j=[],W=[];(0,P.forEach)(z.recommendations,({key:x,value:q})=>{q.important?z.important?U.push({extensionId:x,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):j.push({extensionId:x,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):W.push({extensionId:x,extensionName:q.name,isExtensionPack:!!q.isExtensionPack})}),U.length&&this.highImportanceExecutableTips.set(F,{exeFriendlyName:z.friendlyName,windowsPath:z.windowsPath,recommendations:U}),j.length&&this.mediumImportanceExecutableTips.set(F,{exeFriendlyName:z.friendlyName,windowsPath:z.windowsPath,recommendations:j}),W.length&&this.allOtherExecutableTips.set(F,{exeFriendlyName:z.friendlyName,windowsPath:z.windowsPath,recommendations:W})}),(0,A.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const a=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...a,...o]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const a=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(a,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(o,u)}groupImportantTipsByExe(a,o){const u=new Map;a.forEach(O=>u.set(O.extensionId.toLowerCase(),O));const{installed:d,uninstalled:m}=this.groupByInstalled([...u.keys()],o);for(const O of d){const N=u.get(O);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:N.exeName})}for(const O of m){const N=u.get(O);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:N.exeName})}const k=this.getPromptedExecutableTips(),_=new Map;for(const O of m){const N=u.get(O);if(N&&(!k[N.exeName]||!k[N.exeName].includes(N.extensionId))){let C=_.get(N.exeName);C||(C=[],_.set(N.exeName,C)),C.push(N)}}return _}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[a,o]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(o[0].exeName,o);break;case"ignored":this.highImportanceTipsByExe.delete(a);break;case"incompatibleWindow":const d=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(d(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const m=this._register((0,A.disposableTimeout)(()=>{m.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const a=this.getLastPromptedMediumExeTime(),o=Date.now()-a,u=7*24*60*60*1e3;if(o<u){const k=this._register((0,A.disposableTimeout)(()=>{k.dispose(),this.promptMediumImportanceExeBasedTip()},u-o));return}const[d,m]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(m).then(k=>{switch(k){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(d),this.addToRecommendedExecutables(m[0].exeName,m);const _=this._register((0,A.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},u));break;case"ignored":this.mediumImportanceTipsByExe.delete(d),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const O=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(O(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const N=this._register((0,A.disposableTimeout)(()=>{N.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(a){const o=a.map(({extensionId:d})=>d.toLowerCase()),u=(0,n.localize)(0,null,a[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(o,u,`@exe:"${a[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let a=this.storageService.getNumber(s,0);return a||(a=Date.now(),this.updateLastPromptedMediumExeTime(a)),a}updateLastPromptedMediumExeTime(a){this.storageService.store(s,a,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(a,o){const u=this.getPromptedExecutableTips();u[a]=o.map(({extensionId:d})=>d.toLowerCase()),this.storageService.store(t,JSON.stringify(u),0,0)}groupByInstalled(a,o){const u=[],d=[],m=o.reduce((k,_)=>(k.add(_.identifier.id.toLowerCase()),k),new Set);return a.forEach(k=>{m.has(k.toLowerCase())?u.push(k):d.push(k)}),{installed:u,uninstalled:d}}async getValidExecutableBasedExtensionTips(a){const o=[],u=new Map;for(const d of a.keys()){const m=a.get(d);if(!m||!(0,D.isNonEmptyArray)(m.recommendations))continue;const k=[];R.isWindows?m.windowsPath&&k.push(m.windowsPath.replace("%USERPROFILE%",S.env.USERPROFILE).replace("%ProgramFiles(x86)%",S.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",S.env.ProgramFiles).replace("%APPDATA%",S.env.APPDATA).replace("%WINDIR%",S.env.WINDIR)):(k.push((0,L.join)("/usr/local/bin",d)),k.push((0,L.join)("/usr/bin",d)),k.push((0,L.join)(this.environmentService.userHome.fsPath,d)));for(const _ of k){let O=u.get(_);if(O===void 0&&(O=await this.fileService.exists(E.URI.file(_)),u.set(_,O)),O)for(const{extensionId:N,extensionName:C,isExtensionPack:F}of m.recommendations)o.push({extensionId:N,extensionName:C,isExtensionPack:F,exeName:d,exeFriendlyName:m.exeFriendlyName,windowsPath:m.windowsPath})}}return o}};r=he([X(0,I.INativeEnvironmentService),X(1,c.ITelemetryService),X(2,g.IExtensionManagementService),X(3,l.IStorageService),X(4,w.INativeHostService),X(5,h.IExtensionRecommendationNotificationService),X(6,y.IFileService),X(7,v.IProductService),X(8,p.IRequestService),X(9,f.ILogService)],r),e.ExtensionTipsService=r}),define(te[89],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(T){this.appenders=T}listen(T,L){throw new Error(`Event not found: ${L}`)}call(T,L,{eventName:R,data:S}){return this.appenders.forEach(E=>E.log(R,S)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class A{constructor(T){this.channel=T}log(T,L){return this.channel.call("log",{eventName:T,data:L}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=A}),define(te[47],ne([0,1,26,18,20,21]),function(J,e,D,A,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class L{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(w,v){return Promise.resolve(void 0)}publicLog2(w,v){return this.publicLog(w,v)}publicLogError(w,v){return Promise.resolve(void 0)}publicLogError2(w,v){return this.publicLogError(w,v)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=L,e.NullTelemetryService=new L;class R{async publicLog(w,v,p){}async publicLogError(w,v,p){}}e.NullEndpointTelemetryService=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(f,w){return w.onDidChangeConfiguration(v=>{v.source!==6&&f.publicLog2("updateConfiguration",{configurationSource:(0,P.ConfigurationTargetToString)(v.source),configurationKeys:h(v.sourceConfig)})})}e.configurationTelemetry=S;function E(f,w){return!(w.disableTelemetry||!f.enableTelemetry)}e.supportsTelemetry=E;function n(f){const w=f.getValue(T.TELEMETRY_SETTING_ID),v=f.getValue("telemetry.enableCrashReporter");if(f.getValue(T.TELEMETRY_OLD_SETTING_ID)===!1||v===!1)return 0;switch(w??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=n;function I(f){const w=Object.create(null),v=Object.create(null),p=Object.create(null);b(f,p);for(let l in p){l=l.length>150?l.substr(l.length-149):l;const c=p[l];typeof c=="number"?v[l]=c:typeof c=="boolean"?v[l]=c?1:0:typeof c=="string"?w[l]=c.substring(0,1023):typeof c!="undefined"&&c!==null&&(w[l]=c)}return{properties:w,measurements:v}}e.validateTelemetryData=I;function g(f){if(!f)return"none";let w="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(p=>{f.indexOf(`${p}+`)===0&&(w=p)}),w}e.cleanRemoteAuthority=g;function b(f,w,v=0,p){if(!!f)for(let l of Object.getOwnPropertyNames(f)){const c=f[l],t=p?p+l:l;Array.isArray(c)?w[t]=(0,D.safeStringify)(c):c instanceof Date?w[t]=c.toISOString():(0,A.isObject)(c)?v<2?b(c,w,v+1,t+"."):w[t]=(0,D.safeStringify)(c):w[t]=c}}function h(f){if(!f)return[];const w=[];return y(w,"",f),w}function y(f,w,v){v&&typeof v=="object"&&!Array.isArray(v)?Object.keys(v).forEach(p=>y(f,w?`${w}.${p}`:p,v[p])):f.push(w)}}),define(te[199],ne([0,1,17,27,8,26,4,31,7,20,13,28,35,74,14,10,29,43,46,23,21,47]),function(J,e,D,A,P,T,L,R,S,E,n,I,g,b,h,y,f,w,v,p,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const t=L.isWeb?"web":(0,I.getTargetPlatform)(L.platform,R.arch);var s;(function(K){K[K.None=0]="None",K[K.IncludeVersions=1]="IncludeVersions",K[K.IncludeFiles=2]="IncludeFiles",K[K.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",K[K.IncludeSharedAccounts=8]="IncludeSharedAccounts",K[K.IncludeVersionProperties=16]="IncludeVersionProperties",K[K.ExcludeNonValidated=32]="ExcludeNonValidated",K[K.IncludeInstallationTargets=64]="IncludeInstallationTargets",K[K.IncludeAssetUri=128]="IncludeAssetUri",K[K.IncludeStatistics=256]="IncludeStatistics",K[K.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",K[K.Unpublished=4096]="Unpublished"})(s||(s={}));function r(...K){return String(K.reduce((H,re)=>H|re,0))}var i;(function(K){K[K.Tag=1]="Tag",K[K.ExtensionId=4]="ExtensionId",K[K.Category=5]="Category",K[K.ExtensionName=7]="ExtensionName",K[K.Target=8]="Target",K[K.Featured=9]="Featured",K[K.SearchText=10]="SearchText",K[K.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},d={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class m{constructor(H=d){this.state=H}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(H,re=this.state.pageSize){return new m({...this.state,pageNumber:H,pageSize:re})}withFilter(H,...re){const ie=[...this.state.criteria,...re.length?re.map(ae=>({filterType:H,value:ae})):[{filterType:H}]];return new m({...this.state,criteria:ie})}withSortBy(H){return new m({...this.state,sortBy:H})}withSortOrder(H){return new m({...this.state,sortOrder:H})}withFlags(...H){return new m({...this.state,flags:H.reduce((re,ie)=>re|ie,0)})}withAssetTypes(...H){return new m({...this.state,assetTypes:H})}get raw(){const{criteria:H,pageNumber:re,pageSize:ie,sortBy:ae,sortOrder:ue,flags:fe,assetTypes:de}=this.state;return{filters:[{criteria:H,pageNumber:re,pageSize:ie,sortBy:ae,sortOrder:ue}],assetTypes:de,flags:fe}}get searchText(){const H=this.state.criteria.filter(re=>re.filterType===i.SearchText)[0];return H&&H.value?H.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(H=>String(H.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function k(K,H){const re=(K||[]).filter(ie=>ie.statisticName===H)[0];return re?re.value:0}function _(K){const H="Microsoft.VisualStudio.Code.Translation.";return K.files.filter(ie=>ie.assetType.indexOf(H)===0).reduce((ie,ae)=>{const ue=F(K,ae.assetType);return ue&&ie.push([ae.assetType.substring(H.length),ue]),ie},[])}function O(K){if(K.properties){const H=K.properties.filter(ae=>ae.key===a.Repository),re=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=H.filter(ae=>re.test(ae.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return F(K,a.Repository)}function N(K){return{uri:`${K.fallbackAssetUri}/${a.VSIX}?redirect=true${K.targetPlatform?`&targetPlatform=${K.targetPlatform}`:""}`,fallbackUri:`${K.fallbackAssetUri}/${a.VSIX}${K.targetPlatform?`?targetPlatform=${K.targetPlatform}`:""}`}}function C(K){const H=F(K,a.Icon);if(H)return H;const re=I.DefaultIconPath;return{uri:re,fallbackUri:re}}function F(K,H){return K.files.filter(ie=>ie.assetType===H)[0]?{uri:`${K.assetUri}/${H}`,fallbackUri:`${K.fallbackAssetUri}/${H}`}:null}function z(K,H){const re=K.properties?K.properties.filter(ae=>ae.key===H):[],ie=re.length>0&&re[0].value;return ie?ie.split(",").map(ae=>(0,g.adoptToGalleryExtensionId)(ae)):[]}function U(K){const H=K.properties?K.properties.filter(re=>re.key===o.Engine):[];return H.length>0&&H[0].value||""}function j(K){const H=K.properties?K.properties.filter(ie=>ie.key===o.LocalizedLanguages):[],re=H.length>0&&H[0].value||"";return re?re.split(","):[]}function W(K){return K.indexOf("preview")!==-1}function x(K){return K.targetPlatform?(0,I.toTargetPlatform)(K.targetPlatform):"undefined"}function q(K){const H=(0,D.distinct)(K.versions.map(x)),re=!!K.tags?.includes(I.WEB_EXTENSION_TAG),ie=H.indexOf("web");return re?ie===-1&&H.push("web"):ie!==-1&&H.splice(ie,1),H}function $(K,H){const re=(0,I.getFallbackTargetPlarforms)(H);for(let ie=0;ie<K.length;ie++){const ae=K[ie];if(ae.version===K[ie-1]?.version){let ue=ie;const fe=x(ae);if(fe===H)for(;ue>0&&K[ue-1].version===ae.version;)ue--;else if(re.includes(fe))for(;ue>0&&K[ue-1].version===ae.version&&x(K[ue-1])!==H;)ue--;ue!==ie&&(K.splice(ie,1),K.splice(ue,0,ae))}}return K}e.sortExtensionVersions=$;function G(K,H,re,ie,ae){const ue=q(K);let fe=K.versions[0];return fe=K.versions.find(de=>de.version===fe.version&&(0,I.isTargetPlatformCompatible)(x(de),ue,ae))||fe,M(K,fe,ue,H,re,ie)}function M(K,H,re,ie,ae,ue){const fe={manifest:F(H,a.Manifest),readme:F(H,a.Details),changelog:F(H,a.Changelog),license:F(H,a.License),repository:O(H),download:N(H),icon:C(H),coreTranslations:_(H)};return{identifier:{id:(0,g.getGalleryExtensionId)(K.publisher.publisherName,K.extensionName),uuid:K.extensionId},name:K.extensionName,version:H.version,displayName:K.displayName,publisherId:K.publisher.publisherId,publisher:K.publisher.publisherName,publisherDisplayName:K.publisher.displayName,description:K.shortDescription||"",installCount:k(K.statistics,"install"),rating:k(K.statistics,"averagerating"),ratingCount:k(K.statistics,"ratingcount"),categories:K.categories||[],tags:K.tags||[],releaseDate:Date.parse(K.releaseDate),lastUpdated:Date.parse(K.lastUpdated),allTargetPlatforms:re,assets:fe,properties:{dependencies:z(H,o.Dependency),extensionPack:z(H,o.ExtensionPack),engine:U(H),localizedLanguages:j(H),targetPlatform:x(H)},preview:W(K.flags),telemetryData:{index:(ae.pageNumber-1)*ae.pageSize+ie,querySource:ue}}}let B=class{constructor(H,re,ie,ae,ue,fe,de,Ie){this.requestService=re,this.logService=ie,this.environmentService=ae,this.telemetryService=ue,this.fileService=fe,this.productService=de,this.configurationService=Ie;const Ce=de.extensionsGallery;this.extensionsGalleryUrl=Ce&&Ce.serviceUrl,this.extensionsControlUrl=Ce&&Ce.controlUrl,this.commonHeadersPromise=Z(de.version,de,this.environmentService,this.configurationService,this.fileService,H)}api(H=""){return`${this.extensionsGalleryUrl}${H}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(H,re){const ie=[];let ae=new m().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,H.length).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExtensionName,...H.map(({id:fe})=>fe.toLowerCase()));H.every(fe=>!fe.version)&&(ae=ae.withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties,s.IncludeLatestVersionOnly));const{galleryExtensions:ue}=await this.queryGallery(ae,t,A.CancellationToken.None);for(let fe=0;fe<ue.length;fe++){const de=ue[fe];if(!de.versions.length)continue;const Ie=(0,g.getGalleryExtensionId)(de.publisher.publisherName,de.extensionName),Ce=H.find(Ee=>(0,g.areSameExtensions)(Ee,{id:Ie}))?.version;if(Ce){const Ee=de.versions.find(_e=>_e.version===Ce);Ee&&ie.push(M(de,Ee,q(de),fe,ae))}else ie.push(G(de,fe,ae,void 0,t))}return ie}async getCompatibleExtension(H,re){const ie=(0,I.isIExtensionIdentifier)(H)?null:H;if(ie){if((0,I.isNotWebExtensionInWebTargetPlatform)(ie.allTargetPlatforms,re))return null;if(await this.isExtensionCompatible(ie,re))return ie}const{id:ae,uuid:ue}=ie?ie.identifier:H;let fe=new m().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");ue?fe=fe.withFilter(i.ExtensionId,ue):fe=fe.withFilter(i.ExtensionName,ae);const{galleryExtensions:de}=await this.queryGallery(fe,re,A.CancellationToken.None),[Ie]=de;if(!Ie||!Ie.versions.length)return null;const Ce=q(Ie);if((0,I.isNotWebExtensionInWebTargetPlatform)(Ce,re))return null;for(let Ee of Ie.versions){if(!U(Ee)){const _e=await this.getEngine(Ee);Ee={...Ee,properties:[...Ee.properties||[],{key:o.Engine,value:_e}]}}if(await this.isRawExtensionVersionCompatible(Ee,Ce,re))return M(Ie,Ee,Ce,0,fe)}return null}async isExtensionCompatible(H,re){if(!(0,I.isTargetPlatformCompatible)(H.properties.targetPlatform,H.allTargetPlatforms,re))return!1;let ie=H.properties.engine;if(!ie){const ae=await this.getManifest(H,A.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");ie=ae.engines.vscode}return(0,b.isEngineValid)(ie,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(H,re,ie){if(!(0,I.isTargetPlatformCompatible)(x(H),re,ie))return!1;const ae=await this.getEngine(H);return(0,b.isEngineValid)(ae,this.productService.version,this.productService.date)}async query(H,re){const ie=A.CancellationToken.isCancellationToken(H)?{}:H,ae=A.CancellationToken.isCancellationToken(H)?H:re;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ue=ie.text||"";const fe=(0,T.getOrDefault)(ie,Re=>Re.pageSize,50);let de=new m().withFlags(s.IncludeLatestVersionOnly,s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,fe).withFilter(i.Target,"Microsoft.VisualStudio.Code");ue?(ue=ue.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Re,ke,Fe)=>(de=de.withFilter(i.Category,Fe||ke),"")),ue=ue.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Re,ke,Fe)=>(de=de.withFilter(i.Tag,Fe||ke),"")),ue=ue.replace(/\bfeatured(\s+|\b|$)/g,()=>(de=de.withFilter(i.Featured),"")),ue=ue.trim(),ue&&(ue=ue.length<200?ue:ue.substring(0,200),de=de.withFilter(i.SearchText,ue)),de=de.withSortBy(0)):ie.ids?de=de.withFilter(i.ExtensionId,...ie.ids):ie.names?de=de.withFilter(i.ExtensionName,...ie.names):de=de.withSortBy(4),typeof ie.sortBy=="number"&&(de=de.withSortBy(ie.sortBy)),typeof ie.sortOrder=="number"&&(de=de.withSortOrder(ie.sortOrder));const{galleryExtensions:Ie,total:Ce}=await this.queryGallery(de,t,ae),Ee=Ie.map((Re,ke)=>G(Re,ke,de,ie.source,t)),_e=async(Re,ke)=>{if(ke.isCancellationRequested)throw(0,P.canceled)();const Fe=de.withPage(Re+1),{galleryExtensions:$e}=await this.queryGallery(Fe,t,ke);return $e.map((Ne,qe)=>G(Ne,qe,Fe,ie.source,t))};return{firstPage:Ee,total:Ce,pageSize:de.pageSize,getPage:_e}}async queryGallery(H,re,ie){if(!this.isEnabled())throw new Error("No extension gallery service configured.");H=H.withFlags(H.flags,s.ExcludeNonValidated).withFilter(i.ExcludeWithFlags,r(s.Unpublished));const ae=await this.commonHeadersPromise,ue=JSON.stringify(H.raw),fe={...ae,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ue.length)},de=new Date().getTime();let Ie,Ce,Ee=0;try{if(Ie=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ue,headers:fe},ie),Ie.res.statusCode&&Ie.res.statusCode>=400&&Ie.res.statusCode<500)return{galleryExtensions:[],total:Ee};const _e=await(0,w.asJson)(Ie);if(_e){const Re=_e.results[0],ke=Re.extensions;ke.forEach($e=>$($e.versions,re));const Fe=Re.resultMetadata&&Re.resultMetadata.filter($e=>$e.metadataType==="ResultCount")[0];return Ee=Fe&&Fe.metadataItems.filter($e=>$e.name==="TotalCount")[0].count||0,{galleryExtensions:ke,total:Ee}}return{galleryExtensions:[],total:Ee}}catch(_e){throw Ce=_e,_e}finally{this.telemetryService.publicLog2("galleryService:query",{...H.telemetryData,requestBodySize:String(ue.length),duration:new Date().getTime()-de,success:!!Ie&&(0,w.isSuccess)(Ie),responseBodySize:Ie?.res.headers["Content-Length"],statusCode:Ie?String(Ie.res.statusCode):void 0,errorCode:Ce?(0,P.isPromiseCanceledError)(Ce)?"canceled":(0,P.getErrorMessage)(Ce).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ee)})}}async reportStatistic(H,re,ie,ae){if(!this.isEnabled())return;const ue=L.isWeb?this.api(`/itemName/${H}.${re}/version/${ie}/statType/${ae==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${H}/extensions/${re}/${ie}/stats?statType=${ae}`),fe=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ie={...await this.commonHeadersPromise,Accept:fe};try{await this.requestService.request({type:"POST",url:ue,headers:Ie},A.CancellationToken.None)}catch(Ce){}}async download(H,re,ie){this.logService.trace("ExtensionGalleryService#download",H.identifier.id);const ae=(0,g.getGalleryExtensionTelemetryData)(H),ue=new Date().getTime(),fe=Ee=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ae,duration:Ee}),de=ie===1?"install":ie===2?"update":"",Ie=de?{uri:`${H.assets.download.uri}${S.URI.parse(H.assets.download.uri).query?"&":"?"}${de}=true`,fallbackUri:`${H.assets.download.fallbackUri}${S.URI.parse(H.assets.download.fallbackUri).query?"&":"?"}${de}=true`}:H.assets.download,Ce=await this.getAsset(Ie);await this.fileService.writeFile(re,Ce.stream),fe(new Date().getTime()-ue)}async getReadme(H,re){if(H.assets.readme){const ie=await this.getAsset(H.assets.readme,{},re);return await(0,w.asText)(ie)||""}return""}async getManifest(H,re){if(H.assets.manifest){const ie=await this.getAsset(H.assets.manifest,{},re),ae=await(0,w.asText)(ie);return ae?JSON.parse(ae):null}return null}async getManifestFromRawExtensionVersion(H,re){const ie=F(H,a.Manifest);if(!ie)throw new Error("Manifest was not found");const ae={"Accept-Encoding":"gzip"},ue=await this.getAsset(ie,{headers:ae});return await(0,w.asJson)(ue)}async getCoreTranslation(H,re){const ie=H.assets.coreTranslations.filter(ae=>ae[0]===re.toUpperCase())[0];if(ie){const ae=await this.getAsset(ie[1]),ue=await(0,w.asText)(ae);return ue?JSON.parse(ue):null}return null}async getChangelog(H,re){if(H.assets.changelog){const ie=await this.getAsset(H.assets.changelog,{},re);return await(0,w.asText)(ie)||""}return""}async getAllCompatibleVersions(H,re){let ie=new m().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");H.identifier.uuid?ie=ie.withFilter(i.ExtensionId,H.identifier.uuid):ie=ie.withFilter(i.ExtensionName,H.identifier.id);const{galleryExtensions:ae}=await this.queryGallery(ie,re,A.CancellationToken.None);if(!ae.length)return[];const ue=q(ae[0]);if((0,I.isNotWebExtensionInWebTargetPlatform)(ue,re))return[];const fe=[];for(const de of ae[0].versions)try{fe[fe.length-1]?.version!==de.version&&await this.isRawExtensionVersionCompatible(de,ue,re)&&fe.push({version:de.version,date:de.lastUpdated})}catch(Ie){}return fe}async getAsset(H,re={},ie=A.CancellationToken.None){const ae=await this.commonHeadersPromise,ue={type:"GET"},fe={...ae,...re.headers||{}};re={...re,...ue,headers:fe};const de=H.uri,Ie=H.fallbackUri,Ce={...re,url:de};try{const Ee=await this.requestService.request(Ce,ie);if(Ee.res.statusCode===200)return Ee;const _e=await(0,w.asText)(Ee);throw new Error(`Expected 200, got back ${Ee.res.statusCode} instead.

${_e}`)}catch(Ee){if((0,P.isPromiseCanceledError)(Ee))throw Ee;const _e=(0,P.getErrorMessage)(Ee);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:de,message:_e});const Re={...re,url:Ie};return this.requestService.request(Re,ie)}}async getEngine(H){let re=U(H);if(!re){const ie=await this.getManifestFromRawExtensionVersion(H,A.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");re=ie.engines.vscode}return re}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const H=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},A.CancellationToken.None);if(H.res.statusCode!==200)throw new Error("Could not get extensions report.");const re=await(0,w.asJson)(H),ie=new Map;if(re)for(const ae of re.malicious){const ue=ie.get(ae)||{id:{id:ae},malicious:!0,slow:!1};ue.malicious=!0,ie.set(ae,ue)}return[...ie.values()]}};B=he([X(1,w.IRequestService),X(2,y.ILogService),X(3,n.IEnvironmentService),X(4,l.ITelemetryService),X(5,h.IFileService),X(6,f.IProductService),X(7,E.IConfigurationService)],B);let V=class extends B{constructor(H,re,ie,ae,ue,fe,de,Ie){super(H,re,ie,ae,ue,fe,de,Ie)}};V=he([X(0,p.IStorageService),X(1,w.IRequestService),X(2,y.ILogService),X(3,n.IEnvironmentService),X(4,l.ITelemetryService),X(5,h.IFileService),X(6,f.IProductService),X(7,E.IConfigurationService)],V),e.ExtensionGalleryService=V;let Q=class extends B{constructor(H,re,ie,ae,ue,fe,de){super(void 0,H,re,ie,ae,ue,fe,de)}};Q=he([X(0,w.IRequestService),X(1,y.ILogService),X(2,n.IEnvironmentService),X(3,l.ITelemetryService),X(4,h.IFileService),X(5,f.IProductService),X(6,E.IConfigurationService)],Q),e.ExtensionGalleryServiceWithNoStorageService=Q;async function Z(K,H,re,ie,ae,ue){const fe={"X-Market-Client-Id":`VSCode ${K}`,"User-Agent":`VSCode ${K}`},de=await(0,v.getServiceMachineId)(re,ae,ue);return(0,c.supportsTelemetry)(H,re)&&(0,c.getTelemetryLevel)(ie)===3&&(fe["X-Market-User-Id"]=de),fe}e.resolveMarketplaceHeaders=Z}),define(te[90],ne([0,1,2,13,10,47]),function(J,e,D,A,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let L=class extends D.Disposable{constructor(S,E,n=""){super();this.prefix=n;const I=S.getLogger(E.telemetryLogResource);I?this.logger=this._register(I):(this.logger=this._register(S.createLogger(E.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(S,E){this.logger.trace(`${this.prefix}telemetry/${S}`,(0,T.validateTelemetryData)(E))}};L=he([X(0,P.ILoggerService),X(1,A.IEnvironmentService)],L),e.TelemetryLogAppender=L}),define(te[91],ne([0,1,2,26,4,25,139,20,38,42,34,21,47]),function(J,e,D,A,P,T,L,R,S,E,n,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let b=class{constructor(f,w){this._configurationService=w,this._experimentProperties={},this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=f.appenders,this._commonProperties=f.commonProperties||Promise.resolve({}),this._piiPaths=f.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let v of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(v),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(v=>{const p=/^[a-f0-9]+$/i.test(v["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!p})})}setExperimentProperty(f,w){this._experimentProperties[f]=w}_updateTelemetryLevel(){this._telemetryLevel=(0,g.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const f=await this._commonProperties;let w=f.sessionID,v=f["common.instanceId"],p=f["common.machineId"],l=f["common.firstSessionDate"],c=f["common.msftInternal"];return{sessionId:w,instanceId:v,machineId:p,firstSessionDate:l,msftInternal:c}}dispose(){this._disposables.dispose()}_log(f,w,v,p){return this.telemetryLevel<w?Promise.resolve(void 0):this._commonProperties.then(l=>{v=(0,A.mixin)(v,l),v=(0,A.mixin)(v,this._experimentProperties),v=(0,A.cloneAndChange)(v,c=>{if(typeof c=="string")return this._cleanupInfo(c,p)}),this._appenders.forEach(c=>c.log(f,v))},l=>{console.error(l)})}publicLog(f,w,v){return this._log(f,3,w,v)}publicLog2(f,w,v){return this.publicLog(f,w,v)}publicLogError(f,w){return this.sendErrorTelemetry?this._log(f,2,w,!0):Promise.resolve(void 0)}publicLogError2(f,w){return this.publicLogError(f,w)}_anonymizeFilePaths(f){let w=f;const v=[];for(let t of this._cleanupPatterns)for(;;){const s=t.exec(f);if(!s)break;v.push([s.index,t.lastIndex])}const p=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(w="";;){const t=l.exec(f);if(!t)break;!p.test(t[0])&&v.every(([s,r])=>t.index<s||t.index>=r)&&(w+=f.substring(c,t.index)+"<REDACTED: user-file-path>",c=l.lastIndex)}return c<f.length&&(w+=f.substr(c)),w}_removePropertiesWithPossibleUserInfo(f){if(!f)return f;const w=f.toLowerCase(),v=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(w)?"<REDACTED: secret>":v.test(w)?"<REDACTED: email>":f}_cleanupInfo(f,w){let v=f;w&&(v=this._anonymizeFilePaths(v));for(let p of this._cleanupPatterns)v=v.replace(p,"");return v=this._removePropertiesWithPossibleUserInfo(v),v}};b.IDLE_START_EVENT_NAME="UserIdleStart",b.IDLE_STOP_EVENT_NAME="UserIdleStop",b=he([X(1,R.IConfigurationService)],b),e.TelemetryService=b;function h(){const y=(0,L.localize)(0,null,E.default.nameLong),f=E.default.privacyStatementUrl?(0,L.localize)(2,null,"https://aka.ms/vscode-telemetry",E.default.privacyStatementUrl):(0,L.localize)(1,null,"https://aka.ms/vscode-telemetry"),w=P.isWeb?"":(0,L.localize)(3,null),v=(0,L.localize)(4,null),p=(0,L.localize)(5,null),l=(0,L.localize)(6,null),c=(0,L.localize)(7,null),t=`
|       | ${v} | ${p} | ${l} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,L.localize)(8,null);return`
${y} ${f} ${w}

&nbsp;

${c}
${t}

&nbsp;

${s}
`}n.Registry.as(S.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(9,null),properties:{[I.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,L.localize)(10,null),(0,L.localize)(11,null),(0,L.localize)(12,null),(0,L.localize)(13,null)],markdownDescription:h(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),n.Registry.as(S.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(14,null),properties:{[I.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,L.localize)(16,null,E.default.nameLong,E.default.privacyStatementUrl):(0,L.localize)(15,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(17,null,`\`#${I.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[200],ne([0,1,8,26,47]),function(J,e,D,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function T(R){const S=await new Promise((n,I)=>{J(["applicationinsights"],n,I)});let E;return S.defaultClient?(E=new S.TelemetryClient(R),E.channel.setUseDiskRetryCaching(!0)):(S.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),E=S.defaultClient),R.indexOf("AIF-")===0&&(E.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),E}class L{constructor(S,E,n){this._eventPrefix=S,this._defaultData=E,this._defaultData||(this._defaultData=Object.create(null)),typeof n=="function"?this._aiClient=n():this._aiClient=n,this._asyncAIClient=null}_withAIClient(S){if(!!this._aiClient){if(typeof this._aiClient!="string"){S(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=T(this._aiClient)),this._asyncAIClient.then(E=>{S(E)},E=>{(0,D.onUnexpectedError)(E),console.error(E)})}}log(S,E){!this._aiClient||(E=(0,A.mixin)(E,this._defaultData),E=(0,P.validateTelemetryData)(E),this._withAIClient(n=>n.trackEvent({name:this._eventPrefix+"/"+S,properties:E.properties,measurements:E.measurements})))}flush(){return this._aiClient?new Promise(S=>{this._withAIClient(E=>{E.flush({callback:()=>{this._aiClient=void 0,S(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=L}),define(te[201],ne([0,1,15,45,20,13,10,21,89,90,91]),function(J,e,D,A,P,T,L,R,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let I=class{constructor(b,h,y,f){this.configurationService=b,this.telemetryService=h,this.loggerService=y,this.environmentService=f,this.customTelemetryServices=new Map}async getCustomTelemetryService(b){if(!this.customTelemetryServices.has(b.id)){const{machineId:h,sessionId:y}=await this.telemetryService.getTelemetryInfo(),f=Object.create(null);f["common.vscodemachineid"]=h,f["common.vscodesessionid"]=y;const w=[b.id,JSON.stringify(f),b.aiKey],p=new A.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:w,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),l=[new S.TelemetryAppenderClient(p),new E.TelemetryLogAppender(this.loggerService,this.environmentService,`[${b.id}] `)];this.customTelemetryServices.set(b.id,new n.TelemetryService({appenders:l,sendErrorTelemetry:b.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(b.id)}async publicLog(b,h,y){await(await this.getCustomTelemetryService(b)).publicLog(h,y)}async publicLogError(b,h,y){await(await this.getCustomTelemetryService(b)).publicLogError(h,y)}};I=he([X(0,P.IConfigurationService),X(1,R.ITelemetryService),X(2,L.ILoggerService),X(3,T.IEnvironmentService)],I),e.CustomEndpointTelemetryService=I}),define(te[202],ne([0,1,5,27,3,2,10]),function(J,e,D,A,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends T.Disposable{constructor(E,n){super();this._logService=n,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new P.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=E===void 0?15e3:E}createRequest(E){return new Promise((n,I)=>{const g=++this._lastRequestId;this._pendingRequests.set(g,n),this._onCreateRequest.fire({requestId:g,...E});const b=new A.CancellationTokenSource;(0,D.timeout)(this._timeout,b.token).then(()=>I(`Request ${g} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(g,[(0,T.toDisposable)(()=>b.cancel())])})}acceptReply(E,n){const I=this._pendingRequests.get(E);I?(this._pendingRequests.delete(E),(0,T.dispose)(this._pendingRequestDisposables.get(E)||[]),this._pendingRequestDisposables.delete(E),I(n)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${E}`)}};R=he([X(1,L.ILogService)],R),e.RequestStore=R}),define(te[92],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var A;(function(f){f.Shell="terminal.integrated.shell.",f.ShellArgs="terminal.integrated.shellArgs.",f.DefaultProfile="terminal.integrated.defaultProfile.",f.Profiles="terminal.integrated.profiles."})(A=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var P;(function(f){f.ShellLinux="terminal.integrated.shell.linux",f.ShellMacOs="terminal.integrated.shell.osx",f.ShellWindows="terminal.integrated.shell.windows",f.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",f.AutomationShellLinux="terminal.integrated.automationShell.linux",f.AutomationShellMacOs="terminal.integrated.automationShell.osx",f.AutomationShellWindows="terminal.integrated.automationShell.windows",f.ShellArgsLinux="terminal.integrated.shellArgs.linux",f.ShellArgsMacOs="terminal.integrated.shellArgs.osx",f.ShellArgsWindows="terminal.integrated.shellArgs.windows",f.ProfilesWindows="terminal.integrated.profiles.windows",f.ProfilesMacOs="terminal.integrated.profiles.osx",f.ProfilesLinux="terminal.integrated.profiles.linux",f.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",f.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",f.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",f.UseWslProfiles="terminal.integrated.useWslProfiles",f.TabsEnabled="terminal.integrated.tabs.enabled",f.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",f.TabsHideCondition="terminal.integrated.tabs.hideCondition",f.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",f.TabsShowActions="terminal.integrated.tabs.showActions",f.TabsLocation="terminal.integrated.tabs.location",f.TabsFocusMode="terminal.integrated.tabs.focusMode",f.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",f.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",f.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",f.CopyOnSelection="terminal.integrated.copyOnSelection",f.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",f.FontFamily="terminal.integrated.fontFamily",f.FontSize="terminal.integrated.fontSize",f.LetterSpacing="terminal.integrated.letterSpacing",f.LineHeight="terminal.integrated.lineHeight",f.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",f.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",f.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",f.BellDuration="terminal.integrated.bellDuration",f.FontWeight="terminal.integrated.fontWeight",f.FontWeightBold="terminal.integrated.fontWeightBold",f.CursorBlinking="terminal.integrated.cursorBlinking",f.CursorStyle="terminal.integrated.cursorStyle",f.CursorWidth="terminal.integrated.cursorWidth",f.Scrollback="terminal.integrated.scrollback",f.DetectLocale="terminal.integrated.detectLocale",f.DefaultLocation="terminal.integrated.defaultLocation",f.GpuAcceleration="terminal.integrated.gpuAcceleration",f.TerminalTitleSeparator="terminal.integrated.tabs.separator",f.TerminalTitle="terminal.integrated.tabs.title",f.TerminalDescription="terminal.integrated.tabs.description",f.RightClickBehavior="terminal.integrated.rightClickBehavior",f.Cwd="terminal.integrated.cwd",f.ConfirmOnExit="terminal.integrated.confirmOnExit",f.ConfirmOnKill="terminal.integrated.confirmOnKill",f.EnableBell="terminal.integrated.enableBell",f.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",f.AllowChords="terminal.integrated.allowChords",f.AllowMnemonics="terminal.integrated.allowMnemonics",f.EnvMacOs="terminal.integrated.env.osx",f.EnvLinux="terminal.integrated.env.linux",f.EnvWindows="terminal.integrated.env.windows",f.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",f.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",f.ShowExitAlert="terminal.integrated.showExitAlert",f.SplitCwd="terminal.integrated.splitCwd",f.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",f.WordSeparators="terminal.integrated.wordSeparators",f.EnableFileLinks="terminal.integrated.enableFileLinks",f.UnicodeVersion="terminal.integrated.unicodeVersion",f.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",f.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",f.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",f.LocalEchoStyle="terminal.integrated.localEchoStyle",f.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",f.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",f.CustomGlyphs="terminal.integrated.customGlyphs",f.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",f.InheritEnv="terminal.integrated.inheritEnv",f.ShowLinkHover="terminal.integrated.showLinkHover"})(P=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(T=e.WindowsShellType||(e.WindowsShellType={}));var L;(function(f){f[f.Api=0]="Api",f[f.Process=1]="Process",f[f.Sequence=2]="Sequence",f[f.Config=3]="Config"})(L=e.TitleEventSource||(e.TitleEventSource={}));var R;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.Log="log",f.Heartbeat="heartbeat"})(R=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var S;(function(f){f.Cwd="cwd",f.InitialCwd="initialCwd",f.FixedDimensions="fixedDimensions"})(S=e.ProcessPropertyType||(e.ProcessPropertyType={}));var E;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E=e.HeartbeatConstants||(e.HeartbeatConstants={}));var n;(function(f){f[f.Panel=1]="Panel",f[f.Editor=2]="Editor"})(n=e.TerminalLocation||(e.TerminalLocation={}));var I;(function(f){f.TerminalView="view",f.Editor="editor"})(I=e.TerminalLocationString||(e.TerminalLocationString={}));var g;(function(f){f.CwdDetection="cwdDetection"})(g=e.ProcessCapability||(e.ProcessCapability={}));var b;(function(f){f[f.GraceTime=6e4]="GraceTime",f[f.ShortGraceTime=6e3]="ShortGraceTime"})(b=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var h;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(h=e.FlowControlConstants||(e.FlowControlConstants={}));var y;(function(f){f.GitBash="Git Bash",f.Pwsh="PowerShell"})(y=e.ProfileSource||(e.ProfileSource={}))}),define(te[203],ne([0,1,6]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(te[204],ne([0,1,33,26,9,4,31,18,19]),function(J,e,D,A,P,T,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function E(){const I=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let g=0;return I&&I.length===4&&(g=parseInt(I[3])),g}e.getWindowsBuildNumber=E;async function n(I,g,b,h=L.env,y=S.Promises.exists){if(P.isAbsolute(I))return await y(I)?I:void 0;if(g===void 0&&(g=L.cwd()),P.dirname(I)!=="."){const p=P.join(g,I);return await y(p)?p:void 0}const w=(0,A.getCaseInsensitive)(h,"PATH");if(b===void 0&&(0,R.isString)(w)&&(b=w.split(P.delimiter)),b===void 0||b.length===0){const p=P.join(g,I);return await y(p)?p:void 0}for(let p of b){let l;if(P.isAbsolute(p)?l=P.join(p,I):l=P.join(g,p,I),await y(l))return l;if(T.isWindows){let c=l+".com";if(await y(c)||(c=l+".exe",await y(c)))return c}}const v=P.join(g,I);return await y(v)?v:void 0}e.findExecutable=n}),define(te[205],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var D;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST="hc"})(D=e.ColorScheme||(e.ColorScheme={}))}),define(te[93],ne([0,1,50,3,2,6,34,205]),function(J,e,D,A,P,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var S;(function(f){function w(v){return v&&typeof v=="object"&&typeof v.id=="string"}f.isThemeColor=w})(S=e.ThemeColor||(e.ThemeColor={}));function E(f){return{id:f}}e.themeColorFromId=E;var n;(function(f){function w(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||S.isThemeColor(s.color))}f.isThemeIcon=w;const v=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function p(s){const r=v.exec(s);if(!r)return;let[,i]=r;return{id:i}}f.fromString=p;function l(s,r){let i=s.id;const a=i.lastIndexOf("~");return a!==-1&&(i=i.substring(0,a)),r&&(i=`${i}~${r}`),{id:i}}f.modify=l;function c(s,r){return s.id===r.id&&s.color?.id===r.color?.id}f.isEqual=c;function t(s,r){return{id:s.id,color:r?E(r):void 0}}f.asThemeIcon=t,f.asClassNameArray=D.CSSIcon.asClassNameArray,f.asClassName=D.CSSIcon.asClassName,f.asCSSSelector=D.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function I(f){switch(f){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class g{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new A.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,P.toDisposable)(()=>{const v=this.themingParticipants.indexOf(w);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let b=new g;L.Registry.add(e.Extensions.ThemingContribution,b);function h(f){return b.onColorThemeChange(f)}e.registerThemingParticipant=h;class y extends P.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,v){let p=this.theme.getColor(w);return p&&v&&(p=v(p,this.theme)),p?p.toString():null}}e.Themable=y}),define(te[206],ne([0,1,50,93]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=void 0;function P(R,S){const E=R.map(n=>({name:n.profileName,description:T(n)}));return S&&E.push(...S.map(n=>({name:n.title,description:L(n)}))),{values:E.map(n=>n.name),markdownDescriptions:E.map(n=>n.description)}}e.createProfileSchemaEnums=P;function T(R){let S=`$(${A.ThemeIcon.isThemeIcon(R.icon)?R.icon.id:R.icon?R.icon:D.Codicon.terminal.id}) ${R.profileName}
- path: ${R.path}`;return R.args&&(typeof R.args=="string"?S+=`
- args: "${R.args}"`:S+=`
- args: [${R.args.length===0?"":`'${R.args.join("','")}'`}]`),R.overrideName!==void 0&&(S+=`
- overrideName: ${R.overrideName}`),R.color&&(S+=`
- color: ${R.color}`),R.env&&(S+=`
- env: ${JSON.stringify(R.env)}`),S}function L(R){return`$(${A.ThemeIcon.isThemeIcon(R.icon)?R.icon.id:R.icon?R.icon:D.Codicon.terminal.id}) ${R.title}
- extensionIdenfifier: ${R.extensionIdentifier}`}}),define(te[207],ne([0,1,50,140,38,34,206]),function(J,e,D,A,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const R={args:{description:(0,A.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,A.localize)(1,null),type:"boolean"},icon:{description:(0,A.localize)(2,null),type:"string",enum:Array.from(D.iconRegistry.all,f=>f.id),markdownEnumDescriptions:Array.from(D.iconRegistry.all,f=>`$(${f.id})`)},color:{description:(0,A.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,A.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},S={type:"object",required:["path"],properties:{path:{description:(0,A.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},E=(0,A.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),n=(0,A.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),I=(0,A.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),g={id:"terminal",order:100,title:(0,A.localize)(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,A.localize)(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,A.localize)(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,A.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:n},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,A.localize)(15,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,A.localize)(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:n},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,A.localize)(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,A.localize)(19,null)}},{type:"string",markdownDescription:(0,A.localize)(20,null)}],default:[],markdownDeprecationMessage:I},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,A.localize)(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,A.localize)(22,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,A.localize)(23,null),type:"string"},id:{description:(0,A.localize)(24,null),type:"string"},title:{description:(0,A.localize)(25,null),type:"string"},...R}},{type:"null"},S]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,A.localize)(26,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,A.localize)(27,null),type:"string"},id:{description:(0,A.localize)(28,null),type:"string"},title:{description:(0,A.localize)(29,null),type:"string"},...R}},{type:"null"},S]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(30,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,A.localize)(31,null),type:"string"},id:{description:(0,A.localize)(32,null),type:"string"},title:{description:(0,A.localize)(33,null),type:"string"},...R}},{type:"null"},S]}},["terminal.integrated.useWslProfiles"]:{description:(0,A.localize)(34,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,A.localize)(35,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,A.localize)(36,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,A.localize)(37,null),type:"boolean",default:!0}}};function b(){T.Registry.as(P.Extensions.Configuration).registerConfiguration(g),y()}e.registerTerminalPlatformConfiguration=b;let h;function y(f,w){const v=T.Registry.as(P.Extensions.Configuration);let p;f&&(p=(0,L.createProfileSchemaEnums)(f?.profiles,w));const l=h;h={id:"terminal",order:100,title:(0,A.localize)(38,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(39,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:f?.os===3?p?.values:void 0,markdownEnumDescriptions:f?.os===3?p?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,A.localize)(40,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:f?.os===2?p?.values:void 0,markdownEnumDescriptions:f?.os===2?p?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,A.localize)(41,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:f?.os===1?p?.values:void 0,markdownEnumDescriptions:f?.os===1?p?.markdownDescriptions:void 0}}},v.updateConfigurations({add:[h],remove:l?[l]:[]})}e.registerTerminalDefaultProfileConfiguration=y}),define(te[208],ne([0,1,41,50,9,4,19,69,204,93]),function(J,e,D,A,P,T,L,R,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let n;function I(t,s,r,i,a=process.env,o,u,d,m){return o=o||{existsFile:L.SymlinkSupport.existsFile,readFile:L.Promises.readFile},T.isWindows?g(r,o,a,u,i.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:i.getValue("terminal.integrated.profiles.windows"),typeof s=="string"?s:i.getValue("terminal.integrated.defaultProfile.windows"),m,d):p(o,u,r,t&&typeof t=="object"?{...t}:i.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof s=="string"?s:i.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),m,d,a)}e.detectAvailableProfiles=I;async function g(t,s,r,i,a,o,u,d,m){const k=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),_=`${process.env.windir}\\${k?"Sysnative":"System32"}`;let O=!1;(0,S.getWindowsBuildNumber)()>=16299&&(O=!0),await y(d);const N=new Map;t&&(N.set("PowerShell",{source:"PowerShell",icon:A.Codicon.terminalPowershell,isAutoDetected:!0}),N.set("Windows PowerShell",{path:`${_}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:A.Codicon.terminalPowershell,isAutoDetected:!0}),N.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),N.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),N.set("Command Prompt",{path:`${_}\\cmd.exe`,icon:A.Codicon.terminalCmd,isAutoDetected:!0})),l(o,N);const C=await b(N.entries(),u,s,r,i,m);if(t||!t&&a)try{const F=await w(`${_}\\${O?"wsl":"bash"}.exe`,u);for(const z of F)(!o||!(z.profileName in o))&&C.push(z)}catch(F){i?.info("WSL is not installed, so could not detect WSL profiles")}return C}async function b(t,s,r,i=process.env,a,o){const u=[];for(const[d,m]of t){if(m===null)continue;let k,_,O;if("source"in m){const F=n?.get(m.source);if(!F)continue;k=F.paths,_=m.args||F.args,m.icon?O=h(m.icon):F.icon&&(O=F.icon)}else k=Array.isArray(m.path)?m.path:[m.path],_=T.isWindows||Array.isArray(m.args)?m.args:void 0,O=h(m.icon)||void 0;const N=await o?.(k)||k.slice(),C=await c(d,s,N,r,i,_,m.env,m.overrideName,m.isAutoDetected,a);C?(C.isAutoDetected=m.isAutoDetected,C.icon=O,C.color=m.color,u.push(C)):a?.trace("profile not validated",d,k)}return u}function h(t){return typeof t=="string"?{id:t}:t}async function y(t){n&&!t||(n=new Map,n.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),n.set("PowerShell",{profileName:"PowerShell",paths:t||await f(),icon:E.ThemeIcon.asThemeIcon(A.Codicon.terminalPowershell)}))}async function f(){const t=[];for await(const s of(0,R.enumeratePowerShellInstallations)())t.push(s.exePath);return t}async function w(t,s){const r=[],i=await new Promise((u,d)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le"},(m,k)=>{if(m)return d("Problem occurred when getting wsl distros");u(k)})});if(!i)return[];const a=new RegExp(/[\r?\n]/),o=i.split(a).filter(u=>u.trim().length>0&&u!=="");for(const u of o){if(u===""||u.startsWith("docker-desktop"))continue;const d=`${u} (WSL)`,m={profileName:d,path:t,args:["-d",`${u}`],isDefault:d===s,icon:v(u)};r.push(m)}return r}function v(t){return t.includes("Ubuntu")?E.ThemeIcon.asThemeIcon(A.Codicon.terminalUbuntu):t.includes("Debian")?E.ThemeIcon.asThemeIcon(A.Codicon.terminalDebian):E.ThemeIcon.asThemeIcon(A.Codicon.terminalLinux)}async function p(t,s,r,i,a,o,u,d){const m=new Map;if(r){const k=(await t.readFile("/etc/shells")).toString(),_=o||k.split(`
`).filter(N=>N.trim().indexOf("#")!==0&&N.trim().length>0),O=new Map;for(const N of _){let C=(0,P.basename)(N),F=O.get(C)||0;F++,F>1&&(C=`${C} (${F})`),O.set(C,F),m.set(C,{path:N,isAutoDetected:!0})}}return l(i,m),await b(m.entries(),a,t,d,s,u)}function l(t,s){if(!!t)for(const[r,i]of Object.entries(t))i===null||!("path"in i)&&!("source"in i)?s.delete(r):s.set(r,i)}async function c(t,s,r,i,a,o,u,d,m,k){if(r.length===0)return Promise.resolve(void 0);const _=r.shift();if(_==="")return c(t,s,r,i,a,o,u,d,m);const O={profileName:t,path:_,args:o,env:u,overrideName:d,isAutoDetected:m,isDefault:t===s};if((0,P.basename)(_)===_){const C=a.PATH?a.PATH.split(P.delimiter):void 0;return await(0,S.findExecutable)(_,void 0,C,void 0,i.existsFile)?O:c(t,s,r,i,a,o)}return await i.existsFile((0,P.normalize)(_))?O:c(t,s,r,i,a,o,u,d,m)}}),define(te[209],ne([0,1,3,2,15,4,32,45,20,13,73,163,10,83,21,202,92,207,208]),function(J,e,D,A,P,T,L,R,S,E,n,I,g,b,h,y,f,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var p;(function(t){t[t.MaxRestarts=5]="MaxRestarts"})(p||(p={}));let l=0,c=class extends A.Disposable{constructor(s,r,i,a,o){super();this._reconnectConstants=s,this._configurationService=r,this._environmentService=i,this._logService=a,this._telemetryService=o,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new D.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new D.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new D.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new D.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onProcessDidChangeHasChildProcesses=this._register(new D.Emitter),this.onProcessDidChangeHasChildProcesses=this._onProcessDidChangeHasChildProcesses.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,(0,w.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,A.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new y.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost()}async _resolveShellEnv(){if(T.isWindows)return process.env;try{return await(0,I.resolveShellEnv)(this._logService,{_:[]},process.env)}catch(s){return this._logService.error("ptyHost was unable to resolve shell environment",s),{}}}_startPtyHost(){const s={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:l,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},r=(0,n.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);r&&(r.break&&r.port?s.debugBrk=r.port:!r.break&&r.port&&(s.debug=r.port));const i=new R.Client(P.FileAccess.asFileUri("bootstrap-fork",J).fsPath,s);this._onPtyHostStart.fire(),L.ProxyChannel.toService(i.getChannel(f.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(i.onDidProcessExit(d=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(d.code),this._isDisposed||(this._restartCount<=p.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${d.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${d.code}, giving up`))}));const o=i.getChannel(f.TerminalIpcChannels.Log);b.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{b.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const u=L.ProxyChannel.toService(i.getChannel(f.TerminalIpcChannels.PtyHost));return this._register(u.onProcessData(d=>this._onProcessData.fire(d))),this._register(u.onProcessExit(d=>this._onProcessExit.fire(d))),this._register(u.onProcessReady(d=>this._onProcessReady.fire(d))),this._register(u.onProcessTitleChanged(d=>this._onProcessTitleChanged.fire(d))),this._register(u.onProcessShellTypeChanged(d=>this._onProcessShellTypeChanged.fire(d))),this._register(u.onProcessOverrideDimensions(d=>this._onProcessOverrideDimensions.fire(d))),this._register(u.onProcessResolvedShellLaunchConfig(d=>this._onProcessResolvedShellLaunchConfig.fire(d))),this._register(u.onProcessDidChangeHasChildProcesses(d=>this._onProcessDidChangeHasChildProcesses.fire(d))),this._register(u.onDidChangeProperty(d=>this._onDidChangeProperty.fire(d))),this._register(u.onProcessReplay(d=>this._onProcessReplay.fire(d))),this._register(u.onProcessOrphanQuestion(d=>this._onProcessOrphanQuestion.fire(d))),this._register(u.onDidRequestDetach(d=>this._onDidRequestDetach.fire(d))),[i,u]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(s,r,i,a,o,u,d,m,k,_,O){const N=setTimeout(()=>this._handleUnresponsiveCreateProcess(),f.HeartbeatConstants.CreateProcessTimeout),C=await this._proxy.createProcess(s,r,i,a,o,u,d,m,k,_,O);return clearTimeout(N),l=Math.max(l,C),C}updateTitle(s,r,i){return this._proxy.updateTitle(s,r,i)}updateIcon(s,r,i){return this._proxy.updateIcon(s,r,i)}attachToProcess(s){return this._proxy.attachToProcess(s)}detachFromProcess(s){return this._proxy.detachFromProcess(s)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(s){return this._proxy.start(s)}shutdown(s,r){return this._proxy.shutdown(s,r)}input(s,r){return this._proxy.input(s,r)}processBinary(s,r){return this._proxy.processBinary(s,r)}resize(s,r,i){return this._proxy.resize(s,r,i)}acknowledgeDataEvent(s,r){return this._proxy.acknowledgeDataEvent(s,r)}setUnicodeVersion(s,r){return this._proxy.setUnicodeVersion(s,r)}getInitialCwd(s){return this._proxy.getInitialCwd(s)}getCwd(s){return this._proxy.getCwd(s)}getLatency(s){return this._proxy.getLatency(s)}orphanQuestionReply(s){return this._proxy.orphanQuestionReply(s)}getDefaultSystemShell(s){return this._proxy.getDefaultSystemShell(s)}async getProfiles(s,r,i,a=!1){const o=await this._shellEnv;return(0,v.detectAvailableProfiles)(r,i,a,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,s))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(s){return this._proxy.getWslPath(s)}setTerminalLayoutInfo(s){return this._proxy.setTerminalLayoutInfo(s)}async getTerminalLayoutInfo(s){return await this._proxy.getTerminalLayoutInfo(s)}async requestDetachInstance(s,r){return this._proxy.requestDetachInstance(s,r)}async acceptDetachInstanceReply(s,r){return this._proxy.acceptDetachInstanceReply(s,r)}async serializeTerminalState(s){return this._proxy.serializeTerminalState(s)}async reviveTerminalProcesses(s){return this._proxy.reviveTerminalProcesses(s)}async refreshProperty(s,r){return this._proxy.refreshProperty(s,r)}async updateProperty(s,r,i){return this._proxy.updateProperty(s,r,i)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier+f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${f.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(s,r){return this._resolveVariablesRequestStore.createRequest({workspaceId:s,originalText:r})}async acceptPtyHostResolvedVariables(s,r){this._resolveVariablesRequestStore.acceptReply(s,r)}};c=he([X(1,S.IConfigurationService),X(2,E.IEnvironmentService),X(3,g.ILogService),X(4,h.ITelemetryService)],c),e.PtyHostService=c}),define(te[54],ne([0,1,44]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function A(L,R,S,E){const n=(0,D.setProperty)(L,R,S,E)[0];return n&&(L=L.substring(0,n.offset)+n.content+L.substring(n.offset+n.length)),L}e.edit=A;function P(L,R,S){let E=S;for(;E>=0;){if(L.charAt(E)===R.charAt(R.length-1)&&R.length===1)return E+1;if(E--,R.length===2&&E>=0&&L.charAt(E)===R.charAt(0))return E+2}return 0}e.getLineStartOffset=P;function T(L,R,S){let E=S;for(;E>=0;)if(L.charAt(E)===R.charAt(R.length-1)&&R.length===1||(E++,R.length===2&&E>=0&&L.charAt(E)===R.charAt(1)))return E;return L.length-1}e.getLineEndOffset=T}),define(te[210],ne([0,1,26,60]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function P(I,g,b,h,y){const f=[],w=[],v=[];if(!g){const _=I.filter(({identifier:O})=>y.every(N=>N.toLowerCase()!==O.id.toLowerCase()));return{local:{added:f,removed:w,updated:v},remote:_.length>0?{added:_,updated:[],removed:[],all:_}:null}}I=I.map(E),g=g.map(E),b=b?b.map(E):null;const p=new Map,l=_=>{_.uuid&&p.set(_.id.toLowerCase(),_.uuid)};I.forEach(({identifier:_})=>l(_)),g.forEach(({identifier:_})=>l(_)),b&&b.forEach(({identifier:_})=>l(_));const c=_=>{const O=_.identifier.uuid||p.get(_.identifier.id.toLowerCase());return O?`uuid:${O}`:`id:${_.identifier.id.toLowerCase()}`},t=(_,O)=>(_.set(c(O),O),_),s=I.reduce(t,new Map),r=g.reduce(t,new Map),i=g.reduce((_,O)=>{const N=c(O);O=(0,D.deepClone)(O);const C=s.get(N);return C&&(C.installed&&(O.installed=!0),O.version||(O.version=C.version)),t(_,O)},new Map),a=b?b.reduce(t,new Map):null,o=h.reduce(t,new Map),u=y.reduce((_,O)=>{const N=p.get(O.toLowerCase());return _.add(N?`uuid:${N}`:`id:${O.toLowerCase()}`)},new Set),d=T(s,r,u);if(d.added.size>0||d.removed.size>0||d.updated.size>0){const _=T(a,s,u),O=T(a,r,u),N=(C,F)=>{const z=s.get(C);if(z){const U=r.get(C);return{...F?U:z,version:(U.version&&A.gt(U.version,z.version),z.version),state:L(z,U,a?.get(C))}}};for(const C of O.removed.values()){const F=s.get(C);F&&w.push(F.identifier)}for(const C of O.added.values())if(_.added.has(C)){if(d.updated.has(C)){const F=N(C,!0);F&&(v.push(n(F,C)),i.set(C,F))}}else{const F=r.get(C);F.installed&&f.push(n(F,C))}for(const C of O.updated.values()){const F=N(C,!0);F&&(v.push(n(F,C)),i.set(C,F))}for(const C of _.added.values())O.added.has(C)||i.set(C,s.get(C));for(const C of _.updated.values())if(!O.removed.has(C)&&!O.updated.has(C)){const F=N(C,!1);F&&(i.get(C)?.installed&&(F.installed=!0),i.set(C,F))}for(const C of _.removed.values())!o.has(C)&&!O.updated.has(C)&&a?.get(C)?.installed&&i.delete(C)}const m=[],k=T(r,i,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(k.added.size>0||k.updated.size>0||k.removed.size>0)&&i.forEach((_,O)=>m.push(n(_,O))),{local:{added:f,removed:w,updated:v},remote:m.length?{added:[...k.added].map(_=>i.get(_)),updated:[...k.updated].map(_=>i.get(_)),removed:[...k.removed].map(_=>r.get(_)),all:m}:null}}e.merge=P;function T(I,g,b,{checkInstalledProperty:h,checkVersionProperty:y}={checkInstalledProperty:!1,checkVersionProperty:!1}){const f=I?[...I.keys()].filter(c=>!b.has(c)):[],w=[...g.keys()].filter(c=>!b.has(c)),v=w.filter(c=>f.indexOf(c)===-1).reduce((c,t)=>(c.add(t),c),new Set),p=f.filter(c=>w.indexOf(c)===-1).reduce((c,t)=>(c.add(t),c),new Set),l=new Set;for(const c of f){if(p.has(c))continue;const t=I.get(c),s=g.get(c);(!s||t.disabled!==s.disabled||!S(t.state,s.state)||y&&t.version!==s.version||h&&t.installed!==s.installed)&&l.add(c)}return{added:v,removed:p,updated:l}}function L(I,g,b){const h=I.state,y=g.state,f=b?.state;if(!g.version||h&&A.gt(I.version,g.version))return h;if(y&&A.gt(g.version,I.version)||!h)return y;if(!y)return h;const w=(0,D.deepClone)(h),v=f?R(f,y):{added:Object.keys(y).reduce((l,c)=>(l.add(c),l),new Set),removed:new Set,updated:new Set},p=f?R(f,h):{added:Object.keys(h).reduce((l,c)=>(l.add(c),l),new Set),removed:new Set,updated:new Set};for(const l of[...v.added.values(),...v.updated.values()])w[l]=y[l];for(const l of v.removed.values())p.updated.has(l)||delete w[l];return w}function R(I,g){const b=Object.keys(I),h=Object.keys(g),y=h.filter(v=>b.indexOf(v)===-1).reduce((v,p)=>(v.add(p),v),new Set),f=b.filter(v=>h.indexOf(v)===-1).reduce((v,p)=>(v.add(p),v),new Set),w=new Set;for(const v of b){if(f.has(v))continue;const p=I[v],l=g[v];(0,D.equals)(p,l)||w.add(v)}return{added:y,removed:f,updated:w}}function S(I={},g={}){const{added:b,removed:h,updated:y}=R(I,g);return b.size===0&&h.size===0&&y.size===0}function E(I){return{...I,disabled:!!I.disabled,installed:!!I.installed}}function n(I,g){const b={identifier:{id:I.identifier.id,uuid:g.startsWith("uuid:")?g.substring("uuid:".length):void 0}};return I.version&&(b.version=I.version),I.disabled&&(b.disabled=!0),I.installed&&(b.installed=!0),I.state&&(b.state=I.state),b}}),define(te[94],ne([0,1,17,3,2,35,6,29,23]),function(J,e,D,A,P,T,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,L.createDecorator)("IExtensionsStorageSyncService");const E=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let n=class nt extends P.Disposable{constructor(g,b){super();this.storageService=g,this.productService=b,this._onDidChangeExtensionsStorage=this._register(new A.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(g){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(g.id)}@${g.version}`}static fromKey(g){const b=E.exec(g);if(b&&b[1])return{id:b[1],version:b[2]}}initialize(){const g=this.storageService.keys(0,1);for(const b of g){const h=nt.fromKey(b);h&&this.extensionsWithKeysForSync.add(h.id.toLowerCase())}}onDidChangeStorageValue(g){if(g.scope!==0)return;if(this.extensionsWithKeysForSync.has(g.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const b=nt.fromKey(g.key);if(b){this.extensionsWithKeysForSync.add(b.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(g,b){this.storageService.store(nt.toKey(g),JSON.stringify(b),0,1)}getKeysForSync(g){const b=this.productService.extensionSyncedKeys?.[g.id.toLowerCase()],h=this.storageService.get(nt.toKey(g),0),y=h?JSON.parse(h):void 0;return y&&b?(0,D.distinct)([...y,...b]):y||b}};n=he([X(0,S.IStorageService),X(1,R.IProductService)],n),e.ExtensionsStorageSyncService=n}),define(te[95],ne([0,1,17,20,6]),function(J,e,D,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,P.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,S){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return E=E.filter(n=>n!==R&&n!==`-${R}`),S&&E.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}updateSynchronizedExtensions(R,S){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return E=E.filter(n=>n!==R&&n!==`-${R}`),S&&E.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}getIgnoredExtensions(R){const S=R.filter(g=>g.isMachineScoped).map(g=>g.identifier.id.toLowerCase()),E=this.getConfiguredIgnoredExtensions().map(g=>g.toLowerCase()),n=[],I=[];if(Array.isArray(E))for(const g of E)g.startsWith("-")?I.push(g.substring(1)):n.push(g);return(0,D.distinct)([...S,...n].filter(g=>I.indexOf(g)===-1))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(S=>S.toLowerCase())}};T=he([X(0,A.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(te[211],ne([0,1,17,36,26,158,54]),function(J,e,D,A,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(l){return(0,A.parse)(l)||[]}e.parseKeybindings=R;async function S(l,c,t,s,r){const i=R(l),a=R(c),o=t?R(t):null,u=[...i,...a,...o||[]].map(j=>j.key),d=await r.resolveUserBindings(u);let m=n(i,a,o,d);if(!m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:l,hasChanges:!1,hasConflicts:!1};if(!m.hasLocalForwarded&&m.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};if(m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};const k=g(i),_=g(a),O=o?g(o):null,N=h(k,_,d),C=O?h(O,k,d):{added:[...k.keys()].reduce((j,W)=>(j.add(W),j),new Set),removed:new Set,updated:new Set},F=O?h(O,_,d):{added:[..._.keys()].reduce((j,W)=>(j.add(W),j),new Set),removed:new Set,updated:new Set},z=E(N,C,F);let U=l;for(const j of z.removed.values())z.conflicts.has(j)||(U=v(U,j,s));for(const j of z.added.values()){if(z.conflicts.has(j))continue;const W=_.get(j);if(W.some(x=>x.command!==`-${j}`&&m.conflicts.has(d[x.key]))){z.conflicts.add(j);continue}U=w(U,W,s)}for(const j of z.updated.values()){if(z.conflicts.has(j))continue;const W=_.get(j);if(W.some(x=>x.command!==`-${j}`&&m.conflicts.has(d[x.key]))){z.conflicts.add(j);continue}U=p(U,j,W,s)}return{mergeContent:U,hasChanges:!0,hasConflicts:z.conflicts.size>0}}e.merge=S;function E(l,c,t){const s=new Set,r=new Set,i=new Set,a=new Set;for(const o of c.removed.values())t.updated.has(o)&&a.add(o);for(const o of t.removed.values())a.has(o)||(c.updated.has(o)?a.add(o):r.add(o));for(const o of c.added.values())a.has(o)||t.added.has(o)&&l.updated.has(o)&&a.add(o);for(const o of t.added.values())a.has(o)||(c.added.has(o)?l.updated.has(o)&&a.add(o):s.add(o));for(const o of c.updated.values())a.has(o)||t.updated.has(o)&&l.updated.has(o)&&a.add(o);for(const o of t.updated.values())a.has(o)||(c.updated.has(o)?l.updated.has(o)&&a.add(o):i.add(o));return{added:s,removed:r,updated:i,conflicts:a}}function n(l,c,t,s){const r=new Set,i=I(l,s),a=I(c,s),o=t?I(t,s):null,u=b(i,a);if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const d=o?b(o,i):{added:[...i.keys()].reduce((C,F)=>(C.add(F),C),new Set),removed:new Set,updated:new Set};if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:r,removed:r,updated:r,conflicts:r};const m=o?b(o,a):{added:[...a.keys()].reduce((C,F)=>(C.add(F),C),new Set),removed:new Set,updated:new Set};if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const{added:k,removed:_,updated:O,conflicts:N}=E(u,d,m);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:k,removed:_,updated:O,conflicts:N}}function I(l,c){const t=new Map;for(const s of l){const r=c[s.key];let i=t.get(r);i||(i=[],t.set(r,i)),i.push(s)}return t}function g(l){const c=new Map;for(const t of l){const s=t.command[0]==="-"?t.command.substring(1):t.command;let r=c.get(s);r||(r=[],c.set(s,r)),r.push(t)}return c}function b(l,c){const t=[...l.keys()],s=[...c.keys()],r=s.filter(o=>t.indexOf(o)===-1).reduce((o,u)=>(o.add(u),o),new Set),i=t.filter(o=>s.indexOf(o)===-1).reduce((o,u)=>(o.add(u),o),new Set),a=new Set;for(const o of t){if(i.has(o))continue;const u=l.get(o).map(m=>({...m,key:o})),d=c.get(o).map(m=>({...m,key:o}));(0,D.equals)(u,d,(m,k)=>f(m,k))||a.add(o)}return{added:r,removed:i,updated:a}}function h(l,c,t){const s=[...l.keys()],r=[...c.keys()],i=r.filter(u=>s.indexOf(u)===-1).reduce((u,d)=>(u.add(d),u),new Set),a=s.filter(u=>r.indexOf(u)===-1).reduce((u,d)=>(u.add(d),u),new Set),o=new Set;for(const u of s){if(a.has(u))continue;const d=l.get(u).map(k=>({...k,key:t[k.key]})),m=c.get(u).map(k=>({...k,key:t[k.key]}));y(d,m)||o.add(u)}return{added:i,removed:a,updated:o}}function y(l,c){return!(!(0,D.equals)(l.filter(({command:t})=>t[0]!=="-"),c.filter(({command:t})=>t[0]!=="-"),(t,s)=>f(t,s))||!(0,D.equals)(l.filter(({command:t})=>t[0]==="-"),c.filter(({command:t})=>t[0]==="-"),(t,s)=>f(t,s)))}function f(l,c){if(l.command!==c.command||l.key!==c.key)return!1;const t=T.ContextKeyExpr.deserialize(l.when),s=T.ContextKeyExpr.deserialize(c.when);return!(t&&!s||!t&&s||t&&s&&!t.equals(s)||!P.equals(l.args,c.args))}function w(l,c,t){for(const s of c)l=L.edit(l,[-1],s,t);return l}function v(l,c,t){const s=R(l);for(let r=s.length-1;r>=0;r--)(s[r].command===c||s[r].command===`-${c}`)&&(l=L.edit(l,[r],void 0,t));return l}function p(l,c,t,s){const r=R(l),i=r.findIndex(a=>a.command===c||a.command===`-${c}`);for(let a=r.length-1;a>=0;a--)(r[a].command===c||r[a].command===`-${c}`)&&(l=L.edit(l,[a],void 0,s));for(let a=t.length-1;a>=0;a--)l=L.edit(l,[i],t[a],s);return l}}),define(te[212],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(T,L,R){const S={},E={},n=new Set;if(!L)return{local:{added:S,updated:E,removed:[...n.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const I=A(T,L);if(I.added.size===0&&I.removed.size===0&&I.updated.size===0)return{local:{added:S,updated:E,removed:[...n.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const g=A(R,T),b=A(R,L),h={},y={},f=new Set,w=new Set;for(const v of g.removed.values())b.updated.has(v)?S[v]=L[v]:f.add(v);for(const v of b.removed.values())w.has(v)||(g.updated.has(v)?w.add(v):n.add(v));for(const v of g.updated.values())w.has(v)||(b.updated.has(v)?I.updated.has(v)&&w.add(v):y[v]=T[v]);for(const v of b.updated.values())w.has(v)||(g.updated.has(v)?I.updated.has(v)&&w.add(v):T[v]!==void 0&&(E[v]=L[v]));for(const v of g.added.values())w.has(v)||(b.added.has(v)?I.updated.has(v)&&w.add(v):h[v]=T[v]);for(const v of b.added.values())w.has(v)||(g.added.has(v)?I.updated.has(v)&&w.add(v):S[v]=L[v]);return{local:{added:S,removed:[...n.values()],updated:E},remote:{added:h,removed:[...f.values()],updated:y},conflicts:[...w.values()]}}e.merge=D;function A(T,L){const R=T?Object.keys(T):[],S=L?Object.keys(L):[],E=S.filter(g=>R.indexOf(g)===-1).reduce((g,b)=>(g.add(b),g),new Set),n=R.filter(g=>S.indexOf(g)===-1).reduce((g,b)=>(g.add(b),g),new Set),I=new Set;for(const g of R){if(n.has(g))continue;const b=T[g],h=L[g];b!==h&&I.add(g)}return{added:E,removed:n,updated:I}}function P(T,L){const{added:R,removed:S,updated:E}=A(T,L);return R.size===0&&S.size===0&&E.size===0}e.areSame=P}),define(te[24],ne([0,1,17,16,18,145,38,28,6,85,34]),function(J,e,D,A,P,T,L,R,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function I(){const o=n.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(u=>!!o[u].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=I;function g(){const o=n.Registry.as(L.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(o).filter(k=>!!o[k].ignoreSync),d=Object.keys(o).filter(k=>o[k].scope===2||o[k].scope===6),m=I();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...u,...d,...m])}e.getDefaultIgnoredSettings=g,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function b(){const o="vscode://schemas/ignoredSettings",u=n.Registry.as(L.Extensions.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const d=n.Registry.as(E.Extensions.JSONContribution),m=()=>{const k=I(),_=g().filter(F=>F!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(L.allSettings.properties).filter(F=>_.indexOf(F)===-1),N=_.filter(F=>k.indexOf(F)===-1),C={items:{type:"string",enum:[...O,...N.map(F=>`-${F}`)]}};d.registerSchema(o,C)};return u.onDidUpdateConfiguration(()=>m())}e.registerConfiguration=b;function h(o){return o&&(0,P.isObject)(o)&&(0,P.isString)(o.id)&&(0,P.isArray)(o.scopes)}e.isAuthenticationProvider=h;var y;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Extensions="extensions",o.GlobalState="globalState"})(y=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function f(o,u,d){return d.joinPath(u.userDataSyncHome,o,`lastSync${o}.json`)}e.getLastSyncResourceUri=f,e.IUserDataSyncStoreManagementService=(0,S.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,S.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,S.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function w(o){const u={};return u[e.HEADER_EXECUTION_ID]=o,u}e.createSyncHeaders=w;var v;(function(o){o.Unauthorized="Unauthorized",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.UnresolvedConflicts="UnresolvedConflicts",o.Unknown="Unknown"})(v=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class p extends Error{constructor(u,d,m,k){super(u);this.code=d,this.resource=m,this.operationId=k,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=p;class l extends p{constructor(u,d,m,k,_){super(u,m,void 0,_);this.url=d,this.serverCode=k}}e.UserDataSyncStoreError=l;class c extends p{constructor(u,d){super(u,d)}}e.UserDataAutoSyncError=c,function(o){function u(d){if(d instanceof o)return d;const m=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(d.name);if(m&&m[1]){const k=m[2]==="unknown"?void 0:m[2],_=m[3]==="unknown"?void 0:m[3];return new o(d.message,m[1],k,_)}return new o(d.message,"Unknown")}o.toUserDataSyncError=u}(p=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var s;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(s=e.Change||(e.Change={}));var r;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(r=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function i(o){return`sync.enable.${o}`}e.getEnablementKey=i,e.IUserDataSyncResourceEnablementService=(0,S.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,S.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,S.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,S.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,S.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,S.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function a(o,u){if(o.scheme!==e.USER_DATA_SYNC_SCHEME)return o=o.with({scheme:u.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(d=>(0,A.isEqualOrParent)(o,(0,A.joinPath)(u.userDataSyncHome,d,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=a}),define(te[48],ne([0,1,17,5,22,27,3,36,2,16,25,18,7,141,20,13,14,46,23,21,24]),function(J,e,D,A,P,T,L,R,S,E,n,I,g,b,h,y,f,w,v,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function c(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&(Object.keys(a).length===2||Object.keys(a).length===3&&a.machineId!==void 0&&typeof a.machineId=="string"))}e.isSyncData=c;let t=class extends S.Disposable{constructor(o,u,d,m,k,_,O,N,C,F){super();this.resource=o,this.fileService=u,this.environmentService=d,this.userDataSyncStoreService=k,this.userDataSyncBackupStoreService=_,this.userDataSyncResourceEnablementService=O,this.telemetryService=N,this.logService=C,this.configurationService=F,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new A.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,n.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(d.userDataSyncHome,1024)?E.extUri:E.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(d.userDataSyncHome,o),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,l.PREVIEW_DIR_NAME),this.lastSyncResource=(0,l.getLastSyncResourceUri)(o,d,this.extUri),this.currentMachineIdPromise=(0,w.getServiceMachineId)(d,u,m)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const o=await this.syncPreviewPromise;this.syncPreviewPromise=null;const u=await this.performSync(o.remoteUserData,o.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(u)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const o=await this.getLastSyncUserData();(o?(await this.doGenerateSyncResourcePreview(o,o,!0,this.getUserDataSyncConfiguration(),T.CancellationToken.None)).resourcePreviews.some(({remoteChange:d})=>d!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(o){if(this._status!==o){const u=this._status;o==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),u==="hasConflicts"&&o==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=o,this._onDidChangStatus.fire(o)}}async sync(o,u={}){await this._sync(o,!0,this.getUserDataSyncConfiguration(),u)}async preview(o,u,d={}){return this._sync(o,!1,u,d)}async apply(o,u={}){try{this.syncHeaders={...u};const d=await this.doApply(o);return this.setStatus(d),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(o,u,d,m){try{if(this.syncHeaders={...m},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let k="idle";try{const _=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(o,_);return k=await this.performSync(O,_,u,d),k==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):k==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(k)}}finally{this.syncHeaders={}}}async replace(o){const u=await this.resolveContent(o);if(!u)return!1;const d=this.parseSyncData(u);if(!d)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const m=await this.getLastSyncUserData(),k=await this.getLatestRemoteUserData(null,m),_=await this.isRemoteDataFromCurrentMachine(k),O=await this.generateSyncPreview({ref:k.ref,syncData:d},m,_,this.getUserDataSyncConfiguration(),T.CancellationToken.None),N=[];for(const C of O){const F=await this.getAcceptResult(C,C.remoteResource,void 0,T.CancellationToken.None),{remoteChange:z}=await this.getAcceptResult(C,C.previewResource,C.remoteContent,T.CancellationToken.None);N.push([C,{...F,remoteChange:z!==0?z:2}])}await this.applyResult(k,m,N,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(o){const u=await this.currentMachineIdPromise;return!!o.syncData?.machineId&&o.syncData.machineId===u}async getLatestRemoteUserData(o,u){if(u){const d=o&&o.latest?o.latest[this.resource]:void 0;if(u.ref===d||d===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async performSync(o,u,d,m){if(o.syncData&&o.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new l.UserDataSyncError((0,b.localize)(0,null,this.resource,this.version,o.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(o,u,d,m)}catch(k){if(k instanceof l.UserDataSyncError)switch(k.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(o,u,d,m);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),o=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.performSync(o,u,d,m)}throw k}}async doSync(o,u,d,m){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,A.createCancelablePromise)(_=>this.doGenerateSyncResourcePreview(o,u,d,m,_)));const k=await this.syncPreviewPromise;return this.updateConflicts(k.resourcePreviews),k.resourcePreviews.some(({mergeState:_})=>_==="conflict")?"hasConflicts":d?await this.doApply(!1):"syncing"}catch(k){throw this.syncPreviewPromise=null,k}}async merge(o){return await this.updateSyncResourcePreview(o,async u=>{const d=await this.getMergeResult(u,T.CancellationToken.None);await this.fileService.writeFile(u.previewResource,P.VSBuffer.fromString(d?.content||""));const m=d&&!d.hasConflicts?await this.getAcceptResult(u,u.previewResource,void 0,T.CancellationToken.None):void 0;return u.acceptResult=m,u.mergeState=d.hasConflicts?"conflict":m?"accepted":"preview",u.localChange=m?m.localChange:d.localChange,u.remoteChange=m?m.remoteChange:d.remoteChange,u}),this.syncPreviewPromise}async accept(o,u){return await this.updateSyncResourcePreview(o,async d=>{const m=await this.getAcceptResult(d,o,u,T.CancellationToken.None);return d.acceptResult=m,d.mergeState="accepted",d.localChange=m.localChange,d.remoteChange=m.remoteChange,d}),this.syncPreviewPromise}async discard(o){return await this.updateSyncResourcePreview(o,async u=>{const d=await this.getMergeResult(u,T.CancellationToken.None);return await this.fileService.writeFile(u.previewResource,P.VSBuffer.fromString(d.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=d.localChange,u.remoteChange=d.remoteChange,u}),this.syncPreviewPromise}async updateSyncResourcePreview(o,u){if(!this.syncPreviewPromise)return;let d=await this.syncPreviewPromise;const m=d.resourcePreviews.findIndex(({localResource:k,remoteResource:_,previewResource:O})=>this.extUri.isEqual(k,o)||this.extUri.isEqual(_,o)||this.extUri.isEqual(O,o));m!==-1&&(this.syncPreviewPromise=(0,A.createCancelablePromise)(async k=>{const _=[...d.resourcePreviews];return _[m]=await u(_[m]),{...d,resourcePreviews:_}}),d=await this.syncPreviewPromise,this.updateConflicts(d.resourcePreviews),d.resourcePreviews.some(({mergeState:k})=>k==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(o){if(!this.syncPreviewPromise)return"idle";const u=await this.syncPreviewPromise;return u.resourcePreviews.some(({mergeState:d})=>d==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:d})=>d!=="accepted")?"syncing":(await this.applyResult(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(d=>[d,d.acceptResult]),o),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(o){}}updateConflicts(o){const u=o.filter(({mergeState:d})=>d==="conflict");(0,D.equals)(this._conflicts,u,(d,m)=>this.extUri.isEqual(d.previewResource,m.previewResource))||(this._conflicts=u,this._onDidChangeConflicts.fire(u))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:u,ref:d})=>({created:u,uri:this.toRemoteBackupResource(d)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:u,ref:d})=>({created:u,uri:this.toLocalBackupResource(d)}))}toRemoteBackupResource(o){return g.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${o}`})}toLocalBackupResource(o){return g.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${o}`})}async getMachineId({uri:o}){const u=this.extUri.basename(o);if(this.extUri.isEqual(o,this.toRemoteBackupResource(u))){const{content:d}=await this.getUserData(u);if(d)return this.parseSyncData(d)?.machineId}}async resolveContent(o){const u=this.extUri.basename(o);if(this.extUri.isEqual(o,this.toRemoteBackupResource(u))){const{content:d}=await this.getUserData(u);return d}return this.extUri.isEqual(o,this.toLocalBackupResource(u))?this.userDataSyncBackupStoreService.resolveContent(this.resource,u):null}async resolvePreviewContent(o){const u=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(u)for(const d of u.resourcePreviews){if(this.extUri.isEqual(d.acceptedResource,o))return d.acceptResult?d.acceptResult.content:null;if(this.extUri.isEqual(d.remoteResource,o))return d.remoteContent;if(this.extUri.isEqual(d.localResource,o))return d.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(o){}}async doGenerateSyncResourcePreview(o,u,d,m,k){const _=await this.isRemoteDataFromCurrentMachine(o),O=await this.generateSyncPreview(o,u,_,m,k),N=[];for(const C of O){const F=C.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(C.localChange===0&&C.remoteChange===0)N.push({...C,acceptedResource:F,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const z=d?await this.getMergeResult(C,k):void 0;if(k.isCancellationRequested)break;await this.fileService.writeFile(C.previewResource,P.VSBuffer.fromString(z?.content||""));const U=z&&!z.hasConflicts?await this.getAcceptResult(C,C.previewResource,void 0,k):void 0;N.push({...C,acceptResult:U,mergeState:z?.hasConflicts?"conflict":U?"accepted":"preview",localChange:U?U.localChange:z?z.localChange:C.localChange,remoteChange:U?U.remoteChange:z?z.remoteChange:C.remoteChange})}}return{remoteUserData:o,lastSyncUserData:u,resourcePreviews:N,isLastSyncFromCurrentMachine:_}}async getLastSyncUserData(){try{const o=await this.fileService.readFile(this.lastSyncResource),u=JSON.parse(o.value.toString()),d=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=u.version&&d&&u.version!==d,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${d}.`),await this.resetLocal(),null;const m=u;if(m.content===null)return{ref:u.ref,syncData:null};const k=JSON.parse(m.content);if(c(k))return{...u,syncData:k,content:void 0}}catch(o){o instanceof f.FileOperationError&&o.fileOperationResult===1||this.logService.error(o)}return null}async updateLastSyncUserData(o,u={}){if(u.ref||u.content||u.version)throw new Error("Cannot have core properties as additional");const d=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),m={ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null,version:d,...u};await this.fileService.writeFile(this.lastSyncResource,P.VSBuffer.fromString(JSON.stringify(m)))}async getRemoteUserData(o){const{ref:u,content:d}=await this.getUserData(o);let m=null;return d!==null&&(m=this.parseSyncData(d)),{ref:u,syncData:m}}parseSyncData(o){try{const u=JSON.parse(o);if(c(u))return u}catch(u){this.logService.error(u)}throw new l.UserDataSyncError((0,b.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(o){if((0,I.isString)(o)){const u=await this.userDataSyncStoreService.resolveContent(this.resource,o);return{ref:o,content:u}}else{const u=o?{ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,u,this.syncHeaders)}}async updateRemoteUserData(o,u){const d=await this.currentMachineIdPromise,m={version:this.version,machineId:d,content:o};return u=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(m),u,this.syncHeaders),{ref:u,syncData:m}}async backupLocal(o){const u={version:this.version,content:o};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(u))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};t=he([X(1,f.IFileService),X(2,y.IEnvironmentService),X(3,v.IStorageService),X(4,l.IUserDataSyncStoreService),X(5,l.IUserDataSyncBackupStoreService),X(6,l.IUserDataSyncResourceEnablementService),X(7,p.ITelemetryService),X(8,l.IUserDataSyncLogService),X(9,h.IConfigurationService)],t),e.AbstractSynchroniser=t;let s=class extends t{constructor(o,u,d,m,k,_,O,N,C,F,z){super(u,d,m,k,_,O,N,C,F,z);this.file=o,this._register(this.fileService.watch(this.extUri.dirname(o))),this._register(this.fileService.onDidFilesChange(U=>this.onFileChanges(U)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(o){return null}}async updateLocalFileContent(o,u,d){try{u?await this.fileService.writeFile(this.file,P.VSBuffer.fromString(o),d?void 0:u):await this.fileService.createFile(this.file,P.VSBuffer.fromString(o),{overwrite:d})}catch(m){throw m instanceof f.FileOperationError&&m.fileOperationResult===1||m instanceof f.FileOperationError&&m.fileOperationResult===3?new l.UserDataSyncError(m.message,"LocalPreconditionFailed"):m}}onFileChanges(o){!o.contains(this.file)||this.triggerLocalChange()}};s=he([X(2,f.IFileService),X(3,y.IEnvironmentService),X(4,v.IStorageService),X(5,l.IUserDataSyncStoreService),X(6,l.IUserDataSyncBackupStoreService),X(7,l.IUserDataSyncResourceEnablementService),X(8,p.ITelemetryService),X(9,l.IUserDataSyncLogService),X(10,h.IConfigurationService)],s),e.AbstractFileSynchroniser=s;let r=class extends s{constructor(o,u,d,m,k,_,O,N,C,F,z,U){super(o,u,d,m,k,_,O,N,C,F,U);this.userDataSyncUtilService=z,this._formattingOptions=void 0}hasErrors(o){const u=[];return(0,R.parse)(o,u,{allowEmptyContent:!0,allowTrailingComma:!0}),u.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};r=he([X(2,f.IFileService),X(3,y.IEnvironmentService),X(4,v.IStorageService),X(5,l.IUserDataSyncStoreService),X(6,l.IUserDataSyncBackupStoreService),X(7,l.IUserDataSyncResourceEnablementService),X(8,p.ITelemetryService),X(9,l.IUserDataSyncLogService),X(10,l.IUserDataSyncUtilService),X(11,h.IConfigurationService)],r),e.AbstractJsonFileSynchroniser=r;let i=class{constructor(o,u,d,m){this.resource=o,this.environmentService=u,this.logService=d,this.fileService=m,this.extUri=this.fileService.hasCapability(u.userDataSyncHome,1024)?E.extUri:E.extUriIgnorePathCase,this.lastSyncResource=(0,l.getLastSyncResourceUri)(this.resource,u,E.extUri)}async initialize({ref:o,content:u}){if(!u){this.logService.info("Remote content does not exist.",this.resource);return}const d=this.parseSyncData(u);if(!d)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:o,syncData:d})}catch(k){this.logService.error(k)}}parseSyncData(o){try{const u=JSON.parse(o);if(c(u))return u}catch(u){this.logService.error(u)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(o,u={}){const d={ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null,...u};await this.fileService.writeFile(this.lastSyncResource,P.VSBuffer.fromString(JSON.stringify(d)))}};i=he([X(1,y.IEnvironmentService),X(2,l.IUserDataSyncLogService),X(3,f.IFileService)],i),e.AbstractInitializer=i}),define(te[213],ne([0,1,5,27,8,3,44,49,25,7,20,13,28,35,14,23,21,48,210,94,95,24]),function(J,e,D,A,P,T,L,R,S,E,n,I,g,b,h,y,f,w,v,p,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function t(o,u){const d=JSON.parse(o.content);if(o.version===1||o.version===2){const m=(await u.getInstalled(0)).filter(k=>k.isBuiltin);for(const k of d)o.version===1&&(k.enabled===!1&&(k.disabled=!0),delete k.enabled),o.version===2&&m.every(_=>!(0,b.areSameExtensions)(_.identifier,k.identifier))&&(k.installed=!0)}return d}function s(o,u,d){const m=d.get((0,b.getExtensionId)(o,u),0)||"{}";return JSON.parse(m)}e.getExtensionStorageState=s;function r(o,u,d,m){m.store((0,b.getExtensionId)(o,u),JSON.stringify(d),0,1)}e.storeExtensionStorageState=r;let i=class ht extends w.AbstractSynchroniser{constructor(u,d,m,k,_,O,N,C,F,z,U,j,W,x){super("extensions",d,u,m,k,_,j,W,F,U);this.storageService=m,this.extensionManagementService=O,this.extensionEnablementService=N,this.ignoredExtensionsManagementService=C,this.extensionGalleryService=z,this.extensionsStorageSyncService=x,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.debounce(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,q=>q.some(({local:$})=>!!$)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,q=>!q.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(u,d){const m=u.syncData?await t(u.syncData,this.extensionManagementService):null,k=d?.skippedExtensions||[],_=d?.syncData?await t(d.syncData,this.extensionManagementService):null,O=await this.extensionManagementService.getInstalled(void 0,!0),N=this.getLocalExtensions(O),C=this.ignoredExtensionsManagementService.getIgnoredExtensions(O);m?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:F,remote:z}=(0,v.merge)(N,m,_,k,C),U={local:F,remote:z,content:this.getPreviewContent(N,F.added,F.updated,F.removed),localChange:F.added.length>0||F.removed.length>0||F.updated.length>0?2:0,remoteChange:z!==null?2:0};return[{skippedExtensions:k,localResource:this.localResource,localContent:this.format(N),localExtensions:N,remoteResource:this.remoteResource,remoteContent:m?this.format(m):null,previewResource:this.previewResource,previewResult:U,localChange:U.localChange,remoteChange:U.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(u,d,m,k){const _=[...d,...m],O=new Set,N=C=>{O.add(C.id.toLowerCase()),C.uuid&&O.add(C.uuid)};_.forEach(({identifier:C})=>N(C)),k.forEach(N);for(const C of u)O.has(C.identifier.id.toLowerCase())||C.identifier.uuid&&O.has(C.identifier.uuid)||_.push(C);return this.format(_)}async getMergeResult(u,d){return{...u.previewResult,hasConflicts:!1}}async getAcceptResult(u,d,m,k){if(this.extUri.isEqual(d,this.localResource))return this.acceptLocal(u);if(this.extUri.isEqual(d,this.remoteResource))return this.acceptRemote(u);if(this.extUri.isEqual(d,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async acceptLocal(u){const d=await this.extensionManagementService.getInstalled(),m=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),k=(0,v.merge)(u.localExtensions,null,null,u.skippedExtensions,m),{local:_,remote:O}=k;return{content:u.localContent,local:_,remote:O,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:O!==null?2:0}}async acceptRemote(u){const d=await this.extensionManagementService.getInstalled(),m=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),k=u.remoteContent?JSON.parse(u.remoteContent):null;if(k!==null){const _=(0,v.merge)(u.localExtensions,k,u.localExtensions,[],m),{local:O,remote:N}=_;return{content:u.remoteContent,local:O,remote:N,localChange:O.added.length>0||O.removed.length>0||O.updated.length>0?2:0,remoteChange:N!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(u,d,m,k){let{skippedExtensions:_,localExtensions:O}=m[0][0],{local:N,remote:C,localChange:F,remoteChange:z}=m[0][1];if(F===0&&z===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),F!==0&&(await this.backupLocal(JSON.stringify(O)),_=await this.updateLocalExtensions(N.added,N.removed,N.updated,_)),C){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const U=JSON.stringify(C.all);u=await this.updateRemoteUserData(U,k?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${C.added.length?` Added: ${JSON.stringify(C.added.map(j=>j.identifier.id))}.`:""}${C.updated.length?` Updated: ${JSON.stringify(C.updated.map(j=>j.identifier.id))}.`:""}${C.removed.length?` Removed: ${JSON.stringify(C.removed.map(j=>j.identifier.id))}.`:""}`)}d?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(u,{skippedExtensions:_}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${_.length?` Skipped: ${JSON.stringify(_.map(U=>U.identifier.id))}.`:""}`))}async getAssociatedResources({uri:u}){return[{resource:this.extUri.joinPath(u,"extensions.json"),comparableResource:ht.EXTENSIONS_DATA_URI}]}async resolveContent(u){if(this.extUri.isEqual(u,ht.EXTENSIONS_DATA_URI)){const m=await this.extensionManagementService.getInstalled(),k=this.ignoredExtensionsManagementService.getIgnoredExtensions(m),_=this.getLocalExtensions(m).filter(O=>!k.some(N=>(0,b.areSameExtensions)({id:N},O.identifier)));return this.format(_)}if(this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u))return this.resolvePreviewContent(u);let d=await super.resolveContent(u);if(d)return d;if(d=await super.resolveContent(this.extUri.dirname(u)),d){const m=this.parseSyncData(d);if(m)switch(this.extUri.basename(u)){case"extensions.json":return this.format(this.parseExtensions(m))}}return null}format(u){u.sort((k,_)=>!k.identifier.uuid&&_.identifier.uuid?-1:k.identifier.uuid&&!_.identifier.uuid?1:(0,S.compare)(k.identifier.id,_.identifier.id));const d=JSON.stringify(u),m=(0,R.format)(d,void 0,{});return(0,L.applyEdits)(d,m)}async hasLocalData(){try{const u=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(u).some(m=>m.installed||m.disabled))return!0}catch(u){}return!1}async updateLocalExtensions(u,d,m,k){const _=[],O=[],N=await this.extensionManagementService.getInstalled();if(d.length){const F=N.filter(({identifier:z,isBuiltin:U})=>!U&&d.some(j=>(0,b.areSameExtensions)(z,j)));await D.Promises.settled(F.map(async z=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,z.identifier.id),await this.extensionManagementService.uninstall(z,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,z.identifier.id),_.push(z.identifier)}))}(u.length||m.length)&&await D.Promises.settled([...u,...m].map(async F=>{const z=N.find(j=>(0,b.areSameExtensions)(j.identifier,F.identifier));if(z&&z.isBuiltin){F.state&&z.manifest.version===F.version&&this.updateExtensionState(F.state,z.manifest.publisher,z.manifest.name,z.manifest.version),F.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,F.identifier.id),await this.extensionEnablementService.disableExtension(F.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,F.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,F.identifier.id),await this.extensionEnablementService.enableExtension(F.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,F.identifier.id)),_.push(F.identifier);return}const U=(await this.extensionGalleryService.getExtensions([F.identifier],A.CancellationToken.None))[0];if(F.state&&(z?z.manifest.version===F.version:!!U)){const j=z?z.manifest.publisher:U.publisher,W=z?z.manifest.name:U.name;this.updateExtensionState(F.state,j,W,z?.manifest.version)}if(U)try{F.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,F.identifier.id,U.version),await this.extensionEnablementService.disableExtension(U.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,F.identifier.id,U.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,F.identifier.id,U.version),await this.extensionEnablementService.enableExtension(U.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,F.identifier.id,U.version)),z||(await this.extensionManagementService.canInstall(U)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,F.identifier.id,U.version),await this.extensionManagementService.installFromGallery(U,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,F.identifier.id,U.version),_.push(U.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,U.displayName||U.identifier.id),O.push(F)))}catch(j){O.push(F),j instanceof g.ExtensionManagementError&&j.code===g.INSTALL_ERROR_INCOMPATIBLE?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,U.displayName||U.identifier.id):(this.logService.error(j),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,U.displayName||U.identifier.id))}else O.push(F),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,F.identifier.id)}));const C=[];for(const F of k)_.some(z=>(0,b.areSameExtensions)(z,F.identifier))||C.push(F);for(const F of O)C.some(z=>(0,b.areSameExtensions)(z.identifier,F.identifier))||C.push(F);return C}updateExtensionState(u,d,m,k){const _=s(d,m,this.storageService),O=k?this.extensionsStorageSyncService.getKeysForSync({id:(0,b.getGalleryExtensionId)(d,m),version:k}):void 0;O?O.forEach(N=>{_[N]=u[N]}):Object.keys(u).forEach(N=>_[N]=u[N]),r(d,m,_,this.storageService)}parseExtensions(u){return JSON.parse(u.content)}getLocalExtensions(u){const d=this.extensionEnablementService.getDisabledExtensions();return u.map(({identifier:m,isBuiltin:k,manifest:_})=>{const O={identifier:m,version:_.version};d.some(N=>(0,b.areSameExtensions)(N,m))&&(O.disabled=!0),k||(O.installed=!0);try{const N=this.extensionsStorageSyncService.getKeysForSync({id:m.id,version:_.version});if(N){const C=s(_.publisher,_.name,this.storageService);O.state=Object.keys(C).reduce((F,z)=>(N.includes(z)&&(F[z]=C[z]),F),{})}}catch(N){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,P.getErrorMessage)(N))}return O})}};i.EXTENSIONS_DATA_URI=E.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=he([X(0,I.IEnvironmentService),X(1,h.IFileService),X(2,y.IStorageService),X(3,c.IUserDataSyncStoreService),X(4,c.IUserDataSyncBackupStoreService),X(5,g.IExtensionManagementService),X(6,g.IGlobalExtensionEnablementService),X(7,l.IIgnoredExtensionsManagementService),X(8,c.IUserDataSyncLogService),X(9,g.IExtensionGalleryService),X(10,n.IConfigurationService),X(11,c.IUserDataSyncResourceEnablementService),X(12,f.ITelemetryService),X(13,p.IExtensionsStorageSyncService)],i),e.ExtensionsSynchroniser=i;let a=class extends w.AbstractInitializer{constructor(u,d,m,k,_){super("extensions",k,_,m);this.extensionManagementService=u,this.ignoredExtensionsManagementService=d}async parseExtensions(u){return u.syncData?await t(u.syncData,this.extensionManagementService):null}generatePreview(u,d){const m=[],k=[],_=[];for(const O of u){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(O.identifier.id))continue;const N=d.find(C=>(0,b.areSameExtensions)(C.identifier,O.identifier));N?(m.push(N),O.disabled&&_.push(O.identifier)):O.installed&&(k.push(O.identifier),O.disabled&&_.push(O.identifier))}return{installedExtensions:m,newExtensions:k,disabledExtensions:_,remoteExtensions:u}}};a=he([X(0,g.IExtensionManagementService),X(1,l.IIgnoredExtensionsManagementService),X(2,h.IFileService),X(3,I.IEnvironmentService),X(4,c.IUserDataSyncLogService)],a),e.AbstractExtensionsInitializer=a}),define(te[214],ne([0,1,26,24]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function P(R,S,E,n,I){if(!S)return{remote:Object.keys(R).length>0?R:null,local:{added:{},removed:[],updated:{}}};const g=T(R,S);if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const b=E?T(E,S):{added:Object.keys(S).reduce((v,p)=>(v.add(p),v),new Set),removed:new Set,updated:new Set},h=E?T(E,R):{added:Object.keys(R).reduce((v,p)=>(v.add(p),v),new Set),removed:new Set,updated:new Set},y={added:{},removed:[],updated:{}},f=D.deepClone(S),w=!E;for(const v of h.added.values())v!==A.SYNC_SERVICE_URL_TYPE&&w&&b.added.has(v)||(f[v]=R[v]);for(const v of h.updated.values())f[v]=R[v];for(const v of h.removed.values())n.unregistered.includes(v)||delete f[v];for(const v of b.added.values()){const p=S[v];if(n.machine.includes(v)){I.info(`GlobalState: Skipped adding ${v} in local storage because it is declared as machine scoped.`);continue}if(E&&h.added.has(v))continue;const l=R[v];l&&l.value===p.value||v===A.SYNC_SERVICE_URL_TYPE&&w&&h.added.has(v)||(l?y.updated[v]=p:y.added[v]=p)}for(const v of b.updated.values()){const p=S[v];if(n.machine.includes(v)){I.info(`GlobalState: Skipped updating ${v} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(v)||h.removed.has(v))continue;const l=R[v];l&&l.value===p.value||(y.updated[v]=p)}for(const v of b.removed.values()){if(n.machine.includes(v)){I.trace(`GlobalState: Skipped removing ${v} in local storage because it is declared as machine scoped.`);continue}h.updated.has(v)||h.removed.has(v)||y.removed.push(v)}return{local:y,remote:L(f,S)?null:f}}e.merge=P;function T(R,S){const E=Object.keys(R),n=Object.keys(S),I=n.filter(h=>E.indexOf(h)===-1).reduce((h,y)=>(h.add(y),h),new Set),g=E.filter(h=>n.indexOf(h)===-1).reduce((h,y)=>(h.add(y),h),new Set),b=new Set;for(const h of E){if(g.has(h))continue;const y=R[h],f=S[h];D.equals(y,f)||b.add(h)}return{added:I,removed:g,updated:b}}function L(R,S){const{added:E,removed:n,updated:I}=T(R,S);return E.size===0&&n.size===0&&I.size===0}}),define(te[215],ne([0,1,22,8,3,36,44,49,4,7,30,20,13,14,10,46,23,21,48,54,214,24]),function(J,e,D,A,P,T,L,R,S,E,n,I,g,b,h,y,f,w,v,p,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const t="globalState.argv.",s=["locale"];function r(d){const m=d.storage?Object.keys(d.storage).sort():[],k={};m.forEach(N=>k[N]=d.storage[N]),d.storage=k;const _=JSON.stringify(d),O=(0,R.format)(_,void 0,{});return(0,L.applyEdits)(_,O)}const i=1;let a=class ft extends v.AbstractSynchroniser{constructor(m,k,_,O,N,C,F,z,U){super("globalState",m,N,U,k,_,C,F,O,z);this.storageService=U,this.version=i,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(m.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(P.Event.any(P.Event.filter(m.onDidFilesChange,j=>j.contains(this.environmentService.argvResource)),P.Event.filter(U.onDidChangeValue,j=>j.scope===0&&j.target!==void 0?j.target===0:U.keys(0,0).includes(j.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(m,k,_){const O=m.syncData?JSON.parse(m.syncData.content):null;k=k===null&&_?m:k;const N=k&&k.syncData?JSON.parse(k.syncData.content):null,C=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const F=this.getStorageKeys(N),{local:z,remote:U}=(0,l.merge)(C.storage,O?O.storage:null,N?N.storage:null,F,this.logService),j={content:null,local:z,remote:U,localChange:Object.keys(z.added).length>0||Object.keys(z.updated).length>0||z.removed.length>0?2:0,remoteChange:U!==null?2:0};return[{localResource:this.localResource,localContent:r(C),localUserData:C,remoteResource:this.remoteResource,remoteContent:O?r(O):null,previewResource:this.previewResource,previewResult:j,localChange:j.localChange,remoteChange:j.remoteChange,acceptedResource:this.acceptedResource,storageKeys:F}]}async getMergeResult(m,k){return{...m.previewResult,hasConflicts:!1}}async getAcceptResult(m,k,_,O){if(this.extUri.isEqual(k,this.localResource))return this.acceptLocal(m);if(this.extUri.isEqual(k,this.remoteResource))return this.acceptRemote(m);if(this.extUri.isEqual(k,this.previewResource))return m.previewResult;throw new Error(`Invalid Resource: ${k.toString()}`)}async acceptLocal(m){return{content:m.localContent,local:{added:{},removed:[],updated:{}},remote:m.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(m){if(m.remoteContent!==null){const k=JSON.parse(m.remoteContent),{local:_,remote:O}=(0,l.merge)(m.localUserData.storage,k.storage,null,m.storageKeys,this.logService);return{content:m.remoteContent,local:_,remote:O,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:m.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(m,k,_,O){let{localUserData:N}=_[0][0],{local:C,remote:F,localChange:z,remoteChange:U}=_[0][1];if(z===0&&U===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),z!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(N)),await this.writeLocalGlobalState(C),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),U!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const j=JSON.stringify({storage:F});m=await this.updateRemoteUserData(j,O?null:m.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}k?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:m}){return[{resource:this.extUri.joinPath(m,"globalState.json"),comparableResource:ft.GLOBAL_STATE_DATA_URI}]}async resolveContent(m){if(this.extUri.isEqual(m,ft.GLOBAL_STATE_DATA_URI)){const _=await this.getLocalGlobalState();return r(_)}if(this.extUri.isEqual(this.remoteResource,m)||this.extUri.isEqual(this.localResource,m)||this.extUri.isEqual(this.acceptedResource,m))return this.resolvePreviewContent(m);let k=await super.resolveContent(m);if(k)return k;if(k=await super.resolveContent(this.extUri.dirname(m)),k){const _=this.parseSyncData(k);if(_)switch(this.extUri.basename(m)){case"globalState.json":return r(JSON.parse(_.content))}}return null}async hasLocalData(){try{const{storage:m}=await this.getLocalGlobalState();if(Object.keys(m).length>1||m[`${t}.locale`]?.value!=="en")return!0}catch(m){}return!1}async getLocalGlobalState(){const m={},k=await this.getLocalArgvContent(),_=(0,T.parse)(k);for(const O of s)_[O]!==void 0&&(m[`${t}${O}`]={version:1,value:_[O]});for(const O of this.storageService.keys(0,0)){const N=this.storageService.get(O,0);N&&(m[O]={version:1,value:N})}return{storage:m}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const m=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),m.value.toString()}catch(m){this.logService.debug((0,A.getErrorMessage)(m))}return"{}"}async writeLocalGlobalState({added:m,removed:k,updated:_}){const O={},N={},C=(z,U)=>{for(const j of z){if(j.startsWith(t)){O[j.substring(t.length)]=U?U[j].value:void 0;continue}if(U){const W=U[j];W.value!==String(this.storageService.get(j,0))&&(N[j]=W.value)}else this.storageService.get(j,0)!==void 0&&(N[j]=void 0)}};if(C(Object.keys(m),m),C(Object.keys(_),_),C(k),Object.keys(O).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(O),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(N).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const z of Object.keys(N))this.storageService.store(z,N[z],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(N))}}async updateArgv(m){const k=await this.getLocalArgvContent();let _=k;for(const O of Object.keys(m))_=(0,p.edit)(_,[O],m[O],{});k!==_&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(_)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(m){const k=this.storageService.keys(0,0),_=this.storageService.keys(0,1),O=[...k,..._],N=m?.storage?Object.keys(m.storage).filter(C=>!C.startsWith(t)&&!O.includes(C)&&this.storageService.get(C,0)!==void 0):[];if(!S.isWeb){const C=[...c.ALL_SYNC_RESOURCES.map(F=>(0,c.getEnablementKey)(F)),c.SYNC_SERVICE_URL_TYPE];N.push(...C),_.push(...C)}return{user:k,machine:_,unregistered:N}}};a.GLOBAL_STATE_DATA_URI=E.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),a=he([X(0,b.IFileService),X(1,c.IUserDataSyncStoreService),X(2,c.IUserDataSyncBackupStoreService),X(3,c.IUserDataSyncLogService),X(4,g.IEnvironmentService),X(5,c.IUserDataSyncResourceEnablementService),X(6,w.ITelemetryService),X(7,I.IConfigurationService),X(8,f.IStorageService)],a),e.GlobalStateSynchroniser=a;let o=class extends v.AbstractInitializer{constructor(m,k,_,O){super("globalState",_,O,k);this.storageService=m}async doInitialize(m){const k=m.syncData?JSON.parse(m.syncData.content):null;if(!k){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const _={},O={};for(const N of Object.keys(k.storage))N.startsWith(t)?_[N.substring(t.length)]=k.storage[N].value:this.storageService.get(N,0)===void 0&&(O[N]=k.storage[N].value);if(Object.keys(_).length){let N="{}";try{N=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(C){}for(const C of Object.keys(_))N=(0,p.edit)(N,[C],_[C],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(N))}if(Object.keys(O).length)for(const N of Object.keys(O))this.storageService.store(N,O[N],0,0)}};o=he([X(0,f.IStorageService),X(1,b.IFileService),X(2,g.IEnvironmentService),X(3,c.IUserDataSyncLogService)],o),e.GlobalStateInitializer=o;let u=class{constructor(m,k,_,O,N){this.userDataSyncStoreClient=m,this.storageService=k,this.environmentService=_,this.fileService=O,this.logService=N}getSyncStoreType(m){return this.parseGlobalState(m)?.storage[c.SYNC_SERVICE_URL_TYPE]?.value}async sync(m){const k=(0,c.createSyncHeaders)((0,n.generateUuid)());try{return await this.doSync(m,k)}catch(_){if(_ instanceof c.UserDataSyncError)switch(_.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(m,k)}throw _}}async doSync(m,k){const _=await this.userDataSyncStoreClient.read("globalState",null,k),O=this.parseGlobalState(_)||{storage:{}};O.storage[c.SYNC_SERVICE_URL_TYPE]={value:m,version:i};const N=await(0,y.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),C={version:i,machineId:N,content:r(O)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(C),_.ref,k)}parseGlobalState({content:m}){if(!m)return null;const k=JSON.parse(m);if((0,v.isSyncData)(k))return k?JSON.parse(k.content):null;throw new Error("Invalid remote data")}};u=he([X(1,f.IStorageService),X(2,g.IEnvironmentService),X(3,b.IFileService),X(4,h.ILogService)],u),e.UserDataSyncStoreTypeSynchronizer=u}),define(te[216],ne([0,1,17,22,3,36,4,18,142,20,13,14,23,21,48,211,24]),function(J,e,D,A,P,T,L,R,S,E,n,I,g,b,h,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function w(l,c,t){try{const s=JSON.parse(l);if(!c)return(0,R.isUndefined)(s.all)?null:s.all;switch(L.OS){case 2:return(0,R.isUndefined)(s.mac)?null:s.mac;case 3:return(0,R.isUndefined)(s.linux)?null:s.linux;case 1:return(0,R.isUndefined)(s.windows)?null:s.windows}}catch(s){return t.error(s),null}}e.getKeybindingsContentFromSyncContent=w;let v=class extends h.AbstractJsonFileSynchroniser{constructor(c,t,s,r,i,a,o,u,d,m){super(o.keybindingsResource,"keybindings",a,o,u,c,t,i,m,s,d,r);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(P.Event.filter(r.onDidChangeConfiguration,k=>k.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(c,t,s,r){const i=c.syncData?w(c.syncData.content,r.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;t=t===null&&s?c:t;const a=t?this.getKeybindingsContentFromLastSyncUserData(t):null,o=await this.getLocalFileContent(),u=await this.getFormattingOptions();let d=null,m=!1,k=!1,_=!1;if(i){let N=o?o.value.toString():"[]";if(N=N||"[]",this.hasErrors(N))throw new f.UserDataSyncError((0,S.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==N||a!==i){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const C=await(0,y.merge)(N,i,a,u,this.userDataSyncUtilService);C.hasChanges&&(d=C.mergeContent,_=C.hasConflicts,m=_||C.mergeContent!==N,k=_||C.mergeContent!==i)}}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),d=o.value.toString(),k=!0);const O={content:d,localChange:m?o?2:1:0,remoteChange:k?2:0,hasConflicts:_};return[{fileContent:o,localResource:this.localResource,localContent:o?o.value.toString():null,localChange:O.localChange,remoteResource:this.remoteResource,remoteContent:i,remoteChange:O.remoteChange,previewResource:this.previewResource,previewResult:O,acceptedResource:this.acceptedResource}]}async getMergeResult(c,t){return c.previewResult}async getAcceptResult(c,t,s,r){if(this.extUri.isEqual(t,this.localResource))return{content:c.fileContent?c.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:c.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return s===void 0?{content:c.previewResult.content,localChange:c.previewResult.localChange,remoteChange:c.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(c,t,s,r){const{fileContent:i}=s[0][0];let{content:a,localChange:o,remoteChange:u}=s[0][1];if(o===0&&u===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.hasErrors(a)))throw new f.UserDataSyncError((0,S.localize)(1,null),"LocalInvalidContent",this.resource);if(o!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),i&&await this.backupLocal(this.toSyncContent(i.value.toString())),await this.updateLocalFileContent(a||"[]",i,r),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),u!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const d=this.toSyncContent(a||"[]",c.syncData?.content);c=await this.updateRemoteUserData(d,r?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(d){}t?.ref!==c.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(c,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const c=await this.getLocalFileContent();if(c){const t=(0,T.parse)(c.value.toString());if((0,D.isNonEmptyArray)(t))return!0}}catch(c){if(c.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:c}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(c,"keybindings.json"),comparableResource:t}]}async resolveContent(c){if(this.extUri.isEqual(this.remoteResource,c)||this.extUri.isEqual(this.localResource,c)||this.extUri.isEqual(this.acceptedResource,c))return this.resolvePreviewContent(c);let t=await super.resolveContent(c);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(c)),t){const s=this.parseSyncData(t);if(s)switch(this.extUri.basename(c)){case"keybindings.json":return w(s.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(c){return!c.syncData||c.platformSpecific!==void 0&&c.platformSpecific!==this.syncKeybindingsPerPlatform()?null:w(c.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(c,t){let s={};try{s=JSON.parse(t||"{}")}catch(r){this.logService.error(r)}switch(this.syncKeybindingsPerPlatform()?delete s.all:s.all=c,L.OS){case 2:s.mac=c;break;case 3:s.linux=c;break;case 1:s.windows=c;break}return JSON.stringify(s)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};v=he([X(0,f.IUserDataSyncStoreService),X(1,f.IUserDataSyncBackupStoreService),X(2,f.IUserDataSyncLogService),X(3,E.IConfigurationService),X(4,f.IUserDataSyncResourceEnablementService),X(5,I.IFileService),X(6,n.IEnvironmentService),X(7,g.IStorageService),X(8,f.IUserDataSyncUtilService),X(9,b.ITelemetryService)],v),e.KeybindingsSynchroniser=v;let p=class extends h.AbstractInitializer{constructor(c,t,s){super("keybindings",t,s,c)}async doInitialize(c){const t=c.syncData?this.getKeybindingsContentFromSyncContent(c.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,A.VSBuffer.fromString(t)),await this.updateLastSyncUserData(c)}async isEmpty(){try{const c=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,T.parse)(c.value.toString());return!(0,D.isNonEmptyArray)(t)}catch(c){return c.fileOperationResult===1}}getKeybindingsContentFromSyncContent(c){try{return w(c,!0,this.logService)}catch(t){return this.logService.error(t),null}}};p=he([X(0,I.IFileService),X(1,n.IEnvironmentService),X(2,f.IUserDataSyncLogService)],p),e.KeybindingsInitializer=p}),define(te[217],ne([0,1,17,36,44,49,26,54,24]),function(J,e,D,A,P,T,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function E(o,u,d){let m=[];d?m=I(d):m=n(u);const k=[],_=[...(0,S.getDisallowedIgnoredSettings)()];if(Array.isArray(m))for(const O of m)O.startsWith("-")?_.push(O.substring(1)):k.push(O);return(0,D.distinct)([...o,...k].filter(O=>_.indexOf(O)===-1))}e.getIgnoredSettings=E;function n(o){let u=o.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=o.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:o.getValue("settingsSync.ignoredSettings")||[]}function I(o){const u=(0,A.parse)(o);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function g(o,u,d,m){if(d.length){const k=a(u),_=(0,A.parse)(u),O=(0,A.parse)(o),N=[];for(const C of d){const F=_[C],z=O[C];F===void 0?o=R.edit(o,[C],void 0,m):z!==void 0?o=R.edit(o,[C],F,m):N.push(c(C,k))}N.sort((C,F)=>C.startOffset-F.startOffset),N.forEach(C=>o=w(C.setting.key,u,o,m))}return o}e.updateIgnoredSettings=g;function b(o,u,d,m,k,_){const O=g(o,u,m,_),N=d!==O,C=d!==u;if(!N&&!C)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(N&&!C)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(C&&!N)return{conflictsSettings:[],localContent:g(u,o,m,_),remoteContent:null,hasConflicts:!1};if(d===null&&y(o)){const H=h(o,u,m)?null:g(u,o,m,_);return{conflictsSettings:[],localContent:H,remoteContent:null,hasConflicts:!1}}let F=o,z=u;const U=(0,A.parse)(o),j=(0,A.parse)(u),W=d?(0,A.parse)(d):null,x=m.reduce((H,re)=>(H.add(re),H),new Set),q=f(U,j,x),$=f(W,U,x),G=f(W,j,x),M=new Map,B=new Set,V=H=>{B.add(H);const re=k.filter(({key:ie})=>ie===H)[0];re?(F=R.edit(F,[H],re.value,_),z=R.edit(z,[H],re.value,_)):M.set(H,{key:H,localValue:U[H],remoteValue:j[H]})};for(const H of $.removed.values())G.updated.has(H)?V(H):z=R.edit(z,[H],void 0,_);for(const H of G.removed.values())B.has(H)||($.updated.has(H)?V(H):F=R.edit(F,[H],void 0,_));for(const H of $.updated.values())B.has(H)||(G.updated.has(H)?q.updated.has(H)&&V(H):z=R.edit(z,[H],U[H],_));for(const H of G.updated.values())B.has(H)||($.updated.has(H)?q.updated.has(H)&&V(H):F=R.edit(F,[H],j[H],_));for(const H of $.added.values())B.has(H)||(G.added.has(H)?q.updated.has(H)&&V(H):z=w(H,F,z,_));for(const H of G.added.values())B.has(H)||($.added.has(H)?q.updated.has(H)&&V(H):F=w(H,z,F,_));const Q=M.size>0||!h(F,z,m),Z=Q||!h(F,o,[]),K=Q||!h(z,u,[]);return{localContent:Z?F:null,remoteContent:K?z:null,conflictsSettings:[...M.values()],hasConflicts:Q}}e.merge=b;function h(o,u,d){if(o===u)return!0;const m=(0,A.parse)(o),k=(0,A.parse)(u),_=d.reduce((C,F)=>(C.add(F),C),new Set),O=a(o).filter(C=>!(C.setting&&_.has(C.setting.key))),N=a(u).filter(C=>!(C.setting&&_.has(C.setting.key)));if(O.length!==N.length)return!1;for(let C=0;C<O.length;C++){const F=O[C],z=N[C];if(F.setting&&z.setting){if(F.setting.key!==z.setting.key||!L.equals(m[F.setting.key],k[F.setting.key]))return!1}else if(!F.setting&&!z.setting){if(F.value!==z.value)return!1}else return!1}return!0}e.areSame=h;function y(o){return o?a(o).length===0:!0}e.isEmpty=y;function f(o,u,d){const m=o?Object.keys(o).filter(C=>!d.has(C)):[],k=Object.keys(u).filter(C=>!d.has(C)),_=k.filter(C=>m.indexOf(C)===-1).reduce((C,F)=>(C.add(F),C),new Set),O=m.filter(C=>k.indexOf(C)===-1).reduce((C,F)=>(C.add(F),C),new Set),N=new Set;if(o)for(const C of m){if(O.has(C))continue;const F=o[C],z=u[C];L.equals(F,z)||N.add(C)}return{added:_,removed:O,updated:N}}function w(o,u,d,m){const k=(0,A.parse)(u),_=a(u),O=a(d),N=v(o,_,O);return p(d,o,k[o],N,O,m)}e.addSetting=w;function v(o,u,d){const m=u.findIndex(_=>_.setting?.key===o),k=u[m-1];if(k){if(k.setting){const O=c(k.setting.key,d);if(O)return{index:d.indexOf(O),insertAfter:!0}}else{const O=t(m,u);if(O){const N=c(O.setting.key,d);if(N){const C=s(d.indexOf(N),d),F=r(u,O,u[m]);if(C){const z=r(d,N,C),U=i(F,z);return U?{index:d.indexOf(U),insertAfter:!0}:{index:d.indexOf(C),insertAfter:!1}}else{const z=r(d,N,d[d.length-1]),U=i(F,z);return U?{index:d.indexOf(U),insertAfter:!0}:{index:d.length-1,insertAfter:!0}}}}}const _=u[m+1];if(_)if(_.setting){const O=c(_.setting.key,d);if(O)return{index:d.indexOf(O),insertAfter:!1}}else{const O=s(m,u);if(O){const N=c(O.setting.key,d);if(N){const C=t(d.indexOf(N),d),F=r(u,u[m],O);if(C){const z=r(d,C,N),U=i(F.reverse(),z.reverse());return U?{index:d.indexOf(U),insertAfter:!1}:{index:d.indexOf(C),insertAfter:!0}}else{const z=r(d,d[0],N),U=i(F.reverse(),z.reverse());return U?{index:d.indexOf(U),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:d.length-1,insertAfter:!0}}function p(o,u,d,m,k,_){let O;return m.index===-1?O=(0,P.setProperty)(o,[u],d,_):O=l(o,u,d,m,k,_).map(N=>(0,P.withFormatting)(o,N,_)[0]),(0,P.applyEdits)(o,O)}function l(o,u,d,m,k,_){const O=`${JSON.stringify(u)}: ${JSON.stringify(d)}`,N=(0,T.getEOL)(_,o),C=k[m.index];if(m.insertAfter){const F=[];if(C.setting)F.push({offset:C.endOffset,length:0,content:","+O});else{const z=s(m.index,k),U=t(m.index,k),j=U?.setting?.commaOffset;U&&j===void 0&&F.push({offset:U.endOffset,length:0,content:","});const W=j!==void 0&&j>C.endOffset;F.push({offset:W?j+1:C.endOffset,length:0,content:z?N+O+",":N+O})}return F}else{if(C.setting)return[{offset:C.startOffset,length:0,content:O+","}];const F=(k[m.index-1]&&!k[m.index-1].setting?N:"")+O+(s(m.index,k)?",":"")+N;return[{offset:C.startOffset,length:0,content:F}]}}function c(o,u){return u.filter(d=>d.setting?.key===o)[0]}function t(o,u){for(let d=o-1;d>=0;d--)if(u[d].setting)return u[d]}function s(o,u){for(let d=o+1;d<u.length;d++)if(u[d].setting)return u[d]}function r(o,u,d){const m=o.indexOf(u),k=o.indexOf(d);return o.filter((_,O)=>m<O&&O<k)}function i(o,u){if(o.length&&u.length){let d=0;for(;d<u.length&&d<o.length;d++)if(o[d].value!==u[d].value)return u[d-1];return u[d-1]}}function a(o){const u=[];let d=-1,m,k;const _={onObjectBegin:O=>{d++},onObjectProperty:(O,N,C)=>{d===0&&(m=N,k=O)},onObjectEnd:(O,N)=>{d--,d===0&&u.push({startOffset:m,endOffset:O+N,value:o.substring(m,O+N),setting:{key:k,commaOffset:void 0}})},onArrayBegin:(O,N)=>{d++},onArrayEnd:(O,N)=>{d--,d===0&&u.push({startOffset:m,endOffset:O+N,value:o.substring(m,O+N),setting:{key:k,commaOffset:void 0}})},onLiteralValue:(O,N,C)=>{d===0&&u.push({startOffset:m,endOffset:N+C,value:o.substring(m,N+C),setting:{key:k,commaOffset:void 0}})},onSeparator:(O,N,C)=>{if(d===0&&O===","){let F=u.length-1;for(;F>=0&&!u[F].setting;F--);const z=u[F];z&&u.splice(F,1,{startOffset:z.startOffset,endOffset:z.endOffset,value:z.value,setting:{key:z.setting.key,commaOffset:N}})}},onComment:(O,N)=>{d===0&&u.push({startOffset:O,endOffset:O+N,value:o.substring(O,O+N)})}};return(0,A.visit)(o,_),u}}),define(te[218],ne([0,1,22,3,44,143,20,86,13,28,14,23,21,48,54,217,24]),function(J,e,D,A,P,T,L,R,S,E,n,I,g,b,h,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function w(t){return t&&t.settings&&typeof t.settings=="string"&&Object.keys(t).length===1}function v(t){const s=JSON.parse(t);return w(s)?s:{settings:t}}e.parseSettingsSyncContent=v;let p=class extends b.AbstractJsonFileSynchroniser{constructor(s,r,i,a,o,u,d,m,k,_,O){super(r.settingsResource,"settings",s,r,i,a,o,k,_,u,d,m);this.extensionManagementService=O,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(s){const r=await this.getLastSyncUserData(),i=await this.getLatestRemoteUserData(s,r),a=this.getSettingsSyncContent(i),o=new R.ConfigurationModelParser(f.USER_DATA_SYNC_CONFIGURATION_SCOPE);return a?.settings&&o.parse(a.settings),o.configurationModel.getValue(f.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(s,r,i){const a=await this.getLocalFileContent(),o=await this.getFormattingOptions(),u=this.getSettingsSyncContent(s);r=r===null&&i?s:r;const d=r?this.getSettingsSyncContent(r):null,m=await this.getIgnoredSettings();let k=null,_=!1,O=!1,N=!1;if(u){let F=a?a.value.toString().trim():"{}";F=F||"{}",this.validateContent(F),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const z=(0,y.merge)(F,u.settings,d?d.settings:null,m,[],o);k=z.localContent||z.remoteContent,_=z.localContent!==null,O=z.remoteContent!==null,N=z.hasConflicts}else a&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),k=a.value.toString(),O=!0);const C={content:k,localChange:_?2:0,remoteChange:O?2:0,hasConflicts:N};return[{fileContent:a,localResource:this.localResource,localContent:a?a.value.toString():null,localChange:C.localChange,remoteResource:this.remoteResource,remoteContent:u?u.settings:null,remoteChange:C.remoteChange,previewResource:this.previewResource,previewResult:C,acceptedResource:this.acceptedResource}]}async getMergeResult(s,r){const i=await this.getFormattingOptions(),a=await this.getIgnoredSettings();return{...s.previewResult,content:s.previewResult.content?(0,y.updateIgnoredSettings)(s.previewResult.content,"{}",a,i):null}}async getAcceptResult(s,r,i,a){const o=await this.getFormattingOptions(),u=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:s.fileContent?(0,y.updateIgnoredSettings)(s.fileContent.value.toString(),"{}",u,o):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:s.remoteContent!==null?(0,y.updateIgnoredSettings)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",u,o):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return i===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:i!==null?(0,y.updateIgnoredSettings)(i,s.fileContent?s.fileContent.value.toString():"{}",u,o):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(s,r,i,a){const{fileContent:o}=i[0][0];let{content:u,localChange:d,remoteChange:m}=i[0][1];if(d===0&&m===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),u=u?u.trim():"{}",u=u||"{}",this.validateContent(u),d!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),o&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(o.value.toString()))),await this.updateLocalFileContent(u,o,a),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),m!==0){const k=await this.getFormattingOptions(),_=this.getSettingsSyncContent(s),O=await this.getIgnoredSettings(u);u=(0,y.updateIgnoredSettings)(u,_?_.settings:"{}",O,k),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),s=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(u)),a?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(k){}r?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(s),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const r=await this.getFormattingOptions(),i=(0,h.edit)(s.value.toString(),[f.CONFIGURATION_SYNC_STORE_KEY],void 0,r);return!(0,y.isEmpty)(i)}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:s}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(s,"settings.json"),comparableResource:r}]}async resolveContent(s){if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s))return this.resolvePreviewContent(s);let r=await super.resolveContent(s);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(s)),r){const i=this.parseSyncData(r);if(i){const a=this.parseSettingsSyncContent(i.content);if(a)switch(this.extUri.basename(s)){case"settings.json":return a.settings}}}return null}async resolvePreviewContent(s){let r=await super.resolvePreviewContent(s);if(r){const i=await this.getFormattingOptions(),a=await this.getIgnoredSettings();r=(0,y.updateIgnoredSettings)(r,"{}",a,i)}return r}getSettingsSyncContent(s){return s.syncData?this.parseSettingsSyncContent(s.syncData.content):null}parseSettingsSyncContent(s){try{return v(s)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(s){return{settings:s}}async getIgnoredSettings(s){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=A.Event.any(A.Event.filter(this.extensionManagementService.onDidInstallExtensions,a=>a.some(({local:o})=>!!o)),A.Event.filter(this.extensionManagementService.onDidUninstallExtension,a=>!a.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const r=await this._defaultIgnoredSettings;return(0,y.getIgnoredSettings)(r,this.configurationService,s)}validateContent(s){if(this.hasErrors(s))throw new f.UserDataSyncError((0,T.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const s=await this.getLocalFileContent();if(!s)return;const r=JSON.parse(s.value.toString());if(!c(r))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const i=this.parseSettingsSyncContent(r.content);if(!i||!i.settings)return;let a=i.settings;const o=await this.getFormattingOptions();for(const u in r)if(["version","content","machineId"].indexOf(u)===-1&&r[u]!==void 0){const d=(0,P.setProperty)(a,[u],r[u],o);d.length&&(a=(0,P.applyEdits)(a,d))}await this.fileService.writeFile(this.file,D.VSBuffer.fromString(a))}catch(s){}}};p=he([X(0,n.IFileService),X(1,S.IEnvironmentService),X(2,I.IStorageService),X(3,f.IUserDataSyncStoreService),X(4,f.IUserDataSyncBackupStoreService),X(5,f.IUserDataSyncLogService),X(6,f.IUserDataSyncUtilService),X(7,L.IConfigurationService),X(8,f.IUserDataSyncResourceEnablementService),X(9,g.ITelemetryService),X(10,E.IExtensionManagementService)],p),e.SettingsSynchroniser=p;let l=class extends b.AbstractInitializer{constructor(s,r,i){super("settings",r,i,s)}async doInitialize(s){const r=s.syncData?this.parseSettingsSyncContent(s.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.environmentService.settingsResource);return(0,y.isEmpty)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}parseSettingsSyncContent(s){try{return v(s)}catch(r){this.logService.error(r)}return null}};l=he([X(0,n.IFileService),X(1,S.IEnvironmentService),X(2,f.IUserDataSyncLogService)],l),e.SettingsInitializer=l;function c(t){return!!(t&&t.version!==void 0&&typeof t.version=="number"&&t.content!==void 0&&typeof t.content=="string"&&t.machineId!==void 0&&typeof t.machineId=="string")}}),define(te[219],ne([0,1,22,3,26,20,13,14,23,21,48,212,24]),function(J,e,D,A,P,T,L,R,S,E,n,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let b=class extends n.AbstractSynchroniser{constructor(f,w,v,p,l,c,t,s,r){super("snippets",w,f,v,p,l,s,r,c,t);this.version=1,this.snippetsFolder=f.snippetsHome,this._register(this.fileService.watch(f.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(A.Event.filter(this.fileService.onDidFilesChange,i=>i.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(f,w,v){const p=await this.getSnippetsFileContents(),l=this.toSnippetsContents(p),c=f.syncData?this.parseSnippets(f.syncData):null;w=w===null&&v?f:w;const t=w&&w.syncData?this.parseSnippets(w.syncData):null;c?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,I.merge)(l,c,t);return this.getResourcePreviews(s,p,c||{})}async getMergeResult(f,w){return f.previewResult}async getAcceptResult(f,w,v,p){if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:0,remoteChange:f.fileContent?f.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:f.remoteContent,localChange:f.remoteContent!==null?f.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder))return v===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:v,localChange:v===null?f.fileContent!==null?3:0:2,remoteChange:v===null?f.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${w.toString()}`)}async applyResult(f,w,v,p){const l=v.map(([c,t])=>({...c,acceptResult:t}));l.every(({localChange:c,remoteChange:t})=>c===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),l.some(({localChange:c})=>c!==0)&&(await this.updateLocalBackup(l),await this.updateLocalSnippets(l,p)),l.some(({remoteChange:c})=>c!==0)&&(f=await this.updateRemoteSnippets(l,f,p)),w?.ref!==f.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(f),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:c}of l)try{await this.fileService.del(c)}catch(t){}}getResourcePreviews(f,w,v){const p=new Map;for(const l of Object.keys(f.local.added)){const c={content:f.local.added[l],hasConflicts:!1,localChange:1,remoteChange:0};p.set(l,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(f.local.updated)){const c={content:f.local.updated[l],hasConflicts:!1,localChange:2,remoteChange:0};p.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of f.local.removed){const c={content:null,hasConflicts:!1,localChange:3,remoteChange:0};p.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(f.remote.added)){const c={content:f.remote.added[l],hasConflicts:!1,localChange:0,remoteChange:1};p.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(f.remote.updated)){const c={content:f.remote.updated[l],hasConflicts:!1,localChange:0,remoteChange:2};p.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of f.remote.removed){const c={content:null,hasConflicts:!1,localChange:0,remoteChange:3};p.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of f.conflicts){const c={content:w[l]?w[l].value.toString():null,hasConflicts:!0,localChange:w[l]?2:1,remoteChange:v[l]?2:1};p.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l]||null,localContent:w[l]?w[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(w))if(!p.has(l)){const c={content:w[l]?w[l].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};p.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l]||null,localContent:w[l]?w[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...p.values()]}async getAssociatedResources({uri:f}){let w=await super.resolveContent(f);if(w){const v=this.parseSyncData(w);if(v){const p=this.parseSnippets(v),l=[];for(const c of Object.keys(p)){const t=this.extUri.joinPath(f,c),s=this.extUri.joinPath(this.snippetsFolder,c),r=await this.fileService.exists(s);l.push({resource:t,comparableResource:r?s:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"})})}return l}}return[]}async resolveContent(f){if(this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(f);let w=await super.resolveContent(f);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(f)),w){const v=this.parseSyncData(w);if(v)return this.parseSnippets(v)[this.extUri.basename(f)]||null}return null}async hasLocalData(){try{const f=await this.getSnippetsFileContents();if(Object.keys(f).length)return!0}catch(f){}return!1}async updateLocalBackup(f){const w={};for(const v of f)v.fileContent&&(w[this.extUri.basename(v.localResource)]=v.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(w)))}async updateLocalSnippets(f,w){for(const{fileContent:v,acceptResult:p,localResource:l,remoteResource:c,localChange:t}of f)if(t!==0){const s=c?this.extUri.basename(c):this.extUri.basename(l),r=this.extUri.joinPath(this.snippetsFolder,s);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(r)),await this.fileService.del(r),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(r))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(r)),await this.fileService.createFile(r,D.VSBuffer.fromString(p.content),{overwrite:w}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(r))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(r)),await this.fileService.writeFile(r,D.VSBuffer.fromString(p.content),w?void 0:v),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(r)))}}async updateRemoteSnippets(f,w,v){const p=w.syncData?this.parseSnippets(w.syncData):{},l=(0,P.deepClone)(p);for(const{acceptResult:c,localResource:t,remoteResource:s,remoteChange:r}of f)if(r!==0){const i=t?this.extUri.basename(t):this.extUri.basename(s);r===3?delete l[i]:l[i]=c.content}return(0,I.areSame)(p,l)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),w=await this.updateRemoteUserData(JSON.stringify(l),v?null:w.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),w}parseSnippets(f){return JSON.parse(f.content)}toSnippetsContents(f){const w={};for(const v of Object.keys(f))w[v]=f[v].value.toString();return w}async getSnippetsFileContents(){const f={};let w;try{w=await this.fileService.resolve(this.snippetsFolder)}catch(v){if(v instanceof R.FileOperationError&&v.fileOperationResult===1)return f;throw v}for(const v of w.children||[]){const p=v.resource,l=this.extUri.extname(p);if(l===".json"||l===".code-snippets"){const c=this.extUri.relativePath(this.snippetsFolder,p),t=await this.fileService.readFile(p);f[c]=t}}return f}};b=he([X(0,L.IEnvironmentService),X(1,R.IFileService),X(2,S.IStorageService),X(3,g.IUserDataSyncStoreService),X(4,g.IUserDataSyncBackupStoreService),X(5,g.IUserDataSyncLogService),X(6,T.IConfigurationService),X(7,g.IUserDataSyncResourceEnablementService),X(8,E.ITelemetryService)],b),e.SnippetsSynchroniser=b;let h=class extends n.AbstractInitializer{constructor(f,w,v){super("snippets",w,v,f)}async doInitialize(f){const w=f.syncData?JSON.parse(f.syncData.content):null;if(!w){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const p of Object.keys(w)){const l=w[p];if(l){const c=this.extUri.joinPath(this.environmentService.snippetsHome,p);await this.fileService.createFile(c,D.VSBuffer.fromString(l)),this.logService.info("Created snippet",this.extUri.basename(c))}}await this.updateLastSyncUserData(f)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(f){return f.fileOperationResult===1}}};h=he([X(0,R.IFileService),X(1,L.IEnvironmentService),X(2,g.IUserDataSyncLogService)],h),e.SnippetsInitializer=h}),define(te[62],ne([0,1,3,2,6,24]),function(J,e,D,A,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,P.createDecorator)("IUserDataSyncAccountService");let L=class extends A.Disposable{constructor(S){super();this.userDataSyncStoreService=S,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(S.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(S.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(S){(S&&this._account?S.token!==this._account.token||S.authenticationProviderId!==this._account.authenticationProviderId:S!==this._account)&&(this._account=S,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(S))}};L=he([X(0,T.IUserDataSyncStoreService)],L),e.UserDataSyncAccountService=L}),define(te[220],ne([0,1,5,22,57,2,16,20,13,14,24]),function(J,e,D,A,P,T,L,R,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let I=class extends T.Disposable{constructor(b,h,y,f){super();this.environmentService=b,this.fileService=h,this.configurationService=y,this.logService=f,n.ALL_SYNC_RESOURCES.forEach(w=>this.cleanUpBackup(w))}async getAllRefs(b){const h=(0,L.joinPath)(this.environmentService.userDataSyncHome,b),y=await this.fileService.resolve(h);return y.children?y.children.filter(w=>w.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(w.name)).sort().reverse().map(w=>({ref:w.name,created:this.getCreationTime(w)})):[]}async resolveContent(b,h){if(!h){const y=await this.getAllRefs(b);y.length&&(h=y[y.length-1].ref)}if(h){const y=(0,L.joinPath)(this.environmentService.userDataSyncHome,b,h);return(await this.fileService.readFile(y)).value.toString()}return null}async backup(b,h){const y=(0,L.joinPath)(this.environmentService.userDataSyncHome,b),f=(0,L.joinPath)(y,`${(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(f,A.VSBuffer.fromString(h))}catch(w){this.logService.error(w)}try{this.cleanUpBackup(b)}catch(w){}}async cleanUpBackup(b){const h=(0,L.joinPath)(this.environmentService.userDataSyncHome,b);try{try{if(!await this.fileService.exists(h))return}catch(f){return}const y=await this.fileService.resolve(h);if(y.children){const f=y.children.filter(l=>l.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(l.name)).sort(),w=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let v=f.filter(l=>Date.now()-this.getCreationTime(l)>w);const p=f.length-v.length;p<10&&(v=v.slice(10-p)),await D.Promises.settled(v.map(async l=>{this.logService.info("Deleting from backup",l.resource.path),await this.fileService.del(l.resource)}))}}catch(y){this.logService.error(y)}}getCreationTime(b){return b.ctime||new Date(parseInt(b.name.substring(0,4)),parseInt(b.name.substring(4,6))-1,parseInt(b.name.substring(6,8)),parseInt(b.name.substring(9,11)),parseInt(b.name.substring(11,13)),parseInt(b.name.substring(13,15))).getTime()}};I=he([X(0,S.IEnvironmentService),X(1,E.IFileService),X(2,R.IConfigurationService),X(3,n.IUserDataSyncLogService)],I),e.UserDataSyncBackupStoreService=I}),define(te[221],ne([0,1,2,7]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class P{constructor(g){this.service=g}listen(g,b){switch(b){case"onError":return this.service.onError}throw new Error(`Event not found: ${b}`)}call(g,b,h){switch(b){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=P;class T{constructor(g){this.service=g}listen(g,b){throw new Error(`Event not found: ${b}`)}call(g,b,h){switch(b){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(A.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class L{constructor(g){this.channel=g}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(g){return this.channel.call("resolveUserKeybindings",[g])}async resolveFormattingOptions(g){return this.channel.call("resolveFormattingOptions",[g])}}e.UserDataSyncUtilServiceClient=L;class R{constructor(g){this.service=g}listen(g,b){switch(b){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${b}`)}async call(g,b,h){switch(b){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class S{constructor(g){this.service=g}listen(g,b){switch(b){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${b}`)}call(g,b,h){switch(b){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=S;class E{constructor(g){this.service=g}listen(g,b){switch(b){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${b}`)}call(g,b,h){switch(b){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=E;class n extends D.Disposable{constructor(g){super();this.channel=g,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(g){return this.channel.call("switch",[g])}async getPreviousUserDataSyncStore(){const g=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(g)}revive(g){return{url:A.URI.revive(g.url),type:g.type,defaultUrl:A.URI.revive(g.defaultUrl),insidersUrl:A.URI.revive(g.insidersUrl),stableUrl:A.URI.revive(g.stableUrl),canSwitch:g.canSwitch,authenticationProviders:g.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=n}),define(te[222],ne([0,1,13,10]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let P=class extends A.AbstractLogger{constructor(L,R){super();this.logger=this._register(L.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(L,...R){this.logger.trace(L,...R)}debug(L,...R){this.logger.debug(L,...R)}info(L,...R){this.logger.info(L,...R)}warn(L,...R){this.logger.warn(L,...R)}error(L,...R){this.logger.error(L,...R)}critical(L,...R){this.logger.critical(L,...R)}flush(){this.logger.flush()}};P=he([X(0,A.ILoggerService),X(1,D.IEnvironmentService)],P),e.UserDataSyncLogService=P}),define(te[63],ne([0,1,3,2,4,25,146,13,14,6,29,46,23,24]),function(J,e,D,A,P,T,L,R,S,E,n,I,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,E.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName";let y=class Ze extends A.Disposable{constructor(w,v,p,l,c,t){super();this.storageService=p,this.userDataSyncStoreService=l,this.logService=c,this.productService=t,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,I.getServiceMachineId)(w,v,p)}async getMachines(w){const v=await this.currentMachineIdPromise;return(await this.readMachinesData(w)).machines.map(l=>({...l,isCurrent:l.id===v}))}async addCurrentMachine(w){const v=await this.currentMachineIdPromise,p=await this.readMachinesData(w);p.machines.some(({id:l})=>l===v)||(p.machines.push({id:v,name:this.computeCurrentMachineName(p.machines)}),await this.writeMachinesData(p))}async removeCurrentMachine(w){const v=await this.currentMachineIdPromise,p=await this.readMachinesData(w),l=p.machines.filter(({id:c})=>c!==v);l.length!==p.machines.length&&(p.machines=l,await this.writeMachinesData(p))}async renameMachine(w,v,p){const l=await this.currentMachineIdPromise,c=await this.readMachinesData(p),t=c.machines.find(({id:s})=>s===w);t&&(t.name=v,await this.writeMachinesData(c),c.machines.some(({id:s})=>s===l)&&this.storageService.store(h,v,0,1))}async setEnablement(w,v){const p=await this.readMachinesData(),l=p.machines.find(({id:c})=>c===w);l&&(l.disabled=v?void 0:!0,await this.writeMachinesData(p))}computeCurrentMachineName(w){const v=this.storageService.get(h,0);if(v)return v;const p=`${this.productService.nameLong} (${(0,P.PlatformToString)(P.isWeb?0:P.platform)})`,l=new RegExp(`${(0,T.escapeRegExpCharacters)(p)}\\s#(\\d+)`);let c=0;for(const t of w){const s=l.exec(t.name),r=s?parseInt(s[1]):0;c=r>c?r:c}return`${p} #${c+1}`}async readMachinesData(w){this.userData=await this.readUserData(w);const v=this.parse(this.userData);if(v.version!==Ze.VERSION)throw new Error((0,L.localize)(0,null,this.productService.nameLong));return v}async writeMachinesData(w){const v=JSON.stringify(w),p=await this.userDataSyncStoreService.write(Ze.RESOURCE,v,this.userData?.ref||null);this.userData={ref:p,content:v},this._onDidChange.fire()}async readUserData(w){if(this.userData){const v=w&&w.latest?w.latest[Ze.RESOURCE]:void 0;if(this.userData.ref===v)return this.userData;if(v===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ze.RESOURCE,this.userData)}parse(w){if(w.content!==null)try{return JSON.parse(w.content)}catch(v){this.logService.error(v)}return{version:Ze.VERSION,machines:[]}}};y.VERSION=1,y.RESOURCE="machines",y=he([X(0,R.IEnvironmentService),X(1,S.IFileService),X(2,g.IStorageService),X(3,b.IUserDataSyncStoreService),X(4,b.IUserDataSyncLogService),X(5,n.IProductService)],y),e.UserDataSyncMachinesService=y}),define(te[96],ne([0,1,5,57,37,8,3,2,4,16,7,144,13,29,23,21,24,62,63]),function(J,e,D,A,P,T,L,R,S,E,n,I,g,b,h,y,f,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const p="sync.enable",l="sync.disableMachineEventually",c="sync.sessionId",t="sync.storeUrl",s="sync.productQuality";let r=class extends R.Disposable{constructor(u,d,m){super();this.storageService=u,this.environmentService=d,this.userDataSyncStoreManagementService=m,this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(u.onDidChangeValue(k=>this.onDidStorageChange(k)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(p,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(u){u&&!this.canToggleEnablement()||this.storageService.store(p,u,0,1)}onDidStorageChange(u){if(u.scope===0&&p===u.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};r=he([X(0,h.IStorageService),X(1,g.IEnvironmentService),X(2,f.IUserDataSyncStoreManagementService)],r),e.UserDataAutoSyncEnablementService=r;let i=class extends R.Disposable{constructor(u,d,m,k,_,O,N,C,F,z,U){super();this.userDataSyncStoreManagementService=d,this.userDataSyncStoreService=m,this.userDataSyncResourceEnablementService=k,this.userDataSyncService=_,this.logService=O,this.userDataSyncAccountService=N,this.telemetryService=C,this.userDataSyncMachinesService=F,this.storageService=z,this.autoSync=this._register(new R.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new L.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=U,this.syncTriggerDelayer=this._register(new D.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=d.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=u.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(d.onDidChangeUserDataSyncStore(()=>{(0,E.isEqual)(this.syncUrl,d.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=d.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(N.onDidChangeAccount(()=>this.updateAutoSync())),this._register(m.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(L.Event.debounce(_.onDidChangeLocal,(j,W)=>j?[...j,W]:[W],1e3)(j=>this.triggerSync(j,!1,!1))),this._register(L.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,j])=>j)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const u=this.storageService.get(t,0);return u?n.URI.parse(u):void 0}set syncUrl(u){u?this.storageService.store(t,u.toString(),0,1):this.storageService.remove(t,0)}get productQuality(){return this.storageService.get(s,0)}set productQuality(u){u?this.storageService.store(s,u,0,1):this.storageService.remove(s,0)}updateAutoSync(){const{enabled:u,message:d}=this.isAutoSyncEnabled();u?this.autoSync.value===void 0&&(this.autoSync.value=new a(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(m=>this.onDidFinishSync(m))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(d&&this.logService.info(d),this.autoSync.clear()):d&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(d))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,A.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(u,d,m){try{this.userDataSyncAccountService.account&&!m&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(c,0),u?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(k){if(d)this.logService.error(k),this.updateEnablement(!1);else throw k}}updateEnablement(u){this.userDataAutoSyncEnablementService.isEnabled()!==u&&(this.telemetryService.publicLog2(p,{enabled:u}),this.userDataAutoSyncEnablementService.setEnablement(u),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(u){if(!u){this.successiveFailures=0;return}const d=f.UserDataSyncError.toUserDataSyncError(u);d instanceof f.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:d.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),d.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):d.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):d.code==="LocalTooManyRequests"||d.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):d.code==="UpgradeRequired"||d.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):d.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${d.resource} content with newer version than of client. Requires client upgrade.`)):d.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${d.resource} content with older version than of client. Requires server reset.`)):d.code==="ServiceChanged"||d.code==="DefaultServiceChanged"?S.isWeb&&d.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(d),this.successiveFailures++),this._onError.fire(d)}async disableMachineEventually(){this.storageService.store(l,!0,0,1),await(0,D.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(l,0,!1)}stopDisableMachineEventually(){this.storageService.remove(l,0)}async triggerSync(u,d,m){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(d&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...u),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",m)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};i=he([X(0,b.IProductService),X(1,f.IUserDataSyncStoreManagementService),X(2,f.IUserDataSyncStoreService),X(3,f.IUserDataSyncResourceEnablementService),X(4,f.IUserDataSyncService),X(5,f.IUserDataSyncLogService),X(6,w.IUserDataSyncAccountService),X(7,y.ITelemetryService),X(8,v.IUserDataSyncMachinesService),X(9,h.IStorageService),X(10,f.IUserDataAutoSyncEnablementService)],i),e.UserDataAutoSyncService=i;class a extends R.Disposable{constructor(u,d,m,k,_,O,N,C){super();this.lastSyncUrl=u,this.interval=d,this.userDataSyncStoreManagementService=m,this.userDataSyncStoreService=k,this.userDataSyncService=_,this.userDataSyncMachinesService=O,this.logService=N,this.storageService=C,this.intervalHandler=this._register(new R.MutableDisposable),this._onDidStartSync=this._register(new L.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new L.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,R.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(a.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(a.INTERVAL_SYNCING,!1),this.interval)}sync(u,d){const m=(0,D.createCancelablePromise)(async k=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(_){if((0,T.isPromiseCanceledError)(_))return}return this.doSync(u,d,k)});return this.syncPromise=m,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,E.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const u=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),d=this.userDataSyncStoreManagementService.userDataSyncStore;return!!d&&!!u&&(!(0,E.isEqual)(d.defaultUrl,u.defaultUrl)||!(0,E.isEqual)(d.insidersUrl,u.insidersUrl)||!(0,E.isEqual)(d.stableUrl,u.stableUrl))}async doSync(u,d,m){this.logService.info(`Auto Sync: Triggered by ${u}`),this._onDidStartSync.fire();let k;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,d),m.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new f.UserDataAutoSyncError((0,I.localize)(0,null),"DefaultServiceChanged"):new f.UserDataAutoSyncError((0,I.localize)(1,null),"ServiceChanged"):new f.UserDataAutoSyncError((0,I.localize)(2,null),"TurnedOff");const _=this.storageService.get(c,0);if(_&&this.manifest&&_!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new f.UserDataAutoSyncError((0,I.localize)(3,null),"DefaultServiceChanged"):new f.UserDataAutoSyncError((0,I.localize)(4,null),"ServiceChanged"):new f.UserDataAutoSyncError((0,I.localize)(5,null),"SessionExpired");const O=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(m.isCancellationRequested)return;const N=O.find(C=>C.isCurrent);if(N?.disabled)throw new f.UserDataAutoSyncError((0,I.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(C){throw new f.UserDataAutoSyncError((0,P.toErrorMessage)(C),C instanceof f.UserDataSyncError?C.code:"Unknown")}if(this.manifest&&this.manifest.session!==_&&this.storageService.store(c,this.manifest.session,0,1),m.isCancellationRequested)return;N||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(_){this.logService.error(_),k=_}this._onDidFinishSync.fire(k)}register(u){return super._register(u)}}a.INTERVAL_SYNCING="Interval"}),define(te[223],ne([0,1,3,2,4,23,21,24]),function(J,e,D,A,P,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let S=class extends A.Disposable{constructor(n,I){super();this.storageService=n,this.telemetryService=I,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(n.onDidChangeValue(g=>this.onDidStorageChange(g)))}isResourceEnabled(n){return this.storageService.getBoolean((0,R.getEnablementKey)(n),0,!0)}setResourceEnablement(n,I){if(this.isResourceEnabled(n)!==I){const g=(0,R.getEnablementKey)(n);this.telemetryService.publicLog2(g,{enabled:I}),this.storeResourceEnablement(g,I)}}getResourceSyncStateVersion(n){}storeResourceEnablement(n,I){this.storageService.store(n,I,0,P.isWeb?0:1)}onDidStorageChange(n){if(n.scope===0){const I=R.ALL_SYNC_RESOURCES.filter(g=>(0,R.getEnablementKey)(g)===n.key)[0];if(I){this._onDidChangeResourceEnablement.fire([I,this.isResourceEnabled(I)]);return}}}};S=he([X(0,T.IStorageService),X(1,L.ITelemetryService)],S),e.UserDataSyncResourceEnablementService=S}),define(te[224],ne([0,1,17,5,37,8,3,2,16,30,20,6,23,21,213,215,216,218,219,24]),function(J,e,D,A,P,T,L,R,S,E,n,I,g,b,h,y,f,w,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const l="sync.lastSyncTime";let c=class extends R.Disposable{constructor(i,a,o,u,d,m,k){super();this.userDataSyncStoreService=i,this.userDataSyncStoreManagementService=a,this.instantiationService=o,this.configurationService=u,this.logService=d,this.telemetryService=m,this.storageService=k,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new L.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new L.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(w.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(f.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(v.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(y.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(h.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(L.Event.any(...this.synchronisers.map(_=>L.Event.map(_.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(L.Event.any(...this.synchronisers.map(_=>L.Event.map(_.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(l,0,void 0),this.onDidChangeLocal=L.Event.any(...this.synchronisers.map(_=>L.Event.map(_.onDidChangeLocal,()=>_.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(i,a){await this.checkEnablement();const o=(0,E.generateUuid)();try{const k=(0,p.createSyncHeaders)(o);a&&(k["Cache-Control"]="no-cache"),i=await this.userDataSyncStoreService.manifest(i,k)}catch(k){const _=p.UserDataSyncError.toUserDataSyncError(k);throw this.reportUserDataSyncError(_,o),_}let u=!1;const d=this;let m;return{manifest:i,run(){if(u)throw new Error("Can run a task only once");return m=(0,A.createCancelablePromise)(k=>d.sync(i,o,k)),m.finally(()=>m=void 0)},async stop(){if(m&&m.cancel(),d.status!=="idle")return d.stop()}}}async createManualSyncTask(){await this.checkEnablement();const i=(0,E.generateUuid)(),a=(0,p.createSyncHeaders)(i);let o;try{o=await this.userDataSyncStoreService.manifest(null,a)}catch(u){const d=p.UserDataSyncError.toUserDataSyncError(u);throw this.reportUserDataSyncError(d,i),d}return new t(i,o,a,this.synchronisers,this.configurationService,this.logService)}async sync(i,a,o){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),o.isCancellationRequested)return;const u=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const d=(0,p.createSyncHeaders)(a);for(const m of this.synchronisers){if(o.isCancellationRequested)return;try{await m.sync(i,d)}catch(k){let _=!1;if(k instanceof p.UserDataSyncError)switch(k.code){case"TooLarge":k=new p.UserDataSyncError(k.message,k.code,m.resource),_=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":_=!0;break}const O=p.UserDataSyncError.toUserDataSyncError(k);if(this.reportUserDataSyncError(O,a),_)throw O;this.logService.error(k),this.logService.error(`${m.resource}: ${(0,P.toErrorMessage)(k)}`),this._syncErrors.push([m.resource,O])}}this.logService.info(`Sync done. Took ${new Date().getTime()-u}ms`),this.updateLastSyncTime()}catch(d){const m=p.UserDataSyncError.toUserDataSyncError(d);throw this.reportUserDataSyncError(m,a),m}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const i of this.synchronisers)try{i.status!=="idle"&&await i.stop()}catch(a){this.logService.error(a)}}async replace(i){await this.checkEnablement();for(const a of this.synchronisers)if(await a.replace(i))return}async accept(i,a,o,u){await this.checkEnablement();const d=this.getSynchroniser(i);await d.accept(a,o),u&&await d.apply(!1,(0,p.createSyncHeaders)((0,E.generateUuid)()))}async resolveContent(i){for(const a of this.synchronisers){const o=await a.resolveContent(i);if(o)return o}return null}getRemoteSyncResourceHandles(i){return this.getSynchroniser(i).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(i){return this.getSynchroniser(i).getLocalSyncResourceHandles()}getAssociatedResources(i,a){return this.getSynchroniser(i).getAssociatedResources(a)}getMachineId(i,a){return this.getSynchroniser(i).getMachineId(a)}async hasLocalData(){const i=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const a of i)if(await a.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(i){this.logService.error(i)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(l,0);for(const i of this.synchronisers)try{await i.resetLocal()}catch(a){this.logService.error(`${i.resource}: ${(0,P.toErrorMessage)(a)}`),this.logService.error(a)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const i of this.synchronisers)if(await i.hasPreviouslySynced())return!0;return!1}setStatus(i){const a=this._status;this._status!==i&&(this._status=i,this._onDidChangeStatus.fire(i),a==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const i=this.computeStatus();this.setStatus(i)}updateConflicts(){const i=this.computeConflicts();(0,D.equals)(this._conflicts,i,([a,o],[u,d])=>a===a&&(0,D.equals)(o,d,(m,k)=>(0,S.isEqual)(m.previewResource,k.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(i))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(l,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(i,a){this.telemetryService.publicLog2("sync/error",{code:i.code,serverCode:i instanceof p.UserDataSyncStoreError?String(i.serverCode):void 0,url:i instanceof p.UserDataSyncStoreError?i.url:void 0,resource:i.resource,executionId:a,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(i=>i.status==="hasConflicts").map(i=>[i.resource,i.conflicts.map(s)])}getSynchroniser(i){return this.synchronisers.find(a=>a.resource===i)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};c=he([X(0,p.IUserDataSyncStoreService),X(1,p.IUserDataSyncStoreManagementService),X(2,I.IInstantiationService),X(3,n.IConfigurationService),X(4,p.IUserDataSyncLogService),X(5,b.ITelemetryService),X(6,g.IStorageService)],c),e.UserDataSyncService=c;class t extends R.Disposable{constructor(i,a,o,u,d,m){super();this.id=i,this.manifest=a,this.syncHeaders=o,this.synchronisers=u,this.configurationService=d,this.logService=m,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new L.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,A.createCancelablePromise)(i=>this.getPreviews(i))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(i){throw this.logService.error(i),i}}async accept(i,a){try{return await this.performAction(i,o=>o.accept(i,a))}catch(o){throw this.logService.error(o),o}}async merge(i){try{return i?await this.performAction(i,a=>a.merge(i)):await this.mergeAll()}catch(a){throw this.logService.error(a),a}}async discard(i){try{return await this.performAction(i,a=>a.discard(i))}catch(a){throw this.logService.error(a),a}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const i=[];for(const[,a]of this.previews)for(const o of a.resourcePreviews)o.mergeState==="conflict"&&i.push(o.previewResource);for(const a of i)await this.discard(a);return this.previews}catch(i){throw this.logService.error(i),i}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const i=[];for(const[a,o]of this.previews){this.synchronizingResources.push([a,o.resourcePreviews.map(m=>m.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(m=>m.resource===a);for(const m of o.resourcePreviews)(m.localChange!==0||m.remoteChange!==0)&&m.mergeState==="preview"&&await u.merge(m.previewResource);const d=await u.apply(!1,this.syncHeaders);d&&i.push(this.toSyncResourcePreview(u.resource,d)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(m=>m[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}catch(i){throw this.logService.error(i),i}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,a]of this.previews){this.synchronizingResources.push([i,a.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const o=this.synchronisers.find(u=>u.resource===i);for(const u of a.resourcePreviews)await o.accept(u.remoteResource);await o.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,a]of this.previews){this.synchronizingResources.push([i,a.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const o=this.synchronisers.find(u=>u.resource===i);for(const u of a.resourcePreviews)await o.accept(u.localResource);await o.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async stop(){for(const i of this.synchronisers)try{await i.stop()}catch(a){(0,T.isPromiseCanceledError)(a)||this.logService.error(a)}this.reset()}async performAction(i,a){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const o=this.previews.findIndex(([,C])=>C.resourcePreviews.some(({localResource:F,previewResource:z,remoteResource:U})=>(0,S.isEqual)(i,F)||(0,S.isEqual)(i,z)||(0,S.isEqual)(i,U)));if(o===-1)return this.previews;const[u,d]=this.previews[o],m=d.resourcePreviews.find(({localResource:C,remoteResource:F,previewResource:z})=>(0,S.isEqual)(C,i)||(0,S.isEqual)(F,i)||(0,S.isEqual)(z,i));if(!m)return this.previews;let k=this.synchronizingResources.find(C=>C[0]===u);k||(k=[u,[]],this.synchronizingResources.push(k)),k[1].some(C=>(0,S.isEqual)(C,m.localResource))||(k[1].push(m.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const _=this.synchronisers.find(C=>C.resource===this.previews[o][0]),O=await a(_);O?this.previews.splice(o,1,this.toSyncResourcePreview(_.resource,O)):this.previews.splice(o,1);const N=this.synchronizingResources.findIndex(C=>C[0]===u);return this.synchronizingResources[N][1].splice(k[1].findIndex(C=>(0,S.isEqual)(C,m.localResource)),1),k[1].length||(this.synchronizingResources.splice(N,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const i=[];for(const[a,o]of this.previews){this.synchronizingResources.push([a,o.resourcePreviews.map(m=>m.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(m=>m.resource===a);let d=o;for(const m of o.resourcePreviews)(m.localChange!==0||m.remoteChange!==0)&&m.mergeState==="preview"&&(d=await u.merge(m.previewResource));d&&i.push(this.toSyncResourcePreview(u.resource,d)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(m=>m[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}async getPreviews(i){const a=[],o=await this.getUserDataSyncConfiguration();for(const u of this.synchronisers){if(i.isCancellationRequested)return[];const d=await u.preview(this.manifest,o,this.syncHeaders);d&&a.push(this.toSyncResourcePreview(u.resource,d))}return a}async getUserDataSyncConfiguration(){const i=this.configurationService.getValue(p.USER_DATA_SYNC_CONFIGURATION_SCOPE),a=await this.synchronisers.find(o=>o instanceof w.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...i,...a}}toSyncResourcePreview(i,a){return[i,{isLastSyncFromCurrentMachine:a.isLastSyncFromCurrentMachine,resourcePreviews:a.resourcePreviews.map(s)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function s(r){return{localResource:r.localResource,previewResource:r.previewResource,remoteResource:r.remoteResource,acceptedResource:r.acceptedResource,localChange:r.localChange,remoteChange:r.remoteChange,mergeState:r.mergeState}}}),define(te[225],ne([0,1,3,2,18,7,24]),function(J,e,D,A,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class R{constructor(I,g){this.service=I,this.logService=g,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(I,g){switch(g){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${g}`)}async call(I,g,b){try{return await this._call(I,g,b)}catch(h){throw this.logService.error(h),h}}async _call(I,g,b){switch(g){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(T.URI.revive(b[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(b[0],T.URI.revive(b[1]),b[2],b[3]);case"resolveContent":return this.service.resolveContent(T.URI.revive(b[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(b[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(b[0]);case"getAssociatedResources":return this.service.getAssociatedResources(b[0],{created:b[1].created,uri:T.URI.revive(b[1].uri)});case"getMachineId":return this.service.getMachineId(b[0],{created:b[1].created,uri:T.URI.revive(b[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(g.startsWith("manualSync/")){const h=g.substring("manualSync/".length),y=b[0],f=this.getManualSyncTask(y);switch(b=b.slice(1),h){case"preview":return f.preview();case"accept":return f.accept(T.URI.revive(b[0]),b[1]);case"merge":return f.merge(T.URI.revive(b[0]));case"discard":return f.discard(T.URI.revive(b[0]));case"discardConflicts":return f.discardConflicts();case"apply":return f.apply();case"pull":return f.pull();case"push":return f.push();case"stop":return f.stop();case"_getStatus":return f.status;case"dispose":return this.disposeManualSyncTask(f)}}throw new Error("Invalid call")}getManualSyncTask(I){const g=this.manualSyncTasks.get(this.createKey(I));if(!g)throw new Error(`Manual sync taks not found: ${I}`);return g.manualSyncTask}async createManualSyncTask(){const I=new A.DisposableStore,g=I.add(await this.service.createManualSyncTask());return I.add(g.onSynchronizeResources(b=>this.onManualSynchronizeResources.fire({manualSyncTaskId:g.id,data:b}))),this.manualSyncTasks.set(this.createKey(g.id),{manualSyncTask:g,disposables:I}),{id:g.id,manifest:g.manifest,status:g.status}}disposeManualSyncTask(I){I.dispose();const g=this.createKey(I.id);this.manualSyncTasks.get(g)?.disposables.dispose(),this.manualSyncTasks.delete(g)}createKey(I){return`manualSyncTask-${I}`}}e.UserDataSyncChannel=R;class S extends A.Disposable{constructor(I){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(g,b,h){return I.call(g,b,h).then(null,y=>{throw L.UserDataSyncError.toUserDataSyncError(y)})},listen(g,b){return I.listen(g,b)}},this.channel.call("_getInitialData").then(([g,b,h])=>{this.updateStatus(g),this.updateConflicts(b),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(y=>this.updateStatus(y))),this._register(this.channel.listen("onDidChangeLastSyncTime")(y=>this.updateLastSyncTime(y)))}),this._register(this.channel.listen("onDidChangeConflicts")(g=>this.updateConflicts(g))),this._register(this.channel.listen("onSyncErrors")(g=>this._onSyncErrors.fire(g.map(([b,h])=>[b,L.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:I,manifest:g,status:b}=await this.channel.call("createManualSyncTask"),h=this,y=new E(I,g,b,{async call(f,w,v){return h.channel.call(`manualSync/${f}`,[I,...(0,P.isArray)(w)?w:[w]],v)},listen(f,w){return D.Event.map(D.Event.filter(h.channel.listen(`manualSync/${f}`,w),v=>!y.isDiposed()&&v.manualSyncTaskId===I),v=>v.data)}});return y}replace(I){return this.channel.call("replace",[I])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(I,g,b,h){return this.channel.call("accept",[I,g,b,h])}resolveContent(I){return this.channel.call("resolveContent",[I])}async getLocalSyncResourceHandles(I){return(await this.channel.call("getLocalSyncResourceHandles",[I])).map(({created:b,uri:h})=>({created:b,uri:T.URI.revive(h)}))}async getRemoteSyncResourceHandles(I){return(await this.channel.call("getRemoteSyncResourceHandles",[I])).map(({created:b,uri:h})=>({created:b,uri:T.URI.revive(h)}))}async getAssociatedResources(I,g){return(await this.channel.call("getAssociatedResources",[I,g])).map(({resource:h,comparableResource:y})=>({resource:T.URI.revive(h),comparableResource:T.URI.revive(y)}))}async getMachineId(I,g){return this.channel.call("getMachineId",[I,g])}async updateStatus(I){this._status=I,this._onDidChangeStatus.fire(I)}async updateConflicts(I){this._conflicts=I.map(([g,b])=>[g,b.map(h=>({...h,localResource:T.URI.revive(h.localResource),remoteResource:T.URI.revive(h.remoteResource),previewResource:T.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(I){this._lastSyncTime!==I&&(this._lastSyncTime=I,this._onDidChangeLastSyncTime.fire(I))}}e.UserDataSyncChannelClient=S;class E extends A.Disposable{constructor(I,g,b,h){super();this.id=I,this.manifest=g,this._disposed=!1,this._status=b;const y=this;this.channel={async call(f,w,v){try{const p=await h.call(f,w,v);return y.isDiposed()||(y._status=await h.call("_getStatus")),p}catch(p){throw L.UserDataSyncError.toUserDataSyncError(p)}},listen(f,w){return h.listen(f,w)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const I=await this.channel.call("preview");return this.deserializePreviews(I)}async accept(I,g){const b=await this.channel.call("accept",[I,g]);return this.deserializePreviews(b)}async merge(I){const g=await this.channel.call("merge",[I]);return this.deserializePreviews(g)}async discard(I){const g=await this.channel.call("discard",[I]);return this.deserializePreviews(g)}async discardConflicts(){const I=await this.channel.call("discardConflicts");return this.deserializePreviews(I)}async apply(){const I=await this.channel.call("apply");return this.deserializePreviews(I)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(I){return I.map(([g,b])=>[g,{isLastSyncFromCurrentMachine:b.isLastSyncFromCurrentMachine,resourcePreviews:b.resourcePreviews.map(h=>({...h,localResource:T.URI.revive(h.localResource),remoteResource:T.URI.revive(h.remoteResource),previewResource:T.URI.revive(h.previewResource),acceptedResource:T.URI.revive(h.acceptedResource)}))}])}}}),define(te[226],ne([0,1,5,27,8,3,2,104,4,16,18,7,30,20,13,14,29,43,46,23,24]),function(J,e,D,A,P,T,L,R,S,E,n,I,g,b,h,y,f,w,v,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const c="sync.previous.store",t="sync.donot-make-requests-until",s="sync.user-session-id",r="sync.machine-session-id",i=100,a=1e3*60*5;let o=class extends L.Disposable{constructor(O,N,C){super();this.productService=O,this.configurationService=N,this.storageService=C,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter(C.onDidChangeValue,F=>F.key===l.SYNC_SERVICE_URL_TYPE&&F.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(l.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(l.SYNC_SERVICE_URL_TYPE,O,0,S.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[l.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(l.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,N){O=S.isWeb&&O?.web?{...O,...O.web}:O;const C={...O||{},...N||{}};if(C&&(0,n.isString)(C.url)&&(0,n.isObject)(C.authenticationProviders)&&Object.keys(C.authenticationProviders).every(F=>(0,n.isArray)(C.authenticationProviders[F].scopes))){const F=C,z=!!F.canSwitch&&!N?.url,U=F.url===F.insidersUrl?"insiders":"stable",j=(z?this.userDataSyncStoreType:void 0)||U,W=N?.url||(j==="insiders"?F.insidersUrl:j==="stable"?F.stableUrl:F.url);return{url:I.URI.parse(W),type:j,defaultType:U,defaultUrl:I.URI.parse(F.url),stableUrl:I.URI.parse(F.stableUrl),insidersUrl:I.URI.parse(F.insidersUrl),canSwitch:z,authenticationProviders:Object.keys(F.authenticationProviders).reduce((x,q)=>(x.push({id:q,scopes:F.authenticationProviders[q].scopes}),x),[])}}}};o=he([X(0,f.IProductService),X(1,b.IConfigurationService),X(2,p.IStorageService)],o),e.AbstractUserDataSyncStoreManagementService=o;let u=class extends o{constructor(O,N,C){super(O,N,C);const F=this.storageService.get(c,0);F&&(this.previousConfigurationSyncStore=JSON.parse(F));const z=this.productService[l.CONFIGURATION_SYNC_STORE_KEY];z?this.storageService.store(c,JSON.stringify(z),0,1):this.storageService.remove(c,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};u=he([X(0,f.IProductService),X(1,b.IConfigurationService),X(2,p.IStorageService)],u),e.UserDataSyncStoreManagementService=u;let d=class extends L.Disposable{constructor(O,N,C,F,z,U,j){super();this.requestService=C,this.logService=F,this.storageService=j,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,v.getServiceMachineId)(z,U,j).then(W=>{const x={"X-Client-Name":`${N.applicationName}${S.isWeb?"-web":""}`,"X-Client-Version":N.version};return N.commit&&(x["X-Client-Commit"]=N.commit),x}),this.session=new k(i,a,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,L.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,N){this.authToken={token:O,type:N}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,E.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(t,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(N=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),N).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,N=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O),C={},F=await this.request(N.toString(),{type:"GET",headers:C},[],A.CancellationToken.None);return(await(0,w.asJson)(F)||[]).map(({url:U,created:j})=>({ref:(0,E.relativePath)(N,N.with({path:U})),created:j*1e3}))}async resolveContent(O,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const C=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O,N).toString(),F={};F["Cache-Control"]="no-cache";const z=await this.request(C,{type:"GET",headers:F},[],A.CancellationToken.None);return await(0,w.asText)(z)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),C={};await this.request(N,{type:"DELETE",headers:C},[],A.CancellationToken.None)}async read(O,N,C={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();C={...C},C["Cache-Control"]="no-cache",N&&(C["If-None-Match"]=N.ref);const z=await this.request(F,{type:"GET",headers:C},[304],A.CancellationToken.None);let U=null;if(z.res.statusCode===304&&(U=N),U===null){const j=z.res.headers.etag;if(!j)throw new l.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",z.res.statusCode,z.res.headers[l.HEADER_OPERATION_ID]);const W=await(0,w.asText)(z);if(!W&&z.res.statusCode===304)throw new l.UserDataSyncStoreError("Empty response",F,"EmptyResponse",z.res.statusCode,z.res.headers[l.HEADER_OPERATION_ID]);U={ref:j,content:W}}return U}async write(O,N,C,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();F={...F},F["Content-Type"]=R.Mimes.text,C&&(F["If-Match"]=C);const U=await this.request(z,{type:"POST",data:N,headers:F},[],A.CancellationToken.None),j=U.res.headers.etag;if(!j)throw new l.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",U.res.statusCode,U.res.headers[l.HEADER_OPERATION_ID]);return j}async manifest(O,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const C=(0,E.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();N={...N},N["Content-Type"]="application/json",O&&(N["If-None-Match"]=O.ref);const F=await this.request(C,{type:"GET",headers:N},[304],A.CancellationToken.None);let z=null;if(F.res.statusCode===304&&(z=O),!z){const j=F.res.headers.etag;if(!j)throw new l.UserDataSyncStoreError("Server did not return the ref",C,"NoRef",F.res.statusCode,F.res.headers[l.HEADER_OPERATION_ID]);const W=await(0,w.asText)(F);if(!W&&F.res.statusCode===304)throw new l.UserDataSyncStoreError("Empty response",C,"EmptyResponse",F.res.statusCode,F.res.headers[l.HEADER_OPERATION_ID]);W&&(z={...JSON.parse(W),ref:j})}const U=this.storageService.get(s,0);return U&&z&&U!==z.session&&this.clearSession(),z===null&&U&&this.clearSession(),z&&this.storageService.store(s,z.session,0,1),z}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),N={"Content-Type":R.Mimes.text};await this.request(O,{type:"DELETE",headers:N},[],A.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(s,0),this.storageService.remove(r,0)}async request(O,N,C,F){if(!this.authToken)throw new l.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new l.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const z=await this.commonHeadersPromise;N.headers={...N.headers||{},...z,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(N.headers),this.logService.trace("Sending request to server",{url:O,type:N.type,headers:{...N.headers,authorization:void 0}});let U;try{U=await this.session.request(O,N,F)}catch(q){if(!(q instanceof l.UserDataSyncStoreError)){let $="RequestFailed";const G=(0,P.getErrorMessage)(q).toLowerCase();G.includes("xhr timeout")?$="RequestTimeout":G.includes("protocol")&&G.includes("not supported")?$="RequestProtocolNotSupported":G.includes("request path contains unescaped characters")?$="RequestPathNotEscaped":G.includes("headers must be an object")?$="RequestHeadersNotObject":(0,P.isPromiseCanceledError)(q)&&($="RequestCanceled"),q=new l.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,$,void 0,void 0)}throw this.logService.info("Request failed",O),q}const j=U.res.headers[l.HEADER_OPERATION_ID],W={url:O,status:U.res.statusCode,"execution-id":N.headers[l.HEADER_EXECUTION_ID],"operation-id":j},x=(0,w.isSuccess)(U)||U.res.statusCode&&C.indexOf(U.res.statusCode)!==-1;if(x?this.logService.trace("Request succeeded",W):this.logService.info("Request failed",W),U.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new l.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",U.res.statusCode,j);if(this._onTokenSucceed.fire(),U.res.statusCode===409)throw new l.UserDataSyncStoreError(`${N.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",U.res.statusCode,j);if(U.res.statusCode===410)throw new l.UserDataSyncStoreError(`${N.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",U.res.statusCode,j);if(U.res.statusCode===412)throw new l.UserDataSyncStoreError(`${N.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",U.res.statusCode,j);if(U.res.statusCode===413)throw new l.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",U.res.statusCode,j);if(U.res.statusCode===426)throw new l.UserDataSyncStoreError(`${N.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",U.res.statusCode,j);if(U.res.statusCode===429){const q=U.res.headers["retry-after"];throw q?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(q)*1e3)),new l.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",U.res.statusCode,j)):new l.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",U.res.statusCode,j)}if(!x)throw new l.UserDataSyncStoreError("Server returned "+U.res.statusCode,O,"Unknown",U.res.statusCode,j);return U}addSessionHeaders(O){let N=this.storageService.get(r,0);N===void 0&&(N=(0,g.generateUuid)(),this.storageService.store(r,N,0,1)),O["X-Machine-Session-Id"]=N;const C=this.storageService.get(s,0);C!==void 0&&(O["X-User-Session-Id"]=C)}};d=he([X(1,f.IProductService),X(2,w.IRequestService),X(3,l.IUserDataSyncLogService),X(4,h.IEnvironmentService),X(5,y.IFileService),X(6,p.IStorageService)],d),e.UserDataSyncStoreClient=d;let m=class extends d{constructor(O,N,C,F,z,U,j){super(O.userDataSyncStore?.url,N,C,F,z,U,j);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};m=he([X(0,l.IUserDataSyncStoreManagementService),X(1,f.IProductService),X(2,w.IRequestService),X(3,l.IUserDataSyncLogService),X(4,h.IEnvironmentService),X(5,y.IFileService),X(6,p.IStorageService)],m),e.UserDataSyncStoreService=m;class k{constructor(O,N,C,F){this.limit=O,this.interval=N,this.requestService=C,this.logService=F,this.requests=[],this.startTime=void 0}request(O,N,C){if(this.isExpired()&&this.reset(),N.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new l.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(N,C)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=k}),define(te[227],ne([0,1,3,59,29,23,21,96,24,62,63]),function(J,e,D,A,P,T,L,R,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let I=class extends R.UserDataAutoSyncService{constructor(b,h,y,f,w,v,p,l,c,t,s,r){super(b,h,y,f,w,p,l,c,t,s,r);this._register(D.Event.debounce(D.Event.any(D.Event.map(v.onDidFocusWindow,()=>"windowFocus"),D.Event.map(v.onDidOpenWindow,()=>"windowOpen")),(i,a)=>i?[...i,a]:[a],1e3)(i=>this.triggerSync(i,!0,!1)))}};I=he([X(0,P.IProductService),X(1,S.IUserDataSyncStoreManagementService),X(2,S.IUserDataSyncStoreService),X(3,S.IUserDataSyncResourceEnablementService),X(4,S.IUserDataSyncService),X(5,A.INativeHostService),X(6,S.IUserDataSyncLogService),X(7,E.IUserDataSyncAccountService),X(8,L.ITelemetryService),X(9,n.IUserDataSyncMachinesService),X(10,T.IStorageService),X(11,S.IUserDataAutoSyncEnablementService)],I),e.UserDataAutoSyncService=I}),define(te[228],ne([0,1,5,3,2]),function(J,e,D,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends P.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:S,getActiveWindowId:E}){super();this.disposables=this._register(new P.DisposableStore),A.Event.latch(A.Event.any(R,S))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>E()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch(I){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(te[64],ne([0,1,52,5,9,18,19,122,239,240]),function(J,e,D,A,P,T,L,R,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class n extends Error{constructor(t,s){let r=s.message;switch(t){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r);this.type=t,this.cause=s}}e.ExtractError=n;function I(c){const t=c.externalFileAttributes>>16||33188;return[448,56,7].map(s=>t&s).reduce((s,r)=>s+r,t&61440)}function g(c){if(c instanceof n)return c;let t;return/end of central directory record signature not found/.test(c.message)&&(t="CorruptZip"),new n(t,c)}function b(c,t,s,r,i,a){const o=P.dirname(t),u=P.join(r,o);if(!u.startsWith(r))return Promise.reject(new Error(R.localize(0,null,t)));const d=P.join(r,t);let m;return a.onCancellationRequested(()=>{m&&m.destroy()}),Promise.resolve(L.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((k,_)=>{if(!a.isCancellationRequested)try{m=(0,D.createWriteStream)(d,{mode:s}),m.once("close",()=>k()),m.once("error",_),c.once("error",_),c.pipe(m)}catch(O){_(O)}}))}function h(c,t,s,r){let i=(0,A.createCancelablePromise)(()=>Promise.resolve()),a=0;return r.onCancellationRequested(()=>{i.cancel(),c.close()}),new Promise((o,u)=>{const d=new A.Sequencer,m=k=>{k.isCancellationRequested||(a++,c.readEntry())};c.once("error",u),c.once("close",()=>i.then(()=>{r.isCancellationRequested||c.entryCount===a?o():u(new n("Incomplete",new Error(R.localize(1,null,a,c.entryCount))))},u)),c.readEntry(),c.on("entry",k=>{if(r.isCancellationRequested)return;if(!s.sourcePathRegex.test(k.fileName)){m(r);return}const _=k.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(_)){const C=P.join(t,_);i=(0,A.createCancelablePromise)(F=>L.Promises.mkdir(C,{recursive:!0}).then(()=>m(F)).then(void 0,u));return}const O=f(c,k),N=I(k);i=(0,A.createCancelablePromise)(C=>d.queue(()=>O.then(F=>b(F,_,N,t,s,C).then(()=>m(C)))).then(null,u))})})}function y(c,t=!1){return new Promise((s,r)=>{(0,S.open)(c,t?{lazyEntries:!0}:void 0,(i,a)=>{i?r(g(i)):s((0,T.assertIsDefined)(a))})})}function f(c,t){return new Promise((s,r)=>{c.openReadStream(t,(i,a)=>{i?r(g(i)):s((0,T.assertIsDefined)(a))})})}function w(c,t){return new Promise((s,r)=>{const i=new E.ZipFile;t.forEach(o=>{o.contents?i.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&i.addFile(o.localPath,o.path)}),i.end();const a=(0,D.createWriteStream)(c);i.outputStream.pipe(a),i.outputStream.once("error",r),a.once("error",r),a.once("finish",()=>s(c))})}e.zip=w;function v(c,t,s={},r){const i=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let a=y(c,!0);return s.overwrite&&(a=a.then(o=>L.Promises.rm(t).then(()=>o))),a.then(o=>h(o,t,{sourcePathRegex:i},r))}e.extract=v;function p(c,t){return y(c).then(s=>new Promise((r,i)=>{s.on("entry",a=>{a.fileName===t&&f(s,a).then(o=>r(o),o=>i(o))}),s.once("close",()=>i(new Error(R.localize(2,null,t))))}))}function l(c,t){return p(c,t).then(s=>new Promise((r,i)=>{const a=[];s.once("error",i),s.on("data",o=>a.push(o)),s.on("end",()=>r(Buffer.concat(a)))}))}e.buffer=l}),define(te[229],ne([0,1,64,131]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function P(T){return(0,D.buffer)(T,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch(R){throw new Error((0,A.localize)(0,null))}})}e.getManifest=P}),define(te[230],ne([0,1,17,5,8,2,15,9,4,16,60,7,30,19,64,132,13,28,35,151,14,10,29]),function(J,e,D,A,P,T,L,R,S,E,n,I,g,b,h,y,f,w,v,p,l,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const s="scanningSystem",r="scanningUser",i="extracting",a="deleting",o="renaming";let u=class extends T.Disposable{constructor(m,k,_,O,N){super();this.beforeRemovingExtension=m,this.fileService=k,this.logService=_,this.environmentService=O,this.productService=N,this._devSystemExtensionsPath=null,this.systemExtensionsPath=O.builtinExtensionsPath,this.extensionsPath=O.extensionsPath,this.uninstalledPath=R.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new A.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(m){const k=[];(m===null||m===0)&&k.push(this.scanSystemExtensions().then(null,_=>Promise.reject(new w.ExtensionManagementError(this.joinErrors(_).message,s)))),(m===null||m===1)&&k.push(this.scanUserExtensions(!0).then(null,_=>Promise.reject(new w.ExtensionManagementError(this.joinErrors(_).message,r))));try{const _=await Promise.all(k);return(0,D.flatten)(_)}catch(_){throw this.joinErrors(_)}}async scanUserExtensions(m){this.logService.trace("Started scanning user extensions");let[k,_]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return _=_.filter(O=>!k[new v.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]),m&&(_=(0,v.groupByExtension)(_,N=>N.identifier).map(N=>N.sort((C,F)=>n.rcompare(C.manifest.version,F.manifest.version))[0])),this.logService.trace("Scanned user extensions:",_.length),_}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(m,k,_,O){const N=m.key(),C=R.join(this.extensionsPath,`.${(0,g.generateUuid)()}`),F=R.join(this.extensionsPath,N);try{await b.Promises.rm(F)}catch(U){try{await b.Promises.rm(F)}catch(j){}throw new w.ExtensionManagementError((0,y.localize)(0,null,F,m.id),a)}await this.extractAtLocation(m,k,C,O);let z=await this.scanExtension(I.URI.file(C),1);if(!z)throw new Error((0,y.localize)(1,null,C));await this.storeMetadata(z,{..._,installedTimestamp:Date.now()});try{await this.rename(m,C,F,Date.now()+2*60*1e3),this.logService.info("Renamed to",F)}catch(U){try{await b.Promises.rm(C)}catch(j){}if(U.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",m.id);else throw this.logService.info(`Rename failed because of ${(0,P.getErrorMessage)(U)}. Deleted from extracted location`,C),U}try{z=await this.scanExtension(I.URI.file(F),1)}catch(U){}if(z)return z;throw new Error((0,y.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(m,k){return this.setMetadata(m,k),await this.storeMetadata(m,{...k,installedTimestamp:m.installedTimestamp}),m}async storeMetadata(m,k){k.isMachineScoped=k.isMachineScoped||void 0,k.isBuiltin=k.isBuiltin||void 0,k.installedTimestamp=k.installedTimestamp||void 0;const _=R.join(m.location.fsPath,"package.json"),O=await b.Promises.readFile(_,"utf8"),{manifest:N}=await this.parseManifest(O);return N.__metadata=k,await b.Promises.writeFile(_,JSON.stringify(N,null,"	")),m}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...m){const k=m.map(_=>new v.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version));await this.withUninstalledExtensions(_=>{k.forEach(O=>_[O.key()]=!0)})}async setInstalled(m){await this.withUninstalledExtensions(O=>delete O[m.key()]);const _=(await this.scanExtensions(1)).find(O=>new v.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).equals(m))||null;return _?(await this.storeMetadata(_,{installedTimestamp:Date.now()}),this.scanExtension(_.location,1)):null}async withUninstalledExtensions(m){return this.uninstalledFileLimiter.queue(async()=>{let k;try{k=await b.Promises.readFile(this.uninstalledPath,"utf8")}catch(O){if(O.code!=="ENOENT")throw O}let _={};if(k)try{_=JSON.parse(k)}catch(O){}return m&&(m(_),Object.keys(_).length?await b.Promises.writeFile(this.uninstalledPath,JSON.stringify(_)):await b.Promises.rm(this.uninstalledPath)),_})}async removeExtension(m,k){this.logService.trace(`Deleting ${k} extension from disk`,m.identifier.id,m.location.fsPath),await b.Promises.rm(m.location.fsPath),this.logService.info("Deleted from disk",m.identifier.id,m.location.fsPath)}async removeUninstalledExtension(m){await this.removeExtension(m,"uninstalled"),await this.withUninstalledExtensions(k=>delete k[new v.ExtensionIdentifierWithVersion(m.identifier,m.manifest.version).key()])}async extractAtLocation(m,k,_,O){this.logService.trace(`Started extracting the extension from ${k} to ${_}`);try{await b.Promises.rm(_)}catch(N){throw new w.ExtensionManagementError(this.joinErrors(N).message,a)}try{await(0,h.extract)(k,_,{sourcePath:"extension",overwrite:!0},O),this.logService.info(`Extracted extension to ${_}:`,m.id)}catch(N){try{await b.Promises.rm(_)}catch(C){}throw new w.ExtensionManagementError(N.message,N instanceof h.ExtractError&&N.type?N.type:i)}}async rename(m,k,_,O){try{await b.Promises.rename(k,_)}catch(N){if(S.isWindows&&N&&N.code==="EPERM"&&Date.now()<O)return this.logService.info(`Failed renaming ${k} to ${_} with 'EPERM' error. Trying again...`,m.id),this.rename(m,k,_,O);throw new w.ExtensionManagementError(N.message||(0,y.localize)(3,null,k,_),N.code||o)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const m=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return m;const k=this.scanDevSystemExtensions(),[_,O]=await Promise.all([m,k]);return[..._,...O]}async scanExtensionsInDir(m,k){const _=new A.Limiter(10),O=await this.fileService.resolve(I.URI.file(m));return O.children?(await Promise.all(O.children.filter(C=>C.isDirectory).map(C=>_.queue(async()=>k===1&&(0,E.basename)(C.resource).indexOf(".")===0?null:this.scanExtension(C.resource,k))))).filter(C=>C&&C.identifier):[]}async scanExtension(m,k){try{const _=await this.fileService.resolve(m);if(_.children){const{manifest:O,metadata:N}=await this.readManifest(m.fsPath),C=_.children.find(({name:j})=>/^readme(\.txt|\.md|)$/i.test(j))?.resource,F=_.children.find(({name:j})=>/^changelog(\.txt|\.md|)$/i.test(j))?.resource,z={id:(0,v.getGalleryExtensionId)(O.publisher,O.name)},U={type:k,identifier:z,manifest:O,location:m,readmeUrl:C,changelogUrl:F,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:k===0};return N&&(this.setMetadata(U,N),U.installedTimestamp=N.installedTimestamp),U}}catch(_){k!==0&&this.logService.trace(_)}return null}async scanDefaultSystemExtensions(){const m=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",m.length),m}async scanDevSystemExtensions(){const m=this.getDevSystemExtensionsList();if(m.length){const k=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",k.length),k.filter(_=>m.some(O=>(0,v.areSameExtensions)(_.identifier,{id:O})))}else return[]}setMetadata(m,k){m.publisherDisplayName=k.publisherDisplayName||null,m.publisherId=k.publisherId||null,m.identifier.uuid=k.id,m.isMachineScoped=!!k.isMachineScoped,m.isBuiltin=m.type===0||!!k.isBuiltin}async removeUninstalledExtensions(){const m=await this.getUninstalledExtensions(),k=await this.scanAllUserExtensions(),_=new Set;for(const C of k)m[new v.ExtensionIdentifierWithVersion(C.identifier,C.manifest.version).key()]||_.add(C.identifier.id.toLowerCase());const O=(0,v.groupByExtension)(k,C=>C.identifier);await A.Promises.settled(O.map(async C=>{const F=C.sort((z,U)=>n.rcompare(z.manifest.version,U.manifest.version))[0];_.has(F.identifier.id.toLowerCase())||await this.beforeRemovingExtension(F)}));const N=k.filter(C=>m[new v.ExtensionIdentifierWithVersion(C.identifier,C.manifest.version).key()]);await A.Promises.settled(N.map(C=>this.removeUninstalledExtension(C)))}async removeOutdatedExtensions(){const m=await this.scanAllUserExtensions(),k=[],_=(0,v.groupByExtension)(m,O=>O.identifier);k.push(...(0,D.flatten)(_.map(O=>O.sort((N,C)=>n.rcompare(N.manifest.version,C.manifest.version)).slice(1)))),await A.Promises.settled(k.map(O=>this.removeExtension(O,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(m=>m.name)}joinErrors(m){const k=Array.isArray(m)?m:[m];return k.length===1?k[0]instanceof Error?k[0]:new Error(k[0]):k.reduce((_,O)=>new Error(`${_.message}${_.message?",":""}${O instanceof Error?O.message:O}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=R.normalize(R.join(L.FileAccess.asFileUri("",J).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(m){const k=[b.Promises.readFile(R.join(m,"package.json"),"utf8").then(C=>this.parseManifest(C)),b.Promises.readFile(R.join(m,"package.nls.json"),"utf8").then(void 0,C=>C.code!=="ENOENT"?Promise.reject(C):"{}").then(C=>JSON.parse(C))],[{manifest:_,metadata:O},N]=await Promise.all(k);return{manifest:(0,p.localizeManifest)(_,N),metadata:O}}parseManifest(m){return new Promise((k,_)=>{try{const O=JSON.parse(m),N=O.__metadata||null;k({manifest:O,metadata:N})}catch(O){_(new Error((0,y.localize)(4,null)))}})}};u=he([X(1,l.IFileService),X(2,c.ILogService),X(3,f.INativeEnvironmentService),X(4,t.IProductService)],u),e.ExtensionsScanner=u}),define(te[231],ne([0,1,37,8,15,9,4,31,16,60,7,30,19,64,130,77,13,197,28,35,182,171,229,183,230,184,74,14,6,10,42,21]),function(J,e,D,A,P,T,L,R,S,E,n,I,g,b,h,y,f,w,v,p,l,c,t,s,r,i,a,o,u,d,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const _="unsetUninstalled",O="downloading";let N=class extends w.AbstractExtensionManagementService{constructor(W,x,q,$,G,M,B){super(W,x,q);this.environmentService=$,this.downloadService=G,this.fileService=B;const V=this._register(M.createInstance(c.ExtensionsLifecycle));this.extensionsScanner=this._register(M.createInstance(r.ExtensionsScanner,Z=>V.postUninstall(Z))),this.manifestCache=this._register(new s.ExtensionsManifestCache($,this)),this.extensionsDownloader=this._register(M.createInstance(l.ExtensionsDownloader));const Q=this._register(new i.ExtensionsWatcher(this,B,$,q));this._register(Q.onDidChangeExtensionsByAnotherSource(({added:Z,removed:K})=>{Z.length&&this._onDidInstallExtensions.fire(Z.map(H=>({identifier:H.identifier,operation:0,local:H}))),K.forEach(H=>this._onDidUninstallExtension.fire({identifier:H}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const W=await this.isAlpineLinux(),x=(0,v.getTargetPlatform)(W?"alpine":L.platform,R.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",x),x})()),this._targetPlatformPromise}async isAlpineLinux(){if(!L.isLinux)return!1;let W;try{W=(await this.fileService.readFile(n.URI.file("/etc/os-release"))).value.toString()}catch(x){try{W=(await this.fileService.readFile(n.URI.file("/usr/lib/os-release"))).value.toString()}catch(q){this.logService.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(q))}}return!!W&&(W.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(W){this.logService.trace("ExtensionManagementService#zip",W.identifier.id);const x=await this.collectFiles(W),q=await(0,b.zip)((0,S.joinPath)(this.environmentService.tmpDir,(0,I.generateUuid)()).fsPath,x);return n.URI.file(q)}async unzip(W){return this.logService.trace("ExtensionManagementService#unzip",W.toString()),(await this.install(W)).identifier}async getManifest(W){const x=await this.downloadVsix(W),q=T.resolve(x.fsPath);return(0,t.getManifest)(q)}getInstalled(W=null){return this.extensionsScanner.scanExtensions(W)}async install(W,x={}){this.logService.trace("ExtensionManagementService#install",W.toString());const q=await this.downloadVsix(W),$=await(0,t.getManifest)(T.resolve(q.fsPath));if($.engines&&$.engines.vscode&&!(0,a.isEngineValid)($.engines.vscode,m.default.version,m.default.date))throw new Error(h.localize(0,null,(0,p.getGalleryExtensionId)($.publisher,$.name),m.default.version));return this.installExtension($,q,x)}async updateMetadata(W,x){return this.logService.trace("ExtensionManagementService#updateMetadata",W.identifier.id),W=await this.extensionsScanner.saveMetadataForLocalExtension(W,{...W.manifest.__metadata||{},...x}),this.manifestCache.invalidate(),W}async updateExtensionScope(W,x){return this.logService.trace("ExtensionManagementService#updateExtensionScope",W.identifier.id),W=await this.extensionsScanner.saveMetadataForLocalExtension(W,{...W.manifest.__metadata||{},isMachineScoped:x}),this.manifestCache.invalidate(),W}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(W){if(W.scheme===P.Schemas.file)return W;const x=(0,S.joinPath)(this.environmentService.tmpDir,(0,I.generateUuid)());return await this.downloadService.download(W,x),x}createInstallExtensionTask(W,x,q){return n.URI.isUri(x)?new z(W,x,q,this.galleryService,this.extensionsScanner,this.logService):new F(x,q,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(W,x){return new U(W,x,this.extensionsScanner)}async collectFiles(W){const x=async $=>{let G=await g.Promises.readdir($);G=G.map(V=>T.join($,V));const M=await Promise.all(G.map(V=>g.Promises.stat(V)));let B=Promise.resolve([]);return M.forEach((V,Q)=>{const Z=G[Q];V.isFile()&&(B=B.then(K=>[...K,Z])),V.isDirectory()&&(B=B.then(K=>x(Z).then(H=>[...K,...H])))}),B};return(await x(W.location.fsPath)).map($=>({path:`extension/${T.relative(W.location.fsPath,$)}`,localPath:$}))}};N=he([X(0,v.IExtensionGalleryService),X(1,k.ITelemetryService),X(2,d.ILogService),X(3,f.INativeEnvironmentService),X(4,y.IDownloadService),X(5,u.IInstantiationService),X(6,o.IFileService)],N),e.ExtensionManagementService=N;class C extends w.AbstractExtensionTask{constructor(W,x,q,$){super();this.identifier=W,this.source=x,this.extensionsScanner=q,this.logService=$,this._operation=1}get operation(){return this._operation}async installExtension(W,x){try{const q=await this.unsetUninstalledAndGetLocal(W.identifierWithVersion);if(q)return W.metadata?this.extensionsScanner.saveMetadataForLocalExtension(q,W.metadata):q}catch(q){throw L.isMacintosh?new v.ExtensionManagementError(h.localize(1,null),_):new v.ExtensionManagementError(h.localize(2,null),_)}return this.extract(W,x)}async unsetUninstalledAndGetLocal(W){if(!await this.isUninstalled(W))return null;this.logService.trace("Removing the extension from uninstalled list:",W.id);const q=await this.extensionsScanner.setInstalled(W);return this.logService.info("Removed the extension from uninstalled list:",W.id),q}async isUninstalled(W){return!!(await this.extensionsScanner.getUninstalledExtensions())[W.key()]}async extract({zipPath:W,identifierWithVersion:x,metadata:q},$){let G=await this.extensionsScanner.extractUserExtension(x,W,q,$);return this.logService.info("Extracting completed.",x.id),G}}class F extends C{constructor(W,x,q,$,G){super(W.identifier,W,$,G);this.gallery=W,this.options=x,this.extensionsDownloader=q}async doRun(W){const q=(await this.extensionsScanner.scanExtensions(null)).find(G=>(0,p.areSameExtensions)(G.identifier,this.gallery.identifier));q&&(this._operation=2);const $=await this.downloadInstallableExtension(this.gallery,this._operation);$.metadata.isMachineScoped=this.options.isMachineScoped||q?.isMachineScoped,$.metadata.isBuiltin=this.options.isBuiltin||q?.isBuiltin;try{const G=await this.installExtension($,W);return q&&E.neq(q.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(q),G}catch(G){throw await this.deleteDownloadedVSIX($.zipPath),G}}async deleteDownloadedVSIX(W){try{await this.extensionsDownloader.delete(n.URI.file(W))}catch(x){this.logService.warn("Error while deleting the downloaded vsix",W.toString(),(0,A.getErrorMessage)(x))}}async downloadInstallableExtension(W,x){const q={id:W.identifier.uuid,publisherId:W.publisherId,publisherDisplayName:W.publisherDisplayName};let $;try{this.logService.trace("Started downloading extension:",W.identifier.id),$=(await this.extensionsDownloader.downloadExtension(W,x)).fsPath,this.logService.info("Downloaded extension:",W.identifier.id,$)}catch(G){throw new v.ExtensionManagementError((0,w.joinErrors)(G).message,O)}try{const G=await(0,t.getManifest)($);return{zipPath:$,identifierWithVersion:new p.ExtensionIdentifierWithVersion(W.identifier,G.version),metadata:q}}catch(G){throw await this.deleteDownloadedVSIX($),new v.ExtensionManagementError((0,w.joinErrors)(G).message,w.INSTALL_ERROR_VALIDATING)}}}class z extends C{constructor(W,x,q,$,G,M){super({id:(0,p.getGalleryExtensionId)(W.publisher,W.name)},x,G,M);this.manifest=W,this.location=x,this.options=q,this.galleryService=$}async doRun(W){const x=new p.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),$=(await this.extensionsScanner.scanExtensions(1)).find(M=>(0,p.areSameExtensions)(this.identifier,M.identifier)),G=await this.getMetadata(this.identifier.id,W);if(G.isMachineScoped=this.options.isMachineScoped||$?.isMachineScoped,G.isBuiltin=this.options.isBuiltin||$?.isBuiltin,$)if(this._operation=2,x.equals(new p.ExtensionIdentifierWithVersion($.identifier,$.manifest.version)))try{await this.extensionsScanner.removeExtension($,"existing")}catch(M){throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else E.gt($.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled($);else{const M=await this.unsetUninstalledAndGetLocal(x);if(M)try{await this.extensionsScanner.removeExtension(M,"existing")}catch(B){throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:T.resolve(this.location.fsPath),identifierWithVersion:x,metadata:G},W)}async getMetadata(W,x){try{const q=(await this.galleryService.query({names:[W],pageSize:1},x)).firstPage[0];if(q)return{id:q.identifier.uuid,publisherDisplayName:q.publisherDisplayName,publisherId:q.publisherId}}catch(q){}return{}}}class U extends w.AbstractExtensionTask{constructor(W,x,q){super();this.extension=W,this.options=x,this.extensionsScanner=q}async doRun(W){const x=[],q=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const $=new p.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);x.push(...q.filter(G=>$.equals(new p.ExtensionIdentifierWithVersion(G.identifier,G.manifest.version))))}else x.push(...q.filter($=>(0,p.areSameExtensions)($.identifier,this.extension.identifier)));if(!x.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...x),this.options.remove)for(const $ of x)try{W.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension($)}catch(G){throw new Error(h.localize(6,null,(0,D.toErrorMessage)(G)))}}}}),define(te[232],ne([0,1,80,56,33,22,8,3,2,9,4,30,32,70,241]),function(J,e,D,A,P,T,L,R,S,E,n,I,g,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class y{constructor(u){this.socket=u,this._errorListener=d=>{if(d){if(d.code==="EPIPE")return;(0,L.onUnexpectedError)(d)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(u){const d=m=>u(T.VSBuffer.wrap(m));return this.socket.on("data",d),{dispose:()=>this.socket.off("data",d)}}onClose(u){const d=m=>{u({type:0,hadError:m,error:void 0})};return this.socket.on("close",d),{dispose:()=>this.socket.off("close",d)}}onEnd(u){return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(u){if(!this.socket.destroyed)try{this.socket.write(u.buffer,d=>{if(d){if(d.code==="EPIPE")return;(0,L.onUnexpectedError)(d)}})}catch(d){if(d.code==="EPIPE")return;(0,L.onUnexpectedError)(d)}}end(){this.socket.end()}drain(){return new Promise((u,d)=>{if(this.socket.bufferSize===0){u();return}const m=()=>{this.socket.off("close",m),this.socket.off("end",m),this.socket.off("error",m),this.socket.off("timeout",m),this.socket.off("drain",m),u()};this.socket.on("close",m),this.socket.on("end",m),this.socket.on("error",m),this.socket.on("timeout",m),this.socket.on("drain",m)})}}e.NodeSocket=y;var f;(function(o){o[o.MinHeaderByteSize=2]="MinHeaderByteSize"})(f||(f={}));var w;(function(o){o[o.PeekHeader=1]="PeekHeader",o[o.ReadHeader=2]="ReadHeader",o[o.ReadBody=3]="ReadBody",o[o.Fin=4]="Fin"})(w||(w={}));class v extends S.Disposable{constructor(u,d,m,k){super();this._onDidZlibFlush=this._register(new R.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new R.Emitter),this._onClose=this._register(new R.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=d,this._recordInflateBytes=k,d?(this._zlibInflate=h.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",_=>{console.error(_),(0,L.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})}),this._zlibInflate.on("data",_=>{this._pendingInflateData.push(_)}),m&&(this._zlibInflate.write(m.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",_=>{console.error(_),(0,L.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})}),this._zlibDeflate.on("data",_=>{this._pendingDeflateData.push(_)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new b.ChunkStream,this._register(this.socket.onData(_=>this._acceptChunk(_))),this._register(this.socket.onClose(_=>this._onClose.fire(_)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?T.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):T.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){this._totalOutgoingDataBytes+=u.byteLength,this._zlibDeflate?(this._zlibDeflate.write(u.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let d=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,d=d.slice(0,d.length-4),this._isEnded||this._write(T.VSBuffer.wrap(d),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(u,!1)}_write(u,d){let m=2;u.byteLength<126?m+=0:u.byteLength<2**16?m+=2:m+=8;const k=T.VSBuffer.alloc(m);if(d?k.writeUInt8(194,0):k.writeUInt8(130,0),u.byteLength<126)k.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){k.writeUInt8(126,1);let _=1;k.writeUInt8(u.byteLength>>>8&255,++_),k.writeUInt8(u.byteLength>>>0&255,++_)}else{k.writeUInt8(127,1);let _=1;k.writeUInt8(0,++_),k.writeUInt8(0,++_),k.writeUInt8(0,++_),k.writeUInt8(0,++_),k.writeUInt8(u.byteLength>>>24&255,++_),k.writeUInt8(u.byteLength>>>16&255,++_),k.writeUInt8(u.byteLength>>>8&255,++_),k.writeUInt8(u.byteLength>>>0&255,++_)}this._totalOutgoingWireBytes+=k.byteLength+u.byteLength,this.socket.write(T.VSBuffer.concat([k,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._totalIncomingWireBytes+=u.byteLength,this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const d=this._incomingData.peek(this._state.readLen),m=d.readUInt8(0),k=(m&128)>>>7,_=(m&64)>>>6,O=d.readUInt8(1),N=(O&128)>>>7,C=O&127;this._state.state=2,this._state.readLen=2+(N?4:0)+(C===126?2:0)+(C===127?8:0),this._state.fin=k,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(_)),this._state.firstFrameOfMessage=Boolean(k),this._state.mask=0}else if(this._state.state===2){const d=this._incomingData.read(this._state.readLen),m=d.readUInt8(1),k=(m&128)>>>7;let _=m&127,O=1;_===126?_=d.readUInt8(++O)*2**8+d.readUInt8(++O):_===127&&(_=d.readUInt8(++O)*0+d.readUInt8(++O)*0+d.readUInt8(++O)*0+d.readUInt8(++O)*0+d.readUInt8(++O)*2**24+d.readUInt8(++O)*2**16+d.readUInt8(++O)*2**8+d.readUInt8(++O));let N=0;k&&(N=d.readUInt8(++O)*2**24+d.readUInt8(++O)*2**16+d.readUInt8(++O)*2**8+d.readUInt8(++O)),this._state.state=3,this._state.readLen=_,this._state.mask=N}else if(this._state.state===3){const d=this._incomingData.read(this._state.readLen);p(d,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(d.buffer)),this._zlibInflate.write(d.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const m=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=m.length,this._onData.fire(T.VSBuffer.wrap(m))})):(this._totalIncomingDataBytes+=d.byteLength,this._onData.fire(d))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await R.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=v;function p(o,u){if(u===0)return;let d=o.byteLength>>>2;for(let C=0;C<d;C++){const F=o.readUInt32BE(C*4);o.writeUInt32BE(F^u,C*4)}let m=d*4,k=o.byteLength-m;const _=u>>>24&255,O=u>>>16&255,N=u>>>8&255;k>=1&&o.writeUInt8(o.readUInt8(m)^_,m),k>=2&&o.writeUInt8(o.readUInt8(m+1)^O,m+1),k>=3&&o.writeUInt8(o.readUInt8(m+2)^N,m+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function c(){const o=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${o}-sock`;let u;return e.XDG_RUNTIME_DIR?u=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${o}.sock`):u=(0,E.join)((0,P.tmpdir)(),`vscode-ipc-${o}.sock`),s(u),u}e.createRandomIPCHandle=c;function t(o,u,d){const m=(0,D.createHash)("md5").update(o).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${m}-${d}-${u}-sock`;let k;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?k=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-${m.substr(0,8)}-${d}-${u}.sock`):k=(0,E.join)(o,`${d}-${u}.sock`),s(k),k}e.createStaticIPCHandle=t;function s(o){const u=l[n.platform];typeof u=="number"&&o.length>=u&&console.warn(`WARNING: IPC handle "${o}" is longer than ${u} chars, try a shorter --user-data-dir`)}class r extends g.IPCServer{constructor(u){super(r.toClientConnectionEvent(u));this.server=u}static toClientConnectionEvent(u){const d=R.Event.fromNodeEventEmitter(u,"connection");return R.Event.map(d,m=>({protocol:new b.Protocol(new y(m)),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(m,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function i(o){return new Promise((u,d)=>{const m=(0,A.createServer)();m.on("error",d),m.listen(o,()=>{m.removeListener("error",d),u(new r(m))})})}e.serve=i;function a(o,u){return new Promise((d,m)=>{const k=(0,A.createConnection)(o,()=>{k.removeListener("error",m),d(b.Client.fromSocket(new y(k),u))});k.once("error",m)})}e.connect=a}),define(te[233],ne([0,1,56,232]),function(J,e,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(P,T,L,R){const S=n=>R(n,void 0),E=D.createConnection({host:P,port:T},()=>{E.removeListener("error",S);const n=Buffer.alloc(16);for(let h=0;h<16;h++)n[h]=Math.round(Math.random()*256);const I=n.toString("base64");let g=[`GET ws://${/:/.test(P)?`[${P}]`:P}:${T}/?${L}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${I}`];E.write(g.join(`\r
`)+`\r
\r
`);const b=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(E.off("data",b),R(void 0,new A.NodeSocket(E)))};E.on("data",b)});E.once("error",S)}}}),define(te[234],ne([0,1,56,111,233,5,2,20,10,29,180,61,88]),function(J,e,D,A,P,T,L,R,S,E,n,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function b(w,v,p,l,c){return new h(w,v,p,l,c).waitForReady()}class h extends L.Disposable{constructor(v,p,l,c,t){super();this.defaultTunnelHost=p,this.suggestedLocalPort=t,this.privacy=I.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=v,this._server=D.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=c,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(p=>{p()})}async waitForReady(){let v=await(0,A.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),p=null;return this._server.listen(v,this.defaultTunnelHost),await this._barrier.wait(),p=this._server.address(),p||(v=0,this._server.listen(v,this.defaultTunnelHost),await this._barrier.wait(),p=this._server.address()),this.tunnelLocalPort=p.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${p.port}`,this}async _onConnection(v){v.pause();const p=(0,I.isLocalhost)(this.tunnelRemoteHost)||(0,I.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,n.connectRemoteAgentTunnel)(this._options,p,this.tunnelRemotePort),c=l.getSocket().socket,t=l.readEntireBuffer();l.dispose(),t.byteLength>0&&v.write(t.buffer),v.on("end",()=>{this._socketsDispose.delete(v.localAddress),c.end()}),v.on("close",()=>c.end()),v.on("error",()=>{this._socketsDispose.delete(v.localAddress),c.destroy()}),c.on("end",()=>v.end()),c.on("close",()=>v.end()),c.on("error",()=>{v.destroy()}),v.pipe(c),c.pipe(v),this._socketsDispose.set(v.localAddress,()=>{v.end(),c.end()})}}let y=class extends I.AbstractTunnelService{constructor(v,p,l,c,t){super(p);this.socketFactory=v,this.signService=l,this.productService=c,this.configurationService=t}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(v,p,l,c,t,s,r){const i=this.getTunnelFromMap(p,l);if(i)return++i.refcount,i.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,p,l,c,t,s,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${p}:${l} on local port ${c}.`);const a={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:v,signService:this.signService,logService:this.logService,ipcLogger:null},o=b(a,this.defaultTunnelHost,p,l,c);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(p,l,o),o}}};y=he([X(1,S.ILogService),X(2,g.ISignService),X(3,E.IProductService),X(4,R.IConfigurationService)],y),e.BaseTunnelService=y;let f=class extends y{constructor(v,p,l,c){super(P.nodeSocketFactory,v,p,l,c)}};f=he([X(0,S.ILogService),X(1,g.ISignService),X(2,E.IProductService),X(3,R.IConfigurationService)],f),e.TunnelService=f}),define(te[242],ne([0,1,116,52,243,33,37,8,2,15,16,7,32,115,176,159,177,168,169,170,157,161,20,178,76,196,77,189,13,149,192,199,28,160,198,231,78,152,14,173,175,53,6,165,82,166,167,58,185,10,83,59,42,29,188,43,23,194,195,21,89,90,91,47,200,201,92,203,209,94,95,96,24,62,220,221,222,63,223,224,225,226,227,228,79,172,88,191,61,234,186,187]),function(J,e,D,A,P,T,L,R,S,E,n,I,g,b,h,y,f,w,v,p,l,c,t,s,r,i,a,o,u,d,m,k,_,O,N,C,F,z,U,j,W,x,q,$,G,M,B,V,Q,Z,K,H,re,ie,ae,ue,fe,de,Ie,Ce,Ee,_e,Re,ke,Fe,$e,Ne,qe,ee,oe,ce,ye,pe,Oe,De,Y,se,le,ge,me,be,Te,Le,Se,we,Pe,Ae,Ue,it,Ge,je,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class wt extends S.Disposable{constructor(ve){super();this.configuration=ve,this.server=this._register(new b.Server),(0,P.gracefulify)(A),this.registerListeners()}registerListeners(){const ve=()=>this.dispose();process.once("exit",ve),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",ve)}async open(){const ve=await this.initServices();(0,pe.registerConfiguration)(),ve.invokeFunction(Me=>{const xe=Me.get(Z.ILogService);xe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Me),this.registerErrorHandler(xe)}),this._register((0,S.combinedDisposable)(ve.createInstance(h.CodeCacheCleaner,this.configuration.codeCachePath),ve.createInstance(f.LanguagePackCachedDataCleaner),ve.createInstance(p.StorageDataCleaner,this.configuration.backupWorkspacesPath),ve.createInstance(v.LogsDataCleaner),ve.createInstance(w.LocalizationsUpdater),ve.createInstance(y.DeprecatedExtensionsCleaner)))}async initServices(){const ve=new G.ServiceCollection,Me={_serviceBrand:void 0,...re.default};ve.set(ie.IProductService,Me);const xe=new g.StaticRouter(We=>We==="main"),Je=new M.MessagePortMainProcessService(this.server,xe);ve.set(B.IMainProcessService,Je);const ze=new d.NativeEnvironmentService(this.configuration.args,Me);ve.set(u.INativeEnvironmentService,ze);const rt=new K.LogLevelChannelClient(this.server.getChannel("logLevel",xe)),Xe=new K.LoggerChannelClient(this.configuration.logLevel,rt.onDidChangeLogLevel,Je.getChannel("logger"));ve.set(Z.ILoggerService,Xe);const at=this._register(new Z.MultiplexLogService([this._register(new Z.ConsoleLogger(this.configuration.logLevel)),this._register(Xe.createLogger((0,n.joinPath)(I.URI.file(ze.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ke=this._register(new K.FollowerLogService(rt,at));ve.set(Z.ILogService,Ke);const Qe=this._register(new j.FileService(Ke));ve.set(U.IFileService,Qe);const ot=this._register(new W.DiskFileSystemProvider(Ke));Qe.registerProvider(E.Schemas.file,ot);const Ve=this._register(new s.ConfigurationService(ze.settingsResource,Qe));ve.set(t.IConfigurationService,Ve);const et=new de.NativeStorageService(void 0,Je,ze);ve.set(fe.IStorageService,et),this._register((0,S.toDisposable)(()=>et.flush())),await Promise.all([Ve.initialize(),et.initialize()]),ve.set(ue.IRequestService,new x.SyncDescriptor(ae.RequestService)),ve.set(l.IChecksumService,new x.SyncDescriptor(c.ChecksumService));const st=g.ProxyChannel.toService(Je.getChannel("nativeHost"),{context:this.configuration.windowId});ve.set(H.INativeHostService,st),ve.set(a.IDownloadService,new x.SyncDescriptor(o.DownloadService));const ct=this._register(new Se.ActiveWindowManager(st)),lt=new g.StaticRouter(We=>ct.getActiveClientId().then(ut=>We===ut));ve.set(F.IExtensionRecommendationNotificationService,new z.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",lt)));let Ye;const tt=[];if((0,ke.supportsTelemetry)(Me,ze)){const We=new _e.TelemetryLogAppender(Xe,ze);tt.push(We);const{appRoot:ut,extensionsPath:It,installSourcePath:Ct}=ze;if(Me.aiConfig&&Me.aiConfig.asimovKey){const gt=new Fe.AppInsightsAppender("monacoworkbench",null,Me.aiConfig.asimovKey);this._register((0,S.toDisposable)(()=>gt.flush())),tt.push(gt)}Ye=new Re.TelemetryService({appenders:tt,commonProperties:(0,Ie.resolveCommonProperties)(Qe,(0,T.release)(),(0,T.hostname)(),process.arch,Me.commit,Me.version,this.configuration.machineId,Me.msftInternalDomains,Ct),sendErrorTelemetry:!0,piiPaths:[ut,It]},Ve)}else{Ye=ke.NullTelemetryService;const We=ke.NullAppender;tt.push(We)}this.server.registerChannel("telemetryAppender",new Ee.TelemetryAppenderChannel(tt)),ve.set(Ce.ITelemetryService,Ye);const bt=new $e.CustomEndpointTelemetryService(Ve,Ye,Xe,ze);return ve.set(Ce.ICustomEndpointTelemetryService,bt),ve.set(_.IExtensionManagementService,new x.SyncDescriptor(C.ExtensionManagementService)),ve.set(_.IExtensionGalleryService,new x.SyncDescriptor(k.ExtensionGalleryService)),ve.set(_.IExtensionTipsService,new x.SyncDescriptor(N.ExtensionTipsService)),ve.set(V.ILocalizationsService,new x.SyncDescriptor(Q.LocalizationsService)),ve.set(r.IDiagnosticsService,new x.SyncDescriptor(i.DiagnosticsService)),ve.set(Oe.IUserDataSyncAccountService,new x.SyncDescriptor(Oe.UserDataSyncAccountService)),ve.set(pe.IUserDataSyncLogService,new x.SyncDescriptor(se.UserDataSyncLogService)),ve.set(pe.IUserDataSyncUtilService,new Y.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",We=>We.ctx!=="main"))),ve.set(_.IGlobalExtensionEnablementService,new x.SyncDescriptor(m.GlobalExtensionEnablementService)),ve.set(ce.IIgnoredExtensionsManagementService,new x.SyncDescriptor(ce.IgnoredExtensionsManagementService)),ve.set(oe.IExtensionsStorageSyncService,new x.SyncDescriptor(oe.ExtensionsStorageSyncService)),ve.set(pe.IUserDataSyncStoreManagementService,new x.SyncDescriptor(Te.UserDataSyncStoreManagementService)),ve.set(pe.IUserDataSyncStoreService,new x.SyncDescriptor(Te.UserDataSyncStoreService)),ve.set(le.IUserDataSyncMachinesService,new x.SyncDescriptor(le.UserDataSyncMachinesService)),ve.set(pe.IUserDataSyncBackupStoreService,new x.SyncDescriptor(De.UserDataSyncBackupStoreService)),ve.set(pe.IUserDataAutoSyncEnablementService,new x.SyncDescriptor(ye.UserDataAutoSyncEnablementService)),ve.set(pe.IUserDataSyncResourceEnablementService,new x.SyncDescriptor(ge.UserDataSyncResourceEnablementService)),ve.set(pe.IUserDataSyncService,new x.SyncDescriptor(me.UserDataSyncService)),ve.set(qe.ILocalPtyService,this._register(new ee.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ve.getValue("terminal.integrated.persistentSessionScrollback")??100},Ve,ze,Ke,Ye))),ve.set(we.IExtensionHostStarter,this._register(new Pe.ExtensionHostStarter(Ke))),ve.set(Ae.ISignService,new x.SyncDescriptor(Ue.SignService)),ve.set(it.ITunnelService,new x.SyncDescriptor(Ge.TunnelService)),ve.set(je.ISharedProcessTunnelService,new x.SyncDescriptor(St.SharedProcessTunnelService)),new $.InstantiationService(ve)}initChannels(ve){const Me=new O.ExtensionManagementChannel(ve.get(_.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Me);const xe=g.ProxyChannel.fromService(ve.get(V.ILocalizationsService));this.server.registerChannel("localizations",xe);const Je=g.ProxyChannel.fromService(ve.get(r.IDiagnosticsService));this.server.registerChannel("diagnostics",Je);const ze=new O.ExtensionTipsChannel(ve.get(_.IExtensionTipsService));this.server.registerChannel("extensionTipsService",ze);const rt=g.ProxyChannel.fromService(ve.get(l.IChecksumService));this.server.registerChannel("checksum",rt);const Xe=new Y.UserDataSyncMachinesServiceChannel(ve.get(le.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Xe);const at=g.ProxyChannel.fromService(ve.get(Ce.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",at);const Ke=new Y.UserDataSyncAccountServiceChannel(ve.get(Oe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ke);const Qe=new Y.UserDataSyncStoreManagementServiceChannel(ve.get(pe.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Qe);const ot=new be.UserDataSyncChannel(ve.get(pe.IUserDataSyncService),ve.get(Z.ILogService));this.server.registerChannel("userDataSync",ot);const Ve=this._register(ve.get(q.IInstantiationService).createInstance(Le.UserDataAutoSyncService)),et=new Y.UserDataAutoSyncChannel(Ve);this.server.registerChannel("userDataAutoSync",et);const st=ve.get(qe.ILocalPtyService),ct=g.ProxyChannel.fromService(st);this.server.registerChannel(Ne.TerminalIpcChannels.LocalPty,ct);const lt=g.ProxyChannel.fromService(ve.get(we.IExtensionHostStarter));this.server.registerChannel(we.ipcExtensionHostStarterChannelName,lt);const Ye=g.ProxyChannel.fromService(ve.get(je.ISharedProcessTunnelService));this.server.registerChannel(je.ipcSharedProcessTunnelChannelName,Ye)}registerErrorHandler(ve){window.addEventListener("unhandledrejection",Me=>{(0,R.onUnexpectedError)(Me.reason),Me.preventDefault()}),(0,R.setUnexpectedErrorHandler)(Me=>{const xe=(0,L.toErrorMessage)(Me,!0);!xe||ve.error(`[uncaught exception in sharedProcess]: ${xe}`)})}}async function Et(dt){const ve=new wt(dt);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ve.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Et})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/cad4c193d85f0891204da41c0508de39e7aa38c6/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
