/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var fe=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/platform","vs/base/common/types","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/hash","vs/base/common/severity","fs","vs/editor/common/core/position","vs/base/common/errorMessage","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/marshalling","vs/platform/contextkey/common/contextkey","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/skipList","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],me=function(Y){for(var e=[],p=0,F=Y.length;p<F;p++)e[p]=fe[Y[p]];return e};define(fe[58],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(F,C){if(!F)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=p}),define(fe[59],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const p=Object.prototype.hasOwnProperty;function F(i){const k=[];for(let a in i)p.call(i,a)&&k.push(i[a]);return k}e.values=F;function C(i,k){for(let a in i)if(p.call(i,a)&&k({key:a,value:i[a]},function(){delete i[a]})===!1)return}e.forEach=C;function y(i,k){const a=Object.create(null);for(const g of i){const d=k(g);let w=a[d];w||(w=a[d]=[]),w.push(g)}return a}e.groupBy=y;function A(i){const k=Object.create(null);return i&&i.forEach((a,g)=>{k[g]=a}),k}e.fromMap=A;function _(i,k){const a=[],g=[];for(let d of i)k.has(d)||a.push(d);for(let d of k)i.has(d)||g.push(d);return{removed:a,added:g}}e.diffSets=_;function S(i,k){const a=[],g=[];for(let[d,w]of i)k.has(d)||a.push(w);for(let[d,w]of k)i.has(d)||g.push(w);return{removed:a,added:g}}e.diffMaps=S;class I{constructor(){this.map=new Map}add(k,a){let g=this.map.get(k);g||(g=new Set,this.map.set(k,g)),g.add(a)}delete(k,a){const g=this.map.get(k);!g||(g.delete(a),g.size===0&&this.map.delete(k))}forEach(k,a){const g=this.map.get(k);!g||g.forEach(a)}}e.SetMap=I}),define(fe[60],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(A){return(_,S,I)=>{let i=null,k=null;if(typeof I.value=="function"?(i="value",k=I.value):typeof I.get=="function"&&(i="get",k=I.get),!k)throw new Error("not supported");I[i]=A(k,S)}}e.createDecorator=p;function F(A,_,S){let I=null,i=null;if(typeof S.value=="function"?(I="value",i=S.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(I="get",i=S.get),!i)throw new Error("not supported");const k=`$memoize$${_}`;S[I]=function(...a){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,a)}),this[k]}}e.memoize=F;function C(A,_,S){return p((I,i)=>{const k=`$debounce$${i}`,a=`$debounce$result$${i}`;return function(...g){this[a]||(this[a]=S?S():void 0),clearTimeout(this[k]),_&&(this[a]=_(this[a],...g),g=[this[a]]),this[k]=setTimeout(()=>{I.apply(this,g),this[a]=S?S():void 0},A)}})}e.debounce=C;function y(A,_,S){return p((I,i)=>{const k=`$throttle$timer$${i}`,a=`$throttle$result$${i}`,g=`$throttle$lastRun$${i}`,d=`$throttle$pending$${i}`;return function(...w){if(this[a]||(this[a]=S?S():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),_&&(this[a]=_(this[a],...w)),this[d])return;const D=this[g]+A;D<=Date.now()?(this[g]=Date.now(),I.apply(this,[this[a]]),this[a]=S?S():void 0):(this[d]=!0,this[k]=setTimeout(()=>{this[d]=!1,this[g]=Date.now(),I.apply(this,[this[a]]),this[a]=S?S():void 0},D-Date.now()))}})}e.throttle=y}),define(fe[17],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(h=>{h(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=p,e.errorHandler=new p;function F(v){e.errorHandler.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=F;function C(v){S(v)||e.errorHandler.onUnexpectedError(v)}e.onUnexpectedError=C;function y(v){S(v)||e.errorHandler.onUnexpectedExternalError(v)}e.onUnexpectedExternalError=y;function A(v){if(v instanceof Error){let{name:t,message:h}=v;const s=v.stacktrace||v.stack;return{$isError:!0,name:t,message:h,stack:s}}return v}e.transformErrorForSerialization=A;const _="Canceled";function S(v){return v instanceof Error&&v.name===_&&v.message===_}e.isPromiseCanceledError=S;class I extends Error{constructor(){super(_);this.name=this.message}}e.CancellationError=I;function i(){const v=new Error(_);return v.name=v.message,v}e.canceled=i;function k(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.illegalArgument=k;function a(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.illegalState=a;function g(v){return v?new Error(`readonly property '${v} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function d(v){const t=new Error(`${v} has been disposed`);return t.name="DISPOSED",t}e.disposed=d;function w(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.getErrorMessage=w;class D extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=D;class T extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=T;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function c(v){const t=v;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=c;function r(v,t=Object.create(null)){const h=new Error(v);return t.actions&&(h.actions=t.actions),h}e.createErrorWithActions=r}),define(fe[18],me([0,1,17]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function F(x,X=0){return x[x.length-(1+X)]}e.tail=F;function C(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}e.tail2=C;function y(x,X,Q=(de,_e)=>de===_e){if(x===X)return!0;if(!x||!X||x.length!==X.length)return!1;for(let de=0,_e=x.length;de<_e;de++)if(!Q(x[de],X[de]))return!1;return!0}e.equals=y;function A(x,X,Q){let de=0,_e=x.length-1;for(;de<=_e;){const ye=(de+_e)/2|0,ke=Q(x[ye],X);if(ke<0)de=ye+1;else if(ke>0)_e=ye-1;else return ye}return-(de+1)}e.binarySearch=A;function _(x,X){let Q=0,de=x.length;if(de===0)return 0;for(;Q<de;){const _e=Math.floor((Q+de)/2);X(x[_e])?de=_e:Q=_e+1}return Q}e.findFirstInSorted=_;function S(x,X,Q){if(x=x|0,x>=X.length)throw new TypeError("invalid index");let de=X[Math.floor(X.length*Math.random())],_e=[],ye=[],ke=[];for(let xe of X){const We=Q(xe,de);We<0?_e.push(xe):We>0?ye.push(xe):ke.push(xe)}return x<_e.length?S(x,_e,Q):x<_e.length+ke.length?ke[0]:S(x-(_e.length+ke.length),ye,Q)}e.quickSelect=S;function I(x,X){const Q=[];let de;for(const _e of x.slice(0).sort(X))!de||X(de[0],_e)!==0?(de=[_e],Q.push(de)):de.push(_e);return Q}e.groupBy=I;function i(x,X,Q){const de=[];function _e(xe,We,He){if(We===0&&He.length===0)return;const q=de[de.length-1];q&&q.start+q.deleteCount===xe?(q.deleteCount+=We,q.toInsert.push(...He)):de.push({start:xe,deleteCount:We,toInsert:He})}let ye=0,ke=0;for(;;){if(ye===x.length){_e(ye,0,X.slice(ke));break}if(ke===X.length){_e(ye,x.length-ye,[]);break}const xe=x[ye],We=X[ke],He=Q(xe,We);He===0?(ye+=1,ke+=1):He<0?(_e(ye,1,[]),ye+=1):He>0&&(_e(ye,0,[We]),ke+=1)}return de}e.sortedDiff=i;function k(x,X,Q){const de=i(x,X,Q),_e=[],ye=[];for(const ke of de)_e.push(...x.slice(ke.start,ke.start+ke.deleteCount)),ye.push(...ke.toInsert);return{removed:_e,added:ye}}e.delta=k;function a(x,X,Q){if(Q===0)return[];const de=x.slice(0,Q).sort(X);return d(x,X,de,Q,x.length),de}e.top=a;function g(x,X,Q,de,_e){return Q===0?Promise.resolve([]):new Promise((ye,ke)=>{(async()=>{const xe=x.length,We=x.slice(0,Q).sort(X);for(let He=Q,q=Math.min(Q+de,xe);He<xe;He=q,q=Math.min(q+de,xe)){if(He>Q&&await new Promise(ee=>setTimeout(ee)),_e&&_e.isCancellationRequested)throw(0,p.canceled)();d(x,X,We,He,q)}return We})().then(ye,ke)})}e.topAsync=g;function d(x,X,Q,de,_e){for(const ye=Q.length;de<_e;de++){const ke=x[de];if(X(ke,Q[ye-1])<0){Q.pop();const xe=_(Q,We=>X(ke,We)<0);Q.splice(xe,0,ke)}}}function w(x){return x.filter(X=>!!X)}e.coalesce=w;function D(x){let X=0;for(let Q=0;Q<x.length;Q++)x[Q]&&(x[X]=x[Q],X+=1);x.length=X}e.coalesceInPlace=D;function T(x,X,Q){x.splice(Q,0,x.splice(X,1)[0])}e.move=T;function E(x){return!Array.isArray(x)||x.length===0}e.isFalsyOrEmpty=E;function c(x){return Array.isArray(x)&&x.length>0}e.isNonEmptyArray=c;function r(x,X=Q=>Q){const Q=new Set;return x.filter(de=>{const _e=X(de);return Q.has(_e)?!1:(Q.add(_e),!0)})}e.distinct=r;function v(x){const X=Object.create(null);return Q=>{const de=x(Q);return X[de]?!1:(X[de]=!0,!0)}}e.uniqueFilter=v;function t(x,X){const Q=h(x,X);if(Q!==-1)return x[Q]}e.findLast=t;function h(x,X){for(let Q=x.length-1;Q>=0;Q--){const de=x[Q];if(X(de))return Q}return-1}e.lastIndex=h;function s(x,X){return x.length>0?x[0]:X}e.firstOrDefault=s;function n(x,X,Q=(de,_e)=>de===_e){let de=0;for(let _e=0,ye=Math.min(x.length,X.length);_e<ye&&Q(x[_e],X[_e]);_e++)de++;return de}e.commonPrefixLength=n;function u(x){return[].concat(...x)}e.flatten=u;function o(x,X){let Q=typeof X=="number"?x:0;typeof X=="number"?Q=x:(Q=0,X=x);const de=[];if(Q<=X)for(let _e=Q;_e<X;_e++)de.push(_e);else for(let _e=Q;_e>X;_e--)de.push(_e);return de}e.range=o;function l(x,X,Q){return x.reduce((de,_e)=>(de[X(_e)]=Q?Q(_e):_e,de),Object.create(null))}e.index=l;function m(x,X){return x.push(X),()=>b(x,X)}e.insert=m;function b(x,X){const Q=x.indexOf(X);if(Q>-1)return x.splice(Q,1),X}e.remove=b;function f(x,X,Q){const de=x.slice(0,X),_e=x.slice(X);return de.concat(Q,_e)}e.arrayInsert=f;function P(x,X){let Q;if(typeof X=="number"){let de=X;Q=()=>{const _e=Math.sin(de++)*179426549;return _e-Math.floor(_e)}}else Q=Math.random;for(let de=x.length-1;de>0;de-=1){const _e=Math.floor(Q()*(de+1)),ye=x[de];x[de]=x[_e],x[_e]=ye}}e.shuffle=P;function L(x,X){const Q=x.indexOf(X);Q>-1&&(x.splice(Q,1),x.unshift(X))}e.pushToStart=L;function M(x,X){const Q=x.indexOf(X);Q>-1&&(x.splice(Q,1),x.push(X))}e.pushToEnd=M;function R(x,X){return Array.isArray(x)?x.map(X):X(x)}e.mapArrayOrNot=R;function W(x){return Array.isArray(x)?x:[x]}e.asArray=W;function V(x){return x[Math.floor(Math.random()*x.length)]}e.getRandomElement=V;function N(x,X){for(const Q of x){const de=X(Q);if(de!==void 0)return de}}e.mapFind=N;function j(x,X,Q){const de=B(x,X),_e=x.length,ye=Q.length;x.length=_e+ye;for(let ke=_e-1;ke>=de;ke--)x[ke+ye]=x[ke];for(let ke=0;ke<ye;ke++)x[ke+de]=Q[ke]}e.insertInto=j;function U(x,X,Q,de){const _e=B(x,X),ye=x.splice(_e,Q);return j(x,_e,de),ye}e.splice=U;function B(x,X){return X<0?Math.max(X+x.length,0):Math.min(X,x.length)}function z(x,X){let Q=Number.MAX_SAFE_INTEGER,de=0;return x.forEach((_e,ye)=>{const ke=X(_e);ke<Q&&(Q=ke,de=ye)}),de}e.minIndex=z;function O(x,X){let Q=Number.MIN_SAFE_INTEGER,de=0;return x.forEach((_e,ye)=>{const ke=X(_e);ke>Q&&(Q=ke,de=ye)}),de}e.maxIndex=O;class ${constructor(X){this.items=X,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(X){let Q=this.firstIdx;for(;Q<this.items.length&&X(this.items[Q]);)Q++;const de=Q===this.firstIdx?null:this.items.slice(this.firstIdx,Q);return this.firstIdx=Q,de}takeFromEndWhile(X){let Q=this.lastIdx;for(;Q>=0&&X(this.items[Q]);)Q--;const de=Q===this.lastIdx?null:this.items.slice(Q+1,this.lastIdx+1);return this.lastIdx=Q,de}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=$}),define(fe[76],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(F){const C=this;let y=!1,A;return function(){return y||(y=!0,A=F.apply(C,arguments)),A}}e.once=p}),define(fe[77],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class p{constructor(C){this._prefix=C,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=p,e.defaultGenerator=new p("id#")}),define(fe[94],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(F){function C(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}F.is=C;const y=Object.freeze([]);function A(){return y}F.empty=A;function*_(v){yield v}F.single=_;function S(v){return v||y}F.from=S;function I(v){return!v||v[Symbol.iterator]().next().done===!0}F.isEmpty=I;function i(v){return v[Symbol.iterator]().next().value}F.first=i;function k(v,t){for(const h of v)if(t(h))return!0;return!1}F.some=k;function a(v,t){for(const h of v)if(t(h))return h}F.find=a;function*g(v,t){for(const h of v)t(h)&&(yield h)}F.filter=g;function*d(v,t){let h=0;for(const s of v)yield t(s,h++)}F.map=d;function*w(...v){for(const t of v)for(const h of t)yield h}F.concat=w;function*D(v){for(const t of v)for(const h of t)yield h}F.concatNested=D;function T(v,t,h){let s=h;for(const n of v)s=t(s,n);return s}F.reduce=T;function*E(v,t,h=v.length){for(t<0&&(t+=v.length),h<0?h+=v.length:h>v.length&&(h=v.length);t<h;t++)yield v[t]}F.slice=E;function c(v,t=Number.POSITIVE_INFINITY){const h=[];if(t===0)return[h,v];const s=v[Symbol.iterator]();for(let n=0;n<t;n++){const u=s.next();if(u.done)return[h,F.empty()];h.push(u.value)}return[h,{[Symbol.iterator](){return s}}]}F.consume=c;function r(v,t,h=(s,n)=>s===n){const s=v[Symbol.iterator](),n=t[Symbol.iterator]();for(;;){const u=s.next(),o=n.next();if(u.done!==o.done)return!1;if(u.done)return!0;if(!h(u.value,o.value))return!1}}F.equals=r})(p=e.Iterable||(e.Iterable={}))}),define(fe[61],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var y;(function(t){t.DEFAULT={allowTrailingComma:!0}})(y=e.ParseOptions||(e.ParseOptions={}));function A(t,h=!1){let s=0,n=t.length,u="",o=0,l=16,m=0;function b(V){let N=0,j=0;for(;N<V;){const U=t.charCodeAt(s);if(U>=48&&U<=57)j=j*16+U-48;else if(U>=65&&U<=70)j=j*16+U-65+10;else if(U>=97&&U<=102)j=j*16+U-97+10;else break;s++,N++}return N<V&&(j=-1),j}function f(V){s=V,u="",o=0,l=16,m=0}function P(){const V=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&I(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&I(t.charCodeAt(s)))for(s++;s<t.length&&I(t.charCodeAt(s));)s++;else return m=3,t.substring(V,s);let N=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&I(t.charCodeAt(s))){for(s++;s<t.length&&I(t.charCodeAt(s));)s++;N=s}else m=3;return t.substring(V,N)}function L(){let V="",N=s;for(;;){if(s>=n){V+=t.substring(N,s),m=2;break}const j=t.charCodeAt(s);if(j===34){V+=t.substring(N,s),s++;break}if(j===92){if(V+=t.substring(N,s),s++,s>=n){m=2;break}switch(t.charCodeAt(s++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:const B=b(4);B>=0?V+=String.fromCharCode(B):m=4;break;default:m=5}N=s;continue}if(j>=0&&j<=31)if(S(j)){V+=t.substring(N,s),m=2;break}else m=6;s++}return V}function M(){if(u="",m=0,o=s,s>=n)return o=n,l=17;let V=t.charCodeAt(s);if(_(V)){do s++,u+=String.fromCharCode(V),V=t.charCodeAt(s);while(_(V));return l=15}if(S(V))return s++,u+=String.fromCharCode(V),V===13&&t.charCodeAt(s)===10&&(s++,u+=`
`),l=14;switch(V){case 123:return s++,l=1;case 125:return s++,l=2;case 91:return s++,l=3;case 93:return s++,l=4;case 58:return s++,l=6;case 44:return s++,l=5;case 34:return s++,u=L(),l=10;case 47:const N=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<n&&!S(t.charCodeAt(s));)s++;return u=t.substring(N,s),l=12}if(t.charCodeAt(s+1)===42){s+=2;const j=n-1;let U=!1;for(;s<j;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,U=!0;break}s++}return U||(s++,m=1),u=t.substring(N,s),l=13}return u+=String.fromCharCode(V),s++,l=16;case 45:if(u+=String.fromCharCode(V),s++,s===n||!I(t.charCodeAt(s)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=P(),l=11;default:for(;s<n&&R(V);)s++,V=t.charCodeAt(s);if(o!==s){switch(u=t.substring(o,s),u){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return u+=String.fromCharCode(V),s++,l=16}}function R(V){if(_(V)||S(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let V;do V=M();while(V>=12&&V<=15);return V}return{setPosition:f,getPosition:()=>s,scan:h?W:M,getToken:()=>l,getTokenValue:()=>u,getTokenOffset:()=>o,getTokenLength:()=>s-o,getTokenError:()=>m}}e.createScanner=A;function _(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function I(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function k(t,h){const s=[],n=new Object;let u;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function m(b,f,P,L){o.value=b,o.offset=f,o.length=P,o.type=L,o.colonOffset=void 0,u=o}try{c(t,{onObjectBegin:(b,f)=>{if(h<=b)throw n;u=void 0,l=h>b,s.push("")},onObjectProperty:(b,f,P)=>{if(h<f||(m(b,f,P,"property"),s[s.length-1]=b,h<=f+P))throw n},onObjectEnd:(b,f)=>{if(h<=b)throw n;u=void 0,s.pop()},onArrayBegin:(b,f)=>{if(h<=b)throw n;u=void 0,s.push(0)},onArrayEnd:(b,f)=>{if(h<=b)throw n;u=void 0,s.pop()},onLiteralValue:(b,f,P)=>{if(h<f||(m(b,f,P,v(b)),h<=f+P))throw n},onSeparator:(b,f,P)=>{if(h<=f)throw n;if(b===":"&&u&&u.type==="property")u.colonOffset=f,l=!1,u=void 0;else if(b===","){const L=s[s.length-1];typeof L=="number"?s[s.length-1]=L+1:(l=!0,s[s.length-1]=""),u=void 0}}})}catch(b){if(b!==n)throw b}return{path:s,previousNode:u,isAtPropertyKey:l,matches:b=>{let f=0;for(let P=0;f<b.length&&P<s.length;P++)if(b[f]===s[P]||b[f]==="*")f++;else if(b[f]!=="**")return!1;return f===b.length}}}e.getLocation=k;function a(t,h=[],s=y.DEFAULT){let n=null,u=[];const o=[];function l(b){Array.isArray(u)?u.push(b):n!==null&&(u[n]=b)}return c(t,{onObjectBegin:()=>{const b={};l(b),o.push(u),u=b,n=null},onObjectProperty:b=>{n=b},onObjectEnd:()=>{u=o.pop()},onArrayBegin:()=>{const b=[];l(b),o.push(u),u=b,n=null},onArrayEnd:()=>{u=o.pop()},onLiteralValue:l,onError:(b,f,P)=>{h.push({error:b,offset:f,length:P})}},s),u[0]}e.parse=a;function g(t,h=[],s=y.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(b){n.type==="property"&&(n.length=b-n.offset,n=n.parent)}function o(b){return n.children.push(b),b}c(t,{onObjectBegin:b=>{n=o({type:"object",offset:b,length:-1,parent:n,children:[]})},onObjectProperty:(b,f,P)=>{n=o({type:"property",offset:f,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:b,offset:f,length:P,parent:n})},onObjectEnd:(b,f)=>{n.length=b+f-n.offset,n=n.parent,u(b+f)},onArrayBegin:(b,f)=>{n=o({type:"array",offset:b,length:-1,parent:n,children:[]})},onArrayEnd:(b,f)=>{n.length=b+f-n.offset,n=n.parent,u(b+f)},onLiteralValue:(b,f,P)=>{o({type:v(b),offset:f,length:P,parent:n,value:b}),u(f+P)},onSeparator:(b,f,P)=>{n.type==="property"&&(b===":"?n.colonOffset=f:b===","&&u(f))},onError:(b,f,P)=>{h.push({error:b,offset:f,length:P})}},s);const m=n.children[0];return m&&delete m.parent,m}e.parseTree=g;function d(t,h){if(!t)return;let s=t;for(let n of h)if(typeof n=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let u=!1;for(const o of s.children)if(Array.isArray(o.children)&&o.children[0].value===n){s=o.children[1],u=!0;break}if(!u)return}else{const u=n;if(s.type!=="array"||u<0||!Array.isArray(s.children)||u>=s.children.length)return;s=s.children[u]}return s}e.findNodeAtLocation=d;function w(t){if(!t.parent||!t.parent.children)return[];const h=w(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;h.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&h.push(s)}return h}e.getNodePath=w;function D(t){switch(t.type){case"array":return t.children.map(D);case"object":const h=Object.create(null);for(let s of t.children){const n=s.children[1];n&&(h[s.children[0].value]=D(n))}return h;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=D;function T(t,h,s=!1){return h>=t.offset&&h<t.offset+t.length||s&&h===t.offset+t.length}e.contains=T;function E(t,h,s=!1){if(T(t,h,s)){const n=t.children;if(Array.isArray(n))for(let u=0;u<n.length&&n[u].offset<=h;u++){const o=E(n[u],h,s);if(o)return o}return t}}e.findNodeAtOffset=E;function c(t,h,s=y.DEFAULT){const n=A(t,!1);function u(Q){return Q?()=>Q(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(Q){return Q?de=>Q(de,n.getTokenOffset(),n.getTokenLength()):()=>!0}const l=u(h.onObjectBegin),m=o(h.onObjectProperty),b=u(h.onObjectEnd),f=u(h.onArrayBegin),P=u(h.onArrayEnd),L=o(h.onLiteralValue),M=o(h.onSeparator),R=u(h.onComment),W=o(h.onError),V=s&&s.disallowComments,N=s&&s.allowTrailingComma;function j(){for(;;){const Q=n.scan();switch(n.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:V||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(Q){case 12:case 13:V?U(10):R();break;case 16:U(1);break;case 15:case 14:break;default:return Q}}}function U(Q,de=[],_e=[]){if(W(Q),de.length+_e.length>0){let ye=n.getToken();for(;ye!==17;){if(de.indexOf(ye)!==-1){j();break}else if(_e.indexOf(ye)!==-1)break;ye=j()}}}function B(Q){const de=n.getTokenValue();return Q?L(de):m(de),j(),!0}function z(){switch(n.getToken()){case 11:let Q=0;try{Q=JSON.parse(n.getTokenValue()),typeof Q!="number"&&(U(2),Q=0)}catch(de){U(2)}L(Q);break;case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return j(),!0}function O(){return n.getToken()!==10?(U(3,[],[2,5]),!1):(B(!1),n.getToken()===6?(M(":"),j(),X()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function $(){l(),j();let Q=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(Q||U(4,[],[]),M(","),j(),n.getToken()===2&&N)break}else Q&&U(6,[],[]);O()||U(4,[],[2,5]),Q=!0}return b(),n.getToken()!==2?U(7,[2],[]):j(),!0}function x(){f(),j();let Q=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(Q||U(4,[],[]),M(","),j(),n.getToken()===4&&N)break}else Q&&U(6,[],[]);X()||U(4,[],[4,5]),Q=!0}return P(),n.getToken()!==4?U(8,[4],[]):j(),!0}function X(){switch(n.getToken()){case 3:return x();case 1:return $();case 10:return B(!0);default:return z()}}return j(),n.getToken()===17?s.allowEmptyContent?!0:(U(4,[],[]),!1):X()?(n.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=c;function r(t,h){let s=A(t),n=[],u,o=0,l;do switch(l=s.getPosition(),u=s.scan(),u){case 12:case 13:case 17:o!==l&&n.push(t.substring(o,l)),h!==void 0&&n.push(s.getTokenValue().replace(/[^\r\n]/g,h)),o=s.getPosition();break}while(u!==17);return n.join("")}e.stripComments=r;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(fe[139],me([0,1,61]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function F(S,I,i){let k,a,g,d,w;if(I){for(d=I.offset,w=d+I.length,g=d;g>0&&!_(S,g-1);)g--;let o=w;for(;o<S.length&&!_(S,o);)o++;a=S.substring(g,o),k=y(a,i)}else a=S,k=0,g=0,d=0,w=S.length;const D=A(i,S);let T=!1,E=0,c;i.insertSpaces?c=C(" ",i.tabSize||4):c="	";const r=(0,p.createScanner)(a,!1);let v=!1;function t(){return D+C(c,k+E)}function h(){let o=r.scan();for(T=!1;o===15||o===14;)T=T||o===14,o=r.scan();return v=o===16||r.getTokenError()!==0,o}const s=[];function n(o,l,m){!v&&l<w&&m>d&&S.substring(l,m)!==o&&s.push({offset:l,length:m-l,content:o})}let u=h();if(u!==17){const o=r.getTokenOffset()+g,l=C(c,k);n(l,g,o)}for(;u!==17;){let o=r.getTokenOffset()+r.getTokenLength()+g,l=h(),m="";for(;!T&&(l===12||l===13);){const f=r.getTokenOffset()+g;n(" ",o,f),o=r.getTokenOffset()+r.getTokenLength()+g,m=l===12?t():"",l=h()}if(l===2)u!==1&&(E--,m=t());else if(l===4)u!==3&&(E--,m=t());else{switch(u){case 3:case 1:E++,m=t();break;case 5:case 12:m=t();break;case 13:T?m=t():m=" ";break;case 6:m=" ";break;case 10:if(l===6){m="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?m=" ":l!==5&&l!==17&&(v=!0);break;case 16:v=!0;break}T&&(l===12||l===13)&&(m=t())}const b=r.getTokenOffset()+g;n(m,o,b),u=l}return s}e.format=F;function C(S,I){let i="";for(let k=0;k<I;k++)i+=S;return i}function y(S,I){let i=0,k=0;const a=I.tabSize||4;for(;i<S.length;){const g=S.charAt(i);if(g===" ")k++;else if(g==="	")k+=a;else break;i++}return Math.floor(k/a)}function A(S,I){for(let i=0;i<I.length;i++){const k=I.charAt(i);if(k==="\r")return i+1<I.length&&I.charAt(i+1)===`
`?`\r
`:"\r";if(k===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=A;function _(S,I){return`\r
`.indexOf(S.charAt(I))!==-1}e.isEOL=_}),define(fe[140],me([0,1,61,139]),function(Y,e,p,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function C(I,i,k){return y(I,i,void 0,k)}e.removeProperty=C;function y(I,i,k,a,g){const d=i.slice(),w=[],D=(0,p.parseTree)(I,w);let T,E;for(;d.length>0&&(E=d.pop(),T=(0,p.findNodeAtLocation)(D,d),T===void 0&&k!==void 0);)typeof E=="string"?k={[E]:k}:k=[k];if(T)if(T.type==="object"&&typeof E=="string"&&Array.isArray(T.children)){const c=(0,p.findNodeAtLocation)(T,[E]);if(c!==void 0)if(k===void 0){if(!c.parent)throw new Error("Malformed AST");const r=T.children.indexOf(c.parent);let v,t=c.parent.offset+c.parent.length;if(r>0){const h=T.children[r-1];v=h.offset+h.length}else v=T.offset+1,T.children.length>1&&(t=T.children[1].offset);return A(I,{offset:v,length:t-v,content:""},a)}else return A(I,{offset:c.offset,length:c.length,content:JSON.stringify(k)},a);else{if(k===void 0)return[];const r=`${JSON.stringify(E)}: ${JSON.stringify(k)}`,v=g?g(T.children.map(h=>h.children[0].value)):T.children.length;let t;if(v>0){const h=T.children[v-1];t={offset:h.offset+h.length,length:0,content:","+r}}else T.children.length===0?t={offset:T.offset+1,length:0,content:r}:t={offset:T.offset+1,length:0,content:r+","};return A(I,t,a)}}else if(T.type==="array"&&typeof E=="number"&&Array.isArray(T.children))if(k!==void 0){const c=`${JSON.stringify(k)}`;let r;if(T.children.length===0||E===0)r={offset:T.offset+1,length:0,content:T.children.length===0?c:c+","};else{const v=E===-1||E>T.children.length?T.children.length:E,t=T.children[v-1];r={offset:t.offset+t.length,length:0,content:","+c}}return A(I,r,a)}else{const c=E,r=T.children[c];let v;if(T.children.length===1)v={offset:T.offset+1,length:T.length-2,content:""};else if(T.children.length-1===c){const t=T.children[c-1],h=t.offset+t.length,s=T.offset+T.length;v={offset:h,length:s-2-h,content:""}}else v={offset:r.offset,length:T.children[c+1].offset-r.offset,content:""};return A(I,v,a)}else throw new Error(`Can not add ${typeof E!="number"?"index":"property"} to parent of type ${T.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return A(I,{offset:D?D.offset:0,length:D?D.length:0,content:JSON.stringify(k)},a)}}e.setProperty=y;function A(I,i,k){let a=_(I,i),g=i.offset,d=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;g>0&&!(0,F.isEOL)(a,g-1);)g--;for(;d<a.length&&!(0,F.isEOL)(a,d);)d++}const w=(0,F.format)(a,{offset:g,length:d-g},k);for(let T=w.length-1;T>=0;T--){const E=w[T];a=_(a,E),g=Math.min(g,E.offset),d=Math.max(d,E.offset+E.length),d+=E.content.length-E.length}const D=I.length-(a.length-d)-g;return[{offset:g,length:D,content:a.substring(g,d)}]}e.withFormatting=A;function _(I,i){return I.substring(0,i.offset)+i.content+I.substring(i.offset+i.length)}e.applyEdit=_;function S(I,i){let k=i.slice(0).sort((g,d)=>{const w=g.offset-d.offset;return w===0?g.length-d.length:w}),a=I.length;for(let g=k.length-1;g>=0;g--){let d=k[g];if(d.offset+d.length<=a)I=_(I,d);else throw new Error("Overlapping edit");a=d.offset}return I}e.applyEdits=S}),define(fe[141],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class p{constructor(C){this.executor=C,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(C){this._error=C}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(C){return new p(()=>C(this.getValue()))}}e.Lazy=p}),define(fe[6],me([0,1,76,94]),function(Y,e,p,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const C=!1;let y=null;function A(n){y=n}if(e.setDisposableTracker=A,C){const n="__is_disposable_tracked__";A(new class{trackDisposable(u){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[n]||console.log(o)},3e3)}setParent(u,o){if(u&&u!==E.None)try{u[n]=!0}catch{}}markAsDisposed(u){if(u&&u!==E.None)try{u[n]=!0}catch{}}markAsSingleton(u){}})}function _(n){return y?.trackDisposable(n),n}function S(n){y?.markAsDisposed(n)}function I(n,u){y?.setParent(n,u)}function i(n,u){if(!!y)for(const o of n)y.setParent(o,u)}function k(n){return y?.markAsSingleton(n),n}e.markAsSingleton=k;class a extends Error{constructor(u){super(`Encountered errors while disposing of store. Errors: [${u.join(", ")}]`);this.errors=u}}e.MultiDisposeError=a;function g(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=g;function d(n){if(F.Iterable.is(n)){let u=[];for(const o of n)if(o)try{o.dispose()}catch(l){u.push(l)}if(u.length===1)throw u[0];if(u.length>1)throw new a(u);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}e.dispose=d;function w(...n){const u=D(()=>d(n));return i(n,u),u}e.combinedDisposable=w;function D(n){const u=_({dispose:(0,p.once)(()=>{S(u),n()})});return u}e.toDisposable=D;class T{constructor(){this._toDispose=new Set,this._isDisposed=!1,_(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return I(u,this),this._isDisposed?T.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(u),u}}e.DisposableStore=T,T.DISABLE_DISPOSED_WARNING=!1;class E{constructor(){this._store=new T,_(this),I(this._store,this)}dispose(){S(this),this._store.dispose()}_register(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(u)}}e.Disposable=E,E.None=Object.freeze({dispose(){}});class c{constructor(){this._isDisposed=!1,_(this)}get value(){return this._isDisposed?void 0:this._value}set value(u){this._isDisposed||u===this._value||(this._value?.dispose(),u&&I(u,this),this._value=u)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const u=this._value;return this._value=void 0,u&&I(u,null),u}}e.MutableDisposable=c;class r{constructor(u){this._disposable=u,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=r;class v{constructor(){this.references=new Map}acquire(u,...o){let l=this.references.get(u);l||(l={counter:0,object:this.createReferencedObject(u,...o)},this.references.set(u,l));const{object:m}=l,b=(0,p.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(u,l.object),this.references.delete(u))});return l.counter++,{object:m,dispose:b}}}e.ReferenceCollection=v;class t{constructor(u){this.referenceCollection=u}async acquire(u,...o){const l=this.referenceCollection.acquire(u,...o);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(m){throw l.dispose(),m}}}e.AsyncReferenceCollection=t;class h{constructor(u){this.object=u}dispose(){}}e.ImmortalReference=h;function s(n){const u=new T;try{n(u)}finally{u.dispose()}}e.disposeOnReturn=s}),define(fe[95],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(y){this.element=y,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class F{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let y=this._first;for(;y!==p.Undefined;){const A=y.next;y.prev=p.Undefined,y.next=p.Undefined,y=A}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(y){return this._insert(y,!1)}push(y){return this._insert(y,!0)}_insert(y,A){const _=new p(y);if(this._first===p.Undefined)this._first=_,this._last=_;else if(A){const I=this._last;this._last=_,_.prev=I,I.next=_}else{const I=this._first;this._first=_,_.next=I,I.prev=_}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(_))}}shift(){if(this._first!==p.Undefined){const y=this._first.element;return this._remove(this._first),y}}pop(){if(this._last!==p.Undefined){const y=this._last.element;return this._remove(this._last),y}}_remove(y){if(y.prev!==p.Undefined&&y.next!==p.Undefined){const A=y.prev;A.next=y.next,y.next.prev=A}else y.prev===p.Undefined&&y.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):y.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):y.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let y=this._first;for(;y!==p.Undefined;)yield y.element,y=y.next}}e.LinkedList=F}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(Re,Ce){for(var Pe=0;Pe<Ce.length;Pe++){var se=Ce[Pe];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Re,se.key,se)}}function e(Re,Ce,Pe){return Ce&&Y(Re.prototype,Ce),Pe&&Y(Re,Pe),Re}function p(Re,Ce){if(!!Re){if(typeof Re=="string")return F(Re,Ce);var Pe=Object.prototype.toString.call(Re).slice(8,-1);if(Pe==="Object"&&Re.constructor&&(Pe=Re.constructor.name),Pe==="Map"||Pe==="Set")return Array.from(Re);if(Pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Pe))return F(Re,Ce)}}function F(Re,Ce){(Ce==null||Ce>Re.length)&&(Ce=Re.length);for(var Pe=0,se=new Array(Ce);Pe<Ce;Pe++)se[Pe]=Re[Pe];return se}function C(Re,Ce){var Pe=typeof Symbol!="undefined"&&Re[Symbol.iterator]||Re["@@iterator"];if(Pe)return(Pe=Pe.call(Re)).next.bind(Pe);if(Array.isArray(Re)||(Pe=p(Re))||Ce&&Re&&typeof Re.length=="number"){Pe&&(Re=Pe);var se=0;return function(){return se>=Re.length?{done:!0}:{done:!1,value:Re[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var y={exports:{}};function A(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function _(Re){y.exports.defaults=Re}y.exports={defaults:A(),getDefaults:A,changeDefaults:_};var S=/[&<>"']/,I=/[&<>"']/g,i=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},g=function(Ce){return a[Ce]};function d(Re,Ce){if(Ce){if(S.test(Re))return Re.replace(I,g)}else if(i.test(Re))return Re.replace(k,g);return Re}var w=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function D(Re){return Re.replace(w,function(Ce,Pe){return Pe=Pe.toLowerCase(),Pe==="colon"?":":Pe.charAt(0)==="#"?Pe.charAt(1)==="x"?String.fromCharCode(parseInt(Pe.substring(2),16)):String.fromCharCode(+Pe.substring(1)):""})}var T=/(^|[^\[])\^/g;function E(Re,Ce){Re=Re.source||Re,Ce=Ce||"";var Pe={replace:function(ue,be){return be=be.source||be,be=be.replace(T,"$1"),Re=Re.replace(ue,be),Pe},getRegex:function(){return new RegExp(Re,Ce)}};return Pe}var c=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(Re,Ce,Pe){if(Re){var se;try{se=decodeURIComponent(D(Pe)).replace(c,"").toLowerCase()}catch(ue){return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}Ce&&!r.test(Pe)&&(Pe=u(Ce,Pe));try{Pe=encodeURI(Pe).replace(/%25/g,"%")}catch(ue){return null}return Pe}var t={},h=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function u(Re,Ce){t[" "+Re]||(h.test(Re)?t[" "+Re]=Re+"/":t[" "+Re]=b(Re,"/",!0)),Re=t[" "+Re];var Pe=Re.indexOf(":")===-1;return Ce.substring(0,2)==="//"?Pe?Ce:Re.replace(s,"$1")+Ce:Ce.charAt(0)==="/"?Pe?Ce:Re.replace(n,"$1")+Ce:Re+Ce}var o={exec:function(){}};function l(Re){for(var Ce=1,Pe,se;Ce<arguments.length;Ce++){Pe=arguments[Ce];for(se in Pe)Object.prototype.hasOwnProperty.call(Pe,se)&&(Re[se]=Pe[se])}return Re}function m(Re,Ce){var Pe=Re.replace(/\|/g,function(be,we,Fe){for(var qe=!1,ze=we;--ze>=0&&Fe[ze]==="\\";)qe=!qe;return qe?"|":" |"}),se=Pe.split(/ \|/),ue=0;if(se[0].trim()||se.shift(),se[se.length-1].trim()||se.pop(),se.length>Ce)se.splice(Ce);else for(;se.length<Ce;)se.push("");for(;ue<se.length;ue++)se[ue]=se[ue].trim().replace(/\\\|/g,"|");return se}function b(Re,Ce,Pe){var se=Re.length;if(se===0)return"";for(var ue=0;ue<se;){var be=Re.charAt(se-ue-1);if(be===Ce&&!Pe)ue++;else if(be!==Ce&&Pe)ue++;else break}return Re.substr(0,se-ue)}function f(Re,Ce){if(Re.indexOf(Ce[1])===-1)return-1;for(var Pe=Re.length,se=0,ue=0;ue<Pe;ue++)if(Re[ue]==="\\")ue++;else if(Re[ue]===Ce[0])se++;else if(Re[ue]===Ce[1]&&(se--,se<0))return ue;return-1}function P(Re){Re&&Re.sanitize&&!Re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(Re,Ce){if(Ce<1)return"";for(var Pe="";Ce>1;)Ce&1&&(Pe+=Re),Ce>>=1,Re+=Re;return Pe+Re}var M={escape:d,unescape:D,edit:E,cleanUrl:v,resolveUrl:u,noopTest:o,merge:l,splitCells:m,rtrim:b,findClosingBracket:f,checkSanitizeDeprecation:P,repeatString:L},R=y.exports.defaults,W=M.rtrim,V=M.splitCells,N=M.escape,j=M.findClosingBracket;function U(Re,Ce,Pe,se){var ue=Ce.href,be=Ce.title?N(Ce.title):null,we=Re[1].replace(/\\([\[\]])/g,"$1");if(Re[0].charAt(0)!=="!"){se.state.inLink=!0;var Fe={type:"link",raw:Pe,href:ue,title:be,text:we,tokens:se.inlineTokens(we,[])};return se.state.inLink=!1,Fe}else return{type:"image",raw:Pe,href:ue,title:be,text:N(we)}}function B(Re,Ce){var Pe=Re.match(/^(\s+)(?:```)/);if(Pe===null)return Ce;var se=Pe[1];return Ce.split(`
`).map(function(ue){var be=ue.match(/^\s+/);if(be===null)return ue;var we=be[0];return we.length>=se.length?ue.slice(se.length):ue}).join(`
`)}var z=function(){function Re(Pe){this.options=Pe||R}var Ce=Re.prototype;return Ce.space=function(se){var ue=this.rules.block.newline.exec(se);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},Ce.code=function(se){var ue=this.rules.block.code.exec(se);if(ue){var be=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?be:W(be,`
`)}}},Ce.fences=function(se){var ue=this.rules.block.fences.exec(se);if(ue){var be=ue[0],we=B(be,ue[3]||"");return{type:"code",raw:be,lang:ue[2]?ue[2].trim():ue[2],text:we}}},Ce.heading=function(se){var ue=this.rules.block.heading.exec(se);if(ue){var be=ue[2].trim();if(/#$/.test(be)){var we=W(be,"#");(this.options.pedantic||!we||/ $/.test(we))&&(be=we.trim())}var Fe={type:"heading",raw:ue[0],depth:ue[1].length,text:be,tokens:[]};return this.lexer.inline(Fe.text,Fe.tokens),Fe}},Ce.hr=function(se){var ue=this.rules.block.hr.exec(se);if(ue)return{type:"hr",raw:ue[0]}},Ce.blockquote=function(se){var ue=this.rules.block.blockquote.exec(se);if(ue){var be=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(be,[]),text:be}}},Ce.list=function(se){var ue=this.rules.block.list.exec(se);if(ue){var be,we,Fe,qe,ze,et,at,Be,ge,Ee,ne=ue[1].trim(),K=ne.length>1,Se={type:"list",raw:"",ordered:K,start:K?+ne.slice(0,-1):"",loose:!1,items:[]};ne=K?"\\d{1,9}\\"+ne.slice(-1):"\\"+ne,this.options.pedantic&&(ne=K?ne:"[*+-]");for(var Le=new RegExp("^( {0,3}"+ne+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");se&&!(this.rules.block.hr.test(se)||!(ue=Le.exec(se)));){ge=ue[2].split(`
`),this.options.pedantic?(qe=2,Ee=ge[0].trimLeft()):(qe=ue[2].search(/[^ ]/),qe=ue[1].length+(qe>4?1:qe),Ee=ge[0].slice(qe-ue[1].length)),et=!1,be=ue[0],!ge[0]&&/^ *$/.test(ge[1])&&(be=ue[1]+ge.slice(0,2).join(`
`)+`
`,Se.loose=!0,ge=[]);var it=new RegExp("^ {0,"+Math.min(3,qe-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(ze=1;ze<ge.length;ze++){if(Be=ge[ze],this.options.pedantic&&(Be=Be.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),it.test(Be)){be=ue[1]+ge.slice(0,ze).join(`
`)+`
`;break}if(!et){Be.trim()||(et=!0),Be.search(/[^ ]/)>=qe?Ee+=`
`+Be.slice(qe):Ee+=`
`+Be;continue}if(Be.search(/[^ ]/)>=qe||!Be.trim()){Ee+=`
`+Be.slice(qe);continue}else{be=ue[1]+ge.slice(0,ze).join(`
`)+`
`;break}}Se.loose||(at?Se.loose=!0:/\n *\n *$/.test(be)&&(at=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(Ee),we&&(Fe=we[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),Se.items.push({type:"list_item",raw:be,task:!!we,checked:Fe,loose:!1,text:Ee}),Se.raw+=be,se=se.slice(be.length)}Se.items[Se.items.length-1].raw=be.trimRight(),Se.items[Se.items.length-1].text=Ee.trimRight(),Se.raw=Se.raw.trimRight();var Ge=Se.items.length;for(ze=0;ze<Ge;ze++)this.lexer.state.top=!1,Se.items[ze].tokens=this.lexer.blockTokens(Se.items[ze].text,[]),Se.items[ze].tokens.some(function(pt){return pt.type==="space"})&&(Se.loose=!0,Se.items[ze].loose=!0);return Se}},Ce.html=function(se){var ue=this.rules.block.html.exec(se);if(ue){var be={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};return this.options.sanitize&&(be.type="paragraph",be.text=this.options.sanitizer?this.options.sanitizer(ue[0]):N(ue[0]),be.tokens=[],this.lexer.inline(be.text,be.tokens)),be}},Ce.def=function(se){var ue=this.rules.block.def.exec(se);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var be=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:be,raw:ue[0],href:ue[2],title:ue[3]}}},Ce.table=function(se){var ue=this.rules.block.table.exec(se);if(ue){var be={type:"table",header:V(ue[1]).map(function(at){return{text:at}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(be.header.length===be.align.length){be.raw=ue[0];var we=be.align.length,Fe,qe,ze,et;for(Fe=0;Fe<we;Fe++)/^ *-+: *$/.test(be.align[Fe])?be.align[Fe]="right":/^ *:-+: *$/.test(be.align[Fe])?be.align[Fe]="center":/^ *:-+ *$/.test(be.align[Fe])?be.align[Fe]="left":be.align[Fe]=null;for(we=be.rows.length,Fe=0;Fe<we;Fe++)be.rows[Fe]=V(be.rows[Fe],be.header.length).map(function(at){return{text:at}});for(we=be.header.length,qe=0;qe<we;qe++)be.header[qe].tokens=[],this.lexer.inlineTokens(be.header[qe].text,be.header[qe].tokens);for(we=be.rows.length,qe=0;qe<we;qe++)for(et=be.rows[qe],ze=0;ze<et.length;ze++)et[ze].tokens=[],this.lexer.inlineTokens(et[ze].text,et[ze].tokens);return be}}},Ce.lheading=function(se){var ue=this.rules.block.lheading.exec(se);if(ue){var be={type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},Ce.paragraph=function(se){var ue=this.rules.block.paragraph.exec(se);if(ue){var be={type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},Ce.text=function(se){var ue=this.rules.block.text.exec(se);if(ue){var be={type:"text",raw:ue[0],text:ue[0],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},Ce.escape=function(se){var ue=this.rules.inline.escape.exec(se);if(ue)return{type:"escape",raw:ue[0],text:N(ue[1])}},Ce.tag=function(se){var ue=this.rules.inline.tag.exec(se);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):N(ue[0]):ue[0]}},Ce.link=function(se){var ue=this.rules.inline.link.exec(se);if(ue){var be=ue[2].trim();if(!this.options.pedantic&&/^</.test(be)){if(!/>$/.test(be))return;var we=W(be.slice(0,-1),"\\");if((be.length-we.length)%2==0)return}else{var Fe=j(ue[2],"()");if(Fe>-1){var qe=ue[0].indexOf("!")===0?5:4,ze=qe+ue[1].length+Fe;ue[2]=ue[2].substring(0,Fe),ue[0]=ue[0].substring(0,ze).trim(),ue[3]=""}}var et=ue[2],at="";if(this.options.pedantic){var Be=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(et);Be&&(et=Be[1],at=Be[3])}else at=ue[3]?ue[3].slice(1,-1):"";return et=et.trim(),/^</.test(et)&&(this.options.pedantic&&!/>$/.test(be)?et=et.slice(1):et=et.slice(1,-1)),U(ue,{href:et&&et.replace(this.rules.inline._escapes,"$1"),title:at&&at.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},Ce.reflink=function(se,ue){var be;if((be=this.rules.inline.reflink.exec(se))||(be=this.rules.inline.nolink.exec(se))){var we=(be[2]||be[1]).replace(/\s+/g," ");if(we=ue[we.toLowerCase()],!we||!we.href){var Fe=be[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return U(be,we,be[0],this.lexer)}},Ce.emStrong=function(se,ue,be){be===void 0&&(be="");var we=this.rules.inline.emStrong.lDelim.exec(se);if(!!we&&!(we[3]&&be.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=we[1]||we[2]||"";if(!Fe||Fe&&(be===""||this.rules.inline.punctuation.exec(be))){var qe=we[0].length-1,ze,et,at=qe,Be=0,ge=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ge.lastIndex=0,ue=ue.slice(-1*se.length+qe);(we=ge.exec(ue))!=null;)if(ze=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!ze){if(et=ze.length,we[3]||we[4]){at+=et;continue}else if((we[5]||we[6])&&qe%3&&!((qe+et)%3)){Be+=et;continue}if(at-=et,!(at>0)){if(et=Math.min(et,et+at+Be),Math.min(qe,et)%2){var Ee=se.slice(1,qe+we.index+et);return{type:"em",raw:se.slice(0,qe+we.index+et+1),text:Ee,tokens:this.lexer.inlineTokens(Ee,[])}}var ne=se.slice(2,qe+we.index+et-1);return{type:"strong",raw:se.slice(0,qe+we.index+et+1),text:ne,tokens:this.lexer.inlineTokens(ne,[])}}}}}},Ce.codespan=function(se){var ue=this.rules.inline.code.exec(se);if(ue){var be=ue[2].replace(/\n/g," "),we=/[^ ]/.test(be),Fe=/^ /.test(be)&&/ $/.test(be);return we&&Fe&&(be=be.substring(1,be.length-1)),be=N(be,!0),{type:"codespan",raw:ue[0],text:be}}},Ce.br=function(se){var ue=this.rules.inline.br.exec(se);if(ue)return{type:"br",raw:ue[0]}},Ce.del=function(se){var ue=this.rules.inline.del.exec(se);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2],[])}},Ce.autolink=function(se,ue){var be=this.rules.inline.autolink.exec(se);if(be){var we,Fe;return be[2]==="@"?(we=N(this.options.mangle?ue(be[1]):be[1]),Fe="mailto:"+we):(we=N(be[1]),Fe=we),{type:"link",raw:be[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},Ce.url=function(se,ue){var be;if(be=this.rules.inline.url.exec(se)){var we,Fe;if(be[2]==="@")we=N(this.options.mangle?ue(be[0]):be[0]),Fe="mailto:"+we;else{var qe;do qe=be[0],be[0]=this.rules.inline._backpedal.exec(be[0])[0];while(qe!==be[0]);we=N(be[0]),be[1]==="www."?Fe="http://"+we:Fe=we}return{type:"link",raw:be[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},Ce.inlineText=function(se,ue){var be=this.rules.inline.text.exec(se);if(be){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(be[0]):N(be[0]):be[0]:we=N(this.options.smartypants?ue(be[0]):be[0]),{type:"text",raw:be[0],text:we}}},Re}(),O=M.noopTest,$=M.edit,x=M.merge,X={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:O,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};X._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,X._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,X.def=$(X.def).replace("label",X._label).replace("title",X._title).getRegex(),X.bullet=/(?:[*+-]|\d{1,9}[.)])/,X.listItemStart=$(/^( *)(bull) */).replace("bull",X.bullet).getRegex(),X.list=$(X.list).replace(/bull/g,X.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+X.def.source+")").getRegex(),X._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",X._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,X.html=$(X.html,"i").replace("comment",X._comment).replace("tag",X._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),X.paragraph=$(X._paragraph).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",X._tag).getRegex(),X.blockquote=$(X.blockquote).replace("paragraph",X.paragraph).getRegex(),X.normal=x({},X),X.gfm=x({},X.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),X.gfm.table=$(X.gfm.table).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",X._tag).getRegex(),X.pedantic=x({},X.normal,{html:$(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",X._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:O,paragraph:$(X.normal._paragraph).replace("hr",X.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",X.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:O,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:O,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=$(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=$(X._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=$(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=$(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=$(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=$(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=$(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=$(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=$(Q.reflink).replace("label",Q._label).getRegex(),Q.reflinkSearch=$(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=x({},Q),Q.pedantic=x({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:$(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:$(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=x({},Q.normal,{escape:$(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),Q.gfm.url=$(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=x({},Q.gfm,{br:$(Q.br).replace("{2,}","*").getRegex(),text:$(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var de={block:X,inline:Q},_e=z,ye=y.exports.defaults,ke=de.block,xe=de.inline,We=M.repeatString;function He(Re){return Re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(Re){var Ce="",Pe,se,ue=Re.length;for(Pe=0;Pe<ue;Pe++)se=Re.charCodeAt(Pe),Math.random()>.5&&(se="x"+se.toString(16)),Ce+="&#"+se+";";return Ce}var ee=function(){function Re(Pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=Pe||ye,this.options.tokenizer=this.options.tokenizer||new _e,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:ke.normal,inline:xe.normal};this.options.pedantic?(se.block=ke.pedantic,se.inline=xe.pedantic):this.options.gfm&&(se.block=ke.gfm,this.options.breaks?se.inline=xe.breaks:se.inline=xe.gfm),this.tokenizer.rules=se}Re.lex=function(se,ue){var be=new Re(ue);return be.lex(se)},Re.lexInline=function(se,ue){var be=new Re(ue);return be.inlineTokens(se)};var Ce=Re.prototype;return Ce.lex=function(se){se=se.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(se,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},Ce.blockTokens=function(se,ue){var be=this;ue===void 0&&(ue=[]),this.options.pedantic&&(se=se.replace(/^ +$/gm,""));for(var we,Fe,qe,ze;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(at){return(we=at.call({lexer:be},se,ue))?(se=se.substring(we.raw.length),ue.push(we),!0):!1}))){if(we=this.tokenizer.space(se)){se=se.substring(we.raw.length),we.type&&ue.push(we);continue}if(we=this.tokenizer.code(se)){se=se.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(we);continue}if(we=this.tokenizer.fences(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.heading(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.hr(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.blockquote(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.list(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.html(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.def(se)){se=se.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.lheading(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(qe=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var at=Infinity,Be=se.slice(1),ge=void 0;be.options.extensions.startBlock.forEach(function(Ee){ge=Ee.call({lexer:this},Be),typeof ge=="number"&&ge>=0&&(at=Math.min(at,ge))}),at<Infinity&&at>=0&&(qe=se.substring(0,at+1))}(),this.state.top&&(we=this.tokenizer.paragraph(qe))){Fe=ue[ue.length-1],ze&&Fe.type==="paragraph"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(we),ze=qe.length!==se.length,se=se.substring(we.raw.length);continue}if(we=this.tokenizer.text(se)){se=se.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(we);continue}if(se){var et="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(et);break}else throw new Error(et)}}return this.state.top=!0,ue},Ce.inline=function(se,ue){this.inlineQueue.push({src:se,tokens:ue})},Ce.inlineTokens=function(se,ue){var be=this;ue===void 0&&(ue=[]);var we,Fe,qe,ze=se,et,at,Be;if(this.tokens.links){var ge=Object.keys(this.tokens.links);if(ge.length>0)for(;(et=this.tokenizer.rules.inline.reflinkSearch.exec(ze))!=null;)ge.includes(et[0].slice(et[0].lastIndexOf("[")+1,-1))&&(ze=ze.slice(0,et.index)+"["+We("a",et[0].length-2)+"]"+ze.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(et=this.tokenizer.rules.inline.blockSkip.exec(ze))!=null;)ze=ze.slice(0,et.index)+"["+We("a",et[0].length-2)+"]"+ze.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(et=this.tokenizer.rules.inline.escapedEmSt.exec(ze))!=null;)ze=ze.slice(0,et.index)+"++"+ze.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(at||(Be=""),at=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ne){return(we=ne.call({lexer:be},se,ue))?(se=se.substring(we.raw.length),ue.push(we),!0):!1}))){if(we=this.tokenizer.escape(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.tag(se)){se=se.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):ue.push(we);continue}if(we=this.tokenizer.link(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):ue.push(we);continue}if(we=this.tokenizer.emStrong(se,ze,Be)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.codespan(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.br(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.del(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.autolink(se,q)){se=se.substring(we.raw.length),ue.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(se,q))){se=se.substring(we.raw.length),ue.push(we);continue}if(qe=se,this.options.extensions&&this.options.extensions.startInline&&function(){var ne=Infinity,K=se.slice(1),Se=void 0;be.options.extensions.startInline.forEach(function(Le){Se=Le.call({lexer:this},K),typeof Se=="number"&&Se>=0&&(ne=Math.min(ne,Se))}),ne<Infinity&&ne>=0&&(qe=se.substring(0,ne+1))}(),we=this.tokenizer.inlineText(qe,He)){se=se.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(Be=we.raw.slice(-1)),at=!0,Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):ue.push(we);continue}if(se){var Ee="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(Ee);break}else throw new Error(Ee)}}return ue},e(Re,null,[{key:"rules",get:function(){return{block:ke,inline:xe}}}]),Re}(),re=y.exports.defaults,le=M.cleanUrl,Z=M.escape,ae=function(){function Re(Pe){this.options=Pe||re}var Ce=Re.prototype;return Ce.code=function(se,ue,be){var we=(ue||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(se,we);Fe!=null&&Fe!==se&&(be=!0,se=Fe)}return se=se.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+Z(we,!0)+'">'+(be?se:Z(se,!0))+`</code></pre>
`:"<pre><code>"+(be?se:Z(se,!0))+`</code></pre>
`},Ce.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},Ce.html=function(se){return se},Ce.heading=function(se,ue,be,we){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+we.slug(be)+'">'+se+"</h"+ue+`>
`:"<h"+ue+">"+se+"</h"+ue+`>
`},Ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ce.list=function(se,ue,be){var we=ue?"ol":"ul",Fe=ue&&be!==1?' start="'+be+'"':"";return"<"+we+Fe+`>
`+se+"</"+we+`>
`},Ce.listitem=function(se){return"<li>"+se+`</li>
`},Ce.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ce.paragraph=function(se){return"<p>"+se+`</p>
`},Ce.table=function(se,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+ue+`</table>
`},Ce.tablerow=function(se){return`<tr>
`+se+`</tr>
`},Ce.tablecell=function(se,ue){var be=ue.header?"th":"td",we=ue.align?"<"+be+' align="'+ue.align+'">':"<"+be+">";return we+se+"</"+be+`>
`},Ce.strong=function(se){return"<strong>"+se+"</strong>"},Ce.em=function(se){return"<em>"+se+"</em>"},Ce.codespan=function(se){return"<code>"+se+"</code>"},Ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ce.del=function(se){return"<del>"+se+"</del>"},Ce.link=function(se,ue,be){if(se=le(this.options.sanitize,this.options.baseUrl,se),se===null)return be;var we='<a href="'+Z(se)+'"';return ue&&(we+=' title="'+ue+'"'),we+=">"+be+"</a>",we},Ce.image=function(se,ue,be){if(se=le(this.options.sanitize,this.options.baseUrl,se),se===null)return be;var we='<img src="'+se+'" alt="'+be+'"';return ue&&(we+=' title="'+ue+'"'),we+=this.options.xhtml?"/>":">",we},Ce.text=function(se){return se},Re}(),pe=function(){function Re(){}var Ce=Re.prototype;return Ce.strong=function(se){return se},Ce.em=function(se){return se},Ce.codespan=function(se){return se},Ce.del=function(se){return se},Ce.html=function(se){return se},Ce.text=function(se){return se},Ce.link=function(se,ue,be){return""+be},Ce.image=function(se,ue,be){return""+be},Ce.br=function(){return""},Re}(),Me=function(){function Re(){this.seen={}}var Ce=Re.prototype;return Ce.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ce.getNextSafeSlug=function(se,ue){var be=se,we=0;if(this.seen.hasOwnProperty(be)){we=this.seen[se];do we++,be=se+"-"+we;while(this.seen.hasOwnProperty(be))}return ue||(this.seen[se]=we,this.seen[be]=0),be},Ce.slug=function(se,ue){ue===void 0&&(ue={});var be=this.serialize(se);return this.getNextSafeSlug(be,ue.dryrun)},Re}(),je=ae,Ke=pe,Je=Me,st=y.exports.defaults,Te=M.unescape,nt=function(){function Re(Pe){this.options=Pe||st,this.options.renderer=this.options.renderer||new je,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ke,this.slugger=new Je}Re.parse=function(se,ue){var be=new Re(ue);return be.parse(se)},Re.parseInline=function(se,ue){var be=new Re(ue);return be.parseInline(se)};var Ce=Re.prototype;return Ce.parse=function(se,ue){ue===void 0&&(ue=!0);var be="",we,Fe,qe,ze,et,at,Be,ge,Ee,ne,K,Se,Le,it,Ge,pt,Et,ft,bt,mt=se.length;for(we=0;we<mt;we++){if(ne=se[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ne.type]&&(bt=this.options.extensions.renderers[ne.type].call({parser:this},ne),bt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ne.type))){be+=bt||"";continue}switch(ne.type){case"space":continue;case"hr":{be+=this.renderer.hr();continue}case"heading":{be+=this.renderer.heading(this.parseInline(ne.tokens),ne.depth,Te(this.parseInline(ne.tokens,this.textRenderer)),this.slugger);continue}case"code":{be+=this.renderer.code(ne.text,ne.lang,ne.escaped);continue}case"table":{for(ge="",Be="",ze=ne.header.length,Fe=0;Fe<ze;Fe++)Be+=this.renderer.tablecell(this.parseInline(ne.header[Fe].tokens),{header:!0,align:ne.align[Fe]});for(ge+=this.renderer.tablerow(Be),Ee="",ze=ne.rows.length,Fe=0;Fe<ze;Fe++){for(at=ne.rows[Fe],Be="",et=at.length,qe=0;qe<et;qe++)Be+=this.renderer.tablecell(this.parseInline(at[qe].tokens),{header:!1,align:ne.align[qe]});Ee+=this.renderer.tablerow(Be)}be+=this.renderer.table(ge,Ee);continue}case"blockquote":{Ee=this.parse(ne.tokens),be+=this.renderer.blockquote(Ee);continue}case"list":{for(K=ne.ordered,Se=ne.start,Le=ne.loose,ze=ne.items.length,Ee="",Fe=0;Fe<ze;Fe++)Ge=ne.items[Fe],pt=Ge.checked,Et=Ge.task,it="",Ge.task&&(ft=this.renderer.checkbox(pt),Le?Ge.tokens.length>0&&Ge.tokens[0].type==="paragraph"?(Ge.tokens[0].text=ft+" "+Ge.tokens[0].text,Ge.tokens[0].tokens&&Ge.tokens[0].tokens.length>0&&Ge.tokens[0].tokens[0].type==="text"&&(Ge.tokens[0].tokens[0].text=ft+" "+Ge.tokens[0].tokens[0].text)):Ge.tokens.unshift({type:"text",text:ft}):it+=ft),it+=this.parse(Ge.tokens,Le),Ee+=this.renderer.listitem(it,Et,pt);be+=this.renderer.list(Ee,K,Se);continue}case"html":{be+=this.renderer.html(ne.text);continue}case"paragraph":{be+=this.renderer.paragraph(this.parseInline(ne.tokens));continue}case"text":{for(Ee=ne.tokens?this.parseInline(ne.tokens):ne.text;we+1<mt&&se[we+1].type==="text";)ne=se[++we],Ee+=`
`+(ne.tokens?this.parseInline(ne.tokens):ne.text);be+=ue?this.renderer.paragraph(Ee):Ee;continue}default:{var _t='Token with "'+ne.type+'" type was not found.';if(this.options.silent){console.error(_t);return}else throw new Error(_t)}}}return be},Ce.parseInline=function(se,ue){ue=ue||this.renderer;var be="",we,Fe,qe,ze=se.length;for(we=0;we<ze;we++){if(Fe=se[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(qe=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),qe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){be+=qe||"";continue}switch(Fe.type){case"escape":{be+=ue.text(Fe.text);break}case"html":{be+=ue.html(Fe.text);break}case"link":{be+=ue.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,ue));break}case"image":{be+=ue.image(Fe.href,Fe.title,Fe.text);break}case"strong":{be+=ue.strong(this.parseInline(Fe.tokens,ue));break}case"em":{be+=ue.em(this.parseInline(Fe.tokens,ue));break}case"codespan":{be+=ue.codespan(Fe.text);break}case"br":{be+=ue.br();break}case"del":{be+=ue.del(this.parseInline(Fe.tokens,ue));break}case"text":{be+=ue.text(Fe.text);break}default:{var et='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(et);return}else throw new Error(et)}}}return be},Re}(),J=ee,te=nt,ve=z,Qe=ae,tt=pe,ct=Me,ce=M.merge,Ie=M.checkSanitizeDeprecation,Ue=M.escape,Xe=y.exports.getDefaults,rt=y.exports.changeDefaults,ht=y.exports.defaults;function Ye(Re,Ce,Pe){if(typeof Re=="undefined"||Re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");if(typeof Ce=="function"&&(Pe=Ce,Ce=null),Ce=ce({},Ye.defaults,Ce||{}),Ie(Ce),Pe){var se=Ce.highlight,ue;try{ue=J.lex(Re,Ce)}catch(qe){return Pe(qe)}var be=function(ze){var et;if(!ze)try{Ce.walkTokens&&Ye.walkTokens(ue,Ce.walkTokens),et=te.parse(ue,Ce)}catch(at){ze=at}return Ce.highlight=se,ze?Pe(ze):Pe(null,et)};if(!se||se.length<3||(delete Ce.highlight,!ue.length))return be();var we=0;Ye.walkTokens(ue,function(qe){qe.type==="code"&&(we++,setTimeout(function(){se(qe.text,qe.lang,function(ze,et){if(ze)return be(ze);et!=null&&et!==qe.text&&(qe.text=et,qe.escaped=!0),we--,we===0&&be()})},0))}),we===0&&be();return}try{var Fe=J.lex(Re,Ce);return Ce.walkTokens&&Ye.walkTokens(Fe,Ce.walkTokens),te.parse(Fe,Ce)}catch(qe){if(qe.message+=`
Please report this to https://github.com/markedjs/marked.`,Ce.silent)return"<p>An error occurred:</p><pre>"+Ue(qe.message+"",!0)+"</pre>";throw qe}}Ye.options=Ye.setOptions=function(Re){return ce(Ye.defaults,Re),rt(Ye.defaults),Ye},Ye.getDefaults=Xe,Ye.defaults=ht,Ye.use=function(){for(var Re=this,Ce=arguments.length,Pe=new Array(Ce),se=0;se<Ce;se++)Pe[se]=arguments[se];var ue=ce.apply(void 0,[{}].concat(Pe)),be=Ye.defaults.extensions||{renderers:{},childTokens:{}},we;Pe.forEach(function(Fe){if(Fe.extensions&&(we=!0,Fe.extensions.forEach(function(ze){if(!ze.name)throw new Error("extension name required");if(ze.renderer){var et=be.renderers?be.renderers[ze.name]:null;et?be.renderers[ze.name]=function(){for(var at=arguments.length,Be=new Array(at),ge=0;ge<at;ge++)Be[ge]=arguments[ge];var Ee=ze.renderer.apply(this,Be);return Ee===!1&&(Ee=et.apply(this,Be)),Ee}:be.renderers[ze.name]=ze.renderer}if(ze.tokenizer){if(!ze.level||ze.level!=="block"&&ze.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");be[ze.level]?be[ze.level].unshift(ze.tokenizer):be[ze.level]=[ze.tokenizer],ze.start&&(ze.level==="block"?be.startBlock?be.startBlock.push(ze.start):be.startBlock=[ze.start]:ze.level==="inline"&&(be.startInline?be.startInline.push(ze.start):be.startInline=[ze.start]))}ze.childTokens&&(be.childTokens[ze.name]=ze.childTokens)})),Fe.renderer&&function(){var ze=Ye.defaults.renderer||new Qe,et=function(ge){var Ee=ze[ge];ze[ge]=function(){for(var ne=arguments.length,K=new Array(ne),Se=0;Se<ne;Se++)K[Se]=arguments[Se];var Le=Fe.renderer[ge].apply(ze,K);return Le===!1&&(Le=Ee.apply(ze,K)),Le}};for(var at in Fe.renderer)et(at);ue.renderer=ze}(),Fe.tokenizer&&function(){var ze=Ye.defaults.tokenizer||new ve,et=function(ge){var Ee=ze[ge];ze[ge]=function(){for(var ne=arguments.length,K=new Array(ne),Se=0;Se<ne;Se++)K[Se]=arguments[Se];var Le=Fe.tokenizer[ge].apply(ze,K);return Le===!1&&(Le=Ee.apply(ze,K)),Le}};for(var at in Fe.tokenizer)et(at);ue.tokenizer=ze}(),Fe.walkTokens){var qe=Ye.defaults.walkTokens;ue.walkTokens=function(ze){Fe.walkTokens.call(Re,ze),qe&&qe(ze)}}we&&(ue.extensions=be),Ye.setOptions(ue)})},Ye.walkTokens=function(Re,Ce){for(var Pe=function(){var we=ue.value;switch(Ce(we),we.type){case"table":{for(var Fe=C(we.header),qe;!(qe=Fe()).done;){var ze=qe.value;Ye.walkTokens(ze.tokens,Ce)}for(var et=C(we.rows),at;!(at=et()).done;)for(var Be=at.value,ge=C(Be),Ee;!(Ee=ge()).done;){var ne=Ee.value;Ye.walkTokens(ne.tokens,Ce)}break}case"list":{Ye.walkTokens(we.items,Ce);break}default:Ye.defaults.extensions&&Ye.defaults.extensions.childTokens&&Ye.defaults.extensions.childTokens[we.type]?Ye.defaults.extensions.childTokens[we.type].forEach(function(K){Ye.walkTokens(we[K],Ce)}):we.tokens&&Ye.walkTokens(we.tokens,Ce)}},se=C(Re),ue;!(ue=se()).done;)Pe()},Ye.parseInline=function(Re,Ce){if(typeof Re=="undefined"||Re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");Ce=ce({},Ye.defaults,Ce||{}),Ie(Ce);try{var Pe=J.lexInline(Re,Ce);return Ce.walkTokens&&Ye.walkTokens(Pe,Ce.walkTokens),te.parseInline(Pe,Ce)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,Ce.silent)return"<p>An error occurred:</p><pre>"+Ue(se.message+"",!0)+"</pre>";throw se}},Ye.Parser=te,Ye.parser=te.parse,Ye.Renderer=Qe,Ye.TextRenderer=tt,Ye.Lexer=J,Ye.lexer=J.lex,Ye.Tokenizer=ve,Ye.Slugger=ct,Ye.parse=Ye;var vt=Ye;return vt}),define(fe[78],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function p(A,_,S){return Math.min(Math.max(A,_),S)}e.clamp=p;function F(A,_){return(_+A%_)%_}e.rot=F;class C{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=C;class y{constructor(){this._n=1,this._val=0}update(_){return this._val=this._val+(_-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=y}),function(){function Y(C){const y=[];typeof C=="number"&&y.push("code/timeOrigin",C);function A(S){y.push(S,Date.now())}function _(){const S=[];for(let I=0;I<y.length;I+=2)S.push({name:y[I],startTime:y[I+1]});return S}return{mark:A,getMarks:_}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const y=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))y.push({name:A.name,startTime:Math.round(C+A.startTime)});return y}};if(typeof process=="object"){const C=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function p(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=p(F))}(),define(fe[11],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const p="en";let F=!1,C=!1,y=!1,A=!1,_=!1,S=!1,I=!1,i,k=p,a,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const w=typeof d?.versions?.electron=="string"&&d.type==="renderer";if(e.isElectronSandboxed=w&&d?.sandboxed,typeof navigator=="object"&&!w)g=navigator.userAgent,F=g.indexOf("Windows")>=0,C=g.indexOf("Macintosh")>=0,I=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=g.indexOf("Linux")>=0,S=!0,i=navigator.language,k=i;else if(typeof d=="object"){F=d.platform==="win32",C=d.platform==="darwin",y=d.platform==="linux",A=y&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,i=p,k=p;const s=d.env.VSCODE_NLS_CONFIG;if(s)try{const n=JSON.parse(s),u=n.availableLanguages["*"];i=n.locale,k=u||p,a=n._translationsConfigFile}catch(n){}_=!0}else console.error("Unable to resolve platform.");var D;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(D=e.Platform||(e.Platform={}));function T(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=T;let E=0;C?E=1:F?E=3:y&&(E=2),e.isWindows=F,e.isMacintosh=C,e.isLinux=y,e.isLinuxSnap=A,e.isNative=_,e.isWeb=S,e.isIOS=I,e.platform=E,e.userAgent=g,e.language=k;var c;(function(s){function n(){return e.language}s.value=n;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=u;function o(){return e.language==="en"}s.isDefault=o})(c=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=a,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let u=[];e.globals.addEventListener("message",l=>{if(l.data&&l.data.vscodeSetImmediateId)for(let m=0,b=u.length;m<b;m++){const f=u[m];if(f.id===l.data.vscodeSetImmediateId){u.splice(m,1),f.callback();return}}});let o=0;return l=>{const m=++o;u.push({id:m,callback:l}),e.globals.postMessage({vscodeSetImmediateId:m},"*")}}if(typeof d?.nextTick=="function")return d.nextTick.bind(d);const n=Promise.resolve();return u=>n.then(u)}();var r;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=C||I?2:F?1:3;let v=!0,t=!1;function h(){if(!t){t=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,v=new Uint16Array(s.buffer)[0]===(2<<8)+1}return v}e.isLittleEndian=h}),define(fe[38],me([0,1,11]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let F;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const C=p.globals.vscode.process;F={get platform(){return C.platform},get arch(){return C.arch},get env(){return C.env},cwd(){return C.cwd()},nextTick(y){return(0,p.setImmediate)(y)}}}else typeof process!="undefined"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(C){return process.nextTick(C)}}:F={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},get arch(){},nextTick(C){return(0,p.setImmediate)(C)},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.platform=F.platform,e.nextTick=F.nextTick,e.arch=F.arch}),define(fe[8],me([0,1,38]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const F=65,C=97,y=90,A=122,_=46,S=47,I=92,i=58,k=63;class a extends Error{constructor(r,v,t){let h;typeof v=="string"&&v.indexOf("not ")===0?(h="must not be",v=v.replace(/^not /,"")):h="must be";const s=r.indexOf(".")!==-1?"property":"argument";let n=`The "${r}" ${s} ${h} of type ${v}`;n+=`. Received type ${typeof t}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function g(c,r){if(typeof c!="string")throw new a(r,"string",c)}function d(c){return c===S||c===I}function w(c){return c===S}function D(c){return c>=F&&c<=y||c>=C&&c<=A}function T(c,r,v,t){let h="",s=0,n=-1,u=0,o=0;for(let l=0;l<=c.length;++l){if(l<c.length)o=c.charCodeAt(l);else{if(t(o))break;o=S}if(t(o)){if(!(n===l-1||u===1))if(u===2){if(h.length<2||s!==2||h.charCodeAt(h.length-1)!==_||h.charCodeAt(h.length-2)!==_){if(h.length>2){const m=h.lastIndexOf(v);m===-1?(h="",s=0):(h=h.slice(0,m),s=h.length-1-h.lastIndexOf(v)),n=l,u=0;continue}else if(h.length!==0){h="",s=0,n=l,u=0;continue}}r&&(h+=h.length>0?`${v}..`:"..",s=2)}else h.length>0?h+=`${v}${c.slice(n+1,l)}`:h=c.slice(n+1,l),s=l-n-1;n=l,u=0}else o===_&&u!==-1?++u:u=-1}return h}function E(c,r){if(r===null||typeof r!="object")throw new a("pathObject","Object",r);const v=r.dir||r.root,t=r.base||`${r.name||""}${r.ext||""}`;return v?v===r.root?`${v}${t}`:`${v}${c}${t}`:t}e.win32={resolve(...c){let r="",v="",t=!1;for(let h=c.length-1;h>=-1;h--){let s;if(h>=0){if(s=c[h],g(s,"path"),s.length===0)continue}else r.length===0?s=p.cwd():(s=p.env[`=${r}`]||p.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==r.toLowerCase()&&s.charCodeAt(2)===I)&&(s=`${r}\\`));const n=s.length;let u=0,o="",l=!1;const m=s.charCodeAt(0);if(n===1)d(m)&&(u=1,l=!0);else if(d(m))if(l=!0,d(s.charCodeAt(1))){let b=2,f=b;for(;b<n&&!d(s.charCodeAt(b));)b++;if(b<n&&b!==f){const P=s.slice(f,b);for(f=b;b<n&&d(s.charCodeAt(b));)b++;if(b<n&&b!==f){for(f=b;b<n&&!d(s.charCodeAt(b));)b++;(b===n||b!==f)&&(o=`\\\\${P}\\${s.slice(f,b)}`,u=b)}}}else u=1;else D(m)&&s.charCodeAt(1)===i&&(o=s.slice(0,2),u=2,n>2&&d(s.charCodeAt(2))&&(l=!0,u=3));if(o.length>0)if(r.length>0){if(o.toLowerCase()!==r.toLowerCase())continue}else r=o;if(t){if(r.length>0)break}else if(v=`${s.slice(u)}\\${v}`,t=l,l&&r.length>0)break}return v=T(v,!t,"\\",d),t?`${r}\\${v}`:`${r}${v}`||"."},normalize(c){g(c,"path");const r=c.length;if(r===0)return".";let v=0,t,h=!1;const s=c.charCodeAt(0);if(r===1)return w(s)?"\\":c;if(d(s))if(h=!0,d(c.charCodeAt(1))){let u=2,o=u;for(;u<r&&!d(c.charCodeAt(u));)u++;if(u<r&&u!==o){const l=c.slice(o,u);for(o=u;u<r&&d(c.charCodeAt(u));)u++;if(u<r&&u!==o){for(o=u;u<r&&!d(c.charCodeAt(u));)u++;if(u===r)return`\\\\${l}\\${c.slice(o)}\\`;u!==o&&(t=`\\\\${l}\\${c.slice(o,u)}`,v=u)}}}else v=1;else D(s)&&c.charCodeAt(1)===i&&(t=c.slice(0,2),v=2,r>2&&d(c.charCodeAt(2))&&(h=!0,v=3));let n=v<r?T(c.slice(v),!h,"\\",d):"";return n.length===0&&!h&&(n="."),n.length>0&&d(c.charCodeAt(r-1))&&(n+="\\"),t===void 0?h?`\\${n}`:n:h?`${t}\\${n}`:`${t}${n}`},isAbsolute(c){g(c,"path");const r=c.length;if(r===0)return!1;const v=c.charCodeAt(0);return d(v)||r>2&&D(v)&&c.charCodeAt(1)===i&&d(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let r,v;for(let s=0;s<c.length;++s){const n=c[s];g(n,"path"),n.length>0&&(r===void 0?r=v=n:r+=`\\${n}`)}if(r===void 0)return".";let t=!0,h=0;if(typeof v=="string"&&d(v.charCodeAt(0))){++h;const s=v.length;s>1&&d(v.charCodeAt(1))&&(++h,s>2&&(d(v.charCodeAt(2))?++h:t=!1))}if(t){for(;h<r.length&&d(r.charCodeAt(h));)h++;h>=2&&(r=`\\${r.slice(h)}`)}return e.win32.normalize(r)},relative(c,r){if(g(c,"from"),g(r,"to"),c===r)return"";const v=e.win32.resolve(c),t=e.win32.resolve(r);if(v===t||(c=v.toLowerCase(),r=t.toLowerCase(),c===r))return"";let h=0;for(;h<c.length&&c.charCodeAt(h)===I;)h++;let s=c.length;for(;s-1>h&&c.charCodeAt(s-1)===I;)s--;const n=s-h;let u=0;for(;u<r.length&&r.charCodeAt(u)===I;)u++;let o=r.length;for(;o-1>u&&r.charCodeAt(o-1)===I;)o--;const l=o-u,m=n<l?n:l;let b=-1,f=0;for(;f<m;f++){const L=c.charCodeAt(h+f);if(L!==r.charCodeAt(u+f))break;L===I&&(b=f)}if(f!==m){if(b===-1)return t}else{if(l>m){if(r.charCodeAt(u+f)===I)return t.slice(u+f+1);if(f===2)return t.slice(u+f)}n>m&&(c.charCodeAt(h+f)===I?b=f:f===2&&(b=3)),b===-1&&(b=0)}let P="";for(f=h+b+1;f<=s;++f)(f===s||c.charCodeAt(f)===I)&&(P+=P.length===0?"..":"\\..");return u+=b,P.length>0?`${P}${t.slice(u,o)}`:(t.charCodeAt(u)===I&&++u,t.slice(u,o))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const r=e.win32.resolve(c);if(r.length<=2)return c;if(r.charCodeAt(0)===I){if(r.charCodeAt(1)===I){const v=r.charCodeAt(2);if(v!==k&&v!==_)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(D(r.charCodeAt(0))&&r.charCodeAt(1)===i&&r.charCodeAt(2)===I)return`\\\\?\\${r}`;return c},dirname(c){g(c,"path");const r=c.length;if(r===0)return".";let v=-1,t=0;const h=c.charCodeAt(0);if(r===1)return d(h)?c:".";if(d(h)){if(v=t=1,d(c.charCodeAt(1))){let u=2,o=u;for(;u<r&&!d(c.charCodeAt(u));)u++;if(u<r&&u!==o){for(o=u;u<r&&d(c.charCodeAt(u));)u++;if(u<r&&u!==o){for(o=u;u<r&&!d(c.charCodeAt(u));)u++;if(u===r)return c;u!==o&&(v=t=u+1)}}}}else D(h)&&c.charCodeAt(1)===i&&(v=r>2&&d(c.charCodeAt(2))?3:2,t=v);let s=-1,n=!0;for(let u=r-1;u>=t;--u)if(d(c.charCodeAt(u))){if(!n){s=u;break}}else n=!1;if(s===-1){if(v===-1)return".";s=v}return c.slice(0,s)},basename(c,r){r!==void 0&&g(r,"ext"),g(c,"path");let v=0,t=-1,h=!0,s;if(c.length>=2&&D(c.charCodeAt(0))&&c.charCodeAt(1)===i&&(v=2),r!==void 0&&r.length>0&&r.length<=c.length){if(r===c)return"";let n=r.length-1,u=-1;for(s=c.length-1;s>=v;--s){const o=c.charCodeAt(s);if(d(o)){if(!h){v=s+1;break}}else u===-1&&(h=!1,u=s+1),n>=0&&(o===r.charCodeAt(n)?--n==-1&&(t=s):(n=-1,t=u))}return v===t?t=u:t===-1&&(t=c.length),c.slice(v,t)}for(s=c.length-1;s>=v;--s)if(d(c.charCodeAt(s))){if(!h){v=s+1;break}}else t===-1&&(h=!1,t=s+1);return t===-1?"":c.slice(v,t)},extname(c){g(c,"path");let r=0,v=-1,t=0,h=-1,s=!0,n=0;c.length>=2&&c.charCodeAt(1)===i&&D(c.charCodeAt(0))&&(r=t=2);for(let u=c.length-1;u>=r;--u){const o=c.charCodeAt(u);if(d(o)){if(!s){t=u+1;break}continue}h===-1&&(s=!1,h=u+1),o===_?v===-1?v=u:n!==1&&(n=1):v!==-1&&(n=-1)}return v===-1||h===-1||n===0||n===1&&v===h-1&&v===t+1?"":c.slice(v,h)},format:E.bind(null,"\\"),parse(c){g(c,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return r;const v=c.length;let t=0,h=c.charCodeAt(0);if(v===1)return d(h)?(r.root=r.dir=c,r):(r.base=r.name=c,r);if(d(h)){if(t=1,d(c.charCodeAt(1))){let b=2,f=b;for(;b<v&&!d(c.charCodeAt(b));)b++;if(b<v&&b!==f){for(f=b;b<v&&d(c.charCodeAt(b));)b++;if(b<v&&b!==f){for(f=b;b<v&&!d(c.charCodeAt(b));)b++;b===v?t=b:b!==f&&(t=b+1)}}}}else if(D(h)&&c.charCodeAt(1)===i){if(v<=2)return r.root=r.dir=c,r;if(t=2,d(c.charCodeAt(2))){if(v===3)return r.root=r.dir=c,r;t=3}}t>0&&(r.root=c.slice(0,t));let s=-1,n=t,u=-1,o=!0,l=c.length-1,m=0;for(;l>=t;--l){if(h=c.charCodeAt(l),d(h)){if(!o){n=l+1;break}continue}u===-1&&(o=!1,u=l+1),h===_?s===-1?s=l:m!==1&&(m=1):s!==-1&&(m=-1)}return u!==-1&&(s===-1||m===0||m===1&&s===u-1&&s===n+1?r.base=r.name=c.slice(n,u):(r.name=c.slice(n,s),r.base=c.slice(n,u),r.ext=c.slice(s,u))),n>0&&n!==t?r.dir=c.slice(0,n-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let r="",v=!1;for(let t=c.length-1;t>=-1&&!v;t--){const h=t>=0?c[t]:p.cwd();g(h,"path"),h.length!==0&&(r=`${h}/${r}`,v=h.charCodeAt(0)===S)}return r=T(r,!v,"/",w),v?`/${r}`:r.length>0?r:"."},normalize(c){if(g(c,"path"),c.length===0)return".";const r=c.charCodeAt(0)===S,v=c.charCodeAt(c.length-1)===S;return c=T(c,!r,"/",w),c.length===0?r?"/":v?"./":".":(v&&(c+="/"),r?`/${c}`:c)},isAbsolute(c){return g(c,"path"),c.length>0&&c.charCodeAt(0)===S},join(...c){if(c.length===0)return".";let r;for(let v=0;v<c.length;++v){const t=c[v];g(t,"path"),t.length>0&&(r===void 0?r=t:r+=`/${t}`)}return r===void 0?".":e.posix.normalize(r)},relative(c,r){if(g(c,"from"),g(r,"to"),c===r||(c=e.posix.resolve(c),r=e.posix.resolve(r),c===r))return"";const v=1,t=c.length,h=t-v,s=1,n=r.length-s,u=h<n?h:n;let o=-1,l=0;for(;l<u;l++){const b=c.charCodeAt(v+l);if(b!==r.charCodeAt(s+l))break;b===S&&(o=l)}if(l===u)if(n>u){if(r.charCodeAt(s+l)===S)return r.slice(s+l+1);if(l===0)return r.slice(s+l)}else h>u&&(c.charCodeAt(v+l)===S?o=l:l===0&&(o=0));let m="";for(l=v+o+1;l<=t;++l)(l===t||c.charCodeAt(l)===S)&&(m+=m.length===0?"..":"/..");return`${m}${r.slice(s+o)}`},toNamespacedPath(c){return c},dirname(c){if(g(c,"path"),c.length===0)return".";const r=c.charCodeAt(0)===S;let v=-1,t=!0;for(let h=c.length-1;h>=1;--h)if(c.charCodeAt(h)===S){if(!t){v=h;break}}else t=!1;return v===-1?r?"/":".":r&&v===1?"//":c.slice(0,v)},basename(c,r){r!==void 0&&g(r,"ext"),g(c,"path");let v=0,t=-1,h=!0,s;if(r!==void 0&&r.length>0&&r.length<=c.length){if(r===c)return"";let n=r.length-1,u=-1;for(s=c.length-1;s>=0;--s){const o=c.charCodeAt(s);if(o===S){if(!h){v=s+1;break}}else u===-1&&(h=!1,u=s+1),n>=0&&(o===r.charCodeAt(n)?--n==-1&&(t=s):(n=-1,t=u))}return v===t?t=u:t===-1&&(t=c.length),c.slice(v,t)}for(s=c.length-1;s>=0;--s)if(c.charCodeAt(s)===S){if(!h){v=s+1;break}}else t===-1&&(h=!1,t=s+1);return t===-1?"":c.slice(v,t)},extname(c){g(c,"path");let r=-1,v=0,t=-1,h=!0,s=0;for(let n=c.length-1;n>=0;--n){const u=c.charCodeAt(n);if(u===S){if(!h){v=n+1;break}continue}t===-1&&(h=!1,t=n+1),u===_?r===-1?r=n:s!==1&&(s=1):r!==-1&&(s=-1)}return r===-1||t===-1||s===0||s===1&&r===t-1&&r===v+1?"":c.slice(r,t)},format:E.bind(null,"/"),parse(c){g(c,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return r;const v=c.charCodeAt(0)===S;let t;v?(r.root="/",t=1):t=0;let h=-1,s=0,n=-1,u=!0,o=c.length-1,l=0;for(;o>=t;--o){const m=c.charCodeAt(o);if(m===S){if(!u){s=o+1;break}continue}n===-1&&(u=!1,n=o+1),m===_?h===-1?h=o:l!==1&&(l=1):h!==-1&&(l=-1)}if(n!==-1){const m=s===0&&v?1:s;h===-1||l===0||l===1&&h===n-1&&h===s+1?r.base=r.name=c.slice(m,n):(r.name=c.slice(m,h),r.base=c.slice(m,n),r.ext=c.slice(h,n))}return s>0?r.dir=c.slice(0,s-1):v&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(fe[96],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var p;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(p=e.Source||(e.Source={}));var F;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(F=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(y,...A){const _=A.reduce((i,k)=>(i[k]=!0,i),{}),S=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(i=>!_[i]).forEach(i=>{for(let k=0;k<S.length;k++)if(i.search(S[k])!==-1){delete y[i];break}})}e.sanitizeProcessEnvironment=C}),define(fe[142],me([0,1]),function(Y,e){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class F{constructor(_,S,I){this.level=_,this.key=S,this.value=I,this.forward=[]}}const C=void 0;class y{constructor(_,S=2**16){this.comparator=_,this[p]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(S)|0),this._header=new F(this._maxLevel,C,C)}get size(){return this._size}clear(){this._header=new F(this._maxLevel,C,C)}has(_){return Boolean(y._search(this,_,this.comparator))}get(_){return y._search(this,_,this.comparator)?.value}set(_,S){return y._insert(this,_,S,this.comparator)&&(this._size+=1),this}delete(_){const S=y._delete(this,_,this.comparator);return S&&(this._size-=1),S}forEach(_,S){let I=this._header.forward[0];for(;I;)_.call(S,I.value,I.key,this),I=I.forward[0]}[(p=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let _=this._header.forward[0];for(;_;)yield[_.key,_.value],_=_.forward[0]}*keys(){let _=this._header.forward[0];for(;_;)yield _.key,_=_.forward[0]}*values(){let _=this._header.forward[0];for(;_;)yield _.value,_=_.forward[0]}toString(){let _="[SkipList]:",S=this._header.forward[0];for(;S;)_+=`node(${S.key}, ${S.value}, lvl:${S.level})`,S=S.forward[0];return _}static _search(_,S,I){let i=_._header;for(let k=_._level-1;k>=0;k--)for(;i.forward[k]&&I(i.forward[k].key,S)<0;)i=i.forward[k];if(i=i.forward[0],i&&I(i.key,S)===0)return i}static _insert(_,S,I,i){let k=[],a=_._header;for(let g=_._level-1;g>=0;g--){for(;a.forward[g]&&i(a.forward[g].key,S)<0;)a=a.forward[g];k[g]=a}if(a=a.forward[0],a&&i(a.key,S)===0)return a.value=I,!1;{let g=y._randomLevel(_);if(g>_._level){for(let d=_._level;d<g;d++)k[d]=_._header;_._level=g}a=new F(g,S,I);for(let d=0;d<g;d++)a.forward[d]=k[d].forward[d],k[d].forward[d]=a;return!0}}static _randomLevel(_,S=.5){let I=1;for(;Math.random()<S&&I<_._maxLevel;)I+=1;return I}static _delete(_,S,I){let i=[],k=_._header;for(let a=_._level-1;a>=0;a--){for(;k.forward[a]&&I(k.forward[a].key,S)<0;)k=k.forward[a];i[a]=k}if(k=k.forward[0],!k||I(k.key,S)!==0)return!1;for(let a=0;a<_._level&&i[a].forward[a]===k;a++)i[a].forward[a]=k.forward[a];for(;_._level>0&&_._header.forward[_._level-1]===C;)_._level-=1;return!0}}e.SkipList=y}),define(fe[46],me([0,1,11]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const F=p.globals.performance&&typeof p.globals.performance.now=="function";class C{constructor(A){this._highResolution=F&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new C(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=C}),define(fe[3],me([0,1,17,76,6,95,46]),function(Y,e,p,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var _;(function(r){r.None=()=>C.Disposable.None;function v(N){return(j,U=null,B)=>{let z=!1,O;return O=N($=>{if(!z)return O?O.dispose():z=!0,j.call(U,$)},null,B),z&&O.dispose(),O}}r.once=v;function t(N,j){return l((U,B=null,z)=>N(O=>U.call(B,j(O)),null,z))}r.map=t;function h(N,j){return l((U,B=null,z)=>N(O=>{j(O),U.call(B,O)},null,z))}r.forEach=h;function s(N,j){return l((U,B=null,z)=>N(O=>j(O)&&U.call(B,O),null,z))}r.filter=s;function n(N){return N}r.signal=n;function u(...N){return(j,U=null,B)=>(0,C.combinedDisposable)(...N.map(z=>z(O=>j.call(U,O),null,B)))}r.any=u;function o(N,j,U){let B=U;return t(N,z=>(B=j(B,z),B))}r.reduce=o;function l(N){let j;const U=new a({onFirstListenerAdd(){j=N(U.fire,U)},onLastListenerRemove(){j.dispose()}});return U.event}function m(N,j,U=100,B=!1,z){let O,$,x,X=0;const Q=new a({leakWarningThreshold:z,onFirstListenerAdd(){O=N(de=>{X++,$=j($,de),B&&!x&&(Q.fire($),$=void 0),clearTimeout(x),x=setTimeout(()=>{const _e=$;$=void 0,x=void 0,(!B||X>1)&&Q.fire(_e),X=0},U)})},onLastListenerRemove(){O.dispose()}});return Q.event}r.debounce=m;function b(N,j=(U,B)=>U===B){let U=!0,B;return s(N,z=>{const O=U||!j(z,B);return U=!1,B=z,O})}r.latch=b;function f(N,j){return[r.filter(N,j),r.filter(N,U=>!j(U))]}r.split=f;function P(N,j=!1,U=[]){let B=U.slice(),z=N(x=>{B?B.push(x):$.fire(x)});const O=()=>{B&&B.forEach(x=>$.fire(x)),B=null},$=new a({onFirstListenerAdd(){z||(z=N(x=>$.fire(x)))},onFirstListenerDidAdd(){B&&(j?setTimeout(O):O())},onLastListenerRemove(){z&&z.dispose(),z=null}});return $.event}r.buffer=P;class L{constructor(j){this.event=j}map(j){return new L(t(this.event,j))}forEach(j){return new L(h(this.event,j))}filter(j){return new L(s(this.event,j))}reduce(j,U){return new L(o(this.event,j,U))}latch(){return new L(b(this.event))}debounce(j,U=100,B=!1,z){return new L(m(this.event,j,U,B,z))}on(j,U,B){return this.event(j,U,B)}once(j,U,B){return v(this.event)(j,U,B)}}function M(N){return new L(N)}r.chain=M;function R(N,j,U=B=>B){const B=(...x)=>$.fire(U(...x)),z=()=>N.on(j,B),O=()=>N.removeListener(j,B),$=new a({onFirstListenerAdd:z,onLastListenerRemove:O});return $.event}r.fromNodeEventEmitter=R;function W(N,j,U=B=>B){const B=(...x)=>$.fire(U(...x)),z=()=>N.addEventListener(j,B),O=()=>N.removeEventListener(j,B),$=new a({onFirstListenerAdd:z,onLastListenerRemove:O});return $.event}r.fromDOMEventEmitter=W;function V(N){return new Promise(j=>v(N)(j))}r.toPromise=V})(_=e.Event||(e.Event={}));class S{constructor(v){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${v}_${S._idPool++}`}start(v){this._stopWatch=new A.StopWatch(!0),this._listenerCount=v}stop(){if(this._stopWatch){const v=this._stopWatch.elapsed();this._elapsedOverall+=v,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${v.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let I=-1;function i(r){const v=I;return I=r,{dispose(){I=v}}}e.setGlobalLeakWarningThreshold=i;class k{constructor(v,t=Math.random().toString(18).slice(2,5)){this.customThreshold=v,this.name=t,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(v){let t=I;if(typeof this.customThreshold=="number"&&(t=this.customThreshold),t<=0||v<t)return;this._stacks||(this._stacks=new Map);const h=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(h)||0;if(this._stacks.set(h,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=t*.5;let n,u=0;for(const[o,l]of this._stacks)(!n||u<l)&&(n=o,u=l);console.warn(`[${this.name}] potential listener LEAK detected, having ${v} listeners already. MOST frequent listener (${u}):`),console.warn(n)}return()=>{const n=this._stacks.get(h)||0;this._stacks.set(h,n-1)}}}class a{constructor(v){this._disposed=!1,this._options=v,this._leakageMon=I>0?new k(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(v,t,h)=>{this._listeners||(this._listeners=new y.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(t?[v,t]:v);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,v,t);const u=this._leakageMon?.check(this._listeners.size),o=(0,C.toDisposable)(()=>{u&&u(),this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return h instanceof C.DisposableStore?h.add(o):Array.isArray(h)&&h.push(o),o}),this._event}fire(v){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new y.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,v]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,h]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,h):t[0].call(t[1],h)}catch(s){(0,p.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=a;class g extends a{async fireAsync(v,t,h){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,v]);for(;this._asyncDeliveryQueue.size>0&&!t.isCancellationRequested;){const[s,n]=this._asyncDeliveryQueue.shift(),u=[],o={...n,waitUntil:l=>{if(Object.isFrozen(u))throw new Error("waitUntil can NOT be called asynchronous");h&&(l=h(l,typeof s=="function"?s:s[0])),u.push(l)}};try{typeof s=="function"?s.call(void 0,o):s[0].call(s[1],o)}catch(l){(0,p.onUnexpectedError)(l);continue}Object.freeze(u),await Promise.allSettled(u).then(l=>{for(const m of l)m.status==="rejected"&&(0,p.onUnexpectedError)(m.reason)})}}}}e.AsyncEmitter=g;class d extends a{constructor(v){super(v);this._isPaused=0,this._eventQueue=new y.LinkedList,this._mergeFn=v?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const v=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(v))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(v){this._listeners&&(this._isPaused!==0?this._eventQueue.push(v):super.fire(v))}}e.PauseableEmitter=d;class w extends d{constructor(v){super(v);this._delay=v.delay??100}fire(v){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(v)}}e.DebounceEmitter=w;class D extends a{constructor(v){super(v);this._queuedEvents=[],this._mergeFn=v?.merge}fire(v){this._queuedEvents.push(v),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(t=>super.fire(t)),this._queuedEvents=[]})}}e.MicrotaskEmitter=D;class T{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new a({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(v){const t={event:v,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);const h=()=>{this.hasListeners&&this.unhook(t);const s=this.events.indexOf(t);this.events.splice(s,1)};return(0,C.toDisposable)((0,F.once)(h))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(v=>this.hook(v))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(v=>this.unhook(v))}hook(v){v.listener=v.event(t=>this.emitter.fire(t))}unhook(v){v.listener&&v.listener.dispose(),v.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=T;class E{constructor(){this.buffers=[]}wrapEvent(v){return(t,h,s)=>v(n=>{const u=this.buffers[this.buffers.length-1];u?u.push(()=>t.call(h,n)):t.call(h,n)},void 0,s)}bufferEvents(v){const t=[];this.buffers.push(t);const h=v();return this.buffers.pop(),t.forEach(s=>s()),h}}e.EventBufferer=E;class c{constructor(){this.listening=!1,this.inputEvent=_.None,this.inputEventListener=C.Disposable.None,this.emitter=new a({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(v){this.inputEvent=v,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=v(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=c}),define(fe[21],me([0,1,3]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const F=Object.freeze(function(_,S){const I=setTimeout(_.bind(S),0);return{dispose(){clearTimeout(I)}}});var C;(function(_){function S(I){return I===_.None||I===_.Cancelled||I instanceof y?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}_.isCancellationToken=S,_.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),_.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(C=e.CancellationToken||(e.CancellationToken={}));class y{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?F:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new y),this._token}cancel(){this._token?this._token instanceof y&&this._token.cancel():this._token=C.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof y&&this._token.dispose():this._token=C.None}}e.CancellationTokenSource=A}),define(fe[47],me([0,1,3]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class F{constructor(){this._icons=new Map,this._onDidRegister=new p.Emitter}add(k){const a=this._icons.get(k.id);a?k.description?a.description=k.description:console.error(`Duplicate registration of codicon ${k.id}`):(this._icons.set(k.id,k),this._onDidRegister.fire(k))}get(k){return this._icons.get(k)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const C=new F;e.iconRegistry=C;function y(i,k){return new _(i,k)}e.registerCodicon=y;function A(i){return i?i.replace(/\$\((.*?)\)/g,(k,a)=>` ${a} `).trim():""}e.getCodiconAriaLabel=A;class _{constructor(k,a,g){this.id=k,this.definition=a,this.description=g,C.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=_;function S(i,k){const a=["codicon","codicon-"+i];return k&&a.push("codicon-modifier-"+k),a}e.getClassNamesArray=S;var I;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const k=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function a(w){if(w instanceof _)return["codicon","codicon-"+w.id];const D=k.exec(w.id);if(!D)return a(_.error);let[,T,E]=D;const c=["codicon","codicon-"+T];return E&&c.push("codicon-modifier-"+E.substr(1)),c}i.asClassNameArray=a;function g(w){return a(w).join(" ")}i.asClassName=g;function d(w){return"."+a(w).join(".")}i.asCSSSelector=d})(I=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"})}(_=e.Codicon||(e.Codicon={}))}),define(fe[97],me([0,1,17,6]),function(Y,e,p,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function C(c){const r=c;return r?[r.on,r.pause,r.resume,r.destroy].every(v=>typeof v=="function"):!1}e.isReadableStream=C;function y(c){const r=c;return r?C(r.stream)&&Array.isArray(r.buffer)&&typeof r.ended=="boolean":!1}e.isReadableBufferedStream=y;function A(c,r){return new _(c,r)}e.newWriteableStream=A;class _{constructor(r,v){this.reducer=r,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(r){if(!this.state.destroyed){if(this.state.flowing)this.emitData(r);else if(this.buffer.data.push(r),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(v=>this.pendingWritePromises.push(v))}}error(r){this.state.destroyed||(this.state.flowing?this.emitError(r):this.buffer.error.push(r))}end(r){this.state.destroyed||(typeof r!="undefined"&&this.write(r),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(r){this.listeners.data.slice(0).forEach(v=>v(r))}emitError(r){this.listeners.error.length===0?(0,p.onUnexpectedError)(r):this.listeners.error.slice(0).forEach(v=>v(r))}emitEnd(){this.listeners.end.slice(0).forEach(r=>r())}on(r,v){if(!this.state.destroyed)switch(r){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(r,v){if(this.state.destroyed)return;let t;switch(r){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const h=t.indexOf(v);h>=0&&t.splice(h,1)}}flowData(){if(this.buffer.data.length>0){const r=this.reducer(this.buffer.data);this.emitData(r),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const r of this.buffer.error)this.emitError(r);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(c,r){const v=[];let t;for(;(t=c.read())!==null;)v.push(t);return r(v)}e.consumeReadable=S;function I(c,r,v){const t=[];let h;for(;(h=c.read())!==null&&t.length<v;)t.push(h);return h===null&&t.length>0?r(t):{read:()=>{if(t.length>0)return t.shift();if(typeof h!="undefined"){const s=h;return h=void 0,s}return c.read()}}}e.peekReadable=I;function i(c,r){return new Promise((v,t)=>{const h=[];k(c,{onData:s=>{r&&h.push(s)},onError:s=>{r?t(s):v(void 0)},onEnd:()=>{v(r?r(h):void 0)}})})}e.consumeStream=i;function k(c,r){c.on("error",v=>r.onError(v)),c.on("end",()=>r.onEnd()),c.on("data",v=>r.onData(v))}e.listenStream=k;function a(c,r){return new Promise((v,t)=>{const h=new F.DisposableStore,s=[],n=l=>{if(s.push(l),s.length>r)return h.dispose(),c.pause(),v({stream:c,buffer:s,ended:!1})},u=l=>t(l),o=()=>v({stream:c,buffer:s,ended:!0});h.add((0,F.toDisposable)(()=>c.removeListener("error",u))),c.on("error",u),h.add((0,F.toDisposable)(()=>c.removeListener("end",o))),c.on("end",o),h.add((0,F.toDisposable)(()=>c.removeListener("data",n))),c.on("data",n)})}e.peekStream=a;function g(c,r){const v=A(r);return v.end(c),v}e.toStream=g;function d(){const c=A(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=d;function w(c){let r=!1;return{read:()=>r?null:(r=!0,c)}}e.toReadable=w;function D(c,r,v){const t=A(v);return k(c,{onData:h=>t.write(r.data(h)),onError:h=>t.error(r.error?r.error(h):h),onEnd:()=>t.end()}),t}e.transform=D;function T(c,r,v){let t=!1;return{read:()=>{const h=r.read();return t?h:(t=!0,h!==null?v([c,h]):c)}}}e.prefixedReadable=T;function E(c,r,v){let t=!1;const h=A(v);return k(r,{onData:s=>t?h.write(s):(t=!0,h.write(v([c,s]))),onError:s=>h.error(s),onEnd:()=>{t||(t=!0,h.write(c)),h.end()}}),h}e.prefixedStream=E}),define(fe[22],me([0,1,97]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const F=typeof Buffer!="undefined";let C,y;class A{constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}static alloc(n){return F?new A(Buffer.allocUnsafe(n)):new A(new Uint8Array(n))}static wrap(n){return F&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new A(n)}static fromString(n,u){return!(u?.dontUseNodeBuffer||!1)&&F?new A(Buffer.from(n)):(C||(C=new TextEncoder),new A(C.encode(n)))}static concat(n,u){if(typeof u=="undefined"){u=0;for(let m=0,b=n.length;m<b;m++)u+=n[m].byteLength}const o=A.alloc(u);let l=0;for(let m=0,b=n.length;m<b;m++){const f=n[m];o.set(f,l),l+=f.byteLength}return o}toString(){return F?this.buffer.toString():(y||(y=new TextDecoder),y.decode(this.buffer))}slice(n,u){return new A(this.buffer.subarray(n,u))}set(n,u){n instanceof A?this.buffer.set(n.buffer,u):this.buffer.set(n,u)}readUInt32BE(n){return I(this.buffer,n)}writeUInt32BE(n,u){i(this.buffer,n,u)}readUInt32LE(n){return k(this.buffer,n)}writeUInt32LE(n,u){a(this.buffer,n,u)}readUInt8(n){return g(this.buffer,n)}writeUInt8(n,u){d(this.buffer,n,u)}}e.VSBuffer=A;function _(s,n){return s[n+0]<<0>>>0|s[n+1]<<8>>>0}e.readUInt16LE=_;function S(s,n,u){s[u+0]=n&255,n=n>>>8,s[u+1]=n&255}e.writeUInt16LE=S;function I(s,n){return s[n]*2**24+s[n+1]*2**16+s[n+2]*2**8+s[n+3]}e.readUInt32BE=I;function i(s,n,u){s[u+3]=n,n=n>>>8,s[u+2]=n,n=n>>>8,s[u+1]=n,n=n>>>8,s[u]=n}e.writeUInt32BE=i;function k(s,n){return s[n+0]<<0>>>0|s[n+1]<<8>>>0|s[n+2]<<16>>>0|s[n+3]<<24>>>0}e.readUInt32LE=k;function a(s,n,u){s[u+0]=n&255,n=n>>>8,s[u+1]=n&255,n=n>>>8,s[u+2]=n&255,n=n>>>8,s[u+3]=n&255}e.writeUInt32LE=a;function g(s,n){return s[n]}e.readUInt8=g;function d(s,n,u){s[u]=n}e.writeUInt8=d;function w(s){return p.consumeReadable(s,n=>A.concat(n))}e.readableToBuffer=w;function D(s){return p.toReadable(s)}e.bufferToReadable=D;function T(s){return p.consumeStream(s,n=>A.concat(n))}e.streamToBuffer=T;async function E(s){return s.ended?A.concat(s.buffer):A.concat([...s.buffer,await T(s.stream)])}e.bufferedStreamToBuffer=E;function c(s){return p.toStream(s,n=>A.concat(n))}e.bufferToStream=c;function r(s){return p.transform(s,{data:n=>typeof n=="string"?A.fromString(n):A.wrap(n)},n=>A.concat(n))}e.streamToBufferReadableStream=r;function v(s){return p.newWriteableStream(n=>A.concat(n),s)}e.newWriteableBufferStream=v;function t(s,n){return p.prefixedReadable(s,n,u=>A.concat(u))}e.prefixedBufferReadable=t;function h(s,n){return p.prefixedStream(s,n,u=>A.concat(u))}e.prefixedBufferStream=h}),define(fe[9],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function p(ce){return!ce||typeof ce!="string"?!0:ce.trim().length===0}e.isFalsyOrWhitespace=p;const F=/{(\d+)}/g;function C(ce,...Ie){return Ie.length===0?ce:ce.replace(F,function(Ue,Xe){const rt=parseInt(Xe,10);return isNaN(rt)||rt<0||rt>=Ie.length?Ue:Ie[rt]})}e.format=C;const y=/{([^}]+)}/g;function A(ce,Ie){return ce.replace(y,(Ue,Xe)=>Ie[Xe]??Ue)}e.format2=A;function _(ce){return ce.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.escape=_;function S(ce){return ce.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function I(ce,Ie){let Ue=0;const Xe=Ie.charCodeAt(0);for(let rt=ce.length-1;rt>=0;rt--)ce.charCodeAt(rt)===Xe&&Ue++;return Ue}e.count=I;function i(ce,Ie,Ue="\u2026"){return ce.length<=Ie?ce:`${ce.substr(0,Ie)}${Ue}`}e.truncate=i;function k(ce,Ie=" "){const Ue=a(ce,Ie);return g(Ue,Ie)}e.trim=k;function a(ce,Ie){if(!ce||!Ie)return ce;const Ue=Ie.length;if(Ue===0||ce.length===0)return ce;let Xe=0;for(;ce.indexOf(Ie,Xe)===Xe;)Xe=Xe+Ue;return ce.substring(Xe)}e.ltrim=a;function g(ce,Ie){if(!ce||!Ie)return ce;const Ue=Ie.length,Xe=ce.length;if(Ue===0||Xe===0)return ce;let rt=Xe,ht=-1;for(;ht=ce.lastIndexOf(Ie,rt-1),!(ht===-1||ht+Ue!==rt);){if(ht===0)return"";rt=ht}return ce.substring(0,rt)}e.rtrim=g;function d(ce){return ce.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function w(ce){return ce.replace(/\*/g,"")}e.stripWildcards=w;function D(ce,Ie,Ue={}){if(!ce)throw new Error("Cannot create regex from empty string");Ie||(ce=S(ce)),Ue.wholeWord&&(/\B/.test(ce.charAt(0))||(ce="\\b"+ce),/\B/.test(ce.charAt(ce.length-1))||(ce=ce+"\\b"));let Xe="";return Ue.global&&(Xe+="g"),Ue.matchCase||(Xe+="i"),Ue.multiline&&(Xe+="m"),Ue.unicode&&(Xe+="u"),new RegExp(ce,Xe)}e.createRegExp=D;function T(ce){return ce.source==="^"||ce.source==="^$"||ce.source==="$"||ce.source==="^\\s*$"?!1:!!(ce.exec("")&&ce.lastIndex===0)}e.regExpLeadsToEndlessLoop=T;function E(ce){return!!ce.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function c(ce){return(ce.global?"g":"")+(ce.ignoreCase?"i":"")+(ce.multiline?"m":"")+(ce.unicode?"u":"")}e.regExpFlags=c;function r(ce){return ce.split(/\r\n|\r|\n/)}e.splitLines=r;function v(ce){for(let Ie=0,Ue=ce.length;Ie<Ue;Ie++){const Xe=ce.charCodeAt(Ie);if(Xe!==32&&Xe!==9)return Ie}return-1}e.firstNonWhitespaceIndex=v;function t(ce,Ie=0,Ue=ce.length){for(let Xe=Ie;Xe<Ue;Xe++){const rt=ce.charCodeAt(Xe);if(rt!==32&&rt!==9)return ce.substring(Ie,Xe)}return ce.substring(Ie,Ue)}e.getLeadingWhitespace=t;function h(ce,Ie=ce.length-1){for(let Ue=Ie;Ue>=0;Ue--){const Xe=ce.charCodeAt(Ue);if(Xe!==32&&Xe!==9)return Ue}return-1}e.lastNonWhitespaceIndex=h;function s(ce,Ie){return ce<Ie?-1:ce>Ie?1:0}e.compare=s;function n(ce,Ie,Ue=0,Xe=ce.length,rt=0,ht=Ie.length){for(;Ue<Xe&&rt<ht;Ue++,rt++){let Re=ce.charCodeAt(Ue),Ce=Ie.charCodeAt(rt);if(Re<Ce)return-1;if(Re>Ce)return 1}const Ye=Xe-Ue,vt=ht-rt;return Ye<vt?-1:Ye>vt?1:0}e.compareSubstring=n;function u(ce,Ie){return o(ce,Ie,0,ce.length,0,Ie.length)}e.compareIgnoreCase=u;function o(ce,Ie,Ue=0,Xe=ce.length,rt=0,ht=Ie.length){for(;Ue<Xe&&rt<ht;Ue++,rt++){let Re=ce.charCodeAt(Ue),Ce=Ie.charCodeAt(rt);if(Re===Ce)continue;if(Re>=128||Ce>=128)return n(ce.toLowerCase(),Ie.toLowerCase(),Ue,Xe,rt,ht);l(Re)&&(Re-=32),l(Ce)&&(Ce-=32);const Pe=Re-Ce;if(Pe!==0)return Pe}const Ye=Xe-Ue,vt=ht-rt;return Ye<vt?-1:Ye>vt?1:0}e.compareSubstringIgnoreCase=o;function l(ce){return ce>=97&&ce<=122}e.isLowerAsciiLetter=l;function m(ce){return ce>=65&&ce<=90}e.isUpperAsciiLetter=m;function b(ce,Ie){return ce.length===Ie.length&&o(ce,Ie)===0}e.equalsIgnoreCase=b;function f(ce,Ie){const Ue=Ie.length;return Ie.length>ce.length?!1:o(ce,Ie,0,Ue)===0}e.startsWithIgnoreCase=f;function P(ce,Ie){let Ue,Xe=Math.min(ce.length,Ie.length);for(Ue=0;Ue<Xe;Ue++)if(ce.charCodeAt(Ue)!==Ie.charCodeAt(Ue))return Ue;return Xe}e.commonPrefixLength=P;function L(ce,Ie){let Ue,Xe=Math.min(ce.length,Ie.length);const rt=ce.length-1,ht=Ie.length-1;for(Ue=0;Ue<Xe;Ue++)if(ce.charCodeAt(rt-Ue)!==Ie.charCodeAt(ht-Ue))return Ue;return Xe}e.commonSuffixLength=L;function M(ce){return 55296<=ce&&ce<=56319}e.isHighSurrogate=M;function R(ce){return 56320<=ce&&ce<=57343}e.isLowSurrogate=R;function W(ce,Ie){return(ce-55296<<10)+(Ie-56320)+65536}e.computeCodePoint=W;function V(ce,Ie,Ue){const Xe=ce.charCodeAt(Ue);if(M(Xe)&&Ue+1<Ie){const rt=ce.charCodeAt(Ue+1);if(R(rt))return W(Xe,rt)}return Xe}e.getNextCodePoint=V;function N(ce,Ie){const Ue=ce.charCodeAt(Ie-1);if(R(Ue)&&Ie>1){const Xe=ce.charCodeAt(Ie-2);if(M(Xe))return W(Xe,Ue)}return Ue}function j(ce,Ie){const Ue=nt.getInstance(),Xe=Ie,rt=ce.length,ht=V(ce,rt,Ie);Ie+=ht>=65536?2:1;let Ye=Ue.getGraphemeBreakType(ht);for(;Ie<rt;){const vt=V(ce,rt,Ie),Re=Ue.getGraphemeBreakType(vt);if(st(Ye,Re))break;Ie+=vt>=65536?2:1,Ye=Re}return Ie-Xe}e.nextCharLength=j;function U(ce,Ie){const Ue=nt.getInstance(),Xe=Ie,rt=N(ce,Ie);Ie-=rt>=65536?2:1;let ht=Ue.getGraphemeBreakType(rt);for(;Ie>0;){const Ye=N(ce,Ie),vt=Ue.getGraphemeBreakType(Ye);if(st(vt,ht))break;Ie-=Ye>=65536?2:1,ht=vt}return Xe-Ie}e.prevCharLength=U;function B(ce,Ie){const Ue=nt.getInstance(),Xe=ce.length,rt=Ie,ht=V(ce,Xe,Ie),Ye=Ue.getGraphemeBreakType(ht);Ie+=ht>=65536?2:1;let vt=Ye;for(;Ie<Xe;){const Ce=V(ce,Xe,Ie),Pe=Ue.getGraphemeBreakType(Ce);if(st(vt,Pe))break;Ie+=Ce>=65536?2:1,vt=Pe}const Re=Ie;for(Ie=rt,vt=Ye;Ie>0;){const Ce=N(ce,Ie),Pe=Ue.getGraphemeBreakType(Ce);if(st(Pe,vt))break;Ie-=Ce>=65536?2:1,vt=Pe}return[Ie,Re]}function z(ce,Ie){return Ie>0&&R(ce.charCodeAt(Ie))?B(ce,Ie-1):B(ce,Ie)}e.getCharContainingOffset=z;const O=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function $(ce){return O.test(ce)}e.containsRTL=$;const x=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function X(ce){return x.test(ce)}e.containsEmoji=X;const Q=/^[\t\n\r\x20-\x7E]*$/;function de(ce){return Q.test(ce)}e.isBasicASCII=de,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function _e(ce){return e.UNUSUAL_LINE_TERMINATORS.test(ce)}e.containsUnusualLineTerminators=_e;function ye(ce){for(let Ie=0,Ue=ce.length;Ie<Ue;Ie++)if(ke(ce.charCodeAt(Ie)))return!0;return!1}e.containsFullWidthCharacter=ye;function ke(ce){return ce=+ce,ce>=11904&&ce<=55215||ce>=63744&&ce<=64255||ce>=65281&&ce<=65374}e.isFullWidthCharacter=ke;function xe(ce){return ce>=127462&&ce<=127487||ce===8986||ce===8987||ce===9200||ce===9203||ce>=9728&&ce<=10175||ce===11088||ce===11093||ce>=127744&&ce<=128591||ce>=128640&&ce<=128764||ce>=128992&&ce<=129003||ce>=129280&&ce<=129535||ce>=129648&&ce<=129750}e.isEmojiImprecise=xe;function We(ce,Ie){if(ce.length<Ie)return ce;const Ue=/\b/g;let Xe=0;for(;Ue.test(ce)&&!(ce.length-Ue.lastIndex<Ie);)Xe=Ue.lastIndex,Ue.lastIndex+=1;return ce.substring(Xe).replace(/^\s/,"")}e.lcut=We;const He=/\x1B\x5B[12]?K/g,q=/\x1b\[\d+m/g,ee=/\x1b\[0?m/g;function re(ce){return ce&&(ce=ce.replace(He,""),ce=ce.replace(q,""),ce=ce.replace(ee,"")),ce}e.removeAnsiEscapeCodes=re,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function le(ce){return!!(ce&&ce.length>0&&ce.charCodeAt(0)===65279)}e.startsWithUTF8BOM=le;function Z(ce){return le(ce)?ce.substr(1):ce}e.stripUTF8BOM=Z;function ae(ce,Ie){if(!ce||!Ie||ce.length<Ie.length)return!1;const Ue=Ie.length,Xe=ce.toLowerCase();let rt=0,ht=-1;for(;rt<Ue;){const Ye=Xe.indexOf(Ie[rt],ht+1);if(Ye<0)return!1;ht=Ye,rt++}return!0}e.fuzzyContains=ae;function pe(ce,Ie=!1){return ce?(Ie&&(ce=ce.replace(/\\./g,"")),ce.toLowerCase()!==ce):!1}e.containsUppercaseCharacter=pe;function Me(ce){return ce.charAt(0).toUpperCase()+ce.slice(1)}e.uppercaseFirstLetter=Me;function je(ce,Ie=1){if(Ie===0)return"";let Ue=-1;do Ue=ce.indexOf(`
`,Ue+1),Ie--;while(Ie>0&&Ue>=0);return Ue===-1?ce:(ce[Ue-1]==="\r"&&Ue--,ce.substr(0,Ue))}e.getNLines=je;function Ke(ce){const Ie=90-65+1;return ce=ce%(2*Ie),ce<Ie?String.fromCharCode(97+ce):String.fromCharCode(65+ce-Ie)}e.singleLetterHash=Ke;function Je(ce){return nt.getInstance().getGraphemeBreakType(ce)}e.getGraphemeBreakType=Je;function st(ce,Ie){return ce===0?Ie!==5&&Ie!==7:ce===2&&Ie===3?!1:ce===4||ce===2||ce===3||Ie===4||Ie===2||Ie===3?!0:!(ce===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(ce===11||ce===9)&&(Ie===9||Ie===10)||(ce===12||ce===10)&&Ie===10||Ie===5||Ie===13||Ie===7||ce===1||ce===13&&Ie===14||ce===6&&Ie===6)}e.breakBetweenGraphemeBreakType=st;var Te;(function(ce){ce[ce.Other=0]="Other",ce[ce.Prepend=1]="Prepend",ce[ce.CR=2]="CR",ce[ce.LF=3]="LF",ce[ce.Control=4]="Control",ce[ce.Extend=5]="Extend",ce[ce.Regional_Indicator=6]="Regional_Indicator",ce[ce.SpacingMark=7]="SpacingMark",ce[ce.L=8]="L",ce[ce.V=9]="V",ce[ce.T=10]="T",ce[ce.LV=11]="LV",ce[ce.LVT=12]="LVT",ce[ce.ZWJ=13]="ZWJ",ce[ce.Extended_Pictographic=14]="Extended_Pictographic"})(Te=e.GraphemeBreakType||(e.GraphemeBreakType={}));class nt{constructor(){this._data=J()}static getInstance(){return nt._INSTANCE||(nt._INSTANCE=new nt),nt._INSTANCE}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Ue=this._data,Xe=Ue.length/3;let rt=1;for(;rt<=Xe;)if(Ie<Ue[3*rt])rt=2*rt;else if(Ie>Ue[3*rt+1])rt=2*rt+1;else return Ue[3*rt+2];return 0}}nt._INSTANCE=null;function J(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function te(ce,Ie){if(ce===0)return 0;const Ue=ve(ce,Ie);if(Ue!==void 0)return Ue;const Xe=N(Ie,ce);return ce-=Qe(Xe),ce}e.getLeftDeleteOffset=te;function ve(ce,Ie){let Ue=N(Ie,ce);for(ce-=Qe(Ue);tt(Ue)||Ue===65039||Ue===8419;){if(ce===0)return;Ue=N(Ie,ce),ce-=Qe(Ue)}if(!!xe(Ue)){if(ce>=0){const Xe=N(Ie,ce);Xe===8205&&(ce-=Qe(Xe))}return ce}}function Qe(ce){return ce>=65536?2:1}function tt(ce){return 127995<=ce&&ce<=127999}var ct;(function(ce){ce[ce.zwj=8205]="zwj",ce[ce.emojiVariantSelector=65039]="emojiVariantSelector",ce[ce.enclosingKeyCap=8419]="enclosingKeyCap"})(ct||(ct={}))}),define(fe[48],me([0,1,9]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function F(T){return C(T,0)}e.hash=F;function C(T,E){switch(typeof T){case"object":return T===null?y(349,E):Array.isArray(T)?S(T,E):I(T,E);case"string":return _(T,E);case"boolean":return A(T,E);case"number":return y(T,E);case"undefined":return y(937,E);default:return y(617,E)}}e.doHash=C;function y(T,E){return(E<<5)-E+T|0}e.numberHash=y;function A(T,E){return y(T?433:863,E)}function _(T,E){E=y(149417,E);for(let c=0,r=T.length;c<r;c++)E=y(T.charCodeAt(c),E);return E}e.stringHash=_;function S(T,E){return E=y(104579,E),T.reduce((c,r)=>C(r,c),E)}function I(T,E){return E=y(181387,E),Object.keys(T).sort().reduce((c,r)=>(c=_(r,c),C(T[r],c)),E)}class i{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=C(E,this._value),this._value}}e.Hasher=i;var k;(function(T){T[T.BLOCK_SIZE=64]="BLOCK_SIZE",T[T.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function a(T,E,c=32){const r=c-E,v=~((1<<r)-1);return(T<<E|(v&T)>>>r)>>>0}function g(T,E=0,c=T.byteLength,r=0){for(let v=0;v<c;v++)T[E+v]=r}function d(T,E,c="0"){for(;T.length<E;)T=c+T;return T}function w(T,E=32){return T instanceof ArrayBuffer?Array.from(new Uint8Array(T)).map(c=>c.toString(16).padStart(2,"0")).join(""):d((T>>>0).toString(16),E/4)}e.toHexString=w;class D{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const c=E.length;if(c===0)return;const r=this._buff;let v=this._buffLen,t=this._leftoverHighSurrogate,h,s;for(t!==0?(h=t,s=-1,t=0):(h=E.charCodeAt(0),s=0);;){let n=h;if(p.isHighSurrogate(h))if(s+1<c){const u=E.charCodeAt(s+1);p.isLowSurrogate(u)?(s++,n=p.computeCodePoint(h,u)):n=65533}else{t=h;break}else p.isLowSurrogate(h)&&(n=65533);if(v=this._push(r,v,n),s++,s<c)h=E.charCodeAt(s);else break}this._buffLen=v,this._leftoverHighSurrogate=t}_push(E,c,r){return r<128?E[c++]=r:r<2048?(E[c++]=192|(r&1984)>>>6,E[c++]=128|(r&63)>>>0):r<65536?(E[c++]=224|(r&61440)>>>12,E[c++]=128|(r&4032)>>>6,E[c++]=128|(r&63)>>>0):(E[c++]=240|(r&1835008)>>>18,E[c++]=128|(r&258048)>>>12,E[c++]=128|(r&4032)>>>6,E[c++]=128|(r&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=D._bigBlock32,c=this._buffDV;for(let l=0;l<64;l+=4)E.setUint32(l,c.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)E.setUint32(l,a(E.getUint32(l-12,!1)^E.getUint32(l-32,!1)^E.getUint32(l-56,!1)^E.getUint32(l-64,!1),1),!1);let r=this._h0,v=this._h1,t=this._h2,h=this._h3,s=this._h4,n,u,o;for(let l=0;l<80;l++)l<20?(n=v&t|~v&h,u=1518500249):l<40?(n=v^t^h,u=1859775393):l<60?(n=v&t|v&h|t&h,u=2400959708):(n=v^t^h,u=3395469782),o=a(r,5)+n+s+u+E.getUint32(l*4,!1)&4294967295,s=h,h=t,t=a(v,30),v=r,r=o;this._h0=this._h0+r&4294967295,this._h1=this._h1+v&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+h&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=D,D._bigBlock32=new DataView(new ArrayBuffer(320))}),define(fe[49],me([0,1,9]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(F||(F={})),function(C){const y="error",A="warning",_="warn",S="info",I="ignore";function i(a){return a?p.equalsIgnoreCase(y,a)?C.Error:p.equalsIgnoreCase(A,a)||p.equalsIgnoreCase(_,a)?C.Warning:p.equalsIgnoreCase(S,a)?C.Info:C.Ignore:C.Ignore}C.fromValue=i;function k(a){switch(a){case C.Error:return y;case C.Warning:return A;case C.Info:return S;default:return I}}C.toString=k}(F||(F={})),e.default=F}),define(fe[12],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(m){return Array.isArray(m)}e.isArray=p;function F(m){return typeof m=="string"}e.isString=F;function C(m){return Array.isArray(m)&&m.every(b=>F(b))}e.isStringArray=C;function y(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}e.isObject=y;function A(m){return typeof m=="number"&&!isNaN(m)}e.isNumber=A;function _(m){return!!m&&typeof m[Symbol.iterator]=="function"}e.isIterable=_;function S(m){return m===!0||m===!1}e.isBoolean=S;function I(m){return typeof m=="undefined"}e.isUndefined=I;function i(m){return!k(m)}e.isDefined=i;function k(m){return I(m)||m===null}e.isUndefinedOrNull=k;function a(m,b){if(!m)throw new Error(b?`Unexpected type, expected '${b}'`:"Unexpected type")}e.assertType=a;function g(m){if(k(m))throw new Error("Assertion Failed: argument is undefined or null");return m}e.assertIsDefined=g;function d(...m){const b=[];for(let f=0;f<m.length;f++){const P=m[f];if(k(P))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);b.push(P)}return b}e.assertAllDefined=d;const w=Object.prototype.hasOwnProperty;function D(m){if(!y(m))return!1;for(let b in m)if(w.call(m,b))return!1;return!0}e.isEmptyObject=D;function T(m){return typeof m=="function"}e.isFunction=T;function E(...m){return m.length>0&&m.every(T)}e.areFunctions=E;function c(m,b){const f=Math.min(m.length,b.length);for(let P=0;P<f;P++)r(m[P],b[P])}e.validateConstraints=c;function r(m,b){if(F(b)){if(typeof m!==b)throw new Error(`argument does not match constraint: typeof ${b}`)}else if(T(b)){try{if(m instanceof b)return}catch{}if(!k(m)&&m.constructor===b||b.length===1&&b.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=r;function v(m){let b=[],f=Object.getPrototypeOf(m);for(;Object.prototype!==f;)b=b.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return b}e.getAllPropertyNames=v;function t(m){const b=[];for(const f of v(m))typeof m[f]=="function"&&b.push(f);return b}e.getAllMethodNames=t;function h(m,b){const f=L=>function(){const M=Array.prototype.slice.call(arguments,0);return b(L,M)};let P={};for(const L of m)P[L]=f(L);return P}e.createProxyObject=h;function s(m){return m===null?void 0:m}e.withNullAsUndefined=s;function n(m){return typeof m=="undefined"?null:m}e.withUndefinedAsNull=n;function u(m){return class{constructor(){return new Proxy({},{get(b,f){if(b[f])return b[f];throw new Error(`Not Implemented: ${m}->${String(f)}`)}})}}}e.NotImplementedProxy=u;function o(m,b="Unreachable"){throw new Error(b)}e.assertNever=o;function l(m){return!!m&&typeof m.then=="function"&&typeof m.catch=="function"}e.isPromise=l}),define(fe[29],me([0,1,8,11,9,12]),function(Y,e,p,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(s){return s===47||s===92}e.isPathSeparator=A;function _(s){return s.replace(/[\\/]/g,p.posix.sep)}e.toSlashes=_;function S(s){return s.indexOf("/")===-1&&(s=_(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=S;function I(s,n=p.posix.sep){if(!s)return"";const u=s.length,o=s.charCodeAt(0);if(A(o)){if(A(s.charCodeAt(1))&&!A(s.charCodeAt(2))){let m=3;const b=m;for(;m<u&&!A(s.charCodeAt(m));m++);if(b!==m&&!A(s.charCodeAt(m+1))){for(m+=1;m<u;m++)if(A(s.charCodeAt(m)))return s.slice(0,m+1).replace(/[\\/]/g,n)}}return n}else if(T(o)&&s.charCodeAt(1)===58)return A(s.charCodeAt(2))?s.slice(0,2)+n:s.slice(0,2);let l=s.indexOf("://");if(l!==-1){for(l+=3;l<u;l++)if(A(s.charCodeAt(l)))return s.slice(0,l+1)}return""}e.getRoot=I;function i(s){if(!F.isWindows||!s||s.length<5)return!1;let n=s.charCodeAt(0);if(n!==92||(n=s.charCodeAt(1),n!==92))return!1;let u=2;const o=u;for(;u<s.length&&(n=s.charCodeAt(u),n!==92);u++);return!(o===u||(n=s.charCodeAt(u+1),isNaN(n)||n===92))}e.isUNC=i;const k=/[\\/:\*\?"<>\|]/g,a=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(s,n=F.isWindows){const u=n?k:a;return!(!s||s.length===0||/^\s+$/.test(s)||(u.lastIndex=0,u.test(s))||n&&g.test(s)||s==="."||s===".."||n&&s[s.length-1]==="."||n&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=d;function w(s,n,u){const o=s===n;return!u||o?o:!s||!n?!1:(0,C.equalsIgnoreCase)(s,n)}e.isEqual=w;function D(s,n,u,o=p.sep){if(s===n)return!0;if(!s||!n||n.length>s.length)return!1;if(u){if(!(0,C.startsWithIgnoreCase)(s,n))return!1;if(n.length===s.length)return!0;let m=n.length;return n.charAt(n.length-1)===o&&m--,s.charAt(m)===o}return n.charAt(n.length-1)!==o&&(n+=o),s.indexOf(n)===0}e.isEqualOrParent=D;function T(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=T;function E(s,n){return F.isWindows&&s.endsWith(":")&&(s+=p.sep),(0,p.isAbsolute)(s)||(s=(0,p.join)(n,s)),s=(0,p.normalize)(s),F.isWindows?(s=(0,C.rtrim)(s,p.sep),s.endsWith(":")&&(s+=p.sep)):(s=(0,C.rtrim)(s,p.sep),s||(s=p.sep)),s}e.sanitizeFilePath=E;function c(s){const n=(0,p.normalize)(s);return F.isWindows?s.length>3?!1:r(n)&&(s.length===2||n.charCodeAt(2)===92):n===p.posix.sep}e.isRootOrDriveLetter=c;function r(s){return F.isWindows?T(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=r;function v(s){return r(s)?s[0]:void 0}e.getDriveLetter=v;function t(s,n,u){return n.length>s.length?-1:s===n?0:(u&&(s=s.toLowerCase(),n=n.toLowerCase()),s.indexOf(n))}e.indexOfPath=t;function h(s){const n=s.split(":");let u,o,l;if(n.forEach(m=>{const b=Number(m);(0,y.isNumber)(b)?o===void 0?o=b:l===void 0&&(l=b):u=u?[u,m].join(":"):m}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:o!==void 0?o:void 0,column:l!==void 0?l:o!==void 0?1:void 0}}e.parseLineAndColumnAware=h}),define(fe[25],me([0,1,12]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function F(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const D=Array.isArray(w)?[]:{};return Object.keys(w).forEach(T=>{w[T]&&typeof w[T]=="object"?D[T]=F(w[T]):D[T]=w[T]}),D}e.deepClone=F;function C(w){if(!w||typeof w!="object")return w;const D=[w];for(;D.length>0;){const T=D.shift();Object.freeze(T);for(const E in T)if(y.call(T,E)){const c=T[E];typeof c=="object"&&!Object.isFrozen(c)&&D.push(c)}}return w}e.deepFreeze=C;const y=Object.prototype.hasOwnProperty;function A(w,D){return _(w,D,new Set)}e.cloneAndChange=A;function _(w,D,T){if((0,p.isUndefinedOrNull)(w))return w;const E=D(w);if(typeof E!="undefined")return E;if((0,p.isArray)(w)){const c=[];for(const r of w)c.push(_(r,D,T));return c}if((0,p.isObject)(w)){if(T.has(w))throw new Error("Cannot clone recursive data-structure");T.add(w);const c={};for(let r in w)y.call(w,r)&&(c[r]=_(w[r],D,T));return T.delete(w),c}return w}function S(w,D,T=!0){return(0,p.isObject)(w)?((0,p.isObject)(D)&&Object.keys(D).forEach(E=>{E in w?T&&((0,p.isObject)(w[E])&&(0,p.isObject)(D[E])?S(w[E],D[E],T):w[E]=D[E]):w[E]=D[E]}),w):D}e.mixin=S;function I(w,D){if(w===D)return!0;if(w==null||D===null||D===void 0||typeof w!=typeof D||typeof w!="object"||Array.isArray(w)!==Array.isArray(D))return!1;let T,E;if(Array.isArray(w)){if(w.length!==D.length)return!1;for(T=0;T<w.length;T++)if(!I(w[T],D[T]))return!1}else{const c=[];for(E in w)c.push(E);c.sort();const r=[];for(E in D)r.push(E);if(r.sort(),!I(c,r))return!1;for(T=0;T<c.length;T++)if(!I(w[c[T]],D[c[T]]))return!1}return!0}e.equals=I;function i(w){const D=new Set;return JSON.stringify(w,(T,E)=>{if((0,p.isObject)(E)||Array.isArray(E)){if(D.has(E))return"[Circular]";D.add(E)}return E})}e.safeStringify=i;function k(w,D,T){const E=D(w);return typeof E=="undefined"?T:E}e.getOrDefault=k;function a(w,D){const T=Object.create(null);return!w||!D||Object.keys(D).forEach(c=>{const r=w[c],v=D[c];I(r,v)||(T[c]=v)}),T}e.distinct=a;function g(w,D){const T=D.toLowerCase(),E=Object.keys(w).find(c=>c.toLowerCase()===T);return E?w[E]:w[D]}e.getCaseInsensitive=g;function d(w,D){const T=Object.create(null);for(const E of Object.keys(w))D(E,w[E])&&(T[E]=w[E]);return T}e.filter=d}),define(fe[98],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var p;(function(y){y[y.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",y[y.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",y[y.MAX_UINT_8=255]="MAX_UINT_8",y[y.MAX_UINT_16=65535]="MAX_UINT_16",y[y.MAX_UINT_32=4294967295]="MAX_UINT_32",y[y.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(p=e.Constants||(e.Constants={}));function F(y){return y<0?0:y>255?255:y|0}e.toUint8=F;function C(y){return y<0?0:y>4294967295?4294967295:y|0}e.toUint32=C}),define(fe[2],me([0,1,8,11]),function(Y,e,p,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,y=/^\//,A=/^\/\//;function _(s,n){if(!s.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!C.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!y.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(s,n){return!s&&!n?"file":s}function I(s,n){switch(s){case"https":case"http":case"file":n?n[0]!==k&&(n=k+n):n=k;break}return n}const i="",k="/",a=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(n,u,o,l,m,b=!1){typeof n=="object"?(this.scheme=n.scheme||i,this.authority=n.authority||i,this.path=n.path||i,this.query=n.query||i,this.fragment=n.fragment||i):(this.scheme=S(n,b),this.authority=u||i,this.path=I(this.scheme,o||i),this.query=l||i,this.fragment=m||i,_(this,b))}static isUri(n){return n instanceof g?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return c(this,!1)}with(n){if(!n)return this;let{scheme:u,authority:o,path:l,query:m,fragment:b}=n;return u===void 0?u=this.scheme:u===null&&(u=i),o===void 0?o=this.authority:o===null&&(o=i),l===void 0?l=this.path:l===null&&(l=i),m===void 0?m=this.query:m===null&&(m=i),b===void 0?b=this.fragment:b===null&&(b=i),u===this.scheme&&o===this.authority&&l===this.path&&m===this.query&&b===this.fragment?this:new w(u,o,l,m,b)}static parse(n,u=!1){const o=a.exec(n);return o?new w(o[2]||i,h(o[4]||i),h(o[5]||i),h(o[7]||i),h(o[9]||i),u):new w(i,i,i,i,i)}static file(n){let u=i;if(F.isWindows&&(n=n.replace(/\\/g,k)),n[0]===k&&n[1]===k){const o=n.indexOf(k,2);o===-1?(u=n.substring(2),n=k):(u=n.substring(2,o),n=n.substring(o)||k)}return new w("file",u,n,i,i)}static from(n){const u=new w(n.scheme,n.authority,n.path,n.query,n.fragment);return _(u,!0),u}static joinPath(n,...u){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return F.isWindows&&n.scheme==="file"?o=g.file(p.win32.join(c(n,!0),...u)).path:o=p.posix.join(n.path,...u),n.with({path:o})}toString(n=!1){return r(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof g)return n;{const u=new w(n);return u._formatted=n.external,u._fsPath=n._sep===d?n.fsPath:null,u}}else return n}}e.URI=g;const d=F.isWindows?1:void 0;class w extends g{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(n=!1){return n?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=d),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const D={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function T(s,n){let u,o=-1;for(let l=0;l<s.length;l++){const m=s.charCodeAt(l);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||n&&m===47)o!==-1&&(u+=encodeURIComponent(s.substring(o,l)),o=-1),u!==void 0&&(u+=s.charAt(l));else{u===void 0&&(u=s.substr(0,l));const b=D[m];b!==void 0?(o!==-1&&(u+=encodeURIComponent(s.substring(o,l)),o=-1),u+=b):o===-1&&(o=l)}}return o!==-1&&(u+=encodeURIComponent(s.substring(o))),u!==void 0?u:s}function E(s){let n;for(let u=0;u<s.length;u++){const o=s.charCodeAt(u);o===35||o===63?(n===void 0&&(n=s.substr(0,u)),n+=D[o]):n!==void 0&&(n+=s[u])}return n!==void 0?n:s}function c(s,n){let u;return s.authority&&s.path.length>1&&s.scheme==="file"?u=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?n?u=s.path.substr(1):u=s.path[1].toLowerCase()+s.path.substr(2):u=s.path,F.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=c;function r(s,n){const u=n?E:T;let o="",{scheme:l,authority:m,path:b,query:f,fragment:P}=s;if(l&&(o+=l,o+=":"),(m||l==="file")&&(o+=k,o+=k),m){let L=m.indexOf("@");if(L!==-1){const M=m.substr(0,L);m=m.substr(L+1),L=M.indexOf(":"),L===-1?o+=u(M,!1):(o+=u(M.substr(0,L),!1),o+=":",o+=u(M.substr(L+1),!1)),o+="@"}m=m.toLowerCase(),L=m.indexOf(":"),L===-1?o+=u(m,!1):(o+=u(m.substr(0,L),!1),o+=m.substr(L))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const L=b.charCodeAt(1);L>=65&&L<=90&&(b=`/${String.fromCharCode(L+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const L=b.charCodeAt(0);L>=65&&L<=90&&(b=`${String.fromCharCode(L+32)}:${b.substr(2)}`)}o+=u(b,!0)}return f&&(o+="?",o+=u(f,!1)),P&&(o+="#",o+=n?P:T(P,!1)),o}function v(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+v(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function h(s){return s.match(t)?s.replace(t,n=>v(n)):s}});var ot=this&&this.__classPrivateFieldSet||function(Y,e,p,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,p):C?C.value=p:e.set(Y,p),p},Oe=this&&this.__classPrivateFieldGet||function(Y,e,p,F){if(p==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?F:p==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[24],me([0,1,18,9,2]),function(Y,e,p,F,C){"use strict";var y,A,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(s,n,u){let o=s.get(n);return o===void 0&&(o=u,s.set(n,o)),o}e.getOrSet=S;function I(s){const n=[];return s.forEach((u,o)=>{n.push(`${o} => ${u}`)}),`Map(${s.size}) {${n.join(", ")}}`}e.mapToString=I;function i(s){const n=[];return s.forEach(u=>{n.push(u)}),`Set(${s.size}) {${n.join(", ")}}`}e.setToString=i;class k{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const u=n.charCodeAt(0),o=this._value.charCodeAt(this._pos);return u-o}value(){return this._value[this._pos]}}e.StringIterator=k;class a{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,F.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=a;class g{constructor(n=!0,u=!0){this._splitOnBackslash=n,this._caseSensitive=u}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const u=this._value.charCodeAt(this._to);if(u===47||this._splitOnBackslash&&u===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,F.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=g;var d;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(d||(d={}));class w{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new g(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,F.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,F.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,F.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,F.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=w;class D{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var T;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(T||(T={}));class E{constructor(n){this._iter=n}static forUris(n=()=>!1){return new E(new w(n))}static forPaths(){return new E(new g)}static forStrings(){return new E(new k)}static forConfigKeys(){return new E(new a)}clear(){this._root=void 0}fill(n,u){if(u){const o=u.slice(0);(0,p.shuffle)(o);for(let l of o)this.set(l,n)}else{const o=n.slice(0);(0,p.shuffle)(o);for(let l of o)this.set(l[0],l[1])}}set(n,u){const o=this._iter.reset(n);let l;this._root||(this._root=new D,this._root.segment=o.value());const m=[];for(l=this._root;;){const f=o.cmp(l.segment);if(f>0)l.left||(l.left=new D,l.left.segment=o.value()),m.push([-1,l]),l=l.left;else if(f<0)l.right||(l.right=new D,l.right.segment=o.value()),m.push([1,l]),l=l.right;else if(o.hasNext())o.next(),l.mid||(l.mid=new D,l.mid.segment=o.value()),m.push([0,l]),l=l.mid;else break}const b=l.value;l.value=u,l.key=n;for(let f=m.length-1;f>=0;f--){const P=m[f][1];P.updateHeight();const L=P.balanceFactor();if(L<-1||L>1){const M=m[f][0],R=m[f+1][0];if(M===1&&R===1)m[f][1]=P.rotateLeft();else if(M===-1&&R===-1)m[f][1]=P.rotateRight();else if(M===1&&R===-1)P.right=m[f+1][1]=m[f+1][1].rotateRight(),m[f][1]=P.rotateLeft();else if(M===-1&&R===1)P.left=m[f+1][1]=m[f+1][1].rotateLeft(),m[f][1]=P.rotateRight();else throw new Error;if(f>0)switch(m[f-1][0]){case-1:m[f-1][1].left=m[f][1];break;case 1:m[f-1][1].right=m[f][1];break;case 0:m[f-1][1].mid=m[f][1];break}else this._root=m[0][1]}}return b}get(n){return this._getNode(n)?.value}_getNode(n){const u=this._iter.reset(n);let o=this._root;for(;o;){const l=u.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(u.hasNext())u.next(),o=o.mid;else break}return o}has(n){const u=this._getNode(n);return!(u?.value===void 0&&u?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,u){const o=this._iter.reset(n),l=[];let m=this._root;for(;m;){const b=o.cmp(m.segment);if(b>0)l.push([-1,m]),m=m.left;else if(b<0)l.push([1,m]),m=m.right;else if(o.hasNext())o.next(),l.push([0,m]),m=m.mid;else break}if(!!m){if(u?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const b=this._min(m.right),{key:f,value:P,segment:L}=b;this._delete(b.key,!1),m.key=f,m.value=P,m.segment=L}else{const b=m.left??m.right;if(l.length>0){const[f,P]=l[l.length-1];switch(f){case-1:P.left=b;break;case 0:P.mid=b;break;case 1:P.right=b;break}}else this._root=b}for(let b=l.length-1;b>=0;b--){const f=l[b][1];f.updateHeight();const P=f.balanceFactor();if(P>1?(f.right.balanceFactor()>=0||(f.right=l[b+1][1]=l[b+1][1].rotateRight()),l[b][1]=f.rotateLeft()):P<-1&&(f.left.balanceFactor()<=0||(f.left=l[b+1][1]=l[b+1][1].rotateLeft()),l[b][1]=f.rotateRight()),b>0)switch(l[b-1][0]){case-1:l[b-1][1].left=l[b][1];break;case 1:l[b-1][1].right=l[b][1];break;case 0:l[b-1][1].mid=l[b][1];break}else this._root=l[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const u=this._iter.reset(n);let o=this._root,l;for(;o;){const m=u.cmp(o.segment);if(m>0)o=o.left;else if(m<0)o=o.right;else if(u.hasNext())u.next(),l=o.value||l,o=o.mid;else break}return o&&o.value||l}findSuperstr(n){const u=this._iter.reset(n);let o=this._root;for(;o;){const l=u.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(u.hasNext())u.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(n){for(const[u,o]of this)n(o,u)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){!n||(n.left&&(yield*this._entries(n.left)),n.value&&(yield[n.key,n.value]),n.mid&&(yield*this._entries(n.mid)),n.right&&(yield*this._entries(n.right)))}_isBalanced(){const n=u=>{if(!u)return!0;const o=u.balanceFactor();return o<-1||o>1?!1:n(u.left)&&n(u.right)};return n(this._root)}}e.TernarySearchTree=E;class c{constructor(n,u){this[y]="ResourceMap",n instanceof c?(this.map=new Map(n.map),this.toKey=u??c.defaultToKey):(this.map=new Map,this.toKey=n??c.defaultToKey)}set(n,u){return this.map.set(this.toKey(n),u),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,u){typeof u!="undefined"&&(n=n.bind(u));for(let[o,l]of this.map)n(l,C.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield C.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[C.URI.parse(n[0]),n[1]]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[C.URI.parse(n[0]),n[1]]}}e.ResourceMap=c,c.defaultToKey=s=>s.toString();var r;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(r=e.Touch||(e.Touch={}));class v{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,u=0){const o=this._map.get(n);if(!!o)return u!==0&&this.touch(o,u),o.value}set(n,u,o=0){let l=this._map.get(n);if(l)l.value=u,o!==0&&this.touch(l,o);else{switch(l={key:n,value:u,next:void 0,previous:void 0},o){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(n,l),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const u=this._map.get(n);if(!!u)return this._map.delete(n),this.removeItem(u),this._size--,u.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,u){const o=this._state;let l=this._head;for(;l;){if(u?n.bind(u)(l.value,l.key,this):n(l.value,l.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const n=this,u=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==u)throw new Error("LinkedMap got modified during iteration.");if(o){const m={value:o.key,done:!1};return o=o.next,m}else return{value:void 0,done:!0}}};return l}values(){const n=this,u=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==u)throw new Error("LinkedMap got modified during iteration.");if(o){const m={value:o.value,done:!1};return o=o.next,m}else return{value:void 0,done:!0}}};return l}entries(){const n=this,u=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==u)throw new Error("LinkedMap got modified during iteration.");if(o){const m={value:[o.key,o.value],done:!1};return o=o.next,m}else return{value:void 0,done:!0}}};return l}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let u=this._head,o=this.size;for(;u&&o>n;)this._map.delete(u.key),u=u.next,o--;this._head=u,this._size=o,u&&(u.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const u=n.next,o=n.previous;if(!u||!o)throw new Error("Invalid list");u.previous=o,o.next=u}n.next=void 0,n.previous=void 0,this._state++}touch(n,u){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(n===this._head)return;const o=n.next,l=n.previous;n===this._tail?(l.next=void 0,this._tail=l):(o.previous=l,l.next=o),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(u===2){if(n===this._tail)return;const o=n.next,l=n.previous;n===this._head?(o.previous=void 0,this._head=o):(o.previous=l,l.next=o),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((u,o)=>{n.push([o,u])}),n}fromJSON(n){this.clear();for(const[u,o]of n)this.set(u,o)}}e.LinkedMap=v;class t extends v{constructor(n,u=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,u),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,u=2){return super.get(n,u)}peek(n){return super.get(n,0)}set(n,u){return super.set(n,u,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=t;class h{constructor(n){_.set(this,void 0),ot(this,_,n,"f")}get size(){return Oe(this,_,"f").size}forEach(n,u){Oe(this,_,"f").forEach(n,u)}get(n){return Oe(this,_,"f").get(n)}has(n){return Oe(this,_,"f").has(n)}entries(){return Oe(this,_,"f").entries()}keys(){return Oe(this,_,"f").keys()}values(){return Oe(this,_,"f").values()}[(_=new WeakMap,Symbol.iterator)](){return Oe(this,_,"f").entries()}}e.ReadonlyMapView=h}),define(fe[99],me([0,1,24,9]),function(Y,e,p,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function C(...Z){return function(ae,pe){for(let Me=0,je=Z.length;Me<je;Me++){const Ke=Z[Me](ae,pe);if(Ke)return Ke}return null}}e.or=C,e.matchesStrictPrefix=y.bind(void 0,!1),e.matchesPrefix=y.bind(void 0,!0);function y(Z,ae,pe){if(!pe||pe.length<ae.length)return null;let Me;return Z?Me=F.startsWithIgnoreCase(pe,ae):Me=pe.indexOf(ae)===0,Me?ae.length>0?[{start:0,end:ae.length}]:[]:null}function A(Z,ae){const pe=ae.toLowerCase().indexOf(Z.toLowerCase());return pe===-1?null:[{start:pe,end:pe+Z.length}]}e.matchesContiguousSubString=A;function _(Z,ae){return S(Z.toLowerCase(),ae.toLowerCase(),0,0)}e.matchesSubString=_;function S(Z,ae,pe,Me){if(pe===Z.length)return[];if(Me===ae.length)return null;if(Z[pe]===ae[Me]){let je=null;return(je=S(Z,ae,pe+1,Me+1))?T({start:Me,end:Me+1},je):null}return S(Z,ae,pe,Me+1)}function I(Z){return 97<=Z&&Z<=122}function i(Z){return 65<=Z&&Z<=90}e.isUpper=i;function k(Z){return 48<=Z&&Z<=57}function a(Z){return Z===32||Z===9||Z===10||Z===13}const g=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Z=>g.add(Z.charCodeAt(0)));function d(Z){return a(Z)||g.has(Z)}function w(Z,ae){return Z===ae||d(Z)&&d(ae)}function D(Z){return I(Z)||i(Z)||k(Z)}function T(Z,ae){return ae.length===0?ae=[Z]:Z.end===ae[0].start?ae[0].start=Z.start:ae.unshift(Z),ae}function E(Z,ae){for(let pe=ae;pe<Z.length;pe++){const Me=Z.charCodeAt(pe);if(i(Me)||k(Me)||pe>0&&!D(Z.charCodeAt(pe-1)))return pe}return Z.length}function c(Z,ae,pe,Me){if(pe===Z.length)return[];if(Me===ae.length)return null;if(Z[pe]!==ae[Me].toLowerCase())return null;{let je=null,Ke=Me+1;for(je=c(Z,ae,pe+1,Me+1);!je&&(Ke=E(ae,Ke))<ae.length;)je=c(Z,ae,pe+1,Ke),Ke++;return je===null?null:T({start:Me,end:Me+1},je)}}function r(Z){let ae=0,pe=0,Me=0,je=0,Ke=0;for(let J=0;J<Z.length;J++)Ke=Z.charCodeAt(J),i(Ke)&&ae++,I(Ke)&&pe++,D(Ke)&&Me++,k(Ke)&&je++;const Je=ae/Z.length,st=pe/Z.length,Te=Me/Z.length,nt=je/Z.length;return{upperPercent:Je,lowerPercent:st,alphaPercent:Te,numericPercent:nt}}function v(Z){const{upperPercent:ae,lowerPercent:pe}=Z;return pe===0&&ae>.6}function t(Z){const{upperPercent:ae,lowerPercent:pe,alphaPercent:Me,numericPercent:je}=Z;return pe>.2&&ae<.8&&Me>.6&&je<.2}function h(Z){let ae=0,pe=0,Me=0,je=0;for(let Ke=0;Ke<Z.length;Ke++)Me=Z.charCodeAt(Ke),i(Me)&&ae++,I(Me)&&pe++,a(Me)&&je++;return(ae===0||pe===0)&&je===0?Z.length<=30:ae<=5}function s(Z,ae){if(!ae||(ae=ae.trim(),ae.length===0)||!h(Z)||ae.length>60)return null;const pe=r(ae);if(!t(pe)){if(!v(pe))return null;ae=ae.toLowerCase()}let Me=null,je=0;for(Z=Z.toLowerCase();je<ae.length&&(Me=c(Z,ae,0,je))===null;)je=E(ae,je+1);return Me}e.matchesCamelCase=s;function n(Z,ae,pe=!1){if(!ae||ae.length===0)return null;let Me=null,je=0;for(Z=Z.toLowerCase(),ae=ae.toLowerCase();je<ae.length&&(Me=u(Z,ae,0,je,pe))===null;)je=o(ae,je+1);return Me}e.matchesWords=n;function u(Z,ae,pe,Me,je){if(pe===Z.length)return[];if(Me===ae.length)return null;if(w(Z.charCodeAt(pe),ae.charCodeAt(Me))){let Ke=null,Je=Me+1;if(Ke=u(Z,ae,pe+1,Me+1,je),!je)for(;!Ke&&(Je=o(ae,Je))<ae.length;)Ke=u(Z,ae,pe+1,Je,je),Je++;return Ke===null?null:T({start:Me,end:Me+1},Ke)}else return null}function o(Z,ae){for(let pe=ae;pe<Z.length;pe++)if(d(Z.charCodeAt(pe))||pe>0&&d(Z.charCodeAt(pe-1)))return pe;return Z.length}const l=C(e.matchesPrefix,s,A),m=C(e.matchesPrefix,s,_),b=new p.LRUCache(1e4);function f(Z,ae,pe=!1){if(typeof Z!="string"||typeof ae!="string")return null;let Me=b.get(Z);Me||(Me=new RegExp(F.convertSimple2RegExpPattern(Z),"i"),b.set(Z,Me));const je=Me.exec(ae);return je?[{start:je.index,end:je.index+je[0].length}]:pe?m(Z,ae):l(Z,ae)}e.matchesFuzzy=f;function P(Z,ae){const pe=xe(Z,Z.toLowerCase(),0,ae,ae.toLowerCase(),0,!0);return pe?M(pe):null}e.matchesFuzzy2=P;function L(Z,ae,pe,Me,je,Ke){const Je=Math.min(13,Z.length);for(;pe<Je;pe++){const st=xe(Z,ae,pe,Me,je,Ke,!1);if(st)return st}return[0,Ke]}e.anyScore=L;function M(Z){if(typeof Z=="undefined")return[];const ae=[],pe=Z[1];for(let Me=Z.length-1;Me>1;Me--){const je=Z[Me]+pe,Ke=ae[ae.length-1];Ke&&Ke.end===je?Ke.end=je+1:ae.push({start:je,end:je+1})}return ae}e.createMatches=M;const R=128;function W(){const Z=[],ae=[];for(let pe=0;pe<=R;pe++)ae[pe]=0;for(let pe=0;pe<=R;pe++)Z.push(ae.slice(0));return Z}function V(Z){const ae=[];for(let pe=0;pe<=Z;pe++)ae[pe]=0;return ae}const N=V(2*R),j=V(2*R),U=W(),B=W(),z=W(),O=!1;function $(Z,ae,pe,Me,je){function Ke(st,Te,nt=" "){for(;st.length<Te;)st=nt+st;return st}let Je=` |   |${Me.split("").map(st=>Ke(st,3)).join("|")}
`;for(let st=0;st<=pe;st++)st===0?Je+=" |":Je+=`${ae[st-1]}|`,Je+=Z[st].slice(0,je+1).map(Te=>Ke(Te.toString(),3)).join("|")+`
`;return Je}function x(Z,ae,pe,Me){Z=Z.substr(ae),pe=pe.substr(Me),console.log($(B,Z,Z.length,pe,pe.length)),console.log($(z,Z,Z.length,pe,pe.length)),console.log($(U,Z,Z.length,pe,pe.length))}function X(Z,ae){if(ae<0||ae>=Z.length)return!1;const pe=Z.codePointAt(ae);switch(pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!F.isEmojiImprecise(pe)}}function Q(Z,ae){if(ae<0||ae>=Z.length)return!1;switch(Z.charCodeAt(ae)){case 32:case 9:return!0;default:return!1}}function de(Z,ae,pe){return ae[Z]!==pe[Z]}function _e(Z,ae,pe,Me,je,Ke,Je=!1){for(;ae<pe&&je<Ke;)Z[ae]===Me[je]&&(Je&&(N[ae]=je),ae+=1),je+=1;return ae===pe}e.isPatternInWord=_e;var ye;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var ke;(function(Z){Z.Default=[-100,0];function ae(pe){return!pe||pe.length===2&&pe[0]===-100&&pe[1]===0}Z.isDefault=ae})(ke=e.FuzzyScore||(e.FuzzyScore={}));function xe(Z,ae,pe,Me,je,Ke,Je){const st=Z.length>R?R:Z.length,Te=Me.length>R?R:Me.length;if(pe>=st||Ke>=Te||st-pe>Te-Ke||!_e(ae,pe,st,je,Ke,Te,!0))return;We(st,Te,pe,Ke,ae,je);let nt=1,J=1,te=pe,ve=Ke;const Qe=[!1];for(nt=1,te=pe;te<st;nt++,te++){const Ue=N[te],Xe=j[te],rt=te+1<st?j[te+1]:Te;for(J=Ue-Ke+1,ve=Ue;ve<rt;J++,ve++){let ht=Number.MIN_SAFE_INTEGER,Ye=!1;ve<=Xe&&(ht=He(Z,ae,te,pe,Me,je,ve,Te,Ke,U[nt-1][J-1]===0,Qe));let vt=0;ht!==Number.MAX_SAFE_INTEGER&&(Ye=!0,vt=ht+B[nt-1][J-1]);const Re=ve>Ue,Ce=Re?B[nt][J-1]+(U[nt][J-1]>0?-5:0):0,Pe=ve>Ue+1&&U[nt][J-1]>0,se=Pe?B[nt][J-2]+(U[nt][J-2]>0?-5:0):0;if(Pe&&(!Re||se>=Ce)&&(!Ye||se>=vt))B[nt][J]=se,z[nt][J]=3,U[nt][J]=0;else if(Re&&(!Ye||Ce>=vt))B[nt][J]=Ce,z[nt][J]=2,U[nt][J]=0;else if(Ye)B[nt][J]=vt,z[nt][J]=1,U[nt][J]=U[nt-1][J-1]+1;else throw new Error("not possible")}}if(O&&x(Z,pe,Me,Ke),!Qe[0]&&!Je)return;nt--,J--;const tt=[B[nt][J],Ke];let ct=0,ce=0;for(;nt>=1;){let Ue=J;do{const Xe=z[nt][Ue];if(Xe===3)Ue=Ue-2;else if(Xe===2)Ue=Ue-1;else break}while(Ue>=1);ct>1&&ae[pe+nt-1]===je[Ke+J-1]&&!de(Ue+Ke-1,Me,je)&&ct+1>U[nt][Ue]&&(Ue=J),Ue===J?ct++:ct=1,ce||(ce=Ue),nt--,J=Ue-1,tt.push(J)}Te===st&&(tt[0]+=2);const Ie=ce-st;return tt[0]-=Ie,tt}e.fuzzyScore=xe;function We(Z,ae,pe,Me,je,Ke){let Je=Z-1,st=ae-1;for(;Je>=pe&&st>=Me;)je[Je]===Ke[st]&&(j[Je]=st,Je--),st--}function He(Z,ae,pe,Me,je,Ke,Je,st,Te,nt,J){if(ae[pe]!==Ke[Je])return Number.MIN_SAFE_INTEGER;let te=1,ve=!1;return Je===pe-Me?te=Z[pe]===je[Je]?7:5:de(Je,je,Ke)&&(Je===0||!de(Je-1,je,Ke))?(te=Z[pe]===je[Je]?7:5,ve=!0):X(Ke,Je)&&(Je===0||!X(Ke,Je-1))?te=5:(X(Ke,Je-1)||Q(Ke,Je-1))&&(te=5,ve=!0),te>1&&pe===Me&&(J[0]=!0),ve||(ve=de(Je,je,Ke)||X(Ke,Je-1)||Q(Ke,Je-1)),pe===Me?Je>Te&&(te-=ve?3:5):nt?te+=ve?2:0:te+=ve?0:1,Je+1===st&&(te-=ve?3:5),te}function q(Z,ae,pe,Me,je,Ke,Je){return re(Z,ae,pe,Me,je,Ke,!0,Je)}e.fuzzyScoreGracefulAggressive=q;function ee(Z,ae,pe,Me,je,Ke,Je){return re(Z,ae,pe,Me,je,Ke,!1,Je)}e.fuzzyScoreGraceful=ee;function re(Z,ae,pe,Me,je,Ke,Je,st){let Te=xe(Z,ae,pe,Me,je,Ke,st);if(Te&&!Je)return Te;if(Z.length>=3){const nt=Math.min(7,Z.length-1);for(let J=pe+1;J<nt;J++){const te=le(Z,J);if(te){const ve=xe(te,te.toLowerCase(),pe,Me,je,Ke,st);ve&&(ve[0]-=3,(!Te||ve[0]>Te[0])&&(Te=ve))}}}return Te}function le(Z,ae){if(ae+1>=Z.length)return;const pe=Z[ae],Me=Z[ae+1];if(pe!==Me)return Z.slice(0,ae)+Me+pe+Z.slice(ae+2)}}),define(fe[143],me([0,1,47,99,9]),function(Y,e,p,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const y=new RegExp(`\\$\\(${p.CSSIcon.iconNameExpression}(?:${p.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${y.source}`,"g");function _(w){return w.replace(A,(D,T)=>T?D:`\\${D}`)}e.escapeIcons=_;const S=new RegExp(`\\\\${y.source}`,"g");function I(w){return w.replace(S,D=>`\\${D}`)}e.markdownEscapeEscapedIcons=I;const i=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function k(w){return w.indexOf(e.iconStartMarker)===-1?w:w.replace(i,(D,T,E,c)=>E?D:T||c||"")}e.stripIcons=k;function a(w){const D=w.indexOf(e.iconStartMarker);return D===-1?{text:w}:g(w,D)}e.parseLabelWithIcons=a;function g(w,D){const T=[];let E="";function c(o){if(o){E+=o;for(const l of o)T.push(t)}}let r=-1,v="",t=0,h,s,n=D;const u=w.length;for(c(w.substr(0,D));n<u;)h=w[n],s=w[n+1],h===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(r=n,c(v),v=e.iconStartMarker,n++):h===")"&&r!==-1?(t+=n-r+1,r=-1,v=""):r!==-1?/^[a-z0-9\-]$/i.test(h)?v+=h:(c(v),r=-1,v=""):c(h),n++;return c(v),{text:E,iconOffsets:T}}function d(w,D,T=!1){const{text:E,iconOffsets:c}=D;if(!c||c.length===0)return(0,F.matchesFuzzy)(w,E,T);const r=(0,C.ltrim)(E," "),v=E.length-r.length,t=(0,F.matchesFuzzy)(w,r,T);if(t)for(const h of t){const s=c[h.start+v]+v;h.start+=s,h.end+=s}return t}e.matchesFuzzyIconAware=d}),define(fe[100],me([0,1,17,143]),function(Y,e,p,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var C;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(C=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(g="",d=!1){if(this.value=g,typeof this.value!="string")throw(0,p.illegalArgument)("value");typeof d=="boolean"?(this.isTrusted=d,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=d.isTrusted??void 0,this.supportThemeIcons=d.supportThemeIcons??!1,this.supportHtml=d.supportHtml??!1)}appendText(g,d=0){return this.value+=I(this.supportThemeIcons?(0,F.escapeIcons)(g):g).replace(/([ \t]+)/g,(w,D)=>"&nbsp;".repeat(D.length)).replace(/\>/gm,"\\>").replace(/\n/g,d===1?`\\
`:`

`),this}appendMarkdown(g){return this.value+=g,this}appendCodeblock(g,d){return this.value+="\n```",this.value+=g,this.value+=`
`,this.value+=d,this.value+="\n```\n",this}}e.MarkdownString=y;function A(a){return _(a)?!a.value:Array.isArray(a)?a.every(A):!0}e.isEmptyMarkdownString=A;function _(a){return a instanceof y?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.isMarkdownString=_;function S(a,g){return a===g?!0:!a||!g?!1:a.value===g.value&&a.isTrusted===g.isTrusted&&a.supportThemeIcons===g.supportThemeIcons}e.markdownStringEqual=S;function I(a){return a.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=I;function i(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=i;function k(a){const g=[],d=a.split("|").map(D=>D.trim());a=d[0];const w=d[1];if(w){const D=/height=(\d+)/.exec(w),T=/width=(\d+)/.exec(w),E=D?D[1]:"",c=T?T[1]:"",r=isFinite(parseInt(c)),v=isFinite(parseInt(E));r&&g.push(`width="${c}"`),v&&g.push(`height="${E}"`)}return{href:a,dimensions:g}}e.parseHrefAndDimensions=k}),define(fe[62],me([0,1,22,9,2]),function(Y,e,p,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function y(i){return JSON.stringify(i,S)}e.stringify=y;function A(i){let k=JSON.parse(i);return k=I(k),k}e.parse=A;var _;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(_=e.MarshalledId||(e.MarshalledId={}));function S(i,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:(0,F.regExpFlags)(k)}:k}function I(i,k=0){if(!i||k>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return C.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof p.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let a=0;a<i.length;++a)i[a]=I(i[a],k+1);else for(const a in i)Object.hasOwnProperty.call(i,a)&&(i[a]=I(i[a],k+1))}return i}e.revive=I}),define(fe[10],me([0,1,11,2]),function(Y,e,p,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var C;(function(_){_.inMemory="inmemory",_.vscode="vscode",_.internal="private",_.walkThrough="walkThrough",_.walkThroughSnippet="walkThroughSnippet",_.http="http",_.https="https",_.file="file",_.mailto="mailto",_.untitled="untitled",_.data="data",_.command="command",_.vscodeRemote="vscode-remote",_.vscodeRemoteResource="vscode-remote-resource",_.userData="vscode-userdata",_.vscodeCustomEditor="vscode-custom-editor",_.vscodeNotebook="vscode-notebook",_.vscodeNotebookCell="vscode-notebook-cell",_.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",_.vscodeNotebookCellOutput="vscode-notebook-cell-output",_.vscodeInteractive="vscode-interactive",_.vscodeInteractiveInput="vscode-interactive-input",_.vscodeSettings="vscode-settings",_.vscodeWorkspaceTrust="vscode-workspace-trust",_.vscodeTerminal="vscode-terminal",_.webviewPanel="webview-panel",_.vscodeWebview="vscode-webview",_.extension="extension",_.vscodeFileResource="vscode-file",_.tmp="tmp"})(C=e.Schemas||(e.Schemas={}));class y{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,I,i){this._hosts[S]=I,this._ports[S]=i}setConnectionToken(S,I){this._connectionTokens[S]=I}rewrite(S){if(this._delegate)return this._delegate(S);const I=S.authority;let i=this._hosts[I];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const k=this._ports[I],a=this._connectionTokens[I];let g=`path=${encodeURIComponent(S.path)}`;return typeof a=="string"&&(g+=`&tkn=${encodeURIComponent(a)}`),F.URI.from({scheme:p.isWeb?this._preferredWebSchema:C.vscodeRemoteResource,authority:`${i}:${k}`,path:"/vscode-remote-resource",query:g})}}e.RemoteAuthorities=new y;class A{asBrowserUri(S,I){const i=this.toUri(S,I);return i.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===C.file&&(p.isNative||typeof p.globals.importScripts=="function"&&p.globals.origin===`${C.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?i.with({scheme:C.vscodeFileResource,authority:i.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(S,I){const i=this.toUri(S,I);return i.scheme===C.vscodeFileResource?i.with({scheme:C.file,authority:i.authority!==A.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(S,I){return F.URI.isUri(S)?S:F.URI.parse(I.toUrl(S))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(fe[79],me([0,1,24]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const F=new p.LRUCache(1e4);function C(I){return S(I,"NFC",F)}e.normalizeNFC=C;const y=new p.LRUCache(1e4);function A(I){return S(I,"NFD",y)}e.normalizeNFD=A;const _=/[^\u0000-\u0080]/;function S(I,i,k){if(!I)return I;const a=k.get(I);if(a)return a;let g;return _.test(I)?g=I.normalize(i):g=I,k.set(I,g),g}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(i){return A(i).replace(I,"")}}()}),define(fe[23],me([0,1,29,10,8,11,9,2]),function(Y,e,p,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(g){return(0,_.uriToFsPath)(g,!0)}e.originalFSPath=S;class I{constructor(d){this._ignorePathCasing=d}compare(d,w,D=!1){return d===w?0:(0,A.compare)(this.getComparisonKey(d,D),this.getComparisonKey(w,D))}isEqual(d,w,D=!1){return d===w?!0:!d||!w?!1:this.getComparisonKey(d,D)===this.getComparisonKey(w,D)}getComparisonKey(d,w=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,w,D=!1){if(d.scheme===w.scheme){if(d.scheme===F.Schemas.file)return p.isEqualOrParent(S(d),S(w),this._ignorePathCasing(d))&&d.query===w.query&&(D||d.fragment===w.fragment);if((0,e.isEqualAuthority)(d.authority,w.authority))return p.isEqualOrParent(d.path,w.path,this._ignorePathCasing(d),"/")&&d.query===w.query&&(D||d.fragment===w.fragment)}return!1}joinPath(d,...w){return _.URI.joinPath(d,...w)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return C.posix.basename(d.path)}extname(d){return C.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let w;return d.scheme===F.Schemas.file?w=_.URI.file(C.dirname(S(d))).path:(w=C.posix.dirname(d.path),d.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),w="/")),d.with({path:w})}normalizePath(d){if(!d.path.length)return d;let w;return d.scheme===F.Schemas.file?w=_.URI.file(C.normalize(S(d))).path:w=C.posix.normalize(d.path),d.with({path:w})}relativePath(d,w){if(d.scheme!==w.scheme||!(0,e.isEqualAuthority)(d.authority,w.authority))return;if(d.scheme===F.Schemas.file){const E=C.relative(S(d),S(w));return y.isWindows?p.toSlashes(E):E}let D=d.path||"/",T=w.path||"/";if(this._ignorePathCasing(d)){let E=0;for(const c=Math.min(D.length,T.length);E<c&&!(D.charCodeAt(E)!==T.charCodeAt(E)&&D.charAt(E).toLowerCase()!==T.charAt(E).toLowerCase());E++);D=T.substr(0,E)+D.substr(E)}return C.posix.relative(D,T)}resolvePath(d,w){if(d.scheme===F.Schemas.file){const D=_.URI.file(C.resolve(S(d),w));return d.with({authority:D.authority,path:D.path})}return w=p.toPosixPath(w),d.with({path:C.posix.resolve(d.path,w)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,w){return d===w||(0,A.equalsIgnoreCase)(d,w)}hasTrailingPathSeparator(d,w=C.sep){if(d.scheme===F.Schemas.file){const D=S(d);return D.length>p.getRoot(D).length&&D[D.length-1]===w}else{const D=d.path;return D.length>1&&D.charCodeAt(D.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,w=C.sep){return(0,e.hasTrailingPathSeparator)(d,w)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,w=C.sep){let D=!1;if(d.scheme===F.Schemas.file){const T=S(d);D=T!==void 0&&T.length===p.getRoot(T).length&&T[T.length-1]===w}else{w="/";const T=d.path;D=T.length===1&&T.charCodeAt(T.length-1)===47}return!D&&!(0,e.hasTrailingPathSeparator)(d,w)?d.with({path:d.path+"/"}):d}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(g=>g.scheme===F.Schemas.file?!y.isLinux:!0),e.extUriIgnorePathCase=new I(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(g,d){const w=[];for(let D=0;D<g.length;D++){const T=d(g[D]);g.some((E,c)=>c===D?!1:(0,e.isEqualOrParent)(T,d(E)))||w.push(g[D])}return w}e.distinctParents=i;var k;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function d(w){const D=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(c=>{const[r,v]=c.split(":");r&&v&&D.set(r,v)});const E=w.path.substring(0,w.path.indexOf(";"));return E&&D.set(g.META_DATA_MIME,E),D}g.parseMetaData=d})(k=e.DataUri||(e.DataUri={}));function a(g,d,w){if(d){let D=g.path;return D&&D[0]!==C.posix.sep&&(D=C.posix.sep+D),g.with({scheme:w,authority:d,path:D})}return g.with({scheme:w})}e.toLocalResource=a}),define(fe[15],me([0,1,21,17,3,6,23]),function(Y,e,p,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function _(U){return!!U&&typeof U.then=="function"}e.isThenable=_;function S(U){const B=new p.CancellationTokenSource,z=U(B.token),O=new Promise(($,x)=>{const X=B.token.onCancellationRequested(()=>{X.dispose(),B.dispose(),x((0,F.canceled)())});Promise.resolve(z).then(Q=>{X.dispose(),B.dispose(),$(Q)},Q=>{X.dispose(),B.dispose(),x(Q)})});return new class{cancel(){B.cancel()}then($,x){return O.then($,x)}catch($){return this.then(void 0,$)}finally($){return O.finally($)}}}e.createCancelablePromise=S;function I(U,B,z){return Promise.race([U,new Promise(O=>B.onCancellationRequested(()=>O(z)))])}e.raceCancellation=I;async function i(U){let B=-1;const z=U.map(($,x)=>$.then(X=>(B=x,X))),O=await Promise.race(z);return U.forEach(($,x)=>{x!==B&&$.cancel()}),O}e.raceCancellablePromises=i;function k(U,B,z){let O;const $=setTimeout(()=>{O?.(void 0),z?.()},B);return Promise.race([U.finally(()=>clearTimeout($)),new Promise(x=>O=x)])}e.raceTimeout=k;function a(U){return new Promise((B,z)=>{const O=U();_(O)?O.then(B,z):B(O)})}e.asPromise=a;class g{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(B){if(this.activePromise){if(this.queuedPromiseFactory=B,!this.queuedPromise){const z=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(z,z).then(O)})}return new Promise((z,O)=>{this.queuedPromise.then(z,O)})}return this.activePromise=B(),new Promise((z,O)=>{this.activePromise.then($=>{this.activePromise=null,z($)},$=>{this.activePromise=null,O($)})})}}e.Throttler=g;class d{constructor(){this.current=Promise.resolve(null)}queue(B){return this.current=this.current.then(()=>B(),()=>B())}}e.Sequencer=d;class w{constructor(){this.promiseMap=new Map}queue(B,z){const $=(this.promiseMap.get(B)??Promise.resolve()).catch(()=>{}).then(z).finally(()=>{this.promiseMap.get(B)===$&&this.promiseMap.delete(B)});return this.promiseMap.set(B,$),$}}e.SequencerByKey=w;class D{constructor(B){this.defaultDelay=B,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(B,z=this.defaultDelay){return this.task=B,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,$)=>{this.doResolve=O,this.doReject=$}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},z),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,F.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=D;class T{constructor(B){this.delayer=new D(B),this.throttler=new g}trigger(B,z){return this.delayer.trigger(()=>this.throttler.queue(B),z)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=T;class E{constructor(){this._isOpen=!1,this._promise=new Promise((B,z)=>{this._completePromise=B})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=E;class c extends E{constructor(B){super();this._timeout=setTimeout(()=>this.open(),B)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function r(U,B){return B?new Promise((z,O)=>{const $=setTimeout(()=>{x.dispose(),z()},U),x=B.onCancellationRequested(()=>{clearTimeout($),x.dispose(),O((0,F.canceled)())})}):S(z=>r(U,z))}e.timeout=r;function v(U,B=0){const z=setTimeout(U,B);return(0,y.toDisposable)(()=>clearTimeout(z))}e.disposableTimeout=v;function t(U){const B=[];let z=0;const O=U.length;function $(){return z<O?U[z++]():null}function x(X){X!=null&&B.push(X);const Q=$();return Q?Q.then(x):Promise.resolve(B)}return Promise.resolve(null).then(x)}e.sequence=t;function h(U,B=O=>!!O,z=null){let O=0;const $=U.length,x=()=>{if(O>=$)return Promise.resolve(z);const X=U[O++];return Promise.resolve(X()).then(de=>B(de)?Promise.resolve(de):x())};return x()}e.first=h;function s(U,B=O=>!!O,z=null){if(U.length===0)return Promise.resolve(z);let O=U.length;const $=()=>{O=-1;for(const x of U)x.cancel?.()};return new Promise((x,X)=>{for(const Q of U)Q.then(de=>{--O>=0&&B(de)?($(),x(de)):O===0&&x(z)}).catch(de=>{--O>=0&&($(),X(de))})})}e.firstParallel=s;class n{constructor(B){this._size=0,this.maxDegreeOfParalellism=B,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new C.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(B){return this._size++,new Promise((z,O)=>{this.outstandingPromises.push({factory:B,c:z,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const B=this.outstandingPromises.shift();this.runningPromises++;const z=B.factory();z.then(B.c,B.e),z.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=n;class u extends n{constructor(){super(1)}}e.Queue=u;class o{constructor(){this.queues=new Map}queueFor(B,z=A.extUri){const O=z.getComparisonKey(B);let $=this.queues.get(O);return $||($=new u,C.Event.once($.onFinished)(()=>{$?.dispose(),this.queues.delete(O)}),this.queues.set(O,$)),$}dispose(){this.queues.forEach(B=>B.dispose()),this.queues.clear()}}e.ResourceQueue=o;class l{constructor(B,z){this._token=-1,typeof B=="function"&&typeof z=="number"&&this.setIfNotSet(B,z)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(B,z){this.cancel(),this._token=setTimeout(()=>{this._token=-1,B()},z)}setIfNotSet(B,z){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,B()},z))}}e.TimeoutTimer=l;class m{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(B,z){this.cancel(),this._token=setInterval(()=>{B()},z)}}e.IntervalTimer=m;class b{constructor(B,z){this.timeoutToken=-1,this.runner=B,this.timeout=z,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(B=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,B)}get delay(){return this.timeout}set delay(B){this.timeout=B}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=b;class f{constructor(B,z){z%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.runner=B,this.timeout=z,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(B=this.timeout){B%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(B/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=f;class P extends b{constructor(B,z){super(B,z);this.units=[]}work(B){this.units.push(B),this.isScheduled()||this.schedule()}doRun(){const B=this.units;this.units=[],this.runner&&this.runner(B)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=P;class L extends y.Disposable{constructor(B,z,O,$){super();this.maxWorkChunkSize=B,this.maxPendingWork=z,this.throttleDelay=O,this.handler=$,this.pendingWork=[],this.throttler=this._register(new y.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(B){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+B.length>this.maxPendingWork)return!1}else if(this.pending+B.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...B),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new b(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=L,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=U=>{const B=setTimeout(()=>{const O=Date.now()+15;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let z=!1;return{dispose(){z||(z=!0,clearTimeout(B))}}}:e.runWhenIdle=(U,B)=>{const z=requestIdleCallback(U,typeof B=="number"?{timeout:B}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(z))}}}}();class M{constructor(B){this._didRun=!1,this._executor=()=>{try{this._value=B()}catch(z){this._error=z}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=M;async function R(U,B,z){let O;for(let $=0;$<z;$++)try{return await U()}catch(x){O=x,await r(B)}throw O}e.retry=R;class W{hasPending(B){return this._pending?typeof B=="number"?this._pending.taskId===B:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(B,z,O){return this._pending={taskId:B,cancel:()=>O?.(),promise:z},z.then(()=>this.donePending(B),()=>this.donePending(B)),z}donePending(B){this._pending&&B===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const B=this._next;this._next=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}setNext(B){if(this._next)this._next.run=B;else{let z,O;const $=new Promise((x,X)=>{z=x,O=X});this._next={run:B,promise:$,promiseResolve:z,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=W;class V{constructor(B){this.interval=B,this.lastIncrementTime=0,this.value=0}increment(){const B=Date.now();return B-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=B,this.value=0),this.value++,this.value}}e.IntervalCounter=V;class N{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((B,z)=>{this.completeCallback=B,this.errorCallback=z})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(B){return new Promise(z=>{this.completeCallback(B),this.resolved=!0,z()})}error(B){return new Promise(z=>{this.errorCallback(B),this.rejected=!0,z()})}cancel(){new Promise(B=>{this.errorCallback((0,F.canceled)()),this.rejected=!0,B()})}}e.DeferredPromise=N;var j;(function(U){async function B(O){let $;const x=await Promise.all(O.map(X=>X.then(Q=>Q,Q=>{$||($=Q)})));if(typeof $!="undefined")throw $;return x}U.settled=B;function z(O){return new Promise(async($,x)=>{try{await O($,x)}catch(X){x(X)}})}U.withAsyncBody=z})(j=e.Promises||(e.Promises={}))}),define(fe[101],me([0,1,15,8]),function(Y,e,p,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const C=new p.IdleValue(()=>{const b=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:b,collatorIsNumeric:b.resolvedOptions().numeric}}),y=new p.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new p.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function _(b,f,P=!1){const L=b||"",M=f||"",R=C.value.collator.compare(L,M);return C.value.collatorIsNumeric&&R===0&&L!==M?L<M?-1:1:R}e.compareFileNames=_;function S(b,f){const P=y.value.collator;return b=b||"",f=f||"",v(P,b,f)}e.compareFileNamesDefault=S;function I(b,f){const P=y.value.collator;return b=b||"",f=f||"",n(b,f)||v(P,b,f)}e.compareFileNamesUpper=I;function i(b,f){const P=y.value.collator;return b=b||"",f=f||"",s(b,f)||v(P,b,f)}e.compareFileNamesLower=i;function k(b,f){return b=b||"",f=f||"",b===f?0:b<f?-1:1}e.compareFileNamesUnicode=k;function a(b,f,P=!1){P||(b=b&&b.toLowerCase(),f=f&&f.toLowerCase());const[L,M]=c(b),[R,W]=c(f);return L!==R?L<R?-1:1:M===W?0:M<W?-1:1}e.noIntlCompareFileNames=a;function g(b,f){const[P,L]=c(b),[M,R]=c(f);let W=C.value.collator.compare(L,R);if(W===0){if(C.value.collatorIsNumeric&&L!==R)return L<R?-1:1;if(W=C.value.collator.compare(P,M),C.value.collatorIsNumeric&&W===0&&P!==M)return P<M?-1:1}return W}e.compareFileExtensions=g;function d(b,f){b=b||"",f=f||"";const P=r(b),L=r(f),M=y.value.collator,R=A.value.collator;return v(R,P,L)||v(M,b,f)}e.compareFileExtensionsDefault=d;function w(b,f){b=b||"",f=f||"";const P=r(b),L=r(f),M=y.value.collator,R=A.value.collator;return v(R,P,L)||n(b,f)||v(M,b,f)}e.compareFileExtensionsUpper=w;function D(b,f){b=b||"",f=f||"";const P=r(b),L=r(f),M=y.value.collator,R=A.value.collator;return v(R,P,L)||s(b,f)||v(M,b,f)}e.compareFileExtensionsLower=D;function T(b,f){b=b||"",f=f||"";const P=r(b).toLowerCase(),L=r(f).toLowerCase();return P!==L?P<L?-1:1:b!==f?b<f?-1:1:0}e.compareFileExtensionsUnicode=T;const E=/^(.*?)(\.([^.]*))?$/;function c(b,f=!1){const P=b?E.exec(b):[];let L=[P&&P[1]||"",P&&P[3]||""];return f&&(!L[0]&&L[1]||L[0]&&L[0].charAt(0)===".")&&(L=[L[0]+"."+L[1],""]),L}function r(b){const f=b?E.exec(b):[];return f&&f[1]&&f[1].charAt(0)!=="."&&f[3]||""}function v(b,f,P){let L=b.compare(f,P);return L!==0?L:f.length!==P.length?f.length<P.length?-1:1:0}function t(b){const f=b.charAt(0);return f.toLocaleUpperCase()!==f}function h(b){const f=b.charAt(0);return f.toLocaleLowerCase()!==f}function s(b,f){return t(b)&&h(f)?-1:h(b)&&t(f)?1:0}function n(b,f){return h(b)&&t(f)?-1:t(b)&&h(f)?1:0}function u(b,f,P=!1){return P||(b=b&&b.toLowerCase(),f=f&&f.toLowerCase()),b===f?0:b<f?-1:1}function o(b,f,P=!1){const L=b.split(F.sep),M=f.split(F.sep),R=L.length-1,W=M.length-1;let V,N;for(let j=0;;j++){if(V=R===j,N=W===j,V&&N)return _(L[j],M[j],P);if(V)return-1;if(N)return 1;const U=u(L[j],M[j],P);if(U!==0)return U}}e.comparePaths=o;function l(b,f,P){const L=b.toLowerCase(),M=f.toLowerCase(),R=m(b,f,P);if(R)return R;const W=L.endsWith(P),V=M.endsWith(P);if(W!==V)return W?-1:1;const N=_(L,M);return N!==0?N:L.localeCompare(M)}e.compareAnything=l;function m(b,f,P){const L=b.toLowerCase(),M=f.toLowerCase(),R=L.startsWith(P),W=M.startsWith(P);if(R!==W)return R?-1:1;if(R&&W){if(L.length<M.length)return-1;if(L.length>M.length)return 1}return 0}e.compareByPrefix=m}),define(fe[102],me([0,1,101,99,48,8,11,9]),function(Y,e,p,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,I=[S,[]];function i(U,B,z,O){if(!U||!B)return I;const $=U.length,x=B.length;if($<x)return I;const X=U.toLowerCase();return k(B,z,x,U,X,$,O)}e.scoreFuzzy=i;function k(U,B,z,O,$,x,X){const Q=[],de=[];for(let xe=0;xe<z;xe++){const We=xe*x,He=We-x,q=xe>0,ee=U[xe],re=B[xe];for(let le=0;le<x;le++){const Z=le>0,ae=We+le,pe=ae-1,Me=He+le-1,je=Z?Q[pe]:0,Ke=q&&Z?Q[Me]:0,Je=q&&Z?de[Me]:0;let st;!Ke&&q?st=0:st=a(ee,re,O,$,le,Je),st&&Ke+st>=je&&(X||q||$.startsWith(B,le))?(de[ae]=Je+1,Q[ae]=Ke+st):(de[ae]=S,Q[ae]=je)}}const _e=[];let ye=z-1,ke=x-1;for(;ye>=0&&ke>=0;){const xe=ye*x+ke;de[xe]===S||(_e.push(ke),ye--),ke--}return[Q[z*x-1],_e.reverse()]}function a(U,B,z,O,$,x){let X=0;if(!g(B,O[$]))return X;if(X+=1,x>0&&(X+=x*5),U===z[$]&&(X+=1),$===0)X+=8;else{const Q=d(z.charCodeAt($-1));Q?X+=Q:(0,F.isUpper)(z.charCodeAt($))&&(X+=2)}return X}function g(U,B){return U===B?!0:U==="/"||U==="\\"?B==="/"||B==="\\":!1}function d(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const w=[void 0,[]];function D(U,B,z=0,O=0){const $=B;return $.values&&$.values.length>1?T(U,$.values,z,O):E(U,B,z,O)}e.scoreFuzzy2=D;function T(U,B,z,O){let $=0;const x=[];for(const X of B){const[Q,de]=E(U,X,z,O);if(typeof Q!="number")return w;$+=Q,x.push(...de)}return[$,m(x)]}function E(U,B,z,O){const $=(0,F.fuzzyScore)(B.original,B.originalLowercase,z,U,U.toLowerCase(),O,!0);return $?[$[0],(0,F.createMatches)($)]:w}const c=Object.freeze({score:0}),r=1<<18,v=1<<17,t=1<<16;function h(U,B,z,O){const $=O.values?O.values:[O];return(0,C.hash)({[O.normalized]:{values:$.map(X=>({value:X.normalized,expectContiguousMatch:X.expectContiguousMatch})),label:U,description:B,allowNonContiguousMatches:z}})}function s(U,B,z,O,$){if(!U||!B.normalized)return c;const x=O.getItemLabel(U);if(!x)return c;const X=O.getItemDescription(U),Q=h(x,X,z,B),de=$[Q];if(de)return de;const _e=n(x,X,O.getItemPath(U),B,z);return $[Q]=_e,_e}e.scoreItemFuzzy=s;function n(U,B,z,O,$){const x=!z||!O.containsPathSeparator;return z&&(A.isLinux?O.pathNormalized===z:(0,_.equalsIgnoreCase)(O.pathNormalized,z))?{score:r,labelMatch:[{start:0,end:U.length}],descriptionMatch:B?[{start:0,end:B.length}]:void 0}:O.values&&O.values.length>1?u(U,B,z,O.values,x,$):o(U,B,z,O,x,$)}function u(U,B,z,O,$,x){let X=0;const Q=[],de=[];for(const _e of O){const{score:ye,labelMatch:ke,descriptionMatch:xe}=o(U,B,z,_e,$,x);if(ye===S)return c;X+=ye,ke&&Q.push(...ke),xe&&de.push(...xe)}return{score:X,labelMatch:m(Q),descriptionMatch:m(de)}}function o(U,B,z,O,$,x){if($||!B){const[X,Q]=i(U,O.normalized,O.normalizedLowercase,x&&!O.expectContiguousMatch);if(X){const de=(0,F.matchesPrefix)(O.normalized,U);let _e;return de?(_e=v,_e+=Math.round(O.normalized.length/U.length*100)):_e=t,{score:_e+X,labelMatch:de||l(Q)}}}if(B){let X=B;z&&(X=`${B}${y.sep}`);const Q=X.length,de=`${X}${U}`,[_e,ye]=i(de,O.normalized,O.normalizedLowercase,x&&!O.expectContiguousMatch);if(_e){const ke=l(ye),xe=[],We=[];return ke.forEach(He=>{He.start<Q&&He.end>Q?(xe.push({start:0,end:He.end-Q}),We.push({start:He.start,end:Q})):He.start>=Q?xe.push({start:He.start-Q,end:He.end-Q}):We.push(He)}),{score:_e,labelMatch:xe,descriptionMatch:We}}}return c}function l(U){const B=[];if(!U)return B;let z;for(const O of U)z&&z.end===O?z.end+=1:(z={start:O,end:O+1},B.push(z));return B}function m(U){const B=U.sort(($,x)=>$.start-x.start),z=[];let O;for(const $ of B)!O||!b(O,$)?(O=$,z.push($)):(O.start=Math.min(O.start,$.start),O.end=Math.max(O.end,$.end));return z}function b(U,B){return!(U.end<B.start||B.end<U.start)}function f(U,B,z,O,$,x){const X=s(U,z,O,$,x),Q=s(B,z,O,$,x),de=X.score,_e=Q.score;if((de===r||_e===r)&&de!==_e)return de===r?-1:1;if(de>t||_e>t){if(de!==_e)return de>_e?-1:1;if(de<v&&_e<v){const ee=L(X.labelMatch,Q.labelMatch);if(ee!==0)return ee}const He=$.getItemLabel(U)||"",q=$.getItemLabel(B)||"";if(He.length!==q.length)return He.length-q.length}if(de!==_e)return de>_e?-1:1;const ye=Array.isArray(X.labelMatch)&&X.labelMatch.length>0,ke=Array.isArray(Q.labelMatch)&&Q.labelMatch.length>0;if(ye&&!ke)return-1;if(ke&&!ye)return 1;const xe=P(U,X,$),We=P(B,Q,$);return xe&&We&&xe!==We?We>xe?-1:1:M(U,B,z,$)}e.compareItemsByFuzzyScore=f;function P(U,B,z){let O=-1,$=-1;if(B.descriptionMatch&&B.descriptionMatch.length?O=B.descriptionMatch[0].start:B.labelMatch&&B.labelMatch.length&&(O=B.labelMatch[0].start),B.labelMatch&&B.labelMatch.length){if($=B.labelMatch[B.labelMatch.length-1].end,B.descriptionMatch&&B.descriptionMatch.length){const x=z.getItemDescription(U);x&&($+=x.length)}}else B.descriptionMatch&&B.descriptionMatch.length&&($=B.descriptionMatch[B.descriptionMatch.length-1].end);return $-O}function L(U,B){if(!U&&!B||(!U||!U.length)&&(!B||!B.length))return 0;if(!B||!B.length)return-1;if(!U||!U.length)return 1;const z=U[0].start,$=U[U.length-1].end-z,x=B[0].start,Q=B[B.length-1].end-x;return $===Q?0:Q<$?1:-1}function M(U,B,z,O){const $=O.getItemLabel(U)||"",x=O.getItemLabel(B)||"",X=O.getItemDescription(U),Q=O.getItemDescription(B),de=$.length+(X?X.length:0),_e=x.length+(Q?Q.length:0);if(de!==_e)return de-_e;const ye=O.getItemPath(U),ke=O.getItemPath(B);return ye&&ke&&ye.length!==ke.length?ye.length-ke.length:$!==x?(0,p.compareAnything)($,x,z.normalized):X&&Q&&X!==Q?(0,p.compareAnything)(X,Q,z.normalized):ye&&ke&&ye!==ke?(0,p.compareAnything)(ye,ke,z.normalized):0}function R(U){return U.startsWith('"')&&U.endsWith('"')}const W=" ";function V(U){typeof U!="string"&&(U="");const B=U.toLowerCase(),{pathNormalized:z,normalized:O,normalizedLowercase:$}=N(U),x=z.indexOf(y.sep)>=0,X=R(U);let Q;const de=U.split(W);if(de.length>1)for(const _e of de){const ye=R(_e),{pathNormalized:ke,normalized:xe,normalizedLowercase:We}=N(_e);xe&&(Q||(Q=[]),Q.push({original:_e,originalLowercase:_e.toLowerCase(),pathNormalized:ke,normalized:xe,normalizedLowercase:We,expectContiguousMatch:ye}))}return{original:U,originalLowercase:B,pathNormalized:z,normalized:O,normalizedLowercase:$,values:Q,containsPathSeparator:x,expectContiguousMatch:X}}e.prepareQuery=V;function N(U){let B;A.isWindows?B=U.replace(/\//g,y.sep):B=U.replace(/\\/g,y.sep);const z=(0,_.stripWildcards)(B).replace(/\s|"/g,"");return{pathNormalized:B,normalized:z,normalizedLowercase:z.toLowerCase()}}function j(U){return Array.isArray(U)?V(U.map(B=>B.original).join(W)):V(U.original)}e.pieceToQuery=j}),define(fe[30],me([0,1,15,29,24,8,9]),function(Y,e,p,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function _(){return Object.create(null)}e.getEmptyExpression=_;const S="**",I="/",i="[/\\\\]",k="[^/\\\\]",a=/\//g;function g(O){switch(O){case 0:return"";case 1:return`${k}*?`;default:return`(?:${i}|${k}+${i}|${i}${k}+)*?`}}function d(O,$){if(!O)return[];const x=[];let X=!1,Q=!1,de="";for(const _e of O){switch(_e){case $:if(!X&&!Q){x.push(de),de="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}de+=_e}return de&&x.push(de),x}e.splitGlobAware=d;function w(O){if(!O)return"";let $="";const x=d(O,I);if(x.every(X=>X===S))$=".*";else{let X=!1;x.forEach((Q,de)=>{if(Q===S){X||($+=g(2),X=!0);return}let _e=!1,ye="",ke=!1,xe="";for(const We of Q){if(We!=="}"&&_e){ye+=We;continue}if(ke&&(We!=="]"||!xe)){let He;We==="-"?He=We:(We==="^"||We==="!")&&!xe?He="^":We===I?He="":He=A.escapeRegExpCharacters(We),xe+=He;continue}switch(We){case"{":_e=!0;continue;case"[":ke=!0;continue;case"}":$+=`(?:${d(ye,",").map(ee=>w(ee)).join("|")})`,_e=!1,ye="";break;case"]":$+="["+xe+"]",ke=!1,xe="";break;case"?":$+=k;continue;case"*":$+=g(1);continue;default:$+=A.escapeRegExpCharacters(We)}}de<x.length-1&&(x[de+1]!==S||de+2<x.length)&&($+=i),X=!1})}return $}const D=/^\*\*\/\*\.[\w\.-]+$/,T=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,c=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new C.LRUCache(1e4),h=function(){return!1},s=function(){return null};function n(O,$){if(!O)return s;let x;typeof O!="string"?x=O.pattern:x=O,x=x.trim();const X=`${x}_${!!$.trimForExclusions}`;let Q=t.get(X);if(Q)return u(Q,O);let de;if(D.test(x)){const _e=x.substr(4);Q=function(ye,ke){return typeof ye=="string"&&ye.endsWith(_e)?x:null}}else(de=T.exec(o(x,$)))?Q=l(de[1],x):($.trimForExclusions?c:E).test(x)?Q=m(x,$):(de=r.exec(o(x,$)))?Q=b(de[1].substr(1),x,!0):(de=v.exec(o(x,$)))?Q=b(de[1],x,!1):Q=f(x);return t.set(X,Q),u(Q,O)}function u(O,$){return typeof $=="string"?O:function(x,X){return F.isEqualOrParent(x,$.base)?O(y.relative($.base,x),X):null}}function o(O,$){return $.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function l(O,$){const x=`/${O}`,X=`\\${O}`,Q=function(_e,ye){return typeof _e!="string"?null:ye?ye===O?$:null:_e===O||_e.endsWith(x)||_e.endsWith(X)?$:null},de=[O];return Q.basenames=de,Q.patterns=[$],Q.allBasenames=de,Q}function m(O,$){const x=z(O.slice(1,-1).split(",").map(ye=>n(ye,$)).filter(ye=>ye!==s),O),X=x.length;if(!X)return s;if(X===1)return x[0];const Q=function(ye,ke){for(let xe=0,We=x.length;xe<We;xe++)if(x[xe](ye,ke))return O;return null},de=x.find(ye=>!!ye.allBasenames);de&&(Q.allBasenames=de.allBasenames);const _e=x.reduce((ye,ke)=>ke.allPaths?ye.concat(ke.allPaths):ye,[]);return _e.length&&(Q.allPaths=_e),Q}function b(O,$,x){const X=y.sep===y.posix.sep,Q=X?O:O.replace(a,y.sep),de=y.sep+Q,_e=y.posix.sep+O,ye=x?function(ke,xe){return typeof ke=="string"&&(ke===Q||ke.endsWith(de)||!X&&(ke===O||ke.endsWith(_e)))?$:null}:function(ke,xe){return typeof ke=="string"&&(ke===Q||!X&&ke===O)?$:null};return ye.allPaths=[(x?"*/":"./")+O],ye}function f(O){try{const $=new RegExp(`^${w(O)}$`);return function(x){return $.lastIndex=0,typeof x=="string"&&$.test(x)?O:null}}catch($){return s}}function P(O,$,x){return!O||typeof $!="string"?!1:L(O)($,void 0,x)}e.match=P;function L(O,$={}){if(!O)return h;if(typeof O=="string"||V(O)){const x=n(O,$);if(x===s)return h;const X=function(Q,de){return!!x(Q,de)};return x.allBasenames&&(X.allBasenames=x.allBasenames),x.allPaths&&(X.allPaths=x.allPaths),X}return U(O,$)}e.parse=L;function M(O){if(!O)return;let $;return x=>($||($=(O()||Promise.resolve([])).then(X=>X?W(X):{})),$.then(X=>!!X[x]))}e.hasSiblingPromiseFn=M;function R(O){if(!O)return;let $;return x=>{if(!$){const X=O();$=X?W(X):{}}return!!$[x]}}e.hasSiblingFn=R;function W(O){const $={};for(const x of O)$[x]=!0;return $}function V(O){const $=O;return $&&typeof $.base=="string"&&typeof $.pattern=="string"}e.isRelativePattern=V;function N(O){return O.allBasenames||[]}e.getBasenameTerms=N;function j(O){return O.allPaths||[]}e.getPathTerms=j;function U(O,$){const x=z(Object.getOwnPropertyNames(O).map(ye=>B(ye,O[ye],$)).filter(ye=>ye!==s)),X=x.length;if(!X)return s;if(!x.some(ye=>!!ye.requiresSiblings)){if(X===1)return x[0];const ye=function(We,He){for(let q=0,ee=x.length;q<ee;q++){const re=x[q](We,He);if(re)return re}return null},ke=x.find(We=>!!We.allBasenames);ke&&(ye.allBasenames=ke.allBasenames);const xe=x.reduce((We,He)=>He.allPaths?We.concat(He.allPaths):We,[]);return xe.length&&(ye.allPaths=xe),ye}const Q=function(ye,ke,xe){let We;for(let He=0,q=x.length;He<q;He++){const ee=x[He];ee.requiresSiblings&&xe&&(ke||(ke=y.basename(ye)),We||(We=ke.substr(0,ke.length-y.extname(ye).length)));const re=ee(ye,ke,We,xe);if(re)return re}return null},de=x.find(ye=>!!ye.allBasenames);de&&(Q.allBasenames=de.allBasenames);const _e=x.reduce((ye,ke)=>ke.allPaths?ye.concat(ke.allPaths):ye,[]);return _e.length&&(Q.allPaths=_e),Q}function B(O,$,x){if($===!1)return s;const X=n(O,x);if(X===s)return s;if(typeof $=="boolean")return X;if($){const Q=$.when;if(typeof Q=="string"){const de=(_e,ye,ke,xe)=>{if(!xe||!X(_e,ye))return null;const We=Q.replace("$(basename)",ke),He=xe(We);return(0,p.isThenable)(He)?He.then(q=>q?O:null):He?O:null};return de.requiresSiblings=!0,de}}return X}function z(O,$){const x=O.filter(ye=>!!ye.basenames);if(x.length<2)return O;const X=x.reduce((ye,ke)=>{const xe=ke.basenames;return xe?ye.concat(xe):ye},[]);let Q;if($){Q=[];for(let ye=0,ke=X.length;ye<ke;ye++)Q.push($)}else Q=x.reduce((ye,ke)=>{const xe=ke.patterns;return xe?ye.concat(xe):ye},[]);const de=function(ye,ke){if(typeof ye!="string")return null;if(!ke){let We;for(We=ye.length;We>0;We--){const He=ye.charCodeAt(We-1);if(He===47||He===92)break}ke=ye.substr(We)}const xe=X.indexOf(ke);return xe!==-1?Q[xe]:null};de.basenames=X,de.patterns=Q,de.allBasenames=X;const _e=O.filter(ye=>!ye.basenames);return _e.push(de),_e}}),define(fe[80],me([0,1,29,10,8,11,23,9,2]),function(Y,e,p,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function I(n,u,o){if(typeof n=="string"&&(n=S.URI.file(n)),o){const m=o.getWorkspaceFolder(n);if(m){const b=o.getWorkspace().folders.length>1;let f;if((0,A.isEqual)(m.uri,n)?f="":f=(0,A.relativePath)(m.uri,n),b){const P=m.name?m.name:(0,A.basename)(m.uri);f=f?P+" \u2022 "+f:P}return f}}if(n.scheme!==F.Schemas.file&&n.scheme!==F.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,p.hasDriveLetter)(n.fsPath))return(0,C.normalize)(k(n.fsPath));let l=(0,C.normalize)(n.fsPath);return!y.isWindows&&u?.userHome&&(l=g(l,u.userHome.fsPath)),l}e.getPathLabel=I;function i(n){if(!n)return;typeof n=="string"&&(n=S.URI.file(n));const u=(0,A.basename)(n)||(n.scheme===F.Schemas.file?n.fsPath:n.path);return y.isWindows&&(0,p.isRootOrDriveLetter)(u)?k(u):u}e.getBaseLabel=i;function k(n){return(0,p.hasDriveLetter)(n)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=k;let a=Object.create(null);function g(n,u){if(y.isWindows||!n||!u)return n;let o=a.original===u?a.normalized:void 0;return o||(o=`${(0,_.rtrim)(u,C.posix.sep)}${C.posix.sep}`,a={original:u,normalized:o}),(y.isLinux?n.startsWith(o):(0,_.startsWithIgnoreCase)(n,o))&&(n=`~/${n.substr(o.length)}`),n}e.tildify=g;function d(n,u){return n.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=d;const w="\u2026",D="\\\\",T="~";function E(n,u=C.sep){const o=new Array(n.length);let l=!1;for(let m=0;m<n.length;m++){let b=n[m];if(b===""){o[m]=`.${u}`;continue}if(!b){o[m]=b;continue}l=!0;let f="";b.indexOf(D)===0?(f=b.substr(0,b.indexOf(D)+D.length),b=b.substr(b.indexOf(D)+D.length)):b.indexOf(u)===0?(f=b.substr(0,b.indexOf(u)+u.length),b=b.substr(b.indexOf(u)+u.length)):b.indexOf(T)===0&&(f=b.substr(0,b.indexOf(T)+T.length),b=b.substr(b.indexOf(T)+T.length));const P=b.split(u);for(let L=1;l&&L<=P.length;L++)for(let M=P.length-L;l&&M>=0;M--){l=!1;let R=P.slice(M,M+L).join(u);for(let W=0;!l&&W<n.length;W++)if(W!==m&&n[W]&&n[W].indexOf(R)>-1){const V=M+L===P.length,N=M>0&&n[W].indexOf(u)>-1?u+R:R,j=n[W].endsWith(N);l=!V||j}if(!l){let W="";(P[0].endsWith(":")||f!=="")&&(M===1&&(M=0,L++,R=P[0]+u+R),M>0&&(W=P[0]+u),W=f+W),M>0&&(W=W+w+u),W=W+R,M+L<P.length&&(W=W+u+w),o[m]=W}}l&&(o[m]=b)}return o}e.shorten=E;var c;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function r(n,u=Object.create(null)){const o=[];let l=!1,m="";for(const b of n)if(b==="$"||l&&b==="{")m&&o.push({value:m,type:c.TEXT}),m="",l=!0;else if(b==="}"&&l){const f=u[m];if(typeof f=="string")f.length&&o.push({value:f,type:c.VARIABLE});else if(f){const P=o[o.length-1];(!P||P.type!==c.SEPARATOR)&&o.push({value:f.label,type:c.SEPARATOR})}m="",l=!1}else m+=b;return m&&!l&&o.push({value:m,type:c.TEXT}),o.filter((b,f)=>{if(b.type===c.SEPARATOR){const P=o[f-1],L=o[f+1];return[P,L].every(M=>M&&(M.type===c.VARIABLE||M.type===c.TEXT)&&M.value.length>0)}return!0}).map(b=>b.value).join("")}e.template=r;function v(n,u){return y.isMacintosh||u?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):n.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=v;function t(n,u){return y.isMacintosh||u?n.replace(/\(&&\w\)|&&/g,""):y.isWindows?n.replace(/&&|&/g,o=>o==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function h(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=h;function s(n){const u=n.indexOf("/")!==-1?C.posix:C.win32,o=u.basename(n),l=u.dirname(n);return o.length?{name:o,parentPath:l}:{name:l,parentPath:""}}e.splitName=s}),define(fe[103],me([0,1,30,10,8,23,9]),function(Y,e,p,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var _;(function(n){n.text="text/plain",n.binary="application/octet-stream",n.unknown="application/unknown",n.markdown="text/markdown",n.latex="text/latex"})(_=e.Mimes||(e.Mimes={}));let S=[],I=[],i=[];function k(n,u=!1){const o=a(n);S.push(o),o.userConfigured?i.push(o):I.push(o),u&&!o.userConfigured&&S.forEach(l=>{l.mime===o.mime||l.userConfigured||(o.extension&&l.extension===o.extension&&console.warn(`Overwriting extension <<${o.extension}>> to now point to mime <<${o.mime}>>`),o.filename&&l.filename===o.filename&&console.warn(`Overwriting filename <<${o.filename}>> to now point to mime <<${o.mime}>>`),o.filepattern&&l.filepattern===o.filepattern&&console.warn(`Overwriting filepattern <<${o.filepattern}>> to now point to mime <<${o.mime}>>`),o.firstline&&l.firstline===o.firstline&&console.warn(`Overwriting firstline <<${o.firstline}>> to now point to mime <<${o.mime}>>`))})}e.registerTextMime=k;function a(n){return{id:n.id,mime:n.mime,filename:n.filename,extension:n.extension,filepattern:n.filepattern,firstline:n.firstline,userConfigured:n.userConfigured,filenameLowercase:n.filename?n.filename.toLowerCase():void 0,extensionLowercase:n.extension?n.extension.toLowerCase():void 0,filepatternLowercase:n.filepattern?(0,p.parse)(n.filepattern.toLowerCase()):void 0,filepatternOnPath:n.filepattern?n.filepattern.indexOf(C.posix.sep)>=0:!1}}function g(n){n?(S=S.filter(u=>!u.userConfigured),i=[]):(S=[],I=[],i=[])}e.clearTextMimes=g;function d(n,u){let o;if(n)switch(n.scheme){case F.Schemas.file:o=n.fsPath;break;case F.Schemas.data:o=y.DataUri.parseMetaData(n).get(y.DataUri.META_DATA_LABEL);break;default:o=n.path}if(!o)return[_.unknown];o=o.toLowerCase();const l=(0,C.basename)(o),m=w(o,l,i);if(m)return[m,_.text];const b=w(o,l,I);if(b)return[b,_.text];if(u){const f=D(u);if(f)return[f,_.text]}return[_.unknown]}e.guessMimeTypes=d;function w(n,u,o){let l=null,m=null,b=null;for(let f=o.length-1;f>=0;f--){const P=o[f];if(u===P.filenameLowercase){l=P;break}if(P.filepattern&&(!m||P.filepattern.length>m.filepattern.length)){const L=P.filepatternOnPath?n:u;P.filepatternLowercase?.(L)&&(m=P)}P.extension&&(!b||P.extension.length>b.extension.length)&&u.endsWith(P.extensionLowercase)&&(b=P)}return l?l.mime:m?m.mime:b?b.mime:null}function D(n){if((0,A.startsWithUTF8BOM)(n)&&(n=n.substr(1)),n.length>0)for(let u=S.length-1;u>=0;u--){const o=S[u];if(!o.firstline)continue;const l=n.match(o.firstline);if(l&&l.length>0)return o.mime}return null}function T(n){return n?typeof n=="string"?n===_.binary||n===_.text||n===_.unknown:n.length===1&&T(n[0]):!0}e.isUnspecific=T;const E={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},c={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function r(n){const u=(0,C.extname)(n),o=E[u.toLowerCase()];return o!==void 0?o:v(n)}e.getMediaOrTextMime=r;function v(n){const u=(0,C.extname)(n);return c[u.toLowerCase()]}e.getMediaMime=v;function t(n){for(const u in c)if(c[u]===n)return u}e.getExtensionForMimeType=t;const h=/^(.+)\/(.+?)(;.+)?$/;function s(n,u){const o=h.exec(n);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:u?void 0:n}e.normalizeMimeType=s}),define(fe[104],me([0,1,2]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function F(i){return i.toJSON()}class C{constructor(k){this._uriTransformer=k}transformIncoming(k){const a=this._uriTransformer.transformIncoming(k);return a===k?k:F(p.URI.from(a))}transformOutgoing(k){const a=this._uriTransformer.transformOutgoing(k);return a===k?k:F(p.URI.from(a))}transformOutgoingURI(k){const a=this._uriTransformer.transformOutgoing(k);return a===k?k:p.URI.from(a)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function y(i,k,a){if(!i||a>200)return null;if(typeof i=="object"){if(i instanceof p.URI)return k.transformOutgoing(i);for(let g in i)if(Object.hasOwnProperty.call(i,g)){const d=y(i[g],k,a+1);d!==null&&(i[g]=d)}}return null}function A(i,k){const a=y(i,k,0);return a===null?i:a}e.transformOutgoingURIs=A;function _(i,k,a,g){if(!i||g>200)return null;if(typeof i=="object"){if(i.$mid===1)return a?p.URI.revive(k.transformIncoming(i)):k.transformIncoming(i);for(let d in i)if(Object.hasOwnProperty.call(i,d)){const w=_(i[d],k,a,g+1);w!==null&&(i[d]=w)}}return null}function S(i,k){const a=_(i,k,!1,0);return a===null?i:a}e.transformIncomingURIs=S;function I(i,k){const a=_(i,k,!0,0);return a===null?i:a}e.transformAndReviveIncomingURIs=I}),define(fe[32],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(S){return p.test(S)}e.isUUID=F;const C=new Uint8Array(16),y=[];for(let S=0;S<256;S++)y.push(S.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(S){for(let I=0;I<S.length;I++)S[I]=Math.floor(Math.random()*256);return S};function _(){A(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let S=0,I="";return I+=y[C[S++]],I+=y[C[S++]],I+=y[C[S++]],I+=y[C[S++]],I+="-",I+=y[C[S++]],I+=y[C[S++]],I+="-",I+=y[C[S++]],I+=y[C[S++]],I+="-",I+=y[C[S++]],I+=y[C[S++]],I+="-",I+=y[C[S++]],I+=y[C[S++]],I+=y[C[S++]],I+=y[C[S++]],I+=y[C[S++]],I+=y[C[S++]],I}e.generateUuid=_}),define(fe[144],me([0,1,105]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class F{constructor(y="utf8"){this.stringDecoder=new p.StringDecoder(y),this.remaining=null}write(y){const A=[],_=this.remaining?this.remaining+this.stringDecoder.write(y):this.stringDecoder.write(y);if(_.length<1)return A;let S=0,I,i=S;for(;i<_.length;)if(I=_.charCodeAt(i),I===13||I===10){if(A.push(_.substring(S,i)),i++,i<_.length){const k=I;I=_.charCodeAt(i),(k===13&&I===10||k===10&&I===13)&&i++}S=i}else i++;return this.remaining=S<_.length?_.substr(S):null,A}end(){return this.remaining}}e.LineDecoder=F}),define(fe[28],me([0,1,50,81,292,15,29,79,8,11,23,2,32]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var g;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(g=e.RimRafMode||(e.RimRafMode={}));async function d(N,j=g.UNLINK){if((0,A.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return j===g.UNLINK?D(N):w(N)}async function w(N){try{const j=(0,S.join)((0,F.tmpdir)(),(0,a.generateUuid)());try{await e.Promises.rename(N,j)}catch(U){return D(N)}D(j).catch(U=>{})}catch(j){if(j.code!=="ENOENT")throw j}}async function D(N){return e.Promises.rmdir(N,{recursive:!0,maxRetries:3})}function T(N){if((0,A.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync(N,{recursive:!0})}e.rimrafSync=T;async function E(N,j){return v(await(j?c(N):(0,C.promisify)(p.readdir)(N)))}async function c(N){try{return await(0,C.promisify)(p.readdir)(N,{withFileTypes:!0})}catch(B){console.warn("[node.js fs] readdir with filetypes failed with error: ",B)}const j=[],U=await E(N);for(const B of U){let z=!1,O=!1,$=!1;try{const x=await e.Promises.lstat((0,S.join)(N,B));z=x.isFile(),O=x.isDirectory(),$=x.isSymbolicLink()}catch(x){console.warn("[node.js fs] unexpected error from lstat after readdir: ",x)}j.push({name:B,isFile:()=>z,isDirectory:()=>O,isSymbolicLink:()=>$})}return j}function r(N){return v(p.readdirSync(N))}e.readdirSync=r;function v(N){return N.map(j=>typeof j=="string"?I.isMacintosh?(0,_.normalizeNFC)(j):j:(j.name=I.isMacintosh?(0,_.normalizeNFC)(j.name):j.name,j))}async function t(N){const j=await E(N),U=[];for(const B of j)await s.existsDirectory((0,S.join)(N,B))&&U.push(B);return U}function h(N,j=1e3){return new Promise(U=>{let B=!1;const z=setInterval(()=>{B||(B=!0,p.access(N,O=>{B=!1,O&&(clearInterval(z),U(void 0))}))},j)})}e.whenDeleted=h;var s;(function(N){async function j(z){let O;try{if(O=await e.Promises.lstat(z),!O.isSymbolicLink())return{stat:O}}catch($){}try{return{stat:await e.Promises.stat(z),symbolicLink:O?.isSymbolicLink()?{dangling:!1}:void 0}}catch($){if($.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(I.isWindows&&$.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(z)),symbolicLink:{dangling:!1}}}catch(x){if(x.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw x}throw $}}N.stat=j;async function U(z){try{const{stat:O,symbolicLink:$}=await N.stat(z);return O.isFile()&&$?.dangling!==!0}catch(O){}return!1}N.existsFile=U;async function B(z){try{const{stat:O,symbolicLink:$}=await N.stat(z);return O.isDirectory()&&$?.dangling!==!0}catch(O){}return!1}N.existsDirectory=B})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new y.ResourceQueue;function u(N,j,U){return n.queueFor(k.URI.file(N),i.extUriBiasedIgnorePathCase).queue(()=>{const B=b(U);return new Promise((z,O)=>l(N,j,B,$=>$?O($):z()))})}let o=!0;function l(N,j,U,B){if(!o)return p.writeFile(N,j,{mode:U.mode,flag:U.flag},B);p.open(N,U.flag,U.mode,(z,O)=>{if(z)return B(z);p.writeFile(O,j,$=>{if($)return p.close(O,()=>B($));p.fdatasync(O,x=>(x&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",x),o=!1),p.close(O,X=>B(X))))})})}function m(N,j,U){const B=b(U);if(!o)return p.writeFileSync(N,j,{mode:B.mode,flag:B.flag});const z=p.openSync(N,B.flag,B.mode);try{p.writeFileSync(z,j);try{p.fdatasyncSync(z)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),o=!1}}finally{p.closeSync(z)}}e.writeFileSync=m;function b(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function f(N,j){if(N===j)return;async function U(B){try{const z=await e.Promises.lstat(B);if(z.isDirectory()||z.isSymbolicLink())return;await e.Promises.utimes(B,z.atime,new Date)}catch(z){}}try{await e.Promises.rename(N,j),await U(j)}catch(B){if(N.toLowerCase()!==j.toLowerCase()&&B.code==="EXDEV"||N.endsWith("."))await P(N,j,{preserveSymlinks:!1}),await d(N,g.MOVE),await U(j);else throw B}}async function P(N,j,U){return M(N,j,{root:{source:N,target:j},options:U,handledSourcePaths:new Set})}const L=511;async function M(N,j,U){if(U.handledSourcePaths.has(N))return;U.handledSourcePaths.add(N);const{stat:B,symbolicLink:z}=await s.stat(N);if(z){if(U.options.preserveSymlinks)try{return await V(N,j,U)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(z.dangling)return}return B.isDirectory()?R(N,j,B.mode&L,U):W(N,j,B.mode&L)}async function R(N,j,U,B){await e.Promises.mkdir(j,{recursive:!0,mode:U});const z=await E(N);for(const O of z)await M((0,S.join)(N,O),(0,S.join)(j,O),B)}async function W(N,j,U){await e.Promises.copyFile(N,j),await e.Promises.chmod(j,U)}async function V(N,j,U){let B=await e.Promises.readlink(N);(0,A.isEqualOrParent)(B,U.root.source,!I.isLinux)&&(B=(0,S.join)(U.root.target,B.substr(U.root.source.length+1))),await e.Promises.symlink(B,j)}e.Promises=new class{get access(){return(0,C.promisify)(p.access)}get stat(){return(0,C.promisify)(p.stat)}get lstat(){return(0,C.promisify)(p.lstat)}get utimes(){return(0,C.promisify)(p.utimes)}get read(){return(0,C.promisify)(p.read)}get readFile(){return(0,C.promisify)(p.readFile)}get write(){return(0,C.promisify)(p.write)}get appendFile(){return(0,C.promisify)(p.appendFile)}get fdatasync(){return(0,C.promisify)(p.fdatasync)}get truncate(){return(0,C.promisify)(p.truncate)}get rename(){return(0,C.promisify)(p.rename)}get copyFile(){return(0,C.promisify)(p.copyFile)}get open(){return(0,C.promisify)(p.open)}get close(){return(0,C.promisify)(p.close)}get symlink(){return(0,C.promisify)(p.symlink)}get readlink(){return(0,C.promisify)(p.readlink)}get chmod(){return(0,C.promisify)(p.chmod)}get mkdir(){return(0,C.promisify)(p.mkdir)}get unlink(){return(0,C.promisify)(p.unlink)}get rmdir(){return(0,C.promisify)(p.rmdir)}get realpath(){return(0,C.promisify)(p.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return E}get readDirsInDir(){return t}get writeFile(){return u}get rm(){return d}get move(){return f}get copy(){return P}}}),define(fe[106],me([0,1,50,8,9,28]),function(Y,e,p,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(i){const k=(0,F.dirname)(i);if(i===k)return i;const a=((0,F.basename)(i)||i).toLowerCase();try{const d=(0,y.readdirSync)(k).filter(w=>w.toLowerCase()===a);if(d.length===1){const w=A(k);if(w)return(0,F.join)(w,d[0])}else if(d.length>1){const w=d.indexOf(a);if(w>=0){const D=A(k);if(D)return(0,F.join)(D,d[w])}}}catch(g){}return null}e.realcaseSync=A;async function _(i){try{return await y.Promises.realpath(i)}catch(k){const a=I(i);return await y.Promises.access(a,p.constants.R_OK),a}}e.realpath=_;function S(i){try{return p.realpathSync(i)}catch(k){const a=I(i);return p.accessSync(a,p.constants.R_OK),a}}e.realpathSync=S;function I(i){return(0,C.rtrim)((0,F.normalize)(i),F.sep)}});var Ve=this&&this.__decorate||function(Y,e,p,F){var C=arguments.length,y=C<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,p):F,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")y=Reflect.decorate(Y,e,p,F);else for(var _=Y.length-1;_>=0;_--)(A=Y[_])&&(y=(C<3?A(y):C>3?A(e,p,y):A(e,p))||y);return C>3&&y&&Object.defineProperty(e,p,y),y};define(fe[107],me([0,1,18,15,22,21,60,17,3,6,62,9,12]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var g;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(g=e.RequestType||(e.RequestType={}));function d(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(w=e.ResponseType||(e.ResponseType={}));function D(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var T;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(T||(T={}));class E{constructor(O){this.buffer=O,this.pos=0}read(O){const $=this.buffer.slice(this.pos,this.pos+O);return this.pos+=$.byteLength,$}}class c{constructor(){this.buffers=[]}get buffer(){return C.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var r;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object"})(r||(r={}));function v(z){const O=C.VSBuffer.alloc(4);return O.writeUInt32BE(z,0),O}function t(z){return z.read(4).readUInt32BE(0)}function h(z){const O=C.VSBuffer.alloc(1);return O.writeUInt8(z,0),O}const s={Undefined:h(r.Undefined),String:h(r.String),Buffer:h(r.Buffer),VSBuffer:h(r.VSBuffer),Array:h(r.Array),Object:h(r.Object)},n=typeof Buffer!="undefined";function u(z,O){if(typeof O=="undefined")z.write(s.Undefined);else if(typeof O=="string"){const $=C.VSBuffer.fromString(O);z.write(s.String),z.write(v($.byteLength)),z.write($)}else if(n&&Buffer.isBuffer(O)){const $=C.VSBuffer.wrap(O);z.write(s.Buffer),z.write(v($.byteLength)),z.write($)}else if(O instanceof C.VSBuffer)z.write(s.VSBuffer),z.write(v(O.byteLength)),z.write(O);else if(Array.isArray(O)){z.write(s.Array),z.write(v(O.length));for(const $ of O)u(z,$)}else{const $=C.VSBuffer.fromString(JSON.stringify(O));z.write(s.Object),z.write(v($.byteLength)),z.write($)}}function o(z){switch(z.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return z.read(t(z)).toString();case r.Buffer:return z.read(t(z)).buffer;case r.VSBuffer:return z.read(t(z));case r.Array:{const $=t(z),x=[];for(let X=0;X<$;X++)x.push(o(z));return x}case r.Object:return JSON.parse(z.read(t(z)).toString())}}class l{constructor(O,$,x=null,X=1e3){this.protocol=O,this.ctx=$,this.logger=x,this.timeoutDelay=X,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Q=>this.onRawMessage(Q)),this.sendResponse({type:200})}registerChannel(O,$){this.channels.set(O,$),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const $=this.send([O.type]);this.logger&&this.logger.logOutgoing($,0,1,D(O.type));return}case 201:case 202:case 204:case 203:{const $=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing($,O.id,1,D(O.type),O.data);return}}}send(O,$=void 0){const x=new c;return u(x,O),u(x,$),this.sendBuffer(x.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch($){return 0}}onRawMessage(O){const $=new E(O),x=o($),X=o($),Q=x[0];switch(Q){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,x[1],1,`${d(Q)}: ${x[2]}.${x[3]}`,X),this.onPromise({type:Q,id:x[1],channelName:x[2],name:x[3],arg:X});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,x[1],1,`${d(Q)}: ${x[2]}.${x[3]}`,X),this.onEventListen({type:Q,id:x[1],channelName:x[2],name:x[3],arg:X});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,x[1],1,`${d(Q)}`),this.disposeActiveRequest({type:Q,id:x[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,x[1],1,`${d(Q)}`),this.disposeActiveRequest({type:Q,id:x[1]})}}onPromise(O){const $=this.channels.get(O.channelName);if(!$){this.collectPendingRequest(O);return}const x=new y.CancellationTokenSource;let X;try{X=$.call(this.ctx,O.name,O.arg,x.token)}catch(_e){X=Promise.reject(_e)}const Q=O.id;X.then(_e=>{this.sendResponse({id:Q,data:_e,type:201}),this.activeRequests.delete(O.id)},_e=>{_e instanceof Error?this.sendResponse({id:Q,data:{message:_e.message,name:_e.name,stack:_e.stack?_e.stack.split?_e.stack.split(`
`):_e.stack:void 0},type:202}):this.sendResponse({id:Q,data:_e,type:203}),this.activeRequests.delete(O.id)});const de=(0,I.toDisposable)(()=>x.cancel());this.activeRequests.set(O.id,de)}onEventListen(O){const $=this.channels.get(O.channelName);if(!$){this.collectPendingRequest(O);return}const x=O.id,Q=$.listen(this.ctx,O.name,O.arg)(de=>this.sendResponse({id:x,data:de,type:204}));this.activeRequests.set(O.id,Q)}disposeActiveRequest(O){const $=this.activeRequests.get(O.id);$&&($.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let $=this.pendingRequests.get(O.channelName);$||($=[],this.pendingRequests.set(O.channelName,$));const x=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);$.push({request:O,timeoutTimer:x})}flushPendingRequests(O){const $=this.pendingRequests.get(O);if($){for(const x of $)switch(clearTimeout(x.timeoutTimer),x.request.type){case 100:this.onPromise(x.request);break;case 102:this.onEventListen(x.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}e.ChannelServer=l;var m;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));class b{constructor(O,$=null){this.protocol=O,this.isDisposed=!1,this.state=T.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(x=>this.onBuffer(x)),this.logger=$}getChannel(O){const $=this;return{call(x,X,Q){return $.isDisposed?Promise.reject(_.canceled()):$.requestPromise(O,x,X,Q)},listen(x,X){return $.isDisposed?Promise.reject(_.canceled()):$.requestEvent(O,x,X)}}}requestPromise(O,$,x,X=y.CancellationToken.None){const Q=this.lastRequestId++,_e={id:Q,type:100,channelName:O,name:$,arg:x};if(X.isCancellationRequested)return Promise.reject(_.canceled());let ye;return new Promise((xe,We)=>{if(X.isCancellationRequested)return We(_.canceled());const He=()=>{const le=Z=>{switch(Z.type){case 201:this.handlers.delete(Q),xe(Z.data);break;case 202:this.handlers.delete(Q);const ae=new Error(Z.data.message);ae.stack=Z.data.stack,ae.name=Z.data.name,We(ae);break;case 203:this.handlers.delete(Q),We(Z.data);break}};this.handlers.set(Q,le),this.sendRequest(_e)};let q=null;this.state===T.Idle?He():(q=(0,F.createCancelablePromise)(le=>this.whenInitialized()),q.then(()=>{q=null,He()}));const ee=()=>{q?(q.cancel(),q=null):this.sendRequest({id:Q,type:101}),We(_.canceled())},re=X.onCancellationRequested(ee);ye=(0,I.combinedDisposable)((0,I.toDisposable)(ee),re),this.activeRequests.add(ye)}).finally(()=>{this.activeRequests.delete(ye)})}requestEvent(O,$,x){const X=this.lastRequestId++,de={id:X,type:102,channelName:O,name:$,arg:x};let _e=null;const ye=new S.Emitter({onFirstListenerAdd:()=>{_e=(0,F.createCancelablePromise)(xe=>this.whenInitialized()),_e.then(()=>{_e=null,this.activeRequests.add(ye),this.sendRequest(de)})},onLastListenerRemove:()=>{_e?(_e.cancel(),_e=null):(this.activeRequests.delete(ye),this.sendRequest({id:X,type:103}))}}),ke=xe=>ye.fire(xe.data);return this.handlers.set(X,ke),ye.event}sendRequest(O){switch(O.type){case 100:case 102:{const $=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing($,O.id,0,`${d(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const $=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing($,O.id,0,d(O.type));return}}}send(O,$=void 0){const x=new c;return u(x,O),u(x,$),this.sendBuffer(x.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch($){return 0}}onBuffer(O){const $=new E(O),x=o($),X=o($),Q=x[0];switch(Q){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,D(Q)),this.onResponse({type:x[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,x[1],0,D(Q),X),this.onResponse({type:x[0],id:x[1],data:X})}}onResponse(O){if(O.type===200){this.state=T.Idle,this._onDidInitialize.fire();return}const $=this.handlers.get(O.id);$&&$(O)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===T.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}Ve([A.memoize],b.prototype,"onDidInitializePromise",null),e.ChannelClient=b;class f{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:$,onDidClientDisconnect:x})=>{S.Event.once($.onMessage)(Q=>{const de=new E(Q),_e=o(de),ye=new l($,_e),ke=new b($);this.channels.forEach((We,He)=>ye.registerChannel(He,We));const xe={channelServer:ye,channelClient:ke,ctx:_e};this._connections.add(xe),this._onDidAddConnection.fire(xe),x(()=>{ye.dispose(),ke.dispose(),this._connections.delete(xe),this._onDidRemoveConnection.fire(xe)})})})}get connections(){const O=[];return this._connections.forEach($=>O.push($)),O}getChannel(O,$){const x=this;return{call(X,Q,de){let _e;if((0,a.isFunction)($)){let ke=(0,p.getRandomElement)(x.connections.filter($));_e=ke?Promise.resolve(ke):S.Event.toPromise(S.Event.filter(x.onDidAddConnection,$))}else _e=$.routeCall(x,X,Q);const ye=_e.then(ke=>ke.channelClient.getChannel(O));return L(ye).call(X,Q,de)},listen(X,Q){if((0,a.isFunction)($))return x.getMulticastEvent(O,$,X,Q);const de=$.routeEvent(x,X,Q).then(_e=>_e.channelClient.getChannel(O));return L(de).listen(X,Q)}}}getMulticastEvent(O,$,x,X){const Q=this;let de=new I.DisposableStore;const _e=new S.Emitter({onFirstListenerAdd:()=>{de=new I.DisposableStore;const ye=new S.EventMultiplexer,ke=new Map,xe=He=>{const ee=He.channelClient.getChannel(O).listen(x,X),re=ye.add(ee);ke.set(He,re)},We=He=>{const q=ke.get(He);!q||(q.dispose(),ke.delete(He))};Q.connections.filter($).forEach(xe),S.Event.filter(Q.onDidAddConnection,$)(xe,void 0,de),Q.onDidRemoveConnection(We,void 0,de),ye.event(_e.fire,_e,de),de.add(ye)},onLastListenerRemove:()=>{de.dispose()}});return _e.event}registerChannel(O,$){this.channels.set(O,$),this._connections.forEach(x=>{x.channelServer.registerChannel(O,$)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=f;class P{constructor(O,$,x=null){const X=new c;u(X,$),O.send(X.buffer),this.channelClient=new b(O,x),this.channelServer=new l(O,$,x)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,$){this.channelServer.registerChannel(O,$)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=P;function L(z){return{call(O,$,x){return z.then(X=>X.call(O,$,x))},listen(O,$){const x=new S.Relay;return z.then(X=>x.input=X.listen(O,$)),x.event}}}e.getDelayedChannel=L;function M(z){let O=!1;return{call($,x,X){return O?z.call($,x,X):(0,F.timeout)(0).then(()=>O=!0).then(()=>z.call($,x,X))},listen($,x){if(O)return z.listen($,x);const X=new S.Relay;return(0,F.timeout)(0).then(()=>O=!0).then(()=>X.input=z.listen($,x)),X.event}}}e.getNextTickChannel=M;class R{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const $ of O.connections)if(await Promise.resolve(this.fn($.ctx)))return Promise.resolve($);return await S.Event.toPromise(O.onDidAddConnection),await this.route(O)}}e.StaticRouter=R;var W;(function(z){function O(Q,de){const _e=Q,ye=de&&de.disableMarshalling,ke=new Map;for(const xe in _e)x(xe)&&ke.set(xe,S.Event.buffer(_e[xe],!0));return new class{listen(xe,We,He){const q=ke.get(We);if(q)return q;if(X(We)){const ee=_e[We];if(typeof ee=="function")return ee.call(_e,He)}throw new Error(`Event not found: ${We}`)}call(xe,We,He){const q=_e[We];if(typeof q=="function"){if(!ye&&Array.isArray(He))for(let ee=0;ee<He.length;ee++)He[ee]=(0,i.revive)(He[ee]);return q.apply(_e,He)}throw new Error(`Method not found: ${We}`)}}}z.fromService=O;function $(Q,de){const _e=de&&de.disableMarshalling;return new Proxy({},{get(ye,ke){if(typeof ke=="string")return de?.properties?.has(ke)?de.properties.get(ke):X(ke)?function(xe){return Q.listen(ke,xe)}:x(ke)?Q.listen(ke):async function(...xe){let We;de&&!(0,a.isUndefinedOrNull)(de.context)?We=[de.context,...xe]:We=xe;const He=await Q.call(ke,We);return _e?He:(0,i.revive)(He)};throw new Error(`Property not found: ${String(ke)}`)}})}z.toService=$;function x(Q){return Q[0]==="o"&&Q[1]==="n"&&k.isUpperAsciiLetter(Q.charCodeAt(2))}function X(Q){return/^onDynamic/.test(Q)&&k.isUpperAsciiLetter(Q.charCodeAt(9))}})(W=e.ProxyChannel||(e.ProxyChannel={}));const V=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){let O=z.toString();if(O!=="[object Object]")return O}return z}function j(z){return Array.isArray(z)?z.map(N):N(z)}function U(z,O,$,x,X,Q,de){de=j(de);const _e=V[X],ye=_e[x%_e.length];let ke=[`%c[${z}]%c[${String(O).padStart(7," ")}]%c[len: ${String($).padStart(5," ")}]%c${String(x).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${ye}`];/\($/.test(Q)?(ke=ke.concat(de),ke.push(")")):ke.push(de),console.log.apply(console,ke)}e.logWithColors=U;class B{constructor(O,$){this._outgoingPrefix=O,this._incomingPrefix=$,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,$,x,X,Q){this._totalOutgoing+=O,U(this._outgoingPrefix,this._totalOutgoing,O,$,x,X,Q)}logIncoming(O,$,x,X,Q){this._totalIncoming+=O,U(this._incomingPrefix,this._totalIncoming,O,$,x,X,Q)}}e.IPCLogger=B}),define(fe[108],me([0,1,22,3,6,11,38,107]),function(Y,e,p,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var S;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function i(){return I||(I=p.VSBuffer.alloc(0)),I}class k{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,u){if(n===0)return i();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const b=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=n),b}if(this._chunks[0].byteLength>n){const b=this._chunks[0].slice(0,n);return u&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),b}let o=p.VSBuffer.alloc(n),l=0,m=0;for(;n>0;){const b=this._chunks[m];if(b.byteLength>n){const f=b.slice(0,n);o.set(f,l),l+=n,u&&(this._chunks[m]=b.slice(n),this._totalLength-=n),n-=n}else o.set(b,l),l+=b.byteLength,u?(this._chunks.shift(),this._totalLength-=b.byteLength):m++,n-=b.byteLength}return o}}e.ChunkStream=k;var a;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.KeepAlive=4]="KeepAlive",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest"})(a||(a={}));var g;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",s[s.KeepAliveTime=5e3]="KeepAliveTime",s[s.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(g=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(n,u,o,l){this.type=n,this.id=u,this.ack=o,this.data=l,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends C.Disposable{constructor(n){super();this._onMessage=this._register(new F.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5);else{const o=this._state.messageType,l=this._state.id,m=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new d(o,l,m,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class D{constructor(n){this._isDisposed=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(n){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=p.VSBuffer.alloc(13);u.writeUInt8(n.type,0),u.writeUInt32BE(n.id,1),u.writeUInt32BE(n.ack,5),u.writeUInt32BE(n.data.byteLength,9),this._writeSoon(u,n.data)}_bufferAdd(n,u){const o=this._totalLength===0;return this._data.push(n,u),this._totalLength+=n.byteLength+u.byteLength,o}_bufferTake(){const n=p.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,u){this._bufferAdd(n,u)&&y.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class T extends C.Disposable{constructor(n){super();this._onMessage=new F.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new D(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new d(1,0,0,n))}}e.Protocol=T;class E extends _.IPCClient{constructor(n,u,o=null){super(n,u,o);this.protocol=n}static fromSocket(n,u){return new E(new T(n),u)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=E;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new F.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,A.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class r{constructor(n){this.data=n,this.next=null}}class v{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],u=0,o=this._first;for(;o;)n[u++]=o.data,o=o.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const u=new r(n);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class t{constructor(){this.lastRuns=[];const n=Date.now();for(let u=0;u<t._HISTORY_LENGTH;u++)this.lastRuns[u]=n-1e3*u;setInterval(()=>{for(let u=t._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const n=Date.now(),u=(1+t._HISTORY_LENGTH)*1e3;let o=0;for(let l=0;l<t._HISTORY_LENGTH;l++)n-this.lastRuns[l]<=u&&o++;return 1-o/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class h{constructor(n,u=null,o=t.getInstance()){this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=o,this._isReconnecting=!1,this._outgoingUnackMsg=new v,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=n,this._socketWriter=new D(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),u&&this._socketReader.acceptChunk(u),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,C.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new d(5,0,0,i());this._socketWriter.write(n),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const n=Date.now()-this._socketWriter.lastWriteTime;if(n>=5e3){const u=new d(4,0,0,i());this._socketWriter.write(u),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-n+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const n=Date.now()-this._socketReader.lastReadTime;if(n>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-n,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,u){this._isReconnecting=!0,this._socketDisposables=(0,C.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=n,this._socketWriter=new D(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(o=>this._onSocketClose.fire(o))),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1;const n=this._outgoingUnackMsg.toArray();for(let u=0,o=n.length;u<o;u++)this._socketWriter.write(n[u]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(n.type===1){if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new d(6,0,0,i())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data)}else if(n.type===2)this._onControlMessage.fire(n.data);else if(n.type===5)this._onDidDispose.fire();else if(n.type===6){const u=this._outgoingUnackMsg.toArray();for(let o=0,l=u.length;o<l;o++)this._socketWriter.write(u[o]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new d(1,u,this._incomingAckId,n);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(n){const u=new d(2,0,0,n);this._socketWriter.write(u)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const n=this._outgoingUnackMsg.peek(),u=Date.now()-n.writtenTime;if(u>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-u,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new d(3,0,this._incomingAckId,i());this._socketWriter.write(n)}}e.PersistentProtocol=h}),define(fe[109],me([0,1,98]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class F{constructor(_){let S=(0,p.toUint8)(_);this._defaultValue=S,this._asciiMap=F._createAsciiMap(S),this._map=new Map}static _createAsciiMap(_){let S=new Uint8Array(256);for(let I=0;I<256;I++)S[I]=_;return S}set(_,S){let I=(0,p.toUint8)(S);_>=0&&_<256?this._asciiMap[_]=I:this._map.set(_,I)}get(_){return _>=0&&_<256?this._asciiMap[_]:this._map.get(_)||this._defaultValue}}e.CharacterClassifier=F;var C;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(C||(C={}));class y{constructor(){this._actual=new F(0)}add(_){this._actual.set(_,1)}has(_){return this._actual.get(_)===1}}e.CharacterSet=y}),define(fe[145],me([0,1,109]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var F;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(F=e.WordCharacterClass||(e.WordCharacterClass={}));class C extends p.CharacterClassifier{constructor(_){super(0);for(let S=0,I=_.length;S<I;S++)this.set(_.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=C;function y(A){let _={};return S=>(_.hasOwnProperty(S)||(_[S]=A(S)),_[S])}e.getMapForWordSeparators=y(A=>new C(A))}),define(fe[51],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class p{constructor(C,y){this.lineNumber=C,this.column=y}with(C=this.lineNumber,y=this.column){return C===this.lineNumber&&y===this.column?this:new p(C,y)}delta(C=0,y=0){return this.with(this.lineNumber+C,this.column+y)}equals(C){return p.equals(this,C)}static equals(C,y){return!C&&!y?!0:!!C&&!!y&&C.lineNumber===y.lineNumber&&C.column===y.column}isBefore(C){return p.isBefore(this,C)}static isBefore(C,y){return C.lineNumber<y.lineNumber?!0:y.lineNumber<C.lineNumber?!1:C.column<y.column}isBeforeOrEqual(C){return p.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,y){return C.lineNumber<y.lineNumber?!0:y.lineNumber<C.lineNumber?!1:C.column<=y.column}static compare(C,y){let A=C.lineNumber|0,_=y.lineNumber|0;if(A===_){let S=C.column|0,I=y.column|0;return S-I}return A-_}clone(){return new p(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new p(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}}e.Position=p}),define(fe[42],me([0,1,51]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class F{constructor(y,A,_,S){y>_||y===_&&A>S?(this.startLineNumber=_,this.startColumn=S,this.endLineNumber=y,this.endColumn=A):(this.startLineNumber=y,this.startColumn=A,this.endLineNumber=_,this.endColumn=S)}isEmpty(){return F.isEmpty(this)}static isEmpty(y){return y.startLineNumber===y.endLineNumber&&y.startColumn===y.endColumn}containsPosition(y){return F.containsPosition(this,y)}static containsPosition(y,A){return!(A.lineNumber<y.startLineNumber||A.lineNumber>y.endLineNumber||A.lineNumber===y.startLineNumber&&A.column<y.startColumn||A.lineNumber===y.endLineNumber&&A.column>y.endColumn)}containsRange(y){return F.containsRange(this,y)}static containsRange(y,A){return!(A.startLineNumber<y.startLineNumber||A.endLineNumber<y.startLineNumber||A.startLineNumber>y.endLineNumber||A.endLineNumber>y.endLineNumber||A.startLineNumber===y.startLineNumber&&A.startColumn<y.startColumn||A.endLineNumber===y.endLineNumber&&A.endColumn>y.endColumn)}strictContainsRange(y){return F.strictContainsRange(this,y)}static strictContainsRange(y,A){return!(A.startLineNumber<y.startLineNumber||A.endLineNumber<y.startLineNumber||A.startLineNumber>y.endLineNumber||A.endLineNumber>y.endLineNumber||A.startLineNumber===y.startLineNumber&&A.startColumn<=y.startColumn||A.endLineNumber===y.endLineNumber&&A.endColumn>=y.endColumn)}plusRange(y){return F.plusRange(this,y)}static plusRange(y,A){let _,S,I,i;return A.startLineNumber<y.startLineNumber?(_=A.startLineNumber,S=A.startColumn):A.startLineNumber===y.startLineNumber?(_=A.startLineNumber,S=Math.min(A.startColumn,y.startColumn)):(_=y.startLineNumber,S=y.startColumn),A.endLineNumber>y.endLineNumber?(I=A.endLineNumber,i=A.endColumn):A.endLineNumber===y.endLineNumber?(I=A.endLineNumber,i=Math.max(A.endColumn,y.endColumn)):(I=y.endLineNumber,i=y.endColumn),new F(_,S,I,i)}intersectRanges(y){return F.intersectRanges(this,y)}static intersectRanges(y,A){let _=y.startLineNumber,S=y.startColumn,I=y.endLineNumber,i=y.endColumn,k=A.startLineNumber,a=A.startColumn,g=A.endLineNumber,d=A.endColumn;return _<k?(_=k,S=a):_===k&&(S=Math.max(S,a)),I>g?(I=g,i=d):I===g&&(i=Math.min(i,d)),_>I||_===I&&S>i?null:new F(_,S,I,i)}equalsRange(y){return F.equalsRange(this,y)}static equalsRange(y,A){return!!y&&!!A&&y.startLineNumber===A.startLineNumber&&y.startColumn===A.startColumn&&y.endLineNumber===A.endLineNumber&&y.endColumn===A.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(y){return new p.Position(y.endLineNumber,y.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(y){return new p.Position(y.startLineNumber,y.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(y,A){return new F(this.startLineNumber,this.startColumn,y,A)}setStartPosition(y,A){return new F(y,A,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(y){return new F(y.startLineNumber,y.startColumn,y.startLineNumber,y.startColumn)}static fromPositions(y,A=y){return new F(y.lineNumber,y.column,A.lineNumber,A.column)}static lift(y){return y?new F(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn):null}static isIRange(y){return y&&typeof y.startLineNumber=="number"&&typeof y.startColumn=="number"&&typeof y.endLineNumber=="number"&&typeof y.endColumn=="number"}static areIntersectingOrTouching(y,A){return!(y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<A.startColumn||A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<y.startColumn)}static areIntersecting(y,A){return!(y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<=A.startColumn||A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<=y.startColumn)}static compareRangesUsingStarts(y,A){if(y&&A){const I=y.startLineNumber|0,i=A.startLineNumber|0;if(I===i){const k=y.startColumn|0,a=A.startColumn|0;if(k===a){const g=y.endLineNumber|0,d=A.endLineNumber|0;if(g===d){const w=y.endColumn|0,D=A.endColumn|0;return w-D}return g-d}return k-a}return I-i}return(y?1:0)-(A?1:0)}static compareRangesUsingEnds(y,A){return y.endLineNumber===A.endLineNumber?y.endColumn===A.endColumn?y.startLineNumber===A.startLineNumber?y.startColumn-A.startColumn:y.startLineNumber-A.startLineNumber:y.endColumn-A.endColumn:y.endLineNumber-A.endLineNumber}static spansMultipleLines(y){return y.endLineNumber>y.startLineNumber}}e.Range=F}),define(fe[146],me([0,1,51,42]),function(Y,e,p,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var C;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(C=e.SelectionDirection||(e.SelectionDirection={}));class y extends F.Range{constructor(_,S,I,i){super(_,S,I,i);this.selectionStartLineNumber=_,this.selectionStartColumn=S,this.positionLineNumber=I,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(_){return y.selectionsEqual(this,_)}static selectionsEqual(_,S){return _.selectionStartLineNumber===S.selectionStartLineNumber&&_.selectionStartColumn===S.selectionStartColumn&&_.positionLineNumber===S.positionLineNumber&&_.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(_,S){return this.getDirection()===0?new y(this.startLineNumber,this.startColumn,_,S):new y(_,S,this.startLineNumber,this.startColumn)}getPosition(){return new p.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(_,S){return this.getDirection()===0?new y(_,S,this.endLineNumber,this.endColumn):new y(this.endLineNumber,this.endColumn,_,S)}static fromPositions(_,S=_){return new y(_.lineNumber,_.column,S.lineNumber,S.column)}static liftSelection(_){return new y(_.selectionStartLineNumber,_.selectionStartColumn,_.positionLineNumber,_.positionColumn)}static selectionsArrEqual(_,S){if(_&&!S||!_&&S)return!1;if(!_&&!S)return!0;if(_.length!==S.length)return!1;for(let I=0,i=_.length;I<i;I++)if(!this.selectionsEqual(_[I],S[I]))return!1;return!0}static isISelection(_){return _&&typeof _.selectionStartLineNumber=="number"&&typeof _.selectionStartColumn=="number"&&typeof _.positionLineNumber=="number"&&typeof _.positionColumn=="number"}static createWithDirection(_,S,I,i,k){return k===0?new y(_,S,I,i):new y(I,i,_,S)}}e.Selection=y}),define(fe[110],me([0,1,25]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.BracketPairWithMinIndentation=e.BracketPair=e.IndentGuideHorizontalLine=e.IndentGuide=e.HorizontalGuidesState=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var F;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(F=e.OverviewRulerLane||(e.OverviewRulerLane={}));var C;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(C=e.MinimapPosition||(e.MinimapPosition={}));var y;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(y=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var _;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(_=e.EndOfLineSequence||(e.EndOfLineSequence={}));class S{constructor(v){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,v.tabSize|0),this.indentSize=v.tabSize|0,this.insertSpaces=Boolean(v.insertSpaces),this.defaultEOL=v.defaultEOL|0,this.trimAutoWhitespace=Boolean(v.trimAutoWhitespace),this.bracketPairColorizationOptions=v.bracketPairColorizationOptions}equals(v){return this.tabSize===v.tabSize&&this.indentSize===v.indentSize&&this.insertSpaces===v.insertSpaces&&this.defaultEOL===v.defaultEOL&&this.trimAutoWhitespace===v.trimAutoWhitespace&&(0,p.equals)(this.bracketPairColorizationOptions,v.bracketPairColorizationOptions)}createChangeEvent(v){return{tabSize:this.tabSize!==v.tabSize,indentSize:this.indentSize!==v.indentSize,insertSpaces:this.insertSpaces!==v.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==v.trimAutoWhitespace}}}e.TextModelResolvedOptions=S;class I{constructor(v,t){this._findMatchBrand=void 0,this.range=v,this.matches=t}}e.FindMatch=I;var i;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(i=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var k;(function(r){r[r.Disabled=0]="Disabled",r[r.EnabledForActive=1]="EnabledForActive",r[r.Enabled=2]="Enabled"})(k=e.HorizontalGuidesState||(e.HorizontalGuidesState={}));class a{constructor(v,t,h){this.visibleColumn=v,this.className=t,this.horizontalLine=h}}e.IndentGuide=a;class g{constructor(v,t){this.top=v,this.endColumn=t}}e.IndentGuideHorizontalLine=g;class d{constructor(v,t,h,s){this.range=v,this.openingBracketRange=t,this.closingBracketRange=h,this.nestingLevel=s}}e.BracketPair=d;class w extends d{constructor(v,t,h,s,n){super(v,t,h,s);this.minVisibleColumnIndentation=n}}e.BracketPairWithMinIndentation=w;var D;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None"})(D=e.PositionAffinity||(e.PositionAffinity={}));var T;(function(r){r[r.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(T=e.ModelConstants||(e.ModelConstants={}));class E{constructor(v,t,h,s,n,u){this.identifier=v,this.range=t,this.text=h,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=n,this._isTracked=u}}e.ValidAnnotatedEditOperation=E;class c{constructor(v,t,h){this.reverseEdits=v,this.changes=t,this.trimAutoWhitespaceLineNumbers=h}}e.ApplyEditsResult=c}),define(fe[147],me([0,1,9,145,51,42,110]),function(Y,e,p,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const _=999;class S{constructor(c,r,v,t){this.searchString=c,this.isRegex=r,this.matchCase=v,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let c;this.isRegex?c=I(this.searchString):c=this.searchString.indexOf(`
`)>=0;let r=null;try{r=p.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:c,global:!0,unicode:!0})}catch(t){return null}if(!r)return null;let v=!this.isRegex&&!c;return v&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(v=this.matchCase),new i(r,this.wordSeparators?(0,F.getMapForWordSeparators)(this.wordSeparators):null,v?this.searchString:null)}}e.SearchParams=S;function I(E){if(!E||E.length===0)return!1;for(let c=0,r=E.length;c<r;c++)if(E.charCodeAt(c)===92){if(c++,c>=r)break;const t=E.charCodeAt(c);if(t===110||t===114||t===87)return!0}return!1}e.isMultilineRegexSource=I;class i{constructor(c,r,v){this.regex=c,this.wordSeparators=r,this.simpleSearch=v}}e.SearchData=i;function k(E,c,r){if(!r)return new A.FindMatch(E,null);let v=[];for(let t=0,h=c.length;t<h;t++)v[t]=c[t];return new A.FindMatch(E,v)}e.createFindMatch=k;class a{constructor(c){let r=[],v=0;for(let t=0,h=c.length;t<h;t++)c.charCodeAt(t)===10&&(r[v++]=t);this._lineFeedsOffsets=r}findLineFeedCountBeforeOffset(c){const r=this._lineFeedsOffsets;let v=0,t=r.length-1;if(t===-1||c<=r[0])return 0;for(;v<t;){const h=v+((t-v)/2>>0);r[h]>=c?t=h-1:r[h+1]>=c?(v=h,t=h):v=h+1}return v+1}}class g{static findMatches(c,r,v,t,h){const s=r.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(c,v,new T(s.wordSeparators,s.regex),t,h):this._doFindMatchesLineByLine(c,v,s,t,h):[]}static _getMultilineMatchRange(c,r,v,t,h,s){let n,u=0;t?(u=t.findLineFeedCountBeforeOffset(h),n=r+h+u):n=r+h;let o;if(t){let f=t.findLineFeedCountBeforeOffset(h+s.length)-u;o=n+s.length+f}else o=n+s.length;const l=c.getPositionAt(n),m=c.getPositionAt(o);return new y.Range(l.lineNumber,l.column,m.lineNumber,m.column)}static _doFindMatchesMultiline(c,r,v,t,h){const s=c.getOffsetAt(r.getStartPosition()),n=c.getValueInRange(r,1),u=c.getEOL()===`\r
`?new a(n):null,o=[];let l=0,m;for(v.reset(0);m=v.next(n);)if(o[l++]=k(this._getMultilineMatchRange(c,s,n,u,m.index,m[0]),m,t),l>=h)return o;return o}static _doFindMatchesLineByLine(c,r,v,t,h){const s=[];let n=0;if(r.startLineNumber===r.endLineNumber){const o=c.getLineContent(r.startLineNumber).substring(r.startColumn-1,r.endColumn-1);return n=this._findMatchesInLine(v,o,r.startLineNumber,r.startColumn-1,n,s,t,h),s}const u=c.getLineContent(r.startLineNumber).substring(r.startColumn-1);n=this._findMatchesInLine(v,u,r.startLineNumber,r.startColumn-1,n,s,t,h);for(let o=r.startLineNumber+1;o<r.endLineNumber&&n<h;o++)n=this._findMatchesInLine(v,c.getLineContent(o),o,0,n,s,t,h);if(n<h){const o=c.getLineContent(r.endLineNumber).substring(0,r.endColumn-1);n=this._findMatchesInLine(v,o,r.endLineNumber,0,n,s,t,h)}return s}static _findMatchesInLine(c,r,v,t,h,s,n,u){const o=c.wordSeparators;if(!n&&c.simpleSearch){const b=c.simpleSearch,f=b.length,P=r.length;let L=-f;for(;(L=r.indexOf(b,L+f))!==-1;)if((!o||D(o,r,P,L,f))&&(s[h++]=new A.FindMatch(new y.Range(v,L+1+t,v,L+1+f+t),null),h>=u))return h;return h}const l=new T(c.wordSeparators,c.regex);let m;l.reset(0);do if(m=l.next(r),m&&(s[h++]=k(new y.Range(v,m.index+1+t,v,m.index+1+m[0].length+t),m,n),h>=u))return h;while(m);return h}static findNextMatch(c,r,v,t){const h=r.parseSearchRequest();if(!h)return null;const s=new T(h.wordSeparators,h.regex);return h.regex.multiline?this._doFindNextMatchMultiline(c,v,s,t):this._doFindNextMatchLineByLine(c,v,s,t)}static _doFindNextMatchMultiline(c,r,v,t){const h=new C.Position(r.lineNumber,1),s=c.getOffsetAt(h),n=c.getLineCount(),u=c.getValueInRange(new y.Range(h.lineNumber,h.column,n,c.getLineMaxColumn(n)),1),o=c.getEOL()===`\r
`?new a(u):null;v.reset(r.column-1);let l=v.next(u);return l?k(this._getMultilineMatchRange(c,s,u,o,l.index,l[0]),l,t):r.lineNumber!==1||r.column!==1?this._doFindNextMatchMultiline(c,new C.Position(1,1),v,t):null}static _doFindNextMatchLineByLine(c,r,v,t){const h=c.getLineCount(),s=r.lineNumber,n=c.getLineContent(s),u=this._findFirstMatchInLine(v,n,s,r.column,t);if(u)return u;for(let o=1;o<=h;o++){const l=(s+o-1)%h,m=c.getLineContent(l+1),b=this._findFirstMatchInLine(v,m,l+1,1,t);if(b)return b}return null}static _findFirstMatchInLine(c,r,v,t,h){c.reset(t-1);const s=c.next(r);return s?k(new y.Range(v,s.index+1,v,s.index+1+s[0].length),s,h):null}static findPreviousMatch(c,r,v,t){const h=r.parseSearchRequest();if(!h)return null;const s=new T(h.wordSeparators,h.regex);return h.regex.multiline?this._doFindPreviousMatchMultiline(c,v,s,t):this._doFindPreviousMatchLineByLine(c,v,s,t)}static _doFindPreviousMatchMultiline(c,r,v,t){const h=this._doFindMatchesMultiline(c,new y.Range(1,1,r.lineNumber,r.column),v,t,10*_);if(h.length>0)return h[h.length-1];const s=c.getLineCount();return r.lineNumber!==s||r.column!==c.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(c,new C.Position(s,c.getLineMaxColumn(s)),v,t):null}static _doFindPreviousMatchLineByLine(c,r,v,t){const h=c.getLineCount(),s=r.lineNumber,n=c.getLineContent(s).substring(0,r.column-1),u=this._findLastMatchInLine(v,n,s,t);if(u)return u;for(let o=1;o<=h;o++){const l=(h+s-o-1)%h,m=c.getLineContent(l+1),b=this._findLastMatchInLine(v,m,l+1,t);if(b)return b}return null}static _findLastMatchInLine(c,r,v,t){let h=null,s;for(c.reset(0);s=c.next(r);)h=k(new y.Range(v,s.index+1,v,s.index+1+s[0].length),s,t);return h}}e.TextModelSearch=g;function d(E,c,r,v,t){if(v===0)return!0;const h=c.charCodeAt(v-1);if(E.get(h)!==0||h===13||h===10)return!0;if(t>0){const s=c.charCodeAt(v);if(E.get(s)!==0)return!0}return!1}function w(E,c,r,v,t){if(v+t===r)return!0;const h=c.charCodeAt(v+t);if(E.get(h)!==0||h===13||h===10)return!0;if(t>0){const s=c.charCodeAt(v+t-1);if(E.get(s)!==0)return!0}return!1}function D(E,c,r,v,t){return d(E,c,r,v,t)&&w(E,c,r,v,t)}e.isValidMatch=D;class T{constructor(c,r){this._wordSeparators=c,this._searchRegex=r,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(c){this._searchRegex.lastIndex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(c){const r=c.length;let v;do{if(this._prevMatchStartIndex+this._prevMatchLength===r||(v=this._searchRegex.exec(c),!v))return null;const t=v.index,h=v[0].length;if(t===this._prevMatchStartIndex&&h===this._prevMatchLength){if(h===0){p.getNextCodePoint(c,r,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=h,!this._wordSeparators||D(this._wordSeparators,c,r,t,h))return v}while(v);return null}}e.Searcher=T}),define(fe[111],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function p(_=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const I of e.USUAL_WORD_SEPARATORS)_.indexOf(I)>=0||(S+="\\"+I);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=p();function F(_){let S=e.DEFAULT_WORD_REGEXP;if(_&&_ instanceof RegExp)if(_.global)S=_;else{let I="g";_.ignoreCase&&(I+="i"),_.multiline&&(I+="m"),_.unicode&&(I+="u"),S=new RegExp(_.source,I)}return S.lastIndex=0,S}e.ensureValidWordDefinition=F;const C={maxLen:1e3,windowSize:15,timeBudget:150};function y(_,S,I,i,k=C){if(I.length>k.maxLen){let D=_-k.maxLen/2;return D<0?D=0:i+=D,I=I.substring(D,_+k.maxLen/2),y(_,S,I,i,k)}const a=Date.now(),g=_-1-i;let d=-1,w=null;for(let D=1;!(Date.now()-a>=k.timeBudget);D++){const T=g-k.windowSize*D;S.lastIndex=Math.max(0,T);const E=A(S,I,g,d);if(!E&&w||(w=E,T<=0))break;d=T}if(w){let D={word:w[0],startColumn:i+1+w.index,endColumn:i+1+w.index+w[0].length};return S.lastIndex=0,D}return null}e.getWordAtText=y;function A(_,S,I,i){let k;for(;k=_.exec(S);){const a=k.index||0;if(a<=I&&_.lastIndex>=I)return k;if(i>0&&a>i)return null}return null}}),define(fe[148],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var p;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(p=e.IndentAction||(e.IndentAction={}));class F{constructor(_){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=_.open,this.close=_.close,this._standardTokenMask=0,Array.isArray(_.notIn))for(let S=0,I=_.notIn.length;S<I;S++)switch(_.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(_){return(this._standardTokenMask&_)==0}}e.StandardAutoClosingPairConditional=F;class C{constructor(_){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of _)y(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),y(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),y(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),y(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&y(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=C;function y(A,_,S){A.has(_)?A.get(_).push(S):A.set(_,[S])}}),define(fe[82],me([0,1,30,8]),function(Y,e,p,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function C(y,A,_,S){if(Array.isArray(y)){let I=0;for(const i of y){const k=C(i,A,_,S);if(k===10)return k;k>I&&(I=k)}return I}else{if(typeof y=="string")return S?y==="*"?5:y===_?10:0:0;if(y){const{language:I,pattern:i,scheme:k,hasAccessToAllModels:a}=y;if(!S&&!a)return 0;let g=0;if(k)if(k===A.scheme)g=10;else if(k==="*")g=5;else return 0;if(I)if(I===_)g=10;else if(I==="*")g=Math.max(g,5);else return 0;if(i){let d;if(typeof i=="string"?d=i:d={...i,base:(0,F.normalize)(i.base)},d===A.fsPath||(0,p.match)(d,A.fsPath))g=10;else return 0}return g}else return 0}}e.score=C}),define(fe[149],me([0,1,109]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var F;(function(g){g[g.Invalid=0]="Invalid",g[g.Start=1]="Start",g[g.H=2]="H",g[g.HT=3]="HT",g[g.HTT=4]="HTT",g[g.HTTP=5]="HTTP",g[g.F=6]="F",g[g.FI=7]="FI",g[g.FIL=8]="FIL",g[g.BeforeColon=9]="BeforeColon",g[g.AfterColon=10]="AfterColon",g[g.AlmostThere=11]="AlmostThere",g[g.End=12]="End",g[g.Accept=13]="Accept",g[g.LastKnownState=14]="LastKnownState"})(F=e.State||(e.State={}));class C{constructor(d,w,D){const T=new Uint8Array(d*w);for(let E=0,c=d*w;E<c;E++)T[E]=D;this._data=T,this.rows=d,this.cols=w}get(d,w){return this._data[d*this.cols+w]}set(d,w,D){this._data[d*this.cols+w]=D}}e.Uint8Matrix=C;class y{constructor(d){let w=0,D=0;for(let E=0,c=d.length;E<c;E++){let[r,v,t]=d[E];v>w&&(w=v),r>D&&(D=r),t>D&&(D=t)}w++,D++;let T=new C(D,w,0);for(let E=0,c=d.length;E<c;E++){let[r,v,t]=d[E];T.set(r,v,t)}this._states=T,this._maxCharCode=w}nextState(d,w){return w<0||w>=this._maxCharCode?0:this._states.get(d,w)}}e.StateMachine=y;let A=null;function _(){return A===null&&(A=new y([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var S;(function(g){g[g.None=0]="None",g[g.ForceTermination=1]="ForceTermination",g[g.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let I=null;function i(){if(I===null){I=new p.CharacterClassifier(0);const g=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<g.length;w++)I.set(g.charCodeAt(w),1);const d=".,;";for(let w=0;w<d.length;w++)I.set(d.charCodeAt(w),2)}return I}class k{static _createLink(d,w,D,T,E){let c=E-1;do{const r=w.charCodeAt(c);if(d.get(r)!==2)break;c--}while(c>T);if(T>0){const r=w.charCodeAt(T-1),v=w.charCodeAt(c);(r===40&&v===41||r===91&&v===93||r===123&&v===125)&&c--}return{range:{startLineNumber:D,startColumn:T+1,endLineNumber:D,endColumn:c+2},url:w.substring(T,c+1)}}static computeLinks(d,w=_()){const D=i();let T=[];for(let E=1,c=d.getLineCount();E<=c;E++){const r=d.getLineContent(E),v=r.length;let t=0,h=0,s=0,n=1,u=!1,o=!1,l=!1,m=!1;for(;t<v;){let b=!1;const f=r.charCodeAt(t);if(n===13){let P;switch(f){case 40:u=!0,P=0;break;case 41:P=u?0:1;break;case 91:l=!0,o=!0,P=0;break;case 93:l=!1,P=o?0:1;break;case 123:m=!0,P=0;break;case 125:P=m?0:1;break;case 39:P=s===34||s===96?0:1;break;case 34:P=s===39||s===96?0:1;break;case 96:P=s===39||s===34?0:1;break;case 42:P=s===42?1:0;break;case 124:P=s===124?1:0;break;case 32:P=l?0:1;break;default:P=D.get(f)}P===1&&(T.push(k._createLink(D,r,E,h,t)),b=!0)}else if(n===12){let P;f===91?(o=!0,P=0):P=D.get(f),P===1?b=!0:n=13}else n=w.nextState(n,f),n===0&&(b=!0);b&&(n=1,u=!1,o=!1,m=!1,h=t+1,s=f),t++}n===13&&T.push(k._createLink(D,r,E,h,v))}return T}}e.LinkComputer=k;function a(g){return!g||typeof g.getLineCount!="function"||typeof g.getLineContent!="function"?[]:k.computeLinks(g)}e.computeLinks=a}),define(fe[150],me([0,1,3,6]),function(Y,e,p,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class C{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new p.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(A){this._onDidChange.fire({changedLanguages:A,changedColorMap:!1})}register(A,_){return this._map.set(A,_),this.fire([A]),(0,F.toDisposable)(()=>{this._map.get(A)===_&&(this._map.delete(A),this.fire([A]))})}registerPromise(A,_){let S=null,I=!1;return this._promises.set(A,_.then(i=>{this._promises.delete(A),!(I||!i)&&(S=this.register(A,i))})),(0,F.toDisposable)(()=>{I=!0,S&&S.dispose()})}getPromise(A){const _=this.get(A);if(_)return Promise.resolve(_);const S=this._promises.get(A);return S?S.then(I=>this.get(A)):null}get(A){return this._map.get(A)||null}setColorMap(A){this._colorMap=A,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=C}),define(fe[112],me([0,1,22,11]),function(Y,e,p,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var C;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(C||(C={}));function y(k){for(let a=0,g=k.length;a<g;a+=4){const d=k[a+0],w=k[a+1],D=k[a+2],T=k[a+3];k[a+0]=T,k[a+1]=D,k[a+2]=w,k[a+3]=d}}function A(k){const a=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return F.isLittleEndian()||y(a),p.VSBuffer.wrap(a)}function _(k){const a=k.buffer;if(F.isLittleEndian()||y(a),a.byteOffset%4==0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const g=new Uint8Array(a.byteLength);return g.set(a),new Uint32Array(g.buffer,g.byteOffset,g.length/4)}}function S(k){const a=new Uint32Array(I(k));let g=0;if(a[g++]=k.id,k.type==="full")a[g++]=1,a[g++]=k.data.length,a.set(k.data,g),g+=k.data.length;else{a[g++]=2,a[g++]=k.deltas.length;for(const d of k.deltas)a[g++]=d.start,a[g++]=d.deleteCount,d.data?(a[g++]=d.data.length,a.set(d.data,g),g+=d.data.length):a[g++]=0}return A(a)}e.encodeSemanticTokensDto=S;function I(k){let a=0;if(a+=1+1,k.type==="full")a+=1+k.data.length;else{a+=1,a+=(1+1+1)*k.deltas.length;for(const g of k.deltas)g.data&&(a+=g.data.length)}return a}function i(k){const a=_(k);let g=0;const d=a[g++];if(a[g++]===1){const E=a[g++],c=a.subarray(g,g+E);return g+=E,{id:d,type:"full",data:c}}const D=a[g++];let T=[];for(let E=0;E<D;E++){const c=a[g++],r=a[g++],v=a[g++];let t;v>0&&(t=a.subarray(g,g+v),g+=v),T[E]={start:c,deleteCount:r,data:t}}return{id:d,type:"delta",deltas:T}}e.decodeSemanticTokensDto=i}),define(fe[113],me([0,1,98]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class F{constructor(A,_){this._prefixSumIndexOfResultBrand=void 0,this.index=A,this.remainder=_}}e.PrefixSumIndexOfResult=F;class C{constructor(A){this.values=A,this.prefixSum=new Uint32Array(A.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(A,_){A=(0,p.toUint32)(A);const S=this.values,I=this.prefixSum,i=_.length;return i===0?!1:(this.values=new Uint32Array(S.length+i),this.values.set(S.subarray(0,A),0),this.values.set(S.subarray(A),A+i),this.values.set(_,A),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(A,_){return A=(0,p.toUint32)(A),_=(0,p.toUint32)(_),this.values[A]===_?!1:(this.values[A]=_,A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),!0)}removeValues(A,_){A=(0,p.toUint32)(A),_=(0,p.toUint32)(_);const S=this.values,I=this.prefixSum;if(A>=S.length)return!1;let i=S.length-A;return _>=i&&(_=i),_===0?!1:(this.values=new Uint32Array(S.length-_),this.values.set(S.subarray(0,A),0),this.values.set(S.subarray(A+_),A),this.prefixSum=new Uint32Array(this.values.length),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(A){return A<0?0:(A=(0,p.toUint32)(A),this._getPrefixSum(A))}_getPrefixSum(A){if(A<=this.prefixSumValidIndex[0])return this.prefixSum[A];let _=this.prefixSumValidIndex[0]+1;_===0&&(this.prefixSum[0]=this.values[0],_++),A>=this.values.length&&(A=this.values.length-1);for(let S=_;S<=A;S++)this.prefixSum[S]=this.prefixSum[S-1]+this.values[S];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],A),this.prefixSum[A]}getIndexOf(A){A=Math.floor(A),this.getTotalSum();let _=0,S=this.values.length-1,I=0,i=0,k=0;for(;_<=S;)if(I=_+(S-_)/2|0,i=this.prefixSum[I],k=i-this.values[I],A<k)S=I-1;else if(A>=i)_=I+1;else break;return new F(I,A-k)}}e.PrefixSumComputer=C}),define(fe[151],me([0,1,9,51,113]),function(Y,e,p,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class y{constructor(_,S,I,i){this._uri=_,this._lines=S,this._eol=I,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(_){_.eol&&_.eol!==this._eol&&(this._eol=_.eol,this._lineStarts=null);const S=_.changes;for(const I of S)this._acceptDeleteRange(I.range),this._acceptInsertText(new F.Position(I.range.startLineNumber,I.range.startColumn),I.text);this._versionId=_.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const _=this._eol.length,S=this._lines.length,I=new Uint32Array(S);for(let i=0;i<S;i++)I[i]=this._lines[i].length+_;this._lineStarts=new C.PrefixSumComputer(I)}}_setLineText(_,S){this._lines[_]=S,this._lineStarts&&this._lineStarts.changeValue(_,this._lines[_].length+this._eol.length)}_acceptDeleteRange(_){if(_.startLineNumber===_.endLineNumber){if(_.startColumn===_.endColumn)return;this._setLineText(_.startLineNumber-1,this._lines[_.startLineNumber-1].substring(0,_.startColumn-1)+this._lines[_.startLineNumber-1].substring(_.endColumn-1));return}this._setLineText(_.startLineNumber-1,this._lines[_.startLineNumber-1].substring(0,_.startColumn-1)+this._lines[_.endLineNumber-1].substring(_.endColumn-1)),this._lines.splice(_.startLineNumber,_.endLineNumber-_.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(_.startLineNumber,_.endLineNumber-_.startLineNumber)}_acceptInsertText(_,S){if(S.length===0)return;let I=(0,p.splitLines)(S);if(I.length===1){this._setLineText(_.lineNumber-1,this._lines[_.lineNumber-1].substring(0,_.column-1)+I[0]+this._lines[_.lineNumber-1].substring(_.column-1));return}I[I.length-1]+=this._lines[_.lineNumber-1].substring(_.column-1),this._setLineText(_.lineNumber-1,this._lines[_.lineNumber-1].substring(0,_.column-1)+I[0]);let i=new Uint32Array(I.length-1);for(let k=1;k<I.length;k++)this._lines.splice(_.lineNumber+k-1,0,I[k]),i[k-1]=I[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(_.lineNumber,i)}}e.MirrorTextModel=y}),define(fe[152],me([19,20]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(fe[153],me([0,1,152]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const F=60,C=F*60,y=C*24,A=y*7,_=y*30,S=y*365;function I(k,a){typeof k!="number"&&(k=k.getTime());const g=Math.round((new Date().getTime()-k)/1e3);if(g<-30)return(0,p.localize)(0,null,I(new Date().getTime()+g*1e3,!1));if(g<30)return(0,p.localize)(1,null);let d;return g<F?(d=g,a?d===1?(0,p.localize)(2,null,d):(0,p.localize)(3,null,d):d===1?(0,p.localize)(4,null,d):(0,p.localize)(5,null,d)):g<C?(d=Math.floor(g/F),a?d===1?(0,p.localize)(6,null,d):(0,p.localize)(7,null,d):d===1?(0,p.localize)(8,null,d):(0,p.localize)(9,null,d)):g<y?(d=Math.floor(g/C),a?d===1?(0,p.localize)(10,null,d):(0,p.localize)(11,null,d):d===1?(0,p.localize)(12,null,d):(0,p.localize)(13,null,d)):g<A?(d=Math.floor(g/y),a?d===1?(0,p.localize)(14,null,d):(0,p.localize)(15,null,d):d===1?(0,p.localize)(16,null,d):(0,p.localize)(17,null,d)):g<_?(d=Math.floor(g/A),a?d===1?(0,p.localize)(18,null,d):(0,p.localize)(19,null,d):d===1?(0,p.localize)(20,null,d):(0,p.localize)(21,null,d)):g<S?(d=Math.floor(g/_),a?d===1?(0,p.localize)(22,null,d):(0,p.localize)(23,null,d):d===1?(0,p.localize)(24,null,d):(0,p.localize)(25,null,d)):(d=Math.floor(g/S),a?d===1?(0,p.localize)(26,null,d):(0,p.localize)(27,null,d):d===1?(0,p.localize)(28,null,d):(0,p.localize)(29,null,d))}e.fromNow=I;function i(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(fe[154],me([19,20]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(fe[52],me([0,1,18,12,154]),function(Y,e,p,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function y(I,i){return i&&(I.stack||I.stacktrace)?C.localize(0,null,_(I),A(I.stack)||A(I.stacktrace)):_(I)}function A(I){return Array.isArray(I)?I.join(`
`):I}function _(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?C.localize(1,null,I.message):I.message||C.localize(2,null)}function S(I=null,i=!1){if(!I)return C.localize(3,null);if(Array.isArray(I)){const k=p.coalesce(I),a=S(k[0],i);return k.length>1?C.localize(4,null,a,k.length):a}if(F.isString(I))return I;if(I.detail){const k=I.detail;if(k.error)return y(k.error,i);if(k.exception)return y(k.exception,i)}return I.stack?y(I,i):I.message?I.message:C.localize(5,null)}e.toErrorMessage=S}),define(fe[155],me([19,20]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(fe[114],me([0,1,39,29,10,25,8,11,38,96,12,144,28,155]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function d(v){switch(v){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function w(v,t){if(_.isWindows)try{const h={stdio:["pipe","pipe","ignore"]};t&&(h.cwd=t);const s=p.execFile("taskkill",["/T","/F","/PID",v.pid.toString()],h);return new Promise(n=>{s.once("error",u=>{n({success:!1,error:u})}),s.once("exit",(u,o)=>{n(u===0?{success:!0}:{success:!1,code:u!==null?u:1})})})}catch(h){return Promise.resolve({success:!1,error:h,code:h.status?d(h.status):1})}else if(_.isLinux||_.isMacintosh)try{const h=C.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(s=>{p.execFile(h,[v.pid.toString()],{encoding:"utf8",shell:!0},(n,u,o)=>{s(n?{success:!1,error:n}:{success:!0})})})}catch(h){return Promise.resolve({success:!1,error:h})}else v.kill("SIGKILL");return Promise.resolve({success:!0})}function D(v=S.env){return v.comspec||"cmd.exe"}e.getWindowsShell=D;class T{constructor(t,h,s,n){if(h!==void 0&&s!==void 0&&n!==void 0)this.cmd=t,this.args=h,this.shell=s,this.options=n;else{const u=t;this.cmd=u.command,this.shell=u.isShellCommand,this.args=u.args.slice(0),this.options=u.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const u=Object.create(null);Object.keys(S.env).forEach(o=>{u[o]=S.env[o]}),Object.keys(this.options.env).forEach(o=>{u[o]=this.options.env[o]}),this.options.env=u}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const h=t.lastIndexOf(A.sep);return h!==-1&&(t=t.substring(h+1)),T.WellKnowCommands[t]?t:"other"}start(t){return _.isWindows&&(this.options&&this.options.cwd&&F.isUNC(this.options.cwd)||!this.options&&F.isUNC(S.cwd()))?Promise.reject(new Error(g.localize(0,null))):this.useExec().then(h=>{let s,n;const u=new Promise((o,l)=>{s=o,n=l});if(h){let o=this.cmd;this.args&&(o=o+" "+this.args.join(" ")),this.childProcess=p.exec(o,this.options,(l,m,b)=>{this.childProcess=null;const f=l;f&&f.killed?n({killed:this.terminateRequested,stdout:m.toString(),stderr:b.toString()}):this.handleExec(s,t,l,m,b)})}else{let o=null;const l=m=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(m,s,t,n);const b={terminated:this.terminateRequested};i.isNumber(m)&&(b.cmdCode=m),s(b)};if(this.shell&&_.isWindows){const m=y.deepClone(this.options);m.windowsVerbatimArguments=!0,m.detached=!1;let b=!1,f=!1;const P=[];let L=this.ensureQuotes(this.cmd);P.push(L.value),b=L.quoted,this.args&&this.args.forEach(R=>{L=this.ensureQuotes(R),P.push(L.value),f=f&&L.quoted});const M=["/s","/c"];b?f?M.push('"'+P.join(" ")+'"'):P.length>1?M.push('"'+P[0]+'" '+P.slice(1).join(" ")):M.push('"'+P[0]+'"'):M.push(P.join(" ")),o=p.spawn(D(),M,m)}else this.cmd&&(o=p.spawn(this.cmd,this.args,this.options));o&&(this.childProcess=o,this.childProcessPromise=Promise.resolve(o),this.pidResolve&&(this.pidResolve(i.isNumber(o.pid)?o.pid:-1),this.pidResolve=void 0),o.on("error",m=>{this.childProcess=null,n({terminated:this.terminateRequested,error:m})}),o.pid&&(this.childProcess.on("close",l),this.handleSpawn(o,s,t,n,!0)))}return u})}handleClose(t,h,s,n){}ensureQuotes(t){return T.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,w(t,this.options.cwd).then(h=>(h.success&&(this.childProcess=null),h))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!_.isWindows)return t(!1);const h=p.spawn(D(),["/s","/c"]);h.on("error",s=>t(!0)),h.on("exit",s=>t(!1))})}}e.AbstractProcess=T,T.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},T.regexp=/^[^"].* .*[^"]/;class E extends T{constructor(t,h,s,n){super(t,h,s,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,h,s,n,u){[n,u].forEach((o,l)=>{const m=new k.LineDecoder;m.write(o).forEach(P=>{h({line:P,source:l===0?0:1})});const f=m.end();f&&h({line:f,source:l===0?0:1})}),t({terminated:this.terminateRequested,error:s})}handleSpawn(t,h,s,n,u){const o=new k.LineDecoder,l=new k.LineDecoder;t.stdout.on("data",m=>{o.write(m).forEach(f=>s({line:f,source:0}))}),t.stderr.on("data",m=>{l.write(m).forEach(f=>s({line:f,source:1}))}),this.stdoutLineDecoder=o,this.stderrLineDecoder=l}handleClose(t,h,s,n){const u=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;u&&s({line:u,source:0});const o=this.stderrLineDecoder?this.stderrLineDecoder.end():null;o&&s({line:o,source:1})}}e.LineProcess=E;function c(v){let t=[],h=!1;const s=function(n){if(h){t.push(n);return}(!v.send(n,o=>{if(o&&console.error(o),h=!1,t.length>0){const l=t.slice(0);t=[],l.forEach(m=>s(m))}})||_.isWindows)&&(h=!0)};return{send:s}}e.createQueuedSender=c;var r;(function(v){async function t(h,s,n){if(A.isAbsolute(h))return h;if(s===void 0&&(s=S.cwd()),A.dirname(h)!=="."||(n===void 0&&i.isString(S.env.PATH)&&(n=S.env.PATH.split(A.delimiter)),n===void 0||n.length===0))return A.join(s,h);async function o(l){if(await a.Promises.exists(l)){let m;try{m=await a.Promises.stat(l)}catch(b){b.message.startsWith("EACCES")&&(m=await a.Promises.lstat(l))}return m?!m.isDirectory():!1}return!1}for(let l of n){let m;if(A.isAbsolute(l)?m=A.join(l,h):m=A.join(s,l,h),await o(m))return m;let b=m+".com";if(await o(b)||(b=m+".exe",await o(b)))return b}return A.join(s,h)}v.findExecutable=t})(r=e.win32||(e.win32={}))}),define(fe[156],me([19,20]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(fe[115],me([0,1,156,11,111]),function(Y,e,p,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(J){J[J.None=0]="None",J[J.Keep=1]="Keep",J[J.Brackets=2]="Brackets",J[J.Advanced=3]="Advanced",J[J.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class A{constructor(te){this._values=te}hasChanged(te){return this._values[te]}}e.ConfigurationChangedEvent=A;class _{constructor(){this._values=[]}_read(te){return this._values[te]}get(te){return this._values[te]}_write(te,ve){this._values[te]=ve}}e.ValidatedEditorOptions=_;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class I{constructor(te,ve,Qe,tt){this.id=te,this.name=ve,this.defaultValue=Qe,this.schema=tt}compute(te,ve,Qe){return Qe}}class i{constructor(te,ve=null){this.schema=void 0,this.id=te,this.name="_never_",this.defaultValue=void 0,this.deps=ve}validate(te){return this.defaultValue}}class k{constructor(te,ve,Qe,tt){this.id=te,this.name=ve,this.defaultValue=Qe,this.schema=tt}validate(te){return typeof te=="undefined"?this.defaultValue:te}compute(te,ve,Qe){return Qe}}function a(J,te){return typeof J=="undefined"?te:J==="false"?!1:Boolean(J)}e.boolean=a;class g extends k{constructor(te,ve,Qe,tt=void 0){typeof tt!="undefined"&&(tt.type="boolean",tt.default=Qe),super(te,ve,Qe,tt)}validate(te){return a(te,this.defaultValue)}}function d(J,te,ve,Qe){if(typeof J=="undefined")return te;let tt=parseInt(J,10);return isNaN(tt)?te:(tt=Math.max(ve,tt),tt=Math.min(Qe,tt),tt|0)}e.clampedInt=d;class w extends k{constructor(te,ve,Qe,tt,ct,ce=void 0){typeof ce!="undefined"&&(ce.type="integer",ce.default=Qe,ce.minimum=tt,ce.maximum=ct),super(te,ve,Qe,ce),this.minimum=tt,this.maximum=ct}static clampedInt(te,ve,Qe,tt){return d(te,ve,Qe,tt)}validate(te){return w.clampedInt(te,this.defaultValue,this.minimum,this.maximum)}}class D extends k{constructor(te,ve,Qe,tt,ct){typeof ct!="undefined"&&(ct.type="number",ct.default=Qe),super(te,ve,Qe,ct),this.validationFn=tt}static clamp(te,ve,Qe){return te<ve?ve:te>Qe?Qe:te}static float(te,ve){if(typeof te=="number")return te;if(typeof te=="undefined")return ve;const Qe=parseFloat(te);return isNaN(Qe)?ve:Qe}validate(te){return this.validationFn(D.float(te,this.defaultValue))}}class T extends k{static string(te,ve){return typeof te!="string"?ve:te}constructor(te,ve,Qe,tt=void 0){typeof tt!="undefined"&&(tt.type="string",tt.default=Qe),super(te,ve,Qe,tt)}validate(te){return T.string(te,this.defaultValue)}}function E(J,te,ve){return typeof J!="string"||ve.indexOf(J)===-1?te:J}e.stringSet=E;class c extends k{constructor(te,ve,Qe,tt,ct=void 0){typeof ct!="undefined"&&(ct.type="string",ct.enum=tt,ct.default=Qe),super(te,ve,Qe,ct),this._allowedValues=tt}validate(te){return E(te,this.defaultValue,this._allowedValues)}}class r extends I{constructor(te,ve,Qe,tt,ct,ce,Ie=void 0){typeof Ie!="undefined"&&(Ie.type="string",Ie.enum=ct,Ie.default=tt),super(te,ve,Qe,Ie),this._allowedValues=ct,this._convert=ce}validate(te){return typeof te!="string"?this.defaultValue:this._allowedValues.indexOf(te)===-1?this.defaultValue:this._convert(te)}}function v(J){switch(J){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class t extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",description:p.localize(3,null)})}validate(te){switch(te){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(te,ve,Qe){return Qe===0?te.accessibilitySupport:Qe}}class h extends I{constructor(){const te={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",te,{"editor.comments.insertSpace":{type:"boolean",default:te.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:te.ignoreEmptyLines,description:p.localize(5,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{insertSpace:a(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:a(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(J){J[J.Hidden=0]="Hidden",J[J.Blink=1]="Blink",J[J.Smooth=2]="Smooth",J[J.Phase=3]="Phase",J[J.Expand=4]="Expand",J[J.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function n(J){switch(J){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var u;(function(J){J[J.Line=1]="Line",J[J.Block=2]="Block",J[J.Underline=3]="Underline",J[J.LineThin=4]="LineThin",J[J.BlockOutline=5]="BlockOutline",J[J.UnderlineThin=6]="UnderlineThin"})(u=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function o(J){switch(J){case u.Line:return"line";case u.Block:return"block";case u.Underline:return"underline";case u.LineThin:return"line-thin";case u.BlockOutline:return"block-outline";case u.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=o;function l(J){switch(J){case"line":return u.Line;case"block":return u.Block;case"underline":return u.Underline;case"line-thin":return u.LineThin;case"block-outline":return u.BlockOutline;case"underline-thin":return u.UnderlineThin}}class m extends i{constructor(){super(126,[65,33])}compute(te,ve,Qe){const tt=["monaco-editor"];return ve.get(33)&&tt.push(ve.get(33)),te.extraEditorClassName&&tt.push(te.extraEditorClassName),ve.get(65)==="default"?tt.push("mouse-default"):ve.get(65)==="copy"&&tt.push("mouse-copy"),ve.get(99)&&tt.push("showUnused"),ve.get(124)&&tt.push("showDeprecated"),tt.join(" ")}}class b extends g{constructor(){super(32,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(te,ve,Qe){return Qe&&te.emptySelectionClipboard}}class f extends I{constructor(){const te={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",te,{"editor.find.cursorMoveOnType":{type:"boolean",default:te.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:te.seedSearchStringFromSelection,enumDescriptions:[p.localize(8,null),p.localize(9,null),p.localize(10,null)],description:p.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:te.autoFindInSelection,enumDescriptions:[p.localize(12,null),p.localize(13,null),p.localize(14,null)],description:p.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:te.globalFindClipboard,description:p.localize(16,null),included:F.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:te.addExtraSpaceOnTop,description:p.localize(17,null)},"editor.find.loop":{type:"boolean",default:te.loop,description:p.localize(18,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{cursorMoveOnType:a(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof te.seedSearchStringFromSelection=="boolean"?te.seedSearchStringFromSelection?"always":"never":E(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof te.autoFindInSelection=="boolean"?te.autoFindInSelection?"always":"never":E(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:a(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:a(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:a(ve.loop,this.defaultValue.loop)}}}class P extends I{constructor(){super(44,"fontLigatures",P.OFF,{anyOf:[{type:"boolean",description:p.localize(19,null)},{type:"string",description:p.localize(20,null)}],description:p.localize(21,null),default:!1})}validate(te){return typeof te=="undefined"?this.defaultValue:typeof te=="string"?te==="false"?P.OFF:te==="true"?P.ON:te:Boolean(te)?P.ON:P.OFF}}e.EditorFontLigatures=P,P.OFF='"liga" off, "calt" off',P.ON='"liga" on, "calt" on';class L extends i{constructor(){super(43)}compute(te,ve,Qe){return te.fontInfo}}class M extends k{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(22,null)})}validate(te){let ve=D.float(te,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:D.clamp(ve,6,100)}compute(te,ve,Qe){return te.fontInfo.fontSize}}class R extends I{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:R.MINIMUM_VALUE,maximum:R.MAXIMUM_VALUE,errorMessage:p.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:R.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(24,null)})}validate(te){return te==="normal"||te==="bold"?te:String(w.clampedInt(te,e.EDITOR_FONT_DEFAULTS.fontWeight,R.MINIMUM_VALUE,R.MAXIMUM_VALUE))}}R.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],R.MINIMUM_VALUE=1,R.MAXIMUM_VALUE=1e3;class W extends I{constructor(){const te={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:te.multiple,enumDescriptions:[p.localize(25,null),p.localize(26,null),p.localize(27,null)]},Qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",te,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(29,null),...ve},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(30,null),...ve},"editor.gotoLocation.multipleDeclarations":{description:p.localize(31,null),...ve},"editor.gotoLocation.multipleImplementations":{description:p.localize(32,null),...ve},"editor.gotoLocation.multipleReferences":{description:p.localize(33,null),...ve},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:te.alternativeDefinitionCommand,enum:Qe,description:p.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:te.alternativeTypeDefinitionCommand,enum:Qe,description:p.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:te.alternativeDeclarationCommand,enum:Qe,description:p.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:te.alternativeImplementationCommand,enum:Qe,description:p.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:te.alternativeReferenceCommand,enum:Qe,description:p.localize(38,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{multiple:E(ve.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ve.multipleDefinitions??E(ve.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ve.multipleTypeDefinitions??E(ve.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ve.multipleDeclarations??E(ve.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ve.multipleImplementations??E(ve.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ve.multipleReferences??E(ve.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:T.string(ve.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:T.string(ve.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:T.string(ve.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:T.string(ve.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:T.string(ve.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class V extends I{constructor(){const te={enabled:!0,delay:300,sticky:!0};super(52,"hover",te,{"editor.hover.enabled":{type:"boolean",default:te.enabled,description:p.localize(39,null)},"editor.hover.delay":{type:"number",default:te.delay,description:p.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:te.sticky,description:p.localize(41,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:a(ve.enabled,this.defaultValue.enabled),delay:w.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:a(ve.sticky,this.defaultValue.sticky)}}}var N;(function(J){J[J.None=0]="None",J[J.Text=1]="Text",J[J.Blocks=2]="Blocks"})(N=e.RenderMinimap||(e.RenderMinimap={}));class j extends i{constructor(){super(129,[49,57,37,64,91,59,60,93,116,119,120,121,2])}compute(te,ve,Qe){return j.computeLayout(ve,{memory:te.memory,outerWidth:te.outerWidth,outerHeight:te.outerHeight,isDominatedByLongLines:te.isDominatedByLongLines,lineHeight:te.fontInfo.lineHeight,viewLineCount:te.viewLineCount,lineNumbersDigitCount:te.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:te.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:te.fontInfo.maxDigitWidth,pixelRatio:te.pixelRatio})}static computeContainedMinimapLineCount(te){const ve=te.height/te.lineHeight,Qe=te.scrollBeyondLastLine?ve-1:0,tt=(te.viewLineCount+Qe)/(te.pixelRatio*te.height),ct=Math.floor(te.viewLineCount/tt);return{typicalViewportLineCount:ve,extraLinesBeyondLastLine:Qe,desiredRatio:tt,minimapLineCount:ct}}static _computeMinimapLayout(te,ve){const Qe=te.outerWidth,tt=te.outerHeight,ct=te.pixelRatio;if(!te.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ct*tt),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:tt};const ce=ve.stableMinimapLayoutInput,Ie=ce&&te.outerHeight===ce.outerHeight&&te.lineHeight===ce.lineHeight&&te.typicalHalfwidthCharacterWidth===ce.typicalHalfwidthCharacterWidth&&te.pixelRatio===ce.pixelRatio&&te.scrollBeyondLastLine===ce.scrollBeyondLastLine&&te.minimap.enabled===ce.minimap.enabled&&te.minimap.side===ce.minimap.side&&te.minimap.size===ce.minimap.size&&te.minimap.showSlider===ce.minimap.showSlider&&te.minimap.renderCharacters===ce.minimap.renderCharacters&&te.minimap.maxColumn===ce.minimap.maxColumn&&te.minimap.scale===ce.minimap.scale&&te.verticalScrollbarWidth===ce.verticalScrollbarWidth&&te.isViewportWrapping===ce.isViewportWrapping,Ue=te.lineHeight,Xe=te.typicalHalfwidthCharacterWidth,rt=te.scrollBeyondLastLine,ht=te.minimap.renderCharacters;let Ye=ct>=2?Math.round(te.minimap.scale*2):te.minimap.scale;const vt=te.minimap.maxColumn,Re=te.minimap.size,Ce=te.minimap.side,Pe=te.verticalScrollbarWidth,se=te.viewLineCount,ue=te.remainingWidth,be=te.isViewportWrapping,we=ht?2:3;let Fe=Math.floor(ct*tt);const qe=Fe/ct;let ze=!1,et=!1,at=we*Ye,Be=Ye/ct,ge=1;if(Re==="fill"||Re==="fit"){const{typicalViewportLineCount:Ge,extraLinesBeyondLastLine:pt,desiredRatio:Et,minimapLineCount:ft}=j.computeContainedMinimapLineCount({viewLineCount:se,scrollBeyondLastLine:rt,height:tt,lineHeight:Ue,pixelRatio:ct});if(se/ft>1)ze=!0,et=!0,Ye=1,at=1,Be=Ye/ct;else{let mt=!1,_t=Ye+1;if(Re==="fit"){const Dt=Math.ceil((se+pt)*at);be&&Ie&&ue<=ve.stableFitRemainingWidth?(mt=!0,_t=ve.stableFitMaxMinimapScale):mt=Dt>Fe}if(Re==="fill"||mt){ze=!0;const Dt=Ye;at=Math.min(Ue*ct,Math.max(1,Math.floor(1/Et))),be&&Ie&&ue<=ve.stableFitRemainingWidth&&(_t=ve.stableFitMaxMinimapScale),Ye=Math.min(_t,Math.max(1,Math.floor(at/we))),Ye>Dt&&(ge=Math.min(2,Ye/Dt)),Be=Ye/ct/ge,Fe=Math.ceil(Math.max(Ge,se+pt)*at),be?(ve.stableMinimapLayoutInput=te,ve.stableFitRemainingWidth=ue,ve.stableFitMaxMinimapScale=Ye):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0)}}}const Ee=Math.floor(vt*Be),ne=Math.min(Ee,Math.max(0,Math.floor((ue-Pe-2)*Be/(Xe+Be)))+e.MINIMAP_GUTTER_WIDTH);let K=Math.floor(ct*ne);const Se=K/ct;K=Math.floor(K*ge);const Le=ht?1:2,it=Ce==="left"?0:Qe-ne-Pe;return{renderMinimap:Le,minimapLeft:it,minimapWidth:ne,minimapHeightIsEditorHeight:ze,minimapIsSampling:et,minimapScale:Ye,minimapLineHeight:at,minimapCanvasInnerWidth:K,minimapCanvasInnerHeight:Fe,minimapCanvasOuterWidth:Se,minimapCanvasOuterHeight:qe}}static computeLayout(te,ve){const Qe=ve.outerWidth|0,tt=ve.outerHeight|0,ct=ve.lineHeight|0,ce=ve.lineNumbersDigitCount|0,Ie=ve.typicalHalfwidthCharacterWidth,Ue=ve.maxDigitWidth,Xe=ve.pixelRatio,rt=ve.viewLineCount,ht=te.get(121),Ye=ht==="inherit"?te.get(120):ht,vt=Ye==="inherit"?te.get(116):Ye,Re=te.get(119),Ce=te.get(2),Pe=ve.isDominatedByLongLines,se=te.get(49),ue=te.get(59).renderType!==0,be=te.get(60),we=te.get(93),Fe=te.get(64),qe=te.get(91),ze=qe.verticalScrollbarSize,et=qe.verticalHasArrows,at=qe.arrowSize,Be=qe.horizontalScrollbarSize,ge=te.get(57),Ee=te.get(37);let ne;if(typeof ge=="string"&&/^\d+(\.\d+)?ch$/.test(ge)){const kt=parseFloat(ge.substr(0,ge.length-2));ne=w.clampedInt(kt*Ie,0,0,1e3)}else ne=w.clampedInt(ge,0,0,1e3);Ee&&(ne+=16);let K=0;if(ue){const kt=Math.max(ce,be);K=Math.round(kt*Ue)}let Se=0;se&&(Se=ct);let Le=0,it=Le+Se,Ge=it+K,pt=Ge+ne;const Et=Qe-Se-K-ne;let ft=!1,bt=!1,mt=-1;Ce!==2&&(Ye==="inherit"&&Pe?(ft=!0,bt=!0):vt==="on"||vt==="bounded"?bt=!0:vt==="wordWrapColumn"&&(mt=Re));const _t=j._computeMinimapLayout({outerWidth:Qe,outerHeight:tt,lineHeight:ct,typicalHalfwidthCharacterWidth:Ie,pixelRatio:Xe,scrollBeyondLastLine:we,minimap:Fe,verticalScrollbarWidth:ze,viewLineCount:rt,remainingWidth:Et,isViewportWrapping:bt},ve.memory||new S);_t.renderMinimap!==0&&_t.minimapLeft===0&&(Le+=_t.minimapWidth,it+=_t.minimapWidth,Ge+=_t.minimapWidth,pt+=_t.minimapWidth);const Dt=Et-_t.minimapWidth,xt=Math.max(1,Math.floor((Dt-ze-2)/Ie)),Vt=et?at:0;return bt&&(mt=Math.max(1,xt),vt==="bounded"&&(mt=Math.min(mt,Re))),{width:Qe,height:tt,glyphMarginLeft:Le,glyphMarginWidth:Se,lineNumbersLeft:it,lineNumbersWidth:K,decorationsLeft:Ge,decorationsWidth:ne,contentLeft:pt,contentWidth:Dt,minimap:_t,viewportColumn:xt,isWordWrapMinified:ft,isViewportWrapping:bt,wrappingColumn:mt,verticalScrollbarWidth:ze,horizontalScrollbarHeight:Be,overviewRuler:{top:Vt,width:ze,height:tt-2*Vt,right:0}}}}e.EditorLayoutInfoComputer=j;class U extends I{constructor(){const te={enabled:!0};super(56,"lightbulb",te,{"editor.lightbulb.enabled":{type:"boolean",default:te.enabled,description:p.localize(42,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:a(te.enabled,this.defaultValue.enabled)}}}class B extends I{constructor(){const te={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",te,{"editor.inlayHints.enabled":{type:"boolean",default:te.enabled,description:p.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:te.fontSize,markdownDescription:p.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:te.fontFamily,markdownDescription:p.localize(45,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:a(ve.enabled,this.defaultValue.enabled),fontSize:w.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:T.string(ve.fontFamily,this.defaultValue.fontFamily)}}}class z extends D{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,te=>D.clamp(te,0,150),{markdownDescription:p.localize(46,null)})}compute(te,ve,Qe){return te.fontInfo.lineHeight}}class O extends I{constructor(){const te={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",te,{"editor.minimap.enabled":{type:"boolean",default:te.enabled,description:p.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(48,null),p.localize(49,null),p.localize(50,null)],default:te.size,description:p.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:te.side,description:p.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:te.showSlider,description:p.localize(53,null)},"editor.minimap.scale":{type:"number",default:te.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:te.renderCharacters,description:p.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:te.maxColumn,description:p.localize(56,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:a(ve.enabled,this.defaultValue.enabled),size:E(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:E(ve.side,this.defaultValue.side,["right","left"]),showSlider:E(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:a(ve.renderCharacters,this.defaultValue.renderCharacters),scale:w.clampedInt(ve.scale,1,1,3),maxColumn:w.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function $(J){return J==="ctrlCmd"?F.isMacintosh?"metaKey":"ctrlKey":"altKey"}class x extends I{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(58,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{top:w.clampedInt(ve.top,0,0,1e3),bottom:w.clampedInt(ve.bottom,0,0,1e3)}}}class X extends I{constructor(){const te={enabled:!0,cycle:!1};super(75,"parameterHints",te,{"editor.parameterHints.enabled":{type:"boolean",default:te.enabled,description:p.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:te.cycle,description:p.localize(60,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:a(ve.enabled,this.defaultValue.enabled),cycle:a(ve.cycle,this.defaultValue.cycle)}}}class Q extends i{constructor(){super(127)}compute(te,ve,Qe){return te.pixelRatio}}class de extends I{constructor(){const te={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",te,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:te.strings,description:p.localize(61,null)},comments:{type:"boolean",default:te.comments,description:p.localize(62,null)},other:{type:"boolean",default:te.other,description:p.localize(63,null)}}}],default:te,description:p.localize(64,null)});this.defaultValue=te}validate(te){if(typeof te=="boolean")return te;if(te&&typeof te=="object"){const ve=te,Qe={other:a(ve.other,this.defaultValue.other),comments:a(ve.comments,this.defaultValue.comments),strings:a(ve.strings,this.defaultValue.strings)};return Qe.other&&Qe.comments&&Qe.strings?!0:!Qe.other&&!Qe.comments&&!Qe.strings?!1:Qe}return this.defaultValue}}var _e;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative",J[J.Interval=3]="Interval",J[J.Custom=4]="Custom"})(_e=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ye extends I{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(65,null),p.localize(66,null),p.localize(67,null),p.localize(68,null)],default:"on",description:p.localize(69,null)})}validate(te){let ve=this.defaultValue.renderType,Qe=this.defaultValue.renderFn;return typeof te!="undefined"&&(typeof te=="function"?(ve=4,Qe=te):te==="interval"?ve=3:te==="relative"?ve=2:te==="on"?ve=1:ve=0),{renderType:ve,renderFn:Qe}}}function ke(J){const te=J.get(86);return te==="editable"?J.get(80):te!=="on"}e.filterValidationDecorations=ke;class xe extends I{constructor(){const te=[],ve={type:"number",description:p.localize(70,null)};super(90,"rulers",te,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:p.localize(71,null),format:"color-hex"}}}]},default:te,description:p.localize(72,null)})}validate(te){if(Array.isArray(te)){let ve=[];for(let Qe of te)if(typeof Qe=="number")ve.push({column:w.clampedInt(Qe,0,0,1e4),color:null});else if(Qe&&typeof Qe=="object"){const tt=Qe;ve.push({column:w.clampedInt(tt.column,0,0,1e4),color:tt.color})}return ve.sort((Qe,tt)=>Qe.column-tt.column),ve}return this.defaultValue}}function We(J,te){if(typeof J!="string")return te;switch(J){case"hidden":return 2;case"visible":return 3;default:return 1}}class He extends I{constructor(){const te={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",te,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(73,null),p.localize(74,null),p.localize(75,null)],default:"auto",description:p.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(77,null),p.localize(78,null),p.localize(79,null)],default:"auto",description:p.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:te.verticalScrollbarSize,description:p.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:te.horizontalScrollbarSize,description:p.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:te.scrollByPage,description:p.localize(83,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te,Qe=w.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),tt=w.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:w.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:We(ve.vertical,this.defaultValue.vertical),horizontal:We(ve.horizontal,this.defaultValue.horizontal),useShadows:a(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:a(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:a(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:a(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:a(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Qe,horizontalSliderSize:w.clampedInt(ve.horizontalSliderSize,Qe,0,1e3),verticalScrollbarSize:tt,verticalSliderSize:w.clampedInt(ve.verticalSliderSize,tt,0,1e3),scrollByPage:a(ve.scrollByPage,this.defaultValue.scrollByPage)}}}class q extends I{constructor(){const te={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",te,{"editor.inlineSuggest.enabled":{type:"boolean",default:te.enabled,description:p.localize(84,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:a(ve.enabled,this.defaultValue.enabled),mode:E(ve.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ee extends I{constructor(){const te={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",te,{"editor.bracketPairColorization.enabled":{type:"boolean",default:te.enabled,description:p.localize(85,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:a(te.enabled,this.defaultValue.enabled)}}}class re extends I{constructor(){const te={bracketPairs:"none",bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",te,{"editor.guides.bracketPairs":{type:"string",enum:["all","active","none"],default:te.bracketPairs,description:p.localize(86,null)},"editor.guides.bracketPairsHorizontal":{type:"string",enum:["all","active","none"],default:te.bracketPairsHorizontal,description:p.localize(87,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:te.highlightActiveBracketPair,description:p.localize(88,null)},"editor.guides.indentation":{type:"boolean",default:te.indentation,description:p.localize(89,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:te.highlightActiveIndentation,description:p.localize(90,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{bracketPairs:E(ve.bracketPairs,this.defaultValue.bracketPairs,["all","active","none"]),bracketPairsHorizontal:E(ve.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,["all","active","none"]),highlightActiveBracketPair:a(ve.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:a(ve.indentation,this.defaultValue.indentation),highlightActiveIndentation:a(ve.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}class le extends I{constructor(){const te={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",te,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(91,null),p.localize(92,null)],default:te.insertMode,description:p.localize(93,null)},"editor.suggest.filterGraceful":{type:"boolean",default:te.filterGraceful,description:p.localize(94,null)},"editor.suggest.localityBonus":{type:"boolean",default:te.localityBonus,description:p.localize(95,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:te.shareSuggestSelections,markdownDescription:p.localize(96,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:te.snippetsPreventQuickSuggestions,description:p.localize(97,null)},"editor.suggest.showIcons":{type:"boolean",default:te.showIcons,description:p.localize(98,null)},"editor.suggest.showStatusBar":{type:"boolean",default:te.showStatusBar,description:p.localize(99,null)},"editor.suggest.preview":{type:"boolean",default:te.preview,description:p.localize(100,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:te.showInlineDetails,description:p.localize(101,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(102,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(103,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(104,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(105,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(106,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(107,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(108,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(109,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(110,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(111,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(112,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(113,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(114,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(115,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(116,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(117,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(118,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(119,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(120,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(121,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(122,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(123,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(124,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(125,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(126,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(127,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(128,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(129,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(130,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(131,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(132,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{insertMode:E(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:a(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:a(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:a(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:a(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:a(ve.showIcons,this.defaultValue.showIcons),showStatusBar:a(ve.showStatusBar,this.defaultValue.showStatusBar),preview:a(ve.preview,this.defaultValue.preview),previewMode:E(ve.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:a(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:a(ve.showMethods,this.defaultValue.showMethods),showFunctions:a(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:a(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:a(ve.showDeprecated,this.defaultValue.showDeprecated),showFields:a(ve.showFields,this.defaultValue.showFields),showVariables:a(ve.showVariables,this.defaultValue.showVariables),showClasses:a(ve.showClasses,this.defaultValue.showClasses),showStructs:a(ve.showStructs,this.defaultValue.showStructs),showInterfaces:a(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:a(ve.showModules,this.defaultValue.showModules),showProperties:a(ve.showProperties,this.defaultValue.showProperties),showEvents:a(ve.showEvents,this.defaultValue.showEvents),showOperators:a(ve.showOperators,this.defaultValue.showOperators),showUnits:a(ve.showUnits,this.defaultValue.showUnits),showValues:a(ve.showValues,this.defaultValue.showValues),showConstants:a(ve.showConstants,this.defaultValue.showConstants),showEnums:a(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:a(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:a(ve.showKeywords,this.defaultValue.showKeywords),showWords:a(ve.showWords,this.defaultValue.showWords),showColors:a(ve.showColors,this.defaultValue.showColors),showFiles:a(ve.showFiles,this.defaultValue.showFiles),showReferences:a(ve.showReferences,this.defaultValue.showReferences),showFolders:a(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:a(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:a(ve.showSnippets,this.defaultValue.showSnippets),showUsers:a(ve.showUsers,this.defaultValue.showUsers),showIssues:a(ve.showIssues,this.defaultValue.showIssues)}}}class Z extends I{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(133,null),default:!0,type:"boolean"}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:a(te.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ae extends i{constructor(){super(128,[80])}compute(te,ve,Qe){return ve.get(80)?!0:te.tabFocusMode}}var pe;(function(J){J[J.None=0]="None",J[J.Same=1]="Same",J[J.Indent=2]="Indent",J[J.DeepIndent=3]="DeepIndent"})(pe=e.WrappingIndent||(e.WrappingIndent={}));function Me(J){switch(J){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class je extends i{constructor(){super(130,[129])}compute(te,ve,Qe){const tt=ve.get(129);return{isDominatedByLongLines:te.isDominatedByLongLines,isWordWrapMinified:tt.isWordWrapMinified,isViewportWrapping:tt.isViewportWrapping,wrappingColumn:tt.wrappingColumn}}}const Ke="Consolas, 'Courier New', monospace",Je="Menlo, Monaco, 'Courier New', monospace",st="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:F.isMacintosh?Je:F.isLinux?st:Ke,fontWeight:"normal",fontSize:F.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Te(J){return e.editorOptionsRegistry[J.id]=J,J}var nt;(function(J){J[J.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",J[J.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",J[J.accessibilitySupport=2]="accessibilitySupport",J[J.accessibilityPageSize=3]="accessibilityPageSize",J[J.ariaLabel=4]="ariaLabel",J[J.autoClosingBrackets=5]="autoClosingBrackets",J[J.autoClosingDelete=6]="autoClosingDelete",J[J.autoClosingOvertype=7]="autoClosingOvertype",J[J.autoClosingQuotes=8]="autoClosingQuotes",J[J.autoIndent=9]="autoIndent",J[J.automaticLayout=10]="automaticLayout",J[J.autoSurround=11]="autoSurround",J[J.bracketPairColorization=12]="bracketPairColorization",J[J.guides=13]="guides",J[J.codeLens=14]="codeLens",J[J.codeLensFontFamily=15]="codeLensFontFamily",J[J.codeLensFontSize=16]="codeLensFontSize",J[J.colorDecorators=17]="colorDecorators",J[J.columnSelection=18]="columnSelection",J[J.comments=19]="comments",J[J.contextmenu=20]="contextmenu",J[J.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",J[J.cursorBlinking=22]="cursorBlinking",J[J.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",J[J.cursorStyle=24]="cursorStyle",J[J.cursorSurroundingLines=25]="cursorSurroundingLines",J[J.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",J[J.cursorWidth=27]="cursorWidth",J[J.disableLayerHinting=28]="disableLayerHinting",J[J.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",J[J.domReadOnly=30]="domReadOnly",J[J.dragAndDrop=31]="dragAndDrop",J[J.emptySelectionClipboard=32]="emptySelectionClipboard",J[J.extraEditorClassName=33]="extraEditorClassName",J[J.fastScrollSensitivity=34]="fastScrollSensitivity",J[J.find=35]="find",J[J.fixedOverflowWidgets=36]="fixedOverflowWidgets",J[J.folding=37]="folding",J[J.foldingStrategy=38]="foldingStrategy",J[J.foldingHighlight=39]="foldingHighlight",J[J.foldingImportsByDefault=40]="foldingImportsByDefault",J[J.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",J[J.fontFamily=42]="fontFamily",J[J.fontInfo=43]="fontInfo",J[J.fontLigatures=44]="fontLigatures",J[J.fontSize=45]="fontSize",J[J.fontWeight=46]="fontWeight",J[J.formatOnPaste=47]="formatOnPaste",J[J.formatOnType=48]="formatOnType",J[J.glyphMargin=49]="glyphMargin",J[J.gotoLocation=50]="gotoLocation",J[J.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",J[J.hover=52]="hover",J[J.inDiffEditor=53]="inDiffEditor",J[J.inlineSuggest=54]="inlineSuggest",J[J.letterSpacing=55]="letterSpacing",J[J.lightbulb=56]="lightbulb",J[J.lineDecorationsWidth=57]="lineDecorationsWidth",J[J.lineHeight=58]="lineHeight",J[J.lineNumbers=59]="lineNumbers",J[J.lineNumbersMinChars=60]="lineNumbersMinChars",J[J.linkedEditing=61]="linkedEditing",J[J.links=62]="links",J[J.matchBrackets=63]="matchBrackets",J[J.minimap=64]="minimap",J[J.mouseStyle=65]="mouseStyle",J[J.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",J[J.mouseWheelZoom=67]="mouseWheelZoom",J[J.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",J[J.multiCursorModifier=69]="multiCursorModifier",J[J.multiCursorPaste=70]="multiCursorPaste",J[J.occurrencesHighlight=71]="occurrencesHighlight",J[J.overviewRulerBorder=72]="overviewRulerBorder",J[J.overviewRulerLanes=73]="overviewRulerLanes",J[J.padding=74]="padding",J[J.parameterHints=75]="parameterHints",J[J.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",J[J.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",J[J.quickSuggestions=78]="quickSuggestions",J[J.quickSuggestionsDelay=79]="quickSuggestionsDelay",J[J.readOnly=80]="readOnly",J[J.renameOnType=81]="renameOnType",J[J.renderControlCharacters=82]="renderControlCharacters",J[J.renderFinalNewline=83]="renderFinalNewline",J[J.renderLineHighlight=84]="renderLineHighlight",J[J.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",J[J.renderValidationDecorations=86]="renderValidationDecorations",J[J.renderWhitespace=87]="renderWhitespace",J[J.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",J[J.roundedSelection=89]="roundedSelection",J[J.rulers=90]="rulers",J[J.scrollbar=91]="scrollbar",J[J.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",J[J.scrollBeyondLastLine=93]="scrollBeyondLastLine",J[J.scrollPredominantAxis=94]="scrollPredominantAxis",J[J.selectionClipboard=95]="selectionClipboard",J[J.selectionHighlight=96]="selectionHighlight",J[J.selectOnLineNumbers=97]="selectOnLineNumbers",J[J.showFoldingControls=98]="showFoldingControls",J[J.showUnused=99]="showUnused",J[J.snippetSuggestions=100]="snippetSuggestions",J[J.smartSelect=101]="smartSelect",J[J.smoothScrolling=102]="smoothScrolling",J[J.stickyTabStops=103]="stickyTabStops",J[J.stopRenderingLineAfter=104]="stopRenderingLineAfter",J[J.suggest=105]="suggest",J[J.suggestFontSize=106]="suggestFontSize",J[J.suggestLineHeight=107]="suggestLineHeight",J[J.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",J[J.suggestSelection=109]="suggestSelection",J[J.tabCompletion=110]="tabCompletion",J[J.tabIndex=111]="tabIndex",J[J.unusualLineTerminators=112]="unusualLineTerminators",J[J.useShadowDOM=113]="useShadowDOM",J[J.useTabStops=114]="useTabStops",J[J.wordSeparators=115]="wordSeparators",J[J.wordWrap=116]="wordWrap",J[J.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",J[J.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",J[J.wordWrapColumn=119]="wordWrapColumn",J[J.wordWrapOverride1=120]="wordWrapOverride1",J[J.wordWrapOverride2=121]="wordWrapOverride2",J[J.wrappingIndent=122]="wrappingIndent",J[J.wrappingStrategy=123]="wrappingStrategy",J[J.showDeprecated=124]="showDeprecated",J[J.inlayHints=125]="inlayHints",J[J.editorClassName=126]="editorClassName",J[J.pixelRatio=127]="pixelRatio",J[J.tabFocusMode=128]="tabFocusMode",J[J.layoutInfo=129]="layoutInfo",J[J.wrappingInfo=130]="wrappingInfo"})(nt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Te(new g(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(134,null)})),acceptSuggestionOnEnter:Te(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(135,null),""],markdownDescription:p.localize(136,null)})),accessibilitySupport:Te(new t),accessibilityPageSize:Te(new w(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(137,null)})),ariaLabel:Te(new T(4,"ariaLabel",p.localize(138,null))),autoClosingBrackets:Te(new c(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(139,null),p.localize(140,null),""],description:p.localize(141,null)})),autoClosingDelete:Te(new c(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(142,null),""],description:p.localize(143,null)})),autoClosingOvertype:Te(new c(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(144,null),""],description:p.localize(145,null)})),autoClosingQuotes:Te(new c(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(146,null),p.localize(147,null),""],description:p.localize(148,null)})),autoIndent:Te(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[p.localize(149,null),p.localize(150,null),p.localize(151,null),p.localize(152,null),p.localize(153,null)],description:p.localize(154,null)})),automaticLayout:Te(new g(10,"automaticLayout",!1)),autoSurround:Te(new c(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(155,null),p.localize(156,null),p.localize(157,null),""],description:p.localize(158,null)})),bracketPairColorization:Te(new ee),bracketPairGuides:Te(new re),stickyTabStops:Te(new g(103,"stickyTabStops",!1,{description:p.localize(159,null)})),codeLens:Te(new g(14,"codeLens",!0,{description:p.localize(160,null)})),codeLensFontFamily:Te(new T(15,"codeLensFontFamily","",{description:p.localize(161,null)})),codeLensFontSize:Te(new w(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(162,null)})),colorDecorators:Te(new g(17,"colorDecorators",!0,{description:p.localize(163,null)})),columnSelection:Te(new g(18,"columnSelection",!1,{description:p.localize(164,null)})),comments:Te(new h),contextmenu:Te(new g(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Te(new g(21,"copyWithSyntaxHighlighting",!0,{description:p.localize(165,null)})),cursorBlinking:Te(new r(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],n,{description:p.localize(166,null)})),cursorSmoothCaretAnimation:Te(new g(23,"cursorSmoothCaretAnimation",!1,{description:p.localize(167,null)})),cursorStyle:Te(new r(24,"cursorStyle",u.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],l,{description:p.localize(168,null)})),cursorSurroundingLines:Te(new w(25,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(169,null)})),cursorSurroundingLinesStyle:Te(new c(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(170,null),p.localize(171,null)],description:p.localize(172,null)})),cursorWidth:Te(new w(27,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(173,null)})),disableLayerHinting:Te(new g(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Te(new g(29,"disableMonospaceOptimizations",!1)),domReadOnly:Te(new g(30,"domReadOnly",!1)),dragAndDrop:Te(new g(31,"dragAndDrop",!0,{description:p.localize(174,null)})),emptySelectionClipboard:Te(new b),extraEditorClassName:Te(new T(33,"extraEditorClassName","")),fastScrollSensitivity:Te(new D(34,"fastScrollSensitivity",5,J=>J<=0?5:J,{markdownDescription:p.localize(175,null)})),find:Te(new f),fixedOverflowWidgets:Te(new g(36,"fixedOverflowWidgets",!1)),folding:Te(new g(37,"folding",!0,{description:p.localize(176,null)})),foldingStrategy:Te(new c(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(177,null),p.localize(178,null)],description:p.localize(179,null)})),foldingHighlight:Te(new g(39,"foldingHighlight",!0,{description:p.localize(180,null)})),foldingImportsByDefault:Te(new g(40,"foldingImportsByDefault",!1,{description:p.localize(181,null)})),unfoldOnClickAfterEndOfLine:Te(new g(41,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(182,null)})),fontFamily:Te(new T(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(183,null)})),fontInfo:Te(new L),fontLigatures2:Te(new P),fontSize:Te(new M),fontWeight:Te(new R),formatOnPaste:Te(new g(47,"formatOnPaste",!1,{description:p.localize(184,null)})),formatOnType:Te(new g(48,"formatOnType",!1,{description:p.localize(185,null)})),glyphMargin:Te(new g(49,"glyphMargin",!0,{description:p.localize(186,null)})),gotoLocation:Te(new W),hideCursorInOverviewRuler:Te(new g(51,"hideCursorInOverviewRuler",!1,{description:p.localize(187,null)})),hover:Te(new V),inDiffEditor:Te(new g(53,"inDiffEditor",!1)),letterSpacing:Te(new D(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,J=>D.clamp(J,-5,20),{description:p.localize(188,null)})),lightbulb:Te(new U),lineDecorationsWidth:Te(new k(57,"lineDecorationsWidth",10)),lineHeight:Te(new z),lineNumbers:Te(new ye),lineNumbersMinChars:Te(new w(60,"lineNumbersMinChars",5,1,300)),linkedEditing:Te(new g(61,"linkedEditing",!1,{description:p.localize(189,null)})),links:Te(new g(62,"links",!0,{description:p.localize(190,null)})),matchBrackets:Te(new c(63,"matchBrackets","always",["always","near","never"],{description:p.localize(191,null)})),minimap:Te(new O),mouseStyle:Te(new c(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Te(new D(66,"mouseWheelScrollSensitivity",1,J=>J===0?1:J,{markdownDescription:p.localize(192,null)})),mouseWheelZoom:Te(new g(67,"mouseWheelZoom",!1,{markdownDescription:p.localize(193,null)})),multiCursorMergeOverlapping:Te(new g(68,"multiCursorMergeOverlapping",!0,{description:p.localize(194,null)})),multiCursorModifier:Te(new r(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],$,{markdownEnumDescriptions:[p.localize(195,null),p.localize(196,null)],markdownDescription:p.localize(197,null)})),multiCursorPaste:Te(new c(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(198,null),p.localize(199,null)],markdownDescription:p.localize(200,null)})),occurrencesHighlight:Te(new g(71,"occurrencesHighlight",!0,{description:p.localize(201,null)})),overviewRulerBorder:Te(new g(72,"overviewRulerBorder",!0,{description:p.localize(202,null)})),overviewRulerLanes:Te(new w(73,"overviewRulerLanes",3,0,3)),padding:Te(new x),parameterHints:Te(new X),peekWidgetDefaultFocus:Te(new c(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(203,null),p.localize(204,null)],description:p.localize(205,null)})),definitionLinkOpensInPeek:Te(new g(77,"definitionLinkOpensInPeek",!1,{description:p.localize(206,null)})),quickSuggestions:Te(new de),quickSuggestionsDelay:Te(new w(79,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(207,null)})),readOnly:Te(new g(80,"readOnly",!1)),renameOnType:Te(new g(81,"renameOnType",!1,{description:p.localize(208,null),markdownDeprecationMessage:p.localize(209,null)})),renderControlCharacters:Te(new g(82,"renderControlCharacters",!1,{description:p.localize(210,null)})),renderFinalNewline:Te(new g(83,"renderFinalNewline",!0,{description:p.localize(211,null)})),renderLineHighlight:Te(new c(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(212,null)],description:p.localize(213,null)})),renderLineHighlightOnlyWhenFocus:Te(new g(85,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(214,null)})),renderValidationDecorations:Te(new c(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Te(new c(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(215,null),p.localize(216,null),p.localize(217,null),""],description:p.localize(218,null)})),revealHorizontalRightPadding:Te(new w(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Te(new g(89,"roundedSelection",!0,{description:p.localize(219,null)})),rulers:Te(new xe),scrollbar:Te(new He),scrollBeyondLastColumn:Te(new w(92,"scrollBeyondLastColumn",5,0,1073741824,{description:p.localize(220,null)})),scrollBeyondLastLine:Te(new g(93,"scrollBeyondLastLine",!0,{description:p.localize(221,null)})),scrollPredominantAxis:Te(new g(94,"scrollPredominantAxis",!0,{description:p.localize(222,null)})),selectionClipboard:Te(new g(95,"selectionClipboard",!0,{description:p.localize(223,null),included:F.isLinux})),selectionHighlight:Te(new g(96,"selectionHighlight",!0,{description:p.localize(224,null)})),selectOnLineNumbers:Te(new g(97,"selectOnLineNumbers",!0)),showFoldingControls:Te(new c(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[p.localize(225,null),p.localize(226,null)],description:p.localize(227,null)})),showUnused:Te(new g(99,"showUnused",!0,{description:p.localize(228,null)})),showDeprecated:Te(new g(124,"showDeprecated",!0,{description:p.localize(229,null)})),inlayHints:Te(new B),snippetSuggestions:Te(new c(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(230,null),p.localize(231,null),p.localize(232,null),p.localize(233,null)],description:p.localize(234,null)})),smartSelect:Te(new Z),smoothScrolling:Te(new g(102,"smoothScrolling",!1,{description:p.localize(235,null)})),stopRenderingLineAfter:Te(new w(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Te(new le),inlineSuggest:Te(new q),suggestFontSize:Te(new w(106,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(236,null)})),suggestLineHeight:Te(new w(107,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(237,null)})),suggestOnTriggerCharacters:Te(new g(108,"suggestOnTriggerCharacters",!0,{description:p.localize(238,null)})),suggestSelection:Te(new c(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(239,null),p.localize(240,null),p.localize(241,null)],description:p.localize(242,null)})),tabCompletion:Te(new c(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(243,null),p.localize(244,null),p.localize(245,null)],description:p.localize(246,null)})),tabIndex:Te(new w(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Te(new c(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(247,null),p.localize(248,null),p.localize(249,null)],description:p.localize(250,null)})),useShadowDOM:Te(new g(113,"useShadowDOM",!0)),useTabStops:Te(new g(114,"useTabStops",!0,{description:p.localize(251,null)})),wordSeparators:Te(new T(115,"wordSeparators",C.USUAL_WORD_SEPARATORS,{description:p.localize(252,null)})),wordWrap:Te(new c(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(253,null),p.localize(254,null),p.localize(255,null),p.localize(256,null)],description:p.localize(257,null)})),wordWrapBreakAfterCharacters:Te(new T(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Te(new T(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Te(new w(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(258,null)})),wordWrapOverride1:Te(new c(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Te(new c(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Te(new r(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Me,{enumDescriptions:[p.localize(259,null),p.localize(260,null),p.localize(261,null),p.localize(262,null)],description:p.localize(263,null)})),wrappingStrategy:Te(new c(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[p.localize(264,null),p.localize(265,null)],description:p.localize(266,null)})),editorClassName:Te(new m),pixelRatio:Te(new Q),tabFocusMode:Te(new ae),layoutInfo:Te(new j),wrappingInfo:Te(new je)}}),define(fe[157],me([19,20]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(fe[158],me([19,20]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(fe[159],me([19,20]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(fe[160],me([19,20]),function(Y,e){return Y.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(fe[161],me([19,20]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(fe[162],me([19,20]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(fe[163],me([19,20]),function(Y,e){return Y.create("vs/platform/theme/common/iconRegistry",e)}),define(fe[164],me([19,20]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(fe[165],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(fe[166],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(fe[167],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(fe[168],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(fe[169],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(fe[170],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(fe[171],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(fe[172],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostDebugService",e)}),define(fe[173],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostTunnelService",e)}),define(fe[174],me([19,20]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(fe[175],me([19,20]),function(Y,e){return Y.create("vs/workbench/common/views",e)}),define(fe[176],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(fe[177],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(fe[178],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(fe[179],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(fe[180],me([19,20]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(fe[181],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var p;(function(A){A[A.ACTIVATE=1]="ACTIVATE",A[A.RESTORE=2]="RESTORE",A[A.PRESERVE=3]="PRESERVE"})(p=e.EditorActivation||(e.EditorActivation={}));var F;(function(A){A[A.PICK=0]="PICK",A[A.DISABLED=1]="DISABLED",A[A.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(F=e.EditorResolution||(e.EditorResolution={}));var C;(function(A){A[A.API=0]="API",A[A.USER=1]="USER"})(C=e.EditorOpenContext||(e.EditorOpenContext={}));var y;(function(A){A[A.Center=0]="Center",A[A.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",A[A.NearTop=2]="NearTop",A[A.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(y=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(fe[182],me([0,1,159]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const F=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function y(a){return a=a.trim(),a==="*"||F.test(a)}e.isValidVersionStr=y;function A(a){if(!y(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let g=a.match(F);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=A;function _(a){if(!a)return null;let g=a.majorBase,d=a.majorMustEqual,w=a.minorBase,D=a.minorMustEqual,T=a.patchBase,E=a.patchMustEqual;a.hasCaret&&(g===0||(D=!1),E=!1);let c=0;if(a.preRelease){const r=C.exec(a.preRelease);if(r){const[,v,t,h]=r;c=Date.UTC(Number(v),Number(t)-1,Number(h))}}return{majorBase:g,majorMustEqual:d,minorBase:w,minorMustEqual:D,patchBase:T,patchMustEqual:E,isMinimum:a.hasGreaterEquals,notBefore:c}}e.normalizeVersion=_;function S(a,g,d){let w;typeof a=="string"?w=_(A(a)):w=a;let D;g instanceof Date?D=g.getTime():typeof g=="string"&&(D=new Date(g).getTime());let T;if(typeof d=="string"?T=_(A(d)):T=d,!w||!T)return!1;let E=w.majorBase,c=w.minorBase,r=w.patchBase,v=T.majorBase,t=T.minorBase,h=T.patchBase,s=T.notBefore,n=T.majorMustEqual,u=T.minorMustEqual,o=T.patchMustEqual;return T.isMinimum?E>v?!0:E<v?!1:c>t?!0:c<t||D&&D<s?!1:r>=h:(E===1&&v===0&&(!n||!u||!o)&&(v=1,t=0,h=0,n=!0,u=!1,o=!1),E<v?!1:E>v?!n:c<t?!1:c>t?!u:r<h?!1:r>h?!o:!(D&&D<s))}e.isValidVersion=S;function I(a,g,d,w){return d.isBuiltin||typeof d.main=="undefined"?!0:k(a,g,d.engines.vscode,w)}e.isValidExtensionVersion=I;function i(a,g,d){return a==="*"||k(g,d,a)}e.isEngineValid=i;function k(a,g,d,w=[]){let D=_(A(d));if(!D)return w.push(p.localize(0,null,d)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return w.push(p.localize(1,null,d)),!1}else if(!D.majorMustEqual)return w.push(p.localize(2,null,d)),!1;return S(a,g,D)?!0:(w.push(p.localize(3,null,a,d)),!1)}}),define(fe[116],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class p{constructor(C,y=[],A=!1){this.ctor=C,this.staticArguments=y,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=p}),define(fe[83],me([0,1,116]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const F=[];function C(A,_,S){_ instanceof p.SyncDescriptor||(_=new p.SyncDescriptor(_,[],S)),F.push([A,_])}e.registerSingleton=C;function y(){return F}e.getSingletonServiceDescriptors=y}),define(fe[183],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(y){this.incoming=new Map,this.outgoing=new Map,this.data=y}}e.Node=p;class F{constructor(y){this._hashFn=y,this._nodes=new Map}roots(){const y=[];for(let A of this._nodes.values())A.outgoing.size===0&&y.push(A);return y}insertEdge(y,A){const _=this.lookupOrInsertNode(y),S=this.lookupOrInsertNode(A);_.outgoing.set(this._hashFn(A),S),S.incoming.set(this._hashFn(y),_)}removeNode(y){const A=this._hashFn(y);this._nodes.delete(A);for(let _ of this._nodes.values())_.outgoing.delete(A),_.incoming.delete(A)}lookupOrInsertNode(y){const A=this._hashFn(y);let _=this._nodes.get(A);return _||(_=new p(y),this._nodes.set(A,_)),_}lookup(y){return this._nodes.get(this._hashFn(y))}isEmpty(){return this._nodes.size===0}toString(){let y=[];for(let[A,_]of this._nodes)y.push(`${A}, (incoming)[${[..._.incoming.keys()].join(", ")}], (outgoing)[${[..._.outgoing.keys()].join(",")}]`);return y.join(`
`)}findCycleSlow(){for(let[y,A]of this._nodes){const _=new Set([y]),S=this._findCycle(A,_);if(S)return S}}_findCycle(y,A){for(let[_,S]of y.outgoing){if(A.has(_))return[...A,_].join(" -> ");A.add(_);const I=this._findCycle(S,A);if(I)return I;A.delete(_)}}}e.Graph=F}),define(fe[4],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function S(I){return I[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=S})(p=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function F(_,S,I,i){S[p.DI_TARGET]===S?S[p.DI_DEPENDENCIES].push({id:_,index:I,optional:i}):(S[p.DI_DEPENDENCIES]=[{id:_,index:I,optional:i}],S[p.DI_TARGET]=S)}function C(_){if(p.serviceIds.has(_))return p.serviceIds.get(_);const S=function(I,i,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(S,I,k,!1)};return S.toString=()=>_,p.serviceIds.set(_,S),S}e.createDecorator=C;function y(_){return _}e.refineServiceDecorator=y;function A(_){return function(S,I,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");F(_,S,i,!0)}}e.optional=A}),define(fe[184],me([0,1,4]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,p.createDecorator)("modelService");function F(C){return!C.isTooLargeForSyncing()&&!C.isForSimpleWidget}e.shouldSynchronizeModel=F}),define(fe[185],me([0,1,3,48,6,24,78,82,184]),function(Y,e,p,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function I(w){return typeof w=="string"?!1:Array.isArray(w)?w.every(I):!!w.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new p.Emitter}get onDidChange(){return this._onDidChange.event}register(D,T){let E={selector:D,provider:T,_score:-1,_time:this._clock++};return this._entries.push(E),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,C.toDisposable)(()=>{if(E){let c=this._entries.indexOf(E);c>=0&&(this._entries.splice(c,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),E=void 0)}})}has(D){return this.all(D).length>0}all(D){if(!D)return[];this._updateScores(D);const T=[];for(let E of this._entries)E._score>0&&T.push(E.provider);return T}ordered(D){const T=[];return this._orderedForEach(D,E=>T.push(E.provider)),T}orderedGroups(D){const T=[];let E,c;return this._orderedForEach(D,r=>{E&&c===r._score?E.push(r.provider):(c=r._score,E=[r.provider],T.push(E))}),T}_orderedForEach(D,T){if(!!D){this._updateScores(D);for(const E of this._entries)E._score>0&&T(E)}}_updateScores(D){let T={uri:D.uri.toString(),language:D.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===T.language&&this._lastCandidate.uri===T.uri)){this._lastCandidate=T;for(let E of this._entries)if(E._score=(0,_.score)(E.selector,D.uri,D.getLanguageIdentifier().language,(0,S.shouldSynchronizeModel)(D)),I(E.selector)&&E._score>0){for(let c of this._entries)c._score=0;E._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(D,T){return D._score<T._score?1:D._score>T._score?-1:D._time<T._time?1:D._time>T._time?-1:0}}e.LanguageFeatureRegistry=i;const k=new WeakMap;let a=0;function g(w){let D=k.get(w);return D===void 0&&(D=++a,k.set(w,D)),D}class d{constructor(D,T,E=Number.MAX_SAFE_INTEGER){this._registry=D,this.min=T,this.max=E,this._cache=new y.LRUCache(50,.7)}_key(D){return D.id+this._registry.all(D).reduce((T,E)=>(0,F.doHash)(g(E),T),0)}_clamp(D){return D===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(D*1.3)))}get(D){const T=this._key(D),E=this._cache.get(T);return this._clamp(E?.value)}update(D,T){const E=this._key(D);let c=this._cache.get(E);return c||(c=new A.MovingAverage,this._cache.set(E,c)),c.update(T),this.get(D)}}e.LanguageFeatureRequestDelays=d}),define(fe[84],me([0,1,2,42,185,150,47]),function(Y,e,p,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var _;(function(f){f[f.Null=0]="Null",f[f.PlainText=1]="PlainText"})(_=e.LanguageId||(e.LanguageId={}));class S{constructor(P,L){this.language=P,this.id=L}}e.LanguageIdentifier=S;var I;(function(f){f[f.NotSet=-1]="NotSet",f[f.None=0]="None",f[f.Italic=1]="Italic",f[f.Bold=2]="Bold",f[f.Underline=4]="Underline"})(I=e.FontStyle||(e.FontStyle={}));var i;(function(f){f[f.None=0]="None",f[f.DefaultForeground=1]="DefaultForeground",f[f.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var k;(function(f){f[f.Other=0]="Other",f[f.Comment=1]="Comment",f[f.String=2]="String",f[f.RegEx=4]="RegEx"})(k=e.StandardTokenType||(e.StandardTokenType={}));var a;(function(f){f[f.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",f[f.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",f[f.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",f[f.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",f[f.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",f[f.ITALIC_MASK=2048]="ITALIC_MASK",f[f.BOLD_MASK=4096]="BOLD_MASK",f[f.UNDERLINE_MASK=8192]="UNDERLINE_MASK",f[f.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",f[f.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",f[f.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",f[f.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",f[f.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",f[f.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",f[f.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",f[f.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",f[f.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",f[f.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(a=e.MetadataConsts||(e.MetadataConsts={}));class g{static getLanguageId(P){return(P&255)>>>0}static getTokenType(P){return(P&1792)>>>8}static getFontStyle(P){return(P&14336)>>>11}static getForeground(P){return(P&8372224)>>>14}static getBackground(P){return(P&4286578688)>>>23}static getClassNameFromMetadata(P){let L=this.getForeground(P),M="mtk"+L,R=this.getFontStyle(P);return R&1&&(M+=" mtki"),R&2&&(M+=" mtkb"),R&4&&(M+=" mtku"),M}static getInlineStyleFromMetadata(P,L){const M=this.getForeground(P),R=this.getFontStyle(P);let W=`color: ${L[M]};`;return R&1&&(W+="font-style: italic;"),R&2&&(W+="font-weight: bold;"),R&4&&(W+="text-decoration: underline;"),W}}e.TokenMetadata=g;var d;(function(f){f[f.Method=0]="Method",f[f.Function=1]="Function",f[f.Constructor=2]="Constructor",f[f.Field=3]="Field",f[f.Variable=4]="Variable",f[f.Class=5]="Class",f[f.Struct=6]="Struct",f[f.Interface=7]="Interface",f[f.Module=8]="Module",f[f.Property=9]="Property",f[f.Event=10]="Event",f[f.Operator=11]="Operator",f[f.Unit=12]="Unit",f[f.Value=13]="Value",f[f.Constant=14]="Constant",f[f.Enum=15]="Enum",f[f.EnumMember=16]="EnumMember",f[f.Keyword=17]="Keyword",f[f.Text=18]="Text",f[f.Color=19]="Color",f[f.File=20]="File",f[f.Reference=21]="Reference",f[f.Customcolor=22]="Customcolor",f[f.Folder=23]="Folder",f[f.TypeParameter=24]="TypeParameter",f[f.User=25]="User",f[f.Issue=26]="Issue",f[f.Snippet=27]="Snippet"})(d=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let f=Object.create(null);return f[0]="symbol-method",f[1]="symbol-function",f[2]="symbol-constructor",f[3]="symbol-field",f[4]="symbol-variable",f[5]="symbol-class",f[6]="symbol-struct",f[7]="symbol-interface",f[8]="symbol-module",f[9]="symbol-property",f[10]="symbol-event",f[11]="symbol-operator",f[12]="symbol-unit",f[13]="symbol-value",f[14]="symbol-constant",f[15]="symbol-enum",f[16]="symbol-enum-member",f[17]="symbol-keyword",f[27]="symbol-snippet",f[18]="symbol-text",f[19]="symbol-color",f[20]="symbol-file",f[21]="symbol-reference",f[22]="symbol-customcolor",f[23]="symbol-folder",f[24]="symbol-type-parameter",f[25]="account",f[26]="issues",function(P){const L=f[P];let M=L&&A.iconRegistry.get(L);return M||(console.info("No codicon found for CompletionItemKind "+P),M=A.Codicon.symbolProperty),M.classNames}}(),e.completionKindFromString=function(){let f=Object.create(null);return f.method=0,f.function=1,f.constructor=2,f.field=3,f.variable=4,f.class=5,f.struct=6,f.interface=7,f.module=8,f.property=9,f.event=10,f.operator=11,f.unit=12,f.value=13,f.constant=14,f.enum=15,f["enum-member"]=16,f.enumMember=16,f.keyword=17,f.snippet=27,f.text=18,f.color=19,f.file=20,f.reference=21,f.customcolor=22,f.folder=23,f["type-parameter"]=24,f.typeParameter=24,f.account=25,f.issue=26,function(P,L){let M=f[P];return typeof M=="undefined"&&!L&&(M=9),M}}();var w;(function(f){f[f.Deprecated=1]="Deprecated"})(w=e.CompletionItemTag||(e.CompletionItemTag={}));var D;(function(f){f[f.KeepWhitespace=1]="KeepWhitespace",f[f.InsertAsSnippet=4]="InsertAsSnippet"})(D=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var T;(function(f){f[f.Invoke=0]="Invoke",f[f.TriggerCharacter=1]="TriggerCharacter",f[f.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(T=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(f){f[f.Automatic=0]="Automatic",f[f.Explicit=1]="Explicit"})(E=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var c;(function(f){f[f.Invoke=1]="Invoke",f[f.Auto=2]="Auto"})(c=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var r;(function(f){f[f.Invoke=1]="Invoke",f[f.TriggerCharacter=2]="TriggerCharacter",f[f.ContentChange=3]="ContentChange"})(r=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var v;(function(f){f[f.Text=0]="Text",f[f.Read=1]="Read",f[f.Write=2]="Write"})(v=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(f){return f&&p.URI.isUri(f.uri)&&F.Range.isIRange(f.range)&&(F.Range.isIRange(f.originSelectionRange)||F.Range.isIRange(f.targetSelectionRange))}e.isLocationLink=t;var h;(function(f){f[f.File=0]="File",f[f.Module=1]="Module",f[f.Namespace=2]="Namespace",f[f.Package=3]="Package",f[f.Class=4]="Class",f[f.Method=5]="Method",f[f.Property=6]="Property",f[f.Field=7]="Field",f[f.Constructor=8]="Constructor",f[f.Enum=9]="Enum",f[f.Interface=10]="Interface",f[f.Function=11]="Function",f[f.Variable=12]="Variable",f[f.Constant=13]="Constant",f[f.String=14]="String",f[f.Number=15]="Number",f[f.Boolean=16]="Boolean",f[f.Array=17]="Array",f[f.Object=18]="Object",f[f.Key=19]="Key",f[f.Null=20]="Null",f[f.EnumMember=21]="EnumMember",f[f.Struct=22]="Struct",f[f.Event=23]="Event",f[f.Operator=24]="Operator",f[f.TypeParameter=25]="TypeParameter"})(h=e.SymbolKind||(e.SymbolKind={}));var s;(function(f){f[f.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var n;(function(f){const P=new Map;P.set("file",0),P.set("module",1),P.set("namespace",2),P.set("package",3),P.set("class",4),P.set("method",5),P.set("property",6),P.set("field",7),P.set("constructor",8),P.set("enum",9),P.set("interface",10),P.set("function",11),P.set("variable",12),P.set("constant",13),P.set("string",14),P.set("number",15),P.set("boolean",16),P.set("array",17),P.set("object",18),P.set("key",19),P.set("null",20),P.set("enum-member",21),P.set("struct",22),P.set("event",23),P.set("operator",24),P.set("type-parameter",25);const L=new Map;L.set(0,"file"),L.set(1,"module"),L.set(2,"namespace"),L.set(3,"package"),L.set(4,"class"),L.set(5,"method"),L.set(6,"property"),L.set(7,"field"),L.set(8,"constructor"),L.set(9,"enum"),L.set(10,"interface"),L.set(11,"function"),L.set(12,"variable"),L.set(13,"constant"),L.set(14,"string"),L.set(15,"number"),L.set(16,"boolean"),L.set(17,"array"),L.set(18,"object"),L.set(19,"key"),L.set(20,"null"),L.set(21,"enum-member"),L.set(22,"struct"),L.set(23,"event"),L.set(24,"operator"),L.set(25,"type-parameter");function M(V){return P.get(V)}f.fromString=M;function R(V){return L.get(V)}f.toString=R;function W(V,N){const j=L.get(V);let U=j&&A.iconRegistry.get("symbol-"+j);return U||(console.info("No codicon found for SymbolKind "+V),U=A.Codicon.symbolProperty),`${N?"inline":"block"} ${U.classNames}`}f.toCssClassName=W})(n=e.SymbolKinds||(e.SymbolKinds={}));class u{constructor(P){this.value=P}}e.FoldingRangeKind=u,u.Comment=new u("comment"),u.Imports=new u("imports"),u.Region=new u("region");var o;(function(f){f[f.Collapsed=0]="Collapsed",f[f.Expanded=1]="Expanded"})(o=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var l;(function(f){f[f.Editing=0]="Editing",f[f.Preview=1]="Preview"})(l=e.CommentMode||(e.CommentMode={}));var m;(function(f){f[f.Other=0]="Other",f[f.Type=1]="Type",f[f.Parameter=2]="Parameter"})(m=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new C.LanguageFeatureRegistry,e.RenameProviderRegistry=new C.LanguageFeatureRegistry,e.CompletionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new C.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new C.LanguageFeatureRegistry,e.HoverProviderRegistry=new C.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new C.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new C.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new C.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new C.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new C.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.LinkProviderRegistry=new C.LanguageFeatureRegistry,e.ColorProviderRegistry=new C.LanguageFeatureRegistry,e.SelectionRangeRegistry=new C.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.TokenizationRegistry=new y.TokenizationRegistryImpl;var b;(function(f){f[f.None=0]="None",f[f.Option=1]="Option",f[f.Default=2]="Default",f[f.Preferred=3]="Preferred"})(b=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(fe[63],me([0,1,11,9,4]),function(Y,e,p,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let y=p.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",p.isMacintosh),A.set("isLinux",p.isLinux),A.set("isWindows",p.isWindows),A.set("isWeb",p.isWeb),A.set("isMacNative",p.isMacintosh&&!p.isWeb),A.set("isEdge",y.indexOf("Edg/")>=0),A.set("isFirefox",y.indexOf("Firefox")>=0),A.set("isChrome",y.indexOf("Chrome")>=0),A.set("isSafari",y.indexOf("Safari")>=0);const _=Object.prototype.hasOwnProperty;var S;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return a.INSTANCE}static true(){return g.INSTANCE}static has(R){return d.create(R)}static equals(R,W){return w.create(R,W)}static notEquals(R,W){return E.create(R,W)}static regex(R,W){return s.create(R,W)}static in(R,W){return D.create(R,W)}static not(R){return c.create(R)}static and(...R){return o.create(R,null)}static or(...R){return l.create(R,null,!0)}static greater(R,W){return r.create(R,W)}static less(R,W){return t.create(R,W)}static deserialize(R,W=!1){if(!!R)return this._deserializeOrExpression(R,W)}static _deserializeOrExpression(R,W){let V=R.split("||");return l.create(V.map(N=>this._deserializeAndExpression(N,W)),null,!0)}static _deserializeAndExpression(R,W){let V=R.split("&&");return o.create(V.map(N=>this._deserializeOne(N,W)),null)}static _deserializeOne(R,W){if(R=R.trim(),R.indexOf("!=")>=0){let V=R.split("!=");return E.create(V[0].trim(),this._deserializeValue(V[1],W))}if(R.indexOf("==")>=0){let V=R.split("==");return w.create(V[0].trim(),this._deserializeValue(V[1],W))}if(R.indexOf("=~")>=0){let V=R.split("=~");return s.create(V[0].trim(),this._deserializeRegexValue(V[1],W))}if(R.indexOf(" in ")>=0){let V=R.split(" in ");return D.create(V[0].trim(),V[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(R)){const V=R.split(">=");return v.create(V[0].trim(),V[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(R)){const V=R.split(">");return r.create(V[0].trim(),V[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(R)){const V=R.split("<=");return h.create(V[0].trim(),V[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(R)){const V=R.split("<");return t.create(V[0].trim(),V[1].trim())}return/^\!\s*/.test(R)?c.create(R.substr(1).trim()):d.create(R)}static _deserializeValue(R,W){if(R=R.trim(),R==="true")return!0;if(R==="false")return!1;let V=/^'([^']*)'$/.exec(R);return V?V[1].trim():R}static _deserializeRegexValue(R,W){if((0,F.isFalsyOrWhitespace)(R)){if(W)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let V=R.indexOf("/"),N=R.lastIndexOf("/");if(V===N||V<0){if(W)throw new Error(`bad regexp-value '${R}', missing /-enclosure`);return console.warn(`bad regexp-value '${R}', missing /-enclosure`),null}let j=R.slice(V+1,N),U=R[N+1]==="i"?"i":"";try{return new RegExp(j,U)}catch(B){if(W)throw new Error(`bad regexp-value '${R}', parse error: ${B}`);return console.warn(`bad regexp-value '${R}', parse error: ${B}`),null}}}e.ContextKeyExpr=I;function i(M,R){const W=M?M.substituteConstants():void 0,V=R?R.substituteConstants():void 0;return!W&&!V?!0:!W||!V?!1:W.equals(V)}e.expressionsAreEqualWithConstantSubstitution=i;function k(M,R){return M.cmp(R)}class a{constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return g.INSTANCE}}e.ContextKeyFalseExpr=a,a.INSTANCE=new a;class g{constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return a.INSTANCE}}e.ContextKeyTrueExpr=g,g.INSTANCE=new g;class d{constructor(R,W){this.key=R,this.negated=W,this.type=2}static create(R,W=null){const V=A.get(R);return typeof V=="boolean"?V?g.INSTANCE:a.INSTANCE:new d(R,W)}cmp(R){return R.type!==this.type?this.type-R.type:b(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=A.get(this.key);return typeof R=="boolean"?R?g.INSTANCE:a.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.negated||(this.negated=c.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=d;class w{constructor(R,W,V){this.key=R,this.value=W,this.negated=V,this.type=4}static create(R,W,V=null){if(typeof W=="boolean")return W?d.create(R,V):c.create(R,V);const N=A.get(R);return typeof N=="boolean"?W===(N?"true":"false")?g.INSTANCE:a.INSTANCE:new w(R,W,V)}cmp(R){return R.type!==this.type?this.type-R.type:f(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){const R=A.get(this.key);if(typeof R=="boolean"){const W=R?"true":"false";return this.value===W?g.INSTANCE:a.INSTANCE}return this}evaluate(R){return R.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(R){return R.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class D{constructor(R,W){this.key=R,this.valueKey=W,this.type=10,this.negated=null}static create(R,W){return new D(R,W)}cmp(R){return R.type!==this.type?this.type-R.type:f(this.key,this.valueKey,R.key,R.valueKey)}equals(R){return R.type===this.type?this.key===R.key&&this.valueKey===R.valueKey:!1}substituteConstants(){return this}evaluate(R){const W=R.getValue(this.valueKey),V=R.getValue(this.key);return Array.isArray(W)?W.indexOf(V)>=0:typeof V=="string"&&typeof W=="object"&&W!==null?_.call(W,V):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(R){return R.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=T.create(this)),this.negated}}e.ContextKeyInExpr=D;class T{constructor(R){this._actual=R,this.type=11}static create(R){return new T(R)}cmp(R){return R.type!==this.type?this.type-R.type:this._actual.cmp(R._actual)}equals(R){return R.type===this.type?this._actual.equals(R._actual):!1}substituteConstants(){return this}evaluate(R){return!this._actual.evaluate(R)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(R){return new T(this._actual.map(R))}negate(){return this._actual}}e.ContextKeyNotInExpr=T;class E{constructor(R,W,V){this.key=R,this.value=W,this.negated=V,this.type=5}static create(R,W,V=null){if(typeof W=="boolean")return W?c.create(R,V):d.create(R,V);const N=A.get(R);return typeof N=="boolean"?W===(N?"true":"false")?a.INSTANCE:g.INSTANCE:new E(R,W,V)}cmp(R){return R.type!==this.type?this.type-R.type:f(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){const R=A.get(this.key);if(typeof R=="boolean"){const W=R?"true":"false";return this.value===W?a.INSTANCE:g.INSTANCE}return this}evaluate(R){return R.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(R){return R.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=E;class c{constructor(R,W){this.key=R,this.negated=W,this.type=3}static create(R,W=null){const V=A.get(R);return typeof V=="boolean"?V?a.INSTANCE:g.INSTANCE:new c(R,W)}cmp(R){return R.type!==this.type?this.type-R.type:b(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=A.get(this.key);return typeof R=="boolean"?R?a.INSTANCE:g.INSTANCE:this}evaluate(R){return!R.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(R){return R.mapNot(this.key)}negate(){return this.negated||(this.negated=d.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=c;class r{constructor(R,W,V){this.key=R,this.value=W,this.negated=V,this.type=12}static create(R,W,V=null){return new r(R,W,V)}cmp(R){return R.type!==this.type?this.type-R.type:f(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return parseFloat(R.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(R){return R.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=r;class v{constructor(R,W,V){this.key=R,this.value=W,this.negated=V,this.type=13}static create(R,W,V=null){return new v(R,W,V)}cmp(R){return R.type!==this.type?this.type-R.type:f(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return parseFloat(R.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(R){return R.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=v;class t{constructor(R,W,V){this.key=R,this.value=W,this.negated=V,this.type=14}static create(R,W,V=null){return new t(R,W,V)}cmp(R){return R.type!==this.type?this.type-R.type:f(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return parseFloat(R.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(R){return R.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=t;class h{constructor(R,W,V){this.key=R,this.value=W,this.negated=V,this.type=15}static create(R,W,V=null){return new h(R,W,V)}cmp(R){return R.type!==this.type?this.type-R.type:f(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return parseFloat(R.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(R){return R.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=h;class s{constructor(R,W){this.key=R,this.regexp=W,this.type=7,this.negated=null}static create(R,W){return new s(R,W)}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.key<R.key)return-1;if(this.key>R.key)return 1;const W=this.regexp?this.regexp.source:"",V=R.regexp?R.regexp.source:"";return W<V?-1:W>V?1:0}equals(R){if(R.type===this.type){const W=this.regexp?this.regexp.source:"",V=R.regexp?R.regexp.source:"";return this.key===R.key&&W===V}return!1}substituteConstants(){return this}evaluate(R){let W=R.getValue(this.key);return this.regexp?this.regexp.test(W):!1}serialize(){const R=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${R}`}keys(){return[this.key]}map(R){return R.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=s;class n{constructor(R){this._actual=R,this.type=8}static create(R){return new n(R)}cmp(R){return R.type!==this.type?this.type-R.type:this._actual.cmp(R._actual)}equals(R){return R.type===this.type?this._actual.equals(R._actual):!1}substituteConstants(){return this}evaluate(R){return!this._actual.evaluate(R)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(R){return new n(this._actual.map(R))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function u(M){let R=null;for(let W=0,V=M.length;W<V;W++){const N=M[W].substituteConstants();if(M[W]!==N&&R===null){R=[];for(let j=0;j<W;j++)R[j]=M[j]}R!==null&&(R[W]=N)}return R===null?M:R}class o{constructor(R,W){this.expr=R,this.negated=W,this.type=6}static create(R,W){return o._normalizeArr(R,W)}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let W=0,V=this.expr.length;W<V;W++){const N=k(this.expr[W],R.expr[W]);if(N!==0)return N}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let W=0,V=this.expr.length;W<V;W++)if(!this.expr[W].equals(R.expr[W]))return!1;return!0}return!1}substituteConstants(){const R=u(this.expr);return R===this.expr?this:o.create(R,this.negated)}evaluate(R){for(let W=0,V=this.expr.length;W<V;W++)if(!this.expr[W].evaluate(R))return!1;return!0}static _normalizeArr(R,W){const V=[];let N=!1;for(const j of R)if(!!j){if(j.type===1){N=!0;continue}if(j.type===0)return a.INSTANCE;if(j.type===6){V.push(...j.expr);continue}V.push(j)}if(V.length===0&&N)return g.INSTANCE;if(V.length!==0){if(V.length===1)return V[0];V.sort(k);for(let j=1;j<V.length;j++)V[j-1].equals(V[j])&&(V.splice(j,1),j--);if(V.length===1)return V[0];for(;V.length>1;){const j=V[V.length-1];if(j.type!==9)break;V.pop();const U=V.pop(),B=V.length===0,z=l.create(j.expr.map(O=>o.create([O,U],null)),null,B);z&&(V.push(z),V.sort(k))}return V.length===1?V[0]:new o(V,W)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(let W of this.expr)R.push(...W.keys());return R}map(R){return new o(this.expr.map(W=>W.map(R)),null)}negate(){if(!this.negated){const R=[];for(let W of this.expr)R.push(W.negate());this.negated=l.create(R,this,!0)}return this.negated}}class l{constructor(R,W){this.expr=R,this.negated=W,this.type=9}static create(R,W,V){return l._normalizeArr(R,W,V)}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let W=0,V=this.expr.length;W<V;W++){const N=k(this.expr[W],R.expr[W]);if(N!==0)return N}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let W=0,V=this.expr.length;W<V;W++)if(!this.expr[W].equals(R.expr[W]))return!1;return!0}return!1}substituteConstants(){const R=u(this.expr);return R===this.expr?this:l.create(R,this.negated,!1)}evaluate(R){for(let W=0,V=this.expr.length;W<V;W++)if(this.expr[W].evaluate(R))return!0;return!1}static _normalizeArr(R,W,V){let N=[],j=!1;if(R){for(let U=0,B=R.length;U<B;U++){const z=R[U];if(!!z){if(z.type===0){j=!0;continue}if(z.type===1)return g.INSTANCE;if(z.type===9){N=N.concat(z.expr);continue}N.push(z)}}if(N.length===0&&j)return a.INSTANCE;N.sort(k)}if(N.length!==0){if(N.length===1)return N[0];for(let U=1;U<N.length;U++)N[U-1].equals(N[U])&&(N.splice(U,1),U--);if(N.length===1)return N[0];if(V){for(let U=0;U<N.length;U++)for(let B=U+1;B<N.length;B++)P(N[U],N[B])&&(N.splice(B,1),B--);if(N.length===1)return N[0]}return new l(N,W)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(let W of this.expr)R.push(...W.keys());return R}map(R){return new l(this.expr.map(W=>W.map(R)),null)}negate(){if(!this.negated){let R=[];for(let W of this.expr)R.push(W.negate());for(;R.length>1;){const W=R.shift(),V=R.shift(),N=[];for(const U of L(W))for(const B of L(V))N.push(o.create([U,B],null));const j=R.length===0;R.unshift(l.create(N,null,j))}this.negated=R[0]}return this.negated}}class m extends d{constructor(R,W,V){super(R,null);this._defaultValue=W,typeof V=="object"?m._info.push({...V,key:R}):V!==!0&&m._info.push({key:R,description:V,type:W!=null?typeof W:void 0})}static all(){return m._info.values()}bindTo(R){return R.createKey(this.key,this._defaultValue)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return w.create(this.key,R)}notEqualsTo(R){return E.create(this.key,R)}}e.RawContextKey=m,m._info=[],e.IContextKeyService=(0,C.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function b(M,R){return M<R?-1:M>R?1:0}function f(M,R,W,V){return M<W?-1:M>W?1:R<V?-1:R>V?1:0}function P(M,R){if(R.type===6&&M.type!==9&&M.type!==6){for(const N of R.expr)if(M.equals(N))return!0}const W=M.negate(),V=L(W).concat(L(R));V.sort(k);for(let N=0;N<V.length;N++){const U=V[N].negate();for(let B=N+1;B<V.length;B++){const z=V[B];if(U.equals(z))return!0}}return!1}e.implies=P;function L(M){return M.type===9?M.expr:[M]}}),define(fe[186],me([0,1,4]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,p.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,p.refineServiceDecorator)(e.IEnvironmentService)}),define(fe[187],me([0,1,10,158,4]),function(Y,e,p,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var y;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(y=e.TargetPlatform||(e.TargetPlatform={}));function A(E){switch(E){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=A;function _(E){switch(E){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=_;function S(E,c){switch(E){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=S;function I(E,c){return c==="web"&&!E.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function i(E,c,r){return I(c,r)?!1:E==="undefined"||E==="universal"?!0:E==="unknown"?!1:E===r?!0:k(r).includes(E)}e.isTargetPlatformCompatible=i;function k(E){switch(E){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function a(E){return E&&typeof E=="object"&&typeof E.id=="string"&&(!E.uuid||typeof E.uuid=="string")}e.isIExtensionIdentifier=a;var g;(function(E){E[E.NoneOrRelevance=0]="NoneOrRelevance",E[E.LastUpdatedDate=1]="LastUpdatedDate",E[E.Title=2]="Title",E[E.PublisherName=3]="PublisherName",E[E.InstallCount=4]="InstallCount",E[E.PublishedDate=10]="PublishedDate",E[E.AverageRating=6]="AverageRating",E[E.WeightedRating=12]="WeightedRating"})(g=e.SortBy||(e.SortBy={}));var d;(function(E){E[E.Default=0]="Default",E[E.Ascending=1]="Ascending",E[E.Descending=2]="Descending"})(d=e.SortOrder||(e.SortOrder={}));var w;(function(E){E.Install="install",E.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var D;(function(E){E[E.None=0]="None",E[E.Install=1]="Install",E[E.Update=2]="Update"})(D=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class T extends Error{constructor(c,r){super(c);this.code=r,this.name=r}}e.ExtensionManagementError=T,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=p.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,F.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,F.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,C.createDecorator)("IExtensionManagementCLIService")}),define(fe[188],me([0,1,4]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,p.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,p.createDecorator)("externalTerminal")}),define(fe[189],me([0,1,39,10,8,11,96,28,114,160,188]),function(Y,e,p,F,C,y,A,_,S,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=I.localize(0,null);class a{async getDefaultTerminalForPlatforms(){return{windows:g.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class g extends a{openTerminal(r,v){return this.spawnTerminal(p,r,S.getWindowsShell(),v)}spawnTerminal(r,v,t,h){const s=v.windowsExec||g.getDefaultTerminalWindows();h&&h[1]===":"&&(h=h[0].toUpperCase()+h.substr(1));const n=C.basename(s).toLowerCase();if(n==="cmder"||n==="cmder.exe")return r.spawn(s,h?[h]:void 0),Promise.resolve(void 0);const u=["/c","start","/wait"];return s.indexOf(" ")>=0&&u.push('""'),u.push(s),(n==="wt"||n==="wt.exe")&&u.push("-d ."),new Promise((o,l)=>{const m=D(process),b=r.spawn(t,u,{cwd:h,env:m});b.on("error",l),b.on("exit",()=>o())})}runInTerminal(r,v,t,h,s){const n="windowsExec"in s&&s.windowsExec?s.windowsExec:g.getDefaultTerminalWindows();return new Promise((u,o)=>{const l=`"${v} - ${k}"`,m=`""${t.join('" "')}" & pause"`,b=["/c","start",l,"/wait",n,"/c",m],f=Object.assign({},D(process),h);Object.keys(f).filter(M=>f[M]===null).forEach(M=>delete f[M]);const P={cwd:v,env:f,windowsVerbatimArguments:!0};p.spawn(g.CMD,b,P).on("error",M=>{o(T(M))}),u(void 0)})}static getDefaultTerminalWindows(){if(!g._DEFAULT_TERMINAL_WINDOWS){const r=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");g._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${r?"Sysnative":"System32"}\\cmd.exe`}return g._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=g,g.CMD="cmd.exe";class d extends a{openTerminal(r,v){return this.spawnTerminal(p,r,v)}runInTerminal(r,v,t,h,s){const n=s.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((u,o)=>{if(n===i.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const l=n===i.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",b=[F.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${l}.scpt`,Y).fsPath,"-t",r||k,"-w",v];for(let L of t)b.push("-a"),b.push(L);if(h){const L=Object.assign({},D(process),h);for(let M in L){const R=L[M];R===null?(b.push("-u"),b.push(M)):(b.push("-e"),b.push(`${M}=${R}`))}}let f="";const P=p.spawn(d.OSASCRIPT,b);P.on("error",L=>{o(T(L))}),P.stderr.on("data",L=>{f+=L.toString()}),P.on("exit",L=>{if(L===0)u(void 0);else if(f){const M=f.split(`
`,1);o(new Error(M[0]))}else o(new Error(I.localize(1,null,l,L)))})}else o(new Error(I.localize(2,null,n)))})}spawnTerminal(r,v,t){const h=v.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((s,n)=>{const u=["-a",h];t&&u.push(t);const o=D(process),l=r.spawn("/usr/bin/open",u,{cwd:t,env:o});l.on("error",n),l.on("exit",()=>s())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class w extends a{openTerminal(r,v){return this.spawnTerminal(p,r,v)}runInTerminal(r,v,t,h,s){const n=s.linuxExec?Promise.resolve(s.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((u,o)=>{let l=[];n.then(m=>{m.indexOf("gnome-terminal")>=0?l.push("-x"):l.push("-e"),l.push("bash"),l.push("-c");const b=`${E(t)}; echo; read -p "${w.WAIT_MESSAGE}" -n1;`;l.push(`''${b}''`);const f=Object.assign({},D(process),h);Object.keys(f).filter(R=>f[R]===null).forEach(R=>delete f[R]);const P={cwd:v,env:f};let L="";const M=p.spawn(m,l,P);M.on("error",R=>{o(T(R))}),M.stderr.on("data",R=>{L+=R.toString()}),M.on("exit",R=>{if(R===0)u(void 0);else if(L){const W=L.split(`
`,1);o(new Error(W[0]))}else o(new Error(I.localize(4,null,m,R)))})})})}static async getDefaultTerminalLinuxReady(){if(!w._DEFAULT_TERMINAL_LINUX_READY)if(!y.isLinux)w._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const r=await _.Promises.exists("/etc/debian_version");w._DEFAULT_TERMINAL_LINUX_READY=new Promise(v=>{r?v("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?v("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?v("konsole"):process.env.COLORTERM?v(process.env.COLORTERM):process.env.TERM?v(process.env.TERM):v("xterm")})}return w._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(r,v,t){const h=v.linuxExec?Promise.resolve(v.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((s,n)=>{h.then(u=>{const o=D(process),l=r.spawn(u,[],{cwd:t,env:o});l.on("error",n),l.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=w,w.WAIT_MESSAGE=I.localize(3,null);function D(c){const r={...c.env};return(0,A.sanitizeProcessEnvironment)(r),r}function T(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(I.localize(5,null,c.path)):c}function E(c){let r="";for(let v of c)v.indexOf(" ")>=0?r+='"'+v+'"':r+=v,r+=" ";return r}}),define(fe[43],me([0,1,24,8,9,12,2,161,4]),function(Y,e,p,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function I(N){return N.create===!0}e.isFileOpenForWriteOptions=I;var i;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var k;(function(N){N[N.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var a;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(a=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=g;function d(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=d;function w(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function D(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=D;var T;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(T=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(j,U){super(j);this.code=U}}e.FileSystemProviderError=E;function c(N,j){const U=new E(N.toString(),j);return v(U,j),U}e.createFileSystemProviderError=c;function r(N){return N||c((0,_.localize)(0,null),T.Unknown)}e.ensureFileSystemProviderError=r;function v(N,j){return N.name=j?`${j} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=v;function t(N){if(!N)return T.Unknown;if(N instanceof E)return N.code;const j=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!j)return T.Unknown;switch(j[1]){case T.FileExists:return T.FileExists;case T.FileIsADirectory:return T.FileIsADirectory;case T.FileNotADirectory:return T.FileNotADirectory;case T.FileNotFound:return T.FileNotFound;case T.FileExceedsMemoryLimit:return T.FileExceedsMemoryLimit;case T.FileTooLarge:return T.FileTooLarge;case T.FileWriteLocked:return T.FileWriteLocked;case T.NoPermissions:return T.NoPermissions;case T.Unavailable:return T.Unavailable}return T.Unknown}e.toFileSystemProviderErrorCode=t;function h(N){if(N instanceof m)return N.fileOperationResult;switch(t(N)){case T.FileNotFound:return 1;case T.FileIsADirectory:return 0;case T.FileNotADirectory:return 10;case T.FileWriteLocked:return 5;case T.NoPermissions:return 6;case T.FileExists:return 4;case T.FileExceedsMemoryLimit:return 9;case T.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=h;var s;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class n{constructor(j,U,B){this.resource=j,this.operation=U,this.target=B}isOperation(j){return this.operation===j}}e.FileOperationEvent=n;var u;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class o{constructor(j,U){this.added=void 0,this.updated=void 0,this.deleted=void 0;const B=new Map;for(const z of j){const O=B.get(z.type);O?O.push([z.resource,z]):B.set(z.type,[[z.resource,z]])}for(const[z,O]of B)switch(z){case 1:this.added=p.TernarySearchTree.forUris(()=>U),this.added.fill(O);break;case 0:this.updated=p.TernarySearchTree.forUris(()=>U),this.updated.fill(O);break;case 2:this.deleted=p.TernarySearchTree.forUris(()=>U),this.deleted.fill(O);break}}contains(j,...U){return this.doContains(j,{includeChildren:!1},...U)}affects(j,...U){return this.doContains(j,{includeChildren:!0},...U)}doContains(j,U,...B){if(!j)return!1;const z=B.length>0;return!!((!z||B.includes(1))&&(this.added?.get(j)||U.includeChildren&&this.added?.findSuperstr(j))||(!z||B.includes(0))&&(this.updated?.get(j)||U.includeChildren&&this.updated?.findSuperstr(j))||(!z||B.includes(2))&&(this.deleted?.findSubstr(j)||U.includeChildren&&this.deleted?.findSuperstr(j)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=o;function l(N,j,U){return!N||!j||N===j||j.length>N.length?!1:(j.charAt(j.length-1)!==F.sep&&(j+=F.sep),U?(0,C.startsWithIgnoreCase)(N,j):N.indexOf(j)===0)}e.isParent=l;class m extends Error{constructor(j,U,B){super(j);this.fileOperationResult=U,this.options=B}}e.FileOperationError=m;class b extends m{constructor(j,U,B){super(j,2,B);this.stat=U}}e.NotModifiedSinceFileOperationError=b;var f;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(f=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var P;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(P=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=L;async function M(N,j){if(!j.hasProvider(A.URI.from({scheme:N.scheme})))return new Promise(U=>{const B=j.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===N.scheme&&z.added&&(B.dispose(),U())})})}e.whenProviderRegistered=M,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class R{static formatSize(j){return(0,y.isNumber)(j)||(j=0),j<R.KB?(0,_.localize)(1,null,j.toFixed(0)):j<R.MB?(0,_.localize)(2,null,(j/R.KB).toFixed(2)):j<R.GB?(0,_.localize)(3,null,(j/R.MB).toFixed(2)):j<R.TB?(0,_.localize)(4,null,(j/R.GB).toFixed(2)):(0,_.localize)(5,null,(j/R.TB).toFixed(2))}}e.ByteSize=R,R.KB=1024,R.MB=R.KB*R.KB,R.GB=R.MB*R.KB,R.TB=R.GB*R.KB;var W;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(W=e.Arch||(e.Arch={}));function V(N){return{maxFileSize:N===0?300*R.MB:16*R.GB,maxHeapSize:N===0?700*R.MB:2*700*R.MB}}e.getPlatformLimits=V}),define(fe[85],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...C){this._entries=new Map;for(let[y,A]of C)this.set(y,A)}set(C,y){const A=this._entries.get(C);return this._entries.set(C,y),A}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=p}),define(fe[190],me([0,1,15,17,116,183,4,85]),function(Y,e,p,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class I extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class i{constructor(d=new _.ServiceCollection,w=!1,D){this._activeInstantiations=new Set,this._services=d,this._strict=w,this._parent=D,this._services.set(A.IInstantiationService,this)}createChild(d){return new i(d,this._strict,this)}invokeFunction(d,...w){let D=a.traceInvocation(d),T=!1;try{return d({get:(c,r)=>{if(T)throw(0,F.illegalState)("service accessor is only valid during the invocation of its target method");const v=this._getOrCreateServiceInstance(c,D);if(!v&&r!==A.optional)throw new Error(`[invokeFunction] unknown service '${c}'`);return v}},...w)}finally{T=!0,D.stop()}}createInstance(d,...w){let D,T;return d instanceof C.SyncDescriptor?(D=a.traceCreation(d.ctor),T=this._createInstance(d.ctor,d.staticArguments.concat(w),D)):(D=a.traceCreation(d),T=this._createInstance(d,w,D)),D.stop(),T}_createInstance(d,w=[],D){let T=A._util.getServiceDependencies(d).sort((r,v)=>r.index-v.index),E=[];for(const r of T){let v=this._getOrCreateServiceInstance(r.id,D);if(!v&&this._strict&&!r.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${r.id}.`);E.push(v)}let c=T.length>0?T[0].index:w.length;if(w.length!==c){console.warn(`[createInstance] First service dependency of ${d.name} at position ${c+1} conflicts with ${w.length} static arguments`);let r=c-w.length;r>0?w=w.concat(new Array(r)):w=w.slice(0,c)}return new d(...[...w,...E])}_setServiceInstance(d,w){if(this._services.get(d)instanceof C.SyncDescriptor)this._services.set(d,w);else if(this._parent)this._parent._setServiceInstance(d,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let w=this._services.get(d);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):w}_getOrCreateServiceInstance(d,w){let D=this._getServiceInstanceOrDescriptor(d);return D instanceof C.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,D,w.branch(d,!0)):(w.branch(d,!1),D)}_safeCreateAndCacheServiceInstance(d,w,D){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,w,D)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,w,D){const T=new y.Graph(r=>r.id.toString());let E=0;const c=[{id:d,desc:w,_trace:D}];for(;c.length;){const r=c.pop();if(T.lookupOrInsertNode(r),E++>1e3)throw new I(T);for(let v of A._util.getServiceDependencies(r.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(v.id);if(!t&&!v.optional&&console.warn(`[createInstance] ${d} depends on ${v.id} which is NOT registered.`),t instanceof C.SyncDescriptor){const h={id:v.id,desc:t,_trace:r._trace.branch(v.id,!0)};T.insertEdge(r,h),c.push(h)}}}for(;;){const r=T.roots();if(r.length===0){if(!T.isEmpty())throw new I(T);break}for(const{data:v}of r){if(this._getServiceInstanceOrDescriptor(v.id)instanceof C.SyncDescriptor){const h=this._createServiceInstanceWithOwner(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this._setServiceInstance(v.id,h)}T.removeNode(v)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,w,D=[],T,E){if(this._services.get(d)instanceof C.SyncDescriptor)return this._createServiceInstance(w,D,T,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,w,D,T,E);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(d,w=[],D,T){if(D){const E=new p.IdleValue(()=>this._createInstance(d,w,T));return new Proxy(Object.create(null),{get(c,r){if(r in c)return c[r];let v=E.value,t=v[r];return typeof t!="function"||(t=t.bind(v),c[r]=t),t},set(c,r,v){return E.value[r]=v,!0}})}else return this._createInstance(d,w,T)}}e.InstantiationService=i;var k;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(k||(k={}));class a{constructor(d,w){this.type=d,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return S?new a(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):a._None}static traceCreation(d){return S?new a(0,d.name):a._None}branch(d,w){let D=new a(2,d.toString());return this._dep.push([d,w,D]),D}stop(){let d=Date.now()-this._start;a._totals+=d;let w=!1;function D(E,c){let r=[],v=new Array(E+1).join("	");for(const[t,h,s]of c._dep)if(h&&s){w=!0,r.push(`${v}CREATES -> ${t}`);let n=D(E+1,s);n&&r.push(n)}else r.push(`${v}uses -> ${t}`);return r.join(`
`)}let T=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${D(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${a._totals.toFixed(2)}ms)`];(d>2||w)&&console.log(T.join(`
`))}}a._None=new class extends a{constructor(){super(-1,null)}stop(){}branch(){return this}},a._totals=0}),define(fe[13],me([0,1,52,3,6,11,4]),function(Y,e,p,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function _(){return new Date().toISOString()}var S;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class I extends C.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new F.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class i extends I{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...h){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([t,...h]))}debug(t,...h){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([t,...h]))}info(t,...h){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([t,...h]))}warn(t,...h){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([t,...h]))}error(t,...h){if(this.checkLogLevel(S.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(S.Error,this.format(s))}else this.log(S.Error,this.format([t,...h]))}critical(t,...h){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([t,...h]))}flush(){}format(t){let h="";for(let s=0;s<t.length;s++){let n=t[s];if(typeof n=="object")try{n=JSON.stringify(n)}catch(u){}h+=(s>0?" ":"")+n}return h}}e.AbstractMessageLogger=i;class k extends I{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!y.isWindows}trace(t,...h){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${_()}][0m`,t,...h):console.log(`[main ${_()}]`,t,...h))}debug(t,...h){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${_()}][0m`,t,...h):console.log(`[main ${_()}]`,t,...h))}info(t,...h){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${_()}][0m`,t,...h):console.log(`[main ${_()}]`,t,...h))}warn(t,...h){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${_()}][0m`,t,...h):console.warn(`[main ${_()}]`,t,...h))}error(t,...h){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${_()}][0m`,t,...h):console.error(`[main ${_()}]`,t,...h))}critical(t,...h){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${_()}][0m`,t,...h):console.error(`[main ${_()}]`,t,...h))}dispose(){}flush(){}}e.ConsoleMainLogger=k;class a extends I{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...h){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",t,...h)}debug(t,...h){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...h)}info(t,...h){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",t,...h)}warn(t,...h){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",t,...h)}error(t,...h){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",t,...h)}critical(t,...h){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...h)}dispose(){}flush(){}}e.ConsoleLogger=a;class g extends I{constructor(t,h=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(h)}trace(t,...h){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(t),...h])}debug(t,...h){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(t),...h])}info(t,...h){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(t),...h])}warn(t,...h){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(t),...h])}error(t,...h){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(t),...h])}critical(t,...h){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(t),...h])}extractMessage(t){return typeof t=="string"?t:(0,p.toErrorMessage)(t,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class d extends I{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const h of this.logServices)h.setLevel(t);super.setLevel(t)}trace(t,...h){for(const s of this.logServices)s.trace(t,...h)}debug(t,...h){for(const s of this.logServices)s.debug(t,...h)}info(t,...h){for(const s of this.logServices)s.info(t,...h)}warn(t,...h){for(const s of this.logServices)s.warn(t,...h)}error(t,...h){for(const s of this.logServices)s.error(t,...h)}critical(t,...h){for(const s of this.logServices)s.critical(t,...h)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=d;class w extends C.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...h){this.logger.trace(t,...h)}debug(t,...h){this.logger.debug(t,...h)}info(t,...h){this.logger.info(t,...h)}warn(t,...h){this.logger.warn(t,...h)}error(t,...h){this.logger.error(t,...h)}critical(t,...h){this.logger.critical(t,...h)}flush(){this.logger.flush()}}e.LogService=w;class D extends C.Disposable{constructor(t,h){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(h(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(s))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,h){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,h?.always?S.Trace:this.logLevel,h),this.loggers.set(t.toString(),s),h?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=D;class T{constructor(){this.onDidChangeLogLevel=new F.Emitter().event}setLevel(t){}getLevel(){return S.Info}trace(t,...h){}debug(t,...h){}info(t,...h){}warn(t,...h){}error(t,...h){}critical(t,...h){}dispose(){}flush(){}}e.NullLogService=T;function E(v){if(v.verbose)return S.Trace;if(typeof v.logLevel=="string"){const t=c(v.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function c(v){switch(v){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=c;function r(v){switch(v){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=r}),define(fe[117],me([0,1,43,13]),function(Y,e,p,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function C(S,I,i,k){try{const a=await new Promise((g,d)=>{Y(["spdlog"],g,d)});return a.setFlushOn(F.LogLevel.Trace),a.createAsyncRotatingLogger(S,I,i,k)}catch(a){console.error(a)}return null}function y(S,I,i,k){const a=Y.__$__nodeRequire("spdlog");return a.setFlushOn(F.LogLevel.Trace),a.createRotatingLogger(S,I,i,k)}e.createRotatingLogger=y;function A(S,I,i){switch(I){case F.LogLevel.Trace:S.trace(i);break;case F.LogLevel.Debug:S.debug(i);break;case F.LogLevel.Info:S.info(i);break;case F.LogLevel.Warning:S.warn(i);break;case F.LogLevel.Error:S.error(i);break;case F.LogLevel.Critical:S.critical(i);break;default:throw new Error("Invalid log level")}}class _ extends F.AbstractMessageLogger{constructor(I,i,k,a){super();this.name=I,this.filepath=i,this.rotating=k,this.buffer=[],this.setLevel(a),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(g=>{this._logger&&this._logger.setLevel(g)}))}_createSpdLogLogger(){const I=this.rotating?6:1,i=30/I*p.ByteSize.MB;return C(this.name,this.filepath,i,I).then(k=>{if(k){this._logger=k,this._logger.setLevel(this.getLevel());for(const{level:a,message:g}of this.buffer)A(this._logger,a,g);this.buffer=[]}})}log(I,i){this._logger?A(this._logger,I,i):this.getLevel()<=I&&this.buffer.push({level:I,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=_}),define(fe[118],me([0,1,49,162,4]),function(Y,e,p,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var y;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(y=e.MarkerTag||(e.MarkerTag={}));var A;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(A=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function I(d,w){return w-d}S.compare=I;const i=Object.create(null);i[S.Error]=(0,F.localize)(0,null),i[S.Warning]=(0,F.localize)(1,null),i[S.Info]=(0,F.localize)(2,null);function k(d){return i[d]||""}S.toString=k;function a(d){switch(d){case p.default.Error:return S.Error;case p.default.Warning:return S.Warning;case p.default.Info:return S.Info;case p.default.Ignore:return S.Hint}}S.fromSeverity=a;function g(d){switch(d){case S.Error:return p.default.Error;case S.Warning:return p.default.Warning;case S.Info:return p.default.Info;case S.Hint:return p.default.Ignore}}S.toSeverity=g}(A=e.MarkerSeverity||(e.MarkerSeverity={}));var _;(function(S){const I="";function i(a){return k(a,!0)}S.makeKey=i;function k(a,g){let d=[I];return a.source?d.push(a.source.replace("\xA6","\\\xA6")):d.push(I),a.code?typeof a.code=="string"?d.push(a.code.replace("\xA6","\\\xA6")):d.push(a.code.value.replace("\xA6","\\\xA6")):d.push(I),a.severity!==void 0&&a.severity!==null?d.push(A.toString(a.severity)):d.push(I),a.message&&g?d.push(a.message.replace("\xA6","\\\xA6")):d.push(I),a.startLineNumber!==void 0&&a.startLineNumber!==null?d.push(a.startLineNumber.toString()):d.push(I),a.startColumn!==void 0&&a.startColumn!==null?d.push(a.startColumn.toString()):d.push(I),a.endLineNumber!==void 0&&a.endLineNumber!==null?d.push(a.endLineNumber.toString()):d.push(I),a.endColumn!==void 0&&a.endColumn!==null?d.push(a.endColumn.toString()):d.push(I),d.push(I),d.join("\xA6")}S.makeKeyOptionalMessage=k})(_=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,C.createDecorator)("markerService")}),define(fe[191],me([0,1,3,49,4]),function(Y,e,p,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=F.default,e.INotificationService=(0,C.createDecorator)("notificationService");var y;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.GLOBAL=1]="GLOBAL"})(y=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var A;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(A=e.NotificationsFilter||(e.NotificationsFilter={}));class _{constructor(){this.progress=new S,this.onDidClose=p.Event.None,this.onDidChangeVisibility=p.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=_;class S{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=S}),define(fe[192],me([0,1,6,9,2,4]),function(Y,e,p,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,y.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return p.Disposable.None},registerValidator(){return p.Disposable.None},registerExternalUriResolver(){return p.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return p.Disposable.None},async open(){return!1},async resolveExternalUri(_){return{resolved:_,dispose(){}}}});function A(_,S){return C.URI.isUri(_)?(0,F.equalsIgnoreCase)(_.scheme,S):(0,F.startsWithIgnoreCase)(_,S+":")}e.matchesScheme=A}),define(fe[193],me([0,1,10,11,38,23]),function(Y,e,p,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof F.globals.vscode!="undefined"&&typeof F.globals.vscode.context!="undefined"){const _=F.globals.vscode.context.configuration();if(_)A=_.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const _=(0,y.dirname)(p.FileAccess.asFileUri("",Y));A=Y.__$__nodeRequire((0,y.joinPath)(_,"product.json").fsPath);const S=Y.__$__nodeRequire((0,y.joinPath)(_,"package.json").fsPath);C.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:S.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A});var $e=this&&this.__param||function(Y,e){return function(p,F){e(p,F,Y)}};define(fe[119],me([0,1,15,21,6,4]),function(Y,e,p,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,y.createDecorator)("progressService");var A;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(A=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class _{constructor(k){this.callback=k}get value(){return this._value}report(k){this._value=k,this.callback(this._value)}}e.Progress=_,_.None=Object.freeze({report(){}});let S=class extends C.Disposable{constructor(k,a){super();this.deferred=new p.DeferredPromise,a.withProgress(k,g=>(this.reporter=g,this.lastStep&&g.report(this.lastStep),this.deferred.p)),this._register((0,C.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};S=Ve([$e(1,e.IProgressService)],S),e.UnmanagedProgress=S;class I extends C.Disposable{constructor(k){super();this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new C.DisposableStore)}start(k){this.stop();const a=++this.currentOperationId,g=new F.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{a===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,C.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,C.toDisposable)(()=>g.cancel())),this.currentOperationDisposables.add((0,C.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:a,token:g.token,stop:()=>this.doStop(a),isCurrent:()=>this.currentOperationId===a}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,y.createDecorator)("editorProgressService")}),define(fe[34],me([0,1,58,12]),function(Y,e,p,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(A,_){p.ok(F.isString(A)),p.ok(F.isObject(_)),p.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,_)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new C}),define(fe[120],me([0,1,3,34]),function(Y,e,p,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(_){return _.length>0&&_.charAt(_.length-1)==="#"?_.substring(0,_.length-1):_}class y{constructor(){this._onDidChangeSchema=new p.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,I){this.schemasById[C(S)]=I,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new y;F.Registry.add(e.Extensions.JSONContribution,A)}),define(fe[86],me([0,1,18,3,12,157,120,34]),function(Y,e,p,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(E){E.Multiline="multilineText",E.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const i=_.Registry.as(A.Extensions.JSONContribution);class k{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new F.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new F.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:y.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(c,r=!0){this.registerConfigurations([c],r)}registerConfigurations(c,r=!0){const v=this.doRegisterConfigurations(c,r);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}deregisterConfigurations(c){const r=this.doDeregisterConfigurations(c);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}updateConfigurations({add:c,remove:r}){const v=[];v.push(...this.doDeregisterConfigurations(r)),v.push(...this.doRegisterConfigurations(c,!1)),i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,p.distinct)(v))}registerDefaultConfigurations(c){const r=[],v=[];for(const t of c)for(const h in t)if(r.push(h),e.OVERRIDE_PROPERTY_PATTERN.test(h)){this.defaultValues[h]={...this.defaultValues[h]||{},...t[h]};const s={type:"object",default:this.defaultValues[h],description:y.localize(1,null,h),$ref:e.resourceLanguageSettingsSchemaId};v.push(g(h)),this.configurationProperties[h]=s,this.defaultLanguageConfigurationOverridesNode.properties[h]=s}else{this.defaultValues[h]=t[h];const s=this.configurationProperties[h];s&&(this.updatePropertyDefaultValue(h,s),this.updateSchema(h,s))}this.registerOverrideIdentifiers(v),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}deregisterDefaultConfigurations(c){const r=[];for(const v of c)for(const t in v)if(r.push(t),delete this.defaultValues[t],e.OVERRIDE_PROPERTY_PATTERN.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const h=this.configurationProperties[t];h&&(this.updatePropertyDefaultValue(t,h),this.updateSchema(t,h))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}notifyConfigurationSchemaUpdated(...c){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(c){for(const r of c)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(c,r){const v=[];return c.forEach(t=>{v.push(...this.validateAndRegisterProperties(t,r,t.extensionInfo)),this.configurationContributors.push(t),this.registerJSONConfiguration(t)}),v}doDeregisterConfigurations(c){const r=[],v=t=>{if(t.properties)for(const h in t.properties)r.push(h),delete this.configurationProperties[h],this.removeFromSchema(h,t.properties[h]);t.allOf&&t.allOf.forEach(h=>v(h))};for(const t of c){v(t);const h=this.configurationContributors.indexOf(t);h!==-1&&this.configurationContributors.splice(h,1)}return r}validateAndRegisterProperties(c,r=!0,v,t=3){t=C.isUndefinedOrNull(c.scope)?t:c.scope;let h=[],s=c.properties;if(s)for(let u in s){if(r&&D(u)){delete s[u];continue}const o=s[u];if(this.updatePropertyDefaultValue(u,o),e.OVERRIDE_PROPERTY_PATTERN.test(u)?o.scope=void 0:(o.scope=C.isUndefinedOrNull(o.scope)?t:o.scope,o.restricted=C.isUndefinedOrNull(o.restricted)?!!v?.restrictedConfigurations?.includes(u):o.restricted),s[u].hasOwnProperty("included")&&!s[u].included){this.excludedConfigurationProperties[u]=s[u],delete s[u];continue}else this.configurationProperties[u]=s[u];!s[u].deprecationMessage&&s[u].markdownDeprecationMessage&&(s[u].deprecationMessage=s[u].markdownDeprecationMessage),h.push(u)}let n=c.allOf;if(n)for(let u of n)h.push(...this.validateAndRegisterProperties(u,r,v,t));return h}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(c){const r=v=>{let t=v.properties;if(t)for(const s in t)this.updateSchema(s,t[s]);let h=v.allOf;h&&h.forEach(r)};r(c)}updateSchema(c,r){switch(e.allSettings.properties[c]=r,r.scope){case 1:e.applicationSettings.properties[c]=r;break;case 2:e.machineSettings.properties[c]=r;break;case 6:e.machineOverridableSettings.properties[c]=r;break;case 3:e.windowSettings.properties[c]=r;break;case 4:e.resourceSettings.properties[c]=r;break;case 5:e.resourceSettings.properties[c]=r,this.resourceLanguageSettingsSchema.properties[c]=r;break}}removeFromSchema(c,r){switch(delete e.allSettings.properties[c],r.scope){case 1:delete e.applicationSettings.properties[c];break;case 2:delete e.machineSettings.properties[c];break;case 6:delete e.machineOverridableSettings.properties[c];break;case 3:delete e.windowSettings.properties[c];break;case 4:case 5:delete e.resourceSettings.properties[c];break}}updateOverridePropertyPatternKey(){for(const c of this.overrideIdentifiers.values()){const r=`[${c}]`,v={type:"object",description:y.localize(2,null),errorMessage:y.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,v),e.allSettings.properties[r]=v,e.applicationSettings.properties[r]=v,e.machineSettings.properties[r]=v,e.machineOverridableSettings.properties[r]=v,e.windowSettings.properties[r]=v,e.resourceSettings.properties[r]=v}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(c,r){let v=this.defaultValues[c];C.isUndefined(v)&&(v=r.default),C.isUndefined(v)&&(v=d(r.type)),r.default=v}}const a="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(a);function g(E){return E.substring(1,E.length-1)}e.overrideIdentifierFromKey=g;function d(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const w=new k;_.Registry.add(e.Extensions.Configuration,w);function D(E){return E.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(E)?y.localize(5,null,E):w.getConfigurationProperties()[E]!==void 0?y.localize(6,null,E):null:y.localize(4,null)}e.validateProperty=D;function T(){const E=[],c=w.getConfigurationProperties();for(const r of Object.keys(c))E.push([r,c[r].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=T}),define(fe[121],me([0,1,25,12,2,86,4,34]),function(Y,e,p,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function S(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof C.URI)}e.isConfigurationOverrides=S;var I;(function(h){h[h.USER=1]="USER",h[h.USER_LOCAL=2]="USER_LOCAL",h[h.USER_REMOTE=3]="USER_REMOTE",h[h.WORKSPACE=4]="WORKSPACE",h[h.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",h[h.DEFAULT=6]="DEFAULT",h[h.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(h){switch(h){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function k(h,s){const n=s?h?s.keys.filter(P=>h.keys.indexOf(P)===-1):[...s.keys]:[],u=h?s?h.keys.filter(P=>s.keys.indexOf(P)===-1):[...h.keys]:[],o=[];if(s&&h){for(const P of h.keys)if(s.keys.indexOf(P)!==-1){const L=T(h.contents,P),M=T(s.contents,P);p.equals(L,M)||o.push(P)}}const l=[],m=P=>{const L={};for(const M of P)for(const R of M.identifiers)L[v(R)]=M;return L},b=s?m(s.overrides):{},f=h?m(h.overrides):{};if(Object.keys(b).length)for(const P of n){const L=b[P];L&&l.push([(0,y.overrideIdentifierFromKey)(P),L.keys])}if(Object.keys(f).length)for(const P of u){const L=f[P];L&&l.push([(0,y.overrideIdentifierFromKey)(P),L.keys])}if(Object.keys(b).length&&Object.keys(f).length)for(const P of o){const L=f[P],M=b[P];if(L&&M){const R=k({contents:L.contents,keys:L.keys,overrides:[]},{contents:M.contents,keys:M.keys,overrides:[]});l.push([(0,y.overrideIdentifierFromKey)(P),[...R.added,...R.removed,...R.updated]])}}return{added:n,removed:u,updated:o,overrides:l}}e.compare=k;function a(h,s){const n=[];for(const u of Object.keys(h))if(y.OVERRIDE_PROPERTY_PATTERN.test(u)){const o={};for(const l in h[u])o[l]=h[u][l];n.push({identifiers:[(0,y.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(o),contents:g(o,s)})}return n}e.toOverrides=a;function g(h,s){const n=Object.create(null);for(let u in h)d(n,u,h[u],s);return n}e.toValuesTree=g;function d(h,s,n,u){const o=s.split("."),l=o.pop();let m=h;for(let b=0;b<o.length;b++){let f=o[b],P=m[f];switch(typeof P){case"undefined":P=m[f]=Object.create(null);break;case"object":break;default:u(`Ignoring ${s} as ${o.slice(0,b+1).join(".")} is ${JSON.stringify(P)}`);return}m=P}if(typeof m=="object"&&m!==null)try{m[l]=n}catch(b){u(`Ignoring ${s} as ${o.join(".")} is ${JSON.stringify(m)}`)}else u(`Ignoring ${s} as ${o.join(".")} is ${JSON.stringify(m)}`)}e.addToValueTree=d;function w(h,s){const n=s.split(".");D(h,n)}e.removeFromValueTree=w;function D(h,s){const n=s.shift();if(s.length===0){delete h[n];return}if(Object.keys(h).indexOf(n)!==-1){const u=h[n];typeof u=="object"&&!Array.isArray(u)&&(D(u,s),Object.keys(u).length===0&&delete h[n])}}function T(h,s,n){function u(m,b){let f=m;for(const P of b){if(typeof f!="object"||f===null)return;f=f[P]}return f}const o=s.split("."),l=u(h,o);return typeof l=="undefined"?n:l}e.getConfigurationValue=T;function E(h,s,n){Object.keys(s).forEach(u=>{u!=="__proto__"&&(u in h?F.isObject(h[u])&&F.isObject(s[u])?E(h[u],s[u],n):n&&(h[u]=s[u]):h[u]=s[u])})}e.merge=E;function c(){const h=_.Registry.as(y.Extensions.Configuration).getConfigurationProperties();return Object.keys(h)}e.getConfigurationKeys=c;function r(){const h=Object.create(null),s=_.Registry.as(y.Extensions.Configuration).getConfigurationProperties();for(let n in s){let u=s[n].default;d(h,n,u,o=>console.error(`Conflict in default settings: ${o}`))}return h}e.getDefaultValues=r;function v(h){return`[${h}]`}e.keyFromOverrideIdentifier=v;function t(h,s,n){const u=h.inspect(s),o=h.inspect(n);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:u.defaultValue}e.getMigratedSettingValue=t}),define(fe[194],me([0,1,18,3,61,6,24,25,12,2,121,86,34]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class g{constructor(t={},h=[],s=[]){this._contents=t,this._keys=h,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,h){const s=this.getContentsForOverrideIdentifer(h);return s?t?(0,i.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const h of this.overrides)if(h.identifiers.indexOf(t)!==-1)return h.keys;return[]}override(t){let h=this.overrideConfigurations.get(t);return h||(h=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,h)),h}merge(...t){const h=_.deepClone(this.contents),s=_.deepClone(this.overrides),n=[...this.keys];for(const u of t){this.mergeContents(h,u.contents);for(const o of u.overrides){const[l]=s.filter(m=>p.equals(m.identifiers,o.identifiers));l?this.mergeContents(l.contents,o.contents):s.push(_.deepClone(o))}for(const o of u.keys)n.indexOf(o)===-1&&n.push(o)}return new g(h,n,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(t){const h=this.getContentsForOverrideIdentifer(t);if(!h||typeof h!="object"||!Object.keys(h).length)return this;let s={};for(const n of p.distinct([...Object.keys(this.contents),...Object.keys(h)])){let u=this.contents[n],o=h[n];o&&(typeof u=="object"&&typeof o=="object"?(u=_.deepClone(u),this.mergeContents(u,o)):u=o),s[n]=u}return new g(s,this.keys,this.overrides)}mergeContents(t,h){for(const s of Object.keys(h)){if(s in t&&S.isObject(t[s])&&S.isObject(h[s])){this.mergeContents(t[s],h[s]);continue}t[s]=_.deepClone(h[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?_.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const h of this.overrides)if(h.identifiers.indexOf(t)!==-1)return h.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,h){this.addKey(t),(0,i.addToValueTree)(this.contents,t,h,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let h=this.keys.length;for(let s=0;s<h;s++)t.indexOf(this.keys[s])===0&&(h=s);this.keys.splice(h,1,t)}removeKey(t){let h=this.keys.indexOf(t);return h!==-1?(this.keys.splice(h,1),!0):!1}}e.ConfigurationModel=g;class d extends g{constructor(){const t=(0,i.getDefaultValues)(),h=(0,i.getConfigurationKeys)(),s=[];for(const n of Object.keys(t))k.OVERRIDE_PROPERTY_PATTERN.test(n)&&s.push({identifiers:[(0,k.overrideIdentifierFromKey)(n).trim()],keys:Object.keys(t[n]),contents:(0,i.toValuesTree)(t[n],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,h,s)}}e.DefaultConfigurationModel=d;class w{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,h){if(!S.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,h)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,h){this._raw=t;const{contents:s,keys:n,overrides:u,restricted:o}=this.doParseRaw(t,h);this._configurationModel=new g(s,n,u),this._restrictedConfigurations=o||[]}doParseContent(t){let h={},s=null,n=[],u=[],o=[];function l(b){Array.isArray(n)?n.push(b):s!==null&&(n[s]=b)}let m={onObjectBegin:()=>{let b={};l(b),u.push(n),n=b,s=null},onObjectProperty:b=>{s=b},onObjectEnd:()=>{n=u.pop()},onArrayBegin:()=>{let b=[];l(b),u.push(n),n=b,s=null},onArrayEnd:()=>{n=u.pop()},onLiteralValue:l,onError:(b,f,P)=>{o.push({error:b,offset:f,length:P})}};if(t)try{C.visit(t,m),h=n[0]||{}}catch(b){console.error(`Error while parsing settings file ${this._name}: ${b}`),this._parseErrors=[b]}return h}doParseRaw(t,h){const s=a.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),n=this.filter(t,s,!0,h);t=n.raw;const u=(0,i.toValuesTree)(t,m=>console.error(`Conflict in settings file ${this._name}: ${m}`)),o=Object.keys(t),l=(0,i.toOverrides)(t,m=>console.error(`Conflict in settings file ${this._name}: ${m}`));return{contents:u,keys:o,overrides:l,restricted:n.restricted}}filter(t,h,s,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:t,restricted:[]};const u={},o=[];for(let l in t)if(k.OVERRIDE_PROPERTY_PATTERN.test(l)&&s){const m=this.filter(t[l],h,!1,n);u[l]=m.raw,o.push(...m.restricted)}else{const m=h[l],b=m?typeof m.scope!="undefined"?m.scope:3:void 0;m?.restricted&&o.push(l),(b===void 0||n.scopes===void 0||n.scopes.includes(b))&&(n.skipRestricted&&m?.restricted||(u[l]=t[l]))}return{raw:u,restricted:o}}}e.ConfigurationModelParser=w;class D extends y.Disposable{constructor(t,h,s,n){super();this.userSettingsResource=t,this.scopes=h,this.fileService=n,this._onDidChange=this._register(new F.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(F.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=D;class T{constructor(t,h,s=new g,n=new g,u=new A.ResourceMap,o=new g,l=new A.ResourceMap,m=!0){this._defaultConfiguration=t,this._localUserConfiguration=h,this._remoteUserConfiguration=s,this._workspaceConfiguration=n,this._folderConfigurations=u,this._memoryConfiguration=o,this._memoryConfigurationByResource=l,this._freeze=m,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(t,h,s){return this.getConsolidateConfigurationModel(h,s).getValue(t)}updateValue(t,h,s={}){let n;s.resource?(n=this._memoryConfigurationByResource.get(s.resource),n||(n=new g,this._memoryConfigurationByResource.set(s.resource,n))):n=this._memoryConfiguration,h===void 0?n.removeValue(t):n.setValue(t,h),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,h,s){const n=this.getConsolidateConfigurationModel(h,s),u=this.getFolderConfigurationModelForResource(h.resource,s),o=h.resource?this._memoryConfigurationByResource.get(h.resource)||this._memoryConfiguration:this._memoryConfiguration,l=h.overrideIdentifier?this._defaultConfiguration.freeze().override(h.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),m=h.overrideIdentifier?this.userConfiguration.freeze().override(h.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),b=h.overrideIdentifier?this.localUserConfiguration.freeze().override(h.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),f=h.overrideIdentifier?this.remoteUserConfiguration.freeze().override(h.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),P=s?h.overrideIdentifier?this._workspaceConfiguration.freeze().override(h.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,L=u?h.overrideIdentifier?u.freeze().override(h.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,M=h.overrideIdentifier?o.override(h.overrideIdentifier).getValue(t):o.getValue(t),R=n.getValue(t),W=p.distinct(p.flatten(n.overrides.map(V=>V.identifiers))).filter(V=>n.getOverrideValue(t,V)!==void 0);return{defaultValue:l,userValue:m,userLocalValue:b,userRemoteValue:f,workspaceValue:P,workspaceFolderValue:L,memoryValue:M,value:R,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:h.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,h.overrideIdentifier):void 0}:void 0,user:m!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:h.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,h.overrideIdentifier):void 0}:void 0,userLocal:b!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:h.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,h.overrideIdentifier):void 0}:void 0,userRemote:f!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:h.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,h.overrideIdentifier):void 0}:void 0,workspace:P!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:h.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,h.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:u?.freeze().getValue(t),override:h.overrideIdentifier?u?.freeze().getOverrideValue(t,h.overrideIdentifier):void 0}:void 0,memory:M!==void 0?{value:o.getValue(t),override:h.overrideIdentifier?o.getOverrideValue(t,h.overrideIdentifier):void 0}:void 0,overrideIdentifiers:W.length?W:void 0}}keys(t){const h=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:h?h.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,h){this._folderConfigurations.set(t,h),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,h){const s=h.filter(n=>k.OVERRIDE_PROPERTY_PATTERN.test(n)).map(n=>{const u=(0,k.overrideIdentifierFromKey)(n),o=this._defaultConfiguration.getKeysForOverrideIdentifier(u),l=t.getKeysForOverrideIdentifier(u),m=[...l.filter(b=>o.indexOf(b)===-1),...o.filter(b=>l.indexOf(b)===-1),...o.filter(b=>!_.equals(this._defaultConfiguration.override(u).getValue(b),t.override(u).getValue(b)))];return[u,m]});return this.updateDefaultConfiguration(t),{keys:h,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:h,updated:s,removed:n,overrides:u}=(0,i.compare)(this.localUserConfiguration,t),o=[...h,...s,...n];return o.length&&this.updateLocalUserConfiguration(t),{keys:o,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:h,updated:s,removed:n,overrides:u}=(0,i.compare)(this.remoteUserConfiguration,t);let o=[...h,...s,...n];return o.length&&this.updateRemoteUserConfiguration(t),{keys:o,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:h,updated:s,removed:n,overrides:u}=(0,i.compare)(this.workspaceConfiguration,t);let o=[...h,...s,...n];return o.length&&this.updateWorkspaceConfiguration(t),{keys:o,overrides:u}}compareAndUpdateFolderConfiguration(t,h){const s=this.folderConfigurations.get(t),{added:n,updated:u,removed:o,overrides:l}=(0,i.compare)(s,h);let m=[...n,...u,...o];return(m.length||!s)&&this.updateFolderConfiguration(t,h),{keys:m,overrides:l}}compareAndDeleteFolderConfiguration(t){const h=this.folderConfigurations.get(t);if(!h)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:n,removed:u,overrides:o}=(0,i.compare)(h,void 0);return{keys:[...s,...n,...u],overrides:o}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,h){let s=this.getConsolidatedConfigurationModelForResource(t,h);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},h){let s=this.getWorkspaceConsolidatedConfiguration();if(h&&t){const n=h.getFolder(t);n&&(s=this.getFolderConsolidatedConfiguration(n.uri)||s);const u=this._memoryConfigurationByResource.get(t);u&&(s=s.merge(u))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let h=this._foldersConsolidatedConfigurations.get(t);if(!h){const s=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(t);n?(h=s.merge(n),this._freeze&&(h=h.freeze()),this._foldersConsolidatedConfigurations.set(t,h)):h=s}return h}getFolderConfigurationModelForResource(t,h){if(h&&t){const s=h.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,h)=>{const{contents:s,overrides:n,keys:u}=this._folderConfigurations.get(h);return t.push([h,{contents:s,overrides:n,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(h=>t.add(h)),this.userConfiguration.freeze().keys.forEach(h=>t.add(h)),this._workspaceConfiguration.freeze().keys.forEach(h=>t.add(h)),this._folderConfigurations.forEach(h=>h.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const h=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>h.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>h.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>h.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(n=>h.add(n))),[...h.values()]}static parse(t){const h=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),n=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((o,l)=>(o.set(I.URI.revive(l[0]),this.parseConfigurationModel(l[1])),o),new A.ResourceMap);return new T(h,s,new g,n,u,new g,new A.ResourceMap,!1)}static parseConfigurationModel(t){return new g(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=T;function E(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const t=new Set,h=new Map;for(const n of v)n.keys.forEach(u=>t.add(u)),n.overrides.forEach(([u,o])=>{const l=(0,A.getOrSet)(h,u,new Set);o.forEach(m=>l.add(m))});const s=[];return h.forEach((n,u)=>s.push([u,[...n.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=E;class c{constructor(t,h,s,n){this.change=t,this.previous=h,this.currentConfiguraiton=s,this.currentWorkspace=n,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(l=>u.add(l)),t.overrides.forEach(([,l])=>l.forEach(m=>u.add(m))),this.affectedKeys=[...u.values()];const o=new g;this.affectedKeys.forEach(l=>o.setValue(l,{})),this.affectedKeysTree=o.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=T.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,h){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(h){const s=this.previousConfiguration?this.previousConfiguration.getValue(t,h,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(t,h,this.currentWorkspace);return!_.equals(s,n)}return!0}return!1}doesAffectedKeysTreeContains(t,h){let s=(0,i.toValuesTree)({[h]:!0},()=>{}),n;for(;typeof s=="object"&&(n=Object.keys(s)[0]);){if(t=t[n],!t)return!1;s=s[n]}return!0}}e.ConfigurationChangeEvent=c;class r extends c{constructor(t,h,s,n){super({keys:t.allKeys(),overrides:[]},void 0,t,h);this.source=s,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=r}),define(fe[122],me([0,1,4]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,p.createDecorator)("remoteAuthorityResolverService");var F;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(F=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class C extends Error{constructor(A,_=F.Unknown,S){super(A);this._message=A,this._code=_,this._detail=S,this.isHandled=_===F.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype)}static isTemporarilyNotAvailable(A){return A instanceof C&&A._code===F.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof C&&A._code===F.NoResolverFound}static isHandled(A){return A instanceof C&&A.isHandled}}e.RemoteAuthorityResolverError=C}),define(fe[64],me([0,1,10]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function F(I){return I.scheme===p.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=F;function C(I){if(!I)return;const i=I.indexOf("+");return i<0?I:I.substr(0,i)}e.getRemoteName=C;function y(I){return I.scheme!==p.Schemas.file&&I.scheme!==p.Schemas.vscodeRemote}e.isVirtualResource=y;function A(I){if(I.folders.length)return I.folders.every(i=>y(i.uri))?I.folders[0].uri:void 0;if(I.configuration&&y(I.configuration))return I.configuration}e.getVirtualWorkspaceLocation=A;function _(I){return A(I)?.scheme}e.getVirtualWorkspaceScheme=_;function S(I){return A(I)!==void 0}e.isVirtualWorkspace=S}),define(fe[26],me([0,1,9,4,64]),function(Y,e,p,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function y(a){if(typeof a=="object"&&a!==null&&a.supported!==!0)return a.description}e.getWorkspaceSupportTypeMessage=y;function A(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var _;(function(a){a[a.System=0]="System",a[a.User=1]="User"})(_=e.ExtensionType||(e.ExtensionType={}));class S{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,d){if(typeof g=="undefined"||g===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof g=="string"||typeof d=="string"){let w=typeof g=="string"?g:g.value,D=typeof d=="string"?d:d.value;return p.equalsIgnoreCase(w,D)}return g._lower===d._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.ExtensionIdentifier=S;function I(a){return a.contributes&&a.contributes.localizations?a.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function i(a){return a.contributes&&a.contributes.authentication?a.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=i;function k(a,g){if(g&&a.enableProposedApi){const d=`onResolveRemoteAuthority:${(0,C.getRemoteName)(g)}`;return a.activationEvents?.indexOf(d)!==-1}return!1}e.isResolverExtension=k,e.IBuiltinExtensionsScannerService=(0,F.createDecorator)("IBuiltinExtensionsScannerService")}),define(fe[195],me([0,1,9,26]),function(Y,e,p,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function C(d,w){return d.uuid&&w.uuid?d.uuid===w.uuid:d.id===w.id?!0:(0,p.compareIgnoreCase)(d.id,w.id)===0}e.areSameExtensions=C;class y{constructor(w,D){this.version=D,this.id=w.id,this.uuid=w.uuid}key(){return`${this.id}-${this.version}`}equals(w){return w instanceof y?C(this,w)&&this.version===w.version:!1}}e.ExtensionIdentifierWithVersion=y;function A(d,w){return`${d}.${w}`}e.getExtensionId=A;function _(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=_;function S(d,w){return _(A(d,w))}e.getGalleryExtensionId=S;function I(d,w){const D=[],T=E=>{for(const c of D)if(c.some(r=>C(w(r),w(E))))return c;return null};for(const E of d){const c=T(E);c?c.push(E):D.push([E])}return D}e.groupByExtension=I;function i(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function k(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=k,e.BetterMergeId=new F.ExtensionIdentifier("pprice.better-merge");function a(d){const w=new Set;for(const D of d)D.malicious&&w.add(D.id.id);return w}e.getMaliciousExtensionsSet=a;function g(d,w){const D=[],T=w.manifest.extensionDependencies?.slice(0)??[];for(;T.length;){const E=T.shift();if(E&&D.every(c=>!C(c.identifier,{id:E}))){const c=d.filter(r=>C(r.identifier,{id:E}));c.length===1&&(D.push(c[0]),T.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return D}e.getExtensionDependencies=g}),define(fe[123],me([0,1,3,11,4,13]),function(Y,e,p,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,C.createDecorator)("tunnelService");var A;(function(d){d.Http="http",d.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var _;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(_=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function i(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=i,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=k;function a(d,w){return w?w!==1&&d<1024:!F.isWindows&&d<1024}e.isPortPrivileged=a;let g=class{constructor(w){this.logService=w,this._onTunnelOpened=new p.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new p.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new p.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w,D){return this._tunnelProvider=w,w?(this._canElevate=D.elevation,this._privacyOptions=D.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],D=Array.from(this._tunnels.values());for(let T of D){const E=Array.from(T.values());for(let c of E){const r=await c.value;r&&w.push(r)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:D}of w.values())await D.then(T=>T?.dispose());w.clear()}this._tunnels.clear()}openTunnel(w,D,T,E,c=!1,r=_.Private,v){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${D}:${T} on local port ${E}.`),!w)return;D||(D="localhost");const t=this.retainOrCreateTunnel(w,D,T,E,c,r,v);return t?t.then(h=>{if(!h){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(D,T);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(h);return(h.tunnelRemoteHost!==D||h.tunnelRemotePort!==T)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const D=this._tunnels.get(w.tunnelRemoteHost);if(D){const T=D.get(w.tunnelRemotePort);T&&(T.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,T))}}}}async tryDisposeTunnel(w,D,T){if(T.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${D}.`);const E=T.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(D),E}}async closeTunnel(w,D){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${D} `);const T=this._tunnels.get(w);if(T&&T.has(D)){const E=T.get(D);E.refcount=0,await this.tryDisposeTunnel(w,D,E)}}addTunnelToMap(w,D,T){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(D,{refcount:1,value:T})}async removeEmptyTunnelFromMap(w,D){const T=this._tunnels.get(w);T&&(await T.get(D)||T.delete(D),T.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,D){let T=[w];i(w)?(T.push(...e.LOCALHOST_ADDRESSES),T.push(...e.ALL_INTERFACES_ADDRESSES)):k(w)&&T.push(...e.ALL_INTERFACES_ADDRESSES);const E=T.map(c=>this._tunnels.get(c));for(const c of E){const r=c?.get(D);if(r)return r}}canTunnel(w){return!!I(w)}createWithProvider(w,D,T,E,c,r,v){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${D}:${T} on local port ${E}.`);const h={elevationRequired:c?a(E===void 0?T:E):!1},s={remoteAddress:{host:D,port:T},localAddressPort:E,privacy:r,public:r!==_.Private,protocol:v},n=w.forwardPort(s,h);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),n&&this.addTunnelToMap(D,T,n),n}};g=Ve([$e(0,y.ILogService)],g),e.AbstractTunnelService=g}),define(fe[196],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class p{vsda(){return new Promise((C,y)=>Y(["vsda"],C,y))}async sign(C){try{const y=await this.vsda(),A=new y.signer;if(A)return A.sign(C)}catch(y){}return C}}e.SignService=p}),define(fe[197],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class p{constructor(C){this._callback=C,this._terminalBufferMap=new Map}dispose(){for(const C of this._terminalBufferMap.values())C.dispose()}startBuffering(C,y,A=5){let _;return _=y(S=>{const I=typeof S=="string"?S:S.data;let i=this._terminalBufferMap.get(C);if(i){i.data.push(I);return}const k=setTimeout(()=>this.flushBuffer(C),A);i={data:[I],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(C),_.dispose()}},this._terminalBufferMap.set(C,i)}),_}stopBuffering(C){const y=this._terminalBufferMap.get(C);y&&y.dispose()}flushBuffer(C){const y=this._terminalBufferMap.get(C);y&&(this._terminalBufferMap.delete(C),this._callback(C,y.data.join("")))}}e.TerminalDataBufferer=p}),define(fe[198],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var p;(function(F){F.DARK="dark",F.LIGHT="light",F.HIGH_CONTRAST="hc"})(p=e.ColorScheme||(e.ColorScheme={}))}),define(fe[65],me([0,1,47,3,6,4,34,198]),function(Y,e,p,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,y.createDecorator)("themeService");var S;(function(D){function T(E){return E&&typeof E=="object"&&typeof E.id=="string"}D.isThemeColor=T})(S=e.ThemeColor||(e.ThemeColor={}));function I(D){return{id:D}}e.themeColorFromId=I;var i;(function(D){function T(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color=="undefined"||S.isThemeColor(h.color))}D.isThemeIcon=T;const E=new RegExp(`^\\$\\((${p.CSSIcon.iconNameExpression}(?:${p.CSSIcon.iconModifierExpression})?)\\)$`);function c(h){const s=E.exec(h);if(!s)return;let[,n]=s;return{id:n}}D.fromString=c;function r(h,s){let n=h.id;const u=n.lastIndexOf("~");return u!==-1&&(n=n.substring(0,u)),s&&(n=`${n}~${s}`),{id:n}}D.modify=r;function v(h,s){return h.id===s.id&&h.color?.id===s.color?.id}D.isEqual=v;function t(h,s){return{id:h.id,color:s?I(s):void 0}}D.asThemeIcon=t,D.asClassNameArray=p.CSSIcon.asClassNameArray,D.asClassName=p.CSSIcon.asClassName,D.asCSSSelector=p.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=p.Codicon.file,e.FolderThemeIcon=p.Codicon.folder;function k(D){switch(D){case _.ColorScheme.DARK:return"vs-dark";case _.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class a{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new F.Emitter}onColorThemeChange(T){return this.themingParticipants.push(T),this.onThemingParticipantAddedEmitter.fire(T),(0,C.toDisposable)(()=>{const E=this.themingParticipants.indexOf(T);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let g=new a;A.Registry.add(e.Extensions.ThemingContribution,g);function d(D){return g.onColorThemeChange(D)}e.registerThemingParticipant=d;class w extends C.Disposable{constructor(T){super();this.themeService=T,this.theme=T.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(T){this.theme=T,this.updateStyles()}updateStyles(){}getColor(T,E){let c=this.theme.getColor(T);return c&&E&&(c=E(c,this.theme)),c?c.toString():null}}e.Themable=w}),define(fe[199],me([0,1,15,47,3,163,120,34,65]),function(Y,e,p,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class I{constructor(){this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${F.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(T,E,c,r){const v=this.iconsById[T];if(v){if(c&&!v.description){v.description=c,this.iconSchema.properties[T].markdownDescription=`${c} $(${T})`;const s=this.iconReferenceSchema.enum.indexOf(T);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=c),this._onDidChange.fire()}return v}let t={id:T,description:c,defaults:E,deprecationMessage:r};this.iconsById[T]=t;let h={$ref:"#/definitions/icons"};return r&&(h.deprecationMessage=r),c&&(h.markdownDescription=`${c}: $(${T})`),this.iconSchema.properties[T]=h,this.iconReferenceSchema.enum.push(T),this.iconReferenceSchema.enumDescriptions.push(c||""),this._onDidChange.fire(),{id:T}}deregisterIcon(T){delete this.iconsById[T],delete this.iconSchema.properties[T];const E=this.iconReferenceSchema.enum.indexOf(T);E!==-1&&(this.iconReferenceSchema.enum.splice(E,1),this.iconReferenceSchema.enumDescriptions.splice(E,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(T=>this.iconsById[T])}getIcon(T){return this.iconsById[T]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(T,E){const c=this.iconFontsById[T];if(c)return c;let r={id:T,definition:E};return this.iconFontsById[T]=r,this._onDidChange.fire(),r}deregisterIconFont(T){delete this.iconFontsById[T]}getIconFonts(){return Object.keys(this.iconFontsById).map(T=>this.iconFontsById[T])}getIconFont(T){return this.iconFontsById[T]}toString(){const T=(v,t)=>v.id.localeCompare(t.id),E=v=>{for(;S.ThemeIcon.isThemeIcon(v.defaults);)v=this.iconsById[v.defaults.id];return`codicon codicon-${v?v.id:""}`};let c=[];c.push("| preview     | identifier                        | default codicon ID                | description"),c.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.iconsById).map(v=>this.iconsById[v]);for(const v of r.filter(t=>!!t.description).sort(T))c.push(`|<i class="${E(v)}"></i>|${v.id}|${S.ThemeIcon.isThemeIcon(v.defaults)?v.defaults.id:v.id}|${v.description||""}|`);c.push("| preview     | identifier                        "),c.push("| ----------- | --------------------------------- |");for(const v of r.filter(t=>!S.ThemeIcon.isThemeIcon(t.defaults)).sort(T))c.push(`|<i class="${E(v)}"></i>|${v.id}|`);return c.join(`
`)}}const i=new I;_.Registry.add(e.Extensions.IconContribution,i);function k(D,T,E,c){return i.registerIcon(D,T,E,c)}e.registerIcon=k;function a(){return i}e.getIconRegistry=a;function g(){for(const D of F.iconRegistry.all)i.registerIcon(D.id,D.definition,D.description);F.iconRegistry.onDidRegister(D=>i.registerIcon(D.id,D.definition,D.description))}g(),e.iconsSchemaId="vscode://schemas/icons";let d=_.Registry.as(A.Extensions.JSONContribution);d.registerSchema(e.iconsSchemaId,i.getIconSchema());const w=new p.RunOnceScheduler(()=>d.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{w.isScheduled()||w.schedule()}),e.widgetClose=k("widget-close",F.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=k("goto-previous-location",F.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=k("goto-next-location",F.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=S.ThemeIcon.modify(F.Codicon.sync,"spin")}),define(fe[44],me([0,1,24,23,2,4]),function(Y,e,p,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,y.createDecorator)("contextService");var A;(function(a){a[a.EMPTY=1]="EMPTY",a[a.FOLDER=2]="FOLDER",a[a.WORKSPACE=3]="WORKSPACE"})(A=e.WorkbenchState||(e.WorkbenchState={}));function _(a){const g=a;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}e.isWorkspace=_;function S(a){const g=a;return!!(g&&typeof g=="object"&&C.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}e.isWorkspaceFolder=S;class I{constructor(g,d,w,D,T){this._id=g,this._transient=w,this._configuration=D,this._ignorePathCasing=T,this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(g){this._id=g.id,this._configuration=g.configuration,this._transient=g.transient,this._ignorePathCasing=g._ignorePathCasing,this.folders=g.folders}get folders(){return this._folders}set folders(g){this._folders=g,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(g){this._configuration=g}getFolder(g){return g&&this._foldersMap.findSubstr(g.with({scheme:g.scheme,authority:g.authority,path:g.path}))||null}updateFoldersMap(){this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing);for(const g of this.folders)this._foldersMap.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=I;class i{constructor(g,d){this.raw=d,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,F.joinPath)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function k(a){return new i({uri:a,index:0,name:(0,F.basenameOrAuthority)(a)},{uri:a.toString()})}e.toWorkspaceFolder=k}),define(fe[200],me([0,1,29,61,140,80,10,8,11,23,2,164,4,64,44]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const w=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function D(N){return(typeof N=="string"?(0,_.extname)(N):(0,I.extname)(N))===w}e.hasWorkspaceFileExtension=D,e.IWorkspacesService=(0,a.createDecorator)("workspacesService");function T(N){return N.hasOwnProperty("workspace")}e.isRecentWorkspace=T;function E(N){return N.hasOwnProperty("folderUri")}e.isRecentFolder=E;function c(N){return N.hasOwnProperty("fileUri")}e.isRecentFile=c;function r(N){const j=N;return typeof j?.id=="string"&&i.URI.isUri(j.uri)}e.isSingleFolderWorkspaceIdentifier=r;function v(N){if(N.configuration)return{id:N.id,configPath:N.configuration};if(N.folders.length===1)return{id:N.id,uri:N.folders[0].uri}}e.toWorkspaceIdentifier=v;function t(N){const j=N;return typeof j?.id=="string"&&i.URI.isUri(j.configPath)}e.isWorkspaceIdentifier=t;function h(N){const j=N;if(j?.uri)return{id:j.id,uri:i.URI.revive(j.uri)};const U=N;if(U?.configPath)return{id:U.id,configPath:i.URI.revive(U.configPath)};if(N?.id)return{id:N.id}}e.reviveIdentifier=h;function s(N,j){return I.extUriBiasedIgnorePathCase.isEqualOrParent(N,j.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function n(N){return u(N)||o(N)}e.isStoredWorkspaceFolder=n;function u(N){const j=N;return typeof j?.path=="string"&&(!j.name||typeof j.name=="string")}e.isRawFileWorkspaceFolder=u;function o(N){const j=N;return typeof j?.uri=="string"&&(!j.name||typeof j.name=="string")}e.isRawUriWorkspaceFolder=o;function l(N,j,U,B,z=!S.isWindows,O){if(N.scheme!==B.scheme)return{name:U,uri:N.toString(!0)};let $=j?void 0:O.relativePath(B,N);if($!==void 0)$.length===0?$=".":S.isWindows&&N.scheme===A.Schemas.file&&!z&&($=$.replace(/\//g,"\\"));else if(N.scheme===A.Schemas.file)$=N.fsPath,S.isWindows&&($=(0,y.normalizeDriveLetter)($),z&&($=(0,p.toSlashes)($)));else{if(!O.isEqualAuthority(N.authority,B.authority))return{name:U,uri:N.toString(!0)};$=N.path}return{name:U,path:$}}e.getStoredWorkspaceFolder=l;function m(N,j,U){let B=[],z=new Set;const O=U.dirname(j);for(let $ of N){let x;if(u($))$.path&&(x=U.resolvePath(O,$.path));else if(o($))try{x=i.URI.parse($.uri),x.path[0]!=="/"&&(x=x.with({path:"/"+x.path}))}catch(X){console.warn(X)}if(x){let X=U.getComparisonKey(x);if(!z.has(X)){z.add(X);const Q=$.name||U.basenameOrAuthority(x);B.push(new d.WorkspaceFolder({uri:x,name:Q,index:B.length},$))}}}return B}e.toWorkspaceFolders=m;function b(N,j,U,B,z){let O=f(j,N);const $=z.dirname(j),x=z.dirname(B),X=[],Q=P(O.folders);for(const ke of O.folders){const xe=u(ke)?z.resolvePath($,ke.path):i.URI.parse(ke.uri);let We;U?We=!1:We=!u(ke)||(0,_.isAbsolute)(ke.path),X.push(l(xe,We,ke.name,x,Q,z))}const de={insertSpaces:!1,tabSize:4,eol:S.isLinux||S.isMacintosh?`
`:`\r
`},_e=C.setProperty(N,["folders"],X,de);let ye=C.applyEdits(N,_e);return O.remoteAuthority===(0,g.getRemoteAuthority)(B)&&(ye=C.applyEdits(ye,C.removeProperty(ye,["remoteAuthority"],de))),ye}e.rewriteWorkspaceFileForNewLocation=b;function f(N,j){let U=F.parse(j);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(B=>n(B));else throw new Error(`${N} looks like an invalid workspace file.`);return U}function P(N){return S.isWindows?N.some(j=>u(j)&&j.path.indexOf("/")>=0):!0}e.useSlashForPath=P;function L(N){return N.workspace&&typeof N.workspace=="object"&&typeof N.workspace.id=="string"&&typeof N.workspace.configPath=="string"}function M(N){return typeof N.folderUri=="string"}function R(N){return typeof N.fileUri=="string"}function W(N,j){const U={workspaces:[],files:[]};if(N){const B=function(O,$){for(let x=0;x<O.length;x++)try{$(O[x],x)}catch(X){j.warn(`Error restoring recent entry ${JSON.stringify(O[x])}: ${X.toString()}. Skip entry.`)}},z=N;if(Array.isArray(z.entries))B(z.entries,O=>{const $=O.label,x=O.remoteAuthority;L(O)?U.workspaces.push({label:$,remoteAuthority:x,workspace:{id:O.workspace.id,configPath:i.URI.parse(O.workspace.configPath)}}):M(O)?U.workspaces.push({label:$,remoteAuthority:x,folderUri:i.URI.parse(O.folderUri)}):R(O)&&U.files.push({label:$,remoteAuthority:x,fileUri:i.URI.parse(O.fileUri)})});else{const O=N;Array.isArray(O.workspaces3)&&B(O.workspaces3,($,x)=>{const X=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[x]||void 0;typeof $=="object"&&typeof $.id=="string"&&typeof $.configURIPath=="string"?U.workspaces.push({label:X,workspace:{id:$.id,configPath:i.URI.parse($.configURIPath)}}):typeof $=="string"&&U.workspaces.push({label:X,folderUri:i.URI.parse($)})}),Array.isArray(O.files2)&&B(O.files2,($,x)=>{const X=Array.isArray(O.fileLabels)&&O.fileLabels[x]||void 0;typeof $=="string"&&U.files.push({label:X,fileUri:i.URI.parse($)})})}}return U}e.restoreRecentlyOpened=W;function V(N){const j={entries:[]};for(const U of N.workspaces)E(U)?j.entries.push({folderUri:U.folderUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority}):j.entries.push({workspace:{id:U.workspace.id,configPath:U.workspace.configPath.toString()},label:U.label,remoteAuthority:U.remoteAuthority});for(const U of N.files)j.entries.push({fileUri:U.fileUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority});return j}e.toStoreData=V}),define(fe[87],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class p{constructor(C){this.id=C,this._data=new Map,this._idPool=1}add(C){const y=this._idPool++;return this._data.set(y,C),this.logDebugInfo(),y}get(C,y){return this._data.has(C)?this._data.get(C)[y]:void 0}delete(C){this._data.delete(C),this.logDebugInfo()}logDebugInfo(){!p.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=p,p.enableDebugLogging=!1}),define(fe[53],me([0,1,10,23,4]),function(Y,e,p,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class y{constructor(){this._systemSchemes=new Set(Object.keys(p.Schemas)),this._providerInfo=new Map,this.extUri=new F.ExtUri(_=>{const S=this._providerInfo.get(_.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(_,S){S===null?this._providerInfo.delete(_):this._providerInfo.set(_,S)}isFreeScheme(_){return!this._providerInfo.has(_)&&!this._systemSchemes.has(_)}getCapabilities(_){return this._providerInfo.get(_)}}e.ExtHostFileSystemInfo=y,e.IExtHostFileSystemInfo=(0,C.createDecorator)("IExtHostFileSystemInfo")}),define(fe[27],me([0,1,4]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,p.createDecorator)("IExtHostInitDataService")}),define(fe[201],me([0,1,15]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class F{constructor(A,_,S){this._deferredPromises=new Map,this._id=A,this._shared=_,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(I=>(this._value=I,this)),this._storageListener=this._storage.onDidChangeStorage(I=>{I.shared===this._shared&&I.key===this._id&&(this._value=I.value)}),this._scheduler=new p.RunOnceScheduler(()=>{const I=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of I.values())i.complete()}catch(i){for(const k of I.values())k.error(i)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this._init}get(A,_){let S=this._value[A];return typeof S=="undefined"&&(S=_),S}update(A,_){this._value[A]=_;let S=this._deferredPromises.get(A);if(S!==void 0)return S.p;const I=new p.DeferredPromise;return this._deferredPromises.set(A,I),this._scheduler.isScheduled()||this._scheduler.schedule(),I.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=F;class C extends F{constructor(A,_){super(A.identifier.value,!0,_);this._extension=A}setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}}e.ExtensionGlobalMemento=C}),define(fe[202],me([0,1,3,2,13]),function(Y,e,p,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let y=class{constructor(_,S){this._logService=_,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new p.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new p.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(_,S,I){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(_)).acceptModelChanged(S.value,I)}$acceptDirtyStateChanged(_,S){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(_)).acceptDirty(S)}$acceptModelSaved(_){const S=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(_));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(_,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",_.path,S);const I=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(_));I.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:I.apiNotebook})}};y=Ve([$e(0,C.ILogService)],y),e.ExtHostNotebookDocuments=y}),define(fe[14],me([0,1,4]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,p.createDecorator)("IExtHostRpcService");class F{constructor(y){this.getProxy=y.getProxy.bind(y),this.set=y.set.bind(y),this.assertRegistered=y.assertRegistered.bind(y),this.drain=y.drain.bind(y)}}e.ExtHostRpcService=F});var ot=this&&this.__classPrivateFieldSet||function(Y,e,p,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,p):C?C.value=p:e.set(Y,p),p},Oe=this&&this.__classPrivateFieldGet||function(Y,e,p,F){if(p==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?F:p==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[203],me([0,1,26,3]),function(Y,e,p,F){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class y{constructor(_,S){C.set(this,void 0),this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._id=p.ExtensionIdentifier.toKey(_.identifier),ot(this,C,S,"f"),Oe(this,C,"f").onDidChangePassword(I=>{I.extensionId===this._id&&this._onDidChange.fire({key:I.key})})}get(_){return Oe(this,C,"f").get(this._id,_)}store(_,S){return Oe(this,C,"f").store(this._id,_,S)}delete(_){return Oe(this,C,"f").delete(this._id,_)}}e.ExtensionSecrets=y,C=new WeakMap}),define(fe[124],me([0,1,4,3]),function(Y,e,p,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class C{constructor(){this._onDidChangeTelemetryEnabled=new F.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(A){this._enabled=A}$onDidChangeTelemetryEnabled(A){this._enabled=A,this._onDidChangeTelemetryEnabled.fire(A)}}e.ExtHostTelemetry=C,e.IExtHostTelemetry=(0,p.createDecorator)("IExtHostTelemetry")}),define(fe[66],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var p;(function(E){E[E.Upsert=0]="Upsert",E[E.RemoveChild=1]="RemoveChild",E[E.Invalidated=2]="Invalidated",E[E.SetProp=3]="SetProp",E[E.Bulk=4]="Bulk"})(p=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const F=new WeakMap,C=(E,c)=>{const r={controllerId:c};return F.set(E,r),r};e.createPrivateApiFor=C;const y=E=>F.get(E);e.getPrivateApiFor=y;const A=(E,c,r,v)=>{let t=r;return{enumerable:!0,configurable:!1,get(){return t},set(h){if(!v(t,h)){const s=t;t=h,E.listener?.({op:3,key:c,value:h,previous:s})}}}},_=(E,c)=>E===c,S={range:(E,c)=>E===c?!0:!E||!c?!1:E.isEqual(c),label:_,description:_,busy:_,error:_,canResolveChildren:_,tags:(E,c)=>!(E.length!==c.length||E.some(r=>!c.find(v=>r.id===v.id)))},I=Object.keys(S),i=(E,c)=>({range:A(E,"range",void 0,S.range),label:A(E,"label",c,S.label),description:A(E,"description",void 0,S.description),canResolveChildren:A(E,"canResolveChildren",!1,S.canResolveChildren),busy:A(E,"busy",!1,S.busy),error:A(E,"error",void 0,S.error),tags:A(E,"tags",[],S.tags)}),k=(E,c)=>{const r=new Map;for(const v of I)S[v](E[v],c[v])||r.set(v,c[v]);return r};e.diffTestItems=k;class a extends Error{constructor(c){super(`Attempted to insert a duplicate test item ID ${c}`)}}e.DuplicateTestItemError=a;class g extends Error{constructor(c){super(`TestItem with ID "${c}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=g;class d extends Error{constructor(c,r,v){super(`TestItem with ID "${c}" is from controller "${r}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=d;const w=E=>{const c=(0,e.getPrivateApiFor)(E);let r=new Map;return{get size(){return r.size},forEach(v,t){for(const h of r.values())v.call(t,h,this)},replace(v){const t=new Map,h=new Set(r.keys()),s={op:4,ops:[]};for(const n of v){if(!(n instanceof D))throw new g(n.id);const u=(0,e.getPrivateApiFor)(n).controllerId;if(u!==c.controllerId)throw new d(n.id,u,c.controllerId);if(t.has(n.id))throw new a(n.id);t.set(n.id,n),h.delete(n.id),s.ops.push({op:0,item:n})}for(const n of h.keys())s.ops.push({op:1,id:n});c.listener?.(s),r=t},add(v){if(!(v instanceof D))throw new g(v.id);r.set(v.id,v),c.listener?.({op:0,item:v})},delete(v){r.delete(v)&&c.listener?.({op:1,id:v})},get(v){return r.get(v)},toJSON(){return Array.from(r.values())},[Symbol.iterator](){return r.values()}}};class D{constructor(c,r,v,t){if(r.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(r)} symbol`);const h=(0,e.createPrivateApiFor)(this,c);Object.defineProperties(this,{id:{value:r,enumerable:!0,writable:!1},uri:{value:t,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return h.parent instanceof T?void 0:h.parent}},children:{value:w(this),enumerable:!0,writable:!1},...i(h,v)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=D;class T extends D{constructor(c,r){super(c,c,r,void 0)}}e.TestItemRootImpl=T}),define(fe[54],me([0,1,4,123,3,14]),function(Y,e,p,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(S){function I(k){return{remoteAddress:k.remoteAddress,localAddress:k.localAddress,public:!!k.public,privacy:k.privacy??(k.public?F.TunnelPrivacyId.Public:F.TunnelPrivacyId.Private),protocol:k.protocol}}S.fromApiTunnel=I;function i(k){return{remoteAddress:{host:k.tunnelRemoteHost,port:k.tunnelRemotePort},localAddress:k.localAddress,public:k.privacy!==F.TunnelPrivacyId.ConstantPrivate&&k.privacy!==F.TunnelPrivacyId.ConstantPrivate,privacy:k.privacy,protocol:k.protocol}}S.fromServiceTunnel=i})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,p.createDecorator)("IExtHostTunnelService");let _=class{constructor(I){this.onDidChangeTunnels=new C.Emitter().event}async $applyCandidateFilter(I){return I}async openTunnel(I,i){}async getTunnels(){return[]}async setTunnelExtensionFunctions(I){return{dispose:()=>{}}}registerPortsAttributesProvider(I,i){return{dispose:()=>{}}}async $providePortAttributes(I,i,k,a,g){return[]}async $forwardPort(I,i){}async $closeTunnel(I){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};_=Ve([$e(0,y.IExtHostRpcService)],_),e.ExtHostTunnelService=_});var ot=this&&this.__classPrivateFieldSet||function(Y,e,p,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,p):C?C.value=p:e.set(Y,p),p},Oe=this&&this.__classPrivateFieldGet||function(Y,e,p,F){if(p==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?F:p==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[7],me([0,1,18,17,100,24,103,12,2,32,43,122]),function(Y,e,p,F,C,y,A,_,S,I,i,k){"use strict";var a,g,d,w,D,T,E,c,r,v,t,h,s,n,u,o,l,m,b,f;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function P(G){function H(){return Reflect.construct(G,arguments,this.constructor)}return Object.defineProperty(H,"name",Object.getOwnPropertyDescriptor(G,"name")),Object.setPrototypeOf(H,G),Object.setPrototypeOf(H.prototype,G.prototype),H}let L=D=class{constructor(H){a.set(this,void 0),ot(this,a,H,"f")}static from(...H){let oe=H;return new D(function(){if(oe){for(const De of oe)De&&typeof De.dispose=="function"&&De.dispose();oe=void 0}})}dispose(){typeof Oe(this,a,"f")=="function"&&(Oe(this,a,"f").call(this),ot(this,a,void 0,"f"))}};a=new WeakMap,L=D=Ve([P],L),e.Disposable=L;let M=T=class{constructor(H,oe){if(H<0)throw(0,F.illegalArgument)("line must be non-negative");if(oe<0)throw(0,F.illegalArgument)("character must be non-negative");this._line=H,this._character=oe}static Min(...H){if(H.length===0)throw new TypeError;let oe=H[0];for(let De=1;De<H.length;De++){const Ze=H[De];Ze.isBefore(oe)&&(oe=Ze)}return oe}static Max(...H){if(H.length===0)throw new TypeError;let oe=H[0];for(let De=1;De<H.length;De++){const Ze=H[De];Ze.isAfter(oe)&&(oe=Ze)}return oe}static isPosition(H){if(!H)return!1;if(H instanceof T)return!0;let{line:oe,character:De}=H;return typeof oe=="number"&&typeof De=="number"}get line(){return this._line}get character(){return this._character}isBefore(H){return this._line<H._line?!0:H._line<this._line?!1:this._character<H._character}isBeforeOrEqual(H){return this._line<H._line?!0:H._line<this._line?!1:this._character<=H._character}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this._line===H._line&&this._character===H._character}compareTo(H){return this._line<H._line?-1:this._line>H.line?1:this._character<H._character?-1:this._character>H._character?1:0}translate(H,oe=0){if(H===null||oe===null)throw(0,F.illegalArgument)();let De;return typeof H=="undefined"?De=0:typeof H=="number"?De=H:(De=typeof H.lineDelta=="number"?H.lineDelta:0,oe=typeof H.characterDelta=="number"?H.characterDelta:0),De===0&&oe===0?this:new T(this.line+De,this.character+oe)}with(H,oe=this.character){if(H===null||oe===null)throw(0,F.illegalArgument)();let De;return typeof H=="undefined"?De=this.line:typeof H=="number"?De=H:(De=typeof H.line=="number"?H.line:this.line,oe=typeof H.character=="number"?H.character:this.character),De===this.line&&oe===this.character?this:new T(De,oe)}toJSON(){return{line:this.line,character:this.character}}};M=T=Ve([P],M),e.Position=M;let R=E=class{constructor(H,oe,De,Ze){let lt,dt;if(typeof H=="number"&&typeof oe=="number"&&typeof De=="number"&&typeof Ze=="number"?(lt=new M(H,oe),dt=new M(De,Ze)):H instanceof M&&oe instanceof M&&(lt=H,dt=oe),!lt||!dt)throw new Error("Invalid arguments");lt.isBefore(dt)?(this._start=lt,this._end=dt):(this._start=dt,this._end=lt)}static isRange(H){return H instanceof E?!0:H?M.isPosition(H.start)&&M.isPosition(H.end):!1}get start(){return this._start}get end(){return this._end}contains(H){return H instanceof E?this.contains(H._start)&&this.contains(H._end):H instanceof M?!(H.isBefore(this._start)||this._end.isBefore(H)):!1}isEqual(H){return this._start.isEqual(H._start)&&this._end.isEqual(H._end)}intersection(H){const oe=M.Max(H.start,this._start),De=M.Min(H.end,this._end);if(!oe.isAfter(De))return new E(oe,De)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const oe=M.Min(H.start,this._start),De=M.Max(H.end,this.end);return new E(oe,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(H,oe=this.end){if(H===null||oe===null)throw(0,F.illegalArgument)();let De;return H?M.isPosition(H)?De=H:(De=H.start||this.start,oe=H.end||this.end):De=this.start,De.isEqual(this._start)&&oe.isEqual(this.end)?this:new E(De,oe)}toJSON(){return[this.start,this.end]}};R=E=Ve([P],R),e.Range=R;let W=c=class extends R{constructor(H,oe,De,Ze){let lt,dt;if(typeof H=="number"&&typeof oe=="number"&&typeof De=="number"&&typeof Ze=="number"?(lt=new M(H,oe),dt=new M(De,Ze)):H instanceof M&&oe instanceof M&&(lt=H,dt=oe),!lt||!dt)throw new Error("Invalid arguments");super(lt,dt);this._anchor=lt,this._active=dt}static isSelection(H){return H instanceof c?!0:H?R.isRange(H)&&M.isPosition(H.anchor)&&M.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};W=c=Ve([P],W),e.Selection=W;class V{constructor(H,oe,De){if(typeof H!="string"||H.length===0)throw(0,F.illegalArgument)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,F.illegalArgument)("port");if(typeof De!="undefined"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z\-]+$/.test(De)))throw(0,F.illegalArgument)("connectionToken");this.host=H,this.port=Math.round(oe),this.connectionToken=De}}e.ResolvedAuthority=V;class N extends Error{constructor(H,oe=k.RemoteAuthorityResolverErrorCode.Unknown,De){super(H);this._message=H,this._code=oe,this._detail=De,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,N.prototype)}static NotAvailable(H,oe){return new N(H,k.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(H){return new N(H,k.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=N;var j;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(j=e.EndOfLine||(e.EndOfLine={}));var U;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(U=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let B=r=class{constructor(H,oe){this._range=H,this._newText=oe}static isTextEdit(H){return H instanceof r?!0:H?R.isRange(H)&&typeof H.newText=="string":!1}static replace(H,oe){return new r(H,oe)}static insert(H,oe){return r.replace(new R(H,H),oe)}static delete(H){return r.replace(H,"")}static setEndOfLine(H){const oe=new r(new R(new M(0,0),new M(0,0)),"");return oe.newEol=H,oe}get range(){return this._range}set range(H){if(H&&!R.isRange(H))throw(0,F.illegalArgument)("range");this._range=H}get newText(){return this._newText||""}set newText(H){if(H&&typeof H!="string")throw(0,F.illegalArgument)("newText");this._newText=H}get newEol(){return this._newEol}set newEol(H){if(H&&typeof H!="number")throw(0,F.illegalArgument)("newEol");this._newEol=H}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};B=r=Ve([P],B),e.TextEdit=B;var z;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace"})(z=e.FileEditType||(e.FileEditType={}));let O=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(H,oe,De,Ze){this._edits.push({_type:1,from:H,to:oe,options:De,metadata:Ze})}createFile(H,oe,De){this._edits.push({_type:1,from:void 0,to:H,options:oe,metadata:De})}deleteFile(H,oe,De){this._edits.push({_type:1,from:H,to:void 0,options:oe,metadata:De})}replaceNotebookMetadata(H,oe,De){this._edits.push({_type:3,metadata:De,uri:H,edit:{editType:5,metadata:oe},notebookMetadata:oe})}replaceNotebookCells(H,oe,De,Ze,lt){let dt,gt,It=[],At;if(zt.isNotebookRange(oe)&&Ft.isNotebookCellDataArray(De)&&!Ft.isNotebookCellDataArray(Ze)?(dt=oe.start,gt=oe.end,It=De,At=Ze):typeof oe=="number"&&typeof De=="number"&&Ft.isNotebookCellDataArray(Ze)&&(dt=oe,gt=De,It=Ze,At=lt),dt===void 0||gt===void 0)throw new Error("Invalid arguments");(dt!==gt||It.length>0)&&this._edits.push({_type:5,uri:H,index:dt,count:gt-dt,cells:It,metadata:At})}replaceNotebookCellMetadata(H,oe,De,Ze){this._edits.push({_type:3,metadata:Ze,uri:H,edit:{editType:8,index:oe,metadata:De}})}replace(H,oe,De,Ze){this._edits.push({_type:2,uri:H,edit:new B(oe,De),metadata:Ze})}insert(H,oe,De,Ze){this.replace(H,new R(oe,oe),De,Ze)}delete(H,oe,De){this.replace(H,oe,"",De)}has(H){return this._edits.some(oe=>oe._type===2&&oe.uri.toString()===H.toString())}set(H,oe){if(oe)for(const De of oe)De&&this._edits.push({_type:2,uri:H,edit:De});else{for(let De=0;De<this._edits.length;De++){const Ze=this._edits[De];Ze._type===2&&Ze.uri.toString()===H.toString()&&(this._edits[De]=void 0)}(0,p.coalesceInPlace)(this._edits)}}get(H){const oe=[];for(let De of this._edits)De._type===2&&De.uri.toString()===H.toString()&&oe.push(De.edit);return oe}entries(){const H=new y.ResourceMap;for(let oe of this._edits)if(oe._type===2){let De=H.get(oe.uri);De||(De=[oe.uri,[]],H.set(oe.uri,De)),De[1].push(oe.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};O=Ve([P],O),e.WorkspaceEdit=O;let $=v=class{constructor(H){this._tabstop=1,this.value=H||""}static isSnippetString(H){return H instanceof v?!0:H?typeof H.value=="string":!1}static _escape(H){return H.replace(/\$|}|\\/g,"\\$&")}appendText(H){return this.value+=v._escape(H),this}appendTabstop(H=this._tabstop++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,oe=this._tabstop++){if(typeof H=="function"){const De=new v;De._tabstop=this._tabstop,H(De),this._tabstop=De._tabstop,H=De.value}else H=v._escape(H);return this.value+="${",this.value+=oe,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,oe=this._tabstop++){const De=H.map(Ze=>Ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(H,oe){if(typeof oe=="function"){const De=new v;De._tabstop=this._tabstop,oe(De),this._tabstop=De._tabstop,oe=De.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};$=v=Ve([P],$),e.SnippetString=$;var x;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(x=e.DiagnosticTag||(e.DiagnosticTag={}));var X;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(X=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Q=t=class{constructor(H,oe){if(this.uri=H,oe)if(oe instanceof R)this.range=oe;else if(oe instanceof M)this.range=new R(oe,oe);else throw new Error("Illegal argument")}static isLocation(H){return H instanceof t?!0:H?R.isRange(H.range)&&S.URI.isUri(H.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Q=t=Ve([P],Q),e.Location=Q;let de=class{constructor(H,oe){this.location=H,this.message=oe}static is(H){return H?typeof H.message=="string"&&H.location&&R.isRange(H.location.range)&&S.URI.isUri(H.location.uri):!1}static isEqual(H,oe){return H===oe?!0:!H||!oe?!1:H.message===oe.message&&H.location.range.isEqual(oe.location.range)&&H.location.uri.toString()===oe.location.uri.toString()}};de=Ve([P],de),e.DiagnosticRelatedInformation=de;let _e=class{constructor(H,oe,De=X.Error){if(!R.isRange(H))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=H,this.message=oe,this.severity=De}toJSON(){return{severity:X[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,oe){return H===oe?!0:!H||!oe?!1:H.message===oe.message&&H.severity===oe.severity&&H.code===oe.code&&H.severity===oe.severity&&H.source===oe.source&&H.range.isEqual(oe.range)&&(0,p.equals)(H.tags,oe.tags)&&(0,p.equals)(H.relatedInformation,oe.relatedInformation,de.isEqual)}};_e=Ve([P],_e),e.Diagnostic=_e;let ye=class{constructor(H,oe){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=oe}};ye=Ve([P],ye),e.Hover=ye;var ke;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(ke=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let xe=class{constructor(H,oe=ke.Text){this.range=H,this.kind=oe}toJSON(){return{range:this.range,kind:ke[this.kind]}}};xe=Ve([P],xe),e.DocumentHighlight=xe;var We;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(We=e.SymbolKind||(e.SymbolKind={}));var He;(function(G){G[G.Deprecated=1]="Deprecated"})(He=e.SymbolTag||(e.SymbolTag={}));let q=h=class{constructor(H,oe,De,Ze,lt){this.name=H,this.kind=oe,this.containerName=lt,typeof De=="string"&&(this.containerName=De),Ze instanceof Q?this.location=Ze:De instanceof R&&(this.location=new Q(Ze,De)),h.validate(this)}static validate(H){if(!H.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:We[this.kind],location:this.location,containerName:this.containerName}}};q=h=Ve([P],q),e.SymbolInformation=q;let ee=s=class{constructor(H,oe,De,Ze,lt){this.name=H,this.detail=oe,this.kind=De,this.range=Ze,this.selectionRange=lt,this.children=[],s.validate(this)}static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children&&H.children.forEach(s.validate)}};ee=s=Ve([P],ee),e.DocumentSymbol=ee;var re;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(re=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let le=class{constructor(H,oe){this.title=H,this.kind=oe}};le=Ve([P],le),e.CodeAction=le;let Z=n=class{constructor(H){this.value=H}append(H){return new n(this.value?this.value+n.sep+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+n.sep)}};Z.sep=".",Z=n=Ve([P],Z),e.CodeActionKind=Z,Z.Empty=new Z(""),Z.QuickFix=Z.Empty.append("quickfix"),Z.Refactor=Z.Empty.append("refactor"),Z.RefactorExtract=Z.Refactor.append("extract"),Z.RefactorInline=Z.Refactor.append("inline"),Z.RefactorRewrite=Z.Refactor.append("rewrite"),Z.Source=Z.Empty.append("source"),Z.SourceOrganizeImports=Z.Source.append("organizeImports"),Z.SourceFixAll=Z.Source.append("fixAll");let ae=class{constructor(H,oe){if(this.range=H,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ae=Ve([P],ae),e.SelectionRange=ae;class pe{constructor(H,oe,De,Ze,lt,dt){this.kind=H,this.name=oe,this.detail=De,this.uri=Ze,this.range=lt,this.selectionRange=dt}}e.CallHierarchyItem=pe;class Me{constructor(H,oe){this.fromRanges=oe,this.from=H}}e.CallHierarchyIncomingCall=Me;class je{constructor(H,oe){this.fromRanges=oe,this.to=H}}e.CallHierarchyOutgoingCall=je;var Ke;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(Ke=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Je=class{constructor(H,oe){this.range=H,this.command=oe}get isResolved(){return!!this.command}};Je=Ve([P],Je),e.CodeLens=Je;let st=u=class{constructor(H,oe=!1){g.set(this,void 0),ot(this,g,new C.MarkdownString(H,{supportThemeIcons:oe}),"f")}static isMarkdownString(H){return H instanceof u?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}get value(){return Oe(this,g,"f").value}set value(H){Oe(this,g,"f").value=H}get isTrusted(){return Oe(this,g,"f").isTrusted}set isTrusted(H){Oe(this,g,"f").isTrusted=H}get supportThemeIcons(){return Oe(this,g,"f").supportThemeIcons}set supportThemeIcons(H){Oe(this,g,"f").supportThemeIcons=H}get supportHtml(){return Oe(this,g,"f").supportHtml}set supportHtml(H){Oe(this,g,"f").supportHtml=H}appendText(H){return Oe(this,g,"f").appendText(H),this}appendMarkdown(H){return Oe(this,g,"f").appendMarkdown(H),this}appendCodeblock(H,oe){return Oe(this,g,"f").appendCodeblock(oe??"",H),this}};g=new WeakMap,st=u=Ve([P],st),e.MarkdownString=st;let Te=class{constructor(H,oe){this.label=H,this.documentation=oe}};Te=Ve([P],Te),e.ParameterInformation=Te;let nt=class{constructor(H,oe){this.label=H,this.documentation=oe,this.parameters=[]}};nt=Ve([P],nt),e.SignatureInformation=nt;let J=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};J=Ve([P],J),e.SignatureHelp=J;var te;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(te=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ve;(function(G){G[G.Other=0]="Other",G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(ve=e.InlayHintKind||(e.InlayHintKind={}));let Qe=class{constructor(H,oe,De){this.text=H,this.position=oe,this.kind=De}};Qe=Ve([P],Qe),e.InlayHint=Qe;var tt;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(tt=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ct;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(ct=e.CompletionItemKind||(e.CompletionItemKind={}));var ce;(function(G){G[G.Deprecated=1]="Deprecated"})(ce=e.CompletionItemTag||(e.CompletionItemTag={}));let Ie=class{constructor(H,oe){this.label=H,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&ct[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ie=Ve([P],Ie),e.CompletionItem=Ie;let Ue=class{constructor(H=[],oe=!1){this.items=H,this.isIncomplete=oe}};Ue=Ve([P],Ue),e.CompletionList=Ue;let Xe=class{constructor(H,oe,De){this.text=H,this.range=oe,this.command=De}};Xe=Ve([P],Xe),e.InlineSuggestion=Xe;let rt=class{constructor(H){this.items=H}};rt=Ve([P],rt),e.InlineSuggestions=rt;var ht;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(ht=e.ViewColumn||(e.ViewColumn={}));var Ye;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(Ye=e.StatusBarAlignment||(e.StatusBarAlignment={}));var vt;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative"})(vt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Re;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(Re=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ce;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Ce=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Pe;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(Pe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var se;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(se=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ue;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(ue=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(G){function H(oe){switch(oe){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=H}(Pe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let be=class{constructor(H,oe){if(oe&&!S.URI.isUri(oe))throw(0,F.illegalArgument)("target");if(!R.isRange(H)||H.isEmpty)throw(0,F.illegalArgument)("range");this.range=H,this.target=oe}};be=Ve([P],be),e.DocumentLink=be;let we=class{constructor(H,oe,De,Ze){this.red=H,this.green=oe,this.blue=De,this.alpha=Ze}};we=Ve([P],we),e.Color=we;let Fe=class{constructor(H,oe){if(oe&&!(oe instanceof we))throw(0,F.illegalArgument)("color");if(!R.isRange(H)||H.isEmpty)throw(0,F.illegalArgument)("range");this.range=H,this.color=oe}};Fe=Ve([P],Fe),e.ColorInformation=Fe;let qe=class{constructor(H){if(!H||typeof H!="string")throw(0,F.illegalArgument)("label");this.label=H}};qe=Ve([P],qe),e.ColorPresentation=qe;var ze;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(ze=e.ColorFormat||(e.ColorFormat={}));var et;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(et=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class at{constructor(H,oe,De){if(this.startIndex=H,this.length=oe,this.tooltip=De,typeof H!="number"||H<0)throw(0,F.illegalArgument)("startIndex");if(typeof oe!="number"||oe<1)throw(0,F.illegalArgument)("length");if(De!==void 0&&typeof De!="string")throw(0,F.illegalArgument)("tooltip")}}e.TerminalLink=at;var Be;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(Be=e.TerminalLocation||(e.TerminalLocation={}));class ge{constructor(H){this.options=H,typeof H!="object"&&(0,F.illegalArgument)("options")}}e.TerminalProfile=ge;var Ee;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(Ee=e.TaskRevealKind||(e.TaskRevealKind={}));var ne;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(ne=e.TaskPanelKind||(e.TaskPanelKind={}));let K=o=class{constructor(H,oe){if(this.label=oe,typeof H!="string"||typeof oe!="string")throw(0,F.illegalArgument)("name");this._id=H}static from(H){switch(H){case"clean":return o.Clean;case"build":return o.Build;case"rebuild":return o.Rebuild;case"test":return o.Test;default:return}}get id(){return this._id}};K.Clean=new o("clean","Clean"),K.Build=new o("build","Build"),K.Rebuild=new o("rebuild","Rebuild"),K.Test=new o("test","Test"),K=o=Ve([P],K),e.TaskGroup=K;function Se(G){let H="";for(let oe=0;oe<G.length;oe++)H+=G[oe].replace(/,/g,",,")+",";return H}let Le=class{constructor(H,oe,De){if(typeof H!="string")throw(0,F.illegalArgument)("process");this._args=[],this._process=H,oe!==void 0&&(Array.isArray(oe)?(this._args=oe,this._options=De):this._options=oe)}get process(){return this._process}set process(H){if(typeof H!="string")throw(0,F.illegalArgument)("process");this._process=H}get args(){return this._args}set args(H){Array.isArray(H)||(H=[]),this._args=H}get options(){return this._options}set options(H){this._options=H}computeId(){const H=[];if(H.push("process"),this._process!==void 0&&H.push(this._process),this._args&&this._args.length>0)for(let oe of this._args)H.push(oe);return Se(H)}};Le=Ve([P],Le),e.ProcessExecution=Le;let it=class{constructor(H,oe,De){if(this._args=[],Array.isArray(oe)){if(!H)throw(0,F.illegalArgument)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,F.illegalArgument)("command");this._command=H,this._args=oe,this._options=De}else{if(typeof H!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=H,this._options=oe}}get commandLine(){return this._commandLine}set commandLine(H){if(typeof H!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=H}get command(){return this._command?this._command:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,F.illegalArgument)("command");this._command=H}get args(){return this._args}set args(H){this._args=H||[]}get options(){return this._options}set options(H){this._options=H}computeId(){const H=[];if(H.push("shell"),this._commandLine!==void 0&&H.push(this._commandLine),this._command!==void 0&&H.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let oe of this._args)H.push(typeof oe=="string"?oe:oe.value);return Se(H)}};it=Ve([P],it),e.ShellExecution=it;var Ge;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(Ge=e.ShellQuoting||(e.ShellQuoting={}));var pt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(pt=e.TaskScope||(e.TaskScope={}));class Et{constructor(H){this._callback=H}computeId(){return"customExecution"+(0,I.generateUuid)()}set callback(H){this._callback=H}get callback(){return this._callback}}e.CustomExecution=Et;let ft=l=class{constructor(H,oe,De,Ze,lt,dt){this.__deprecated=!1,this._definition=this.definition=H;let gt;typeof oe=="string"?(this._name=this.name=oe,this._source=this.source=De,this.execution=Ze,gt=lt,this.__deprecated=!0):oe===pt.Global||oe===pt.Workspace?(this.target=oe,this._name=this.name=De,this._source=this.source=Ze,this.execution=lt,gt=dt):(this.target=oe,this._name=this.name=De,this._source=this.source=Ze,this.execution=lt,gt=dt),typeof gt=="string"?(this._problemMatchers=[gt],this._hasDefinedMatchers=!0):Array.isArray(gt)?(this._problemMatchers=gt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(H){this.__id=H}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Le?this._definition={type:l.ProcessType,id:this._execution.computeId()}:this._execution instanceof it?this._definition={type:l.ShellType,id:this._execution.computeId()}:this._execution instanceof Et?this._definition={type:l.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:l.EmptyType,id:(0,I.generateUuid)()}}get definition(){return this._definition}set definition(H){if(H==null)throw(0,F.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=H}get scope(){return this._scope}set target(H){this.clear(),this._scope=H}get name(){return this._name}set name(H){if(typeof H!="string")throw(0,F.illegalArgument)("name");this.clear(),this._name=H}get execution(){return this._execution}set execution(H){H===null&&(H=void 0),this.clear(),this._execution=H;const oe=this._definition.type;(l.EmptyType===oe||l.ProcessType===oe||l.ShellType===oe||l.ExtensionCallbackType===oe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(H){if(Array.isArray(H))this.clear(),this._problemMatchers=H,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.clear(),this._isBackground=H}get source(){return this._source}set source(H){if(typeof H!="string"||H.length===0)throw(0,F.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=H}get group(){return this._group}set group(H){H===null&&(H=void 0),this.clear(),this._group=H}get detail(){return this._detail}set detail(H){H===null&&(H=void 0),this._detail=H}get presentationOptions(){return this._presentationOptions}set presentationOptions(H){H==null&&(H=Object.create(null)),this.clear(),this._presentationOptions=H}get runOptions(){return this._runOptions}set runOptions(H){H==null&&(H=Object.create(null)),this.clear(),this._runOptions=H}};ft.ExtensionCallbackType="customExecution",ft.ProcessType="process",ft.ShellType="shell",ft.EmptyType="$empty",ft=l=Ve([P],ft),e.Task=ft;var bt;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(bt=e.ProgressLocation||(e.ProgressLocation={}));let mt=class{constructor(H,oe=_t.None){this.collapsibleState=oe,S.URI.isUri(H)?this.resourceUri=H:this.label=H}};mt=Ve([P],mt),e.TreeItem=mt;var _t;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Dt=class{constructor(H,oe){this.id=H,this.color=oe}};Dt=Ve([P],Dt),e.ThemeIcon=Dt,Dt.File=new Dt("file"),Dt.Folder=new Dt("folder");let xt=class{constructor(H){this.id=H}};xt=Ve([P],xt),e.ThemeColor=xt;var Vt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(Vt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let kt=class{constructor(H,oe){if(typeof H!="string"&&(!H||!S.URI.isUri(H)&&!S.URI.isUri(H.uri)))throw(0,F.illegalArgument)("base");if(typeof oe!="string")throw(0,F.illegalArgument)("pattern");typeof H=="string"?(this.baseFolder=S.URI.file(H),this.base=H):S.URI.isUri(H)?(this.baseFolder=H,this.base=H.fsPath):(this.baseFolder=H.uri,this.base=H.uri.fsPath),this.pattern=oe}};kt=Ve([P],kt),e.RelativePattern=kt;let $t=class{constructor(H,oe,De,Ze){this.enabled=typeof H=="boolean"?H:!0,typeof oe=="string"&&(this.condition=oe),typeof De=="string"&&(this.hitCondition=De),typeof Ze=="string"&&(this.logMessage=Ze)}get id(){return this._id||(this._id=(0,I.generateUuid)()),this._id}};$t=Ve([P],$t),e.Breakpoint=$t;let en=class extends $t{constructor(H,oe,De,Ze,lt){super(oe,De,Ze,lt);if(H===null)throw(0,F.illegalArgument)("location");this.location=H}};en=Ve([P],en),e.SourceBreakpoint=en;let St=class extends $t{constructor(H,oe,De,Ze,lt){super(oe,De,Ze,lt);this.functionName=H}};St=Ve([P],St),e.FunctionBreakpoint=St;let Qt=class extends $t{constructor(H,oe,De,Ze,lt,dt,gt){super(Ze,lt,dt,gt);if(!oe)throw(0,F.illegalArgument)("dataId");this.label=H,this.dataId=oe,this.canPersist=De}};Qt=Ve([P],Qt),e.DataBreakpoint=Qt;let jt=class{constructor(H,oe,De){this.command=H,this.args=oe||[],this.options=De}};jt=Ve([P],jt),e.DebugAdapterExecutable=jt;let tn=class{constructor(H,oe){this.port=H,this.host=oe}};tn=Ve([P],tn),e.DebugAdapterServer=tn;let nn=class{constructor(H){this.path=H}};nn=Ve([P],nn),e.DebugAdapterNamedPipeServer=nn;let Tt=class{constructor(H){this.implementation=H}};Tt=Ve([P],Tt),e.DebugAdapterInlineImplementation=Tt;let Xt=class{constructor(H,oe){this.range=H,this.expression=oe}};Xt=Ve([P],Xt),e.EvaluatableExpression=Xt;var bn;(function(G){G[G.Automatic=0]="Automatic",G[G.Explicit=1]="Explicit"})(bn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(H,oe){this.range=H,this.text=oe}};Wt=Ve([P],Wt),e.InlineValueText=Wt;let Ht=class{constructor(H,oe,De=!0){this.range=H,this.variableName=oe,this.caseSensitiveLookup=De}};Ht=Ve([P],Ht),e.InlineValueVariableLookup=Ht;let wt=class{constructor(H,oe){this.range=H,this.expression=oe}};wt=Ve([P],wt),e.InlineValueEvaluatableExpression=wt;let rn=class{constructor(H,oe){this.frameId=H,this.stoppedLocation=oe}};rn=Ve([P],rn),e.InlineValueContext=rn;var Ot;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(Ot=e.FileChangeType||(e.FileChangeType={}));let Nt=m=class extends Error{constructor(H,oe=i.FileSystemProviderErrorCode.Unknown,De){super(S.URI.isUri(H)?H.toString(!0):H);this.code=De?.name??"Unknown",(0,i.markAsFileSystemProviderError)(this,oe),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,m.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}static FileExists(H){return new m(H,i.FileSystemProviderErrorCode.FileExists,m.FileExists)}static FileNotFound(H){return new m(H,i.FileSystemProviderErrorCode.FileNotFound,m.FileNotFound)}static FileNotADirectory(H){return new m(H,i.FileSystemProviderErrorCode.FileNotADirectory,m.FileNotADirectory)}static FileIsADirectory(H){return new m(H,i.FileSystemProviderErrorCode.FileIsADirectory,m.FileIsADirectory)}static NoPermissions(H){return new m(H,i.FileSystemProviderErrorCode.NoPermissions,m.NoPermissions)}static Unavailable(H){return new m(H,i.FileSystemProviderErrorCode.Unavailable,m.Unavailable)}};Nt=m=Ve([P],Nt),e.FileSystemError=Nt;let Yt=class{constructor(H,oe,De){this.start=H,this.end=oe,this.kind=De}};Yt=Ve([P],Yt),e.FoldingRange=Yt;var En;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(En=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fn;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(fn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _n;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(_n=e.CommentMode||(e.CommentMode={}));class mn{constructor(H,oe=[]){this.tokenTypes=H,this.tokenModifiers=oe}}e.SemanticTokensLegend=mn;function sn(G){return typeof G=="undefined"||(0,_.isStringArray)(G)}class on{constructor(H){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,H){this._hasLegend=!0;for(let oe=0,De=H.tokenTypes.length;oe<De;oe++)this._tokenTypeStrToInt.set(H.tokenTypes[oe],oe);for(let oe=0,De=H.tokenModifiers.length;oe<De;oe++)this._tokenModifierStrToInt.set(H.tokenModifiers[oe],oe)}}push(H,oe,De,Ze,lt){if(typeof H=="number"&&typeof oe=="number"&&typeof De=="number"&&typeof Ze=="number"&&(typeof lt=="number"||typeof lt=="undefined"))return typeof lt=="undefined"&&(lt=0),this._pushEncoded(H,oe,De,Ze,lt);if(R.isRange(H)&&typeof oe=="string"&&sn(De))return this._push(H,oe,De);throw(0,F.illegalArgument)()}_push(H,oe,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(oe))throw new Error("`tokenType` is not in the provided legend");const Ze=H.start.line,lt=H.start.character,dt=H.end.character-H.start.character,gt=this._tokenTypeStrToInt.get(oe);let It=0;if(De)for(const At of De){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Lt=this._tokenModifierStrToInt.get(At);It|=1<<Lt>>>0}this._pushEncoded(Ze,lt,dt,gt,It)}_pushEncoded(H,oe,De,Ze,lt){if(this._dataIsSortedAndDeltaEncoded&&(H<this._prevLine||H===this._prevLine&&oe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const It=this._data.length/5|0;let At=0,Lt=0;for(let Mt=0;Mt<It;Mt++){let Ut=this._data[5*Mt],dn=this._data[5*Mt+1];Ut===0?(Ut=At,dn+=Lt):Ut+=At,this._data[5*Mt]=Ut,this._data[5*Mt+1]=dn,At=Ut,Lt=dn}}let dt=H,gt=oe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(dt-=this._prevLine,dt===0&&(gt-=this._prevChar)),this._data[this._dataLen++]=dt,this._data[this._dataLen++]=gt,this._data[this._dataLen++]=De,this._data[this._dataLen++]=Ze,this._data[this._dataLen++]=lt,this._prevLine=H,this._prevChar=oe}static _sortAndDeltaEncode(H){let oe=[];const De=H.length/5|0;for(let gt=0;gt<De;gt++)oe[gt]=gt;oe.sort((gt,It)=>{const At=H[5*gt],Lt=H[5*It];if(At===Lt){const Mt=H[5*gt+1],Ut=H[5*It+1];return Mt-Ut}return At-Lt});const Ze=new Uint32Array(H.length);let lt=0,dt=0;for(let gt=0;gt<De;gt++){const It=5*oe[gt],At=H[It+0],Lt=H[It+1],Mt=H[It+2],Ut=H[It+3],dn=H[It+4],Bn=At-lt,Gn=Bn===0?Lt-dt:Lt,hn=5*gt;Ze[hn+0]=Bn,Ze[hn+1]=Gn,Ze[hn+2]=Mt,Ze[hn+3]=Ut,Ze[hn+4]=dn,lt=At,dt=Lt}return Ze}build(H){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),H):new qt(on._sortAndDeltaEncode(this._data),H)}}e.SemanticTokensBuilder=on;class qt{constructor(H,oe){this.resultId=oe,this.data=H}}e.SemanticTokens=qt;class an{constructor(H,oe,De){this.start=H,this.deleteCount=oe,this.data=De}}e.SemanticTokensEdit=an;class Sn{constructor(H,oe){this.resultId=oe,this.edits=H}}e.SemanticTokensEdits=Sn;var yn;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(yn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Gt;(function(G){G[G.Initial=1]="Initial",G[G.Dynamic=2]="Dynamic"})(Gt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Jt=class{constructor(){}};Jt.Back={iconPath:new Dt("arrow-left")},Jt=Ve([P],Jt),e.QuickInputButtons=Jt;var Dn;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor(H,oe,De){this.badge=H,this.tooltip=oe,this.color=De}static validate(H){if(H.badge&&H.badge.length!==1&&H.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Cn;let ln=class{constructor(H){this.kind=H}};ln=Ve([P],ln),e.ColorTheme=ln;var cn;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast"})(cn=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{constructor(H,oe){if(H<0)throw(0,F.illegalArgument)("start must be positive");if(oe<0)throw(0,F.illegalArgument)("end must be positive");H<=oe?(this._start=H,this._end=oe):(this._start=oe,this._end=H)}static isNotebookRange(H){return H instanceof zt?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(H){let oe=this._start,De=this._end;return H.start!==void 0&&(oe=H.start),H.end!==void 0&&(De=H.end),oe===this._start&&De===this._end?this:new zt(oe,De)}}e.NotebookRange=zt;class Ft{constructor(H,oe,De,Ze,lt,dt,gt){this.kind=H,this.value=oe,this.languageId=De,this.mime=Ze,this.outputs=lt??[],this.metadata=dt,this.executionSummary=gt,Ft.validate(this)}static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(oe=>Ft.isNotebookCellData(oe))}static isNotebookCellData(H){return!0}}e.NotebookCellData=Ft;class Ne{constructor(H){this.cells=H}}e.NotebookData=Ne;class Rt{constructor(H,oe){this.data=H,this.mime=oe;const De=(0,A.normalizeMimeType)(oe,!0);if(!De)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}static isNotebookCellOutputItem(H){return H instanceof Rt?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const oe={name:H.name,message:H.message,stack:H.stack};return Rt.json(oe,"application/vnd.code.notebook.error")}static stdout(H){return Rt.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return Rt.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,oe="application/octet-stream"){return new Rt(H,oe)}static text(H,oe=A.Mimes.text){const De=Oe(Rt,d,"f",w).encode(String(H));return new Rt(De,oe)}static json(H,oe="application/json"){const De=JSON.stringify(H,void 0,"	");return Rt.text(De,oe)}}e.NotebookCellOutputItem=Rt,d=Rt,w={value:new TextEncoder};class Kt{constructor(H,oe,De){this.items=Kt.ensureUniqueMimeTypes(H,!0),typeof oe=="string"?(this.id=oe,this.metadata=De):(this.id=(0,I.generateUuid)(),this.metadata=oe??De)}static isNotebookCellOutput(H){return H instanceof Kt?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&(0,_.isArray)(H.items)}static ensureUniqueMimeTypes(H,oe=!1){const De=new Set,Ze=new Set;for(let lt=0;lt<H.length;lt++){const dt=H[lt],gt=(0,A.normalizeMimeType)(dt.mime);if(!De.has(gt)){De.add(gt);continue}Ze.add(lt),oe&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Ze.size===0?H:H.filter((lt,dt)=>!Ze.has(dt))}}e.NotebookCellOutput=Kt;var yt;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(yt=e.NotebookCellKind||(e.NotebookCellKind={}));var kn;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(kn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var In;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(In=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var gn;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(gn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class pn{constructor(H,oe){this.text=H,this.alignment=oe}}e.NotebookCellStatusBarItem=pn;var Pn;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(Pn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Tn{constructor(H,oe=[]){this.uri=H,this.provides=(0,p.asArray)(oe)}}e.NotebookRendererScript=Tn;let un=class{constructor(H,oe){this.label=H,this.timestamp=oe}};un=Ve([P],un),e.TimelineItem=un;var An;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(An=e.ExtensionMode||(e.ExtensionMode={}));var vn;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(vn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Rn;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=4]="RegEx"})(Rn=e.StandardTokenType||(e.StandardTokenType={}));class Ln{constructor(H,oe){this.ranges=H,this.wordPattern=oe}}e.LinkedEditingRanges=Ln;class Fn{constructor(H,oe){this._port=H,this._autoForwardAction=oe}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fn;var Mn;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(Mn=e.TestResultState||(e.TestResultState={}));var On;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(On=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ie=class{constructor(H,oe,De){this.include=H,this.exclude=oe,this.profile=De}};ie=Ve([P],ie),e.TestRunRequest=ie;let he=b=class{constructor(H){this.message=H}static diff(H,oe,De){const Ze=new b(H);return Ze.expectedOutput=oe,Ze.actualOutput=De,Ze}};he=b=Ve([P],he),e.TestMessage=he;let Ae=class{constructor(H){this.id=H}};Ae=Ve([P],Ae),e.TestTag=Ae;let ut=class{constructor(H,oe){this.covered=H,this.total=oe}};ut=Ve([P],ut),e.CoveredCount=ut;let Ct=f=class{constructor(H,oe,De,Ze){this.uri=H,this.statementCoverage=oe,this.branchCoverage=De,this.functionCoverage=Ze}static fromDetails(H,oe){const De=new ut(0,0),Ze=new ut(0,0),lt=new ut(0,0);for(const gt of oe)if("branches"in gt){De.total+=1,De.covered+=gt.executionCount>0?1:0;for(const It of gt.branches)Ze.total+=1,Ze.covered+=It.executionCount>0?1:0}else lt.total+=1,lt.covered+=gt.executionCount>0?1:0;const dt=new f(H,De,Ze.total>0?Ze:void 0,lt.total>0?lt:void 0);return dt.detailedCoverage=oe,dt}};Ct=f=Ve([P],Ct),e.FileCoverage=Ct;let Pt=class{constructor(H,oe,De=[]){this.executionCount=H,this.location=oe,this.branches=De}};Pt=Ve([P],Pt),e.StatementCoverage=Pt;let Nn=class{constructor(H,oe){this.executionCount=H,this.location=oe}};Nn=Ve([P],Nn),e.BranchCoverage=Nn;let Un=class{constructor(H,oe){this.executionCount=H,this.location=oe}};Un=Ve([P],Un),e.FunctionCoverage=Un;var zn;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(zn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Vn;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(Vn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var jn;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(jn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class qn{constructor(H,oe,De,Ze,lt,dt){this.kind=H,this.name=oe,this.detail=De,this.uri=Ze,this.range=lt,this.selectionRange=dt}}e.TypeHierarchyItem=qn}),define(fe[125],me([0,1,58,10,9,151,111,7,18]),function(Y,e,p,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const I=new Map;function i(d,w){w?I.set(d,w):I.delete(d)}e.setWordDefinitionFor=i;function k(d){return I.get(d)}e.getWordDefinitionFor=k;class a extends y.MirrorTextModel{constructor(w,D,T,E,c,r,v,t){super(D,T,E,c);this._proxy=w,this._languageId=r,this._isDirty=v,this._notebook=t,this._isDisposed=!1}dispose(){(0,p.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(w){return(0,S.equals)(this._lines,w)}get document(){if(!this._document){const w=this;this._document={get uri(){return w._uri},get fileName(){return w._uri.fsPath},get isUntitled(){return w._uri.scheme===F.Schemas.untitled},get languageId(){return w._languageId},get version(){return w._versionId},get isClosed(){return w._isDisposed},get isDirty(){return w._isDirty},get notebook(){return w._notebook},save(){return w._save()},getText(D){return D?w._getTextInRange(D):w.getText()},get eol(){return w._eol===`
`?_.EndOfLine.LF:_.EndOfLine.CRLF},get lineCount(){return w._lines.length},lineAt(D){return w._lineAt(D)},offsetAt(D){return w._offsetAt(D)},positionAt(D){return w._positionAt(D)},validateRange(D){return w._validateRange(D)},validatePosition(D){return w._validatePosition(D)},getWordRangeAtPosition(D,T){return w._getWordRangeAtPosition(D,T)}}}return Object.freeze(this._document)}_acceptLanguageId(w){(0,p.ok)(!this._isDisposed),this._languageId=w}_acceptIsDirty(w){(0,p.ok)(!this._isDisposed),this._isDirty=w}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(w){const D=this._validateRange(w);if(D.isEmpty)return"";if(D.isSingleLine)return this._lines[D.start.line].substring(D.start.character,D.end.character);const T=this._eol,E=D.start.line,c=D.end.line,r=[];r.push(this._lines[E].substring(D.start.character));for(let v=E+1;v<c;v++)r.push(this._lines[v]);return r.push(this._lines[c].substring(0,D.end.character)),r.join(T)}_lineAt(w){let D;if(w instanceof _.Position?D=w.line:typeof w=="number"&&(D=w),typeof D!="number"||D<0||D>=this._lines.length||Math.floor(D)!==D)throw new Error("Illegal value for `line`");return new g(D,this._lines[D],D===this._lines.length-1)}_offsetAt(w){return w=this._validatePosition(w),this._ensureLineStarts(),this._lineStarts.getPrefixSum(w.line-1)+w.character}_positionAt(w){w=Math.floor(w),w=Math.max(0,w),this._ensureLineStarts();const D=this._lineStarts.getIndexOf(w),T=this._lines[D.index].length;return new _.Position(D.index,Math.min(D.remainder,T))}_validateRange(w){if(!(w instanceof _.Range))throw new Error("Invalid argument");const D=this._validatePosition(w.start),T=this._validatePosition(w.end);return D===w.start&&T===w.end?w:new _.Range(D.line,D.character,T.line,T.character)}_validatePosition(w){if(!(w instanceof _.Position))throw new Error("Invalid argument");if(this._lines.length===0)return w.with(0,0);let{line:D,character:T}=w,E=!1;if(D<0)D=0,T=0,E=!0;else if(D>=this._lines.length)D=this._lines.length-1,T=this._lines[D].length,E=!0;else{const c=this._lines[D].length;T<0?(T=0,E=!0):T>c&&(T=c,E=!0)}return E?new _.Position(D,T):w}_getWordRangeAtPosition(w,D){const T=this._validatePosition(w);if(!D)D=k(this._languageId);else if((0,C.regExpLeadsToEndlessLoop)(D))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${D.source}' because it matches the empty string.`);const E=(0,A.getWordAtText)(T.character+1,(0,A.ensureValidWordDefinition)(D),this._lines[T.line],0);if(E)return new _.Range(T.line,E.startColumn-1,T.line,E.endColumn-1)}}e.ExtHostDocumentData=a;class g{constructor(w,D,T){this._line=w,this._text=D,this._isLastLine=T}get lineNumber(){return this._line}get text(){return this._text}get range(){return new _.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new _.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=g}),define(fe[204],me([0,1,7,3,113,6,82,24,2,32]),function(Y,e,p,F,C,y,A,_,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(a,g,d,w){this._notebook=d,this._selector=w,this._disposables=new y.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,I.generateUuid)()}),this._init(),this._disposables.add(g.onDidChangeDocument(T=>{const E=this._cellUris.get(T.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const D=T=>{T===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(a.onDidChangeNotebookCells(T=>D(T.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new _.ResourceMap;const a=[],g=[];for(const d of this._notebook.getCells())d.kind===p.NotebookCellKind.Code&&(!this._selector||(0,A.score)(this._selector,d.document.uri,d.document.languageId,!0))&&(this._cellUris.set(d.document.uri,this._cells.length),this._cells.push(d),a.push(d.document.getText().length+1),g.push(d.document.lineCount));this._cellLengths=new C.PrefixSumComputer(new Uint32Array(a)),this._cellLines=new C.PrefixSumComputer(new Uint32Array(g))}get version(){return this._versionId}getText(a){if(!a){let E="";for(const c of this._cells)E+=c.document.getText()+`
`;return E=E.slice(0,-1),E}if(a.isEmpty)return"";const g=this.locationAt(a.start),d=this.locationAt(a.end),w=this._cellUris.get(g.uri),D=this._cellUris.get(d.uri);if(w===void 0||D===void 0)return"";if(w===D)return this._cells[w].document.getText(new p.Range(g.range.start,d.range.end));const T=[this._cells[w].document.getText(new p.Range(g.range.start,new p.Position(this._cells[w].document.lineCount,0)))];for(let E=w+1;E<D;E++)T.push(this._cells[E].document.getText());return T.push(this._cells[D].document.getText(new p.Range(new p.Position(0,0),d.range.end))),T.join(`
`)}offsetAt(a){const g=this._cellLines.getIndexOf(a.line),d=this._cellLengths.getPrefixSum(g.index-1),w=this._cells[g.index].document.offsetAt(a.with(g.remainder));return d+w}positionAt(a){if(typeof a=="number"){const d=this._cellLengths.getIndexOf(a),w=this._cellLines.getPrefixSum(d.index-1);return this._cells[d.index].document.positionAt(d.remainder).translate(w)}const g=this._cellUris.get(a.uri);if(g!==void 0){const d=this._cellLines.getPrefixSum(g-1);return new p.Position(d+a.range.start.line,a.range.start.character)}return new p.Position(0,0)}locationAt(a){p.Range.isRange(a)||(a=new p.Range(a,a));const g=this._cellLines.getIndexOf(a.start.line);let d=g;a.isEmpty||(d=this._cellLines.getIndexOf(a.end.line));const w=new p.Position(g.remainder,a.start.character),D=new p.Position(d.remainder,a.end.character),T=new p.Range(w,D),E=this._cells[g.index];return new p.Location(E.document.uri,E.document.validateRange(T))}contains(a){return this._cellUris.has(a)}validateRange(a){const g=this.validatePosition(a.start),d=this.validatePosition(a.end);return a.with(g,d)}validatePosition(a){const g=this._cellLines.getIndexOf(a.line),d=new p.Position(g.remainder,a.character),w=this._cells[g.index].document.validatePosition(d),D=this._cellLines.getPrefixSum(g.index-1);return new p.Position(D+w.line,w.character)}}e.ExtHostNotebookConcatDocument=i}),define(fe[205],me([0,1,7,14,3]),function(Y,e,p,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let y=class{constructor(_){this._actual=new p.ColorTheme(p.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new C.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(_){let S=_==="light"?p.ColorThemeKind.Light:_==="dark"?p.ColorThemeKind.Dark:p.ColorThemeKind.HighContrast;this._actual=new p.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};y=Ve([$e(0,F.IExtHostRpcService)],y),e.ExtHostTheming=y}),define(fe[67],me([0,1,4]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,p.createDecorator)("IURITransformerService");class F{constructor(y){y?(this.transformIncoming=y.transformIncoming.bind(y),this.transformOutgoing=y.transformOutgoing.bind(y),this.transformOutgoingURI=y.transformOutgoingURI.bind(y),this.transformOutgoingScheme=y.transformOutgoingScheme.bind(y)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=F}),define(fe[206],me([0,1,22]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class F{constructor(){this.buffers=[]}add(S){let I=this.buffers.indexOf(S);return I<0&&(I=this.buffers.length,this.buffers.push(S)),I}}function C(_,S){if(S.serializeBuffersForPostMessage){const I=new F,i=(g,d)=>{if(d instanceof ArrayBuffer){const w=I.add(d);return{$$vscode_array_buffer_reference$$:!0,index:w}}else if(ArrayBuffer.isView(d)){const w=y(d);if(w){const D=I.add(d.buffer);return{$$vscode_array_buffer_reference$$:!0,index:D,view:{type:w,byteLength:d.byteLength,byteOffset:d.byteOffset}}}}return d},k=JSON.stringify(_,i),a=I.buffers.map(g=>{const d=new Uint8Array(g);return p.VSBuffer.wrap(d)});return{message:k,buffers:a}}else return{message:JSON.stringify(_),buffers:[]}}e.serializeWebviewMessage=C;function y(_){switch(_.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(_,S){const I=S.map(a=>{const g=new ArrayBuffer(a.byteLength);return new Uint8Array(g).set(a.buffer),g}),i=S.length?(a,g)=>{if(typeof g=="object"&&g.$$vscode_array_buffer_reference$$){const d=g,{index:w}=d,D=I[w];if(d.view)switch(d.view.type){case 1:return new Int8Array(D,d.view.byteOffset,d.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(D,d.view.byteOffset,d.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(D,d.view.byteOffset,d.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(D,d.view.byteOffset,d.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(D,d.view.byteOffset,d.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(D,d.view.byteOffset,d.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(D,d.view.byteOffset,d.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(D,d.view.byteOffset,d.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(D,d.view.byteOffset,d.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(D,d.view.byteOffset,d.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(D,d.view.byteOffset,d.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return D}return g}:void 0;return{message:JSON.parse(_,i),arrayBuffers:I}}e.deserializeWebviewMessage=A}),define(fe[207],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var p;(function(F){function C(A){const _={items:new Map};return A.types.forEach((S,I)=>{_.items.set(S,{asString:async()=>A.items[I].asString})}),_}F.toITreeDataTransfer=C;async function y(A){const _={types:[],items:[]},S=Array.from(A.items.entries());for(const I of S)_.types.push(I[0]),_.items.push({asString:await I[1].asString()});return _}F.toTreeDataTransferDTO=y})(p=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(fe[88],me([0,1,10,2]),function(Y,e,p,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function C(_,S){return _.scheme===p.Schemas.http||_.scheme===p.Schemas.https?_:(S&&S.authority&&S.isRemote&&_.scheme===p.Schemas.file&&(_=F.URI.from({scheme:p.Schemas.vscodeRemote,authority:S.authority,path:_.path})),F.URI.from({scheme:p.Schemas.https,authority:`${_.scheme}+${y(_.authority)}.${e.webviewRootResourceAuthority}`,path:_.path,fragment:_.fragment,query:_.query}))}e.asWebviewUri=C;function y(_){return _.replace(/./g,S=>{const I=S.charCodeAt(0);return I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57?S:"-"+I.toString(16).padStart(4,"0")})}function A(_){return _.replace(/-([0-9a-f]{4})/g,(S,I)=>String.fromCharCode(parseInt(I,16)))}e.decodeAuthority=A}),define(fe[208],me([0,1,3,6,88]),function(Y,e,p,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(_,S,I){this._proxy=_,this._editors=S,this._initData=I,this._handlePool=0,this._disposables=new F.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const i=S.getVisibleTextEditors();for(const k of this._insets.values())i.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this._insets.forEach(_=>_.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(_,S,I,i,k){let a;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===_){a=c;break}if(!a)throw new Error("not a visible editor");const g=this,d=this._handlePool++,w=new p.Emitter,D=new p.Emitter,T=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(c){return(0,C.asWebviewUri)(c,g._initData.remote)}get cspSource(){return C.webviewGenericCspSource}set options(c){this._options=c,g._proxy.$setOptions(d,c)}get options(){return this._options}set html(c){this._html=c,g._proxy.$setHtml(d,c)}get html(){return this._html}get onDidReceiveMessage(){return w.event}postMessage(c){return g._proxy.$postMessage(d,c)}},E=new class{constructor(){this.editor=_,this.line=S,this.height=I,this.webview=T,this.onDidDispose=D.event}dispose(){g._insets.has(d)&&(g._insets.delete(d),g._proxy.$disposeEditorInset(d),D.fire(),D.dispose(),w.dispose())}};return this._proxy.$createEditorInset(d,a.id,a.value.document.uri,S+1,I,i||{},k.identifier,k.extensionLocation),this._insets.set(d,{editor:_,inset:E,onDidReceiveMessage:w}),E}$onDidDispose(_){const S=this._insets.get(_);S&&S.inset.dispose()}$onDidReceiveMessage(_,S){const I=this._insets.get(_);I&&I.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=y}),define(fe[209],me([0,1,174,12,2,6,4,63,34,18,10]),function(Y,e,p,F,C,y,A,_,S,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,p.localize)(0,null),providerDisplayName:(0,p.localize)(1,null)},e.ActiveEditorDirtyContext=new _.RawContextKey("activeEditorIsDirty",!1,(0,p.localize)(2,null)),e.ActiveEditorPinnedContext=new _.RawContextKey("activeEditorIsNotPreview",!1,(0,p.localize)(3,null)),e.ActiveEditorStickyContext=new _.RawContextKey("activeEditorIsPinned",!1,(0,p.localize)(4,null)),e.ActiveEditorReadonlyContext=new _.RawContextKey("activeEditorIsReadonly",!1,(0,p.localize)(5,null)),e.ActiveEditorCanRevertContext=new _.RawContextKey("activeEditorCanRevert",!1,(0,p.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new _.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new _.RawContextKey("activeEditor",null,{type:"string",description:(0,p.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new _.RawContextKey("activeEditorAvailableEditorIds","",(0,p.localize)(8,null)),e.TextCompareEditorVisibleContext=new _.RawContextKey("textCompareEditorVisible",!1,(0,p.localize)(9,null)),e.TextCompareEditorActiveContext=new _.RawContextKey("textCompareEditorActive",!1,(0,p.localize)(10,null)),e.SideBySideEditorActiveContext=new _.RawContextKey("sideBySideEditorActive",!1,(0,p.localize)(11,null)),e.EditorGroupEditorsCountContext=new _.RawContextKey("groupEditorsCount",0,(0,p.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new _.RawContextKey("activeEditorGroupEmpty",!1,(0,p.localize)(13,null)),e.ActiveEditorGroupIndexContext=new _.RawContextKey("activeEditorGroupIndex",0,(0,p.localize)(14,null)),e.ActiveEditorGroupLastContext=new _.RawContextKey("activeEditorGroupLast",!1,(0,p.localize)(15,null)),e.ActiveEditorGroupLockedContext=new _.RawContextKey("activeEditorGroupLocked",!1,(0,p.localize)(16,null)),e.MultipleEditorGroupsContext=new _.RawContextKey("multipleEditorGroups",!1,(0,p.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new _.RawContextKey("editorIsOpen",!1,(0,p.localize)(18,null)),e.InEditorZenModeContext=new _.RawContextKey("inZenMode",!1,(0,p.localize)(19,null)),e.IsCenteredLayoutContext=new _.RawContextKey("isCenteredLayout",!1,(0,p.localize)(20,null)),e.SplitEditorsVertically=new _.RawContextKey("splitEditorsVertically",!1,(0,p.localize)(21,null)),e.EditorAreaVisibleContext=new _.RawContextKey("editorAreaVisible",!0,(0,p.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function k(M,R,W){for(const V of W.visibleEditorPanes)if(V.group.id===R&&M.matches(V.input))return V.getViewState()}e.findViewStateForEditor=k;function a(M){if(r(M))return!1;const R=M;return C.URI.isUri(R?.resource)}e.isResourceEditorInput=a;function g(M){if(r(M))return!1;const R=M;return R?.original!==void 0&&R.modified!==void 0}e.isResourceDiffEditorInput=g;function d(M){if(r(M)||g(M))return!1;const R=M;return R?.primary!==void 0&&R.secondary!==void 0}e.isResourceSideBySideEditorInput=d;function w(M){if(r(M))return!1;const R=M;return R?R.resource===void 0||R.resource.scheme===i.Schemas.untitled||R.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=w;var D;(function(M){M[M.SHORT=0]="SHORT",M[M.MEDIUM=1]="MEDIUM",M[M.LONG=2]="LONG"})(D=e.Verbosity||(e.Verbosity={}));var T;(function(M){M[M.EXPLICIT=1]="EXPLICIT",M[M.AUTO=2]="AUTO",M[M.FOCUS_CHANGE=3]="FOCUS_CHANGE",M[M.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(T=e.SaveReason||(e.SaveReason={}));var E;(function(M){M[M.None=0]="None",M[M.Readonly=2]="Readonly",M[M.Untitled=4]="Untitled",M[M.Singleton=8]="Singleton",M[M.RequiresTrust=16]="RequiresTrust",M[M.CanSplitInGroup=32]="CanSplitInGroup",M[M.ForceDescription=64]="ForceDescription"})(E=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class c extends y.Disposable{}e.AbstractEditorInput=c;function r(M){return M instanceof c}e.isEditorInput=r;function v(M){const R=M;return C.URI.isUri(R?.preferredResource)}function t(M){const R=M;return r(R?.primary)&&r(R?.secondary)}e.isSideBySideEditorInput=t;function h(M){const R=M;return r(R?.modified)&&r(R?.original)}e.isDiffEditorInput=h;function s(M){return r(M?.editor)}e.isEditorInputWithOptions=s;function n(M){const R=M;return s(M)&&R?.group!==void 0}e.isEditorInputWithOptionsAndGroup=n;function u(M){const R=M;return typeof R?.groupId=="number"&&r(R.editor)}e.isEditorIdentifier=u;var o;(function(M){M[M.UNKNOWN=0]="UNKNOWN",M[M.REPLACE=1]="REPLACE",M[M.MOVE=2]="MOVE",M[M.UNPIN=3]="UNPIN"})(o=e.EditorCloseContext||(e.EditorCloseContext={}));var l;(function(M){M[M.PRIMARY=1]="PRIMARY",M[M.SECONDARY=2]="SECONDARY",M[M.BOTH=3]="BOTH",M[M.ANY=4]="ANY"})(l=e.SideBySideEditor||(e.SideBySideEditor={}));class m{getOriginalUri(R,W){if(!R)return;if(W?.supportSideBySide){const{primary:N,secondary:j}=this.getSideEditors(R);if(N&&j){if(W?.supportSideBySide===l.BOTH)return{primary:this.getOriginalUri(N,{filterByScheme:W.filterByScheme}),secondary:this.getOriginalUri(j,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===l.ANY)return this.getOriginalUri(N,{filterByScheme:W.filterByScheme})??this.getOriginalUri(j,{filterByScheme:W.filterByScheme});R=W.supportSideBySide===l.PRIMARY?N:j}}if(g(R)||d(R))return;const V=v(R)?R.preferredResource:R.resource;return!V||!W||!W.filterByScheme?V:this.filterUri(V,W.filterByScheme)}getSideEditors(R){return t(R)||d(R)?{primary:R.primary,secondary:R.secondary}:h(R)||g(R)?{primary:R.modified,secondary:R.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(R,W){if(!R)return;if(W?.supportSideBySide){const{primary:N,secondary:j}=this.getSideEditors(R);if(N&&j){if(W?.supportSideBySide===l.BOTH)return{primary:this.getCanonicalUri(N,{filterByScheme:W.filterByScheme}),secondary:this.getCanonicalUri(j,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===l.ANY)return this.getCanonicalUri(N,{filterByScheme:W.filterByScheme})??this.getCanonicalUri(j,{filterByScheme:W.filterByScheme});R=W.supportSideBySide===l.PRIMARY?N:j}}if(g(R)||d(R))return;const V=R.resource;return!V||!W||!W.filterByScheme?V:this.filterUri(V,W.filterByScheme)}filterUri(R,W){if(Array.isArray(W)){if(W.some(V=>R.scheme===V))return R}else if(W===R.scheme)return R}}e.EditorResourceAccessor=new m;var b;(function(M){M[M.LEFT=0]="LEFT",M[M.RIGHT=1]="RIGHT"})(b=e.CloseDirection||(e.CloseDirection={}));class f{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(R){const W=this.instantiationService=R.get(A.IInstantiationService);for(const[V,N]of this.editorSerializerConstructors)this.createEditorSerializer(V,N,W);this.editorSerializerConstructors.clear()}createEditorSerializer(R,W,V){const N=V.createInstance(W);this.editorSerializerInstances.set(R,N)}registerFileEditorFactory(R){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=R}getFileEditorFactory(){return(0,F.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(R,W){if(this.editorSerializerConstructors.has(R)||this.editorSerializerInstances.has(R))throw new Error(`A editor serializer with type ID '${R}' was already registered.`);return this.instantiationService?this.createEditorSerializer(R,W,this.instantiationService):this.editorSerializerConstructors.set(R,W),(0,y.toDisposable)(()=>{this.editorSerializerConstructors.delete(R),this.editorSerializerInstances.delete(R)})}getEditorSerializer(R){return this.editorSerializerInstances.get(typeof R=="string"?R:R.typeId)}}S.Registry.add(e.EditorExtensions.EditorFactory,new f);async function P(M,R){if(!M||!M.length)return[];const W=await Promise.all(M.map(async V=>{const N=C.URI.revive(V.fileUri);if(!N||!await R.canHandleResource(N))return;const U=typeof V.exists=="boolean"?V.exists:await R.exists(N);if(!U&&V.openOnlyIfExists)return;const B={selection:U?V.selection:void 0,pinned:!0,override:V.editorOverrideId};let z;return U?z={resource:N,options:B}:z={resource:N,options:B,forceUntitled:!0},z}));return(0,I.coalesce)(W)}e.pathsToEditors=P;var L;(function(M){M[M.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",M[M.SEQUENTIAL=1]="SEQUENTIAL"})(L=e.EditorsOrder||(e.EditorsOrder={}))}),define(fe[210],me([0,1,3,63,175,4,6,24,34,18,59,25,47,199]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,g.registerIcon)("default-view-icon",a.Codicon.window,(0,C.localize)(0,null));var d;(function(u){u.ViewContainersRegistry="workbench.registry.view.containers",u.ViewsRegistry="workbench.registry.view"})(d=e.Extensions||(e.Extensions={}));var w;(function(u){u[u.Sidebar=0]="Sidebar",u[u.Panel=1]="Panel",u[u.AuxiliaryBar=2]="AuxiliaryBar"})(w=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function D(u){switch(u){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=D;function T(u){return`viewContainer.${u}.enabled`}e.getEnabledViewContainerContextKey=T;class E extends A.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new p.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new p.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,I.flatten)([...this.viewContainers.values()])}registerViewContainer(o,l,m){const b=this.get(o.id);if(b)return b;const f=o;return f.openCommandActionDescriptor=m?.donotRegisterOpenCommand?void 0:f.openCommandActionDescriptor??{id:f.id},(0,_.getOrSet)(this.viewContainers,l,[]).push(f),m?.isDefault&&this.defaultViewContainers.push(f),this._onDidRegister.fire({viewContainer:f,viewContainerLocation:l}),f}deregisterViewContainer(o){for(const l of this.viewContainers.keys()){const m=this.viewContainers.get(l),b=m?.indexOf(o);if(b!==-1){m?.splice(b,1),m.length===0&&this.viewContainers.delete(l),this._onDidDeregister.fire({viewContainer:o,viewContainerLocation:l});return}}}get(o){return this.all.filter(l=>l.id===o)[0]}getViewContainers(o){return[...this.viewContainers.get(o)||[]]}getViewContainerLocation(o){return[...this.viewContainers.keys()].filter(l=>this.getViewContainers(l).filter(m=>m?.id===o.id).length>0)[0]}getDefaultViewContainer(o){return this.defaultViewContainers.find(l=>this.getViewContainerLocation(l)===o)}}S.Registry.add(d.ViewContainersRegistry,new E);var c;(function(u){u.Open="2_open",u.Debug="4_debug",u.SCM="5_scm",u.More="9_more"})(c=e.ViewContentGroups||(e.ViewContentGroups={}));function r(u,o){const l=u.group??c.More,m=o.group??c.More;return l!==m?l.localeCompare(m):(u.order??5)-(o.order??5)}class v extends A.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new p.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new p.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new p.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new p.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(o,l){this.registerViews2([{views:o,viewContainer:l}])}registerViews2(o){o.forEach(({views:l,viewContainer:m})=>this.addViews(l,m)),this._onViewsRegistered.fire(o)}deregisterViews(o,l){const m=this.removeViews(o,l);m.length&&this._onViewsDeregistered.fire({views:m,viewContainer:l})}moveViews(o,l){for(const m of this._views.keys())if(m!==l){const b=this.removeViews(o,m);b.length&&(this.addViews(b,l),this._onDidChangeContainer.fire({views:b,from:m,to:l}))}}getViews(o){return this._views.get(o)||[]}getView(o){for(const l of this._viewContainers){const m=(this._views.get(l)||[]).filter(b=>b.id===o)[0];if(m)return m}return null}getViewContainer(o){for(const l of this._viewContainers)if((this._views.get(l)||[]).filter(b=>b.id===o)[0])return l;return null}registerViewWelcomeContent(o,l){return this._viewWelcomeContents.add(o,l),this._onDidChangeViewWelcomeContent.fire(o),(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(o,l),this._onDidChangeViewWelcomeContent.fire(o)})}registerViewWelcomeContent2(o,l){const m=new Map;for(const[b,f]of l)this._viewWelcomeContents.add(o,f),m.set(b,(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(o,f),this._onDidChangeViewWelcomeContent.fire(o)}));return this._onDidChangeViewWelcomeContent.fire(o),m}getViewWelcomeContent(o){const l=[];return this._viewWelcomeContents.forEach(o,m=>l.push(m)),l.sort(r)}addViews(o,l){let m=this._views.get(l);m||(m=[],this._views.set(l,m),this._viewContainers.push(l));for(const b of o){if(this.getView(b.id)!==null)throw new Error((0,C.localize)(1,null,b.id));m.push(b)}}removeViews(o,l){const m=this._views.get(l);if(!m)return[];const b=[],f=[];for(const P of m)o.includes(P)?b.push(P):f.push(P);return b.length&&(f.length?this._views.set(l,f):(this._views.delete(l),this._viewContainers.splice(this._viewContainers.indexOf(l),1))),b}}S.Registry.add(d.ViewsRegistry,new v),e.IViewsService=(0,y.createDecorator)("viewsService"),e.FocusedViewContext=new F.RawContextKey("focusedView","",(0,C.localize)(2,null));function t(u){return`view.${u}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,y.createDecorator)("viewDescriptorService");var h;(function(u){u[u.Default=0]="Default",u[u.Expand=1]="Expand"})(h=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(u){u[u.None=0]="None",u[u.Collapsed=1]="Collapsed",u[u.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class n{constructor(o,l){this.resolved=!1,this._hasResolve=!1,(0,k.mixin)(this,o),this._hasResolve=!!l,this.resolve=async m=>{if(l&&!this.resolved){const b=await l(m);b&&(this.tooltip=this.tooltip??b.tooltip,this.command=this.command??b.command)}m.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=n,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(fe[126],me([0,1,3,15,176]),function(Y,e,p,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class y{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new p.Emitter,this._onExit=new p.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(_){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=_}onEvent(_){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=_}onRequest(_){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=_}sendResponse(_){_.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${_.command}`)):this.internalSend("response",_)}sendRequest(_,S,I,i){const k={command:_};if(S&&Object.keys(S).length>0&&(k.arguments=S),this.internalSend("request",k),typeof i=="number"){const a=setTimeout(()=>{clearTimeout(a);const g=this.pendingRequests.get(k.seq);if(g){this.pendingRequests.delete(k.seq);const d={type:"response",seq:0,request_seq:k.seq,success:!1,command:_,message:(0,C.localize)(0,null,i,_)};g(d)}},i)}return I&&this.pendingRequests.set(k.seq,I),k.seq}acceptMessage(_){this.messageCallback?this.messageCallback(_):(this.queue.push(_),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(_,S){return _.type!=="event"||S.type!=="event"}async processQueue(){let _;for(;this.queue.length;){if((!_||this.needsTaskBoundaryBetween(this.queue[0],_))&&await(0,F.timeout)(0),_=this.queue.shift(),!_)return;switch(_.type){case"event":this.eventCallback&&this.eventCallback(_);break;case"request":this.requestCallback&&this.requestCallback(_);break;case"response":const S=_,I=this.pendingRequests.get(S.request_seq);I&&(this.pendingRequests.delete(S.request_seq),I(S));break}}}internalSend(_,S){S.type=_,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const _=new Map;this.pendingRequests.forEach((S,I)=>_.set(I,S)),await(0,F.timeout)(500),_.forEach((S,I)=>{S({type:"response",seq:0,request_seq:I,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(I)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=y}),define(fe[211],me([0,1,9,2,8,25,10]),function(Y,e,p,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const _=/{([^}]+)}/g;function S(s,n,u){return s.replace(_,function(o,l){return n&&l.length>0&&l[0]!=="_"?o:u&&u.hasOwnProperty(l)?u[l]:o})}e.formatPII=S;function I(s){const n={};for(const u of Object.keys(s))u.startsWith("!")||(n[u]=s[u]);return n}e.filterExceptionsFromTelemetry=I;function i(s){return s.configuration.request==="attach"&&!k(s)&&(!s.parentSession||i(s.parentSession))}e.isSessionAttach=i;function k(s){let n=s.configuration.type;if(!!n)return n==="vslsShare"&&(n=s.configuration.adapterProxy.configuration.type),(0,p.equalsIgnoreCase)(n,"extensionhost")||(0,p.equalsIgnoreCase)(n,"pwa-extensionhost")?s:s.parentSession?k(s.parentSession):void 0}e.getExtensionHostDebugSession=k;function a(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=a;function g(s,n,u){let o,l=0,m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,b=null;for(;b=m.exec(s);){let f=b.index+1,P=f+b[0].length;if(f<=n&&P>=u){o=b[0],l=f;break}}if(o){let f=/\w+/g,P=null;for(;(P=f.exec(o))&&!(P.index+1+l+P[0].length>=u););P&&(o=o.substring(0,f.lastIndex))}return o?{start:l,end:l+o.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=g;const d=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function w(s){return!!(s&&s.match(d))}e.isUri=w;function D(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(w(s.path))return F.URI.parse(s.path);if((0,C.isAbsolute)(s.path))return F.URI.file(s.path)}return s.path}function T(s){if(typeof s.path=="object"){const n=F.URI.revive(s.path);if(n)return n.scheme===A.Schemas.file?n.fsPath:n.toString()}return s.path}function E(s,n){const u=n?D:T,o=(0,y.deepClone)(s);return r(o,(l,m)=>{l&&m&&(m.path=u(m))}),o}e.convertToDAPaths=E;function c(s,n){const u=n?D:T,o=(0,y.deepClone)(s);return r(o,(l,m)=>{!l&&m&&(m.path=u(m))}),o}e.convertToVSCPaths=c;function r(s,n){switch(s.type){case"event":const u=s;switch(u.event){case"output":n(!1,u.body.source);break;case"loadedSource":n(!1,u.body.source);break;case"breakpoint":n(!1,u.body.breakpoint.source);break;default:break}break;case"request":const o=s;switch(o.command){case"setBreakpoints":n(!0,o.arguments.source);break;case"breakpointLocations":n(!0,o.arguments.source);break;case"source":n(!0,o.arguments.source);break;case"gotoTargets":n(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(m=>n(!1,m));break;default:break}break;case"response":const l=s;if(l.success&&l.body)switch(l.command){case"stackTrace":l.body.stackFrames.forEach(m=>n(!1,m.source));break;case"loadedSources":l.body.sources.forEach(m=>n(!1,m));break;case"scopes":l.body.scopes.forEach(m=>n(!1,m.source));break;case"setFunctionBreakpoints":l.body.breakpoints.forEach(m=>n(!1,m.source));break;case"setBreakpoints":l.body.breakpoints.forEach(m=>n(!1,m.source));break;default:break}break}}function v(s){return s.filter(n=>!n.presentation?.hidden).sort((n,u)=>n.presentation?u.presentation?n.presentation.group?u.presentation.group?n.presentation.group!==u.presentation.group?n.presentation.group.localeCompare(u.presentation.group):t(n.presentation.order,u.presentation.order):-1:u.presentation.group?1:t(n.presentation.order,u.presentation.order):-1:u.presentation?1:0)}e.getVisibleAndSorted=v;function t(s,n){return typeof s!="number"?typeof n!="number"?0:1:typeof n!="number"?-1:s-n}async function h(s,n){const u=s.getValue("debug.saveBeforeStart",{overrideIdentifier:n.activeTextEditorMode});if(u!=="none"&&(await n.saveAll(),u==="allEditorsInActiveGroup")){const o=n.activeEditorPane;o&&await n.save({editor:o.input,groupId:o.group.id})}await s.reloadConfiguration()}e.saveAllBeforeDebugStart=h}),define(fe[212],me([0,1,28,39,177,127,8,9,25,11,187,126]),function(Y,e,p,F,C,y,A,_,S,I,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class a extends k.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(E,c){this.outputStream=c,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,E.on("data",r=>this.handleData(r))}sendMessage(E){if(this.outputStream){const c=JSON.stringify(E);this.outputStream.write(`Content-Length: ${Buffer.byteLength(c,"utf8")}${a.TWO_CRLF}${c}`,"utf8")}}handleData(E){for(this.rawData=Buffer.concat([this.rawData,E]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const c=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,c.length>0)try{this.acceptMessage(JSON.parse(c))}catch(r){this._onError.fire(new Error((r.message||r)+`
`+c))}continue}}else{const c=this.rawData.indexOf(a.TWO_CRLF);if(c!==-1){const v=this.rawData.toString("utf8",0,c).split(a.HEADER_LINESEPARATOR);for(const t of v){const h=t.split(a.HEADER_FIELDSEPARATOR);h[0]==="Content-Length"&&(this.contentLength=Number(h[1]))}this.rawData=this.rawData.slice(c+a.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=a,a.TWO_CRLF=`\r
\r
`,a.HEADER_LINESEPARATOR=/\r?\n/,a.HEADER_FIELDSEPARATOR=/: */;class g extends a{startSession(){return new Promise((E,c)=>{let r=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),E(),r=!0}),this.socket.on("close",()=>{r?this._onError.fire(new Error("connection closed")):c(new Error("connection closed"))}),this.socket.on("error",v=>{r?this._onError.fire(v):c(v)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=g;class d extends g{constructor(E){super();this.adapterServer=E}createConnection(E){return y.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",E)}}e.SocketDebugAdapter=d;class w extends g{constructor(E){super();this.adapterServer=E}createConnection(E){return y.createConnection(this.adapterServer.path,E)}}e.NamedPipeDebugAdapter=w;class D extends a{constructor(E,c,r){super();this.adapterExecutable=E,this.debugType=c,this.outputService=r}async startSession(){const E=this.adapterExecutable.command,c=this.adapterExecutable.args,r=this.adapterExecutable.options||{};try{if(E)if(A.isAbsolute(E)){if(!await p.Promises.exists(E))throw new Error(C.localize(0,null,E))}else E.indexOf("/")<0&&E.indexOf("\\")<0;else throw new Error(C.localize(1,null,this.debugType));let v=process.env;if(r.env&&Object.keys(r.env).length>0&&(v=S.mixin(S.deepClone(process.env),r.env)),E==="node")if(Array.isArray(c)&&c.length>0){const h=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:v,execArgv:h?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};r.cwd&&(s.cwd=r.cwd);const n=F.fork(c[0],c.slice(1),s);if(!n.pid)throw new Error(C.localize(2,null,c[0]));this.serverProcess=n}else throw new Error(C.localize(3,null));else{const h={env:v};r.cwd&&(h.cwd=r.cwd),this.serverProcess=F.spawn(E,c,h)}this.serverProcess.on("error",h=>{this._onError.fire(h)}),this.serverProcess.on("exit",(h,s)=>{this._onExit.fire(h)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",h=>{this._onError.fire(h)}),this.serverProcess.stdin.on("error",h=>{this._onError.fire(h)});const t=this.outputService;if(t){const h=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{const n=t.getChannel(i.ExtensionsChannelId);n&&n.append(h(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(v){this._onError.fire(v)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),I.isWindows?new Promise((E,c)=>{const r=F.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(v,t,h){if(v)return c(v)});r.on("exit",E),r.on("error",c)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(E,c){if(!E)return;const r=Object.create(null);E.runtime&&(E.runtime.indexOf("./")===0?r.runtime=A.join(c,E.runtime):r.runtime=E.runtime),E.runtimeArgs&&(r.runtimeArgs=E.runtimeArgs),E.program&&(A.isAbsolute(E.program)?r.program=E.program:r.program=A.join(c,E.program)),E.args&&(r.args=E.args);const v=E;return v.win&&(r.win=D.extract(v.win,c)),v.winx86&&(r.winx86=D.extract(v.winx86,c)),v.windows&&(r.windows=D.extract(v.windows,c)),v.osx&&(r.osx=D.extract(v.osx,c)),v.linux&&(r.linux=D.extract(v.linux,c)),r}static platformAdapterExecutable(E,c){let r=Object.create(null);c=c.toLowerCase();for(const u of E)if(u.contributes){const o=u.contributes.debuggers;o&&o.length>0&&o.filter(l=>typeof l.type=="string"&&_.equalsIgnoreCase(l.type,c)).forEach(l=>{const m=D.extract(l,u.extensionLocation.fsPath);r=S.mixin(r,m,u.isBuiltin)})}let v;I.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?v=r.winx86||r.win||r.windows:I.isWindows?v=r.win||r.windows:I.isMacintosh?v=r.osx:I.isLinux&&(v=r.linux),v=v||r;let t=v.program||r.program;const h=v.args||r.args;let s=v.runtime||r.runtime;const n=v.runtimeArgs||r.runtimeArgs;if(s)return{type:"executable",command:s,args:(n||[]).concat(typeof t=="string"?[t]:[]).concat(h||[])};if(t)return{type:"executable",command:t,args:h||[]}}}e.ExecutableDebugAdapter=D}),define(fe[213],me([0,1,39,11,29,189]),function(Y,e,p,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function A(a,g){return new Promise((d,w)=>{let D="";const T=p.spawn(a,g);T.pid&&T.stdout.on("data",E=>{D+=E.toString()}),T.on("error",E=>{w(E)}),T.on("close",E=>{d(D)})})}let _;function S(a,g){if(!_)if(F.isWindows)_=new y.WindowsExternalTerminalService;else if(F.isMacintosh)_=new y.MacExternalTerminalService;else if(F.isLinux)_=new y.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const d=g.getConfiguration("terminal");return _.runInTerminal(a.title,a.cwd,a.args,a.env||{},d.external||{})}e.runInExternalTerminal=S;async function I(a){if(a)if(F.isWindows){const g=await new Promise((d,w)=>{Y(["windows-process-tree"],d,w)});return new Promise(d=>{g.getProcessTree(a,w=>{d(w.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(a)]).then(g=>{const d=g.trim();return!(d.length===0||d.indexOf(" tmux")>=0)},g=>!0);return Promise.resolve(!0)}e.hasChildProcesses=I;var i;(function(a){a[a.cmd=0]="cmd",a[a.powershell=1]="powershell",a[a.bash=2]="bash"})(i||(i={}));function k(a,g,d,w){a=a.trim().toLowerCase();let D;a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0?D=1:a.indexOf("cmd.exe")>=0?D=0:a.indexOf("bash")>=0?D=2:F.isWindows?D=0:D=2;let T,E=" ";switch(D){case 1:if(T=r=>(r=r.replace(/\'/g,"''"),r.length>0&&r.charAt(r.length-1)==="\\"?`'${r}\\'`:`'${r}'`),d){const r=(0,C.getDriveLetter)(d);r&&(E+=`${r}:; `),E+=`cd ${T(d)}; `}if(w)for(let r in w){const v=w[r];v===null?E+=`Remove-Item env:${r}; `:E+=`\${env:${r}}='${v}'; `}if(g.length>0){const r=T(g.shift());E+=r[0]==="'"?`& ${r} `:`${r} `;for(let v of g)E+=`${T(v)} `}break;case 0:if(T=r=>(r=r.replace(/\"/g,'""'),r.indexOf(" ")>=0||r.indexOf('"')>=0||r.length===0?`"${r}"`:r),d){const r=(0,C.getDriveLetter)(d);r&&(E+=`${r}: && `),E+=`cd ${T(d)} && `}if(w){E+='cmd /C "';for(let r in w){let v=w[r];v===null?E+=`set "${r}=" && `:(v=v.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),E+=`set "${r}=${v}" && `)}}for(let r of g)E+=`${T(r)} `;w&&(E+='"');break;case 2:T=r=>(r=r.replace(/(["'\\\$])/g,"\\$1"),r.indexOf(" ")>=0||r.indexOf(";")>=0||r.length===0?`"${r}"`:r);const c=r=>/[^\w@%\/+=,.:^-]/.test(r)?`'${r.replace(/'/g,"'\\''")}'`:r;if(d&&(E+=`cd ${T(d)} ; `),w){E+="/usr/bin/env";for(let r in w){const v=w[r];v===null?E+=` -u ${c(r)}`:E+=` ${c(`${r}=${v}`)}`}E+=" "}for(let r of g)E+=`${T(r)} `;break}return E}e.prepareCommand=k}),define(fe[128],me([0,1,30,103,10,8,11,63]),function(Y,e,p,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var S;(function(f){f[f.Markup=1]="Markup",f[f.Code=2]="Code"})(S=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",F.Mimes.latex,F.Mimes.markdown,"image/png","image/jpeg",F.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[F.Mimes.latex,F.Mimes.markdown,"application/json",F.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var I;(function(f){f[f.Running=1]="Running",f[f.Idle=2]="Idle"})(I=e.NotebookRunState||(e.NotebookRunState={}));var i;(function(f){f[f.Pending=2]="Pending",f[f.Executing=3]="Executing"})(i=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var k;(function(f){f[f.WithHardKernelDependency=0]="WithHardKernelDependency",f[f.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",f[f.Pure=2]="Pure",f[f.Never=3]="Never"})(k=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var a;(function(f){f.Always="always",f.Never="never",f.Optional="optional"})(a=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var g;(function(f){f[f.ModelChange=1]="ModelChange",f[f.Move=2]="Move",f[f.ChangeLanguage=5]="ChangeLanguage",f[f.Initialize=6]="Initialize",f[f.ChangeCellMetadata=7]="ChangeCellMetadata",f[f.Output=8]="Output",f[f.OutputItem=9]="OutputItem",f[f.ChangeCellContent=10]="ChangeCellContent",f[f.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",f[f.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",f[f.ChangeCellMime=13]="ChangeCellMime",f[f.Unknown=100]="Unknown"})(g=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(f){f[f.Handle=0]="Handle",f[f.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var w;(function(f){f[f.Replace=1]="Replace",f[f.Output=2]="Output",f[f.Metadata=3]="Metadata",f[f.CellLanguage=4]="CellLanguage",f[f.DocumentMetadata=5]="DocumentMetadata",f[f.Move=6]="Move",f[f.OutputItems=7]="OutputItems",f[f.PartialMetadata=8]="PartialMetadata",f[f.PartialInternalMetadata=9]="PartialInternalMetadata"})(w=e.CellEditType||(e.CellEditType={}));var D;(function(f){f.scheme=C.Schemas.vscodeNotebookCell;const P=/^ch(\d{7,})/;function L(N,j){return N.with({scheme:f.scheme,fragment:`ch${j.toString().padStart(7,"0")}${N.scheme!==C.Schemas.file?N.scheme:""}`})}f.generate=L;function M(N){if(N.scheme!==f.scheme)return;const j=P.exec(N.fragment);return j?{handle:Number(j[1]),notebook:N.with({scheme:N.fragment.substr(j[0].length)||C.Schemas.file,fragment:null})}:void 0}f.parse=M;function R(N){if(N.scheme!==C.Schemas.vscodeNotebookCellMetadata)return;const j=P.exec(N.fragment);return j?{handle:Number(j[1]),notebook:N.with({scheme:N.fragment.substr(j[0].length)||C.Schemas.file,fragment:null})}:void 0}f.parseCellMetadataUri=R;function W(N,j,U){return N.with({scheme:U,fragment:`ch${j.toString().padStart(7,"0")}${N.scheme!==C.Schemas.file?N.scheme:""}`})}f.generateCellUri=W;function V(N,j){if(N.scheme!==j)return;const U=P.exec(N.fragment);return U?{handle:Number(U[1]),notebook:N.with({scheme:N.fragment.substr(U[0].length)||C.Schemas.file,fragment:null})}:void 0}f.parseCellUri=V})(D=e.CellUri||(e.CellUri={}));const T=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function E(f){return T.get(f)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=E;function c(f){return T.get(f)?.supportedByCore??!1}e.mimeTypeSupportedByCore=c;function r(f){return T.get(f)?.mergeable??!1}e.mimeTypeIsMergeable=r;function v(f,P){return A.isWindows&&(f=f.replace(/\//g,"\\"),P=P.replace(/\//g,"\\")),p.match(f,P)}function t(f,P,L){let M=0;for(let R=0;R<P.length;R++){if(v(P[R],f))return M;M++}for(let R=0;R<L.length;R++){if(v(L[R],f))return M;M++}return M}function h(f,P,L){return f.sort((M,R)=>t(M,P,L)-t(R,P,L))}e.sortMimeTypes=h;function s(f,P,L,M=(R,W)=>R===W){const R=[];function W(j,U,B){if(U===0&&B.length===0)return;const z=R[R.length-1];z&&z.start+z.deleteCount===j?(z.deleteCount+=U,z.toInsert.push(...B)):R.push({start:j,deleteCount:U,toInsert:B})}let V=0,N=0;for(;;){if(V===f.length){W(V,0,P.slice(N));break}if(N===P.length){W(V,f.length-V,[]);break}const j=f[V],U=P[N];if(M(j,U)){V+=1,N+=1;continue}L(U)?(W(V,1,[]),V+=1):(W(V,0,[U]),N+=1)}return R}e.diff=s,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new _.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(f){f.default="default",f.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(f){const P=f;return!!((typeof P.include=="string"||p.isRelativePattern(P.include))&&(typeof P.exclude=="string"||p.isRelativePattern(P.exclude)))}e.isDocumentExcludePattern=u;function o(f,P,L){if(Array.isArray(f.viewType)&&f.viewType.indexOf(P)>=0||f.viewType===P)return!0;if(f.filenamePattern){let M=u(f.filenamePattern)?f.filenamePattern.include:f.filenamePattern,R=u(f.filenamePattern)?f.filenamePattern.exclude:void 0;if(p.match(M,(0,y.basename)(L.fsPath).toLowerCase()))return!(R&&p.match(R,(0,y.basename)(L.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o;class l{constructor(P){this.textModel=P}getElements(){const P=new Int32Array(this.textModel.cells.length);for(let L=0;L<this.textModel.cells.length;L++)P[L]=this.textModel.cells[L].getHashValue();return P}}e.CellSequence=l,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var m;(function(f){f[f.Left=1]="Left",f[f.Right=2]="Right"})(m=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class b{static create(P){return`${b._prefix}${P}`}static parse(P){if(P.startsWith(b._prefix))return P.substr(b._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=b,b._prefix="notebook/"}),define(fe[214],me([0,1,4]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var F;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState",C[C.Complete=4]="Complete"})(F=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,p.createDecorator)("INotebookExecutionService")}),define(fe[215],me([0,1,179,4,63]),function(Y,e,p,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new C.RawContextKey("customExecutionSupported",!0,p.localize(0,null)),e.ShellExecutionSupportedContext=new C.RawContextKey("shellExecutionSupported",!1,p.localize(1,null)),e.ProcessExecutionSupportedContext=new C.RawContextKey("processExecutionSupported",!1,p.localize(2,null)),e.ITaskService=(0,F.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(fe[216],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function p(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=p;function F(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=F}),define(fe[129],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var p;(function(k){k[k.Unset=0]="Unset",k[k.Queued=1]="Queued",k[k.Running=2]="Running",k[k.Passed=3]="Passed",k[k.Failed=4]="Failed",k[k.Skipped=5]="Skipped",k[k.Errored=6]="Errored"})(p=e.TestResultState||(e.TestResultState={}));var F;(function(k){k[k.Run=2]="Run",k[k.Debug=4]="Debug",k[k.Coverage=8]="Coverage",k[k.HasNonDefaultProfile=16]="HasNonDefaultProfile",k[k.HasConfigurable=32]="HasConfigurable"})(F=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var C;(function(k){k[k.Error=0]="Error",k[k.Info=1]="Info"})(C=e.TestMessageType||(e.TestMessageType={}));var y;(function(k){k[k.NotExpandable=0]="NotExpandable",k[k.Expandable=1]="Expandable",k[k.BusyExpanding=2]="BusyExpanding",k[k.Expanded=3]="Expanded"})(y=e.TestItemExpandState||(e.TestItemExpandState={}));const A=(k,a)=>{a.expand!==void 0&&(k.expand=a.expand),a.item!==void 0&&(k.item=k.item?Object.assign(k.item,a.item):a.item)};e.applyTestItemUpdate=A;var _;(function(k){k[k.Function=0]="Function",k[k.Statement=1]="Statement"})(_=e.DetailType||(e.DetailType={}));var S;(function(k){k[k.Add=0]="Add",k[k.Update=1]="Update",k[k.Remove=2]="Remove",k[k.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",k[k.Retire=4]="Retire",k[k.AddTag=5]="AddTag",k[k.RemoveTag=6]="RemoveTag"})(S=e.TestDiffOpType||(e.TestDiffOpType={}));class I{add(a){}update(a){}remove(a,g){}complete(){}}e.IncrementalChangeCollector=I;class i{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(a){const g=this.createChangeCollector();for(const d of a)switch(d[0]){case 0:{const w=d[1];if(w.parent){if(this.items.has(w.parent)){const D=this.items.get(w.parent);D.children.add(w.item.extId);const T=this.createItem(w,D);this.items.set(w.item.extId,T),g.add(T)}}else{const D=this.createItem(w);this.roots.add(D),this.items.set(w.item.extId,D),g.add(D)}w.expand===2&&this.busyControllerCount++;break}case 1:{const w=d[1],D=this.items.get(w.extId);if(!D)break;w.expand!==void 0&&(D.expand===2&&this.busyControllerCount--,w.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(D,w),g.update(D);break}case 2:{const w=this.items.get(d[1]);if(!w)break;w.parent?this.items.get(w.parent).children.delete(w.item.extId):this.roots.delete(w);const D=[[d[1]]];for(;D.length;)for(const T of D.pop()){const E=this.items.get(T);E&&(D.push(E.children),this.items.delete(T),g.remove(E,E!==w),E.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(d[1]);break;case 3:this.updatePendingRoots(d[1]);break;case 5:this._tags.set(d[1].id,d[1]);break;case 6:this._tags.delete(d[1]);break}g.complete()}retireTest(a){}updatePendingRoots(a){this.pendingRootCount+=a}createChangeCollector(){return new I}}e.AbstractIncrementalTestCollection=i}),define(fe[89],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var p;(function(y){y.Delimiter="\0"})(p=e.TestIdPathParts||(e.TestIdPathParts={}));var F;(function(y){y[y.IsSame=0]="IsSame",y[y.Disconnected=1]="Disconnected",y[y.IsChild=2]="IsChild",y[y.IsParent=3]="IsParent"})(F=e.TestPosition||(e.TestPosition={}));class C{constructor(A,_=A.length){if(this.path=A,this.viewEnd=_,A.length===0||_<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(A,_,S=A.parent){if(A.id===_)return new C([_]);let I=[A.id];for(let i=S;i&&i.id!==_;i=i.parent)I.push(i.id);return I.push(_),new C(I.reverse())}static isRoot(A){return!A.includes("\0")}static fromString(A){return new C(A.split("\0"))}static join(A,_){return new C([...A.path,_])}static joinToString(A,_){return A.toString()+"\0"+_}static compare(A,_){return A===_?0:_.startsWith(A+"\0")?2:A.startsWith(_+"\0")?3:1}get parentId(){return this.viewEnd>1?new C(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let A=1;A<=this.viewEnd;A++)yield new C(this.path,A)}compare(A){if(typeof A=="string")return C.compare(this.toString(),A);for(let _=0;_<A.viewEnd&&_<this.viewEnd;_++)if(A.path[_]!==this.path[_])return 1;return A.viewEnd>this.viewEnd?2:A.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let A=1;A<this.viewEnd;A++)this.stringifed+="\0",this.stringifed+=this.path[A]}return this.stringifed}}e.TestId=C}),define(fe[217],me([0,1,8,38,12,25,11,80,180]),function(Y,e,p,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{constructor(k,a,g){this._contributedVariables=new Map,this._context=k,this._labelService=a,g&&(this._envVariablesPromise=g.then(d=>this.prepareEnv(d)))}prepareEnv(k){if(A.isWindows){const a=Object.create(null);return Object.keys(k).forEach(g=>{a[g.toLowerCase()]=k[g]}),a}return k}resolveWithEnvironment(k,a,g){return this.recursiveResolve(this.prepareEnv(k),a?a.uri:void 0,g)}async resolveAsync(k,a){return this.recursiveResolve(await this._envVariablesPromise,k?k.uri:void 0,a)}async resolveAnyBase(k,a,g,d){const w=y.deepClone(a);return A.isWindows&&w.windows?Object.keys(w.windows).forEach(D=>w[D]=w.windows[D]):A.isMacintosh&&w.osx?Object.keys(w.osx).forEach(D=>w[D]=w.osx[D]):A.isLinux&&w.linux&&Object.keys(w.linux).forEach(D=>w[D]=w.linux[D]),delete w.windows,delete w.osx,delete w.linux,this.recursiveResolve(await this._envVariablesPromise,k?k.uri:void 0,w,g,d)}async resolveAnyAsync(k,a,g){return this.resolveAnyBase(k,a,g)}async resolveAnyMap(k,a,g){const d=new Map;return{newConfig:await this.resolveAnyBase(k,a,g,d),resolvedVariables:d}}resolveWithInteractionReplace(k,a,g,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,a,g,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,a){if(this._contributedVariables.has(k))throw new Error("Variable "+k+" is contributed twice.");this._contributedVariables.set(k,a)}recursiveResolve(k,a,g,d,w){if(C.isString(g))return this.resolveString(k,a,g,d,w);if(C.isArray(g))return g.map(D=>this.recursiveResolve(k,a,D,d,w));if(C.isObject(g)){let D=Object.create(null);return Object.keys(g).forEach(T=>{const E=this.resolveString(k,a,T,d,w);D[E]=this.recursiveResolve(k,a,g[T],d,w)}),D}return g}resolveString(k,a,g,d,w){return g.replace(I.VARIABLE_REGEXP,(T,E)=>{if(E.includes(I.VARIABLE_LHS))return T;let c=this.evaluateSingleVariable(k,T,E,a,d);return w&&w.set(E,c),c!==T&&C.isString(c)&&c.match(I.VARIABLE_REGEXP)&&(c=this.resolveString(k,a,c,d,w)),c})}fsPath(k){return this._labelService?this._labelService.getUriLabel(k,{noPrefix:!0}):k.fsPath}evaluateSingleVariable(k,a,g,d,w){let D;const T=g.split(":");T.length>1&&(g=T[0],D=T[1]);const E=()=>{const v=this._context.getFilePath();if(v)return v;throw new Error((0,S.localize)(0,null,a))},c=()=>{const v=E();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,S.localize)(1,null,a,p.basename(v)))},r=()=>{if(D){const v=this._context.getFolderUri(D);if(v)return v;throw new Error((0,S.localize)(2,null,a,D))}if(d)return d;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,a)):new Error((0,S.localize)(4,null,a))};switch(g){case"env":if(D){if(k){const v=k[A.isWindows?D.toLowerCase():D];if(C.isString(v))return v}return""}throw new Error((0,S.localize)(5,null,a));case"config":if(D){const v=this._context.getConfigurationValue(d,D);if(C.isUndefinedOrNull(v))throw new Error((0,S.localize)(6,null,a,D));if(C.isObject(v))throw new Error((0,S.localize)(7,null,a,D));return v}throw new Error((0,S.localize)(8,null,a));case"command":return this.resolveFromMap(a,D,w,"command");case"input":return this.resolveFromMap(a,D,w,"input");default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,_.normalizeDriveLetter)(this.fsPath(r()));case"cwd":return d||D?(0,_.normalizeDriveLetter)(this.fsPath(r())):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return p.basename(this.fsPath(r()));case"lineNumber":const v=this._context.getLineNumber();if(v)return v;throw new Error((0,S.localize)(9,null,a));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,S.localize)(10,null,a));case"file":return E();case"fileWorkspaceFolder":return c();case"relativeFile":return d||D?p.relative(this.fsPath(r()),E()):E();case"relativeFileDirname":const h=p.dirname(E());if(d||D){const o=p.relative(this.fsPath(r()),h);return o.length===0?".":o}return h;case"fileDirname":return p.dirname(E());case"fileExtname":return p.extname(E());case"fileBasename":return p.basename(E());case"fileBasenameNoExtension":const s=p.basename(E());return s.slice(0,s.length-p.extname(s).length);case"fileDirnameBasename":return p.basename(p.dirname(E()));case"execPath":const n=this._context.getExecPath();return n||a;case"execInstallFolder":const u=this._context.getAppRoot();return u||a;case"pathSeparator":return p.sep;default:try{const o=D?`${g}:${D}`:g;return this.resolveFromMap(a,o,w,void 0)}catch(o){return a}}}}resolveFromMap(k,a,g,d){if(a&&g){const w=d===void 0?g[a]:g[d+":"+a];if(typeof w=="string")return w;throw new Error((0,S.localize)(11,null,k))}return k}}e.AbstractVariableResolverService=I,I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(fe[130],me([0,1,4,209]),function(Y,e,p,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,p.createDecorator)("editorGroupsService");var C;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(C=e.GroupDirection||(e.GroupDirection={}));var y;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(y=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var _;(function(w){w[w.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",w[w.EVEN=1]="EVEN",w[w.TOGGLE=2]="TOGGLE"})(_=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function I(w){const D=w;return(0,F.isEditorInput)(D?.editor)&&(0,F.isEditorInput)(D?.replacement)}e.isEditorReplacement=I;var i;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(i=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(w){w[w.GROUP_ACTIVE=0]="GROUP_ACTIVE",w[w.GROUP_INDEX=1]="GROUP_INDEX",w[w.GROUP_LOCKED=2]="GROUP_LOCKED",w[w.EDITOR_OPEN=3]="EDITOR_OPEN",w[w.EDITOR_CLOSE=4]="EDITOR_CLOSE",w[w.EDITOR_MOVE=5]="EDITOR_MOVE",w[w.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",w[w.EDITOR_LABEL=7]="EDITOR_LABEL",w[w.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",w[w.EDITOR_PIN=9]="EDITOR_PIN",w[w.EDITOR_STICKY=10]="EDITOR_STICKY",w[w.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(k=e.GroupChangeKind||(e.GroupChangeKind={}));var a;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(a=e.OpenEditorContext||(e.OpenEditorContext={}));function g(w){const D=w;return!!D&&typeof D.id=="number"&&Array.isArray(D.editors)}e.isEditorGroup=g;function d(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=d}),define(fe[218],me([0,1,4,130]),function(Y,e,p,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,p.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function C(y){const A=y;return typeof y=="number"||(0,F.isEditorGroup)(A)}e.isPreferredGroup=C}),define(fe[16],me([0,1,18,22,100,293,62,25,12,2,42,84,181,118,66,128,89,218,7]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d,w,D,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var c;(function(ge){function Ee(K){const{selectionStartLineNumber:Se,selectionStartColumn:Le,positionLineNumber:it,positionColumn:Ge}=K,pt=new E.Position(Se-1,Le-1),Et=new E.Position(it-1,Ge-1);return new E.Selection(pt,Et)}ge.to=Ee;function ne(K){const{anchor:Se,active:Le}=K;return{selectionStartLineNumber:Se.line+1,selectionStartColumn:Se.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}ge.from=ne})(c=e.Selection||(e.Selection={}));var r;(function(ge){function Ee(K){if(!K)return;const{start:Se,end:Le}=K;return{startLineNumber:Se.line+1,startColumn:Se.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}ge.from=Ee;function ne(K){if(!K)return;const{startLineNumber:Se,startColumn:Le,endLineNumber:it,endColumn:Ge}=K;return new E.Range(Se-1,Le-1,it-1,Ge-1)}ge.to=ne})(r=e.Range||(e.Range={}));var v;(function(ge){function Ee(ne){switch(ne){case 1:return E.StandardTokenType.Comment;case 0:return E.StandardTokenType.Other;case 4:return E.StandardTokenType.RegEx;case 2:return E.StandardTokenType.String}}ge.to=Ee})(v=e.TokenType||(e.TokenType={}));var t;(function(ge){function Ee(K){return new E.Position(K.lineNumber-1,K.column-1)}ge.to=Ee;function ne(K){return{lineNumber:K.line+1,column:K.character+1}}ge.from=ne})(t=e.Position||(e.Position={}));var h;(function(ge){function Ee(Se,Le){return(0,p.coalesce)((0,p.asArray)(Se).map(it=>ne(it,Le)))}ge.from=Ee;function ne(Se,Le){if(typeof Se=="string")return{$serialized:!0,language:Se};if(Se)return{$serialized:!0,language:Se.language,scheme:K(Se.scheme,Le),pattern:typeof Se.pattern=="undefined"?void 0:ce.from(Se.pattern),exclusive:Se.exclusive}}function K(Se,Le){return Le&&typeof Se=="string"?Le.transformOutgoingScheme(Se):Se}})(h=e.DocumentSelector||(e.DocumentSelector={}));var s;(function(ge){function Ee(K){switch(K){case E.DiagnosticTag.Unnecessary:return 1;case E.DiagnosticTag.Deprecated:return 2}}ge.from=Ee;function ne(K){switch(K){case 1:return E.DiagnosticTag.Unnecessary;case 2:return E.DiagnosticTag.Deprecated;default:return}}ge.to=ne})(s=e.DiagnosticTag||(e.DiagnosticTag={}));var n;(function(ge){function Ee(K){let Se;return K.code&&((0,S.isString)(K.code)||(0,S.isNumber)(K.code)?Se=String(K.code):Se={value:String(K.code.value),target:K.code.target}),{...r.from(K.range),message:K.message,source:K.source,code:Se,severity:o.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(u.from),tags:Array.isArray(K.tags)?(0,p.coalesce)(K.tags.map(s.from)):void 0}}ge.from=Ee;function ne(K){const Se=new E.Diagnostic(r.to(K),K.message,o.to(K.severity));return Se.source=K.source,Se.code=(0,S.isString)(K.code)?K.code:K.code?.value,Se.relatedInformation=K.relatedInformation&&K.relatedInformation.map(u.to),Se.tags=K.tags&&(0,p.coalesce)(K.tags.map(s.to)),Se}ge.to=ne})(n=e.Diagnostic||(e.Diagnostic={}));var u;(function(ge){function Ee(K){return{...r.from(K.location.range),message:K.message,resource:K.location.uri}}ge.from=Ee;function ne(K){return new E.DiagnosticRelatedInformation(new E.Location(K.resource,r.to(K)),K.message)}ge.to=ne})(u=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var o;(function(ge){function Ee(K){switch(K){case E.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case E.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case E.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case E.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}ge.from=Ee;function ne(K){switch(K){case g.MarkerSeverity.Info:return E.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return E.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return E.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return E.DiagnosticSeverity.Hint;default:return E.DiagnosticSeverity.Error}}ge.to=ne})(o=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var l;(function(ge){function Ee(K){return typeof K=="number"&&K>=E.ViewColumn.One?K-1:K===E.ViewColumn.Beside?T.SIDE_GROUP:T.ACTIVE_GROUP}ge.from=Ee;function ne(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}ge.to=ne})(l=e.ViewColumn||(e.ViewColumn={}));function m(ge){return typeof ge.range!="undefined"}function b(ge){return ge.length===0?!0:!!m(ge[0])}e.isDecorationOptionsArr=b;var f;(function(ge){function Ee(Ge){return Ge.map(ge.from)}ge.fromMany=Ee;function ne(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function K(Ge){let pt;if(ne(Ge)){const{language:mt,value:_t}=Ge;pt={value:"```"+mt+`
`+_t+"\n```\n"}}else E.MarkdownString.isMarkdownString(Ge)?pt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml}:typeof Ge=="string"?pt={value:Ge}:pt={value:""};const Et=Object.create(null);pt.uris=Et;const ft=mt=>{try{let _t=I.URI.parse(mt,!0);_t=_t.with({query:Se(_t.query,Et)}),Et[mt]=_t}catch(_t){}return""},bt=new y.Renderer;return bt.link=ft,bt.image=mt=>ft(C.parseHrefAndDimensions(mt).href),y(pt.value,{renderer:bt}),pt}ge.from=K;function Se(Ge,pt){if(!Ge)return Ge;let Et;try{Et=(0,A.parse)(Ge)}catch(bt){}if(!Et)return Ge;let ft=!1;return Et=(0,_.cloneAndChange)(Et,bt=>{if(I.URI.isUri(bt)){const mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return pt[mt]=bt,ft=!0,mt}else return}),ft?JSON.stringify(Et):Ge}function Le(Ge){const pt=new E.MarkdownString(Ge.value,Ge.supportThemeIcons);return pt.isTrusted=Ge.isTrusted,pt.supportHtml=Ge.supportHtml,pt}ge.to=Le;function it(Ge){if(!!Ge)return typeof Ge=="string"?Ge:ge.from(Ge)}ge.fromStrict=it})(f=e.MarkdownString||(e.MarkdownString={}));function P(ge){return b(ge)?ge.map(Ee=>({range:r.from(Ee.range),hoverMessage:Array.isArray(Ee.hoverMessage)?f.fromMany(Ee.hoverMessage):Ee.hoverMessage?f.from(Ee.hoverMessage):void 0,renderOptions:Ee.renderOptions})):ge.map(Ee=>({range:r.from(Ee)}))}e.fromRangeOrRangeWithMessage=P;function L(ge){return typeof ge=="undefined"?ge:typeof ge=="string"?I.URI.file(ge):ge}e.pathOrURIToURI=L;var M;(function(ge){function Ee(ne){return typeof ne=="undefined"?ne:{contentText:ne.contentText,contentIconPath:ne.contentIconPath?L(ne.contentIconPath):void 0,border:ne.border,borderColor:ne.borderColor,fontStyle:ne.fontStyle,fontWeight:ne.fontWeight,textDecoration:ne.textDecoration,color:ne.color,backgroundColor:ne.backgroundColor,margin:ne.margin,width:ne.width,height:ne.height}}ge.from=Ee})(M=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var R;(function(ge){function Ee(ne){return typeof ne=="undefined"?ne:{backgroundColor:ne.backgroundColor,outline:ne.outline,outlineColor:ne.outlineColor,outlineStyle:ne.outlineStyle,outlineWidth:ne.outlineWidth,border:ne.border,borderColor:ne.borderColor,borderRadius:ne.borderRadius,borderSpacing:ne.borderSpacing,borderStyle:ne.borderStyle,borderWidth:ne.borderWidth,fontStyle:ne.fontStyle,fontWeight:ne.fontWeight,textDecoration:ne.textDecoration,cursor:ne.cursor,color:ne.color,opacity:ne.opacity,letterSpacing:ne.letterSpacing,gutterIconPath:ne.gutterIconPath?L(ne.gutterIconPath):void 0,gutterIconSize:ne.gutterIconSize,overviewRulerColor:ne.overviewRulerColor,before:ne.before?M.from(ne.before):void 0,after:ne.after?M.from(ne.after):void 0}}ge.from=Ee})(R=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var W;(function(ge){function Ee(ne){if(typeof ne=="undefined")return ne;switch(ne){case E.DecorationRangeBehavior.OpenOpen:return 0;case E.DecorationRangeBehavior.ClosedClosed:return 1;case E.DecorationRangeBehavior.OpenClosed:return 2;case E.DecorationRangeBehavior.ClosedOpen:return 3}}ge.from=Ee})(W=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var V;(function(ge){function Ee(ne){return{isWholeLine:ne.isWholeLine,rangeBehavior:ne.rangeBehavior?W.from(ne.rangeBehavior):void 0,overviewRulerLane:ne.overviewRulerLane,light:ne.light?R.from(ne.light):void 0,dark:ne.dark?R.from(ne.dark):void 0,backgroundColor:ne.backgroundColor,outline:ne.outline,outlineColor:ne.outlineColor,outlineStyle:ne.outlineStyle,outlineWidth:ne.outlineWidth,border:ne.border,borderColor:ne.borderColor,borderRadius:ne.borderRadius,borderSpacing:ne.borderSpacing,borderStyle:ne.borderStyle,borderWidth:ne.borderWidth,fontStyle:ne.fontStyle,fontWeight:ne.fontWeight,textDecoration:ne.textDecoration,cursor:ne.cursor,color:ne.color,opacity:ne.opacity,letterSpacing:ne.letterSpacing,gutterIconPath:ne.gutterIconPath?L(ne.gutterIconPath):void 0,gutterIconSize:ne.gutterIconSize,overviewRulerColor:ne.overviewRulerColor,before:ne.before?M.from(ne.before):void 0,after:ne.after?M.from(ne.after):void 0}}ge.from=Ee})(V=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var N;(function(ge){function Ee(K){return{text:K.newText,eol:K.newEol&&te.from(K.newEol),range:r.from(K.range)}}ge.from=Ee;function ne(K){const Se=new E.TextEdit(r.to(K.range),K.text);return Se.newEol=typeof K.eol=="undefined"?void 0:te.to(K.eol),Se}ge.to=ne})(N=e.TextEdit||(e.TextEdit={}));var j;(function(ge){function Ee(K,Se,Le){const it={edits:[]};if(K instanceof E.WorkspaceEdit)for(let Ge of K._allEntries())if(Ge._type===1)it.edits.push({_type:1,oldUri:Ge.from,newUri:Ge.to,options:Ge.options,metadata:Ge.metadata});else if(Ge._type===2){const pt=Se?.getDocument(Ge.uri);it.edits.push({_type:2,resource:Ge.uri,edit:N.from(Ge.edit),modelVersionId:pt?.version,metadata:Ge.metadata})}else Ge._type===3?it.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Le?.getNotebookDocument(Ge.uri,!0)?.apiNotebook.version}):Ge._type===5&&it.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Le?.getNotebookDocument(Ge.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(Ye.from)}});return it}ge.from=Ee;function ne(K){const Se=new E.WorkspaceEdit;for(const Le of K.edits)Le.edit?Se.replace(I.URI.revive(Le.resource),r.to(Le.edit.range),Le.edit.text):Se.renameFile(I.URI.revive(Le.oldUri),I.URI.revive(Le.newUri),Le.options);return Se}ge.to=ne})(j=e.WorkspaceEdit||(e.WorkspaceEdit={}));var U;(function(ge){const Ee=Object.create(null);Ee[E.SymbolKind.File]=0,Ee[E.SymbolKind.Module]=1,Ee[E.SymbolKind.Namespace]=2,Ee[E.SymbolKind.Package]=3,Ee[E.SymbolKind.Class]=4,Ee[E.SymbolKind.Method]=5,Ee[E.SymbolKind.Property]=6,Ee[E.SymbolKind.Field]=7,Ee[E.SymbolKind.Constructor]=8,Ee[E.SymbolKind.Enum]=9,Ee[E.SymbolKind.Interface]=10,Ee[E.SymbolKind.Function]=11,Ee[E.SymbolKind.Variable]=12,Ee[E.SymbolKind.Constant]=13,Ee[E.SymbolKind.String]=14,Ee[E.SymbolKind.Number]=15,Ee[E.SymbolKind.Boolean]=16,Ee[E.SymbolKind.Array]=17,Ee[E.SymbolKind.Object]=18,Ee[E.SymbolKind.Key]=19,Ee[E.SymbolKind.Null]=20,Ee[E.SymbolKind.EnumMember]=21,Ee[E.SymbolKind.Struct]=22,Ee[E.SymbolKind.Event]=23,Ee[E.SymbolKind.Operator]=24,Ee[E.SymbolKind.TypeParameter]=25;function ne(Se){return typeof Ee[Se]=="number"?Ee[Se]:6}ge.from=ne;function K(Se){for(const Le in Ee)if(Ee[Le]===Se)return Number(Le);return E.SymbolKind.Property}ge.to=K})(U=e.SymbolKind||(e.SymbolKind={}));var B;(function(ge){function Ee(K){switch(K){case E.SymbolTag.Deprecated:return 1}}ge.from=Ee;function ne(K){switch(K){case 1:return E.SymbolTag.Deprecated}}ge.to=ne})(B=e.SymbolTag||(e.SymbolTag={}));var z;(function(ge){function Ee(K){return{name:K.name,kind:U.from(K.kind),tags:K.tags&&K.tags.map(B.from),containerName:K.containerName,location:Q.from(K.location)}}ge.from=Ee;function ne(K){const Se=new E.SymbolInformation(K.name,U.to(K.kind),K.containerName,Q.to(K.location));return Se.tags=K.tags&&K.tags.map(B.to),Se}ge.to=ne})(z=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var O;(function(ge){function Ee(K){const Se={name:K.name||"!!MISSING: name!!",detail:K.detail,range:r.from(K.range),selectionRange:r.from(K.selectionRange),kind:U.from(K.kind),tags:K.tags?.map(B.from)??[]};return K.children&&(Se.children=K.children.map(Ee)),Se}ge.from=Ee;function ne(K){const Se=new E.DocumentSymbol(K.name,K.detail,U.to(K.kind),r.to(K.range),r.to(K.selectionRange));return(0,p.isNonEmptyArray)(K.tags)&&(Se.tags=K.tags.map(B.to)),K.children&&(Se.children=K.children.map(ne)),Se}ge.to=ne})(O=e.DocumentSymbol||(e.DocumentSymbol={}));var $;(function(ge){function Ee(K){const Se=new E.CallHierarchyItem(U.to(K.kind),K.name,K.detail||"",I.URI.revive(K.uri),r.to(K.range),r.to(K.selectionRange));return Se._sessionId=K._sessionId,Se._itemId=K._itemId,Se}ge.to=Ee;function ne(K,Se,Le){if(Se=Se??K._sessionId,Le=Le??K._itemId,Se===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Le,name:K.name,detail:K.detail,kind:U.from(K.kind),uri:K.uri,range:r.from(K.range),selectionRange:r.from(K.selectionRange),tags:K.tags?.map(B.from)}}ge.from=ne})($=e.CallHierarchyItem||(e.CallHierarchyItem={}));var x;(function(ge){function Ee(ne){return new E.CallHierarchyIncomingCall($.to(ne.from),ne.fromRanges.map(K=>r.to(K)))}ge.to=Ee})(x=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var X;(function(ge){function Ee(ne){return new E.CallHierarchyOutgoingCall($.to(ne.to),ne.fromRanges.map(K=>r.to(K)))}ge.to=Ee})(X=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Q;(function(ge){function Ee(K){return{range:K.range&&r.from(K.range),uri:K.uri}}ge.from=Ee;function ne(K){return new E.Location(I.URI.revive(K.uri),r.to(K.range))}ge.to=ne})(Q=e.location||(e.location={}));var de;(function(ge){function Ee(K){const Se=K,Le=K;return{originSelectionRange:Se.originSelectionRange?r.from(Se.originSelectionRange):void 0,uri:Se.targetUri?Se.targetUri:Le.uri,range:r.from(Se.targetRange?Se.targetRange:Le.range),targetSelectionRange:Se.targetSelectionRange?r.from(Se.targetSelectionRange):void 0}}ge.from=Ee;function ne(K){return{targetUri:I.URI.revive(K.uri),targetRange:r.to(K.range),targetSelectionRange:K.targetSelectionRange?r.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?r.to(K.originSelectionRange):void 0}}ge.to=ne})(de=e.DefinitionLink||(e.DefinitionLink={}));var _e;(function(ge){function Ee(K){return{range:r.from(K.range),contents:f.fromMany(K.contents)}}ge.from=Ee;function ne(K){return new E.Hover(K.contents.map(f.to),r.to(K.range))}ge.to=ne})(_e=e.Hover||(e.Hover={}));var ye;(function(ge){function Ee(K){return{range:r.from(K.range),expression:K.expression}}ge.from=Ee;function ne(K){return new E.EvaluatableExpression(r.to(K.range),K.expression)}ge.to=ne})(ye=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ke;(function(ge){function Ee(K){if(K instanceof E.InlineValueText)return{type:"text",range:r.from(K.range),text:K.text};if(K instanceof E.InlineValueVariableLookup)return{type:"variable",range:r.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof E.InlineValueEvaluatableExpression)return{type:"expression",range:r.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}ge.from=Ee;function ne(K){switch(K.type){case"text":return{range:r.to(K.range),text:K.text};case"variable":return{range:r.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:r.to(K.range),expression:K.expression}}}ge.to=ne})(ke=e.InlineValue||(e.InlineValue={}));var xe;(function(ge){function Ee(K){return{frameId:K.frameId,stoppedLocation:r.from(K.stoppedLocation)}}ge.from=Ee;function ne(K){return new E.InlineValueContext(K.frameId,r.to(K.stoppedLocation))}ge.to=ne})(xe=e.InlineValueContext||(e.InlineValueContext={}));var We;(function(ge){function Ee(K){return{range:r.from(K.range),kind:K.kind}}ge.from=Ee;function ne(K){return new E.DocumentHighlight(r.to(K.range),K.kind)}ge.to=ne})(We=e.DocumentHighlight||(e.DocumentHighlight={}));var He;(function(ge){function Ee(ne){switch(ne){case 1:return E.CompletionTriggerKind.TriggerCharacter;case 2:return E.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return E.CompletionTriggerKind.Invoke}}ge.to=Ee})(He=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var q;(function(ge){function Ee(ne){return{triggerKind:He.to(ne.triggerKind),triggerCharacter:ne.triggerCharacter}}ge.to=Ee})(q=e.CompletionContext||(e.CompletionContext={}));var ee;(function(ge){function Ee(K){switch(K){case E.CompletionItemTag.Deprecated:return 1}}ge.from=Ee;function ne(K){switch(K){case 1:return E.CompletionItemTag.Deprecated}}ge.to=ne})(ee=e.CompletionItemTag||(e.CompletionItemTag={}));var re;(function(ge){const Ee=new Map([[E.CompletionItemKind.Method,0],[E.CompletionItemKind.Function,1],[E.CompletionItemKind.Constructor,2],[E.CompletionItemKind.Field,3],[E.CompletionItemKind.Variable,4],[E.CompletionItemKind.Class,5],[E.CompletionItemKind.Interface,7],[E.CompletionItemKind.Struct,6],[E.CompletionItemKind.Module,8],[E.CompletionItemKind.Property,9],[E.CompletionItemKind.Unit,12],[E.CompletionItemKind.Value,13],[E.CompletionItemKind.Constant,14],[E.CompletionItemKind.Enum,15],[E.CompletionItemKind.EnumMember,16],[E.CompletionItemKind.Keyword,17],[E.CompletionItemKind.Snippet,27],[E.CompletionItemKind.Text,18],[E.CompletionItemKind.Color,19],[E.CompletionItemKind.File,20],[E.CompletionItemKind.Reference,21],[E.CompletionItemKind.Folder,23],[E.CompletionItemKind.Event,10],[E.CompletionItemKind.Operator,11],[E.CompletionItemKind.TypeParameter,24],[E.CompletionItemKind.Issue,26],[E.CompletionItemKind.User,25]]);function ne(Le){return Ee.get(Le)??9}ge.from=ne;const K=new Map([[0,E.CompletionItemKind.Method],[1,E.CompletionItemKind.Function],[2,E.CompletionItemKind.Constructor],[3,E.CompletionItemKind.Field],[4,E.CompletionItemKind.Variable],[5,E.CompletionItemKind.Class],[7,E.CompletionItemKind.Interface],[6,E.CompletionItemKind.Struct],[8,E.CompletionItemKind.Module],[9,E.CompletionItemKind.Property],[12,E.CompletionItemKind.Unit],[13,E.CompletionItemKind.Value],[14,E.CompletionItemKind.Constant],[15,E.CompletionItemKind.Enum],[16,E.CompletionItemKind.EnumMember],[17,E.CompletionItemKind.Keyword],[27,E.CompletionItemKind.Snippet],[18,E.CompletionItemKind.Text],[19,E.CompletionItemKind.Color],[20,E.CompletionItemKind.File],[21,E.CompletionItemKind.Reference],[23,E.CompletionItemKind.Folder],[10,E.CompletionItemKind.Event],[11,E.CompletionItemKind.Operator],[24,E.CompletionItemKind.TypeParameter],[25,E.CompletionItemKind.User],[26,E.CompletionItemKind.Issue]]);function Se(Le){return K.get(Le)??E.CompletionItemKind.Property}ge.to=Se})(re=e.CompletionItemKind||(e.CompletionItemKind={}));var le;(function(ge){function Ee(ne,K){const Se=new E.CompletionItem(ne.label);return Se.insertText=ne.insertText,Se.kind=re.to(ne.kind),Se.tags=ne.tags?.map(ee.to),Se.detail=ne.detail,Se.documentation=C.isMarkdownString(ne.documentation)?f.to(ne.documentation):ne.documentation,Se.sortText=ne.sortText,Se.filterText=ne.filterText,Se.preselect=ne.preselect,Se.commitCharacters=ne.commitCharacters,i.Range.isIRange(ne.range)?Se.range=r.to(ne.range):typeof ne.range=="object"&&(Se.range={inserting:r.to(ne.range.insert),replacing:r.to(ne.range.replace)}),Se.keepWhitespace=typeof ne.insertTextRules=="undefined"?!1:Boolean(ne.insertTextRules&1),typeof ne.insertTextRules!="undefined"&&ne.insertTextRules&4?Se.insertText=new E.SnippetString(ne.insertText):(Se.insertText=ne.insertText,Se.textEdit=Se.range instanceof E.Range?new E.TextEdit(Se.range,Se.insertText):void 0),ne.additionalTextEdits&&ne.additionalTextEdits.length>0&&(Se.additionalTextEdits=ne.additionalTextEdits.map(Le=>N.to(Le))),Se.command=K&&ne.command?K.fromInternal(ne.command):void 0,Se}ge.to=Ee})(le=e.CompletionItem||(e.CompletionItem={}));var Z;(function(ge){function Ee(K){return{label:K.label,documentation:K.documentation?f.fromStrict(K.documentation):void 0}}ge.from=Ee;function ne(K){return{label:K.label,documentation:C.isMarkdownString(K.documentation)?f.to(K.documentation):K.documentation}}ge.to=ne})(Z=e.ParameterInformation||(e.ParameterInformation={}));var ae;(function(ge){function Ee(K){return{label:K.label,documentation:K.documentation?f.fromStrict(K.documentation):void 0,parameters:Array.isArray(K.parameters)?K.parameters.map(Z.from):[],activeParameter:K.activeParameter}}ge.from=Ee;function ne(K){return{label:K.label,documentation:C.isMarkdownString(K.documentation)?f.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(Z.to):[],activeParameter:K.activeParameter}}ge.to=ne})(ae=e.SignatureInformation||(e.SignatureInformation={}));var pe;(function(ge){function Ee(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(ae.from):[]}}ge.from=Ee;function ne(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(ae.to):[]}}ge.to=ne})(pe=e.SignatureHelp||(e.SignatureHelp={}));var Me;(function(ge){function Ee(K){return{text:K.text,position:t.from(K.position),kind:je.from(K.kind??E.InlayHintKind.Other),whitespaceBefore:K.whitespaceBefore,whitespaceAfter:K.whitespaceAfter}}ge.from=Ee;function ne(K){const Se=new E.InlayHint(K.text,t.to(K.position),je.to(K.kind));return Se.whitespaceAfter=K.whitespaceAfter,Se.whitespaceBefore=K.whitespaceBefore,Se}ge.to=ne})(Me=e.InlayHint||(e.InlayHint={}));var je;(function(ge){function Ee(K){return K}ge.from=Ee;function ne(K){return K}ge.to=ne})(je=e.InlayHintKind||(e.InlayHintKind={}));var Ke;(function(ge){function Ee(K){return{range:r.from(K.range),url:K.target,tooltip:K.tooltip}}ge.from=Ee;function ne(K){let Se;if(K.url)try{Se=typeof K.url=="string"?I.URI.parse(K.url,!0):I.URI.revive(K.url)}catch(Le){}return new E.DocumentLink(r.to(K.range),Se)}ge.to=ne})(Ke=e.DocumentLink||(e.DocumentLink={}));var Je;(function(ge){function Ee(K){const Se=new E.ColorPresentation(K.label);return K.textEdit&&(Se.textEdit=N.to(K.textEdit)),K.additionalTextEdits&&(Se.additionalTextEdits=K.additionalTextEdits.map(Le=>N.to(Le))),Se}ge.to=Ee;function ne(K){return{label:K.label,textEdit:K.textEdit?N.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Se=>N.from(Se)):void 0}}ge.from=ne})(Je=e.ColorPresentation||(e.ColorPresentation={}));var st;(function(ge){function Ee(K){return new E.Color(K[0],K[1],K[2],K[3])}ge.to=Ee;function ne(K){return[K.red,K.green,K.blue,K.alpha]}ge.from=ne})(st=e.Color||(e.Color={}));var Te;(function(ge){function Ee(K){return{range:r.from(K.range)}}ge.from=Ee;function ne(K){return new E.SelectionRange(r.to(K.range))}ge.to=ne})(Te=e.SelectionRange||(e.SelectionRange={}));var nt;(function(ge){function Ee(ne){switch(ne){case 2:return E.TextDocumentSaveReason.AfterDelay;case 1:return E.TextDocumentSaveReason.Manual;case 3:case 4:return E.TextDocumentSaveReason.FocusOut}}ge.to=Ee})(nt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var J;(function(ge){function Ee(K){switch(K){case E.TextEditorLineNumbersStyle.Off:return 0;case E.TextEditorLineNumbersStyle.Relative:return 2;case E.TextEditorLineNumbersStyle.On:default:return 1}}ge.from=Ee;function ne(K){switch(K){case 0:return E.TextEditorLineNumbersStyle.Off;case 2:return E.TextEditorLineNumbersStyle.Relative;case 1:default:return E.TextEditorLineNumbersStyle.On}}ge.to=ne})(J=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var te;(function(ge){function Ee(K){if(K===E.EndOfLine.CRLF)return 1;if(K===E.EndOfLine.LF)return 0}ge.from=Ee;function ne(K){if(K===1)return E.EndOfLine.CRLF;if(K===0)return E.EndOfLine.LF}ge.to=ne})(te=e.EndOfLine||(e.EndOfLine={}));var ve;(function(ge){function Ee(ne){if(typeof ne=="object")return ne.viewId;switch(ne){case E.ProgressLocation.SourceControl:return 3;case E.ProgressLocation.Window:return 10;case E.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ge.from=Ee})(ve=e.ProgressLocation||(e.ProgressLocation={}));var Qe;(function(ge){function Ee(ne){const K={start:ne.start+1,end:ne.end+1};return ne.kind&&(K.kind=tt.from(ne.kind)),K}ge.from=Ee})(Qe=e.FoldingRange||(e.FoldingRange={}));var tt;(function(ge){function Ee(ne){if(ne)switch(ne){case E.FoldingRangeKind.Comment:return k.FoldingRangeKind.Comment;case E.FoldingRangeKind.Imports:return k.FoldingRangeKind.Imports;case E.FoldingRangeKind.Region:return k.FoldingRangeKind.Region}}ge.from=Ee})(tt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ct;(function(ge){function Ee(ne){if(ne)return{pinned:typeof ne.preview=="boolean"?!ne.preview:void 0,inactive:ne.background,preserveFocus:ne.preserveFocus,selection:typeof ne.selection=="object"?r.from(ne.selection):void 0,override:typeof ne.override=="boolean"?a.EditorResolution.DISABLED:void 0}}ge.from=Ee})(ct=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ce;(function(ge){function Ee(K){return K instanceof E.RelativePattern||typeof K=="string"?K:ne(K)?new E.RelativePattern(K.base,K.pattern):K}ge.from=Ee;function ne(K){const Se=K;return Se&&typeof Se.base=="string"&&typeof Se.pattern=="string"}})(ce=e.GlobPattern||(e.GlobPattern={}));var Ie;(function(ge){function Ee(ne){if(ne){if(Array.isArray(ne))return ne.map(Ee);if(typeof ne=="string")return ne;{const K=ne;return{language:K.language,scheme:K.scheme,pattern:typeof K.pattern=="undefined"?void 0:ce.from(K.pattern),exclusive:K.exclusive}}}else return}ge.from=Ee})(Ie=e.LanguageSelector||(e.LanguageSelector={}));var Ue;(function(ge){function Ee(K){return{start:K.start,end:K.end}}ge.from=Ee;function ne(K){return new E.NotebookRange(K.start,K.end)}ge.to=ne})(Ue=e.NotebookRange||(e.NotebookRange={}));var Xe;(function(ge){function Ee(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}ge.to=Ee;function ne(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}ge.from=ne})(Xe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var rt;(function(ge){function Ee(K){switch(K){case E.NotebookCellKind.Markup:return w.CellKind.Markup;case E.NotebookCellKind.Code:default:return w.CellKind.Code}}ge.from=Ee;function ne(K){switch(K){case w.CellKind.Markup:return E.NotebookCellKind.Markup;case w.CellKind.Code:default:return E.NotebookCellKind.Code}}ge.to=ne})(rt=e.NotebookCellKind||(e.NotebookCellKind={}));var ht;(function(ge){function Ee(K){const Se={metadata:K.metadata??Object.create(null),cells:[]};for(let Le of K.cells)E.NotebookCellData.validate(Le),Se.cells.push(Ye.from(Le));return Se}ge.from=Ee;function ne(K){const Se=new E.NotebookData(K.cells.map(Ye.to));return(0,S.isEmptyObject)(K.metadata)||(Se.metadata=K.metadata),Se}ge.to=ne})(ht=e.NotebookData||(e.NotebookData={}));var Ye;(function(ge){function Ee(K){return{cellKind:rt.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Xe.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Re.from):[]}}ge.from=Ee;function ne(K){return new E.NotebookCellData(rt.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Re.to):void 0,K.metadata,K.internalMetadata?Xe.to(K.internalMetadata):void 0)}ge.to=ne})(Ye=e.NotebookCellData||(e.NotebookCellData={}));var vt;(function(ge){function Ee(K){return{mime:K.mime,valueBytes:F.VSBuffer.wrap(K.data)}}ge.from=Ee;function ne(K){return new E.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}ge.to=ne})(vt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Re;(function(ge){function Ee(K){return{outputId:K.id,items:K.items.map(vt.from),metadata:K.metadata}}ge.from=Ee;function ne(K){const Se=K.items.map(vt.to);return new E.NotebookCellOutput(Se,K.outputId,K.metadata)}ge.to=ne})(Re=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ce;(function(ge){function Ee(Le){if(Le!=null){if(Le instanceof E.RelativePattern||typeof Le=="string")return Le;if(Se(Le))return new E.RelativePattern(Le.base,Le.pattern);if(K(Le))return{include:ce.from(Le.include)||void 0,exclude:ce.from(Le.exclude)||void 0}}}ge.from=Ee;function ne(Le){return typeof Le=="string"?Le:Se(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}ge.to=ne;function K(Le){const it=Le,Ge=ce.from(it.include);if(!(Ge&&Ge instanceof E.RelativePattern||typeof Ge=="string"))return!1;const pt=ce.from(it.exclude);return!!(pt&&pt instanceof E.RelativePattern||typeof pt=="string")}function Se(Le){const it=Le;return it&&typeof it.base=="string"&&typeof it.pattern=="string"}})(Ce=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Pe;(function(ge){function Ee(ne){return{backgroundColor:ne.backgroundColor,borderColor:ne.borderColor,top:ne.top?M.from(ne.top):void 0}}ge.from=Ee})(Pe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var se;(function(ge){function Ee(ne,K,Se){const Le=typeof ne.command=="string"?{title:"",command:ne.command}:ne.command;return{alignment:ne.alignment===E.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Le,Se),text:ne.text,tooltip:ne.tooltip,accessibilityInformation:ne.accessibilityInformation,priority:ne.priority}}ge.from=Ee})(se=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ue;(function(ge){function Ee(ne){return{transientOutputs:ne?.transientOutputs??!1,transientCellMetadata:ne?.transientCellMetadata??{},transientDocumentMetadata:ne?.transientDocumentMetadata??{}}}ge.from=Ee})(ue=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var be;(function(ge){function Ee(K){return{uri:K.uri,provides:K.provides}}ge.from=Ee;function ne(K){return new E.NotebookRendererScript(I.URI.revive(K.uri),K.provides)}ge.to=ne})(be=e.NotebookRendererScript||(e.NotebookRendererScript={}));var we;(function(ge){function Ee(K){return{message:f.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location?Q.from(K.location):void 0}}ge.from=Ee;function ne(K){const Se=new E.TestMessage(typeof K.message=="string"?K.message:f.to(K.message));return Se.actualOutput=K.actual,Se.expectedOutput=K.expected,Se.location=K.location?Q.to(K.location):void 0,Se}ge.to=ne})(we=e.TestMessage||(e.TestMessage={}));var Fe;(function(ge){let Ee;(function(ne){ne.Delimiter="\0"})(Ee||(Ee={})),ge.namespace=(ne,K)=>ne+"\0"+K,ge.denamespace=ne=>{const K=ne.indexOf("\0");return{ctrlId:ne.slice(0,K),tagId:ne.slice(K+1)}}})(Fe=e.TestTag||(e.TestTag={}));var qe;(function(ge){function Ee(Le){const it=(0,d.getPrivateApiFor)(Le).controllerId;return{extId:D.TestId.fromExtHostTestItem(Le,it).toString(),label:Le.label,uri:Le.uri,tags:Le.tags.map(Ge=>Fe.namespace(it,Ge.id)),range:r.from(Le.range)||null,description:Le.description||null,error:Le.error&&f.fromStrict(Le.error)||null}}ge.from=Ee;function ne(Le){return{id:D.TestId.fromString(Le.extId).localId,label:Le.label,uri:I.URI.revive(Le.uri),tags:(Le.tags||[]).map(it=>{const{tagId:Ge}=Fe.denamespace(it);return new E.TestTag(Ge)}),range:r.to(Le.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Le.description||void 0}}ge.toPlain=ne;function K(Le){const it=D.TestId.fromString(Le.extId),Ge=new d.TestItemImpl(it.controllerId,it.localId,Le.label,I.URI.revive(Le.uri));return Ge.range=r.to(Le.range||void 0),Ge.description=Le.description||void 0,Ge}function Se(Le){let it;for(const Ge of Le.tests){const pt=K(Ge.item);(0,d.getPrivateApiFor)(pt).parent=it,it=pt}return it}ge.toItemFromContext=Se})(qe=e.TestItem||(e.TestItem={})),function(ge){function Ee(K){return{id:K.id}}ge.from=Ee;function ne(K){return new E.TestTag(K.id)}ge.to=ne}(Fe=e.TestTag||(e.TestTag={}));var ze;(function(ge){const Ee=(K,Se)=>{const Le={...qe.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(it=>({state:it.state,duration:it.duration,messages:it.messages.filter(Ge=>Ge.type===0).map(we.to)})),children:K.children.map(it=>Se.get(it)).filter(S.isDefined).map(it=>Ee(it,Se))};for(const it of Le.children)it.parent=Le;return Le};function ne(K){const Se=[],Le=new Map;for(const it of K.items)Le.set(it.item.extId,it),K.request.targets.some(Ge=>Ge.controllerId===it.controllerId&&Ge.testIds.includes(it.item.extId))&&Se.push(it);return{completedAt:K.completedAt,results:Se.map(it=>Ee(it,Le))}}ge.to=ne})(ze=e.TestResults||(e.TestResults={}));var et;(function(ge){function Ee(Le){return{covered:Le.covered,total:Le.covered}}function ne(Le){return"line"in Le?t.from(Le):r.from(Le)}function K(Le){return"branches"in Le?{count:Le.executionCount,location:ne(Le.location),type:1,branches:Le.branches.length?Le.branches.map(it=>({count:it.executionCount,location:it.location&&ne(it.location)})):void 0}:{type:0,count:Le.executionCount,location:ne(Le.location)}}ge.fromDetailed=K;function Se(Le){return{uri:Le.uri,statement:Ee(Le.statementCoverage),branch:Le.branchCoverage&&Ee(Le.branchCoverage),function:Le.functionCoverage&&Ee(Le.functionCoverage),details:Le.detailedCoverage?.map(K)}}ge.fromFile=Se})(et=e.TestCoverage||(e.TestCoverage={}));var at;(function(ge){function Ee(ne){switch(ne){case 1:return E.CodeActionTriggerKind.Invoke;case 2:return E.CodeActionTriggerKind.Automatic}}ge.to=Ee})(at=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Be;(function(ge){function Ee(K){const Se=new E.TypeHierarchyItem(U.to(K.kind),K.name,K.detail||"",I.URI.revive(K.uri),r.to(K.range),r.to(K.selectionRange));return Se._sessionId=K._sessionId,Se._itemId=K._itemId,Se}ge.to=Ee;function ne(K,Se,Le){if(Se=Se??K._sessionId,Le=Le??K._itemId,Se===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Le,kind:U.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:r.from(K.range),selectionRange:r.from(K.selectionRange),tags:K.tags?.map(B.from)}}ge.from=ne})(Be=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(fe[219],me([0,1,2,17,7,16,95]),function(Y,e,p,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class _{constructor(I,i,k,a={timeout:1500,errors:3}){this._logService=I,this._documents=i,this._mainThreadBulkEdits=k,this._thresholds=a,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(I){return(i,k,a)=>{const d={dispose:this._callbacks.push([i,k,I])};return Array.isArray(a)&&a.push(d),d}}async $participateInSave(I,i){const k=p.URI.revive(I);let a=!1;const g=setTimeout(()=>a=!0,this._thresholds.timeout),d=[];try{for(let w of[...this._callbacks]){if(a)break;const D=this._documents.getDocument(k),T=await this._deliverEventAsyncAndBlameBadListeners(w,{document:D,reason:y.TextDocumentSaveReason.to(i)});d.push(T)}}finally{clearTimeout(g)}return d}_deliverEventAsyncAndBlameBadListeners([I,i,k],a){const g=this._badListeners.get(I);return typeof g=="number"&&g>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,I,i,a).then(()=>!0,d=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(d),!(d instanceof Error)||d.message!=="concurrent_edits"){const w=this._badListeners.get(I);this._badListeners.set(I,w?w+1:1),typeof w=="number"&&w>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(I,i,k,a){const g=[],d=Date.now(),{document:w,reason:D}=a,{version:T}=w,E=Object.freeze({document:w,reason:D,waitUntil(c){if(Object.isFrozen(g))throw(0,F.illegalState)("waitUntil can not be called async");g.push(Promise.resolve(c))}});try{i.apply(k,[E])}catch(c){return Promise.reject(c)}return Object.freeze(g),new Promise((c,r)=>{const v=setTimeout(()=>r(new Error("timeout")),this._thresholds.timeout);return Promise.all(g).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-d}ms`),clearTimeout(v),c(t)}).catch(t=>{clearTimeout(v),r(t)})}).then(c=>{const r={edits:[]};for(const v of c)if(Array.isArray(v)&&v.every(t=>t instanceof C.TextEdit))for(const{newText:t,newEol:h,range:s}of v)r.edits.push({_type:2,resource:w.uri,edit:{range:s&&y.Range.from(s),text:t,eol:h&&y.EndOfLine.from(h)}});if(r.edits.length!==0)return T===w.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=_}),define(fe[220],me([0,1,3,30,2,16,7]),function(Y,e,p,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class _{constructor(i,k,a,g,d){this._onDidCreate=new p.Emitter,this._onDidChange=new p.Emitter,this._onDidDelete=new p.Emitter,this._config=0,a&&(this._config+=1),g&&(this._config+=2),d&&(this._config+=4);const w=(0,F.parse)(k),D=i(T=>{if(!a)for(let E of T.created){const c=C.URI.revive(E);w(c.fsPath)&&this._onDidCreate.fire(c)}if(!g)for(let E of T.changed){const c=C.URI.revive(E);w(c.fsPath)&&this._onDidChange.fire(c)}if(!d)for(let E of T.deleted){const c=C.URI.revive(E);w(c.fsPath)&&this._onDidDelete.fire(c)}});this._disposable=A.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,D)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class S{constructor(i,k,a){this._logService=k,this._extHostDocumentsAndEditors=a,this._onFileSystemEvent=new p.Emitter,this._onDidRenameFile=new p.Emitter,this._onDidCreateFile=new p.Emitter,this._onDidDeleteFile=new p.Emitter,this._onWillRenameFile=new p.AsyncEmitter,this._onWillCreateFile=new p.AsyncEmitter,this._onWillDeleteFile=new p.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(i,k,a,g){return new _(this._onFileSystemEvent.event,i,k,a,g)}$onFileEvent(i){this._onFileSystemEvent.fire(i)}$onDidRunFileOperation(i,k){switch(i){case 2:this._onDidRenameFile.fire(Object.freeze({files:k.map(a=>({oldUri:C.URI.revive(a.source),newUri:C.URI.revive(a.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:k.map(a=>C.URI.revive(a.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:k.map(a=>C.URI.revive(a.target))}));break;default:}}getOnWillRenameFileEvent(i){return this._createWillExecuteEvent(i,this._onWillRenameFile)}getOnWillCreateFileEvent(i){return this._createWillExecuteEvent(i,this._onWillCreateFile)}getOnWillDeleteFileEvent(i){return this._createWillExecuteEvent(i,this._onWillDeleteFile)}_createWillExecuteEvent(i,k){return(a,g,d)=>{const w=function(T){a.call(g,T)};return w.extension=i,k.event(w,void 0,d)}}async $onWillRunFileOperation(i,k,a,g){switch(i){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:k.map(d=>({oldUri:C.URI.revive(d.source),newUri:C.URI.revive(d.target)}))},a,g);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:k.map(d=>C.URI.revive(d.target))},a,g);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:k.map(d=>C.URI.revive(d.target))},a,g)}}async _fireWillEvent(i,k,a,g){const d=new Set,w=[];if(await i.fireAsync(k,g,async(T,E)=>{const c=Date.now(),r=await Promise.resolve(T);r instanceof A.WorkspaceEdit&&(w.push(r),d.add(E.extension.displayName??E.extension.identifier.value)),Date.now()-c>a&&this._logService.warn("SLOW file-participant",E.extension.identifier)}),g.isCancellationRequested||w.length===0)return;const D={edits:[]};for(let T of w){let{edits:E}=y.WorkspaceEdit.from(T,this._extHostDocumentsAndEditors);D.edits=D.edits.concat(E)}return{edit:D,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=S}),define(fe[221],me([0,1,10,25,2,16,7,128]),function(Y,e,p,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(a,g,d,w){this.start=a,this.deletedCount=g,this.deletedItems=d,this.items=w}static asApiEvents(a){return a.map(g=>({start:g.start,deletedCount:g.deletedCount,deletedItems:g.deletedItems,items:g.items.map(d=>d.apiCell)}))}}class I{constructor(a,g,d){this.notebook=a,this._extHostDocument=g,this._cellData=d,this.handle=d.handle,this.uri=C.URI.revive(d.uri),this.cellKind=d.cellKind,this._outputs=d.outputs.map(y.NotebookCellOutput.to),this._internalMetadata=d.internalMetadata??{},this._metadata=Object.freeze(d.metadata??{}),this._previousResult=Object.freeze(y.NotebookCellExecutionSummary.to(d.internalMetadata??{}))}static asModelAddData(a,g){return{EOL:g.eol,lines:g.source,modeId:g.language,uri:g.uri,isDirty:!1,versionId:1,notebook:a}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const a=this,g=this._extHostDocument.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return a.notebook.getCellIndex(a)},notebook:a.notebook.apiNotebook,kind:y.NotebookCellKind.to(this._cellData.cellKind),document:g.document,get mime(){return a._mime},set mime(d){a._mime=d},get outputs(){return a._outputs.slice(0)},get metadata(){return a._metadata},get executionSummary(){return a._previousResult}})}return this._apiCell}setOutputs(a){this._outputs=a.map(y.NotebookCellOutput.to)}setOutputItems(a,g,d){const w=d.map(y.NotebookCellOutputItem.to),D=this._outputs.find(T=>T.id===a);D&&(g||(D.items.length=0),D.items.push(...w))}setMetadata(a){this._metadata=Object.freeze(a)}setInternalMetadata(a){this._internalMetadata=a,this._previousResult=Object.freeze(y.NotebookCellExecutionSummary.to(a))}setMime(a){}}e.ExtHostCell=I;class i{constructor(a,g,d,w,D,T){this._proxy=a,this._textDocumentsAndEditors=g,this._textDocuments=d,this._emitter=w,this.uri=D,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=T.viewType,this._metadata=Object.freeze(T.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,T.cells]],!0),this._versionId=T.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const a=this;this._notebook={get uri(){return a.uri},get version(){return a._versionId},get notebookType(){return a._notebookType},get isDirty(){return a._isDirty},get isUntitled(){return a.uri.scheme===p.Schemas.untitled},get isClosed(){return a._disposed},get metadata(){return a._metadata},get cellCount(){return a._cells.length},cellAt(g){return g=a._validateIndex(g),a._cells[g].apiCell},getCells(g){return(g?a._getCells(g):a._cells).map(w=>w.apiCell)},save(){return a._save()}}}return this._notebook}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(a){a.metadata&&(this._metadata=Object.freeze({...this._metadata,...a.metadata}))}acceptDirty(a){this._isDirty=a}acceptModelChanged(a,g){this._versionId=a.versionId,this._isDirty=g;for(const d of a.rawEvents)d.kind===_.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(d.changes,!1):d.kind===_.NotebookCellsChangeType.Move?this._moveCell(d.index,d.newIdx):d.kind===_.NotebookCellsChangeType.Output?this._setCellOutputs(d.index,d.outputs):d.kind===_.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(d.index,d.outputId,d.append,d.outputItems):d.kind===_.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(d.index,d.language):d.kind===_.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(d.index,d.mime):d.kind===_.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(d.index,d.metadata):d.kind===_.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(d.index,d.internalMetadata)}_validateIndex(a){return a=a|0,a<0?0:a>=this._cells.length?this._cells.length-1:a}_validateRange(a){let g=a.start|0,d=a.end|0;return g<0&&(g=0),d>this._cells.length&&(d=this._cells.length),a.with({start:g,end:d})}_getCells(a){a=this._validateRange(a);const g=[];for(let d=a.start;d<a.end;d++)g.push(this._cells[d]);return g}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(a,g){if(this._disposed)return;const d=[],w=[],D=[];a.reverse().forEach(T=>{const c=T[2].map(t=>{const h=new I(this,this._textDocumentsAndEditors,t);return g||w.push(I.asModelAddData(this.apiNotebook,t)),h}),r=new S(T[0],T[1],[],c),v=this._cells.splice(T[0],T[1],...c);for(const t of v)D.push(t.uri),r.deletedItems.push(t.apiCell);d.push(r)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:w,removedDocuments:D}),g||this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(d)}))}_moveCell(a,g){const d=this._cells.splice(a,1);this._cells.splice(g,0,...d);const w=[new S(a,1,d.map(D=>D.apiCell),[]),new S(g,0,[],d)];this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(w)}))}_setCellOutputs(a,g){const d=this._cells[a];d.setOutputs(g),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[d.apiCell]}))}_setCellOutputItems(a,g,d,w){const D=this._cells[a];D.setOutputItems(g,d,w),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[D.apiCell]}))}_changeCellLanguage(a,g){const d=this._cells[a];d.apiCell.document.languageId!==g&&this._textDocuments.$acceptModelModeChanged(d.uri,g)}_changeCellMime(a,g){const d=this._cells[a];d.apiCell.mime=g}_changeCellMetadata(a,g){const d=this._cells[a],w=d.apiCell.metadata;d.setMetadata(g);const D=d.apiCell.metadata;(0,F.equals)(w,D)||this._emitter.emitCellMetadataChange((0,F.deepFreeze)({document:this.apiNotebook,cell:d.apiCell}))}_changeCellInternalMetadata(a,g){const d=this._cells[a],w=d.internalMetadata;if(d.setInternalMetadata(g),w.runState!==g.runState){const D=g.runState??A.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,F.deepFreeze)({document:this.apiNotebook,cell:d.apiCell,state:D}))}}getCellFromApiCell(a){return this._cells.find(g=>g.apiCell===a)}getCellFromIndex(a){return this._cells[a]}getCell(a){return this._cells.find(g=>g.handle===a)}getCellIndex(a){return this._cells.indexOf(a)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(fe[131],me([0,1,7,16,17]),function(Y,e,p,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class y{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,I){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:I})}replaceCells(S,I,i){this._throwIfFinalized(),!(S===I&&i.length===0)&&this._collectedEdits.push({editType:1,index:S,count:I-S,cells:i.map(F.NotebookCellData.from)})}}class A{constructor(S,I,i,k,a,g){this.id=S,this._proxy=I,this.notebookData=i,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=a,this._visibleRanges=k,this._viewColumn=g}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(I){if(!Array.isArray(I)||!I.every(p.NotebookRange.isNotebookRange))throw(0,C.illegalArgument)("selections");S._selections=I,S._trySetSelections(I)},get visibleRanges(){return S._visibleRanges},revealRange(I,i){S._proxy.$tryRevealRange(S.id,F.NotebookRange.from(I),i??p.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(I){const i=new y(this.document.version);return I(i),S._applyEdit(i.finalize())},setDecorations(I,i){return S.setDecorations(I,i)}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(F.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const I=[];let i=-1;for(let k=0;k<S.cellEdits.length;k++){if(i<0){I.push(S.cellEdits[k]),i++;continue}const g=I[i],d=S.cellEdits[k];if(g.editType===1&&d.editType===1&&g.index===d.index){g.cells.push(...S.cellEdits[k].cells),g.count+=S.cellEdits[k].count;continue}I.push(S.cellEdits[k]),i++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,I)}setDecorations(S,I){if(!(I.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return I.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,F.NotebookRange.from(I),S.key)}}e.ExtHostNotebookEditor=A,A.apiEditorsToExtHost=new WeakMap}),define(fe[222],me([0,1,16,119,167,21,60,17]),function(Y,e,p,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(a){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=a}async withProgress(a,g,d){const w=this._handles++,{title:D,location:T,cancellable:E}=g,c={label:(0,C.localize)(0,null,a.displayName||a.name),id:a.identifier.value};return this._proxy.$startProgress(w,{location:p.ProgressLocation.from(T),title:D,source:c,cancellable:E},a).catch(_.onUnexpectedExternalError),this._withProgress(w,d,!!E)}_withProgress(a,g,d){let w;d&&(w=new y.CancellationTokenSource,this._mapHandleToCancellationSource.set(a,w));const D=E=>{this._proxy.$progressEnd(E),this._mapHandleToCancellationSource.delete(E),w&&w.dispose()};let T;try{T=g(new i(this._proxy,a),d&&w?w.token:y.CancellationToken.None)}catch(E){throw D(a),E}return T.then(E=>D(a),E=>D(a)),T}$acceptProgressCanceled(a){const g=this._mapHandleToCancellationSource.get(a);g&&(g.cancel(),this._mapHandleToCancellationSource.delete(a))}}e.ExtHostProgress=S;function I(k,a){return k.message=a.message,typeof a.increment=="number"&&(typeof k.increment=="number"?k.increment+=a.increment:k.increment=a.increment),k}class i extends F.Progress{constructor(a,g){super(d=>this.throttledReport(d));this._proxy=a,this._handle=g}throttledReport(a){this._proxy.$progressReport(this._handle,a)}}Ve([(0,A.throttle)(100,(k,a)=>I(k,a),()=>Object.create(null))],i.prototype,"throttledReport",null)}),define(fe[132],me([0,1,58,17,77,16,7]),function(Y,e,p,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class _{constructor(a,g,d){const w=_._Keys.nextId();a.$registerTextEditorDecorationType(g.identifier,w,y.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:w,dispose(){a.$removeTextEditorDecorationType(w)}})}}e.TextEditorDecorationType=_,_._Keys=new C.IdGenerator("TextEditorDecorationType");class S{constructor(a,g){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=a,this._documentVersionId=a.version,this._undoStopBefore=g.undoStopBefore,this._undoStopAfter=g.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(a,g){this._throwIfFinalized();let d=null;if(a instanceof A.Position)d=new A.Range(a,a);else if(a instanceof A.Range)d=a;else throw new Error("Unrecognized location");this._pushEdit(d,g,!1)}insert(a,g){this._throwIfFinalized(),this._pushEdit(new A.Range(a,a),g,!0)}delete(a){this._throwIfFinalized();let g=null;if(a instanceof A.Range)g=a;else throw new Error("Unrecognized location");this._pushEdit(g,null,!0)}_pushEdit(a,g,d){const w=this._document.validateRange(a);this._collectedEdits.push({range:w,text:g,forceMoveMarkers:d})}setEndOfLine(a){if(this._throwIfFinalized(),a!==A.EndOfLine.LF&&a!==A.EndOfLine.CRLF)throw(0,F.illegalArgument)("endOfLine");this._setEndOfLine=a}}e.TextEditorEdit=S;class I{constructor(a,g,d,w){this._proxy=a,this._id=g,this._accept(d),this._logService=w;const D=this;this.value={get tabSize(){return D._tabSize},set tabSize(T){D._setTabSize(T)},get insertSpaces(){return D._insertSpaces},set insertSpaces(T){D._setInsertSpaces(T)},get cursorStyle(){return D._cursorStyle},set cursorStyle(T){D._setCursorStyle(T)},get lineNumbers(){return D._lineNumbers},set lineNumbers(T){D._setLineNumbers(T)}}}_accept(a){this._tabSize=a.tabSize,this._insertSpaces=a.insertSpaces,this._cursorStyle=a.cursorStyle,this._lineNumbers=y.TextEditorLineNumbersStyle.to(a.lineNumbers)}_validateTabSize(a){if(a==="auto")return"auto";if(typeof a=="number"){const g=Math.floor(a);return g>0?g:null}if(typeof a=="string"){const g=parseInt(a,10);return isNaN(g)?null:g>0?g:null}return null}_setTabSize(a){const g=this._validateTabSize(a);if(g!==null){if(typeof g=="number"){if(this._tabSize===g)return;this._tabSize=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:g}))}}_validateInsertSpaces(a){return a==="auto"?"auto":a==="false"?!1:Boolean(a)}_setInsertSpaces(a){const g=this._validateInsertSpaces(a);if(typeof g=="boolean"){if(this._insertSpaces===g)return;this._insertSpaces=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:g}))}_setCursorStyle(a){this._cursorStyle!==a&&(this._cursorStyle=a,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:a})))}_setLineNumbers(a){this._lineNumbers!==a&&(this._lineNumbers=a,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:y.TextEditorLineNumbersStyle.from(a)})))}assign(a){const g={};let d=!1;if(typeof a.tabSize!="undefined"){const w=this._validateTabSize(a.tabSize);w==="auto"?(d=!0,g.tabSize=w):typeof w=="number"&&this._tabSize!==w&&(this._tabSize=w,d=!0,g.tabSize=w)}if(typeof a.insertSpaces!="undefined"){const w=this._validateInsertSpaces(a.insertSpaces);w==="auto"?(d=!0,g.insertSpaces=w):this._insertSpaces!==w&&(this._insertSpaces=w,d=!0,g.insertSpaces=w)}typeof a.cursorStyle!="undefined"&&this._cursorStyle!==a.cursorStyle&&(this._cursorStyle=a.cursorStyle,d=!0,g.cursorStyle=a.cursorStyle),typeof a.lineNumbers!="undefined"&&this._lineNumbers!==a.lineNumbers&&(this._lineNumbers=a.lineNumbers,d=!0,g.lineNumbers=y.TextEditorLineNumbersStyle.from(a.lineNumbers)),d&&this._warnOnError(this._proxy.$trySetOptions(this._id,g))}_warnOnError(a){a.catch(g=>this._logService.warn(g))}}e.ExtHostTextEditorOptions=I;class i{constructor(a,g,d,w,D,T,E,c){this.id=a,this._proxy=g,this._logService=d,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=D,this._options=new I(this._proxy,this.id,T,d),this._visibleRanges=E,this._viewColumn=c;const r=this;this.value=Object.freeze({get document(){return w.getValue()},set document(v){throw(0,F.readonly)("document")},get selection(){return r._selections&&r._selections[0]},set selection(v){if(!(v instanceof A.Selection))throw(0,F.illegalArgument)("selection");r._selections=[v],r._trySetSelection()},get selections(){return r._selections},set selections(v){if(!Array.isArray(v)||v.some(t=>!(t instanceof A.Selection)))throw(0,F.illegalArgument)("selections");r._selections=v,r._trySetSelection()},get visibleRanges(){return r._visibleRanges},set visibleRanges(v){throw(0,F.readonly)("visibleRanges")},get options(){return r._options.value},set options(v){r._disposed||r._options.assign(v)},get viewColumn(){return r._viewColumn},set viewColumn(v){throw(0,F.readonly)("viewColumn")},edit(v,t={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const h=new S(w.getValue(),t);return v(h),r._applyEdit(h)},insertSnippet(v,t,h={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=r._selections.map(n=>y.Range.from(n));else if(t instanceof A.Position){const{lineNumber:n,column:u}=y.Position.from(t);s=[{startLineNumber:n,startColumn:u,endLineNumber:n,endColumn:u}]}else if(t instanceof A.Range)s=[y.Range.from(t)];else{s=[];for(const n of t)if(n instanceof A.Range)s.push(y.Range.from(n));else{const{lineNumber:u,column:o}=y.Position.from(n);s.push({startLineNumber:u,startColumn:o,endLineNumber:u,endColumn:o})}}return g.$tryInsertSnippet(a,v.value,s,h)},setDecorations(v,t){const h=t.length===0;h&&!r._hasDecorationsForKey.has(v.key)||(h?r._hasDecorationsForKey.delete(v.key):r._hasDecorationsForKey.add(v.key),r._runOnProxy(()=>{if(y.isDecorationOptionsArr(t))return g.$trySetDecorations(a,v.key,y.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let n=0,u=t.length;n<u;n++){const o=t[n];s[4*n]=o.start.line+1,s[4*n+1]=o.start.character+1,s[4*n+2]=o.end.line+1,s[4*n+3]=o.end.character+1}return g.$trySetDecorationsFast(a,v.key,s)}}))},revealRange(v,t){r._runOnProxy(()=>g.$tryRevealRange(a,y.Range.from(v),t||A.TextEditorRevealType.Default))},show(v){g.$tryShowEditor(a,y.ViewColumn.from(v))},hide(){g.$tryHideEditor(a)}})}dispose(){(0,p.ok)(!this._disposed),this._disposed=!0}_acceptOptions(a){(0,p.ok)(!this._disposed),this._options._accept(a)}_acceptVisibleRanges(a){(0,p.ok)(!this._disposed),this._visibleRanges=a}_acceptViewColumn(a){(0,p.ok)(!this._disposed),this._viewColumn=a}_acceptSelections(a){(0,p.ok)(!this._disposed),this._selections=a}async _trySetSelection(){const a=this._selections.map(y.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,a)),this.value}_applyEdit(a){const g=a.finalize();if(g.edits.length===0&&!g.setEndOfLine)return Promise.resolve(!0);const d=g.edits.map(D=>D.range);d.sort((D,T)=>D.end.line===T.end.line?D.end.character===T.end.character?D.start.line===T.start.line?D.start.character-T.start.character:D.start.line-T.start.line:D.end.character-T.end.character:D.end.line-T.end.line);for(let D=0,T=d.length-1;D<T;D++){const E=d[D].end;if(d[D+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const w=g.edits.map(D=>({range:y.Range.from(D.range),text:D.text,forceMoveMarkers:D.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,g.documentVersionId,w,{setEndOfLine:typeof g.setEndOfLine=="number"?y.EndOfLine.from(g.setEndOfLine):void 0,undoStopBefore:g.undoStopBefore,undoStopAfter:g.undoStopAfter})}_runOnProxy(a){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,g=>(g instanceof Error&&g.name==="DISPOSED"||this._logService.warn(g),null))}}e.ExtHostTextEditor=i}),define(fe[223],me([0,1,170,23,2,3,6,210,15,7,12,18,16,21,207]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function w(E,c){if((0,i.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let r;return Array.isArray(E.highlights)&&(r=E.highlights.filter(v=>v.length===2&&typeof v[0]=="number"&&typeof v[1]=="number"),r=r.length?r:void 0),{label:E.label,highlights:r}}}class D{constructor(c,r,v){this._proxy=c,this.commands=r,this.logService=v,this.treeViews=new Map;function t(h){return h&&h.$treeViewId&&h.$treeItemHandle}r.registerArgumentProcessor({processArgument:h=>t(h)?this.convertArgument(h):Array.isArray(h)&&h.length>0?h.map(s=>t(s)?this.convertArgument(s):s):h})}registerTreeDataProvider(c,r,v){const t=this.createTreeView(c,{treeDataProvider:r},v);return{dispose:()=>t.dispose()}}createTreeView(c,r,v){if(!r||!r.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=r.dragAndDropController!==void 0,h=this._proxy.$registerTreeViewDataProvider(c,{showCollapseAll:!!r.showCollapseAll,canSelectMany:!!r.canSelectMany,canDragAndDrop:t}),s=this.createExtHostTreeView(c,r,v);return{get onDidCollapseElement(){return s.onDidCollapseElement},get onDidExpandElement(){return s.onDidExpandElement},get selection(){return s.selectedElements},get onDidChangeSelection(){return s.onDidChangeSelection},get visible(){return s.visible},get onDidChangeVisibility(){return s.onDidChangeVisibility},get message(){return s.message},set message(n){s.message=n},get title(){return s.title},set title(n){s.title=n},get description(){return s.description},set description(n){s.description=n},reveal:(n,u)=>s.reveal(n,u),dispose:async()=>{await h,this.treeViews.delete(c),s.dispose()}}}$getChildren(c,r){const v=this.treeViews.get(c);return v?v.getChildren(r):Promise.reject(new Error((0,p.localize)(0,null,c)))}async $onDrop(c,r,v){const t=this.treeViews.get(c);if(!t)return Promise.reject(new Error((0,p.localize)(1,null,c)));const h=d.TreeDataTransferConverter.toITreeDataTransfer(r);if(h.items.has(_.TREE_ITEM_DATA_TRANSFER_TYPE)){const n=JSON.parse(await h.items.get(_.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(u=>t.getExtensionElement(u)).filter(u=>!!u);n.length>0?h.items.set(_.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(n)}):h.items.delete(_.TREE_ITEM_DATA_TRANSFER_TYPE)}return t.onDrop(h,v)}async $hasResolve(c){const r=this.treeViews.get(c);if(!r)throw new Error((0,p.localize)(2,null,c));return r.hasResolve}$resolve(c,r,v){const t=this.treeViews.get(c);if(!t)throw new Error((0,p.localize)(3,null,c));return t.resolveTreeItem(r,v)}$setExpanded(c,r,v){const t=this.treeViews.get(c);if(!t)throw new Error((0,p.localize)(4,null,c));t.setExpanded(r,v)}$setSelection(c,r){const v=this.treeViews.get(c);if(!v)throw new Error((0,p.localize)(5,null,c));v.setSelection(r)}$setVisible(c,r){const v=this.treeViews.get(c);if(!v)throw new Error((0,p.localize)(6,null,c));v.setVisible(r)}createExtHostTreeView(c,r,v){const t=new T(c,r,this._proxy,this.commands.converter,this.logService,v);return this.treeViews.set(c,t),t}convertArgument(c){const r=this.treeViews.get(c.$treeViewId);return r?r.getExtensionElement(c.$treeItemHandle):null}}e.ExtHostTreeViews=D;class T extends A.Disposable{constructor(c,r,v,t,h,s){super();if(this.viewId=c,this.proxy=v,this.commands=t,this.logService=h,this.extension=s,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new g.CancellationTokenSource,s.contributes&&s.contributes.views)for(const o in s.contributes.views)for(const l of s.contributes.views[o])l.id===c&&(this._title=l.name);this.dataProvider=r.treeDataProvider,this.dndController=r.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(o=>this._onDidChangeData.fire({message:!1,element:o}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(o=>this._onDidChangeData.fire({message:!1,element:o})));let n,u;this._register(y.Event.debounce(this._onDidChangeData.event,(o,l)=>(o||(o={message:!1,elements:[]}),l.element!==!1&&(n||(n=new Promise(m=>u=m),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(l.element)?o.elements.push(...l.element):o.elements.push(l.element)),l.message&&(o.message=!0),o),200,!0)(({message:o,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const m=u;return n=null,this.refresh(l).then(()=>m())})),o&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(c=>this.getExtensionElement(c)).filter(c=>!(0,i.isUndefinedOrNull)(c))}async getChildren(c){const r=c?this.getExtensionElement(c):void 0;if(c&&!r)return this.logService.error(`No tree item with id '${c}' found.`),Promise.resolve([]);let v=this.getChildrenNodes(c);return v||(v=await this.fetchChildrenNodes(r)),v?v.map(t=>t.item):void 0}getExtensionElement(c){return this.elements.get(c)}reveal(c,r){r=r||{select:!0,focus:!1};const v=(0,i.isUndefinedOrNull)(r.select)?!0:r.select,t=(0,i.isUndefinedOrNull)(r.focus)?!1:r.focus,h=(0,i.isUndefinedOrNull)(r.expand)?!1:r.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):c?this.refreshPromise.then(()=>this.resolveUnknownParentChain(c)).then(s=>this.resolveTreeNode(c,s[s.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:s.map(u=>u.item)},{select:v,focus:t,expand:h})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:v,focus:t,expand:h})}get message(){return this._message}set message(c){this._message=c,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(c){this._title=c,this.proxy.$setTitle(this.viewId,c,this._description)}get description(){return this._description}set description(c){this._description=c,this.proxy.$setTitle(this.viewId,this._title,c)}setExpanded(c,r){const v=this.getExtensionElement(c);v&&(r?this._onDidExpandElement.fire(Object.freeze({element:v})):this._onDidCollapseElement.fire(Object.freeze({element:v})))}setSelection(c){(0,k.equals)(this._selectedHandles,c)||(this._selectedHandles=c,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(c){c!==this._visible&&(this._visible=c,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(c,r){const v=this.getExtensionElement(r);if(!!v)return(0,S.asPromise)(()=>this.dndController?.onDrop(c,v))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(c,r){if(!this.dataProvider.resolveTreeItem)return;const v=this.elements.get(c);if(v){const t=this.nodes.get(v);if(t){const h=await this.dataProvider.resolveTreeItem(t.extensionItem,v,r)??t.extensionItem;return t.item.tooltip=this.getTooltip(h.tooltip),t.item.command=this.getCommand(t.disposableStore,h.command),t.item}}}resolveUnknownParentChain(c){return this.resolveParent(c).then(r=>r?this.resolveUnknownParentChain(r).then(v=>this.resolveTreeNode(r,v[v.length-1]).then(t=>(v.push(t),v))):Promise.resolve([]))}resolveParent(c){const r=this.nodes.get(c);return r?Promise.resolve(r.parent?this.elements.get(r.parent.item.handle):void 0):(0,S.asPromise)(()=>this.dataProvider.getParent(c))}resolveTreeNode(c,r){const v=this.nodes.get(c);return v?Promise.resolve(v):(0,S.asPromise)(()=>this.dataProvider.getTreeItem(c)).then(t=>this.createHandle(c,t,r,!0)).then(t=>this.getChildren(r?r.item.handle:void 0).then(()=>{const h=this.getExtensionElement(t);if(h){const s=this.nodes.get(h);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${t}`)}))}getChildrenNodes(c){if(c){let r;if(typeof c=="string"){const v=this.getExtensionElement(c);r=v?this.nodes.get(v):void 0}else r=c;return r&&r.children||void 0}return this.roots}async fetchChildrenNodes(c){this.clearChildren(c);const r=new g.CancellationTokenSource(this._refreshCancellationSource.token);try{const v=c?this.nodes.get(c):void 0,t=await this.dataProvider.getChildren(c);if(r.token.isCancellationRequested)return;const h=await Promise.all((0,k.coalesce)(t||[]).map(async s=>{const n=await this.dataProvider.getTreeItem(s);return n&&!r.token.isCancellationRequested?this.createAndRegisterTreeNode(s,n,v):null}));return r.token.isCancellationRequested?void 0:(0,k.coalesce)(h)}finally{r.dispose()}}refresh(c){if(c.some(v=>!v))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new g.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const v=this.getHandlesToRefresh(c);if(v.length)return this.refreshHandles(v)}return Promise.resolve(void 0)}getHandlesToRefresh(c){const r=new Set,v=c.map(h=>this.nodes.get(h));for(const h of v)if(h&&!r.has(h.item.handle)){let s=h;for(;s&&s.parent&&v.findIndex(n=>s&&s.parent&&n&&n.item.handle===s.parent.item.handle)===-1;){const n=this.elements.get(s.parent.item.handle);s=n?this.nodes.get(n):void 0}s&&!s.parent&&r.add(h.item.handle)}const t=[];return r.forEach(h=>{const s=this.elements.get(h);if(s){const n=this.nodes.get(s);n&&(!n.parent||!r.has(n.parent.item.handle))&&t.push(h)}}),t}refreshHandles(c){const r={};return Promise.all(c.map(v=>this.refreshNode(v).then(t=>{t&&(r[v]=t.item)}))).then(()=>Object.keys(r).length?this.proxy.$refresh(this.viewId,r):void 0)}refreshNode(c){const r=this.getExtensionElement(c);if(r){const v=this.nodes.get(r);if(v)return this.clearChildren(r),(0,S.asPromise)(()=>this.dataProvider.getTreeItem(r)).then(t=>{if(t){const h=this.createTreeNode(r,t,v.parent);return this.updateNodeCache(r,h,v,v.parent),v.dispose(),h}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(c,r,v){const t=this.createTreeNode(c,r,v);if(r.id&&this.elements.has(t.item.handle))throw new Error((0,p.localize)(7,null,r.id));return this.addNodeToCache(c,t),this.addNodeToParentCache(t,v),t}getTooltip(c){return I.MarkdownString.isMarkdownString(c)?a.MarkdownString.from(c):c}getCommand(c,r){return r?this.commands.toInternal(r,c):void 0}createTreeNode(c,r,v){const t=new A.DisposableStore,h=this.createHandle(c,r,v),s=this.getLightIconPath(r);return{item:{handle:h,parentHandle:v?v.item.handle:void 0,label:w(r.label,this.extension),description:r.description,resourceUri:r.resourceUri,tooltip:this.getTooltip(r.tooltip),command:this.getCommand(t,r.command),contextValue:r.contextValue,icon:s,iconDark:this.getDarkIconPath(r)||s,themeIcon:this.getThemeIcon(r),collapsibleState:(0,i.isUndefinedOrNull)(r.collapsibleState)?I.TreeItemCollapsibleState.None:r.collapsibleState,accessibilityInformation:r.accessibilityInformation},extensionItem:r,parent:v,children:void 0,disposableStore:t,dispose(){t.dispose()}}}getThemeIcon(c){return c.iconPath instanceof I.ThemeIcon?c.iconPath:void 0}createHandle(c,{id:r,label:v,resourceUri:t},h,s){if(r)return`${T.ID_HANDLE_PREFIX}/${r}`;const n=w(v,this.extension),u=h?h.item.handle:T.LABEL_HANDLE_PREFIX;let o=n?n.label:t?(0,F.basename)(t):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const l=this.nodes.has(c)?this.nodes.get(c).item.handle:void 0,m=this.getChildrenNodes(h)||[];let b,f=0;do{if(b=`${u}/${f}:${o}`,s||!this.elements.has(b)||l===b)break;f++}while(f<=m.length);return b}getLightIconPath(c){if(c.iconPath&&!(c.iconPath instanceof I.ThemeIcon))return typeof c.iconPath=="string"||C.URI.isUri(c.iconPath)?this.getIconPath(c.iconPath):this.getIconPath(c.iconPath.light)}getDarkIconPath(c){if(c.iconPath&&!(c.iconPath instanceof I.ThemeIcon)&&c.iconPath.dark)return this.getIconPath(c.iconPath.dark)}getIconPath(c){return C.URI.isUri(c)?c:C.URI.file(c)}addNodeToCache(c,r){this.elements.set(r.item.handle,c),this.nodes.set(c,r)}updateNodeCache(c,r,v,t){this.elements.delete(r.item.handle),this.nodes.delete(c),r.item.handle!==v.item.handle&&this.elements.delete(v.item.handle),this.addNodeToCache(c,r);const h=this.getChildrenNodes(t)||[],s=h.filter(n=>n.item.handle===v.item.handle)[0];s&&h.splice(h.indexOf(s),1,r)}addNodeToParentCache(c,r){r?(r.children||(r.children=[]),r.children.push(c)):(this.roots||(this.roots=[]),this.roots.push(c))}clearChildren(c){if(c){const r=this.nodes.get(c);if(r){if(r.children)for(const v of r.children){const t=this.elements.get(v.item.handle);t&&this.clear(t)}r.children=void 0}}else this.clearAll()}clear(c){const r=this.nodes.get(c);if(r){if(r.children)for(const v of r.children){const t=this.elements.get(v.item.handle);t&&this.clear(t)}this.nodes.delete(c),this.elements.delete(r.item.handle),r.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(c=>c.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}T.LABEL_HANDLE_PREFIX="0",T.ID_HANDLE_PREFIX="1"}),define(fe[224],me([0,1,15,3,6,12,66,16,129,89]),function(Y,e,p,F,C,y,A,_,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class i extends C.Disposable{constructor(a){super();this.controllerId=a,this.debounceSendDiff=this._register(new p.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new F.Emitter),this.root=new A.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(a){this._resolveHandler=a;for(const g of this.tree.values())this.updateExpandability(g)}collectDiff(){const a=this.diff;return this.diff=[],a}pushDiff(a){const g=this.diff[this.diff.length-1];if(g&&a[0]===1){if(g[0]===1&&g[1].extId===a[1].extId){(0,S.applyTestItemUpdate)(g[1],a[1]);return}if(g[0]===0&&g[1].item.extId===a[1].extId){(0,S.applyTestItemUpdate)(g[1],a[1]);return}}this.diff.push(a),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(a,g){const d=this.tree.get(a);if(!!d){if((d.expandLevels===void 0||g>d.expandLevels)&&(d.expandLevels=g),d.expand===1){const w=this.resolveChildren(d);return w.isOpen()?this.expandChildren(d,g-1):w.wait().then(()=>this.expandChildren(d,g-1))}else if(d.expand===3)return d.resolveBarrier?.isOpen()===!1?d.resolveBarrier.wait().then(()=>this.expandChildren(d,g-1)):this.expandChildren(d,g-1)}}dispose(){for(const a of this.tree.values())(0,A.getPrivateApiFor)(a.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(a,g){switch(g.op){case 2:this.pushDiff([4,a.fullId.toString()]);break;case 1:this.removeItem(I.TestId.joinToString(a.fullId,g.id));break;case 0:this.upsertItem(g.item,a);break;case 4:for(const E of g.ops)this.onTestItemEvent(a,E);break;case 3:const{key:d,value:w,previous:D}=g,T=a.fullId.toString();switch(d){case"canResolveChildren":this.updateExpandability(a);break;case"tags":this.diffTagRefs(w,D,T);break;case"range":this.pushDiff([1,{extId:T,item:{range:_.Range.from(w)}}]);break;case"error":this.pushDiff([1,{extId:T,item:{error:_.MarkdownString.fromStrict(w)||null}}]);break;default:this.pushDiff([1,{extId:T,item:{[d]:w??null}}]);break}break;default:(0,y.assertNever)(g)}}upsertItem(a,g){if(!(a instanceof A.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${a.id} did not`);const d=I.TestId.fromExtHostTestItem(a,this.root.id,g?.actual),w=(0,A.getPrivateApiFor)(a);w.parent&&w.parent!==g?.actual&&w.parent.children.delete(a.id);let D=this.tree.get(d.toString());if(!D){D={fullId:d,actual:a,parent:g?d.parentId:null,expandLevels:g?.expandLevels?g.expandLevels-1:void 0,expand:0},a.tags.forEach(this.incrementTagRefs,this),this.tree.set(D.fullId.toString(),D),this.setItemParent(a,g),this.pushDiff([0,{parent:D.parent&&D.parent.toString(),controllerId:this.controllerId,expand:D.expand,item:_.TestItem.from(a)}]),this.connectItemAndChildren(a,D,g);return}if(D.actual===a){this.connectItem(a,D,g);return}const T=D.actual.children,E=D.actual,c=(0,A.diffTestItems)(E,a);(0,A.getPrivateApiFor)(E).listener=void 0,D.actual=a,D.expand=0;for(const[r,v]of c)this.onTestItemEvent(D,{op:3,key:r,value:v,previous:E[r]});this.connectItemAndChildren(a,D,g);for(const r of T)a.children.get(r.id)||this.removeItem(I.TestId.joinToString(d,r.id))}diffTagRefs(a,g,d){const w=new Set(g.map(D=>D.id));for(const D of a)w.delete(D.id)||this.incrementTagRefs(D);this.pushDiff([1,{extId:d,item:{tags:a.map(D=>_.TestTag.namespace(this.controllerId,D.id))}}]),w.forEach(this.decrementTagRefs,this)}incrementTagRefs(a){const g=this.tags.get(a.id);g?g.refCount++:(this.tags.set(a.id,{refCount:1}),this.pushDiff([5,{id:_.TestTag.namespace(this.controllerId,a.id),ctrlLabel:this.root.label}]))}decrementTagRefs(a){const g=this.tags.get(a);g&&!--g.refCount&&(this.tags.delete(a),this.pushDiff([6,_.TestTag.namespace(this.controllerId,a)]))}setItemParent(a,g){(0,A.getPrivateApiFor)(a).parent=g&&g.actual!==this.root?g.actual:void 0}connectItem(a,g,d){this.setItemParent(a,d);const w=(0,A.getPrivateApiFor)(a);w.parent=d?.actual,w.listener=D=>this.onTestItemEvent(g,D),this.updateExpandability(g)}connectItemAndChildren(a,g,d){this.connectItem(a,g,d);for(const w of a.children)this.upsertItem(w,g)}updateExpandability(a){let g;this._resolveHandler?a.resolveBarrier?g=a.resolveBarrier.isOpen()?3:2:g=a.actual.canResolveChildren?1:0:g=0,g!==a.expand&&(a.expand=g,this.pushDiff([1,{extId:a.fullId.toString(),expand:g}]),g===1&&a.expandLevels!==void 0&&this.resolveChildren(a))}expandChildren(a,g){if(g<0)return;const d=[];for(const w of a.actual.children){const D=this.expand(I.TestId.joinToString(a.fullId,w.id),g);(0,p.isThenable)(D)&&d.push(D)}if(d.length)return Promise.all(d).then(()=>{})}resolveChildren(a){if(a.resolveBarrier)return a.resolveBarrier;if(!this._resolveHandler){const D=new p.Barrier;return D.open(),D}a.expand=2,this.pushExpandStateUpdate(a);const g=a.resolveBarrier=new p.Barrier,d=D=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),a.actual!==this.root&&(a.actual.error=D.stack||D.message||String(D))};let w;try{w=this._resolveHandler(a.actual===this.root?void 0:a.actual)}catch(D){d(D)}return(0,p.isThenable)(w)?w.catch(d).then(()=>{g.open(),this.updateExpandability(a)}):(g.open(),this.updateExpandability(a)),a.resolveBarrier}pushExpandStateUpdate(a){this.pushDiff([1,{extId:a.fullId.toString(),expand:a.expand}])}removeItem(a){const g=this.tree.get(a);if(!g)throw new Error("attempting to remove non-existent child");this.pushDiff([2,a]);const d=[g];for(;d.length;){const w=d.pop();if(!!w){(0,A.getPrivateApiFor)(w.actual).listener=void 0;for(const D of w.actual.tags)this.decrementTagRefs(D.id);this.tree.delete(w.fullId.toString());for(const D of w.actual.children)d.push(this.tree.get(I.TestId.joinToString(w.fullId,D.id)))}}}flushDiff(){const a=this.collectDiff();a.length&&this.diffOpEmitter.fire(a)}}e.SingleUseTestCollection=i}),define(fe[225],me([0,1,4,186]),function(Y,e,p,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,p.refineServiceDecorator)(F.IEnvironmentService)}),define(fe[226],me([0,1,26,3,8]),function(Y,e,p,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class y{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=y;class A{constructor(i){this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(p.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(p.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let k of i.activationEvents)k==="onUri"&&(k=`onUri:${p.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(k)||this._activationMap.set(k,[]),this._activationMap.get(k).push(i)}}keepOnly(i){const k=new Set;i.forEach(a=>k.add(p.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>k.has(p.ExtensionIdentifier.toKey(a.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,k){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const a=A._findLoopingExtensions(this._extensionDescriptions);if(k=k.concat(a.map(g=>g.identifier)),k.length>0){const g=new Set;k.forEach(d=>g.add(p.ExtensionIdentifier.toKey(d))),this._extensionDescriptions=this._extensionDescriptions.filter(d=>!g.has(p.ExtensionIdentifier.toKey(d.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new y(a)}static _findLoopingExtensions(i){const k=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(D){this._nodesSet.has(D)||(this._nodesSet.add(D),this._nodesArr.push(D))}addArc(D,T){this.addNode(D),this.addNode(T),this._arcs.has(D)?this._arcs.get(D).push(T):this._arcs.set(D,[T])}getArcs(D){return this._arcs.has(D)?this._arcs.get(D):[]}hasOnlyGoodArcs(D,T){const E=k.getArcs(D);for(let c=0;c<E.length;c++)if(!T.has(E[c]))return!1;return!0}getNodes(){return this._nodesArr}};let a=new Map;for(let D of i){const T=p.ExtensionIdentifier.toKey(D.identifier);if(a.set(T,D),D.extensionDependencies)for(let E of D.extensionDependencies){const c=p.ExtensionIdentifier.toKey(E);k.addArc(T,c)}}let g=new Set;k.getNodes().filter(D=>k.getArcs(D).length===0).forEach(D=>g.add(D));let d=k.getNodes().filter(D=>!g.has(D)),w;do{w=!1;for(let D=0;D<d.length;D++){const T=d[D];k.hasOnlyGoodArcs(T,g)&&(d.splice(D,1),D--,g.add(T),w=!0)}}while(w);return d.map(D=>a.get(D))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(p.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const k=this._activationMap.get(i);return k?k.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const k=this._extensionsMap.get(p.ExtensionIdentifier.toKey(i));return k||void 0}}e.ExtensionDescriptionRegistry=A;var _;(function(I){I[I.Builtin=0]="Builtin",I[I.User=1]="User",I[I.Dev=2]="Dev"})(_||(_={}));function S(I,i){const k=I.isBuiltin?0:I.isUnderDevelopment?2:1,a=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(k!==a)return k-a;const g=C.posix.basename(I.extensionLocation.path),d=C.posix.basename(i.extensionLocation.path);return g<d?-1:g>d?1:0}}),define(fe[227],me([0,1,22]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var F;(function(_){_[_.VersionMismatch=55]="VersionMismatch",_[_.UnexpectedError=81]="UnexpectedError"})(F=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var C;(function(_){_[_.Initialized=0]="Initialized",_[_.Ready=1]="Ready",_[_.Terminate=2]="Terminate"})(C=e.MessageType||(e.MessageType={}));function y(_){const S=p.VSBuffer.alloc(1);switch(_){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=y;function A(_,S){if(_.byteLength!==1)return!1;switch(_.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=A}),define(fe[35],me([0,1,3,2,4,26,195]),function(Y,e,p,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new y.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,C.createDecorator)("extensionService");var _;(function(r){r[r.None=0]="None",r[r.LocalProcess=1]="LocalProcess",r[r.LocalWebWorker=2]="LocalWebWorker",r[r.Remote=3]="Remote"})(_=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function S(r){switch(r){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=S;class I{constructor(v){this.dependency=v}}e.MissingExtensionDependency=I;var i;(function(r){r[r.LocalProcess=0]="LocalProcess",r[r.LocalWebWorker=1]="LocalWebWorker",r[r.Remote=2]="Remote"})(i=e.ExtensionHostKind||(e.ExtensionHostKind={}));function k(r){switch(r){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=k;class a{constructor(v,t,h,s){this.codeLoadingTime=v,this.activateCallTime=t,this.activateResolvedTime=h,this.activationReason=s}}e.ActivationTimes=a;class g{constructor(v,t){this.description=v,this.value=t}}e.ExtensionPointContribution=g,e.ExtensionHostLogFileName="exthost";var d;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(d=e.ActivationKind||(e.ActivationKind={}));function w(r){r.enableProposedApi||D(r)}e.checkProposedApiEnabled=w;function D(r){throw new Error(`[${r.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.throwProposedApiError=D;function T(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,A.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation}}e.toExtension=T;function E(r,v){return{identifier:new y.ExtensionIdentifier(r.identifier.id),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!v,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid}}e.toExtensionDescription=E;class c{constructor(){this.onDidRegisterExtensions=p.Event.None,this.onDidChangeExtensionsStatus=p.Event.None,this.onDidChangeExtensions=p.Event.None,this.onWillActivateByEvent=p.Event.None,this.onDidChangeResponsiveChange=p.Event.None}activateByEvent(v){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(v){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(v){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(v){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(v,t){return Promise.resolve()}_onWillActivateExtension(v){}_onDidActivateExtension(v,t,h,s,n){}_onDidActivateExtensionError(v,t){}_onExtensionRuntimeError(v,t){}_onExtensionHostExit(v){}}e.NullExtensionService=c}),define(fe[228],me([0,1,26,35,13]),function(Y,e,p,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class A{constructor(d,w,D,T){this.startup=d,this.codeLoadingTime=w,this.activateCallTime=D,this.activateResolvedTime=T}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class _{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,w){return d===-1||w===-1?-1:w-d}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=_;class S{constructor(d,w,D,T,E,c){this.activationFailed=d,this.activationFailedError=w,this.activationTimes=D,this.module=T,this.exports=E,this.subscriptions=c}}e.ActivatedExtension=S;class I extends S{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=I;class i extends S{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class k extends S{constructor(d){super(!0,d,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=k;let a=class{constructor(d,w,D,T,E){this._logService=E,this._registry=d,this._resolvedExtensionsSet=new Set,w.forEach(c=>this._resolvedExtensionsSet.add(p.ExtensionIdentifier.toKey(c))),this._hostExtensionsMap=new Map,D.forEach(c=>this._hostExtensionsMap.set(p.ExtensionIdentifier.toKey(c),c)),this._host=T,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(d){const w=p.ExtensionIdentifier.toKey(d);return this._activatedExtensions.has(w)}getActivatedExtension(d){const w=p.ExtensionIdentifier.toKey(d),D=this._activatedExtensions.get(w);if(!D)throw new Error("Extension `"+d.value+"` is not known or not activated");return D}activateByEvent(d,w){if(this._alreadyActivatedEvents[d])return y;const D=this._registry.getExtensionDescriptionsForActivationEvent(d);return this._activateExtensions(D.map(T=>({id:T.identifier,reason:{startup:w,extensionId:T.identifier,activationEvent:d}}))).then(()=>{this._alreadyActivatedEvents[d]=!0})}activateById(d,w){const D=this._registry.getExtensionDescription(d);if(!D)throw new Error("Extension `"+d+"` is not known");return this._activateExtensions([{id:D.identifier,reason:w}])}_handleActivateRequest(d,w,D){if(this._hostExtensionsMap.has(p.ExtensionIdentifier.toKey(d.id))){w[p.ExtensionIdentifier.toKey(d.id)]=d;return}const T=this._registry.getExtensionDescription(d.id);if(!T){const r=new Error(`Cannot activate unknown extension '${d.id.value}'`);this._host.onExtensionActivationError(d.id,r,new F.MissingExtensionDependency(d.id.value)),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(d.id),new k(r));return}const E=typeof T.extensionDependencies=="undefined"?[]:T.extensionDependencies;let c=!0;for(let r=0,v=E.length;r<v;r++){const t=E[r];if(this._resolvedExtensionsSet.has(p.ExtensionIdentifier.toKey(t)))continue;const h=this._activatedExtensions.get(p.ExtensionIdentifier.toKey(t));if(h&&!h.activationFailed)continue;if(h&&h.activationFailed){const o=T.displayName||T.identifier.value,l=this._registry.getExtensionDescription(t),m=l&&l.displayName||t,b=new Error(`Cannot activate the '${o}' extension because its dependency '${m}' failed to activate`);b.detail=h.activationFailedError,this._host.onExtensionActivationError(T.identifier,b,null),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(T.identifier),new k(b));return}if(this._hostExtensionsMap.has(p.ExtensionIdentifier.toKey(t))){c=!1,w[p.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(p.ExtensionIdentifier.toKey(t)),reason:d.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){if(!s.main&&!s.browser)continue;c=!1,w[p.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:d.reason};continue}const n=T.displayName||T.identifier.value,u=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(T.identifier,u,new F.MissingExtensionDependency(t)),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(T.identifier),new k(u));return}c?w[p.ExtensionIdentifier.toKey(T.identifier)]=d:D.push(d)}_activateExtensions(d){if(d.length===0||(d=d.filter(E=>!this._activatedExtensions.has(p.ExtensionIdentifier.toKey(E.id))),d.length===0))return Promise.resolve(void 0);const w=Object.create(null),D=[];for(let E=0,c=d.length;E<c;E++)this._handleActivateRequest(d[E],w,D);for(let E=0,c=D.length;E<c;E++){const r=p.ExtensionIdentifier.toKey(D[E].id);w[r]&&delete w[r]}const T=Object.keys(w).map(E=>w[E]);return D.length===0?Promise.all(T.map(E=>this._activateExtension(E.id,E.reason))).then(E=>{}):this._activateExtensions(T).then(E=>this._activateExtensions(D))}_activateExtension(d,w){const D=p.ExtensionIdentifier.toKey(d);if(this._activatedExtensions.has(D))return Promise.resolve(void 0);const T=this._activatingExtensions.get(D);if(T)return T;const E=this._host.actualActivateExtension(d,w).then(void 0,c=>{const r=new Error;return c&&c.name&&(r.name=c.name),c&&c.message?r.message=`Activating extension '${d.value}' failed: ${c.message}.`:r.message=`Activating extension '${d.value}' failed: ${c}.`,c&&c.stack&&(r.stack=c.stack),this._host.onExtensionActivationError(d,r,null),this._logService.error(`Activating extension ${d.value} failed due to an error:`),this._logService.error(c),new k(c)}).then(c=>{this._activatedExtensions.set(D,c),this._activatingExtensions.delete(D)});return this._activatingExtensions.set(D,E),E}};a=Ve([$e(4,C.ILogService)],a),e.ExtensionsActivator=a}),define(fe[229],me([0,1,13,35,27,10,117]),function(Y,e,p,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let _=class extends p.LogService{constructor(I){if(I.logFile.scheme!==y.Schemas.file)throw new Error("Only file-logging supported");super(new A.SpdLogLogger(F.ExtensionHostLogFileName,I.logFile.fsPath,!0,I.logLevel))}$setLevel(I){this.setLevel(I)}};_=Ve([$e(0,C.IExtHostInitDataService)],_),e.ExtHostLogService=_}),define(fe[230],me([0,1,17]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class F{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,A)=>{this._actualOk=y,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):(0,p.onUnexpectedError)(y))}then(y,A){return this._ensureActual().then(y,A)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=F}),define(fe[55],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class p{constructor(I,i){this._proxyIdentifierBrand=void 0,this.isMain=I,this.sid=i,this.nid=++p.count}}e.ProxyIdentifier=p,p.count=0;const F=[];function C(S){const I=new p(!0,S);return F[I.nid]=I,I}e.createMainContextProxyIdentifier=C;function y(S){const I=new p(!1,S);return F[I.nid]=I,I}e.createExtHostContextProxyIdentifier=y;function A(S){return F[S].sid}e.getStringIdentifierForProxy=A;class _{constructor(I){this.value=I}}e.SerializableObjectWithBuffers=_}),define(fe[5],me([0,1,62,2,55]),function(Y,e,p,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var y;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(y=e.UIKind||(e.UIKind={}));var A;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var _;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(_=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var I;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(I=e.CellOutputKind||(e.CellOutputKind={}));var i;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var k;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(k=e.CandidatePortSource||(e.CandidatePortSource={}));var a;(function(c){c.name="$ident";function r(t,h){return Object.defineProperty(t,c.name,{value:h,enumerable:!0}),t}c.mixin=r;function v(t){return t[c.name]}c.of=v})(a=e.ObjectIdentifier||(e.ObjectIdentifier={}));class g{static mixin(r){return r._id=g._n++,r}}e.IdObject=g,g._n=0;var d;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n"})(d=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var w;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(w=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var D;(function(c){c[c.File=1]="File",c[c.Text=2]="Text",c[c.Cell=3]="Cell"})(D=e.WorkspaceEditType||(e.WorkspaceEditType={}));function T(c){if(c&&c.edits)for(const r of c.edits)typeof r.resource=="object"?r.resource=F.URI.revive(r.resource):(r.newUri=F.URI.revive(r.newUri),r.oldUri=F.URI.revive(r.oldUri)),r.metadata&&r.metadata.iconPath&&(r.metadata=(0,p.revive)(r.metadata));return c}e.reviveWorkspaceEditDto=T;var E;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,C.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,C.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,C.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,C.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,C.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,C.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,C.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,C.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,C.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,C.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,C.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,C.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,C.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,C.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,C.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,C.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,C.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,C.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,C.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,C.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,C.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,C.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,C.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,C.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,C.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,C.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,C.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,C.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,C.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,C.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,C.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,C.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,C.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,C.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,C.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,C.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,C.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,C.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,C.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,C.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,C.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,C.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,C.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,C.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,C.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,C.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,C.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,C.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,C.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,C.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,C.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,C.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,C.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,C.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,C.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,C.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,C.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,C.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,C.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,C.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,C.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,C.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,C.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,C.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,C.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,C.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(fe[90],me([0,1,5,3,4]),function(Y,e,p,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class y{constructor(_){this._onDidChangePassword=new F.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=_.getProxy(p.MainContext.MainThreadSecretState)}async $onDidChangePassword(_){this._onDidChangePassword.fire(_)}get(_,S){return this._proxy.$getPassword(_,S)}store(_,S,I){return this._proxy.$setPassword(_,S,I)}delete(_,S){return this._proxy.$deletePassword(_,S)}}e.ExtHostSecretState=y,e.IExtHostSecretState=(0,C.createDecorator)("IExtHostSecretState")}),define(fe[68],me([0,1,4,13,5,14]),function(Y,e,p,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,p.createDecorator)("IExtHostApiDeprecationService");let A=class{constructor(S,I){this._extHostLogService=I,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(C.MainContext.MainThreadTelemetry)}report(S,I,i){const k=this.getUsageKey(S,I);this._reportedUsages.has(k)||(this._reportedUsages.add(k),I.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:I.identifier.value,apiId:S}))}getUsageKey(S,I){return`${S}-${I.identifier.value}`}};A=Ve([$e(0,y.IExtHostRpcService),$e(1,F.ILogService)],A),e.ExtHostApiDeprecationService=A,e.NullApiDeprecationService=Object.freeze(new class{report(_,S,I){}})}),define(fe[231],me([0,1,3,5,7,26]),function(Y,e,p,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new p.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(F.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,I,i,k={}){const a=y.ExtensionIdentifier.toKey(S.identifier),g=this._inFlightRequests.get(a)||[],d=[...i].sort().join(" ");let w=g.find(D=>D.scopes===d);if(w)return w.result;{const D=this._getSession(S,a,I,i,k);w={scopes:d,result:D},g.push(w),this._inFlightRequests.set(a,g);try{await D}finally{const T=g.findIndex(E=>E.scopes===d);T>-1&&(g.splice(T),this._inFlightRequests.set(a,g))}return D}}async _getSession(S,I,i,k,a={}){await this._proxy.$ensureProvider(i);const g=S.displayName||S.name;return this._proxy.$getSession(i,k,I,g,a)}async removeSession(S,I){const i=this._authenticationProviders.get(S);return i?i.provider.removeSession(I):this._proxy.$removeSession(S,I)}registerAuthenticationProvider(S,I,i,k){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:I,provider:i,options:k??{supportsMultipleAccounts:!1}}),this._providers.find(g=>g.id===S)||this._providers.push({id:S,label:I});const a=i.onDidChangeSessions(g=>{this._proxy.$sendDidChangeSessions(S,{added:g.added??[],changed:g.changed??[],removed:g.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,I,k?.supportsMultipleAccounts??!1),new C.Disposable(()=>{a.dispose(),this._authenticationProviders.delete(S);const g=this._providers.findIndex(d=>d.id===S);g>-1&&this._providers.splice(g),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,I){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.createSession(I));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,I){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,I){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,I){return this._onDidChangeSessions.fire({provider:{id:S,label:I}}),Promise.resolve()}}e.ExtHostAuthentication=A}),define(fe[232],me([0,1,5,14,16]),function(Y,e,p,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let y=class{constructor(_,S){this._extHostDocumentsAndEditors=S,this._proxy=_.getProxy(p.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(_){const S=C.WorkspaceEdit.from(_,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};y=Ve([$e(0,F.IExtHostRpcService)],y),e.ExtHostBulkEdits=y}),define(fe[233],me([0,1,5]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class F{constructor(y){const A=y.getProxy(p.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(_){return A.$writeText(_)}})}}e.ExtHostClipboard=F}),define(fe[40],me([0,1,12,7,16,25,5,18,13,62,42,51,2,6,4,14,66,22,55,52]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d,w,D,T,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{constructor(u,o){this._commands=new Map,this._apiCommands=new Map,this._proxy=u.getProxy(A.MainContext.MainThreadCommands),this._logService=o,this.converter=new v(this,l=>{const m=this._apiCommands.get(l);return m?.result===h.Void?m:void 0},o),this._argumentProcessors=[{processArgument(l){return(0,I.revive)(l)}},{processArgument(l){return(0,y.cloneAndChange)(l,function(m){if(i.Range.isIRange(m))return C.Range.to(m);if(k.Position.isIPosition(m))return C.Position.to(m);if(i.Range.isIRange(m.range)&&a.URI.isUri(m.uri))return C.location.to(m);if(m instanceof T.VSBuffer)return m.buffer.buffer;if(!Array.isArray(m))return m})}}]}registerArgumentProcessor(u){this._argumentProcessors.push(u)}registerApiCommand(u){const o=this.registerCommand(!1,u.id,async(...l)=>{const m=u.args.map((f,P)=>{if(!f.validate(l[P]))throw new Error(`Invalid argument '${f.name}' when running '${u.id}', received: ${l[P]}`);return f.convert(l[P])}),b=await this.executeCommand(u.internalId,...m);return u.result.convert(b,l,this.converter)},void 0,{description:u.description,args:u.args,returns:u.result.description});return this._apiCommands.set(u.id,u),new F.Disposable(()=>{o.dispose(),this._apiCommands.delete(u.id)})}registerCommand(u,o,l,m,b,f){if(this._logService.trace("ExtHostCommands#registerCommand",o),!o.trim().length)throw new Error("invalid id");if(this._commands.has(o))throw new Error(`command '${o}' already exists`);return this._commands.set(o,{callback:l,thisArg:m,description:b,extension:f}),u&&this._proxy.$registerCommand(o),new F.Disposable(()=>{this._commands.delete(o)&&u&&this._proxy.$unregisterCommand(o)})}executeCommand(u,...o){return this._logService.trace("ExtHostCommands#executeCommand",u),this._doExecuteCommand(u,o,!0)}async _doExecuteCommand(u,o,l){if(this._commands.has(u))return this._executeContributedCommand(u,o,!1);{let m=!1;const b=(0,y.cloneAndChange)(o,function(f){if(f instanceof F.Position)return C.Position.from(f);if(f instanceof F.Range)return C.Range.from(f);if(f instanceof F.Location)return C.location.from(f);if(F.NotebookRange.isNotebookRange(f))return C.NotebookRange.from(f);if(f instanceof ArrayBuffer)return m=!0,T.VSBuffer.wrap(new Uint8Array(f));if(f instanceof Uint8Array)return m=!0,T.VSBuffer.wrap(f);if(!Array.isArray(f))return f});try{const f=await this._proxy.$executeCommand(u,m?new E.SerializableObjectWithBuffers(b):b,l);return(0,I.revive)(f)}catch(f){if(f instanceof Error&&f.message==="$executeCommand:retry")return this._doExecuteCommand(u,o,!1);throw f}}}async _executeContributedCommand(u,o,l){const m=this._commands.get(u);if(!m)throw new Error("Unknown command");let{callback:b,thisArg:f,description:P}=m;if(P)for(let L=0;L<P.args.length;L++)try{(0,p.validateConstraint)(o[L],P.args[L].constraint)}catch(M){throw new Error(`Running the contributed command: '${u}' failed. Illegal argument '${P.args[L].name}' - ${P.args[L].description}`)}try{return await b.apply(f,o)}catch(L){if(u===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(...o);M&&(u=M.command)}throw this._logService.error(L,u,m.extension?.identifier),l?new class extends Error{constructor(){super((0,c.toErrorMessage)(L));this.id=u,this.source=m.extension?.displayName??m.extension?.name}}:L}}$executeContributedCommand(u,...o){return this._logService.trace("ExtHostCommands#$executeContributedCommand",u),this._commands.has(u)?(o=o.map(l=>this._argumentProcessors.reduce((m,b)=>b.processArgument(m),l)),this._executeContributedCommand(u,o,!0)):Promise.reject(new Error(`Contributed command '${u}' does not exist.`))}getCommands(u=!1){return this._logService.trace("ExtHostCommands#getCommands",u),this._proxy.$getCommands().then(o=>(u&&(o=o.filter(l=>l[0]!=="_")),o))}$getContributedCommandHandlerDescriptions(){const u=Object.create(null);for(let[o,l]of this._commands){let{description:m}=l;m&&(u[o]=m)}return Promise.resolve(u)}};r=Ve([$e(0,w.IExtHostRpcService),$e(1,S.ILogService)],r),e.ExtHostCommands=r,e.IExtHostCommands=(0,d.createDecorator)("IExtHostCommands");class v{constructor(u,o,l){this._commands=u,this._lookupApiCommand=o,this._logService=l,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(u,o){if(!u)return;const l={$ident:void 0,id:u.command,title:u.title,tooltip:u.tooltip};if(!u.command)return l;const m=this._lookupApiCommand(u.command);if(m)l.id=m.internalId,l.arguments=m.args.map((b,f)=>b.convert(u.arguments&&u.arguments[f]));else if((0,_.isNonEmptyArray)(u.arguments)){const b=++this._cachIdPool;this._cache.set(b,u),o.add((0,g.toDisposable)(()=>{this._cache.delete(b),this._logService.trace("CommandsConverter#DISPOSE",b)})),l.$ident=b,l.id=this.delegatingCommandId,l.arguments=[b],this._logService.trace("CommandsConverter#CREATE",u.command,b)}return l}fromInternal(u){const o=A.ObjectIdentifier.of(u);return typeof o=="number"?this._cache.get(o):{command:u.id,title:u.title,arguments:u.arguments}}getActualCommand(...u){return this._cache.get(u[0])}_executeConvertedCommand(...u){const o=this.getActualCommand(...u);return this._logService.trace("CommandsConverter#EXECUTE",u[0],o?o.command:"MISSING"),o?this._commands.executeCommand(o.command,...o.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=v;class t{constructor(u,o,l,m){this.name=u,this.description=o,this.validate=l,this.convert=m}optional(){return new t(this.name,`(optional) ${this.description}`,u=>u==null||this.validate(u),u=>u===void 0?void 0:u===null?null:this.convert(u))}with(u,o){return new t(u??this.name,o??this.description,this.validate,this.convert)}}e.ApiCommandArgument=t,t.Uri=new t("uri","Uri of a text document",n=>a.URI.isUri(n),n=>n),t.Position=new t("position","A position in a text document",n=>F.Position.isPosition(n),C.Position.from),t.Range=new t("range","A range in a text document",n=>F.Range.isRange(n),C.Range.from),t.Selection=new t("selection","A selection in a text document",n=>F.Selection.isSelection(n),C.Selection.from),t.Number=new t("number","",n=>typeof n=="number",n=>n),t.String=new t("string","",n=>typeof n=="string",n=>n),t.CallHierarchyItem=new t("item","A call hierarchy item",n=>n instanceof F.CallHierarchyItem,C.CallHierarchyItem.from),t.TypeHierarchyItem=new t("item","A type hierarchy item",n=>n instanceof F.TypeHierarchyItem,C.TypeHierarchyItem.from),t.TestItem=new t("testItem","A VS Code TestItem",n=>n instanceof D.TestItemImpl,C.TestItem.from);class h{constructor(u,o){this.description=u,this.convert=o}}e.ApiCommandResult=h,h.Void=new h("no result",n=>n);class s{constructor(u,o,l,m,b){this.id=u,this.internalId=o,this.description=l,this.args=m,this.result=b}}e.ApiCommand=s}),define(fe[234],me([0,1,16,7,84,40,18,112]),function(Y,e,p,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",i(p.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,g)=>{if((0,A.isFalsyOrEmpty)(a))return;class d extends F.SymbolInformation{static to(D){const T=new d(D.name,p.SymbolKind.to(D.kind),D.containerName||"",new F.Location(g[0],p.Range.to(D.range)));return T.detail=D.detail,T.range=T.location.range,T.selectionRange=p.Range.to(D.selectionRange),T.children=D.children?D.children.map(d.to):[],T}}return a.map(d.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(p.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(p.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(p.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",k)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",k)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",k)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",k)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",i(p.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",i(p.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(g=>F.Position.isPosition(g)),a=>a.map(p.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(g=>{let d;for(const w of g.reverse())d=new F.SelectionRange(p.Range.to(w),d);return d}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>{const g=[];if(Array.isArray(a))for(let d of a)g.push(...d[1].map(p.WorkspaceSymbol.to));return g})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(p.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(p.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(p.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to a range and placeholder text.",a=>{if(!!a)return{range:p.Range.to(a.range),placeholder:a.text}})),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return p.WorkspaceEdit.to(a)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(p.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new F.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const g=(0,_.decodeSemanticTokensDto)(a);if(g.type==="full")return new F.SemanticTokens(g.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new F.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const g=(0,_.decodeSemanticTokensDto)(a);if(g.type==="full")return new F.SemanticTokens(g.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,g,d)=>{if(!a)return new F.CompletionList([]);const w=a.suggestions.map(D=>p.CompletionItem.to(D,d));return new F.CompletionList(w,a.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return p.SignatureHelp.to(a)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,g,d)=>i(w=>new F.CodeLens(p.Range.to(w.range),w.command&&d.fromInternal(w.command)))(a))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>F.Range.isRange(a),a=>F.Selection.isSelection(a)?p.Selection.from(a):p.Range.from(a)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,g,d)=>i(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(w.command)}else{const D=new F.CodeAction(w.title,w.kind?new F.CodeActionKind(w.kind):void 0);return w.edit&&(D.edit=p.WorkspaceEdit.to(w.edit)),w.command&&(D.command=d.fromInternal(w.command)),D.isPreferred=w.isPreferred,D}})(a))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(g=>new F.ColorInformation(p.Range.to(g.range),p.Color.to(g.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",a=>a instanceof F.Color,p.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:p.Range.from(a.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(p.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",a=>a.map(p.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",i(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(g=>p.NotebookExclusiveDocumentPattern.to(g))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(p.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[p.ViewColumn.from(a.viewColumn),p.TextEditorOpenOptions.from(a)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[p.ViewColumn.from(a.viewColumn),p.TextEditorOpenOptions.from(a)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[p.ViewColumn.from(a.viewColumn),p.TextEditorOpenOptions.from(a)]).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(p.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(p.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(p.TypeHierarchyItem.to))),new y.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[y.ApiCommandArgument.TestItem],y.ApiCommandResult.Void)];class I{static register(g){S.forEach(g.registerApiCommand,g)}}e.ExtHostApiCommands=I;function i(a){return g=>{if(Array.isArray(g))return g.map(a)}}function k(a){if(!Array.isArray(a))return;const g=[];for(const d of a)C.isLocationLink(d)?g.push(p.DefinitionLink.to(d)):g.push(p.location.to(d));return g}}),define(fe[235],me([0,1,15,60,3,6,2,84,26,16,7,5]),function(Y,e,p,F,C,y,A,_,S,I,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function a(g,d,w){const D=g.getProxy(k.MainContext.MainThreadComments);class T{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,d.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const u=this._commentControllers.get(n.handle);return u||n}else if(n&&n.$mid===7){const u=this._commentControllers.get(n.commentControlHandle);if(!u)return n;const o=u.getCommentThread(n.commentThreadHandle);return o||n}else if(n&&n.$mid===8){const u=this._commentControllers.get(n.thread.commentControlHandle);if(!u)return n;const o=u.getCommentThread(n.thread.commentThreadHandle);return o?{thread:o,text:n.text}:n}else if(n&&n.$mid===9){const u=this._commentControllers.get(n.thread.commentControlHandle);if(!u)return n;const o=u.getCommentThread(n.thread.commentThreadHandle);if(!o)return n;let l=n.commentUniqueId,m=o.getCommentByUniqueId(l);return m||n}else if(n&&n.$mid===10){const u=this._commentControllers.get(n.thread.commentControlHandle);if(!u)return n;const o=u.getCommentThread(n.thread.commentThreadHandle);if(!o)return n;let l=n.text,m=n.commentUniqueId,b=o.getCommentByUniqueId(m);return b?(b.body=l,b):n}return n}})}createCommentController(n,u,o){const l=T.handlePool++,m=new c(n,l,u,o);this._commentControllers.set(m.handle,m);const b=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(n.identifier))||[];return b.push(m),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(n.identifier),b),m.value}$createCommentThreadTemplate(n,u,o){const l=this._commentControllers.get(n);!l||l.$createCommentThreadTemplate(u,o)}async $updateCommentThreadTemplate(n,u,o){const l=this._commentControllers.get(n);!l||l.$updateCommentThreadTemplate(u,o)}$deleteCommentThread(n,u){const o=this._commentControllers.get(n);o&&o.$deleteCommentThread(u)}$provideCommentingRanges(n,u,o){const l=this._commentControllers.get(n);if(!l||!l.commentingRangeProvider)return Promise.resolve(void 0);const m=w.getDocument(A.URI.revive(u));return(0,p.asPromise)(()=>l.commentingRangeProvider.provideCommentingRanges(m,o)).then(b=>b?b.map(f=>I.Range.from(f)):void 0)}$toggleReaction(n,u,o,l,m){const b=this._commentControllers.get(n);return!b||!b.reactionHandler?Promise.resolve(void 0):(0,p.asPromise)(()=>{const f=b.getCommentThread(u);if(f){const P=f.getCommentByUniqueId(l.uniqueIdInThread);if(b!==void 0&&P&&b.reactionHandler)return b.reactionHandler(P,t(m))}return Promise.resolve(void 0)})}dispose(){}}T.handlePool=0;class E{constructor(n,u,o,l,m,b,f){this._commentControllerHandle=u,this._id=o,this._uri=l,this._range=m,this._comments=b,this.handle=E._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new C.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputDisposables.value=new y.DisposableStore,this._id===void 0&&(this._id=`${n}.${this.handle}`),D.$createCommentThread(u,this.handle,this._id,this._uri,I.Range.from(this._range),f),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=b,this._localDisposables.push({dispose:()=>{D.$deleteCommentThread(u,this.handle)}});const P=this;this.value={get uri(){return P.uri},get range(){return P.range},set range(L){P.range=L},get comments(){return P.comments},set comments(L){P.comments=L},get collapsibleState(){return P.collapsibleState},set collapsibleState(L){P.collapsibleState=L},get canReply(){return P.canReply},set canReply(L){P.canReply=L},get contextValue(){return P.contextValue},set contextValue(L){P.contextValue=L},get label(){return P.label},set label(L){P.label=L},dispose:()=>{P.dispose()}}}set threadId(n){this._id=n}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(n){n.isEqual(this._range)||(this._range=n,this.modifications.range=n,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(n){this._canReply!==n&&(this._canReply=n,this.modifications.canReply=n,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(n){this._label=n,this.modifications.label=n,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(n){this._contextValue=n,this.modifications.contextValue=n,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(n){this._comments=n,this.modifications.comments=n,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(n){this._collapseState=n,this.modifications.collapsibleState=n,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new y.DisposableStore);const n=o=>Object.prototype.hasOwnProperty.call(this.modifications,o),u={};n("range")&&(u.range=I.Range.from(this._range)),n("label")&&(u.label=this.label),n("contextValue")&&(u.contextValue=this.contextValue),n("comments")&&(u.comments=this._comments.map(o=>r(this,o,this._commentsMap))),n("collapsibleState")&&(u.collapseState=h(this._collapseState)),n("canReply")&&(u.canReply=this.canReply),this.modifications={},D.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,u)}getCommentByUniqueId(n){for(let u of this._commentsMap){let o=u[0],l=u[1];if(n===l)return o}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(n=>n.dispose())}}E._handlePool=0,Ve([(0,F.debounce)(100)],E.prototype,"eventuallyUpdateCommentThread",null);class c{constructor(n,u,o,l){this._extension=n,this._handle=u,this._id=o,this._label=l,this._threads=new Map,D.$registerCommentController(this.handle,o,l);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(b){m.options=b},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(b){m.commentingRangeProvider=b},get reactionHandler(){return m.reactionHandler},set reactionHandler(b){m.reactionHandler=b},createCommentThread(b,f,P){return m.createCommentThread(b,f,P).value},dispose:()=>{m.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{D.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(n){this._reactionHandler=n,D.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!n})}get options(){return this._options}set options(n){this._options=n,D.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(n,u,o,l){if(typeof n=="string"){const m=new E(this.id,this.handle,n,u,o,l,this._extension.identifier);return this._threads.set(m.handle,m),m}else{const m=new E(this.id,this.handle,void 0,n,u,o,this._extension.identifier);return this._threads.set(m.handle,m),m}}$createCommentThreadTemplate(n,u){const o=new E(this.id,this.handle,void 0,A.URI.revive(n),I.Range.to(u),[],this._extension.identifier);return o.collapsibleState=_.CommentThreadCollapsibleState.Expanded,this._threads.set(o.handle,o),o}$updateCommentThreadTemplate(n,u){let o=this._threads.get(n);o&&(o.range=I.Range.to(u))}$deleteCommentThread(n){let u=this._threads.get(n);u&&u.dispose(),this._threads.delete(n)}getCommentThread(n){return this._threads.get(n)}dispose(){this._threads.forEach(n=>{n.dispose()}),this._localDisposables.forEach(n=>n.dispose())}}function r(s,n,u){let o=u.get(n);o||(o=++s.commentHandle,u.set(n,o));const l=n.author&&n.author.iconPath?n.author.iconPath.toString():void 0;return{mode:n.mode,contextValue:n.contextValue,uniqueIdInThread:o,body:I.MarkdownString.from(n.body),userName:n.author.name,userIconPath:l,label:n.label,commentReactions:n.reactions?n.reactions.map(m=>v(m)):void 0}}function v(s){return{label:s.label,iconPath:s.iconPath?I.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function t(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?A.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function h(s){if(s!==void 0)switch(s){case i.CommentThreadCollapsibleState.Expanded:return _.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return _.CommentThreadCollapsibleState.Collapsed}return _.CommentThreadCollapsibleState.Collapsed}return new T}e.createExtHostComments=a}),define(fe[133],me([0,1,2,5,7,4,14,13,18,9,8]),function(Y,e,p,F,C,y,A,_,S,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let k=class wn{constructor(g,d){this._logService=d,this._provider=new Map,this._proxy=g.getProxy(F.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,d){const w=wn._handlePool++;this._provider.set(w,{provider:g,extensionId:d}),this._proxy.$registerDecorationProvider(w,d.value);const D=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(T=>{if(!T){this._proxy.$onDidChange(w,null);return}let E=(0,S.asArray)(T);if(E.length<=wn._maxEventSize){this._proxy.$onDidChange(w,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",d.value,E.length);const c=E.map(t=>({uri:t,rank:(0,I.count)(t.path,"/")})),r=(0,S.groupBy)(c,(t,h)=>t.rank-h.rank||(0,I.compare)(t.uri.path,h.uri.path));let v=[];e:for(let t of r){let h;for(let s of t){let n=(0,i.dirname)(s.uri.path);if(h!==n&&(h=n,v.push(s.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(w,v)});return new C.Disposable(()=>{D?.dispose(),this._proxy.$unregisterDecorationProvider(w),this._provider.delete(w)})}async $provideDecorations(g,d,w){if(!this._provider.has(g))return Object.create(null);const D=Object.create(null),{provider:T,extensionId:E}=this._provider.get(g);return await Promise.all(d.map(async c=>{try{const{uri:r,id:v}=c,t=await Promise.resolve(T.provideFileDecoration(p.URI.revive(r),w));if(!t)return;try{C.FileDecoration.validate(t),D[v]=[t.propagate,t.tooltip,t.badge,t.color]}catch(h){this._logService.warn(`INVALID decoration from extension '${E.value}': ${h}`)}}catch(r){this._logService.error(r)}})),D}};k._handlePool=0,k._maxEventSize=250,k=Ve([$e(0,A.IExtHostRpcService),$e(1,_.ILogService)],k),e.ExtHostDecorations=k,e.IExtHostDecorations=(0,y.createDecorator)("IExtHostDecorations")});var ot=this&&this.__classPrivateFieldSet||function(Y,e,p,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,p):C?C.value=p:e.set(Y,p),p},Oe=this&&this.__classPrivateFieldGet||function(Y,e,p,F){if(p==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?F:p==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[236],me([0,1,165,118,2,5,7,16,3,13,24,53,142]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a){"use strict";var g,d,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class D{constructor(c,r,v,t,h,s){this._name=c,this._owner=r,this._maxDiagnosticsPerFile=v,g.set(this,void 0),d.set(this,void 0),w.set(this,void 0),this._isDisposed=!1,ot(this,w,new a.SkipList((n,u)=>t.compare(n,u)),"f"),ot(this,g,h,"f"),ot(this,d,s,"f")}dispose(){this._isDisposed||(Oe(this,d,"f").fire([...Oe(this,w,"f").keys()]),Oe(this,g,"f")&&Oe(this,g,"f").$clear(this._owner),Oe(this,w,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(c,r){if(!c){this.clear();return}this._checkDisposed();let v=[];if(C.URI.isUri(c)){if(!r){this.delete(c);return}Oe(this,w,"f").set(c,r.slice()),v=[c]}else if(Array.isArray(c)){v=[];let h;c=[...c].sort(D._compareIndexedTuplesByUri);for(const s of c){const[n,u]=s;if((!h||n.toString()!==h.toString())&&(h&&Oe(this,w,"f").get(h).length===0&&Oe(this,w,"f").delete(h),h=n,v.push(n),Oe(this,w,"f").set(n,[])),u){const o=Oe(this,w,"f").get(n);o&&o.push(...u)}else{const o=Oe(this,w,"f").get(n);o&&(o.length=0)}}}if(Oe(this,d,"f").fire(v),!Oe(this,g,"f"))return;const t=[];for(let h of v){let s=[];const n=Oe(this,w,"f").get(h);if(n)if(n.length>this._maxDiagnosticsPerFile){s=[];const u=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(let l of n)if(l.severity===u[o]&&s.push(_.Diagnostic.from(l))===this._maxDiagnosticsPerFile)break e;s.push({severity:F.MarkerSeverity.Info,message:(0,p.localize)(0,null,n.length-this._maxDiagnosticsPerFile),startLineNumber:s[s.length-1].startLineNumber,startColumn:s[s.length-1].startColumn,endLineNumber:s[s.length-1].endLineNumber,endColumn:s[s.length-1].endColumn})}else s=n.map(u=>_.Diagnostic.from(u));t.push([h,s])}Oe(this,g,"f").$changeMany(this._owner,t)}delete(c){this._checkDisposed(),Oe(this,d,"f").fire([c]),Oe(this,w,"f").delete(c),Oe(this,g,"f")&&Oe(this,g,"f").$changeMany(this._owner,[[c,void 0]])}clear(){this._checkDisposed(),Oe(this,d,"f").fire([...Oe(this,w,"f").keys()]),Oe(this,w,"f").clear(),Oe(this,g,"f")&&Oe(this,g,"f").$clear(this._owner)}forEach(c,r){this._checkDisposed();for(let v of Oe(this,w,"f").keys())c.apply(r,[v,this.get(v),this])}get(c){this._checkDisposed();const r=Oe(this,w,"f").get(c);return Array.isArray(r)?Object.freeze(r.slice(0)):[]}has(c){return this._checkDisposed(),Array.isArray(Oe(this,w,"f").get(c))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(c,r){return c[0].toString()<r[0].toString()?-1:c[0].toString()>r[0].toString()?1:0}}e.DiagnosticCollection=D,g=new WeakMap,d=new WeakMap,w=new WeakMap;let T=class Zt{constructor(c,r,v){this._logService=r,this._fileSystemInfoService=v,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:t=>t.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,Zt._mapper),this._proxy=c.getProxy(y.MainContext.MainThreadDiagnostics)}static _mapper(c){const r=new i.ResourceMap;for(const v of c)r.set(v,v);return{uris:Object.freeze(Array.from(r.values()))}}createDiagnosticCollection(c,r){const{_collections:v,_proxy:t,_onDidChangeDiagnostics:h,_logService:s,_fileSystemInfoService:n}=this,u=new class{$changeMany(m,b){t.$changeMany(m,b),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,m,b.length===0?"CLEARING":b)}$clear(m){t.$clear(m),s.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,m)}dispose(){t.dispose()}};let o;if(!r)r="_generated_diagnostic_collection_name_#"+Zt._idPool++,o=r;else if(!v.has(r))o=r;else{this._logService.warn(`DiagnosticCollection with name '${r}' does already exist.`);do o=r+Zt._idPool++;while(v.has(o))}return new class extends D{constructor(){super(r,o,Zt._maxDiagnosticsPerFile,n.extUri,u,h);v.set(o,this)}dispose(){super.dispose(),v.delete(o)}}}getDiagnostics(c){if(c)return this._getDiagnostics(c);{const r=new Map,v=[];for(const t of this._collections.values())t.forEach((h,s)=>{let n=r.get(h.toString());typeof n=="undefined"&&(n=v.length,r.set(h.toString(),n),v.push([h,[]])),v[n][1]=v[n][1].concat(...s)});return v}}_getDiagnostics(c){let r=[];for(let v of this._collections.values())v.has(c)&&(r=r.concat(v.get(c)));return r}$acceptMarkersChange(c){if(!this._mirrorCollection){const r="_generated_mirror",v=new D(r,r,Zt._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(r,v),this._mirrorCollection=v}for(const[r,v]of c)this._mirrorCollection.set(C.URI.revive(r),v.map(_.Diagnostic.to))}};T._idPool=0,T._maxDiagnosticsPerFile=1e3,T=Ve([$e(1,I.ILogService),$e(2,k.IExtHostFileSystemInfo)],T),e.ExtHostDiagnostics=T}),define(fe[237],me([0,1,2,5]),function(Y,e,p,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class C{constructor(A){this._proxy=A.getProxy(F.MainContext.MainThreadDialogs)}showOpenDialog(A){return this._proxy.$showOpenDialog(A).then(_=>_?_.map(S=>p.URI.revive(S)):void 0)}showSaveDialog(A){return this._proxy.$showSaveDialog(A).then(_=>_?p.URI.revive(_):void 0)}}e.ExtHostDialogs=C}),define(fe[238],me([0,1,17,2,7,5,10,21,9]),function(Y,e,p,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class I{constructor(k,a,g){this._documentsAndEditors=a,this._logService=g,this._documentContentProviders=new Map,this._proxy=k.getProxy(y.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,a){if(Object.keys(A.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const g=I._handlePool++;this._documentContentProviders.set(g,a),this._proxy.$registerTextContentProvider(g,k);let d;return typeof a.onDidChange=="function"&&(d=a.onDidChange(w=>{if(w.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${w.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(w)&&this.$provideTextDocumentContent(g,w).then(D=>{if(!D&&typeof D!="string")return;const T=this._documentsAndEditors.getDocument(w);if(!T)return;const E=(0,S.splitLines)(D);if(!T.equalLines(E))return this._proxy.$onVirtualDocumentChange(w,D)},p.onUnexpectedError)})),new C.Disposable(()=>{this._documentContentProviders.delete(g)&&this._proxy.$unregisterTextContentProvider(g),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(k,a){const g=this._documentContentProviders.get(k);return g?Promise.resolve(g.provideTextDocumentContent(F.URI.revive(a),_.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.ExtHostDocumentContentProvider=I,I._handlePool=0}),define(fe[239],me([0,1,3,6,2,5,125,16,12,25,7]),function(Y,e,p,F,C,y,A,_,S,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class k{constructor(g,d){this._onDidAddDocument=new p.Emitter,this._onDidRemoveDocument=new p.Emitter,this._onDidChangeDocument=new p.Emitter,this._onDidSaveDocument=new p.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new F.DisposableStore,this._documentLoader=new Map,this._proxy=g.getProxy(y.MainContext.MainThreadDocuments),this._documentsAndEditors=d,this._documentsAndEditors.onDidRemoveDocuments(w=>{for(const D of w)this._onDidRemoveDocument.fire(D.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(w=>{for(const D of w)this._onDidAddDocument.fire(D.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(g){if(!g)return;const d=this._documentsAndEditors.getDocument(g);if(d)return d}getDocument(g){const d=this.getDocumentData(g);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${g}'`);return d.document}ensureDocumentData(g){const d=this._documentsAndEditors.getDocument(g);if(d)return Promise.resolve(d);let w=this._documentLoader.get(g.toString());return w||(w=this._proxy.$tryOpenDocument(g).then(D=>{this._documentLoader.delete(g.toString());const T=C.URI.revive(D);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(T))},D=>(this._documentLoader.delete(g.toString()),Promise.reject(D))),this._documentLoader.set(g.toString(),w)),w}createDocumentData(g){return this._proxy.$tryCreateDocument(g).then(d=>C.URI.revive(d))}$acceptModelModeChanged(g,d){const w=C.URI.revive(g),D=this._documentsAndEditors.getDocument(w);if(!D)throw new Error("unknown document");this._onDidRemoveDocument.fire(D.document),D._acceptLanguageId(d),this._onDidAddDocument.fire(D.document)}$acceptModelSaved(g){const d=C.URI.revive(g),w=this._documentsAndEditors.getDocument(d);if(!w)throw new Error("unknown document");this.$acceptDirtyStateChanged(g,!1),this._onDidSaveDocument.fire(w.document)}$acceptDirtyStateChanged(g,d){const w=C.URI.revive(g),D=this._documentsAndEditors.getDocument(w);if(!D)throw new Error("unknown document");D._acceptIsDirty(d),this._onDidChangeDocument.fire({document:D.document,contentChanges:[],reason:void 0})}$acceptModelChanged(g,d,w){const D=C.URI.revive(g),T=this._documentsAndEditors.getDocument(D);if(!T)throw new Error("unknown document");T._acceptIsDirty(w),T.onEvents(d);let E;d.isUndoing?E=i.TextDocumentChangeReason.Undo:d.isRedoing&&(E=i.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,I.deepFreeze)({document:T.document,contentChanges:d.changes.map(c=>({range:_.Range.to(c.range),rangeOffset:c.rangeOffset,rangeLength:c.rangeLength,text:c.text})),reason:E}))}setWordDefinitionFor(g,d){(0,A.setWordDefinitionFor)(g,d)}}e.ExtHostDocuments=k}),define(fe[45],me([0,1,58,3,6,2,4,5,125,14,132,16,13,24,10,94,141]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class T{constructor(r){this.value=r,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(r,v){this._extHostRpc=r,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new g.ResourceMap,this._onDidAddDocuments=new F.Emitter,this._onDidRemoveDocuments=new F.Emitter,this._onDidChangeVisibleTextEditors=new F.Emitter,this._onDidChangeActiveTextEditor=new F.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const v=[],t=[],h=[];if(r.removedDocuments)for(const s of r.removedDocuments){const n=y.URI.revive(s),u=this._documents.get(n);u?.unref()&&(this._documents.delete(n),v.push(u.value))}if(r.addedDocuments)for(const s of r.addedDocuments){const n=y.URI.revive(s.uri);let u=this._documents.get(n);if(u&&n.scheme!==d.Schemas.vscodeNotebookCell&&n.scheme!==d.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);u||(u=new T(new S.ExtHostDocumentData(this._extHostRpc.getProxy(_.MainContext.MainThreadDocuments),n,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(n,u),t.push(u.value)),u.ref()}if(r.removedEditors)for(const s of r.removedEditors){const n=this._editors.get(s);this._editors.delete(s),n&&h.push(n)}if(r.addedEditors)for(const s of r.addedEditors){const n=y.URI.revive(s.documentUri);p.ok(this._documents.has(n),`document '${n}' does not exist`),p.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const u=this._documents.get(n).value,o=new i.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(_.MainContext.MainThreadTextEditors),this._logService,new D.Lazy(()=>u.document),s.selections.map(k.Selection.to),s.options,s.visibleRanges.map(l=>k.Range.to(l)),typeof s.editorPosition=="number"?k.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,o)}r.newActiveEditor!==void 0&&(p.ok(r.newActiveEditor===null||this._editors.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this._activeEditorId=r.newActiveEditor),(0,C.dispose)(v),(0,C.dispose)(h),r.removedDocuments&&this._onDidRemoveDocuments.fire(v),r.addedDocuments&&this._onDidAddDocuments.fire(t),(r.removedEditors||r.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),r.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(r){return this._documents.get(r)?.value}allDocuments(){return w.Iterable.map(this._documents.values(),r=>r.value)}getEditor(r){return this._editors.get(r)}activeEditor(r){if(!this._activeEditorId)return;const v=this._editors.get(this._activeEditorId);return r?v:v?.value}allEditors(){return[...this._editors.values()]}};E=Ve([$e(0,I.IExtHostRpcService),$e(1,a.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,A.createDecorator)("IExtHostDocumentsAndEditors")}),define(fe[56],me([0,1,16,5,2,3,4,14,15]),function(Y,e,p,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,A.createDecorator)("IExtHostEditorTabs");let I=class{constructor(k){this._onDidChangeTabs=new y.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new y.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=k.getProxy(F.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(k){let a=-1;this._tabs=k.map((d,w)=>(d.isActive&&(a=w),Object.freeze({label:d.label,viewColumn:p.ViewColumn.to(d.viewColumn),index:w,resource:C.URI.revive(d.resource),additionalResourcesAndViewIds:d.additionalResourcesAndViewIds.map(({resource:D,viewId:T})=>({resource:C.URI.revive(D),viewId:T})),viewId:d.editorId,isActive:d.isActive,move:async(D,T)=>{this._proxy.$moveTab(d,D,p.ViewColumn.from(T)),await(0,S.raceTimeout)(y.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(d),await(0,S.raceTimeout)(y.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((d,w)=>d.viewColumn===w.viewColumn?d.index-w.index:d.viewColumn-w.viewColumn);const g=this._activeTab;this._activeTab=a===-1?void 0:this._tabs[a],this._activeTab!==g&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};I=Ve([$e(0,_.IExtHostRpcService)],I),e.ExtHostEditorTabs=I}),define(fe[240],me([0,1,2,5,6,7,16,149,9,22]),function(Y,e,p,F,C,y,A,_,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(g){this._stateMachine=void 0,this._schemes.push(g)}delete(g){const d=this._schemes.indexOf(g);d>=0&&(this._schemes.splice(d,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const g=this._schemes.sort(),d=[];let w,D,T=14,E=14;for(const c of g){let r=w?(0,S.commonPrefixLength)(w,c):0;for(r===0?D=1:D=E;r<c.length;r++)r+1===c.length?(T=E,E=9):E+=1,d.push([D,c.toUpperCase().charCodeAt(r),E]),d.push([D,c.toLowerCase().charCodeAt(r),E]),D=E;w=c,E=T}d.push([9,58,10]),d.push([10,47,12]),this._stateMachine=new _.StateMachine(d)}}provideDocumentLinks(g){this._initStateMachine();const d=[],w=_.LinkComputer.computeLinks({getLineContent(D){return g.lineAt(D-1).text},getLineCount(){return g.lineCount}},this._stateMachine);for(const D of w){const T=A.DocumentLink.to(D);T.target&&d.push(T)}return d}}class k{constructor(g,d){this._extHostLanguageFeatures=d,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=g.getProxy(F.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(g,d,w,D={}){if(this._registeredSchemes.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const T=this._handlePool++;this._linkProvider.add(d),this._registeredSchemes.add(d),this._fsProvider.set(T,w);let E=2;D.isCaseSensitive&&(E+=1024),D.isReadonly&&(E+=2048),typeof w.copy=="function"&&(E+=8),typeof w.open=="function"&&typeof w.close=="function"&&typeof w.read=="function"&&typeof w.write=="function"&&(E+=4),this._proxy.$registerFileSystemProvider(T,d,E).catch(r=>{console.error(`FAILED to register filesystem provider of ${g.value}-extension for the scheme ${d}`),console.error(r)});const c=w.onDidChangeFile(r=>{const v=[];for(const t of r){let{uri:h,type:s}=t;if(h.scheme!==d)continue;let n;switch(s){case y.FileChangeType.Changed:n=0;break;case y.FileChangeType.Created:n=1;break;case y.FileChangeType.Deleted:n=2;break;default:throw new Error("Unknown FileChangeType")}v.push({resource:h,type:n})}this._proxy.$onFileSystemChange(T,v)});return(0,C.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(d),this._registeredSchemes.delete(d),this._fsProvider.delete(T),this._proxy.$unregisterProvider(T)})}static _asIStat(g){const{type:d,ctime:w,mtime:D,size:T,permissions:E}=g;return{type:d,ctime:w,mtime:D,size:T,permissions:E}}$stat(g,d){return Promise.resolve(this._getFsProvider(g).stat(p.URI.revive(d))).then(w=>k._asIStat(w))}$readdir(g,d){return Promise.resolve(this._getFsProvider(g).readDirectory(p.URI.revive(d)))}$readFile(g,d){return Promise.resolve(this._getFsProvider(g).readFile(p.URI.revive(d))).then(w=>I.VSBuffer.wrap(w))}$writeFile(g,d,w,D){return Promise.resolve(this._getFsProvider(g).writeFile(p.URI.revive(d),w.buffer,D))}$delete(g,d,w){return Promise.resolve(this._getFsProvider(g).delete(p.URI.revive(d),w))}$rename(g,d,w,D){return Promise.resolve(this._getFsProvider(g).rename(p.URI.revive(d),p.URI.revive(w),D))}$copy(g,d,w,D){const T=this._getFsProvider(g);if(!T.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(T.copy(p.URI.revive(d),p.URI.revive(w),D))}$mkdir(g,d){return Promise.resolve(this._getFsProvider(g).createDirectory(p.URI.revive(d)))}$watch(g,d,w,D){const T=this._getFsProvider(g).watch(p.URI.revive(w),D);this._watches.set(d,T)}$unwatch(g,d){const w=this._watches.get(d);w&&(w.dispose(),this._watches.delete(d))}$open(g,d,w){const D=this._getFsProvider(g);if(!D.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(D.open(p.URI.revive(d),w))}$close(g,d){const w=this._getFsProvider(g);if(!w.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(w.close(d))}$read(g,d,w,D){const T=this._getFsProvider(g);if(!T.read)throw new Error('FileSystemProvider does not implement "read"');const E=I.VSBuffer.alloc(D);return Promise.resolve(T.read(d,w,E.buffer,0,D)).then(c=>E.slice(0,c))}$write(g,d,w,D){const T=this._getFsProvider(g);if(!T.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(T.write(d,w,D.buffer,0,D.byteLength))}_getFsProvider(g){const d=this._fsProvider.get(g);if(!d){const w=new Error;throw w.name="ENOPRO",w.message="no provider",w}return d}}e.ExtHostFileSystem=k}),define(fe[91],me([0,1,5,43,7,22,4,14,53]),function(Y,e,p,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let I=class Bt{constructor(k,a){const g=k.getProxy(p.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(d){return g.$stat(d).catch(Bt._handleError)},readDirectory(d){return g.$readdir(d).catch(Bt._handleError)},createDirectory(d){return g.$mkdir(d).catch(Bt._handleError)},async readFile(d){return g.$readFile(d).then(w=>w.buffer).catch(Bt._handleError)},writeFile(d,w){return g.$writeFile(d,y.VSBuffer.wrap(w)).catch(Bt._handleError)},delete(d,w){return g.$delete(d,{recursive:!1,useTrash:!1,...w}).catch(Bt._handleError)},rename(d,w,D){return g.$rename(d,w,{overwrite:!1,...D}).catch(Bt._handleError)},copy(d,w,D){return g.$copy(d,w,{overwrite:!1,...D}).catch(Bt._handleError)},isWritableFileSystem(d){const w=a.getCapabilities(d);if(typeof w=="number")return!(w&2048)}})}static _handleError(k){if(!(k instanceof Error))throw new C.FileSystemError(String(k));if(k.name==="ENOPRO")throw C.FileSystemError.Unavailable(k.message);switch(k.name){case F.FileSystemProviderErrorCode.FileExists:throw C.FileSystemError.FileExists(k.message);case F.FileSystemProviderErrorCode.FileNotFound:throw C.FileSystemError.FileNotFound(k.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw C.FileSystemError.FileNotADirectory(k.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw C.FileSystemError.FileIsADirectory(k.message);case F.FileSystemProviderErrorCode.NoPermissions:throw C.FileSystemError.NoPermissions(k.message);case F.FileSystemProviderErrorCode.Unavailable:throw C.FileSystemError.Unavailable(k.message);default:throw new C.FileSystemError(k.message,k.name)}}};I=Ve([$e(0,_.IExtHostRpcService),$e(1,S.IExtHostFileSystemInfo)],I),e.ExtHostConsumerFileSystem=I,e.IExtHostConsumerFileSystem=(0,A.createDecorator)("IExtHostConsumerFileSystem")}),define(fe[241],me([0,1,2,40]),function(Y,e,p,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class C{constructor(A,_,S,I){this._extHostNotebooks=_,this._textDocumentsAndEditors=S,this._commands=I;const i=new F.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.ApiCommandArgument("showOptions","Show Options",k=>!0,k=>k),new F.ApiCommandArgument("resource","Interactive resource Uri",k=>!0,k=>k),new F.ApiCommandArgument("controllerId","Notebook controller Id",k=>!0,k=>k),new F.ApiCommandArgument("title","Interactive editor title",k=>!0,k=>k)],new F.ApiCommandResult("Notebook and input URI",k=>{if(k.notebookEditorId!==void 0){const a=this._extHostNotebooks.getEditorById(k.notebookEditorId);return{notebookUri:p.URI.revive(k.notebookUri),inputUri:p.URI.revive(k.inputUri),notebookEditor:a.apiEditor}}return{notebookUri:p.URI.revive(k.notebookUri),inputUri:p.URI.revive(k.inputUri)}}));this._commands.registerApiCommand(i)}$willAddInteractiveDocument(A,_,S,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:_,lines:[""],modeId:S,uri:A,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(p.URI.revive(I))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,_){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.ExtHostInteractive=C}),define(fe[242],me([0,1,6,5]),function(Y,e,p,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class C{constructor(A){this._handlePool=0,this._proxy=A.getProxy(F.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const _=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(_,A),(0,p.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(_)})}}e.ExtHostLabelService=C}),define(fe[243],me([0,1,2,25,16,7,5,9,42,18,12,146,6,112,77,87,46,17,3]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d,w,D,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class c{constructor(q,ee){this._documents=q,this._provider=ee}async provideDocumentSymbols(q,ee){const re=this._documents.getDocument(q),le=await this._provider.provideDocumentSymbols(re,ee);if(!(0,I.isFalsyOrEmpty)(le))return le[0]instanceof y.DocumentSymbol?le.map(C.DocumentSymbol.from):c._asDocumentSymbolTree(le)}static _asDocumentSymbolTree(q){q=q.slice(0).sort((le,Z)=>{let ae=le.location.range.start.compareTo(Z.location.range.start);return ae===0&&(ae=Z.location.range.end.compareTo(le.location.range.end)),ae});const ee=[],re=[];for(const le of q){const Z={name:le.name||"!!MISSING: name!!",kind:C.SymbolKind.from(le.kind),tags:le.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:le.containerName,range:C.Range.from(le.location.range),selectionRange:C.Range.from(le.location.range),children:[]};for(;;){if(re.length===0){re.push(Z),ee.push(Z);break}const ae=re[re.length-1];if(S.Range.containsRange(ae.range,Z.range)&&!S.Range.equalsRange(ae.range,Z.range)){ae.children&&ae.children.push(Z),re.push(Z);break}re.pop()}}return ee}}class r{constructor(q,ee,re){this._documents=q,this._commands=ee,this._provider=re,this._cache=new w.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(q,ee){const re=this._documents.getDocument(q),le=await this._provider.provideCodeLenses(re,ee);if(!le||ee.isCancellationRequested)return;const Z=this._cache.add(le),ae=new a.DisposableStore;this._disposables.set(Z,ae);const pe={cacheId:Z,lenses:[]};for(let Me=0;Me<le.length;Me++)pe.lenses.push({cacheId:[Z,Me],range:C.Range.from(le[Me].range),command:this._commands.toInternal(le[Me].command,ae)});return pe}async resolveCodeLens(q,ee){const re=q.cacheId&&this._cache.get(...q.cacheId);if(!re)return;let le;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?le=re:le=await this._provider.resolveCodeLens(re,ee),le||(le=re),ee.isCancellationRequested)return;const Z=q.cacheId&&this._disposables.get(q.cacheId[0]);if(!!Z)return q.command=this._commands.toInternal(le.command??r._badCmd,Z),q}releaseCodeLenses(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}}r._badCmd={command:"missing",title:"!!MISSING: command!!"};function v(He){return Array.isArray(He)?He.map(C.DefinitionLink.from):He?[C.DefinitionLink.from(He)]:[]}class t{constructor(q,ee){this._documents=q,this._provider=ee}async provideDefinition(q,ee,re){const le=this._documents.getDocument(q),Z=C.Position.to(ee),ae=await this._provider.provideDefinition(le,Z,re);return v(ae)}}class h{constructor(q,ee){this._documents=q,this._provider=ee}async provideDeclaration(q,ee,re){const le=this._documents.getDocument(q),Z=C.Position.to(ee),ae=await this._provider.provideDeclaration(le,Z,re);return v(ae)}}class s{constructor(q,ee){this._documents=q,this._provider=ee}async provideImplementation(q,ee,re){const le=this._documents.getDocument(q),Z=C.Position.to(ee),ae=await this._provider.provideImplementation(le,Z,re);return v(ae)}}class n{constructor(q,ee){this._documents=q,this._provider=ee}async provideTypeDefinition(q,ee,re){const le=this._documents.getDocument(q),Z=C.Position.to(ee),ae=await this._provider.provideTypeDefinition(le,Z,re);return v(ae)}}class u{constructor(q,ee){this._documents=q,this._provider=ee}async provideHover(q,ee,re){const le=this._documents.getDocument(q),Z=C.Position.to(ee),ae=await this._provider.provideHover(le,Z,re);if(!(!ae||(0,I.isFalsyOrEmpty)(ae.contents)))return ae.range||(ae.range=le.getWordRangeAtPosition(Z)),ae.range||(ae.range=new y.Range(Z,Z)),C.Hover.from(ae)}}class o{constructor(q,ee){this._documents=q,this._provider=ee}async provideEvaluatableExpression(q,ee,re){const le=this._documents.getDocument(q),Z=C.Position.to(ee),ae=await this._provider.provideEvaluatableExpression(le,Z,re);if(ae)return C.EvaluatableExpression.from(ae)}}class l{constructor(q,ee){this._documents=q,this._provider=ee}async provideInlineValues(q,ee,re,le){const Z=this._documents.getDocument(q),ae=await this._provider.provideInlineValues(Z,C.Range.to(ee),C.InlineValueContext.to(re),le);if(Array.isArray(ae))return ae.map(pe=>C.InlineValue.from(pe))}}class m{constructor(q,ee){this._documents=q,this._provider=ee}async provideDocumentHighlights(q,ee,re){const le=this._documents.getDocument(q),Z=C.Position.to(ee),ae=await this._provider.provideDocumentHighlights(le,Z,re);if(Array.isArray(ae))return ae.map(C.DocumentHighlight.from)}}class b{constructor(q,ee){this._documents=q,this._provider=ee}async provideLinkedEditingRanges(q,ee,re){const le=this._documents.getDocument(q),Z=C.Position.to(ee),ae=await this._provider.provideLinkedEditingRanges(le,Z,re);if(ae&&Array.isArray(ae.ranges))return{ranges:(0,I.coalesce)(ae.ranges.map(C.Range.from)),wordPattern:ae.wordPattern}}}class f{constructor(q,ee){this._documents=q,this._provider=ee}async provideReferences(q,ee,re,le){const Z=this._documents.getDocument(q),ae=C.Position.to(ee),pe=await this._provider.provideReferences(Z,ae,re,le);if(Array.isArray(pe))return pe.map(C.location.from)}}class P{constructor(q,ee,re,le,Z,ae,pe){this._documents=q,this._commands=ee,this._diagnostics=re,this._provider=le,this._logService=Z,this._extension=ae,this._apiDeprecation=pe,this._cache=new w.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(q,ee,re,le){const Z=this._documents.getDocument(q),ae=k.Selection.isISelection(ee)?C.Selection.to(ee):C.Range.to(ee),pe=[];for(const Te of this._diagnostics.getDiagnostics(q))if(ae.intersection(Te.range)&&pe.push(Te)>P._maxCodeActionsPerFile)break;const Me={diagnostics:pe,only:re.only?new y.CodeActionKind(re.only):void 0,triggerKind:C.CodeActionTriggerKind.to(re.trigger)},je=await this._provider.provideCodeActions(Z,ae,Me,le);if(!(0,I.isNonEmptyArray)(je)||le.isCancellationRequested)return;const Ke=this._cache.add(je),Je=new a.DisposableStore;this._disposables.set(Ke,Je);const st=[];for(let Te=0;Te<je.length;Te++){const nt=je[Te];!nt||(P._isCommand(nt)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),st.push({_isSynthetic:!0,title:nt.title,command:this._commands.toInternal(nt,Je)})):(Me.only&&(nt.kind?Me.only.contains(nt.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${nt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),st.push({cacheId:[Ke,Te],title:nt.title,command:nt.command&&this._commands.toInternal(nt.command,Je),diagnostics:nt.diagnostics&&nt.diagnostics.map(C.Diagnostic.from),edit:nt.edit&&C.WorkspaceEdit.from(nt.edit),kind:nt.kind&&nt.kind.value,isPreferred:nt.isPreferred,disabled:nt.disabled?.reason})))}return{cacheId:Ke,actions:st}}async resolveCodeAction(q,ee){const[re,le]=q,Z=this._cache.get(re,le);if(!Z||P._isCommand(Z)||!this._provider.resolveCodeAction)return;const ae=await this._provider.resolveCodeAction(Z,ee)??Z;return ae?.edit?C.WorkspaceEdit.from(ae.edit):void 0}releaseCodeActions(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}static _isCommand(q){return typeof q.command=="string"&&typeof q.title=="string"}}P._maxCodeActionsPerFile=1e3;class L{constructor(q,ee){this._documents=q,this._provider=ee}async provideDocumentFormattingEdits(q,ee,re){const le=this._documents.getDocument(q),Z=await this._provider.provideDocumentFormattingEdits(le,ee,re);if(Array.isArray(Z))return Z.map(C.TextEdit.from)}}class M{constructor(q,ee){this._documents=q,this._provider=ee}async provideDocumentRangeFormattingEdits(q,ee,re,le){const Z=this._documents.getDocument(q),ae=C.Range.to(ee),pe=await this._provider.provideDocumentRangeFormattingEdits(Z,ae,re,le);if(Array.isArray(pe))return pe.map(C.TextEdit.from)}}class R{constructor(q,ee){this._documents=q,this._provider=ee,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,ee,re,le,Z){const ae=this._documents.getDocument(q),pe=C.Position.to(ee),Me=await this._provider.provideOnTypeFormattingEdits(ae,pe,re,le,Z);if(Array.isArray(Me))return Me.map(C.TextEdit.from)}}class W{constructor(q,ee){this._provider=q,this._logService=ee,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(q,ee){const re=A.IdObject.mixin({symbols:[]}),le=await this._provider.provideWorkspaceSymbols(q,ee);if((0,I.isNonEmptyArray)(le))for(const Z of le){if(!Z)continue;if(!Z.name){this._logService.warn("INVALID SymbolInformation, lacks name",Z);continue}const ae=A.IdObject.mixin(C.WorkspaceSymbol.from(Z));this._symbolCache.set(ae._id,Z),re.symbols.push(ae)}return re.symbols.length>0&&this._resultCache.set(re._id,[re.symbols[0]._id,re.symbols[re.symbols.length-1]._id]),re}async resolveWorkspaceSymbol(q,ee){if(typeof this._provider.resolveWorkspaceSymbol!="function")return q;const re=this._symbolCache.get(q._id);if(re){const le=await this._provider.resolveWorkspaceSymbol(re,ee);return le&&(0,F.mixin)(q,C.WorkspaceSymbol.from(le),!0)}}releaseWorkspaceSymbols(q){const ee=this._resultCache.get(q);if(ee){for(let[re,le]=ee;re<=le;re++)this._symbolCache.delete(re);this._resultCache.delete(q)}}}class V{constructor(q,ee,re){this._documents=q,this._provider=ee,this._logService=re}static supportsResolving(q){return typeof q.prepareRename=="function"}async provideRenameEdits(q,ee,re,le){const Z=this._documents.getDocument(q),ae=C.Position.to(ee);try{const pe=await this._provider.provideRenameEdits(Z,ae,re,le);return pe?C.WorkspaceEdit.from(pe):void 0}catch(pe){const Me=V._asMessage(pe);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(pe)}}async resolveRenameLocation(q,ee,re){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const le=this._documents.getDocument(q),Z=C.Position.to(ee);try{const ae=await this._provider.prepareRename(le,Z,re);let pe,Me;if(y.Range.isRange(ae)?(pe=ae,Me=le.getText(ae)):(0,i.isObject)(ae)&&(pe=ae.range,Me=ae.placeholder),!pe||!Me)return;if(pe.start.line>Z.line||pe.end.line<Z.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(pe),text:Me}}catch(ae){const pe=V._asMessage(ae);return pe?{rejectReason:pe,range:void 0,text:void 0}:Promise.reject(ae)}}static _asMessage(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class N{constructor(q,ee){this.resultId=q,this.tokens=ee}}class j{constructor(q,ee){this._documents=q,this._provider=ee,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(q,ee,re){const le=this._documents.getDocument(q),Z=ee!==0?this._previousResults.get(ee):null;let ae=typeof Z?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(le,Z.resultId,re):await this._provider.provideDocumentSemanticTokens(le,re);return Z&&this._previousResults.delete(ee),ae?(ae=j._fixProvidedSemanticTokens(ae),this._send(j._convertToEdits(Z,ae),ae)):null}async releaseDocumentSemanticColoring(q){this._previousResults.delete(q)}static _fixProvidedSemanticTokens(q){return j._isSemanticTokens(q)?j._isCorrectSemanticTokens(q)?q:new y.SemanticTokens(new Uint32Array(q.data),q.resultId):j._isSemanticTokensEdits(q)?j._isCorrectSemanticTokensEdits(q)?q:new y.SemanticTokensEdits(q.edits.map(ee=>new y.SemanticTokensEdit(ee.start,ee.deleteCount,ee.data?new Uint32Array(ee.data):ee.data)),q.resultId):q}static _isSemanticTokens(q){return q&&!!q.data}static _isCorrectSemanticTokens(q){return q.data instanceof Uint32Array}static _isSemanticTokensEdits(q){return q&&Array.isArray(q.edits)}static _isCorrectSemanticTokensEdits(q){for(const ee of q.edits)if(!(ee.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(q,ee){if(!j._isSemanticTokens(ee)||!q||!q.tokens)return ee;const re=q.tokens,le=re.length,Z=ee.data,ae=Z.length;let pe=0;const Me=Math.min(le,ae);for(;pe<Me&&re[pe]===Z[pe];)pe++;if(pe===le&&pe===ae)return new y.SemanticTokensEdits([],ee.resultId);let je=0;const Ke=Me-pe;for(;je<Ke&&re[le-je-1]===Z[ae-je-1];)je++;return new y.SemanticTokensEdits([{start:pe,deleteCount:le-pe-je,data:Z.subarray(pe,ae-je)}],ee.resultId)}_send(q,ee){if(j._isSemanticTokens(q)){const re=this._nextResultId++;return this._previousResults.set(re,new N(q.resultId,q.data)),(0,g.encodeSemanticTokensDto)({id:re,type:"full",data:q.data})}if(j._isSemanticTokensEdits(q)){const re=this._nextResultId++;return j._isSemanticTokens(ee)?this._previousResults.set(re,new N(ee.resultId,ee.data)):this._previousResults.set(re,new N(q.resultId)),(0,g.encodeSemanticTokensDto)({id:re,type:"delta",deltas:(q.edits||[]).map(le=>({start:le.start,deleteCount:le.deleteCount,data:le.data}))})}return null}}e.DocumentSemanticTokensAdapter=j;class U{constructor(q,ee){this._documents=q,this._provider=ee}async provideDocumentRangeSemanticTokens(q,ee,re){const le=this._documents.getDocument(q),Z=await this._provider.provideDocumentRangeSemanticTokens(le,C.Range.to(ee),re);return Z?this._send(Z):null}_send(q){return(0,g.encodeSemanticTokensDto)({id:0,type:"full",data:q.data})}}e.DocumentRangeSemanticTokensAdapter=U;class B{constructor(q,ee,re,le,Z){this._documents=q,this._commands=ee,this._provider=re,this._apiDeprecation=le,this._extension=Z,this._cache=new w.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}async provideCompletionItems(q,ee,re,le){const Z=this._documents.getDocument(q),ae=C.Position.to(ee),pe=Z.getWordRangeAtPosition(ae)||new y.Range(ae,ae),Me=pe.with({end:ae}),je=new D.StopWatch(!0),Ke=await this._provider.provideCompletionItems(Z,ae,le,C.CompletionContext.to(re));if(!Ke||le.isCancellationRequested)return;const Je=Array.isArray(Ke)?new y.CompletionList(Ke):Ke,st=B.supportsResolving(this._provider)?this._cache.add(Je.items):this._cache.add([]),Te=new a.DisposableStore;this._disposables.set(st,Te);const nt=[],J={x:st,b:nt,a:{replace:C.Range.from(pe),insert:C.Range.from(Me)},c:Je.isIncomplete||void 0,d:je.elapsed()};for(let te=0;te<Je.items.length;te++){const ve=Je.items[te],Qe=this._convertCompletionItem(ve,[st,te],Me,pe);nt.push(Qe)}return J}async resolveCompletionItem(q,ee){if(typeof this._provider.resolveCompletionItem!="function")return;const re=this._cache.get(...q);if(!re)return;const le=await this._provider.resolveCompletionItem(re,ee);if(!!le)return this._convertCompletionItem(le,q)}releaseCompletionItems(q){this._disposables.get(q)?.dispose(),this._disposables.delete(q),this._cache.delete(q)}_convertCompletionItem(q,ee,re,le){const Z=this._disposables.get(ee[0]);if(!Z)throw Error("DisposableStore is missing...");const ae={x:ee,a:q.label,b:q.kind!==void 0?C.CompletionItemKind.from(q.kind):void 0,n:q.tags&&q.tags.map(C.CompletionItemTag.from),c:q.detail,d:typeof q.documentation=="undefined"?void 0:C.MarkdownString.fromStrict(q.documentation),e:q.sortText!==q.label?q.sortText:void 0,f:q.filterText!==q.label?q.filterText:void 0,g:q.preselect||void 0,i:q.keepWhitespace?1:0,k:q.commitCharacters,l:q.additionalTextEdits&&q.additionalTextEdits.map(C.TextEdit.from),m:this._commands.toInternal(q.command,Z)};q.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ae.h=q.textEdit.newText):typeof q.insertText=="string"?ae.h=q.insertText:q.insertText instanceof y.SnippetString&&(ae.h=q.insertText.value,ae.i|=4);let pe;return q.textEdit?pe=q.textEdit.range:q.range&&(pe=q.range),y.Range.isRange(pe)?ae.j=C.Range.from(pe):pe&&(!re?.isEqual(pe.inserting)||!le?.isEqual(pe.replacing))&&(ae.j={insert:C.Range.from(pe.inserting),replace:C.Range.from(pe.replacing)}),ae}}class z{constructor(q,ee,re){this._documents=q,this._provider=ee,this._commands=re,this._cache=new w.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(q,ee,re,le){const Z=this._documents.getDocument(q),ae=C.Position.to(ee),pe=await this._provider.provideInlineCompletionItems(Z,ae,{selectedCompletionInfo:re.selectedSuggestionInfo?{range:C.Range.to(re.selectedSuggestionInfo.range),text:re.selectedSuggestionInfo.text}:void 0,triggerKind:re.triggerKind},le);if(!pe||le.isCancellationRequested)return;const Me=(0,i.isArray)(pe)?{items:pe}:pe,je=this._cache.add(Me.items);let Ke;return{pid:je,items:Me.items.map((Je,st)=>{let Te;return Je.command&&(Ke||(Ke=new a.DisposableStore,this._disposables.set(je,Ke)),Te=this._commands.toInternal(Je.command,Ke)),{text:Je.text,range:Je.range?C.Range.from(Je.range):void 0,command:Te,idx:st}})}}disposeCompletions(q){this._cache.delete(q);const ee=this._disposables.get(q);ee&&ee.clear(),this._disposables.delete(q)}handleDidShowCompletionItem(q,ee){const re=this._cache.get(q,ee);re&&O.get(this._provider).fireOnDidShowCompletionItem({completionItem:re})}}class O{constructor(){this._onDidShowCompletionItemEmitter=new E.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(q){let ee=O.map.get(q);return ee||(ee=new O,O.map.set(q,ee)),ee}fireOnDidShowCompletionItem(q){this._onDidShowCompletionItemEmitter.fire(q)}}e.InlineCompletionController=O,O.map=new WeakMap;class ${constructor(q,ee){this._documents=q,this._provider=ee,this._cache=new w.Cache("SignatureHelp")}async provideSignatureHelp(q,ee,re,le){const Z=this._documents.getDocument(q),ae=C.Position.to(ee),pe=this.reviveContext(re),Me=await this._provider.provideSignatureHelp(Z,ae,le,pe);if(Me){const je=this._cache.add([Me]);return{...C.SignatureHelp.from(Me),id:je}}}reviveContext(q){let ee;if(q.activeSignatureHelp){const re=C.SignatureHelp.to(q.activeSignatureHelp),le=this._cache.get(q.activeSignatureHelp.id,0);le?(ee=le,ee.activeSignature=re.activeSignature,ee.activeParameter=re.activeParameter):ee=re}return{...q,activeSignatureHelp:ee}}releaseSignatureHelp(q){this._cache.delete(q)}}class x{constructor(q,ee){this._documents=q,this._provider=ee}async provideInlayHints(q,ee,re){const le=this._documents.getDocument(q),Z=await this._provider.provideInlayHints(le,C.Range.to(ee),re);return Z?{hints:Z.map(C.InlayHint.from)}:void 0}}class X{constructor(q,ee){this._documents=q,this._provider=ee,this._cache=new w.Cache("DocumentLink")}async provideLinks(q,ee){const re=this._documents.getDocument(q),le=await this._provider.provideDocumentLinks(re,ee);if(!(!Array.isArray(le)||le.length===0)&&!ee.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:le.filter(X._validateLink).map(C.DocumentLink.from)};{const Z=this._cache.add(le),ae={links:[],id:Z};for(let pe=0;pe<le.length;pe++){if(!X._validateLink(le[pe]))continue;const Me=C.DocumentLink.from(le[pe]);Me.cacheId=[Z,pe],ae.links.push(Me)}return ae}}}static _validateLink(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,ee){if(typeof this._provider.resolveDocumentLink!="function")return;const re=this._cache.get(...q);if(!re)return;const le=await this._provider.resolveDocumentLink(re,ee);if(!(!le||!X._validateLink(le)))return C.DocumentLink.from(le)}releaseLinks(q){this._cache.delete(q)}}class Q{constructor(q,ee){this._documents=q,this._provider=ee}async provideColors(q,ee){const re=this._documents.getDocument(q),le=await this._provider.provideDocumentColors(re,ee);return Array.isArray(le)?le.map(ae=>({color:C.Color.from(ae.color),range:C.Range.from(ae.range)})):[]}async provideColorPresentations(q,ee,re){const le=this._documents.getDocument(q),Z=C.Range.to(ee.range),ae=C.Color.to(ee.color),pe=await this._provider.provideColorPresentations(ae,{document:le,range:Z},re);if(!!Array.isArray(pe))return pe.map(C.ColorPresentation.from)}}class de{constructor(q,ee){this._documents=q,this._provider=ee}async provideFoldingRanges(q,ee,re){const le=this._documents.getDocument(q),Z=await this._provider.provideFoldingRanges(le,ee,re);if(!!Array.isArray(Z))return Z.map(C.FoldingRange.from)}}class _e{constructor(q,ee,re){this._documents=q,this._provider=ee,this._logService=re}async provideSelectionRanges(q,ee,re){const le=this._documents.getDocument(q),Z=ee.map(C.Position.to),ae=await this._provider.provideSelectionRanges(le,Z,re);if(!(0,I.isNonEmptyArray)(ae))return[];if(ae.length!==Z.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const pe=[];for(let Me=0;Me<Z.length;Me++){const je=[];pe.push(je);let Ke=Z[Me],Je=ae[Me];for(;;){if(!Je.range.contains(Ke))throw new Error("INVALID selection range, must contain the previous range");if(je.push(C.SelectionRange.from(Je)),!Je.parent)break;Ke=Je.range,Je=Je.parent}}return pe}}class ye{constructor(q,ee){this._documents=q,this._provider=ee,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(q,ee,re){const le=this._documents.getDocument(q),Z=C.Position.to(ee),ae=await this._provider.prepareCallHierarchy(le,Z,re);if(!ae)return;const pe=this._idPool.nextId();return this._cache.set(pe,new Map),Array.isArray(ae)?ae.map(Me=>this._cacheAndConvertItem(pe,Me)):[this._cacheAndConvertItem(pe,ae)]}async provideCallsTo(q,ee,re){const le=this._itemFromCache(q,ee);if(!le)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyIncomingCalls(le,re);if(!!Z)return Z.map(ae=>({from:this._cacheAndConvertItem(q,ae.from),fromRanges:ae.fromRanges.map(pe=>C.Range.from(pe))}))}async provideCallsFrom(q,ee,re){const le=this._itemFromCache(q,ee);if(!le)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyOutgoingCalls(le,re);if(!!Z)return Z.map(ae=>({to:this._cacheAndConvertItem(q,ae.to),fromRanges:ae.fromRanges.map(pe=>C.Range.from(pe))}))}releaseSession(q){this._cache.delete(q)}_cacheAndConvertItem(q,ee){const re=this._cache.get(q),le=C.CallHierarchyItem.from(ee,q,re.size.toString(36));return re.set(le._itemId,ee),le}_itemFromCache(q,ee){return this._cache.get(q)?.get(ee)}}class ke{constructor(q,ee){this._documents=q,this._provider=ee,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(q,ee,re){const le=this._documents.getDocument(q),Z=C.Position.to(ee),ae=await this._provider.prepareTypeHierarchy(le,Z,re);if(!ae)return;const pe=this._idPool.nextId();return this._cache.set(pe,new Map),Array.isArray(ae)?ae.map(Me=>this._cacheAndConvertItem(pe,Me)):[this._cacheAndConvertItem(pe,ae)]}async provideSupertypes(q,ee,re){const le=this._itemFromCache(q,ee);if(!le)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySupertypes(le,re);if(!!Z)return Z.map(ae=>this._cacheAndConvertItem(q,ae))}async provideSubtypes(q,ee,re){const le=this._itemFromCache(q,ee);if(!le)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySubtypes(le,re);if(!!Z)return Z.map(ae=>this._cacheAndConvertItem(q,ae))}releaseSession(q){this._cache.delete(q)}_cacheAndConvertItem(q,ee){const re=this._cache.get(q),le=C.TypeHierarchyItem.from(ee,q,re.size.toString(36));return re.set(le._itemId,ee),le}_itemFromCache(q,ee){return this._cache.get(q)?.get(ee)}}class xe{constructor(q,ee){this.adapter=q,this.extension=ee}}class We{constructor(q,ee,re,le,Z,ae,pe){this._adapter=new Map,this._uriTransformer=ee,this._proxy=q.getProxy(A.MainContext.MainThreadLanguageFeatures),this._documents=re,this._commands=le,this._diagnostics=Z,this._logService=ae,this._apiDeprecation=pe}_transformDocumentSelector(q){return C.DocumentSelector.from(q,this._uriTransformer)}_createDisposable(q){return new y.Disposable(()=>{this._adapter.delete(q),this._proxy.$unregister(q)})}_nextHandle(){return We._handlePool++}_withAdapter(q,ee,re,le,Z=!1){const ae=this._adapter.get(q);if(!ae)return Promise.resolve(le);if(ae.adapter instanceof ee){let pe;ae.extension&&(pe=Date.now(),this._logService.trace(`[${ae.extension.identifier.value}] INVOKE provider '${ee.name}'`));const Me=re(ae.adapter,ae.extension),je=ae.extension;return je&&Promise.resolve(Me).then(()=>this._logService.trace(`[${je.identifier.value}] provider DONE after ${Date.now()-pe}ms`),Ke=>{Z&&Ke instanceof T.CancellationError||(this._logService.error(`[${je.identifier.value}] provider FAILED`),this._logService.error(Ke))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(q,ee){const re=this._nextHandle();return this._adapter.set(re,new xe(q,ee)),re}static _extLabel(q){return q.displayName||q.name}registerDocumentSymbolProvider(q,ee,re,le){const Z=this._addNewAdapter(new c(this._documents,re),q),ae=le&&le.label||We._extLabel(q);return this._proxy.$registerDocumentSymbolProvider(Z,this._transformDocumentSelector(ee),ae),this._createDisposable(Z)}$provideDocumentSymbols(q,ee,re){return this._withAdapter(q,c,le=>le.provideDocumentSymbols(p.URI.revive(ee),re),void 0)}registerCodeLensProvider(q,ee,re){const le=this._nextHandle(),Z=typeof re.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(le,new xe(new r(this._documents,this._commands.converter,re),q)),this._proxy.$registerCodeLensSupport(le,this._transformDocumentSelector(ee),Z);let ae=this._createDisposable(le);if(Z!==void 0){const pe=re.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(Z));ae=y.Disposable.from(ae,pe)}return ae}$provideCodeLenses(q,ee,re){return this._withAdapter(q,r,le=>le.provideCodeLenses(p.URI.revive(ee),re),void 0)}$resolveCodeLens(q,ee,re){return this._withAdapter(q,r,le=>le.resolveCodeLens(ee,re),void 0)}$releaseCodeLenses(q,ee){this._withAdapter(q,r,re=>Promise.resolve(re.releaseCodeLenses(ee)),void 0)}registerDefinitionProvider(q,ee,re){const le=this._addNewAdapter(new t(this._documents,re),q);return this._proxy.$registerDefinitionSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDefinition(q,ee,re,le){return this._withAdapter(q,t,Z=>Z.provideDefinition(p.URI.revive(ee),re,le),[])}registerDeclarationProvider(q,ee,re){const le=this._addNewAdapter(new h(this._documents,re),q);return this._proxy.$registerDeclarationSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDeclaration(q,ee,re,le){return this._withAdapter(q,h,Z=>Z.provideDeclaration(p.URI.revive(ee),re,le),[])}registerImplementationProvider(q,ee,re){const le=this._addNewAdapter(new s(this._documents,re),q);return this._proxy.$registerImplementationSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideImplementation(q,ee,re,le){return this._withAdapter(q,s,Z=>Z.provideImplementation(p.URI.revive(ee),re,le),[])}registerTypeDefinitionProvider(q,ee,re){const le=this._addNewAdapter(new n(this._documents,re),q);return this._proxy.$registerTypeDefinitionSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideTypeDefinition(q,ee,re,le){return this._withAdapter(q,n,Z=>Z.provideTypeDefinition(p.URI.revive(ee),re,le),[])}registerHoverProvider(q,ee,re,le){const Z=this._addNewAdapter(new u(this._documents,re),q);return this._proxy.$registerHoverProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideHover(q,ee,re,le){return this._withAdapter(q,u,Z=>Z.provideHover(p.URI.revive(ee),re,le),void 0)}registerEvaluatableExpressionProvider(q,ee,re,le){const Z=this._addNewAdapter(new o(this._documents,re),q);return this._proxy.$registerEvaluatableExpressionProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideEvaluatableExpression(q,ee,re,le){return this._withAdapter(q,o,Z=>Z.provideEvaluatableExpression(p.URI.revive(ee),re,le),void 0)}registerInlineValuesProvider(q,ee,re,le){const Z=typeof re.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ae=this._addNewAdapter(new l(this._documents,re),q);this._proxy.$registerInlineValuesProvider(ae,this._transformDocumentSelector(ee),Z);let pe=this._createDisposable(ae);if(Z!==void 0){const Me=re.onDidChangeInlineValues(je=>this._proxy.$emitInlineValuesEvent(Z));pe=y.Disposable.from(pe,Me)}return pe}$provideInlineValues(q,ee,re,le,Z){return this._withAdapter(q,l,ae=>ae.provideInlineValues(p.URI.revive(ee),re,le,Z),void 0)}registerDocumentHighlightProvider(q,ee,re){const le=this._addNewAdapter(new m(this._documents,re),q);return this._proxy.$registerDocumentHighlightProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDocumentHighlights(q,ee,re,le){return this._withAdapter(q,m,Z=>Z.provideDocumentHighlights(p.URI.revive(ee),re,le),void 0)}registerLinkedEditingRangeProvider(q,ee,re){const le=this._addNewAdapter(new b(this._documents,re),q);return this._proxy.$registerLinkedEditingRangeProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideLinkedEditingRanges(q,ee,re,le){return this._withAdapter(q,b,async Z=>{const ae=await Z.provideLinkedEditingRanges(p.URI.revive(ee),re,le);if(ae)return{ranges:ae.ranges,wordPattern:ae.wordPattern?We._serializeRegExp(ae.wordPattern):void 0}},void 0)}registerReferenceProvider(q,ee,re){const le=this._addNewAdapter(new f(this._documents,re),q);return this._proxy.$registerReferenceSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideReferences(q,ee,re,le,Z){return this._withAdapter(q,f,ae=>ae.provideReferences(p.URI.revive(ee),re,le,Z),void 0)}registerCodeActionProvider(q,ee,re,le){const Z=new a.DisposableStore,ae=this._addNewAdapter(new P(this._documents,this._commands.converter,this._diagnostics,re,this._logService,q,this._apiDeprecation),q);return this._proxy.$registerQuickFixSupport(ae,this._transformDocumentSelector(ee),{providedKinds:le?.providedCodeActionKinds?.map(pe=>pe.value),documentation:le?.documentation?.map(pe=>({kind:pe.kind.value,command:this._commands.converter.toInternal(pe.command,Z)}))},We._extLabel(q),Boolean(re.resolveCodeAction)),Z.add(this._createDisposable(ae)),Z}$provideCodeActions(q,ee,re,le,Z){return this._withAdapter(q,P,ae=>ae.provideCodeActions(p.URI.revive(ee),re,le,Z),void 0)}$resolveCodeAction(q,ee,re){return this._withAdapter(q,P,le=>le.resolveCodeAction(ee,re),void 0)}$releaseCodeActions(q,ee){this._withAdapter(q,P,re=>Promise.resolve(re.releaseCodeActions(ee)),void 0)}registerDocumentFormattingEditProvider(q,ee,re){const le=this._addNewAdapter(new L(this._documents,re),q);return this._proxy.$registerDocumentFormattingSupport(le,this._transformDocumentSelector(ee),q.identifier,q.displayName||q.name),this._createDisposable(le)}$provideDocumentFormattingEdits(q,ee,re,le){return this._withAdapter(q,L,Z=>Z.provideDocumentFormattingEdits(p.URI.revive(ee),re,le),void 0)}registerDocumentRangeFormattingEditProvider(q,ee,re){const le=this._addNewAdapter(new M(this._documents,re),q);return this._proxy.$registerRangeFormattingSupport(le,this._transformDocumentSelector(ee),q.identifier,q.displayName||q.name),this._createDisposable(le)}$provideDocumentRangeFormattingEdits(q,ee,re,le,Z){return this._withAdapter(q,M,ae=>ae.provideDocumentRangeFormattingEdits(p.URI.revive(ee),re,le,Z),void 0)}registerOnTypeFormattingEditProvider(q,ee,re,le){const Z=this._addNewAdapter(new R(this._documents,re),q);return this._proxy.$registerOnTypeFormattingSupport(Z,this._transformDocumentSelector(ee),le,q.identifier),this._createDisposable(Z)}$provideOnTypeFormattingEdits(q,ee,re,le,Z,ae){return this._withAdapter(q,R,pe=>pe.provideOnTypeFormattingEdits(p.URI.revive(ee),re,le,Z,ae),void 0)}registerWorkspaceSymbolProvider(q,ee){const re=this._addNewAdapter(new W(ee,this._logService),q);return this._proxy.$registerNavigateTypeSupport(re),this._createDisposable(re)}$provideWorkspaceSymbols(q,ee,re){return this._withAdapter(q,W,le=>le.provideWorkspaceSymbols(ee,re),{symbols:[]})}$resolveWorkspaceSymbol(q,ee,re){return this._withAdapter(q,W,le=>le.resolveWorkspaceSymbol(ee,re),void 0)}$releaseWorkspaceSymbols(q,ee){this._withAdapter(q,W,re=>re.releaseWorkspaceSymbols(ee),void 0)}registerRenameProvider(q,ee,re){const le=this._addNewAdapter(new V(this._documents,re,this._logService),q);return this._proxy.$registerRenameSupport(le,this._transformDocumentSelector(ee),V.supportsResolving(re)),this._createDisposable(le)}$provideRenameEdits(q,ee,re,le,Z){return this._withAdapter(q,V,ae=>ae.provideRenameEdits(p.URI.revive(ee),re,le,Z),void 0)}$resolveRenameLocation(q,ee,re,le){return this._withAdapter(q,V,Z=>Z.resolveRenameLocation(p.URI.revive(ee),re,le),void 0)}registerDocumentSemanticTokensProvider(q,ee,re,le){const Z=this._nextHandle(),ae=typeof re.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Z,new xe(new j(this._documents,re),q)),this._proxy.$registerDocumentSemanticTokensProvider(Z,this._transformDocumentSelector(ee),le,ae);let pe=this._createDisposable(Z);if(ae){const Me=re.onDidChangeSemanticTokens(je=>this._proxy.$emitDocumentSemanticTokensEvent(ae));pe=y.Disposable.from(pe,Me)}return pe}$provideDocumentSemanticTokens(q,ee,re,le){return this._withAdapter(q,j,Z=>Z.provideDocumentSemanticTokens(p.URI.revive(ee),re,le),null,!0)}$releaseDocumentSemanticTokens(q,ee){this._withAdapter(q,j,re=>re.releaseDocumentSemanticColoring(ee),void 0)}registerDocumentRangeSemanticTokensProvider(q,ee,re,le){const Z=this._addNewAdapter(new U(this._documents,re),q);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Z,this._transformDocumentSelector(ee),le),this._createDisposable(Z)}$provideDocumentRangeSemanticTokens(q,ee,re,le){return this._withAdapter(q,U,Z=>Z.provideDocumentRangeSemanticTokens(p.URI.revive(ee),re,le),null,!0)}registerCompletionItemProvider(q,ee,re,le){const Z=this._addNewAdapter(new B(this._documents,this._commands.converter,re,this._apiDeprecation,q),q);return this._proxy.$registerSuggestSupport(Z,this._transformDocumentSelector(ee),le,B.supportsResolving(re),`${q.identifier.value}(${le.join("")})`),this._createDisposable(Z)}$provideCompletionItems(q,ee,re,le,Z){return this._withAdapter(q,B,ae=>ae.provideCompletionItems(p.URI.revive(ee),re,le,Z),void 0)}$resolveCompletionItem(q,ee,re){return this._withAdapter(q,B,le=>le.resolveCompletionItem(ee,re),void 0)}$releaseCompletionItems(q,ee){this._withAdapter(q,B,re=>re.releaseCompletionItems(ee),void 0)}registerInlineCompletionsProvider(q,ee,re){const le=this._addNewAdapter(new z(this._documents,re,this._commands.converter),q);return this._proxy.$registerInlineCompletionsSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideInlineCompletions(q,ee,re,le,Z){return this._withAdapter(q,z,ae=>ae.provideInlineCompletions(p.URI.revive(ee),re,le,Z),void 0)}$handleInlineCompletionDidShow(q,ee,re){this._withAdapter(q,z,async le=>{le.handleDidShowCompletionItem(ee,re)},void 0)}$freeInlineCompletionsList(q,ee){this._withAdapter(q,z,async re=>{re.disposeCompletions(ee)},void 0)}registerSignatureHelpProvider(q,ee,re,le){const Z=Array.isArray(le)?{triggerCharacters:le,retriggerCharacters:[]}:le,ae=this._addNewAdapter(new $(this._documents,re),q);return this._proxy.$registerSignatureHelpProvider(ae,this._transformDocumentSelector(ee),Z),this._createDisposable(ae)}$provideSignatureHelp(q,ee,re,le,Z){return this._withAdapter(q,$,ae=>ae.provideSignatureHelp(p.URI.revive(ee),re,le,Z),void 0)}$releaseSignatureHelp(q,ee){this._withAdapter(q,$,re=>re.releaseSignatureHelp(ee),void 0)}registerInlayHintsProvider(q,ee,re){const le=typeof re.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Z=this._addNewAdapter(new x(this._documents,re),q);this._proxy.$registerInlayHintsProvider(Z,this._transformDocumentSelector(ee),le);let ae=this._createDisposable(Z);if(le!==void 0){const pe=re.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(le));ae=y.Disposable.from(ae,pe)}return ae}$provideInlayHints(q,ee,re,le){return this._withAdapter(q,x,Z=>Z.provideInlayHints(p.URI.revive(ee),re,le),void 0)}registerDocumentLinkProvider(q,ee,re){const le=this._addNewAdapter(new X(this._documents,re),q);return this._proxy.$registerDocumentLinkProvider(le,this._transformDocumentSelector(ee),typeof re.resolveDocumentLink=="function"),this._createDisposable(le)}$provideDocumentLinks(q,ee,re){return this._withAdapter(q,X,le=>le.provideLinks(p.URI.revive(ee),re),void 0)}$resolveDocumentLink(q,ee,re){return this._withAdapter(q,X,le=>le.resolveLink(ee,re),void 0)}$releaseDocumentLinks(q,ee){this._withAdapter(q,X,re=>re.releaseLinks(ee),void 0)}registerColorProvider(q,ee,re){const le=this._addNewAdapter(new Q(this._documents,re),q);return this._proxy.$registerDocumentColorProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDocumentColors(q,ee,re){return this._withAdapter(q,Q,le=>le.provideColors(p.URI.revive(ee),re),[])}$provideColorPresentations(q,ee,re,le){return this._withAdapter(q,Q,Z=>Z.provideColorPresentations(p.URI.revive(ee),re,le),void 0)}registerFoldingRangeProvider(q,ee,re){const le=this._nextHandle(),Z=typeof re.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(le,new xe(new de(this._documents,re),q)),this._proxy.$registerFoldingRangeProvider(le,this._transformDocumentSelector(ee),Z);let ae=this._createDisposable(le);if(Z!==void 0){const pe=re.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Z));ae=y.Disposable.from(ae,pe)}return ae}$provideFoldingRanges(q,ee,re,le){return this._withAdapter(q,de,Z=>Z.provideFoldingRanges(p.URI.revive(ee),re,le),void 0)}registerSelectionRangeProvider(q,ee,re){const le=this._addNewAdapter(new _e(this._documents,re,this._logService),q);return this._proxy.$registerSelectionRangeProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideSelectionRanges(q,ee,re,le){return this._withAdapter(q,_e,Z=>Z.provideSelectionRanges(p.URI.revive(ee),re,le),[])}registerCallHierarchyProvider(q,ee,re){const le=this._addNewAdapter(new ye(this._documents,re),q);return this._proxy.$registerCallHierarchyProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$prepareCallHierarchy(q,ee,re,le){return this._withAdapter(q,ye,Z=>Promise.resolve(Z.prepareSession(p.URI.revive(ee),re,le)),void 0)}$provideCallHierarchyIncomingCalls(q,ee,re,le){return this._withAdapter(q,ye,Z=>Z.provideCallsTo(ee,re,le),void 0)}$provideCallHierarchyOutgoingCalls(q,ee,re,le){return this._withAdapter(q,ye,Z=>Z.provideCallsFrom(ee,re,le),void 0)}$releaseCallHierarchy(q,ee){this._withAdapter(q,ye,re=>Promise.resolve(re.releaseSession(ee)),void 0)}registerTypeHierarchyProvider(q,ee,re){const le=this._addNewAdapter(new ke(this._documents,re),q);return this._proxy.$registerTypeHierarchyProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$prepareTypeHierarchy(q,ee,re,le){return this._withAdapter(q,ke,Z=>Promise.resolve(Z.prepareSession(p.URI.revive(ee),re,le)),void 0)}$provideTypeHierarchySupertypes(q,ee,re,le){return this._withAdapter(q,ke,Z=>Z.provideSupertypes(ee,re,le),void 0)}$provideTypeHierarchySubtypes(q,ee,re,le){return this._withAdapter(q,ke,Z=>Z.provideSubtypes(ee,re,le),void 0)}$releaseTypeHierarchy(q,ee){this._withAdapter(q,ke,re=>Promise.resolve(re.releaseSession(ee)),void 0)}static _serializeRegExp(q){return{pattern:q.source,flags:(0,_.regExpFlags)(q)}}static _serializeIndentationRule(q){return{decreaseIndentPattern:We._serializeRegExp(q.decreaseIndentPattern),increaseIndentPattern:We._serializeRegExp(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?We._serializeRegExp(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?We._serializeRegExp(q.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(q){return{beforeText:We._serializeRegExp(q.beforeText),afterText:q.afterText?We._serializeRegExp(q.afterText):void 0,previousLineText:q.previousLineText?We._serializeRegExp(q.previousLineText):void 0,action:q.action}}static _serializeOnEnterRules(q){return q.map(We._serializeOnEnterRule)}setLanguageConfiguration(q,ee,re){let{wordPattern:le}=re;if(le&&(0,_.regExpLeadsToEndlessLoop)(le))throw new Error(`Invalid language configuration: wordPattern '${le}' is not allowed to match the empty string.`);le?this._documents.setWordDefinitionFor(ee,le):this._documents.setWordDefinitionFor(ee,void 0),re.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),re.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const Z=this._nextHandle(),ae={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?We._serializeRegExp(re.wordPattern):void 0,indentationRules:re.indentationRules?We._serializeIndentationRule(re.indentationRules):void 0,onEnterRules:re.onEnterRules?We._serializeOnEnterRules(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Z,ee,ae),this._createDisposable(Z)}$setWordDefinitions(q){for(const ee of q)this._documents.setWordDefinitionFor(ee.languageId,new RegExp(ee.regexSource,ee.regexFlags))}}e.ExtHostLanguageFeatures=We,We._handlePool=0}),define(fe[244],me([0,1,5,16,7,49,15,6]),function(Y,e,p,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(i,k,a,g){this._documents=k,this._commands=a,this._uriTransformer=g,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=i.getProxy(p.MainContext.MainThreadLanguages)}$acceptLanguageIds(i){this._languageIds=i}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(i,k){await this._proxy.$changeLanguage(i,k);const a=this._documents.getDocumentData(i);if(!a)throw new Error(`document '${i.toString}' NOT found`);return a.document}async tokenAtPosition(i,k){const a=i.version,g=F.Position.from(k),d=await this._proxy.$tokensAtPosition(i.uri,g),w={type:C.StandardTokenType.Other,range:i.getWordRangeAtPosition(k)??new C.Range(k.line,k.character,k.line,k.character)};if(!d)return w;const D={range:F.Range.to(d.range),type:F.TokenType.to(d.type)};return!D.range.contains(k)||a!==i.version?w:D}createLanguageStatusItem(i,k,a){const g=this._handlePool++,d=this._proxy,w=this._ids,D=`${i.identifier.value}/${k}`;if(w.has(D))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);w.add(D);const T={selector:a,id:k,name:i.displayName??i.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let E,c=new _.DisposableStore;const r=()=>{E?.dispose(),E=(0,A.disposableTimeout)(()=>{c.clear(),this._proxy.$setLanguageStatus(g,{id:D,name:T.name??i.displayName??i.name,source:i.displayName??i.name,selector:F.DocumentSelector.from(T.selector,this._uriTransformer),label:T.text,detail:T.detail??"",severity:T.severity===C.LanguageStatusSeverity.Error?y.default.Error:T.severity===C.LanguageStatusSeverity.Warning?y.default.Warning:y.default.Info,command:T.command&&this._commands.toInternal(T.command,c),accessibilityInfo:T.accessibilityInformation})},0)},v={dispose(){c.dispose(),E?.dispose(),d.$removeLanguageStatus(g),w.delete(D)},get id(){return T.id},get name(){return T.name},set name(t){T.name=t,r()},get selector(){return T.selector},set selector(t){T.selector=t,r()},get text(){return T.text},set text(t){T.text=t,r()},get detail(){return T.detail},set detail(t){T.detail=t,r()},get severity(){return T.severity},set severity(t){T.severity=t,r()},get accessibilityInformation(){return T.accessibilityInformation},set accessibilityInformation(t){T.accessibilityInformation=t,r()},get command(){return T.command},set command(t){T.command=t,r()}};return r(),v}}e.ExtHostLanguages=S}),define(fe[245],me([0,1,5,13,35]),function(Y,e,p,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function y(_){return _&&_.title}let A=class{constructor(S,I){this._logService=I,this._proxy=S.getProxy(p.MainContext.MainThreadMessageService)}showMessage(S,I,i,k,a){const g={extension:S};let d;typeof k=="string"||y(k)?d=[k,...a]:(g.modal=k?.modal,g.useCustom=k?.useCustom,g.detail=k?.detail,d=a),g.useCustom&&(0,C.checkProposedApiEnabled)(S);const w=[];for(let D=0;D<d.length;D++){const T=d[D];if(typeof T=="string")w.push({title:T,handle:D,isCloseAffordance:!1});else if(typeof T=="object"){let{title:E,isCloseAffordance:c}=T;w.push({title:E,isCloseAffordance:!!c,handle:D})}else this._logService.warn("Invalid message item:",T)}return this._proxy.$showMessage(I,i,g,w).then(D=>{if(typeof D=="number")return d[D]})}};A=Ve([$e(1,F.ILogService)],A),e.ExtHostMessageService=A}),define(fe[246],me([0,1,22,3,48,6,24,9,12,2,87,5,16,7,55,221,131]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class T{constructor(c,r,v,t,h){this._textDocumentsAndEditors=v,this._textDocuments=t,this._extensionStoragePaths=h,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new F.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new F.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new F.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new F.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new F.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new F.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new F.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new F.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new i.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=c.getProxy(k.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=c.getProxy(k.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=c.getProxy(k.MainContext.MainThreadNotebookEditors),this._commandsConverter=r.converter,r.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const n=s.notebookEditor?.notebookUri,u=s.cell.handle,l=this._documents.get(n)?.getCell(u);if(l)return l.apiCell}return s}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(c=>c.apiEditor)}getEditorById(c){const r=this._editors.get(c);if(!r)throw new Error(`unknown text editor: ${c}. known editors: ${[...this._editors.keys()]} `);return r}getIdByEditor(c){for(const[r,v]of this._editors)if(v.apiEditor===c)return r}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(c,r){const v=this._documents.get(c);if(!v&&!r)throw new Error(`NO notebook document for '${c}'`);return v}_getProviderData(c){const r=this._notebookContentProviders.get(c);if(!r)throw new Error(`NO provider for '${c}'`);return r}registerNotebookContentProvider(c,r,v,t,h){if((0,_.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(r))throw new Error(`Notebook provider for '${r}' already registered`);this._notebookContentProviders.set(r,{extension:c,provider:v});let s;return v.onDidChangeNotebookContentOptions&&(s=v.onDidChangeNotebookContentOptions(()=>{const n=a.NotebookDocumentContentOptions.from(v.options);this._notebookProxy.$updateNotebookProviderOptions(r,n)})),this._notebookProxy.$registerNotebookProvider({id:c.identifier,location:c.extensionLocation},r,a.NotebookDocumentContentOptions.from(t),T._convertNotebookRegistrationData(c,h)),new g.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(r),this._notebookProxy.$unregisterNotebookProvider(r)})}static _convertNotebookRegistrationData(c,r){if(!r)return;const v=r.filenamePattern.map(t=>a.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(r.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${r.filenamePattern}`);return}return{extension:c.identifier,providerDisplayName:c.displayName||c.name,displayName:r.displayName,filenamePattern:v,exclusive:r.exclusive||!1}}registerNotebookCellStatusBarItemProvider(c,r,v){const t=T._notebookStatusBarItemProviderHandlePool++,h=typeof v.onDidChangeCellStatusBarItems=="function"?T._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(t,v),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(t,h,r);let s;return h!==void 0&&(s=v.onDidChangeCellStatusBarItems(n=>this._notebookProxy.$emitCellStatusBarEvent(h))),new g.Disposable(()=>{this._notebookStatusBarItemProviders.delete(t),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(t,h),s&&s.dispose()})}async createNotebookDocument(c){const r=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:c.viewType,content:c.content&&a.NotebookData.from(c.content)});return I.URI.revive(r)}async openNotebookDocument(c){const r=this._documents.get(c);if(r)return r.apiNotebook;const v=await this._notebookDocumentsProxy.$tryOpenNotebook(c),t=this._documents.get(I.URI.revive(v));return(0,S.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(c,r){I.URI.isUri(c)&&(c=await this.openNotebookDocument(c));let v;typeof r=="object"?v={position:a.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus,selections:r.selections&&r.selections.map(a.NotebookRange.from),pinned:typeof r.preview=="boolean"?!r.preview:void 0}:v={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(c.uri,c.notebookType,v),h=t&&this._editors.get(t)?.apiEditor;if(h)return h;throw t?new Error(`Could NOT open editor for "${c.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${c.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(c,r,v,t){const h=this._notebookStatusBarItemProviders.get(c),s=I.URI.revive(r),n=this._documents.get(s);if(!n||!h)return;const u=n.getCellFromIndex(v);if(!u)return;const o=await h.provideCellStatusBarItems(u.apiCell,t);if(!o)return;const l=new y.DisposableStore,m=this._statusBarCache.add([l]),f=(Array.isArray(o)?o:[o]).map(P=>a.NotebookStatusBarItem.from(P,this._commandsConverter,l));return{cacheId:m,items:f}}$releaseNotebookCellStatusBarItems(c){this._statusBarCache.delete(c)}registerNotebookSerializer(c,r,v,t,h){if((0,_.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,v),this._notebookProxy.$registerNotebookSerializer(s,{id:c.identifier,location:c.extensionLocation},r,a.NotebookDocumentContentOptions.from(t),T._convertNotebookRegistrationData(c,h)),(0,y.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(c,r,v){const t=this._notebookSerializer.get(c);if(!t)throw new Error("NO serializer found");const h=await t.deserializeNotebook(r.buffer,v);return new d.SerializableObjectWithBuffers(a.NotebookData.from(h))}async $notebookToData(c,r,v){const t=this._notebookSerializer.get(c);if(!t)throw new Error("NO serializer found");const h=await t.serializeNotebook(a.NotebookData.to(r.value),v);return p.VSBuffer.wrap(h)}async $openNotebook(c,r,v,t,h){const{provider:s}=this._getProviderData(c),n=await s.openNotebook(I.URI.revive(r),{backupId:v,untitledDocumentData:t?.buffer},h);return new d.SerializableObjectWithBuffers({metadata:n.metadata??Object.create(null),cells:n.cells.map(a.NotebookCellData.from)})}async $saveNotebook(c,r,v){const t=this.getNotebookDocument(I.URI.revive(r)),{provider:h}=this._getProviderData(c);return await h.saveNotebook(t.apiNotebook,v),!0}async $saveNotebookAs(c,r,v,t){const h=this.getNotebookDocument(I.URI.revive(r)),{provider:s}=this._getProviderData(c);return await s.saveNotebookAs(I.URI.revive(v),h.apiNotebook,t),!0}async $backupNotebook(c,r,v){const t=this.getNotebookDocument(I.URI.revive(r)),h=this._getProviderData(c),s=this._extensionStoragePaths.workspaceValue(h.extension)??this._extensionStoragePaths.globalValue(h.extension),n=String((0,C.hash)([t.uri.toString(),this._backupIdPool++])),u=I.URI.joinPath(s,n),o=await h.provider.backupNotebook(t.apiNotebook,{destination:u},v);return t.updateBackup(o),o.id}_createExtHostEditor(c,r,v){if(this._editors.has(r))throw new Error(`editor with id ALREADY EXSIST: ${r}`);const t=new D.ExtHostNotebookEditor(r,this._notebookEditorsProxy,c,v.visibleRanges.map(a.NotebookRange.to),v.selections.map(a.NotebookRange.to),typeof v.viewColumn=="number"?a.ViewColumn.to(v.viewColumn):void 0);this._editors.set(r,t)}$acceptDocumentAndEditorsDelta(c){if(c.value.removedDocuments)for(const v of c.value.removedDocuments){const t=I.URI.revive(v),h=this._documents.get(t);h&&(h.dispose(),this._documents.delete(t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:h.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(h.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===t.toString()&&this._editors.delete(s.id)}if(c.value.addedDocuments){const v=[];for(const t of c.value.addedDocuments){const h=I.URI.revive(t.uri);if(this._documents.has(h))throw new Error(`adding EXISTING notebook ${h} `);const s=this,n=new w.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(u){s._onDidChangeNotebookCells.fire(u)},emitCellOutputsChange(u){s._onDidChangeCellOutputs.fire(u)},emitCellMetadataChange(u){s._onDidChangeCellMetadata.fire(u)},emitCellExecutionStateChange(u){s._onDidChangeCellExecutionState.fire(u)}},h,t);v.push(...t.cells.map(u=>w.ExtHostCell.asModelAddData(n.apiNotebook,u))),this._documents.get(h)?.dispose(),this._documents.set(h,n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this._onDidOpenNotebookDocument.fire(n.apiNotebook)}}if(c.value.addedEditors)for(const v of c.value.addedEditors){if(this._editors.has(v.id))return;const t=I.URI.revive(v.documentUri),h=this._documents.get(t);h&&this._createExtHostEditor(h,v.id,v)}const r=[];if(c.value.removedEditors)for(const v of c.value.removedEditors){const t=this._editors.get(v);t&&(this._editors.delete(v),this._activeNotebookEditor?.id===t.id&&(this._activeNotebookEditor=void 0),r.push(t))}if(c.value.visibleEditors){this._visibleNotebookEditors=c.value.visibleEditors.map(t=>this._editors.get(t)).filter(t=>!!t);const v=new Set;this._visibleNotebookEditors.forEach(t=>v.add(t.id));for(const t of this._editors.values()){const h=v.has(t.id);t._acceptVisibility(h)}this._visibleNotebookEditors=[...this._editors.values()].map(t=>t).filter(t=>t.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}c.value.newActiveEditor===null?this._activeNotebookEditor=void 0:c.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(c.value.newActiveEditor)),c.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=T,T._notebookStatusBarItemProviderHandlePool=0}),define(fe[247],me([0,1,3,77,13,5,14,16]),function(Y,e,p,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(k,a){const g=S._Keys.nextId();k.$registerNotebookEditorDecorationType(g,_.NotebookDecorationRenderOptions.from(a)),this.value={key:g,dispose(){k.$removeNotebookEditorDecorationType(g)}}}}S._Keys=new F.IdGenerator("NotebookEditorDecorationType");let I=class{constructor(k,a,g){this._logService=k,this._extHostRpc=a,this._notebooksAndEditors=g,this._onDidChangeNotebookEditorSelection=new p.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new p.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(k){return new S(this._extHostRpc.getProxy(y.MainContext.MainThreadNotebookEditors),k).value}$acceptEditorPropertiesChanged(k,a){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",k,a);const g=this._notebooksAndEditors.getEditorById(k);a.visibleRanges&&g._acceptVisibleRanges(a.visibleRanges.ranges.map(_.NotebookRange.to)),a.selections&&g._acceptSelections(a.selections.selections.map(_.NotebookRange.to)),a.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:g.apiEditor,visibleRanges:g.apiEditor.visibleRanges}),a.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:g.apiEditor,selections:g.apiEditor.selections}))}$acceptEditorViewColumns(k){for(const a in k)this._notebooksAndEditors.getEditorById(a)._acceptViewColumn(_.ViewColumn.to(k[a]))}};I=Ve([$e(0,C.ILogService),$e(1,A.IExtHostRpcService)],I),e.ExtHostNotebookEditors=I}),define(fe[248],me([0,1,18,15,21,3,6,24,2,26,13,5,40,16,7,88,214,35,55]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d,w,D,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let c=class{constructor(s,n,u,o,l){this._initData=n,this._extHostNotebook=u,this._commands=o,this._logService=l,this._activeExecutions=new _.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=s.getProxy(k.MainContext.MainThreadNotebookKernels);const m=new a.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new a.ApiCommandArgument("options","Select kernel options",b=>!0,b=>{if(b&&"notebookEditor"in b&&"id"in b){const f=this._extHostNotebook.getIdByEditor(b.notebookEditor);return{id:b.id,extension:b.extension,notebookEditorId:f}}else if(b&&"notebookEditor"in b){const f=this._extHostNotebook.getIdByEditor(b.notebookEditor);if(f===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${b.notebookEditor.document.uri.toString()}`);return{notebookEditorId:f}}return b})],a.ApiCommandResult.Void);this._commands.registerApiCommand(m)}createNotebookController(s,n,u,o,l,m){for(let $ of this._kernelData.values())if($.controller.id===n&&I.ExtensionIdentifier.equals(s.identifier,$.extensionId))throw new Error(`notebook controller with id '${n}' ALREADY exist`);const b=this._handlePool++,f=this;this._logService.trace(`NotebookController[${b}], CREATED by ${s.identifier.value}, ${n}`);const P=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${s.identifier}'`);let L=!1;const M=new A.DisposableStore,R=new y.Emitter,W=new y.Emitter,V={id:`${s.identifier.value}/${n}`,notebookType:u,extensionId:s.identifier,extensionLocation:s.extensionLocation,label:o||s.identifier.value,preloads:m?m.map(g.NotebookRendererScript.from):[]};let N=l??P,j;this._proxy.$addKernel(b,V).catch($=>{console.log($),L=!0});let U=0;const B=()=>{if(L)return;const $=++U;Promise.resolve().then(()=>{$===U&&this._proxy.$updateKernel(b,V)})},z=new _.ResourceMap,O={get id(){return n},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:R.event,get label(){return V.label},set label($){V.label=$??s.displayName??s.name,B()},get detail(){return V.detail??""},set detail($){V.detail=$,B()},get description(){return V.description??""},set description($){V.description=$,B()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages($){V.supportedLanguages=$,B()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder($){V.supportsExecutionOrder=$,B()},get rendererScripts(){return V.preloads?V.preloads.map(g.NotebookRendererScript.to):[]},get executeHandler(){return N},set executeHandler($){N=$??P},get interruptHandler(){return j},set interruptHandler($){j=$,V.supportsInterrupt=Boolean($),B()},createNotebookCellExecution($){if(L)throw new Error("notebook controller is DISPOSED");if(!z.has($.notebook.uri))throw f._logService.trace(`NotebookController[${b}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(z.keys()).map(x=>x.toString())),new Error(`notebook controller is NOT associated to notebook: ${$.notebook.uri.toString()}`);return f._createNotebookCellExecution($)},dispose:()=>{L||(this._logService.trace(`NotebookController[${b}], DISPOSED`),L=!0,this._kernelData.delete(b),M.dispose(),R.dispose(),W.dispose(),this._proxy.$removeKernel(b))},updateNotebookAffinity($,x){f._proxy.$updateNotebookPriority(b,$.uri,x)},onDidReceiveMessage:W.event,postMessage($,x){return(0,T.checkProposedApiEnabled)(s),f._proxy.$postMessage(b,x&&f._extHostNotebook.getIdByEditor(x),$)},asWebviewUri($){return(0,T.checkProposedApiEnabled)(s),(0,w.asWebviewUri)($,f._initData.remote)}};return this._kernelData.set(b,{extensionId:s.identifier,controller:O,onDidReceiveMessage:W,onDidChangeSelection:R,associatedNotebooks:z}),O}$acceptNotebookAssociation(s,n,u){const o=this._kernelData.get(s);if(o){const l=this._extHostNotebook.getNotebookDocument(S.URI.revive(n));u?o.associatedNotebooks.set(l.uri,!0):o.associatedNotebooks.delete(l.uri),this._logService.trace(`NotebookController[${s}] ASSOCIATE notebook`,l.uri.toString(),u),o.onDidChangeSelection.fire({selected:u,notebook:l.apiNotebook})}}async $executeCells(s,n,u){const o=this._kernelData.get(s);if(!o)return;const l=this._extHostNotebook.getNotebookDocument(S.URI.revive(n)),m=[];for(let b of u){const f=l.getCell(b);f&&m.push(f.apiCell)}try{this._logService.trace(`NotebookController[${s}] EXECUTE cells`,l.uri.toString(),m.length),await o.controller.executeHandler.call(o.controller,m,l.apiNotebook,o.controller)}catch(b){this._logService.error(`NotebookController[${s}] execute cells FAILED`,b),console.error(b)}}async $cancelCells(s,n,u){const o=this._kernelData.get(s);if(!o)return;const l=this._extHostNotebook.getNotebookDocument(S.URI.revive(n));if(o.controller.interruptHandler)await o.controller.interruptHandler.call(o.controller,l.apiNotebook);else for(let m of u){const b=l.getCell(m);b&&this._activeExecutions.get(b.uri)?.cancel()}}$acceptKernelMessageFromRenderer(s,n,u){const o=this._kernelData.get(s);if(!o)return;const l=this._extHostNotebook.getEditorById(n);o.onDidReceiveMessage.fire(Object.freeze({editor:l.apiEditor,message:u}))}_createNotebookCellExecution(s){if(s.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this._extHostNotebook.getNotebookDocument(s.notebook.uri).getCellFromApiCell(s);if(!u)throw new Error("invalid cell");if(this._activeExecutions.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const o=new v(u.notebook,u,this._proxy);this._activeExecutions.set(u.uri,o);const l=o.onDidChangeState(()=>{o.state===r.Resolved&&(o.dispose(),l.dispose(),this._activeExecutions.delete(u.uri))});return o.asApiObject()}};c=Ve([$e(4,i.ILogService)],c),e.ExtHostNotebookKernels=c;var r;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(r||(r={}));class v extends A.Disposable{constructor(s,n,u){super();this._document=s,this._cell=n,this._proxy=u,this._handle=v.HANDLE++,this._onDidChangeState=new y.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=r.Init,this._tokenSource=this._register(new C.CancellationTokenSource),this._collector=new t(10,o=>this.update(o)),this._executionOrder=n.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(s){await this._collector.addItem(s)}async update(s){const n=Array.isArray(s)?s:[s];return this._proxy.$updateExecutions(new E.SerializableObjectWithBuffers(n))}verifyStateForOutput(){if(this._state===r.Init)throw new Error("Must call start before modifying cell output");if(this._state===r.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(s){let n=this._cell;if(s&&(n=this._document.getCellFromApiCell(s)),!n)throw new Error("INVALID cell");return n.handle}validateAndConvertOutputs(s){return s.map(n=>{const u=d.NotebookCellOutput.ensureUniqueMimeTypes(n.items,!0);return u===n.items?g.NotebookCellOutput.from(n):g.NotebookCellOutput.from({items:u,id:n.id,metadata:n.metadata})})}async updateOutputs(s,n,u){const o=this.cellIndexToHandle(n),l=this.validateAndConvertOutputs((0,p.asArray)(s));return this.updateSoon({editType:D.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:o,append:u,outputs:l})}async updateOutputItems(s,n,u){return s=d.NotebookCellOutput.ensureUniqueMimeTypes((0,p.asArray)(s),!0),this.updateSoon({editType:D.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:s.map(g.NotebookCellOutputItem.from),outputId:n.id,append:u})}asApiObject(){const s=this;return Object.freeze({get token(){return s._tokenSource.token},get cell(){return s._cell.apiCell},get executionOrder(){return s._executionOrder},set executionOrder(u){s._executionOrder=u,s.update([{editType:D.CellExecutionUpdateType.ExecutionState,executionHandle:s._handle,executionOrder:s._executionOrder}])},start(u){if(s._state===r.Resolved||s._state===r.Started)throw new Error("Cannot call start again");s._state=r.Started,s._onDidChangeState.fire(),s.update({editType:D.CellExecutionUpdateType.ExecutionState,executionHandle:s._handle,runStartTime:u})},end(u,o){if(s._state===r.Resolved)throw new Error("Cannot call resolve twice");s._state=r.Resolved,s._onDidChangeState.fire(),s.updateSoon({editType:D.CellExecutionUpdateType.Complete,executionHandle:s._handle,runEndTime:o,lastRunSuccess:u}),s._collector.flush(),s._proxy.$removeExecution(s._handle)},clearOutput(u){return s.verifyStateForOutput(),s.updateOutputs([],u,!1)},appendOutput(u,o){return s.verifyStateForOutput(),s.updateOutputs(u,o,!0)},replaceOutput(u,o){return s.verifyStateForOutput(),s.updateOutputs(u,o,!1)},appendOutputItems(u,o){return s.verifyStateForOutput(),s.updateOutputItems(u,o,!0)},replaceOutputItems(u,o){return s.verifyStateForOutput(),s.updateOutputItems(u,o,!1)}})}}v.HANDLE=0;class t{constructor(s,n){this.delay=s,this.callback=n,this.batch=[],this.startedTimer=Date.now()}addItem(s){return this.batch.push(s),this.currentDeferred||(this.currentDeferred=new F.DeferredPromise,this.startedTimer=Date.now(),(0,F.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const s=this.currentDeferred;this.currentDeferred=void 0;const n=this.batch;return this.batch=[],this.callback(n).finally(()=>s.complete())}}}),define(fe[249],me([0,1,3,5,131]),function(Y,e,p,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class y{constructor(_,S){this._extHostNotebook=S,this._rendererMessageEmitters=new Map,this.proxy=_.getProxy(F.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(_,S,I){const i=this._extHostNotebook.getEditorById(_);this._rendererMessageEmitters.get(S)?.fire({editor:i.apiEditor,message:I})}createRendererMessaging(_,S){if(!_.contributes?.notebookRenderer?.some(a=>a.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);const I=!!_.enableProposedApi,i=new WeakMap;return{onDidReceiveMessage:(a,g,d)=>{const w=I?a:D=>{const T={};i.set(T,D.editor),a({editor:T,message:D.message})};return this.getOrCreateEmitterFor(S).event(w,g,d)},postMessage:(a,g)=>{C.ExtHostNotebookEditor.apiEditorsToExtHost.has(a)&&([a,g]=[g,a]);const d=I?g:i.get(g),w=d&&C.ExtHostNotebookEditor.apiEditorsToExtHost.get(d);return this.proxy.$postMessage(w?.id,S,a)}}}getOrCreateEmitterFor(_){let S=this._rendererMessageEmitters.get(_);return S||(S=new p.Emitter({onLastListenerRemove:()=>{S?.dispose(),this._rendererMessageEmitters.delete(_)}}),this._rendererMessageEmitters.set(_,S),S)}}e.ExtHostNotebookRenderers=y}),define(fe[69],me([0,1,5,3,6,22,4,14]),function(Y,e,p,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class S extends C.Disposable{constructor(d,w,D,T,E){super();this._onDidAppend=this._register(new F.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=d,this._proxy=E,this._id=E.$register(this.name,w,D,T),this._disposed=!1,this._offset=0}get name(){return this._name}append(d){this.validate(),this._offset+=d?y.VSBuffer.fromString(d).byteLength:0}update(){this._id.then(d=>this._proxy.$update(d))}appendLine(d){this.validate(),this.append(d+`
`)}clear(){this.validate();const d=this._offset;this._id.then(w=>this._proxy.$clear(w,d))}show(d,w){this.validate(),this._id.then(D=>this._proxy.$reveal(D,!!(typeof d=="boolean"?d:w)))}hide(){this.validate(),this._id.then(d=>this._proxy.$close(d))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(d=>this._proxy.$dispose(d)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=S;class I extends S{constructor(d,w,D){super(d,!1,void 0,w,D)}append(d){super.append(d),this._id.then(w=>this._proxy.$append(w,d)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=I;class i extends S{constructor(d,w,D){super(d,!0,w,void 0,D)}append(d){throw new Error("Not supported")}}class k{constructor(d,w){this.name=d,this._channel=w}append(d){this._channel.then(w=>w.append(d))}appendLine(d){this._channel.then(w=>w.appendLine(d))}clear(){this._channel.then(d=>d.clear())}show(d,w){this._channel.then(D=>D.show(d,w))}hide(){this._channel.then(d=>d.hide())}dispose(){this._channel.then(d=>d.dispose())}}e.LazyOutputChannel=k;let a=class{constructor(d){this._proxy=d.getProxy(p.MainContext.MainThreadOutputService)}$setVisibleChannel(d){}createOutputChannel(d,w){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");return new I(d,w.identifier.value,this._proxy)}createOutputChannelFromLogFile(d,w){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");if(!w)throw new Error("illegal argument `file`. must not be falsy");return new i(d,w,this._proxy)}};a=Ve([$e(0,_.IExtHostRpcService)],a),e.ExtHostOutputService=a,e.IExtHostOutputService=(0,A.createDecorator)("IExtHostOutputService")}),define(fe[250],me([0,1,15,21,3,6,5,2,7,17,18,49,65]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function g(d,w,D){const T=d.getProxy(A.MainContext.MainThreadQuickOpen);class E{constructor(o,l){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=l}showQuickPick(o,l,m,b=F.CancellationToken.None){this._onDidSelectItem=void 0;const f=Promise.resolve(o),P=++this._instances,L=T.$show(P,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},b),M={},R=L.then(()=>M);return Promise.race([R,f]).then(W=>{if(W!==M)return f.then(V=>{const N=[];for(let j=0;j<V.length;j++){const U=V[j];let B,z,O,$,x;typeof U=="string"?B=U:(B=U.label,z=U.description,O=U.detail,$=U.picked,x=U.alwaysShow),N.push({label:B,description:z,handle:j,detail:O,picked:$,alwaysShow:x})}return m&&typeof m.onDidSelectItem=="function"&&(this._onDidSelectItem=j=>{m.onDidSelectItem(V[j])}),T.$setItems(P,N),L.then(j=>{if(typeof j=="number")return V[j];if(Array.isArray(j))return j.map(U=>V[U])})})}).then(void 0,W=>{if(!(0,I.isPromiseCanceledError)(W))return T.$setError(P,W),Promise.reject(W)})}$onItemSelected(o){this._onDidSelectItem&&this._onDidSelectItem(o)}showInput(o,l=F.CancellationToken.None){return this._validateInput=o?o.validateInput:void 0,T.$input(o,typeof this._validateInput=="function",l).then(void 0,m=>{if(!(0,I.isPromiseCanceledError)(m))return Promise.reject(m)})}$validateInput(o){return this._validateInput?(0,p.asPromise)(()=>this._validateInput(o)):Promise.resolve(void 0)}async showWorkspaceFolderPick(o,l=F.CancellationToken.None){const m=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!m)return;const b=await this._workspace.getWorkspaceFolders2();if(!!b)return b.find(f=>f.uri.toString()===m.uri.toString())}createQuickPick(o,l){const m=new s(o,l,()=>this._sessions.delete(m._id));return this._sessions.set(m._id,m),m}createInputBox(o){const l=new n(o,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}$onDidChangeValue(o,l){const m=this._sessions.get(o);m&&m._fireDidChangeValue(l)}$onDidAccept(o){const l=this._sessions.get(o);l&&l._fireDidAccept()}$onDidChangeActive(o,l){const m=this._sessions.get(o);m instanceof s&&m._fireDidChangeActive(l)}$onDidChangeSelection(o,l){const m=this._sessions.get(o);m instanceof s&&m._fireDidChangeSelection(l)}$onDidTriggerButton(o,l){const m=this._sessions.get(o);m&&m._fireDidTriggerButton(l)}$onDidTriggerItemButton(o,l,m){const b=this._sessions.get(o);b instanceof s&&b._fireDidTriggerItemButton(l,m)}$onDidHide(o){const l=this._sessions.get(o);l&&l._fireDidHide()}}class c{constructor(o,l){this._extensionId=o,this._onDidDispose=l,this._id=s._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new C.Emitter,this._onDidChangeValueEmitter=new C.Emitter,this._onDidTriggerButtonEmitter=new C.Emitter,this._onDidHideEmitter=new C.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((l,m)=>{const b=l===S.QuickInputButtons.Back?-1:m;this._handlesToButtons.set(b,l)}),this.update({buttons:o.map((l,m)=>({...h(l),tooltip:l.tooltip,handle:l===S.QuickInputButtons.Back?-1:m}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const l=this._handlesToButtons.get(o);l&&this._onDidTriggerButtonEmitter.fire(l)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,y.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),T.$dispose(this._id))}update(o){if(!this._disposed){for(const l of Object.keys(o)){const m=o[l];this._pendingUpdate[l]=m===void 0?null:m}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){T.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}c._nextId=1;function r(u){if(u instanceof S.ThemeIcon)return{id:u.id};const o=t(u),l=v(u);return{dark:typeof o=="string"?_.URI.file(o):o,light:typeof l=="string"?_.URI.file(l):l}}function v(u){return typeof u=="object"&&"light"in u?u.light:u}function t(u){return typeof u=="object"&&"dark"in u?u.dark:u}function h(u){const o=r(u.iconPath);let l,m;return"id"in o?m=a.ThemeIcon.asClassName(o):l=o,{iconPath:l,iconClass:m}}class s extends c{constructor(o,l,m){super(o,m);this.enableProposedApi=l,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new C.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new C.Emitter,this._onDidTriggerItemButtonEmitter=new C.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((l,m)=>{this._handlesToItems.set(m,l),this._itemsToHandles.set(l,m)}),this.update({items:o.map((l,m)=>({label:l.label,description:l.description,handle:m,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow,buttons:l.buttons&&this.enableProposedApi?l.buttons.map((b,f)=>({...h(b),tooltip:b.tooltip,handle:f})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(o){this._keepScrollPosition=o,this.update({keepScrollPosition:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(l=>this._itemsToHandles.has(l)),this.update({activeItems:this._activeItems.map(l=>this._itemsToHandles.get(l))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(l=>this._itemsToHandles.has(l)),this.update({selectedItems:this._selectedItems.map(l=>this._itemsToHandles.get(l))})}_fireDidChangeActive(o){const l=(0,i.coalesce)(o.map(m=>this._handlesToItems.get(m)));this._activeItems=l,this._onDidChangeActiveEmitter.fire(l)}_fireDidChangeSelection(o){const l=(0,i.coalesce)(o.map(m=>this._handlesToItems.get(m)));this._selectedItems=l,this._onDidChangeSelectionEmitter.fire(l)}_fireDidTriggerItemButton(o,l){const m=this._handlesToItems.get(o);if(!m||!m.buttons||!m.buttons.length)return;const b=m.buttons[l];b&&this._onDidTriggerItemButtonEmitter.fire({button:b,item:m})}}class n extends c{constructor(o,l){super(o,l);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,this.update({validationMessage:o,severity:o?k.default.Error:k.default.Ignore})}}return new E(w,D)}e.createExtHostQuickOpen=g}),define(fe[251],me([0,1,2,3,60,6,15,5,18,101,13,26,35,65,16]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function w(o){if(o)return typeof o.iconPath=="string"?p.URI.file(o.iconPath):p.URI.isUri(o.iconPath)||g.ThemeIcon.isThemeIcon(o.iconPath)?o.iconPath:void 0}function D(o,l){if(!o.iconPath&&!l.iconPath)return 0;if(o.iconPath){if(!l.iconPath)return 1}else return-1;const m=typeof o.iconPath=="string"?o.iconPath:p.URI.isUri(o.iconPath)?o.iconPath.fsPath:o.iconPath.id,b=typeof l.iconPath=="string"?l.iconPath:p.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id;return(0,I.comparePaths)(m,b)}function T(o,l){let m=0;if(o.strikeThrough!==l.strikeThrough)return o.strikeThrough?1:-1;if(o.faded!==l.faded)return o.faded?1:-1;if(o.tooltip!==l.tooltip)return(o.tooltip||"").localeCompare(l.tooltip||"");if(m=D(o,l),m!==0)return m;if(o.light&&l.light)m=D(o.light,l.light);else{if(o.light)return 1;if(l.light)return-1}if(m!==0)return m;if(o.dark&&l.dark)m=D(o.dark,l.dark);else{if(o.dark)return 1;if(l.dark)return-1}return m}function E(o,l){if(o.command!==l.command)return o.command<l.command?-1:1;if(o.title!==l.title)return o.title<l.title?-1:1;if(o.tooltip!==l.tooltip){if(o.tooltip!==void 0&&l.tooltip!==void 0)return o.tooltip<l.tooltip?-1:1;if(o.tooltip!==void 0)return 1;if(l.tooltip!==void 0)return-1}if(o.arguments===l.arguments)return 0;if(o.arguments)if(l.arguments){if(o.arguments.length!==l.arguments.length)return o.arguments.length-l.arguments.length}else return 1;else return-1;for(let m=0;m<o.arguments.length;m++){const b=o.arguments[m],f=l.arguments[m];if(b!==f)return b<f?-1:1}return 0}function c(o,l){let m=(0,I.comparePaths)(o.resourceUri.fsPath,l.resourceUri.fsPath,!0);if(m!==0)return m;if(o.command&&l.command)m=E(o.command,l.command);else{if(o.command)return 1;if(l.command)return-1}if(m!==0)return m;if(o.decorations&&l.decorations)m=T(o.decorations,l.decorations);else{if(o.decorations)return 1;if(l.decorations)return-1}return m}function r(o,l){for(let m=0;m<o.length;m++)if(o[m]!==l[m])return!1;return!0}function v(o,l){return o.command===l.command&&o.title===l.title&&o.tooltip===l.tooltip&&(o.arguments&&l.arguments?r(o.arguments,l.arguments):o.arguments===l.arguments)}function t(o,l){return(0,S.equals)(o,l,v)}class h{constructor(l,m,b){this._extension=l,this._proxy=m,this._sourceControlHandle=b,this._value="",this._onDidChange=new F.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(l){this._proxy.$setInputBoxValue(this._sourceControlHandle,l),this.updateValue(l)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(l){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,l),this._placeholder=l}get validateInput(){return(0,a.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(l){if((0,a.checkProposedApiEnabled)(this._extension),l&&typeof l!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=l,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!l)}get visible(){return this._visible}set visible(l){l=!!l,this._visible!==l&&(this._visible=l,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,l))}focus(){(0,a.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(l,m){(0,a.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,l,m)}$onInputBoxValueChange(l){this.updateValue(l)}updateValue(l){this._value=l,this._onDidChange.fire(l)}}e.ExtHostSCMInputBox=h;class s{constructor(l,m,b,f,P){this._proxy=l,this._commands=m,this._sourceControlHandle=b,this._id=f,this._label=P,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new F.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=s._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(l){this._label=l,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,l)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(l){this._hideWhenEmpty=l,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(l){this._resourceStates=[...l],this._onDidUpdateResourceStates.fire()}getResourceState(l){return this._resourceStatesMap.get(l)}$executeResourceCommand(l,m){const b=this._resourceStatesCommandsMap.get(l);return b?(0,A.asPromise)(()=>this._commands.executeCommand(b.command,...b.arguments||[],m)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const l=[...this._resourceStates].sort(c),b=(0,S.sortedDiff)(this._resourceSnapshot,l,c).map(L=>{const M=L.toInsert.map(R=>{const W=this._resourceHandlePool++;this._resourceStatesMap.set(W,R);const V=R.resourceUri;let N;if(R.command)if(R.command.command==="vscode.open"||R.command.command==="vscode.diff"){const de=new y.DisposableStore;N=this._commands.converter.toInternal(R.command,de),this._resourceStatesDisposablesMap.set(W,de)}else this._resourceStatesCommandsMap.set(W,R.command);const j=w(R.decorations),U=R.decorations&&w(R.decorations.light)||j,B=R.decorations&&w(R.decorations.dark)||j,z=[U,B],O=R.decorations&&R.decorations.tooltip||"",$=R.decorations&&!!R.decorations.strikeThrough,x=R.decorations&&!!R.decorations.faded,X=R.contextValue||"";return{rawResource:[W,V,z,O,$,x,X,N],handle:W}});return{start:L.start,deleteCount:L.deleteCount,toInsert:M}}),f=b.map(({start:L,deleteCount:M,toInsert:R})=>[L,M,R.map(W=>W.rawResource)]),P=b.reverse();for(const{start:L,deleteCount:M,toInsert:R}of P){const W=R.map(N=>N.handle),V=this._handlesSnapshot.splice(L,M,...W);for(const N of V)this._resourceStatesMap.delete(N),this._resourceStatesCommandsMap.delete(N),this._resourceStatesDisposablesMap.get(N)?.dispose(),this._resourceStatesDisposablesMap.delete(N)}return this._resourceSnapshot=l,f}dispose(){this._disposed=!0,this._onDidDispose.fire()}}s._handlePool=0;class n{constructor(l,m,b,f,P,L){this._extension=l,this._proxy=m,this._commands=b,this._id=f,this._label=P,this._rootUri=L,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new y.MutableDisposable,this._statusBarDisposables=new y.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new F.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new h(l,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,f,P,L)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(l){this._count!==l&&(this._count=l,this._proxy.$updateSourceControl(this.handle,{count:l}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(l){this._quickDiffProvider=l,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!l})}get commitTemplate(){return this._commitTemplate}set commitTemplate(l){l!==this._commitTemplate&&(this._commitTemplate=l,this._proxy.$updateSourceControl(this.handle,{commitTemplate:l}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(l){this._acceptInputDisposables.value=new y.DisposableStore,this._acceptInputCommand=l;const m=this._commands.converter.toInternal(l,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:m})}get actionButton(){return(0,a.checkProposedApiEnabled)(this._extension),this._actionButton}set actionButton(l){(0,a.checkProposedApiEnabled)(this._extension),this._actionButtonDisposables.value=new y.DisposableStore,this._actionButton=l;const m=l!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:m??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(l){if(this._statusBarCommands&&l&&t(this._statusBarCommands,l))return;this._statusBarDisposables.value=new y.DisposableStore,this._statusBarCommands=l;const m=(l||[]).map(b=>this._commands.converter.toInternal(b,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:m})}get selected(){return this._selected}createResourceGroup(l,m){const b=new s(this._proxy,this._commands,this.handle,l,m),f=F.Event.once(b.onDidDispose)(()=>this.createdResourceGroups.delete(b));return this.createdResourceGroups.set(b,f),this.eventuallyAddResourceGroups(),b}eventuallyAddResourceGroups(){const l=[],m=[];for(const[b,f]of this.createdResourceGroups){f.dispose();const P=b.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(b),this.eventuallyUpdateResourceStates()});F.Event.once(b.onDidDispose)(()=>{this.updatedResourceGroups.delete(b),P.dispose(),this._groups.delete(b.handle),this._proxy.$unregisterGroup(this.handle,b.handle)}),l.push([b.handle,b.id,b.label,b.features]);const L=b._takeResourceStateSnapshot();L.length>0&&m.push([b.handle,L]),this._groups.set(b.handle,b)}this._proxy.$registerGroups(this.handle,l,m),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const l=[];this.updatedResourceGroups.forEach(m=>{const b=m._takeResourceStateSnapshot();b.length!==0&&l.push([m.handle,b])}),l.length>0&&this._proxy.$spliceResourceStates(this.handle,l),this.updatedResourceGroups.clear()}getResourceGroup(l){return this._groups.get(l)}setSelectionState(l){this._selected=l,this._onDidChangeSelection.fire(l)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(l=>l.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,Ve([(0,C.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),Ve([(0,C.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let u=class xn{constructor(l,m,b){this._commands=m,this.logService=b,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new F.Emitter,this._proxy=l.getProxy(_.MainContext.MainThreadSCM),this._telemetry=l.getProxy(_.MainContext.MainThreadTelemetry),m.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===3){const P=this._sourceControls.get(f.sourceControlHandle);if(!P)return f;const L=P.getResourceGroup(f.groupHandle);return L?L.getResourceState(f.handle):f}else if(f&&f.$mid===4){const P=this._sourceControls.get(f.sourceControlHandle);return P?P.getResourceGroup(f.groupHandle):f}else if(f&&f.$mid===5){const P=this._sourceControls.get(f.handle);return P||f}return f}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(l,m,b,f){this.logService.trace("ExtHostSCM#createSourceControl",l.identifier.value,m,b,f),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:l.identifier.value});const P=xn._handlePool++,L=new n(l,this._proxy,this._commands,m,b,f);this._sourceControls.set(P,L);const M=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(l.identifier))||[];return M.push(L),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(l.identifier),M),L}getLastInputBox(l){this.logService.trace("ExtHostSCM#getLastInputBox",l.identifier.value);const m=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(l.identifier)),b=m&&m[m.length-1];return b&&b.inputBox}$provideOriginalResource(l,m,b){const f=p.URI.revive(m);this.logService.trace("ExtHostSCM#$provideOriginalResource",l,f.toString());const P=this._sourceControls.get(l);return!P||!P.quickDiffProvider||!P.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.asPromise)(()=>P.quickDiffProvider.provideOriginalResource(f,b)).then(L=>L||null)}$onInputBoxValueChange(l,m){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",l);const b=this._sourceControls.get(l);return b&&b.inputBox.$onInputBoxValueChange(m),Promise.resolve(void 0)}$executeResourceCommand(l,m,b,f){this.logService.trace("ExtHostSCM#$executeResourceCommand",l,m,b);const P=this._sourceControls.get(l);if(!P)return Promise.resolve(void 0);const L=P.getResourceGroup(m);return L?L.$executeResourceCommand(b,f):Promise.resolve(void 0)}$validateInput(l,m,b){this.logService.trace("ExtHostSCM#$validateInput",l);const f=this._sourceControls.get(l);return!f||!f.inputBox.validateInput?Promise.resolve(void 0):(0,A.asPromise)(()=>f.inputBox.validateInput(m,b)).then(P=>{if(!P)return Promise.resolve(void 0);const L=d.MarkdownString.fromStrict(P.message);return L?Promise.resolve([L,P.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(l){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",l),l!==void 0&&this._sourceControls.get(l)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=l,Promise.resolve(void 0)}};u._handlePool=0,u=Ve([$e(2,i.ILogService)],u),e.ExtHostSCM=u});var ot=this&&this.__classPrivateFieldSet||function(Y,e,p,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,p):C?C.value=p:e.set(Y,p),p},Oe=this&&this.__classPrivateFieldGet||function(Y,e,p,F){if(p==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?F:p==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[252],me([0,1,7,5,168,6,16,12]),function(Y,e,p,F,C,y,A,_){"use strict";var S,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class i{constructor(d,w,D,T,E=p.StatusBarAlignment.Left,c){S.set(this,void 0),I.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new y.DisposableStore,ot(this,S,d,"f"),ot(this,I,w,"f"),this._entryId=i.ID_GEN++,this._extension=D,this._id=T,this._alignment=E,this._priority=this.validatePriority(c)}validatePriority(d){if(!!(0,_.isNumber)(d))return d===Number.POSITIVE_INFINITY?Number.MAX_VALUE:d===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:d}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(d){this._text=d,this.update()}set name(d){this._name=d,this.update()}set tooltip(d){this._tooltip=d,this.update()}set color(d){this._color=d,this.update()}set backgroundColor(d){d&&!i.ALLOWED_BACKGROUND_COLORS.has(d.id)&&(d=void 0),this._backgroundColor=d,this.update()}set command(d){this._command?.fromApi!==d&&(this._internalCommandRegistration.clear(),typeof d=="string"?this._command={fromApi:d,internal:Oe(this,I,"f").toInternal({title:"",command:d},this._internalCommandRegistration)}:d?this._command={fromApi:d,internal:Oe(this,I,"f").toInternal(d,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(d){this._accessibilityInformation=d,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let d;this._extension?this._id?d=`${this._extension.identifier.value}.${this._id}`:d=this._extension.identifier.value:d=this._id;let w;this._name?w=this._name:w=(0,C.localize)(0,null,this._extension.displayName||this._extension.name);let D=this._color;this._backgroundColor&&(D=i.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const T=this._tooltip?A.MarkdownString.fromStrict(this._tooltip):void 0;Oe(this,S,"f").$setEntry(this._entryId,d,w,this._text,T,this._command?.internal,D,this._backgroundColor,this._alignment===p.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=i,S=new WeakMap,I=new WeakMap,i.ID_GEN=0,i.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new p.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new p.ThemeColor("statusBarItem.warningForeground")]]);class k{constructor(d){this._messages=[],this._item=d.createStatusBarEntry(void 0,"status.extensionMessage",p.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,C.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(d){const w={message:d};return this._messages.unshift(w),this._update(),new p.Disposable(()=>{const D=this._messages.indexOf(w);D>=0&&(this._messages.splice(D,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class a{constructor(d,w){this._proxy=d.getProxy(F.MainContext.MainThreadStatusBar),this._commands=w,this._statusMessage=new k(this)}createStatusBarEntry(d,w,D,T){return new i(this._proxy,this._commands,d,w,D,T)}setStatusBarMessage(d,w){const D=this._statusMessage.setMessage(d);let T;return typeof w=="number"?T=setTimeout(()=>D.dispose(),w):typeof w!="undefined"&&w.then(()=>D.dispose(),()=>D.dispose()),new p.Disposable(()=>{D.dispose(),clearTimeout(T)})}}e.ExtHostStatusBar=a}),define(fe[92],me([0,1,5,3,4]),function(Y,e,p,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class y{constructor(_){this._onDidChangeStorage=new F.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=_.getProxy(p.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(_,S){this._proxy.$registerExtensionStorageKeysToSync(_,S)}getValue(_,S,I){return this._proxy.$getValue(_,S).then(i=>i||I)}setValue(_,S,I){return this._proxy.$setValue(_,S,I)}$acceptValue(_,S,I){this._onDidChangeStorage.fire({shared:_,key:S,value:I})}}e.ExtHostStorage=y,e.IExtHostStorage=(0,C.createDecorator)("IExtHostStorage")}),define(fe[70],me([0,1,4,27,13,91,2]),function(Y,e,p,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,p.createDecorator)("IExtensionStoragePaths");let _=class{constructor(I,i,k){this._logService=i,this._extHostFileSystem=k,this._workspace=I.workspace??void 0,this._environment=I.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(a=>this._value=a)}async _getWorkspaceStorageURI(I){return A.URI.joinPath(this._environment.workspaceStorageHome,I)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const I=this._workspace.id,i=await this._getWorkspaceStorageURI(I);try{return await this._extHostFileSystem.value.stat(i),this._logService.trace("[ExtHostStorage] storage dir already exists",i),i}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",i),await this._extHostFileSystem.value.createDirectory(i),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(i,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:A.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),i}catch(k){this._logService.error("[ExtHostStorage]",k);return}}workspaceValue(I){if(this._value)return A.URI.joinPath(this._value,I.identifier.value)}globalValue(I){return A.URI.joinPath(this._environment.globalStorageHome,I.identifier.value.toLowerCase())}onWillDeactivateAll(){}};_=Ve([$e(0,F.IExtHostInitDataService),$e(1,C.ILogService),$e(2,y.IExtHostConsumerFileSystem)],_),e.ExtensionStoragePaths=_}),define(fe[33],me([0,1,3,5,4,2,14,6,7,169,17,216,21,32,197,65,12,15]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d,w,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,C.createDecorator)("IExtHostTerminalService");class E{constructor(o,l,m,b){this._proxy=o,this._id=l,this._creationOptions=m,this._name=b,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(P=>this._pidPromiseComplete=P);const f=this;this.value={get name(){return f._name||""},get processId(){return f._pidPromise},get creationOptions(){return f._creationOptions},get exitStatus(){return f._exitStatus},get state(){return f._state},sendText(P,L=!0){f._checkDisposed(),f._proxy.$sendText(f._id,P,L)},show(P){f._checkDisposed(),f._proxy.$show(f._id,P)},hide(){f._checkDisposed(),f._proxy.$hide(f._id)},dispose(){f._disposed||(f._disposed=!0,f._proxy.$dispose(f._id))},get dimensions(){if(!(f._cols===void 0||f._rows===void 0))return{columns:f._cols,rows:f._rows}}}}async create(o,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:o.name,shellPath:(0,D.withNullAsUndefined)(o.shellPath),shellArgs:(0,D.withNullAsUndefined)(o.shellArgs),cwd:(0,D.withNullAsUndefined)(o.cwd),env:(0,D.withNullAsUndefined)(o.env),icon:(0,D.withNullAsUndefined)(s(o.iconPath)),color:w.ThemeColor.isThemeColor(o.color)?o.color.id:void 0,initialText:(0,D.withNullAsUndefined)(o.message),strictEnv:(0,D.withNullAsUndefined)(o.strictEnv),hideFromUser:(0,D.withNullAsUndefined)(o.hideFromUser),isFeatureTerminal:(0,D.withNullAsUndefined)(l?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,D.withNullAsUndefined)(l?.useShellEnvironment),location:l?.location||this._serializeParentTerminal(o.location,l?.resolvedExtHostIdentifier)})}async createExtensionTerminal(o,l,m,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:m,color:w.ThemeColor.isThemeColor(b)?b.id:void 0,location:this._serializeParentTerminal(o,l)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(o,l){return typeof o=="object"?"parentTerminal"in o&&o.parentTerminal&&l?{parentTerminal:l}:"viewColumn"in o?{viewColumn:o.viewColumn,preserveFocus:o.preserveFocus}:void 0:o}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(o){this._name=o}setExitCode(o){this._exitStatus=Object.freeze({code:o})}setDimensions(o,l){return o===this._cols&&l===this._rows||o===0||l===0?!1:(this._cols=o,this._rows=l,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(o){this._pidPromiseComplete?(this._pidPromiseComplete(o),this._pidPromiseComplete=void 0):this._pidPromise.then(l=>{l!==o&&(this._pidPromise=Promise.resolve(o))})}}e.ExtHostTerminal=E;class c{constructor(o){this._pty=o,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new p.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new p.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new p.Emitter,this._onProcessTitleChanged=new p.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new p.Emitter,this._onProcessShellTypeChanged=new p.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onDidChangeProperty=new p.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}refreshProperty(o){return Promise.resolve("")}async updateProperty(o,l){Promise.resolve("")}async start(){}shutdown(){this._pty.close()}input(o){this._pty.handleInput&&this._pty.handleInput(o)}resize(o,l){this._pty.setDimensions&&this._pty.setDimensions({columns:o,rows:l})}async processBinary(o){}acknowledgeDataEvent(o){}async setUnicodeVersion(o){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(o){this._pty.onDidWrite(l=>this._onProcessData.fire(l)),this._pty.onDidClose&&this._pty.onDidClose((l=void 0)=>{this._onProcessExit.fire(l===void 0?void 0:l)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(l=>this._onProcessOverrideDimensions.fire(l&&{cols:l.columns,rows:l.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(l=>this._onProcessTitleChanged.fire(l)),this._pty.open(o||void 0),this._pty.setDimensions&&o&&this._pty.setDimensions(o),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=c;let r=1,v=class extends _.Disposable{constructor(o,l){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new p.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new p.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new p.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new p.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new p.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=l.getProxy(F.MainContext.MainThreadTerminalService),this._bufferer=new d.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new p.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(o),this._register({dispose:()=>{for(const[m,b]of this._terminalProcesses)b.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(o=>o.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(o,l){const m=new E(this._proxy,(0,g.generateUuid)(),o,o.name),b=new c(o.pty);return m.createExtensionTerminal(o.location,this._serializeParentTerminal(o,l).resolvedExtHostIdentifier,s(o.iconPath),n(o.color)).then(f=>{const P=this._setupExtHostProcessListeners(f,b);this._terminalProcessDisposables[f]=P}),this._terminals.push(m),m.value}_serializeParentTerminal(o,l){if(l=l||{},o.location&&typeof o.location=="object"&&"parentTerminal"in o.location){const m=o.location.parentTerminal;if(m){const b=this._terminals.find(f=>f.value===m);b&&(l.resolvedExtHostIdentifier=b._id)}}else o.location&&typeof o.location!="object"?l.location=o.location:l.location&&typeof l.location=="object"&&"splitActiveTerminal"in l.location&&(l.location={splitActiveTerminal:!0});return l}attachPtyToTerminal(o,l){if(!this._getTerminalById(o))throw new Error(`Cannot resolve terminal with id ${o} for virtual process`);const b=new c(l),f=this._setupExtHostProcessListeners(o,b);this._terminalProcessDisposables[o]=f}async $acceptActiveTerminalChanged(o){const l=this._activeTerminal;if(o===null){this._activeTerminal=void 0,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const m=this._getTerminalById(o);m&&(this._activeTerminal=m,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(o,l){const m=this._getTerminalById(o);m&&this._onDidWriteTerminalData.fire({terminal:m.value,data:l})}async $acceptTerminalDimensions(o,l,m){const b=this._getTerminalById(o);b&&b.setDimensions(l,m)&&this._onDidChangeTerminalDimensions.fire({terminal:b.value,dimensions:b.value.dimensions})}async $acceptTerminalMaximumDimensions(o,l,m){this._terminalProcesses.get(o)?.resize(l,m)}async $acceptTerminalTitleChange(o,l){const m=this._getTerminalById(o);m&&(m.name=l)}async $acceptTerminalClosed(o,l){const m=this._getTerminalObjectIndexById(this._terminals,o);if(m!==null){const b=this._terminals.splice(m,1)[0];b.setExitCode(l),this._onDidCloseTerminal.fire(b.value)}}$acceptTerminalOpened(o,l,m,b){if(l){const L=this._getTerminalObjectIndexById(this._terminals,l);if(L!==null){this._terminals[L]._id=o,this._onDidOpenTerminal.fire(this.terminals[L]),this._terminals[L].isOpen=!0;return}}const f={name:b.name,shellPath:b.executable,shellArgs:b.args,cwd:typeof b.cwd=="string"?b.cwd:y.URI.revive(b.cwd),env:b.env,hideFromUser:b.hideFromUser},P=new E(this._proxy,o,f,m);this._terminals.push(P),this._onDidOpenTerminal.fire(P.value),P.isOpen=!0}async $acceptTerminalProcessId(o,l){const m=this._getTerminalById(o);m&&m._setProcessId(l)}async $startExtensionTerminal(o,l){const m=this._getTerminalById(o);if(!m)return{message:(0,I.localize)(0,null,o)};m.isOpen||await new Promise(f=>{const P=this.onDidOpenTerminal(async L=>{L===m.value&&(P.dispose(),f())})});const b=this._terminalProcesses.get(o);b?b.startSendingEvents(l):this._extensionTerminalAwaitingStart[o]={initialDimensions:l}}_setupExtHostProcessListeners(o,l){const m=new _.DisposableStore;m.add(l.onProcessReady(f=>this._proxy.$sendProcessReady(o,f.pid,f.cwd))),m.add(l.onProcessTitleChanged(f=>this._proxy.$sendProcessTitle(o,f))),this._bufferer.startBuffering(o,l.onProcessData),m.add(l.onProcessExit(f=>this._onProcessExit(o,f))),l.onProcessOverrideDimensions&&m.add(l.onProcessOverrideDimensions(f=>this._proxy.$sendOverrideDimensions(o,f))),this._terminalProcesses.set(o,l);const b=this._extensionTerminalAwaitingStart[o];return b&&l instanceof c&&(l.startSendingEvents(b.initialDimensions),delete this._extensionTerminalAwaitingStart[o]),m}$acceptProcessAckDataEvent(o,l){this._terminalProcesses.get(o)?.acknowledgeDataEvent(l)}$acceptProcessInput(o,l){this._terminalProcesses.get(o)?.input(l)}$acceptTerminalInteraction(o){const l=this._getTerminalById(o);l?.setInteractedWith()&&this._onDidChangeTerminalState.fire(l.value)}$acceptProcessResize(o,l,m){try{this._terminalProcesses.get(o)?.resize(l,m)}catch(b){if(b.code!=="EPIPE"&&b.code!=="ERR_IPC_CHANNEL_CLOSED")throw b}}$acceptProcessShutdown(o,l){this._terminalProcesses.get(o)?.shutdown(l)}$acceptProcessRequestInitialCwd(o){this._terminalProcesses.get(o)?.getInitialCwd().then(l=>this._proxy.$sendProcessInitialCwd(o,l))}$acceptProcessRequestCwd(o){this._terminalProcesses.get(o)?.getCwd().then(l=>this._proxy.$sendProcessCwd(o,l))}$acceptProcessRequestLatency(o){return o}registerLinkProvider(o){return this._linkProviders.add(o),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(o),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(o,l,m){if(this._profileProviders.has(l))throw new Error(`Terminal profile provider "${l}" already registered`);return this._profileProviders.set(l,m),this._proxy.$registerProfileProvider(l,o.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(l),this._proxy.$unregisterProfileProvider(l)})}async $createContributedProfileTerminal(o,l){const m=new a.CancellationTokenSource().token,b=await this._profileProviders.get(o)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(!b||!("options"in b))throw new Error(`No terminal profile options provided for id "${o}"`);if("pty"in b.options){this.createExtensionTerminal(b.options,l);return}this.createTerminalFromOptions(b.options,l)}}async $provideLinks(o,l){const m=this._getTerminalById(o);if(!m)return[];this._terminalLinkCache.delete(o);const b=this._terminalLinkCancellationSource.get(o);b&&b.dispose(!0);const f=new a.CancellationTokenSource;this._terminalLinkCancellationSource.set(o,f);const P=[],L={terminal:m.value,line:l},M=[];for(const V of this._linkProviders)M.push(T.Promises.withAsyncBody(async N=>{f.token.onCancellationRequested(()=>N({provider:V,links:[]}));const j=await V.provideTerminalLinks(L,f.token)||[];f.token.isCancellationRequested||N({provider:V,links:j})}));const R=await Promise.all(M);if(f.token.isCancellationRequested)return[];const W=new Map;for(const V of R)V&&V.links.length>0&&P.push(...V.links.map(N=>{const j={id:r++,startIndex:N.startIndex,length:N.length,label:N.tooltip};return W.set(j.id,{provider:V.provider,link:N}),j}));return this._terminalLinkCache.set(o,W),P}$activateLink(o,l){const m=this._terminalLinkCache.get(o)?.get(l);!m||m.provider.handleTerminalLink(m.link)}_onProcessExit(o,l){this._bufferer.stopBuffering(o),this._terminalProcesses.delete(o),delete this._extensionTerminalAwaitingStart[o];const m=this._terminalProcessDisposables[o];m&&(m.dispose(),delete this._terminalProcessDisposables[o]),this._proxy.$sendProcessExit(o,l)}_getTerminalById(o){return this._getTerminalObjectById(this._terminals,o)}_getTerminalObjectById(o,l){const m=this._getTerminalObjectIndexById(o,l);return m!==null?o[m]:null}_getTerminalObjectIndexById(o,l){let m=null;return o.some((b,f)=>b._id===l?(m=f,!0):!1),m}getEnvironmentVariableCollection(o){let l=this._environmentVariableCollections.get(o.identifier.value);return l||(l=new t,this._setEnvironmentVariableCollection(o.identifier.value,l)),l}_syncEnvironmentVariableCollection(o,l){const m=(0,k.serializeEnvironmentVariableCollection)(l.map);this._proxy.$setEnvironmentVariableCollection(o,l.persistent,m.length===0?void 0:m)}$initEnvironmentVariableCollections(o){o.forEach(l=>{const m=l[0],b=new t(l[1]);this._setEnvironmentVariableCollection(m,b)})}$acceptDefaultProfile(o,l){this._defaultProfile=o,this._defaultAutomationProfile=l}_setEnvironmentVariableCollection(o,l){this._environmentVariableCollections.set(o,l),l.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(o,l)})}};v=Ve([$e(1,A.IExtHostRpcService)],v),e.BaseExtHostTerminalService=v;class t{constructor(o){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new p.Emitter,this.map=new Map(o)}get persistent(){return this._persistent}set persistent(o){this._persistent=o,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(o,l){this._setIfDiffers(o,{value:l,type:S.EnvironmentVariableMutatorType.Replace})}append(o,l){this._setIfDiffers(o,{value:l,type:S.EnvironmentVariableMutatorType.Append})}prepend(o,l){this._setIfDiffers(o,{value:l,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(o,l){const m=this.map.get(o);(!m||m.value!==l.value||m.type!==l.type)&&(this.map.set(o,l),this._onDidChangeCollection.fire())}get(o){return this.map.get(o)}forEach(o,l){this.map.forEach((m,b)=>o.call(l,b,m,this))}delete(o){this.map.delete(o),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=t;let h=class extends v{constructor(o){super(!1,o)}createTerminal(o,l,m){throw new i.NotSupportedError}createTerminalFromOptions(o,l){throw new i.NotSupportedError}};h=Ve([$e(0,A.IExtHostRpcService)],h),e.WorkerExtHostTerminalService=h;function s(u){if(!(!u||typeof u=="string"))return"id"in u?{id:u.id,color:u.color}:u}function n(u){return w.ThemeColor.isThemeColor(u)?u:void 0}});var ot=this&&this.__classPrivateFieldSet||function(Y,e,p,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,p):C?C.value=p:e.set(Y,p),p},Oe=this&&this.__classPrivateFieldGet||function(Y,e,p,F){if(p==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?F:p==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[253],me([0,1,18,22,21,3,76,48,6,25,12,32,5,14,66,16,7,224,129,89]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d,w,D,T,E,c){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let v=class{constructor(L,M){this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=L.getProxy(a.MainContext.MainThreadTesting),this.observer=new m(this.proxy),this.runTracker=new h(this.proxy),M.registerArgumentProcessor({processArgument:R=>R?.$mid===13?w.TestItem.toItemFromContext(R):R})}createTestController(L,M){if(this.controllers.has(L))throw new Error(`Attempt to insert a duplicate controller with ID "${L}"`);const R=new S.DisposableStore,W=R.add(new T.SingleUseTestCollection(L));W.root.label=M;const V=new Map,N=this.proxy,j={items:W.root.children,get label(){return M},set label(B){M=B,W.root.label=B,N.$updateControllerLabel(L,M)},get id(){return L},createRunProfile:(B,z,O,$,x)=>{let X=(0,_.hash)(B);for(;V.has(X);)X++;const Q=new b(this.proxy,L,X,B,z,O,$,x);return V.set(X,Q),Q},createTestItem(B,z,O){return new d.TestItemImpl(L,B,z,O)},createTestRun:(B,z,O=!0)=>this.runTracker.createTestRun(L,W,B,z,O),set resolveHandler(B){W.resolveHandler=B},get resolveHandler(){return W.resolveHandler},dispose:()=>{R.dispose()}};j.createRunConfiguration=j.createRunProfile,N.$registerTestController(L,M),R.add((0,S.toDisposable)(()=>N.$unregisterTestController(L)));const U={controller:j,collection:W,profiles:V};return this.controllers.set(L,U),R.add((0,S.toDisposable)(()=>this.controllers.delete(L))),R.add(W.onDidGenerateDiff(B=>N.$publishDiff(L,B))),j}createTestObserver(){return this.observer.checkout()}async runTests(L,M=C.CancellationToken.None){const R=s(L);if(!R)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const W=this.controllers.get(R.controllerId);if(!W)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:L.include?.map(V=>V.id)??[W.collection.root.id],profileGroup:f[R.kind],profileId:R.profileId,controllerId:R.controllerId}],exclude:L.exclude?.map(V=>V.id)},M)}$provideFileCoverage(L,M,R){return(0,p.mapFind)(this.runTracker.trackers,V=>V.id===L?V.getCoverage(M):void 0)?.provideFileCoverage(R)??Promise.resolve([])}$resolveFileCoverage(L,M,R,W){return(0,p.mapFind)(this.runTracker.trackers,N=>N.id===L?N.getCoverage(M):void 0)?.resolveFileCoverage(R,W)??Promise.resolve([])}$configureRunProfile(L,M){this.controllers.get(L)?.profiles.get(M)?.configureHandler?.()}$publishTestResults(L){this.results=Object.freeze(L.map(M=>(0,I.deepFreeze)(w.TestResults.to(M))).concat(this.results).sort((M,R)=>R.completedAt-M.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(L,M){const R=this.controllers.get(c.TestId.fromString(L).controllerId)?.collection;R&&(await R.expand(L,M<0?Infinity:M),R.flushDiff())}$acceptDiff(L){this.observer.applyDiff(L)}async $runControllerTests(L,M){const R=this.controllers.get(L.controllerId);if(!R)return;const{collection:W,profiles:V}=R,N=V.get(L.profileId);if(!N)return;const j=L.testIds.map(O=>W.tree.get(O)).filter(i.isDefined),U=L.excludeExtIds.map(O=>R.collection.tree.get(O)).filter(i.isDefined).filter(O=>j.some($=>$.fullId.compare(O.fullId)===2));if(!j.length)return;const B=new D.TestRunRequest(j.some(O=>O.actual instanceof d.TestItemRootImpl)?void 0:j.map(O=>O.actual),U.map(O=>O.actual),N),z=this.runTracker.prepareForMainThreadTestRun(B,n.fromInternal(L,R.collection),M);try{await N.runHandler(B,M)}finally{z.isRunning&&!M.isCancellationRequested&&await y.Event.toPromise(z.onEnd),z.dispose()}}$cancelExtensionTestRun(L){L===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(L)}};v=Ve([$e(0,g.IExtHostRpcService)],v),e.ExtHostTesting=v;class t extends S.Disposable{constructor(L,M,R){super();this.dto=L,this.proxy=M,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new y.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new C.CancellationTokenSource(R)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:W}of this.tasks.values())W.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(L){return this.tasks.get(L)?.coverage}createRun(L){const M=this.dto.id,R=this.dto.controllerId,W=(0,k.generateUuid)(),V=new u(this.proxy,M,W),N=z=>(O,...$)=>{if(U){console.warn(`Setting the state of test "${O.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(O)||(this.ensureTestIsKnown(O),z(O,...$))},j=(z,O)=>{const $=O instanceof Array?O.map(w.TestMessage.from):[w.TestMessage.from(O)];if(z.uri&&z.range){const x={range:w.Range.from(z.range),uri:z.uri};for(const X of $)X.location=X.location||x}this.proxy.$appendTestMessagesInRun(M,W,c.TestId.fromExtHostTestItem(z,R).toString(),$)};let U=!1;const B={isPersisted:this.dto.isPersisted,token:this.cts.token,name:L,get coverageProvider(){return V.coverageProvider},set coverageProvider(z){V.coverageProvider=z},enqueued:N(z=>{this.proxy.$updateTestStateInRun(M,W,c.TestId.fromExtHostTestItem(z,R).toString(),1)}),skipped:N(z=>{this.proxy.$updateTestStateInRun(M,W,c.TestId.fromExtHostTestItem(z,R).toString(),5)}),started:N(z=>{this.proxy.$updateTestStateInRun(M,W,c.TestId.fromExtHostTestItem(z,R).toString(),2)}),errored:N((z,O,$)=>{j(z,O),this.proxy.$updateTestStateInRun(M,W,c.TestId.fromExtHostTestItem(z,R).toString(),6,$)}),failed:N((z,O,$)=>{j(z,O),this.proxy.$updateTestStateInRun(M,W,c.TestId.fromExtHostTestItem(z,R).toString(),4,$)}),passed:N((z,O)=>{this.proxy.$updateTestStateInRun(M,W,c.TestId.fromExtHostTestItem(z,this.dto.controllerId).toString(),3,O)}),appendOutput:(z,O,$)=>{U||($&&(this.dto.isIncluded($)?this.ensureTestIsKnown($):$=void 0),this.proxy.$appendOutputToRun(M,W,F.VSBuffer.fromString(z),O&&w.location.from(O),$&&c.TestId.fromExtHostTestItem($,R).toString()))},end:()=>{U||(U=!0,this.proxy.$finishedTestRunTask(M,W),this.tasks.delete(W),this.isRunning||this.dispose())}};return this.tasks.set(W,{run:B,coverage:V}),this.proxy.$startedTestRunTask(M,{id:W,name:L,running:!0}),B}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(L){if(!(L instanceof d.TestItemImpl))throw new d.InvalidTestItemError(L.id);if(this.sharedTestIds.has(c.TestId.fromExtHostTestItem(L,this.dto.controllerId).toString()))return;const M=[],R=this.dto.colllection.root;for(;;){const W=w.TestItem.from(L);if(M.unshift(W),this.sharedTestIds.has(W.extId)||(this.sharedTestIds.add(W.extId),L===R))break;L=L.parent||R}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,M)}}class h{constructor(L){this.proxy=L,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(L,M,R){return this.getTracker(L,M,R)}cancelRunById(L){for(const M of this.tracked.values())if(M.id===L){M.dispose();return}}cancelAllRuns(){for(const L of this.tracked.values())L.dispose()}createTestRun(L,M,R,W,V){const N=this.tracked.get(R);if(N)return N.createRun(W);const j=n.fromPublic(L,M,R,V),U=s(R);this.proxy.$startedExtensionTestRun({controllerId:L,profile:U&&{group:f[U.kind],id:U.profileId},exclude:R.exclude?.map(z=>z.id)??[],id:j.id,include:R.include?.map(z=>z.id)??[M.root.id],persist:V});const B=this.getTracker(R,j);return B.onEnd(()=>this.proxy.$finishedExtensionTestRun(j.id)),B.createRun(W)}getTracker(L,M,R){const W=new t(M,this.proxy,R);return this.tracked.set(L,W),W.onEnd(()=>this.tracked.delete(L)),W}}e.TestRunCoordinator=h;const s=P=>{if(!!P.profile){if(!(P.profile instanceof b))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class n{constructor(L,M,R,W,V,N){this.controllerId=L,this.id=M,this.isPersisted=V,this.colllection=N,this.includePrefix=R.map(j=>j+"\0"),this.excludePrefix=W.map(j=>j+"\0")}static fromPublic(L,M,R,W){return new n(L,(0,k.generateUuid)(),R.include?.map(V=>c.TestId.fromExtHostTestItem(V,L).toString())??[L],R.exclude?.map(V=>c.TestId.fromExtHostTestItem(V,L).toString())??[],W,M)}static fromInternal(L,M){return new n(L.controllerId,L.runId,L.testIds,L.excludeExtIds,!0,M)}isIncluded(L){const M=c.TestId.fromExtHostTestItem(L,this.controllerId).toString()+"\0";for(const R of this.excludePrefix)if(M===R||M.startsWith(R))return!1;for(const R of this.includePrefix)if(M===R||M.startsWith(R))return!0;return!1}}e.TestRunDto=n;class u{constructor(L,M,R){this.proxy=L,this.runId=M,this.taskId=R}set coverageProvider(L){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!L||(this._coverageProvider=L,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(L){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(L))());try{return(await this.fileCoverage)?.map(w.TestCoverage.fromFile)??[]}catch(M){throw this.fileCoverage=void 0,M}}async resolveFileCoverage(L,M){const R=await this.fileCoverage;let W=R?.[L];return!this._coverageProvider||!R||!W?[]:(W.detailedCoverage||(W=R[L]=await this._coverageProvider.resolveFileCoverage?.(W,M)??W),W.detailedCoverage?.map(w.TestCoverage.fromDetailed)??[])}}class o extends E.IncrementalChangeCollector{constructor(L){super();this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(L){this.added.add(L)}update(L){Object.assign(L.revived,w.TestItem.toPlain(L.item)),this.added.has(L)||this.updated.add(L)}remove(L){if(this.added.has(L)){this.added.delete(L);return}if(this.updated.delete(L),L.parent&&this.alreadyRemoved.has(L.parent)){this.alreadyRemoved.add(L.item.extId);return}this.removed.add(L)}getChangeEvent(){const{added:L,updated:M,removed:R}=this;return{get added(){return[...L].map(W=>W.revived)},get updated(){return[...M].map(W=>W.revived)},get removed(){return[...R].map(W=>W.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class l extends E.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(L){return this.items.get(L)}getMirroredTestDataByReference(L){return this.items.get(L.id)}createItem(L,M){return{...L,revived:w.TestItem.toPlain(L.item),depth:M?M.depth+1:0,children:new Set}}createChangeCollector(){return new o(this.changeEmitter)}}e.MirroredTestCollection=l;class m{constructor(L){this.proxy=L}checkout(){this.current||(this.current=this.createObserverData());const L=this.current;return L.observers++,{onDidChangeTest:L.tests.onDidChangeTests,get tests(){return[...L.tests.rootTests].map(M=>M.revived)},dispose:(0,A.once)(()=>{--L.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(L){return this.current?.tests.getMirroredTestDataByReference(L)}applyDiff(L){this.current?.tests.apply(L)}createObserverData(){const L=new l;return this.proxy.$subscribeToDiffs(),{observers:0,tests:L}}}class b{constructor(L,M,R,W,V,N,j=!1,U=void 0){this.controllerId=M,this.profileId=R,this._label=W,this.kind=V,this.runHandler=N,this._isDefault=j,this._tag=U,r.set(this,void 0),ot(this,r,L,"f");const B=f[V];if(typeof B!="number")throw new Error(`Unknown TestRunProfile.group ${V}`);Oe(this,r,"f").$publishTestRunProfile({profileId:R,controllerId:M,tag:U?w.TestTag.namespace(this.controllerId,U.id):null,label:W,group:B,isDefault:j,hasConfigurationHandler:!1})}get label(){return this._label}set label(L){L!==this._label&&(this._label=L,Oe(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:L}))}get isDefault(){return this._isDefault}set isDefault(L){L!==this._isDefault&&(this._isDefault=L,Oe(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:L}))}get tag(){return this._tag}set tag(L){L?.id!==this._tag?.id&&(this._tag=L,Oe(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:L?w.TestTag.namespace(this.controllerId,L.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(L){L!==this._configureHandler&&(this._configureHandler=L,Oe(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!L}))}dispose(){Oe(this,r,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=b,r=new WeakMap;const f={[D.TestRunProfileKind.Coverage]:8,[D.TestRunProfileKind.Debug]:4,[D.TestRunProfileKind.Run]:2}}),define(fe[254],me([0,1,3,18,5,132,16,7]),function(Y,e,p,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(i,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new p.Emitter,this._onDidChangeTextEditorOptions=new p.Emitter,this._onDidChangeTextEditorVisibleRanges=new p.Emitter,this._onDidChangeTextEditorViewColumn=new p.Emitter,this._onDidChangeActiveTextEditor=new p.Emitter,this._onDidChangeVisibleTextEditors=new p.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(C.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(a=>this._onDidChangeVisibleTextEditors.fire(a)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(a=>this._onDidChangeActiveTextEditor.fire(a))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const k=this._extHostDocumentsAndEditors.allEditors();return i?k:k.map(a=>a.value)}async showTextDocument(i,k,a){let g;typeof k=="number"?g={position:A.ViewColumn.from(k),preserveFocus:a}:typeof k=="object"?g={position:A.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?A.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:g={preserveFocus:!1};const d=await this._proxy.$tryShowTextDocument(i.uri,g),w=d&&this._extHostDocumentsAndEditors.getEditor(d);if(w)return w.value;throw d?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i,k){return new y.TextEditorDecorationType(this._proxy,i,k).value}$acceptEditorPropertiesChanged(i,k){const a=this._extHostDocumentsAndEditors.getEditor(i);if(!a)throw new Error("unknown text editor");if(k.options&&a._acceptOptions(k.options),k.selections){const g=k.selections.selections.map(A.Selection.to);a._acceptSelections(g)}if(k.visibleRanges){const g=F.coalesce(k.visibleRanges.map(A.Range.to));a._acceptVisibleRanges(g)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:a.value,options:{...k.options,lineNumbers:A.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const g=_.TextEditorSelectionChangeKind.fromValue(k.selections.source),d=k.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:a.value,selections:d,kind:g})}if(k.visibleRanges){const g=F.coalesce(k.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:a.value,visibleRanges:g})}}$acceptEditorPositionData(i){for(const k in i){const a=this._extHostDocumentsAndEditors.getEditor(k);if(!a)throw new Error("Unknown text editor");const g=A.ViewColumn.to(i[k]);a.value.viewColumn!==g&&(a._acceptViewColumn(g),this._onDidChangeTextEditorViewColumn.fire({textEditor:a.value,viewColumn:g}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=S}),define(fe[255],me([0,1,2,4,5,6,7]),function(Y,e,p,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,F.createDecorator)("IExtHostTimeline");class _{constructor(i,k){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(C.MainContext.MainThreadTimeline),k.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===11){const g=a.uri===void 0?void 0:p.URI.revive(a.uri);return this._itemsBySourceAndUriMap.get(a.source)?.get(S(g))?.get(a.handle)}return a}})}async $getTimeline(i,k,a,g,d){return this._providers.get(i)?.provideTimeline(p.URI.revive(k),a,g,d)}registerTimelineProvider(i,k,a,g){const d=new y.DisposableStore,w=this.convertTimelineItem(k.id,g,d).bind(this);let D;k.onDidChange&&(D=k.onDidChange(E=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...E,id:k.id}),this));const T=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...k,scheme:i,onDidChange:void 0,async provideTimeline(E,c,r,v){v?.resetCache&&(d.clear(),T.get(k.id)?.clear());const t=await k.provideTimeline(E,c,r);if(t==null)return;const h=w(E,v);return{...t,source:k.id,items:t.items.map(h)}},dispose(){for(const E of T.values())E.get(k.id)?.clear();D?.dispose(),d.dispose()}})}convertTimelineItem(i,k,a){return(g,d)=>{let w;if(d?.cacheResults){let D=this._itemsBySourceAndUriMap.get(i);D===void 0&&(D=new Map,this._itemsBySourceAndUriMap.set(i,D));const T=S(g);w=D.get(T),w===void 0&&(w=new Map,D.set(T,w))}return D=>{const{iconPath:T,...E}=D,c=`${i}|${D.id??D.timestamp}`;w?.set(c,D);let r,v,t;return D.iconPath&&(T instanceof A.ThemeIcon?t={id:T.id,color:T.color}:p.URI.isUri(T)?(r=T,v=T):{light:r,dark:v}=T),{...E,id:E.id??void 0,handle:c,source:i,command:D.command?k.toInternal(D.command,a):void 0,icon:r,iconDark:v,themeIcon:t,accessibilityInformation:D.accessibilityInformation}}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,y.toDisposable)(()=>{for(const a of this._itemsBySourceAndUriMap.values())a.get(i.id)?.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=_;function S(I){return I?.toString()}}),define(fe[256],me([0,1,6,10,2,5]),function(Y,e,p,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{constructor(S){this._openers=new Map,this._proxy=S.getProxy(y.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,I,i,k){if(this._openers.has(I))throw new Error(`Opener with id '${I}' already registered`);const a=k.schemes.find(g=>!A.supportedSchemes.has(g));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this._openers.set(I,i),this._proxy.$registerUriOpener(I,k.schemes,S,k.label),(0,p.toDisposable)(()=>{this._openers.delete(I),this._proxy.$unregisterUriOpener(I)})}async $canOpenUri(S,I,i){const k=this._openers.get(S);if(!k)throw new Error(`Unknown opener with id: ${S}`);const a=C.URI.revive(I);return k.canOpenExternalUri(a,i)}async $openUri(S,I,i){const k=this._openers.get(S);if(!k)throw new Error(`Unknown opener id: '${S}'`);return k.openExternalUri(C.URI.revive(I.resolvedUri),{sourceUri:C.URI.revive(I.sourceUri)},i)}}e.ExtHostUriOpeners=A,A.supportedSchemes=new Set([F.Schemas.http,F.Schemas.https])}),define(fe[257],me([0,1,5,2,6,17,26]),function(Y,e,p,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class _{constructor(I){this.handles=new Set,this.handlers=new Map,this._proxy=I.getProxy(p.MainContext.MainThreadUrls)}registerUriHandler(I,i){if(this.handles.has(A.ExtensionIdentifier.toKey(I)))throw new Error(`Protocol handler already registered for extension ${I}`);const k=_.HandlePool++;return this.handles.add(A.ExtensionIdentifier.toKey(I)),this.handlers.set(k,i),this._proxy.$registerUriHandler(k,I),(0,C.toDisposable)(()=>{this.handles.delete(A.ExtensionIdentifier.toKey(I)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(I,i){const k=this.handlers.get(I);if(!k)return Promise.resolve(void 0);try{k.handleUri(F.URI.revive(i))}catch(a){(0,y.onUnexpectedError)(a)}return Promise.resolve(void 0)}async createAppUri(I){return F.URI.revive(await this._proxy.$createAppUri(I))}}e.ExtHostUrls=_,_.HandlePool=0});var ot=this&&this.__classPrivateFieldSet||function(Y,e,p,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,p):C?C.value=p:e.set(Y,p),p},Oe=this&&this.__classPrivateFieldGet||function(Y,e,p,F){if(p==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?F:p==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[71],me([0,1,3,2,182,206,88,5]),function(Y,e,p,F,C,y,A,_){"use strict";var S,I,i,k,a,g,d,w,D,T,E,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class r{constructor(l,m,b,f,P,L,M){S.set(this,void 0),I.set(this,void 0),i.set(this,void 0),k.set(this,void 0),a.set(this,void 0),g.set(this,void 0),d.set(this,""),w.set(this,void 0),D.set(this,!1),T.set(this,!1),E.set(this,!1),this._onMessageEmitter=new p.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new p.Emitter),this._onDidDispose=Oe(this,c,"f").event,ot(this,S,l,"f"),ot(this,I,m,"f"),ot(this,w,b,"f"),ot(this,k,f,"f"),ot(this,a,P,"f"),ot(this,g,L,"f"),ot(this,E,v(L),"f"),ot(this,i,M,"f")}dispose(){ot(this,D,!0,"f"),Oe(this,c,"f").fire(),Oe(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(l){return ot(this,T,!0,"f"),(0,A.asWebviewUri)(l,Oe(this,k,"f").remote)}get cspSource(){return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,d,"f")}set html(l){this.assertNotDisposed(),Oe(this,d,"f")!==l&&(ot(this,d,l,"f"),!Oe(this,T,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(l)&&(ot(this,T,!0,"f"),Oe(this,i,"f").report("Webview vscode-resource: uris",Oe(this,g,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,I,"f").$setHtml(Oe(this,S,"f"),l))}get options(){return this.assertNotDisposed(),Oe(this,w,"f")}set options(l){this.assertNotDisposed(),Oe(this,I,"f").$setOptions(Oe(this,S,"f"),s(Oe(this,g,"f"),Oe(this,a,"f"),l)),ot(this,w,l,"f")}async postMessage(l){if(Oe(this,D,"f"))return!1;const m=(0,y.serializeWebviewMessage)(l,{serializeBuffersForPostMessage:Oe(this,E,"f")});return Oe(this,I,"f").$postMessage(Oe(this,S,"f"),m.message,...m.buffers)}assertNotDisposed(){if(Oe(this,D,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=r,S=new WeakMap,I=new WeakMap,i=new WeakMap,k=new WeakMap,a=new WeakMap,g=new WeakMap,d=new WeakMap,w=new WeakMap,D=new WeakMap,T=new WeakMap,E=new WeakMap,c=new WeakMap;function v(o){try{const l=(0,C.normalizeVersion)((0,C.parseVersion)(o.engines.vscode));return!!l&&l.majorBase>=1&&l.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=v;class t{constructor(l,m,b,f,P){this.initData=m,this.workspace=b,this._logService=f,this._deprecationService=P,this._webviews=new Map,this._webviewProxy=l.getProxy(_.MainContext.MainThreadWebviews)}$onMessage(l,m,...b){const f=this.getWebview(l);if(f){const{message:P}=(0,y.deserializeWebviewMessage)(m,b);f._onMessageEmitter.fire(P)}}$onMissingCsp(l,m){this._logService.warn(`${m} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(l,m,b){const f=new r(l,this._webviewProxy,n(m),this.initData,this.workspace,b,this._deprecationService);return this._webviews.set(l,f),f._onDidDispose(()=>{this._webviews.delete(l)}),f}deleteWebview(l){this._webviews.delete(l)}getWebview(l){return this._webviews.get(l)}}e.ExtHostWebviews=t;function h(o){return{id:o.identifier,location:o.extensionLocation}}e.toExtensionData=h;function s(o,l,m){return{enableCommandUris:m.enableCommandUris,enableScripts:m.enableScripts,enableForms:m.enableForms,portMapping:m.portMapping,localResourceRoots:m.localResourceRoots||u(o,l)}}e.serializeWebviewOptions=s;function n(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(l=>F.URI.from(l))}}e.reviveOptions=n;function u(o,l){return[...(l?.getWorkspaceFolders()||[]).map(m=>m.uri),o.extensionLocation]}}),define(fe[258],me([0,1,21,48,6,10,23,2,16,71,87,5,7]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class g{constructor(t,h){this.document=t,this._storagePath=h,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,h){await this.getEdit(t).undo(),h||this.disposeBackup()}async redo(t,h){await this.getEdit(t).redo(),h||this.disposeBackup()}disposeEdits(t){for(const h of t)this._edits.delete(h)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=r(this.document.uri)+this._backupCounter++;return(0,A.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const h=this._edits.get(t,0);if(!h)throw new Error("No edit found");return h}}class d{constructor(){this._documents=new Map}get(t,h){return this._documents.get(this.key(t,h))}add(t,h,s){const n=this.key(t,h.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${t} resource:${h.uri}`);const u=new g(h,s);return this._documents.set(n,u),u}delete(t,h){const s=this.key(t,h.uri);this._documents.delete(s)}key(t,h){return`${t}@@@${h}`}}var w;(function(v){v[v.Text=0]="Text",v[v.Custom=1]="Custom"})(w||(w={}));class D{constructor(){this._providers=new Map}addTextProvider(t,h,s){return this.add(0,t,h,s)}addCustomProvider(t,h,s){return this.add(1,t,h,s)}get(t){return this._providers.get(t)}add(t,h,s,n){if(this._providers.has(h))throw new Error(`Provider for viewType:${h} already registered`);return this._providers.set(h,{type:t,extension:s,provider:n}),new a.Disposable(()=>this._providers.delete(h))}}class T{constructor(t,h,s,n,u){this._extHostDocuments=h,this._extensionStoragePaths=s,this._extHostWebview=n,this._extHostWebviewPanels=u,this._editorProviders=new D,this._documents=new d,this._proxy=t.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,h,s,n){const u=new C.DisposableStore;return E(s)?(u.add(this._editorProviders.addTextProvider(h,t,s)),this._proxy.$registerTextEditorProvider((0,I.toExtensionData)(t),h,n.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,I.shouldSerializeBuffersForPostMessage)(t))):(u.add(this._editorProviders.addCustomProvider(h,t,s)),this.supportEditing(s)&&u.add(s.onDidChangeCustomDocument(o=>{const l=this.getCustomDocumentEntry(h,o.document.uri);if(c(o)){const m=l.addEdit(o);this._proxy.$onDidEdit(o.document.uri,h,m,o.label)}else this._proxy.$onContentChange(o.document.uri,h)})),this._proxy.$registerCustomEditorProvider((0,I.toExtensionData)(t),h,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,(0,I.shouldSerializeBuffersForPostMessage)(t))),a.Disposable.from(u,new a.Disposable(()=>{this._proxy.$unregisterEditorProvider(h)}))}async $createCustomDocument(t,h,s,n,u){const o=this._editorProviders.get(h);if(!o)throw new Error(`No provider found for '${h}'`);if(o.type!==1)throw new Error(`Invalid provide type for '${h}'`);const l=_.URI.revive(t),m=await o.provider.openCustomDocument(l,{backupId:s,untitledDocumentData:n?.buffer},u);let b;return this.supportEditing(o.provider)&&this._extensionStoragePaths&&(b=this._extensionStoragePaths.workspaceValue(o.extension)??this._extensionStoragePaths.globalValue(o.extension)),this._documents.add(h,m,b),{editable:this.supportEditing(o.provider)}}async $disposeCustomDocument(t,h){const s=this._editorProviders.get(h);if(!s)throw new Error(`No provider found for '${h}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${h}'`);const n=_.URI.revive(t),{document:u}=this.getCustomDocumentEntry(h,n);this._documents.delete(h,u),u.dispose()}async $resolveWebviewEditor(t,h,s,n,u,o){const l=this._editorProviders.get(s);if(!l)throw new Error(`No provider found for '${s}'`);const m=S.ViewColumn.to(u),b=this._extHostWebview.createNewWebview(h,n.webviewOptions,l.extension),f=this._extHostWebviewPanels.createNewWebviewPanel(h,s,n.title,m,n.panelOptions,b),P=_.URI.revive(t);switch(l.type){case 1:{const{document:L}=this.getCustomDocumentEntry(s,P);return l.provider.resolveCustomEditor(L,f,o)}case 0:{const L=this._extHostDocuments.getDocument(P);return l.provider.resolveCustomTextEditor(L,f,o)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,h,s){this.getCustomDocumentEntry(h,t).disposeEdits(s)}async $onMoveCustomEditor(t,h,s){const n=this._editorProviders.get(s);if(!n)throw new Error(`No provider found for '${s}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const u=this._extHostWebviewPanels.getWebviewPanel(t);if(!u)throw new Error("No webview found");const o=_.URI.revive(h),l=this._extHostDocuments.getDocument(o);await n.provider.moveCustomTextEditor(l,u,p.CancellationToken.None)}async $undo(t,h,s,n){return this.getCustomDocumentEntry(h,t).undo(s,n)}async $redo(t,h,s,n){return this.getCustomDocumentEntry(h,t).redo(s,n)}async $revert(t,h,s){const n=this.getCustomDocumentEntry(h,t);await this.getCustomEditorProvider(h).revertCustomDocument(n.document,s),n.disposeBackup()}async $onSave(t,h,s){const n=this.getCustomDocumentEntry(h,t);await this.getCustomEditorProvider(h).saveCustomDocument(n.document,s),n.disposeBackup()}async $onSaveAs(t,h,s,n){const u=this.getCustomDocumentEntry(h,t);return this.getCustomEditorProvider(h).saveCustomDocumentAs(u.document,_.URI.revive(s),n)}async $backup(t,h,s){const n=this.getCustomDocumentEntry(h,t),o=await this.getCustomEditorProvider(h).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},s);return n.updateBackup(o),o.id}getCustomDocumentEntry(t,h){const s=this._documents.get(t,_.URI.revive(h));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const s=this._editorProviders.get(t)?.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=T;function E(v){return typeof v.resolveCustomTextEditor=="function"}function c(v){return typeof v.undo=="function"&&typeof v.redo=="function"}function r(v){const t=v.scheme===y.Schemas.file||v.scheme===y.Schemas.untitled?v.fsPath:v.toString();return(0,F.hash)(t)+""}});var ot=this&&this.__classPrivateFieldSet||function(Y,e,p,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,p):C?C.value=p:e.set(Y,p),p},Oe=this&&this.__classPrivateFieldGet||function(Y,e,p,F){if(p==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?F:p==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[259],me([0,1,3,6,2,32,16,71,5,7]),function(Y,e,p,F,C,y,A,_,S,I){"use strict";var i,k,a,g,d,w,D,T,E,c,r,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class h extends F.Disposable{constructor(o,l,m,b,f,P,L){super();i.set(this,void 0),k.set(this,void 0),a.set(this,void 0),g.set(this,void 0),d.set(this,void 0),w.set(this,void 0),D.set(this,void 0),T.set(this,void 0),E.set(this,!0),c.set(this,!0),r.set(this,!1),v.set(this,this._register(new p.Emitter)),this.onDidDispose=Oe(this,v,"f").event,t.set(this,this._register(new p.Emitter)),this.onDidChangeViewState=Oe(this,t,"f").event,ot(this,i,o,"f"),ot(this,k,l,"f"),ot(this,a,m,"f"),ot(this,d,P,"f"),ot(this,T,f,"f"),ot(this,w,b,"f"),ot(this,g,L,"f")}dispose(){Oe(this,r,"f")||(ot(this,r,!0,"f"),Oe(this,v,"f").fire(),Oe(this,k,"f").$disposeWebview(Oe(this,i,"f")),Oe(this,g,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,g,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,a,"f")}get title(){return this.assertNotDisposed(),Oe(this,w,"f")}set title(o){this.assertNotDisposed(),Oe(this,w,"f")!==o&&(ot(this,w,o,"f"),Oe(this,k,"f").$setTitle(Oe(this,i,"f"),o))}get iconPath(){return this.assertNotDisposed(),Oe(this,D,"f")}set iconPath(o){this.assertNotDisposed(),Oe(this,D,"f")!==o&&(ot(this,D,o,"f"),Oe(this,k,"f").$setIconPath(Oe(this,i,"f"),C.URI.isUri(o)?{light:o,dark:o}:o))}get options(){return Oe(this,d,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,T,"f")=="number"&&Oe(this,T,"f")<0))return Oe(this,T,"f")}get active(){return this.assertNotDisposed(),Oe(this,c,"f")}get visible(){return this.assertNotDisposed(),Oe(this,E,"f")}_updateViewState(o){Oe(this,r,"f")||(this.active!==o.active||this.visible!==o.visible||this.viewColumn!==o.viewColumn)&&(ot(this,c,o.active,"f"),ot(this,E,o.visible,"f"),ot(this,T,o.viewColumn,"f"),Oe(this,t,"f").fire({webviewPanel:this}))}reveal(o,l){this.assertNotDisposed(),Oe(this,k,"f").$reveal(Oe(this,i,"f"),{viewColumn:o?A.ViewColumn.from(o):void 0,preserveFocus:!!l})}assertNotDisposed(){if(Oe(this,r,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,k=new WeakMap,a=new WeakMap,g=new WeakMap,d=new WeakMap,w=new WeakMap,D=new WeakMap,T=new WeakMap,E=new WeakMap,c=new WeakMap,r=new WeakMap,v=new WeakMap,t=new WeakMap;class s{constructor(o,l,m){this.webviews=l,this.workspace=m,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=o.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,y.generateUuid)()}createWebviewPanel(o,l,m,b,f={}){const P=typeof b=="object"?b.viewColumn:b,L={viewColumn:A.ViewColumn.from(P),preserveFocus:typeof b=="object"&&!!b.preserveFocus},M=(0,_.shouldSerializeBuffersForPostMessage)(o),R=s.newHandle();this._proxy.$createWebviewPanel((0,_.toExtensionData)(o),R,l,{title:m,panelOptions:n(f),webviewOptions:(0,_.serializeWebviewOptions)(o,this.workspace,f),serializeBuffersForPostMessage:M},L);const W=this.webviews.createNewWebview(R,f,o);return this.createNewWebviewPanel(R,l,m,P,f,W)}$onDidChangeWebviewPanelViewStates(o){const l=Object.keys(o);l.sort((m,b)=>{const f=o[m],P=o[b];return f.active?1:P.active?-1:+f.visible-+P.visible});for(const m of l){const b=this.getWebviewPanel(m);if(!b)continue;const f=o[m];b._updateViewState({active:f.active,visible:f.visible,viewColumn:A.ViewColumn.to(f.position)})}}async $onDidDisposeWebviewPanel(o){this.getWebviewPanel(o)?.dispose(),this._webviewPanels.delete(o),this.webviews.deleteWebview(o)}registerWebviewPanelSerializer(o,l,m){if(this._serializers.has(l))throw new Error(`Serializer for '${l}' already registered`);return this._serializers.set(l,{serializer:m,extension:o}),this._proxy.$registerSerializer(l,{serializeBuffersForPostMessage:(0,_.shouldSerializeBuffersForPostMessage)(o)}),new I.Disposable(()=>{this._serializers.delete(l),this._proxy.$unregisterSerializer(l)})}async $deserializeWebviewPanel(o,l,m,b){const f=this._serializers.get(l);if(!f)throw new Error(`No serializer found for '${l}'`);const{serializer:P,extension:L}=f,M=this.webviews.createNewWebview(o,m.webviewOptions,L),R=this.createNewWebviewPanel(o,l,m.title,b,m.panelOptions,M);await P.deserializeWebviewPanel(R,m.state)}createNewWebviewPanel(o,l,m,b,f,P){const L=new h(o,this._proxy,l,m,b,f,P);return this._webviewPanels.set(o,L),L}getWebviewPanel(o){return this._webviewPanels.get(o)}}e.ExtHostWebviewPanels=s;function n(u){return{enableFindWidget:u.enableFindWidget,retainContextWhenHidden:u.retainContextWhenHidden}}});var ot=this&&this.__classPrivateFieldSet||function(Y,e,p,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,p):C?C.value=p:e.set(Y,p),p},Oe=this&&this.__classPrivateFieldGet||function(Y,e,p,F){if(p==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?F:p==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[260],me([0,1,3,6,71,5,7]),function(Y,e,p,F,C,y,A){"use strict";var _,S,I,i,k,a,g,d,w,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class T extends F.Disposable{constructor(r,v,t,h,s,n){super();_.set(this,void 0),S.set(this,void 0),I.set(this,void 0),i.set(this,void 0),k.set(this,!1),a.set(this,void 0),g.set(this,void 0),d.set(this,void 0),w.set(this,this._register(new p.Emitter)),this.onDidChangeVisibility=Oe(this,w,"f").event,D.set(this,this._register(new p.Emitter)),this.onDidDispose=Oe(this,D,"f").event,ot(this,I,t,"f"),ot(this,g,h,"f"),ot(this,_,r,"f"),ot(this,S,v,"f"),ot(this,i,s,"f"),ot(this,a,n,"f")}dispose(){Oe(this,k,"f")||(ot(this,k,!0,"f"),Oe(this,D,"f").fire(),Oe(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,g,"f")}set title(r){this.assertNotDisposed(),Oe(this,g,"f")!==r&&(ot(this,g,r,"f"),Oe(this,S,"f").$setWebviewViewTitle(Oe(this,_,"f"),r))}get description(){return this.assertNotDisposed(),Oe(this,d,"f")}set description(r){this.assertNotDisposed(),Oe(this,d,"f")!==r&&(ot(this,d,r,"f"),Oe(this,S,"f").$setWebviewViewDescription(Oe(this,_,"f"),r))}get visible(){return Oe(this,a,"f")}get webview(){return Oe(this,i,"f")}get viewType(){return Oe(this,I,"f")}_setVisible(r){r===Oe(this,a,"f")||Oe(this,k,"f")||(ot(this,a,r,"f"),Oe(this,w,"f").fire())}show(r){this.assertNotDisposed(),Oe(this,S,"f").$show(Oe(this,_,"f"),!!r)}assertNotDisposed(){if(Oe(this,k,"f"))throw new Error("Webview is disposed")}}_=new WeakMap,S=new WeakMap,I=new WeakMap,i=new WeakMap,k=new WeakMap,a=new WeakMap,g=new WeakMap,d=new WeakMap,w=new WeakMap,D=new WeakMap;class E{constructor(r,v){this._extHostWebview=v,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=r.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(r,v,t,h){if(this._viewProviders.has(v))throw new Error(`View provider for '${v}' already registered`);return this._viewProviders.set(v,{provider:t,extension:r}),this._proxy.$registerWebviewViewProvider((0,C.toExtensionData)(r),v,{retainContextWhenHidden:h?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new A.Disposable(()=>{this._viewProviders.delete(v),this._proxy.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(r,v,t,h,s){const n=this._viewProviders.get(v);if(!n)throw new Error(`No view provider found for '${v}'`);const{provider:u,extension:o}=n,l=this._extHostWebview.createNewWebview(r,{},o),m=new T(r,this._proxy,v,t,l,!0);this._webviewViews.set(r,m),await u.resolveWebviewView(m,{state:h},s)}async $onDidChangeWebviewViewVisibility(r,v){this.getWebviewView(r)._setVisible(v)}async $disposeWebviewView(r){const v=this.getWebviewView(r);this._webviewViews.delete(r),v.dispose(),this._extHostWebview.deleteWebview(r)}getWebviewView(r){const v=this._webviewViews.get(r);if(!v)throw new Error("No webview found");return v}}e.ExtHostWebviewViews=E}),define(fe[134],me([0,1,3,5,2,10,9,4,14]),function(Y,e,p,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class $n{constructor(k){this._onDidChangeWindowState=new p.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=$n.InitialState,this._proxy=k.getProxy(F.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(a=>this.$onDidChangeWindowFocus(a))}get state(){return this._state}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state={...this._state,focused:k},this._onDidChangeWindowState.fire(this._state))}openUri(k,a){let g;if(typeof k=="string"){g=k;try{k=C.URI.parse(k)}catch(d){return Promise.reject(`Invalid uri - '${k}'`)}}return(0,A.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===y.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,g,a)}async asExternalUri(k,a){if((0,A.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this._proxy.$asExternalUri(k,a);return C.URI.from(g)}};I.InitialState={focused:!0},I=Ve([$e(0,S.IExtHostRpcService)],I),e.ExtHostWindow=I,e.IExtHostWindow=(0,_.createDecorator)("IExtHostWindow")}),define(fe[261],me([0,1,8,81,32,40,6,5,2,14]),function(Y,e,p,F,C,y,A,_,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let i=class extends A.Disposable{constructor(a,g){super();const d=a.getProxy(_.MainContext.MainThreadDownloadService);g.registerCommand(!1,"_workbench.downloadResource",async w=>{const D=S.URI.file((0,p.join)((0,F.tmpdir)(),(0,C.generateUuid)()));return await d.$download(w,D),D})}};i=Ve([$e(0,I.IExtHostRpcService),$e(1,y.IExtHostCommands)],i),e.ExtHostDownloadService=i}),define(fe[262],me([0,1,2,8,153,28,69,27,14,6,13,117,43]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class g{constructor(T,E,c){this.name=T,this.file=E,this.appender=c}static async create(T,E){const c=await(0,k.createRotatingLogger)(T,E,30*a.ByteSize.MB,1);return c.clearFormatters(),new g(T,E,c)}append(T){this.appender.critical(T)}flush(){this.appender.flush()}}class d extends A.AbstractExtHostOutputChannel{constructor(T,E,c,r){super(T,!1,p.URI.file(E.file),c,r);this._appender=E}append(T){super.append(T),this._appender.append(T),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(T,E){this._appender.flush(),super.show(T,E)}clear(){this._appender.flush(),super.clear()}}let w=class extends A.ExtHostOutputService{constructor(T,E,c){super(T);this.logService=E,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new I.MutableDisposable,this._logsLocation=c.logsLocation}$setVisibleChannel(T){if(T){const E=this._channels.get(T);E&&(this._visibleChannelDisposable.value=E.onDidAppend(()=>E.update()))}}createOutputChannel(T,E){if(T=T.trim(),!T)throw new Error("illegal argument `name`. must not be falsy");const c=this._doCreateOutChannel(T,E);return c.then(r=>r._id.then(v=>this._channels.set(v,r))),new A.LazyOutputChannel(T,c)}async _doCreateOutChannel(T,E){try{const c=(0,F.join)(this._logsLocation.fsPath,`output_logging_${(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await y.SymlinkSupport.existsDirectory(c)||await y.Promises.mkdir(c,{recursive:!0});const v=`${this._namePool++}-${T.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=p.URI.file((0,F.join)(c,`${v}.log`)),h=await g.create(v,t.fsPath);return new d(T,h,E.identifier.value,this._proxy)}catch(c){return this.logService.error(c),new A.ExtHostPushOutputChannel(T,E.identifier.value,this._proxy)}}};w=Ve([$e(0,S.IExtHostRpcService),$e(1,i.ILogService),$e(2,_.IExtHostInitDataService)],w),e.ExtHostOutputService2=w}),define(fe[263],me([0,1,50,8,2,70,6,10,15]),function(Y,e,p,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class I extends y.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(v){const t=await super._getWorkspaceStorageURI(v);if(t.scheme!==_.Schemas.file)return t;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${t.fsPath}.`),t;const h=t.fsPath;let s=0;do{let n;s===0?n=h:n=/[/\\]$/.test(h)?`${h.substr(0,h.length-1)}-${s}`:`${h}-${s}`,await i(n);const u=F.join(n,"vscode.lock"),o=await d(this._logService,u,!1);if(o)return this._workspaceStorageLock=o,process.on("exit",()=>{o.dispose()}),C.URI.file(n);s++}while(s<10);return t}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=I;async function i(r){try{await p.promises.stat(r);return}catch{}try{await p.promises.mkdir(r,{recursive:!0})}catch{}}const k=1e3,a=10*60*1e3;class g extends A.Disposable{constructor(v,t){super();this.logService=v,this.filename=t,this._timer=this._register(new S.IntervalTimer),this._timer.cancelAndSet(async()=>{const h=await w(v,t);(!h||h.pid!==process.pid)&&(v.info(`Lock '${t}': The lock was lost unexpectedly.`),this._timer.cancel());try{await p.promises.utimes(t,new Date,new Date)}catch(s){v.error(s),v.info(`Lock '${t}': Could not update mtime.`)}},k)}dispose(){super.dispose();try{p.unlinkSync(this.filename)}catch(v){}}async setWillRelease(v){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${v} ms.`);try{const t={pid:process.pid,willReleaseAt:Date.now()+v};await p.promises.writeFile(this.filename,JSON.stringify(t),{flag:"w"})}catch(t){this.logService.error(t)}}}async function d(r,v,t){try{const s={pid:process.pid,willReleaseAt:0};await p.promises.writeFile(v,JSON.stringify(s),{flag:"wx"})}catch(s){r.error(s)}const h=await w(r,v);return!h||h.pid!==process.pid?t?(r.info(`Lock '${v}': Could not acquire lock, giving up.`),null):(r.info(`Lock '${v}': Could not acquire lock, checking if the file is stale.`),E(r,v)):(r.info(`Lock '${v}': Lock acquired.`),new g(r,v))}async function w(r,v){let t;try{t=await p.promises.readFile(v)}catch(h){return r.error(h),null}try{return JSON.parse(String(t))}catch(h){return r.error(h),null}}async function D(r,v){let t;try{t=await p.promises.stat(v)}catch(h){return r.error(h),0}return t.mtime.getTime()}function T(r){try{return process.kill(r,0),!0}catch(v){return!1}}async function E(r,v){const t=await w(r,v);if(!t)return r.info(`Lock '${v}': Could not read pid of lock holder.`),c(r,v);if(t.willReleaseAt){let o=t.willReleaseAt-Date.now();if(o<5e3){for(o>0?r.info(`Lock '${v}': The lockfile is scheduled to be released in ${o} ms.`):r.info(`Lock '${v}': The lockfile is scheduled to have been released.`);o>0;){if(await(0,S.timeout)(Math.min(100,o)),await D(r,v)===0)return c(r,v);o=t.willReleaseAt-Date.now()}return c(r,v)}}if(!T(t.pid))return r.info(`Lock '${v}': The pid ${t.pid} appears to be gone.`),c(r,v);const h=await D(r,v),s=Date.now()-h;if(s<=a)return r.info(`Lock '${v}': The lock does not look stale, elapsed: ${s} ms, giving up.`),null;r.info(`Lock '${v}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const n=await D(r,v),u=Date.now()-n;return u<=a?(r.info(`Lock '${v}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null):(r.info(`Lock '${v}': The lock looks stale even after waiting for 2s.`),c(r,v))}async function c(r,v){r.info(`Lock '${v}': Deleting a stale lock.`);try{await p.promises.unlink(v)}catch(t){}return d(r,v,!0)}}),define(fe[264],me([0,1,32,14,33]),function(Y,e,p,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let y=class extends C.BaseExtHostTerminalService{constructor(_){super(!0,_)}createTerminal(_,S,I){return this.createTerminalFromOptions({name:_,shellPath:S,shellArgs:I})}createTerminalFromOptions(_,S){const I=new C.ExtHostTerminal(this._proxy,(0,p.generateUuid)(),_,_.name);return this._terminals.push(I),I.create(_,this._serializeParentTerminal(_,S)),I.value}};y=Ve([$e(0,F.IExtHostRpcService)],y),e.ExtHostTerminalService=y}),define(fe[265],me([0,1,5,14,173,6,27,2,39,23,28,7,11,54,3,123,78,13]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d,w,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class E{constructor(m,b,f){this.remoteAddress=m,this.localAddress=b,this._dispose=f,this._onDispose=new d.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function c(l){const m=l.trim().split(`
`),b=[];return m.forEach(P=>{const L=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(P);L&&L.length>=3&&b.push({pid:parseInt(L[1],10),socket:parseInt(L[2],10)})}),b.reduce((P,L)=>(P[L.socket]=L,P),{})}e.getSockets=c;function r(...l){const m=[].concat(...l.map(t));return[...new Map(m.filter(b=>b.st==="0A").map(b=>{const f=b.local_address.split(":");return{socket:parseInt(b.inode,10),ip:v(f[0]),port:parseInt(f[1],16)}}).map(b=>[b.ip+":"+b.port,b])).values()]}e.loadListeningPorts=r;function v(l){let m="";if(l.length===8)for(let b=l.length-2;b>=0;b-=2)m+=parseInt(l.substr(b,2),16),b!==0&&(m+=".");else for(let b=l.length-4;b>=0;b-=4)m+=parseInt(l.substr(b,4),16).toString(16),b!==0&&(m+=":");return m}e.parseIpAddress=v;function t(l){const m=l.trim().split(`
`),b=m.shift().trim().split(/\s+/).filter(P=>P!=="rx_queue"&&P!=="tm->when");return m.map(P=>P.trim().split(/\s+/).reduce((L,M,R)=>(L[b[R]||R]=M,L),{}))}e.loadConnectionTable=t;function h(l){return!!l.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||l.indexOf("out/vs/server/main.js")!==-1||l.indexOf("_productName=VSCode")!==-1}function s(l){const m=l.trim().split(`
`),b=[];return m.forEach(f=>{const P=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(f);P&&P.length>=4&&b.push({pid:parseInt(P[1],10),ppid:parseInt(P[2]),cmd:P[3]})}),b}e.getRootProcesses=s;async function n(l,m,b){const f=b.reduce((L,M)=>(L[M.pid]=M,L),{}),P=[];return l.forEach(({socket:L,ip:M,port:R})=>{const W=m[L]?m[L].pid:void 0,V=W?f[W]?.cmd:void 0;W&&V&&!h(V)&&P.push({host:M,port:R,detail:V,pid:W})}),P}e.findPorts=n;function u(l,m,b){const f=new Map,P=s(m);for(const L of l){const M=b.get(L.port);if(M){f.set(L.port,M);continue}const R=P.find(W=>W.cmd.includes(`${L.port}`));if(R){let W=R,V;do V=P.find(N=>N.ppid===W.pid),V&&(W=V);while(V);f.set(L.port,{host:L.ip,port:L.port,pid:W.pid,detail:W.cmd,ppid:W.ppid})}else f.set(L.port,{host:L.ip,port:L.port,ppid:Number.MAX_VALUE})}return f}e.tryFindRootPorts=u;let o=class extends y.Disposable{constructor(m,b,f){super();this.logService=f,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new d.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=m.getProxy(p.MainContext.MainThreadTunnelService),a.isLinux&&b.remote.isRemote&&b.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(m,b){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${m.identifier.value} called openTunnel API for ${b.remoteAddress.host}:${b.remoteAddress.port}.`);const f=await this._proxy.$openTunnel(b,m.displayName);if(f){const P=new E(f.remoteAddress,f.localAddress,()=>this._proxy.$closeTunnel(f.remoteAddress));return this._register(P),P}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(m){return Math.max(m*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(m,b){const f=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(f,{selector:m,provider:b}),this._proxy.$registerPortsAttributesProvider(m,f),new k.Disposable(()=>{this._portAttributesProviders.delete(f),this._proxy.$unregisterPortsAttributesProvider(f)})}async $providePortAttributes(m,b,f,P,L){const M=[];for(const W of m){const V=this._portAttributesProviders.get(W);if(!V)return[];M.push(...await Promise.all(b.map(async N=>V.provider.providePortAttributes(N,f,P,L))))}const R=M.filter(W=>!!W);return R.length>0?R.map(W=>({autoForwardAction:W.autoForwardAction,port:W.port})):[]}async $registerCandidateFinder(m){if(m&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=m;let b=new D.MovingAverage,f;for(;this._candidateFindingEnabled;){const P=new Date().getTime(),L=(await this.findCandidatePorts()).filter(R=>(0,w.isLocalhost)(R.host)||(0,w.isAllInterfaces)(R.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${L.map(R=>R.port).join(", ")}`);const M=new Date().getTime()-P;b.update(M),(!f||JSON.stringify(f)!==JSON.stringify(L))&&(f=L,await this._proxy.$onFoundNewCandidates(f)),await new Promise(R=>setTimeout(()=>R(),this.calculateDelay(b.value)))}}async setTunnelExtensionFunctions(m){if(m){if(m.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(m.candidatePortSource),m.showCandidatePort&&(this._showCandidatePort=m.showCandidatePort,this._proxy.$setCandidateFilter()),m.tunnelFactory){this._forwardPortProvider=m.tunnelFactory;let b=m.tunnelFeatures?.privacyOptions??[];m.tunnelFeatures?.public&&b.length===0&&(b=[{id:"private",label:C.localize(0,null),themeIcon:"lock"},{id:"public",label:C.localize(1,null),themeIcon:"eye"}]),this._proxy.$setTunnelProvider({elevation:!!m.tunnelFeatures?.elevation,public:!!m.tunnelFeatures?.public,privacyOptions:b})}}else this._forwardPortProvider=void 0;return(0,y.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(m,b){if(this._extensionTunnels.has(m.host)){const f=this._extensionTunnels.get(m.host);f.has(m.port)&&(b&&f.get(m.port).disposeListener.dispose(),await f.get(m.port).tunnel.dispose(),f.delete(m.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(m,b){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const f=this._forwardPortProvider(m,b);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),f!==void 0){const P=await f;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(m.remoteAddress.host)||this._extensionTunnels.set(m.remoteAddress.host,new Map);const L=this._register(P.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(P.remoteAddress))));return this._extensionTunnels.get(m.remoteAddress.host).set(m.remoteAddress.port,{tunnel:P,disposeListener:L}),g.TunnelDto.fromApiTunnel(P)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(f){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(m){const b=await Promise.all(m.map(P=>this._showCandidatePort(P.host,P.port,P.detail??""))),f=m.filter((P,L)=>b[L]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${m.map(P=>P.port).join(", ")} to ${f.map(P=>P.port).join(", ")}`),f}async findCandidatePorts(){let m="",b="";try{m=await i.Promises.readFile("/proc/net/tcp","utf8"),b=await i.Promises.readFile("/proc/net/tcp6","utf8")}catch(U){}const f=r(m,b),P=await new Promise(U=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(B,z,O)=>{U(z)})}),L=c(P),M=await i.Promises.readdir("/proc"),R=[];for(let U of M)try{const B=Number(U),z=I.joinPath(_.URI.file("/proc"),U);if((await i.Promises.stat(z.fsPath)).isDirectory()&&!isNaN(B)){const $=await i.Promises.readlink(I.joinPath(z,"cwd").fsPath),x=await i.Promises.readFile(I.joinPath(z,"cmdline").fsPath,"utf8");R.push({pid:B,cwd:$,cmd:x})}}catch(B){}const W=[],V=f.filter(U=>{const B=L[U.socket];return B||W.push(U),B}),N=n(V,L,R);let j;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${W.length}`),W.length>0){const U=await new Promise(B=>{(0,S.exec)("ps -F -A -l | grep root",(z,O,$)=>{B(O)})});this._foundRootPorts=u(W,U,this._foundRootPorts),j=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${j.join(", ")}`)}return N.then(U=>j?U.concat(j):U)}};o=Ve([$e(0,F.IExtHostRpcService),$e(1,A.IExtHostInitDataService),$e(2,T.ILogService)],o),e.ExtHostTunnelService=o}),define(fe[266],me([0,1,15,22,21,17,3,6,104,230,55]),function(Y,e,p,F,C,y,A,_,S,I,i){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function a(f,P){try{return JSON.stringify(f,P)}catch(L){return"null"}}const g="$$ref$$",d={[g]:-1};class w{constructor(P,L){this.jsonString=P,this.referencedBuffers=L}}function D(f,P=null,L=!1){const M=[];return{jsonString:(L?a:JSON.stringify)(f,(W,V)=>{if(typeof V=="undefined")return d;if(typeof V=="object"){if(V instanceof F.VSBuffer){const N=M.push(V)-1;return{[g]:N}}if(P)return P(W,V)}return V}),referencedBuffers:M}}e.stringifyJsonWithBufferRefs=D;function T(f,P,L){return JSON.parse(f,(M,R)=>{if(R){const W=R[g];if(typeof W=="number")return P[W];if(L&&R.$mid===1)return L.transformIncoming(R)}return R})}e.parseJsonAndRestoreBufferRefs=T;function E(f,P){return JSON.stringify(f,P)}function c(f){return f?(P,L)=>L&&L.$mid===1?f.transformOutgoing(L):L:null}var r;(function(f){f[f.LocalSide=0]="LocalSide",f[f.OtherSide=1]="OtherSide"})(r=e.RequestInitiator||(e.RequestInitiator={}));var v;(function(f){f[f.Responsive=0]="Responsive",f[f.Unresponsive=1]="Unresponsive"})(v=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},h=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class n extends _.Disposable{constructor(P,L=null,M=null){super();this[k]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=P,this._logger=L,this._uriTransformer=M,this._uriReplacer=c(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let R=0,W=i.ProxyIdentifier.count;R<W;R++)this._locals[R]=null,this._proxies[R]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new p.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(R=>this._receiveOneMessage(R))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(P=>{this._pendingRPCReplies[P].resolveErr(y.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(P){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(P){this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(P){this._responsiveState!==P&&(this._responsiveState=P,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(P){return this._uriTransformer?(0,S.transformIncomingURIs)(P,this._uriTransformer):P}getProxy(P){const{nid:L,sid:M}=P;return this._proxies[L]||(this._proxies[L]=this._createProxy(L,M)),this._proxies[L]}_createProxy(P,L){let M={get:(R,W)=>(typeof W=="string"&&!R[W]&&W.charCodeAt(0)===36&&(R[W]=(...V)=>this._remoteCall(P,W,V)),W===s?L:R[W])};return new Proxy(Object.create(null),M)}set(P,L){return this._locals[P.nid]=L,L}assertRegistered(P){for(let L=0,M=P.length;L<M;L++){const R=P[L];if(!this._locals[R.nid])throw new Error(`Missing actor ${R.sid} (isMain: ${R.isMain})`)}}_receiveOneMessage(P){if(this._isDisposed)return;const L=P.byteLength,M=u.read(P,0),R=M.readUInt8(),W=M.readUInt32();switch(R){case 1:case 2:{let{rpcId:V,method:N,args:j}=l.deserializeRequestJSONArgs(M);this._uriTransformer&&(j=(0,S.transformIncomingURIs)(j,this._uriTransformer)),this._receiveRequest(L,W,V,N,j,R===2);break}case 3:case 4:{let{rpcId:V,method:N,args:j}=l.deserializeRequestMixedArgs(M);this._uriTransformer&&(j=(0,S.transformIncomingURIs)(j,this._uriTransformer)),this._receiveRequest(L,W,V,N,j,R===4);break}case 5:{this._logger&&this._logger.logIncoming(L,W,0,"ack"),this._onDidReceiveAcknowledge(W);break}case 6:{this._receiveCancel(L,W);break}case 7:{this._receiveReply(L,W,void 0);break}case 9:{let V=l.deserializeReplyOKJSON(M);this._uriTransformer&&(V=(0,S.transformIncomingURIs)(V,this._uriTransformer)),this._receiveReply(L,W,V);break}case 10:{const V=l.deserializeReplyOKJSONWithBuffers(M,this._uriTransformer);this._receiveReply(L,W,V);break}case 8:{let V=l.deserializeReplyOKVSBuffer(M);this._receiveReply(L,W,V);break}case 11:{let V=l.deserializeReplyErrError(M);this._uriTransformer&&(V=(0,S.transformIncomingURIs)(V,this._uriTransformer)),this._receiveReplyErr(L,W,V);break}case 12:{this._receiveReplyErr(L,W,void 0);break}default:console.error("received unexpected message"),console.error(P)}}_receiveRequest(P,L,M,R,W,V){this._logger&&this._logger.logIncoming(P,L,1,`receiveRequest ${(0,i.getStringIdentifierForProxy)(M)}.${R}(`,W);const N=String(L);let j,U;if(V){const z=new C.CancellationTokenSource;W.push(z.token),j=this._invokeHandler(M,R,W),U=()=>z.cancel()}else j=this._invokeHandler(M,R,W),U=t;this._cancelInvokedHandlers[N]=U;const B=l.serializeAcknowledged(L);this._logger&&this._logger.logOutgoing(B.byteLength,L,1,"ack"),this._protocol.send(B),j.then(z=>{delete this._cancelInvokedHandlers[N];const O=l.serializeReplyOK(L,z,this._uriReplacer);this._logger&&this._logger.logOutgoing(O.byteLength,L,1,"reply:",z),this._protocol.send(O)},z=>{delete this._cancelInvokedHandlers[N];const O=l.serializeReplyErr(L,z);this._logger&&this._logger.logOutgoing(O.byteLength,L,1,"replyErr:",z),this._protocol.send(O)})}_receiveCancel(P,L){this._logger&&this._logger.logIncoming(P,L,1,"receiveCancel");const M=String(L);this._cancelInvokedHandlers[M]&&this._cancelInvokedHandlers[M]()}_receiveReply(P,L,M){this._logger&&this._logger.logIncoming(P,L,0,"receiveReply:",M);const R=String(L);if(!this._pendingRPCReplies.hasOwnProperty(R))return;const W=this._pendingRPCReplies[R];delete this._pendingRPCReplies[R],W.resolveOk(M)}_receiveReplyErr(P,L,M){this._logger&&this._logger.logIncoming(P,L,0,"receiveReplyErr:",M);const R=String(L);if(!this._pendingRPCReplies.hasOwnProperty(R))return;const W=this._pendingRPCReplies[R];delete this._pendingRPCReplies[R];let V;M&&(M.$isError?(V=new Error,V.name=M.name,V.message=M.message,V.stack=M.stack):V=M),W.resolveErr(V)}_invokeHandler(P,L,M){try{return Promise.resolve(this._doInvokeHandler(P,L,M))}catch(R){return Promise.reject(R)}}_doInvokeHandler(P,L,M){const R=this._locals[P];if(!R)throw new Error("Unknown actor "+(0,i.getStringIdentifierForProxy)(P));let W=R[L];if(typeof W!="function")throw new Error("Unknown method "+L+" on actor "+(0,i.getStringIdentifierForProxy)(P));return W.apply(R,M)}_remoteCall(P,L,M){if(this._isDisposed)return Promise.reject(y.canceled());let R=null;if(M.length>0&&C.CancellationToken.isCancellationToken(M[M.length-1])&&(R=M.pop()),R&&R.isCancellationRequested)return Promise.reject(y.canceled());const W=l.serializeRequestArguments(M,this._uriReplacer),V=++this._lastMessageId,N=String(V),j=new I.LazyPromise;R&&R.onCancellationRequested(()=>{const B=l.serializeCancel(V);this._logger&&this._logger.logOutgoing(B.byteLength,V,0,"cancel"),this._protocol.send(l.serializeCancel(V))}),this._pendingRPCReplies[N]=j,this._onWillSendRequest(V);const U=l.serializeRequest(V,P,L,W,!!R);return this._logger&&this._logger.logOutgoing(U.byteLength,V,0,`request: ${(0,i.getStringIdentifierForProxy)(P)}.${L}(`,M),this._protocol.send(U),j}}e.RPCProtocol=n,k=h,n.UNRESPONSIVE_TIME=3*1e3;class u{constructor(P,L){this._buff=P,this._offset=L}static alloc(P,L,M){let R=new u(F.VSBuffer.alloc(M+1+4),0);return R.writeUInt8(P),R.writeUInt32(L),R}static read(P,L){return new u(P,L)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(P){this._buff.writeUInt8(P,this._offset),this._offset+=1}readUInt8(){const P=this._buff.readUInt8(this._offset);return this._offset+=1,P}writeUInt32(P){this._buff.writeUInt32BE(P,this._offset),this._offset+=4}readUInt32(){const P=this._buff.readUInt32BE(this._offset);return this._offset+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this._buff.writeUInt8(P.byteLength,this._offset),this._offset+=1,this._buff.set(P,this._offset),this._offset+=P.byteLength}readShortString(){const P=this._buff.readUInt8(this._offset);this._offset+=1;const M=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,M}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readLongString(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,M}writeBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readVSBuffer(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const L=this._buff.slice(this._offset,this._offset+P);return this._offset+=P,L}static sizeMixedArray(P){let L=0;L+=1;for(let M=0,R=P.length;M<R;M++){const W=P[M];switch(L+=1,W.type){case 1:L+=this.sizeLongString(W.value);break;case 2:L+=this.sizeVSBuffer(W.value);break;case 3:L+=this.sizeUInt32,L+=this.sizeLongString(W.value);for(let V=0;V<W.buffers.length;++V)L+=this.sizeVSBuffer(W.buffers[V]);break;case 4:break}}return L}writeMixedArray(P){this._buff.writeUInt8(P.length,this._offset),this._offset+=1;for(let L=0,M=P.length;L<M;L++){const R=P[L];switch(R.type){case 1:this.writeUInt8(1),this.writeLongString(R.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(R.value);break;case 3:this.writeUInt8(3),this.writeUInt32(R.buffers.length),this.writeLongString(R.value);for(let W=0;W<R.buffers.length;++W)this.writeBuffer(R.buffers[W]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this._buff.readUInt8(this._offset);this._offset+=1;let L=new Array(P);for(let M=0;M<P;M++)switch(this.readUInt8()){case 1:L[M]=this.readLongString();break;case 2:L[M]=this.readVSBuffer();break;case 3:const W=this.readUInt32(),V=this.readLongString(),N=[];for(let j=0;j<W;++j)N.push(this.readVSBuffer());L[M]=new i.SerializableObjectWithBuffers(T(V,N,null));break;case 4:L[M]=void 0;break}return L}}u.sizeUInt32=4;var o;(function(f){f[f.Simple=0]="Simple",f[f.Mixed=1]="Mixed"})(o||(o={}));class l{static _useMixedArgSerialization(P){for(let L=0,M=P.length;L<M;L++)if(P[L]instanceof F.VSBuffer||P[L]instanceof i.SerializableObjectWithBuffers||typeof P[L]=="undefined")return!0;return!1}static serializeRequestArguments(P,L){if(this._useMixedArgSerialization(P)){const M=[];for(let R=0,W=P.length;R<W;R++){const V=P[R];if(V instanceof F.VSBuffer)M[R]={type:2,value:V};else if(typeof V=="undefined")M[R]={type:4};else if(V instanceof i.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:j}=D(V.value,L);M[R]={type:3,value:F.VSBuffer.fromString(N),buffers:j}}else M[R]={type:1,value:F.VSBuffer.fromString(E(V,L))}}return{type:1,args:M}}return{type:0,args:E(P,L)}}static serializeRequest(P,L,M,R,W){switch(R.type){case 0:return this._requestJSONArgs(P,L,M,R.args,W);case 1:return this._requestMixedArgs(P,L,M,R.args,W)}}static _requestJSONArgs(P,L,M,R,W){const V=F.VSBuffer.fromString(M),N=F.VSBuffer.fromString(R);let j=0;j+=u.sizeUInt8(),j+=u.sizeShortString(V),j+=u.sizeLongString(N);let U=u.alloc(W?2:1,P,j);return U.writeUInt8(L),U.writeShortString(V),U.writeLongString(N),U.buffer}static deserializeRequestJSONArgs(P){const L=P.readUInt8(),M=P.readShortString(),R=P.readLongString();return{rpcId:L,method:M,args:JSON.parse(R)}}static _requestMixedArgs(P,L,M,R,W){const V=F.VSBuffer.fromString(M);let N=0;N+=u.sizeUInt8(),N+=u.sizeShortString(V),N+=u.sizeMixedArray(R);let j=u.alloc(W?4:3,P,N);return j.writeUInt8(L),j.writeShortString(V),j.writeMixedArray(R),j.buffer}static deserializeRequestMixedArgs(P){const L=P.readUInt8(),M=P.readShortString(),R=P.readMixedArray(),W=new Array(R.length);for(let V=0,N=R.length;V<N;V++){const j=R[V];typeof j=="string"?W[V]=JSON.parse(j):W[V]=j}return{rpcId:L,method:M,args:W}}static serializeAcknowledged(P){return u.alloc(5,P,0).buffer}static serializeCancel(P){return u.alloc(6,P,0).buffer}static serializeReplyOK(P,L,M){if(typeof L=="undefined")return this._serializeReplyOKEmpty(P);if(L instanceof F.VSBuffer)return this._serializeReplyOKVSBuffer(P,L);if(L instanceof i.SerializableObjectWithBuffers){const{jsonString:R,referencedBuffers:W}=D(L.value,M,!0);return this._serializeReplyOKJSONWithBuffers(P,R,W)}else return this._serializeReplyOKJSON(P,a(L,M))}static _serializeReplyOKEmpty(P){return u.alloc(7,P,0).buffer}static _serializeReplyOKVSBuffer(P,L){let M=0;M+=u.sizeVSBuffer(L);let R=u.alloc(8,P,M);return R.writeVSBuffer(L),R.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static _serializeReplyOKJSON(P,L){const M=F.VSBuffer.fromString(L);let R=0;R+=u.sizeLongString(M);let W=u.alloc(9,P,R);return W.writeLongString(M),W.buffer}static _serializeReplyOKJSONWithBuffers(P,L,M){const R=F.VSBuffer.fromString(L);let W=0;W+=u.sizeUInt32,W+=u.sizeLongString(R);for(const N of M)W+=u.sizeVSBuffer(N);let V=u.alloc(10,P,W);V.writeUInt32(M.length),V.writeLongString(R);for(const N of M)V.writeBuffer(N);return V.buffer}static deserializeReplyOKJSON(P){const L=P.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(P,L){const M=P.readUInt32(),R=P.readLongString(),W=[];for(let V=0;V<M;++V)W.push(P.readVSBuffer());return new i.SerializableObjectWithBuffers(T(R,W,L))}static serializeReplyErr(P,L){return L?this._serializeReplyErrEror(P,L):this._serializeReplyErrEmpty(P)}static _serializeReplyErrEror(P,L){const M=F.VSBuffer.fromString(a(y.transformErrorForSerialization(L),null));let R=0;R+=u.sizeLongString(M);let W=u.alloc(11,P,R);return W.writeLongString(M),W.buffer}static deserializeReplyErrError(P){const L=P.readLongString();return JSON.parse(L)}static _serializeReplyErrEmpty(P){return u.alloc(12,P,0).buffer}}var m;(function(f){f[f.RequestJSONArgs=1]="RequestJSONArgs",f[f.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",f[f.RequestMixedArgs=3]="RequestMixedArgs",f[f.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",f[f.Acknowledged=5]="Acknowledged",f[f.Cancel=6]="Cancel",f[f.ReplyOKEmpty=7]="ReplyOKEmpty",f[f.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",f[f.ReplyOKJSON=9]="ReplyOKJSON",f[f.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",f[f.ReplyErrError=11]="ReplyErrError",f[f.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var b;(function(f){f[f.String=1]="String",f[f.VSBuffer=2]="VSBuffer",f[f.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",f[f.Undefined=4]="Undefined"})(b||(b={}))}),define(fe[267],me([0,1,4]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,p.createDecorator)("remoteAgentService")}),define(fe[268],me([0,1,10,8,11,2,4,64,44,225,267]),function(Y,e,p,F,C,y,A,_,S,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,A.createDecorator)("pathService");let k=class Wn{constructor(g,d,w,D){this.localUserHome=g,this.remoteAgentService=d,this.environmentService=w,this.contextService=D,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||C.OS)(),this.resolveUserHome=(async()=>{const T=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=T?.userHome||g})()}get defaultUriScheme(){return Wn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(g,d){if(g.remoteAuthority)return p.Schemas.vscodeRemote;const w=(0,_.getVirtualWorkspaceScheme)(d.getWorkspace());if(w)return w;const D=d.getWorkspace().folders[0];if(D)return D.uri.scheme;const T=d.getWorkspace().configuration;return T?T.scheme:p.Schemas.file}async userHome(g){return g?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(g=>g===1?F.win32:F.posix)}async fileURI(g){let d="";if(await this.resolveOS===1&&(g=g.replace(/\\/g,"/")),g[0]==="/"&&g[1]==="/"){const D=g.indexOf("/",2);D===-1?(d=g.substring(2),g="/"):(d=g.substring(2,D),g=g.substring(D)||"/")}return y.URI.from({scheme:p.Schemas.file,authority:d,path:g,query:"",fragment:""})}};k=Ve([$e(1,i.IRemoteAgentService),$e(2,I.IWorkbenchEnvironmentService),$e(3,S.IWorkspaceContextService)],k),e.AbstractPathService=k}),define(fe[72],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class p{constructor(A,_){this.line=A,this.character=_}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,_){return new p(0,0)}with(A){return new p(0,0)}}e.Position=p;class F{constructor(A,_,S,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new p(A,_),this.end=new p(S,I)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new F(0,0,0,0)}with(A){return new F(0,0,0,0)}}e.Range=F;var C;(function(y){y[y.Information=1]="Information",y[y.Warning=2]="Warning"})(C=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(fe[31],me([0,1,18,30,25,29,9,4,8,17,72,12]),function(Y,e,p,F,C,y,A,_,S,I,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const a="\u27EA ",g=" characters skipped \u27EB",d=(a.length+g.length+5)*2;e.ISearchService=(0,_.createDecorator)("searchService");var w;(function(B){B[B.file=0]="file",B[B.text=1]="text"})(w=e.SearchProviderType||(e.SearchProviderType={}));var D;(function(B){B[B.File=1]="File",B[B.Text=2]="Text"})(D=e.QueryType||(e.QueryType={}));function T(B){return!!B.preview}e.resultIsMatch=T;function E(B){return!!B.resource}e.isFileMatch=E;function c(B){return!!B.message}e.isProgressMessage=c;var r;(function(B){B[B.Normal=0]="Normal",B[B.NewSearchStarted=1]="NewSearchStarted"})(r=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class v{constructor(z){this.resource=z,this.results=[]}}e.FileMatch=v;class t{constructor(z,O,$){this.ranges=O;const x=Array.isArray(O)?O:[O];if($&&$.matchLines===1&&h(x)){z=(0,A.getNLines)(z,$.matchLines);let X="",Q=0,de=0;const _e=Math.floor($.charsPerLine/5),ye=[];for(const ke of x){const xe=Math.max(ke.startColumn-_e,0),We=ke.startColumn+$.charsPerLine;if(xe>de+_e+d){const He=a+(xe-de)+g;X+=He+z.slice(xe,We),Q+=xe-(de+He.length)}else X+=z.slice(de,We);ye.push(new n(0,ke.startColumn-Q,ke.endColumn-Q)),de=We}this.preview={text:X,matches:Array.isArray(this.ranges)?ye:ye[0]}}else{const X=Array.isArray(O)?O[0].startLineNumber:O.startLineNumber;this.preview={text:z,matches:(0,p.mapArrayOrNot)(O,Q=>new s(Q.startLineNumber-X,Q.startColumn,Q.endLineNumber-X,Q.endColumn))}}}}e.TextSearchMatch=t;function h(B){const z=B[0].startLineNumber;for(const O of B)if(O.startLineNumber!==z||O.endLineNumber!==z)return!1;return!0}class s{constructor(z,O,$,x){this.startLineNumber=z,this.startColumn=O,this.endLineNumber=$,this.endColumn=x}}e.SearchRange=s;class n extends s{constructor(z,O,$){super(z,O,z,$)}}e.OneLineRange=n;var u;(function(B){B.Default="default",B.FileNames="fileNames",B.Type="type",B.Modified="modified",B.CountDescending="countDescending",B.CountAscending="countAscending"})(u=e.SearchSortOrder||(e.SearchSortOrder={}));function o(B,z=!0){const O=B&&B.files&&B.files.exclude,$=z&&B&&B.search&&B.search.exclude;if(!O&&!$)return;if(!O||!$)return O||$;let x=Object.create(null);return x=C.mixin(x,C.deepClone(O)),x=C.mixin(x,C.deepClone($),!0),x}e.getExcludes=o;function l(B,z){return B.excludePattern&&F.match(B.excludePattern,z)?!1:B.includePattern||B.usingSearchPaths?B.includePattern&&F.match(B.includePattern,z)?!0:B.usingSearchPaths?!!B.folderQueries&&B.folderQueries.some(O=>{const $=O.folder.fsPath;if(y.isEqualOrParent(z,$)){const x=S.relative($,z);return!O.includePattern||!!F.match(O.includePattern,x)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var m;(function(B){B[B.unknownEncoding=1]="unknownEncoding",B[B.regexParseError=2]="regexParseError",B[B.globParseError=3]="globParseError",B[B.invalidLiteral=4]="invalidLiteral",B[B.rgProcessError=5]="rgProcessError",B[B.other=6]="other",B[B.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class b extends Error{constructor(z,O){super(z);this.code=O}}e.SearchError=b;function f(B){const z=B.message;if((0,I.isPromiseCanceledError)(B))return new b(z,m.canceled);try{const O=JSON.parse(z);return new b(O.message,O.code)}catch(O){return new b(z,m.other)}}e.deserializeSearchError=f;function P(B){const z={message:B.message,code:B.code};return new Error(JSON.stringify(z))}e.serializeSearchError=P;function L(B){return B.type==="error"?!0:B.type==="success"}e.isSerializedSearchComplete=L;function M(B){return B.type==="success"}e.isSerializedSearchSuccess=M;function R(B){return!!B.path}e.isSerializedFileMatch=R;function W(B,z){const O=B.searchPath?B.searchPath:B.relativePath;return(0,A.fuzzyContains)(O,z)}e.isFilePatternMatch=W;class V{constructor(z){this.path=z,this.results=[]}addMatch(z){this.results.push(z)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=V;function N(B,z){const O={...B||{},...z||{}};return Object.keys(O).filter($=>{const x=O[$];return typeof x=="boolean"&&x})}e.resolvePatternsForProvider=N;class j{constructor(z,O){this._parsedIncludeExpression=null,this._excludeExpression={...z.excludePattern||{},...O.excludePattern||{}},this._parsedExcludeExpression=F.parse(this._excludeExpression);let $=z.includePattern;O.includePattern&&($?$={...$,...O.includePattern}:$=O.includePattern),$&&(this._parsedIncludeExpression=F.parse($))}matchesExcludesSync(z,O,$){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(z,O,$))}includedInQuerySync(z,O,$){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(z,O,$)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(z,O,$))}includedInQuery(z,O,$){const x=this._parsedExcludeExpression(z,O,$),X=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(z,O,$):!0;return(0,k.isPromise)(x)?x.then(Q=>Q?!1:X()):X()}hasSiblingExcludeClauses(){return U(this._excludeExpression)}}e.QueryGlobTester=j;function U(B){for(const z in B)if(typeof B[z]!="boolean")return!0;return!1}}),define(fe[36],me([0,1,18,15,21,3,24,10,78,23,9,12,2,171,4,13,191,44,53,27,14,7,31,5]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d,w,D,T,E,c,r,v,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(P,L,M){return new I.ExtUri(R=>l(R,M)).isEqual(P,L)}function n(P,L,M){return s(P.uri,L.uri,M)?0:(0,i.compare)(P.uri.toString(),L.uri.toString())}function u(P,L,M){return P.index!==L.index?P.index<L.index?-1:1:s(P.uri,L.uri,M)?(0,i.compare)(P.name,L.name):(0,i.compare)(P.uri.toString(),L.uri.toString())}function o(P,L,M,R){const W=P.slice(0).sort((N,j)=>M(N,j,R)),V=L.slice(0).sort((N,j)=>M(N,j,R));return(0,p.delta)(W,V,(N,j)=>M(N,j,R))}function l(P,L){const M=L.getCapabilities(P.scheme);return!(M&&M&1024)}class m extends T.Workspace{constructor(L,M,R,W,V,N,j){super(L,R.map(U=>new T.WorkspaceFolder(U)),W,V,j);this._name=M,this._isUntitled=N,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(j),R.forEach(U=>{this._workspaceFolders.push(U),this._structure.set(U.uri,U)})}static toExtHostWorkspace(L,M,R,W){if(!L)return{workspace:null,added:[],removed:[]};const{id:V,name:N,folders:j,configuration:U,transient:B,isUntitled:z}=L,O=[],$=M;M?j.forEach((de,_e)=>{const ye=a.URI.revive(de.uri),ke=m._findFolder(R||M,ye,W);ke?(ke.name=de.name,ke.index=de.index,O.push(ke)):O.push({uri:ye,name:de.name,index:_e})}):O.push(...j.map(({uri:de,name:_e,index:ye})=>({uri:a.URI.revive(de),name:_e,index:ye}))),O.sort((de,_e)=>de.index<_e.index?-1:1);const x=new m(V,N,O,!!B,U?a.URI.revive(U):null,!!z,de=>l(de,W)),{added:X,removed:Q}=o($?$.workspaceFolders:[],x.workspaceFolders,n,W);return{workspace:x,added:X,removed:Q}}static _findFolder(L,M,R){for(let W=0;W<L.folders.length;W++){const V=L.workspaceFolders[W];if(s(V.uri,M,R))return V}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,M){return M&&this._structure.get(L)&&(L=(0,I.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let b=class{constructor(L,M,R,W){this._onDidChangeWorkspace=new y.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new y.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=W,this._extHostFileSystemInfo=R,this._requestIdProvider=new S.Counter,this._barrier=new F.Barrier,this._proxy=L.getProxy(h.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(h.MainContext.MainThreadMessageService);const V=M.workspace;this._confirmedWorkspace=V?new m(V.id,V.name,[],!!V.transient,V.configuration?a.URI.revive(V.configuration):null,!!V.isUntitled,N=>l(N,R)):void 0}$initializeWorkspace(L,M){this._trusted=M,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?a.URI.from({scheme:_.Schemas.untitled,path:(0,I.basename)((0,I.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,M,R,...W){const V=[];if(Array.isArray(W)&&W.forEach(z=>{a.URI.isUri(z.uri)&&!V.some(O=>s(O.uri,z.uri,this._extHostFileSystemInfo))&&V.push({uri:z.uri,name:z.name||(0,I.basenameOrAuthority)(z.uri)})}),this._unconfirmedWorkspace||[M,R].some(z=>typeof z!="number"||z<0)||R===0&&V.length===0)return!1;const N=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(M+R>N.length)return!1;const j=N.slice(0);j.splice(M,R,...V.map(z=>({uri:z.uri,name:z.name||(0,I.basenameOrAuthority)(z.uri),index:void 0})));for(let z=0;z<j.length;z++){const O=j[z];if(j.some(($,x)=>x!==z&&s(O.uri,$.uri,this._extHostFileSystemInfo)))return!1}j.forEach((z,O)=>z.index=O);const{added:U,removed:B}=o(N,j,u,this._extHostFileSystemInfo);if(U.length===0&&B.length===0)return!1;if(this._proxy){const z=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(z,M,R,V).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(D.Severity.Error,(0,g.localize)(0,null,z,O.toString()),{extension:L},[])})}return this.trySetWorkspaceFolders(j),!0}getWorkspaceFolder(L,M){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,M)}async getWorkspaceFolder2(L,M){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,M)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,M){let R,W="";if(typeof L=="string"?(R=a.URI.file(L),W=L):typeof L!="undefined"&&(R=L,W=L.fsPath),!R)return W;const V=this.getWorkspaceFolder(R,!0);if(!V)return W;typeof M=="undefined"&&this._actualWorkspace&&(M=this._actualWorkspace.folders.length>1);let N=(0,I.relativePath)(V.uri,R);return M&&V.name&&(N=`${V.name}/${N}`),N}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=m.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:M,added:R,removed:W}=m.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=M||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:R,removed:W}))}findFiles(L,M,R,W,V=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${W.value}, entryPoint: findFiles`);let N;if(M===null?N=!1:M&&(typeof M=="string"?N=M:N=M.pattern),V&&V.isCancellationRequested)return Promise.resolve([]);const{includePattern:j,folder:U}=f(L);return this._proxy.$startFileSearch((0,k.withUndefinedAsNull)(j),(0,k.withUndefinedAsNull)(U),(0,k.withUndefinedAsNull)(N),(0,k.withUndefinedAsNull)(R),V).then(B=>Array.isArray(B)?B.map(z=>a.URI.revive(z)):[])}async findTextInFiles(L,M,R,W,V=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${W.value}, entryPoint: findTextInFiles`);const N=this._requestIdProvider.getNext(),j=typeof M.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:M.previewOptions,{includePattern:U,folder:B}=f(M.include),z=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,O={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!0,fileEncoding:M.encoding,maxResults:M.maxResults,previewOptions:j,afterContext:M.afterContext,beforeContext:M.beforeContext,includePattern:U,excludePattern:z},$=!1;if(this._activeSearchCallbacks[N]=x=>{if($)return;const X=a.URI.revive(x.resource);x.results.forEach(Q=>{(0,t.resultIsMatch)(Q)?R({uri:X,preview:{text:Q.preview.text,matches:(0,p.mapArrayOrNot)(Q.preview.matches,de=>new v.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))},ranges:(0,p.mapArrayOrNot)(Q.ranges,de=>new v.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))}):R({uri:X,text:Q.text,lineNumber:Q.lineNumber})})},V.isCancellationRequested)return{};try{const x=await this._proxy.$startTextSearch(L,(0,k.withUndefinedAsNull)(B),O,N,V);return delete this._activeSearchCallbacks[N],x||{}}catch(x){throw delete this._activeSearchCallbacks[N],x}}$handleTextSearchResult(L,M){this._activeSearchCallbacks[M]&&this._activeSearchCallbacks[M](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};b=Ve([$e(0,r.IExtHostRpcService),$e(1,c.IExtHostInitDataService),$e(2,E.IExtHostFileSystemInfo),$e(3,w.ILogService)],b),e.ExtHostWorkspace=b,e.IExtHostWorkspace=(0,d.createDecorator)("IExtHostWorkspace");function f(P){let L,M;return P&&(typeof P=="string"?L=P:(L=P.pattern,M=P.baseFolder||a.URI.file(P.base))),{includePattern:L,folder:M}}}),define(fe[37],me([0,1,25,3,36,5,7,194,86,12,15,4,14,13,2]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function w(h,s){if(s){const n=s.split(".");let u=h;for(let o=0;u&&o<n.length;o++)u=u[n[o]];return u}}function D(h){return h instanceof d.URI}function T(h){return h&&h.uri instanceof d.URI&&h.languageId&&typeof h.languageId=="string"}function E(h){return h&&!h.uri&&h.languageId&&typeof h.languageId=="string"}function c(h){return h&&h.uri instanceof d.URI&&(!h.name||typeof h.name=="string")&&(!h.index||typeof h.index=="number")}function r(h){if(D(h))return{resource:h};if(T(h))return{resource:h.uri,overrideIdentifier:h.languageId};if(E(h))return{overrideIdentifier:h.languageId};if(c(h))return{resource:h.uri};if(h===null)return{resource:null}}let v=class{constructor(s,n,u){this._proxy=s.getProxy(y.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=u,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,n){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(s,n))}};v=Ve([$e(0,a.IExtHostRpcService),$e(1,C.IExtHostWorkspace),$e(2,g.ILogService)],v),e.ExtHostConfiguration=v;class t{constructor(s,n,u,o){this._onDidChangeConfiguration=new F.Emitter,this._proxy=s,this._logService=o,this._extHostWorkspace=n,this._configuration=_.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,n){const u={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=_.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,u))}getConfiguration(s,n,u){const o=r(n)||{},l=this._toReadonlyValue(s?w(this._configuration.getValue(void 0,o,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,o,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,o,u?.identifier);function m(f){if(f==null)return null;if(typeof f=="boolean")return f?1:4;switch(f){case A.ConfigurationTarget.Global:return 1;case A.ConfigurationTarget.Workspace:return 4;case A.ConfigurationTarget.WorkspaceFolder:return 5}}const b={has(f){return typeof w(l,f)!="undefined"},get:(f,P)=>{this._validateConfigurationAccess(s?`${s}.${f}`:f,o,u?.identifier);let L=w(l,f);if(typeof L=="undefined")L=P;else{let M;const R=(W,V)=>{let N;const j=()=>{M=M||(0,p.deepClone)(l),N=N||w(M,V)};return(0,I.isObject)(W)?new Proxy(W,{get:(U,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return j(),()=>N;if(M)return N=N||w(M,V),N[B];const z=U[B];return typeof B=="string"?R(z,`${V}.${B}`):z},set:(U,B,z)=>(j(),N&&(N[B]=z),!0),deleteProperty:(U,B)=>(j(),N&&delete N[B],!0),defineProperty:(U,B,z)=>(j(),N&&Object.defineProperty(N,B,z),!0)}):W};L=R(L,f)}return L},update:(f,P,L,M)=>{f=s?`${s}.${f}`:f;const R=m(L);return P!==void 0?this._proxy.$updateConfigurationOption(R,f,P,o,M):this._proxy.$removeConfigurationOption(R,f,o,M)},inspect:f=>{f=s?`${s}.${f}`:f;const P=(0,p.deepClone)(this._configuration.inspect(f,o,this._extHostWorkspace.workspace));if(P)return{key:f,defaultValue:P.default?.value,globalValue:P.user?.value,workspaceValue:P.workspace?.value,workspaceFolderValue:P.workspaceFolder?.value,defaultLanguageValue:P.default?.override,globalLanguageValue:P.user?.override,workspaceLanguageValue:P.workspace?.override,workspaceFolderLanguageValue:P.workspaceFolder?.override,languageIds:P.overrideIdentifiers}}};return typeof l=="object"&&(0,p.mixin)(b,l,!1),Object.freeze(b)}_toReadonlyValue(s){const n=u=>(0,I.isObject)(u)?new Proxy(u,{get:(o,l)=>n(o[l]),set:(o,l,m)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(l)}' of object`)},deleteProperty:(o,l)=>{throw new Error(`TypeError: Cannot delete read only property '${String(l)}' of object`)},defineProperty:(o,l)=>{throw new Error(`TypeError: Cannot define property '${String(l)}' for a readonly object`)},setPrototypeOf:o=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return n(s)}_validateConfigurationAccess(s,n,u){const o=S.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),l=u?`[${u.value}] `:"";if(o===4){typeof n?.resource=="undefined"&&this._logService.warn(`${l}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(o===3){n?.resource&&this._logService.warn(`${l}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,n){const u=new _.ConfigurationChangeEvent(s,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(o,l)=>u.affectsConfiguration(o,r(l))})}_toMap(s){return s.reduce((n,u)=>(n.set(u[0],u[1]),n),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var ot=this&&this.__classPrivateFieldSet||function(Y,e,p,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,p):C?C.value=p:e.set(Y,p),p},Oe=this&&this.__classPrivateFieldGet||function(Y,e,p,F){if(p==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?F:p==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[73],me([0,1,2,15,3,5,7,36,45,37,21,33,14,27,4,10,11,13,68,215,17]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d,w,D,T,E,c,r){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(V){function N(U){if(U!=null)return U}V.from=N;function j(U){if(U!=null)return U}V.to=j})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var h;(function(V){function N(U){if(U!=null)return U}V.from=N;function j(U){if(U!=null)return U}V.to=j})(h=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(V){function N(U){if(U!=null)return U}V.from=N;function j(U){if(U!=null)return U}V.to=j})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function(V){function N(B){if(B){const z=B;return z&&!!z.process}else return!1}V.is=N;function j(B){if(B==null)return;const z={process:B.process,args:B.args};return B.options&&(z.options=s.from(B.options)),z}V.from=j;function U(B){if(B!=null)return new A.ProcessExecution(B.process,B.args,B.options)}V.to=U})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var u;(function(V){function N(U){if(U!=null)return U}V.from=N;function j(U){if(U!=null)return U}V.to=j})(u=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var o;(function(V){function N(B){if(B){const z=B;return z&&(!!z.commandLine||!!z.command)}else return!1}V.is=N;function j(B){if(B==null)return;const z={};return B.commandLine!==void 0?z.commandLine=B.commandLine:(z.command=B.command,z.args=B.args),B.options&&(z.options=u.from(B.options)),z}V.from=j;function U(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new A.ShellExecution(B.commandLine,B.options):new A.ShellExecution(B.command,B.args?B.args:[],B.options)}V.to=U})(o=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var l;(function(V){function N(B){if(B){let z=B;return z&&z.customExecution==="customExecution"}else return!1}V.is=N;function j(B){return{customExecution:"customExecution"}}V.from=j;function U(B,z){return z.get(B)}V.to=U})(l=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var m;(function(V){function N(j,U){let B;return j.scope!==void 0&&typeof j.scope!="number"?B=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===A.TaskScope.Workspace&&U&&U.workspaceFile?B=U.workspaceFile:B=c.USER_TASKS_GROUP_KEY),{id:j._id,workspaceFolder:B}}V.from=N})(m=e.TaskHandleDTO||(e.TaskHandleDTO={}));var b;(function(V){function N(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}V.from=N})(b=e.TaskGroupDTO||(e.TaskGroupDTO={}));var f;(function(V){function N(B,z){if(B==null)return[];const O=[];for(let $ of B){const x=j($,z);x&&O.push(x)}return O}V.fromMany=N;function j(B,z){if(B==null)return;let O;B.execution instanceof A.ProcessExecution?O=n.from(B.execution):B.execution instanceof A.ShellExecution?O=o.from(B.execution):B.execution&&B.execution instanceof A.CustomExecution&&(O=l.from(B.execution));const $=t.from(B.definition);let x;return B.scope?typeof B.scope=="number"?x=B.scope:x=B.scope.uri:x=A.TaskScope.Workspace,!$||!x?void 0:{_id:B._id,definition:$,name:B.name,source:{extensionId:z.identifier.value,label:B.source,scope:x},execution:O,isBackground:B.isBackground,group:b.from(B.group),presentationOptions:h.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}V.from=j;async function U(B,z,O){if(B==null)return;let $;n.is(B.execution)?$=n.to(B.execution):o.is(B.execution)?$=o.to(B.execution):l.is(B.execution)&&($=l.to(B._id,O));const x=t.to(B.definition);let X;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?X=B.source.scope:X=await z.resolveWorkspaceFolder(p.URI.revive(B.source.scope)):X=A.TaskScope.Workspace),!x||!X)return;const Q=new A.Task(x,X,B.name,B.source.label,$,B.problemMatchers);return B.isBackground!==void 0&&(Q.isBackground=B.isBackground),B.group!==void 0&&(Q.group=A.TaskGroup.from(B.group._id),Q.group&&B.group.isDefault&&(Q.group=new A.TaskGroup(Q.group.id,Q.group.label),B.group.isDefault&&(Q.group.isDefault=B.group.isDefault))),B.presentationOptions&&(Q.presentationOptions=h.to(B.presentationOptions)),B._id&&(Q._id=B._id),B.detail&&(Q.detail=B.detail),Q}V.to=U})(f=e.TaskDTO||(e.TaskDTO={}));var P;(function(V){function N(U){return U}V.from=N;function j(U){if(!!U)return Object.assign(Object.create(null),U)}V.to=j})(P=e.TaskFilterDTO||(e.TaskFilterDTO={}));class L{constructor(N,j,U){this._id=j,this._task=U,v.set(this,void 0),ot(this,v,N,"f")}get task(){return this._task}terminate(){Oe(this,v,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}v=new WeakMap;var M;(function(V){function N(j){return{id:j._id,task:void 0}}V.from=N})(M=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let R=class{constructor(N,j,U,B,z,O,$,x){this._onDidExecuteTask=new C.Emitter,this._onDidTerminateTask=new C.Emitter,this._onDidTaskProcessStarted=new C.Emitter,this._onDidTaskProcessEnded=new C.Emitter,this._proxy=N.getProxy(y.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=B,this._configurationService=z,this._terminalService=O,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=$,this._deprecationService=x,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,j,U){if(!U)return new A.Disposable(()=>{});const B=this.nextHandle();return this._handlers.set(B,{type:j,provider:U,extension:N}),this._proxy.$registerTaskProvider(B,j),new A.Disposable(()=>{this._handlers.delete(B),this._proxy.$unregisterTaskProvider(B)})}registerTaskSystem(N,j){this._proxy.$registerTaskSystem(N,j)}fetchTasks(N){return this._proxy.$fetchTasks(P.from(N)).then(async j=>{const U=[];for(let B of j){const z=await f.to(B,this._workspaceProvider,this._providedCustomExecutions2);z&&U.push(z)}return U})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(j=>N.push(j)),N}terminateTask(N){if(!(N instanceof L))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,j,U){const B=this._providedCustomExecutions2.get(N.id);if(B){if(this._activeCustomExecutions2.get(N.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(N.id,B),this._terminalService.attachPtyToTerminal(j,await B.callback(U))}this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){const j=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:j})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const j=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:j,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const j=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:j,exitCode:N.exitCode})}$provideTasks(N,j){const U=this._handlers.get(N);if(!U)return Promise.reject(new Error("no handler found"));const B=[],z=(0,F.asPromise)(()=>U.provider.provideTasks(i.CancellationToken.None)).then(O=>this.provideTasksInternal(j,B,U,O));return new Promise(O=>{z.then($=>{Promise.all(B).then(()=>{O($)})})})}async $resolveTask(N,j){const U=this._handlers.get(N);if(!U)return Promise.reject(new Error("no handler found"));if(j.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${U.type}].`);const B=await f.to(j,this._workspaceProvider,this._providedCustomExecutions2);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const z=await U.provider.resolveTask(B,i.CancellationToken.None);if(!z)return;this.checkDeprecation(z,U);const O=f.from(z,U.extension);if(!O)throw new Error("Unexpected: Task cannot be resolved.");if(z.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(O.execution)&&await this.addCustomExecution(O,z,!0),await this.resolveTaskInternal(O)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,j,U){const B=await this._proxy.$createTaskId(N);!U&&!this._providedCustomExecutions2.has(B)&&this._notProvidedCustomExecutions.add(B),this._providedCustomExecutions2.set(B,j.execution)}async getTaskExecution(N,j){if(typeof N=="string"){const z=this._taskExecutionPromises.get(N);if(!z)throw new Error("Unexpected: The specified task is missing an execution");return z}let U=this._taskExecutionPromises.get(N.id);if(U)return U;const B=new Promise(async(z,O)=>{const $=j||await f.to(N.task,this._workspaceProvider,this._providedCustomExecutions2);$?z(new L(this,N.id,$)):O("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(N.id,B),B.then(z=>(this._taskExecutions.set(N.id,z),z),z=>Promise.reject(z))}checkDeprecation(N,j){N._deprecated&&this._deprecationService.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));let U=this._notProvidedCustomExecutions.values(),B=U.next();for(;!B.done;)!this._activeCustomExecutions2.has(B.value)&&this._lastStartedTask!==B.value&&(this._providedCustomExecutions2.delete(B.value),this._notProvidedCustomExecutions.delete(B.value)),B=U.next()}};R=Ve([$e(0,a.IExtHostRpcService),$e(1,g.IExtHostInitDataService),$e(2,_.IExtHostWorkspace),$e(3,S.IExtHostDocumentsAndEditors),$e(4,I.IExtHostConfiguration),$e(5,k.IExtHostTerminalService),$e(6,T.ILogService),$e(7,E.IExtHostApiDeprecationService)],R),e.ExtHostTaskBase=R;let W=class extends R{constructor(N,j,U,B,z,O,$,x){super(N,j,U,B,z,O,$,x);this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:"",platform:D.PlatformToString(0)})}async executeTask(N,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const U=f.from(j,N);if(U===void 0)throw new Error("Task is not valid");if(l.is(U.execution))await this.addCustomExecution(U,j,!1);else throw new r.NotSupportedError;const B=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),j);return this._proxy.$executeTask(U).catch(z=>{throw new Error(z)}),B}provideTasksInternal(N,j,U,B){const z=[];if(B)for(let O of B){this.checkDeprecation(O,U),(!O.definition||!N[O.definition.type])&&this._logService.warn(`The task [${O.source}, ${O.name}] uses an undefined task type. The task will be ignored in the future.`);const $=f.from(O,U.extension);$&&l.is($.execution)?(z.push($),j.push(this.addCustomExecution($,O,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:z,extension:U.extension}}async resolveTaskInternal(N){if(l.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,j,U){}};W=Ve([$e(0,a.IExtHostRpcService),$e(1,g.IExtHostInitDataService),$e(2,_.IExtHostWorkspace),$e(3,S.IExtHostDocumentsAndEditors),$e(4,I.IExtHostConfiguration),$e(5,k.IExtHostTerminalService),$e(6,T.ILogService),$e(7,E.IExtHostApiDeprecationService)],W),e.WorkerExtHostTask=W,e.IExtHostTask=(0,d.createDecorator)("IExtHostTask")}),define(fe[269],me([0,1,18,59,30,80,24,10,8,23,9,12,2,147,178,121,44,130,268,31]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d,w,D,T,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let r=class{constructor(m,b,f,P){this.configurationService=m,this.workspaceContextService=b,this.editorGroupsService=f,this.pathService=P}text(m,b,f={}){m=this.getContentPattern(m,f);const P=this.configurationService.getValue(),L=b&&b.some(R=>!this.configurationService.getValue({resource:R}).search.useRipgrep);return{...this.commonQuery(b?.map(D.toWorkspaceFolder),f),type:2,contentPattern:m,previewOptions:f.previewOptions,maxFileSize:f.maxFileSize,usePCRE2:P.search.usePCRE2||L||!1,beforeContext:f.beforeContext,afterContext:f.afterContext,userDisabledExcludesAndIgnoreFiles:f.disregardExcludeSettings&&f.disregardIgnoreFiles}}getContentPattern(m,b){const f=this.configurationService.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const P={...m,wordSeparators:f.editor.wordSeparators};return this.isCaseSensitive(m,b)&&(P.isCaseSensitive=!0),this.isMultiline(m)&&(P.isMultiline=!0),P}file(m,b={}){return{...this.commonQuery(m,b),type:1,filePattern:b.filePattern?b.filePattern.trim():b.filePattern,exists:b.exists,sortByScore:b.sortByScore,cacheKey:b.cacheKey}}handleIncludeExclude(m,b){return m?(m=Array.isArray(m)?m.map(n):n(m),b?this.parseSearchPaths(m):{pattern:t(...Array.isArray(m)?m:[m])}):{}}commonQuery(m=[],b={}){const f=this.handleIncludeExclude(b.includePattern,b.expandPatterns),P=this.handleIncludeExclude(b.excludePattern,b.expandPatterns),L=m.length>1,M=(f.searchPaths&&f.searchPaths.length?f.searchPaths.map(V=>this.getFolderQueryForSearchPath(V,b,P)):m.map(V=>this.getFolderQueryForRoot(V,b,P,L))).filter(V=>!!V),R={_reason:b._reason,folderQueries:M,usingSearchPaths:!!(f.searchPaths&&f.searchPaths.length),extraFileResources:b.extraFileResources,excludePattern:P.pattern,includePattern:f.pattern,onlyOpenEditors:b.onlyOpenEditors,maxResults:b.maxResults};if(b.onlyOpenEditors){const N=p.coalesce(p.flatten(this.editorGroupsService.groups.map(U=>U.editors.map(B=>B.resource)))).filter(U=>(0,c.pathIncludedInQuery)(R,U.fsPath)),j=this.commonQueryFromFileList(N);return{...R,...j}}const W=b.extraFileResources&&b.extraFileResources.filter(V=>(0,c.pathIncludedInQuery)(R,V.fsPath));return R.extraFileResources=W&&W.length?W:void 0,R}commonQueryFromFileList(m){const b=[],f=new A.ResourceMap,P={};let L=!1;return m.forEach(M=>{if(M.scheme===_.Schemas.walkThrough)return;if((0,I.isAbsolutePath)(M)){const W=this.workspaceContextService.getWorkspaceFolder(M)?.uri??M.with({path:S.dirname(M.fsPath)});let V=f.get(W);V||(L=!0,V={folder:W,includePattern:{}},b.push(V),f.set(W,V));const N=S.relative(W.fsPath,M.fsPath);(0,k.assertIsDefined)(V.includePattern)[N.replace(/\\/g,"/")]=!0}else M.fsPath&&(L=!0,P[M.fsPath]=!0)}),{folderQueries:b,includePattern:P,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(m,b){if(b.isSmartCase){if(m.isRegExp){if(i.containsUppercaseCharacter(m.pattern,!0))return!0}else if(i.containsUppercaseCharacter(m.pattern))return!0}return!!m.isCaseSensitive}isMultiline(m){return m.isMultiline||m.isRegExp&&(0,g.isMultilineRegexSource)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const b=j=>S.isAbsolute(j)||/^\.\.?([\/\\]|$)/.test(j),P=(Array.isArray(m)?m:h(m)).map(j=>{const U=this.pathService.resolvedUserHome;return U?(0,y.untildify)(j,U.scheme===_.Schemas.file?U.fsPath:U.path):j}),L=F.groupBy(P,j=>b(j)?"searchPaths":"exprSegments"),M=(L.exprSegments||[]).map(j=>i.rtrim(j,"/")).map(j=>i.rtrim(j,"\\")).map(j=>(j[0]==="."&&(j="*"+j),s(j))),R={},W=this.expandSearchPathPatterns(L.searchPaths||[]);W&&W.length&&(R.searchPaths=W);const V=p.flatten(M),N=t(...V);return N&&(R.pattern=N),R}getExcludesForFolder(m,b){return b.disregardExcludeSettings?void 0:(0,c.getExcludes)(m,!b.disregardSearchExcludeSettings)}expandSearchPathPatterns(m){if(!m||!m.length)return[];const b=p.flatten(m.map(P=>{let{pathPortion:L,globPortion:M}=v(P);M&&(M=u(M));const R=this.expandOneSearchPath(L);return p.flatten(R.map(W=>this.resolveOneSearchPathPattern(W,M)))})),f=new Map;return b.forEach(P=>{const L=P.searchPath.toString(),M=f.get(L);M?P.pattern&&(M.pattern=M.pattern||{},M.pattern[P.pattern]=!0):f.set(L,{searchPath:P.searchPath,pattern:P.pattern?t(P.pattern):void 0})}),Array.from(f.values())}expandOneSearchPath(m){if(S.isAbsolute(m)){const b=this.workspaceContextService.getWorkspace().folders;return b[0]&&b[0].uri.scheme!==_.Schemas.file?[{searchPath:b[0].uri.with({path:m})}]:[{searchPath:a.URI.file(S.normalize(m))}]}if(this.workspaceContextService.getWorkbenchState()===2){const b=this.workspaceContextService.getWorkspace().folders[0].uri;if(m=n(m),m.startsWith("../")||m===".."){const P=S.posix.resolve(b.path,m);return[{searchPath:b.with({path:P})}]}const f=u(m);return[{searchPath:b,pattern:f}]}else{if(m==="./"||m===".\\")return[];{const b=m.replace(/^\.[\/\\]/,""),P=this.workspaceContextService.getWorkspace().folders.map(L=>{const M=b.match(new RegExp(`^${i.escapeRegExpCharacters(L.name)}(?:/(.*)|$)`));return M?{match:M,folder:L}:null}).filter(k.isDefined);if(P.length)return P.map(L=>{const M=L.match[1];return{searchPath:L.folder.uri,pattern:M&&u(M)}});{const L=m.match(/\.[\/\\](.+)[\/\\]?/),M=L?L[1]:m,R=d.localize(0,null,M);throw new Error(R)}}}}resolveOneSearchPathPattern(m,b){const f=m.pattern&&b?`${m.pattern}/${b}`:m.pattern||b,P=[{searchPath:m.searchPath,pattern:f}];return f&&!f.endsWith("**")&&P.push({searchPath:m.searchPath,pattern:f+"/**"}),P}getFolderQueryForSearchPath(m,b,f){const P=this.getFolderQueryForRoot((0,D.toWorkspaceFolder)(m.searchPath),b,f,!1);return P?{...P,includePattern:m.pattern}:null}getFolderQueryForRoot(m,b,f,P){let L;const M=a.URI.isUri(m)?m:m.uri;if(f.searchPaths){const j=f.searchPaths.filter(U=>(0,I.isEqual)(U.searchPath,M))[0];if(j&&!j.pattern)return null;j&&(L=j.pattern)}const R=this.configurationService.getValue({resource:M}),V={...this.getExcludesForFolder(R,b)||{},...L||{}},N=a.URI.isUri(m)?(0,I.basename)(m):m.name;return{folder:M,folderName:P?N:void 0,excludePattern:Object.keys(V).length>0?V:void 0,fileEncoding:R.files&&R.files.encoding,disregardIgnoreFiles:typeof b.disregardIgnoreFiles=="boolean"?b.disregardIgnoreFiles:!R.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof b.disregardGlobalIgnoreFiles=="boolean"?b.disregardGlobalIgnoreFiles:!R.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof b.ignoreSymlinks=="boolean"?b.ignoreSymlinks:!R.search.followSymlinks}}};r=Ve([$e(0,w.IConfigurationService),$e(1,D.IWorkspaceContextService),$e(2,T.IEditorGroupsService),$e(3,E.IPathService)],r),e.QueryBuilder=r;function v(l){const m=l.match(/[\*\{\}\(\)\[\]\?]/);if(m){const b=m.index,f=l.substr(0,b).match(/[/|\\][^/\\]*$/);if(f){let P=l.substr(0,f.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:l.substr((f.index||0)+1)}}}return{pathPortion:l}}function t(...l){return l.length?l.reduce((m,b)=>(m[b]=!0,m),Object.create(null)):void 0}function h(l){return C.splitGlobAware(l,",").map(m=>m.trim()).filter(m=>!!m.length)}function s(l){return[`**/${l}/**`,`**/${l}`].map(b=>b.replace(/\*\*\/\*\*/g,"**"))}function n(l){return l.replace(/\\/g,"/")}function u(l){return n(l).replace(/^\.\//,"").replace(/\/+$/g,"")}function o(l,m){l=p.distinct(l,P=>P.toString());const b=[],f=m.getWorkspace();return l&&l.forEach(P=>{let L;if(m.getWorkbenchState()===2)L=(0,I.relativePath)(f.folders[0].uri,P),L&&L!=="."&&(L="./"+L);else{const M=m.getWorkspaceFolder(P);if(M){const R=M.name;if(f.folders.filter(V=>V.name===R).length===1){const V=(0,I.relativePath)(M.uri,P);V===""?L=`./${M.name}`:L=`./${M.name}/${V}`}else L=P.fsPath}}L&&b.push(L)}),b}e.resolveResourcesForSearchIncludes=o}),define(fe[270],me([0,1,23,2,21,17,4,269,31,44]),function(Y,e,p,F,C,y,A,_,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function k(w,D){const T=D.activationEvents;if(!T)return Promise.resolve(void 0);const E=[],c=[];for(const n of T)if(/^workspaceContains:/.test(n)){const u=n.substr("workspaceContains:".length);u.indexOf("*")>=0||u.indexOf("?")>=0||w.forceUsingSearch?c.push(u):E.push(u)}if(E.length===0&&c.length===0)return Promise.resolve(void 0);let r;const v=new Promise((n,u)=>{r=n}),t=n=>r({activationEvent:n}),h=Promise.all(E.map(n=>a(w,n,t))).then(()=>{}),s=g(w,D.identifier,c,t);return Promise.all([h,s]).then(()=>{r(void 0)}),v}e.checkActivateWorkspaceContainsExtension=k;async function a(w,D,T){for(const E of w.folders)if(await w.exists(p.joinPath(F.URI.revive(E),D))){T(`workspaceContains:${D}`);return}}async function g(w,D,T,E){if(T.length===0)return Promise.resolve(void 0);const c=new C.CancellationTokenSource,r=w.checkExists(w.folders,T,c.token),v=setTimeout(async()=>{c.cancel(),E(`workspaceContainsTimeout:${T.join(",")}`)},i);let t=!1;try{t=await r}catch(h){y.isPromiseCanceledError(h)||y.onUnexpectedError(h)}c.dispose(),clearTimeout(v),t&&E(`workspaceContains:${T.join(",")}`)}function d(w,D,T,E){const c=w.get(A.IInstantiationService),r=w.get(S.ISearchService),t=c.createInstance(_.QueryBuilder).file(D.map(h=>(0,I.toWorkspaceFolder)(F.URI.revive(h))),{_reason:"checkExists",includePattern:T,exists:!0});return r.fileSearch(t,E).then(h=>!!h.limitHit,h=>y.isPromiseCanceledError(h)?!1:Promise.reject(h))}e.checkGlobFileExists=d});var ot=this&&this.__classPrivateFieldSet||function(Y,e,p,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,p):C?C.value=p:e.set(Y,p),p},Oe=this&&this.__classPrivateFieldGet||function(Y,e,p,F){if(p==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?F:p==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[41],me([0,1,166,8,74,23,15,6,24,2,13,5,37,228,92,36,35,226,17,26,22,201,7,122,4,27,70,14,85,54,33,3,270,90,203,10]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d,w,D,T,E,c,r,v,t,h,s,n,u,o,l,m,b,f,P,L,M,R){"use strict";var W,V,N;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let j=class Hn extends _.Disposable{constructor(O,$,x,X,Q,de,_e,ye,ke,xe){super();this._onDidChangeRemoteConnectionData=this._register(new f.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=$,this._extHostContext=x,this._initData=_e,this._extHostWorkspace=X,this._extHostConfiguration=Q,this._logService=de,this._extHostTunnelService=ke,this._extHostTerminalService=xe,this._disposables=new _.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._registry=new T.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new d.ExtHostStorage(this._extHostContext),this._secretState=new L.ExtHostSecretState(this._extHostContext),this._storagePath=ye,this._instaService=O.createChild(new l.ServiceCollection([d.IExtHostStorage,this._storage],[L.IExtHostSecretState,this._secretState]));const We=new Set;this._initData.hostExtensions.forEach(He=>We.add(c.ExtensionIdentifier.toKey(He))),this._activator=new g.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(He,q,ee)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(He,E.transformErrorForSerialization(q),ee)},actualActivateExtension:async(He,q)=>{if(We.has(c.ExtensionIdentifier.toKey(He)))return await this._mainThreadExtensionsProxy.$activateExtension(He,q),new g.HostExtension;const ee=this._registry.getExtensionDescription(He);return this._activateExtension(ee,q)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),C.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){E.onUnexpectedError(O)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let O=[];try{O=this._registry.getAllExtensionDescriptions().map(Q=>Q.identifier).filter(Q=>this.isActivated(Q)).map(Q=>this._deactivate(Q))}catch($){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,$){return this._activator.activateByEvent(O,$)}_activateById(O,$){return this._activator.activateById(O,$)}activateByIdWithErrors(O,$){return this._activateById(O,$).then(()=>{const x=this._activator.getActivatedExtension(O);if(x.activationFailed)return Promise.reject(x.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}async _realPathExtensionUri(O){if(O.scheme!==R.Schemas.file)return O;const $=await this._hostUtils.realpath(O.fsPath);return I.URI.file($)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const O=S.TernarySearchTree.forUris($=>y.extUriBiasedIgnorePathCase.ignorePathCasing($));for(const $ of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint($)){const x=await this._realPathExtensionUri($.extensionLocation);O.set(x,$)}return O})()),this._extensionPathIndex}_deactivate(O){let $=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return $;const x=this._activator.getActivatedExtension(O);if(!x)return $;try{typeof x.module.deactivate=="function"&&($=Promise.resolve(x.module.deactivate()).then(void 0,X=>(this._logService.error(X),Promise.resolve(void 0))))}catch(X){this._logService.error(X)}try{(0,_.dispose)(x.subscriptions)}catch(X){this._logService.error(X)}return $}async _activateExtension(O,$){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,$).then(x=>{const X=x.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,X.codeLoadingTime,X.activateCallTime,X.activateResolvedTime,$),this._logExtensionActivationTimes(O,$,"success",X),x},x=>{throw this._logExtensionActivationTimes(O,$,"failure"),x})}_logExtensionActivationTimes(O,$,x,X){const Q=U(O,$);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Q,...X||{},outcome:x})}_doActivateExtension(O,$){const x=U(O,$);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",x);const X=this._getEntryPoint(O);if(!X)return Promise.resolve(new g.EmptyExtension(g.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value}, startup: ${$.startup}, activationEvent: '${$.activationEvent}'${O.identifier.value!==$.extensionId.value?`, root cause: ${$.extensionId.value}`:""}`),this._logService.flush();const Q=new g.ExtensionActivationTimesBuilder($.startup);return Promise.all([this._loadCommonJSModule(O.identifier,(0,y.joinPath)(O.extensionLocation,X),Q),this._loadExtensionContext(O)]).then(de=>(C.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),Hn._callActivate(this._logService,O.identifier,de[0],de[1],Q))).then(de=>(C.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),de))}_loadExtensionContext(O){const $=new v.ExtensionGlobalMemento(O,this._storage),x=new v.ExtensionMemento(O.identifier.value,!1,this._storage),X=new M.ExtensionSecrets(O,this._secretState),Q=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,de=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([$.whenReady,x.whenReady,this._storagePath.whenReady]).then(()=>{const _e=this;let ye;return Object.freeze({globalState:$,workspaceState:x,secrets:X,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(ke){return F.join(O.extensionLocation.fsPath,ke)},get storagePath(){return _e._storagePath.workspaceValue(O)?.fsPath},get globalStoragePath(){return _e._storagePath.globalValue(O).fsPath},get logPath(){return F.join(_e._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return I.URI.joinPath(_e._initData.logsLocation,O.identifier.value)},get storageUri(){return _e._storagePath.workspaceValue(O)},get globalStorageUri(){return _e._storagePath.globalValue(O)},get extensionMode(){return Q},get extension(){return ye===void 0&&(ye=new B(_e,O.identifier,O,de)),ye},get extensionRuntime(){return(0,D.checkProposedApiEnabled)(O),_e.extensionRuntime},get environmentVariableCollection(){return _e._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,$,x,X,Q){return x=x||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,$,x,X,Q).then(de=>new g.ActivatedExtension(!1,null,Q.build(),x,de,X.subscriptions))}static _callActivateOptional(O,$,x,X,Q){if(typeof x.activate=="function")try{Q.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${$.value}`);const de=typeof global=="object"?global:self,_e=x.activate.apply(de,[X]);return Q.activateCallStop(),Q.activateResolveStart(),Promise.resolve(_e).then(ye=>(Q.activateResolveStop(),ye))}catch(de){return Promise.reject(de)}else return Promise.resolve(x)}_activateOneStartupFinished(O,$){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:$}).then(void 0,x=>{this._logService.error(x)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(C.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const $ of O.activationEvents)$==="onStartupFinished"&&this._activateOneStartupFinished(O,$)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,Q=>{this._logService.error(Q)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Q=>this._handleWorkspaceContainsEagerExtensions(Q.added)));const $=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],x=this._handleWorkspaceContainsEagerExtensions($),X=Promise.all([O,x]).then(()=>{});return Promise.race([X,(0,A.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),X}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map($=>this._handleWorkspaceContainsEagerExtension(O,$))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,$){if(this.isActivated($.identifier))return;const x=!this._initData.remote.isRemote&&!!this._initData.remote.authority,X={folders:O.map(de=>de.uri),forceUsingSearch:x,exists:de=>this._hostUtils.exists(de.fsPath),checkExists:(de,_e,ye)=>this._mainThreadWorkspaceProxy.$checkExists(de,_e,ye)},Q=await(0,P.checkActivateWorkspaceContainsExtension)(X,$);if(!!Q)return this._activateById($.identifier,{startup:!0,extensionId:$.identifier,activationEvent:Q.activationEvent}).then(void 0,de=>this._logService.error(de))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:$}=this._initData.environment;if(!O||!$)throw new Error(p.localize(0,null));const x=await this._loadCommonJSModule(null,$,new g.ExtensionActivationTimesBuilder(!1));if(!x||typeof x.run!="function")throw new Error(p.localize(1,null,$.toString()));return new Promise((X,Q)=>{const de=(ke,xe)=>{ke?Q(ke):X(typeof xe=="number"&&xe>0?1:0)},_e=(0,y.originalFSPath)($),ye=x.run(_e,de);ye&&ye.then&&ye.then(()=>{X(0)}).catch(ke=>{Q(ke.toString())})})}async $extensionTestsExit(O){this._logService.info(`extension host terminating: test runner requested exit with code ${O}`),this._logService.info(`exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(O,$){return this._resolvers[O]=$,(0,_.toDisposable)(()=>{delete this._resolvers[O]})}async _activateAndGetResolver(O){const $=O.indexOf("+");if($===-1)throw new Error("Not an authority that can be resolved!");const x=O.substr(0,$);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${x}`,!1),{authorityPrefix:x,resolver:this._resolvers[x]}}async $resolveAuthority(O,$){const{authorityPrefix:x,resolver:X}=await this._activateAndGetResolver(O);if(!X)return{type:"error",error:{code:h.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${x}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(X)),C.mark(`code/extHost/willResolveAuthority/${x}`);const Q=await X.resolve(O,{resolveAttempt:$});C.mark(`code/extHost/didResolveAuthorityOK/${x}`);const de={authority:O,host:Q.host,port:Q.port,connectionToken:Q.connectionToken},_e={extensionHostEnv:Q.extensionHostEnv,isTrusted:Q.isTrusted};return{type:"ok",value:{authority:de,options:_e,tunnelInformation:{environmentTunnels:Q.environmentTunnels}}}}catch(Q){if(C.mark(`code/extHost/didResolveAuthorityError/${x}`),Q instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q}}async $getCanonicalURI(O,$){const{authorityPrefix:x,resolver:X}=await this._activateAndGetResolver(O);if(!X)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${x}`);const Q=I.URI.revive($);if(typeof X.getCanonicalURI=="undefined")return Q;const de=await(0,A.asPromise)(()=>X.getCanonicalURI(Q));return de||Q}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,$){return $===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(x=>this._activateByEvent(O,!1))}async $activate(O,$){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,$),!0):!1}async $deltaExtensions(O,$){O.forEach(X=>X.extensionLocation=I.URI.revive(X.extensionLocation));const x=await this.getExtensionPathIndex();return await Promise.all($.map(async X=>{const Q=this._registry.getExtensionDescription(X);Q&&x.delete(await this._realPathExtensionUri(Q.extensionLocation))})),await Promise.all(O.map(async X=>{const Q=await this._realPathExtensionUri(X.extensionLocation);x.set(Q,X)})),this._registry.deltaExtensions(O,$),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let $=r.VSBuffer.alloc(O),x=Math.random()%256;for(let X=0;X<O;X++)$.writeUInt8(x,X);return $}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};j=Ve([$e(0,s.IInstantiationService),$e(1,e.IHostUtils),$e(2,o.IExtHostRpcService),$e(3,w.IExtHostWorkspace),$e(4,a.IExtHostConfiguration),$e(5,i.ILogService),$e(6,n.IExtHostInitDataService),$e(7,u.IExtensionStoragePaths),$e(8,m.IExtHostTunnelService),$e(9,b.IExtHostTerminalService)],j),e.AbstractExtHostExtensionService=j;function U(z,O){return{id:z.identifier.value,name:z.name,extensionVersion:z.version,publisherDisplayName:z.publisher,activationEvents:z.activationEvents?z.activationEvents.join(","):null,isBuiltin:z.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class B{constructor(O,$,x,X){W.set(this,void 0),V.set(this,void 0),N.set(this,void 0),ot(this,W,O,"f"),ot(this,V,$,"f"),ot(this,N,x.identifier,"f"),this.id=x.identifier.value,this.extensionUri=x.extensionLocation,this.extensionPath=F.normalize((0,y.originalFSPath)(x.extensionLocation)),this.packageJSON=x,this.extensionKind=X}get isActive(){return Oe(this,W,"f").isActivated(Oe(this,N,"f"))}get exports(){if(this.packageJSON.api!=="none")return Oe(this,W,"f").getExtensionExports(Oe(this,N,"f"))}activate(){return Oe(this,W,"f").activateByIdWithErrors(Oe(this,N,"f"),{startup:!1,extensionId:Oe(this,V,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=B,W=new WeakMap,V=new WeakMap,N=new WeakMap}),define(fe[57],me([0,1,8,2,3,15,5,7,126,36,41,45,217,37,211,14,4,12,38,56]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d,w,D,T,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,D.createDecorator)("IExtHostDebugService");let r=class{constructor(l,m,b,f,P,L){this._workspaceService=m,this._extensionService=b,this._editorsService=f,this._configurationService=P,this._editorTabs=L,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new C.Emitter,this._onDidTerminateDebugSession=new C.Emitter,this._onDidChangeActiveDebugSession=new C.Emitter,this._onDidReceiveDebugSessionCustomEvent=new C.Emitter,this._debugServiceProxy=l.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new C.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(M=>{M.onDidChange(R=>{this.registerAllDebugTypes(M)}),this.registerAllDebugTypes(M)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(l,m){const b=l;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let f=`debug:${encodeURIComponent(b.path||"")}`,P="?";return m&&(f+=`${P}session=${encodeURIComponent(m.id)}`,P="&"),f+=`${P}ref=${b.sourceReference}`,F.URI.parse(f)}else{if(b.path)return F.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(l){const m=[];for(const b of l.getAllExtensionDescriptions())if(b.contributes){const f=b.contributes.debuggers;if(f&&f.length>0)for(const P of f)(0,d.isDebuggerMainContribution)(P)&&m.push(P.type)}this._debugServiceProxy.$registerDebugTypes(m)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const l=[];return this._breakpoints.forEach(m=>l.push(m)),l}addBreakpoints(l){this.startBreakpoints();const m=l.filter(P=>{const L=P.id;return this._breakpoints.has(L)?!1:(this._breakpoints.set(L,P),!0)});this.fireBreakpointChanges(m,[],[]);const b=[],f=new Map;for(const P of m)if(P instanceof _.SourceBreakpoint){let L=f.get(P.location.uri.toString());L||(L={type:"sourceMulti",uri:P.location.uri,lines:[]},f.set(P.location.uri.toString(),L),b.push(L)),L.lines.push({id:P.id,enabled:P.enabled,condition:P.condition,hitCondition:P.hitCondition,logMessage:P.logMessage,line:P.location.range.start.line,character:P.location.range.start.character})}else P instanceof _.FunctionBreakpoint&&b.push({type:"function",id:P.id,enabled:P.enabled,hitCondition:P.hitCondition,logMessage:P.logMessage,condition:P.condition,functionName:P.functionName});return this._debugServiceProxy.$registerBreakpoints(b)}removeBreakpoints(l){this.startBreakpoints();const m=l.filter(L=>this._breakpoints.delete(L.id));this.fireBreakpointChanges([],m,[]);const b=m.filter(L=>L instanceof _.SourceBreakpoint).map(L=>L.id),f=m.filter(L=>L instanceof _.FunctionBreakpoint).map(L=>L.id),P=m.filter(L=>L instanceof _.DataBreakpoint).map(L=>L.id);return this._debugServiceProxy.$unregisterBreakpoints(b,f,P)}startDebugging(l,m,b){return this._debugServiceProxy.$startDebugging(l?l.uri:void 0,m,{parentSessionID:b.parentSession?b.parentSession.id:void 0,lifecycleManagedByParent:b.lifecycleManagedByParent,repl:b.consoleMode===_.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact,debugUI:b.debugUI,suppressSaveBeforeStart:b.suppressSaveBeforeStart})}stopDebugging(l){return this._debugServiceProxy.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,m,b){if(!m)return new _.Disposable(()=>{});const f=this._configProviderHandleCounter++;return this._configProviders.push({type:l,handle:f,provider:m}),this._debugServiceProxy.$registerDebugConfigurationProvider(l,b,!!m.provideDebugConfigurations,!!m.resolveDebugConfiguration,!!m.resolveDebugConfigurationWithSubstitutedVariables,f),new _.Disposable(()=>{this._configProviders=this._configProviders.filter(P=>P.provider!==m),this._debugServiceProxy.$unregisterDebugConfigurationProvider(f)})}registerDebugAdapterDescriptorFactory(l,m,b){if(!b)return new _.Disposable(()=>{});if(!this.definesDebugType(l,m))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${m}' debugger.`);if(this.getAdapterDescriptorFactoryByType(m))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const f=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:m,handle:f,factory:b}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(m,f),new _.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(P=>P.factory!==b),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(f)})}registerDebugAdapterTrackerFactory(l,m){if(!m)return new _.Disposable(()=>{});const b=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:l,handle:b,factory:m}),new _.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(f=>f.factory!==m)})}async $runInTerminal(l,m){return Promise.resolve(void 0)}async $substituteVariables(l,m){if(!this._variableResolver){const[P,L]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(P||[],this._editorsService,L)}let b;const f=await this.getFolder(l);return f&&(b={uri:f.uri,name:f.name,index:f.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(b,m)}createDebugAdapter(l,m){if(l.type==="implementation")return new n(l.implementation)}createSignService(){}async $startDASession(l,m){const b=this,f=await this.getSession(m);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(f.type),f).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}' (extension might have failed to activate)`);const L=this.convertToDto(P),M=this.createDebugAdapter(L,f);if(!M)throw new Error(`Couldn't create a debug adapter for type '${f.type}'.`);const R=M;return this._debugAdapters.set(l,R),this.getDebugAdapterTrackers(f).then(W=>(W&&this._debugAdaptersTrackers.set(l,W),R.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const N=V,j={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const U=await this._signService.sign(N.arguments.value);j.body={signature:U},R.sendResponse(j)}else throw new Error("no signer")}catch(U){j.success=!1,j.message=U.message,R.sendResponse(j)}}else W&&W.onDidSendMessage&&W.onDidSendMessage(V),V=(0,d.convertToVSCPaths)(V,!0),b._debugServiceProxy.$acceptDAMessage(l,V)}),R.onError(V=>{W&&W.onError&&W.onError(V),this._debugServiceProxy.$acceptDAError(l,V.name,V.message,V.stack)}),R.onExit(V=>{W&&W.onExit&&W.onExit((0,T.withNullAsUndefined)(V),void 0),this._debugServiceProxy.$acceptDAExit(l,(0,T.withNullAsUndefined)(V),void 0)}),W&&W.onWillStartSession&&W.onWillStartSession(),R.startSession()))})}$sendDAMessage(l,m){m=(0,d.convertToDAPaths)(m,!1);const b=this._debugAdaptersTrackers.get(l);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(m);const f=this._debugAdapters.get(l);f&&f.sendMessage(m)}$stopDASession(l){const m=this._debugAdaptersTrackers.get(l);this._debugAdaptersTrackers.delete(l),m&&m.onWillStopSession&&m.onWillStopSession();const b=this._debugAdapters.get(l);return this._debugAdapters.delete(l),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const m=[],b=[],f=[];if(l.added)for(const P of l.added){const L=P.id;if(L&&!this._breakpoints.has(L)){let M;if(P.type==="function")M=new _.FunctionBreakpoint(P.functionName,P.enabled,P.condition,P.hitCondition,P.logMessage);else if(P.type==="data")M=new _.DataBreakpoint(P.label,P.dataId,P.canPersist,P.enabled,P.hitCondition,P.condition,P.logMessage);else{const R=F.URI.revive(P.uri);M=new _.SourceBreakpoint(new _.Location(R,new _.Position(P.line,P.character)),P.enabled,P.condition,P.hitCondition,P.logMessage)}M._id=L,this._breakpoints.set(L,M),m.push(M)}}if(l.removed)for(const P of l.removed){const L=this._breakpoints.get(P);L&&(this._breakpoints.delete(P),b.push(L))}if(l.changed){for(const P of l.changed)if(P.id){const L=this._breakpoints.get(P.id);if(L){if(L instanceof _.FunctionBreakpoint&&P.type==="function"){const M=L;M.enabled=P.enabled,M.condition=P.condition,M.hitCondition=P.hitCondition,M.logMessage=P.logMessage,M.functionName=P.functionName}else if(L instanceof _.SourceBreakpoint&&P.type==="source"){const M=L;M.enabled=P.enabled,M.condition=P.condition,M.hitCondition=P.hitCondition,M.logMessage=P.logMessage,M.location=new _.Location(F.URI.revive(P.uri),new _.Position(P.line,P.character))}f.push(L)}}}this.fireBreakpointChanges(m,b,f)}$provideDebugConfigurations(l,m,b){return(0,y.asPromise)(async()=>{const f=this.getConfigProviderByHandle(l);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const P=await this.getFolder(m);return f.provideDebugConfigurations(P,b)}).then(f=>{if(!f)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return f})}$resolveDebugConfiguration(l,m,b,f){return(0,y.asPromise)(async()=>{const P=this.getConfigProviderByHandle(l);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.getFolder(m);return P.resolveDebugConfiguration(L,b,f)})}$resolveDebugConfigurationWithSubstitutedVariables(l,m,b,f){return(0,y.asPromise)(async()=>{const P=this.getConfigProviderByHandle(l);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.getFolder(m);return P.resolveDebugConfigurationWithSubstitutedVariables(L,b,f)})}async $provideDebugAdapter(l,m){const b=this.getAdapterDescriptorFactoryByHandle(l);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const f=await this.getSession(m);return this.getAdapterDescriptor(b,f).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}'`);return this.convertToDto(P)})}async $acceptDebugSessionStarted(l){const m=await this.getSession(l);this._onDidStartDebugSession.fire(m)}async $acceptDebugSessionTerminated(l){const m=await this.getSession(l);m&&(this._onDidTerminateDebugSession.fire(m),this._debugSessions.delete(m.id))}async $acceptDebugSessionActiveChanged(l){this._activeDebugSession=l?await this.getSession(l):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(l,m){const b=await this.getSession(l);b&&b._acceptNameChanged(m)}async $acceptDebugSessionCustomEvent(l,m){const f={session:await this.getSession(l),event:m.event,body:m.body};this._onDidReceiveDebugSessionCustomEvent.fire(f)}convertToDto(l){if(l instanceof _.DebugAdapterExecutable)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof _.DebugAdapterServer)return{type:"server",port:l.port,host:l.host};if(l instanceof _.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:l.path};if(l instanceof _.DebugAdapterInlineImplementation)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(l){const m=this._adapterFactories.filter(b=>b.type===l);if(m.length>0)return m[0].factory}getAdapterDescriptorFactoryByHandle(l){const m=this._adapterFactories.filter(b=>b.handle===l);if(m.length>0)return m[0].factory}getConfigProviderByHandle(l){const m=this._configProviders.filter(b=>b.handle===l);if(m.length>0)return m[0].provider}definesDebugType(l,m){if(l.contributes){const b=l.contributes.debuggers;if(b&&b.length>0){for(const f of b)if(f.label&&f.type&&f.type===m)return!0}}return!1}getDebugAdapterTrackers(l){const b=l.configuration.type,f=this._trackerFactories.filter(P=>P.type===b||P.type==="*").map(P=>(0,y.asPromise)(()=>P.factory.createDebugAdapterTracker(l)).then(L=>L,L=>null));return Promise.race([Promise.all(f).then(P=>{const L=P.filter(M=>!!M);if(L.length>0)return new s(L)}),new Promise((P,L)=>{const M=setTimeout(()=>{clearTimeout(M),L(new Error("timeout"))},1e3)})]).catch(P=>{})}async getAdapterDescriptor(l,m){const b=m.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new _.DebugAdapterServer(b));if(l){const P=await this._extensionService.getExtensionRegistry();return(0,y.asPromise)(()=>l.createDebugAdapterDescriptor(m,this.daExecutableFromPackage(m,P))).then(L=>{if(L)return L})}const f=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(m,f))}daExecutableFromPackage(l,m){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(l,m,b){(l.length>0||m.length>0||b.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:l,removed:m,changed:b}))}async getSession(l){if(l)if(typeof l=="string"){const m=this._debugSessions.get(l);if(m)return m}else{let m=this._debugSessions.get(l.id);if(!m){const b=await this.getFolder(l.folderUri),f=l.parent?this._debugSessions.get(l.parent):void 0;m=new v(this._debugServiceProxy,l.id,l.type,l.name,b,l.configuration,f),this._debugSessions.set(m.id,m),this._debugServiceProxy.$sessionCached(m.id)}return m}throw new Error("cannot find session")}getFolder(l){if(l){const m=F.URI.revive(l);return this._workspaceService.resolveWorkspaceFolder(m)}return Promise.resolve(void 0)}};r=Ve([$e(0,w.IExtHostRpcService),$e(1,I.IExtHostWorkspace),$e(2,i.IExtHostExtensionService),$e(3,k.IExtHostDocumentsAndEditors),$e(4,g.IExtHostConfiguration),$e(5,c.IExtHostEditorTabs)],r),e.ExtHostDebugServiceBase=r;class v{constructor(l,m,b,f,P,L,M){this._debugServiceProxy=l,this._id=m,this._type=b,this._name=f,this._workspaceFolder=P,this._configuration=L,this._parentSession=M}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(l){this._name=l,this._debugServiceProxy.$setDebugSessionName(this._id,l)}get parentSession(){return this._parentSession}_acceptNameChanged(l){this._name=l}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(l,m){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,l,m)}getDebugProtocolBreakpoint(l){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,l.id)}}e.ExtHostDebugSession=v;class t{constructor(l){this.value=Object.freeze({append(m){l.$appendDebugConsole(m)},appendLine(m){this.append(m+`
`)}})}}e.ExtHostDebugConsole=t;class h extends a.AbstractVariableResolverService{constructor(l,m,b,f,P){function L(){if(m){const M=m.activeEditor();if(M)return M.document.uri;const R=f.tabs.filter(W=>W.isActive);if(R.length>0){const W=R[0].resource;return W&&(W.primary||W.secondary)?W.primary??W.secondary:R[0].resource}}}super({getFolderUri:M=>{const R=l.filter(W=>W.name===M);if(R&&R.length>0)return R[0].uri},getWorkspaceFolderCount:()=>l.length,getConfigurationValue:(M,R)=>b.getConfiguration(void 0,M).get(R),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{const M=L();if(M)return p.normalize(M.fsPath)},getWorkspaceFolderPathForFile:()=>{if(P){const M=L();if(M){const R=P.getWorkspaceFolder(M);if(R)return p.normalize(R.uri.fsPath)}}},getSelectedText:()=>{if(m){const M=m.activeEditor();if(M&&!M.selection.isEmpty)return M.document.getText(M.selection)}},getLineNumber:()=>{if(m){const M=m.activeEditor();if(M)return String(M.selection.end.line+1)}}},void 0,Promise.resolve(E.env))}}e.ExtHostVariableResolverService=h;class s{constructor(l){this.trackers=l}onWillStartSession(){this.trackers.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.trackers.forEach(m=>m.onWillReceiveMessage?m.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.trackers.forEach(m=>m.onDidSendMessage?m.onDidSendMessage(l):void 0)}onWillStopSession(){this.trackers.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.trackers.forEach(m=>m.onError?m.onError(l):void 0)}onExit(l,m){this.trackers.forEach(b=>b.onExit?b.onExit(l,m):void 0)}}class n extends S.AbstractDebugAdapter{constructor(l){super();this.implementation=l,l.onDidSendMessage(m=>{this.acceptMessage(m)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.implementation.handleMessage(l)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let u=class extends r{constructor(l,m,b,f,P,L){super(l,m,b,f,P,L)}createVariableResolver(l,m,b){return new h(l,m,b,this._editorTabs)}};u=Ve([$e(0,w.IExtHostRpcService),$e(1,I.IExtHostWorkspace),$e(2,i.IExtHostExtensionService),$e(3,k.IExtHostDocumentsAndEditors),$e(4,g.IExtHostConfiguration),$e(5,c.IExtHostEditorTabs)],u),e.WorkerExtHostDebugService=u}),define(fe[271],me([0,1,74,2,5,37,35,26,14,27,4,41,38,13]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=class{constructor(c,r,v,t,h,s,n){this._apiFactory=c,this._extensionRegistry=r,this._instaService=v,this._extHostConfiguration=t,this._extHostExtensionService=h,this._initData=s,this._logService=n,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),p.mark("code/extHost/willWaitForConfig");const c=await this._extHostConfiguration.getConfigProvider();p.mark("code/extHost/didWaitForConfig");const r=await this._extHostExtensionService.getExtensionPathIndex();this.register(new w(this._apiFactory,r,this._extensionRegistry,c,this._logService)),this.register(this._instaService.createInstance(D)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(T,r,this._initData.environment.appUriScheme))}register(c){if(Array.isArray(c.nodeModuleName))for(let r of c.nodeModuleName)this._factories.set(r,c);else this._factories.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this._alternatives.push(r=>c.alternativeModuleName(r))}};d=Ve([$e(2,i.IInstantiationService),$e(3,y.IExtHostConfiguration),$e(4,k.IExtHostExtensionService),$e(5,I.IExtHostInitDataService),$e(6,g.ILogService)],d),e.RequireInterceptor=d;class w{constructor(c,r,v,t,h){this._apiFactory=c,this._extensionPaths=r,this._extensionRegistry=v,this._configProvider=t,this._logService=h,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(c,r){const v=this._extensionPaths.findSubstr(r);if(v){let t=this._extApiImpl.get(_.ExtensionIdentifier.toKey(v.identifier));return t||(t=this._apiFactory(v,this._extensionRegistry,this._configProvider),this._extApiImpl.set(_.ExtensionIdentifier.toKey(v.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((h,s)=>t+=`	${s} -> ${h.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let D=class{constructor(c,r){this.nodeModuleName="keytar";const{environment:v}=r,t=c.getProxy(C.MainContext.MainThreadKeytar);if(v.appRoot){let h=v.appRoot.fsPath;a.platform==="win32"&&(h=h.replace(/\\/g,"/")),h[h.length-1]==="/"&&(h=h.substr(0,h.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${h}/node_modules.asar/keytar`),this.alternativeNames.add(`${h}/node_modules/keytar`)}this._impl={getPassword:(h,s)=>t.$getPassword(h,s),setPassword:(h,s,n)=>t.$setPassword(h,s,n),deletePassword:(h,s)=>t.$deletePassword(h,s),findPassword:h=>t.$findPassword(h),findCredentials(h){return t.$findCredentials(h)}}}load(c,r){return this._impl}alternativeModuleName(c){const r=c.length;if(r<=7||!this.alternativeNames)return;const v=r-7;if((c.charAt(v)==="/"||c.charAt(v)==="\\")&&c.endsWith("keytar")&&(c=c.replace(/\\/g,"/"),this.alternativeNames.has(c)))return"keytar"}};D=Ve([$e(0,S.IExtHostRpcService),$e(1,I.IExtHostInitDataService)],D);let T=class{constructor(c,r,v){this._extensionPaths=c,this._appUriScheme=r,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=v.getProxy(C.MainContext.MainThreadTelemetry);const t=v.getProxy(C.MainContext.MainThreadWindow);this._impl=(h,s)=>{const n=F.URI.parse(h);return s?this.callOriginal(h,s):n.scheme==="http"||n.scheme==="https"?t.$openUri(n,h,{allowTunneling:!0}):n.scheme==="mailto"||n.scheme===this._appUriScheme?t.$openUri(n,h,{}):this.callOriginal(h,s)}}load(c,r,v){const t=this._extensionPaths.findSubstr(r);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=v(c),this._impl}callOriginal(c,r){return this.sendNoForwardTelemetry(),this._original(c,r)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};T=Ve([$e(2,S.IExtHostRpcService)],T)}),define(fe[272],me([0,1,172,11,7,212,36,41,45,37,33,14,57,196,15,213,56]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let T=class extends a.ExtHostDebugServiceBase{constructor(r,v,t,h,s,n,u){super(r,v,t,h,s,u);this._terminalService=n,this._integratedTerminalInstances=new E}createDebugAdapter(r,v){switch(r.type){case"server":return new y.SocketDebugAdapter(r);case"pipeServer":return new y.NamedPipeDebugAdapter(r);case"executable":return new y.ExecutableDebugAdapter(r,v.type)}return super.createDebugAdapter(r,v)}daExecutableFromPackage(r,v){const t=y.ExecutableDebugAdapter.platformAdapterExecutable(v.getAllExtensionDescriptions(),r.type);if(t)return new C.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new g.SignService}async $runInTerminal(r,v){if(r.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(L=>{this._integratedTerminalInstances.onTerminalClosed(L)}));const t=await this._configurationService.getConfigProvider(),h=this._terminalService.getDefaultShell(!0),s=this._terminalService.getDefaultShellArgs(!0),n=r.title||p.localize(0,null),u=JSON.stringify({shell:h,shellArgs:s});let o=await this._integratedTerminalInstances.checkout(u,n),l,m=!1;if(o)l=r.cwd;else{const L={shellPath:h,shellArgs:s,cwd:r.cwd,name:n,iconPath:new C.ThemeIcon("debug")};m=!0,o=this._terminalService.createTerminalFromOptions(L,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(o,u)}o.show(!0);const b=await o.processId;m?await new Promise(L=>setTimeout(L,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(h.indexOf("powershell")>=0||h.indexOf("pwsh")>=0||h.indexOf("cmd.exe")>=0?o.sendText("cls"):h.indexOf("bash")>=0?o.sendText("clear"):F.isWindows?o.sendText("cls"):o.sendText("clear"));const f=(0,w.prepareCommand)(h,r.args,l,r.env);o.sendText(f);const P=this.onDidTerminateDebugSession(L=>{L.id===v&&(this._integratedTerminalInstances.free(o),P.dispose())});return b}else if(r.kind==="external")return(0,w.runInExternalTerminal)(r,await this._configurationService.getConfigProvider());return super.$runInTerminal(r,v)}createVariableResolver(r,v,t){return new a.ExtHostVariableResolverService(r,v,t,this._editorTabs,this._workspaceService)}};T=Ve([$e(0,k.IExtHostRpcService),$e(1,A.IExtHostWorkspace),$e(2,_.IExtHostExtensionService),$e(3,S.IExtHostDocumentsAndEditors),$e(4,I.IExtHostConfiguration),$e(5,i.IExtHostTerminalService),$e(6,D.IExtHostEditorTabs)],T),e.ExtHostDebugService=T;class E{constructor(){this._terminalInstances=new Map}async checkout(r,v){const h=[...this._terminalInstances.entries()].map(([s,n])=>(0,d.createCancelablePromise)(async u=>{if(s.name!==v||n.lastUsedAt!==-1&&await(0,w.hasChildProcesses)(await s.processId))return null;const o=Date.now();return n.lastUsedAt+E.minUseDelay>o||u.isCancellationRequested||n.config!==r?null:(n.lastUsedAt=o,s)}));return await(0,d.firstParallel)(h,s=>!!s)}insert(r,v){this._terminalInstances.set(r,{lastUsedAt:Date.now(),config:v})}free(r){const v=this._terminalInstances.get(r);v&&(v.lastUsedAt=-1)}onTerminalClosed(r){this._terminalInstances.delete(r)}}E.minUseDelay=1e3}),define(fe[273],me([0,1,8,2,114,36,57,45,37,44,33,14,27,73,10,13,68,56,23,81]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d,w,D,T,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let r=class extends g.ExtHostTaskBase{constructor(t,h,s,n,u,o,l,m,b){super(t,h,s,n,u,o,l,m);this.workspaceService=s,this.editorTabs=b,h.remote.isRemote&&h.remote.authority?this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:h.remote.authority,platform:process.platform}):this.registerTaskSystem(d.Schemas.file,{scheme:d.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,h){const s=h;if(!h.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const n=g.TaskHandleDTO.from(s,this.workspaceService),u=await this._proxy.$getTaskExecution(n);if(u.task===void 0)throw new Error("Task from execution DTO is undefined");const o=await this.getTaskExecution(u,h);return this._proxy.$executeTask(n).catch(()=>{}),o}else{const n=g.TaskDTO.from(h,t);if(n===void 0)return Promise.reject(new Error("Task is not valid"));g.CustomExecutionDTO.is(n.execution)&&await this.addCustomExecution(n,h,!1);const u=await this.getTaskExecution(await this._proxy.$getTaskExecution(n),h);return this._proxy.$executeTask(n).catch(()=>{}),u}}provideTasksInternal(t,h,s,n){const u=[];if(n)for(let o of n){this.checkDeprecation(o,s),(!o.definition||!t[o.definition.type])&&this._logService.warn(`The task [${o.source}, ${o.name}] uses an undefined task type. The task will be ignored in the future.`);const l=g.TaskDTO.from(o,s.extension);l&&(u.push(l),g.CustomExecutionDTO.is(l.execution)&&h.push(this.addCustomExecution(l,o,!0)))}return{tasks:u,extension:s.extension}}async resolveTaskInternal(t){return t}async getVariableResolver(t){if(this._variableResolver===void 0){const h=await this._configurationService.getConfigProvider();this._variableResolver=new A.ExtHostVariableResolverService(t,this._editorService,h,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(t){let h=t&&t.length>0?t[0]:void 0;if(!h){const s=F.URI.file((0,c.homedir)());h=new I.WorkspaceFolder({uri:s,name:E.basename(s),index:0})}return{uri:h.uri,name:h.name,index:h.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,h){const s=F.URI.revive(t),n={process:void 0,variables:Object.create(null)},u=await this._workspaceProvider.resolveWorkspaceFolder(s),o=await this._workspaceProvider.getWorkspaceFolders2()??[],l=await this.getVariableResolver(o),m=u?{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(o);for(let b of h.variables)n.variables[b]=await l.resolveAsync(m,b);if(h.process!==void 0){let b;if(h.process.path!==void 0){b=h.process.path.split(p.delimiter);for(let f=0;f<b.length;f++)b[f]=await l.resolveAsync(m,b[f])}n.process=await C.win32.findExecutable(await l.resolveAsync(m,h.process.name),h.process.cwd!==void 0?await l.resolveAsync(m,h.process.cwd):void 0,b)}return n}async $jsonTasksSupported(){return!0}async $findExecutable(t,h,s){return C.win32.findExecutable(t,h,s)}};r=Ve([$e(0,k.IExtHostRpcService),$e(1,a.IExtHostInitDataService),$e(2,y.IExtHostWorkspace),$e(3,_.IExtHostDocumentsAndEditors),$e(4,S.IExtHostConfiguration),$e(5,i.IExtHostTerminalService),$e(6,w.ILogService),$e(7,D.IExtHostApiDeprecationService),$e(8,T.IExtHostEditorTabs)],r),e.ExtHostTask=r}),define(fe[274],me([0,1,15,17,74,6,2,5,266,13,83,85,27,190,14,67,41,33]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d,w,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(r,v,t,h){this._disposables=new y.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new S.RPCProtocol(r,null,h),v=E._transform(v,this._rpcProtocol);const s=new k.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());s.set(a.IExtHostInitDataService,{_serviceBrand:void 0,...v}),s.set(d.IExtHostRpcService,new d.ExtHostRpcService(this._rpcProtocol)),s.set(w.IURITransformerService,new w.URITransformerService(h)),s.set(D.IHostUtils,t);const n=new g.InstantiationService(s,!0),u=n.invokeFunction(b=>b.get(T.IExtHostTerminalService));this._disposables.add(u),this._logService=n.invokeFunction(b=>b.get(I.ILogService)),C.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",v),this._extensionService=n.invokeFunction(b=>b.get(D.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const o=new WeakMap;this._extensionService.getExtensionPathIndex().then(b=>{Error.prepareStackTrace=(f,P)=>{let L="",M,R;for(const W of P)L+=`
	at ${W.toString()}`,R=W.getFileName(),!M&&R&&(M=b.findSubstr(A.URI.file(R)));return o.set(f,M),`${f.name||"Error"}: ${f.message||""}${L}`}});const l=this._rpcProtocol.getProxy(_.MainContext.MainThreadExtensionService),m=this._rpcProtocol.getProxy(_.MainContext.MainThreadErrors);F.setUnexpectedErrorHandler(b=>{const f=F.transformErrorForSerialization(b),P=o.get(b);P?l.$onExtensionRuntimeError(P.identifier,f):m.$onUnexpectedError(f)})}terminate(r){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${r}`),this._logService.flush(),this._disposables.dispose(),F.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const v=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,p.timeout)(4e3),v]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(r,v){r.extensions.forEach(h=>h.extensionLocation=A.URI.revive(v.transformIncomingURIs(h.extensionLocation))),r.environment.appRoot=A.URI.revive(v.transformIncomingURIs(r.environment.appRoot));const t=r.environment.extensionDevelopmentLocationURI;return t&&(r.environment.extensionDevelopmentLocationURI=t.map(h=>A.URI.revive(v.transformIncomingURIs(h)))),r.environment.extensionTestsLocationURI=A.URI.revive(v.transformIncomingURIs(r.environment.extensionTestsLocationURI)),r.environment.globalStorageHome=A.URI.revive(v.transformIncomingURIs(r.environment.globalStorageHome)),r.environment.workspaceStorageHome=A.URI.revive(v.transformIncomingURIs(r.environment.workspaceStorageHome)),r.logsLocation=A.URI.revive(v.transformIncomingURIs(r.logsLocation)),r.logFile=A.URI.revive(v.transformIncomingURIs(r.logFile)),r.workspace=v.transformIncomingURIs(r.workspace),r}}e.ExtensionHostMain=E}),define(fe[275],me([0,1,8,21,52,30,23,46,31]),function(Y,e,p,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class I{constructor(a,g,d){this.config=a,this.provider=g,this.sessionToken=d,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=a.filePattern,this.includePattern=a.includePattern&&y.parse(a.includePattern),this.maxResults=a.maxResults||void 0,this.exists=a.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=a.excludePattern&&y.parse(a.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(a=>a.cancel()),this.activeCancellationTokens=new Set}search(a){const g=this.config.folderQueries||[];return new Promise((d,w)=>{const D=T=>{this.resultCount++,a(T)};if(this.isCanceled)return d({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(T=>{const E=T.toString(),c=p.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,c)||this.matchFile(D,{base:T,basename:c})}),Promise.all(g.map(T=>this.searchInFolder(T,D))).then(T=>{d({limitHit:this.isLimitHit,stats:T[0]||void 0})},T=>{w(new Error((0,C.toErrorMessage)(T)))})})}async searchInFolder(a,g){const d=new F.CancellationTokenSource,w=this.getSearchOptionsForFolder(a),D=this.initDirectoryTree(),T=new S.QueryGlobTester(this.config,a),E=!T.hasSiblingExcludeClauses();let c;try{this.activeCancellationTokens.add(d),c=_.StopWatch.create();const r=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},w,d.token),v=c.elapsed(),t=_.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(r&&r.forEach(h=>{const s=p.posix.relative(a.folder.path,h.path);if(E){const n=p.basename(h.path);this.matchFile(g,{base:a.folder,relativePath:s,basename:n});return}this.addDirectoryEntries(D,a.folder,s,g)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(D,T,g),{providerTime:v,postProcessTime:t.elapsed()})}finally{d.dispose(),this.activeCancellationTokens.delete(d)}}getSearchOptionsForFolder(a){const g=(0,S.resolvePatternsForProvider)(this.config.includePattern,a.includePattern),d=(0,S.resolvePatternsForProvider)(this.config.excludePattern,a.excludePattern);return{folder:a.folder,excludes:d,includes:g,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}addDirectoryEntries({pathToEntries:a},g,d,w){if(d===this.filePattern){const T=p.basename(this.filePattern);this.matchFile(w,{base:g,relativePath:this.filePattern,basename:T})}function D(T){const E=p.basename(T),c=p.dirname(T);let r=a[c];r||(r=a[c]=[],D(c)),r.push({base:g,relativePath:T,basename:E})}D(d)}matchDirectoryTree({rootEntries:a,pathToEntries:g},d,w){const D=this,T=this.filePattern;function E(c){const r=y.hasSiblingFn(()=>c.map(v=>v.basename));for(let v=0,t=c.length;v<t;v++){const h=c[v],{relativePath:s,basename:n}=h;if(d.matchesExcludesSync(s,n,T!==n?r:void 0))continue;const u=g[s];if(u)E(u);else{if(s===T)continue;D.matchFile(w,h)}if(D.isLimitHit)break}}E(a)}matchFile(a,g){(!this.includePattern||g.relativePath&&this.includePattern(g.relativePath,g.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||a(g))}}class i{constructor(){this.sessions=new Map}fileSearch(a,g,d,w){const D=this.getSessionTokenSource(a.cacheKey),T=new I(a,g,D&&D.token);let E=0;const c=r=>{E+=r.length,d(r.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(T,i.BATCH_SIZE,c,w).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:r.stats}}))}clearCache(a){const g=this.getSessionTokenSource(a);g&&g.cancel()}getSessionTokenSource(a){if(!!a)return this.sessions.has(a)||this.sessions.set(a,new F.CancellationTokenSource),this.sessions.get(a)}rawMatchToSearchItem(a){return a.relativePath?{resource:A.joinPath(a.base,a.relativePath)}:{resource:a.base}}doSearch(a,g,d,w){w.onCancellationRequested(()=>{a.cancel()});const D=E=>{E&&(T.push(E),g>0&&T.length>=g&&(d(T),T=[]))};let T=[];return a.search(D).then(E=>(T.length&&d(T),E),E=>(T.length&&d(T),Promise.reject(E)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(fe[135],me([0,1,18,21,52,30,10,8,23,12,2,31]),function(Y,e,p,F,C,y,A,_,S,I,i,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class a{constructor(c,r,v,t){this.query=c,this.provider=r,this.fileUtils=v,this.processType=t,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(c,r){const v=this.query.folderQueries||[],t=new F.CancellationTokenSource;return r.onCancellationRequested(()=>t.cancel()),new Promise((h,s)=>{this.collector=new d(c);let n=!1;const u=(o,l)=>{if(!n&&!this.isLimitHit){const m=this.resultSize(o);D(o)&&typeof this.query.maxResults=="number"&&this.resultCount+m>this.query.maxResults&&(this.isLimitHit=!0,n=!0,t.cancel(),o=this.trimResultToSize(o,this.query.maxResults-this.resultCount));const b=this.resultSize(o);this.resultCount+=b,(b>0||!D(o))&&this.collector.add(o,l)}};Promise.all(v.map((o,l)=>this.searchInFolder(o,m=>u(m,l),t.token))).then(o=>{t.dispose(),this.collector.flush();const l=o.some(m=>!!m&&!!m.limitHit);h({limitHit:this.isLimitHit||l,messages:(0,p.flatten)(o.map(m=>m?.message?(0,I.isArray)(m.message)?m.message:[m.message]:[])),stats:{type:this.processType}})},o=>{t.dispose();const l=(0,C.toErrorMessage)(o);s(new Error(l))})})}resultSize(c){return D(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}trimResultToSize(c,r){const v=Array.isArray(c.ranges)?c.ranges:[c.ranges],t=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:v.slice(0,r),preview:{matches:t.slice(0,r),text:c.preview.text},uri:c.uri}}async searchInFolder(c,r,v){const t=new k.QueryGlobTester(this.query,c),h=[],s={report:o=>{if(!this.validateProviderResult(o))return;const l=c.folder.scheme===A.Schemas.file?y.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(o.uri))):void 0,m=S.relativePath(c.folder,o.uri);if(m){const b=t.includedInQuery(m,_.basename(m),l);(0,I.isPromise)(b)?h.push(b.then(f=>{f&&r(o)})):b&&r(o)}}},n=this.getSearchOptionsForFolder(c),u=await this.provider.provideTextSearchResults(g(this.query.contentPattern),n,s,v);return h.length&&await Promise.all(h),u}validateProviderResult(c){if(D(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(c){const r=(0,k.resolvePatternsForProvider)(this.query.includePattern,c.includePattern),v=(0,k.resolvePatternsForProvider)(this.query.excludePattern,c.excludePattern),t={folder:i.URI.from(c.folder),excludes:v,includes:r,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.fileUtils.toCanonicalName(c.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=a;function g(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class d{constructor(c){this._onResult=c,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new T(512,r=>this.sendItems(r))}add(c,r){this._currentFileMatch&&(this._currentFolderIdx!==r||!S.isEqual(this._currentUri,c.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=r,this._currentFileMatch={resource:c.uri,results:[]}),this._currentFileMatch.results.push(w(c))}pushToCollector(){const c=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,c)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(c){this._onResult(c)}}e.TextSearchResultsCollector=d;function w(E){return D(E)?{preview:{matches:(0,p.mapArrayOrNot)(E.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:E.preview.text},ranges:(0,p.mapArrayOrNot)(E.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function D(E){return!!E.preview}e.extensionResultIsMatch=D;class T{constructor(c,r){this.maxBatchSize=c,this.cb=r,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(c,r){!c||this.addItemToBatch(c,r)}addItems(c,r){!c||this.addItemsToBatch(c,r)}addItemToBatch(c,r){this.batch.push(c),this.batchSize+=r,this.onUpdate()}addItemsToBatch(c,r){this.batch=this.batch.concat(c),this.batchSize+=r,this.onUpdate()}onUpdate(){this.totalNumberCompleted<T.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},T.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=T,T.TIMEOUT=4e3,T.START_BATCH_AFTER_COUNT=50}),define(fe[75],me([0,1,6,5,4,275,14,67,13,2,135]),function(Y,e,p,F,C,y,A,_,S,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,C.createDecorator)("IExtHostSearch");let k=class{constructor(w,D,T){this.extHostRpc=w,this._uriTransformer=D,this._logService=T,this._proxy=this.extHostRpc.getProxy(F.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new y.FileSearchManager}_transformScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}registerTextSearchProvider(w,D){if(this._textSearchUsedSchemes.has(w))throw new Error(`a text search provider for the scheme '${w}' is already registered`);this._textSearchUsedSchemes.add(w);const T=this._handlePool++;return this._textSearchProvider.set(T,D),this._proxy.$registerTextSearchProvider(T,this._transformScheme(w)),(0,p.toDisposable)(()=>{this._textSearchUsedSchemes.delete(w),this._textSearchProvider.delete(T),this._proxy.$unregisterProvider(T)})}registerFileSearchProvider(w,D){if(this._fileSearchUsedSchemes.has(w))throw new Error(`a file search provider for the scheme '${w}' is already registered`);this._fileSearchUsedSchemes.add(w);const T=this._handlePool++;return this._fileSearchProvider.set(T,D),this._proxy.$registerFileSearchProvider(T,this._transformScheme(w)),(0,p.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(w),this._fileSearchProvider.delete(T),this._proxy.$unregisterProvider(T)})}$provideFileSearchResults(w,D,T,E){const c=a(T),r=this._fileSearchProvider.get(w);if(r)return this._fileSearchManager.fileSearch(c,r,v=>{this._proxy.$handleFileMatch(w,D,v.map(t=>t.resource))},E);throw new Error("unknown provider: "+w)}$clearCache(w){return this._fileSearchManager.clearCache(w),Promise.resolve(void 0)}$provideTextSearchResults(w,D,T,E){const c=this._textSearchProvider.get(w);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${w}`);const r=a(T);return this.createTextSearchManager(r,c).search(t=>this._proxy.$handleTextMatch(w,D,t),E)}$enableExtensionHostSearch(){}createTextSearchManager(w,D){return new i.TextSearchManager(w,D,{readdir:T=>Promise.resolve([]),toCanonicalName:T=>T},"textSearchProvider")}};k=Ve([$e(0,A.IExtHostRpcService),$e(1,_.IURITransformerService),$e(2,S.ILogService)],k),e.ExtHostSearch=k;function a(d){return{...d,folderQueries:d.folderQueries&&d.folderQueries.map(g),extraFileResources:d.extraFileResources&&d.extraFileResources.map(w=>I.URI.revive(w))}}e.reviveQuery=a;function g(d){return{...d,folder:I.URI.revive(d.folder)}}}),define(fe[276],me([0,1,21,17,3,49,2,115,110,148,82,43,5,234,233,40,235,37,236,237,238,219,239,45,41,240,220,243,244,245,69,222,250,251,252,92,33,254,223,16,7,257,71,134,36,35,59,208,242,64,133,73,57,75,13,67,14,27,246,205,54,68,231,255,204,70,91,260,258,259,232,53,253,256,90,56,124,248,72,249,10,192,247,202,241]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d,w,D,T,E,c,r,v,t,h,s,n,u,o,l,m,b,f,P,L,M,R,W,V,N,j,U,B,z,O,$,x,X,Q,de,_e,ye,ke,xe,We,He,q,ee,re,le,Z,ae,pe,Me,je,Ke,Je,st,Te,nt,J,te,ve,Qe,tt,ct,ce,Ie,Ue,Xe,rt,ht,Ye,vt,Re,Ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Pe(se){const ue=se.get(re.IExtHostInitDataService),be=se.get(ve.IExtHostFileSystemInfo),we=se.get(st.IExtHostConsumerFileSystem),Fe=se.get(s.IExtHostExtensionService),qe=se.get($.IExtHostWorkspace),ze=se.get(Ie.IExtHostTelemetry),et=se.get(T.IExtHostConfiguration),at=se.get(q.IURITransformerService),Be=se.get(ee.IExtHostRpcService),ge=se.get(R.IExtHostStorage),Ee=se.get(Je.IExtensionStoragePaths),ne=se.get(He.ILogService),K=se.get(ae.IExtHostTunnelService),Se=se.get(pe.IExtHostApiDeprecationService),Le=se.get(O.IExtHostWindow),it=se.get(ct.IExtHostSecretState),Ge=se.get(ce.IExtHostEditorTabs);Be.set(a.ExtHostContext.ExtHostFileSystemInfo,be),Be.set(a.ExtHostContext.ExtHostLogService,ne),Be.set(a.ExtHostContext.ExtHostWorkspace,qe),Be.set(a.ExtHostContext.ExtHostConfiguration,et),Be.set(a.ExtHostContext.ExtHostExtensionService,Fe),Be.set(a.ExtHostContext.ExtHostStorage,ge),Be.set(a.ExtHostContext.ExtHostTunnelService,K),Be.set(a.ExtHostContext.ExtHostWindow,Le),Be.set(a.ExtHostContext.ExtHostSecretState,it),Be.set(a.ExtHostContext.ExtHostTelemetry,ze),Be.set(a.ExtHostContext.ExtHostEditorTabs,Ge);const pt=Be.set(a.ExtHostContext.ExtHostDecorations,se.get(ye.IExtHostDecorations)),Et=Be.set(a.ExtHostContext.ExtHostDocumentsAndEditors,se.get(h.IExtHostDocumentsAndEditors)),ft=Be.set(a.ExtHostContext.ExtHostCommands,se.get(w.IExtHostCommands)),bt=Be.set(a.ExtHostContext.ExtHostTerminalService,se.get(W.IExtHostTerminalService)),mt=Be.set(a.ExtHostContext.ExtHostDebugService,se.get(xe.IExtHostDebugService)),_t=Be.set(a.ExtHostContext.ExtHostSearch,se.get(We.IExtHostSearch)),Dt=Be.set(a.ExtHostContext.ExtHostTask,se.get(ke.IExtHostTask)),xt=Be.set(a.ExtHostContext.ExtHostOutputService,se.get(b.IExtHostOutputService)),Vt=Be.set(a.ExtHostContext.ExtHostUrls,new B.ExtHostUrls(Be)),kt=Be.set(a.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(Be,Et)),$t=Be.set(a.ExtHostContext.ExtHostDocumentContentProviders,new r.ExtHostDocumentContentProvider(Be,Et,ne)),en=Be.set(a.ExtHostContext.ExtHostDocumentSaveParticipant,new v.ExtHostDocumentSaveParticipant(ne,kt,Be.getProxy(a.MainContext.MainThreadBulkEdits))),St=Be.set(a.ExtHostContext.ExtHostNotebook,new le.ExtHostNotebookController(Be,ft,Et,kt,Ee)),Qt=Be.set(a.ExtHostContext.ExtHostNotebookDocuments,new Re.ExtHostNotebookDocuments(ne,St)),jt=Be.set(a.ExtHostContext.ExtHostNotebookEditors,new vt.ExtHostNotebookEditors(ne,Be,St)),tn=Be.set(a.ExtHostContext.ExtHostNotebookKernels,new Ue.ExtHostNotebookKernels(Be,ue,St,ft,ne)),nn=Be.set(a.ExtHostContext.ExtHostNotebookRenderers,new rt.ExtHostNotebookRenderers(Be,St)),Tt=Be.set(a.ExtHostContext.ExtHostEditors,new V.ExtHostEditors(Be,Et)),Xt=Be.set(a.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(Be.getProxy(a.MainContext.MainThreadTreeViews),ft,ne)),bn=Be.set(a.ExtHostContext.ExtHostEditorInsets,new Q.ExtHostEditorInsets(Be.getProxy(a.MainContext.MainThreadEditorInsets),Tt,ue)),Wt=Be.set(a.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(Be,ne,be)),Ht=Be.set(a.ExtHostContext.ExtHostLanguages,new l.ExtHostLanguages(Be,kt,ft.converter,at)),wt=Be.set(a.ExtHostContext.ExtHostLanguageFeatures,new o.ExtHostLanguageFeatures(Be,at,kt,ft,Wt,ne,Se)),rn=Be.set(a.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(Be,wt)),Ot=Be.set(a.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(Be,ne,Et)),Nt=Be.set(a.ExtHostContext.ExtHostQuickOpen,(0,P.createExtHostQuickOpen)(Be,qe,ft)),Yt=Be.set(a.ExtHostContext.ExtHostSCM,new L.ExtHostSCM(Be,ft,ne)),En=Be.set(a.ExtHostContext.ExtHostComments,(0,D.createExtHostComments)(Be,ft,kt)),fn=Be.set(a.ExtHostContext.ExtHostProgress,new f.ExtHostProgress(Be.getProxy(a.MainContext.MainThreadProgress))),_n=Be.set(a.ExtHostContext.ExtHosLabelService,new de.ExtHostLabelService(Be)),mn=Be.set(a.ExtHostContext.ExtHostTheming,new Z.ExtHostTheming(Be)),sn=Be.set(a.ExtHostContext.ExtHostAuthentication,new Me.ExtHostAuthentication(Be)),on=Be.set(a.ExtHostContext.ExtHostTimeline,new je.ExtHostTimeline(Be,ft)),qt=Be.set(a.ExtHostContext.ExtHostWebviews,new z.ExtHostWebviews(Be,{remote:ue.remote},qe,ne,Se)),an=Be.set(a.ExtHostContext.ExtHostWebviewPanels,new J.ExtHostWebviewPanels(Be,qt,qe)),Sn=Be.set(a.ExtHostContext.ExtHostCustomEditors,new nt.ExtHostCustomEditors(Be,kt,Ee,qt,an)),yn=Be.set(a.ExtHostContext.ExtHostWebviewViews,new Te.ExtHostWebviewViews(Be,qt)),Gt=Be.set(a.ExtHostContext.ExtHostTesting,new Qe.ExtHostTesting(Be,ft)),Jt=Be.set(a.ExtHostContext.ExtHostUriOpeners,new tt.ExtHostUriOpeners(Be));Be.set(a.ExtHostContext.ExtHostInteractive,new Ce.ExtHostInteractive(Be,St,Et,ft));const Dn=(0,X.values)(a.ExtHostContext);Be.assertRegistered(Dn);const Cn=new te.ExtHostBulkEdits(Be,Et),ln=new d.ExtHostClipboard(Be),cn=new m.ExtHostMessageService(Be,ne),zt=new c.ExtHostDialogs(Be),Ft=new M.ExtHostStatusBar(Be,ft.converter);return g.ExtHostApiCommands.register(ft),function(Ne,Rt,Kt){const yt=function(){let ie=!Ne.isUnderDevelopment;function he(Ae){ie||(ne.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Ae(ut){if(Array.isArray(ut))ut.forEach(Ae);else if(typeof ut=="string")he(ut);else{const Ct=ut;typeof Ct.scheme=="undefined"&&he(ut),!Ne.enableProposedApi&&typeof Ct.exclusive=="boolean"&&(0,x.throwProposedApiError)(Ne)}return ut}}(),kn={getSession(ie,he,Ae){return Ae?.forceNewSession&&(0,x.checkProposedApiEnabled)(Ne),sn.getSession(Ne,ie,he,Ae)},get onDidChangeSessions(){return sn.onDidChangeSessions},registerAuthenticationProvider(ie,he,Ae,ut){return sn.registerAuthenticationProvider(ie,he,Ae,ut)}},In={registerCommand(ie,he,Ae){return ft.registerCommand(!0,ie,he,Ae,void 0,Ne)},registerTextEditorCommand(ie,he,Ae){return ft.registerCommand(!0,ie,(...ut)=>{const Ct=Tt.getActiveTextEditor();if(!Ct){ne.warn("Cannot execute "+ie+" because there is no active text editor.");return}return Ct.edit(Pt=>{he.apply(Ae,[Ct,Pt,...ut])}).then(Pt=>{Pt||ne.warn("Edits from command "+ie+" were not applied.")},Pt=>{ne.warn("An error occurred while running command "+ie,Pt)})},void 0,void 0,Ne)},registerDiffInformationCommand:(ie,he,Ae)=>((0,x.checkProposedApiEnabled)(Ne),ft.registerCommand(!0,ie,async(...ut)=>{const Ct=Et.activeEditor(!0);if(!Ct){ne.warn("Cannot execute "+ie+" because there is no active text editor.");return}const Pt=await Tt.getDiffInformation(Ct.id);he.apply(Ae,[Pt,...ut])},void 0,void 0,Ne)),executeCommand(ie,...he){return ft.executeCommand(ie,...he)},getCommands(ie=!1){return ft.getCommands(ie)}},gn={get machineId(){return ue.telemetryInfo.machineId},get sessionId(){return ue.telemetryInfo.sessionId},get language(){return ue.environment.appLanguage},get appName(){return ue.environment.appName},get appRoot(){return ue.environment.appRoot?.fsPath??""},get appHost(){return ue.environment.appHost},get uriScheme(){return ue.environment.appUriScheme},get clipboard(){return ln.value},get shell(){return bt.getDefaultShell(!1)},get isTelemetryEnabled(){return ze.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ze.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ie=Date.now()-new Date(ue.telemetryInfo.firstSessionDate).getTime();return isNaN(ie)?!1:ie<1e3*60*60*24},openExternal(ie,he){return Le.openUri(ie,{allowTunneling:!!ue.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===ue.environment.appUriScheme)return Vt.createAppUri(ie);try{return await Le.asExternalUri(ie,{allowTunneling:!!ue.remote.authority})}catch(he){if((0,Ye.matchesScheme)(ie,ht.Schemas.http)||(0,Ye.matchesScheme)(ie,ht.Schemas.https))return ie;throw he}},get remoteName(){return(0,_e.getRemoteName)(ue.remote.authority)},get remoteAuthority(){return(0,x.checkProposedApiEnabled)(Ne),ue.remote.authority},get uiKind(){return ue.uiKind}};ue.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=ue.remote.isRemote?U.ExtensionKind.Workspace:U.ExtensionKind.UI,Pn={createTestController(ie,he){return Gt.createTestController(ie,he)},createTestObserver(){return(0,x.checkProposedApiEnabled)(Ne),Gt.createTestObserver()},runTests(ie){return(0,x.checkProposedApiEnabled)(Ne),Gt.runTests(ie)},get onDidChangeTestResults(){return(0,x.checkProposedApiEnabled)(Ne),Gt.onResultsChanged},get testResults(){return(0,x.checkProposedApiEnabled)(Ne),Gt.results}},Tn={getExtension(ie){const he=Rt.getExtensionDescription(ie);if(he)return new s.Extension(Fe,Ne.identifier,he,pn)},get all(){return Rt.getAllExtensionDescriptions().map(ie=>new s.Extension(Fe,Ne.identifier,ie,pn))},get onDidChange(){return Rt.onDidChange}},un={createDiagnosticCollection(ie){return Wt.createDiagnosticCollection(Ne.identifier,ie)},get onDidChangeDiagnostics(){return Wt.onDidChangeDiagnostics},getDiagnostics:ie=>Wt.getDiagnostics(ie),getLanguages(){return Ht.getLanguages()},setTextDocumentLanguage(ie,he){return Ht.changeLanguage(ie.uri,he)},match(ie,he){return(0,i.score)(j.LanguageSelector.from(ie),he.uri,he.languageId,!0)},registerCodeActionsProvider(ie,he,Ae){return wt.registerCodeActionProvider(Ne,yt(ie),he,Ae)},registerCodeLensProvider(ie,he){return wt.registerCodeLensProvider(Ne,yt(ie),he)},registerDefinitionProvider(ie,he){return wt.registerDefinitionProvider(Ne,yt(ie),he)},registerDeclarationProvider(ie,he){return wt.registerDeclarationProvider(Ne,yt(ie),he)},registerImplementationProvider(ie,he){return wt.registerImplementationProvider(Ne,yt(ie),he)},registerTypeDefinitionProvider(ie,he){return wt.registerTypeDefinitionProvider(Ne,yt(ie),he)},registerHoverProvider(ie,he){return wt.registerHoverProvider(Ne,yt(ie),he,Ne.identifier)},registerEvaluatableExpressionProvider(ie,he){return wt.registerEvaluatableExpressionProvider(Ne,yt(ie),he,Ne.identifier)},registerInlineValuesProvider(ie,he){return wt.registerInlineValuesProvider(Ne,yt(ie),he,Ne.identifier)},registerDocumentHighlightProvider(ie,he){return wt.registerDocumentHighlightProvider(Ne,yt(ie),he)},registerLinkedEditingRangeProvider(ie,he){return wt.registerLinkedEditingRangeProvider(Ne,yt(ie),he)},registerReferenceProvider(ie,he){return wt.registerReferenceProvider(Ne,yt(ie),he)},registerRenameProvider(ie,he){return wt.registerRenameProvider(Ne,yt(ie),he)},registerDocumentSymbolProvider(ie,he,Ae){return wt.registerDocumentSymbolProvider(Ne,yt(ie),he,Ae)},registerWorkspaceSymbolProvider(ie){return wt.registerWorkspaceSymbolProvider(Ne,ie)},registerDocumentFormattingEditProvider(ie,he){return wt.registerDocumentFormattingEditProvider(Ne,yt(ie),he)},registerDocumentRangeFormattingEditProvider(ie,he){return wt.registerDocumentRangeFormattingEditProvider(Ne,yt(ie),he)},registerOnTypeFormattingEditProvider(ie,he,Ae,...ut){return wt.registerOnTypeFormattingEditProvider(Ne,yt(ie),he,[Ae].concat(ut))},registerDocumentSemanticTokensProvider(ie,he,Ae){return wt.registerDocumentSemanticTokensProvider(Ne,yt(ie),he,Ae)},registerDocumentRangeSemanticTokensProvider(ie,he,Ae){return wt.registerDocumentRangeSemanticTokensProvider(Ne,yt(ie),he,Ae)},registerSignatureHelpProvider(ie,he,Ae,...ut){return typeof Ae=="object"?wt.registerSignatureHelpProvider(Ne,yt(ie),he,Ae):wt.registerSignatureHelpProvider(Ne,yt(ie),he,typeof Ae=="undefined"?[]:[Ae,...ut])},registerCompletionItemProvider(ie,he,...Ae){return wt.registerCompletionItemProvider(Ne,yt(ie),he,Ae)},registerInlineCompletionItemProvider(ie,he){return(0,x.checkProposedApiEnabled)(Ne),wt.registerInlineCompletionsProvider(Ne,yt(ie),he)},registerDocumentLinkProvider(ie,he){return wt.registerDocumentLinkProvider(Ne,yt(ie),he)},registerColorProvider(ie,he){return wt.registerColorProvider(Ne,yt(ie),he)},registerFoldingRangeProvider(ie,he){return wt.registerFoldingRangeProvider(Ne,yt(ie),he)},registerSelectionRangeProvider(ie,he){return wt.registerSelectionRangeProvider(Ne,ie,he)},registerCallHierarchyProvider(ie,he){return wt.registerCallHierarchyProvider(Ne,ie,he)},registerTypeHierarchyProvider(ie,he){return wt.registerTypeHierarchyProvider(Ne,ie,he)},setLanguageConfiguration:(ie,he)=>wt.setLanguageConfiguration(Ne,ie,he),getTokenInformationAtPosition(ie,he){return(0,x.checkProposedApiEnabled)(Ne),Ht.tokenAtPosition(ie,he)},registerInlayHintsProvider(ie,he){return(0,x.checkProposedApiEnabled)(Ne),wt.registerInlayHintsProvider(Ne,ie,he)},createLanguageStatusItem(ie,he){return(0,x.checkProposedApiEnabled)(Ne),Ht.createLanguageStatusItem(Ne,ie,he)}},An={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(ie,he,Ae){const ut=await(A.URI.isUri(ie)?Promise.resolve(vn.openTextDocument(ie)):Promise.resolve(ie));return Tt.showTextDocument(ut,he,Ae)},createTextEditorDecorationType(ie){return Tt.createTextEditorDecorationType(Ne,ie)},onDidChangeActiveTextEditor(ie,he,Ae){return Tt.onDidChangeActiveTextEditor(ie,he,Ae)},onDidChangeVisibleTextEditors(ie,he,Ae){return Tt.onDidChangeVisibleTextEditors(ie,he,Ae)},onDidChangeTextEditorSelection(ie,he,Ae){return Tt.onDidChangeTextEditorSelection(ie,he,Ae)},onDidChangeTextEditorOptions(ie,he,Ae){return Tt.onDidChangeTextEditorOptions(ie,he,Ae)},onDidChangeTextEditorVisibleRanges(ie,he,Ae){return Tt.onDidChangeTextEditorVisibleRanges(ie,he,Ae)},onDidChangeTextEditorViewColumn(ie,he,Ae){return Tt.onDidChangeTextEditorViewColumn(ie,he,Ae)},onDidCloseTerminal(ie,he,Ae){return bt.onDidCloseTerminal(ie,he,Ae)},onDidOpenTerminal(ie,he,Ae){return bt.onDidOpenTerminal(ie,he,Ae)},onDidChangeActiveTerminal(ie,he,Ae){return bt.onDidChangeActiveTerminal(ie,he,Ae)},onDidChangeTerminalDimensions(ie,he,Ae){return(0,x.checkProposedApiEnabled)(Ne),bt.onDidChangeTerminalDimensions(ie,he,Ae)},onDidChangeTerminalState(ie,he,Ae){return bt.onDidChangeTerminalState(ie,he,Ae)},onDidWriteTerminalData(ie,he,Ae){return(0,x.checkProposedApiEnabled)(Ne),bt.onDidWriteTerminalData(ie,he,Ae)},get state(){return Le.state},onDidChangeWindowState(ie,he,Ae){return Le.onDidChangeWindowState(ie,he,Ae)},showInformationMessage(ie,...he){return cn.showMessage(Ne,y.default.Info,ie,he[0],he.slice(1))},showWarningMessage(ie,...he){return cn.showMessage(Ne,y.default.Warning,ie,he[0],he.slice(1))},showErrorMessage(ie,...he){return cn.showMessage(Ne,y.default.Error,ie,he[0],he.slice(1))},showQuickPick(ie,he,Ae){return Nt.showQuickPick(ie,!!Ne.enableProposedApi,he,Ae)},showWorkspaceFolderPick(ie){return Nt.showWorkspaceFolderPick(ie)},showInputBox(ie,he){return Nt.showInput(ie,he)},showOpenDialog(ie){return zt.showOpenDialog(ie)},showSaveDialog(ie){return zt.showSaveDialog(ie)},createStatusBarItem(ie,he,Ae){let ut,Ct,Pt;return typeof ie=="string"?(ut=ie,Ct=he,Pt=Ae):(Ct=ie,Pt=he),Ft.createStatusBarEntry(Ne,ut,Ct,Pt)},setStatusBarMessage(ie,he){return Ft.setStatusBarMessage(ie,he)},withScmProgress(ie){return Se.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),fn.withProgress(Ne,{location:U.ProgressLocation.SourceControl},(he,Ae)=>ie({report(ut){}}))},withProgress(ie,he){return fn.withProgress(Ne,ie,he)},createOutputChannel(ie){return xt.createOutputChannel(ie,Ne)},createWebviewPanel(ie,he,Ae,ut){return an.createWebviewPanel(Ne,ie,he,Ae,ut)},createWebviewTextEditorInset(ie,he,Ae,ut){return(0,x.checkProposedApiEnabled)(Ne),bn.createWebviewEditorInset(ie,he,Ae,ut,Ne)},createTerminal(ie,he,Ae){return typeof ie=="object"?("location"in ie&&(0,x.checkProposedApiEnabled)(Ne),"pty"in ie?bt.createExtensionTerminal(ie):bt.createTerminalFromOptions(ie)):bt.createTerminal(ie,he,Ae)},registerTerminalLinkProvider(ie){return bt.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,he){return bt.registerProfileProvider(Ne,ie,he)},registerTreeDataProvider(ie,he){return Xt.registerTreeDataProvider(ie,he,Ne)},createTreeView(ie,he){return Xt.createTreeView(ie,he,Ne)},registerWebviewPanelSerializer:(ie,he)=>an.registerWebviewPanelSerializer(Ne,ie,he),registerCustomEditorProvider:(ie,he,Ae={})=>Sn.registerCustomEditorProvider(Ne,ie,he,Ae),registerFileDecorationProvider(ie){return pt.registerFileDecorationProvider(ie,Ne.identifier)},registerUriHandler(ie){return Vt.registerUriHandler(Ne.identifier,ie)},createQuickPick(){return Nt.createQuickPick(Ne.identifier,!!Ne.enableProposedApi)},createInputBox(){return Nt.createInputBox(Ne.identifier)},get activeColorTheme(){return mn.activeColorTheme},onDidChangeActiveColorTheme(ie,he,Ae){return mn.onDidChangeActiveColorTheme(ie,he,Ae)},registerWebviewViewProvider(ie,he,Ae){return yn.registerWebviewViewProvider(Ne,ie,he,Ae?.webviewOptions)},get activeNotebookEditor(){return(0,x.checkProposedApiEnabled)(Ne),St.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,he,Ae){return(0,x.checkProposedApiEnabled)(Ne),St.onDidChangeActiveNotebookEditor(ie,he,Ae)},get visibleNotebookEditors(){return(0,x.checkProposedApiEnabled)(Ne),St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,x.checkProposedApiEnabled)(Ne),St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ie,he,Ae){return(0,x.checkProposedApiEnabled)(Ne),jt.onDidChangeNotebookEditorSelection(ie,he,Ae)},onDidChangeNotebookEditorVisibleRanges(ie,he,Ae){return(0,x.checkProposedApiEnabled)(Ne),jt.onDidChangeNotebookEditorVisibleRanges(ie,he,Ae)},showNotebookDocument(ie,he){return(0,x.checkProposedApiEnabled)(Ne),St.showNotebookDocument(ie,he)},registerExternalUriOpener(ie,he,Ae){return(0,x.checkProposedApiEnabled)(Ne),Jt.registerExternalUriOpener(Ne.identifier,ie,he,Ae)},get tabs(){return(0,x.checkProposedApiEnabled)(Ne),Ge.tabs},get activeTab(){return(0,x.checkProposedApiEnabled)(Ne),Ge.activeTab},get onDidChangeTabs(){return(0,x.checkProposedApiEnabled)(Ne),Ge.onDidChangeTabs},get onDidChangeActiveTab(){return(0,x.checkProposedApiEnabled)(Ne),Ge.onDidChangeActiveTab},getInlineCompletionItemController(ie){return(0,x.checkProposedApiEnabled)(Ne),o.InlineCompletionController.get(ie)}},vn={get rootPath(){return Se.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),qe.getPath()},set rootPath(ie){throw F.readonly()},getWorkspaceFolder(ie){return qe.getWorkspaceFolder(ie)},get workspaceFolders(){return qe.getWorkspaceFolders()},get name(){return qe.name},set name(ie){throw F.readonly()},get workspaceFile(){return qe.workspaceFile},set workspaceFile(ie){throw F.readonly()},updateWorkspaceFolders:(ie,he,...Ae)=>qe.updateWorkspaceFolders(Ne,ie,he||0,...Ae),onDidChangeWorkspaceFolders:function(ie,he,Ae){return qe.onDidChangeWorkspace(ie,he,Ae)},asRelativePath:(ie,he)=>qe.getRelativePath(ie,he),findFiles:(ie,he,Ae,ut)=>qe.findFiles(j.GlobPattern.from(ie),j.GlobPattern.from(he),Ae,Ne.identifier,ut),findTextInFiles:(ie,he,Ae,ut)=>{let Ct,Pt;return typeof he=="object"?(Ct=he,Pt=Ae):(Ct={},Pt=he,ut=Ae),qe.findTextInFiles(ie,Ct||{},Pt,Ne.identifier,ut)},saveAll:ie=>qe.saveAll(ie),applyEdit(ie){return Cn.applyWorkspaceEdit(ie)},createFileSystemWatcher:(ie,he,Ae,ut)=>Ot.createFileSystemWatcher(j.GlobPattern.from(ie),he,Ae,ut),get textDocuments(){return kt.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw F.readonly()},openTextDocument(ie){let he;const Ae=ie;if(typeof ie=="string")he=Promise.resolve(A.URI.file(ie));else if(A.URI.isUri(ie))he=Promise.resolve(ie);else if(!Ae||typeof Ae=="object")he=kt.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(ut=>kt.ensureDocumentData(ut).then(Ct=>Ct.document))},onDidOpenTextDocument:(ie,he,Ae)=>kt.onDidAddDocument(ie,he,Ae),onDidCloseTextDocument:(ie,he,Ae)=>kt.onDidRemoveDocument(ie,he,Ae),onDidChangeTextDocument:(ie,he,Ae)=>kt.onDidChangeDocument(ie,he,Ae),onDidSaveTextDocument:(ie,he,Ae)=>kt.onDidSaveDocument(ie,he,Ae),onWillSaveTextDocument:(ie,he,Ae)=>en.getOnWillSaveTextDocumentEvent(Ne)(ie,he,Ae),get notebookDocuments(){return St.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,he){let Ae;if(A.URI.isUri(ie))Ae=ie,await St.openNotebookDocument(ie);else if(typeof ie=="string")Ae=A.URI.revive(await St.createNotebookDocument({viewType:ie,content:he}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(ie,he,Ae,ut){return St.registerNotebookSerializer(Ne,ie,he,Ae,Ne.enableProposedApi?ut:void 0)},registerNotebookContentProvider:(ie,he,Ae,ut)=>((0,x.checkProposedApiEnabled)(Ne),St.registerNotebookContentProvider(Ne,ie,he,Ae,Ne.enableProposedApi?ut:void 0)),onDidChangeConfiguration:(ie,he,Ae)=>Kt.onDidChangeConfiguration(ie,he,Ae),getConfiguration(ie,he){return he=arguments.length===1?void 0:he,Kt.getConfiguration(ie,he,Ne)},registerTextDocumentContentProvider(ie,he){return $t.registerTextDocumentContentProvider(ie,he)},registerTaskProvider:(ie,he)=>(Se.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),Dt.registerTaskProvider(Ne,ie,he)),registerFileSystemProvider(ie,he,Ae){return rn.registerFileSystemProvider(Ne.identifier,ie,he,Ae)},get fs(){return we.value},registerFileSearchProvider:(ie,he)=>((0,x.checkProposedApiEnabled)(Ne),_t.registerFileSearchProvider(ie,he)),registerTextSearchProvider:(ie,he)=>((0,x.checkProposedApiEnabled)(Ne),_t.registerTextSearchProvider(ie,he)),registerRemoteAuthorityResolver:(ie,he)=>((0,x.checkProposedApiEnabled)(Ne),Fe.registerRemoteAuthorityResolver(ie,he)),registerResourceLabelFormatter:ie=>((0,x.checkProposedApiEnabled)(Ne),_n.$registerResourceLabelFormatter(ie)),onDidCreateFiles:(ie,he,Ae)=>Ot.onDidCreateFile(ie,he,Ae),onDidDeleteFiles:(ie,he,Ae)=>Ot.onDidDeleteFile(ie,he,Ae),onDidRenameFiles:(ie,he,Ae)=>Ot.onDidRenameFile(ie,he,Ae),onWillCreateFiles:(ie,he,Ae)=>Ot.getOnWillCreateFileEvent(Ne)(ie,he,Ae),onWillDeleteFiles:(ie,he,Ae)=>Ot.getOnWillDeleteFileEvent(Ne)(ie,he,Ae),onWillRenameFiles:(ie,he,Ae)=>Ot.getOnWillRenameFileEvent(Ne)(ie,he,Ae),openTunnel:ie=>((0,x.checkProposedApiEnabled)(Ne),K.openTunnel(Ne,ie).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,x.checkProposedApiEnabled)(Ne),K.getTunnels()},onDidChangeTunnels:(ie,he,Ae)=>((0,x.checkProposedApiEnabled)(Ne),K.onDidChangeTunnels(ie,he,Ae)),registerPortAttributesProvider:(ie,he)=>((0,x.checkProposedApiEnabled)(Ne),K.registerPortsAttributesProvider(ie,he)),registerTimelineProvider:(ie,he)=>((0,x.checkProposedApiEnabled)(Ne),on.registerTimelineProvider(ie,he,Ne.identifier,ft.converter)),get isTrusted(){return qe.trusted},requestWorkspaceTrust:ie=>((0,x.checkProposedApiEnabled)(Ne),qe.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,he,Ae)=>qe.onDidGrantWorkspaceTrust(ie,he,Ae)},Rn={get inputBox(){return Se.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),Yt.getLastInputBox(Ne)},createSourceControl(ie,he,Ae){return Yt.createSourceControl(Ne,ie,he,Ae)}},Ln={createCommentController(ie,he){return En.createCommentController(Ne,ie,he)}},Fn={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},onDidStartDebugSession(ie,he,Ae){return mt.onDidStartDebugSession(ie,he,Ae)},onDidTerminateDebugSession(ie,he,Ae){return mt.onDidTerminateDebugSession(ie,he,Ae)},onDidChangeActiveDebugSession(ie,he,Ae){return mt.onDidChangeActiveDebugSession(ie,he,Ae)},onDidReceiveDebugSessionCustomEvent(ie,he,Ae){return mt.onDidReceiveDebugSessionCustomEvent(ie,he,Ae)},onDidChangeBreakpoints(ie,he,Ae){return mt.onDidChangeBreakpoints(ie,he,Ae)},registerDebugConfigurationProvider(ie,he,Ae){return mt.registerDebugConfigurationProvider(ie,he,Ae||U.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,he){return mt.registerDebugAdapterDescriptorFactory(Ne,ie,he)},registerDebugAdapterTrackerFactory(ie,he){return mt.registerDebugAdapterTrackerFactory(ie,he)},startDebugging(ie,he,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?mt.startDebugging(ie,he,{parentSession:Ae}):mt.startDebugging(ie,he,Ae||{})},stopDebugging(ie){return mt.stopDebugging(ie)},addBreakpoints(ie){return mt.addBreakpoints(ie)},removeBreakpoints(ie){return mt.removeBreakpoints(ie)},asDebugSourceUri(ie,he){return mt.asDebugSourceUri(ie,he)}},Mn={registerTaskProvider:(ie,he)=>Dt.registerTaskProvider(Ne,ie,he),fetchTasks:ie=>Dt.fetchTasks(ie),executeTask:ie=>Dt.executeTask(Ne,ie),get taskExecutions(){return Dt.taskExecutions},onDidStartTask:(ie,he,Ae)=>Dt.onDidStartTask(ie,he,Ae),onDidEndTask:(ie,he,Ae)=>Dt.onDidEndTask(ie,he,Ae),onDidStartTaskProcess:(ie,he,Ae)=>Dt.onDidStartTaskProcess(ie,he,Ae),onDidEndTaskProcess:(ie,he,Ae)=>Dt.onDidEndTaskProcess(ie,he,Ae)},On={createNotebookController(ie,he,Ae,ut,Ct){return tn.createNotebookController(Ne,ie,he,Ae,ut,Ne.enableProposedApi?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(ie,he)=>St.registerNotebookCellStatusBarItemProvider(Ne,ie,he),get onDidSaveNotebookDocument(){return(0,x.checkProposedApiEnabled)(Ne),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ie){return(0,x.checkProposedApiEnabled)(Ne),jt.createNotebookEditorDecorationType(ie)},createRendererMessaging(ie){return nn.createRendererMessaging(Ne,ie)},onDidChangeNotebookDocumentMetadata(ie,he,Ae){return(0,x.checkProposedApiEnabled)(Ne),Qt.onDidChangeNotebookDocumentMetadata(ie,he,Ae)},onDidChangeNotebookCells(ie,he,Ae){return(0,x.checkProposedApiEnabled)(Ne),St.onDidChangeNotebookCells(ie,he,Ae)},onDidChangeNotebookCellExecutionState(ie,he,Ae){return(0,x.checkProposedApiEnabled)(Ne),St.onDidChangeNotebookCellExecutionState(ie,he,Ae)},onDidChangeCellOutputs(ie,he,Ae){return(0,x.checkProposedApiEnabled)(Ne),St.onDidChangeCellOutputs(ie,he,Ae)},onDidChangeCellMetadata(ie,he,Ae){return(0,x.checkProposedApiEnabled)(Ne),St.onDidChangeCellMetadata(ie,he,Ae)},createConcatTextDocument(ie,he){return(0,x.checkProposedApiEnabled)(Ne),new Ke.ExtHostNotebookConcatDocument(St,kt,ie,he)}};return{version:ue.version,authentication:kn,commands:In,comments:Ln,debug:Fn,env:gn,extensions:Tn,languages:un,notebooks:On,scm:Rn,tasks:Mn,tests:Pn,window:An,workspace:vn,Breakpoint:U.Breakpoint,CallHierarchyIncomingCall:U.CallHierarchyIncomingCall,CallHierarchyItem:U.CallHierarchyItem,CallHierarchyOutgoingCall:U.CallHierarchyOutgoingCall,CancellationError:F.CancellationError,CancellationTokenSource:p.CancellationTokenSource,CandidatePortSource:a.CandidatePortSource,CodeAction:U.CodeAction,CodeActionKind:U.CodeActionKind,CodeActionTriggerKind:U.CodeActionTriggerKind,CodeLens:U.CodeLens,Color:U.Color,ColorInformation:U.ColorInformation,ColorPresentation:U.ColorPresentation,ColorThemeKind:U.ColorThemeKind,CommentMode:U.CommentMode,CommentThreadCollapsibleState:U.CommentThreadCollapsibleState,CompletionItem:U.CompletionItem,CompletionItemKind:U.CompletionItemKind,CompletionItemTag:U.CompletionItemTag,CompletionList:U.CompletionList,CompletionTriggerKind:U.CompletionTriggerKind,ConfigurationTarget:U.ConfigurationTarget,CustomExecution:U.CustomExecution,DebugAdapterExecutable:U.DebugAdapterExecutable,DebugAdapterInlineImplementation:U.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:U.DebugAdapterNamedPipeServer,DebugAdapterServer:U.DebugAdapterServer,DebugConfigurationProviderTriggerKind:U.DebugConfigurationProviderTriggerKind,DebugConsoleMode:U.DebugConsoleMode,DecorationRangeBehavior:U.DecorationRangeBehavior,Diagnostic:U.Diagnostic,DiagnosticRelatedInformation:U.DiagnosticRelatedInformation,DiagnosticSeverity:U.DiagnosticSeverity,DiagnosticTag:U.DiagnosticTag,Disposable:U.Disposable,DocumentHighlight:U.DocumentHighlight,DocumentHighlightKind:U.DocumentHighlightKind,DocumentLink:U.DocumentLink,DocumentSymbol:U.DocumentSymbol,EndOfLine:U.EndOfLine,EnvironmentVariableMutatorType:U.EnvironmentVariableMutatorType,EvaluatableExpression:U.EvaluatableExpression,InlineValueText:U.InlineValueText,InlineValueVariableLookup:U.InlineValueVariableLookup,InlineValueEvaluatableExpression:U.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:U.InlineCompletionTriggerKind,EventEmitter:C.Emitter,ExtensionKind:U.ExtensionKind,ExtensionMode:U.ExtensionMode,ExternalUriOpenerPriority:U.ExternalUriOpenerPriority,FileChangeType:U.FileChangeType,FileDecoration:U.FileDecoration,FileSystemError:U.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:U.FoldingRange,FoldingRangeKind:U.FoldingRangeKind,FunctionBreakpoint:U.FunctionBreakpoint,InlineCompletionItem:U.InlineSuggestion,InlineCompletionList:U.InlineSuggestions,Hover:U.Hover,IndentAction:I.IndentAction,Location:U.Location,MarkdownString:U.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:U.ParameterInformation,PortAutoForwardAction:U.PortAutoForwardAction,Position:U.Position,ProcessExecution:U.ProcessExecution,ProgressLocation:U.ProgressLocation,QuickInputButtons:U.QuickInputButtons,Range:U.Range,RelativePattern:U.RelativePattern,Selection:U.Selection,SelectionRange:U.SelectionRange,SemanticTokens:U.SemanticTokens,SemanticTokensBuilder:U.SemanticTokensBuilder,SemanticTokensEdit:U.SemanticTokensEdit,SemanticTokensEdits:U.SemanticTokensEdits,SemanticTokensLegend:U.SemanticTokensLegend,ShellExecution:U.ShellExecution,ShellQuoting:U.ShellQuoting,SignatureHelp:U.SignatureHelp,SignatureHelpTriggerKind:U.SignatureHelpTriggerKind,SignatureInformation:U.SignatureInformation,SnippetString:U.SnippetString,SourceBreakpoint:U.SourceBreakpoint,StandardTokenType:U.StandardTokenType,StatusBarAlignment:U.StatusBarAlignment,SymbolInformation:U.SymbolInformation,SymbolKind:U.SymbolKind,SymbolTag:U.SymbolTag,Task:U.Task,TaskGroup:U.TaskGroup,TaskPanelKind:U.TaskPanelKind,TaskRevealKind:U.TaskRevealKind,TaskScope:U.TaskScope,TerminalLink:U.TerminalLink,TerminalLocation:U.TerminalLocation,TerminalProfile:U.TerminalProfile,TextDocumentSaveReason:U.TextDocumentSaveReason,TextEdit:U.TextEdit,TextEditorCursorStyle:_.TextEditorCursorStyle,TextEditorLineNumbersStyle:U.TextEditorLineNumbersStyle,TextEditorRevealType:U.TextEditorRevealType,TextEditorSelectionChangeKind:U.TextEditorSelectionChangeKind,TextDocumentChangeReason:U.TextDocumentChangeReason,ThemeColor:U.ThemeColor,ThemeIcon:U.ThemeIcon,TreeItem:U.TreeItem,TreeItemCollapsibleState:U.TreeItemCollapsibleState,TypeHierarchyItem:U.TypeHierarchyItem,UIKind:a.UIKind,Uri:A.URI,ViewColumn:U.ViewColumn,WorkspaceEdit:U.WorkspaceEdit,InlayHint:U.InlayHint,InlayHintKind:U.InlayHintKind,RemoteAuthorityResolverError:U.RemoteAuthorityResolverError,ResolvedAuthority:U.ResolvedAuthority,SourceControlInputBoxValidationType:U.SourceControlInputBoxValidationType,ExtensionRuntime:U.ExtensionRuntime,TimelineItem:U.TimelineItem,NotebookRange:U.NotebookRange,NotebookCellKind:U.NotebookCellKind,NotebookCellExecutionState:U.NotebookCellExecutionState,NotebookCellData:U.NotebookCellData,NotebookData:U.NotebookData,NotebookRendererScript:U.NotebookRendererScript,NotebookCellStatusBarAlignment:U.NotebookCellStatusBarAlignment,NotebookEditorRevealType:U.NotebookEditorRevealType,NotebookCellOutput:U.NotebookCellOutput,NotebookCellOutputItem:U.NotebookCellOutputItem,NotebookCellStatusBarItem:U.NotebookCellStatusBarItem,NotebookControllerAffinity:U.NotebookControllerAffinity,PortAttributes:U.PortAttributes,LinkedEditingRanges:U.LinkedEditingRanges,TestResultState:U.TestResultState,TestRunRequest:U.TestRunRequest,TestMessage:U.TestMessage,TestTag:U.TestTag,TestRunProfileKind:U.TestRunProfileKind,TextSearchCompleteMessageType:Xe.TextSearchCompleteMessageType,CoveredCount:U.CoveredCount,FileCoverage:U.FileCoverage,StatementCoverage:U.StatementCoverage,BranchCoverage:U.BranchCoverage,FunctionCoverage:U.FunctionCoverage,WorkspaceTrustState:U.WorkspaceTrustState,LanguageStatusSeverity:U.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Pe}),define(fe[277],me([0,1,83,69,36,133,37,40,45,33,73,57,75,92,54,68,134,91,53,90,124,56]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d,w,D,T,E,c,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,p.registerSingleton)(w.IExtHostApiDeprecationService,w.ExtHostApiDeprecationService),(0,p.registerSingleton)(_.IExtHostCommands,_.ExtHostCommands),(0,p.registerSingleton)(A.IExtHostConfiguration,A.ExtHostConfiguration),(0,p.registerSingleton)(T.IExtHostConsumerFileSystem,T.ExtHostConsumerFileSystem),(0,p.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService),(0,p.registerSingleton)(y.IExtHostDecorations,y.ExtHostDecorations),(0,p.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,p.registerSingleton)(E.IExtHostFileSystemInfo,E.ExtHostFileSystemInfo),(0,p.registerSingleton)(F.IExtHostOutputService,F.ExtHostOutputService),(0,p.registerSingleton)(a.IExtHostSearch,a.ExtHostSearch),(0,p.registerSingleton)(g.IExtHostStorage,g.ExtHostStorage),(0,p.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,p.registerSingleton)(I.IExtHostTerminalService,I.WorkerExtHostTerminalService),(0,p.registerSingleton)(d.IExtHostTunnelService,d.ExtHostTunnelService),(0,p.registerSingleton)(D.IExtHostWindow,D.ExtHostWindow),(0,p.registerSingleton)(C.IExtHostWorkspace,C.ExtHostWorkspace),(0,p.registerSingleton)(c.IExtHostSecretState,c.ExtHostSecretState),(0,p.registerSingleton)(r.IExtHostTelemetry,r.ExtHostTelemetry),(0,p.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs)}),define(fe[93],me([0,1,18,13,31,72]),function(Y,e,p,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function A(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=A;function _(k,a,g,d){const w=(0,p.mapArrayOrNot)(g,S),D=new C.TextSearchMatch(a,w,d),T=D.preview.matches;return{ranges:(0,p.mapArrayOrNot)(w,I),uri:k,preview:{text:D.preview.text,matches:(0,p.mapArrayOrNot)(T,I)}}}e.createTextSearchResult=_;function S(k){return new C.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function I(k){return new y.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let i=class{constructor(a,g){this.prefix=a,this.logService=g}appendLine(a){this.logService.debug(`${this.prefix}#search`,a)}};i=Ve([$e(1,F.ILogService)],i),e.OutputChannel=i}),define(fe[278],me([0,1,97,22]),function(Y,e,p,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function C(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(h=>h===t)}e.isUTFEncoding=C,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const y=512,A=512,_=512*8,S=512*128;class I{constructor(h){this.iconvLiteDecoder=h}static async create(h){let s;if(h!==e.UTF8)s=(await new Promise((u,o)=>{Y(["iconv-lite-umd"],u,o)})).getDecoder(g(h));else{const n=new TextDecoder;s={write(u){return n.decode(u,{stream:!0})},end(){return n.decode()}}}return new I(s)}write(h){return this.iconvLiteDecoder.write(h)}end(){return this.iconvLiteDecoder.end()}}function i(t,h){const s=h.minBytesRequiredForDetection??h.guessEncoding?_:A;return new Promise((n,u)=>{const o=(0,p.newWriteableStream)(P=>P.join("")),l=[];let m=0,b;const f=async()=>{try{const P=await v({buffer:F.VSBuffer.concat(l),bytesRead:m},h.guessEncoding);P.encoding=await h.overwriteEncoding(P.encoding),b=await I.create(P.encoding);const L=b.write(F.VSBuffer.concat(l).buffer);o.write(L),l.length=0,m=0,n({stream:o,detected:P})}catch(P){u(P)}};(0,p.listenStream)(t,{onData:async P=>{b?o.write(b.write(P.buffer)):(l.push(P),m+=P.byteLength,m>=s&&(t.pause(),await f(),setTimeout(()=>t.resume())))},onError:P=>o.error(P),onEnd:async()=>{b||await f(),o.end(b?.end())}})})}e.toDecodeStream=i;async function k(t,h,s){const u=(await new Promise((m,b)=>{Y(["iconv-lite-umd"],m,b)})).getEncoder(g(h),s);let o=!1,l=!1;return{read(){if(l)return null;const m=t.read();if(typeof m!="string"){if(l=!0,!o&&s?.addBOM)switch(h){case e.UTF8:case e.UTF8_with_bom:return F.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return F.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return F.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const b=u.end();return b&&b.length>0?(o=!0,F.VSBuffer.wrap(b)):null}return o=!0,F.VSBuffer.wrap(u.write(m))}}}e.toEncodeReadable=k;async function a(t){return(await new Promise((s,n)=>{Y(["iconv-lite-umd"],s,n)})).encodingExists(g(t))}e.encodingExists=a;function g(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=g;function d(t,h){if(!t||h<e.UTF16be_BOM.length)return null;const s=t.readUInt8(0),n=t.readUInt8(1);if(s===e.UTF16be_BOM[0]&&n===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&n===e.UTF16le_BOM[1])return e.UTF16le;if(h<e.UTF8_BOM.length)return null;const u=t.readUInt8(2);return s===e.UTF8_BOM[0]&&n===e.UTF8_BOM[1]&&u===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=d;const w=["ascii","utf-16","utf-32"];async function D(t){const h=await new Promise((l,m)=>{Y(["jschardet"],l,m)}),s=t.slice(0,S),n=c(s.buffer),u=h.detect(n);if(!u||!u.encoding)return null;const o=u.encoding.toLowerCase();return 0<=w.indexOf(o)?null:E(u.encoding)}const T={ibm866:"cp866",big5:"cp950"};function E(t){const h=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return T[h]||h}function c(t){let h="";for(let s=0;s<t.length;s++)h+=String.fromCharCode(t[s]);return h}function r(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const h=t.match(/windows(\d+)/);return h?"windows-"+h[1]:t}}e.toCanonicalName=r;function v({buffer:t,bytesRead:h},s){let n=d(t,h),u=!1;if(n!==e.UTF16be&&n!==e.UTF16le&&t){let o=!0,l=!0,m=!1;for(let b=0;b<h&&b<y;b++){const f=b%2==1,P=t.readUInt8(b)===0;if(P&&(m=!0),o&&(f&&!P||!f&&P)&&(o=!1),l&&(f&&P||!f&&!P)&&(l=!1),P&&!o&&!l)break}m&&(o?n=e.UTF16le:l?n=e.UTF16be:u=!0)}return s&&!u&&!n&&t?D(t.slice(0,h)).then(o=>({seemsBinary:!1,encoding:o})):{seemsBinary:u,encoding:n}}e.detectEncodingFromBuffer=v,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(fe[136],me([0,1,278,28,135]),function(Y,e,p,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class y extends C.TextSearchManager{constructor(_,S,I=F,i="searchProcess"){super(_,S,{readdir:k=>I.Promises.readdir(k.fsPath),toCanonicalName:k=>(0,p.toCanonicalName)(k)},i)}}e.NativeTextSearchManager=y}),define(fe[279],me([0,1,280,294,295,2,296]),function(Y,e,p,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function _(k,a,g,d,w,D){const T=D.environment.useHostProxy,E=typeof T=="boolean"?T:!D.remote.isRemote,c=(0,A.createProxyResolver)({resolveProxy:v=>k.resolveProxy(v),getHttpProxySetting:()=>a.getConfiguration("http").get("proxy"),log:(v,t,...h)=>{switch(v){case A.LogLevel.Trace:d.trace(t,...h);break;case A.LogLevel.Debug:d.debug(t,...h);break;case A.LogLevel.Info:d.info(t,...h);break;case A.LogLevel.Warning:d.warn(t,...h);break;case A.LogLevel.Error:d.error(t,...h);break;case A.LogLevel.Critical:d.critical(t,...h);break;case A.LogLevel.Off:break;default:s(v,t,h);break}function s(n,u,...o){d.error("Unknown log level",n),d.error(u,...o)}},getLogLevel:()=>d.getLevel(),proxyResolveTelemetry:v=>{w.$publicLog2("resolveProxy",v)},useHostProxy:E,env:process.env}),r=S(a,c);return i(g,r)}e.connectProxyResolver=_;function S(k,a){const g={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(w=>{g.config=k.getConfiguration("http").get("proxySupport")||"off"});const d={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(w=>{d.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},p,(0,A.createHttpPatch)(p,a,{config:"off"},d,!0)),on:Object.assign({},p,(0,A.createHttpPatch)(p,a,{config:"on"},d,!0)),override:Object.assign({},p,(0,A.createHttpPatch)(p,a,{config:"override"},d,!0)),onRequest:Object.assign({},p,(0,A.createHttpPatch)(p,a,g,d,!0)),default:Object.assign(p,(0,A.createHttpPatch)(p,a,g,d,!1))},https:{off:Object.assign({},F,(0,A.createHttpPatch)(F,a,{config:"off"},d,!0)),on:Object.assign({},F,(0,A.createHttpPatch)(F,a,{config:"on"},d,!0)),override:Object.assign({},F,(0,A.createHttpPatch)(F,a,{config:"override"},d,!0)),onRequest:Object.assign({},F,(0,A.createHttpPatch)(F,a,g,d,!0)),default:Object.assign(F,(0,A.createHttpPatch)(F,a,g,d,!1))},tls:Object.assign(C,(0,A.createTlsPatch)(C))}}const I=new Map;function i(k,a){return k.getExtensionPathIndex().then(g=>{const d=Y.__$__nodeRequire("module"),w=d._load;d._load=function(T,E,c){if(T==="tls")return a.tls;if(T!=="http"&&T!=="https")return w.apply(this,arguments);const r=a[T],v=g.findSubstr(y.URI.file(E.filename));let t=I.get(v);if(t||I.set(v,t={}),!t[T]){let h=r.default;v&&v.enableProposedApi&&(h=r[v.proxySupport]||r.onRequest),t[T]={...h}}return t[T]}})}}),define(fe[281],me([0,1,39,8,79,29,11,9,93,282]),function(Y,e,p,F,C,y,A,_,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const i=I.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(c,r,v,t){const h=a(c,r,v,t),s=r.folder.fsPath;return{cmd:p.spawn(i,h.args,{cwd:s}),rgDiskPath:i,siblingClauses:h.siblingClauses,rgArgs:h,cwd:s}}e.spawnRipgrepCmd=k;function a(c,r,v,t){const h=["--files","--hidden","--case-sensitive"];d([r],v,!1).forEach(n=>{const u=(0,S.anchorGlob)(n);if(h.push("-g",u),A.isMacintosh){const o=(0,C.normalizeNFD)(u);o!==u&&h.push("-g",o)}});const s=g([r],t,void 0,!1);return s.globArgs.forEach(n=>{const u=`!${(0,S.anchorGlob)(n)}`;if(h.push("-g",u),A.isMacintosh){const o=(0,C.normalizeNFD)(u);o!==u&&h.push("-g",o)}}),r.disregardIgnoreFiles!==!1?h.push("--no-ignore"):h.push("--no-ignore-parent"),r.ignoreSymlinks||h.push("--follow"),c.exists&&h.push("--quiet"),h.push("--no-config"),r.disregardGlobalIgnoreFiles&&h.push("--no-ignore-global"),{args:h,siblingClauses:s.siblingClauses}}function g(c,r,v,t=!0){const h=[];let s={};return c.forEach(n=>{const u=Object.assign({},n.excludePattern||{},r||{}),o=w(u,t?n.folder.fsPath:void 0,v);h.push(...o.globArgs),o.siblingClauses&&(s=Object.assign(s,o.siblingClauses))}),{globArgs:h,siblingClauses:s}}e.foldersToRgExcludeGlobs=g;function d(c,r,v=!0){const t=[];return c.forEach(h=>{const s=Object.assign({},r||{},h.includePattern||{}),n=w(s,v?h.folder.fsPath:void 0);t.push(...n.globArgs)}),t}e.foldersToIncludeGlobs=d;function w(c,r,v){const t=[],h={};return Object.keys(c).forEach(s=>{if(v&&v.has(s)||!s)return;const n=c[s];s=T(r?D(r,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof n=="boolean"&&n?(s.startsWith("\\\\")&&(s+="**"),t.push(E(s))):n&&n.when&&(h[s]=n)}),{globArgs:t,siblingClauses:h}}function D(c,r){return F.isAbsolute(r)?r:F.join(c,r)}e.getAbsoluteGlob=D;function T(c){return c=_.rtrim(c,"\\"),_.rtrim(c,"/")}function E(c){return y.getRoot(c).toLowerCase()==="c:/"?c.replace(/^c:[/\\]/i,"/"):c}e.fixDriveC=E}),define(fe[283],me([0,1,39,50,8,105,18,52,30,79,29,11,46,9,12,28,31,281,102]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d,w,D,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const c=new Set;process.on("exit",()=>{c.forEach(s=>s())});class r{constructor(n){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=n,this.filePattern=n.filePattern||"",this.includePattern=n.includePattern&&S.parse(n.includePattern),this.maxResults=n.maxResults||null,this.exists=!!n.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,E.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=n.excludePattern&&S.parse(n.excludePattern),this.folderExcludePatterns=new Map,n.folderQueries.forEach(u=>{const o=Object.assign({},u.excludePattern||{},this.config.excludePattern||{}),l=u.folder.fsPath;n.folderQueries.map(m=>m.folder.fsPath).filter(m=>m!==l).forEach(m=>{(0,i.isEqualOrParent)(m,l)&&(o[C.relative(l,m)]=!0)}),this.folderExcludePatterns.set(l,new t(o,l))})}cancel(){this.isCanceled=!0}walk(n,u,o,l,m){if(this.fileWalkSW=a.StopWatch.create(!1),this.isCanceled)return m(null,this.isLimitHit);u.forEach(b=>{const f=C.basename(b.fsPath);this.globalExcludePattern&&this.globalExcludePattern(b.fsPath,f)||this.matchFile(o,{relativePath:b.fsPath,searchPath:void 0})}),this.cmdSW=a.StopWatch.create(!1),this.parallel(n,(b,f)=>{this.call(this.cmdTraversal,this,b,o,l,P=>{if(P){const L=(0,_.toErrorMessage)(P);console.error(L),this.errors.push(L),f(P,void 0)}else f(null,void 0)})},(b,f)=>{this.fileWalkSW.stop();const P=b?A.coalesce(b)[0]:null;m(P,this.isLimitHit)})}parallel(n,u,o){const l=new Array(n.length),m=new Array(n.length);let b=!1,f=0;if(n.length===0)return o(null,[]);n.forEach((P,L)=>{u(P,(M,R)=>{if(M?(b=!0,l[L]=null,m[L]=M):(l[L]=R,m[L]=null),++f===n.length)return o(b?m:null,l)})})}call(n,u,...o){try{n.apply(u,o)}catch(l){o[o.length-1](l)}}cmdTraversal(n,u,o,l){const m=n.folder.fsPath,b=k.isMacintosh;let f;const P=()=>f&&f.kill();c.add(P);let L=U=>{c.delete(P),L=()=>{},l(U)},M="";const R=this.initDirectoryTree();let W;const V=(0,T.spawnRipgrepCmd)(this.config,n,this.config.includePattern,this.folderExcludePatterns.get(n.folder.fsPath).expression);f=V.cmd,W=!Object.keys(V.siblingClauses).length;const N=V.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let j=`${V.rgDiskPath} ${N}
 - cwd: ${V.cwd}`;V.rgArgs.siblingClauses&&(j+=`
 - Sibling clauses: ${JSON.stringify(V.rgArgs.siblingClauses)}`),o({message:j}),this.cmdResultCount=0,this.collectStdout(f,"utf8",o,(U,B,z)=>{if(U){L(U);return}if(this.isLimitHit){L();return}const $=(M+(b?I.normalizeNFC(B||""):B)).split(`
`);if(z){const x=$.length;$[x-1]=$[x-1].trim(),$[x-1]||$.pop()}else M=$.pop()||"";if($.length&&$[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=$.length,W){for(const x of $)if(this.matchFile(u,{base:m,relativePath:x,searchPath:this.getSearchPath(n,x)}),this.isLimitHit){P();break}(z||this.isLimitHit)&&L();return}this.addDirectoryEntries(n,R,m,$,u),z&&(this.matchDirectoryTree(R,m,u),L())})}spawnFindCmd(n){const u=this.folderExcludePatterns.get(n.folder.fsPath),o=u.getBasenameTerms(),l=u.getPathTerms(),m=["-L","."];if(o.length||l.length){m.push("-not","(","(");for(const b of o)m.push("-name",b),m.push("-o");for(const b of l)m.push("-path",b),m.push("-o");m.pop(),m.push(")","-prune",")")}return m.push("-type","f"),p.spawn("find",m,{cwd:n.folder.fsPath})}readStdout(n,u,o){let l="";this.collectStdout(n,u,()=>{},(m,b,f)=>{if(m){o(m);return}l+=b,f&&o(null,l)})}collectStdout(n,u,o,l){let m=(P,L,M)=>{(P||M)&&(m=()=>{},this.cmdSW&&this.cmdSW.stop()),l(P,L,M)},b=!1;n.stdout?(this.forwardData(n.stdout,u,m),n.stdout.once("data",()=>b=!0)):o({message:"stdout is null"});let f;n.stderr?f=this.collectData(n.stderr):o({message:"stderr is null"}),n.on("error",P=>{m(P)}),n.on("close",P=>{let L;!b&&(L=this.decodeData(f,u))&&h(L)?m(new Error(`command failed with error code ${P}: ${this.decodeData(f,u)}`)):(this.exists&&P===0&&(this.isLimitHit=!0),m(null,"",!0))})}forwardData(n,u,o){const l=new y.StringDecoder(u);return n.on("data",m=>{o(null,l.write(m))}),l}collectData(n){const u=[];return n.on("data",o=>{u.push(o)}),u}decodeData(n,u){const o=new y.StringDecoder(u);return n.map(l=>o.write(l)).join("")}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries(n,{pathToEntries:u},o,l,m){l.indexOf(this.filePattern)!==-1&&this.matchFile(m,{base:o,relativePath:this.filePattern,searchPath:this.getSearchPath(n,this.filePattern)});const b=f=>{const P=C.basename(f),L=C.dirname(f);let M=u[L];M||(M=u[L]=[],b(L)),M.push({base:o,relativePath:f,basename:P,searchPath:this.getSearchPath(n,f)})};l.forEach(b)}matchDirectoryTree({rootEntries:n,pathToEntries:u},o,l){const m=this,b=this.folderExcludePatterns.get(o),f=this.filePattern;function P(L){m.directoriesWalked++;const M=S.hasSiblingFn(()=>L.map(R=>R.basename));for(let R=0,W=L.length;R<W;R++){const V=L[R],{relativePath:N,basename:j}=V;if(b.test(N,j,f!==j?M:void 0))continue;const U=u[N];if(U)P(U);else{if(m.filesWalked++,N===f)continue;m.matchFile(l,V)}if(m.isLimitHit)break}}P(n)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(n,u,o,l,m){const b=n.folder,f=S.hasSiblingFn(()=>o);this.parallel(o,(P,L)=>{if(this.isCanceled||this.isLimitHit)return L(null);const M=u?[u,P].join(C.sep):P;if(this.folderExcludePatterns.get(n.folder.fsPath).test(M,P,this.config.filePattern!==P?f:void 0))return L(null);const R=[b.fsPath,M].join(C.sep);F.lstat(R,(W,V)=>{if(W||this.isCanceled||this.isLimitHit)return L(null);this.statLinkIfNeeded(R,V,(N,j)=>N||this.isCanceled||this.isLimitHit?L(null):j.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(R,V,(U,B)=>U||this.isCanceled||this.isLimitHit||(B=B||"",this.walkedPaths[B])?L(null):(this.walkedPaths[B]=!0,w.Promises.readdir(R).then(z=>{if(this.isCanceled||this.isLimitHit)return L(null);this.doWalk(n,M,z,l,O=>L(O||null))},z=>{L(null)})))):(this.filesWalked++,M===this.filePattern||this.maxFilesize&&d.isNumber(j.size)&&j.size>this.maxFilesize||this.matchFile(l,{base:b.fsPath,relativePath:M,searchPath:this.getSearchPath(n,M)}),L(null,void 0)))})},P=>{const L=P&&A.coalesce(P);return m(L&&L.length>0?L[0]:void 0)})}matchFile(n,u){this.isFileMatch(u)&&(!this.includePattern||this.includePattern(u.relativePath,C.basename(u.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||n(u))}isFileMatch(n){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,D.isFilePatternMatch)(n,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(n,u,o){return u.isSymbolicLink()?F.stat(n,o):o(null,u)}realPathIfNeeded(n,u,o){return u.isSymbolicLink()?F.realpath(n,(l,m)=>l?o(l):o(null,m)):o(null,n)}getSearchPath(n,u){return n.folderName?C.join(n.folderName,u):u}}e.FileWalker=r;class v{constructor(n){this.folderQueries=n.folderQueries,this.extraFiles=n.extraFileResources||[],this.walker=new r(n)}search(n,u,o){this.walker.walk(this.folderQueries,this.extraFiles,n,u,(l,m)=>{o(l,{limitHit:m,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=v;class t{constructor(n,u){this.expression=n,this.root=u,this.init(n)}init(n){let u,o;Object.keys(n).filter(l=>n[l]).forEach(l=>{C.isAbsolute(l)?(u=u||S.getEmptyExpression(),u[l]=n[l]):(o=o||S.getEmptyExpression(),o[l]=n[l])}),this.absoluteParsedExpr=u&&S.parse(u,{trimForExclusions:!0}),this.relativeParsedExpr=o&&S.parse(o,{trimForExclusions:!0})}test(n,u,o){return this.relativeParsedExpr&&this.relativeParsedExpr(n,u,o)||this.absoluteParsedExpr&&this.absoluteParsedExpr(C.join(this.root,n),u,o)}getBasenameTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...S.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...S.getBasenameTerms(this.relativeParsedExpr)),n}getPathTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...S.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...S.getPathTerms(this.relativeParsedExpr)),n}}function h(s){const n=s.trim().split(`
`),u=n[0].trim();if(u.startsWith("Error parsing regex"))return u;if(u.startsWith("regex parse error"))return g.uppercaseFirstLetter(n[n.length-1].trim());if(u.startsWith("error parsing glob")||u.startsWith("unsupported encoding"))return u.charAt(0).toUpperCase()+u.substr(1);if(u==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(u.startsWith("Literal "))return u}e.rgErrorMsgForDisplay=h}),define(fe[137],me([0,1,39,297,105,18,59,30,8,9,2,31,72,298,282,93]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const D=d.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class T{constructor(b){this.outputChannel=b}provideTextSearchResults(b,f,P,L){return this.outputChannel.appendLine(`provideTextSearchResults ${b.pattern}, ${JSON.stringify({...f,folder:f.folder.toString()})}`),new Promise((M,R)=>{L.onCancellationRequested(()=>O());const W=h(b,f),V=f.folder.fsPath,N=W.map(de=>de.match(/^-/)?de:`'${de}'`).join(" ");this.outputChannel.appendLine(`${D} ${N}
 - cwd: ${V}`);let j=p.spawn(D,W,{cwd:V});j.on("error",de=>{console.error(de),this.outputChannel.appendLine("Error: "+(de&&de.message)),R((0,k.serializeSearchError)(new k.SearchError(de&&de.message,k.SearchErrorCode.rgProcessError)))});let U=!1;const B=new r(f.maxResults,V,f.previewOptions);B.on("result",de=>{U=!0,x="",P.report(de)});let z=!1;const O=()=>{z=!0,j&&j.kill(),B&&B.cancel()};let $=!1;B.on("hitLimit",()=>{$=!0,O()});let x="";j.stdout.on("data",de=>{B.handleData(de),U||(x+=de)});let X=!1;j.stdout.once("data",()=>X=!0);let Q="";j.stderr.on("data",de=>{const _e=de.toString();this.outputChannel.appendLine(_e),Q+=_e}),j.on("close",()=>{if(this.outputChannel.appendLine(X?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(U?"Got result from parser":"No result from parser"),x&&this.outputChannel.appendLine(`Got data without result: ${x}`),this.outputChannel.appendLine(""),z)M({limitHit:$});else{B.flush(),j=null;let de;Q&&!X&&(de=E(Q))?R((0,k.serializeSearchError)(new k.SearchError(de.message,de.code))):M({limitHit:$})}})})}}e.RipgrepTextSearchEngine=T;function E(m){const b=m.split(`
`),f=b[0].trim();if(b.some(L=>L.startsWith("regex parse error")))return new k.SearchError(c(b),k.SearchErrorCode.regexParseError);const P=f.match(/grep config error: unknown encoding: (.*)/);if(P)return new k.SearchError(`Unknown encoding: ${P[1]}`,k.SearchErrorCode.unknownEncoding);if(f.startsWith("error parsing glob"))return new k.SearchError(f.charAt(0).toUpperCase()+f.substr(1),k.SearchErrorCode.globParseError);if(f.startsWith("the literal"))return new k.SearchError(f.charAt(0).toUpperCase()+f.substr(1),k.SearchErrorCode.invalidLiteral);if(f.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(f,k.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=E;function c(m){const b=["Regex parse error"],f=m.filter(P=>P.startsWith("PCRE2:"));if(f.length>=1){const P=f[0].replace("PCRE2:","");if(P.indexOf(":")!==-1&&P.split(":").length>=2){const L=P.split(":")[1];b.push(":"+L)}}return b.join("")}e.buildRegexParseError=c;class r extends F.EventEmitter{constructor(b,f,P){super();this.maxResults=b,this.rootFolder=f,this.previewOptions=P,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new C.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(b,f){return super.on(b,f),this}handleData(b){if(this.isDone)return;const f=typeof b=="string"?b:this.stringDecoder.write(b);this.handleDecodedData(f)}handleDecodedData(b){let f=b.indexOf(`
`);const P=this.remainder+b;if(f>=0)f+=this.remainder.length;else{this.remainder=P;return}let L=0;for(;f>=0;)this.handleLine(P.substring(L,f).trim()),L=f+1,f=P.indexOf(`
`,L);this.remainder=P.substring(L)}handleLine(b){if(this.isDone||!b)return;let f;try{f=JSON.parse(b)}catch(P){throw new Error(`malformed line from rg: ${b}`)}if(f.type==="match"){const P=v(f.data.path),L=i.URI.file(S.join(this.rootFolder,P)),M=this.createTextSearchMatch(f.data,L);this.onResult(M),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(f.type==="context"){const P=v(f.data.path),L=i.URI.file(S.join(this.rootFolder,P));this.createTextSearchContext(f.data,L).forEach(R=>this.onResult(R))}}createTextSearchMatch(b,f){const P=b.line_number-1,L=v(b.lines),M=Buffer.from(L);let R=0,W=0,V=P;b.submatches.length===0&&b.submatches.push(L.length?{start:0,end:1,match:{text:L[0]}}:{start:0,end:0,match:{text:""}});const N=(0,y.coalesce)(b.submatches.map((j,U)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const B=v(j.match),z=M.slice(R,j.start).toString().length,O=W+z,$=t(B),x=V,X=$.numLines+x,Q=$.numLines>0?$.lastLineLength:$.lastLineLength+O;return R=j.end,W=Q,V=X,new a.Range(x,O,X,Q)}));return(0,w.createTextSearchResult)(f,L,N,this.previewOptions)}createTextSearchContext(b,f){const P=v(b.lines),L=b.line_number;return P.replace(/\r?\n$/,"").split(`
`).map((M,R)=>({text:M,uri:f,lineNumber:L+R}))}onResult(b){this.emit("result",b)}}e.RipgrepParser=r;function v(m){return m.bytes?Buffer.from(m.bytes,"base64").toString():m.text}function t(m){const b=/\n/g;let f=0,P=-1,L;for(;L=b.exec(m);)f++,P=L.index;const M=P>=0?m.length-P-1:m.length;return{numLines:f,lastLineLength:M}}function h(m,b){const f=["--hidden"];f.push(m.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:P,otherIncludes:L}=(0,A.groupBy)(b.includes,R=>R.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const R=new Set;L.forEach(W=>{R.add(W)}),f.push("-g","!*"),R.forEach(W=>{s(W).map(w.anchorGlob).forEach(V=>{f.push("-g",V)})})}P&&P.length&&P.forEach(R=>{f.push("-g",R)}),b.excludes.map(w.anchorGlob).forEach(R=>f.push("-g",`!${R}`)),b.maxFileSize&&f.push("--max-filesize",b.maxFileSize+""),b.useIgnoreFiles?f.push("--no-ignore-parent"):f.push("--no-ignore"),b.followSymlinks&&f.push("--follow"),b.encoding&&b.encoding!=="utf8"&&f.push("--encoding",b.encoding),m.pattern==="--"&&(m.isRegExp=!0,m.pattern="\\-\\-"),m.isMultiline&&!m.isRegExp&&(m.pattern=(0,I.escapeRegExpCharacters)(m.pattern),m.isRegExp=!0),b.usePCRE2&&f.push("--pcre2"),f.push("--crlf"),m.isRegExp&&(m.pattern=n(m.pattern),f.push("--auto-hybrid-regex"));let M;if(m.isWordMatch){const W=(0,I.createRegExp)(m.pattern,!!m.isRegExp,{wholeWord:m.isWordMatch}).source.replace(/\\\//g,"/");f.push("--regexp",W)}else if(m.isRegExp){let R=o(m.pattern);R=l(R),f.push("--regexp",R)}else M=m.pattern,f.push("--fixed-strings");return f.push("--no-config"),b.useGlobalIgnoreFiles||f.push("--no-ignore-global"),f.push("--json"),m.isMultiline&&f.push("--multiline"),b.beforeContext&&f.push("--before-context",b.beforeContext+""),b.afterContext&&f.push("--after-context",b.afterContext+""),f.push("--"),M&&f.push(M),f.push("."),f}function s(m){const b=(0,_.splitGlobAware)(m,"/");return b.map((f,P)=>b.slice(0,P+1).join("/"))}e.spreadGlobComponents=s;function n(m){const b=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;m.match(b);)m=m.replace(b,"$1\\x{$2}");const f=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;m.match(f);)m=m.replace(f,"$1\\x{$2}");return m}e.unicodeEscapesToPCRE2=n;const u=m=>m.type==="Assertion"&&m.kind==="lookbehind";function o(m){let b;try{b=new g.RegExpParser().parsePattern(m)}catch{return m}let f="",P=0;const L=(W,V,N)=>{f+=m.slice(P,W)+N,P=V},M=[];return new g.RegExpVisitor({onCharacterEnter(W){if(W.raw!=="\\n")return;const V=M[0];if(!V)L(W.start,W.end,"\\r?\\n");else if(!M.some(u))if(V.type==="CharacterClass")if(V.negate){const N=m.slice(V.start+2,W.start)+m.slice(W.end,V.end-1);L(V.start,V.end,"(?!\\r?\\n"+(N?`|[${N}]`:"")+")")}else{const N=m.slice(V.start+1,W.start)+m.slice(W.end,V.end-1);L(V.start,V.end,N===""?"\\r?\\n":`(?:[${N}]|\\r?\\n)`)}else V.type==="Quantifier"&&L(W.start,W.end,"(?:\\r?\\n)")},onQuantifierEnter(W){M.unshift(W)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(W){M.unshift(W)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(W){M.unshift(W)},onCharacterClassLeave(){M.shift()},onAssertionEnter(W){u(W)&&M.push(W)},onAssertionLeave(W){M[0]===W&&M.shift()}}).visit(b),f+=m.slice(P),f}e.fixRegexNewline=o;function l(m){return m.replace(/\n/g,"\\r?\\n")}e.fixNewline=l}),define(fe[284],me([0,1,21,137,119,10]),function(Y,e,p,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class A{constructor(I){this.outputChannel=I,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(I,i,k,a){const g=new F.RipgrepTextSearchEngine(this.outputChannel);if(i.folder.scheme===y.Schemas.userData){const d={...i,folder:i.folder.with({scheme:y.Schemas.file})},w=new C.Progress(D=>k.report({...D,uri:D.uri.with({scheme:i.folder.scheme})}));return this.withToken(a,D=>g.provideTextSearchResults(I,d,w,D))}else return this.withToken(a,d=>g.provideTextSearchResults(I,i,k,d))}async withToken(I,i){const k=_(I);this.inProgress.add(k);const a=await i(k.token);return this.inProgress.delete(k),a}dispose(){this.inProgress.forEach(I=>I.cancel())}}e.RipgrepSearchProvider=A;function _(S){const I=new p.CancellationTokenSource;return S.onCancellationRequested(()=>I.cancel()),I}}),define(fe[285],me([0,1,28,137,136]),function(Y,e,p,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class y{constructor(S){this.query=S}search(S,I,i){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(g){i({message:g})}},a=new C.NativeTextSearchManager(this.query,new F.RipgrepTextSearchEngine(k),p);return new Promise((g,d)=>a.search(w=>{I(w.map(A))},S).then(w=>g({limitHit:w.limitHit,type:"success",stats:w.stats}),d))}}e.TextSearchEngineAdapter=y;function A(_){return{path:_.resource&&_.resource.fsPath,results:_.results,numMatches:(_.results||[]).reduce((S,I)=>{if(I.ranges){const i=I;return S+(Array.isArray(i.ranges)?i.ranges.length:1)}else return S+1},0)}}}),define(fe[286],me([0,1,50,299,18,15,17,3,102,8,46,2,43,31,283,285]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,F.gracefulify(p);class D{constructor(t="searchProcess"){this.processType=t,this.caches=Object.create(null)}fileSearch(t){let h;const s=c(t),n=new _.Emitter({onFirstListenerDidAdd:()=>{h=(0,y.createCancelablePromise)(u=>this.doFileSearchWithEngine(d.Engine,s,o=>n.fire(o),u)),h.then(u=>n.fire(u),u=>n.fire({type:"error",error:{message:u.message,stack:u.stack}}))},onLastListenerRemove:()=>{h.cancel()}});return n.event}textSearch(t){let h;const s=c(t),n=new _.Emitter({onFirstListenerDidAdd:()=>{h=(0,y.createCancelablePromise)(u=>this.ripgrepTextSearch(s,o=>n.fire(o),u)),h.then(u=>n.fire(u),u=>n.fire({type:"error",error:{message:u.message,stack:u.stack}}))},onLastListenerRemove:()=>{h.cancel()}});return n.event}ripgrepTextSearch(t,h,s){return t.maxFileSize=(0,a.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new w.TextSearchEngineAdapter(t).search(s,h,h)}doFileSearch(t,h,s){return this.doFileSearchWithEngine(d.Engine,t,h,s)}doFileSearchWithEngine(t,h,s,n,u=D.BATCH_SIZE){let o=0;const l=b=>{Array.isArray(b)?(o+=b.length,s(b.map(f=>this.rawMatchToSearchItem(f)))):b.relativePath?(o++,s(this.rawMatchToSearchItem(b))):s(b)};if(h.sortByScore){let b=this.trySortedSearchFromCache(h,l,n);if(!b){const f=h.maxResults?Object.assign({},h,{maxResults:null}):h,P=new t(f);b=this.doSortedSearch(P,h,s,l,n)}return new Promise((f,P)=>{b.then(([L,M])=>{const R=M.map(W=>this.rawMatchToSearchItem(W));this.sendProgress(R,s,u),f(L)},P)})}const m=new t(h);return this.doSearch(m,l,u,n).then(b=>({limitHit:b.limitHit,type:"success",stats:{detailStats:b.stats,type:this.processType,fromCache:!1,resultCount:o,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,I.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,h,s,n,u){const o=new _.Emitter;let l=(0,y.createCancelablePromise)(b=>{let f=[];const P=L=>{Array.isArray(L)?f=L:(n(L),o.fire(L))};return this.doSearch(t,P,-1,b).then(L=>[L,f])}),m;if(h.cacheKey){m=this.getOrCreateCache(h.cacheKey);const b={promise:l,event:o.event,resolved:!1};m.resultsToSearchCache[h.filePattern||""]=b,l.then(()=>{b.resolved=!0},f=>{delete m.resultsToSearchCache[h.filePattern||""]}),l=this.preventCancellation(l)}return l.then(([b,f])=>{const P=m?m.scorerCache:Object.create(null),L=(typeof h.maxResults!="number"||h.maxResults>0)&&i.StopWatch.create(!1);return this.sortResults(h,f,P,u).then(M=>{const R=L?L.elapsed():-1;return[{type:"success",stats:{detailStats:b.stats,sortingTime:R,fromCache:!1,type:this.processType,workspaceFolderCount:h.folderQueries.length,resultCount:M.length},messages:b.messages,limitHit:b.limitHit||typeof h.maxResults=="number"&&f.length>h.maxResults},M]})})}getOrCreateCache(t){const h=this.caches[t];return h||(this.caches[t]=new T)}trySortedSearchFromCache(t,h,s){const n=t.cacheKey&&this.caches[t.cacheKey];if(!n)return;const u=this.getResultsFromCache(n,t.filePattern||"",h,s);if(u)return u.then(([o,l,m])=>{const b=i.StopWatch.create(!1);return this.sortResults(t,l,n.scorerCache,s).then(f=>{const P=b.elapsed(),L={fromCache:!0,detailStats:m,type:this.processType,resultCount:l.length,sortingTime:P};return[{type:"success",limitHit:o.limitHit||typeof t.maxResults=="number"&&l.length>t.maxResults,stats:L},f]})})}sortResults(t,h,s,n){const u=(0,S.prepareQuery)(t.filePattern||""),o=(m,b)=>(0,S.compareItemsByFuzzyScore)(m,b,u,!0,E,s),l=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return C.topAsync(h,o,l,1e4,n)}sendProgress(t,h,s){if(s&&s>0)for(let n=0;n<t.length;n+=s)h(t.slice(n,n+s));else h(t)}getResultsFromCache(t,h,s,n){const u=i.StopWatch.create(!1),o=h.indexOf(I.sep)>=0;let l;for(const P in t.resultsToSearchCache)if(h.startsWith(P)){if(o&&P.indexOf(I.sep)<0&&P!=="")continue;const L=t.resultsToSearchCache[P];l={promise:this.preventCancellation(L.promise),event:L.event,resolved:L.resolved};break}if(!l)return null;const m=u.elapsed(),b=i.StopWatch.create(!1),f=l.event(s);return n&&n.onCancellationRequested(()=>{f.dispose()}),l.promise.then(([P,L])=>{if(n&&n.isCancellationRequested)throw(0,A.canceled)();const M=[],R=(0,S.prepareQuery)(h).normalizedLowercase;for(const W of L)!(0,g.isFilePatternMatch)(W,R)||M.push(W);return[P,M,{cacheWasResolved:l.resolved,cacheLookupTime:m,cacheFilterTime:b.elapsed(),cacheEntryCount:L.length}]})}doSearch(t,h,s,n){return new Promise((u,o)=>{let l=[];n&&n.onCancellationRequested(()=>t.cancel()),t.search(m=>{m&&(s?(l.push(m),s>0&&l.length>=s&&(h(l),l=[])):h(m))},m=>{h(m)},(m,b)=>{l.length&&h(l),m?o(m):u(b)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(h,s){return t.then(h,s)}catch(h){return this.then(void 0,h)}finally(h){return t.finally(h)}}}}e.SearchService=D,D.BATCH_SIZE=512;class T{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const E=new class{getItemLabel(v){return(0,I.basename)(v.relativePath)}getItemDescription(v){return(0,I.dirname)(v.relativePath)}getItemPath(v){return v.relativePath}};function c(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(r),extraFileResources:v.extraFileResources&&v.extraFileResources.map(t=>k.URI.revive(t))}}function r(v){return{...v,folder:k.URI.revive(v.folder)}}}),define(fe[287],me([0,1,6,10,2,28,13,27,14,75,67,31,286,284,93,136]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let D=class extends I.ExtHostSearch{constructor(E,c,r,v){super(E,r,v);this._pfs=y,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const t=new d.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(F.Schemas.userData,new g.RipgrepSearchProvider(t)),c.remote.isRemote&&c.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const E=new d.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(F.Schemas.file,new g.RipgrepSearchProvider(E)),this.registerInternalFileSearchProvider(F.Schemas.file,new a.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(E,c){const r=this._handlePool++;return this._internalFileSearchProvider=c,this._internalFileSearchHandle=r,this._proxy.$registerFileSearchProvider(r,this._transformScheme(E)),(0,p.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(r)})}$provideFileSearchResults(E,c,r,v){const t=(0,I.reviveQuery)(r);return E===this._internalFileSearchHandle?this.doInternalFileSearch(E,c,t,v):super.$provideFileSearchResults(E,c,r,v)}doInternalFileSearch(E,c,r,v){const t=h=>{if((0,k.isSerializedFileMatch)(h)&&(h=[h]),Array.isArray(h)){this._proxy.$handleFileMatch(E,c,h.map(s=>C.URI.file(s.path)));return}h.message&&this._logService.debug("ExtHostSearch",h.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(r,t,v)}$clearCache(E){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(E),super.$clearCache(E)}createTextSearchManager(E,c){return new w.NativeTextSearchManager(E,c,void 0,"textSearchProvider")}};D=Ve([$e(0,S.IExtHostRpcService),$e(1,_.IExtHostInitDataService),$e(2,i.IURITransformerService),$e(3,A.ILogService)],D),e.NativeExtHostSearch=D}),define(fe[138],me([0,1,300,127,81,22,17,3,6,8,11,32,107,108,301]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{constructor(l){this.socket=l,this._errorListener=m=>{if(m){if(m.code==="EPIPE")return;(0,A.onUnexpectedError)(m)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(l){const m=b=>l(y.VSBuffer.wrap(b));return this.socket.on("data",m),{dispose:()=>this.socket.off("data",m)}}onClose(l){const m=b=>{l({type:0,hadError:b,error:void 0})};return this.socket.on("close",m),{dispose:()=>this.socket.off("close",m)}}onEnd(l){return this.socket.on("end",l),{dispose:()=>this.socket.off("end",l)}}write(l){if(!this.socket.destroyed)try{this.socket.write(l.buffer,m=>{if(m){if(m.code==="EPIPE")return;(0,A.onUnexpectedError)(m)}})}catch(m){if(m.code==="EPIPE")return;(0,A.onUnexpectedError)(m)}}end(){this.socket.end()}drain(){return new Promise((l,m)=>{if(this.socket.bufferSize===0){l();return}const b=()=>{this.socket.off("close",b),this.socket.off("end",b),this.socket.off("error",b),this.socket.off("timeout",b),this.socket.off("drain",b),l()};this.socket.on("close",b),this.socket.on("end",b),this.socket.on("error",b),this.socket.on("timeout",b),this.socket.on("drain",b)})}}e.NodeSocket=w;var D;(function(o){o[o.MinHeaderByteSize=2]="MinHeaderByteSize"})(D||(D={}));var T;(function(o){o[o.PeekHeader=1]="PeekHeader",o[o.ReadHeader=2]="ReadHeader",o[o.ReadBody=3]="ReadBody",o[o.Fin=4]="Fin"})(T||(T={}));class E extends S.Disposable{constructor(l,m,b,f){super();this._onDidZlibFlush=this._register(new _.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new _.Emitter),this._onClose=this._register(new _.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=l,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=m,this._recordInflateBytes=f,m?(this._zlibInflate=d.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",P=>{console.error(P),(0,A.onUnexpectedError)(P),this._onClose.fire({type:0,hadError:!0,error:P})}),this._zlibInflate.on("data",P=>{this._pendingInflateData.push(P)}),b&&(this._zlibInflate.write(b.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=d.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",P=>{console.error(P),(0,A.onUnexpectedError)(P),this._onClose.fire({type:0,hadError:!0,error:P})}),this._zlibDeflate.on("data",P=>{this._pendingDeflateData.push(P)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new g.ChunkStream,this._register(this.socket.onData(P=>this._acceptChunk(P))),this._register(this.socket.onClose(P=>this._onClose.fire(P)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?y.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):y.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this._onData.event(l)}onClose(l){return this._onClose.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){this._totalOutgoingDataBytes+=l.byteLength,this._zlibDeflate?(this._zlibDeflate.write(l.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let m=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,m=m.slice(0,m.length-4),this._isEnded||this._write(y.VSBuffer.wrap(m),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(l,!1)}_write(l,m){let b=2;l.byteLength<126?b+=0:l.byteLength<2**16?b+=2:b+=8;const f=y.VSBuffer.alloc(b);if(m?f.writeUInt8(194,0):f.writeUInt8(130,0),l.byteLength<126)f.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){f.writeUInt8(126,1);let P=1;f.writeUInt8(l.byteLength>>>8&255,++P),f.writeUInt8(l.byteLength>>>0&255,++P)}else{f.writeUInt8(127,1);let P=1;f.writeUInt8(0,++P),f.writeUInt8(0,++P),f.writeUInt8(0,++P),f.writeUInt8(0,++P),f.writeUInt8(l.byteLength>>>24&255,++P),f.writeUInt8(l.byteLength>>>16&255,++P),f.writeUInt8(l.byteLength>>>8&255,++P),f.writeUInt8(l.byteLength>>>0&255,++P)}this._totalOutgoingWireBytes+=f.byteLength+l.byteLength,this.socket.write(y.VSBuffer.concat([f,l]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(l){if(l.byteLength!==0){for(this._totalIncomingWireBytes+=l.byteLength,this._incomingData.acceptChunk(l);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const m=this._incomingData.peek(this._state.readLen),b=m.readUInt8(0),f=(b&128)>>>7,P=(b&64)>>>6,L=m.readUInt8(1),M=(L&128)>>>7,R=L&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(R===126?2:0)+(R===127?8:0),this._state.fin=f,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(P)),this._state.firstFrameOfMessage=Boolean(f),this._state.mask=0}else if(this._state.state===2){const m=this._incomingData.read(this._state.readLen),b=m.readUInt8(1),f=(b&128)>>>7;let P=b&127,L=1;P===126?P=m.readUInt8(++L)*2**8+m.readUInt8(++L):P===127&&(P=m.readUInt8(++L)*0+m.readUInt8(++L)*0+m.readUInt8(++L)*0+m.readUInt8(++L)*0+m.readUInt8(++L)*2**24+m.readUInt8(++L)*2**16+m.readUInt8(++L)*2**8+m.readUInt8(++L));let M=0;f&&(M=m.readUInt8(++L)*2**24+m.readUInt8(++L)*2**16+m.readUInt8(++L)*2**8+m.readUInt8(++L)),this._state.state=3,this._state.readLen=P,this._state.mask=M}else if(this._state.state===3){const m=this._incomingData.read(this._state.readLen);c(m,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(m.buffer)),this._zlibInflate.write(m.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const b=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=b.length,this._onData.fire(y.VSBuffer.wrap(b))})):(this._totalIncomingDataBytes+=m.byteLength,this._onData.fire(m))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await _.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=E;function c(o,l){if(l===0)return;let m=o.byteLength>>>2;for(let R=0;R<m;R++){const W=o.readUInt32BE(R*4);o.writeUInt32BE(W^l,R*4)}let b=m*4,f=o.byteLength-b;const P=l>>>24&255,L=l>>>16&255,M=l>>>8&255;f>=1&&o.writeUInt8(o.readUInt8(b)^P,b),f>=2&&o.writeUInt8(o.readUInt8(b+1)^L,b+1),f>=3&&o.writeUInt8(o.readUInt8(b+2)^M,b+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function v(){const o=(0,k.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${o}-sock`;let l;return e.XDG_RUNTIME_DIR?l=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${o}.sock`):l=(0,I.join)((0,C.tmpdir)(),`vscode-ipc-${o}.sock`),h(l),l}e.createRandomIPCHandle=v;function t(o,l,m){const b=(0,p.createHash)("md5").update(o).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${b}-${m}-${l}-sock`;let f;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?f=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-${b.substr(0,8)}-${m}-${l}.sock`):f=(0,I.join)(o,`${m}-${l}.sock`),h(f),f}e.createStaticIPCHandle=t;function h(o){const l=r[i.platform];typeof l=="number"&&o.length>=l&&console.warn(`WARNING: IPC handle "${o}" is longer than ${l} chars, try a shorter --user-data-dir`)}class s extends a.IPCServer{constructor(l){super(s.toClientConnectionEvent(l));this.server=l}static toClientConnectionEvent(l){const m=_.Event.fromNodeEventEmitter(l,"connection");return _.Event.map(m,b=>({protocol:new g.Protocol(new w(b)),onDidClientDisconnect:_.Event.once(_.Event.fromNodeEventEmitter(b,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function n(o){return new Promise((l,m)=>{const b=(0,F.createServer)();b.on("error",m),b.listen(o,()=>{b.removeListener("error",m),l(new s(b))})})}e.serve=n;function u(o,l){return new Promise((m,b)=>{const f=(0,F.createConnection)(o,()=>{f.removeListener("error",b),m(g.Client.fromSocket(new w(f),l))});f.once("error",b)})}e.connect=u}),define(fe[288],me([0,1,138,280,50,40,2,200,13]),function(Y,e,p,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class I{constructor(a,g,d){this._commands=a,this.logService=g,this._ipcHandlePath=d,this._server=F.createServer((w,D)=>this.onRequest(w,D)),this.setup().catch(w=>(g.error(w),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",a=>this.logService.error(a))}catch(a){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(a,g){const d=[];a.setEncoding("utf8"),a.on("data",w=>d.push(w)),a.on("end",()=>{const w=JSON.parse(d.join(""));switch(w.type){case"open":this.open(w,g);break;case"openExternal":this.openExternal(w,g);break;case"status":this.getStatus(w,g);break;case"extensionManagement":this.manageExtensions(w,g).catch(this.logService.error);break;default:g.writeHead(404),g.write(`Unknown message type: ${w.type}`,D=>{D&&this.logService.error(D)}),g.end();break}})}open(a,g){let{fileURIs:d,folderURIs:w,forceNewWindow:D,diffMode:T,addMode:E,forceReuseWindow:c,gotoLineMode:r,waitMarkerFilePath:v}=a;const t=[];if(Array.isArray(w))for(const h of w)try{t.push({folderUri:A.URI.parse(h)})}catch(s){}if(Array.isArray(d))for(const h of d)try{(0,_.hasWorkspaceFileExtension)(h)?t.push({workspaceUri:A.URI.parse(h)}):t.push({fileUri:A.URI.parse(h)})}catch(s){}if(t.length){const h=v?A.URI.file(v):void 0,n={forceNewWindow:D,diffMode:T,addMode:E,gotoLineMode:r,forceReuseWindow:c,preferNewWindow:!c&&!h&&!E,waitMarkerFileURI:h};this._commands.executeCommand("_remoteCLI.windowOpen",t,n)}g.writeHead(200),g.end()}async openExternal(a,g){for(const d of a.uris){const w=A.URI.parse(d),D=w.scheme==="file"?w:d;await this._commands.executeCommand("_remoteCLI.openExternal",D)}g.writeHead(200),g.end()}async manageExtensions(a,g){try{const d=T=>T?.map(E=>/\.vsix$/i.test(E)?A.URI.parse(E):E),w={list:a.list,install:d(a.install),uninstall:d(a.uninstall),force:a.force},D=await this._commands.executeCommand("_remoteCLI.manageExtensions",w);g.writeHead(200),g.write(D)}catch(d){g.writeHead(500),g.write(String(d),w=>{w&&this.logService.error(w)})}g.end()}async getStatus(a,g){try{const d=await this._commands.executeCommand("_remoteCLI.getSystemStatus");g.writeHead(200),g.write(d),g.end()}catch(d){g.writeHead(500),g.write(String(d),w=>{w&&this.logService.error(w)}),g.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&C.existsSync(this._ipcHandlePath)&&C.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=I;let i=class extends I{constructor(a,g){super(a,g,(0,p.createRandomIPCHandle)())}};i=Ve([$e(0,y.IExtHostCommands),$e(1,S.ILogService)],i),e.CLIServer=i}),define(fe[289],me([0,1,74,276,271,5,279,41,261,2,10,7,288,106]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class d extends C.RequireInterceptor{_installInterceptor(){const T=this,E=Y.__$__nodeRequire("module"),c=E._load;E._load=function(v,t,h){for(let s of T._alternatives){let n=s(v);if(n){v=n;break}}return T._factories.has(v)?T._factories.get(v).load(v,I.URI.file((0,g.realpathSync)(t.filename)),s=>c.apply(this,[s,t,h])):c.apply(this,arguments)}}}class w extends _.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=k.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const T=this._instaService.invokeFunction(F.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(S.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(a.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(d,T,this._registry).install(),p.mark("code/extHost/didInitAPI");const c=await this._extHostConfiguration.getConfigProvider();await(0,A.connectProxyResolver)(this._extHostWorkspace,c,this,this._logService,this._mainThreadTelemetryProxy,this._initData),p.mark("code/extHost/didInitProxyResolver");const r=process.send,v=this._extHostContext.getProxy(y.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?r.apply(process,t):(v.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(T){return T.main}_loadCommonJSModule(T,E,c){if(E.scheme!==i.Schemas.file)throw new Error(`Cannot load URI: '${E}', must be of file-scheme`);let r=null;c.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${E.toString(!0)}`),this._logService.flush();try{T&&p.mark(`code/extHost/willLoadExtensionCode/${T.value}`),r=Y.__$__nodeRequire(E.fsPath)}catch(v){return Promise.reject(v)}finally{T&&p.mark(`code/extHost/didLoadExtensionCode/${T.value}`),c.codeLoadingStop()}return Promise.resolve(r)}async $setRemoteEnvironment(T){if(!!this._initData.remote.isRemote)for(const E in T){const c=T[E];c===null?delete process.env[E]:process.env[E]=c}}}e.ExtHostExtensionService=w}),define(fe[290],me([0,1,83,262,264,273,272,287,289,229,265,57,41,69,75,73,33,54,13,70,263]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d,w,D,T,E,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,p.registerSingleton)(a.IExtHostExtensionService,S.ExtHostExtensionService),(0,p.registerSingleton)(E.ILogService,I.ExtHostLogService),(0,p.registerSingleton)(c.IExtensionStoragePaths,r.ExtensionStoragePaths),(0,p.registerSingleton)(k.IExtHostDebugService,A.ExtHostDebugService),(0,p.registerSingleton)(g.IExtHostOutputService,F.ExtHostOutputService2),(0,p.registerSingleton)(d.IExtHostSearch,_.NativeExtHostSearch),(0,p.registerSingleton)(w.IExtHostTask,y.ExtHostTask),(0,p.registerSingleton)(D.IExtHostTerminalService,C.ExtHostTerminalService),(0,p.registerSingleton)(T.IExtHostTunnelService,i.ExtHostTunnelService)}),define(fe[291],me([0,1,127,302,74,17,108,138,193,227,274,22,104,28,106,15,115,277,290]),function(Y,e,p,F,C,y,A,_,S,I,i,k,a,g,d,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let u=0;u<process.execArgv.length;u++)process.execArgv[u]==="--inspect-port=0"&&(process.execArgv.splice(u,1),u--)}();const T=F(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const n=Y.__$__nodeRequire("module"),u=n._load;n._load=function(o){if(o==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return u.apply(this,arguments)}})();const E=process.exit.bind(process);function c(n){process.exit=function(u){if(n)E(u);else{const o=new Error("An extension called process.exit() and this was prevented.");console.warn(o.stack)}},process.crash=function(){const u=new Error("An extension called process.crash() and this was prevented.");console.warn(u.stack)}}let r=function(n){E()};function v(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((n,u)=>{let o=null,l=setTimeout(()=>{r("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const m=108e5,b=3e5,f=new w.ProcessTimeRunOnceScheduler(()=>r("renderer disconnected for too long (1)"),m),P=new w.ProcessTimeRunOnceScheduler(()=>r("renderer disconnected for too long (2)"),b);process.on("message",(M,R)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){const W=k.VSBuffer.wrap(Buffer.from(M.initialDataChunk,"base64"));let V;if(M.skipWebSocketFrames)V=new _.NodeSocket(R);else{const N=k.VSBuffer.wrap(Buffer.from(M.inflateBytes,"base64"));V=new _.WebSocketNodeSocket(new _.NodeSocket(R),M.permessageDeflate,N,!1)}o?(f.cancel(),P.cancel(),o.beginAcceptReconnection(V,W),o.endAcceptReconnection()):(clearTimeout(l),o=new A.PersistentProtocol(V,W),o.onDidDispose(()=>r("renderer disconnected")),n(o),o.onSocketClose(()=>{f.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(P.isScheduled())return;f.isScheduled()&&P.schedule()}});const L={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(L)});{const n=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((u,o)=>{const l=p.createConnection(n,()=>{l.removeListener("error",o),u(new A.PersistentProtocol(new _.NodeSocket(l)))});l.once("error",o),l.on("close",()=>{r("renderer closed the socket")})})}}async function t(){const n=await v();return new class{constructor(){this._onMessage=new A.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,n.onMessage(u=>{(0,I.isMessageOfType)(u,2)?(this._terminating=!0,r("received terminate message from renderer")):this._onMessage.fire(u)})}send(u){this._terminating||n.send(u)}drain(){return n.drain()}}}function h(n){return new Promise(u=>{const o=n.onMessage(l=>{o.dispose();const m=JSON.parse(l.toString()),b=m.commit,f=S.default.commit;b&&f&&b!==f&&E(55);const P=[];process.on("unhandledRejection",(R,W)=>{P.push(W),setTimeout(()=>{const V=P.indexOf(W);V>=0&&W.catch(N=>{P.splice(V,1),(0,y.isPromiseCanceledError)(N)||(console.warn(`rejected promise not handled within 1 second: ${N}`),N&&N.stack&&console.warn(`stack trace: ${N.stack}`),(0,y.onUnexpectedError)(R))})},1e3)}),process.on("rejectionHandled",R=>{const W=P.indexOf(R);W>=0&&P.splice(W,1)}),process.on("uncaughtException",function(R){(0,y.onUnexpectedError)(R)});let L=0;setInterval(function(){try{process.kill(m.parentPid,0),L=0}catch(R){R&&R.code==="EPERM"?(L++,L>=3&&r(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${R.message} (code: ${R.code}) (errno: ${R.errno})`)):r(`parent process ${m.parentPid} does not exist anymore: ${R.message} (code: ${R.code}) (errno: ${R.errno})`)}},1e3);let M;try{M=Y.__$__nodeRequire("native-watchdog"),M.start(m.parentPid)}catch(R){(0,y.onUnexpectedError)(R)}n.send((0,I.createMessageOfType)(0)),u({protocol:n,initData:m})});n.send((0,I.createMessageOfType)(1))})}async function s(){C.mark("code/extHost/willConnectToRenderer");const n=await t();C.mark("code/extHost/didConnectToRenderer");const u=await h(n);C.mark("code/extHost/didWaitForInitData");const{initData:o}=u;c(!!o.environment.extensionTestsLocationURI),o.environment.useHostProxy=T.useHostProxy!==void 0?T.useHostProxy!=="false":void 0,o.environment.skipWorkspaceStorageLock=(0,D.boolean)(T.skipWorkspaceStorageLock,!1);const l=new class{exit(P){E(P)}exists(P){return g.Promises.exists(P)}realpath(P){return(0,d.realpath)(P)}};let m=null;if(o.remote.authority&&T.uriTransformerPath)try{const P=Y.__$__nodeRequire(T.uriTransformerPath)(o.remote.authority);m=new a.URITransformer(P)}catch(f){console.error(f)}const b=new i.ExtensionHostMain(u.protocol,o,l,m);r=f=>b.terminate(f)}e.startExtensionHostProcess=s}),define(fe[303],me([0,1,291]),function(Y,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,p.startExtensionHostProcess)().catch(F=>console.log(F))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/cad4c193d85f0891204da41c0508de39e7aa38c6/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
